/*!--------------------------------------------------------
 * Copyright (C) Microsoft Corporation. All rights reserved.
 *--------------------------------------------------------*/(function(){var Z=["require","exports","vs/base/common/lifecycle","vs/base/common/event","vs/base/common/platform","vs/base/common/uri","vs/base/common/async","vs/platform/instantiation/common/instantiation","vs/base/common/path","vs/base/common/errors","vs/nls","vs/nls!vs/code/electron-browser/sharedProcess/sharedProcessMain","vs/platform/environment/common/environment","vs/platform/log/common/log","vs/platform/files/common/files","vs/base/common/network","vs/base/common/resources","vs/base/common/arrays","vs/base/common/types","vs/base/node/pfs","vs/platform/telemetry/common/telemetry","vs/platform/configuration/common/configuration","vs/platform/storage/common/storage","vs/platform/userDataSync/common/userDataSync","vs/base/common/strings","vs/base/common/buffer","vs/base/common/objects","vs/base/common/cancellation","vs/platform/extensionManagement/common/extensionManagement","vs/platform/product/common/productService","vs/base/common/uuid","vs/base/common/process","vs/platform/extensionManagement/common/extensionManagementUtil","vs/platform/registry/common/platform","vs/base/common/json","os","vs/base/parts/ipc/common/ipc","child_process","vs/base/common/errorMessage","vs/platform/configuration/common/configurationRegistry","vs/base/common/extpath","vs/base/common/map","vs/platform/product/common/product","vs/platform/request/common/request","vs/base/common/jsonEdit","vs/platform/serviceMachineId/common/serviceMachineId","vs/platform/telemetry/common/telemetryUtils","vs/platform/userDataSync/common/abstractSynchronizer","vs/base/common/jsonFormatter","vs/base/common/codicons","vs/base/common/stream","fs","vs/base/parts/ipc/node/ipc.cp","vs/platform/instantiation/common/descriptors","vs/platform/userDataSync/common/content","vs/base/common/iterator","vs/base/common/date","vs/platform/localizations/common/localizations","vs/base/common/semver/semver","vs/platform/native/electron-sandbox/native","vs/platform/userDataSync/common/userDataSyncAccount","vs/platform/userDataSync/common/userDataSyncMachines","vs/base/node/zip","vs/base/common/collections","vs/base/common/decorators","vs/base/common/functional","vs/base/common/normalization","vs/base/common/glob","vs/base/node/decoder","vs/base/node/powershell","vs/base/parts/storage/common/storage","vs/base/node/processes","vs/platform/environment/common/environmentService","vs/platform/extensions/common/extensionValidator","vs/platform/diagnostics/common/diagnostics","vs/platform/download/common/download","vs/platform/extensionRecommendations/common/extensionRecommendations","vs/platform/extensions/common/extensions","vs/platform/files/node/watcher/watcher","vs/platform/instantiation/common/serviceCollection","vs/platform/log/common/logIpc","vs/platform/files/common/io","vs/platform/jsonschemas/common/jsonContributionRegistry","vs/platform/telemetry/common/telemetryIpc","vs/platform/telemetry/common/telemetryLogAppender","vs/platform/telemetry/common/telemetryService","vs/platform/terminal/common/terminal","vs/platform/theme/common/themeService","vs/platform/userDataSync/common/extensionsStorageSync","vs/platform/userDataSync/common/ignoredExtensions","vs/platform/userDataSync/common/userDataAutoSyncService","vs/base/common/assert","vs/base/common/linkedList","vs/base/common/stopwatch","vs/base/common/console","vs/base/common/marshalling","vs/base/common/mime","vs/base/common/uriIpc","string_decoder","vs/base/node/macAddress","vs/base/node/id","vs/base/node/extpath","vs/base/node/ps","vs/base/node/watcher","vs/base/parts/ipc/common/ipc.mp","vs/base/parts/ipc/electron-browser/ipc.mp","electron","vs/base/parts/request/browser/request","vs/nls!vs/base/common/date","vs/nls!vs/base/common/errorMessage","vs/nls!vs/base/node/processes","vs/base/node/shell","vs/nls!vs/base/node/zip","vs/nls!vs/platform/configuration/common/configurationRegistry","vs/nls!vs/platform/environment/node/argv","vs/nls!vs/platform/environment/node/argvHelper","vs/nls!vs/platform/extensionManagement/common/abstractExtensionManagementService","vs/nls!vs/platform/extensionManagement/common/extensionManagement","vs/nls!vs/platform/extensionManagement/electron-sandbox/extensionTipsService","vs/nls!vs/platform/extensionManagement/node/extensionManagementService","vs/nls!vs/platform/extensionManagement/node/extensionManagementUtil","vs/nls!vs/platform/extensionManagement/node/extensionsScanner","vs/nls!vs/platform/extensions/common/extensionValidator","vs/nls!vs/platform/files/common/fileService","vs/nls!vs/platform/files/common/files","vs/nls!vs/platform/files/common/io","vs/nls!vs/platform/files/node/diskFileSystemProvider","vs/nls!vs/platform/request/common/request","vs/nls!vs/platform/telemetry/common/telemetryService","vs/nls!vs/platform/terminal/common/terminalPlatformConfiguration","vs/nls!vs/platform/userDataSync/common/abstractSynchronizer","vs/nls!vs/platform/userDataSync/common/keybindingsSync","vs/nls!vs/platform/userDataSync/common/settingsSync","vs/nls!vs/platform/userDataSync/common/userDataAutoSyncService","vs/nls!vs/platform/userDataSync/common/userDataSync","vs/nls!vs/platform/userDataSync/common/userDataSyncMachines","vs/platform/environment/node/argv","vs/platform/environment/node/userDataPath","path","vs/platform/environment/node/environmentService","vs/platform/extensionManagement/common/configRemotes","vs/platform/extensionManagement/common/extensionNls","vs/platform/extensionRecommendations/electron-sandbox/extensionRecommendationsIpc","vs/platform/files/node/watcher/nsfw/watcherService","vs/platform/files/node/watcher/unix/watcherService","vs/platform/files/node/watcher/win32/csharpWatcherService","vs/platform/files/node/watcher/win32/watcherService","vs/platform/instantiation/common/extensions","vs/platform/instantiation/common/graph","vs/platform/checksum/common/checksumService","vs/platform/contextkey/common/contextkey","vs/code/electron-browser/sharedProcess/contrib/deprecatedExtensionsCleaner","vs/platform/extensionManagement/common/extensionManagementIpc","vs/platform/extensions/common/extensionHostStarter","vs/platform/extensionManagement/node/extensionsManifestCache","vs/platform/checksum/node/checksumService","crypto","vs/platform/environment/node/argvHelper","vs/platform/environment/node/shellEnv","vs/platform/files/node/watcher/nodejs/watcherService","vs/platform/instantiation/common/instantiationService","vs/platform/ipc/electron-browser/mainProcessService","vs/platform/ipc/electron-sandbox/services","vs/code/electron-browser/sharedProcess/contrib/localizationsUpdater","vs/code/electron-browser/sharedProcess/contrib/logsDataCleaner","vs/code/electron-browser/sharedProcess/contrib/storageDataCleaner","vs/platform/extensionManagement/node/extensionDownloader","vs/platform/extensionManagement/node/extensionLifecycle","vs/platform/extensionManagement/node/extensionsWatcher","vs/platform/extensions/node/extensionHostStarter","vs/platform/localizations/node/localizations","vs/platform/files/common/fileService","vs/base/common/performance","vs/platform/files/node/diskFileSystemProvider","vs/code/electron-browser/sharedProcess/contrib/codeCacheCleaner","vs/code/electron-browser/sharedProcess/contrib/languagePackCachedDataCleaner","vs/platform/configuration/common/configurationModels","vs/platform/configuration/common/configurationService","vs/platform/request/browser/requestService","vs/platform/download/common/downloadService","vs/platform/extensionManagement/common/extensionTipsService","vs/platform/extensionManagement/common/extensionEnablementService","vs/platform/storage/common/storageIpc","vs/platform/storage/electron-sandbox/storageService","vs/platform/telemetry/common/commonProperties","vs/platform/diagnostics/node/diagnosticsService","vs/platform/extensionManagement/common/abstractExtensionManagementService","vs/platform/extensionManagement/electron-sandbox/extensionTipsService","vs/platform/extensionManagement/common/extensionGalleryService","vs/platform/telemetry/node/appInsightsAppender","vs/platform/telemetry/node/customEndpointTelemetryService","vs/platform/terminal/common/requestStore","vs/platform/terminal/electron-sandbox/terminal","vs/platform/terminal/node/terminalEnvironment","vs/platform/theme/common/theme","vs/platform/terminal/common/terminalProfiles","vs/platform/terminal/common/terminalPlatformConfiguration","vs/platform/terminal/node/terminalProfiles","vs/platform/terminal/node/ptyHostService","vs/platform/userDataSync/common/extensionsMerge","vs/platform/userDataSync/common/keybindingsMerge","vs/platform/userDataSync/common/snippetsMerge","vs/platform/userDataSync/common/extensionsSync","vs/platform/userDataSync/common/globalStateMerge","vs/platform/userDataSync/common/globalStateSync","vs/platform/userDataSync/common/keybindingsSync","vs/platform/userDataSync/common/settingsMerge","vs/platform/userDataSync/common/settingsSync","vs/platform/userDataSync/common/snippetsSync","vs/platform/userDataSync/common/userDataSyncBackupStoreService","vs/platform/userDataSync/common/userDataSyncIpc","vs/platform/userDataSync/common/userDataSyncLog","vs/platform/userDataSync/common/userDataSyncResourceEnablementService","vs/platform/userDataSync/common/userDataSyncService","vs/platform/userDataSync/common/userDataSyncServiceIpc","vs/platform/userDataSync/common/userDataSyncStoreService","vs/platform/userDataSync/electron-sandbox/userDataAutoSyncService","vs/platform/windows/node/windowTracker","vs/platform/extensionManagement/node/extensionManagementUtil","vs/platform/extensionManagement/node/extensionsScanner","vs/platform/extensionManagement/node/extensionManagementService","util","minimist","assert","yauzl","yazl","vs/code/electron-browser/sharedProcess/sharedProcessMain","graceful-fs"],te=function(K){for(var e=[],D=0,L=K.length;D<L;D++)e[D]=Z[K[D]];return e};define(Z[91],te([0,1]),function(K,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ok=void 0;function D(L,R){if(!L)throw new Error(R?`Assertion failed (${R})`:"Assertion Failed")}e.ok=D}),define(Z[63],te([0,1]),function(K,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.SetMap=e.diffMaps=e.diffSets=e.fromMap=e.groupBy=e.forEach=e.values=void 0;const D=Object.prototype.hasOwnProperty;function L(i){const C=[];for(let g in i)D.call(i,g)&&C.push(i[g]);return C}e.values=L;function R(i,C){for(let g in i)if(D.call(i,g)&&C({key:g,value:i[g]},function(){delete i[g]})===!1)return}e.forEach=R;function T(i,C){const g=Object.create(null);for(const w of i){const u=C(w);let S=g[u];S||(S=g[u]=[]),S.push(w)}return g}e.groupBy=T;function k(i){const C=Object.create(null);return i&&i.forEach((g,w)=>{C[w]=g}),C}e.fromMap=k;function P(i,C){const g=[],w=[];for(let u of i)C.has(u)||g.push(u);for(let u of C)i.has(u)||w.push(u);return{removed:g,added:w}}e.diffSets=P;function m(i,C){const g=[],w=[];for(let[u,S]of i)C.has(u)||g.push(S);for(let[u,S]of C)i.has(u)||w.push(S);return{removed:g,added:w}}e.diffMaps=m;class b{constructor(){this.map=new Map}add(C,g){let w=this.map.get(C);w||(w=new Set,this.map.set(C,w)),w.add(g)}delete(C,g){const w=this.map.get(C);!w||(w.delete(g),w.size===0&&this.map.delete(C))}forEach(C,g){const w=this.map.get(C);!w||w.forEach(g)}}e.SetMap=b}),define(Z[64],te([0,1]),function(K,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.throttle=e.debounce=e.memoize=e.createDecorator=void 0;function D(k){return(P,m,b)=>{let i=null,C=null;if(typeof b.value=="function"?(i="value",C=b.value):typeof b.get=="function"&&(i="get",C=b.get),!C)throw new Error("not supported");b[i]=k(C,m)}}e.createDecorator=D;function L(k,P,m){let b=null,i=null;if(typeof m.value=="function"?(b="value",i=m.value,i.length!==0&&console.warn("Memoize should only be used in functions with zero parameters")):typeof m.get=="function"&&(b="get",i=m.get),!i)throw new Error("not supported");const C=`$memoize$${P}`;m[b]=function(...g){return this.hasOwnProperty(C)||Object.defineProperty(this,C,{configurable:!1,enumerable:!1,writable:!1,value:i.apply(this,g)}),this[C]}}e.memoize=L;function R(k,P,m){return D((b,i)=>{const C=`$debounce$${i}`,g=`$debounce$result$${i}`;return function(...w){this[g]||(this[g]=m?m():void 0),clearTimeout(this[C]),P&&(this[g]=P(this[g],...w),w=[this[g]]),this[C]=setTimeout(()=>{b.apply(this,w),this[g]=m?m():void 0},k)}})}e.debounce=R;function T(k,P,m){return D((b,i)=>{const C=`$throttle$timer$${i}`,g=`$throttle$result$${i}`,w=`$throttle$lastRun$${i}`,u=`$throttle$pending$${i}`;return function(...S){if(this[g]||(this[g]=m?m():void 0),(this[w]===null||this[w]===void 0)&&(this[w]=-Number.MAX_VALUE),P&&(this[g]=P(this[g],...S)),this[u])return;const f=this[w]+k;f<=Date.now()?(this[w]=Date.now(),b.apply(this,[this[g]]),this[g]=m?m():void 0):(this[u]=!0,this[C]=setTimeout(()=>{this[u]=!1,this[w]=Date.now(),b.apply(this,[this[g]]),this[g]=m?m():void 0},f-Date.now()))}})}e.throttle=T}),define(Z[9],te([0,1]),function(K,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.createErrorWithActions=e.isErrorWithActions=e.ExpectedError=e.NotSupportedError=e.NotImplementedError=e.getErrorMessage=e.disposed=e.readonly=e.illegalState=e.illegalArgument=e.canceled=e.CancellationError=e.isPromiseCanceledError=e.transformErrorForSerialization=e.onUnexpectedExternalError=e.onUnexpectedError=e.setUnexpectedErrorHandler=e.errorHandler=e.ErrorHandler=void 0;class D{constructor(){this.listeners=[],this.unexpectedErrorHandler=function(t){setTimeout(()=>{throw t.stack?new Error(t.message+`

`+t.stack):t},0)}}addListener(t){return this.listeners.push(t),()=>{this._removeListener(t)}}emit(t){this.listeners.forEach(r=>{r(t)})}_removeListener(t){this.listeners.splice(this.listeners.indexOf(t),1)}setUnexpectedErrorHandler(t){this.unexpectedErrorHandler=t}getUnexpectedErrorHandler(){return this.unexpectedErrorHandler}onUnexpectedError(t){this.unexpectedErrorHandler(t),this.emit(t)}onUnexpectedExternalError(t){this.unexpectedErrorHandler(t)}}e.ErrorHandler=D,e.errorHandler=new D;function L(a){e.errorHandler.setUnexpectedErrorHandler(a)}e.setUnexpectedErrorHandler=L;function R(a){m(a)||e.errorHandler.onUnexpectedError(a)}e.onUnexpectedError=R;function T(a){m(a)||e.errorHandler.onUnexpectedExternalError(a)}e.onUnexpectedExternalError=T;function k(a){if(a instanceof Error){let{name:t,message:r}=a;const n=a.stacktrace||a.stack;return{$isError:!0,name:t,message:r,stack:n}}return a}e.transformErrorForSerialization=k;const P="Canceled";function m(a){return a instanceof Error&&a.name===P&&a.message===P}e.isPromiseCanceledError=m;class b extends Error{constructor(){super(P);this.name=this.message}}e.CancellationError=b;function i(){const a=new Error(P);return a.name=a.message,a}e.canceled=i;function C(a){return a?new Error(`Illegal argument: ${a}`):new Error("Illegal argument")}e.illegalArgument=C;function g(a){return a?new Error(`Illegal state: ${a}`):new Error("Illegal state")}e.illegalState=g;function w(a){return a?new Error(`readonly property '${a} cannot be changed'`):new Error("readonly property cannot be changed")}e.readonly=w;function u(a){const t=new Error(`${a} has been disposed`);return t.name="DISPOSED",t}e.disposed=u;function S(a){return a?a.message?a.message:a.stack?a.stack.split(`
`)[0]:String(a):"Error"}e.getErrorMessage=S;class f extends Error{constructor(t){super("NotImplemented");t&&(this.message=t)}}e.NotImplementedError=f;class I extends Error{constructor(t){super("NotSupported");t&&(this.message=t)}}e.NotSupportedError=I;class y extends Error{constructor(){super(...arguments);this.isExpected=!0}}e.ExpectedError=y;function E(a){const t=a;return t instanceof Error&&Array.isArray(t.actions)}e.isErrorWithActions=E;function o(a,t=Object.create(null)){const r=new Error(a);return t.actions&&(r.actions=t.actions),r}e.createErrorWithActions=o}),define(Z[17],te([0,1,9]),function(K,e,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ArrayQueue=e.maxIndex=e.minIndex=e.splice=e.insertInto=e.mapFind=e.getRandomElement=e.asArray=e.mapArrayOrNot=e.pushToEnd=e.pushToStart=e.shuffle=e.arrayInsert=e.remove=e.insert=e.index=e.range=e.flatten=e.commonPrefixLength=e.firstOrDefault=e.lastIndex=e.uniqueFilter=e.distinctES6=e.distinct=e.isNonEmptyArray=e.isFalsyOrEmpty=e.move=e.coalesceInPlace=e.coalesce=e.topAsync=e.top=e.delta=e.sortedDiff=e.groupBy=e.quickSelect=e.findFirstInSorted=e.binarySearch=e.equals=e.tail2=e.tail=void 0;function L(_,Y=0){return _[_.length-(1+Y)]}e.tail=L;function R(_){if(_.length===0)throw new Error("Invalid tail call");return[_.slice(0,_.length-1),_[_.length-1]]}e.tail2=R;function T(_,Y,G=(ne,ee)=>ne===ee){if(_===Y)return!0;if(!_||!Y||_.length!==Y.length)return!1;for(let ne=0,ee=_.length;ne<ee;ne++)if(!G(_[ne],Y[ne]))return!1;return!0}e.equals=T;function k(_,Y,G){let ne=0,ee=_.length-1;for(;ne<=ee;){const X=(ne+ee)/2|0,B=G(_[X],Y);if(B<0)ne=X+1;else if(B>0)ee=X-1;else return X}return-(ne+1)}e.binarySearch=k;function P(_,Y){let G=0,ne=_.length;if(ne===0)return 0;for(;G<ne;){const ee=Math.floor((G+ne)/2);Y(_[ee])?ne=ee:G=ee+1}return G}e.findFirstInSorted=P;function m(_,Y,G){if(_=_|0,_>=Y.length)throw new TypeError("invalid index");let ne=Y[Math.floor(Y.length*Math.random())],ee=[],X=[],B=[];for(let re of Y){const ie=G(re,ne);ie<0?ee.push(re):ie>0?X.push(re):B.push(re)}return _<ee.length?m(_,ee,G):_<ee.length+B.length?B[0]:m(_-(ee.length+B.length),X,G)}e.quickSelect=m;function b(_,Y){const G=[];let ne;for(const ee of _.slice(0).sort(Y))!ne||Y(ne[0],ee)!==0?(ne=[ee],G.push(ne)):ne.push(ee);return G}e.groupBy=b;function i(_,Y,G){const ne=[];function ee(re,ie,ce){if(ie===0&&ce.length===0)return;const ue=ne[ne.length-1];ue&&ue.start+ue.deleteCount===re?(ue.deleteCount+=ie,ue.toInsert.push(...ce)):ne.push({start:re,deleteCount:ie,toInsert:ce})}let X=0,B=0;for(;;){if(X===_.length){ee(X,0,Y.slice(B));break}if(B===Y.length){ee(X,_.length-X,[]);break}const re=_[X],ie=Y[B],ce=G(re,ie);ce===0?(X+=1,B+=1):ce<0?(ee(X,1,[]),X+=1):ce>0&&(ee(X,0,[ie]),B+=1)}return ne}e.sortedDiff=i;function C(_,Y,G){const ne=i(_,Y,G),ee=[],X=[];for(const B of ne)ee.push(..._.slice(B.start,B.start+B.deleteCount)),X.push(...B.toInsert);return{removed:ee,added:X}}e.delta=C;function g(_,Y,G){if(G===0)return[];const ne=_.slice(0,G).sort(Y);return u(_,Y,ne,G,_.length),ne}e.top=g;function w(_,Y,G,ne,ee){return G===0?Promise.resolve([]):new Promise((X,B)=>{(async()=>{const re=_.length,ie=_.slice(0,G).sort(Y);for(let ce=G,ue=Math.min(G+ne,re);ce<re;ce=ue,ue=Math.min(ue+ne,re)){if(ce>G&&await new Promise(ge=>setTimeout(ge)),ee&&ee.isCancellationRequested)throw(0,D.canceled)();u(_,Y,ie,ce,ue)}return ie})().then(X,B)})}e.topAsync=w;function u(_,Y,G,ne,ee){for(const X=G.length;ne<ee;ne++){const B=_[ne];if(Y(B,G[X-1])<0){G.pop();const re=P(G,ie=>Y(B,ie)<0);G.splice(re,0,B)}}}function S(_){return _.filter(Y=>!!Y)}e.coalesce=S;function f(_){let Y=0;for(let G=0;G<_.length;G++)_[G]&&(_[Y]=_[G],Y+=1);_.length=Y}e.coalesceInPlace=f;function I(_,Y,G){_.splice(G,0,_.splice(Y,1)[0])}e.move=I;function y(_){return!Array.isArray(_)||_.length===0}e.isFalsyOrEmpty=y;function E(_){return Array.isArray(_)&&_.length>0}e.isNonEmptyArray=E;function o(_,Y){if(!Y)return _.filter((ne,ee)=>_.indexOf(ne)===ee);const G=Object.create(null);return _.filter(ne=>{const ee=Y(ne);return G[ee]?!1:(G[ee]=!0,!0)})}e.distinct=o;function a(_){const Y=new Set;return _.filter(G=>Y.has(G)?!1:(Y.add(G),!0))}e.distinctES6=a;function t(_){const Y=Object.create(null);return G=>{const ne=_(G);return Y[ne]?!1:(Y[ne]=!0,!0)}}e.uniqueFilter=t;function r(_,Y){for(let G=_.length-1;G>=0;G--){const ne=_[G];if(Y(ne))return G}return-1}e.lastIndex=r;function n(_,Y){return _.length>0?_[0]:Y}e.firstOrDefault=n;function s(_,Y,G=(ne,ee)=>ne===ee){let ne=0;for(let ee=0,X=Math.min(_.length,Y.length);ee<X&&G(_[ee],Y[ee]);ee++)ne++;return ne}e.commonPrefixLength=s;function c(_){return[].concat(..._)}e.flatten=c;function l(_,Y){let G=typeof Y=="number"?_:0;typeof Y=="number"?G=_:(G=0,Y=_);const ne=[];if(G<=Y)for(let ee=G;ee<Y;ee++)ne.push(ee);else for(let ee=G;ee>Y;ee--)ne.push(ee);return ne}e.range=l;function h(_,Y,G){return _.reduce((ne,ee)=>(ne[Y(ee)]=G?G(ee):ee,ne),Object.create(null))}e.index=h;function d(_,Y){return _.push(Y),()=>v(_,Y)}e.insert=d;function v(_,Y){const G=_.indexOf(Y);if(G>-1)return _.splice(G,1),Y}e.remove=v;function A(_,Y,G){const ne=_.slice(0,Y),ee=_.slice(Y);return ne.concat(G,ee)}e.arrayInsert=A;function O(_,Y){let G;if(typeof Y=="number"){let ne=Y;G=()=>{const ee=Math.sin(ne++)*179426549;return ee-Math.floor(ee)}}else G=Math.random;for(let ne=_.length-1;ne>0;ne-=1){const ee=Math.floor(G()*(ne+1)),X=_[ne];_[ne]=_[ee],_[ee]=X}}e.shuffle=O;function p(_,Y){const G=_.indexOf(Y);G>-1&&(_.splice(G,1),_.unshift(Y))}e.pushToStart=p;function U(_,Y){const G=_.indexOf(Y);G>-1&&(_.splice(G,1),_.push(Y))}e.pushToEnd=U;function F(_,Y){return Array.isArray(_)?_.map(Y):Y(_)}e.mapArrayOrNot=F;function z(_){return Array.isArray(_)?_:[_]}e.asArray=z;function H(_){return _[Math.floor(Math.random()*_.length)]}e.getRandomElement=H;function M(_,Y){for(const G of _){const ne=Y(G);if(ne!==void 0)return ne}}e.mapFind=M;function j(_,Y,G){const ne=x(_,Y),ee=_.length,X=G.length;_.length=ee+X;for(let B=ee-1;B>=ne;B--)_[B+X]=_[B];for(let B=0;B<X;B++)_[B+ne]=G[B]}e.insertInto=j;function q(_,Y,G,ne){const ee=x(_,Y),X=_.splice(ee,G);return j(_,ee,ne),X}e.splice=q;function x(_,Y){return Y<0?Math.max(Y+_.length,0):Math.min(Y,_.length)}function $(_,Y){let G=Number.MAX_SAFE_INTEGER,ne=0;return _.forEach((ee,X)=>{const B=Y(ee);B<G&&(G=B,ne=X)}),ne}e.minIndex=$;function N(_,Y){let G=Number.MIN_SAFE_INTEGER,ne=0;return _.forEach((ee,X)=>{const B=Y(ee);B>G&&(G=B,ne=X)}),ne}e.maxIndex=N;class W{constructor(Y){this.items=Y,this.firstIdx=0,this.lastIdx=this.items.length-1}get length(){return this.lastIdx-this.firstIdx+1}takeWhile(Y){let G=this.firstIdx;for(;G<this.items.length&&Y(this.items[G]);)G++;const ne=G===this.firstIdx?null:this.items.slice(this.firstIdx,G);return this.firstIdx=G,ne}takeFromEndWhile(Y){let G=this.lastIdx;for(;G>=0&&Y(this.items[G]);)G--;const ne=G===this.lastIdx?null:this.items.slice(G+1,this.lastIdx+1);return this.lastIdx=G,ne}}e.ArrayQueue=W}),define(Z[65],te([0,1]),function(K,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.once=void 0;function D(L){const R=this;let T=!1,k;return function(){return T||(T=!0,k=L.apply(R,arguments)),k}}e.once=D}),define(Z[55],te([0,1]),function(K,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Iterable=void 0;var D;(function(L){function R(a){return a&&typeof a=="object"&&typeof a[Symbol.iterator]=="function"}L.is=R;const T=Object.freeze([]);function k(){return T}L.empty=k;function*P(a){yield a}L.single=P;function m(a){return a||T}L.from=m;function b(a){return!a||a[Symbol.iterator]().next().done===!0}L.isEmpty=b;function i(a){return a[Symbol.iterator]().next().value}L.first=i;function C(a,t){for(const r of a)if(t(r))return!0;return!1}L.some=C;function g(a,t){for(const r of a)if(t(r))return r}L.find=g;function*w(a,t){for(const r of a)t(r)&&(yield r)}L.filter=w;function*u(a,t){let r=0;for(const n of a)yield t(n,r++)}L.map=u;function*S(...a){for(const t of a)for(const r of t)yield r}L.concat=S;function*f(a){for(const t of a)for(const r of t)yield r}L.concatNested=f;function I(a,t,r){let n=r;for(const s of a)n=t(n,s);return n}L.reduce=I;function*y(a,t,r=a.length){for(t<0&&(t+=a.length),r<0?r+=a.length:r>a.length&&(r=a.length);t<r;t++)yield a[t]}L.slice=y;function E(a,t=Number.POSITIVE_INFINITY){const r=[];if(t===0)return[r,a];const n=a[Symbol.iterator]();for(let s=0;s<t;s++){const c=n.next();if(c.done)return[r,L.empty()];r.push(c.value)}return[r,{[Symbol.iterator](){return n}}]}L.consume=E;function o(a,t,r=(n,s)=>n===s){const n=a[Symbol.iterator](),s=t[Symbol.iterator]();for(;;){const c=n.next(),l=s.next();if(c.done!==l.done)return!1;if(c.done)return!0;if(!r(c.value,l.value))return!1}}L.equals=o})(D=e.Iterable||(e.Iterable={}))}),define(Z[34],te([0,1]),function(K,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getNodeType=e.stripComments=e.visit=e.findNodeAtOffset=e.contains=e.getNodeValue=e.getNodePath=e.findNodeAtLocation=e.parseTree=e.parse=e.getLocation=e.createScanner=e.ParseOptions=e.ParseErrorCode=e.SyntaxKind=e.ScanError=void 0;var D;(function(t){t[t.None=0]="None",t[t.UnexpectedEndOfComment=1]="UnexpectedEndOfComment",t[t.UnexpectedEndOfString=2]="UnexpectedEndOfString",t[t.UnexpectedEndOfNumber=3]="UnexpectedEndOfNumber",t[t.InvalidUnicode=4]="InvalidUnicode",t[t.InvalidEscapeCharacter=5]="InvalidEscapeCharacter",t[t.InvalidCharacter=6]="InvalidCharacter"})(D=e.ScanError||(e.ScanError={}));var L;(function(t){t[t.OpenBraceToken=1]="OpenBraceToken",t[t.CloseBraceToken=2]="CloseBraceToken",t[t.OpenBracketToken=3]="OpenBracketToken",t[t.CloseBracketToken=4]="CloseBracketToken",t[t.CommaToken=5]="CommaToken",t[t.ColonToken=6]="ColonToken",t[t.NullKeyword=7]="NullKeyword",t[t.TrueKeyword=8]="TrueKeyword",t[t.FalseKeyword=9]="FalseKeyword",t[t.StringLiteral=10]="StringLiteral",t[t.NumericLiteral=11]="NumericLiteral",t[t.LineCommentTrivia=12]="LineCommentTrivia",t[t.BlockCommentTrivia=13]="BlockCommentTrivia",t[t.LineBreakTrivia=14]="LineBreakTrivia",t[t.Trivia=15]="Trivia",t[t.Unknown=16]="Unknown",t[t.EOF=17]="EOF"})(L=e.SyntaxKind||(e.SyntaxKind={}));var R;(function(t){t[t.InvalidSymbol=1]="InvalidSymbol",t[t.InvalidNumberFormat=2]="InvalidNumberFormat",t[t.PropertyNameExpected=3]="PropertyNameExpected",t[t.ValueExpected=4]="ValueExpected",t[t.ColonExpected=5]="ColonExpected",t[t.CommaExpected=6]="CommaExpected",t[t.CloseBraceExpected=7]="CloseBraceExpected",t[t.CloseBracketExpected=8]="CloseBracketExpected",t[t.EndOfFileExpected=9]="EndOfFileExpected",t[t.InvalidCommentToken=10]="InvalidCommentToken",t[t.UnexpectedEndOfComment=11]="UnexpectedEndOfComment",t[t.UnexpectedEndOfString=12]="UnexpectedEndOfString",t[t.UnexpectedEndOfNumber=13]="UnexpectedEndOfNumber",t[t.InvalidUnicode=14]="InvalidUnicode",t[t.InvalidEscapeCharacter=15]="InvalidEscapeCharacter",t[t.InvalidCharacter=16]="InvalidCharacter"})(R=e.ParseErrorCode||(e.ParseErrorCode={}));var T;(function(t){t.DEFAULT={allowTrailingComma:!0}})(T=e.ParseOptions||(e.ParseOptions={}));function k(t,r=!1){let n=0,s=t.length,c="",l=0,h=16,d=0;function v(H){let M=0,j=0;for(;M<H;){const q=t.charCodeAt(n);if(q>=48&&q<=57)j=j*16+q-48;else if(q>=65&&q<=70)j=j*16+q-65+10;else if(q>=97&&q<=102)j=j*16+q-97+10;else break;n++,M++}return M<H&&(j=-1),j}function A(H){n=H,c="",l=0,h=16,d=0}function O(){const H=n;if(t.charCodeAt(n)===48)n++;else for(n++;n<t.length&&b(t.charCodeAt(n));)n++;if(n<t.length&&t.charCodeAt(n)===46)if(n++,n<t.length&&b(t.charCodeAt(n)))for(n++;n<t.length&&b(t.charCodeAt(n));)n++;else return d=3,t.substring(H,n);let M=n;if(n<t.length&&(t.charCodeAt(n)===69||t.charCodeAt(n)===101))if(n++,(n<t.length&&t.charCodeAt(n)===43||t.charCodeAt(n)===45)&&n++,n<t.length&&b(t.charCodeAt(n))){for(n++;n<t.length&&b(t.charCodeAt(n));)n++;M=n}else d=3;return t.substring(H,M)}function p(){let H="",M=n;for(;;){if(n>=s){H+=t.substring(M,n),d=2;break}const j=t.charCodeAt(n);if(j===34){H+=t.substring(M,n),n++;break}if(j===92){if(H+=t.substring(M,n),n++,n>=s){d=2;break}switch(t.charCodeAt(n++)){case 34:H+='"';break;case 92:H+="\\";break;case 47:H+="/";break;case 98:H+="\b";break;case 102:H+="\f";break;case 110:H+=`
`;break;case 114:H+="\r";break;case 116:H+="	";break;case 117:const x=v(4);x>=0?H+=String.fromCharCode(x):d=4;break;default:d=5}M=n;continue}if(j>=0&&j<=31)if(m(j)){H+=t.substring(M,n),d=2;break}else d=6;n++}return H}function U(){if(c="",d=0,l=n,n>=s)return l=s,h=17;let H=t.charCodeAt(n);if(P(H)){do n++,c+=String.fromCharCode(H),H=t.charCodeAt(n);while(P(H));return h=15}if(m(H))return n++,c+=String.fromCharCode(H),H===13&&t.charCodeAt(n)===10&&(n++,c+=`
`),h=14;switch(H){case 123:return n++,h=1;case 125:return n++,h=2;case 91:return n++,h=3;case 93:return n++,h=4;case 58:return n++,h=6;case 44:return n++,h=5;case 34:return n++,c=p(),h=10;case 47:const M=n-1;if(t.charCodeAt(n+1)===47){for(n+=2;n<s&&!m(t.charCodeAt(n));)n++;return c=t.substring(M,n),h=12}if(t.charCodeAt(n+1)===42){n+=2;const j=s-1;let q=!1;for(;n<j;){if(t.charCodeAt(n)===42&&t.charCodeAt(n+1)===47){n+=2,q=!0;break}n++}return q||(n++,d=1),c=t.substring(M,n),h=13}return c+=String.fromCharCode(H),n++,h=16;case 45:if(c+=String.fromCharCode(H),n++,n===s||!b(t.charCodeAt(n)))return h=16;case 48:case 49:case 50:case 51:case 52:case 53:case 54:case 55:case 56:case 57:return c+=O(),h=11;default:for(;n<s&&F(H);)n++,H=t.charCodeAt(n);if(l!==n){switch(c=t.substring(l,n),c){case"true":return h=8;case"false":return h=9;case"null":return h=7}return h=16}return c+=String.fromCharCode(H),n++,h=16}}function F(H){if(P(H)||m(H))return!1;switch(H){case 125:case 93:case 123:case 91:case 34:case 58:case 44:case 47:return!1}return!0}function z(){let H;do H=U();while(H>=12&&H<=15);return H}return{setPosition:A,getPosition:()=>n,scan:r?z:U,getToken:()=>h,getTokenValue:()=>c,getTokenOffset:()=>l,getTokenLength:()=>n-l,getTokenError:()=>d}}e.createScanner=k;function P(t){return t===32||t===9||t===11||t===12||t===160||t===5760||t>=8192&&t<=8203||t===8239||t===8287||t===12288||t===65279}function m(t){return t===10||t===13||t===8232||t===8233}function b(t){return t>=48&&t<=57}var i;(function(t){t[t.nullCharacter=0]="nullCharacter",t[t.maxAsciiCharacter=127]="maxAsciiCharacter",t[t.lineFeed=10]="lineFeed",t[t.carriageReturn=13]="carriageReturn",t[t.lineSeparator=8232]="lineSeparator",t[t.paragraphSeparator=8233]="paragraphSeparator",t[t.nextLine=133]="nextLine",t[t.space=32]="space",t[t.nonBreakingSpace=160]="nonBreakingSpace",t[t.enQuad=8192]="enQuad",t[t.emQuad=8193]="emQuad",t[t.enSpace=8194]="enSpace",t[t.emSpace=8195]="emSpace",t[t.threePerEmSpace=8196]="threePerEmSpace",t[t.fourPerEmSpace=8197]="fourPerEmSpace",t[t.sixPerEmSpace=8198]="sixPerEmSpace",t[t.figureSpace=8199]="figureSpace",t[t.punctuationSpace=8200]="punctuationSpace",t[t.thinSpace=8201]="thinSpace",t[t.hairSpace=8202]="hairSpace",t[t.zeroWidthSpace=8203]="zeroWidthSpace",t[t.narrowNoBreakSpace=8239]="narrowNoBreakSpace",t[t.ideographicSpace=12288]="ideographicSpace",t[t.mathematicalSpace=8287]="mathematicalSpace",t[t.ogham=5760]="ogham",t[t._=95]="_",t[t.$=36]="$",t[t._0=48]="_0",t[t._1=49]="_1",t[t._2=50]="_2",t[t._3=51]="_3",t[t._4=52]="_4",t[t._5=53]="_5",t[t._6=54]="_6",t[t._7=55]="_7",t[t._8=56]="_8",t[t._9=57]="_9",t[t.a=97]="a",t[t.b=98]="b",t[t.c=99]="c",t[t.d=100]="d",t[t.e=101]="e",t[t.f=102]="f",t[t.g=103]="g",t[t.h=104]="h",t[t.i=105]="i",t[t.j=106]="j",t[t.k=107]="k",t[t.l=108]="l",t[t.m=109]="m",t[t.n=110]="n",t[t.o=111]="o",t[t.p=112]="p",t[t.q=113]="q",t[t.r=114]="r",t[t.s=115]="s",t[t.t=116]="t",t[t.u=117]="u",t[t.v=118]="v",t[t.w=119]="w",t[t.x=120]="x",t[t.y=121]="y",t[t.z=122]="z",t[t.A=65]="A",t[t.B=66]="B",t[t.C=67]="C",t[t.D=68]="D",t[t.E=69]="E",t[t.F=70]="F",t[t.G=71]="G",t[t.H=72]="H",t[t.I=73]="I",t[t.J=74]="J",t[t.K=75]="K",t[t.L=76]="L",t[t.M=77]="M",t[t.N=78]="N",t[t.O=79]="O",t[t.P=80]="P",t[t.Q=81]="Q",t[t.R=82]="R",t[t.S=83]="S",t[t.T=84]="T",t[t.U=85]="U",t[t.V=86]="V",t[t.W=87]="W",t[t.X=88]="X",t[t.Y=89]="Y",t[t.Z=90]="Z",t[t.ampersand=38]="ampersand",t[t.asterisk=42]="asterisk",t[t.at=64]="at",t[t.backslash=92]="backslash",t[t.bar=124]="bar",t[t.caret=94]="caret",t[t.closeBrace=125]="closeBrace",t[t.closeBracket=93]="closeBracket",t[t.closeParen=41]="closeParen",t[t.colon=58]="colon",t[t.comma=44]="comma",t[t.dot=46]="dot",t[t.doubleQuote=34]="doubleQuote",t[t.equals=61]="equals",t[t.exclamation=33]="exclamation",t[t.greaterThan=62]="greaterThan",t[t.lessThan=60]="lessThan",t[t.minus=45]="minus",t[t.openBrace=123]="openBrace",t[t.openBracket=91]="openBracket",t[t.openParen=40]="openParen",t[t.percent=37]="percent",t[t.plus=43]="plus",t[t.question=63]="question",t[t.semicolon=59]="semicolon",t[t.singleQuote=39]="singleQuote",t[t.slash=47]="slash",t[t.tilde=126]="tilde",t[t.backspace=8]="backspace",t[t.formFeed=12]="formFeed",t[t.byteOrderMark=65279]="byteOrderMark",t[t.tab=9]="tab",t[t.verticalTab=11]="verticalTab"})(i||(i={}));function C(t,r){const n=[],s=new Object;let c;const l={value:{},offset:0,length:0,type:"object",parent:void 0};let h=!1;function d(v,A,O,p){l.value=v,l.offset=A,l.length=O,l.type=p,l.colonOffset=void 0,c=l}try{E(t,{onObjectBegin:(v,A)=>{if(r<=v)throw s;c=void 0,h=r>v,n.push("")},onObjectProperty:(v,A,O)=>{if(r<A||(d(v,A,O,"property"),n[n.length-1]=v,r<=A+O))throw s},onObjectEnd:(v,A)=>{if(r<=v)throw s;c=void 0,n.pop()},onArrayBegin:(v,A)=>{if(r<=v)throw s;c=void 0,n.push(0)},onArrayEnd:(v,A)=>{if(r<=v)throw s;c=void 0,n.pop()},onLiteralValue:(v,A,O)=>{if(r<A||(d(v,A,O,a(v)),r<=A+O))throw s},onSeparator:(v,A,O)=>{if(r<=A)throw s;if(v===":"&&c&&c.type==="property")c.colonOffset=A,h=!1,c=void 0;else if(v===","){const p=n[n.length-1];typeof p=="number"?n[n.length-1]=p+1:(h=!0,n[n.length-1]=""),c=void 0}}})}catch(v){if(v!==s)throw v}return{path:n,previousNode:c,isAtPropertyKey:h,matches:v=>{let A=0;for(let O=0;A<v.length&&O<n.length;O++)if(v[A]===n[O]||v[A]==="*")A++;else if(v[A]!=="**")return!1;return A===v.length}}}e.getLocation=C;function g(t,r=[],n=T.DEFAULT){let s=null,c=[];const l=[];function h(v){Array.isArray(c)?c.push(v):s!==null&&(c[s]=v)}return E(t,{onObjectBegin:()=>{const v={};h(v),l.push(c),c=v,s=null},onObjectProperty:v=>{s=v},onObjectEnd:()=>{c=l.pop()},onArrayBegin:()=>{const v=[];h(v),l.push(c),c=v,s=null},onArrayEnd:()=>{c=l.pop()},onLiteralValue:h,onError:(v,A,O)=>{r.push({error:v,offset:A,length:O})}},n),c[0]}e.parse=g;function w(t,r=[],n=T.DEFAULT){let s={type:"array",offset:-1,length:-1,children:[],parent:void 0};function c(v){s.type==="property"&&(s.length=v-s.offset,s=s.parent)}function l(v){return s.children.push(v),v}E(t,{onObjectBegin:v=>{s=l({type:"object",offset:v,length:-1,parent:s,children:[]})},onObjectProperty:(v,A,O)=>{s=l({type:"property",offset:A,length:-1,parent:s,children:[]}),s.children.push({type:"string",value:v,offset:A,length:O,parent:s})},onObjectEnd:(v,A)=>{s.length=v+A-s.offset,s=s.parent,c(v+A)},onArrayBegin:(v,A)=>{s=l({type:"array",offset:v,length:-1,parent:s,children:[]})},onArrayEnd:(v,A)=>{s.length=v+A-s.offset,s=s.parent,c(v+A)},onLiteralValue:(v,A,O)=>{l({type:a(v),offset:A,length:O,parent:s,value:v}),c(A+O)},onSeparator:(v,A,O)=>{s.type==="property"&&(v===":"?s.colonOffset=A:v===","&&c(A))},onError:(v,A,O)=>{r.push({error:v,offset:A,length:O})}},n);const d=s.children[0];return d&&delete d.parent,d}e.parseTree=w;function u(t,r){if(!t)return;let n=t;for(let s of r)if(typeof s=="string"){if(n.type!=="object"||!Array.isArray(n.children))return;let c=!1;for(const l of n.children)if(Array.isArray(l.children)&&l.children[0].value===s){n=l.children[1],c=!0;break}if(!c)return}else{const c=s;if(n.type!=="array"||c<0||!Array.isArray(n.children)||c>=n.children.length)return;n=n.children[c]}return n}e.findNodeAtLocation=u;function S(t){if(!t.parent||!t.parent.children)return[];const r=S(t.parent);if(t.parent.type==="property"){const n=t.parent.children[0].value;r.push(n)}else if(t.parent.type==="array"){const n=t.parent.children.indexOf(t);n!==-1&&r.push(n)}return r}e.getNodePath=S;function f(t){switch(t.type){case"array":return t.children.map(f);case"object":const r=Object.create(null);for(let n of t.children){const s=n.children[1];s&&(r[n.children[0].value]=f(s))}return r;case"null":case"string":case"number":case"boolean":return t.value;default:return}}e.getNodeValue=f;function I(t,r,n=!1){return r>=t.offset&&r<t.offset+t.length||n&&r===t.offset+t.length}e.contains=I;function y(t,r,n=!1){if(I(t,r,n)){const s=t.children;if(Array.isArray(s))for(let c=0;c<s.length&&s[c].offset<=r;c++){const l=y(s[c],r,n);if(l)return l}return t}}e.findNodeAtOffset=y;function E(t,r,n=T.DEFAULT){const s=k(t,!1);function c(G){return G?()=>G(s.getTokenOffset(),s.getTokenLength()):()=>!0}function l(G){return G?ne=>G(ne,s.getTokenOffset(),s.getTokenLength()):()=>!0}const h=c(r.onObjectBegin),d=l(r.onObjectProperty),v=c(r.onObjectEnd),A=c(r.onArrayBegin),O=c(r.onArrayEnd),p=l(r.onLiteralValue),U=l(r.onSeparator),F=c(r.onComment),z=l(r.onError),H=n&&n.disallowComments,M=n&&n.allowTrailingComma;function j(){for(;;){const G=s.scan();switch(s.getTokenError()){case 4:q(14);break;case 5:q(15);break;case 3:q(13);break;case 1:H||q(11);break;case 2:q(12);break;case 6:q(16);break}switch(G){case 12:case 13:H?q(10):F();break;case 16:q(1);break;case 15:case 14:break;default:return G}}}function q(G,ne=[],ee=[]){if(z(G),ne.length+ee.length>0){let X=s.getToken();for(;X!==17;){if(ne.indexOf(X)!==-1){j();break}else if(ee.indexOf(X)!==-1)break;X=j()}}}function x(G){const ne=s.getTokenValue();return G?p(ne):d(ne),j(),!0}function $(){switch(s.getToken()){case 11:let G=0;try{G=JSON.parse(s.getTokenValue()),typeof G!="number"&&(q(2),G=0)}catch(ne){q(2)}p(G);break;case 7:p(null);break;case 8:p(!0);break;case 9:p(!1);break;default:return!1}return j(),!0}function N(){return s.getToken()!==10?(q(3,[],[2,5]),!1):(x(!1),s.getToken()===6?(U(":"),j(),Y()||q(4,[],[2,5])):q(5,[],[2,5]),!0)}function W(){h(),j();let G=!1;for(;s.getToken()!==2&&s.getToken()!==17;){if(s.getToken()===5){if(G||q(4,[],[]),U(","),j(),s.getToken()===2&&M)break}else G&&q(6,[],[]);N()||q(4,[],[2,5]),G=!0}return v(),s.getToken()!==2?q(7,[2],[]):j(),!0}function _(){A(),j();let G=!1;for(;s.getToken()!==4&&s.getToken()!==17;){if(s.getToken()===5){if(G||q(4,[],[]),U(","),j(),s.getToken()===4&&M)break}else G&&q(6,[],[]);Y()||q(4,[],[4,5]),G=!0}return O(),s.getToken()!==4?q(8,[4],[]):j(),!0}function Y(){switch(s.getToken()){case 3:return _();case 1:return W();case 10:return x(!0);default:return $()}}return j(),s.getToken()===17?n.allowEmptyContent?!0:(q(4,[],[]),!1):Y()?(s.getToken()!==17&&q(9,[],[]),!0):(q(4,[],[]),!1)}e.visit=E;function o(t,r){let n=k(t),s=[],c,l=0,h;do switch(h=n.getPosition(),c=n.scan(),c){case 12:case 13:case 17:l!==h&&s.push(t.substring(l,h)),r!==void 0&&s.push(n.getTokenValue().replace(/[^\r\n]/g,r)),l=n.getPosition();break}while(c!==17);return s.join("")}e.stripComments=o;function a(t){switch(typeof t){case"boolean":return"boolean";case"number":return"number";case"string":return"string";case"object":{if(t){if(Array.isArray(t))return"array"}else return"null";return"object"}default:return"null"}}e.getNodeType=a}),define(Z[48],te([0,1,34]),function(K,e,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.isEOL=e.getEOL=e.format=void 0;function L(m,b,i){let C,g,w,u,S;if(b){for(u=b.offset,S=u+b.length,w=u;w>0&&!P(m,w-1);)w--;let l=S;for(;l<m.length&&!P(m,l);)l++;g=m.substring(w,l),C=T(g,i)}else g=m,C=0,w=0,u=0,S=m.length;const f=k(i,m);let I=!1,y=0,E;i.insertSpaces?E=R(" ",i.tabSize||4):E="	";const o=(0,D.createScanner)(g,!1);let a=!1;function t(){return f+R(E,C+y)}function r(){let l=o.scan();for(I=!1;l===15||l===14;)I=I||l===14,l=o.scan();return a=l===16||o.getTokenError()!==0,l}const n=[];function s(l,h,d){!a&&h<S&&d>u&&m.substring(h,d)!==l&&n.push({offset:h,length:d-h,content:l})}let c=r();if(c!==17){const l=o.getTokenOffset()+w,h=R(E,C);s(h,w,l)}for(;c!==17;){let l=o.getTokenOffset()+o.getTokenLength()+w,h=r(),d="";for(;!I&&(h===12||h===13);){const A=o.getTokenOffset()+w;s(" ",l,A),l=o.getTokenOffset()+o.getTokenLength()+w,d=h===12?t():"",h=r()}if(h===2)c!==1&&(y--,d=t());else if(h===4)c!==3&&(y--,d=t());else{switch(c){case 3:case 1:y++,d=t();break;case 5:case 12:d=t();break;case 13:I?d=t():d=" ";break;case 6:d=" ";break;case 10:if(h===6){d="";break}case 7:case 8:case 9:case 11:case 2:case 4:h===12||h===13?d=" ":h!==5&&h!==17&&(a=!0);break;case 16:a=!0;break}I&&(h===12||h===13)&&(d=t())}const v=o.getTokenOffset()+w;s(d,l,v),c=h}return n}e.format=L;function R(m,b){let i="";for(let C=0;C<b;C++)i+=m;return i}function T(m,b){let i=0,C=0;const g=b.tabSize||4;for(;i<m.length;){const w=m.charAt(i);if(w===" ")C++;else if(w==="	")C+=g;else break;i++}return Math.floor(C/g)}function k(m,b){for(let i=0;i<b.length;i++){const C=b.charAt(i);if(C==="\r")return i+1<b.length&&b.charAt(i+1)===`
`?`\r
`:"\r";if(C===`
`)return`
`}return m&&m.eol||`
`}e.getEOL=k;function P(m,b){return`\r
`.indexOf(m.charAt(b))!==-1}e.isEOL=P}),define(Z[44],te([0,1,34,48]),function(K,e,D,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.applyEdits=e.applyEdit=e.withFormatting=e.setProperty=e.removeProperty=void 0;function R(b,i,C){return T(b,i,void 0,C)}e.removeProperty=R;function T(b,i,C,g,w){const u=i.slice(),S=[],f=(0,D.parseTree)(b,S);let I,y;for(;u.length>0&&(y=u.pop(),I=(0,D.findNodeAtLocation)(f,u),I===void 0&&C!==void 0);)typeof y=="string"?C={[y]:C}:C=[C];if(I)if(I.type==="object"&&typeof y=="string"&&Array.isArray(I.children)){const E=(0,D.findNodeAtLocation)(I,[y]);if(E!==void 0)if(C===void 0){if(!E.parent)throw new Error("Malformed AST");const o=I.children.indexOf(E.parent);let a,t=E.parent.offset+E.parent.length;if(o>0){const r=I.children[o-1];a=r.offset+r.length}else a=I.offset+1,I.children.length>1&&(t=I.children[1].offset);return k(b,{offset:a,length:t-a,content:""},g)}else return k(b,{offset:E.offset,length:E.length,content:JSON.stringify(C)},g);else{if(C===void 0)return[];const o=`${JSON.stringify(y)}: ${JSON.stringify(C)}`,a=w?w(I.children.map(r=>r.children[0].value)):I.children.length;let t;if(a>0){const r=I.children[a-1];t={offset:r.offset+r.length,length:0,content:","+o}}else I.children.length===0?t={offset:I.offset+1,length:0,content:o}:t={offset:I.offset+1,length:0,content:o+","};return k(b,t,g)}}else if(I.type==="array"&&typeof y=="number"&&Array.isArray(I.children))if(C!==void 0){const E=`${JSON.stringify(C)}`;let o;if(I.children.length===0||y===0)o={offset:I.offset+1,length:0,content:I.children.length===0?E:E+","};else{const a=y===-1||y>I.children.length?I.children.length:y,t=I.children[a-1];o={offset:t.offset+t.length,length:0,content:","+E}}return k(b,o,g)}else{const E=y,o=I.children[E];let a;if(I.children.length===1)a={offset:I.offset+1,length:I.length-2,content:""};else if(I.children.length-1===E){const t=I.children[E-1],r=t.offset+t.length,n=I.offset+I.length;a={offset:r,length:n-2-r,content:""}}else a={offset:o.offset,length:I.children[E+1].offset-o.offset,content:""};return k(b,a,g)}else throw new Error(`Can not add ${typeof y!="number"?"index":"property"} to parent of type ${I.type}`);else{if(C===void 0)throw new Error("Can not delete in empty document");return k(b,{offset:f?f.offset:0,length:f?f.length:0,content:JSON.stringify(C)},g)}}e.setProperty=T;function k(b,i,C){let g=P(b,i),w=i.offset,u=i.offset+i.content.length;if(i.length===0||i.content.length===0){for(;w>0&&!(0,L.isEOL)(g,w-1);)w--;for(;u<g.length&&!(0,L.isEOL)(g,u);)u++}const S=(0,L.format)(g,{offset:w,length:u-w},C);for(let I=S.length-1;I>=0;I--){const y=S[I];g=P(g,y),w=Math.min(w,y.offset),u=Math.max(u,y.offset+y.length),u+=y.content.length-y.length}const f=b.length-(g.length-u)-w;return[{offset:w,length:f,content:g.substring(w,u)}]}e.withFormatting=k;function P(b,i){return b.substring(0,i.offset)+i.content+b.substring(i.offset+i.length)}e.applyEdit=P;function m(b,i){let C=i.slice(0).sort((w,u)=>{const S=w.offset-u.offset;return S===0?w.length-u.length:S}),g=b.length;for(let w=C.length-1;w>=0;w--){let u=C[w];if(u.offset+u.length<=g)b=P(b,u);else throw new Error("Overlapping edit");g=u.offset}return b}e.applyEdits=m}),define(Z[2],te([0,1,65,55]),function(K,e,D,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ImmortalReference=e.AsyncReferenceCollection=e.ReferenceCollection=e.RefCountedDisposable=e.MutableDisposable=e.Disposable=e.DisposableStore=e.toDisposable=e.combinedDisposable=e.dispose=e.isDisposable=e.MultiDisposeError=e.markAsSingleton=e.setDisposableTracker=void 0;const R=!1;let T=null;function k(n){T=n}if(e.setDisposableTracker=k,R){const n="__is_disposable_tracked__";k(new class{trackDisposable(s){const c=new Error("Potentially leaked disposable").stack;setTimeout(()=>{s[n]||console.log(c)},3e3)}setParent(s,c){if(s&&s!==y.None)try{s[n]=!0}catch{}}markAsDisposed(s){if(s&&s!==y.None)try{s[n]=!0}catch{}}markAsSingleton(s){}})}function P(n){return T?.trackDisposable(n),n}function m(n){T?.markAsDisposed(n)}function b(n,s){T?.setParent(n,s)}function i(n,s){if(!!T)for(const c of n)T.setParent(c,s)}function C(n){return T?.markAsSingleton(n),n}e.markAsSingleton=C;class g extends Error{constructor(s){super(`Encountered errors while disposing of store. Errors: [${s.join(", ")}]`);this.errors=s}}e.MultiDisposeError=g;function w(n){return typeof n.dispose=="function"&&n.dispose.length===0}e.isDisposable=w;function u(n){if(L.Iterable.is(n)){let s=[];for(const c of n)if(c)try{c.dispose()}catch(l){s.push(l)}if(s.length===1)throw s[0];if(s.length>1)throw new g(s);return Array.isArray(n)?[]:n}else if(n)return n.dispose(),n}e.dispose=u;function S(...n){const s=f(()=>u(n));return i(n,s),s}e.combinedDisposable=S;function f(n){const s=P({dispose:(0,D.once)(()=>{m(s),n()})});return s}e.toDisposable=f;class I{constructor(){this._toDispose=new Set,this._isDisposed=!1,P(this)}dispose(){this._isDisposed||(m(this),this._isDisposed=!0,this.clear())}clear(){try{u(this._toDispose.values())}finally{this._toDispose.clear()}}add(s){if(!s)return s;if(s===this)throw new Error("Cannot register a disposable on itself!");return b(s,this),this._isDisposed?I.DISABLE_DISPOSED_WARNING||console.warn(new Error("Trying to add a disposable to a DisposableStore that has already been disposed of. The added object will be leaked!").stack):this._toDispose.add(s),s}}e.DisposableStore=I,I.DISABLE_DISPOSED_WARNING=!1;class y{constructor(){this._store=new I,P(this),b(this._store,this)}dispose(){m(this),this._store.dispose()}_register(s){if(s===this)throw new Error("Cannot register a disposable on itself!");return this._store.add(s)}}e.Disposable=y,y.None=Object.freeze({dispose(){}});class E{constructor(){this._isDisposed=!1,P(this)}get value(){return this._isDisposed?void 0:this._value}set value(s){this._isDisposed||s===this._value||(this._value?.dispose(),s&&b(s,this),this._value=s)}clear(){this.value=void 0}dispose(){this._isDisposed=!0,m(this),this._value?.dispose(),this._value=void 0}clearAndLeak(){const s=this._value;return this._value=void 0,s&&b(s,null),s}}e.MutableDisposable=E;class o{constructor(s){this._disposable=s,this._counter=1}acquire(){return this._counter++,this}release(){return--this._counter==0&&this._disposable.dispose(),this}}e.RefCountedDisposable=o;class a{constructor(){this.references=new Map}acquire(s,...c){let l=this.references.get(s);l||(l={counter:0,object:this.createReferencedObject(s,...c)},this.references.set(s,l));const{object:h}=l,d=(0,D.once)(()=>{--l.counter==0&&(this.destroyReferencedObject(s,l.object),this.references.delete(s))});return l.counter++,{object:h,dispose:d}}}e.ReferenceCollection=a;class t{constructor(s){this.referenceCollection=s}async acquire(s,...c){const l=this.referenceCollection.acquire(s,...c);try{return{object:await l.object,dispose:()=>l.dispose()}}catch(h){throw l.dispose(),h}}}e.AsyncReferenceCollection=t;class r{constructor(s){this.object=s}dispose(){}}e.ImmortalReference=r}),define(Z[92],te([0,1]),function(K,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.LinkedList=void 0;class D{constructor(T){this.element=T,this.next=D.Undefined,this.prev=D.Undefined}}D.Undefined=new D(void 0);class L{constructor(){this._first=D.Undefined,this._last=D.Undefined,this._size=0}get size(){return this._size}isEmpty(){return this._first===D.Undefined}clear(){let T=this._first;for(;T!==D.Undefined;){const k=T.next;T.prev=D.Undefined,T.next=D.Undefined,T=k}this._first=D.Undefined,this._last=D.Undefined,this._size=0}unshift(T){return this._insert(T,!1)}push(T){return this._insert(T,!0)}_insert(T,k){const P=new D(T);if(this._first===D.Undefined)this._first=P,this._last=P;else if(k){const b=this._last;this._last=P,P.prev=b,b.next=P}else{const b=this._first;this._first=P,P.next=b,b.prev=P}this._size+=1;let m=!1;return()=>{m||(m=!0,this._remove(P))}}shift(){if(this._first!==D.Undefined){const T=this._first.element;return this._remove(this._first),T}}pop(){if(this._last!==D.Undefined){const T=this._last.element;return this._remove(this._last),T}}_remove(T){if(T.prev!==D.Undefined&&T.next!==D.Undefined){const k=T.prev;k.next=T.next,T.next.prev=k}else T.prev===D.Undefined&&T.next===D.Undefined?(this._first=D.Undefined,this._last=D.Undefined):T.next===D.Undefined?(this._last=this._last.prev,this._last.next=D.Undefined):T.prev===D.Undefined&&(this._first=this._first.next,this._first.prev=D.Undefined);this._size-=1}*[Symbol.iterator](){let T=this._first;for(;T!==D.Undefined;)yield T.element,T=T.next}}e.LinkedList=L}),function(){function K(R){const T=[];typeof R=="number"&&T.push("code/timeOrigin",R);function k(m){T.push(m,Date.now())}function P(){const m=[];for(let b=0;b<T.length;b+=2)m.push({name:T[b],startTime:T[b+1]});return m}return{mark:k,getMarks:P}}function e(){if(typeof performance=="object"&&typeof performance.mark=="function")return typeof performance.timeOrigin!="number"&&!performance.timing?K():{mark(R){performance.mark(R)},getMarks(){let R=performance.timeOrigin;typeof R!="number"&&(R=performance.timing.navigationStart||performance.timing.redirectStart||performance.timing.fetchStart);const T=[{name:"code/timeOrigin",startTime:Math.round(R)}];for(const k of performance.getEntriesByType("mark"))T.push({name:k.name,startTime:Math.round(R+k.startTime)});return T}};if(typeof process=="object"){const R=Math.round((require.nodeRequire||require)("perf_hooks").performance.timeOrigin);return K(R)}else return console.trace("perf-util loaded in UNKNOWN environment"),K()}function D(R){return R.MonacoPerformanceMarks||(R.MonacoPerformanceMarks=e()),R.MonacoPerformanceMarks}var L;typeof global=="object"?L=global:typeof self=="object"?L=self:L={},typeof define=="function"?define("vs/base/common/performance",[],function(){return D(L)}):typeof module=="object"&&typeof module.exports=="object"?module.exports=D(L):(console.trace("perf-util defined in UNKNOWN context (neither requirejs or commonjs)"),L.perf=D(L))}(),define(Z[4],te([0,1]),function(K,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.isLittleEndian=e.OS=e.OperatingSystem=e.setImmediate=e.translationsConfigFile=e.locale=e.Language=e.language=e.userAgent=e.platform=e.isIOS=e.isWeb=e.isNative=e.isLinuxSnap=e.isLinux=e.isMacintosh=e.isWindows=e.PlatformToString=e.Platform=e.isElectronSandboxed=e.globals=void 0;const D="en";let L=!1,R=!1,T=!1,k=!1,P=!1,m=!1,b=!1,i,C=D,g,w;e.globals=typeof self=="object"?self:typeof global=="object"?global:{};let u;typeof e.globals.vscode!="undefined"&&typeof e.globals.vscode.process!="undefined"?u=e.globals.vscode.process:typeof process!="undefined"&&(u=process);const S=typeof u?.versions?.electron=="string"&&u.type==="renderer";if(e.isElectronSandboxed=S&&u?.sandboxed,typeof navigator=="object"&&!S)w=navigator.userAgent,L=w.indexOf("Windows")>=0,R=w.indexOf("Macintosh")>=0,b=(w.indexOf("Macintosh")>=0||w.indexOf("iPad")>=0||w.indexOf("iPhone")>=0)&&!!navigator.maxTouchPoints&&navigator.maxTouchPoints>0,T=w.indexOf("Linux")>=0,m=!0,i=navigator.language,C=i;else if(typeof u=="object"){L=u.platform==="win32",R=u.platform==="darwin",T=u.platform==="linux",k=T&&!!u.env.SNAP&&!!u.env.SNAP_REVISION,i=D,C=D;const n=u.env.VSCODE_NLS_CONFIG;if(n)try{const s=JSON.parse(n),c=s.availableLanguages["*"];i=s.locale,C=c||D,g=s._translationsConfigFile}catch(s){}P=!0}else console.error("Unable to resolve platform.");var f;(function(n){n[n.Web=0]="Web",n[n.Mac=1]="Mac",n[n.Linux=2]="Linux",n[n.Windows=3]="Windows"})(f=e.Platform||(e.Platform={}));function I(n){switch(n){case 0:return"Web";case 1:return"Mac";case 2:return"Linux";case 3:return"Windows"}}e.PlatformToString=I;let y=0;R?y=1:L?y=3:T&&(y=2),e.isWindows=L,e.isMacintosh=R,e.isLinux=T,e.isLinuxSnap=k,e.isNative=P,e.isWeb=m,e.isIOS=b,e.platform=y,e.userAgent=w,e.language=C;var E;(function(n){function s(){return e.language}n.value=s;function c(){return e.language.length===2?e.language==="en":e.language.length>=3?e.language[0]==="e"&&e.language[1]==="n"&&e.language[2]==="-":!1}n.isDefaultVariant=c;function l(){return e.language==="en"}n.isDefault=l})(E=e.Language||(e.Language={})),e.locale=i,e.translationsConfigFile=g,e.setImmediate=function(){if(e.globals.setImmediate)return e.globals.setImmediate.bind(e.globals);if(typeof e.globals.postMessage=="function"&&!e.globals.importScripts){let c=[];e.globals.addEventListener("message",h=>{if(h.data&&h.data.vscodeSetImmediateId)for(let d=0,v=c.length;d<v;d++){const A=c[d];if(A.id===h.data.vscodeSetImmediateId){c.splice(d,1),A.callback();return}}});let l=0;return h=>{const d=++l;c.push({id:d,callback:h}),e.globals.postMessage({vscodeSetImmediateId:d},"*")}}if(typeof u?.nextTick=="function")return u.nextTick.bind(u);const s=Promise.resolve();return c=>s.then(c)}();var o;(function(n){n[n.Windows=1]="Windows",n[n.Macintosh=2]="Macintosh",n[n.Linux=3]="Linux"})(o=e.OperatingSystem||(e.OperatingSystem={})),e.OS=R||b?2:L?1:3;let a=!0,t=!1;function r(){if(!t){t=!0;const n=new Uint8Array(2);n[0]=1,n[1]=2,a=new Uint16Array(n.buffer)[0]===(2<<8)+1}return a}e.isLittleEndian=r}),define(Z[31],te([0,1,4]),function(K,e,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.arch=e.nextTick=e.platform=e.env=e.cwd=void 0;let L;if(typeof D.globals.vscode!="undefined"&&typeof D.globals.vscode.process!="undefined"){const R=D.globals.vscode.process;L={get platform(){return R.platform},get arch(){return R.arch},get env(){return R.env},cwd(){return R.cwd()},nextTick(T){return(0,D.setImmediate)(T)}}}else typeof process!="undefined"?L={get platform(){return process.platform},get arch(){return process.arch},get env(){return process.env},cwd(){return process.env.VSCODE_CWD||process.cwd()},nextTick(R){return process.nextTick(R)}}:L={get platform(){return D.isWindows?"win32":D.isMacintosh?"darwin":"linux"},get arch(){},nextTick(R){return(0,D.setImmediate)(R)},get env(){return{}},cwd(){return"/"}};e.cwd=L.cwd,e.env=L.env,e.platform=L.platform,e.nextTick=L.nextTick,e.arch=L.arch}),define(Z[8],te([0,1,31]),function(K,e,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.delimiter=e.sep=e.toNamespacedPath=e.parse=e.format=e.extname=e.basename=e.dirname=e.relative=e.resolve=e.join=e.isAbsolute=e.normalize=e.posix=e.win32=void 0;const L=65,R=97,T=90,k=122,P=46,m=47,b=92,i=58,C=63;class g extends Error{constructor(o,a,t){let r;typeof a=="string"&&a.indexOf("not ")===0?(r="must not be",a=a.replace(/^not /,"")):r="must be";const n=o.indexOf(".")!==-1?"property":"argument";let s=`The "${o}" ${n} ${r} of type ${a}`;s+=`. Received type ${typeof t}`,super(s),this.code="ERR_INVALID_ARG_TYPE"}}function w(E,o){if(typeof E!="string")throw new g(o,"string",E)}function u(E){return E===m||E===b}function S(E){return E===m}function f(E){return E>=L&&E<=T||E>=R&&E<=k}function I(E,o,a,t){let r="",n=0,s=-1,c=0,l=0;for(let h=0;h<=E.length;++h){if(h<E.length)l=E.charCodeAt(h);else{if(t(l))break;l=m}if(t(l)){if(!(s===h-1||c===1))if(c===2){if(r.length<2||n!==2||r.charCodeAt(r.length-1)!==P||r.charCodeAt(r.length-2)!==P){if(r.length>2){const d=r.lastIndexOf(a);d===-1?(r="",n=0):(r=r.slice(0,d),n=r.length-1-r.lastIndexOf(a)),s=h,c=0;continue}else if(r.length!==0){r="",n=0,s=h,c=0;continue}}o&&(r+=r.length>0?`${a}..`:"..",n=2)}else r.length>0?r+=`${a}${E.slice(s+1,h)}`:r=E.slice(s+1,h),n=h-s-1;s=h,c=0}else l===P&&c!==-1?++c:c=-1}return r}function y(E,o){if(o===null||typeof o!="object")throw new g("pathObject","Object",o);const a=o.dir||o.root,t=o.base||`${o.name||""}${o.ext||""}`;return a?a===o.root?`${a}${t}`:`${a}${E}${t}`:t}e.win32={resolve(...E){let o="",a="",t=!1;for(let r=E.length-1;r>=-1;r--){let n;if(r>=0){if(n=E[r],w(n,"path"),n.length===0)continue}else o.length===0?n=D.cwd():(n=D.env[`=${o}`]||D.cwd(),(n===void 0||n.slice(0,2).toLowerCase()!==o.toLowerCase()&&n.charCodeAt(2)===b)&&(n=`${o}\\`));const s=n.length;let c=0,l="",h=!1;const d=n.charCodeAt(0);if(s===1)u(d)&&(c=1,h=!0);else if(u(d))if(h=!0,u(n.charCodeAt(1))){let v=2,A=v;for(;v<s&&!u(n.charCodeAt(v));)v++;if(v<s&&v!==A){const O=n.slice(A,v);for(A=v;v<s&&u(n.charCodeAt(v));)v++;if(v<s&&v!==A){for(A=v;v<s&&!u(n.charCodeAt(v));)v++;(v===s||v!==A)&&(l=`\\\\${O}\\${n.slice(A,v)}`,c=v)}}}else c=1;else f(d)&&n.charCodeAt(1)===i&&(l=n.slice(0,2),c=2,s>2&&u(n.charCodeAt(2))&&(h=!0,c=3));if(l.length>0)if(o.length>0){if(l.toLowerCase()!==o.toLowerCase())continue}else o=l;if(t){if(o.length>0)break}else if(a=`${n.slice(c)}\\${a}`,t=h,h&&o.length>0)break}return a=I(a,!t,"\\",u),t?`${o}\\${a}`:`${o}${a}`||"."},normalize(E){w(E,"path");const o=E.length;if(o===0)return".";let a=0,t,r=!1;const n=E.charCodeAt(0);if(o===1)return S(n)?"\\":E;if(u(n))if(r=!0,u(E.charCodeAt(1))){let c=2,l=c;for(;c<o&&!u(E.charCodeAt(c));)c++;if(c<o&&c!==l){const h=E.slice(l,c);for(l=c;c<o&&u(E.charCodeAt(c));)c++;if(c<o&&c!==l){for(l=c;c<o&&!u(E.charCodeAt(c));)c++;if(c===o)return`\\\\${h}\\${E.slice(l)}\\`;c!==l&&(t=`\\\\${h}\\${E.slice(l,c)}`,a=c)}}}else a=1;else f(n)&&E.charCodeAt(1)===i&&(t=E.slice(0,2),a=2,o>2&&u(E.charCodeAt(2))&&(r=!0,a=3));let s=a<o?I(E.slice(a),!r,"\\",u):"";return s.length===0&&!r&&(s="."),s.length>0&&u(E.charCodeAt(o-1))&&(s+="\\"),t===void 0?r?`\\${s}`:s:r?`${t}\\${s}`:`${t}${s}`},isAbsolute(E){w(E,"path");const o=E.length;if(o===0)return!1;const a=E.charCodeAt(0);return u(a)||o>2&&f(a)&&E.charCodeAt(1)===i&&u(E.charCodeAt(2))},join(...E){if(E.length===0)return".";let o,a;for(let n=0;n<E.length;++n){const s=E[n];w(s,"path"),s.length>0&&(o===void 0?o=a=s:o+=`\\${s}`)}if(o===void 0)return".";let t=!0,r=0;if(typeof a=="string"&&u(a.charCodeAt(0))){++r;const n=a.length;n>1&&u(a.charCodeAt(1))&&(++r,n>2&&(u(a.charCodeAt(2))?++r:t=!1))}if(t){for(;r<o.length&&u(o.charCodeAt(r));)r++;r>=2&&(o=`\\${o.slice(r)}`)}return e.win32.normalize(o)},relative(E,o){if(w(E,"from"),w(o,"to"),E===o)return"";const a=e.win32.resolve(E),t=e.win32.resolve(o);if(a===t||(E=a.toLowerCase(),o=t.toLowerCase(),E===o))return"";let r=0;for(;r<E.length&&E.charCodeAt(r)===b;)r++;let n=E.length;for(;n-1>r&&E.charCodeAt(n-1)===b;)n--;const s=n-r;let c=0;for(;c<o.length&&o.charCodeAt(c)===b;)c++;let l=o.length;for(;l-1>c&&o.charCodeAt(l-1)===b;)l--;const h=l-c,d=s<h?s:h;let v=-1,A=0;for(;A<d;A++){const p=E.charCodeAt(r+A);if(p!==o.charCodeAt(c+A))break;p===b&&(v=A)}if(A!==d){if(v===-1)return t}else{if(h>d){if(o.charCodeAt(c+A)===b)return t.slice(c+A+1);if(A===2)return t.slice(c+A)}s>d&&(E.charCodeAt(r+A)===b?v=A:A===2&&(v=3)),v===-1&&(v=0)}let O="";for(A=r+v+1;A<=n;++A)(A===n||E.charCodeAt(A)===b)&&(O+=O.length===0?"..":"\\..");return c+=v,O.length>0?`${O}${t.slice(c,l)}`:(t.charCodeAt(c)===b&&++c,t.slice(c,l))},toNamespacedPath(E){if(typeof E!="string")return E;if(E.length===0)return"";const o=e.win32.resolve(E);if(o.length<=2)return E;if(o.charCodeAt(0)===b){if(o.charCodeAt(1)===b){const a=o.charCodeAt(2);if(a!==C&&a!==P)return`\\\\?\\UNC\\${o.slice(2)}`}}else if(f(o.charCodeAt(0))&&o.charCodeAt(1)===i&&o.charCodeAt(2)===b)return`\\\\?\\${o}`;return E},dirname(E){w(E,"path");const o=E.length;if(o===0)return".";let a=-1,t=0;const r=E.charCodeAt(0);if(o===1)return u(r)?E:".";if(u(r)){if(a=t=1,u(E.charCodeAt(1))){let c=2,l=c;for(;c<o&&!u(E.charCodeAt(c));)c++;if(c<o&&c!==l){for(l=c;c<o&&u(E.charCodeAt(c));)c++;if(c<o&&c!==l){for(l=c;c<o&&!u(E.charCodeAt(c));)c++;if(c===o)return E;c!==l&&(a=t=c+1)}}}}else f(r)&&E.charCodeAt(1)===i&&(a=o>2&&u(E.charCodeAt(2))?3:2,t=a);let n=-1,s=!0;for(let c=o-1;c>=t;--c)if(u(E.charCodeAt(c))){if(!s){n=c;break}}else s=!1;if(n===-1){if(a===-1)return".";n=a}return E.slice(0,n)},basename(E,o){o!==void 0&&w(o,"ext"),w(E,"path");let a=0,t=-1,r=!0,n;if(E.length>=2&&f(E.charCodeAt(0))&&E.charCodeAt(1)===i&&(a=2),o!==void 0&&o.length>0&&o.length<=E.length){if(o===E)return"";let s=o.length-1,c=-1;for(n=E.length-1;n>=a;--n){const l=E.charCodeAt(n);if(u(l)){if(!r){a=n+1;break}}else c===-1&&(r=!1,c=n+1),s>=0&&(l===o.charCodeAt(s)?--s==-1&&(t=n):(s=-1,t=c))}return a===t?t=c:t===-1&&(t=E.length),E.slice(a,t)}for(n=E.length-1;n>=a;--n)if(u(E.charCodeAt(n))){if(!r){a=n+1;break}}else t===-1&&(r=!1,t=n+1);return t===-1?"":E.slice(a,t)},extname(E){w(E,"path");let o=0,a=-1,t=0,r=-1,n=!0,s=0;E.length>=2&&E.charCodeAt(1)===i&&f(E.charCodeAt(0))&&(o=t=2);for(let c=E.length-1;c>=o;--c){const l=E.charCodeAt(c);if(u(l)){if(!n){t=c+1;break}continue}r===-1&&(n=!1,r=c+1),l===P?a===-1?a=c:s!==1&&(s=1):a!==-1&&(s=-1)}return a===-1||r===-1||s===0||s===1&&a===r-1&&a===t+1?"":E.slice(a,r)},format:y.bind(null,"\\"),parse(E){w(E,"path");const o={root:"",dir:"",base:"",ext:"",name:""};if(E.length===0)return o;const a=E.length;let t=0,r=E.charCodeAt(0);if(a===1)return u(r)?(o.root=o.dir=E,o):(o.base=o.name=E,o);if(u(r)){if(t=1,u(E.charCodeAt(1))){let v=2,A=v;for(;v<a&&!u(E.charCodeAt(v));)v++;if(v<a&&v!==A){for(A=v;v<a&&u(E.charCodeAt(v));)v++;if(v<a&&v!==A){for(A=v;v<a&&!u(E.charCodeAt(v));)v++;v===a?t=v:v!==A&&(t=v+1)}}}}else if(f(r)&&E.charCodeAt(1)===i){if(a<=2)return o.root=o.dir=E,o;if(t=2,u(E.charCodeAt(2))){if(a===3)return o.root=o.dir=E,o;t=3}}t>0&&(o.root=E.slice(0,t));let n=-1,s=t,c=-1,l=!0,h=E.length-1,d=0;for(;h>=t;--h){if(r=E.charCodeAt(h),u(r)){if(!l){s=h+1;break}continue}c===-1&&(l=!1,c=h+1),r===P?n===-1?n=h:d!==1&&(d=1):n!==-1&&(d=-1)}return c!==-1&&(n===-1||d===0||d===1&&n===c-1&&n===s+1?o.base=o.name=E.slice(s,c):(o.name=E.slice(s,n),o.base=E.slice(s,c),o.ext=E.slice(n,c))),s>0&&s!==t?o.dir=E.slice(0,s-1):o.dir=o.root,o},sep:"\\",delimiter:";",win32:null,posix:null},e.posix={resolve(...E){let o="",a=!1;for(let t=E.length-1;t>=-1&&!a;t--){const r=t>=0?E[t]:D.cwd();w(r,"path"),r.length!==0&&(o=`${r}/${o}`,a=r.charCodeAt(0)===m)}return o=I(o,!a,"/",S),a?`/${o}`:o.length>0?o:"."},normalize(E){if(w(E,"path"),E.length===0)return".";const o=E.charCodeAt(0)===m,a=E.charCodeAt(E.length-1)===m;return E=I(E,!o,"/",S),E.length===0?o?"/":a?"./":".":(a&&(E+="/"),o?`/${E}`:E)},isAbsolute(E){return w(E,"path"),E.length>0&&E.charCodeAt(0)===m},join(...E){if(E.length===0)return".";let o;for(let a=0;a<E.length;++a){const t=E[a];w(t,"path"),t.length>0&&(o===void 0?o=t:o+=`/${t}`)}return o===void 0?".":e.posix.normalize(o)},relative(E,o){if(w(E,"from"),w(o,"to"),E===o||(E=e.posix.resolve(E),o=e.posix.resolve(o),E===o))return"";const a=1,t=E.length,r=t-a,n=1,s=o.length-n,c=r<s?r:s;let l=-1,h=0;for(;h<c;h++){const v=E.charCodeAt(a+h);if(v!==o.charCodeAt(n+h))break;v===m&&(l=h)}if(h===c)if(s>c){if(o.charCodeAt(n+h)===m)return o.slice(n+h+1);if(h===0)return o.slice(n+h)}else r>c&&(E.charCodeAt(a+h)===m?l=h:h===0&&(l=0));let d="";for(h=a+l+1;h<=t;++h)(h===t||E.charCodeAt(h)===m)&&(d+=d.length===0?"..":"/..");return`${d}${o.slice(n+l)}`},toNamespacedPath(E){return E},dirname(E){if(w(E,"path"),E.length===0)return".";const o=E.charCodeAt(0)===m;let a=-1,t=!0;for(let r=E.length-1;r>=1;--r)if(E.charCodeAt(r)===m){if(!t){a=r;break}}else t=!1;return a===-1?o?"/":".":o&&a===1?"//":E.slice(0,a)},basename(E,o){o!==void 0&&w(o,"ext"),w(E,"path");let a=0,t=-1,r=!0,n;if(o!==void 0&&o.length>0&&o.length<=E.length){if(o===E)return"";let s=o.length-1,c=-1;for(n=E.length-1;n>=0;--n){const l=E.charCodeAt(n);if(l===m){if(!r){a=n+1;break}}else c===-1&&(r=!1,c=n+1),s>=0&&(l===o.charCodeAt(s)?--s==-1&&(t=n):(s=-1,t=c))}return a===t?t=c:t===-1&&(t=E.length),E.slice(a,t)}for(n=E.length-1;n>=0;--n)if(E.charCodeAt(n)===m){if(!r){a=n+1;break}}else t===-1&&(r=!1,t=n+1);return t===-1?"":E.slice(a,t)},extname(E){w(E,"path");let o=-1,a=0,t=-1,r=!0,n=0;for(let s=E.length-1;s>=0;--s){const c=E.charCodeAt(s);if(c===m){if(!r){a=s+1;break}continue}t===-1&&(r=!1,t=s+1),c===P?o===-1?o=s:n!==1&&(n=1):o!==-1&&(n=-1)}return o===-1||t===-1||n===0||n===1&&o===t-1&&o===a+1?"":E.slice(o,t)},format:y.bind(null,"/"),parse(E){w(E,"path");const o={root:"",dir:"",base:"",ext:"",name:""};if(E.length===0)return o;const a=E.charCodeAt(0)===m;let t;a?(o.root="/",t=1):t=0;let r=-1,n=0,s=-1,c=!0,l=E.length-1,h=0;for(;l>=t;--l){const d=E.charCodeAt(l);if(d===m){if(!c){n=l+1;break}continue}s===-1&&(c=!1,s=l+1),d===P?r===-1?r=l:h!==1&&(h=1):r!==-1&&(h=-1)}if(s!==-1){const d=n===0&&a?1:n;r===-1||h===0||h===1&&r===s-1&&r===n+1?o.base=o.name=E.slice(d,s):(o.name=E.slice(d,r),o.base=E.slice(d,s),o.ext=E.slice(r,s))}return n>0?o.dir=E.slice(0,n-1):a&&(o.dir="/"),o},sep:"/",delimiter:":",win32:null,posix:null},e.posix.win32=e.win32.win32=e.win32,e.posix.posix=e.win32.posix=e.posix,e.normalize=D.platform==="win32"?e.win32.normalize:e.posix.normalize,e.isAbsolute=D.platform==="win32"?e.win32.isAbsolute:e.posix.isAbsolute,e.join=D.platform==="win32"?e.win32.join:e.posix.join,e.resolve=D.platform==="win32"?e.win32.resolve:e.posix.resolve,e.relative=D.platform==="win32"?e.win32.relative:e.posix.relative,e.dirname=D.platform==="win32"?e.win32.dirname:e.posix.dirname,e.basename=D.platform==="win32"?e.win32.basename:e.posix.basename,e.extname=D.platform==="win32"?e.win32.extname:e.posix.extname,e.format=D.platform==="win32"?e.win32.format:e.posix.format,e.parse=D.platform==="win32"?e.win32.parse:e.posix.parse,e.toNamespacedPath=D.platform==="win32"?e.win32.toNamespacedPath:e.posix.toNamespacedPath,e.sep=D.platform==="win32"?e.win32.sep:e.posix.sep,e.delimiter=D.platform==="win32"?e.win32.delimiter:e.posix.delimiter}),function(K,e){if(typeof exports=="object"&&typeof module=="object")module.exports=e();else if(typeof define=="function"&&define.amd)define("vs/base/common/semver/semver",[],e);else{var D=e();for(var L in D)(typeof exports=="object"?exports:K)[L]=D[L]}}(typeof self!="undefined"?self:this,function(){return function(K){var e={};function D(L){if(e[L])return e[L].exports;var R=e[L]={i:L,l:!1,exports:{}};return K[L].call(R.exports,R,R.exports,D),R.l=!0,R.exports}return D.m=K,D.c=e,D.d=function(L,R,T){D.o(L,R)||Object.defineProperty(L,R,{enumerable:!0,get:T})},D.r=function(L){typeof Symbol!="undefined"&&Symbol.toStringTag&&Object.defineProperty(L,Symbol.toStringTag,{value:"Module"}),Object.defineProperty(L,"__esModule",{value:!0})},D.t=function(L,R){if(1&R&&(L=D(L)),8&R||4&R&&typeof L=="object"&&L&&L.__esModule)return L;var T=Object.create(null);if(D.r(T),Object.defineProperty(T,"default",{enumerable:!0,value:L}),2&R&&typeof L!="string")for(var k in L)D.d(T,k,function(P){return L[P]}.bind(null,k));return T},D.n=function(L){var R=L&&L.__esModule?function(){return L.default}:function(){return L};return D.d(R,"a",R),R},D.o=function(L,R){return Object.prototype.hasOwnProperty.call(L,R)},D.p="",D(D.s=0)}([function(K,e,D){(function(L){var R;e=K.exports=ee,R=typeof L=="object"&&L.env&&L.env.NODE_DEBUG&&/\bsemver\b/i.test(L.env.NODE_DEBUG)?function(){var Q=Array.prototype.slice.call(arguments,0);Q.unshift("SEMVER"),console.log.apply(console,Q)}:function(){},e.SEMVER_SPEC_VERSION="2.0.0";var T=256,k=Number.MAX_SAFE_INTEGER||9007199254740991,P=e.re=[],m=e.src=[],b=0,i=b++;m[i]="0|[1-9]\\d*";var C=b++;m[C]="[0-9]+";var g=b++;m[g]="\\d*[a-zA-Z-][a-zA-Z0-9-]*";var w=b++;m[w]="("+m[i]+")\\.("+m[i]+")\\.("+m[i]+")";var u=b++;m[u]="("+m[C]+")\\.("+m[C]+")\\.("+m[C]+")";var S=b++;m[S]="(?:"+m[i]+"|"+m[g]+")";var f=b++;m[f]="(?:"+m[C]+"|"+m[g]+")";var I=b++;m[I]="(?:-("+m[S]+"(?:\\."+m[S]+")*))";var y=b++;m[y]="(?:-?("+m[f]+"(?:\\."+m[f]+")*))";var E=b++;m[E]="[0-9A-Za-z-]+";var o=b++;m[o]="(?:\\+("+m[E]+"(?:\\."+m[E]+")*))";var a=b++,t="v?"+m[w]+m[I]+"?"+m[o]+"?";m[a]="^"+t+"$";var r="[v=\\s]*"+m[u]+m[y]+"?"+m[o]+"?",n=b++;m[n]="^"+r+"$";var s=b++;m[s]="((?:<|>)?=?)";var c=b++;m[c]=m[C]+"|x|X|\\*";var l=b++;m[l]=m[i]+"|x|X|\\*";var h=b++;m[h]="[v=\\s]*("+m[l]+")(?:\\.("+m[l]+")(?:\\.("+m[l]+")(?:"+m[I]+")?"+m[o]+"?)?)?";var d=b++;m[d]="[v=\\s]*("+m[c]+")(?:\\.("+m[c]+")(?:\\.("+m[c]+")(?:"+m[y]+")?"+m[o]+"?)?)?";var v=b++;m[v]="^"+m[s]+"\\s*"+m[h]+"$";var A=b++;m[A]="^"+m[s]+"\\s*"+m[d]+"$";var O=b++;m[O]="(?:^|[^\\d])(\\d{1,16})(?:\\.(\\d{1,16}))?(?:\\.(\\d{1,16}))?(?:$|[^\\d])";var p=b++;m[p]="(?:~>?)";var U=b++;m[U]="(\\s*)"+m[p]+"\\s+",P[U]=new RegExp(m[U],"g");var F=b++;m[F]="^"+m[p]+m[h]+"$";var z=b++;m[z]="^"+m[p]+m[d]+"$";var H=b++;m[H]="(?:\\^)";var M=b++;m[M]="(\\s*)"+m[H]+"\\s+",P[M]=new RegExp(m[M],"g");var j=b++;m[j]="^"+m[H]+m[h]+"$";var q=b++;m[q]="^"+m[H]+m[d]+"$";var x=b++;m[x]="^"+m[s]+"\\s*("+r+")$|^$";var $=b++;m[$]="^"+m[s]+"\\s*("+t+")$|^$";var N=b++;m[N]="(\\s*)"+m[s]+"\\s*("+r+"|"+m[h]+")",P[N]=new RegExp(m[N],"g");var W=b++;m[W]="^\\s*("+m[h]+")\\s+-\\s+("+m[h]+")\\s*$";var _=b++;m[_]="^\\s*("+m[d]+")\\s+-\\s+("+m[d]+")\\s*$";var Y=b++;m[Y]="(<|>)?=?\\s*\\*";for(var G=0;G<35;G++)R(G,m[G]),P[G]||(P[G]=new RegExp(m[G]));function ne(Q,ae){if(Q instanceof ee)return Q;if(typeof Q!="string"||Q.length>T||!(ae?P[n]:P[a]).test(Q))return null;try{return new ee(Q,ae)}catch(oe){return null}}function ee(Q,ae){if(Q instanceof ee){if(Q.loose===ae)return Q;Q=Q.version}else if(typeof Q!="string")throw new TypeError("Invalid Version: "+Q);if(Q.length>T)throw new TypeError("version is longer than "+T+" characters");if(!(this instanceof ee))return new ee(Q,ae);R("SemVer",Q,ae),this.loose=ae;var oe=Q.trim().match(ae?P[n]:P[a]);if(!oe)throw new TypeError("Invalid Version: "+Q);if(this.raw=Q,this.major=+oe[1],this.minor=+oe[2],this.patch=+oe[3],this.major>k||this.major<0)throw new TypeError("Invalid major version");if(this.minor>k||this.minor<0)throw new TypeError("Invalid minor version");if(this.patch>k||this.patch<0)throw new TypeError("Invalid patch version");oe[4]?this.prerelease=oe[4].split(".").map(function(pe){if(/^[0-9]+$/.test(pe)){var Se=+pe;if(Se>=0&&Se<k)return Se}return pe}):this.prerelease=[],this.build=oe[5]?oe[5].split("."):[],this.format()}e.parse=ne,e.valid=function(Q,ae){var oe=ne(Q,ae);return oe?oe.version:null},e.clean=function(Q,ae){var oe=ne(Q.trim().replace(/^[=v]+/,""),ae);return oe?oe.version:null},e.SemVer=ee,ee.prototype.format=function(){return this.version=this.major+"."+this.minor+"."+this.patch,this.prerelease.length&&(this.version+="-"+this.prerelease.join(".")),this.version},ee.prototype.toString=function(){return this.version},ee.prototype.compare=function(Q){return R("SemVer.compare",this.version,this.loose,Q),Q instanceof ee||(Q=new ee(Q,this.loose)),this.compareMain(Q)||this.comparePre(Q)},ee.prototype.compareMain=function(Q){return Q instanceof ee||(Q=new ee(Q,this.loose)),B(this.major,Q.major)||B(this.minor,Q.minor)||B(this.patch,Q.patch)},ee.prototype.comparePre=function(Q){if(Q instanceof ee||(Q=new ee(Q,this.loose)),this.prerelease.length&&!Q.prerelease.length)return-1;if(!this.prerelease.length&&Q.prerelease.length)return 1;if(!this.prerelease.length&&!Q.prerelease.length)return 0;var ae=0;do{var oe=this.prerelease[ae],pe=Q.prerelease[ae];if(R("prerelease compare",ae,oe,pe),oe===void 0&&pe===void 0)return 0;if(pe===void 0)return 1;if(oe===void 0)return-1;if(oe!==pe)return B(oe,pe)}while(++ae)},ee.prototype.inc=function(Q,ae){switch(Q){case"premajor":this.prerelease.length=0,this.patch=0,this.minor=0,this.major++,this.inc("pre",ae);break;case"preminor":this.prerelease.length=0,this.patch=0,this.minor++,this.inc("pre",ae);break;case"prepatch":this.prerelease.length=0,this.inc("patch",ae),this.inc("pre",ae);break;case"prerelease":this.prerelease.length===0&&this.inc("patch",ae),this.inc("pre",ae);break;case"major":this.minor===0&&this.patch===0&&this.prerelease.length!==0||this.major++,this.minor=0,this.patch=0,this.prerelease=[];break;case"minor":this.patch===0&&this.prerelease.length!==0||this.minor++,this.patch=0,this.prerelease=[];break;case"patch":this.prerelease.length===0&&this.patch++,this.prerelease=[];break;case"pre":if(this.prerelease.length===0)this.prerelease=[0];else{for(var oe=this.prerelease.length;--oe>=0;)typeof this.prerelease[oe]=="number"&&(this.prerelease[oe]++,oe=-2);oe===-1&&this.prerelease.push(0)}ae&&(this.prerelease[0]===ae?isNaN(this.prerelease[1])&&(this.prerelease=[ae,0]):this.prerelease=[ae,0]);break;default:throw new Error("invalid increment argument: "+Q)}return this.format(),this.raw=this.version,this},e.inc=function(Q,ae,oe,pe){typeof oe=="string"&&(pe=oe,oe=void 0);try{return new ee(Q,oe).inc(ae,pe).version}catch(Se){return null}},e.diff=function(Q,ae){if(ue(Q,ae))return null;var oe=ne(Q),pe=ne(ae);if(oe.prerelease.length||pe.prerelease.length){for(var Se in oe)if((Se==="major"||Se==="minor"||Se==="patch")&&oe[Se]!==pe[Se])return"pre"+Se;return"prerelease"}for(var Se in oe)if((Se==="major"||Se==="minor"||Se==="patch")&&oe[Se]!==pe[Se])return Se},e.compareIdentifiers=B;var X=/^[0-9]+$/;function B(Q,ae){var oe=X.test(Q),pe=X.test(ae);return oe&&pe&&(Q=+Q,ae=+ae),oe&&!pe?-1:pe&&!oe?1:Q<ae?-1:Q>ae?1:0}function re(Q,ae,oe){return new ee(Q,oe).compare(new ee(ae,oe))}function ie(Q,ae,oe){return re(Q,ae,oe)>0}function ce(Q,ae,oe){return re(Q,ae,oe)<0}function ue(Q,ae,oe){return re(Q,ae,oe)===0}function ge(Q,ae,oe){return re(Q,ae,oe)!==0}function de(Q,ae,oe){return re(Q,ae,oe)>=0}function Ie(Q,ae,oe){return re(Q,ae,oe)<=0}function Pe(Q,ae,oe,pe){var Se;switch(ae){case"===":typeof Q=="object"&&(Q=Q.version),typeof oe=="object"&&(oe=oe.version),Se=Q===oe;break;case"!==":typeof Q=="object"&&(Q=Q.version),typeof oe=="object"&&(oe=oe.version),Se=Q!==oe;break;case"":case"=":case"==":Se=ue(Q,oe,pe);break;case"!=":Se=ge(Q,oe,pe);break;case">":Se=ie(Q,oe,pe);break;case">=":Se=de(Q,oe,pe);break;case"<":Se=ce(Q,oe,pe);break;case"<=":Se=Ie(Q,oe,pe);break;default:throw new TypeError("Invalid operator: "+ae)}return Se}function Ee(Q,ae){if(Q instanceof Ee){if(Q.loose===ae)return Q;Q=Q.value}if(!(this instanceof Ee))return new Ee(Q,ae);R("comparator",Q,ae),this.loose=ae,this.parse(Q),this.semver===Oe?this.value="":this.value=this.operator+this.semver.version,R("comp",this)}e.rcompareIdentifiers=function(Q,ae){return B(ae,Q)},e.major=function(Q,ae){return new ee(Q,ae).major},e.minor=function(Q,ae){return new ee(Q,ae).minor},e.patch=function(Q,ae){return new ee(Q,ae).patch},e.compare=re,e.compareLoose=function(Q,ae){return re(Q,ae,!0)},e.rcompare=function(Q,ae,oe){return re(ae,Q,oe)},e.sort=function(Q,ae){return Q.sort(function(oe,pe){return e.compare(oe,pe,ae)})},e.rsort=function(Q,ae){return Q.sort(function(oe,pe){return e.rcompare(oe,pe,ae)})},e.gt=ie,e.lt=ce,e.eq=ue,e.neq=ge,e.gte=de,e.lte=Ie,e.cmp=Pe,e.Comparator=Ee;var Oe={};function Re(Q,ae){if(Q instanceof Re)return Q.loose===ae?Q:new Re(Q.raw,ae);if(Q instanceof Ee)return new Re(Q.value,ae);if(!(this instanceof Re))return new Re(Q,ae);if(this.loose=ae,this.raw=Q,this.set=Q.split(/\s*\|\|\s*/).map(function(oe){return this.parseRange(oe.trim())},this).filter(function(oe){return oe.length}),!this.set.length)throw new TypeError("Invalid SemVer Range: "+Q);this.format()}function Te(Q){return!Q||Q.toLowerCase()==="x"||Q==="*"}function Ne(Q,ae,oe,pe,Se,Fe,Le,Me,Ae,V,se,le,he){return((ae=Te(oe)?"":Te(pe)?">="+oe+".0.0":Te(Se)?">="+oe+"."+pe+".0":">="+ae)+" "+(Me=Te(Ae)?"":Te(V)?"<"+(+Ae+1)+".0.0":Te(se)?"<"+Ae+"."+(+V+1)+".0":le?"<="+Ae+"."+V+"."+se+"-"+le:"<="+Me)).trim()}function _e(Q,ae){for(var oe=0;oe<Q.length;oe++)if(!Q[oe].test(ae))return!1;if(ae.prerelease.length){for(oe=0;oe<Q.length;oe++)if(R(Q[oe].semver),Q[oe].semver!==Oe&&Q[oe].semver.prerelease.length>0){var pe=Q[oe].semver;if(pe.major===ae.major&&pe.minor===ae.minor&&pe.patch===ae.patch)return!0}return!1}return!0}function ze(Q,ae,oe){try{ae=new Re(ae,oe)}catch(pe){return!1}return ae.test(Q)}function $e(Q,ae,oe,pe){var Se,Fe,Le,Me,Ae;switch(Q=new ee(Q,pe),ae=new Re(ae,pe),oe){case">":Se=ie,Fe=Ie,Le=ce,Me=">",Ae=">=";break;case"<":Se=ce,Fe=de,Le=ie,Me="<",Ae="<=";break;default:throw new TypeError('Must provide a hilo val of "<" or ">"')}if(ze(Q,ae,pe))return!1;for(var V=0;V<ae.set.length;++V){var se=ae.set[V],le=null,he=null;if(se.forEach(function(me){me.semver===Oe&&(me=new Ee(">=0.0.0")),le=le||me,he=he||me,Se(me.semver,le.semver,pe)?le=me:Le(me.semver,he.semver,pe)&&(he=me)}),le.operator===Me||le.operator===Ae||(!he.operator||he.operator===Me)&&Fe(Q,he.semver)||he.operator===Ae&&Le(Q,he.semver))return!1}return!0}Ee.prototype.parse=function(Q){var ae=this.loose?P[x]:P[$],oe=Q.match(ae);if(!oe)throw new TypeError("Invalid comparator: "+Q);this.operator=oe[1],this.operator==="="&&(this.operator=""),oe[2]?this.semver=new ee(oe[2],this.loose):this.semver=Oe},Ee.prototype.toString=function(){return this.value},Ee.prototype.test=function(Q){return R("Comparator.test",Q,this.loose),this.semver===Oe||(typeof Q=="string"&&(Q=new ee(Q,this.loose)),Pe(Q,this.operator,this.semver,this.loose))},Ee.prototype.intersects=function(Q,ae){if(!(Q instanceof Ee))throw new TypeError("a Comparator is required");var oe;if(this.operator==="")return oe=new Re(Q.value,ae),ze(this.value,oe,ae);if(Q.operator==="")return oe=new Re(this.value,ae),ze(Q.semver,oe,ae);var pe=!(this.operator!==">="&&this.operator!==">"||Q.operator!==">="&&Q.operator!==">"),Se=!(this.operator!=="<="&&this.operator!=="<"||Q.operator!=="<="&&Q.operator!=="<"),Fe=this.semver.version===Q.semver.version,Le=!(this.operator!==">="&&this.operator!=="<="||Q.operator!==">="&&Q.operator!=="<="),Me=Pe(this.semver,"<",Q.semver,ae)&&(this.operator===">="||this.operator===">")&&(Q.operator==="<="||Q.operator==="<"),Ae=Pe(this.semver,">",Q.semver,ae)&&(this.operator==="<="||this.operator==="<")&&(Q.operator===">="||Q.operator===">");return pe||Se||Fe&&Le||Me||Ae},e.Range=Re,Re.prototype.format=function(){return this.range=this.set.map(function(Q){return Q.join(" ").trim()}).join("||").trim(),this.range},Re.prototype.toString=function(){return this.range},Re.prototype.parseRange=function(Q){var ae=this.loose;Q=Q.trim(),R("range",Q,ae);var oe=ae?P[_]:P[W];Q=Q.replace(oe,Ne),R("hyphen replace",Q),Q=Q.replace(P[N],"$1$2$3"),R("comparator trim",Q,P[N]),Q=(Q=(Q=Q.replace(P[U],"$1~")).replace(P[M],"$1^")).split(/\s+/).join(" ");var pe=ae?P[x]:P[$],Se=Q.split(" ").map(function(Fe){return function(Le,Me){return R("comp",Le),Le=function(Ae,V){return Ae.trim().split(/\s+/).map(function(se){return function(le,he){R("caret",le,he);var me=he?P[q]:P[j];return le.replace(me,function(be,ve,we,Ce,De){var ke;return R("caret",le,be,ve,we,Ce,De),Te(ve)?ke="":Te(we)?ke=">="+ve+".0.0 <"+(+ve+1)+".0.0":Te(Ce)?ke=ve==="0"?">="+ve+"."+we+".0 <"+ve+"."+(+we+1)+".0":">="+ve+"."+we+".0 <"+(+ve+1)+".0.0":De?(R("replaceCaret pr",De),De.charAt(0)!=="-"&&(De="-"+De),ke=ve==="0"?we==="0"?">="+ve+"."+we+"."+Ce+De+" <"+ve+"."+we+"."+(+Ce+1):">="+ve+"."+we+"."+Ce+De+" <"+ve+"."+(+we+1)+".0":">="+ve+"."+we+"."+Ce+De+" <"+(+ve+1)+".0.0"):(R("no pr"),ke=ve==="0"?we==="0"?">="+ve+"."+we+"."+Ce+" <"+ve+"."+we+"."+(+Ce+1):">="+ve+"."+we+"."+Ce+" <"+ve+"."+(+we+1)+".0":">="+ve+"."+we+"."+Ce+" <"+(+ve+1)+".0.0"),R("caret return",ke),ke})}(se,V)}).join(" ")}(Le,Me),R("caret",Le),Le=function(Ae,V){return Ae.trim().split(/\s+/).map(function(se){return function(le,he){var me=he?P[z]:P[F];return le.replace(me,function(be,ve,we,Ce,De){var ke;return R("tilde",le,be,ve,we,Ce,De),Te(ve)?ke="":Te(we)?ke=">="+ve+".0.0 <"+(+ve+1)+".0.0":Te(Ce)?ke=">="+ve+"."+we+".0 <"+ve+"."+(+we+1)+".0":De?(R("replaceTilde pr",De),De.charAt(0)!=="-"&&(De="-"+De),ke=">="+ve+"."+we+"."+Ce+De+" <"+ve+"."+(+we+1)+".0"):ke=">="+ve+"."+we+"."+Ce+" <"+ve+"."+(+we+1)+".0",R("tilde return",ke),ke})}(se,V)}).join(" ")}(Le,Me),R("tildes",Le),Le=function(Ae,V){return R("replaceXRanges",Ae,V),Ae.split(/\s+/).map(function(se){return function(le,he){le=le.trim();var me=he?P[A]:P[v];return le.replace(me,function(be,ve,we,Ce,De,ke){R("xRange",le,be,ve,we,Ce,De,ke);var Xe=Te(we),ye=Xe||Te(Ce),Ue=ye||Te(De);return ve==="="&&Ue&&(ve=""),Xe?be=ve===">"||ve==="<"?"<0.0.0":"*":ve&&Ue?(ye&&(Ce=0),Ue&&(De=0),ve===">"?(ve=">=",ye?(we=+we+1,Ce=0,De=0):Ue&&(Ce=+Ce+1,De=0)):ve==="<="&&(ve="<",ye?we=+we+1:Ce=+Ce+1),be=ve+we+"."+Ce+"."+De):ye?be=">="+we+".0.0 <"+(+we+1)+".0.0":Ue&&(be=">="+we+"."+Ce+".0 <"+we+"."+(+Ce+1)+".0"),R("xRange return",be),be})}(se,V)}).join(" ")}(Le,Me),R("xrange",Le),Le=function(Ae,V){return R("replaceStars",Ae,V),Ae.trim().replace(P[Y],"")}(Le,Me),R("stars",Le),Le}(Fe,ae)}).join(" ").split(/\s+/);return this.loose&&(Se=Se.filter(function(Fe){return!!Fe.match(pe)})),Se=Se.map(function(Fe){return new Ee(Fe,ae)})},Re.prototype.intersects=function(Q,ae){if(!(Q instanceof Re))throw new TypeError("a Range is required");return this.set.some(function(oe){return oe.every(function(pe){return Q.set.some(function(Se){return Se.every(function(Fe){return pe.intersects(Fe,ae)})})})})},e.toComparators=function(Q,ae){return new Re(Q,ae).set.map(function(oe){return oe.map(function(pe){return pe.value}).join(" ").trim().split(" ")})},Re.prototype.test=function(Q){if(!Q)return!1;typeof Q=="string"&&(Q=new ee(Q,this.loose));for(var ae=0;ae<this.set.length;ae++)if(_e(this.set[ae],Q))return!0;return!1},e.satisfies=ze,e.maxSatisfying=function(Q,ae,oe){var pe=null,Se=null;try{var Fe=new Re(ae,oe)}catch(Le){return null}return Q.forEach(function(Le){Fe.test(Le)&&(pe&&Se.compare(Le)!==-1||(Se=new ee(pe=Le,oe)))}),pe},e.minSatisfying=function(Q,ae,oe){var pe=null,Se=null;try{var Fe=new Re(ae,oe)}catch(Le){return null}return Q.forEach(function(Le){Fe.test(Le)&&(pe&&Se.compare(Le)!==1||(Se=new ee(pe=Le,oe)))}),pe},e.validRange=function(Q,ae){try{return new Re(Q,ae).range||"*"}catch(oe){return null}},e.ltr=function(Q,ae,oe){return $e(Q,ae,"<",oe)},e.gtr=function(Q,ae,oe){return $e(Q,ae,">",oe)},e.outside=$e,e.prerelease=function(Q,ae){var oe=ne(Q,ae);return oe&&oe.prerelease.length?oe.prerelease:null},e.intersects=function(Q,ae,oe){return Q=new Re(Q,oe),ae=new Re(ae,oe),Q.intersects(ae)},e.coerce=function(Q){if(Q instanceof ee)return Q;if(typeof Q!="string")return null;var ae=Q.match(P[O]);return ae==null?null:ne((ae[1]||"0")+"."+(ae[2]||"0")+"."+(ae[3]||"0"))}}).call(this,D(1))},function(K,e){var D,L,R=K.exports={};function T(){throw new Error("setTimeout has not been defined")}function k(){throw new Error("clearTimeout has not been defined")}function P(f){if(D===setTimeout)return setTimeout(f,0);if((D===T||!D)&&setTimeout)return D=setTimeout,setTimeout(f,0);try{return D(f,0)}catch(I){try{return D.call(null,f,0)}catch(y){return D.call(this,f,0)}}}(function(){try{D=typeof setTimeout=="function"?setTimeout:T}catch(f){D=T}try{L=typeof clearTimeout=="function"?clearTimeout:k}catch(f){L=k}})();var m,b=[],i=!1,C=-1;function g(){i&&m&&(i=!1,m.length?b=m.concat(b):C=-1,b.length&&w())}function w(){if(!i){var f=P(g);i=!0;for(var I=b.length;I;){for(m=b,b=[];++C<I;)m&&m[C].run();C=-1,I=b.length}m=null,i=!1,function(y){if(L===clearTimeout)return clearTimeout(y);if((L===k||!L)&&clearTimeout)return L=clearTimeout,clearTimeout(y);try{L(y)}catch(E){try{return L.call(null,y)}catch(o){return L.call(this,y)}}}(f)}}function u(f,I){this.fun=f,this.array=I}function S(){}R.nextTick=function(f){var I=new Array(arguments.length-1);if(arguments.length>1)for(var y=1;y<arguments.length;y++)I[y-1]=arguments[y];b.push(new u(f,I)),b.length!==1||i||P(w)},u.prototype.run=function(){this.fun.apply(null,this.array)},R.title="browser",R.browser=!0,R.env={},R.argv=[],R.version="",R.versions={},R.on=S,R.addListener=S,R.once=S,R.off=S,R.removeListener=S,R.removeAllListeners=S,R.emit=S,R.prependListener=S,R.prependOnceListener=S,R.listeners=function(f){return[]},R.binding=function(f){throw new Error("process.binding is not supported")},R.cwd=function(){return"/"},R.chdir=function(f){throw new Error("process.chdir is not supported")},R.umask=function(){return 0}}])}),define(Z[93],te([0,1,4]),function(K,e,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.StopWatch=void 0;const L=D.globals.performance&&typeof D.globals.performance.now=="function";class R{constructor(k){this._highResolution=L&&k,this._startTime=this._now(),this._stopTime=-1}static create(k=!0){return new R(k)}stop(){this._stopTime=this._now()}elapsed(){return this._stopTime!==-1?this._stopTime-this._startTime:this._now()-this._startTime}_now(){return this._highResolution?D.globals.performance.now():Date.now()}}e.StopWatch=R}),define(Z[3],te([0,1,9,65,2,92,93]),function(K,e,D,L,R,T,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Relay=e.EventBufferer=e.EventMultiplexer=e.MicrotaskEmitter=e.DebounceEmitter=e.PauseableEmitter=e.AsyncEmitter=e.Emitter=e.setGlobalLeakWarningThreshold=e.Event=void 0;var P;(function(o){o.None=()=>R.Disposable.None;function a(M){return(j,q=null,x)=>{let $=!1,N;return N=M(W=>{if(!$)return N?N.dispose():$=!0,j.call(q,W)},null,x),$&&N.dispose(),N}}o.once=a;function t(M,j){return h((q,x=null,$)=>M(N=>q.call(x,j(N)),null,$))}o.map=t;function r(M,j){return h((q,x=null,$)=>M(N=>{j(N),q.call(x,N)},null,$))}o.forEach=r;function n(M,j){return h((q,x=null,$)=>M(N=>j(N)&&q.call(x,N),null,$))}o.filter=n;function s(M){return M}o.signal=s;function c(...M){return(j,q=null,x)=>(0,R.combinedDisposable)(...M.map($=>$(N=>j.call(q,N),null,x)))}o.any=c;function l(M,j,q){let x=q;return t(M,$=>(x=j(x,$),x))}o.reduce=l;function h(M){let j;const q=new g({onFirstListenerAdd(){j=M(q.fire,q)},onLastListenerRemove(){j.dispose()}});return q.event}function d(M,j,q=100,x=!1,$){let N,W,_,Y=0;const G=new g({leakWarningThreshold:$,onFirstListenerAdd(){N=M(ne=>{Y++,W=j(W,ne),x&&!_&&(G.fire(W),W=void 0),clearTimeout(_),_=setTimeout(()=>{const ee=W;W=void 0,_=void 0,(!x||Y>1)&&G.fire(ee),Y=0},q)})},onLastListenerRemove(){N.dispose()}});return G.event}o.debounce=d;function v(M,j=(q,x)=>q===x){let q=!0,x;return n(M,$=>{const N=q||!j($,x);return q=!1,x=$,N})}o.latch=v;function A(M,j){return[o.filter(M,j),o.filter(M,q=>!j(q))]}o.split=A;function O(M,j=!1,q=[]){let x=q.slice(),$=M(_=>{x?x.push(_):W.fire(_)});const N=()=>{x&&x.forEach(_=>W.fire(_)),x=null},W=new g({onFirstListenerAdd(){$||($=M(_=>W.fire(_)))},onFirstListenerDidAdd(){x&&(j?setTimeout(N):N())},onLastListenerRemove(){$&&$.dispose(),$=null}});return W.event}o.buffer=O;class p{constructor(j){this.event=j}map(j){return new p(t(this.event,j))}forEach(j){return new p(r(this.event,j))}filter(j){return new p(n(this.event,j))}reduce(j,q){return new p(l(this.event,j,q))}latch(){return new p(v(this.event))}debounce(j,q=100,x=!1,$){return new p(d(this.event,j,q,x,$))}on(j,q,x){return this.event(j,q,x)}once(j,q,x){return a(this.event)(j,q,x)}}function U(M){return new p(M)}o.chain=U;function F(M,j,q=x=>x){const x=(..._)=>W.fire(q(..._)),$=()=>M.on(j,x),N=()=>M.removeListener(j,x),W=new g({onFirstListenerAdd:$,onLastListenerRemove:N});return W.event}o.fromNodeEventEmitter=F;function z(M,j,q=x=>x){const x=(..._)=>W.fire(q(..._)),$=()=>M.addEventListener(j,x),N=()=>M.removeEventListener(j,x),W=new g({onFirstListenerAdd:$,onLastListenerRemove:N});return W.event}o.fromDOMEventEmitter=z;function H(M){return new Promise(j=>a(M)(j))}o.toPromise=H})(P=e.Event||(e.Event={}));class m{constructor(a){this._listenerCount=0,this._invocationCount=0,this._elapsedOverall=0,this._name=`${a}_${m._idPool++}`}start(a){this._stopWatch=new k.StopWatch(!0),this._listenerCount=a}stop(){if(this._stopWatch){const a=this._stopWatch.elapsed();this._elapsedOverall+=a,this._invocationCount+=1,console.info(`did FIRE ${this._name}: elapsed_ms: ${a.toFixed(5)}, listener: ${this._listenerCount} (elapsed_overall: ${this._elapsedOverall.toFixed(2)}, invocations: ${this._invocationCount})`),this._stopWatch=void 0}}}m._idPool=0;let b=-1;function i(o){const a=b;return b=o,{dispose(){b=a}}}e.setGlobalLeakWarningThreshold=i;class C{constructor(a,t=Math.random().toString(18).slice(2,5)){this.customThreshold=a,this.name=t,this._warnCountdown=0}dispose(){this._stacks&&this._stacks.clear()}check(a){let t=b;if(typeof this.customThreshold=="number"&&(t=this.customThreshold),t<=0||a<t)return;this._stacks||(this._stacks=new Map);const r=new Error().stack.split(`
`).slice(3).join(`
`),n=this._stacks.get(r)||0;if(this._stacks.set(r,n+1),this._warnCountdown-=1,this._warnCountdown<=0){this._warnCountdown=t*.5;let s,c=0;for(const[l,h]of this._stacks)(!s||c<h)&&(s=l,c=h);console.warn(`[${this.name}] potential listener LEAK detected, having ${a} listeners already. MOST frequent listener (${c}):`),console.warn(s)}return()=>{const s=this._stacks.get(r)||0;this._stacks.set(r,s-1)}}}class g{constructor(a){this._disposed=!1,this._options=a,this._leakageMon=b>0?new C(this._options&&this._options.leakWarningThreshold):void 0,this._perfMon=this._options?._profName?new m(this._options._profName):void 0}get event(){return this._event||(this._event=(a,t,r)=>{this._listeners||(this._listeners=new T.LinkedList);const n=this._listeners.isEmpty();n&&this._options&&this._options.onFirstListenerAdd&&this._options.onFirstListenerAdd(this);const s=this._listeners.push(t?[a,t]:a);n&&this._options&&this._options.onFirstListenerDidAdd&&this._options.onFirstListenerDidAdd(this),this._options&&this._options.onListenerDidAdd&&this._options.onListenerDidAdd(this,a,t);const c=this._leakageMon?.check(this._listeners.size),l=(0,R.toDisposable)(()=>{c&&c(),this._disposed||(s(),this._options&&this._options.onLastListenerRemove&&(this._listeners&&!this._listeners.isEmpty()||this._options.onLastListenerRemove(this)))});return r instanceof R.DisposableStore?r.add(l):Array.isArray(r)&&r.push(l),l}),this._event}fire(a){if(this._listeners){this._deliveryQueue||(this._deliveryQueue=new T.LinkedList);for(let t of this._listeners)this._deliveryQueue.push([t,a]);for(this._perfMon?.start(this._deliveryQueue.size);this._deliveryQueue.size>0;){const[t,r]=this._deliveryQueue.shift();try{typeof t=="function"?t.call(void 0,r):t[0].call(t[1],r)}catch(n){(0,D.onUnexpectedError)(n)}}this._perfMon?.stop()}}dispose(){this._disposed||(this._disposed=!0,this._listeners?.clear(),this._deliveryQueue?.clear(),this._options?.onLastListenerRemove?.(),this._leakageMon?.dispose())}}e.Emitter=g;class w extends g{async fireAsync(a,t,r){if(!!this._listeners){this._asyncDeliveryQueue||(this._asyncDeliveryQueue=new T.LinkedList);for(const n of this._listeners)this._asyncDeliveryQueue.push([n,a]);for(;this._asyncDeliveryQueue.size>0&&!t.isCancellationRequested;){const[n,s]=this._asyncDeliveryQueue.shift(),c=[],l={...s,waitUntil:h=>{if(Object.isFrozen(c))throw new Error("waitUntil can NOT be called asynchronous");r&&(h=r(h,typeof n=="function"?n:n[0])),c.push(h)}};try{typeof n=="function"?n.call(void 0,l):n[0].call(n[1],l)}catch(h){(0,D.onUnexpectedError)(h);continue}Object.freeze(c),await Promise.allSettled(c).then(h=>{for(const d of h)d.status==="rejected"&&(0,D.onUnexpectedError)(d.reason)})}}}}e.AsyncEmitter=w;class u extends g{constructor(a){super(a);this._isPaused=0,this._eventQueue=new T.LinkedList,this._mergeFn=a?.merge}pause(){this._isPaused++}resume(){if(this._isPaused!==0&&--this._isPaused==0)if(this._mergeFn){const a=Array.from(this._eventQueue);this._eventQueue.clear(),super.fire(this._mergeFn(a))}else for(;!this._isPaused&&this._eventQueue.size!==0;)super.fire(this._eventQueue.shift())}fire(a){this._listeners&&(this._isPaused!==0?this._eventQueue.push(a):super.fire(a))}}e.PauseableEmitter=u;class S extends u{constructor(a){super(a);this._delay=a.delay??100}fire(a){this._handle||(this.pause(),this._handle=setTimeout(()=>{this._handle=void 0,this.resume()},this._delay)),super.fire(a)}}e.DebounceEmitter=S;class f extends g{constructor(a){super(a);this._queuedEvents=[],this._mergeFn=a?.merge}fire(a){this._queuedEvents.push(a),this._queuedEvents.length===1&&queueMicrotask(()=>{this._mergeFn?super.fire(this._mergeFn(this._queuedEvents)):this._queuedEvents.forEach(t=>super.fire(t)),this._queuedEvents=[]})}}e.MicrotaskEmitter=f;class I{constructor(){this.hasListeners=!1,this.events=[],this.emitter=new g({onFirstListenerAdd:()=>this.onFirstListenerAdd(),onLastListenerRemove:()=>this.onLastListenerRemove()})}get event(){return this.emitter.event}add(a){const t={event:a,listener:null};this.events.push(t),this.hasListeners&&this.hook(t);const r=()=>{this.hasListeners&&this.unhook(t);const n=this.events.indexOf(t);this.events.splice(n,1)};return(0,R.toDisposable)((0,L.once)(r))}onFirstListenerAdd(){this.hasListeners=!0,this.events.forEach(a=>this.hook(a))}onLastListenerRemove(){this.hasListeners=!1,this.events.forEach(a=>this.unhook(a))}hook(a){a.listener=a.event(t=>this.emitter.fire(t))}unhook(a){a.listener&&a.listener.dispose(),a.listener=null}dispose(){this.emitter.dispose()}}e.EventMultiplexer=I;class y{constructor(){this.buffers=[]}wrapEvent(a){return(t,r,n)=>a(s=>{const c=this.buffers[this.buffers.length-1];c?c.push(()=>t.call(r,s)):t.call(r,s)},void 0,n)}bufferEvents(a){const t=[];this.buffers.push(t);const r=a();return this.buffers.pop(),t.forEach(n=>n()),r}}e.EventBufferer=y;class E{constructor(){this.listening=!1,this.inputEvent=P.None,this.inputEventListener=R.Disposable.None,this.emitter=new g({onFirstListenerDidAdd:()=>{this.listening=!0,this.inputEventListener=this.inputEvent(this.emitter.fire,this.emitter)},onLastListenerRemove:()=>{this.listening=!1,this.inputEventListener.dispose()}}),this.event=this.emitter.event}set input(a){this.inputEvent=a,this.listening&&(this.inputEventListener.dispose(),this.inputEventListener=a(this.emitter.fire,this.emitter))}dispose(){this.inputEventListener.dispose(),this.emitter.dispose()}}e.Relay=E}),define(Z[27],te([0,1,3]),function(K,e,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.CancellationTokenSource=e.CancellationToken=void 0;const L=Object.freeze(function(P,m){const b=setTimeout(P.bind(m),0);return{dispose(){clearTimeout(b)}}});var R;(function(P){function m(b){return b===P.None||b===P.Cancelled||b instanceof T?!0:!b||typeof b!="object"?!1:typeof b.isCancellationRequested=="boolean"&&typeof b.onCancellationRequested=="function"}P.isCancellationToken=m,P.None=Object.freeze({isCancellationRequested:!1,onCancellationRequested:D.Event.None}),P.Cancelled=Object.freeze({isCancellationRequested:!0,onCancellationRequested:L})})(R=e.CancellationToken||(e.CancellationToken={}));class T{constructor(){this._isCancelled=!1,this._emitter=null}cancel(){this._isCancelled||(this._isCancelled=!0,this._emitter&&(this._emitter.fire(void 0),this.dispose()))}get isCancellationRequested(){return this._isCancelled}get onCancellationRequested(){return this._isCancelled?L:(this._emitter||(this._emitter=new D.Emitter),this._emitter.event)}dispose(){this._emitter&&(this._emitter.dispose(),this._emitter=null)}}class k{constructor(m){this._token=void 0,this._parentListener=void 0,this._parentListener=m&&m.onCancellationRequested(this.cancel,this)}get token(){return this._token||(this._token=new T),this._token}cancel(){this._token?this._token instanceof T&&this._token.cancel():this._token=R.Cancelled}dispose(m=!1){m&&this.cancel(),this._parentListener&&this._parentListener.dispose(),this._token?this._token instanceof T&&this._token.dispose():this._token=R.None}}e.CancellationTokenSource=k}),define(Z[49],te([0,1,3]),function(K,e,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.CSSIcon=e.getClassNamesArray=e.Codicon=e.getCodiconAriaLabel=e.registerCodicon=e.iconRegistry=void 0;class L{constructor(){this._icons=new Map,this._onDidRegister=new D.Emitter}add(C){const g=this._icons.get(C.id);g?C.description?g.description=C.description:console.error(`Duplicate registration of codicon ${C.id}`):(this._icons.set(C.id,C),this._onDidRegister.fire(C))}get(C){return this._icons.get(C)}get all(){return this._icons.values()}get onDidRegister(){return this._onDidRegister.event}}const R=new L;e.iconRegistry=R;function T(i,C){return new P(i,C)}e.registerCodicon=T;function k(i){return i?i.replace(/\$\((.*?)\)/g,(C,g)=>` ${g} `).trim():""}e.getCodiconAriaLabel=k;class P{constructor(C,g,w){this.id=C,this.definition=g,this.description=w,R.add(this)}get classNames(){return"codicon codicon-"+this.id}get classNamesArray(){return["codicon","codicon-"+this.id]}get cssSelector(){return".codicon.codicon-"+this.id}}e.Codicon=P;function m(i,C){const g=["codicon","codicon-"+i];return C&&g.push("codicon-modifier-"+C),g}e.getClassNamesArray=m;var b;(function(i){i.iconNameSegment="[A-Za-z0-9]+",i.iconNameExpression="[A-Za-z0-9\\-]+",i.iconModifierExpression="~[A-Za-z]+";const C=new RegExp(`^(${i.iconNameExpression})(${i.iconModifierExpression})?$`);function g(S){if(S instanceof P)return["codicon","codicon-"+S.id];const f=C.exec(S.id);if(!f)return g(P.error);let[,I,y]=f;const E=["codicon","codicon-"+I];return y&&E.push("codicon-modifier-"+y.substr(1)),E}i.asClassNameArray=g;function w(S){return g(S).join(" ")}i.asClassName=w;function u(S){return"."+g(S).join(".")}i.asCSSSelector=u})(b=e.CSSIcon||(e.CSSIcon={})),function(i){i.add=new i("add",{fontCharacter:"\\ea60"}),i.plus=new i("plus",{fontCharacter:"\\ea60"}),i.gistNew=new i("gist-new",{fontCharacter:"\\ea60"}),i.repoCreate=new i("repo-create",{fontCharacter:"\\ea60"}),i.lightbulb=new i("lightbulb",{fontCharacter:"\\ea61"}),i.lightBulb=new i("light-bulb",{fontCharacter:"\\ea61"}),i.repo=new i("repo",{fontCharacter:"\\ea62"}),i.repoDelete=new i("repo-delete",{fontCharacter:"\\ea62"}),i.gistFork=new i("gist-fork",{fontCharacter:"\\ea63"}),i.repoForked=new i("repo-forked",{fontCharacter:"\\ea63"}),i.gitPullRequest=new i("git-pull-request",{fontCharacter:"\\ea64"}),i.gitPullRequestAbandoned=new i("git-pull-request-abandoned",{fontCharacter:"\\ea64"}),i.recordKeys=new i("record-keys",{fontCharacter:"\\ea65"}),i.keyboard=new i("keyboard",{fontCharacter:"\\ea65"}),i.tag=new i("tag",{fontCharacter:"\\ea66"}),i.tagAdd=new i("tag-add",{fontCharacter:"\\ea66"}),i.tagRemove=new i("tag-remove",{fontCharacter:"\\ea66"}),i.person=new i("person",{fontCharacter:"\\ea67"}),i.personFollow=new i("person-follow",{fontCharacter:"\\ea67"}),i.personOutline=new i("person-outline",{fontCharacter:"\\ea67"}),i.personFilled=new i("person-filled",{fontCharacter:"\\ea67"}),i.gitBranch=new i("git-branch",{fontCharacter:"\\ea68"}),i.gitBranchCreate=new i("git-branch-create",{fontCharacter:"\\ea68"}),i.gitBranchDelete=new i("git-branch-delete",{fontCharacter:"\\ea68"}),i.sourceControl=new i("source-control",{fontCharacter:"\\ea68"}),i.mirror=new i("mirror",{fontCharacter:"\\ea69"}),i.mirrorPublic=new i("mirror-public",{fontCharacter:"\\ea69"}),i.star=new i("star",{fontCharacter:"\\ea6a"}),i.starAdd=new i("star-add",{fontCharacter:"\\ea6a"}),i.starDelete=new i("star-delete",{fontCharacter:"\\ea6a"}),i.starEmpty=new i("star-empty",{fontCharacter:"\\ea6a"}),i.comment=new i("comment",{fontCharacter:"\\ea6b"}),i.commentAdd=new i("comment-add",{fontCharacter:"\\ea6b"}),i.alert=new i("alert",{fontCharacter:"\\ea6c"}),i.warning=new i("warning",{fontCharacter:"\\ea6c"}),i.search=new i("search",{fontCharacter:"\\ea6d"}),i.searchSave=new i("search-save",{fontCharacter:"\\ea6d"}),i.logOut=new i("log-out",{fontCharacter:"\\ea6e"}),i.signOut=new i("sign-out",{fontCharacter:"\\ea6e"}),i.logIn=new i("log-in",{fontCharacter:"\\ea6f"}),i.signIn=new i("sign-in",{fontCharacter:"\\ea6f"}),i.eye=new i("eye",{fontCharacter:"\\ea70"}),i.eyeUnwatch=new i("eye-unwatch",{fontCharacter:"\\ea70"}),i.eyeWatch=new i("eye-watch",{fontCharacter:"\\ea70"}),i.circleFilled=new i("circle-filled",{fontCharacter:"\\ea71"}),i.primitiveDot=new i("primitive-dot",{fontCharacter:"\\ea71"}),i.closeDirty=new i("close-dirty",{fontCharacter:"\\ea71"}),i.debugBreakpoint=new i("debug-breakpoint",{fontCharacter:"\\ea71"}),i.debugBreakpointDisabled=new i("debug-breakpoint-disabled",{fontCharacter:"\\ea71"}),i.debugHint=new i("debug-hint",{fontCharacter:"\\ea71"}),i.primitiveSquare=new i("primitive-square",{fontCharacter:"\\ea72"}),i.edit=new i("edit",{fontCharacter:"\\ea73"}),i.pencil=new i("pencil",{fontCharacter:"\\ea73"}),i.info=new i("info",{fontCharacter:"\\ea74"}),i.issueOpened=new i("issue-opened",{fontCharacter:"\\ea74"}),i.gistPrivate=new i("gist-private",{fontCharacter:"\\ea75"}),i.gitForkPrivate=new i("git-fork-private",{fontCharacter:"\\ea75"}),i.lock=new i("lock",{fontCharacter:"\\ea75"}),i.mirrorPrivate=new i("mirror-private",{fontCharacter:"\\ea75"}),i.close=new i("close",{fontCharacter:"\\ea76"}),i.removeClose=new i("remove-close",{fontCharacter:"\\ea76"}),i.x=new i("x",{fontCharacter:"\\ea76"}),i.repoSync=new i("repo-sync",{fontCharacter:"\\ea77"}),i.sync=new i("sync",{fontCharacter:"\\ea77"}),i.clone=new i("clone",{fontCharacter:"\\ea78"}),i.desktopDownload=new i("desktop-download",{fontCharacter:"\\ea78"}),i.beaker=new i("beaker",{fontCharacter:"\\ea79"}),i.microscope=new i("microscope",{fontCharacter:"\\ea79"}),i.vm=new i("vm",{fontCharacter:"\\ea7a"}),i.deviceDesktop=new i("device-desktop",{fontCharacter:"\\ea7a"}),i.file=new i("file",{fontCharacter:"\\ea7b"}),i.fileText=new i("file-text",{fontCharacter:"\\ea7b"}),i.more=new i("more",{fontCharacter:"\\ea7c"}),i.ellipsis=new i("ellipsis",{fontCharacter:"\\ea7c"}),i.kebabHorizontal=new i("kebab-horizontal",{fontCharacter:"\\ea7c"}),i.mailReply=new i("mail-reply",{fontCharacter:"\\ea7d"}),i.reply=new i("reply",{fontCharacter:"\\ea7d"}),i.organization=new i("organization",{fontCharacter:"\\ea7e"}),i.organizationFilled=new i("organization-filled",{fontCharacter:"\\ea7e"}),i.organizationOutline=new i("organization-outline",{fontCharacter:"\\ea7e"}),i.newFile=new i("new-file",{fontCharacter:"\\ea7f"}),i.fileAdd=new i("file-add",{fontCharacter:"\\ea7f"}),i.newFolder=new i("new-folder",{fontCharacter:"\\ea80"}),i.fileDirectoryCreate=new i("file-directory-create",{fontCharacter:"\\ea80"}),i.trash=new i("trash",{fontCharacter:"\\ea81"}),i.trashcan=new i("trashcan",{fontCharacter:"\\ea81"}),i.history=new i("history",{fontCharacter:"\\ea82"}),i.clock=new i("clock",{fontCharacter:"\\ea82"}),i.folder=new i("folder",{fontCharacter:"\\ea83"}),i.fileDirectory=new i("file-directory",{fontCharacter:"\\ea83"}),i.symbolFolder=new i("symbol-folder",{fontCharacter:"\\ea83"}),i.logoGithub=new i("logo-github",{fontCharacter:"\\ea84"}),i.markGithub=new i("mark-github",{fontCharacter:"\\ea84"}),i.github=new i("github",{fontCharacter:"\\ea84"}),i.terminal=new i("terminal",{fontCharacter:"\\ea85"}),i.console=new i("console",{fontCharacter:"\\ea85"}),i.repl=new i("repl",{fontCharacter:"\\ea85"}),i.zap=new i("zap",{fontCharacter:"\\ea86"}),i.symbolEvent=new i("symbol-event",{fontCharacter:"\\ea86"}),i.error=new i("error",{fontCharacter:"\\ea87"}),i.stop=new i("stop",{fontCharacter:"\\ea87"}),i.variable=new i("variable",{fontCharacter:"\\ea88"}),i.symbolVariable=new i("symbol-variable",{fontCharacter:"\\ea88"}),i.array=new i("array",{fontCharacter:"\\ea8a"}),i.symbolArray=new i("symbol-array",{fontCharacter:"\\ea8a"}),i.symbolModule=new i("symbol-module",{fontCharacter:"\\ea8b"}),i.symbolPackage=new i("symbol-package",{fontCharacter:"\\ea8b"}),i.symbolNamespace=new i("symbol-namespace",{fontCharacter:"\\ea8b"}),i.symbolObject=new i("symbol-object",{fontCharacter:"\\ea8b"}),i.symbolMethod=new i("symbol-method",{fontCharacter:"\\ea8c"}),i.symbolFunction=new i("symbol-function",{fontCharacter:"\\ea8c"}),i.symbolConstructor=new i("symbol-constructor",{fontCharacter:"\\ea8c"}),i.symbolBoolean=new i("symbol-boolean",{fontCharacter:"\\ea8f"}),i.symbolNull=new i("symbol-null",{fontCharacter:"\\ea8f"}),i.symbolNumeric=new i("symbol-numeric",{fontCharacter:"\\ea90"}),i.symbolNumber=new i("symbol-number",{fontCharacter:"\\ea90"}),i.symbolStructure=new i("symbol-structure",{fontCharacter:"\\ea91"}),i.symbolStruct=new i("symbol-struct",{fontCharacter:"\\ea91"}),i.symbolParameter=new i("symbol-parameter",{fontCharacter:"\\ea92"}),i.symbolTypeParameter=new i("symbol-type-parameter",{fontCharacter:"\\ea92"}),i.symbolKey=new i("symbol-key",{fontCharacter:"\\ea93"}),i.symbolText=new i("symbol-text",{fontCharacter:"\\ea93"}),i.symbolReference=new i("symbol-reference",{fontCharacter:"\\ea94"}),i.goToFile=new i("go-to-file",{fontCharacter:"\\ea94"}),i.symbolEnum=new i("symbol-enum",{fontCharacter:"\\ea95"}),i.symbolValue=new i("symbol-value",{fontCharacter:"\\ea95"}),i.symbolRuler=new i("symbol-ruler",{fontCharacter:"\\ea96"}),i.symbolUnit=new i("symbol-unit",{fontCharacter:"\\ea96"}),i.activateBreakpoints=new i("activate-breakpoints",{fontCharacter:"\\ea97"}),i.archive=new i("archive",{fontCharacter:"\\ea98"}),i.arrowBoth=new i("arrow-both",{fontCharacter:"\\ea99"}),i.arrowDown=new i("arrow-down",{fontCharacter:"\\ea9a"}),i.arrowLeft=new i("arrow-left",{fontCharacter:"\\ea9b"}),i.arrowRight=new i("arrow-right",{fontCharacter:"\\ea9c"}),i.arrowSmallDown=new i("arrow-small-down",{fontCharacter:"\\ea9d"}),i.arrowSmallLeft=new i("arrow-small-left",{fontCharacter:"\\ea9e"}),i.arrowSmallRight=new i("arrow-small-right",{fontCharacter:"\\ea9f"}),i.arrowSmallUp=new i("arrow-small-up",{fontCharacter:"\\eaa0"}),i.arrowUp=new i("arrow-up",{fontCharacter:"\\eaa1"}),i.bell=new i("bell",{fontCharacter:"\\eaa2"}),i.bold=new i("bold",{fontCharacter:"\\eaa3"}),i.book=new i("book",{fontCharacter:"\\eaa4"}),i.bookmark=new i("bookmark",{fontCharacter:"\\eaa5"}),i.debugBreakpointConditionalUnverified=new i("debug-breakpoint-conditional-unverified",{fontCharacter:"\\eaa6"}),i.debugBreakpointConditional=new i("debug-breakpoint-conditional",{fontCharacter:"\\eaa7"}),i.debugBreakpointConditionalDisabled=new i("debug-breakpoint-conditional-disabled",{fontCharacter:"\\eaa7"}),i.debugBreakpointDataUnverified=new i("debug-breakpoint-data-unverified",{fontCharacter:"\\eaa8"}),i.debugBreakpointData=new i("debug-breakpoint-data",{fontCharacter:"\\eaa9"}),i.debugBreakpointDataDisabled=new i("debug-breakpoint-data-disabled",{fontCharacter:"\\eaa9"}),i.debugBreakpointLogUnverified=new i("debug-breakpoint-log-unverified",{fontCharacter:"\\eaaa"}),i.debugBreakpointLog=new i("debug-breakpoint-log",{fontCharacter:"\\eaab"}),i.debugBreakpointLogDisabled=new i("debug-breakpoint-log-disabled",{fontCharacter:"\\eaab"}),i.briefcase=new i("briefcase",{fontCharacter:"\\eaac"}),i.broadcast=new i("broadcast",{fontCharacter:"\\eaad"}),i.browser=new i("browser",{fontCharacter:"\\eaae"}),i.bug=new i("bug",{fontCharacter:"\\eaaf"}),i.calendar=new i("calendar",{fontCharacter:"\\eab0"}),i.caseSensitive=new i("case-sensitive",{fontCharacter:"\\eab1"}),i.check=new i("check",{fontCharacter:"\\eab2"}),i.checklist=new i("checklist",{fontCharacter:"\\eab3"}),i.chevronDown=new i("chevron-down",{fontCharacter:"\\eab4"}),i.chevronLeft=new i("chevron-left",{fontCharacter:"\\eab5"}),i.chevronRight=new i("chevron-right",{fontCharacter:"\\eab6"}),i.chevronUp=new i("chevron-up",{fontCharacter:"\\eab7"}),i.chromeClose=new i("chrome-close",{fontCharacter:"\\eab8"}),i.chromeMaximize=new i("chrome-maximize",{fontCharacter:"\\eab9"}),i.chromeMinimize=new i("chrome-minimize",{fontCharacter:"\\eaba"}),i.chromeRestore=new i("chrome-restore",{fontCharacter:"\\eabb"}),i.circleOutline=new i("circle-outline",{fontCharacter:"\\eabc"}),i.debugBreakpointUnverified=new i("debug-breakpoint-unverified",{fontCharacter:"\\eabc"}),i.circleSlash=new i("circle-slash",{fontCharacter:"\\eabd"}),i.circuitBoard=new i("circuit-board",{fontCharacter:"\\eabe"}),i.clearAll=new i("clear-all",{fontCharacter:"\\eabf"}),i.clippy=new i("clippy",{fontCharacter:"\\eac0"}),i.closeAll=new i("close-all",{fontCharacter:"\\eac1"}),i.cloudDownload=new i("cloud-download",{fontCharacter:"\\eac2"}),i.cloudUpload=new i("cloud-upload",{fontCharacter:"\\eac3"}),i.code=new i("code",{fontCharacter:"\\eac4"}),i.collapseAll=new i("collapse-all",{fontCharacter:"\\eac5"}),i.colorMode=new i("color-mode",{fontCharacter:"\\eac6"}),i.commentDiscussion=new i("comment-discussion",{fontCharacter:"\\eac7"}),i.compareChanges=new i("compare-changes",{fontCharacter:"\\eafd"}),i.creditCard=new i("credit-card",{fontCharacter:"\\eac9"}),i.dash=new i("dash",{fontCharacter:"\\eacc"}),i.dashboard=new i("dashboard",{fontCharacter:"\\eacd"}),i.database=new i("database",{fontCharacter:"\\eace"}),i.debugContinue=new i("debug-continue",{fontCharacter:"\\eacf"}),i.debugDisconnect=new i("debug-disconnect",{fontCharacter:"\\ead0"}),i.debugPause=new i("debug-pause",{fontCharacter:"\\ead1"}),i.debugRestart=new i("debug-restart",{fontCharacter:"\\ead2"}),i.debugStart=new i("debug-start",{fontCharacter:"\\ead3"}),i.debugStepInto=new i("debug-step-into",{fontCharacter:"\\ead4"}),i.debugStepOut=new i("debug-step-out",{fontCharacter:"\\ead5"}),i.debugStepOver=new i("debug-step-over",{fontCharacter:"\\ead6"}),i.debugStop=new i("debug-stop",{fontCharacter:"\\ead7"}),i.debug=new i("debug",{fontCharacter:"\\ead8"}),i.deviceCameraVideo=new i("device-camera-video",{fontCharacter:"\\ead9"}),i.deviceCamera=new i("device-camera",{fontCharacter:"\\eada"}),i.deviceMobile=new i("device-mobile",{fontCharacter:"\\eadb"}),i.diffAdded=new i("diff-added",{fontCharacter:"\\eadc"}),i.diffIgnored=new i("diff-ignored",{fontCharacter:"\\eadd"}),i.diffModified=new i("diff-modified",{fontCharacter:"\\eade"}),i.diffRemoved=new i("diff-removed",{fontCharacter:"\\eadf"}),i.diffRenamed=new i("diff-renamed",{fontCharacter:"\\eae0"}),i.diff=new i("diff",{fontCharacter:"\\eae1"}),i.discard=new i("discard",{fontCharacter:"\\eae2"}),i.editorLayout=new i("editor-layout",{fontCharacter:"\\eae3"}),i.emptyWindow=new i("empty-window",{fontCharacter:"\\eae4"}),i.exclude=new i("exclude",{fontCharacter:"\\eae5"}),i.extensions=new i("extensions",{fontCharacter:"\\eae6"}),i.eyeClosed=new i("eye-closed",{fontCharacter:"\\eae7"}),i.fileBinary=new i("file-binary",{fontCharacter:"\\eae8"}),i.fileCode=new i("file-code",{fontCharacter:"\\eae9"}),i.fileMedia=new i("file-media",{fontCharacter:"\\eaea"}),i.filePdf=new i("file-pdf",{fontCharacter:"\\eaeb"}),i.fileSubmodule=new i("file-submodule",{fontCharacter:"\\eaec"}),i.fileSymlinkDirectory=new i("file-symlink-directory",{fontCharacter:"\\eaed"}),i.fileSymlinkFile=new i("file-symlink-file",{fontCharacter:"\\eaee"}),i.fileZip=new i("file-zip",{fontCharacter:"\\eaef"}),i.files=new i("files",{fontCharacter:"\\eaf0"}),i.filter=new i("filter",{fontCharacter:"\\eaf1"}),i.flame=new i("flame",{fontCharacter:"\\eaf2"}),i.foldDown=new i("fold-down",{fontCharacter:"\\eaf3"}),i.foldUp=new i("fold-up",{fontCharacter:"\\eaf4"}),i.fold=new i("fold",{fontCharacter:"\\eaf5"}),i.folderActive=new i("folder-active",{fontCharacter:"\\eaf6"}),i.folderOpened=new i("folder-opened",{fontCharacter:"\\eaf7"}),i.gear=new i("gear",{fontCharacter:"\\eaf8"}),i.gift=new i("gift",{fontCharacter:"\\eaf9"}),i.gistSecret=new i("gist-secret",{fontCharacter:"\\eafa"}),i.gist=new i("gist",{fontCharacter:"\\eafb"}),i.gitCommit=new i("git-commit",{fontCharacter:"\\eafc"}),i.gitCompare=new i("git-compare",{fontCharacter:"\\eafd"}),i.gitMerge=new i("git-merge",{fontCharacter:"\\eafe"}),i.githubAction=new i("github-action",{fontCharacter:"\\eaff"}),i.githubAlt=new i("github-alt",{fontCharacter:"\\eb00"}),i.globe=new i("globe",{fontCharacter:"\\eb01"}),i.grabber=new i("grabber",{fontCharacter:"\\eb02"}),i.graph=new i("graph",{fontCharacter:"\\eb03"}),i.gripper=new i("gripper",{fontCharacter:"\\eb04"}),i.heart=new i("heart",{fontCharacter:"\\eb05"}),i.home=new i("home",{fontCharacter:"\\eb06"}),i.horizontalRule=new i("horizontal-rule",{fontCharacter:"\\eb07"}),i.hubot=new i("hubot",{fontCharacter:"\\eb08"}),i.inbox=new i("inbox",{fontCharacter:"\\eb09"}),i.issueClosed=new i("issue-closed",{fontCharacter:"\\eba4"}),i.issueReopened=new i("issue-reopened",{fontCharacter:"\\eb0b"}),i.issues=new i("issues",{fontCharacter:"\\eb0c"}),i.italic=new i("italic",{fontCharacter:"\\eb0d"}),i.jersey=new i("jersey",{fontCharacter:"\\eb0e"}),i.json=new i("json",{fontCharacter:"\\eb0f"}),i.kebabVertical=new i("kebab-vertical",{fontCharacter:"\\eb10"}),i.key=new i("key",{fontCharacter:"\\eb11"}),i.law=new i("law",{fontCharacter:"\\eb12"}),i.lightbulbAutofix=new i("lightbulb-autofix",{fontCharacter:"\\eb13"}),i.linkExternal=new i("link-external",{fontCharacter:"\\eb14"}),i.link=new i("link",{fontCharacter:"\\eb15"}),i.listOrdered=new i("list-ordered",{fontCharacter:"\\eb16"}),i.listUnordered=new i("list-unordered",{fontCharacter:"\\eb17"}),i.liveShare=new i("live-share",{fontCharacter:"\\eb18"}),i.loading=new i("loading",{fontCharacter:"\\eb19"}),i.location=new i("location",{fontCharacter:"\\eb1a"}),i.mailRead=new i("mail-read",{fontCharacter:"\\eb1b"}),i.mail=new i("mail",{fontCharacter:"\\eb1c"}),i.markdown=new i("markdown",{fontCharacter:"\\eb1d"}),i.megaphone=new i("megaphone",{fontCharacter:"\\eb1e"}),i.mention=new i("mention",{fontCharacter:"\\eb1f"}),i.milestone=new i("milestone",{fontCharacter:"\\eb20"}),i.mortarBoard=new i("mortar-board",{fontCharacter:"\\eb21"}),i.move=new i("move",{fontCharacter:"\\eb22"}),i.multipleWindows=new i("multiple-windows",{fontCharacter:"\\eb23"}),i.mute=new i("mute",{fontCharacter:"\\eb24"}),i.noNewline=new i("no-newline",{fontCharacter:"\\eb25"}),i.note=new i("note",{fontCharacter:"\\eb26"}),i.octoface=new i("octoface",{fontCharacter:"\\eb27"}),i.openPreview=new i("open-preview",{fontCharacter:"\\eb28"}),i.package_=new i("package",{fontCharacter:"\\eb29"}),i.paintcan=new i("paintcan",{fontCharacter:"\\eb2a"}),i.pin=new i("pin",{fontCharacter:"\\eb2b"}),i.play=new i("play",{fontCharacter:"\\eb2c"}),i.run=new i("run",{fontCharacter:"\\eb2c"}),i.plug=new i("plug",{fontCharacter:"\\eb2d"}),i.preserveCase=new i("preserve-case",{fontCharacter:"\\eb2e"}),i.preview=new i("preview",{fontCharacter:"\\eb2f"}),i.project=new i("project",{fontCharacter:"\\eb30"}),i.pulse=new i("pulse",{fontCharacter:"\\eb31"}),i.question=new i("question",{fontCharacter:"\\eb32"}),i.quote=new i("quote",{fontCharacter:"\\eb33"}),i.radioTower=new i("radio-tower",{fontCharacter:"\\eb34"}),i.reactions=new i("reactions",{fontCharacter:"\\eb35"}),i.references=new i("references",{fontCharacter:"\\eb36"}),i.refresh=new i("refresh",{fontCharacter:"\\eb37"}),i.regex=new i("regex",{fontCharacter:"\\eb38"}),i.remoteExplorer=new i("remote-explorer",{fontCharacter:"\\eb39"}),i.remote=new i("remote",{fontCharacter:"\\eb3a"}),i.remove=new i("remove",{fontCharacter:"\\eb3b"}),i.replaceAll=new i("replace-all",{fontCharacter:"\\eb3c"}),i.replace=new i("replace",{fontCharacter:"\\eb3d"}),i.repoClone=new i("repo-clone",{fontCharacter:"\\eb3e"}),i.repoForcePush=new i("repo-force-push",{fontCharacter:"\\eb3f"}),i.repoPull=new i("repo-pull",{fontCharacter:"\\eb40"}),i.repoPush=new i("repo-push",{fontCharacter:"\\eb41"}),i.report=new i("report",{fontCharacter:"\\eb42"}),i.requestChanges=new i("request-changes",{fontCharacter:"\\eb43"}),i.rocket=new i("rocket",{fontCharacter:"\\eb44"}),i.rootFolderOpened=new i("root-folder-opened",{fontCharacter:"\\eb45"}),i.rootFolder=new i("root-folder",{fontCharacter:"\\eb46"}),i.rss=new i("rss",{fontCharacter:"\\eb47"}),i.ruby=new i("ruby",{fontCharacter:"\\eb48"}),i.saveAll=new i("save-all",{fontCharacter:"\\eb49"}),i.saveAs=new i("save-as",{fontCharacter:"\\eb4a"}),i.save=new i("save",{fontCharacter:"\\eb4b"}),i.screenFull=new i("screen-full",{fontCharacter:"\\eb4c"}),i.screenNormal=new i("screen-normal",{fontCharacter:"\\eb4d"}),i.searchStop=new i("search-stop",{fontCharacter:"\\eb4e"}),i.server=new i("server",{fontCharacter:"\\eb50"}),i.settingsGear=new i("settings-gear",{fontCharacter:"\\eb51"}),i.settings=new i("settings",{fontCharacter:"\\eb52"}),i.shield=new i("shield",{fontCharacter:"\\eb53"}),i.smiley=new i("smiley",{fontCharacter:"\\eb54"}),i.sortPrecedence=new i("sort-precedence",{fontCharacter:"\\eb55"}),i.splitHorizontal=new i("split-horizontal",{fontCharacter:"\\eb56"}),i.splitVertical=new i("split-vertical",{fontCharacter:"\\eb57"}),i.squirrel=new i("squirrel",{fontCharacter:"\\eb58"}),i.starFull=new i("star-full",{fontCharacter:"\\eb59"}),i.starHalf=new i("star-half",{fontCharacter:"\\eb5a"}),i.symbolClass=new i("symbol-class",{fontCharacter:"\\eb5b"}),i.symbolColor=new i("symbol-color",{fontCharacter:"\\eb5c"}),i.symbolConstant=new i("symbol-constant",{fontCharacter:"\\eb5d"}),i.symbolEnumMember=new i("symbol-enum-member",{fontCharacter:"\\eb5e"}),i.symbolField=new i("symbol-field",{fontCharacter:"\\eb5f"}),i.symbolFile=new i("symbol-file",{fontCharacter:"\\eb60"}),i.symbolInterface=new i("symbol-interface",{fontCharacter:"\\eb61"}),i.symbolKeyword=new i("symbol-keyword",{fontCharacter:"\\eb62"}),i.symbolMisc=new i("symbol-misc",{fontCharacter:"\\eb63"}),i.symbolOperator=new i("symbol-operator",{fontCharacter:"\\eb64"}),i.symbolProperty=new i("symbol-property",{fontCharacter:"\\eb65"}),i.wrench=new i("wrench",{fontCharacter:"\\eb65"}),i.wrenchSubaction=new i("wrench-subaction",{fontCharacter:"\\eb65"}),i.symbolSnippet=new i("symbol-snippet",{fontCharacter:"\\eb66"}),i.tasklist=new i("tasklist",{fontCharacter:"\\eb67"}),i.telescope=new i("telescope",{fontCharacter:"\\eb68"}),i.textSize=new i("text-size",{fontCharacter:"\\eb69"}),i.threeBars=new i("three-bars",{fontCharacter:"\\eb6a"}),i.thumbsdown=new i("thumbsdown",{fontCharacter:"\\eb6b"}),i.thumbsup=new i("thumbsup",{fontCharacter:"\\eb6c"}),i.tools=new i("tools",{fontCharacter:"\\eb6d"}),i.triangleDown=new i("triangle-down",{fontCharacter:"\\eb6e"}),i.triangleLeft=new i("triangle-left",{fontCharacter:"\\eb6f"}),i.triangleRight=new i("triangle-right",{fontCharacter:"\\eb70"}),i.triangleUp=new i("triangle-up",{fontCharacter:"\\eb71"}),i.twitter=new i("twitter",{fontCharacter:"\\eb72"}),i.unfold=new i("unfold",{fontCharacter:"\\eb73"}),i.unlock=new i("unlock",{fontCharacter:"\\eb74"}),i.unmute=new i("unmute",{fontCharacter:"\\eb75"}),i.unverified=new i("unverified",{fontCharacter:"\\eb76"}),i.verified=new i("verified",{fontCharacter:"\\eb77"}),i.versions=new i("versions",{fontCharacter:"\\eb78"}),i.vmActive=new i("vm-active",{fontCharacter:"\\eb79"}),i.vmOutline=new i("vm-outline",{fontCharacter:"\\eb7a"}),i.vmRunning=new i("vm-running",{fontCharacter:"\\eb7b"}),i.watch=new i("watch",{fontCharacter:"\\eb7c"}),i.whitespace=new i("whitespace",{fontCharacter:"\\eb7d"}),i.wholeWord=new i("whole-word",{fontCharacter:"\\eb7e"}),i.window=new i("window",{fontCharacter:"\\eb7f"}),i.wordWrap=new i("word-wrap",{fontCharacter:"\\eb80"}),i.zoomIn=new i("zoom-in",{fontCharacter:"\\eb81"}),i.zoomOut=new i("zoom-out",{fontCharacter:"\\eb82"}),i.listFilter=new i("list-filter",{fontCharacter:"\\eb83"}),i.listFlat=new i("list-flat",{fontCharacter:"\\eb84"}),i.listSelection=new i("list-selection",{fontCharacter:"\\eb85"}),i.selection=new i("selection",{fontCharacter:"\\eb85"}),i.listTree=new i("list-tree",{fontCharacter:"\\eb86"}),i.debugBreakpointFunctionUnverified=new i("debug-breakpoint-function-unverified",{fontCharacter:"\\eb87"}),i.debugBreakpointFunction=new i("debug-breakpoint-function",{fontCharacter:"\\eb88"}),i.debugBreakpointFunctionDisabled=new i("debug-breakpoint-function-disabled",{fontCharacter:"\\eb88"}),i.debugStackframeActive=new i("debug-stackframe-active",{fontCharacter:"\\eb89"}),i.debugStackframeDot=new i("debug-stackframe-dot",{fontCharacter:"\\eb8a"}),i.debugStackframe=new i("debug-stackframe",{fontCharacter:"\\eb8b"}),i.debugStackframeFocused=new i("debug-stackframe-focused",{fontCharacter:"\\eb8b"}),i.debugBreakpointUnsupported=new i("debug-breakpoint-unsupported",{fontCharacter:"\\eb8c"}),i.symbolString=new i("symbol-string",{fontCharacter:"\\eb8d"}),i.debugReverseContinue=new i("debug-reverse-continue",{fontCharacter:"\\eb8e"}),i.debugStepBack=new i("debug-step-back",{fontCharacter:"\\eb8f"}),i.debugRestartFrame=new i("debug-restart-frame",{fontCharacter:"\\eb90"}),i.callIncoming=new i("call-incoming",{fontCharacter:"\\eb92"}),i.callOutgoing=new i("call-outgoing",{fontCharacter:"\\eb93"}),i.menu=new i("menu",{fontCharacter:"\\eb94"}),i.expandAll=new i("expand-all",{fontCharacter:"\\eb95"}),i.feedback=new i("feedback",{fontCharacter:"\\eb96"}),i.groupByRefType=new i("group-by-ref-type",{fontCharacter:"\\eb97"}),i.ungroupByRefType=new i("ungroup-by-ref-type",{fontCharacter:"\\eb98"}),i.account=new i("account",{fontCharacter:"\\eb99"}),i.bellDot=new i("bell-dot",{fontCharacter:"\\eb9a"}),i.debugConsole=new i("debug-console",{fontCharacter:"\\eb9b"}),i.library=new i("library",{fontCharacter:"\\eb9c"}),i.output=new i("output",{fontCharacter:"\\eb9d"}),i.runAll=new i("run-all",{fontCharacter:"\\eb9e"}),i.syncIgnored=new i("sync-ignored",{fontCharacter:"\\eb9f"}),i.pinned=new i("pinned",{fontCharacter:"\\eba0"}),i.githubInverted=new i("github-inverted",{fontCharacter:"\\eba1"}),i.debugAlt=new i("debug-alt",{fontCharacter:"\\eb91"}),i.serverProcess=new i("server-process",{fontCharacter:"\\eba2"}),i.serverEnvironment=new i("server-environment",{fontCharacter:"\\eba3"}),i.pass=new i("pass",{fontCharacter:"\\eba4"}),i.stopCircle=new i("stop-circle",{fontCharacter:"\\eba5"}),i.playCircle=new i("play-circle",{fontCharacter:"\\eba6"}),i.record=new i("record",{fontCharacter:"\\eba7"}),i.debugAltSmall=new i("debug-alt-small",{fontCharacter:"\\eba8"}),i.vmConnect=new i("vm-connect",{fontCharacter:"\\eba9"}),i.cloud=new i("cloud",{fontCharacter:"\\ebaa"}),i.merge=new i("merge",{fontCharacter:"\\ebab"}),i.exportIcon=new i("export",{fontCharacter:"\\ebac"}),i.graphLeft=new i("graph-left",{fontCharacter:"\\ebad"}),i.magnet=new i("magnet",{fontCharacter:"\\ebae"}),i.notebook=new i("notebook",{fontCharacter:"\\ebaf"}),i.redo=new i("redo",{fontCharacter:"\\ebb0"}),i.checkAll=new i("check-all",{fontCharacter:"\\ebb1"}),i.pinnedDirty=new i("pinned-dirty",{fontCharacter:"\\ebb2"}),i.passFilled=new i("pass-filled",{fontCharacter:"\\ebb3"}),i.circleLargeFilled=new i("circle-large-filled",{fontCharacter:"\\ebb4"}),i.circleLargeOutline=new i("circle-large-outline",{fontCharacter:"\\ebb5"}),i.combine=new i("combine",{fontCharacter:"\\ebb6"}),i.gather=new i("gather",{fontCharacter:"\\ebb6"}),i.table=new i("table",{fontCharacter:"\\ebb7"}),i.variableGroup=new i("variable-group",{fontCharacter:"\\ebb8"}),i.typeHierarchy=new i("type-hierarchy",{fontCharacter:"\\ebb9"}),i.typeHierarchySub=new i("type-hierarchy-sub",{fontCharacter:"\\ebba"}),i.typeHierarchySuper=new i("type-hierarchy-super",{fontCharacter:"\\ebbb"}),i.gitPullRequestCreate=new i("git-pull-request-create",{fontCharacter:"\\ebbc"}),i.runAbove=new i("run-above",{fontCharacter:"\\ebbd"}),i.runBelow=new i("run-below",{fontCharacter:"\\ebbe"}),i.notebookTemplate=new i("notebook-template",{fontCharacter:"\\ebbf"}),i.debugRerun=new i("debug-rerun",{fontCharacter:"\\ebc0"}),i.workspaceTrusted=new i("workspace-trusted",{fontCharacter:"\\ebc1"}),i.workspaceUntrusted=new i("workspace-untrusted",{fontCharacter:"\\ebc2"}),i.workspaceUnspecified=new i("workspace-unspecified",{fontCharacter:"\\ebc3"}),i.terminalCmd=new i("terminal-cmd",{fontCharacter:"\\ebc4"}),i.terminalDebian=new i("terminal-debian",{fontCharacter:"\\ebc5"}),i.terminalLinux=new i("terminal-linux",{fontCharacter:"\\ebc6"}),i.terminalPowershell=new i("terminal-powershell",{fontCharacter:"\\ebc7"}),i.terminalTmux=new i("terminal-tmux",{fontCharacter:"\\ebc8"}),i.terminalUbuntu=new i("terminal-ubuntu",{fontCharacter:"\\ebc9"}),i.terminalBash=new i("terminal-bash",{fontCharacter:"\\ebca"}),i.arrowSwap=new i("arrow-swap",{fontCharacter:"\\ebcb"}),i.copy=new i("copy",{fontCharacter:"\\ebcc"}),i.personAdd=new i("person-add",{fontCharacter:"\\ebcd"}),i.filterFilled=new i("filter-filled",{fontCharacter:"\\ebce"}),i.wand=new i("wand",{fontCharacter:"\\ebcf"}),i.debugLineByLine=new i("debug-line-by-line",{fontCharacter:"\\ebd0"}),i.inspect=new i("inspect",{fontCharacter:"\\ebd1"}),i.layers=new i("layers",{fontCharacter:"\\ebd2"}),i.layersDot=new i("layers-dot",{fontCharacter:"\\ebd3"}),i.layersActive=new i("layers-active",{fontCharacter:"\\ebd4"}),i.compass=new i("compass",{fontCharacter:"\\ebd5"}),i.compassDot=new i("compass-dot",{fontCharacter:"\\ebd6"}),i.compassActive=new i("compass-active",{fontCharacter:"\\ebd7"}),i.azure=new i("azure",{fontCharacter:"\\ebd8"}),i.issueDraft=new i("issue-draft",{fontCharacter:"\\ebd9"}),i.gitPullRequestClosed=new i("git-pull-request-closed",{fontCharacter:"\\ebda"}),i.gitPullRequestDraft=new i("git-pull-request-draft",{fontCharacter:"\\ebdb"}),i.debugAll=new i("debug-all",{fontCharacter:"\\ebdc"}),i.debugCoverage=new i("debug-coverage",{fontCharacter:"\\ebdd"}),i.runErrors=new i("run-errors",{fontCharacter:"\\ebde"}),i.folderLibrary=new i("folder-library",{fontCharacter:"\\ebdf"}),i.dropDownButton=new i("drop-down-button",i.chevronDown.definition)}(P=e.Codicon||(e.Codicon={}))}),define(Z[50],te([0,1,9,2]),function(K,e,D,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.prefixedStream=e.prefixedReadable=e.transform=e.toReadable=e.emptyStream=e.toStream=e.peekStream=e.listenStream=e.consumeStream=e.peekReadable=e.consumeReadable=e.newWriteableStream=e.isReadableBufferedStream=e.isReadableStream=void 0;function R(E){const o=E;return o?[o.on,o.pause,o.resume,o.destroy].every(a=>typeof a=="function"):!1}e.isReadableStream=R;function T(E){const o=E;return o?R(o.stream)&&Array.isArray(o.buffer)&&typeof o.ended=="boolean":!1}e.isReadableBufferedStream=T;function k(E,o){return new P(E,o)}e.newWriteableStream=k;class P{constructor(o,a){this.reducer=o,this.options=a,this.state={flowing:!1,ended:!1,destroyed:!1},this.buffer={data:[],error:[]},this.listeners={data:[],error:[],end:[]},this.pendingWritePromises=[]}pause(){this.state.destroyed||(this.state.flowing=!1)}resume(){this.state.destroyed||this.state.flowing||(this.state.flowing=!0,this.flowData(),this.flowErrors(),this.flowEnd())}write(o){if(!this.state.destroyed){if(this.state.flowing)this.emitData(o);else if(this.buffer.data.push(o),typeof this.options?.highWaterMark=="number"&&this.buffer.data.length>this.options.highWaterMark)return new Promise(a=>this.pendingWritePromises.push(a))}}error(o){this.state.destroyed||(this.state.flowing?this.emitError(o):this.buffer.error.push(o))}end(o){this.state.destroyed||(typeof o!="undefined"&&this.write(o),this.state.flowing?(this.emitEnd(),this.destroy()):this.state.ended=!0)}emitData(o){this.listeners.data.slice(0).forEach(a=>a(o))}emitError(o){this.listeners.error.length===0?(0,D.onUnexpectedError)(o):this.listeners.error.slice(0).forEach(a=>a(o))}emitEnd(){this.listeners.end.slice(0).forEach(o=>o())}on(o,a){if(!this.state.destroyed)switch(o){case"data":this.listeners.data.push(a),this.resume();break;case"end":this.listeners.end.push(a),this.state.flowing&&this.flowEnd()&&this.destroy();break;case"error":this.listeners.error.push(a),this.state.flowing&&this.flowErrors();break}}removeListener(o,a){if(this.state.destroyed)return;let t;switch(o){case"data":t=this.listeners.data;break;case"end":t=this.listeners.end;break;case"error":t=this.listeners.error;break}if(t){const r=t.indexOf(a);r>=0&&t.splice(r,1)}}flowData(){if(this.buffer.data.length>0){const o=this.reducer(this.buffer.data);this.emitData(o),this.buffer.data.length=0;const a=[...this.pendingWritePromises];this.pendingWritePromises.length=0,a.forEach(t=>t())}}flowErrors(){if(this.listeners.error.length>0){for(const o of this.buffer.error)this.emitError(o);this.buffer.error.length=0}}flowEnd(){return this.state.ended?(this.emitEnd(),this.listeners.end.length>0):!1}destroy(){this.state.destroyed||(this.state.destroyed=!0,this.state.ended=!0,this.buffer.data.length=0,this.buffer.error.length=0,this.listeners.data.length=0,this.listeners.error.length=0,this.listeners.end.length=0,this.pendingWritePromises.length=0)}}function m(E,o){const a=[];let t;for(;(t=E.read())!==null;)a.push(t);return o(a)}e.consumeReadable=m;function b(E,o,a){const t=[];let r;for(;(r=E.read())!==null&&t.length<a;)t.push(r);return r===null&&t.length>0?o(t):{read:()=>{if(t.length>0)return t.shift();if(typeof r!="undefined"){const n=r;return r=void 0,n}return E.read()}}}e.peekReadable=b;function i(E,o){return new Promise((a,t)=>{const r=[];C(E,{onData:n=>{o&&r.push(n)},onError:n=>{o?t(n):a(void 0)},onEnd:()=>{a(o?o(r):void 0)}})})}e.consumeStream=i;function C(E,o){E.on("error",a=>o.onError(a)),E.on("end",()=>o.onEnd()),E.on("data",a=>o.onData(a))}e.listenStream=C;function g(E,o){return new Promise((a,t)=>{const r=new L.DisposableStore,n=[],s=h=>{if(n.push(h),n.length>o)return r.dispose(),E.pause(),a({stream:E,buffer:n,ended:!1})},c=h=>t(h),l=()=>a({stream:E,buffer:n,ended:!0});r.add((0,L.toDisposable)(()=>E.removeListener("error",c))),E.on("error",c),r.add((0,L.toDisposable)(()=>E.removeListener("end",l))),E.on("end",l),r.add((0,L.toDisposable)(()=>E.removeListener("data",s))),E.on("data",s)})}e.peekStream=g;function w(E,o){const a=k(o);return a.end(E),a}e.toStream=w;function u(){const E=k(()=>{throw new Error("not supported")});return E.end(),E}e.emptyStream=u;function S(E){let o=!1;return{read:()=>o?null:(o=!0,E)}}e.toReadable=S;function f(E,o,a){const t=k(a);return C(E,{onData:r=>t.write(o.data(r)),onError:r=>t.error(o.error?o.error(r):r),onEnd:()=>t.end()}),t}e.transform=f;function I(E,o,a){let t=!1;return{read:()=>{const r=o.read();return t?r:(t=!0,r!==null?a([E,r]):E)}}}e.prefixedReadable=I;function y(E,o,a){let t=!1;const r=k(a);return C(o,{onData:n=>t?r.write(n):(t=!0,r.write(a([E,n]))),onError:n=>r.error(n),onEnd:()=>{t||(t=!0,r.write(E)),r.end()}}),r}e.prefixedStream=y}),define(Z[25],te([0,1,50]),function(K,e,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.prefixedBufferStream=e.prefixedBufferReadable=e.newWriteableBufferStream=e.streamToBufferReadableStream=e.bufferToStream=e.bufferedStreamToBuffer=e.streamToBuffer=e.bufferToReadable=e.readableToBuffer=e.writeUInt8=e.readUInt8=e.writeUInt32LE=e.readUInt32LE=e.writeUInt32BE=e.readUInt32BE=e.writeUInt16LE=e.readUInt16LE=e.VSBuffer=void 0;const L=typeof Buffer!="undefined";let R,T;class k{constructor(s){this.buffer=s,this.byteLength=this.buffer.byteLength}static alloc(s){return L?new k(Buffer.allocUnsafe(s)):new k(new Uint8Array(s))}static wrap(s){return L&&!Buffer.isBuffer(s)&&(s=Buffer.from(s.buffer,s.byteOffset,s.byteLength)),new k(s)}static fromString(s,c){return!(c?.dontUseNodeBuffer||!1)&&L?new k(Buffer.from(s)):(R||(R=new TextEncoder),new k(R.encode(s)))}static concat(s,c){if(typeof c=="undefined"){c=0;for(let d=0,v=s.length;d<v;d++)c+=s[d].byteLength}const l=k.alloc(c);let h=0;for(let d=0,v=s.length;d<v;d++){const A=s[d];l.set(A,h),h+=A.byteLength}return l}toString(){return L?this.buffer.toString():(T||(T=new TextDecoder),T.decode(this.buffer))}slice(s,c){return new k(this.buffer.subarray(s,c))}set(s,c){s instanceof k?this.buffer.set(s.buffer,c):this.buffer.set(s,c)}readUInt32BE(s){return b(this.buffer,s)}writeUInt32BE(s,c){i(this.buffer,s,c)}readUInt32LE(s){return C(this.buffer,s)}writeUInt32LE(s,c){g(this.buffer,s,c)}readUInt8(s){return w(this.buffer,s)}writeUInt8(s,c){u(this.buffer,s,c)}}e.VSBuffer=k;function P(n,s){return n[s+0]<<0>>>0|n[s+1]<<8>>>0}e.readUInt16LE=P;function m(n,s,c){n[c+0]=s&255,s=s>>>8,n[c+1]=s&255}e.writeUInt16LE=m;function b(n,s){return n[s]*2**24+n[s+1]*2**16+n[s+2]*2**8+n[s+3]}e.readUInt32BE=b;function i(n,s,c){n[c+3]=s,s=s>>>8,n[c+2]=s,s=s>>>8,n[c+1]=s,s=s>>>8,n[c]=s}e.writeUInt32BE=i;function C(n,s){return n[s+0]<<0>>>0|n[s+1]<<8>>>0|n[s+2]<<16>>>0|n[s+3]<<24>>>0}e.readUInt32LE=C;function g(n,s,c){n[c+0]=s&255,s=s>>>8,n[c+1]=s&255,s=s>>>8,n[c+2]=s&255,s=s>>>8,n[c+3]=s&255}e.writeUInt32LE=g;function w(n,s){return n[s]}e.readUInt8=w;function u(n,s,c){n[c]=s}e.writeUInt8=u;function S(n){return D.consumeReadable(n,s=>k.concat(s))}e.readableToBuffer=S;function f(n){return D.toReadable(n)}e.bufferToReadable=f;function I(n){return D.consumeStream(n,s=>k.concat(s))}e.streamToBuffer=I;async function y(n){return n.ended?k.concat(n.buffer):k.concat([...n.buffer,await I(n.stream)])}e.bufferedStreamToBuffer=y;function E(n){return D.toStream(n,s=>k.concat(s))}e.bufferToStream=E;function o(n){return D.transform(n,{data:s=>typeof s=="string"?k.fromString(s):k.wrap(s)},s=>k.concat(s))}e.streamToBufferReadableStream=o;function a(n){return D.newWriteableStream(s=>k.concat(s),n)}e.newWriteableBufferStream=a;function t(n,s){return D.prefixedReadable(n,s,c=>k.concat(c))}e.prefixedBufferReadable=t;function r(n,s){return D.prefixedStream(n,s,c=>k.concat(c))}e.prefixedBufferStream=r}),define(Z[24],te([0,1]),function(K,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getLeftDeleteOffset=e.GraphemeBreakType=e.breakBetweenGraphemeBreakType=e.getGraphemeBreakType=e.singleLetterHash=e.getNLines=e.uppercaseFirstLetter=e.containsUppercaseCharacter=e.fuzzyContains=e.stripUTF8BOM=e.startsWithUTF8BOM=e.UTF8_BOM_CHARACTER=e.removeAnsiEscapeCodes=e.lcut=e.isEmojiImprecise=e.isFullWidthCharacter=e.containsFullWidthCharacter=e.containsUnusualLineTerminators=e.UNUSUAL_LINE_TERMINATORS=e.isBasicASCII=e.containsEmoji=e.containsRTL=e.getCharContainingOffset=e.prevCharLength=e.nextCharLength=e.getNextCodePoint=e.computeCodePoint=e.isLowSurrogate=e.isHighSurrogate=e.commonSuffixLength=e.commonPrefixLength=e.startsWithIgnoreCase=e.equalsIgnoreCase=e.isUpperAsciiLetter=e.isLowerAsciiLetter=e.compareSubstringIgnoreCase=e.compareIgnoreCase=e.compareSubstring=e.compare=e.lastNonWhitespaceIndex=e.getLeadingWhitespace=e.firstNonWhitespaceIndex=e.splitLines=e.regExpFlags=e.regExpContainsBackreference=e.regExpLeadsToEndlessLoop=e.createRegExp=e.stripWildcards=e.convertSimple2RegExpPattern=e.rtrim=e.ltrim=e.trim=e.truncate=e.count=e.escapeRegExpCharacters=e.escape=e.format2=e.format=e.isFalsyOrWhitespace=void 0;function D(V){return!V||typeof V!="string"?!0:V.trim().length===0}e.isFalsyOrWhitespace=D;const L=/{(\d+)}/g;function R(V,...se){return se.length===0?V:V.replace(L,function(le,he){const me=parseInt(he,10);return isNaN(me)||me<0||me>=se.length?le:se[me]})}e.format=R;const T=/{([^}]+)}/g;function k(V,se){return V.replace(T,(le,he)=>se[he]??le)}e.format2=k;function P(V){return V.replace(/[<>&]/g,function(se){switch(se){case"<":return"&lt;";case">":return"&gt;";case"&":return"&amp;";default:return se}})}e.escape=P;function m(V){return V.replace(/[\\\{\}\*\+\?\|\^\$\.\[\]\(\)]/g,"\\$&")}e.escapeRegExpCharacters=m;function b(V,se){let le=0;const he=se.charCodeAt(0);for(let me=V.length-1;me>=0;me--)V.charCodeAt(me)===he&&le++;return le}e.count=b;function i(V,se,le="\u2026"){return V.length<=se?V:`${V.substr(0,se)}${le}`}e.truncate=i;function C(V,se=" "){const le=g(V,se);return w(le,se)}e.trim=C;function g(V,se){if(!V||!se)return V;const le=se.length;if(le===0||V.length===0)return V;let he=0;for(;V.indexOf(se,he)===he;)he=he+le;return V.substring(he)}e.ltrim=g;function w(V,se){if(!V||!se)return V;const le=se.length,he=V.length;if(le===0||he===0)return V;let me=he,be=-1;for(;be=V.lastIndexOf(se,me-1),!(be===-1||be+le!==me);){if(be===0)return"";me=be}return V.substring(0,me)}e.rtrim=w;function u(V){return V.replace(/[\-\\\{\}\+\?\|\^\$\.\,\[\]\(\)\#\s]/g,"\\$&").replace(/[\*]/g,".*")}e.convertSimple2RegExpPattern=u;function S(V){return V.replace(/\*/g,"")}e.stripWildcards=S;function f(V,se,le={}){if(!V)throw new Error("Cannot create regex from empty string");se||(V=m(V)),le.wholeWord&&(/\B/.test(V.charAt(0))||(V="\\b"+V),/\B/.test(V.charAt(V.length-1))||(V=V+"\\b"));let he="";return le.global&&(he+="g"),le.matchCase||(he+="i"),le.multiline&&(he+="m"),le.unicode&&(he+="u"),new RegExp(V,he)}e.createRegExp=f;function I(V){return V.source==="^"||V.source==="^$"||V.source==="$"||V.source==="^\\s*$"?!1:!!(V.exec("")&&V.lastIndex===0)}e.regExpLeadsToEndlessLoop=I;function y(V){return!!V.match(/([^\\]|^)(\\\\)*\\\d+/)}e.regExpContainsBackreference=y;function E(V){return(V.global?"g":"")+(V.ignoreCase?"i":"")+(V.multiline?"m":"")+(V.unicode?"u":"")}e.regExpFlags=E;function o(V){return V.split(/\r\n|\r|\n/)}e.splitLines=o;function a(V){for(let se=0,le=V.length;se<le;se++){const he=V.charCodeAt(se);if(he!==32&&he!==9)return se}return-1}e.firstNonWhitespaceIndex=a;function t(V,se=0,le=V.length){for(let he=se;he<le;he++){const me=V.charCodeAt(he);if(me!==32&&me!==9)return V.substring(se,he)}return V.substring(se,le)}e.getLeadingWhitespace=t;function r(V,se=V.length-1){for(let le=se;le>=0;le--){const he=V.charCodeAt(le);if(he!==32&&he!==9)return le}return-1}e.lastNonWhitespaceIndex=r;function n(V,se){return V<se?-1:V>se?1:0}e.compare=n;function s(V,se,le=0,he=V.length,me=0,be=se.length){for(;le<he&&me<be;le++,me++){let Ce=V.charCodeAt(le),De=se.charCodeAt(me);if(Ce<De)return-1;if(Ce>De)return 1}const ve=he-le,we=be-me;return ve<we?-1:ve>we?1:0}e.compareSubstring=s;function c(V,se){return l(V,se,0,V.length,0,se.length)}e.compareIgnoreCase=c;function l(V,se,le=0,he=V.length,me=0,be=se.length){for(;le<he&&me<be;le++,me++){let Ce=V.charCodeAt(le),De=se.charCodeAt(me);if(Ce===De)continue;const ke=Ce-De;if(!(ke===32&&d(De))&&!(ke===-32&&d(Ce)))return h(Ce)&&h(De)?ke:s(V.toLowerCase(),se.toLowerCase(),le,he,me,be)}const ve=he-le,we=be-me;return ve<we?-1:ve>we?1:0}e.compareSubstringIgnoreCase=l;function h(V){return V>=97&&V<=122}e.isLowerAsciiLetter=h;function d(V){return V>=65&&V<=90}e.isUpperAsciiLetter=d;function v(V){return h(V)||d(V)}function A(V,se){return V.length===se.length&&O(V,se)}e.equalsIgnoreCase=A;function O(V,se,le=V.length){for(let he=0;he<le;he++){const me=V.charCodeAt(he),be=se.charCodeAt(he);if(me!==be){if(v(me)&&v(be)){const ve=Math.abs(me-be);if(ve!==0&&ve!==32)return!1}else if(String.fromCharCode(me).toLowerCase()!==String.fromCharCode(be).toLowerCase())return!1}}return!0}function p(V,se){const le=se.length;return se.length>V.length?!1:O(V,se,le)}e.startsWithIgnoreCase=p;function U(V,se){let le,he=Math.min(V.length,se.length);for(le=0;le<he;le++)if(V.charCodeAt(le)!==se.charCodeAt(le))return le;return he}e.commonPrefixLength=U;function F(V,se){let le,he=Math.min(V.length,se.length);const me=V.length-1,be=se.length-1;for(le=0;le<he;le++)if(V.charCodeAt(me-le)!==se.charCodeAt(be-le))return le;return he}e.commonSuffixLength=F;function z(V){return 55296<=V&&V<=56319}e.isHighSurrogate=z;function H(V){return 56320<=V&&V<=57343}e.isLowSurrogate=H;function M(V,se){return(V-55296<<10)+(se-56320)+65536}e.computeCodePoint=M;function j(V,se,le){const he=V.charCodeAt(le);if(z(he)&&le+1<se){const me=V.charCodeAt(le+1);if(H(me))return M(he,me)}return he}e.getNextCodePoint=j;function q(V,se){const le=V.charCodeAt(se-1);if(H(le)&&se>1){const he=V.charCodeAt(se-2);if(z(he))return M(he,le)}return le}function x(V,se){const le=oe.getInstance(),he=se,me=V.length,be=j(V,me,se);se+=be>=65536?2:1;let ve=le.getGraphemeBreakType(be);for(;se<me;){const we=j(V,me,se),Ce=le.getGraphemeBreakType(we);if(Q(ve,Ce))break;se+=we>=65536?2:1,ve=Ce}return se-he}e.nextCharLength=x;function $(V,se){const le=oe.getInstance(),he=se,me=q(V,se);se-=me>=65536?2:1;let be=le.getGraphemeBreakType(me);for(;se>0;){const ve=q(V,se),we=le.getGraphemeBreakType(ve);if(Q(we,be))break;se-=ve>=65536?2:1,be=we}return he-se}e.prevCharLength=$;function N(V,se){const le=oe.getInstance(),he=V.length,me=se,be=j(V,he,se),ve=le.getGraphemeBreakType(be);se+=be>=65536?2:1;let we=ve;for(;se<he;){const De=j(V,he,se),ke=le.getGraphemeBreakType(De);if(Q(we,ke))break;se+=De>=65536?2:1,we=ke}const Ce=se;for(se=me,we=ve;se>0;){const De=q(V,se),ke=le.getGraphemeBreakType(De);if(Q(ke,we))break;se-=De>=65536?2:1,we=ke}return[se,Ce]}function W(V,se){return se>0&&H(V.charCodeAt(se))?N(V,se-1):N(V,se)}e.getCharContainingOffset=W;const _=/(?:[\u05BE\u05C0\u05C3\u05C6\u05D0-\u05F4\u0608\u060B\u060D\u061B-\u064A\u066D-\u066F\u0671-\u06D5\u06E5\u06E6\u06EE\u06EF\u06FA-\u0710\u0712-\u072F\u074D-\u07A5\u07B1-\u07EA\u07F4\u07F5\u07FA-\u0815\u081A\u0824\u0828\u0830-\u0858\u085E-\u08BD\u200F\uFB1D\uFB1F-\uFB28\uFB2A-\uFD3D\uFD50-\uFDFC\uFE70-\uFEFC]|\uD802[\uDC00-\uDD1B\uDD20-\uDE00\uDE10-\uDE33\uDE40-\uDEE4\uDEEB-\uDF35\uDF40-\uDFFF]|\uD803[\uDC00-\uDCFF]|\uD83A[\uDC00-\uDCCF\uDD00-\uDD43\uDD50-\uDFFF]|\uD83B[\uDC00-\uDEBB])/;function Y(V){return _.test(V)}e.containsRTL=Y;const G=/(?:[\u231A\u231B\u23F0\u23F3\u2600-\u27BF\u2B50\u2B55]|\uD83C[\uDDE6-\uDDFF\uDF00-\uDFFF]|\uD83D[\uDC00-\uDE4F\uDE80-\uDEFC\uDFE0-\uDFEB]|\uD83E[\uDD00-\uDDFF\uDE70-\uDED6])/;function ne(V){return G.test(V)}e.containsEmoji=ne;const ee=/^[\t\n\r\x20-\x7E]*$/;function X(V){return ee.test(V)}e.isBasicASCII=X,e.UNUSUAL_LINE_TERMINATORS=/[\u2028\u2029]/;function B(V){return e.UNUSUAL_LINE_TERMINATORS.test(V)}e.containsUnusualLineTerminators=B;function re(V){for(let se=0,le=V.length;se<le;se++)if(ie(V.charCodeAt(se)))return!0;return!1}e.containsFullWidthCharacter=re;function ie(V){return V=+V,V>=11904&&V<=55215||V>=63744&&V<=64255||V>=65281&&V<=65374}e.isFullWidthCharacter=ie;function ce(V){return V>=127462&&V<=127487||V===8986||V===8987||V===9200||V===9203||V>=9728&&V<=10175||V===11088||V===11093||V>=127744&&V<=128591||V>=128640&&V<=128764||V>=128992&&V<=129003||V>=129280&&V<=129535||V>=129648&&V<=129750}e.isEmojiImprecise=ce;function ue(V,se){if(V.length<se)return V;const le=/\b/g;let he=0;for(;le.test(V)&&!(V.length-le.lastIndex<se);)he=le.lastIndex,le.lastIndex+=1;return V.substring(he).replace(/^\s/,"")}e.lcut=ue;const ge=/\x1B\x5B[12]?K/g,de=/\x1b\[\d+m/g,Ie=/\x1b\[0?m/g;function Pe(V){return V&&(V=V.replace(ge,""),V=V.replace(de,""),V=V.replace(Ie,"")),V}e.removeAnsiEscapeCodes=Pe,e.UTF8_BOM_CHARACTER=String.fromCharCode(65279);function Ee(V){return!!(V&&V.length>0&&V.charCodeAt(0)===65279)}e.startsWithUTF8BOM=Ee;function Oe(V){return Ee(V)?V.substr(1):V}e.stripUTF8BOM=Oe;function Re(V,se){if(!V||!se||V.length<se.length)return!1;const le=se.length,he=V.toLowerCase();let me=0,be=-1;for(;me<le;){const ve=he.indexOf(se[me],be+1);if(ve<0)return!1;be=ve,me++}return!0}e.fuzzyContains=Re;function Te(V,se=!1){return V?(se&&(V=V.replace(/\\./g,"")),V.toLowerCase()!==V):!1}e.containsUppercaseCharacter=Te;function Ne(V){return V.charAt(0).toUpperCase()+V.slice(1)}e.uppercaseFirstLetter=Ne;function _e(V,se=1){if(se===0)return"";let le=-1;do le=V.indexOf(`
`,le+1),se--;while(se>0&&le>=0);return le===-1?V:(V[le-1]==="\r"&&le--,V.substr(0,le))}e.getNLines=_e;function ze(V){const se=90-65+1;return V=V%(2*se),V<se?String.fromCharCode(97+V):String.fromCharCode(65+V-se)}e.singleLetterHash=ze;function $e(V){return oe.getInstance().getGraphemeBreakType(V)}e.getGraphemeBreakType=$e;function Q(V,se){return V===0?se!==5&&se!==7:V===2&&se===3?!1:V===4||V===2||V===3||se===4||se===2||se===3?!0:!(V===8&&(se===8||se===9||se===11||se===12)||(V===11||V===9)&&(se===9||se===10)||(V===12||V===10)&&se===10||se===5||se===13||se===7||V===1||V===13&&se===14||V===6&&se===6)}e.breakBetweenGraphemeBreakType=Q;var ae;(function(V){V[V.Other=0]="Other",V[V.Prepend=1]="Prepend",V[V.CR=2]="CR",V[V.LF=3]="LF",V[V.Control=4]="Control",V[V.Extend=5]="Extend",V[V.Regional_Indicator=6]="Regional_Indicator",V[V.SpacingMark=7]="SpacingMark",V[V.L=8]="L",V[V.V=9]="V",V[V.T=10]="T",V[V.LV=11]="LV",V[V.LVT=12]="LVT",V[V.ZWJ=13]="ZWJ",V[V.Extended_Pictographic=14]="Extended_Pictographic"})(ae=e.GraphemeBreakType||(e.GraphemeBreakType={}));class oe{constructor(){this._data=pe()}static getInstance(){return oe._INSTANCE||(oe._INSTANCE=new oe),oe._INSTANCE}getGraphemeBreakType(se){if(se<32)return se===10?3:se===13?2:4;if(se<127)return 0;const le=this._data,he=le.length/3;let me=1;for(;me<=he;)if(se<le[3*me])me=2*me;else if(se>le[3*me+1])me=2*me+1;else return le[3*me+2];return 0}}oe._INSTANCE=null;function pe(){return JSON.parse("[0,0,0,51592,51592,11,44424,44424,11,72251,72254,5,7150,7150,7,48008,48008,11,55176,55176,11,128420,128420,14,3276,3277,5,9979,9980,14,46216,46216,11,49800,49800,11,53384,53384,11,70726,70726,5,122915,122916,5,129320,129327,14,2558,2558,5,5906,5908,5,9762,9763,14,43360,43388,8,45320,45320,11,47112,47112,11,48904,48904,11,50696,50696,11,52488,52488,11,54280,54280,11,70082,70083,1,71350,71350,7,73111,73111,5,127892,127893,14,128726,128727,14,129473,129474,14,2027,2035,5,2901,2902,5,3784,3789,5,6754,6754,5,8418,8420,5,9877,9877,14,11088,11088,14,44008,44008,5,44872,44872,11,45768,45768,11,46664,46664,11,47560,47560,11,48456,48456,11,49352,49352,11,50248,50248,11,51144,51144,11,52040,52040,11,52936,52936,11,53832,53832,11,54728,54728,11,69811,69814,5,70459,70460,5,71096,71099,7,71998,71998,5,72874,72880,5,119149,119149,7,127374,127374,14,128335,128335,14,128482,128482,14,128765,128767,14,129399,129400,14,129680,129685,14,1476,1477,5,2377,2380,7,2759,2760,5,3137,3140,7,3458,3459,7,4153,4154,5,6432,6434,5,6978,6978,5,7675,7679,5,9723,9726,14,9823,9823,14,9919,9923,14,10035,10036,14,42736,42737,5,43596,43596,5,44200,44200,11,44648,44648,11,45096,45096,11,45544,45544,11,45992,45992,11,46440,46440,11,46888,46888,11,47336,47336,11,47784,47784,11,48232,48232,11,48680,48680,11,49128,49128,11,49576,49576,11,50024,50024,11,50472,50472,11,50920,50920,11,51368,51368,11,51816,51816,11,52264,52264,11,52712,52712,11,53160,53160,11,53608,53608,11,54056,54056,11,54504,54504,11,54952,54952,11,68108,68111,5,69933,69940,5,70197,70197,7,70498,70499,7,70845,70845,5,71229,71229,5,71727,71735,5,72154,72155,5,72344,72345,5,73023,73029,5,94095,94098,5,121403,121452,5,126981,127182,14,127538,127546,14,127990,127990,14,128391,128391,14,128445,128449,14,128500,128505,14,128752,128752,14,129160,129167,14,129356,129356,14,129432,129442,14,129648,129651,14,129751,131069,14,173,173,4,1757,1757,1,2274,2274,1,2494,2494,5,2641,2641,5,2876,2876,5,3014,3016,7,3262,3262,7,3393,3396,5,3570,3571,7,3968,3972,5,4228,4228,7,6086,6086,5,6679,6680,5,6912,6915,5,7080,7081,5,7380,7392,5,8252,8252,14,9096,9096,14,9748,9749,14,9784,9786,14,9833,9850,14,9890,9894,14,9938,9938,14,9999,9999,14,10085,10087,14,12349,12349,14,43136,43137,7,43454,43456,7,43755,43755,7,44088,44088,11,44312,44312,11,44536,44536,11,44760,44760,11,44984,44984,11,45208,45208,11,45432,45432,11,45656,45656,11,45880,45880,11,46104,46104,11,46328,46328,11,46552,46552,11,46776,46776,11,47000,47000,11,47224,47224,11,47448,47448,11,47672,47672,11,47896,47896,11,48120,48120,11,48344,48344,11,48568,48568,11,48792,48792,11,49016,49016,11,49240,49240,11,49464,49464,11,49688,49688,11,49912,49912,11,50136,50136,11,50360,50360,11,50584,50584,11,50808,50808,11,51032,51032,11,51256,51256,11,51480,51480,11,51704,51704,11,51928,51928,11,52152,52152,11,52376,52376,11,52600,52600,11,52824,52824,11,53048,53048,11,53272,53272,11,53496,53496,11,53720,53720,11,53944,53944,11,54168,54168,11,54392,54392,11,54616,54616,11,54840,54840,11,55064,55064,11,65438,65439,5,69633,69633,5,69837,69837,1,70018,70018,7,70188,70190,7,70368,70370,7,70465,70468,7,70712,70719,5,70835,70840,5,70850,70851,5,71132,71133,5,71340,71340,7,71458,71461,5,71985,71989,7,72002,72002,7,72193,72202,5,72281,72283,5,72766,72766,7,72885,72886,5,73104,73105,5,92912,92916,5,113824,113827,4,119173,119179,5,121505,121519,5,125136,125142,5,127279,127279,14,127489,127490,14,127570,127743,14,127900,127901,14,128254,128254,14,128369,128370,14,128400,128400,14,128425,128432,14,128468,128475,14,128489,128494,14,128715,128720,14,128745,128745,14,128759,128760,14,129004,129023,14,129296,129304,14,129340,129342,14,129388,129392,14,129404,129407,14,129454,129455,14,129485,129487,14,129659,129663,14,129719,129727,14,917536,917631,5,13,13,2,1160,1161,5,1564,1564,4,1807,1807,1,2085,2087,5,2363,2363,7,2402,2403,5,2507,2508,7,2622,2624,7,2691,2691,7,2786,2787,5,2881,2884,5,3006,3006,5,3072,3072,5,3170,3171,5,3267,3268,7,3330,3331,7,3406,3406,1,3538,3540,5,3655,3662,5,3897,3897,5,4038,4038,5,4184,4185,5,4352,4447,8,6068,6069,5,6155,6157,5,6448,6449,7,6742,6742,5,6783,6783,5,6966,6970,5,7042,7042,7,7143,7143,7,7212,7219,5,7412,7412,5,8206,8207,4,8294,8303,4,8596,8601,14,9410,9410,14,9742,9742,14,9757,9757,14,9770,9770,14,9794,9794,14,9828,9828,14,9855,9855,14,9882,9882,14,9900,9903,14,9929,9933,14,9963,9967,14,9987,9988,14,10006,10006,14,10062,10062,14,10175,10175,14,11744,11775,5,42607,42607,5,43043,43044,7,43263,43263,5,43444,43445,7,43569,43570,5,43698,43700,5,43766,43766,5,44032,44032,11,44144,44144,11,44256,44256,11,44368,44368,11,44480,44480,11,44592,44592,11,44704,44704,11,44816,44816,11,44928,44928,11,45040,45040,11,45152,45152,11,45264,45264,11,45376,45376,11,45488,45488,11,45600,45600,11,45712,45712,11,45824,45824,11,45936,45936,11,46048,46048,11,46160,46160,11,46272,46272,11,46384,46384,11,46496,46496,11,46608,46608,11,46720,46720,11,46832,46832,11,46944,46944,11,47056,47056,11,47168,47168,11,47280,47280,11,47392,47392,11,47504,47504,11,47616,47616,11,47728,47728,11,47840,47840,11,47952,47952,11,48064,48064,11,48176,48176,11,48288,48288,11,48400,48400,11,48512,48512,11,48624,48624,11,48736,48736,11,48848,48848,11,48960,48960,11,49072,49072,11,49184,49184,11,49296,49296,11,49408,49408,11,49520,49520,11,49632,49632,11,49744,49744,11,49856,49856,11,49968,49968,11,50080,50080,11,50192,50192,11,50304,50304,11,50416,50416,11,50528,50528,11,50640,50640,11,50752,50752,11,50864,50864,11,50976,50976,11,51088,51088,11,51200,51200,11,51312,51312,11,51424,51424,11,51536,51536,11,51648,51648,11,51760,51760,11,51872,51872,11,51984,51984,11,52096,52096,11,52208,52208,11,52320,52320,11,52432,52432,11,52544,52544,11,52656,52656,11,52768,52768,11,52880,52880,11,52992,52992,11,53104,53104,11,53216,53216,11,53328,53328,11,53440,53440,11,53552,53552,11,53664,53664,11,53776,53776,11,53888,53888,11,54000,54000,11,54112,54112,11,54224,54224,11,54336,54336,11,54448,54448,11,54560,54560,11,54672,54672,11,54784,54784,11,54896,54896,11,55008,55008,11,55120,55120,11,64286,64286,5,66272,66272,5,68900,68903,5,69762,69762,7,69817,69818,5,69927,69931,5,70003,70003,5,70070,70078,5,70094,70094,7,70194,70195,7,70206,70206,5,70400,70401,5,70463,70463,7,70475,70477,7,70512,70516,5,70722,70724,5,70832,70832,5,70842,70842,5,70847,70848,5,71088,71089,7,71102,71102,7,71219,71226,5,71231,71232,5,71342,71343,7,71453,71455,5,71463,71467,5,71737,71738,5,71995,71996,5,72000,72000,7,72145,72147,7,72160,72160,5,72249,72249,7,72273,72278,5,72330,72342,5,72752,72758,5,72850,72871,5,72882,72883,5,73018,73018,5,73031,73031,5,73109,73109,5,73461,73462,7,94031,94031,5,94192,94193,7,119142,119142,7,119155,119162,4,119362,119364,5,121476,121476,5,122888,122904,5,123184,123190,5,126976,126979,14,127184,127231,14,127344,127345,14,127405,127461,14,127514,127514,14,127561,127567,14,127778,127779,14,127896,127896,14,127985,127986,14,127995,127999,5,128326,128328,14,128360,128366,14,128378,128378,14,128394,128397,14,128405,128406,14,128422,128423,14,128435,128443,14,128453,128464,14,128479,128480,14,128484,128487,14,128496,128498,14,128640,128709,14,128723,128724,14,128736,128741,14,128747,128748,14,128755,128755,14,128762,128762,14,128981,128991,14,129096,129103,14,129292,129292,14,129311,129311,14,129329,129330,14,129344,129349,14,129360,129374,14,129394,129394,14,129402,129402,14,129413,129425,14,129445,129450,14,129466,129471,14,129483,129483,14,129511,129535,14,129653,129655,14,129667,129670,14,129705,129711,14,129731,129743,14,917505,917505,4,917760,917999,5,10,10,3,127,159,4,768,879,5,1471,1471,5,1536,1541,1,1648,1648,5,1767,1768,5,1840,1866,5,2070,2073,5,2137,2139,5,2307,2307,7,2366,2368,7,2382,2383,7,2434,2435,7,2497,2500,5,2519,2519,5,2563,2563,7,2631,2632,5,2677,2677,5,2750,2752,7,2763,2764,7,2817,2817,5,2879,2879,5,2891,2892,7,2914,2915,5,3008,3008,5,3021,3021,5,3076,3076,5,3146,3149,5,3202,3203,7,3264,3265,7,3271,3272,7,3298,3299,5,3390,3390,5,3402,3404,7,3426,3427,5,3535,3535,5,3544,3550,7,3635,3635,7,3763,3763,7,3893,3893,5,3953,3966,5,3981,3991,5,4145,4145,7,4157,4158,5,4209,4212,5,4237,4237,5,4520,4607,10,5970,5971,5,6071,6077,5,6089,6099,5,6277,6278,5,6439,6440,5,6451,6456,7,6683,6683,5,6744,6750,5,6765,6770,7,6846,6846,5,6964,6964,5,6972,6972,5,7019,7027,5,7074,7077,5,7083,7085,5,7146,7148,7,7154,7155,7,7222,7223,5,7394,7400,5,7416,7417,5,8204,8204,5,8233,8233,4,8288,8292,4,8413,8416,5,8482,8482,14,8986,8987,14,9193,9203,14,9654,9654,14,9733,9733,14,9745,9745,14,9752,9752,14,9760,9760,14,9766,9766,14,9774,9775,14,9792,9792,14,9800,9811,14,9825,9826,14,9831,9831,14,9852,9853,14,9872,9873,14,9880,9880,14,9885,9887,14,9896,9897,14,9906,9916,14,9926,9927,14,9936,9936,14,9941,9960,14,9974,9974,14,9982,9985,14,9992,9997,14,10002,10002,14,10017,10017,14,10055,10055,14,10071,10071,14,10145,10145,14,11013,11015,14,11503,11505,5,12334,12335,5,12951,12951,14,42612,42621,5,43014,43014,5,43047,43047,7,43204,43205,5,43335,43345,5,43395,43395,7,43450,43451,7,43561,43566,5,43573,43574,5,43644,43644,5,43710,43711,5,43758,43759,7,44005,44005,5,44012,44012,7,44060,44060,11,44116,44116,11,44172,44172,11,44228,44228,11,44284,44284,11,44340,44340,11,44396,44396,11,44452,44452,11,44508,44508,11,44564,44564,11,44620,44620,11,44676,44676,11,44732,44732,11,44788,44788,11,44844,44844,11,44900,44900,11,44956,44956,11,45012,45012,11,45068,45068,11,45124,45124,11,45180,45180,11,45236,45236,11,45292,45292,11,45348,45348,11,45404,45404,11,45460,45460,11,45516,45516,11,45572,45572,11,45628,45628,11,45684,45684,11,45740,45740,11,45796,45796,11,45852,45852,11,45908,45908,11,45964,45964,11,46020,46020,11,46076,46076,11,46132,46132,11,46188,46188,11,46244,46244,11,46300,46300,11,46356,46356,11,46412,46412,11,46468,46468,11,46524,46524,11,46580,46580,11,46636,46636,11,46692,46692,11,46748,46748,11,46804,46804,11,46860,46860,11,46916,46916,11,46972,46972,11,47028,47028,11,47084,47084,11,47140,47140,11,47196,47196,11,47252,47252,11,47308,47308,11,47364,47364,11,47420,47420,11,47476,47476,11,47532,47532,11,47588,47588,11,47644,47644,11,47700,47700,11,47756,47756,11,47812,47812,11,47868,47868,11,47924,47924,11,47980,47980,11,48036,48036,11,48092,48092,11,48148,48148,11,48204,48204,11,48260,48260,11,48316,48316,11,48372,48372,11,48428,48428,11,48484,48484,11,48540,48540,11,48596,48596,11,48652,48652,11,48708,48708,11,48764,48764,11,48820,48820,11,48876,48876,11,48932,48932,11,48988,48988,11,49044,49044,11,49100,49100,11,49156,49156,11,49212,49212,11,49268,49268,11,49324,49324,11,49380,49380,11,49436,49436,11,49492,49492,11,49548,49548,11,49604,49604,11,49660,49660,11,49716,49716,11,49772,49772,11,49828,49828,11,49884,49884,11,49940,49940,11,49996,49996,11,50052,50052,11,50108,50108,11,50164,50164,11,50220,50220,11,50276,50276,11,50332,50332,11,50388,50388,11,50444,50444,11,50500,50500,11,50556,50556,11,50612,50612,11,50668,50668,11,50724,50724,11,50780,50780,11,50836,50836,11,50892,50892,11,50948,50948,11,51004,51004,11,51060,51060,11,51116,51116,11,51172,51172,11,51228,51228,11,51284,51284,11,51340,51340,11,51396,51396,11,51452,51452,11,51508,51508,11,51564,51564,11,51620,51620,11,51676,51676,11,51732,51732,11,51788,51788,11,51844,51844,11,51900,51900,11,51956,51956,11,52012,52012,11,52068,52068,11,52124,52124,11,52180,52180,11,52236,52236,11,52292,52292,11,52348,52348,11,52404,52404,11,52460,52460,11,52516,52516,11,52572,52572,11,52628,52628,11,52684,52684,11,52740,52740,11,52796,52796,11,52852,52852,11,52908,52908,11,52964,52964,11,53020,53020,11,53076,53076,11,53132,53132,11,53188,53188,11,53244,53244,11,53300,53300,11,53356,53356,11,53412,53412,11,53468,53468,11,53524,53524,11,53580,53580,11,53636,53636,11,53692,53692,11,53748,53748,11,53804,53804,11,53860,53860,11,53916,53916,11,53972,53972,11,54028,54028,11,54084,54084,11,54140,54140,11,54196,54196,11,54252,54252,11,54308,54308,11,54364,54364,11,54420,54420,11,54476,54476,11,54532,54532,11,54588,54588,11,54644,54644,11,54700,54700,11,54756,54756,11,54812,54812,11,54868,54868,11,54924,54924,11,54980,54980,11,55036,55036,11,55092,55092,11,55148,55148,11,55216,55238,9,65056,65071,5,65529,65531,4,68097,68099,5,68159,68159,5,69446,69456,5,69688,69702,5,69808,69810,7,69815,69816,7,69821,69821,1,69888,69890,5,69932,69932,7,69957,69958,7,70016,70017,5,70067,70069,7,70079,70080,7,70089,70092,5,70095,70095,5,70191,70193,5,70196,70196,5,70198,70199,5,70367,70367,5,70371,70378,5,70402,70403,7,70462,70462,5,70464,70464,5,70471,70472,7,70487,70487,5,70502,70508,5,70709,70711,7,70720,70721,7,70725,70725,7,70750,70750,5,70833,70834,7,70841,70841,7,70843,70844,7,70846,70846,7,70849,70849,7,71087,71087,5,71090,71093,5,71100,71101,5,71103,71104,5,71216,71218,7,71227,71228,7,71230,71230,7,71339,71339,5,71341,71341,5,71344,71349,5,71351,71351,5,71456,71457,7,71462,71462,7,71724,71726,7,71736,71736,7,71984,71984,5,71991,71992,7,71997,71997,7,71999,71999,1,72001,72001,1,72003,72003,5,72148,72151,5,72156,72159,7,72164,72164,7,72243,72248,5,72250,72250,1,72263,72263,5,72279,72280,7,72324,72329,1,72343,72343,7,72751,72751,7,72760,72765,5,72767,72767,5,72873,72873,7,72881,72881,7,72884,72884,7,73009,73014,5,73020,73021,5,73030,73030,1,73098,73102,7,73107,73108,7,73110,73110,7,73459,73460,5,78896,78904,4,92976,92982,5,94033,94087,7,94180,94180,5,113821,113822,5,119141,119141,5,119143,119145,5,119150,119154,5,119163,119170,5,119210,119213,5,121344,121398,5,121461,121461,5,121499,121503,5,122880,122886,5,122907,122913,5,122918,122922,5,123628,123631,5,125252,125258,5,126980,126980,14,127183,127183,14,127245,127247,14,127340,127343,14,127358,127359,14,127377,127386,14,127462,127487,6,127491,127503,14,127535,127535,14,127548,127551,14,127568,127569,14,127744,127777,14,127780,127891,14,127894,127895,14,127897,127899,14,127902,127984,14,127987,127989,14,127991,127994,14,128000,128253,14,128255,128317,14,128329,128334,14,128336,128359,14,128367,128368,14,128371,128377,14,128379,128390,14,128392,128393,14,128398,128399,14,128401,128404,14,128407,128419,14,128421,128421,14,128424,128424,14,128433,128434,14,128444,128444,14,128450,128452,14,128465,128467,14,128476,128478,14,128481,128481,14,128483,128483,14,128488,128488,14,128495,128495,14,128499,128499,14,128506,128591,14,128710,128714,14,128721,128722,14,128725,128725,14,128728,128735,14,128742,128744,14,128746,128746,14,128749,128751,14,128753,128754,14,128756,128758,14,128761,128761,14,128763,128764,14,128884,128895,14,128992,129003,14,129036,129039,14,129114,129119,14,129198,129279,14,129293,129295,14,129305,129310,14,129312,129319,14,129328,129328,14,129331,129338,14,129343,129343,14,129351,129355,14,129357,129359,14,129375,129387,14,129393,129393,14,129395,129398,14,129401,129401,14,129403,129403,14,129408,129412,14,129426,129431,14,129443,129444,14,129451,129453,14,129456,129465,14,129472,129472,14,129475,129482,14,129484,129484,14,129488,129510,14,129536,129647,14,129652,129652,14,129656,129658,14,129664,129666,14,129671,129679,14,129686,129704,14,129712,129718,14,129728,129730,14,129744,129750,14,917504,917504,4,917506,917535,4,917632,917759,4,918000,921599,4,0,9,4,11,12,4,14,31,4,169,169,14,174,174,14,1155,1159,5,1425,1469,5,1473,1474,5,1479,1479,5,1552,1562,5,1611,1631,5,1750,1756,5,1759,1764,5,1770,1773,5,1809,1809,5,1958,1968,5,2045,2045,5,2075,2083,5,2089,2093,5,2259,2273,5,2275,2306,5,2362,2362,5,2364,2364,5,2369,2376,5,2381,2381,5,2385,2391,5,2433,2433,5,2492,2492,5,2495,2496,7,2503,2504,7,2509,2509,5,2530,2531,5,2561,2562,5,2620,2620,5,2625,2626,5,2635,2637,5,2672,2673,5,2689,2690,5,2748,2748,5,2753,2757,5,2761,2761,7,2765,2765,5,2810,2815,5,2818,2819,7,2878,2878,5,2880,2880,7,2887,2888,7,2893,2893,5,2903,2903,5,2946,2946,5,3007,3007,7,3009,3010,7,3018,3020,7,3031,3031,5,3073,3075,7,3134,3136,5,3142,3144,5,3157,3158,5,3201,3201,5,3260,3260,5,3263,3263,5,3266,3266,5,3270,3270,5,3274,3275,7,3285,3286,5,3328,3329,5,3387,3388,5,3391,3392,7,3398,3400,7,3405,3405,5,3415,3415,5,3457,3457,5,3530,3530,5,3536,3537,7,3542,3542,5,3551,3551,5,3633,3633,5,3636,3642,5,3761,3761,5,3764,3772,5,3864,3865,5,3895,3895,5,3902,3903,7,3967,3967,7,3974,3975,5,3993,4028,5,4141,4144,5,4146,4151,5,4155,4156,7,4182,4183,7,4190,4192,5,4226,4226,5,4229,4230,5,4253,4253,5,4448,4519,9,4957,4959,5,5938,5940,5,6002,6003,5,6070,6070,7,6078,6085,7,6087,6088,7,6109,6109,5,6158,6158,4,6313,6313,5,6435,6438,7,6441,6443,7,6450,6450,5,6457,6459,5,6681,6682,7,6741,6741,7,6743,6743,7,6752,6752,5,6757,6764,5,6771,6780,5,6832,6845,5,6847,6848,5,6916,6916,7,6965,6965,5,6971,6971,7,6973,6977,7,6979,6980,7,7040,7041,5,7073,7073,7,7078,7079,7,7082,7082,7,7142,7142,5,7144,7145,5,7149,7149,5,7151,7153,5,7204,7211,7,7220,7221,7,7376,7378,5,7393,7393,7,7405,7405,5,7415,7415,7,7616,7673,5,8203,8203,4,8205,8205,13,8232,8232,4,8234,8238,4,8265,8265,14,8293,8293,4,8400,8412,5,8417,8417,5,8421,8432,5,8505,8505,14,8617,8618,14,9000,9000,14,9167,9167,14,9208,9210,14,9642,9643,14,9664,9664,14,9728,9732,14,9735,9741,14,9743,9744,14,9746,9746,14,9750,9751,14,9753,9756,14,9758,9759,14,9761,9761,14,9764,9765,14,9767,9769,14,9771,9773,14,9776,9783,14,9787,9791,14,9793,9793,14,9795,9799,14,9812,9822,14,9824,9824,14,9827,9827,14,9829,9830,14,9832,9832,14,9851,9851,14,9854,9854,14,9856,9861,14,9874,9876,14,9878,9879,14,9881,9881,14,9883,9884,14,9888,9889,14,9895,9895,14,9898,9899,14,9904,9905,14,9917,9918,14,9924,9925,14,9928,9928,14,9934,9935,14,9937,9937,14,9939,9940,14,9961,9962,14,9968,9973,14,9975,9978,14,9981,9981,14,9986,9986,14,9989,9989,14,9998,9998,14,10000,10001,14,10004,10004,14,10013,10013,14,10024,10024,14,10052,10052,14,10060,10060,14,10067,10069,14,10083,10084,14,10133,10135,14,10160,10160,14,10548,10549,14,11035,11036,14,11093,11093,14,11647,11647,5,12330,12333,5,12336,12336,14,12441,12442,5,12953,12953,14,42608,42610,5,42654,42655,5,43010,43010,5,43019,43019,5,43045,43046,5,43052,43052,5,43188,43203,7,43232,43249,5,43302,43309,5,43346,43347,7,43392,43394,5,43443,43443,5,43446,43449,5,43452,43453,5,43493,43493,5,43567,43568,7,43571,43572,7,43587,43587,5,43597,43597,7,43696,43696,5,43703,43704,5,43713,43713,5,43756,43757,5,43765,43765,7,44003,44004,7,44006,44007,7,44009,44010,7,44013,44013,5,44033,44059,12,44061,44087,12,44089,44115,12,44117,44143,12,44145,44171,12,44173,44199,12,44201,44227,12,44229,44255,12,44257,44283,12,44285,44311,12,44313,44339,12,44341,44367,12,44369,44395,12,44397,44423,12,44425,44451,12,44453,44479,12,44481,44507,12,44509,44535,12,44537,44563,12,44565,44591,12,44593,44619,12,44621,44647,12,44649,44675,12,44677,44703,12,44705,44731,12,44733,44759,12,44761,44787,12,44789,44815,12,44817,44843,12,44845,44871,12,44873,44899,12,44901,44927,12,44929,44955,12,44957,44983,12,44985,45011,12,45013,45039,12,45041,45067,12,45069,45095,12,45097,45123,12,45125,45151,12,45153,45179,12,45181,45207,12,45209,45235,12,45237,45263,12,45265,45291,12,45293,45319,12,45321,45347,12,45349,45375,12,45377,45403,12,45405,45431,12,45433,45459,12,45461,45487,12,45489,45515,12,45517,45543,12,45545,45571,12,45573,45599,12,45601,45627,12,45629,45655,12,45657,45683,12,45685,45711,12,45713,45739,12,45741,45767,12,45769,45795,12,45797,45823,12,45825,45851,12,45853,45879,12,45881,45907,12,45909,45935,12,45937,45963,12,45965,45991,12,45993,46019,12,46021,46047,12,46049,46075,12,46077,46103,12,46105,46131,12,46133,46159,12,46161,46187,12,46189,46215,12,46217,46243,12,46245,46271,12,46273,46299,12,46301,46327,12,46329,46355,12,46357,46383,12,46385,46411,12,46413,46439,12,46441,46467,12,46469,46495,12,46497,46523,12,46525,46551,12,46553,46579,12,46581,46607,12,46609,46635,12,46637,46663,12,46665,46691,12,46693,46719,12,46721,46747,12,46749,46775,12,46777,46803,12,46805,46831,12,46833,46859,12,46861,46887,12,46889,46915,12,46917,46943,12,46945,46971,12,46973,46999,12,47001,47027,12,47029,47055,12,47057,47083,12,47085,47111,12,47113,47139,12,47141,47167,12,47169,47195,12,47197,47223,12,47225,47251,12,47253,47279,12,47281,47307,12,47309,47335,12,47337,47363,12,47365,47391,12,47393,47419,12,47421,47447,12,47449,47475,12,47477,47503,12,47505,47531,12,47533,47559,12,47561,47587,12,47589,47615,12,47617,47643,12,47645,47671,12,47673,47699,12,47701,47727,12,47729,47755,12,47757,47783,12,47785,47811,12,47813,47839,12,47841,47867,12,47869,47895,12,47897,47923,12,47925,47951,12,47953,47979,12,47981,48007,12,48009,48035,12,48037,48063,12,48065,48091,12,48093,48119,12,48121,48147,12,48149,48175,12,48177,48203,12,48205,48231,12,48233,48259,12,48261,48287,12,48289,48315,12,48317,48343,12,48345,48371,12,48373,48399,12,48401,48427,12,48429,48455,12,48457,48483,12,48485,48511,12,48513,48539,12,48541,48567,12,48569,48595,12,48597,48623,12,48625,48651,12,48653,48679,12,48681,48707,12,48709,48735,12,48737,48763,12,48765,48791,12,48793,48819,12,48821,48847,12,48849,48875,12,48877,48903,12,48905,48931,12,48933,48959,12,48961,48987,12,48989,49015,12,49017,49043,12,49045,49071,12,49073,49099,12,49101,49127,12,49129,49155,12,49157,49183,12,49185,49211,12,49213,49239,12,49241,49267,12,49269,49295,12,49297,49323,12,49325,49351,12,49353,49379,12,49381,49407,12,49409,49435,12,49437,49463,12,49465,49491,12,49493,49519,12,49521,49547,12,49549,49575,12,49577,49603,12,49605,49631,12,49633,49659,12,49661,49687,12,49689,49715,12,49717,49743,12,49745,49771,12,49773,49799,12,49801,49827,12,49829,49855,12,49857,49883,12,49885,49911,12,49913,49939,12,49941,49967,12,49969,49995,12,49997,50023,12,50025,50051,12,50053,50079,12,50081,50107,12,50109,50135,12,50137,50163,12,50165,50191,12,50193,50219,12,50221,50247,12,50249,50275,12,50277,50303,12,50305,50331,12,50333,50359,12,50361,50387,12,50389,50415,12,50417,50443,12,50445,50471,12,50473,50499,12,50501,50527,12,50529,50555,12,50557,50583,12,50585,50611,12,50613,50639,12,50641,50667,12,50669,50695,12,50697,50723,12,50725,50751,12,50753,50779,12,50781,50807,12,50809,50835,12,50837,50863,12,50865,50891,12,50893,50919,12,50921,50947,12,50949,50975,12,50977,51003,12,51005,51031,12,51033,51059,12,51061,51087,12,51089,51115,12,51117,51143,12,51145,51171,12,51173,51199,12,51201,51227,12,51229,51255,12,51257,51283,12,51285,51311,12,51313,51339,12,51341,51367,12,51369,51395,12,51397,51423,12,51425,51451,12,51453,51479,12,51481,51507,12,51509,51535,12,51537,51563,12,51565,51591,12,51593,51619,12,51621,51647,12,51649,51675,12,51677,51703,12,51705,51731,12,51733,51759,12,51761,51787,12,51789,51815,12,51817,51843,12,51845,51871,12,51873,51899,12,51901,51927,12,51929,51955,12,51957,51983,12,51985,52011,12,52013,52039,12,52041,52067,12,52069,52095,12,52097,52123,12,52125,52151,12,52153,52179,12,52181,52207,12,52209,52235,12,52237,52263,12,52265,52291,12,52293,52319,12,52321,52347,12,52349,52375,12,52377,52403,12,52405,52431,12,52433,52459,12,52461,52487,12,52489,52515,12,52517,52543,12,52545,52571,12,52573,52599,12,52601,52627,12,52629,52655,12,52657,52683,12,52685,52711,12,52713,52739,12,52741,52767,12,52769,52795,12,52797,52823,12,52825,52851,12,52853,52879,12,52881,52907,12,52909,52935,12,52937,52963,12,52965,52991,12,52993,53019,12,53021,53047,12,53049,53075,12,53077,53103,12,53105,53131,12,53133,53159,12,53161,53187,12,53189,53215,12,53217,53243,12,53245,53271,12,53273,53299,12,53301,53327,12,53329,53355,12,53357,53383,12,53385,53411,12,53413,53439,12,53441,53467,12,53469,53495,12,53497,53523,12,53525,53551,12,53553,53579,12,53581,53607,12,53609,53635,12,53637,53663,12,53665,53691,12,53693,53719,12,53721,53747,12,53749,53775,12,53777,53803,12,53805,53831,12,53833,53859,12,53861,53887,12,53889,53915,12,53917,53943,12,53945,53971,12,53973,53999,12,54001,54027,12,54029,54055,12,54057,54083,12,54085,54111,12,54113,54139,12,54141,54167,12,54169,54195,12,54197,54223,12,54225,54251,12,54253,54279,12,54281,54307,12,54309,54335,12,54337,54363,12,54365,54391,12,54393,54419,12,54421,54447,12,54449,54475,12,54477,54503,12,54505,54531,12,54533,54559,12,54561,54587,12,54589,54615,12,54617,54643,12,54645,54671,12,54673,54699,12,54701,54727,12,54729,54755,12,54757,54783,12,54785,54811,12,54813,54839,12,54841,54867,12,54869,54895,12,54897,54923,12,54925,54951,12,54953,54979,12,54981,55007,12,55009,55035,12,55037,55063,12,55065,55091,12,55093,55119,12,55121,55147,12,55149,55175,12,55177,55203,12,55243,55291,10,65024,65039,5,65279,65279,4,65520,65528,4,66045,66045,5,66422,66426,5,68101,68102,5,68152,68154,5,68325,68326,5,69291,69292,5,69632,69632,7,69634,69634,7,69759,69761,5]")}function Se(V,se){if(V===0)return 0;const le=Fe(V,se);if(le!==void 0)return le;const he=q(se,V);return V-=Le(he),V}e.getLeftDeleteOffset=Se;function Fe(V,se){let le=q(se,V);for(V-=Le(le);Me(le)||le===65039||le===8419;){if(V===0)return;le=q(se,V),V-=Le(le)}if(!!ce(le)){if(V>=0){const he=q(se,V);he===8205&&(V-=Le(he))}return V}}function Le(V){return V>=65536?2:1}function Me(V){return 127995<=V&&V<=127999}var Ae;(function(V){V[V.zwj=8205]="zwj",V[V.emojiVariantSelector=65039]="emojiVariantSelector",V[V.enclosingKeyCap=8419]="enclosingKeyCap"})(Ae||(Ae={}))}),define(Z[18],te([0,1]),function(K,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.isPromise=e.assertNever=e.NotImplementedProxy=e.withUndefinedAsNull=e.withNullAsUndefined=e.createProxyObject=e.getAllMethodNames=e.getAllPropertyNames=e.validateConstraint=e.validateConstraints=e.areFunctions=e.isFunction=e.isEmptyObject=e.assertAllDefined=e.assertIsDefined=e.assertType=e.isUndefinedOrNull=e.isDefined=e.isUndefined=e.isBoolean=e.isIterable=e.isNumber=e.isObject=e.isStringArray=e.isString=e.isArray=void 0;function D(d){return Array.isArray(d)}e.isArray=D;function L(d){return typeof d=="string"}e.isString=L;function R(d){return Array.isArray(d)&&d.every(v=>L(v))}e.isStringArray=R;function T(d){return typeof d=="object"&&d!==null&&!Array.isArray(d)&&!(d instanceof RegExp)&&!(d instanceof Date)}e.isObject=T;function k(d){return typeof d=="number"&&!isNaN(d)}e.isNumber=k;function P(d){return!!d&&typeof d[Symbol.iterator]=="function"}e.isIterable=P;function m(d){return d===!0||d===!1}e.isBoolean=m;function b(d){return typeof d=="undefined"}e.isUndefined=b;function i(d){return!C(d)}e.isDefined=i;function C(d){return b(d)||d===null}e.isUndefinedOrNull=C;function g(d,v){if(!d)throw new Error(v?`Unexpected type, expected '${v}'`:"Unexpected type")}e.assertType=g;function w(d){if(C(d))throw new Error("Assertion Failed: argument is undefined or null");return d}e.assertIsDefined=w;function u(...d){const v=[];for(let A=0;A<d.length;A++){const O=d[A];if(C(O))throw new Error(`Assertion Failed: argument at index ${A} is undefined or null`);v.push(O)}return v}e.assertAllDefined=u;const S=Object.prototype.hasOwnProperty;function f(d){if(!T(d))return!1;for(let v in d)if(S.call(d,v))return!1;return!0}e.isEmptyObject=f;function I(d){return typeof d=="function"}e.isFunction=I;function y(...d){return d.length>0&&d.every(I)}e.areFunctions=y;function E(d,v){const A=Math.min(d.length,v.length);for(let O=0;O<A;O++)o(d[O],v[O])}e.validateConstraints=E;function o(d,v){if(L(v)){if(typeof d!==v)throw new Error(`argument does not match constraint: typeof ${v}`)}else if(I(v)){try{if(d instanceof v)return}catch{}if(!C(d)&&d.constructor===v||v.length===1&&v.call(void 0,d)===!0)return;throw new Error("argument does not match one of these constraints: arg instanceof constraint, arg.constructor === constraint, nor constraint(arg) === true")}}e.validateConstraint=o;function a(d){let v=[],A=Object.getPrototypeOf(d);for(;Object.prototype!==A;)v=v.concat(Object.getOwnPropertyNames(A)),A=Object.getPrototypeOf(A);return v}e.getAllPropertyNames=a;function t(d){const v=[];for(const A of a(d))typeof d[A]=="function"&&v.push(A);return v}e.getAllMethodNames=t;function r(d,v){const A=p=>function(){const U=Array.prototype.slice.call(arguments,0);return v(p,U)};let O={};for(const p of d)O[p]=A(p);return O}e.createProxyObject=r;function n(d){return d===null?void 0:d}e.withNullAsUndefined=n;function s(d){return typeof d=="undefined"?null:d}e.withUndefinedAsNull=s;function c(d){return class{constructor(){return new Proxy({},{get(v,A){if(v[A])return v[A];throw new Error(`Not Implemented: ${d}->${String(A)}`)}})}}}e.NotImplementedProxy=c;function l(d,v="Unreachable"){throw new Error(v)}e.assertNever=l;function h(d){return!!d&&typeof d.then=="function"&&typeof d.catch=="function"}e.isPromise=h}),define(Z[40],te([0,1,8,4,24,18]),function(K,e,D,L,R,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.parseLineAndColumnAware=e.indexOfPath=e.getDriveLetter=e.hasDriveLetter=e.isRootOrDriveLetter=e.sanitizeFilePath=e.isWindowsDriveLetter=e.isEqualOrParent=e.isEqual=e.isValidBasename=e.isUNC=e.getRoot=e.toPosixPath=e.toSlashes=e.isPathSeparator=void 0;function k(n){return n===47||n===92}e.isPathSeparator=k;function P(n){return n.replace(/[\\/]/g,D.posix.sep)}e.toSlashes=P;function m(n){return n.indexOf("/")===-1&&(n=P(n)),/^[a-zA-Z]:(\/|$)/.test(n)&&(n="/"+n),n}e.toPosixPath=m;function b(n,s=D.posix.sep){if(!n)return"";const c=n.length,l=n.charCodeAt(0);if(k(l)){if(k(n.charCodeAt(1))&&!k(n.charCodeAt(2))){let d=3;const v=d;for(;d<c&&!k(n.charCodeAt(d));d++);if(v!==d&&!k(n.charCodeAt(d+1))){for(d+=1;d<c;d++)if(k(n.charCodeAt(d)))return n.slice(0,d+1).replace(/[\\/]/g,s)}}return s}else if(I(l)&&n.charCodeAt(1)===58)return k(n.charCodeAt(2))?n.slice(0,2)+s:n.slice(0,2);let h=n.indexOf("://");if(h!==-1){for(h+=3;h<c;h++)if(k(n.charCodeAt(h)))return n.slice(0,h+1)}return""}e.getRoot=b;function i(n){if(!L.isWindows||!n||n.length<5)return!1;let s=n.charCodeAt(0);if(s!==92||(s=n.charCodeAt(1),s!==92))return!1;let c=2;const l=c;for(;c<n.length&&(s=n.charCodeAt(c),s!==92);c++);return!(l===c||(s=n.charCodeAt(c+1),isNaN(s)||s===92))}e.isUNC=i;const C=/[\\/:\*\?"<>\|]/g,g=/[\\/]/g,w=/^(con|prn|aux|clock\$|nul|lpt[0-9]|com[0-9])(\.(.*?))?$/i;function u(n,s=L.isWindows){const c=s?C:g;return!(!n||n.length===0||/^\s+$/.test(n)||(c.lastIndex=0,c.test(n))||s&&w.test(n)||n==="."||n===".."||s&&n[n.length-1]==="."||s&&n.length!==n.trim().length||n.length>255)}e.isValidBasename=u;function S(n,s,c){const l=n===s;return!c||l?l:!n||!s?!1:(0,R.equalsIgnoreCase)(n,s)}e.isEqual=S;function f(n,s,c,l=D.sep){if(n===s)return!0;if(!n||!s||s.length>n.length)return!1;if(c){if(!(0,R.startsWithIgnoreCase)(n,s))return!1;if(s.length===n.length)return!0;let d=s.length;return s.charAt(s.length-1)===l&&d--,n.charAt(d)===l}return s.charAt(s.length-1)!==l&&(s+=l),n.indexOf(s)===0}e.isEqualOrParent=f;function I(n){return n>=65&&n<=90||n>=97&&n<=122}e.isWindowsDriveLetter=I;function y(n,s){return L.isWindows&&n.endsWith(":")&&(n+=D.sep),(0,D.isAbsolute)(n)||(n=(0,D.join)(s,n)),n=(0,D.normalize)(n),L.isWindows?(n=(0,R.rtrim)(n,D.sep),n.endsWith(":")&&(n+=D.sep)):(n=(0,R.rtrim)(n,D.sep),n||(n=D.sep)),n}e.sanitizeFilePath=y;function E(n){const s=(0,D.normalize)(n);return L.isWindows?n.length>3?!1:o(s)&&(n.length===2||s.charCodeAt(2)===92):s===D.posix.sep}e.isRootOrDriveLetter=E;function o(n){return L.isWindows?I(n.charCodeAt(0))&&n.charCodeAt(1)===58:!1}e.hasDriveLetter=o;function a(n){return o(n)?n[0]:void 0}e.getDriveLetter=a;function t(n,s,c){return s.length>n.length?-1:n===s?0:(c&&(n=n.toLowerCase(),s=s.toLowerCase()),n.indexOf(s))}e.indexOfPath=t;function r(n){const s=n.split(":");let c,l,h;if(s.forEach(d=>{const v=Number(d);(0,T.isNumber)(v)?l===void 0?l=v:h===void 0&&(h=v):c=c?[c,d].join(":"):d}),!c)throw new Error("Format for `--goto` should be: `FILE:LINE(:COLUMN)`");return{path:c,line:l!==void 0?l:void 0,column:h!==void 0?h:l!==void 0?1:void 0}}e.parseLineAndColumnAware=r}),define(Z[26],te([0,1,18]),function(K,e,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.filter=e.getCaseInsensitive=e.distinct=e.getOrDefault=e.safeStringify=e.equals=e.mixin=e.cloneAndChange=e.deepFreeze=e.deepClone=void 0;function L(S){if(!S||typeof S!="object"||S instanceof RegExp)return S;const f=Array.isArray(S)?[]:{};return Object.keys(S).forEach(I=>{S[I]&&typeof S[I]=="object"?f[I]=L(S[I]):f[I]=S[I]}),f}e.deepClone=L;function R(S){if(!S||typeof S!="object")return S;const f=[S];for(;f.length>0;){const I=f.shift();Object.freeze(I);for(const y in I)if(T.call(I,y)){const E=I[y];typeof E=="object"&&!Object.isFrozen(E)&&f.push(E)}}return S}e.deepFreeze=R;const T=Object.prototype.hasOwnProperty;function k(S,f){return P(S,f,new Set)}e.cloneAndChange=k;function P(S,f,I){if((0,D.isUndefinedOrNull)(S))return S;const y=f(S);if(typeof y!="undefined")return y;if((0,D.isArray)(S)){const E=[];for(const o of S)E.push(P(o,f,I));return E}if((0,D.isObject)(S)){if(I.has(S))throw new Error("Cannot clone recursive data-structure");I.add(S);const E={};for(let o in S)T.call(S,o)&&(E[o]=P(S[o],f,I));return I.delete(S),E}return S}function m(S,f,I=!0){return(0,D.isObject)(S)?((0,D.isObject)(f)&&Object.keys(f).forEach(y=>{y in S?I&&((0,D.isObject)(S[y])&&(0,D.isObject)(f[y])?m(S[y],f[y],I):S[y]=f[y]):S[y]=f[y]}),S):f}e.mixin=m;function b(S,f){if(S===f)return!0;if(S==null||f===null||f===void 0||typeof S!=typeof f||typeof S!="object"||Array.isArray(S)!==Array.isArray(f))return!1;let I,y;if(Array.isArray(S)){if(S.length!==f.length)return!1;for(I=0;I<S.length;I++)if(!b(S[I],f[I]))return!1}else{const E=[];for(y in S)E.push(y);E.sort();const o=[];for(y in f)o.push(y);if(o.sort(),!b(E,o))return!1;for(I=0;I<E.length;I++)if(!b(S[E[I]],f[E[I]]))return!1}return!0}e.equals=b;function i(S){const f=new Set;return JSON.stringify(S,(I,y)=>{if((0,D.isObject)(y)||Array.isArray(y)){if(f.has(y))return"[Circular]";f.add(y)}return y})}e.safeStringify=i;function C(S,f,I){const y=f(S);return typeof y=="undefined"?I:y}e.getOrDefault=C;function g(S,f){const I=Object.create(null);return!S||!f||Object.keys(f).forEach(E=>{const o=S[E],a=f[E];b(o,a)||(I[E]=a)}),I}e.distinct=g;function w(S,f){const I=f.toLowerCase(),y=Object.keys(S).find(E=>E.toLowerCase()===I);return y?S[y]:S[f]}e.getCaseInsensitive=w;function u(S,f){const I=Object.create(null);for(const y of Object.keys(S))f(y,S[y])&&(I[y]=S[y]);return I}e.filter=u}),define(Z[5],te([0,1,8,4]),function(K,e,D,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.uriToFsPath=e.URI=void 0;const R=/^\w[\w\d+.-]*$/,T=/^\//,k=/^\/\//;function P(n,s){if(!n.scheme&&s)throw new Error(`[UriError]: Scheme is missing: {scheme: "", authority: "${n.authority}", path: "${n.path}", query: "${n.query}", fragment: "${n.fragment}"}`);if(n.scheme&&!R.test(n.scheme))throw new Error("[UriError]: Scheme contains illegal characters.");if(n.path){if(n.authority){if(!T.test(n.path))throw new Error('[UriError]: If a URI contains an authority component, then the path component must either be empty or begin with a slash ("/") character')}else if(k.test(n.path))throw new Error('[UriError]: If a URI does not contain an authority component, then the path cannot begin with two slash characters ("//")')}}function m(n,s){return!n&&!s?"file":n}function b(n,s){switch(n){case"https":case"http":case"file":s?s[0]!==C&&(s=C+s):s=C;break}return s}const i="",C="/",g=/^(([^:/?#]+?):)?(\/\/([^/?#]*))?([^?#]*)(\?([^#]*))?(#(.*))?/;class w{constructor(s,c,l,h,d,v=!1){typeof s=="object"?(this.scheme=s.scheme||i,this.authority=s.authority||i,this.path=s.path||i,this.query=s.query||i,this.fragment=s.fragment||i):(this.scheme=m(s,v),this.authority=c||i,this.path=b(this.scheme,l||i),this.query=h||i,this.fragment=d||i,P(this,v))}static isUri(s){return s instanceof w?!0:s?typeof s.authority=="string"&&typeof s.fragment=="string"&&typeof s.path=="string"&&typeof s.query=="string"&&typeof s.scheme=="string"&&typeof s.fsPath=="string"&&typeof s.with=="function"&&typeof s.toString=="function":!1}get fsPath(){return E(this,!1)}with(s){if(!s)return this;let{scheme:c,authority:l,path:h,query:d,fragment:v}=s;return c===void 0?c=this.scheme:c===null&&(c=i),l===void 0?l=this.authority:l===null&&(l=i),h===void 0?h=this.path:h===null&&(h=i),d===void 0?d=this.query:d===null&&(d=i),v===void 0?v=this.fragment:v===null&&(v=i),c===this.scheme&&l===this.authority&&h===this.path&&d===this.query&&v===this.fragment?this:new S(c,l,h,d,v)}static parse(s,c=!1){const l=g.exec(s);return l?new S(l[2]||i,r(l[4]||i),r(l[5]||i),r(l[7]||i),r(l[9]||i),c):new S(i,i,i,i,i)}static file(s){let c=i;if(L.isWindows&&(s=s.replace(/\\/g,C)),s[0]===C&&s[1]===C){const l=s.indexOf(C,2);l===-1?(c=s.substring(2),s=C):(c=s.substring(2,l),s=s.substring(l)||C)}return new S("file",c,s,i,i)}static from(s){const c=new S(s.scheme,s.authority,s.path,s.query,s.fragment);return P(c,!0),c}static joinPath(s,...c){if(!s.path)throw new Error("[UriError]: cannot call joinPath on URI without path");let l;return L.isWindows&&s.scheme==="file"?l=w.file(D.win32.join(E(s,!0),...c)).path:l=D.posix.join(s.path,...c),s.with({path:l})}toString(s=!1){return o(this,s)}toJSON(){return this}static revive(s){if(s){if(s instanceof w)return s;{const c=new S(s);return c._formatted=s.external,c._fsPath=s._sep===u?s.fsPath:null,c}}else return s}}e.URI=w;const u=L.isWindows?1:void 0;class S extends w{constructor(){super(...arguments);this._formatted=null,this._fsPath=null}get fsPath(){return this._fsPath||(this._fsPath=E(this,!1)),this._fsPath}toString(s=!1){return s?o(this,!0):(this._formatted||(this._formatted=o(this,!1)),this._formatted)}toJSON(){const s={$mid:1};return this._fsPath&&(s.fsPath=this._fsPath,s._sep=u),this._formatted&&(s.external=this._formatted),this.path&&(s.path=this.path),this.scheme&&(s.scheme=this.scheme),this.authority&&(s.authority=this.authority),this.query&&(s.query=this.query),this.fragment&&(s.fragment=this.fragment),s}}const f={[58]:"%3A",[47]:"%2F",[63]:"%3F",[35]:"%23",[91]:"%5B",[93]:"%5D",[64]:"%40",[33]:"%21",[36]:"%24",[38]:"%26",[39]:"%27",[40]:"%28",[41]:"%29",[42]:"%2A",[43]:"%2B",[44]:"%2C",[59]:"%3B",[61]:"%3D",[32]:"%20"};function I(n,s){let c,l=-1;for(let h=0;h<n.length;h++){const d=n.charCodeAt(h);if(d>=97&&d<=122||d>=65&&d<=90||d>=48&&d<=57||d===45||d===46||d===95||d===126||s&&d===47)l!==-1&&(c+=encodeURIComponent(n.substring(l,h)),l=-1),c!==void 0&&(c+=n.charAt(h));else{c===void 0&&(c=n.substr(0,h));const v=f[d];v!==void 0?(l!==-1&&(c+=encodeURIComponent(n.substring(l,h)),l=-1),c+=v):l===-1&&(l=h)}}return l!==-1&&(c+=encodeURIComponent(n.substring(l))),c!==void 0?c:n}function y(n){let s;for(let c=0;c<n.length;c++){const l=n.charCodeAt(c);l===35||l===63?(s===void 0&&(s=n.substr(0,c)),s+=f[l]):s!==void 0&&(s+=n[c])}return s!==void 0?s:n}function E(n,s){let c;return n.authority&&n.path.length>1&&n.scheme==="file"?c=`//${n.authority}${n.path}`:n.path.charCodeAt(0)===47&&(n.path.charCodeAt(1)>=65&&n.path.charCodeAt(1)<=90||n.path.charCodeAt(1)>=97&&n.path.charCodeAt(1)<=122)&&n.path.charCodeAt(2)===58?s?c=n.path.substr(1):c=n.path[1].toLowerCase()+n.path.substr(2):c=n.path,L.isWindows&&(c=c.replace(/\//g,"\\")),c}e.uriToFsPath=E;function o(n,s){const c=s?y:I;let l="",{scheme:h,authority:d,path:v,query:A,fragment:O}=n;if(h&&(l+=h,l+=":"),(d||h==="file")&&(l+=C,l+=C),d){let p=d.indexOf("@");if(p!==-1){const U=d.substr(0,p);d=d.substr(p+1),p=U.indexOf(":"),p===-1?l+=c(U,!1):(l+=c(U.substr(0,p),!1),l+=":",l+=c(U.substr(p+1),!1)),l+="@"}d=d.toLowerCase(),p=d.indexOf(":"),p===-1?l+=c(d,!1):(l+=c(d.substr(0,p),!1),l+=d.substr(p))}if(v){if(v.length>=3&&v.charCodeAt(0)===47&&v.charCodeAt(2)===58){const p=v.charCodeAt(1);p>=65&&p<=90&&(v=`/${String.fromCharCode(p+32)}:${v.substr(3)}`)}else if(v.length>=2&&v.charCodeAt(1)===58){const p=v.charCodeAt(0);p>=65&&p<=90&&(v=`${String.fromCharCode(p+32)}:${v.substr(2)}`)}l+=c(v,!0)}return A&&(l+="?",l+=c(A,!1)),O&&(l+="#",l+=s?O:I(O,!1)),l}function a(n){try{return decodeURIComponent(n)}catch{return n.length>3?n.substr(0,3)+a(n.substr(3)):n}}const t=/(%[0-9A-Za-z][0-9A-Za-z])+/g;function r(n){return n.match(t)?n.replace(t,s=>a(s)):n}}),define(Z[94],te([0,1,5]),function(K,e,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.log=e.getFirstFrame=e.parse=e.isRemoteConsoleLog=void 0;function L(b){const i=b;return i&&typeof i.type=="string"&&typeof i.severity=="string"}e.isRemoteConsoleLog=L;function R(b){const i=[];let C;try{const g=JSON.parse(b.arguments),w=g[g.length-1];w&&w.__$stack&&(g.pop(),C=w.__$stack),i.push(...g)}catch(g){i.push("Unable to log remote console arguments",b.arguments)}return{args:i,stack:C}}e.parse=R;function T(b){if(typeof b!="string")return T(R(b).stack);const i=b;if(i){const C=k(i),g=/at [^\/]*((?:(?:[a-zA-Z]+:)|(?:[\/])|(?:\\\\))(?:.+)):(\d+):(\d+)/.exec(C||"");if(g&&g.length===4)return{uri:D.URI.file(g[1]),line:Number(g[2]),column:Number(g[3])}}}e.getFirstFrame=T;function k(b){if(!b)return b;const i=b.indexOf(`
`);return i===-1?b:b.substring(0,i)}function P(b,i){const{args:C,stack:g}=R(b),w=typeof C[0]=="string"&&C.length===1;let u=k(g);u&&(u=`(${u.trim()})`);let S=[];if(typeof C[0]=="string"?u&&w?S=[`%c[${i}] %c${C[0]} %c${u}`,m("blue"),m(""),m("grey")]:S=[`%c[${i}] %c${C[0]}`,m("blue"),m(""),...C.slice(1)]:S=[`%c[${i}]%`,m("blue"),...C],u&&!w&&S.push(u),typeof console[b.severity]!="function")throw new Error("Unknown console method");console[b.severity].apply(console,S)}e.log=P;function m(b){return`color: ${b}`}});var mt=this&&this.__classPrivateFieldSet||function(K,e,D,L,R){if(L==="m")throw new TypeError("Private method is not writable");if(L==="a"&&!R)throw new TypeError("Private accessor was defined without a setter");if(typeof e=="function"?K!==e||!R:!e.has(K))throw new TypeError("Cannot write private member to an object whose class did not declare it");return L==="a"?R.call(K,D):R?R.value=D:e.set(K,D),D},je=this&&this.__classPrivateFieldGet||function(K,e,D,L){if(D==="a"&&!L)throw new TypeError("Private accessor was defined without a getter");if(typeof e=="function"?K!==e||!L:!e.has(K))throw new TypeError("Cannot read private member from an object whose class did not declare it");return D==="m"?L:D==="a"?L.call(K):L?L.value:e.get(K)};define(Z[41],te([0,1,17,24,5]),function(K,e,D,L,R){"use strict";var T,k,P;Object.defineProperty(e,"__esModule",{value:!0}),e.ReadonlyMapView=e.LRUCache=e.LinkedMap=e.Touch=e.ResourceMap=e.TernarySearchTree=e.UriIterator=e.PathIterator=e.ConfigKeysIterator=e.StringIterator=e.setToString=e.mapToString=e.getOrSet=void 0;function m(r,n,s){let c=r.get(n);return c===void 0&&(c=s,r.set(n,c)),c}e.getOrSet=m;function b(r){const n=[];return r.forEach((s,c)=>{n.push(`${c} => ${s}`)}),`Map(${r.size}) {${n.join(", ")}}`}e.mapToString=b;function i(r){const n=[];return r.forEach(s=>{n.push(s)}),`Set(${r.size}) {${n.join(", ")}}`}e.setToString=i;class C{constructor(){this._value="",this._pos=0}reset(n){return this._value=n,this._pos=0,this}next(){return this._pos+=1,this}hasNext(){return this._pos<this._value.length-1}cmp(n){const s=n.charCodeAt(0),c=this._value.charCodeAt(this._pos);return s-c}value(){return this._value[this._pos]}}e.StringIterator=C;class g{constructor(n=!0){this._caseSensitive=n}reset(n){return this._value=n,this._from=0,this._to=0,this.next()}hasNext(){return this._to<this._value.length}next(){this._from=this._to;let n=!0;for(;this._to<this._value.length;this._to++)if(this._value.charCodeAt(this._to)===46)if(n)this._from++;else break;else n=!1;return this}cmp(n){return this._caseSensitive?(0,L.compareSubstring)(n,this._value,0,n.length,this._from,this._to):(0,L.compareSubstringIgnoreCase)(n,this._value,0,n.length,this._from,this._to)}value(){return this._value.substring(this._from,this._to)}}e.ConfigKeysIterator=g;class w{constructor(n=!0,s=!0){this._splitOnBackslash=n,this._caseSensitive=s}reset(n){return this._value=n.replace(/\\$|\/$/,""),this._from=0,this._to=0,this.next()}hasNext(){return this._to<this._value.length}next(){this._from=this._to;let n=!0;for(;this._to<this._value.length;this._to++){const s=this._value.charCodeAt(this._to);if(s===47||this._splitOnBackslash&&s===92)if(n)this._from++;else break;else n=!1}return this}cmp(n){return this._caseSensitive?(0,L.compareSubstring)(n,this._value,0,n.length,this._from,this._to):(0,L.compareSubstringIgnoreCase)(n,this._value,0,n.length,this._from,this._to)}value(){return this._value.substring(this._from,this._to)}}e.PathIterator=w;var u;(function(r){r[r.Scheme=1]="Scheme",r[r.Authority=2]="Authority",r[r.Path=3]="Path",r[r.Query=4]="Query",r[r.Fragment=5]="Fragment"})(u||(u={}));class S{constructor(n){this._ignorePathCasing=n,this._states=[],this._stateIdx=0}reset(n){return this._value=n,this._states=[],this._value.scheme&&this._states.push(1),this._value.authority&&this._states.push(2),this._value.path&&(this._pathIterator=new w(!1,!this._ignorePathCasing(n)),this._pathIterator.reset(n.path),this._pathIterator.value()&&this._states.push(3)),this._value.query&&this._states.push(4),this._value.fragment&&this._states.push(5),this._stateIdx=0,this}next(){return this._states[this._stateIdx]===3&&this._pathIterator.hasNext()?this._pathIterator.next():this._stateIdx+=1,this}hasNext(){return this._states[this._stateIdx]===3&&this._pathIterator.hasNext()||this._stateIdx<this._states.length-1}cmp(n){if(this._states[this._stateIdx]===1)return(0,L.compareIgnoreCase)(n,this._value.scheme);if(this._states[this._stateIdx]===2)return(0,L.compareIgnoreCase)(n,this._value.authority);if(this._states[this._stateIdx]===3)return this._pathIterator.cmp(n);if(this._states[this._stateIdx]===4)return(0,L.compare)(n,this._value.query);if(this._states[this._stateIdx]===5)return(0,L.compare)(n,this._value.fragment);throw new Error}value(){if(this._states[this._stateIdx]===1)return this._value.scheme;if(this._states[this._stateIdx]===2)return this._value.authority;if(this._states[this._stateIdx]===3)return this._pathIterator.value();if(this._states[this._stateIdx]===4)return this._value.query;if(this._states[this._stateIdx]===5)return this._value.fragment;throw new Error}}e.UriIterator=S;class f{isEmpty(){return!this.left&&!this.mid&&!this.right&&!this.value}}class I{constructor(n){this._iter=n}static forUris(n=()=>!1){return new I(new S(n))}static forPaths(){return new I(new w)}static forStrings(){return new I(new C)}static forConfigKeys(){return new I(new g)}clear(){this._root=void 0}set(n,s){const c=this._iter.reset(n);let l;for(this._root||(this._root=new f,this._root.segment=c.value()),l=this._root;;){const d=c.cmp(l.segment);if(d>0)l.left||(l.left=new f,l.left.segment=c.value()),l=l.left;else if(d<0)l.right||(l.right=new f,l.right.segment=c.value()),l=l.right;else if(c.hasNext())c.next(),l.mid||(l.mid=new f,l.mid.segment=c.value()),l=l.mid;else break}const h=l.value;return l.value=s,l.key=n,h}fill(n,s){const c=s.slice(0);(0,D.shuffle)(c);for(let l of c)this.set(l,n)}get(n){return this._getNode(n)?.value}_getNode(n){const s=this._iter.reset(n);let c=this._root;for(;c;){const l=s.cmp(c.segment);if(l>0)c=c.left;else if(l<0)c=c.right;else if(s.hasNext())s.next(),c=c.mid;else break}return c}has(n){const s=this._getNode(n);return!(s?.value===void 0&&s?.mid===void 0)}delete(n){return this._delete(n,!1)}deleteSuperstr(n){return this._delete(n,!0)}_delete(n,s){const c=this._iter.reset(n),l=[];let h=this._root;for(;h;){const d=c.cmp(h.segment);if(d>0)l.push([1,h]),h=h.left;else if(d<0)l.push([-1,h]),h=h.right;else if(c.hasNext())c.next(),l.push([0,h]),h=h.mid;else{for(s?(h.left=void 0,h.mid=void 0,h.right=void 0):h.value=void 0;l.length>0&&h.isEmpty();){let[v,A]=l.pop();switch(v){case 1:A.left=void 0;break;case 0:A.mid=void 0;break;case-1:A.right=void 0;break}h=A}break}}}findSubstr(n){const s=this._iter.reset(n);let c=this._root,l;for(;c;){const h=s.cmp(c.segment);if(h>0)c=c.left;else if(h<0)c=c.right;else if(s.hasNext())s.next(),l=c.value||l,c=c.mid;else break}return c&&c.value||l}findSuperstr(n){const s=this._iter.reset(n);let c=this._root;for(;c;){const l=s.cmp(c.segment);if(l>0)c=c.left;else if(l<0)c=c.right;else if(s.hasNext())s.next(),c=c.mid;else return c.mid?this._entries(c.mid):void 0}}forEach(n){for(const[s,c]of this)n(c,s)}*[Symbol.iterator](){yield*this._entries(this._root)}*_entries(n){if(!n)return;const s=[n];for(;s.length>0;){const c=s.pop();c&&(c.value&&(yield[c.key,c.value]),c.left&&s.push(c.left),c.mid&&s.push(c.mid),c.right&&s.push(c.right))}}}e.TernarySearchTree=I;class y{constructor(n,s){this[T]="ResourceMap",n instanceof y?(this.map=new Map(n.map),this.toKey=s??y.defaultToKey):(this.map=new Map,this.toKey=n??y.defaultToKey)}set(n,s){return this.map.set(this.toKey(n),s),this}get(n){return this.map.get(this.toKey(n))}has(n){return this.map.has(this.toKey(n))}get size(){return this.map.size}clear(){this.map.clear()}delete(n){return this.map.delete(this.toKey(n))}forEach(n,s){typeof s!="undefined"&&(n=n.bind(s));for(let[c,l]of this.map)n(l,R.URI.parse(c),this)}values(){return this.map.values()}*keys(){for(let n of this.map.keys())yield R.URI.parse(n)}*entries(){for(let n of this.map.entries())yield[R.URI.parse(n[0]),n[1]]}*[(T=Symbol.toStringTag,Symbol.iterator)](){for(let n of this.map)yield[R.URI.parse(n[0]),n[1]]}}e.ResourceMap=y,y.defaultToKey=r=>r.toString();var E;(function(r){r[r.None=0]="None",r[r.AsOld=1]="AsOld",r[r.AsNew=2]="AsNew"})(E=e.Touch||(e.Touch={}));class o{constructor(){this[k]="LinkedMap",this._map=new Map,this._head=void 0,this._tail=void 0,this._size=0,this._state=0}clear(){this._map.clear(),this._head=void 0,this._tail=void 0,this._size=0,this._state++}isEmpty(){return!this._head&&!this._tail}get size(){return this._size}get first(){return this._head?.value}get last(){return this._tail?.value}has(n){return this._map.has(n)}get(n,s=0){const c=this._map.get(n);if(!!c)return s!==0&&this.touch(c,s),c.value}set(n,s,c=0){let l=this._map.get(n);if(l)l.value=s,c!==0&&this.touch(l,c);else{switch(l={key:n,value:s,next:void 0,previous:void 0},c){case 0:this.addItemLast(l);break;case 1:this.addItemFirst(l);break;case 2:this.addItemLast(l);break;default:this.addItemLast(l);break}this._map.set(n,l),this._size++}return this}delete(n){return!!this.remove(n)}remove(n){const s=this._map.get(n);if(!!s)return this._map.delete(n),this.removeItem(s),this._size--,s.value}shift(){if(!this._head&&!this._tail)return;if(!this._head||!this._tail)throw new Error("Invalid list");const n=this._head;return this._map.delete(n.key),this.removeItem(n),this._size--,n.value}forEach(n,s){const c=this._state;let l=this._head;for(;l;){if(s?n.bind(s)(l.value,l.key,this):n(l.value,l.key,this),this._state!==c)throw new Error("LinkedMap got modified during iteration.");l=l.next}}keys(){const n=this,s=this._state;let c=this._head;const l={[Symbol.iterator](){return l},next(){if(n._state!==s)throw new Error("LinkedMap got modified during iteration.");if(c){const h={value:c.key,done:!1};return c=c.next,h}else return{value:void 0,done:!0}}};return l}values(){const n=this,s=this._state;let c=this._head;const l={[Symbol.iterator](){return l},next(){if(n._state!==s)throw new Error("LinkedMap got modified during iteration.");if(c){const h={value:c.value,done:!1};return c=c.next,h}else return{value:void 0,done:!0}}};return l}entries(){const n=this,s=this._state;let c=this._head;const l={[Symbol.iterator](){return l},next(){if(n._state!==s)throw new Error("LinkedMap got modified during iteration.");if(c){const h={value:[c.key,c.value],done:!1};return c=c.next,h}else return{value:void 0,done:!0}}};return l}[(k=Symbol.toStringTag,Symbol.iterator)](){return this.entries()}trimOld(n){if(n>=this.size)return;if(n===0){this.clear();return}let s=this._head,c=this.size;for(;s&&c>n;)this._map.delete(s.key),s=s.next,c--;this._head=s,this._size=c,s&&(s.previous=void 0),this._state++}addItemFirst(n){if(!this._head&&!this._tail)this._tail=n;else if(this._head)n.next=this._head,this._head.previous=n;else throw new Error("Invalid list");this._head=n,this._state++}addItemLast(n){if(!this._head&&!this._tail)this._head=n;else if(this._tail)n.previous=this._tail,this._tail.next=n;else throw new Error("Invalid list");this._tail=n,this._state++}removeItem(n){if(n===this._head&&n===this._tail)this._head=void 0,this._tail=void 0;else if(n===this._head){if(!n.next)throw new Error("Invalid list");n.next.previous=void 0,this._head=n.next}else if(n===this._tail){if(!n.previous)throw new Error("Invalid list");n.previous.next=void 0,this._tail=n.previous}else{const s=n.next,c=n.previous;if(!s||!c)throw new Error("Invalid list");s.previous=c,c.next=s}n.next=void 0,n.previous=void 0,this._state++}touch(n,s){if(!this._head||!this._tail)throw new Error("Invalid list");if(!(s!==1&&s!==2)){if(s===1){if(n===this._head)return;const c=n.next,l=n.previous;n===this._tail?(l.next=void 0,this._tail=l):(c.previous=l,l.next=c),n.previous=void 0,n.next=this._head,this._head.previous=n,this._head=n,this._state++}else if(s===2){if(n===this._tail)return;const c=n.next,l=n.previous;n===this._head?(c.previous=void 0,this._head=c):(c.previous=l,l.next=c),n.next=void 0,n.previous=this._tail,this._tail.next=n,this._tail=n,this._state++}}}toJSON(){const n=[];return this.forEach((s,c)=>{n.push([c,s])}),n}fromJSON(n){this.clear();for(const[s,c]of n)this.set(s,c)}}e.LinkedMap=o;class a extends o{constructor(n,s=1){super();this._limit=n,this._ratio=Math.min(Math.max(0,s),1)}get limit(){return this._limit}set limit(n){this._limit=n,this.checkTrim()}get ratio(){return this._ratio}set ratio(n){this._ratio=Math.min(Math.max(0,n),1),this.checkTrim()}get(n,s=2){return super.get(n,s)}peek(n){return super.get(n,0)}set(n,s){return super.set(n,s,2),this.checkTrim(),this}checkTrim(){this.size>this._limit&&this.trimOld(Math.round(this._limit*this._ratio))}}e.LRUCache=a;class t{constructor(n){P.set(this,void 0),mt(this,P,n,"f")}get size(){return je(this,P,"f").size}forEach(n,s){je(this,P,"f").forEach(n,s)}get(n){return je(this,P,"f").get(n)}has(n){return je(this,P,"f").has(n)}entries(){return je(this,P,"f").entries()}keys(){return je(this,P,"f").keys()}values(){return je(this,P,"f").values()}[(P=new WeakMap,Symbol.iterator)](){return je(this,P,"f").entries()}}e.ReadonlyMapView=t}),define(Z[95],te([0,1,25,24,5]),function(K,e,D,L,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.revive=e.MarshalledId=e.parse=e.stringify=void 0;function T(i){return JSON.stringify(i,m)}e.stringify=T;function k(i){let C=JSON.parse(i);return C=b(C),C}e.parse=k;var P;(function(i){i[i.Uri=1]="Uri",i[i.Regexp=2]="Regexp",i[i.ScmResource=3]="ScmResource",i[i.ScmResourceGroup=4]="ScmResourceGroup",i[i.ScmProvider=5]="ScmProvider",i[i.CommentController=6]="CommentController",i[i.CommentThread=7]="CommentThread",i[i.CommentThreadReply=8]="CommentThreadReply",i[i.CommentNode=9]="CommentNode",i[i.CommentThreadNode=10]="CommentThreadNode",i[i.TimelineActionContext=11]="TimelineActionContext",i[i.NotebookCellActionContext=12]="NotebookCellActionContext",i[i.TestItemContext=13]="TestItemContext"})(P=e.MarshalledId||(e.MarshalledId={}));function m(i,C){return C instanceof RegExp?{$mid:2,source:C.source,flags:(0,L.regExpFlags)(C)}:C}function b(i,C=0){if(!i||C>200)return i;if(typeof i=="object"){switch(i.$mid){case 1:return R.URI.revive(i);case 2:return new RegExp(i.source,i.flags)}if(i instanceof D.VSBuffer||i instanceof Uint8Array)return i;if(Array.isArray(i))for(let g=0;g<i.length;++g)i[g]=b(i[g],C+1);else for(const g in i)Object.hasOwnProperty.call(i,g)&&(i[g]=b(i[g],C+1))}return i}e.revive=b}),define(Z[15],te([0,1,4,5]),function(K,e,D,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.FileAccess=e.RemoteAuthorities=e.Schemas=void 0;var R;(function(P){P.inMemory="inmemory",P.vscode="vscode",P.internal="private",P.walkThrough="walkThrough",P.walkThroughSnippet="walkThroughSnippet",P.http="http",P.https="https",P.file="file",P.mailto="mailto",P.untitled="untitled",P.data="data",P.command="command",P.vscodeRemote="vscode-remote",P.vscodeRemoteResource="vscode-remote-resource",P.userData="vscode-userdata",P.vscodeCustomEditor="vscode-custom-editor",P.vscodeNotebook="vscode-notebook",P.vscodeNotebookCell="vscode-notebook-cell",P.vscodeNotebookCellMetadata="vscode-notebook-cell-metadata",P.vscodeNotebookCellOutput="vscode-notebook-cell-output",P.vscodeInteractive="vscode-interactive",P.vscodeInteractiveInput="vscode-interactive-input",P.vscodeSettings="vscode-settings",P.vscodeWorkspaceTrust="vscode-workspace-trust",P.vscodeTerminal="vscode-terminal",P.webviewPanel="webview-panel",P.vscodeWebview="vscode-webview",P.extension="extension",P.vscodeFileResource="vscode-file",P.tmp="tmp"})(R=e.Schemas||(e.Schemas={}));class T{constructor(){this._hosts=Object.create(null),this._ports=Object.create(null),this._connectionTokens=Object.create(null),this._preferredWebSchema="http",this._delegate=null}setPreferredWebSchema(m){this._preferredWebSchema=m}setDelegate(m){this._delegate=m}set(m,b,i){this._hosts[m]=b,this._ports[m]=i}setConnectionToken(m,b){this._connectionTokens[m]=b}rewrite(m){if(this._delegate)return this._delegate(m);const b=m.authority;let i=this._hosts[b];i&&i.indexOf(":")!==-1&&(i=`[${i}]`);const C=this._ports[b],g=this._connectionTokens[b];let w=`path=${encodeURIComponent(m.path)}`;return typeof g=="string"&&(w+=`&tkn=${encodeURIComponent(g)}`),L.URI.from({scheme:D.isWeb?this._preferredWebSchema:R.vscodeRemoteResource,authority:`${i}:${C}`,path:"/vscode-remote-resource",query:w})}}e.RemoteAuthorities=new T;class k{asBrowserUri(m,b){const i=this.toUri(m,b);return i.scheme===R.vscodeRemote?e.RemoteAuthorities.rewrite(i):i.scheme===R.file&&(D.isNative||typeof D.globals.importScripts=="function"&&D.globals.origin===`${R.vscodeFileResource}://${k.FALLBACK_AUTHORITY}`)?i.with({scheme:R.vscodeFileResource,authority:i.authority||k.FALLBACK_AUTHORITY,query:null,fragment:null}):i}asFileUri(m,b){const i=this.toUri(m,b);return i.scheme===R.vscodeFileResource?i.with({scheme:R.file,authority:i.authority!==k.FALLBACK_AUTHORITY?i.authority:null,query:null,fragment:null}):i}toUri(m,b){return L.URI.isUri(m)?m:L.URI.parse(b.toUrl(m))}}k.FALLBACK_AUTHORITY="vscode-app",e.FileAccess=new k}),define(Z[66],te([0,1,41]),function(K,e,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.removeAccents=e.normalizeNFD=e.normalizeNFC=void 0;const L=new D.LRUCache(1e4);function R(b){return m(b,"NFC",L)}e.normalizeNFC=R;const T=new D.LRUCache(1e4);function k(b){return m(b,"NFD",T)}e.normalizeNFD=k;const P=/[^\u0000-\u0080]/;function m(b,i,C){if(!b)return b;const g=C.get(b);if(g)return g;let w;return P.test(b)?w=b.normalize(i):w=b,C.set(b,w),w}e.removeAccents=function(){const b=/[\u0300-\u036f]/g;return function(i){return k(i).replace(b,"")}}()}),define(Z[16],te([0,1,40,15,8,4,24,5]),function(K,e,D,L,R,T,k,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.toLocalResource=e.DataUri=e.distinctParents=e.addTrailingPathSeparator=e.removeTrailingPathSeparator=e.hasTrailingPathSeparator=e.isEqualAuthority=e.isAbsolutePath=e.resolvePath=e.relativePath=e.normalizePath=e.joinPath=e.dirname=e.extname=e.basename=e.basenameOrAuthority=e.getComparisonKey=e.isEqualOrParent=e.isEqual=e.extUriIgnorePathCase=e.extUriBiasedIgnorePathCase=e.extUri=e.ExtUri=e.originalFSPath=void 0;function m(w){return(0,P.uriToFsPath)(w,!0)}e.originalFSPath=m;class b{constructor(u){this._ignorePathCasing=u}compare(u,S,f=!1){return u===S?0:(0,k.compare)(this.getComparisonKey(u,f),this.getComparisonKey(S,f))}isEqual(u,S,f=!1){return u===S?!0:!u||!S?!1:this.getComparisonKey(u,f)===this.getComparisonKey(S,f)}getComparisonKey(u,S=!1){return u.with({path:this._ignorePathCasing(u)?u.path.toLowerCase():void 0,fragment:S?null:void 0}).toString()}ignorePathCasing(u){return this._ignorePathCasing(u)}isEqualOrParent(u,S,f=!1){if(u.scheme===S.scheme){if(u.scheme===L.Schemas.file)return D.isEqualOrParent(m(u),m(S),this._ignorePathCasing(u))&&u.query===S.query&&(f||u.fragment===S.fragment);if((0,e.isEqualAuthority)(u.authority,S.authority))return D.isEqualOrParent(u.path,S.path,this._ignorePathCasing(u),"/")&&u.query===S.query&&(f||u.fragment===S.fragment)}return!1}joinPath(u,...S){return P.URI.joinPath(u,...S)}basenameOrAuthority(u){return(0,e.basename)(u)||u.authority}basename(u){return R.posix.basename(u.path)}extname(u){return R.posix.extname(u.path)}dirname(u){if(u.path.length===0)return u;let S;return u.scheme===L.Schemas.file?S=P.URI.file(R.dirname(m(u))).path:(S=R.posix.dirname(u.path),u.authority&&S.length&&S.charCodeAt(0)!==47&&(console.error(`dirname("${u.toString})) resulted in a relative path`),S="/")),u.with({path:S})}normalizePath(u){if(!u.path.length)return u;let S;return u.scheme===L.Schemas.file?S=P.URI.file(R.normalize(m(u))).path:S=R.posix.normalize(u.path),u.with({path:S})}relativePath(u,S){if(u.scheme!==S.scheme||!(0,e.isEqualAuthority)(u.authority,S.authority))return;if(u.scheme===L.Schemas.file){const y=R.relative(m(u),m(S));return T.isWindows?D.toSlashes(y):y}let f=u.path||"/",I=S.path||"/";if(this._ignorePathCasing(u)){let y=0;for(const E=Math.min(f.length,I.length);y<E&&!(f.charCodeAt(y)!==I.charCodeAt(y)&&f.charAt(y).toLowerCase()!==I.charAt(y).toLowerCase());y++);f=I.substr(0,y)+f.substr(y)}return R.posix.relative(f,I)}resolvePath(u,S){if(u.scheme===L.Schemas.file){const f=P.URI.file(R.resolve(m(u),S));return u.with({authority:f.authority,path:f.path})}return S=D.toPosixPath(S),u.with({path:R.posix.resolve(u.path,S)})}isAbsolutePath(u){return!!u.path&&u.path[0]==="/"}isEqualAuthority(u,S){return u===S||(0,k.equalsIgnoreCase)(u,S)}hasTrailingPathSeparator(u,S=R.sep){if(u.scheme===L.Schemas.file){const f=m(u);return f.length>D.getRoot(f).length&&f[f.length-1]===S}else{const f=u.path;return f.length>1&&f.charCodeAt(f.length-1)===47&&!/^[a-zA-Z]:(\/$|\\$)/.test(u.fsPath)}}removeTrailingPathSeparator(u,S=R.sep){return(0,e.hasTrailingPathSeparator)(u,S)?u.with({path:u.path.substr(0,u.path.length-1)}):u}addTrailingPathSeparator(u,S=R.sep){let f=!1;if(u.scheme===L.Schemas.file){const I=m(u);f=I!==void 0&&I.length===D.getRoot(I).length&&I[I.length-1]===S}else{S="/";const I=u.path;f=I.length===1&&I.charCodeAt(I.length-1)===47}return!f&&!(0,e.hasTrailingPathSeparator)(u,S)?u.with({path:u.path+"/"}):u}}e.ExtUri=b,e.extUri=new b(()=>!1),e.extUriBiasedIgnorePathCase=new b(w=>w.scheme===L.Schemas.file?!T.isLinux:!0),e.extUriIgnorePathCase=new b(w=>!0),e.isEqual=e.extUri.isEqual.bind(e.extUri),e.isEqualOrParent=e.extUri.isEqualOrParent.bind(e.extUri),e.getComparisonKey=e.extUri.getComparisonKey.bind(e.extUri),e.basenameOrAuthority=e.extUri.basenameOrAuthority.bind(e.extUri),e.basename=e.extUri.basename.bind(e.extUri),e.extname=e.extUri.extname.bind(e.extUri),e.dirname=e.extUri.dirname.bind(e.extUri),e.joinPath=e.extUri.joinPath.bind(e.extUri),e.normalizePath=e.extUri.normalizePath.bind(e.extUri),e.relativePath=e.extUri.relativePath.bind(e.extUri),e.resolvePath=e.extUri.resolvePath.bind(e.extUri),e.isAbsolutePath=e.extUri.isAbsolutePath.bind(e.extUri),e.isEqualAuthority=e.extUri.isEqualAuthority.bind(e.extUri),e.hasTrailingPathSeparator=e.extUri.hasTrailingPathSeparator.bind(e.extUri),e.removeTrailingPathSeparator=e.extUri.removeTrailingPathSeparator.bind(e.extUri),e.addTrailingPathSeparator=e.extUri.addTrailingPathSeparator.bind(e.extUri);function i(w,u){const S=[];for(let f=0;f<w.length;f++){const I=u(w[f]);w.some((y,E)=>E===f?!1:(0,e.isEqualOrParent)(I,u(y)))||S.push(w[f])}return S}e.distinctParents=i;var C;(function(w){w.META_DATA_LABEL="label",w.META_DATA_DESCRIPTION="description",w.META_DATA_SIZE="size",w.META_DATA_MIME="mime";function u(S){const f=new Map;S.path.substring(S.path.indexOf(";")+1,S.path.lastIndexOf(";")).split(";").forEach(E=>{const[o,a]=E.split(":");o&&a&&f.set(o,a)});const y=S.path.substring(0,S.path.indexOf(";"));return y&&f.set(w.META_DATA_MIME,y),f}w.parseMetaData=u})(C=e.DataUri||(e.DataUri={}));function g(w,u,S){if(u){let f=w.path;return f&&f[0]!==R.posix.sep&&(f=R.posix.sep+f),w.with({scheme:S,authority:u,path:f})}return w.with({scheme:S})}e.toLocalResource=g}),define(Z[6],te([0,1,27,9,3,2,16]),function(K,e,D,L,R,T,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Promises=e.DeferredPromise=e.IntervalCounter=e.TaskSequentializer=e.retry=e.IdleValue=e.runWhenIdle=e.ThrottledWorker=e.RunOnceWorker=e.ProcessTimeRunOnceScheduler=e.RunOnceScheduler=e.IntervalTimer=e.TimeoutTimer=e.ResourceQueue=e.Queue=e.Limiter=e.firstParallel=e.first=e.sequence=e.disposableTimeout=e.timeout=e.AutoOpenBarrier=e.Barrier=e.ThrottledDelayer=e.Delayer=e.SequencerByKey=e.Sequencer=e.Throttler=e.asPromise=e.raceTimeout=e.raceCancellablePromises=e.raceCancellation=e.createCancelablePromise=e.isThenable=void 0;function P(q){return!!q&&typeof q.then=="function"}e.isThenable=P;function m(q){const x=new D.CancellationTokenSource,$=q(x.token),N=new Promise((W,_)=>{const Y=x.token.onCancellationRequested(()=>{Y.dispose(),x.dispose(),_((0,L.canceled)())});Promise.resolve($).then(G=>{Y.dispose(),x.dispose(),W(G)},G=>{Y.dispose(),x.dispose(),_(G)})});return new class{cancel(){x.cancel()}then(W,_){return N.then(W,_)}catch(W){return this.then(void 0,W)}finally(W){return N.finally(W)}}}e.createCancelablePromise=m;function b(q,x,$){return Promise.race([q,new Promise(N=>x.onCancellationRequested(()=>N($)))])}e.raceCancellation=b;async function i(q){let x=-1;const $=q.map((W,_)=>W.then(Y=>(x=_,Y))),N=await Promise.race($);return q.forEach((W,_)=>{_!==x&&W.cancel()}),N}e.raceCancellablePromises=i;function C(q,x,$){let N;const W=setTimeout(()=>{N?.(void 0),$?.()},x);return Promise.race([q.finally(()=>clearTimeout(W)),new Promise(_=>N=_)])}e.raceTimeout=C;function g(q){return new Promise((x,$)=>{const N=q();P(N)?N.then(x,$):x(N)})}e.asPromise=g;class w{constructor(){this.activePromise=null,this.queuedPromise=null,this.queuedPromiseFactory=null}queue(x){if(this.activePromise){if(this.queuedPromiseFactory=x,!this.queuedPromise){const $=()=>{this.queuedPromise=null;const N=this.queue(this.queuedPromiseFactory);return this.queuedPromiseFactory=null,N};this.queuedPromise=new Promise(N=>{this.activePromise.then($,$).then(N)})}return new Promise(($,N)=>{this.queuedPromise.then($,N)})}return this.activePromise=x(),new Promise(($,N)=>{this.activePromise.then(W=>{this.activePromise=null,$(W)},W=>{this.activePromise=null,N(W)})})}}e.Throttler=w;class u{constructor(){this.current=Promise.resolve(null)}queue(x){return this.current=this.current.then(()=>x(),()=>x())}}e.Sequencer=u;class S{constructor(){this.promiseMap=new Map}queue(x,$){const W=(this.promiseMap.get(x)??Promise.resolve()).catch(()=>{}).then($).finally(()=>{this.promiseMap.get(x)===W&&this.promiseMap.delete(x)});return this.promiseMap.set(x,W),W}}e.SequencerByKey=S;class f{constructor(x){this.defaultDelay=x,this.timeout=null,this.completionPromise=null,this.doResolve=null,this.doReject=null,this.task=null}trigger(x,$=this.defaultDelay){return this.task=x,this.cancelTimeout(),this.completionPromise||(this.completionPromise=new Promise((N,W)=>{this.doResolve=N,this.doReject=W}).then(()=>{if(this.completionPromise=null,this.doResolve=null,this.task){const N=this.task;return this.task=null,N()}})),this.timeout=setTimeout(()=>{this.timeout=null,this.doResolve&&this.doResolve(null)},$),this.completionPromise}isTriggered(){return this.timeout!==null}cancel(){this.cancelTimeout(),this.completionPromise&&(this.doReject&&this.doReject((0,L.canceled)()),this.completionPromise=null)}cancelTimeout(){this.timeout!==null&&(clearTimeout(this.timeout),this.timeout=null)}dispose(){this.cancel()}}e.Delayer=f;class I{constructor(x){this.delayer=new f(x),this.throttler=new w}trigger(x,$){return this.delayer.trigger(()=>this.throttler.queue(x),$)}isTriggered(){return this.delayer.isTriggered()}cancel(){this.delayer.cancel()}dispose(){this.delayer.dispose()}}e.ThrottledDelayer=I;class y{constructor(){this._isOpen=!1,this._promise=new Promise((x,$)=>{this._completePromise=x})}isOpen(){return this._isOpen}open(){this._isOpen=!0,this._completePromise(!0)}wait(){return this._promise}}e.Barrier=y;class E extends y{constructor(x){super();this._timeout=setTimeout(()=>this.open(),x)}open(){clearTimeout(this._timeout),super.open()}}e.AutoOpenBarrier=E;function o(q,x){return x?new Promise(($,N)=>{const W=setTimeout(()=>{_.dispose(),$()},q),_=x.onCancellationRequested(()=>{clearTimeout(W),_.dispose(),N((0,L.canceled)())})}):m($=>o(q,$))}e.timeout=o;function a(q,x=0){const $=setTimeout(q,x);return(0,T.toDisposable)(()=>clearTimeout($))}e.disposableTimeout=a;function t(q){const x=[];let $=0;const N=q.length;function W(){return $<N?q[$++]():null}function _(Y){Y!=null&&x.push(Y);const G=W();return G?G.then(_):Promise.resolve(x)}return Promise.resolve(null).then(_)}e.sequence=t;function r(q,x=N=>!!N,$=null){let N=0;const W=q.length,_=()=>{if(N>=W)return Promise.resolve($);const Y=q[N++];return Promise.resolve(Y()).then(ne=>x(ne)?Promise.resolve(ne):_())};return _()}e.first=r;function n(q,x=N=>!!N,$=null){if(q.length===0)return Promise.resolve($);let N=q.length;const W=()=>{N=-1;for(const _ of q)_.cancel?.()};return new Promise((_,Y)=>{for(const G of q)G.then(ne=>{--N>=0&&x(ne)?(W(),_(ne)):N===0&&_($)}).catch(ne=>{--N>=0&&(W(),Y(ne))})})}e.firstParallel=n;class s{constructor(x){this._size=0,this.maxDegreeOfParalellism=x,this.outstandingPromises=[],this.runningPromises=0,this._onFinished=new R.Emitter}get onFinished(){return this._onFinished.event}get size(){return this._size}queue(x){return this._size++,new Promise(($,N)=>{this.outstandingPromises.push({factory:x,c:$,e:N}),this.consume()})}consume(){for(;this.outstandingPromises.length&&this.runningPromises<this.maxDegreeOfParalellism;){const x=this.outstandingPromises.shift();this.runningPromises++;const $=x.factory();$.then(x.c,x.e),$.then(()=>this.consumed(),()=>this.consumed())}}consumed(){this._size--,this.runningPromises--,this.outstandingPromises.length>0?this.consume():this._onFinished.fire()}dispose(){this._onFinished.dispose()}}e.Limiter=s;class c extends s{constructor(){super(1)}}e.Queue=c;class l{constructor(){this.queues=new Map}queueFor(x,$=k.extUri){const N=$.getComparisonKey(x);let W=this.queues.get(N);return W||(W=new c,R.Event.once(W.onFinished)(()=>{W?.dispose(),this.queues.delete(N)}),this.queues.set(N,W)),W}dispose(){this.queues.forEach(x=>x.dispose()),this.queues.clear()}}e.ResourceQueue=l;class h{constructor(x,$){this._token=-1,typeof x=="function"&&typeof $=="number"&&this.setIfNotSet(x,$)}dispose(){this.cancel()}cancel(){this._token!==-1&&(clearTimeout(this._token),this._token=-1)}cancelAndSet(x,$){this.cancel(),this._token=setTimeout(()=>{this._token=-1,x()},$)}setIfNotSet(x,$){this._token===-1&&(this._token=setTimeout(()=>{this._token=-1,x()},$))}}e.TimeoutTimer=h;class d{constructor(){this._token=-1}dispose(){this.cancel()}cancel(){this._token!==-1&&(clearInterval(this._token),this._token=-1)}cancelAndSet(x,$){this.cancel(),this._token=setInterval(()=>{x()},$)}}e.IntervalTimer=d;class v{constructor(x,$){this.timeoutToken=-1,this.runner=x,this.timeout=$,this.timeoutHandler=this.onTimeout.bind(this)}dispose(){this.cancel(),this.runner=null}cancel(){this.isScheduled()&&(clearTimeout(this.timeoutToken),this.timeoutToken=-1)}schedule(x=this.timeout){this.cancel(),this.timeoutToken=setTimeout(this.timeoutHandler,x)}get delay(){return this.timeout}set delay(x){this.timeout=x}isScheduled(){return this.timeoutToken!==-1}onTimeout(){this.timeoutToken=-1,this.runner&&this.doRun()}doRun(){this.runner&&this.runner()}}e.RunOnceScheduler=v;class A{constructor(x,$){$%1e3!=0&&console.warn(`ProcessTimeRunOnceScheduler resolution is 1s, ${$}ms is not a multiple of 1000ms.`),this.runner=x,this.timeout=$,this.counter=0,this.intervalToken=-1,this.intervalHandler=this.onInterval.bind(this)}dispose(){this.cancel(),this.runner=null}cancel(){this.isScheduled()&&(clearInterval(this.intervalToken),this.intervalToken=-1)}schedule(x=this.timeout){x%1e3!=0&&console.warn(`ProcessTimeRunOnceScheduler resolution is 1s, ${x}ms is not a multiple of 1000ms.`),this.cancel(),this.counter=Math.ceil(x/1e3),this.intervalToken=setInterval(this.intervalHandler,1e3)}isScheduled(){return this.intervalToken!==-1}onInterval(){this.counter--,!(this.counter>0)&&(clearInterval(this.intervalToken),this.intervalToken=-1,this.runner&&this.runner())}}e.ProcessTimeRunOnceScheduler=A;class O extends v{constructor(x,$){super(x,$);this.units=[]}work(x){this.units.push(x),this.isScheduled()||this.schedule()}doRun(){const x=this.units;this.units=[],this.runner&&this.runner(x)}dispose(){this.units=[],super.dispose()}}e.RunOnceWorker=O;class p extends T.Disposable{constructor(x,$,N,W){super();this.maxWorkChunkSize=x,this.maxPendingWork=$,this.throttleDelay=N,this.handler=W,this.pendingWork=[],this.throttler=this._register(new T.MutableDisposable),this.disposed=!1}get pending(){return this.pendingWork.length}work(x){if(this.disposed)return!1;if(typeof this.maxPendingWork=="number"){if(this.throttler.value){if(this.pending+x.length>this.maxPendingWork)return!1}else if(this.pending+x.length-this.maxWorkChunkSize>this.maxPendingWork)return!1}return this.pendingWork.push(...x),this.throttler.value||this.doWork(),!0}doWork(){this.handler(this.pendingWork.splice(0,this.maxWorkChunkSize)),this.pendingWork.length>0&&(this.throttler.value=new v(()=>{this.throttler.clear(),this.doWork()},this.throttleDelay),this.throttler.value.schedule())}dispose(){super.dispose(),this.disposed=!0}}e.ThrottledWorker=p,function(){if(typeof requestIdleCallback!="function"||typeof cancelIdleCallback!="function"){const q=Object.freeze({didTimeout:!0,timeRemaining(){return 15}});e.runWhenIdle=x=>{const $=setTimeout(()=>x(q));let N=!1;return{dispose(){N||(N=!0,clearTimeout($))}}}}else e.runWhenIdle=(q,x)=>{const $=requestIdleCallback(q,typeof x=="number"?{timeout:x}:void 0);let N=!1;return{dispose(){N||(N=!0,cancelIdleCallback($))}}}}();class U{constructor(x){this._didRun=!1,this._executor=()=>{try{this._value=x()}catch($){this._error=$}finally{this._didRun=!0}},this._handle=(0,e.runWhenIdle)(()=>this._executor())}dispose(){this._handle.dispose()}get value(){if(this._didRun||(this._handle.dispose(),this._executor()),this._error)throw this._error;return this._value}get isInitialized(){return this._didRun}}e.IdleValue=U;async function F(q,x,$){let N;for(let W=0;W<$;W++)try{return await q()}catch(_){N=_,await o(x)}throw N}e.retry=F;class z{hasPending(x){return this._pending?typeof x=="number"?this._pending.taskId===x:!!this._pending:!1}get pending(){return this._pending?this._pending.promise:void 0}cancelPending(){this._pending?.cancel()}setPending(x,$,N){return this._pending={taskId:x,cancel:()=>N?.(),promise:$},$.then(()=>this.donePending(x),()=>this.donePending(x)),$}donePending(x){this._pending&&x===this._pending.taskId&&(this._pending=void 0,this.triggerNext())}triggerNext(){if(this._next){const x=this._next;this._next=void 0,x.run().then(x.promiseResolve,x.promiseReject)}}setNext(x){if(this._next)this._next.run=x;else{let $,N;const W=new Promise((_,Y)=>{$=_,N=Y});this._next={run:x,promise:W,promiseResolve:$,promiseReject:N}}return this._next.promise}}e.TaskSequentializer=z;class H{constructor(x){this.interval=x,this.lastIncrementTime=0,this.value=0}increment(){const x=Date.now();return x-this.lastIncrementTime>this.interval&&(this.lastIncrementTime=x,this.value=0),this.value++,this.value}}e.IntervalCounter=H;class M{constructor(){this.rejected=!1,this.resolved=!1,this.p=new Promise((x,$)=>{this.completeCallback=x,this.errorCallback=$})}get isRejected(){return this.rejected}get isResolved(){return this.resolved}get isSettled(){return this.rejected||this.resolved}complete(x){return new Promise($=>{this.completeCallback(x),this.resolved=!0,$()})}error(x){return new Promise($=>{this.errorCallback(x),this.rejected=!0,$()})}cancel(){new Promise(x=>{this.errorCallback((0,L.canceled)()),this.rejected=!0,x()})}}e.DeferredPromise=M;var j;(function(q){async function x($){let N;const W=await Promise.all($.map(_=>_.then(Y=>Y,Y=>{N||(N=Y)})));if(typeof N!="undefined")throw N;return W}q.settled=x})(j=e.Promises||(e.Promises={}))}),define(Z[67],te([0,1,6,40,41,8,24]),function(K,e,D,L,R,T,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getPathTerms=e.getBasenameTerms=e.isRelativePattern=e.hasSiblingFn=e.hasSiblingPromiseFn=e.parse=e.match=e.splitGlobAware=e.getEmptyExpression=void 0;function P(){return Object.create(null)}e.getEmptyExpression=P;const m="**",b="/",i="[/\\\\]",C="[^/\\\\]",g=/\//g;function w(N){switch(N){case 0:return"";case 1:return`${C}*?`;default:return`(?:${i}|${C}+${i}|${i}${C}+)*?`}}function u(N,W){if(!N)return[];const _=[];let Y=!1,G=!1,ne="";for(const ee of N){switch(ee){case W:if(!Y&&!G){_.push(ne),ne="";continue}break;case"{":Y=!0;break;case"}":Y=!1;break;case"[":G=!0;break;case"]":G=!1;break}ne+=ee}return ne&&_.push(ne),_}e.splitGlobAware=u;function S(N){if(!N)return"";let W="";const _=u(N,b);if(_.every(Y=>Y===m))W=".*";else{let Y=!1;_.forEach((G,ne)=>{if(G===m){Y||(W+=w(2),Y=!0);return}let ee=!1,X="",B=!1,re="";for(const ie of G){if(ie!=="}"&&ee){X+=ie;continue}if(B&&(ie!=="]"||!re)){let ce;ie==="-"?ce=ie:(ie==="^"||ie==="!")&&!re?ce="^":ie===b?ce="":ce=k.escapeRegExpCharacters(ie),re+=ce;continue}switch(ie){case"{":ee=!0;continue;case"[":B=!0;continue;case"}":W+=`(?:${u(X,",").map(ge=>S(ge)).join("|")})`,ee=!1,X="";break;case"]":W+="["+re+"]",B=!1,re="";break;case"?":W+=C;continue;case"*":W+=w(1);continue;default:W+=k.escapeRegExpCharacters(ie)}}ne<_.length-1&&(_[ne+1]!==m||ne+2<_.length)&&(W+=i),Y=!1})}return W}const f=/^\*\*\/\*\.[\w\.-]+$/,I=/^\*\*\/([\w\.-]+)\/?$/,y=/^{\*\*\/[\*\.]?[\w\.-]+\/?(,\*\*\/[\*\.]?[\w\.-]+\/?)*}$/,E=/^{\*\*\/[\*\.]?[\w\.-]+(\/(\*\*)?)?(,\*\*\/[\*\.]?[\w\.-]+(\/(\*\*)?)?)*}$/,o=/^\*\*((\/[\w\.-]+)+)\/?$/,a=/^([\w\.-]+(\/[\w\.-]+)*)\/?$/,t=new R.LRUCache(1e4),r=function(){return!1},n=function(){return null};function s(N,W){if(!N)return n;let _;typeof N!="string"?_=N.pattern:_=N,_=_.trim();const Y=`${_}_${!!W.trimForExclusions}`;let G=t.get(Y);if(G)return c(G,N);let ne;if(f.test(_)){const ee=_.substr(4);G=function(X,B){return typeof X=="string"&&X.endsWith(ee)?_:null}}else(ne=I.exec(l(_,W)))?G=h(ne[1],_):(W.trimForExclusions?E:y).test(_)?G=d(_,W):(ne=o.exec(l(_,W)))?G=v(ne[1].substr(1),_,!0):(ne=a.exec(l(_,W)))?G=v(ne[1],_,!1):G=A(_);return t.set(Y,G),c(G,N)}function c(N,W){return typeof W=="string"?N:function(_,Y){return L.isEqualOrParent(_,W.base)?N(T.relative(W.base,_),Y):null}}function l(N,W){return W.trimForExclusions&&N.endsWith("/**")?N.substr(0,N.length-2):N}function h(N,W){const _=`/${N}`,Y=`\\${N}`,G=function(ee,X){return typeof ee!="string"?null:X?X===N?W:null:ee===N||ee.endsWith(_)||ee.endsWith(Y)?W:null},ne=[N];return G.basenames=ne,G.patterns=[W],G.allBasenames=ne,G}function d(N,W){const _=$(N.slice(1,-1).split(",").map(X=>s(X,W)).filter(X=>X!==n),N),Y=_.length;if(!Y)return n;if(Y===1)return _[0];const G=function(X,B){for(let re=0,ie=_.length;re<ie;re++)if(_[re](X,B))return N;return null},ne=_.find(X=>!!X.allBasenames);ne&&(G.allBasenames=ne.allBasenames);const ee=_.reduce((X,B)=>B.allPaths?X.concat(B.allPaths):X,[]);return ee.length&&(G.allPaths=ee),G}function v(N,W,_){const Y=T.sep===T.posix.sep,G=Y?N:N.replace(g,T.sep),ne=T.sep+G,ee=T.posix.sep+N,X=_?function(B,re){return typeof B=="string"&&(B===G||B.endsWith(ne)||!Y&&(B===N||B.endsWith(ee)))?W:null}:function(B,re){return typeof B=="string"&&(B===G||!Y&&B===N)?W:null};return X.allPaths=[(_?"*/":"./")+N],X}function A(N){try{const W=new RegExp(`^${S(N)}$`);return function(_){return W.lastIndex=0,typeof _=="string"&&W.test(_)?N:null}}catch(W){return n}}function O(N,W,_){return!N||typeof W!="string"?!1:p(N)(W,void 0,_)}e.match=O;function p(N,W={}){if(!N)return r;if(typeof N=="string"||H(N)){const _=s(N,W);if(_===n)return r;const Y=function(G,ne){return!!_(G,ne)};return _.allBasenames&&(Y.allBasenames=_.allBasenames),_.allPaths&&(Y.allPaths=_.allPaths),Y}return q(N,W)}e.parse=p;function U(N){if(!N)return;let W;return _=>(W||(W=(N()||Promise.resolve([])).then(Y=>Y?z(Y):{})),W.then(Y=>!!Y[_]))}e.hasSiblingPromiseFn=U;function F(N){if(!N)return;let W;return _=>{if(!W){const Y=N();W=Y?z(Y):{}}return!!W[_]}}e.hasSiblingFn=F;function z(N){const W={};for(const _ of N)W[_]=!0;return W}function H(N){const W=N;return W&&typeof W.base=="string"&&typeof W.pattern=="string"}e.isRelativePattern=H;function M(N){return N.allBasenames||[]}e.getBasenameTerms=M;function j(N){return N.allPaths||[]}e.getPathTerms=j;function q(N,W){const _=$(Object.getOwnPropertyNames(N).map(X=>x(X,N[X],W)).filter(X=>X!==n)),Y=_.length;if(!Y)return n;if(!_.some(X=>!!X.requiresSiblings)){if(Y===1)return _[0];const X=function(ie,ce){for(let ue=0,ge=_.length;ue<ge;ue++){const de=_[ue](ie,ce);if(de)return de}return null},B=_.find(ie=>!!ie.allBasenames);B&&(X.allBasenames=B.allBasenames);const re=_.reduce((ie,ce)=>ce.allPaths?ie.concat(ce.allPaths):ie,[]);return re.length&&(X.allPaths=re),X}const G=function(X,B,re){let ie;for(let ce=0,ue=_.length;ce<ue;ce++){const ge=_[ce];ge.requiresSiblings&&re&&(B||(B=T.basename(X)),ie||(ie=B.substr(0,B.length-T.extname(X).length)));const de=ge(X,B,ie,re);if(de)return de}return null},ne=_.find(X=>!!X.allBasenames);ne&&(G.allBasenames=ne.allBasenames);const ee=_.reduce((X,B)=>B.allPaths?X.concat(B.allPaths):X,[]);return ee.length&&(G.allPaths=ee),G}function x(N,W,_){if(W===!1)return n;const Y=s(N,_);if(Y===n)return n;if(typeof W=="boolean")return Y;if(W){const G=W.when;if(typeof G=="string"){const ne=(ee,X,B,re)=>{if(!re||!Y(ee,X))return null;const ie=G.replace("$(basename)",B),ce=re(ie);return(0,D.isThenable)(ce)?ce.then(ue=>ue?N:null):ce?N:null};return ne.requiresSiblings=!0,ne}}return Y}function $(N,W){const _=N.filter(X=>!!X.basenames);if(_.length<2)return N;const Y=_.reduce((X,B)=>{const re=B.basenames;return re?X.concat(re):X},[]);let G;if(W){G=[];for(let X=0,B=Y.length;X<B;X++)G.push(W)}else G=_.reduce((X,B)=>{const re=B.patterns;return re?X.concat(re):X},[]);const ne=function(X,B){if(typeof X!="string")return null;if(!B){let ie;for(ie=X.length;ie>0;ie--){const ce=X.charCodeAt(ie-1);if(ce===47||ce===92)break}B=X.substr(ie)}const re=Y.indexOf(B);return re!==-1?G[re]:null};ne.basenames=Y,ne.patterns=G,ne.allBasenames=Y;const ee=N.filter(X=>!X.basenames);return ee.push(ne),ee}}),define(Z[96],te([0,1,67,15,8,16,24]),function(K,e,D,L,R,T,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.normalizeMimeType=e.getExtensionForMimeType=e.getMediaMime=e.getMediaOrTextMime=e.isUnspecific=e.guessMimeTypes=e.clearTextMimes=e.registerTextMime=e.Mimes=void 0;var P;(function(s){s.text="text/plain",s.binary="application/octet-stream",s.unknown="application/unknown",s.markdown="text/markdown"})(P=e.Mimes||(e.Mimes={}));let m=[],b=[],i=[];function C(s,c=!1){const l=g(s);m.push(l),l.userConfigured?i.push(l):b.push(l),c&&!l.userConfigured&&m.forEach(h=>{h.mime===l.mime||h.userConfigured||(l.extension&&h.extension===l.extension&&console.warn(`Overwriting extension <<${l.extension}>> to now point to mime <<${l.mime}>>`),l.filename&&h.filename===l.filename&&console.warn(`Overwriting filename <<${l.filename}>> to now point to mime <<${l.mime}>>`),l.filepattern&&h.filepattern===l.filepattern&&console.warn(`Overwriting filepattern <<${l.filepattern}>> to now point to mime <<${l.mime}>>`),l.firstline&&h.firstline===l.firstline&&console.warn(`Overwriting firstline <<${l.firstline}>> to now point to mime <<${l.mime}>>`))})}e.registerTextMime=C;function g(s){return{id:s.id,mime:s.mime,filename:s.filename,extension:s.extension,filepattern:s.filepattern,firstline:s.firstline,userConfigured:s.userConfigured,filenameLowercase:s.filename?s.filename.toLowerCase():void 0,extensionLowercase:s.extension?s.extension.toLowerCase():void 0,filepatternLowercase:s.filepattern?(0,D.parse)(s.filepattern.toLowerCase()):void 0,filepatternOnPath:s.filepattern?s.filepattern.indexOf(R.posix.sep)>=0:!1}}function w(s){s?(m=m.filter(c=>!c.userConfigured),i=[]):(m=[],b=[],i=[])}e.clearTextMimes=w;function u(s,c){let l;if(s)switch(s.scheme){case L.Schemas.file:l=s.fsPath;break;case L.Schemas.data:l=T.DataUri.parseMetaData(s).get(T.DataUri.META_DATA_LABEL);break;default:l=s.path}if(!l)return[P.unknown];l=l.toLowerCase();const h=(0,R.basename)(l),d=S(l,h,i);if(d)return[d,P.text];const v=S(l,h,b);if(v)return[v,P.text];if(c){const A=f(c);if(A)return[A,P.text]}return[P.unknown]}e.guessMimeTypes=u;function S(s,c,l){let h=null,d=null,v=null;for(let A=l.length-1;A>=0;A--){const O=l[A];if(c===O.filenameLowercase){h=O;break}if(O.filepattern&&(!d||O.filepattern.length>d.filepattern.length)){const p=O.filepatternOnPath?s:c;O.filepatternLowercase?.(p)&&(d=O)}O.extension&&(!v||O.extension.length>v.extension.length)&&c.endsWith(O.extensionLowercase)&&(v=O)}return h?h.mime:d?d.mime:v?v.mime:null}function f(s){if((0,k.startsWithUTF8BOM)(s)&&(s=s.substr(1)),s.length>0)for(let c=m.length-1;c>=0;c--){const l=m[c];if(!l.firstline)continue;const h=s.match(l.firstline);if(h&&h.length>0)return l.mime}return null}function I(s){return s?typeof s=="string"?s===P.binary||s===P.text||s===P.unknown:s.length===1&&I(s[0]):!0}e.isUnspecific=I;const y={".css":"text/css",".csv":"text/csv",".htm":"text/html",".html":"text/html",".ics":"text/calendar",".js":"text/javascript",".mjs":"text/javascript",".txt":"text/plain",".xml":"text/xml"},E={".aac":"audio/x-aac",".avi":"video/x-msvideo",".bmp":"image/bmp",".flv":"video/x-flv",".gif":"image/gif",".ico":"image/x-icon",".jpe":"image/jpg",".jpeg":"image/jpg",".jpg":"image/jpg",".m1v":"video/mpeg",".m2a":"audio/mpeg",".m2v":"video/mpeg",".m3a":"audio/mpeg",".mid":"audio/midi",".midi":"audio/midi",".mk3d":"video/x-matroska",".mks":"video/x-matroska",".mkv":"video/x-matroska",".mov":"video/quicktime",".movie":"video/x-sgi-movie",".mp2":"audio/mpeg",".mp2a":"audio/mpeg",".mp3":"audio/mpeg",".mp4":"video/mp4",".mp4a":"audio/mp4",".mp4v":"video/mp4",".mpe":"video/mpeg",".mpeg":"video/mpeg",".mpg":"video/mpeg",".mpg4":"video/mp4",".mpga":"audio/mpeg",".oga":"audio/ogg",".ogg":"audio/ogg",".ogv":"video/ogg",".png":"image/png",".psd":"image/vnd.adobe.photoshop",".qt":"video/quicktime",".spx":"audio/ogg",".svg":"image/svg+xml",".tga":"image/x-tga",".tif":"image/tiff",".tiff":"image/tiff",".wav":"audio/x-wav",".webm":"video/webm",".webp":"image/webp",".wma":"audio/x-ms-wma",".wmv":"video/x-ms-wmv",".woff":"application/font-woff"};function o(s){const c=(0,R.extname)(s),l=y[c.toLowerCase()];return l!==void 0?l:a(s)}e.getMediaOrTextMime=o;function a(s){const c=(0,R.extname)(s);return E[c.toLowerCase()]}e.getMediaMime=a;function t(s){for(const c in E)if(E[c]===s)return c}e.getExtensionForMimeType=t;const r=/^(.+)\/(.+?)(;.+)?$/;function n(s,c){const l=r.exec(s);return l?`${l[1].toLowerCase()}/${l[2].toLowerCase()}${l[3]??""}`:c?void 0:s}e.normalizeMimeType=n}),define(Z[97],te([0,1,5]),function(K,e,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.transformAndReviveIncomingURIs=e.transformIncomingURIs=e.transformOutgoingURIs=e.DefaultURITransformer=e.URITransformer=void 0;function L(i){return i.toJSON()}class R{constructor(C){this._uriTransformer=C}transformIncoming(C){const g=this._uriTransformer.transformIncoming(C);return g===C?C:L(D.URI.from(g))}transformOutgoing(C){const g=this._uriTransformer.transformOutgoing(C);return g===C?C:L(D.URI.from(g))}transformOutgoingURI(C){const g=this._uriTransformer.transformOutgoing(C);return g===C?C:D.URI.from(g)}transformOutgoingScheme(C){return this._uriTransformer.transformOutgoingScheme(C)}}e.URITransformer=R,e.DefaultURITransformer=new class{transformIncoming(i){return i}transformOutgoing(i){return i}transformOutgoingURI(i){return i}transformOutgoingScheme(i){return i}};function T(i,C,g){if(!i||g>200)return null;if(typeof i=="object"){if(i instanceof D.URI)return C.transformOutgoing(i);for(let w in i)if(Object.hasOwnProperty.call(i,w)){const u=T(i[w],C,g+1);u!==null&&(i[w]=u)}}return null}function k(i,C){const g=T(i,C,0);return g===null?i:g}e.transformOutgoingURIs=k;function P(i,C,g,w){if(!i||w>200)return null;if(typeof i=="object"){if(i.$mid===1)return g?D.URI.revive(C.transformIncoming(i)):C.transformIncoming(i);for(let u in i)if(Object.hasOwnProperty.call(i,u)){const S=P(i[u],C,g,w+1);S!==null&&(i[u]=S)}}return null}function m(i,C){const g=P(i,C,!1,0);return g===null?i:g}e.transformIncomingURIs=m;function b(i,C){const g=P(i,C,!0,0);return g===null?i:g}e.transformAndReviveIncomingURIs=b}),define(Z[30],te([0,1]),function(K,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.generateUuid=e.isUUID=void 0;const D=/^[0-9a-f]{8}-[0-9a-f]{4}-[0-9a-f]{4}-[0-9a-f]{4}-[0-9a-f]{12}$/i;function L(m){return D.test(m)}e.isUUID=L;const R=new Uint8Array(16),T=[];for(let m=0;m<256;m++)T.push(m.toString(16).padStart(2,"0"));let k;typeof crypto=="object"&&typeof crypto.getRandomValues=="function"?k=crypto.getRandomValues.bind(crypto):k=function(m){for(let b=0;b<m.length;b++)m[b]=Math.floor(Math.random()*256);return m};function P(){k(R),R[6]=R[6]&15|64,R[8]=R[8]&63|128;let m=0,b="";return b+=T[R[m++]],b+=T[R[m++]],b+=T[R[m++]],b+=T[R[m++]],b+="-",b+=T[R[m++]],b+=T[R[m++]],b+="-",b+=T[R[m++]],b+=T[R[m++]],b+="-",b+=T[R[m++]],b+=T[R[m++]],b+="-",b+=T[R[m++]],b+=T[R[m++]],b+=T[R[m++]],b+=T[R[m++]],b+=T[R[m++]],b+=T[R[m++]],b}e.generateUuid=P}),define(Z[68],te([0,1,98]),function(K,e,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.LineDecoder=void 0;class L{constructor(T="utf8"){this.stringDecoder=new D.StringDecoder(T),this.remaining=null}write(T){const k=[],P=this.remaining?this.remaining+this.stringDecoder.write(T):this.stringDecoder.write(T);if(P.length<1)return k;let m=0,b,i=m;for(;i<P.length;)if(b=P.charCodeAt(i),b===13||b===10){if(k.push(P.substring(m,i)),i++,i<P.length){const C=b;b=P.charCodeAt(i),(C===13&&b===10||C===10&&b===13)&&i++}m=i}else i++;return this.remaining=m<P.length?P.substr(m):null,k}end(){return this.remaining}}e.LineDecoder=L}),define(Z[99],te([0,1,35]),function(K,e,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getMac=void 0;const L=new Set(["00:00:00:00:00:00","ff:ff:ff:ff:ff:ff","ac:de:48:00:11:22"]);function R(P){const m=P.replace(/\-/g,":").toLowerCase();return!L.has(m)}function T(){return new Promise(async(P,m)=>{const b=setTimeout(()=>m("Unable to retrieve mac address (timeout after 10s)"),1e4);try{P(await k())}catch(i){m(i)}finally{clearTimeout(b)}})}e.getMac=T;function k(){return new Promise((P,m)=>{try{const b=(0,D.networkInterfaces)();for(let i in b){const C=b[i];if(C){for(const{mac:g}of C)if(R(g))return P(g)}}m("Unable to retrieve mac address (unexpected format)")}catch(b){m(b)}})}}),define(Z[100],te([0,1,35,9,41,30,99]),function(K,e,D,L,R,T,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getMachineId=e.virtualMachineHint=void 0,e.virtualMachineHint=new class{_isVirtualMachineMacAddress(i){return this._virtualMachineOUIs||(this._virtualMachineOUIs=R.TernarySearchTree.forStrings(),this._virtualMachineOUIs.set("00-50-56",!0),this._virtualMachineOUIs.set("00-0C-29",!0),this._virtualMachineOUIs.set("00-05-69",!0),this._virtualMachineOUIs.set("00-03-FF",!0),this._virtualMachineOUIs.set("00-1C-42",!0),this._virtualMachineOUIs.set("00-16-3E",!0),this._virtualMachineOUIs.set("08-00-27",!0),this._virtualMachineOUIs.set("00:50:56",!0),this._virtualMachineOUIs.set("00:0C:29",!0),this._virtualMachineOUIs.set("00:05:69",!0),this._virtualMachineOUIs.set("00:03:FF",!0),this._virtualMachineOUIs.set("00:1C:42",!0),this._virtualMachineOUIs.set("00:16:3E",!0),this._virtualMachineOUIs.set("08:00:27",!0)),!!this._virtualMachineOUIs.findSubstr(i)}value(){if(this._value===void 0){let i=0,C=0;const g=(0,D.networkInterfaces)();for(let w in g){const u=g[w];if(u)for(const{mac:S,internal:f}of u)f||(C+=1,this._isVirtualMachineMacAddress(S.toUpperCase())&&(i+=1))}this._value=C>0?i/C:0}return this._value}};let P;async function m(){return P||(P=(async()=>await b()||T.generateUuid())()),P}e.getMachineId=m;async function b(){try{const i=await new Promise((g,w)=>{K(["crypto"],g,w)}),C=await(0,k.getMac)();return i.createHash("sha256").update(C,"utf8").digest("hex")}catch(i){L.onUnexpectedError(i);return}}}),define(Z[19],te([0,1,51,35,221,6,40,66,8,4,16,5,30]),function(K,e,D,L,R,T,k,P,m,b,i,C,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Promises=e.writeFileSync=e.SymlinkSupport=e.whenDeleted=e.readdirSync=e.rimrafSync=e.RimRafMode=void 0;var w;(function(M){M[M.UNLINK=0]="UNLINK",M[M.MOVE=1]="MOVE"})(w=e.RimRafMode||(e.RimRafMode={}));async function u(M,j=w.UNLINK){if((0,k.isRootOrDriveLetter)(M))throw new Error("rimraf - will refuse to recursively delete root");return j===w.UNLINK?f(M):S(M)}async function S(M){try{const j=(0,m.join)((0,L.tmpdir)(),(0,g.generateUuid)());try{await e.Promises.rename(M,j)}catch(q){return f(M)}f(j).catch(q=>{})}catch(j){if(j.code!=="ENOENT")throw j}}async function f(M){return e.Promises.rmdir(M,{recursive:!0,maxRetries:3})}function I(M){if((0,k.isRootOrDriveLetter)(M))throw new Error("rimraf - will refuse to recursively delete root");D.rmdirSync(M,{recursive:!0})}e.rimrafSync=I;async function y(M,j){return a(await(j?E(M):(0,R.promisify)(D.readdir)(M)))}async function E(M){try{return await(0,R.promisify)(D.readdir)(M,{withFileTypes:!0})}catch(x){console.warn("[node.js fs] readdir with filetypes failed with error: ",x)}const j=[],q=await y(M);for(const x of q){let $=!1,N=!1,W=!1;try{const _=await e.Promises.lstat((0,m.join)(M,x));$=_.isFile(),N=_.isDirectory(),W=_.isSymbolicLink()}catch(_){console.warn("[node.js fs] unexpected error from lstat after readdir: ",_)}j.push({name:x,isFile:()=>$,isDirectory:()=>N,isSymbolicLink:()=>W})}return j}function o(M){return a(D.readdirSync(M))}e.readdirSync=o;function a(M){return M.map(j=>typeof j=="string"?b.isMacintosh?(0,P.normalizeNFC)(j):j:(j.name=b.isMacintosh?(0,P.normalizeNFC)(j.name):j.name,j))}async function t(M){const j=await y(M),q=[];for(const x of j)await n.existsDirectory((0,m.join)(M,x))&&q.push(x);return q}function r(M,j=1e3){return new Promise(q=>{let x=!1;const $=setInterval(()=>{x||(x=!0,D.access(M,N=>{x=!1,N&&(clearInterval($),q(void 0))}))},j)})}e.whenDeleted=r;var n;(function(M){async function j($){let N;try{if(N=await e.Promises.lstat($),!N.isSymbolicLink())return{stat:N}}catch(W){}try{return{stat:await e.Promises.stat($),symbolicLink:N?.isSymbolicLink()?{dangling:!1}:void 0}}catch(W){if(W.code==="ENOENT"&&N)return{stat:N,symbolicLink:{dangling:!0}};if(b.isWindows&&W.code==="EACCES")try{return{stat:await e.Promises.stat(await e.Promises.readlink($)),symbolicLink:{dangling:!1}}}catch(_){if(_.code==="ENOENT"&&N)return{stat:N,symbolicLink:{dangling:!0}};throw _}throw W}}M.stat=j;async function q($){try{const{stat:N,symbolicLink:W}=await M.stat($);return N.isFile()&&W?.dangling!==!0}catch(N){}return!1}M.existsFile=q;async function x($){try{const{stat:N,symbolicLink:W}=await M.stat($);return N.isDirectory()&&W?.dangling!==!0}catch(N){}return!1}M.existsDirectory=x})(n=e.SymlinkSupport||(e.SymlinkSupport={}));const s=new T.ResourceQueue;function c(M,j,q){return s.queueFor(C.URI.file(M),i.extUriBiasedIgnorePathCase).queue(()=>{const x=v(q);return new Promise(($,N)=>h(M,j,x,W=>W?N(W):$()))})}let l=!0;function h(M,j,q,x){if(!l)return D.writeFile(M,j,{mode:q.mode,flag:q.flag},x);D.open(M,q.flag,q.mode,($,N)=>{if($)return x($);D.writeFile(N,j,W=>{if(W)return D.close(N,()=>x(W));D.fdatasync(N,_=>(_&&(console.warn("[node.js fs] fdatasync is now disabled for this session because it failed: ",_),l=!1),D.close(N,Y=>x(Y))))})})}function d(M,j,q){const x=v(q);if(!l)return D.writeFileSync(M,j,{mode:x.mode,flag:x.flag});const $=D.openSync(M,x.flag,x.mode);try{D.writeFileSync($,j);try{D.fdatasyncSync($)}catch(N){console.warn("[node.js fs] fdatasyncSync is now disabled for this session because it failed: ",N),l=!1}}finally{D.closeSync($)}}e.writeFileSync=d;function v(M){return M?{mode:typeof M.mode=="number"?M.mode:438,flag:typeof M.flag=="string"?M.flag:"w"}:{mode:438,flag:"w"}}async function A(M,j){if(M===j)return;async function q(x){try{const $=await e.Promises.lstat(x);if($.isDirectory()||$.isSymbolicLink())return;await e.Promises.utimes(x,$.atime,new Date)}catch($){}}try{await e.Promises.rename(M,j),await q(j)}catch(x){if(M.toLowerCase()!==j.toLowerCase()&&x.code==="EXDEV"||M.endsWith("."))await O(M,j,{preserveSymlinks:!1}),await u(M,w.MOVE),await q(j);else throw x}}async function O(M,j,q){return U(M,j,{root:{source:M,target:j},options:q,handledSourcePaths:new Set})}const p=511;async function U(M,j,q){if(q.handledSourcePaths.has(M))return;q.handledSourcePaths.add(M);const{stat:x,symbolicLink:$}=await n.stat(M);if($){if(q.options.preserveSymlinks)try{return await H(M,j,q)}catch(N){console.warn("[node.js fs] copy of symlink failed: ",N)}if($.dangling)return}return x.isDirectory()?F(M,j,x.mode&p,q):z(M,j,x.mode&p)}async function F(M,j,q,x){await e.Promises.mkdir(j,{recursive:!0,mode:q});const $=await y(M);for(const N of $)await U((0,m.join)(M,N),(0,m.join)(j,N),x)}async function z(M,j,q){await e.Promises.copyFile(M,j),await e.Promises.chmod(j,q)}async function H(M,j,q){let x=await e.Promises.readlink(M);(0,k.isEqualOrParent)(x,q.root.source,!b.isLinux)&&(x=(0,m.join)(q.root.target,x.substr(q.root.source.length+1))),await e.Promises.symlink(x,j)}e.Promises=new class{get access(){return(0,R.promisify)(D.access)}get stat(){return(0,R.promisify)(D.stat)}get lstat(){return(0,R.promisify)(D.lstat)}get utimes(){return(0,R.promisify)(D.utimes)}get read(){return(0,R.promisify)(D.read)}get readFile(){return(0,R.promisify)(D.readFile)}get write(){return(0,R.promisify)(D.write)}get appendFile(){return(0,R.promisify)(D.appendFile)}get fdatasync(){return(0,R.promisify)(D.fdatasync)}get truncate(){return(0,R.promisify)(D.truncate)}get rename(){return(0,R.promisify)(D.rename)}get copyFile(){return(0,R.promisify)(D.copyFile)}get open(){return(0,R.promisify)(D.open)}get close(){return(0,R.promisify)(D.close)}get symlink(){return(0,R.promisify)(D.symlink)}get readlink(){return(0,R.promisify)(D.readlink)}get chmod(){return(0,R.promisify)(D.chmod)}get mkdir(){return(0,R.promisify)(D.mkdir)}get unlink(){return(0,R.promisify)(D.unlink)}get rmdir(){return(0,R.promisify)(D.rmdir)}get realpath(){return(0,R.promisify)(D.realpath)}async exists(M){try{return await e.Promises.access(M),!0}catch{return!1}}get readdir(){return y}get readDirsInDir(){return t}get writeFile(){return c}get rm(){return u}get move(){return A}get copy(){return O}}}),define(Z[101],te([0,1,51,8,24,19]),function(K,e,D,L,R,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.realpathSync=e.realpath=e.realcaseSync=void 0;function k(i){const C=(0,L.dirname)(i);if(i===C)return i;const g=((0,L.basename)(i)||i).toLowerCase();try{const u=(0,T.readdirSync)(C).filter(S=>S.toLowerCase()===g);if(u.length===1){const S=k(C);if(S)return(0,L.join)(S,u[0])}else if(u.length>1){const S=u.indexOf(g);if(S>=0){const f=k(C);if(f)return(0,L.join)(f,u[S])}}}catch(w){}return null}e.realcaseSync=k;async function P(i){try{return await T.Promises.realpath(i)}catch(C){const g=b(i);return await T.Promises.access(g,D.constants.R_OK),g}}e.realpath=P;function m(i){try{return D.realpathSync(i)}catch(C){const g=b(i);return D.accessSync(g,D.constants.R_OK),g}}e.realpathSync=m;function b(i){return(0,R.rtrim)((0,L.normalize)(i),L.sep)}}),define(Z[69],te([0,1,35,8,19]),function(K,e,D,L,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getFirstAvailablePowerShellInstallation=e.enumeratePowerShellInstallations=void 0;const T=/^\d+$/,k=/^Microsoft.PowerShell_.*/,P=/^Microsoft.PowerShellPreview_.*/;var m;(function(o){o[o.x64=0]="x64",o[o.x86=1]="x86",o[o.ARM=2]="ARM"})(m||(m={}));let b;switch(process.arch){case"ia32":case"x32":b=1;break;case"arm":case"arm64":b=2;break;default:b=0;break}let i;process.env.PROCESSOR_ARCHITEW6432?i=process.env.PROCESSOR_ARCHITEW6432==="ARM64"?2:0:process.env.PROCESSOR_ARCHITECTURE==="ARM64"?i=2:process.env.PROCESSOR_ARCHITECTURE==="X86"?i=1:i=0;class C{constructor(a,t,r){this.exePath=a,this.displayName=t,this.knownToExist=r}async exists(){return this.knownToExist===void 0&&(this.knownToExist=await R.SymlinkSupport.existsFile(this.exePath)),this.knownToExist}}function g({useAlternateBitness:o=!1}={}){return o?b===0?process.env["ProgramFiles(x86)"]||null:i===0&&process.env.ProgramW6432||null:process.env.ProgramFiles||null}async function w({useAlternateBitness:o=!1,findPreview:a=!1}={}){const t=g({useAlternateBitness:o});if(!t)return null;const r=L.join(t,"PowerShell");if(!await R.SymlinkSupport.existsDirectory(r))return null;let n=-1,s=null;for(const h of await R.Promises.readdir(r)){let d=-1;if(a){const A=h.indexOf("-");if(A<0)continue;const O=h.substring(0,A);if(!T.test(O)||h.substring(A+1)!=="preview")continue;d=parseInt(O,10)}else{if(!T.test(h))continue;d=parseInt(h,10)}if(d<=n)continue;const v=L.join(r,h,"pwsh.exe");!await R.SymlinkSupport.existsFile(v)||(s=v,n=d)}if(!s)return null;const c=t.includes("x86")?" (x86)":"",l=a?" Preview":"";return new C(s,`PowerShell${l}${c}`,!0)}async function u({findPreview:o}={}){if(!process.env.LOCALAPPDATA)return null;const a=L.join(process.env.LOCALAPPDATA,"Microsoft","WindowsApps");if(!await R.SymlinkSupport.existsDirectory(a))return null;const{pwshMsixDirRegex:t,pwshMsixName:r}=o?{pwshMsixDirRegex:P,pwshMsixName:"PowerShell Preview (Store)"}:{pwshMsixDirRegex:k,pwshMsixName:"PowerShell (Store)"};for(const n of await R.Promises.readdir(a))if(t.test(n)){const s=L.join(a,n,"pwsh.exe");return new C(s,r)}return null}function S(){const o=L.join(D.homedir(),".dotnet","tools","pwsh.exe");return new C(o,".NET Core PowerShell Global Tool")}function f(){const o=L.join(process.env.windir,b===1&&i!==1?"SysNative":"System32","WindowsPowerShell","v1.0","powershell.exe");return new C(o,"Windows PowerShell",!0)}async function*I(){let o=await w();o&&(yield o),o=await w({useAlternateBitness:!0}),o&&(yield o),o=await u(),o&&(yield o),o=S(),o&&(yield o),o=await w({findPreview:!0}),o&&(yield o),o=await u({findPreview:!0}),o&&(yield o),o=await w({useAlternateBitness:!0,findPreview:!0}),o&&(yield o),o=f(),o&&(yield o)}async function*y(){for await(const o of I())await o.exists()&&(yield o)}e.enumeratePowerShellInstallations=y;async function E(){for await(const o of y())return o;return null}e.getFirstAvailablePowerShellInstallation=E}),define(Z[102],te([0,1,37,15]),function(K,e,D,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.listProcesses=void 0;function R(k){return new Promise((P,m)=>{let b;const i=new Map;function C(w,u,S,f,I){const y=i.get(u);if(w===k||y){const E={name:g(S),cmd:S,pid:w,ppid:u,load:f,mem:I};i.set(w,E),w===k&&(b=E),y&&(y.children||(y.children=[]),y.children.push(E),y.children.length>1&&(y.children=y.children.sort((o,a)=>o.pid-a.pid)))}}function g(w){const u=/--disable-blink-features=Auxclick/,S=/\\watcher\\win32\\CodeHelper\.exe/,f=/--crashes-directory/,I=/\\pipe\\winpty-control/,y=/conhost\.exe/,E=/--type=([a-zA-Z-]+)/;if(S.exec(w))return"watcherService ";if(f.exec(w))return"electron-crash-reporter";if(I.exec(w))return"winpty-process";if(y.exec(w))return"console-window-host (Windows internal process)";let o=E.exec(w);if(o&&o.length===2)return o[1]==="renderer"?u.exec(w)?"shared-process":"window":o[1];const a=/[a-zA-Z-]+\.js/g;let t="";do o=a.exec(w),o&&(t+=o+" ");while(o);return t&&w.indexOf("node ")<0&&w.indexOf("node.exe")<0?`electron_node ${t}`:w}if(process.platform==="win32"){const w=u=>u.indexOf("\\\\?\\")===0||u.indexOf("\\??\\")===0?u.substr(4):u.indexOf('"\\\\?\\')===0||u.indexOf('"\\??\\')===0?'"'+u.substr(5):u;new Promise((u,S)=>{K(["windows-process-tree"],u,S)}).then(u=>{u.getProcessList(k,S=>{u.getProcessCpuUsage(S,f=>{const I=new Map;f.forEach(y=>{const E=w(y.commandLine||"");I.set(y.pid,{name:g(E),cmd:E,pid:y.pid,ppid:y.ppid,load:y.cpu||0,mem:y.memory||0})}),b=I.get(k),b?(I.forEach(y=>{const E=I.get(y.ppid);E&&(E.children||(E.children=[]),E.children.push(y))}),I.forEach(y=>{y.children&&(y.children=y.children.sort((E,o)=>E.pid-o.pid))}),P(b)):m(new Error(`Root process ${k} not found`))})},u.ProcessDataFlag.CommandLine|u.ProcessDataFlag.Memory)})}else{let w=function(){let u=[b];const S=[];for(;u.length;){const I=u.shift();I&&(S.push(I.pid),I.children&&(u=u.concat(I.children)))}let f=JSON.stringify(L.FileAccess.asFileUri("vs/base/node/cpuUsage.sh",K).fsPath);f+=" "+S.join(" "),(0,D.exec)(f,{},(I,y,E)=>{if(I||E)m(I||new Error(E.toString()));else{const o=y.toString().split(`
`);for(let a=0;a<S.length;a++){const t=i.get(S[a]);t.load=parseFloat(o[a])}if(!b){m(new Error(`Root process ${k} not found`));return}P(b)}})};(0,D.exec)("which ps",{},(u,S,f)=>{if(u||f)if(process.platform!=="linux")m(u||new Error(f.toString()));else{const I=JSON.stringify(L.FileAccess.asFileUri("vs/base/node/ps.sh",K).fsPath);(0,D.exec)(I,{},(y,E,o)=>{y||o?m(y||new Error(o.toString())):(T(E,C),w())})}else{const I=S.toString().trim(),y="-ax -o pid=,ppid=,pcpu=,pmem=,command=";(0,D.exec)(`${I} ${y}`,{maxBuffer:1e3*1024,env:{LC_NUMERIC:"en_US.UTF-8"}},(E,o,a)=>{E||a&&!a.includes("screen size is bogus")?m(E||new Error(a.toString())):(T(o,C),process.platform==="linux"?w():b?P(b):m(new Error(`Root process ${k} not found`)))})}})}})}e.listProcesses=R;function T(k,P){const m=/^\s*([0-9]+)\s+([0-9]+)\s+([0-9]+\.[0-9]+)\s+([0-9]+\.[0-9]+)\s+(.+)$/,b=k.toString().split(`
`);for(const i of b){const C=m.exec(i.trim());C&&C.length===6&&P(parseInt(C[1]),parseInt(C[2]),C[5],parseFloat(C[3]),parseFloat(C[4]))}}}),define(Z[103],te([0,1,51,27,40,2,66,8,4,19]),function(K,e,D,L,R,T,k,P,m,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.watchFileContents=e.CHANGE_BUFFER_DELAY=e.watchFolder=e.watchFile=void 0;function i(u,S,f){return g({path:u,isDirectory:!1},S,f)}e.watchFile=i;function C(u,S,f){return g({path:u,isDirectory:!0},S,f)}e.watchFolder=C,e.CHANGE_BUFFER_DELAY=100;function g(u,S,f){if(m.isMacintosh&&(0,R.isEqualOrParent)(u.path,"/Volumes/"))return f(`Refusing to watch ${u.path} for changes using fs.watch() for possibly being a network share where watching is unreliable and unstable.`),T.Disposable.None;const I=(0,P.basename)(u.path),y=new Map;let E=!1,o=[(0,T.toDisposable)(()=>{y.forEach(a=>(0,T.dispose)(a)),y.clear()})];try{const a=(0,D.watch)(u.path);o.push((0,T.toDisposable)(()=>{a.removeAllListeners(),a.close()}));const t=new Set;u.isDirectory&&b.Promises.readdir(u.path).then(r=>r.forEach(n=>t.add(n))),a.on("error",(r,n)=>{E||f(`Failed to watch ${u.path} for changes using fs.watch() (${r}, ${n})`)}),a.on("change",(r,n)=>{if(E)return;let s="";if(n&&(s=n.toString(),m.isMacintosh&&(s=(0,k.normalizeNFC)(s))),!s||r!=="change"&&r!=="rename")return;const c=u.isDirectory?(0,P.join)(u.path,s):u.path;if(u.isDirectory)if(r==="rename"){const l=y.get(c);l&&(0,T.dispose)(l);const h=setTimeout(async()=>{y.delete(c);const d=await b.Promises.exists(c);if(E)return;let v;d?t.has(s)?v="changed":(v="added",t.add(s)):(t.delete(s),v="deleted"),S(v,c)},e.CHANGE_BUFFER_DELAY);y.set(c,(0,T.toDisposable)(()=>clearTimeout(h)))}else{let l;t.has(s)?l="changed":(l="added",t.add(s)),S(l,c)}else if(r==="rename"||s!==I){const l=setTimeout(async()=>{const h=await b.Promises.exists(c);E||(h?(S("changed",c),o=[g(u,S,f)]):S("deleted",c))},e.CHANGE_BUFFER_DELAY);(0,T.dispose)(o),o=[(0,T.toDisposable)(()=>clearTimeout(l))]}else S("changed",c)})}catch(a){b.Promises.exists(u.path).then(t=>{t&&!E&&f(`Failed to watch ${u.path} for changes using fs.watch() (${a.toString()})`)})}return(0,T.toDisposable)(()=>{E=!0,o=(0,T.dispose)(o)})}async function w(u,S,f,I=512){const y=await b.Promises.open(u,"r"),E=Buffer.allocUnsafe(I),o=new L.CancellationTokenSource(f);let a,t=!1;const r=i(u,async n=>{if(n==="changed"){if(t)return;t=!0;try{for(;!o.token.isCancellationRequested;){const{bytesRead:s}=await b.Promises.read(y,E,0,I,null);if(!s||o.token.isCancellationRequested)break;S(E.slice(0,s))}}catch(s){a=new Error(s),o.dispose(!0)}finally{t=!1}}},n=>{a=new Error(n),o.dispose(!0)});return new Promise((n,s)=>{o.token.onCancellationRequested(async()=>{r.dispose(),await b.Promises.close(y),a?s(a):n()})})}e.watchFileContents=w});var fe=this&&this.__decorate||function(K,e,D,L){var R=arguments.length,T=R<3?e:L===null?L=Object.getOwnPropertyDescriptor(e,D):L,k;if(typeof Reflect=="object"&&typeof Reflect.decorate=="function")T=Reflect.decorate(K,e,D,L);else for(var P=K.length-1;P>=0;P--)(k=K[P])&&(T=(R<3?k(T):R>3?k(e,D,T):k(e,D))||T);return R>3&&T&&Object.defineProperty(e,D,T),T};define(Z[36],te([0,1,17,6,25,27,64,9,3,2,95,24,18]),function(K,e,D,L,R,T,k,P,m,b,i,C,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IPCLogger=e.logWithColors=e.ProxyChannel=e.StaticRouter=e.getNextTickChannel=e.getDelayedChannel=e.IPCClient=e.IPCServer=e.ChannelClient=e.RequestInitiator=e.ChannelServer=e.ResponseType=e.RequestType=void 0;var w;(function($){$[$.Promise=100]="Promise",$[$.PromiseCancel=101]="PromiseCancel",$[$.EventListen=102]="EventListen",$[$.EventDispose=103]="EventDispose"})(w=e.RequestType||(e.RequestType={}));function u($){switch($){case 100:return"req";case 101:return"cancel";case 102:return"subscribe";case 103:return"unsubscribe"}}var S;(function($){$[$.Initialize=200]="Initialize",$[$.PromiseSuccess=201]="PromiseSuccess",$[$.PromiseError=202]="PromiseError",$[$.PromiseErrorObj=203]="PromiseErrorObj",$[$.EventFire=204]="EventFire"})(S=e.ResponseType||(e.ResponseType={}));function f($){switch($){case 200:return"init";case 201:return"reply:";case 202:case 203:return"replyErr:";case 204:return"event:"}}var I;(function($){$[$.Uninitialized=0]="Uninitialized",$[$.Idle=1]="Idle"})(I||(I={}));class y{constructor(N){this.buffer=N,this.pos=0}read(N){const W=this.buffer.slice(this.pos,this.pos+N);return this.pos+=W.byteLength,W}}class E{constructor(){this.buffers=[]}get buffer(){return R.VSBuffer.concat(this.buffers)}write(N){this.buffers.push(N)}}var o;(function($){$[$.Undefined=0]="Undefined",$[$.String=1]="String",$[$.Buffer=2]="Buffer",$[$.VSBuffer=3]="VSBuffer",$[$.Array=4]="Array",$[$.Object=5]="Object"})(o||(o={}));function a($){const N=R.VSBuffer.alloc(4);return N.writeUInt32BE($,0),N}function t($){return $.read(4).readUInt32BE(0)}function r($){const N=R.VSBuffer.alloc(1);return N.writeUInt8($,0),N}const n={Undefined:r(o.Undefined),String:r(o.String),Buffer:r(o.Buffer),VSBuffer:r(o.VSBuffer),Array:r(o.Array),Object:r(o.Object)},s=typeof Buffer!="undefined";function c($,N){if(typeof N=="undefined")$.write(n.Undefined);else if(typeof N=="string"){const W=R.VSBuffer.fromString(N);$.write(n.String),$.write(a(W.byteLength)),$.write(W)}else if(s&&Buffer.isBuffer(N)){const W=R.VSBuffer.wrap(N);$.write(n.Buffer),$.write(a(W.byteLength)),$.write(W)}else if(N instanceof R.VSBuffer)$.write(n.VSBuffer),$.write(a(N.byteLength)),$.write(N);else if(Array.isArray(N)){$.write(n.Array),$.write(a(N.length));for(const W of N)c($,W)}else{const W=R.VSBuffer.fromString(JSON.stringify(N));$.write(n.Object),$.write(a(W.byteLength)),$.write(W)}}function l($){switch($.read(1).readUInt8(0)){case o.Undefined:return;case o.String:return $.read(t($)).toString();case o.Buffer:return $.read(t($)).buffer;case o.VSBuffer:return $.read(t($));case o.Array:{const W=t($),_=[];for(let Y=0;Y<W;Y++)_.push(l($));return _}case o.Object:return JSON.parse($.read(t($)).toString())}}class h{constructor(N,W,_=null,Y=1e3){this.protocol=N,this.ctx=W,this.logger=_,this.timeoutDelay=Y,this.channels=new Map,this.activeRequests=new Map,this.pendingRequests=new Map,this.protocolListener=this.protocol.onMessage(G=>this.onRawMessage(G)),this.sendResponse({type:200})}registerChannel(N,W){this.channels.set(N,W),setTimeout(()=>this.flushPendingRequests(N),0)}sendResponse(N){switch(N.type){case 200:{const W=this.send([N.type]);this.logger&&this.logger.logOutgoing(W,0,1,f(N.type));return}case 201:case 202:case 204:case 203:{const W=this.send([N.type,N.id],N.data);this.logger&&this.logger.logOutgoing(W,N.id,1,f(N.type),N.data);return}}}send(N,W=void 0){const _=new E;return c(_,N),c(_,W),this.sendBuffer(_.buffer)}sendBuffer(N){try{return this.protocol.send(N),N.byteLength}catch(W){return 0}}onRawMessage(N){const W=new y(N),_=l(W),Y=l(W),G=_[0];switch(G){case 100:return this.logger&&this.logger.logIncoming(N.byteLength,_[1],1,`${u(G)}: ${_[2]}.${_[3]}`,Y),this.onPromise({type:G,id:_[1],channelName:_[2],name:_[3],arg:Y});case 102:return this.logger&&this.logger.logIncoming(N.byteLength,_[1],1,`${u(G)}: ${_[2]}.${_[3]}`,Y),this.onEventListen({type:G,id:_[1],channelName:_[2],name:_[3],arg:Y});case 101:return this.logger&&this.logger.logIncoming(N.byteLength,_[1],1,`${u(G)}`),this.disposeActiveRequest({type:G,id:_[1]});case 103:return this.logger&&this.logger.logIncoming(N.byteLength,_[1],1,`${u(G)}`),this.disposeActiveRequest({type:G,id:_[1]})}}onPromise(N){const W=this.channels.get(N.channelName);if(!W){this.collectPendingRequest(N);return}const _=new T.CancellationTokenSource;let Y;try{Y=W.call(this.ctx,N.name,N.arg,_.token)}catch(ee){Y=Promise.reject(ee)}const G=N.id;Y.then(ee=>{this.sendResponse({id:G,data:ee,type:201}),this.activeRequests.delete(N.id)},ee=>{ee instanceof Error?this.sendResponse({id:G,data:{message:ee.message,name:ee.name,stack:ee.stack?ee.stack.split?ee.stack.split(`
`):ee.stack:void 0},type:202}):this.sendResponse({id:G,data:ee,type:203}),this.activeRequests.delete(N.id)});const ne=(0,b.toDisposable)(()=>_.cancel());this.activeRequests.set(N.id,ne)}onEventListen(N){const W=this.channels.get(N.channelName);if(!W){this.collectPendingRequest(N);return}const _=N.id,G=W.listen(this.ctx,N.name,N.arg)(ne=>this.sendResponse({id:_,data:ne,type:204}));this.activeRequests.set(N.id,G)}disposeActiveRequest(N){const W=this.activeRequests.get(N.id);W&&(W.dispose(),this.activeRequests.delete(N.id))}collectPendingRequest(N){let W=this.pendingRequests.get(N.channelName);W||(W=[],this.pendingRequests.set(N.channelName,W));const _=setTimeout(()=>{console.error(`Unknown channel: ${N.channelName}`),N.type===100&&this.sendResponse({id:N.id,data:{name:"Unknown channel",message:`Channel name '${N.channelName}' timed out after ${this.timeoutDelay}ms`,stack:void 0},type:202})},this.timeoutDelay);W.push({request:N,timeoutTimer:_})}flushPendingRequests(N){const W=this.pendingRequests.get(N);if(W){for(const _ of W)switch(clearTimeout(_.timeoutTimer),_.request.type){case 100:this.onPromise(_.request);break;case 102:this.onEventListen(_.request);break}this.pendingRequests.delete(N)}}dispose(){this.protocolListener&&(this.protocolListener.dispose(),this.protocolListener=null),this.activeRequests.forEach(N=>N.dispose()),this.activeRequests.clear()}}e.ChannelServer=h;var d;(function($){$[$.LocalSide=0]="LocalSide",$[$.OtherSide=1]="OtherSide"})(d=e.RequestInitiator||(e.RequestInitiator={}));class v{constructor(N,W=null){this.protocol=N,this.isDisposed=!1,this.state=I.Uninitialized,this.activeRequests=new Set,this.handlers=new Map,this.lastRequestId=0,this._onDidInitialize=new m.Emitter,this.onDidInitialize=this._onDidInitialize.event,this.protocolListener=this.protocol.onMessage(_=>this.onBuffer(_)),this.logger=W}getChannel(N){const W=this;return{call(_,Y,G){return W.isDisposed?Promise.reject(P.canceled()):W.requestPromise(N,_,Y,G)},listen(_,Y){return W.isDisposed?Promise.reject(P.canceled()):W.requestEvent(N,_,Y)}}}requestPromise(N,W,_,Y=T.CancellationToken.None){const G=this.lastRequestId++,ee={id:G,type:100,channelName:N,name:W,arg:_};if(Y.isCancellationRequested)return Promise.reject(P.canceled());let X;return new Promise((re,ie)=>{if(Y.isCancellationRequested)return ie(P.canceled());const ce=()=>{const Ie=Pe=>{switch(Pe.type){case 201:this.handlers.delete(G),re(Pe.data);break;case 202:this.handlers.delete(G);const Ee=new Error(Pe.data.message);Ee.stack=Pe.data.stack,Ee.name=Pe.data.name,ie(Ee);break;case 203:this.handlers.delete(G),ie(Pe.data);break}};this.handlers.set(G,Ie),this.sendRequest(ee)};let ue=null;this.state===I.Idle?ce():(ue=(0,L.createCancelablePromise)(Ie=>this.whenInitialized()),ue.then(()=>{ue=null,ce()}));const ge=()=>{ue?(ue.cancel(),ue=null):this.sendRequest({id:G,type:101}),ie(P.canceled())},de=Y.onCancellationRequested(ge);X=(0,b.combinedDisposable)((0,b.toDisposable)(ge),de),this.activeRequests.add(X)}).finally(()=>{this.activeRequests.delete(X)})}requestEvent(N,W,_){const Y=this.lastRequestId++,ne={id:Y,type:102,channelName:N,name:W,arg:_};let ee=null;const X=new m.Emitter({onFirstListenerAdd:()=>{ee=(0,L.createCancelablePromise)(re=>this.whenInitialized()),ee.then(()=>{ee=null,this.activeRequests.add(X),this.sendRequest(ne)})},onLastListenerRemove:()=>{ee?(ee.cancel(),ee=null):(this.activeRequests.delete(X),this.sendRequest({id:Y,type:103}))}}),B=re=>X.fire(re.data);return this.handlers.set(Y,B),X.event}sendRequest(N){switch(N.type){case 100:case 102:{const W=this.send([N.type,N.id,N.channelName,N.name],N.arg);this.logger&&this.logger.logOutgoing(W,N.id,0,`${u(N.type)}: ${N.channelName}.${N.name}`,N.arg);return}case 101:case 103:{const W=this.send([N.type,N.id]);this.logger&&this.logger.logOutgoing(W,N.id,0,u(N.type));return}}}send(N,W=void 0){const _=new E;return c(_,N),c(_,W),this.sendBuffer(_.buffer)}sendBuffer(N){try{return this.protocol.send(N),N.byteLength}catch(W){return 0}}onBuffer(N){const W=new y(N),_=l(W),Y=l(W),G=_[0];switch(G){case 200:return this.logger&&this.logger.logIncoming(N.byteLength,0,0,f(G)),this.onResponse({type:_[0]});case 201:case 202:case 204:case 203:return this.logger&&this.logger.logIncoming(N.byteLength,_[1],0,f(G),Y),this.onResponse({type:_[0],id:_[1],data:Y})}}onResponse(N){if(N.type===200){this.state=I.Idle,this._onDidInitialize.fire();return}const W=this.handlers.get(N.id);W&&W(N)}get onDidInitializePromise(){return m.Event.toPromise(this.onDidInitialize)}whenInitialized(){return this.state===I.Idle?Promise.resolve():this.onDidInitializePromise}dispose(){this.isDisposed=!0,this.protocolListener&&(this.protocolListener.dispose(),this.protocolListener=null),this.activeRequests.forEach(N=>N.dispose()),this.activeRequests.clear()}}fe([k.memoize],v.prototype,"onDidInitializePromise",null),e.ChannelClient=v;class A{constructor(N){this.channels=new Map,this._connections=new Set,this._onDidAddConnection=new m.Emitter,this.onDidAddConnection=this._onDidAddConnection.event,this._onDidRemoveConnection=new m.Emitter,this.onDidRemoveConnection=this._onDidRemoveConnection.event,N(({protocol:W,onDidClientDisconnect:_})=>{m.Event.once(W.onMessage)(G=>{const ne=new y(G),ee=l(ne),X=new h(W,ee),B=new v(W);this.channels.forEach((ie,ce)=>X.registerChannel(ce,ie));const re={channelServer:X,channelClient:B,ctx:ee};this._connections.add(re),this._onDidAddConnection.fire(re),_(()=>{X.dispose(),B.dispose(),this._connections.delete(re),this._onDidRemoveConnection.fire(re)})})})}get connections(){const N=[];return this._connections.forEach(W=>N.push(W)),N}getChannel(N,W){const _=this;return{call(Y,G,ne){let ee;if((0,g.isFunction)(W)){let B=(0,D.getRandomElement)(_.connections.filter(W));ee=B?Promise.resolve(B):m.Event.toPromise(m.Event.filter(_.onDidAddConnection,W))}else ee=W.routeCall(_,Y,G);const X=ee.then(B=>B.channelClient.getChannel(N));return p(X).call(Y,G,ne)},listen(Y,G){if((0,g.isFunction)(W))return _.getMulticastEvent(N,W,Y,G);const ne=W.routeEvent(_,Y,G).then(ee=>ee.channelClient.getChannel(N));return p(ne).listen(Y,G)}}}getMulticastEvent(N,W,_,Y){const G=this;let ne=new b.DisposableStore;const ee=new m.Emitter({onFirstListenerAdd:()=>{ne=new b.DisposableStore;const X=new m.EventMultiplexer,B=new Map,re=ce=>{const ge=ce.channelClient.getChannel(N).listen(_,Y),de=X.add(ge);B.set(ce,de)},ie=ce=>{const ue=B.get(ce);!ue||(ue.dispose(),B.delete(ce))};G.connections.filter(W).forEach(re),m.Event.filter(G.onDidAddConnection,W)(re,void 0,ne),G.onDidRemoveConnection(ie,void 0,ne),X.event(ee.fire,ee,ne),ne.add(X)},onLastListenerRemove:()=>{ne.dispose()}});return ee.event}registerChannel(N,W){this.channels.set(N,W),this._connections.forEach(_=>{_.channelServer.registerChannel(N,W)})}dispose(){this.channels.clear(),this._connections.clear(),this._onDidAddConnection.dispose(),this._onDidRemoveConnection.dispose()}}e.IPCServer=A;class O{constructor(N,W,_=null){const Y=new E;c(Y,W),N.send(Y.buffer),this.channelClient=new v(N,_),this.channelServer=new h(N,W,_)}getChannel(N){return this.channelClient.getChannel(N)}registerChannel(N,W){this.channelServer.registerChannel(N,W)}dispose(){this.channelClient.dispose(),this.channelServer.dispose()}}e.IPCClient=O;function p($){return{call(N,W,_){return $.then(Y=>Y.call(N,W,_))},listen(N,W){const _=new m.Relay;return $.then(Y=>_.input=Y.listen(N,W)),_.event}}}e.getDelayedChannel=p;function U($){let N=!1;return{call(W,_,Y){return N?$.call(W,_,Y):(0,L.timeout)(0).then(()=>N=!0).then(()=>$.call(W,_,Y))},listen(W,_){if(N)return $.listen(W,_);const Y=new m.Relay;return(0,L.timeout)(0).then(()=>N=!0).then(()=>Y.input=$.listen(W,_)),Y.event}}}e.getNextTickChannel=U;class F{constructor(N){this.fn=N}routeCall(N){return this.route(N)}routeEvent(N){return this.route(N)}async route(N){for(const W of N.connections)if(await Promise.resolve(this.fn(W.ctx)))return Promise.resolve(W);return await m.Event.toPromise(N.onDidAddConnection),await this.route(N)}}e.StaticRouter=F;var z;(function($){function N(G,ne){const ee=G,X=ne&&ne.disableMarshalling,B=new Map;for(const re in ee)_(re)&&B.set(re,m.Event.buffer(ee[re],!0));return new class{listen(re,ie,ce){const ue=B.get(ie);if(ue)return ue;if(Y(ie)){const ge=ee[ie];if(typeof ge=="function")return ge.call(ee,ce)}throw new Error(`Event not found: ${ie}`)}call(re,ie,ce){const ue=ee[ie];if(typeof ue=="function"){if(!X&&Array.isArray(ce))for(let ge=0;ge<ce.length;ge++)ce[ge]=(0,i.revive)(ce[ge]);return ue.apply(ee,ce)}throw new Error(`Method not found: ${ie}`)}}}$.fromService=N;function W(G,ne){const ee=ne&&ne.disableMarshalling;return new Proxy({},{get(X,B){if(typeof B=="string")return ne?.properties?.has(B)?ne.properties.get(B):Y(B)?function(re){return G.listen(B,re)}:_(B)?G.listen(B):async function(...re){let ie;ne&&!(0,g.isUndefinedOrNull)(ne.context)?ie=[ne.context,...re]:ie=re;const ce=await G.call(B,ie);return ee?ce:(0,i.revive)(ce)};throw new Error(`Property not found: ${String(B)}`)}})}$.toService=W;function _(G){return G[0]==="o"&&G[1]==="n"&&C.isUpperAsciiLetter(G.charCodeAt(2))}function Y(G){return/^onScoped/.test(G)&&C.isUpperAsciiLetter(G.charCodeAt(8))}})(z=e.ProxyChannel||(e.ProxyChannel={}));const H=[["#2977B1","#FC802D","#34A13A","#D3282F","#9366BA"],["#8B564C","#E177C0","#7F7F7F","#BBBE3D","#2EBECD"]];function M($){if(Array.isArray($))return $;if($&&typeof $=="object"&&typeof $.toString=="function"){let N=$.toString();if(N!=="[object Object]")return N}return $}function j($){return Array.isArray($)?$.map(M):M($)}function q($,N,W,_,Y,G,ne){ne=j(ne);const ee=H[Y],X=ee[_%ee.length];let B=[`%c[${$}]%c[${String(N).padStart(7," ")}]%c[len: ${String(W).padStart(5," ")}]%c${String(_).padStart(5," ")} - ${G}`,"color: darkgreen","color: grey","color: grey",`color: ${X}`];/\($/.test(G)?(B=B.concat(ne),B.push(")")):B.push(ne),console.log.apply(console,B)}e.logWithColors=q;class x{constructor(N,W){this._outgoingPrefix=N,this._incomingPrefix=W,this._totalIncoming=0,this._totalOutgoing=0}logOutgoing(N,W,_,Y,G){this._totalOutgoing+=N,q(this._outgoingPrefix,this._totalOutgoing,N,W,_,Y,G)}logIncoming(N,W,_,Y,G){this._totalIncoming+=N,q(this._incomingPrefix,this._totalIncoming,N,W,_,Y,G)}}e.IPCLogger=x}),define(Z[104],te([0,1,25,3,36]),function(K,e,D,L,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Client=e.Protocol=void 0;class T{constructor(m){this.port=m,this.onMessage=L.Event.fromDOMEventEmitter(this.port,"message",b=>D.VSBuffer.wrap(b.data)),m.start()}send(m){this.port.postMessage(m.buffer)}disconnect(){this.port.close()}}e.Protocol=T;class k extends R.IPCClient{constructor(m,b){const i=new T(m);super(i,b);this.protocol=i}dispose(){this.protocol.disconnect()}}e.Client=k}),define(Z[105],te([0,1,106,3,36,104]),function(K,e,D,L,R,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Server=void 0;class k extends R.IPCServer{static getOnDidClientConnect(){const m=L.Event.fromNodeEventEmitter(D.ipcRenderer,"vscode:createMessageChannel",(b,i)=>i);return L.Event.map(m,b=>{const{port1:i,port2:C}=new MessageChannel,w={protocol:new T.Protocol(i),onDidClientDisconnect:L.Event.fromDOMEventEmitter(i,"close")};return D.ipcRenderer.postMessage("vscode:createMessageChannelResult",b,[C]),w})}constructor(){super(k.getOnDidClientConnect())}}e.Server=k}),define(Z[107],te([0,1,25,9]),function(K,e,D,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.request=void 0;function R(P,m){P.proxyAuthorization&&(P.headers={...P.headers||{},"Proxy-Authorization":P.proxyAuthorization});const b=new XMLHttpRequest;return new Promise((i,C)=>{b.open(P.type||"GET",P.url||"",!0,P.user,P.password),T(b,P),b.responseType="arraybuffer",b.onerror=g=>C(new Error(b.statusText&&"XHR failed: "+b.statusText||"XHR failed")),b.onload=g=>{i({res:{statusCode:b.status,headers:k(b)},stream:(0,D.bufferToStream)(D.VSBuffer.wrap(new Uint8Array(b.response)))})},b.ontimeout=g=>C(new Error(`XHR timeout: ${P.timeout}ms`)),P.timeout&&(b.timeout=P.timeout),b.send(P.data),m.onCancellationRequested(()=>{b.abort(),C((0,L.canceled)())})})}e.request=R;function T(P,m){if(m.headers){e:for(let b in m.headers){switch(b){case"User-Agent":case"Accept-Encoding":case"Content-Length":continue e}P.setRequestHeader(b,m.headers[b])}}}function k(P){const m=Object.create(null);for(const b of P.getAllResponseHeaders().split(/\r\n|\n|\r/g))if(b){const i=b.indexOf(":");m[b.substr(0,i).trim().toLowerCase()]=b.substr(i+1).trim()}return m}}),define(Z[70],te([0,1,6,3,2,18]),function(K,e,D,L,R,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.InMemoryStorageDatabase=e.Storage=e.isStorageItemsChangeEvent=e.StorageHint=void 0;var k;(function(C){C[C.STORAGE_DOES_NOT_EXIST=0]="STORAGE_DOES_NOT_EXIST"})(k=e.StorageHint||(e.StorageHint={}));function P(C){const g=C;return g?.changed instanceof Map||g?.deleted instanceof Set}e.isStorageItemsChangeEvent=P;var m;(function(C){C[C.None=0]="None",C[C.Initialized=1]="Initialized",C[C.Closed=2]="Closed"})(m||(m={}));class b extends R.Disposable{constructor(g,w=Object.create(null)){super();this.database=g,this.options=w,this._onDidChangeStorage=this._register(new L.Emitter),this.onDidChangeStorage=this._onDidChangeStorage.event,this.state=m.None,this.cache=new Map,this.flushDelayer=new D.ThrottledDelayer(b.DEFAULT_FLUSH_DELAY),this.pendingDeletes=new Set,this.pendingInserts=new Map,this.pendingClose=void 0,this.whenFlushedCallbacks=[],this.registerListeners()}registerListeners(){this._register(this.database.onDidChangeItemsExternal(g=>this.onDidChangeItemsExternal(g)))}onDidChangeItemsExternal(g){g.changed?.forEach((w,u)=>this.accept(u,w)),g.deleted?.forEach(w=>this.accept(w,void 0))}accept(g,w){if(this.state===m.Closed)return;let u=!1;(0,T.isUndefinedOrNull)(w)?u=this.cache.delete(g):this.cache.get(g)!==w&&(this.cache.set(g,w),u=!0),u&&this._onDidChangeStorage.fire(g)}get items(){return this.cache}get size(){return this.cache.size}async init(){this.state===m.None&&(this.state=m.Initialized,this.options.hint!==k.STORAGE_DOES_NOT_EXIST&&(this.cache=await this.database.getItems()))}get(g,w){const u=this.cache.get(g);return(0,T.isUndefinedOrNull)(u)?w:u}getBoolean(g,w){const u=this.get(g);return(0,T.isUndefinedOrNull)(u)?w:u==="true"}getNumber(g,w){const u=this.get(g);return(0,T.isUndefinedOrNull)(u)?w:parseInt(u,10)}async set(g,w){if(this.state===m.Closed)return;if((0,T.isUndefinedOrNull)(w))return this.delete(g);const u=String(w);if(this.cache.get(g)!==u)return this.cache.set(g,u),this.pendingInserts.set(g,u),this.pendingDeletes.delete(g),this._onDidChangeStorage.fire(g),this.flushDelayer.trigger(()=>this.flushPending())}async delete(g){if(!(this.state===m.Closed||!this.cache.delete(g)))return this.pendingDeletes.has(g)||this.pendingDeletes.add(g),this.pendingInserts.delete(g),this._onDidChangeStorage.fire(g),this.flushDelayer.trigger(()=>this.flushPending())}async close(){return this.pendingClose||(this.pendingClose=this.doClose()),this.pendingClose}async doClose(){this.state=m.Closed;try{await this.flushDelayer.trigger(()=>this.flushPending(),0)}catch(g){}await this.database.close(()=>this.cache)}get hasPending(){return this.pendingInserts.size>0||this.pendingDeletes.size>0}async flushPending(){if(!this.hasPending)return;const g={insert:this.pendingInserts,delete:this.pendingDeletes};return this.pendingDeletes=new Set,this.pendingInserts=new Map,this.database.updateItems(g).finally(()=>{if(!this.hasPending)for(;this.whenFlushedCallbacks.length;)this.whenFlushedCallbacks.pop()?.()})}async whenFlushed(){if(!!this.hasPending)return new Promise(g=>this.whenFlushedCallbacks.push(g))}dispose(){this.flushDelayer.dispose(),super.dispose()}}e.Storage=b,b.DEFAULT_FLUSH_DELAY=100;class i{constructor(){this.onDidChangeItemsExternal=L.Event.None,this.items=new Map}async getItems(){return this.items}async updateItems(g){g.insert&&g.insert.forEach((w,u)=>this.items.set(u,w)),g.delete&&g.delete.forEach(w=>this.items.delete(w))}async close(){}}e.InMemoryStorageDatabase=i}),define(Z[108],te([10,11]),function(K,e){return K.create("vs/base/common/date",e)}),define(Z[56],te([0,1,108]),function(K,e,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.toLocalISOString=e.fromNow=void 0;const L=60,R=L*60,T=R*24,k=T*7,P=T*30,m=T*365;function b(C,g){typeof C!="number"&&(C=C.getTime());const w=Math.round((new Date().getTime()-C)/1e3);if(w<-30)return(0,D.localize)(0,null,b(new Date().getTime()+w*1e3,!1));if(w<30)return(0,D.localize)(1,null);let u;return w<L?(u=w,g?u===1?(0,D.localize)(2,null,u):(0,D.localize)(3,null,u):u===1?(0,D.localize)(4,null,u):(0,D.localize)(5,null,u)):w<R?(u=Math.floor(w/L),g?u===1?(0,D.localize)(6,null,u):(0,D.localize)(7,null,u):u===1?(0,D.localize)(8,null,u):(0,D.localize)(9,null,u)):w<T?(u=Math.floor(w/R),g?u===1?(0,D.localize)(10,null,u):(0,D.localize)(11,null,u):u===1?(0,D.localize)(12,null,u):(0,D.localize)(13,null,u)):w<k?(u=Math.floor(w/T),g?u===1?(0,D.localize)(14,null,u):(0,D.localize)(15,null,u):u===1?(0,D.localize)(16,null,u):(0,D.localize)(17,null,u)):w<P?(u=Math.floor(w/k),g?u===1?(0,D.localize)(18,null,u):(0,D.localize)(19,null,u):u===1?(0,D.localize)(20,null,u):(0,D.localize)(21,null,u)):w<m?(u=Math.floor(w/P),g?u===1?(0,D.localize)(22,null,u):(0,D.localize)(23,null,u):u===1?(0,D.localize)(24,null,u):(0,D.localize)(25,null,u)):(u=Math.floor(w/m),g?u===1?(0,D.localize)(26,null,u):(0,D.localize)(27,null,u):u===1?(0,D.localize)(28,null,u):(0,D.localize)(29,null,u))}e.fromNow=b;function i(C){return C.getFullYear()+"-"+String(C.getMonth()+1).padStart(2,"0")+"-"+String(C.getDate()).padStart(2,"0")+"T"+String(C.getHours()).padStart(2,"0")+":"+String(C.getMinutes()).padStart(2,"0")+":"+String(C.getSeconds()).padStart(2,"0")+"."+(C.getMilliseconds()/1e3).toFixed(3).slice(2,5)+"Z"}e.toLocalISOString=i}),define(Z[109],te([10,11]),function(K,e){return K.create("vs/base/common/errorMessage",e)}),define(Z[38],te([0,1,17,18,109]),function(K,e,D,L,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.toErrorMessage=void 0;function T(b,i){return i&&(b.stack||b.stacktrace)?R.localize(0,null,P(b),k(b.stack)||k(b.stacktrace)):P(b)}function k(b){return Array.isArray(b)?b.join(`
`):b}function P(b){return typeof b.code=="string"&&typeof b.errno=="number"&&typeof b.syscall=="string"?R.localize(1,null,b.message):b.message||R.localize(2,null)}function m(b=null,i=!1){if(!b)return R.localize(3,null);if(Array.isArray(b)){const C=D.coalesce(b),g=m(C[0],i);return C.length>1?R.localize(4,null,g,C.length):g}if(L.isString(b))return b;if(b.detail){const C=b.detail;if(C.error)return T(C.error,i);if(C.exception)return T(C.exception,i)}return b.stack?T(b,i):b.message?b.message:R.localize(5,null)}e.toErrorMessage=m}),define(Z[110],te([10,11]),function(K,e){return K.create("vs/base/node/processes",e)}),define(Z[71],te([0,1,37,40,15,26,8,4,31,18,68,19,110]),function(K,e,D,L,R,T,k,P,m,b,i,C,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.win32=e.createQueuedSender=e.LineProcess=e.AbstractProcess=e.getWindowsShell=e.TerminateResponseCode=e.Source=void 0;function w(o){switch(o){case 0:return 0;case 1:return 2;case 128:return 3;default:return 1}}function u(o,a){if(P.isWindows)try{const t={stdio:["pipe","pipe","ignore"]};a&&(t.cwd=a);const r=D.execFile("taskkill",["/T","/F","/PID",o.pid.toString()],t);return new Promise(n=>{r.once("error",s=>{n({success:!1,error:s})}),r.once("exit",(s,c)=>{n(s===0?{success:!0}:{success:!1,code:s!==null?s:1})})})}catch(t){return Promise.resolve({success:!1,error:t,code:t.status?w(t.status):1})}else if(P.isLinux||P.isMacintosh)try{const t=R.FileAccess.asFileUri("vs/base/node/terminateProcess.sh",K).fsPath;return new Promise(r=>{D.execFile(t,[o.pid.toString()],{encoding:"utf8",shell:!0},(n,s,c)=>{r(n?{success:!1,error:n}:{success:!0})})})}catch(t){return Promise.resolve({success:!1,error:t})}else o.kill("SIGKILL");return Promise.resolve({success:!0})}function S(o=m.env){return o.comspec||"cmd.exe"}e.getWindowsShell=S;class f{constructor(a,t,r,n){if(t!==void 0&&r!==void 0&&n!==void 0)this.cmd=a,this.args=t,this.shell=r,this.options=n;else{const s=a;this.cmd=s.command,this.shell=s.isShellCommand,this.args=s.args.slice(0),this.options=s.options||{}}if(this.childProcess=null,this.childProcessPromise=null,this.terminateRequested=!1,this.options.env){const s=Object.create(null);Object.keys(m.env).forEach(c=>{s[c]=m.env[c]}),Object.keys(this.options.env).forEach(c=>{s[c]=this.options.env[c]}),this.options.env=s}}getSanitizedCommand(){let a=this.cmd.toLowerCase();const t=a.lastIndexOf(k.sep);return t!==-1&&(a=a.substring(t+1)),f.WellKnowCommands[a]?a:"other"}start(a){return P.isWindows&&(this.options&&this.options.cwd&&L.isUNC(this.options.cwd)||!this.options&&L.isUNC(m.cwd()))?Promise.reject(new Error(g.localize(0,null))):this.useExec().then(t=>{let r,n;const s=new Promise((c,l)=>{r=c,n=l});if(t){let c=this.cmd;this.args&&(c=c+" "+this.args.join(" ")),this.childProcess=D.exec(c,this.options,(l,h,d)=>{this.childProcess=null;const v=l;v&&v.killed?n({killed:this.terminateRequested,stdout:h.toString(),stderr:d.toString()}):this.handleExec(r,a,l,h,d)})}else{let c=null;const l=h=>{this.childProcess=null,this.childProcessPromise=null,this.handleClose(h,r,a,n);const d={terminated:this.terminateRequested};b.isNumber(h)&&(d.cmdCode=h),r(d)};if(this.shell&&P.isWindows){const h=T.deepClone(this.options);h.windowsVerbatimArguments=!0,h.detached=!1;let d=!1,v=!1;const A=[];let O=this.ensureQuotes(this.cmd);A.push(O.value),d=O.quoted,this.args&&this.args.forEach(U=>{O=this.ensureQuotes(U),A.push(O.value),v=v&&O.quoted});const p=["/s","/c"];d?v?p.push('"'+A.join(" ")+'"'):A.length>1?p.push('"'+A[0]+'" '+A.slice(1).join(" ")):p.push('"'+A[0]+'"'):p.push(A.join(" ")),c=D.spawn(S(),p,h)}else this.cmd&&(c=D.spawn(this.cmd,this.args,this.options));c&&(this.childProcess=c,this.childProcessPromise=Promise.resolve(c),this.pidResolve&&(this.pidResolve(b.isNumber(c.pid)?c.pid:-1),this.pidResolve=void 0),c.on("error",h=>{this.childProcess=null,n({terminated:this.terminateRequested,error:h})}),c.pid&&(this.childProcess.on("close",l),this.handleSpawn(c,r,a,n,!0)))}return s})}handleClose(a,t,r,n){}ensureQuotes(a){return f.regexp.test(a)?{value:'"'+a+'"',quoted:!0}:{value:a,quoted:a.length>0&&a[0]==='"'&&a[a.length-1]==='"'}}get pid(){return this.childProcessPromise?this.childProcessPromise.then(a=>a.pid,a=>-1):new Promise(a=>{this.pidResolve=a})}terminate(){return this.childProcessPromise?this.childProcessPromise.then(a=>(this.terminateRequested=!0,u(a,this.options.cwd).then(t=>(t.success&&(this.childProcess=null),t))),a=>({success:!0})):Promise.resolve({success:!0})}useExec(){return new Promise(a=>{if(!this.shell||!P.isWindows)return a(!1);const t=D.spawn(S(),["/s","/c"]);t.on("error",r=>a(!0)),t.on("exit",r=>a(!1))})}}e.AbstractProcess=f,f.WellKnowCommands={ant:!0,cmake:!0,eslint:!0,gradle:!0,grunt:!0,gulp:!0,jake:!0,jenkins:!0,jshint:!0,make:!0,maven:!0,msbuild:!0,msc:!0,nmake:!0,npm:!0,rake:!0,tsc:!0,xbuild:!0},f.regexp=/^[^"].* .*[^"]/;class I extends f{constructor(a,t,r,n){super(a,t,r,n);this.stdoutLineDecoder=null,this.stderrLineDecoder=null}handleExec(a,t,r,n,s){[n,s].forEach((c,l)=>{const h=new i.LineDecoder;h.write(c).forEach(A=>{t({line:A,source:l===0?0:1})});const v=h.end();v&&t({line:v,source:l===0?0:1})}),a({terminated:this.terminateRequested,error:r})}handleSpawn(a,t,r,n,s){const c=new i.LineDecoder,l=new i.LineDecoder;a.stdout.on("data",h=>{c.write(h).forEach(v=>r({line:v,source:0}))}),a.stderr.on("data",h=>{l.write(h).forEach(v=>r({line:v,source:1}))}),this.stdoutLineDecoder=c,this.stderrLineDecoder=l}handleClose(a,t,r,n){const s=this.stdoutLineDecoder?this.stdoutLineDecoder.end():null;s&&r({line:s,source:0});const c=this.stderrLineDecoder?this.stderrLineDecoder.end():null;c&&r({line:c,source:1})}}e.LineProcess=I;function y(o){let a=[],t=!1;const r=function(n){if(t){a.push(n);return}(!o.send(n,c=>{if(c&&console.error(c),t=!1,a.length>0){const l=a.slice(0);a=[],l.forEach(h=>r(h))}})||P.isWindows)&&(t=!0)};return{send:r}}e.createQueuedSender=y;var E;(function(o){async function a(t,r,n){if(k.isAbsolute(t))return t;if(r===void 0&&(r=m.cwd()),k.dirname(t)!=="."||(n===void 0&&b.isString(m.env.PATH)&&(n=m.env.PATH.split(k.delimiter)),n===void 0||n.length===0))return k.join(r,t);async function c(l){if(await C.Promises.exists(l)){let h;try{h=await C.Promises.stat(l)}catch(d){d.message.startsWith("EACCES")&&(h=await C.Promises.lstat(l))}return h?!h.isDirectory():!1}return!1}for(let l of n){let h;if(k.isAbsolute(l)?h=k.join(l,t):h=k.join(r,l,t),await c(h))return h;let d=h+".com";if(await c(d)||(d=h+".exe",await c(d)))return d}return k.join(r,t)}o.findExecutable=a})(E=e.win32||(e.win32={}))}),define(Z[111],te([0,1,35,4,69,71]),function(K,e,D,L,R,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getSystemShellSync=e.getSystemShell=void 0;async function k(w,u){return w===1?L.isWindows?C():T.getWindowsShell(u):b(w,u)}e.getSystemShell=k;function P(w,u){return w===1?L.isWindows?g(u):T.getWindowsShell(u):b(w,u)}e.getSystemShellSync=P;let m=null;function b(w,u){if(L.isLinux&&w===2||L.isMacintosh&&w===3)return"/bin/bash";if(!m){let S;if(L.isWindows)S="/bin/bash";else{if(S=u.SHELL,!S)try{S=(0,D.userInfo)().shell}catch(f){}S||(S="sh"),S==="/bin/false"&&(S="/bin/bash")}m=S}return m}let i=null;async function C(){return i||(i=(await(0,R.getFirstAvailablePowerShellInstallation)()).exePath),i}function g(w){if(i)return i;const u=L.isWindows&&parseFloat((0,D.release)())>=10,S=w.hasOwnProperty("PROCESSOR_ARCHITEW6432"),f=`${w.windir}\\${S?"Sysnative":"System32"}\\WindowsPowerShell\\v1.0\\powershell.exe`;return u?f:T.getWindowsShell(w)}}),define(Z[52],te([0,1,37,6,25,27,94,9,3,2,26,4,71,36]),function(K,e,D,L,R,T,k,P,m,b,i,C,g,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Client=e.Server=void 0;class u extends w.ChannelServer{constructor(I){super({send:y=>{try{process.send&&process.send(y.buffer.toString("base64"))}catch(E){}},onMessage:m.Event.fromNodeEventEmitter(process,"message",y=>R.VSBuffer.wrap(Buffer.from(y,"base64")))},I);process.once("disconnect",()=>this.dispose())}}e.Server=u;class S{constructor(I,y){this.modulePath=I,this.options=y,this.activeRequests=new Set,this.channels=new Map,this._onDidProcessExit=new m.Emitter,this.onDidProcessExit=this._onDidProcessExit.event;const E=y&&y.timeout?y.timeout:6e4;this.disposeDelayer=new L.Delayer(E),this.child=null,this._client=null}getChannel(I){const y=this;return{call(E,o,a){return y.requestPromise(I,E,o,a)},listen(E,o){return y.requestEvent(I,E,o)}}}requestPromise(I,y,E,o=T.CancellationToken.None){if(!this.disposeDelayer)return Promise.reject(new Error("disposed"));if(o.isCancellationRequested)return Promise.reject(P.canceled());this.disposeDelayer.cancel();const a=this.getCachedChannel(I),t=(0,L.createCancelablePromise)(s=>a.call(y,E,s)),r=o.onCancellationRequested(()=>t.cancel()),n=(0,b.toDisposable)(()=>t.cancel());return this.activeRequests.add(n),t.finally(()=>{r.dispose(),this.activeRequests.delete(n),this.activeRequests.size===0&&this.disposeDelayer&&this.disposeDelayer.trigger(()=>this.disposeClient())}),t}requestEvent(I,y,E){if(!this.disposeDelayer)return m.Event.None;this.disposeDelayer.cancel();let o;const a=new m.Emitter({onFirstListenerAdd:()=>{o=this.getCachedChannel(I).listen(y,E)(a.fire,a),this.activeRequests.add(o)},onLastListenerRemove:()=>{this.activeRequests.delete(o),o.dispose(),this.activeRequests.size===0&&this.disposeDelayer&&this.disposeDelayer.trigger(()=>this.disposeClient())}});return a.event}get client(){if(!this._client){const I=this.options&&this.options.args?this.options.args:[],y=Object.create(null);y.env={...(0,i.deepClone)(process.env),VSCODE_PARENT_PID:String(process.pid)},this.options&&this.options.env&&(y.env={...y.env,...this.options.env}),this.options&&this.options.freshExecArgv&&(y.execArgv=[]),this.options&&typeof this.options.debug=="number"&&(y.execArgv=["--nolazy","--inspect="+this.options.debug]),this.options&&typeof this.options.debugBrk=="number"&&(y.execArgv=["--nolazy","--inspect-brk="+this.options.debugBrk]),y.execArgv===void 0&&(y.execArgv=process.execArgv.filter(c=>!/^--inspect(-brk)?=/.test(c))),C.isMacintosh&&y.env&&delete y.env.DYLD_LIBRARY_PATH,this.child=(0,D.fork)(this.modulePath,I,y);const E=new m.Emitter;m.Event.fromNodeEventEmitter(this.child,"message",c=>c)(c=>{if((0,k.isRemoteConsoleLog)(c)){(0,k.log)(c,`IPC Library: ${this.options.serverName}`);return}E.fire(R.VSBuffer.wrap(Buffer.from(c,"base64")))});const a=this.options.useQueue?(0,g.createQueuedSender)(this.child):this.child,t=c=>this.child&&this.child.connected&&a.send(c.buffer.toString("base64")),r=E.event,n={send:t,onMessage:r};this._client=new w.ChannelClient(n);const s=()=>this.disposeClient();process.once("exit",s),this.child.on("error",c=>console.warn('IPC "'+this.options.serverName+'" errored with '+c)),this.child.on("exit",(c,l)=>{process.removeListener("exit",s),this.activeRequests.forEach(h=>(0,b.dispose)(h)),this.activeRequests.clear(),c!==0&&l!=="SIGTERM"&&console.warn('IPC "'+this.options.serverName+'" crashed with exit code '+c+" and signal "+l),this.disposeDelayer&&this.disposeDelayer.cancel(),this.disposeClient(),this._onDidProcessExit.fire({code:c,signal:l})})}return this._client}getCachedChannel(I){let y=this.channels.get(I);return y||(y=this.client.getChannel(I),this.channels.set(I,y)),y}disposeClient(){this._client&&(this.child&&(this.child.kill(),this.child=null),this._client=null,this.channels.clear())}dispose(){this._onDidProcessExit.dispose(),this.disposeDelayer&&(this.disposeDelayer.cancel(),this.disposeDelayer=void 0),this.disposeClient(),this.activeRequests.clear()}}e.Client=S}),define(Z[112],te([10,11]),function(K,e){return K.create("vs/base/node/zip",e)}),define(Z[113],te([10,11]),function(K,e){return K.create("vs/platform/configuration/common/configurationRegistry",e)}),define(Z[114],te([10,11]),function(K,e){return K.create("vs/platform/environment/node/argv",e)}),define(Z[115],te([10,11]),function(K,e){return K.create("vs/platform/environment/node/argvHelper",e)}),define(Z[116],te([10,11]),function(K,e){return K.create("vs/platform/extensionManagement/common/abstractExtensionManagementService",e)}),define(Z[117],te([10,11]),function(K,e){return K.create("vs/platform/extensionManagement/common/extensionManagement",e)}),define(Z[118],te([10,11]),function(K,e){return K.create("vs/platform/extensionManagement/electron-sandbox/extensionTipsService",e)}),define(Z[119],te([10,11]),function(K,e){return K.create("vs/platform/extensionManagement/node/extensionManagementService",e)}),define(Z[120],te([10,11]),function(K,e){return K.create("vs/platform/extensionManagement/node/extensionManagementUtil",e)}),define(Z[121],te([10,11]),function(K,e){return K.create("vs/platform/extensionManagement/node/extensionsScanner",e)}),define(Z[122],te([10,11]),function(K,e){return K.create("vs/platform/extensions/common/extensionValidator",e)}),define(Z[123],te([10,11]),function(K,e){return K.create("vs/platform/files/common/fileService",e)}),define(Z[124],te([10,11]),function(K,e){return K.create("vs/platform/files/common/files",e)}),define(Z[125],te([10,11]),function(K,e){return K.create("vs/platform/files/common/io",e)}),define(Z[126],te([10,11]),function(K,e){return K.create("vs/platform/files/node/diskFileSystemProvider",e)}),define(Z[127],te([10,11]),function(K,e){return K.create("vs/platform/request/common/request",e)}),define(Z[128],te([10,11]),function(K,e){return K.create("vs/platform/telemetry/common/telemetryService",e)}),define(Z[129],te([10,11]),function(K,e){return K.create("vs/platform/terminal/common/terminalPlatformConfiguration",e)}),define(Z[130],te([10,11]),function(K,e){return K.create("vs/platform/userDataSync/common/abstractSynchronizer",e)}),define(Z[131],te([10,11]),function(K,e){return K.create("vs/platform/userDataSync/common/keybindingsSync",e)}),define(Z[132],te([10,11]),function(K,e){return K.create("vs/platform/userDataSync/common/settingsSync",e)}),define(Z[133],te([10,11]),function(K,e){return K.create("vs/platform/userDataSync/common/userDataAutoSyncService",e)}),define(Z[134],te([10,11]),function(K,e){return K.create("vs/platform/userDataSync/common/userDataSync",e)}),define(Z[135],te([10,11]),function(K,e){return K.create("vs/platform/userDataSync/common/userDataSyncMachines",e)}),define(Z[72],te([0,1,56,64,15,8,31,16,5]),function(K,e,D,L,R,T,k,P,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.parsePtyHostPort=e.parseSearchPort=e.parseExtensionHostPort=e.AbstractNativeEnvironmentService=void 0;class b{constructor(S,f,I){this._args=S,this.paths=f,this.productService=I}get appRoot(){return(0,T.dirname)(R.FileAccess.asFileUri("",K).fsPath)}get userHome(){return m.URI.file(this.paths.homeDir)}get userDataPath(){return this.paths.userDataDir}get appSettingsHome(){return m.URI.file((0,T.join)(this.userDataPath,"User"))}get tmpDir(){return m.URI.file(this.paths.tmpDir)}get userRoamingDataHome(){return this.appSettingsHome}get settingsResource(){return(0,P.joinPath)(this.userRoamingDataHome,"settings.json")}get userDataSyncHome(){return(0,P.joinPath)(this.userRoamingDataHome,"sync")}get logsPath(){if(!this.args.logsPath){const S=(0,D.toLocalISOString)(new Date).replace(/-|:|\.\d+Z$/g,"");this.args.logsPath=(0,T.join)(this.userDataPath,"logs",S)}return this.args.logsPath}get userDataSyncLogResource(){return m.URI.file((0,T.join)(this.logsPath,"userDataSync.log"))}get sync(){return this.args.sync}get machineSettingsResource(){return(0,P.joinPath)(m.URI.file((0,T.join)(this.userDataPath,"Machine")),"settings.json")}get globalStorageHome(){return m.URI.joinPath(this.appSettingsHome,"globalStorage")}get workspaceStorageHome(){return m.URI.joinPath(this.appSettingsHome,"workspaceStorage")}get keybindingsResource(){return(0,P.joinPath)(this.userRoamingDataHome,"keybindings.json")}get keyboardLayoutResource(){return(0,P.joinPath)(this.userRoamingDataHome,"keyboardLayout.json")}get argvResource(){const S=k.env.VSCODE_PORTABLE;return S?m.URI.file((0,T.join)(S,"argv.json")):(0,P.joinPath)(this.userHome,this.productService.dataFolderName,"argv.json")}get snippetsHome(){return(0,P.joinPath)(this.userRoamingDataHome,"snippets")}get isExtensionDevelopment(){return!!this.args.extensionDevelopmentPath}get untitledWorkspacesHome(){return m.URI.file((0,T.join)(this.userDataPath,"Workspaces"))}get installSourcePath(){return(0,T.join)(this.userDataPath,"installSource")}get builtinExtensionsPath(){const S=this.args["builtin-extensions-dir"];return S?(0,T.resolve)(S):(0,T.normalize)((0,T.join)(R.FileAccess.asFileUri("",K).fsPath,"..","extensions"))}get extensionsDownloadPath(){const S=this.args["extensions-download-dir"];return S?(0,T.resolve)(S):(0,T.join)(this.userDataPath,"CachedExtensionVSIXs")}get extensionsPath(){const S=this.args["extensions-dir"];if(S)return(0,T.resolve)(S);const f=k.env.VSCODE_EXTENSIONS;if(f)return f;const I=k.env.VSCODE_PORTABLE;return I?(0,T.join)(I,"extensions"):(0,P.joinPath)(this.userHome,this.productService.dataFolderName,"extensions").fsPath}get extensionDevelopmentLocationURI(){const S=this.args.extensionDevelopmentPath;if(Array.isArray(S))return S.map(f=>/^[^:/?#]+?:\/\//.test(f)?m.URI.parse(f):m.URI.file((0,T.normalize)(f)))}get extensionDevelopmentKind(){return this.args.extensionDevelopmentKind?.map(S=>S==="ui"||S==="workspace"||S==="web"?S:"workspace")}get extensionTestsLocationURI(){const S=this.args.extensionTestsPath;if(S)return/^[^:/?#]+?:\/\//.test(S)?m.URI.parse(S):m.URI.file((0,T.normalize)(S))}get disableExtensions(){if(this.args["disable-extensions"])return!0;const S=this.args["disable-extension"];if(S){if(typeof S=="string")return[S];if(Array.isArray(S)&&S.length>0)return S}return!1}get debugExtensionHost(){return i(this.args,this.isBuilt)}get debugRenderer(){return!!this.args.debugRenderer}get isBuilt(){return!k.env.VSCODE_DEV}get verbose(){return!!this.args.verbose}get logLevel(){return this.args.log}get serviceMachineIdResource(){return(0,P.joinPath)(m.URI.file(this.userDataPath),"machineid")}get crashReporterId(){return this.args["crash-reporter-id"]}get crashReporterDirectory(){return this.args["crash-reporter-directory"]}get driverHandle(){return this.args.driver}get telemetryLogResource(){return m.URI.file((0,T.join)(this.logsPath,"telemetry.log"))}get disableTelemetry(){return!!this.args["disable-telemetry"]}get disableWorkspaceTrust(){return!!this.args["disable-workspace-trust"]}get args(){return this._args}}fe([L.memoize],b.prototype,"appRoot",null),fe([L.memoize],b.prototype,"userHome",null),fe([L.memoize],b.prototype,"userDataPath",null),fe([L.memoize],b.prototype,"appSettingsHome",null),fe([L.memoize],b.prototype,"tmpDir",null),fe([L.memoize],b.prototype,"userRoamingDataHome",null),fe([L.memoize],b.prototype,"settingsResource",null),fe([L.memoize],b.prototype,"userDataSyncHome",null),fe([L.memoize],b.prototype,"userDataSyncLogResource",null),fe([L.memoize],b.prototype,"sync",null),fe([L.memoize],b.prototype,"machineSettingsResource",null),fe([L.memoize],b.prototype,"globalStorageHome",null),fe([L.memoize],b.prototype,"workspaceStorageHome",null),fe([L.memoize],b.prototype,"keybindingsResource",null),fe([L.memoize],b.prototype,"keyboardLayoutResource",null),fe([L.memoize],b.prototype,"argvResource",null),fe([L.memoize],b.prototype,"snippetsHome",null),fe([L.memoize],b.prototype,"isExtensionDevelopment",null),fe([L.memoize],b.prototype,"untitledWorkspacesHome",null),fe([L.memoize],b.prototype,"installSourcePath",null),fe([L.memoize],b.prototype,"builtinExtensionsPath",null),fe([L.memoize],b.prototype,"extensionsPath",null),fe([L.memoize],b.prototype,"extensionDevelopmentLocationURI",null),fe([L.memoize],b.prototype,"extensionDevelopmentKind",null),fe([L.memoize],b.prototype,"extensionTestsLocationURI",null),fe([L.memoize],b.prototype,"debugExtensionHost",null),fe([L.memoize],b.prototype,"serviceMachineIdResource",null),fe([L.memoize],b.prototype,"telemetryLogResource",null),fe([L.memoize],b.prototype,"disableWorkspaceTrust",null),e.AbstractNativeEnvironmentService=b;function i(u,S){return w(u["inspect-extensions"],u["inspect-brk-extensions"],5870,S,u.debugId)}e.parseExtensionHostPort=i;function C(u,S){return w(u["inspect-search"],u["inspect-brk-search"],5876,S)}e.parseSearchPort=C;function g(u,S){return w(u["inspect-ptyhost"],u["inspect-brk-ptyhost"],5877,S)}e.parsePtyHostPort=g;function w(u,S,f,I,y){const o=Number(S||u)||(I?null:f),a=o?Boolean(!!S):!1;return{port:o,break:a,debugId:y}}}),define(Z[136],te([0,1,222,4,114]),function(K,e,D,L,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.buildVersionMessage=e.buildHelpMessage=e.formatOptions=e.parseArgs=e.OPTIONS=void 0;const T={o:(0,R.localize)(0,null),e:(0,R.localize)(1,null),t:(0,R.localize)(2,null)};e.OPTIONS={diff:{type:"boolean",cat:"o",alias:"d",args:["file","file"],description:(0,R.localize)(3,null)},add:{type:"boolean",cat:"o",alias:"a",args:"folder",description:(0,R.localize)(4,null)},goto:{type:"boolean",cat:"o",alias:"g",args:"file:line[:character]",description:(0,R.localize)(5,null)},"new-window":{type:"boolean",cat:"o",alias:"n",description:(0,R.localize)(6,null)},"reuse-window":{type:"boolean",cat:"o",alias:"r",description:(0,R.localize)(7,null)},wait:{type:"boolean",cat:"o",alias:"w",description:(0,R.localize)(8,null)},waitMarkerFilePath:{type:"string"},locale:{type:"string",cat:"o",args:"locale",description:(0,R.localize)(9,null)},"user-data-dir":{type:"string",cat:"o",args:"dir",description:(0,R.localize)(10,null)},help:{type:"boolean",cat:"o",alias:"h",description:(0,R.localize)(11,null)},"extensions-dir":{type:"string",deprecates:"extensionHomePath",cat:"e",args:"dir",description:(0,R.localize)(12,null)},"extensions-download-dir":{type:"string"},"builtin-extensions-dir":{type:"string"},"list-extensions":{type:"boolean",cat:"e",description:(0,R.localize)(13,null)},"show-versions":{type:"boolean",cat:"e",description:(0,R.localize)(14,null)},category:{type:"string",cat:"e",description:(0,R.localize)(15,null),args:"category"},"install-extension":{type:"string[]",cat:"e",args:"extension-id[@version] | path-to-vsix",description:(0,R.localize)(16,null)},"uninstall-extension":{type:"string[]",cat:"e",args:"extension-id",description:(0,R.localize)(17,null)},"enable-proposed-api":{type:"string[]",cat:"e",args:"extension-id",description:(0,R.localize)(18,null)},version:{type:"boolean",cat:"t",alias:"v",description:(0,R.localize)(19,null)},verbose:{type:"boolean",cat:"t",description:(0,R.localize)(20,null)},log:{type:"string",cat:"t",args:"level",description:(0,R.localize)(21,null)},status:{type:"boolean",alias:"s",cat:"t",description:(0,R.localize)(22,null)},"prof-startup":{type:"boolean",cat:"t",description:(0,R.localize)(23,null)},"prof-append-timers":{type:"string"},"no-cached-data":{type:"boolean"},"prof-startup-prefix":{type:"string"},"prof-v8-extensions":{type:"boolean"},"disable-extensions":{type:"boolean",deprecates:"disableExtensions",cat:"t",description:(0,R.localize)(24,null)},"disable-extension":{type:"string[]",cat:"t",args:"extension-id",description:(0,R.localize)(25,null)},sync:{type:"string",cat:"t",description:(0,R.localize)(26,null),args:["on","off"]},"inspect-extensions":{type:"string",deprecates:"debugPluginHost",args:"port",cat:"t",description:(0,R.localize)(27,null)},"inspect-brk-extensions":{type:"string",deprecates:"debugBrkPluginHost",args:"port",cat:"t",description:(0,R.localize)(28,null)},"disable-gpu":{type:"boolean",cat:"t",description:(0,R.localize)(29,null)},"max-memory":{type:"string",cat:"t",description:(0,R.localize)(30,null),args:"memory"},telemetry:{type:"boolean",cat:"t",description:(0,R.localize)(31,null)},remote:{type:"string"},"folder-uri":{type:"string[]",cat:"o",args:"uri"},"file-uri":{type:"string[]",cat:"o",args:"uri"},"locate-extension":{type:"string[]"},extensionDevelopmentPath:{type:"string[]"},extensionDevelopmentKind:{type:"string[]"},extensionTestsPath:{type:"string"},debugId:{type:"string"},debugRenderer:{type:"boolean"},"inspect-ptyhost":{type:"string"},"inspect-brk-ptyhost":{type:"string"},"inspect-search":{type:"string",deprecates:"debugSearch"},"inspect-brk-search":{type:"string",deprecates:"debugBrkSearch"},"export-default-configuration":{type:"string"},"install-source":{type:"string"},driver:{type:"string"},logExtensionHostCommunication:{type:"boolean"},"skip-release-notes":{type:"boolean"},"skip-welcome":{type:"boolean"},"disable-telemetry":{type:"boolean"},"disable-updates":{type:"boolean"},"disable-keytar":{type:"boolean"},"disable-workspace-trust":{type:"boolean"},"disable-crash-reporter":{type:"boolean"},"crash-reporter-directory":{type:"string"},"crash-reporter-id":{type:"string"},"skip-add-to-recently-opened":{type:"boolean"},"unity-launch":{type:"boolean"},"open-url":{type:"boolean"},"file-write":{type:"boolean"},"file-chmod":{type:"boolean"},"driver-verbose":{type:"boolean"},"install-builtin-extension":{type:"string[]"},force:{type:"boolean"},"do-not-sync":{type:"boolean"},trace:{type:"boolean"},"trace-category-filter":{type:"string"},"trace-options":{type:"string"},"force-user-env":{type:"boolean"},"force-disable-user-env":{type:"boolean"},"open-devtools":{type:"boolean"},__sandbox:{type:"boolean"},logsPath:{type:"string"},"no-proxy-server":{type:"boolean"},"no-sandbox":{type:"boolean",alias:"sandbox"},"proxy-server":{type:"string"},"proxy-bypass-list":{type:"string"},"proxy-pac-url":{type:"string"},"js-flags":{type:"string"},inspect:{type:"string"},"inspect-brk":{type:"string"},nolazy:{type:"boolean"},"force-device-scale-factor":{type:"string"},"force-renderer-accessibility":{type:"boolean"},"ignore-certificate-errors":{type:"boolean"},"allow-insecure-localhost":{type:"boolean"},"log-net-log":{type:"string"},vmodule:{type:"string"},_urls:{type:"string[]"},_:{type:"string[]"}};const k={onUnknownOption:()=>{},onMultipleValues:()=>{}};function P(u,S,f=k){const I={},y=[],E=[];for(let r in S){const n=S[r];n.alias&&(I[r]=n.alias),n.type==="string"||n.type==="string[]"?(y.push(r),n.deprecates&&y.push(n.deprecates)):n.type==="boolean"&&(E.push(r),n.deprecates&&E.push(n.deprecates))}const o=D(u,{string:y,boolean:E,alias:I}),a={},t=o;a._=o._.map(r=>String(r)).filter(r=>r.length>0),delete t._;for(let r in S){const n=S[r];n.alias&&delete t[n.alias];let s=t[r];n.deprecates&&t.hasOwnProperty(n.deprecates)&&(s||(s=t[n.deprecates]),delete t[n.deprecates]),typeof s!="undefined"&&(n.type==="string[]"?s&&!Array.isArray(s)&&(s=[s]):n.type==="string"&&Array.isArray(s)&&(s=s.pop(),f.onMultipleValues(r,s)),a[r]=s),delete t[r]}for(let r in t)f.onUnknownOption(r);return a}e.parseArgs=P;function m(u,S){let f="";return S.args&&(Array.isArray(S.args)?f=` <${S.args.join("> <")}>`:f=` <${S.args}>`),S.alias?`-${S.alias} --${u}${f}`:`--${u}${f}`}function b(u,S){let f=0,I=[];for(const a in u){const t=u[a],r=m(a,t);f=Math.max(f,r.length),I.push([r,t.description])}let y=f+2+1;if(S-y<25)return I.reduce((a,t)=>a.concat([`  ${t[0]}`,`      ${t[1]}`]),[]);let E=S-y-1,o=[];for(const a of I){let t=a[0],r=C(a[1],E),n=i(y-t.length-2);o.push("  "+t+n+r[0]);for(let s=1;s<r.length;s++)o.push(i(y)+r[s])}return o}e.formatOptions=b;function i(u){return" ".repeat(u)}function C(u,S){let f=[];for(;u.length;){let I=u.length<S?u.length:u.lastIndexOf(" ",S),y=u.slice(0,I).trim();u=u.slice(I),f.push(y)}return f}function g(u,S,f,I,y=!0){const E=process.stdout.isTTY&&process.stdout.columns||80;let o=[`${u} ${f}`];o.push(""),o.push(`${(0,R.localize)(32,null)}: ${S} [${(0,R.localize)(33,null)}][${(0,R.localize)(34,null)}...]`),o.push(""),y&&(L.isWindows?o.push((0,R.localize)(35,null,S)):o.push((0,R.localize)(36,null,S)),o.push(""));const a={};for(const t in I){const r=I[t];if(r.description&&r.cat){let n=a[r.cat];n||(a[r.cat]=n={}),n[t]=r}}for(let t in a){const r=t;let n=a[r];n&&(o.push(T[r]),o.push(...b(n,E)),o.push(""))}return o.join(`
`)}e.buildHelpMessage=g;function w(u,S){return`${u||(0,R.localize)(37,null)}
${S||(0,R.localize)(38,null)}
${process.arch}`}e.buildVersionMessage=w}),function(){"use strict";function K(e,D,L,R){function T(P){const m=k(P),b=[m];return e.isAbsolute(m)||b.unshift(R),e.resolve(...b)}function k(P){const m=process.env.VSCODE_PORTABLE;if(m)return e.join(m,"user-data");let b=process.env.VSCODE_APPDATA;if(b)return e.join(b,L);const i=P["user-data-dir"];if(i)return i;switch(process.platform){case"win32":if(b=process.env.APPDATA,!b){const C=process.env.USERPROFILE;if(typeof C!="string")throw new Error("Windows: Unexpected undefined %USERPROFILE% environment variable");b=e.join(C,"AppData","Roaming")}break;case"darwin":b=e.join(D.homedir(),"Library","Application Support");break;case"linux":b=process.env.XDG_CONFIG_HOME||e.join(D.homedir(),".config");break;default:throw new Error("Platform not supported")}return e.join(b,L)}return{getUserDataPath:T}}if(typeof define=="function")define(Z[137],te([0,138,35,15,16,31]),function(e,D,L,R,T,k){const P=T.dirname(R.FileAccess.asFileUri("",e)),m=e.__$__nodeRequire(T.joinPath(P,"package.json").fsPath);return K(D,L,m.name,k.cwd())});else if(typeof module=="object"&&typeof module.exports=="object"){const e=require("../../../../../package.json"),D=require("path"),L=require("os");module.exports=K(D,L,e.name,process.env.VSCODE_CWD||process.cwd())}else throw new Error("Unknown context")}(),define(Z[139],te([0,1,35,72,137]),function(K,e,D,L,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.NativeEnvironmentService=void 0;class T extends L.AbstractNativeEnvironmentService{constructor(P,m){super(P,{homeDir:(0,D.homedir)(),tmpDir:(0,D.tmpdir)(),userDataDir:(0,R.getUserDataPath)(P)},m)}}e.NativeEnvironmentService=T}),define(Z[140],te([0,1,5]),function(K,e,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getRemotes=e.getDomainsOfRemotes=e.AllowedSecondLevelDomains=void 0;const L=/^([^@:]+@)?([^:]+):/,R=/^([^@:]+@)?([^:]+):(.+)$/,T=/^([^@]+@)?([^:]+)(:\d+)?$/,k=/([^@:.]+\.[^@:.]+)(:\d+)?$/,P=/^\s*url\s*=\s*(.+\S)\s*$/mg,m=/[^.]/g;e.AllowedSecondLevelDomains=["github.com","bitbucket.org","visualstudio.com","gitlab.com","heroku.com","azurewebsites.net","ibm.com","amazon.com","amazonaws.com","cloudapp.net","rhcloud.com","google.com","azure.com"];function b(f){const I=f.match(k);return I?I[1]:null}function i(f){if(f.indexOf("://")===-1){const I=f.match(L);return I?b(I[2]):null}try{const I=D.URI.parse(f);if(I.authority)return b(I.authority)}catch(I){}return null}function C(f,I){const y=new Set;let E;for(;E=P.exec(f);){const a=i(E[1]);a&&y.add(a)}const o=new Set(I);return Array.from(y).map(a=>o.has(a)?a:a.replace(m,"a"))}e.getDomainsOfRemotes=C;function g(f){const I=f.match(T);return I?I[2]:null}function w(f,I,y){return f&&I?(y&&I.endsWith(".git")&&(I=I.substr(0,I.length-4)),I.indexOf("/")===0?`${f}${I}`:`${f}/${I}`):null}function u(f,I){if(f.indexOf("://")===-1){const y=f.match(R);if(y)return w(y[2],y[3],I)}try{const y=D.URI.parse(f);if(y.authority)return w(g(y.authority),y.path,I)}catch(y){}return null}function S(f,I=!1){const y=[];let E;for(;E=P.exec(f);){const o=u(E[1],I);o&&y.push(o)}return y}e.getRemotes=S}),define(Z[141],te([0,1,26]),function(K,e,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.localizeManifest=void 0;const L=/^%([\w\d.-]+)%$/i;function R(T,k){const P=m=>{if(typeof m!="string")return;const b=L.exec(m);if(!b)return;const i=k[b[1]]??m;return typeof i=="string"?i:typeof i.message=="string"?i.message:m};return(0,D.cloneAndChange)(T,P)}e.localizeManifest=R}),define(Z[142],te([0,1]),function(K,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionRecommendationNotificationServiceChannel=e.ExtensionRecommendationNotificationServiceChannelClient=void 0;class D{constructor(T){this.channel=T}get ignoredRecommendations(){throw new Error("not supported")}promptImportantExtensionsInstallNotification(T,k,P,m){return this.channel.call("promptImportantExtensionsInstallNotification",[T,k,P,m])}promptWorkspaceRecommendations(T){throw new Error("not supported")}hasToIgnoreRecommendationNotifications(){throw new Error("not supported")}}e.ExtensionRecommendationNotificationServiceChannelClient=D;class L{constructor(T){this.service=T}listen(T,k){throw new Error(`Event not found: ${k}`)}call(T,k,P){switch(k){case"promptImportantExtensionsInstallNotification":return this.service.promptImportantExtensionsInstallNotification(P[0],P[1],P[2],P[3])}throw new Error(`Call not found: ${k}`)}}e.ExtensionRecommendationNotificationServiceChannel=L}),define(Z[73],te([0,1,122]),function(K,e,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.isEngineValid=e.isValidExtensionVersion=e.isValidVersion=e.normalizeVersion=e.parseVersion=e.isValidVersionStr=void 0;const L=/^(\^|>=)?((\d+)|x)\.((\d+)|x)\.((\d+)|x)(\-.*)?$/,R=/^-(\d{4})(\d{2})(\d{2})$/;function T(g){return g=g.trim(),g==="*"||L.test(g)}e.isValidVersionStr=T;function k(g){if(!T(g))return null;if(g=g.trim(),g==="*")return{hasCaret:!1,hasGreaterEquals:!1,majorBase:0,majorMustEqual:!1,minorBase:0,minorMustEqual:!1,patchBase:0,patchMustEqual:!1,preRelease:null};let w=g.match(L);return w?{hasCaret:w[1]==="^",hasGreaterEquals:w[1]===">=",majorBase:w[2]==="x"?0:parseInt(w[2],10),majorMustEqual:w[2]!=="x",minorBase:w[4]==="x"?0:parseInt(w[4],10),minorMustEqual:w[4]!=="x",patchBase:w[6]==="x"?0:parseInt(w[6],10),patchMustEqual:w[6]!=="x",preRelease:w[8]||null}:null}e.parseVersion=k;function P(g){if(!g)return null;let w=g.majorBase,u=g.majorMustEqual,S=g.minorBase,f=g.minorMustEqual,I=g.patchBase,y=g.patchMustEqual;g.hasCaret&&(w===0||(f=!1),y=!1);let E=0;if(g.preRelease){const o=R.exec(g.preRelease);if(o){const[,a,t,r]=o;E=Date.UTC(Number(a),Number(t)-1,Number(r))}}return{majorBase:w,majorMustEqual:u,minorBase:S,minorMustEqual:f,patchBase:I,patchMustEqual:y,isMinimum:g.hasGreaterEquals,notBefore:E}}e.normalizeVersion=P;function m(g,w,u){let S;typeof g=="string"?S=P(k(g)):S=g;let f;w instanceof Date?f=w.getTime():typeof w=="string"&&(f=new Date(w).getTime());let I;if(typeof u=="string"?I=P(k(u)):I=u,!S||!I)return!1;let y=S.majorBase,E=S.minorBase,o=S.patchBase,a=I.majorBase,t=I.minorBase,r=I.patchBase,n=I.notBefore,s=I.majorMustEqual,c=I.minorMustEqual,l=I.patchMustEqual;return I.isMinimum?y>a?!0:y<a?!1:E>t?!0:E<t||f&&f<n?!1:o>=r:(y===1&&a===0&&(!s||!c||!l)&&(a=1,t=0,r=0,s=!0,c=!1,l=!1),y<a?!1:y>a?!s:E<t?!1:E>t?!c:o<r?!1:o>r?!l:!(f&&f<n))}e.isValidVersion=m;function b(g,w,u,S){return u.isBuiltin||typeof u.main=="undefined"?!0:C(g,w,u.engines.vscode,S)}e.isValidExtensionVersion=b;function i(g,w,u){return g==="*"||C(w,u,g)}e.isEngineValid=i;function C(g,w,u,S=[]){let f=P(k(u));if(!f)return S.push(D.localize(0,null,u)),!1;if(f.majorBase===0){if(!f.majorMustEqual||!f.minorMustEqual)return S.push(D.localize(1,null,u)),!1}else if(!f.majorMustEqual)return S.push(D.localize(2,null,u)),!1;return m(g,w,f)?!0:(S.push(D.localize(3,null,g,u)),!1)}}),define(Z[143],te([0,1,2,15,36,52]),function(K,e,D,L,R,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.FileWatcher=void 0;class k extends D.Disposable{constructor(m,b,i,C){super();this.requests=m,this.onDidFilesChange=b,this.onLogMessage=i,this.verboseLogging=C,this.isDisposed=!1,this.restartCounter=0,this.startWatching()}startWatching(){const m=this._register(new T.Client(L.FileAccess.asFileUri("bootstrap-fork",K).fsPath,{serverName:"File Watcher (nsfw)",args:["--type=watcherService"],env:{VSCODE_AMD_ENTRYPOINT:"vs/platform/files/node/watcher/nsfw/watcherApp",VSCODE_PIPE_LOGGING:"true",VSCODE_VERBOSE_LOGGING:"true"}}));this._register(m.onDidProcessExit(()=>{this.isDisposed||(this.restartCounter<=k.MAX_RESTARTS?(this.error("terminated unexpectedly and is restarted again..."),this.restartCounter++,this.startWatching()):this.error("failed to start after retrying for some time, giving up. Please report this as a bug report!"))})),this.service=R.ProxyChannel.toService((0,R.getNextTickChannel)(m.getChannel("watcher"))),this.service.setVerboseLogging(this.verboseLogging),this._register(this.service.onDidChangeFile(b=>!this.isDisposed&&this.onDidFilesChange(b))),this._register(this.service.onDidLogMessage(b=>this.onLogMessage(b))),this.watch(this.requests)}setVerboseLogging(m){this.verboseLogging=m,this.isDisposed||this.service?.setVerboseLogging(m)}error(m){this.onLogMessage({type:"error",message:`[File Watcher (nsfw)] ${m}`})}watch(m){this.requests=m,this.service?.watch(m)}dispose(){this.isDisposed=!0,super.dispose()}}e.FileWatcher=k,k.MAX_RESTARTS=5}),define(Z[144],te([0,1,2,15,36,52]),function(K,e,D,L,R,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.FileWatcher=void 0;class k extends D.Disposable{constructor(m,b,i,C,g={}){super();this.folders=m,this.onDidFilesChange=b,this.onLogMessage=i,this.verboseLogging=C,this.watcherOptions=g,this.isDisposed=!1,this.restartCounter=0,this.startWatching()}startWatching(){const m=this._register(new T.Client(L.FileAccess.asFileUri("bootstrap-fork",K).fsPath,{serverName:"File Watcher (chokidar)",args:["--type=watcherService"],env:{VSCODE_AMD_ENTRYPOINT:"vs/platform/files/node/watcher/unix/watcherApp",VSCODE_PIPE_LOGGING:"true",VSCODE_VERBOSE_LOGGING:"true"}}));this._register(m.onDidProcessExit(()=>{this.isDisposed||(this.restartCounter<=k.MAX_RESTARTS?(this.error("terminated unexpectedly and is restarted again..."),this.restartCounter++,this.startWatching()):this.error("failed to start after retrying for some time, giving up. Please report this as a bug report!"))})),this.service=R.ProxyChannel.toService((0,R.getNextTickChannel)(m.getChannel("watcher"))),this.service.init({...this.watcherOptions,verboseLogging:this.verboseLogging}),this._register(this.service.onDidChangeFile(b=>!this.isDisposed&&this.onDidFilesChange(b))),this._register(this.service.onDidLogMessage(b=>this.onLogMessage(b))),this.service.watch(this.folders)}error(m){this.onLogMessage({type:"error",message:`[File Watcher (chokidar)] ${m}`})}setVerboseLogging(m){this.verboseLogging=m,this.service&&this.service.setVerboseLogging(m)}watch(m){this.folders=m,this.service&&this.service.watch(m)}dispose(){this.isDisposed=!0,super.dispose()}}e.FileWatcher=k,k.MAX_RESTARTS=5}),define(Z[145],te([0,1,37,67,15,68]),function(K,e,D,L,R,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.OutOfProcessWin32FolderWatcher=void 0;class k{constructor(m,b,i,C,g){this.watchedFolder=m,this.eventCallback=i,this.logCallback=C,this.verboseLogging=g,this.restartCounter=0,Array.isArray(b)?this.ignored=b.map(w=>(0,L.parse)(w)):this.ignored=[],this.verboseLogging&&this.log(`Start watching: ${m}, excludes: ${b.join(",")}`),this.startWatcher()}startWatcher(){const m=[this.watchedFolder];this.verboseLogging&&m.push("-verbose"),this.handle=(0,D.spawn)(R.FileAccess.asFileUri("vs/platform/files/node/watcher/win32/CodeHelper.exe",K).fsPath,m);const b=new T.LineDecoder;this.handle.stdout.on("data",i=>{const C=[];for(const g of b.write(i)){const w=g.split("|");if(w.length===2){const u=Number(w[0]),S=w[1];if(u>=0&&u<3){if(this.ignored&&this.ignored.some(f=>f(S))){this.verboseLogging&&this.log(S);continue}C.push({type:k.changeTypeMap[u],path:S})}else this.log(w[1])}}C.length>0&&this.eventCallback(C)}),this.handle.on("error",i=>this.onError(i)),this.handle.stderr.on("data",i=>this.onError(i)),this.handle.on("exit",(i,C)=>this.onExit(i,C))}onError(m){this.error("process error: "+m.toString())}onExit(m,b){this.handle&&(this.error(`terminated unexpectedly (code: ${m}, signal: ${b})`),this.restartCounter<=k.MAX_RESTARTS?(this.error("is restarted again..."),this.restartCounter++,this.startWatcher()):this.error("Watcher failed to start after retrying for some time, giving up. Please report this as a bug report!"))}error(m){this.logCallback({type:"error",message:`[File Watcher (C#)] ${m}`})}log(m){this.logCallback({type:"trace",message:`[File Watcher (C#)] ${m}`})}dispose(){this.handle&&(this.handle.kill(),this.handle=void 0)}}e.OutOfProcessWin32FolderWatcher=k,k.MAX_RESTARTS=5,k.changeTypeMap=[0,1,2]}),define(Z[146],te([0,1,8,24,145]),function(K,e,D,L,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.FileWatcher=void 0;class T{constructor(P,m,b,i){this.onDidFilesChange=m,this.onLogMessage=b,this.verboseLogging=i,this.service=void 0,this.folder=P[0],this.folder.path.indexOf("\\\\")===0&&this.folder.path.endsWith(D.posix.sep)&&(this.folder.path=(0,L.rtrim)(this.folder.path,D.posix.sep)),this.service=this.startWatching()}get isDisposed(){return!this.service}startWatching(){return new R.OutOfProcessWin32FolderWatcher(this.folder.path,this.folder.excludes,P=>this.onFileEvents(P),P=>this.onLogMessage(P),this.verboseLogging)}setVerboseLogging(P){this.verboseLogging=P,this.service&&(this.service.dispose(),this.service=this.startWatching())}onFileEvents(P){this.isDisposed||P.length>0&&this.onDidFilesChange(P)}dispose(){this.service&&(this.service.dispose(),this.service=void 0)}}e.FileWatcher=T}),define(Z[53],te([0,1]),function(K,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.SyncDescriptor=void 0;class D{constructor(R,T=[],k=!1){this.ctor=R,this.staticArguments=T,this.supportsDelayedInstantiation=k}}e.SyncDescriptor=D}),define(Z[147],te([0,1,53]),function(K,e,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getSingletonServiceDescriptors=e.registerSingleton=void 0;const L=[];function R(k,P,m){P instanceof D.SyncDescriptor||(P=new D.SyncDescriptor(P,[],m)),L.push([k,P])}e.registerSingleton=R;function T(){return L}e.getSingletonServiceDescriptors=T}),define(Z[148],te([0,1]),function(K,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Graph=e.Node=void 0;class D{constructor(T){this.incoming=new Map,this.outgoing=new Map,this.data=T}}e.Node=D;class L{constructor(T){this._hashFn=T,this._nodes=new Map}roots(){const T=[];for(let k of this._nodes.values())k.outgoing.size===0&&T.push(k);return T}insertEdge(T,k){const P=this.lookupOrInsertNode(T),m=this.lookupOrInsertNode(k);P.outgoing.set(this._hashFn(k),m),m.incoming.set(this._hashFn(T),P)}removeNode(T){const k=this._hashFn(T);this._nodes.delete(k);for(let P of this._nodes.values())P.outgoing.delete(k),P.incoming.delete(k)}lookupOrInsertNode(T){const k=this._hashFn(T);let P=this._nodes.get(k);return P||(P=new D(T),this._nodes.set(k,P)),P}lookup(T){return this._nodes.get(this._hashFn(T))}isEmpty(){return this._nodes.size===0}toString(){let T=[];for(let[k,P]of this._nodes)T.push(`${k}, (incoming)[${[...P.incoming.keys()].join(", ")}], (outgoing)[${[...P.outgoing.keys()].join(",")}]`);return T.join(`
`)}findCycleSlow(){for(let[T,k]of this._nodes){const P=new Set([T]),m=this._findCycle(k,P);if(m)return m}}_findCycle(T,k){for(let[P,m]of T.outgoing){if(k.has(P))return[...k,P].join(" -> ");k.add(P);const b=this._findCycle(m,k);if(b)return b;k.delete(P)}}}e.Graph=L}),define(Z[7],te([0,1]),function(K,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.optional=e.refineServiceDecorator=e.createDecorator=e.IInstantiationService=e._util=void 0;var D;(function(P){P.serviceIds=new Map,P.DI_TARGET="$di$target",P.DI_DEPENDENCIES="$di$dependencies";function m(b){return b[P.DI_DEPENDENCIES]||[]}P.getServiceDependencies=m})(D=e._util||(e._util={})),e.IInstantiationService=R("instantiationService");function L(P,m,b,i){m[D.DI_TARGET]===m?m[D.DI_DEPENDENCIES].push({id:P,index:b,optional:i}):(m[D.DI_DEPENDENCIES]=[{id:P,index:b,optional:i}],m[D.DI_TARGET]=m)}function R(P){if(D.serviceIds.has(P))return D.serviceIds.get(P);const m=function(b,i,C){if(arguments.length!==3)throw new Error("@IServiceName-decorator can only be used to decorate a parameter");L(m,b,C,!1)};return m.toString=()=>P,D.serviceIds.set(P,m),m}e.createDecorator=R;function T(P){return P}e.refineServiceDecorator=T;function k(P){return function(m,b,i){if(arguments.length!==3)throw new Error("@optional-decorator can only be used to decorate a parameter");L(P,m,i,!0)}}e.optional=k}),define(Z[149],te([0,1,7]),function(K,e,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IChecksumService=void 0,e.IChecksumService=(0,D.createDecorator)("checksumService")}),define(Z[150],te([0,1,4,24,7]),function(K,e,D,L,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.implies=e.SET_CONTEXT_COMMAND_ID=e.IContextKeyService=e.RawContextKey=e.ContextKeyNotRegexExpr=e.ContextKeyRegexExpr=e.ContextKeySmallerEqualsExpr=e.ContextKeySmallerExpr=e.ContextKeyGreaterEqualsExpr=e.ContextKeyGreaterExpr=e.ContextKeyNotExpr=e.ContextKeyNotEqualsExpr=e.ContextKeyNotInExpr=e.ContextKeyInExpr=e.ContextKeyEqualsExpr=e.ContextKeyDefinedExpr=e.ContextKeyTrueExpr=e.ContextKeyFalseExpr=e.ContextKeyExpr=e.ContextKeyExprType=void 0;let T=D.userAgent||"";const k=new Map;k.set("false",!1),k.set("true",!0),k.set("isMac",D.isMacintosh),k.set("isLinux",D.isLinux),k.set("isWindows",D.isWindows),k.set("isWeb",D.isWeb),k.set("isMacNative",D.isMacintosh&&!D.isWeb),k.set("isEdge",T.indexOf("Edg/")>=0),k.set("isFirefox",T.indexOf("Firefox")>=0),k.set("isChrome",T.indexOf("Chrome")>=0),k.set("isSafari",T.indexOf("Safari")>=0);const P=Object.prototype.hasOwnProperty;var m;(function(O){O[O.False=0]="False",O[O.True=1]="True",O[O.Defined=2]="Defined",O[O.Not=3]="Not",O[O.Equals=4]="Equals",O[O.NotEquals=5]="NotEquals",O[O.And=6]="And",O[O.Regex=7]="Regex",O[O.NotRegex=8]="NotRegex",O[O.Or=9]="Or",O[O.In=10]="In",O[O.NotIn=11]="NotIn",O[O.Greater=12]="Greater",O[O.GreaterEquals=13]="GreaterEquals",O[O.Smaller=14]="Smaller",O[O.SmallerEquals=15]="SmallerEquals"})(m=e.ContextKeyExprType||(e.ContextKeyExprType={}));class b{static false(){return C.INSTANCE}static true(){return g.INSTANCE}static has(p){return w.create(p)}static equals(p,U){return u.create(p,U)}static notEquals(p,U){return I.create(p,U)}static regex(p,U){return r.create(p,U)}static in(p,U){return S.create(p,U)}static not(p){return y.create(p)}static and(...p){return s.create(p,null)}static or(...p){return c.create(p,null,!0)}static greater(p,U){return E.create(p,U)}static less(p,U){return a.create(p,U)}static deserialize(p,U=!1){if(!!p)return this._deserializeOrExpression(p,U)}static _deserializeOrExpression(p,U){let F=p.split("||");return c.create(F.map(z=>this._deserializeAndExpression(z,U)),null,!0)}static _deserializeAndExpression(p,U){let F=p.split("&&");return s.create(F.map(z=>this._deserializeOne(z,U)),null)}static _deserializeOne(p,U){if(p=p.trim(),p.indexOf("!=")>=0){let F=p.split("!=");return I.create(F[0].trim(),this._deserializeValue(F[1],U))}if(p.indexOf("==")>=0){let F=p.split("==");return u.create(F[0].trim(),this._deserializeValue(F[1],U))}if(p.indexOf("=~")>=0){let F=p.split("=~");return r.create(F[0].trim(),this._deserializeRegexValue(F[1],U))}if(p.indexOf(" in ")>=0){let F=p.split(" in ");return S.create(F[0].trim(),F[1].trim())}if(/^[^<=>]+>=[^<=>]+$/.test(p)){const F=p.split(">=");return o.create(F[0].trim(),F[1].trim())}if(/^[^<=>]+>[^<=>]+$/.test(p)){const F=p.split(">");return E.create(F[0].trim(),F[1].trim())}if(/^[^<=>]+<=[^<=>]+$/.test(p)){const F=p.split("<=");return t.create(F[0].trim(),F[1].trim())}if(/^[^<=>]+<[^<=>]+$/.test(p)){const F=p.split("<");return a.create(F[0].trim(),F[1].trim())}return/^\!\s*/.test(p)?y.create(p.substr(1).trim()):w.create(p)}static _deserializeValue(p,U){if(p=p.trim(),p==="true")return!0;if(p==="false")return!1;let F=/^'([^']*)'$/.exec(p);return F?F[1].trim():p}static _deserializeRegexValue(p,U){if((0,L.isFalsyOrWhitespace)(p)){if(U)throw new Error("missing regexp-value for =~-expression");return console.warn("missing regexp-value for =~-expression"),null}let F=p.indexOf("/"),z=p.lastIndexOf("/");if(F===z||F<0){if(U)throw new Error(`bad regexp-value '${p}', missing /-enclosure`);return console.warn(`bad regexp-value '${p}', missing /-enclosure`),null}let H=p.slice(F+1,z),M=p[z+1]==="i"?"i":"";try{return new RegExp(H,M)}catch(j){if(U)throw new Error(`bad regexp-value '${p}', parse error: ${j}`);return console.warn(`bad regexp-value '${p}', parse error: ${j}`),null}}}e.ContextKeyExpr=b;function i(O,p){return O.cmp(p)}class C{constructor(){this.type=0}cmp(p){return this.type-p.type}equals(p){return p.type===this.type}evaluate(p){return!1}serialize(){return"false"}keys(){return[]}map(p){return this}negate(){return g.INSTANCE}}e.ContextKeyFalseExpr=C,C.INSTANCE=new C;class g{constructor(){this.type=1}cmp(p){return this.type-p.type}equals(p){return p.type===this.type}evaluate(p){return!0}serialize(){return"true"}keys(){return[]}map(p){return this}negate(){return C.INSTANCE}}e.ContextKeyTrueExpr=g,g.INSTANCE=new g;class w{constructor(p,U){this.key=p,this.negated=U,this.type=2}static create(p,U=null){const F=k.get(p);return typeof F=="boolean"?F?g.INSTANCE:C.INSTANCE:new w(p,U)}cmp(p){return p.type!==this.type?this.type-p.type:h(this.key,p.key)}equals(p){return p.type===this.type?this.key===p.key:!1}evaluate(p){return!!p.getValue(this.key)}serialize(){return this.key}keys(){return[this.key]}map(p){return p.mapDefined(this.key)}negate(){return this.negated||(this.negated=y.create(this.key,this)),this.negated}}e.ContextKeyDefinedExpr=w;class u{constructor(p,U,F){this.key=p,this.value=U,this.negated=F,this.type=4}static create(p,U,F=null){if(typeof U=="boolean")return U?w.create(p,F):y.create(p,F);const z=k.get(p);return typeof z=="boolean"?U===(z?"true":"false")?g.INSTANCE:C.INSTANCE:new u(p,U,F)}cmp(p){return p.type!==this.type?this.type-p.type:d(this.key,this.value,p.key,p.value)}equals(p){return p.type===this.type?this.key===p.key&&this.value===p.value:!1}evaluate(p){return p.getValue(this.key)==this.value}serialize(){return`${this.key} == '${this.value}'`}keys(){return[this.key]}map(p){return p.mapEquals(this.key,this.value)}negate(){return this.negated||(this.negated=I.create(this.key,this.value,this)),this.negated}}e.ContextKeyEqualsExpr=u;class S{constructor(p,U){this.key=p,this.valueKey=U,this.type=10,this.negated=null}static create(p,U){return new S(p,U)}cmp(p){return p.type!==this.type?this.type-p.type:d(this.key,this.valueKey,p.key,p.valueKey)}equals(p){return p.type===this.type?this.key===p.key&&this.valueKey===p.valueKey:!1}evaluate(p){const U=p.getValue(this.valueKey),F=p.getValue(this.key);return Array.isArray(U)?U.indexOf(F)>=0:typeof F=="string"&&typeof U=="object"&&U!==null?P.call(U,F):!1}serialize(){return`${this.key} in '${this.valueKey}'`}keys(){return[this.key,this.valueKey]}map(p){return p.mapIn(this.key,this.valueKey)}negate(){return this.negated||(this.negated=f.create(this)),this.negated}}e.ContextKeyInExpr=S;class f{constructor(p){this._actual=p,this.type=11}static create(p){return new f(p)}cmp(p){return p.type!==this.type?this.type-p.type:this._actual.cmp(p._actual)}equals(p){return p.type===this.type?this._actual.equals(p._actual):!1}evaluate(p){return!this._actual.evaluate(p)}serialize(){throw new Error("Method not implemented.")}keys(){return this._actual.keys()}map(p){return new f(this._actual.map(p))}negate(){return this._actual}}e.ContextKeyNotInExpr=f;class I{constructor(p,U,F){this.key=p,this.value=U,this.negated=F,this.type=5}static create(p,U,F=null){if(typeof U=="boolean")return U?y.create(p,F):w.create(p,F);const z=k.get(p);return typeof z=="boolean"?U===(z?"true":"false")?C.INSTANCE:g.INSTANCE:new I(p,U,F)}cmp(p){return p.type!==this.type?this.type-p.type:d(this.key,this.value,p.key,p.value)}equals(p){return p.type===this.type?this.key===p.key&&this.value===p.value:!1}evaluate(p){return p.getValue(this.key)!=this.value}serialize(){return`${this.key} != '${this.value}'`}keys(){return[this.key]}map(p){return p.mapNotEquals(this.key,this.value)}negate(){return this.negated||(this.negated=u.create(this.key,this.value,this)),this.negated}}e.ContextKeyNotEqualsExpr=I;class y{constructor(p,U){this.key=p,this.negated=U,this.type=3}static create(p,U=null){const F=k.get(p);return typeof F=="boolean"?F?C.INSTANCE:g.INSTANCE:new y(p,U)}cmp(p){return p.type!==this.type?this.type-p.type:h(this.key,p.key)}equals(p){return p.type===this.type?this.key===p.key:!1}evaluate(p){return!p.getValue(this.key)}serialize(){return`!${this.key}`}keys(){return[this.key]}map(p){return p.mapNot(this.key)}negate(){return this.negated||(this.negated=w.create(this.key,this)),this.negated}}e.ContextKeyNotExpr=y;class E{constructor(p,U,F){this.key=p,this.value=U,this.negated=F,this.type=12}static create(p,U,F=null){return new E(p,U,F)}cmp(p){return p.type!==this.type?this.type-p.type:d(this.key,this.value,p.key,p.value)}equals(p){return p.type===this.type?this.key===p.key&&this.value===p.value:!1}evaluate(p){return parseFloat(p.getValue(this.key))>parseFloat(this.value)}serialize(){return`${this.key} > ${this.value}`}keys(){return[this.key]}map(p){return p.mapGreater(this.key,this.value)}negate(){return this.negated||(this.negated=t.create(this.key,this.value,this)),this.negated}}e.ContextKeyGreaterExpr=E;class o{constructor(p,U,F){this.key=p,this.value=U,this.negated=F,this.type=13}static create(p,U,F=null){return new o(p,U,F)}cmp(p){return p.type!==this.type?this.type-p.type:d(this.key,this.value,p.key,p.value)}equals(p){return p.type===this.type?this.key===p.key&&this.value===p.value:!1}evaluate(p){return parseFloat(p.getValue(this.key))>=parseFloat(this.value)}serialize(){return`${this.key} >= ${this.value}`}keys(){return[this.key]}map(p){return p.mapGreaterEquals(this.key,this.value)}negate(){return this.negated||(this.negated=a.create(this.key,this.value,this)),this.negated}}e.ContextKeyGreaterEqualsExpr=o;class a{constructor(p,U,F){this.key=p,this.value=U,this.negated=F,this.type=14}static create(p,U,F=null){return new a(p,U,F)}cmp(p){return p.type!==this.type?this.type-p.type:d(this.key,this.value,p.key,p.value)}equals(p){return p.type===this.type?this.key===p.key&&this.value===p.value:!1}evaluate(p){return parseFloat(p.getValue(this.key))<parseFloat(this.value)}serialize(){return`${this.key} < ${this.value}`}keys(){return[this.key]}map(p){return p.mapSmaller(this.key,this.value)}negate(){return this.negated||(this.negated=o.create(this.key,this.value,this)),this.negated}}e.ContextKeySmallerExpr=a;class t{constructor(p,U,F){this.key=p,this.value=U,this.negated=F,this.type=15}static create(p,U,F=null){return new t(p,U,F)}cmp(p){return p.type!==this.type?this.type-p.type:d(this.key,this.value,p.key,p.value)}equals(p){return p.type===this.type?this.key===p.key&&this.value===p.value:!1}evaluate(p){return parseFloat(p.getValue(this.key))<=parseFloat(this.value)}serialize(){return`${this.key} <= ${this.value}`}keys(){return[this.key]}map(p){return p.mapSmallerEquals(this.key,this.value)}negate(){return this.negated||(this.negated=E.create(this.key,this.value,this)),this.negated}}e.ContextKeySmallerEqualsExpr=t;class r{constructor(p,U){this.key=p,this.regexp=U,this.type=7,this.negated=null}static create(p,U){return new r(p,U)}cmp(p){if(p.type!==this.type)return this.type-p.type;if(this.key<p.key)return-1;if(this.key>p.key)return 1;const U=this.regexp?this.regexp.source:"",F=p.regexp?p.regexp.source:"";return U<F?-1:U>F?1:0}equals(p){if(p.type===this.type){const U=this.regexp?this.regexp.source:"",F=p.regexp?p.regexp.source:"";return this.key===p.key&&U===F}return!1}evaluate(p){let U=p.getValue(this.key);return this.regexp?this.regexp.test(U):!1}serialize(){const p=this.regexp?`/${this.regexp.source}/${this.regexp.ignoreCase?"i":""}`:"/invalid/";return`${this.key} =~ ${p}`}keys(){return[this.key]}map(p){return p.mapRegex(this.key,this.regexp)}negate(){return this.negated||(this.negated=n.create(this)),this.negated}}e.ContextKeyRegexExpr=r;class n{constructor(p){this._actual=p,this.type=8}static create(p){return new n(p)}cmp(p){return p.type!==this.type?this.type-p.type:this._actual.cmp(p._actual)}equals(p){return p.type===this.type?this._actual.equals(p._actual):!1}evaluate(p){return!this._actual.evaluate(p)}serialize(){throw new Error("Method not implemented.")}keys(){return this._actual.keys()}map(p){return new n(this._actual.map(p))}negate(){return this._actual}}e.ContextKeyNotRegexExpr=n;class s{constructor(p,U){this.expr=p,this.negated=U,this.type=6}static create(p,U){return s._normalizeArr(p,U)}cmp(p){if(p.type!==this.type)return this.type-p.type;if(this.expr.length<p.expr.length)return-1;if(this.expr.length>p.expr.length)return 1;for(let U=0,F=this.expr.length;U<F;U++){const z=i(this.expr[U],p.expr[U]);if(z!==0)return z}return 0}equals(p){if(p.type===this.type){if(this.expr.length!==p.expr.length)return!1;for(let U=0,F=this.expr.length;U<F;U++)if(!this.expr[U].equals(p.expr[U]))return!1;return!0}return!1}evaluate(p){for(let U=0,F=this.expr.length;U<F;U++)if(!this.expr[U].evaluate(p))return!1;return!0}static _normalizeArr(p,U){const F=[];let z=!1;for(const H of p)if(!!H){if(H.type===1){z=!0;continue}if(H.type===0)return C.INSTANCE;if(H.type===6){F.push(...H.expr);continue}F.push(H)}if(F.length===0&&z)return g.INSTANCE;if(F.length!==0){if(F.length===1)return F[0];F.sort(i);for(let H=1;H<F.length;H++)F[H-1].equals(F[H])&&(F.splice(H,1),H--);if(F.length===1)return F[0];for(;F.length>1;){const H=F[F.length-1];if(H.type!==9)break;F.pop();const M=F.pop(),j=F.length===0,q=c.create(H.expr.map(x=>s.create([x,M],null)),null,j);q&&(F.push(q),F.sort(i))}return F.length===1?F[0]:new s(F,U)}}serialize(){return this.expr.map(p=>p.serialize()).join(" && ")}keys(){const p=[];for(let U of this.expr)p.push(...U.keys());return p}map(p){return new s(this.expr.map(U=>U.map(p)),null)}negate(){if(!this.negated){const p=[];for(let U of this.expr)p.push(U.negate());this.negated=c.create(p,this,!0)}return this.negated}}class c{constructor(p,U){this.expr=p,this.negated=U,this.type=9}static create(p,U,F){return c._normalizeArr(p,U,F)}cmp(p){if(p.type!==this.type)return this.type-p.type;if(this.expr.length<p.expr.length)return-1;if(this.expr.length>p.expr.length)return 1;for(let U=0,F=this.expr.length;U<F;U++){const z=i(this.expr[U],p.expr[U]);if(z!==0)return z}return 0}equals(p){if(p.type===this.type){if(this.expr.length!==p.expr.length)return!1;for(let U=0,F=this.expr.length;U<F;U++)if(!this.expr[U].equals(p.expr[U]))return!1;return!0}return!1}evaluate(p){for(let U=0,F=this.expr.length;U<F;U++)if(this.expr[U].evaluate(p))return!0;return!1}static _normalizeArr(p,U,F){let z=[],H=!1;if(p){for(let M=0,j=p.length;M<j;M++){const q=p[M];if(!!q){if(q.type===0){H=!0;continue}if(q.type===1)return g.INSTANCE;if(q.type===9){z=z.concat(q.expr);continue}z.push(q)}}if(z.length===0&&H)return C.INSTANCE;z.sort(i)}if(z.length!==0){if(z.length===1)return z[0];for(let M=1;M<z.length;M++)z[M-1].equals(z[M])&&(z.splice(M,1),M--);if(z.length===1)return z[0];if(F){for(let M=0;M<z.length;M++)for(let j=M+1;j<z.length;j++)v(z[M],z[j])&&(z.splice(j,1),j--);if(z.length===1)return z[0]}return new c(z,U)}}serialize(){return this.expr.map(p=>p.serialize()).join(" || ")}keys(){const p=[];for(let U of this.expr)p.push(...U.keys());return p}map(p){return new c(this.expr.map(U=>U.map(p)),null)}negate(){if(!this.negated){let p=[];for(let U of this.expr)p.push(U.negate());for(;p.length>1;){const U=p.shift(),F=p.shift(),z=[];for(const M of A(U))for(const j of A(F))z.push(s.create([M,j],null));const H=p.length===0;p.unshift(c.create(z,null,H))}this.negated=p[0]}return this.negated}}class l extends w{constructor(p,U,F){super(p,null);this._defaultValue=U,typeof F=="object"?l._info.push({...F,key:p}):F!==!0&&l._info.push({key:p,description:F,type:U!=null?typeof U:void 0})}static all(){return l._info.values()}bindTo(p){return p.createKey(this.key,this._defaultValue)}getValue(p){return p.getContextKeyValue(this.key)}toNegated(){return this.negate()}isEqualTo(p){return u.create(this.key,p)}notEqualsTo(p){return I.create(this.key,p)}}e.RawContextKey=l,l._info=[],e.IContextKeyService=(0,R.createDecorator)("contextKeyService"),e.SET_CONTEXT_COMMAND_ID="setContext";function h(O,p){return O<p?-1:O>p?1:0}function d(O,p,U,F){return O<U?-1:O>U?1:p<F?-1:p>F?1:0}function v(O,p){if(p.type===6&&O.type!==9&&O.type!==6){for(const z of p.expr)if(O.equals(z))return!0}const U=O.negate(),F=A(U).concat(A(p));F.sort(i);for(let z=0;z<F.length;z++){const M=F[z].negate();for(let j=z+1;j<F.length;j++){const q=F[j];if(M.equals(q))return!0}}return!1}e.implies=v;function A(O){return O.type===9?O.expr:[O]}}),define(Z[74],te([0,1,7]),function(K,e,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.isRemoteDiagnosticError=e.IDiagnosticsService=e.ID=void 0,e.ID="diagnosticsService",e.IDiagnosticsService=(0,D.createDecorator)(e.ID);function L(R){return!!R.hostName&&!!R.errorMessage}e.isRemoteDiagnosticError=L}),define(Z[75],te([0,1,7]),function(K,e,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IDownloadService=void 0,e.IDownloadService=(0,D.createDecorator)("downloadService")}),define(Z[12],te([0,1,7]),function(K,e,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.INativeEnvironmentService=e.IEnvironmentService=void 0,e.IEnvironmentService=(0,D.createDecorator)("environmentService"),e.INativeEnvironmentService=(0,D.refineServiceDecorator)(e.IEnvironmentService)}),define(Z[28],te([0,1,15,117,7]),function(K,e,D,L,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExtensionManagementCLIService=e.PreferencesLocalizedLabel=e.PreferencesLabel=e.ExtensionsChannelId=e.ExtensionsLocalizedLabel=e.ExtensionsLabel=e.DefaultIconPath=e.IExtensionTipsService=e.IGlobalExtensionEnablementService=e.ENABLED_EXTENSIONS_STORAGE_PATH=e.DISABLED_EXTENSIONS_STORAGE_PATH=e.IExtensionManagementService=e.ExtensionManagementError=e.INSTALL_ERROR_INCOMPATIBLE=e.INSTALL_ERROR_MALICIOUS=e.INSTALL_ERROR_NOT_SUPPORTED=e.IExtensionGalleryService=e.InstallOperation=e.StatisticType=e.SortOrder=e.SortBy=e.isIExtensionIdentifier=e.getFallbackTargetPlarforms=e.isTargetPlatformCompatible=e.isNotWebExtensionInWebTargetPlatform=e.getTargetPlatform=e.toTargetPlatform=e.TargetPlatformToString=e.TargetPlatform=e.WEB_EXTENSION_TAG=e.EXTENSION_IDENTIFIER_REGEX=e.EXTENSION_IDENTIFIER_PATTERN=void 0,e.EXTENSION_IDENTIFIER_PATTERN="^([a-z0-9A-Z][a-z0-9-A-Z]*)\\.([a-z0-9A-Z][a-z0-9-A-Z]*)$",e.EXTENSION_IDENTIFIER_REGEX=new RegExp(e.EXTENSION_IDENTIFIER_PATTERN),e.WEB_EXTENSION_TAG="__web_extension";var T;(function(y){y.WIN32_X64="win32-x64",y.WIN32_IA32="win32-ia32",y.WIN32_ARM64="win32-arm64",y.LINUX_X64="linux-x64",y.LINUX_ARM64="linux-arm64",y.LINUX_ARMHF="linux-armhf",y.ALPINE_X64="alpine-x64",y.ALPINE_ARM64="alpine-arm64",y.DARWIN_X64="darwin-x64",y.DARWIN_ARM64="darwin-arm64",y.WEB="web",y.UNIVERSAL="universal",y.UNKNOWN="unknown",y.UNDEFINED="undefined"})(T=e.TargetPlatform||(e.TargetPlatform={}));function k(y){switch(y){case"win32-x64":return"Windows 64 bit";case"win32-ia32":return"Windows 32 bit";case"win32-arm64":return"Windows ARM";case"linux-x64":return"Linux 64 bit";case"linux-arm64":return"Linux ARM 64";case"linux-armhf":return"Linux ARM";case"alpine-x64":return"Alpine Linux 64 bit";case"alpine-arm64":return"Alpine ARM 64";case"darwin-x64":return"Mac";case"darwin-arm64":return"Mac Silicon";case"web":return"Web";case"universal":return"universal";case"unknown":return"unknown";case"undefined":return"undefined"}}e.TargetPlatformToString=k;function P(y){switch(y){case"win32-x64":return"win32-x64";case"win32-ia32":return"win32-ia32";case"win32-arm64":return"win32-arm64";case"linux-x64":return"linux-x64";case"linux-arm64":return"linux-arm64";case"linux-armhf":return"linux-armhf";case"alpine-x64":return"alpine-x64";case"alpine-arm64":return"alpine-arm64";case"darwin-x64":return"darwin-x64";case"darwin-arm64":return"darwin-arm64";case"web":return"web";case"universal":return"universal";default:return"unknown"}}e.toTargetPlatform=P;function m(y,E){switch(y){case 3:return E==="x64"?"win32-x64":E==="ia32"?"win32-ia32":E==="arm64"?"win32-arm64":"unknown";case 2:return E==="x64"?"linux-x64":E==="arm64"?"linux-arm64":E==="arm"?"linux-armhf":"unknown";case"alpine":return E==="x64"?"alpine-x64":E==="arm64"?"alpine-arm64":"unknown";case 1:return E==="x64"?"darwin-x64":E==="arm64"?"darwin-arm64":"unknown";case 0:return"web"}}e.getTargetPlatform=m;function b(y,E){return E==="web"&&!y.includes("web")}e.isNotWebExtensionInWebTargetPlatform=b;function i(y,E,o){return b(E,o)?!1:y==="undefined"||y==="universal"?!0:y==="unknown"?!1:y===o?!0:C(o).includes(y)}e.isTargetPlatformCompatible=i;function C(y){switch(y){case"win32-x64":return["win32-ia32"];case"win32-arm64":return["win32-ia32"]}return[]}e.getFallbackTargetPlarforms=C;function g(y){return y&&typeof y=="object"&&typeof y.id=="string"&&(!y.uuid||typeof y.uuid=="string")}e.isIExtensionIdentifier=g;var w;(function(y){y[y.NoneOrRelevance=0]="NoneOrRelevance",y[y.LastUpdatedDate=1]="LastUpdatedDate",y[y.Title=2]="Title",y[y.PublisherName=3]="PublisherName",y[y.InstallCount=4]="InstallCount",y[y.PublishedDate=10]="PublishedDate",y[y.AverageRating=6]="AverageRating",y[y.WeightedRating=12]="WeightedRating"})(w=e.SortBy||(e.SortBy={}));var u;(function(y){y[y.Default=0]="Default",y[y.Ascending=1]="Ascending",y[y.Descending=2]="Descending"})(u=e.SortOrder||(e.SortOrder={}));var S;(function(y){y.Install="install",y.Uninstall="uninstall"})(S=e.StatisticType||(e.StatisticType={}));var f;(function(y){y[y.None=0]="None",y[y.Install=1]="Install",y[y.Update=2]="Update"})(f=e.InstallOperation||(e.InstallOperation={})),e.IExtensionGalleryService=(0,R.createDecorator)("extensionGalleryService"),e.INSTALL_ERROR_NOT_SUPPORTED="notsupported",e.INSTALL_ERROR_MALICIOUS="malicious",e.INSTALL_ERROR_INCOMPATIBLE="incompatible";class I extends Error{constructor(E,o){super(E);this.code=o,this.name=o}}e.ExtensionManagementError=I,e.IExtensionManagementService=(0,R.createDecorator)("extensionManagementService"),e.DISABLED_EXTENSIONS_STORAGE_PATH="extensionsIdentifiers/disabled",e.ENABLED_EXTENSIONS_STORAGE_PATH="extensionsIdentifiers/enabled",e.IGlobalExtensionEnablementService=(0,R.createDecorator)("IGlobalExtensionEnablementService"),e.IExtensionTipsService=(0,R.createDecorator)("IExtensionTipsService"),e.DefaultIconPath=D.FileAccess.asBrowserUri("./media/defaultIcon.png",K).toString(!0),e.ExtensionsLabel=(0,L.localize)(0,null),e.ExtensionsLocalizedLabel={value:e.ExtensionsLabel,original:"Extensions"},e.ExtensionsChannelId="extensions",e.PreferencesLabel=(0,L.localize)(1,null),e.PreferencesLocalizedLabel={value:e.PreferencesLabel,original:"Preferences"},e.IExtensionManagementCLIService=(0,R.createDecorator)("IExtensionManagementCLIService")});var J=this&&this.__param||function(K,e){return function(D,L){e(D,L,K)}};define(Z[151],te([0,1,2,28]),function(K,e,D,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.DeprecatedExtensionsCleaner=void 0;let R=class extends D.Disposable{constructor(k){super();this.extensionManagementService=k,this._register(k),this.cleanUpDeprecatedExtensions()}cleanUpDeprecatedExtensions(){this.extensionManagementService.removeDeprecatedExtensions()}};R=fe([J(0,L.IExtensionManagementService)],R),e.DeprecatedExtensionsCleaner=R}),define(Z[152],te([0,1,3,2,26,5,97,28]),function(K,e,D,L,R,T,k,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionTipsChannel=e.ExtensionManagementChannelClient=e.ExtensionManagementChannel=void 0;function m(S,f){return T.URI.revive(f?f.transformIncoming(S):S)}function b(S,f){return f?f.transformOutgoingURI(S):S}function i(S,f){f=f||k.DefaultURITransformer;const I=S.manifest;return{...(0,k.transformAndReviveIncomingURIs)({...S,manifest:void 0},f),manifest:I}}function C(S,f){return f?(0,R.cloneAndChange)(S,I=>I instanceof T.URI?f.transformOutgoingURI(I):void 0):S}class g{constructor(f,I){this.service=f,this.getUriTransformer=I,this.onInstallExtension=D.Event.buffer(f.onInstallExtension,!0),this.onDidInstallExtensions=D.Event.buffer(f.onDidInstallExtensions,!0),this.onUninstallExtension=D.Event.buffer(f.onUninstallExtension,!0),this.onDidUninstallExtension=D.Event.buffer(f.onDidUninstallExtension,!0)}listen(f,I){const y=this.getUriTransformer(f);switch(I){case"onInstallExtension":return this.onInstallExtension;case"onDidInstallExtensions":return D.Event.map(this.onDidInstallExtensions,E=>E.map(o=>({...o,local:o.local?C(o.local,y):o.local})));case"onUninstallExtension":return this.onUninstallExtension;case"onDidUninstallExtension":return this.onDidUninstallExtension}throw new Error("Invalid listen")}call(f,I,y){const E=this.getUriTransformer(f);switch(I){case"zip":return this.service.zip(i(y[0],E)).then(o=>b(o,E));case"unzip":return this.service.unzip(m(y[0],E));case"install":return this.service.install(m(y[0],E),y[1]);case"getManifest":return this.service.getManifest(m(y[0],E));case"getTargetPlatform":return this.service.getTargetPlatform();case"canInstall":return this.service.canInstall(y[0]);case"installFromGallery":return this.service.installFromGallery(y[0],y[1]);case"uninstall":return this.service.uninstall(i(y[0],E),y[1]);case"reinstallFromGallery":return this.service.reinstallFromGallery(i(y[0],E));case"getInstalled":return this.service.getInstalled(y[0]).then(o=>o.map(a=>C(a,E)));case"updateMetadata":return this.service.updateMetadata(i(y[0],E),y[1]).then(o=>C(o,E));case"updateExtensionScope":return this.service.updateExtensionScope(i(y[0],E),y[1]).then(o=>C(o,E));case"getExtensionsReport":return this.service.getExtensionsReport()}throw new Error("Invalid call")}}e.ExtensionManagementChannel=g;class w extends L.Disposable{constructor(f){super();this.channel=f,this._onInstallExtension=this._register(new D.Emitter),this.onInstallExtension=this._onInstallExtension.event,this._onDidInstallExtensions=this._register(new D.Emitter),this.onDidInstallExtensions=this._onDidInstallExtensions.event,this._onUninstallExtension=this._register(new D.Emitter),this.onUninstallExtension=this._onUninstallExtension.event,this._onDidUninstallExtension=this._register(new D.Emitter),this.onDidUninstallExtension=this._onDidUninstallExtension.event,this._register(this.channel.listen("onInstallExtension")(I=>this._onInstallExtension.fire({identifier:I.identifier,source:this.isUriComponents(I.source)?T.URI.revive(I.source):I.source}))),this._register(this.channel.listen("onDidInstallExtensions")(I=>this._onDidInstallExtensions.fire(I.map(y=>({...y,local:y.local?i(y.local,null):y.local,source:this.isUriComponents(y.source)?T.URI.revive(y.source):y.source}))))),this._register(this.channel.listen("onUninstallExtension")(I=>this._onUninstallExtension.fire(I))),this._register(this.channel.listen("onDidUninstallExtension")(I=>this._onDidUninstallExtension.fire(I)))}isUriComponents(f){return f?typeof f.path=="string"&&typeof f.scheme=="string":!1}getTargetPlatform(){return this._targetPlatformPromise||(this._targetPlatformPromise=this.channel.call("getTargetPlatform")),this._targetPlatformPromise}async canInstall(f){const I=await this.getTargetPlatform();return f.allTargetPlatforms.some(y=>(0,P.isTargetPlatformCompatible)(y,f.allTargetPlatforms,I))}zip(f){return Promise.resolve(this.channel.call("zip",[f]).then(I=>T.URI.revive(I)))}unzip(f){return Promise.resolve(this.channel.call("unzip",[f]))}install(f,I){return Promise.resolve(this.channel.call("install",[f,I])).then(y=>i(y,null))}getManifest(f){return Promise.resolve(this.channel.call("getManifest",[f]))}installFromGallery(f,I){return Promise.resolve(this.channel.call("installFromGallery",[f,I])).then(y=>i(y,null))}uninstall(f,I){return Promise.resolve(this.channel.call("uninstall",[f,I]))}reinstallFromGallery(f){return Promise.resolve(this.channel.call("reinstallFromGallery",[f]))}getInstalled(f=null){return Promise.resolve(this.channel.call("getInstalled",[f])).then(I=>I.map(y=>i(y,null)))}updateMetadata(f,I){return Promise.resolve(this.channel.call("updateMetadata",[f,I])).then(y=>i(y,null))}updateExtensionScope(f,I){return Promise.resolve(this.channel.call("updateExtensionScope",[f,I])).then(y=>i(y,null))}getExtensionsReport(){return Promise.resolve(this.channel.call("getExtensionsReport"))}registerParticipant(){throw new Error("Not Supported")}}e.ExtensionManagementChannelClient=w;class u{constructor(f){this.service=f}listen(f,I){throw new Error("Invalid listen")}call(f,I,y){switch(I){case"getConfigBasedTips":return this.service.getConfigBasedTips(T.URI.revive(y[0]));case"getImportantExecutableBasedTips":return this.service.getImportantExecutableBasedTips();case"getOtherExecutableBasedTips":return this.service.getOtherExecutableBasedTips();case"getAllWorkspacesTips":return this.service.getAllWorkspacesTips()}throw new Error("Invalid call")}}e.ExtensionTipsChannel=u}),define(Z[76],te([0,1,7]),function(K,e,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExtensionRecommendationNotificationService=e.RecommendationsNotificationResult=e.RecommendationSourceToString=e.RecommendationSource=void 0;var L;(function(k){k[k.FILE=1]="FILE",k[k.WORKSPACE=2]="WORKSPACE",k[k.EXE=3]="EXE"})(L=e.RecommendationSource||(e.RecommendationSource={}));function R(k){switch(k){case 1:return"file";case 2:return"workspace";case 3:return"exe"}}e.RecommendationSourceToString=R;var T;(function(k){k.Ignored="ignored",k.Cancelled="cancelled",k.TooMany="toomany",k.IncompatibleWindow="incompatibleWindow",k.Accepted="reacted"})(T=e.RecommendationsNotificationResult||(e.RecommendationsNotificationResult={})),e.IExtensionRecommendationNotificationService=(0,D.createDecorator)("IExtensionRecommendationNotificationService")}),define(Z[153],te([0,1,7]),function(K,e,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ipcExtensionHostStarterChannelName=e.IExtensionHostStarter=void 0,e.IExtensionHostStarter=(0,D.createDecorator)("extensionHostStarter"),e.ipcExtensionHostStarterChannelName="extensionHostStarter"}),define(Z[77],te([0,1,24,7]),function(K,e,D,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IBuiltinExtensionsScannerService=e.isAuthenticaionProviderExtension=e.isLanguagePackExtension=e.ExtensionIdentifier=e.ExtensionType=e.EXTENSION_CATEGORIES=e.isIExtensionIdentifier=e.getWorkspaceSupportTypeMessage=e.ALL_EXTENSION_KINDS=e.BUILTIN_MANIFEST_CACHE_FILE=e.USER_MANIFEST_CACHE_FILE=e.MANIFEST_CACHE_FOLDER=void 0,e.MANIFEST_CACHE_FOLDER="CachedExtensions",e.USER_MANIFEST_CACHE_FILE="user",e.BUILTIN_MANIFEST_CACHE_FILE="builtin",e.ALL_EXTENSION_KINDS=["ui","workspace","web"];function R(i){if(typeof i=="object"&&i!==null&&i.supported!==!0)return i.description}e.getWorkspaceSupportTypeMessage=R;function T(i){return i&&typeof i=="object"&&typeof i.id=="string"&&(!i.uuid||typeof i.uuid=="string")}e.isIExtensionIdentifier=T,e.EXTENSION_CATEGORIES=["Azure","Data Science","Debuggers","Extension Packs","Education","Formatters","Keymaps","Language Packs","Linters","Machine Learning","Notebooks","Programming Languages","SCM Providers","Snippets","Testing","Themes","Visualization","Other"];var k;(function(i){i[i.System=0]="System",i[i.User=1]="User"})(k=e.ExtensionType||(e.ExtensionType={}));class P{constructor(C){this.value=C,this._lower=C.toLowerCase()}static equals(C,g){if(typeof C=="undefined"||C===null)return typeof g=="undefined"||g===null;if(typeof g=="undefined"||g===null)return!1;if(typeof C=="string"||typeof g=="string"){let w=typeof C=="string"?C:C.value,u=typeof g=="string"?g:g.value;return D.equalsIgnoreCase(w,u)}return C._lower===g._lower}static toKey(C){return typeof C=="string"?C.toLowerCase():C._lower}}e.ExtensionIdentifier=P;function m(i){return i.contributes&&i.contributes.localizations?i.contributes.localizations.length>0:!1}e.isLanguagePackExtension=m;function b(i){return i.contributes&&i.contributes.authentication?i.contributes.authentication.length>0:!1}e.isAuthenticaionProviderExtension=b,e.IBuiltinExtensionsScannerService=(0,L.createDecorator)("IBuiltinExtensionsScannerService")}),define(Z[32],te([0,1,24,77]),function(K,e,D,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getExtensionDependencies=e.getMaliciousExtensionsSet=e.BetterMergeId=e.getGalleryExtensionTelemetryData=e.getLocalExtensionTelemetryData=e.groupByExtension=e.getGalleryExtensionId=e.adoptToGalleryExtensionId=e.getExtensionId=e.ExtensionIdentifierWithVersion=e.areSameExtensions=void 0;function R(u,S){return u.uuid&&S.uuid?u.uuid===S.uuid:u.id===S.id?!0:(0,D.compareIgnoreCase)(u.id,S.id)===0}e.areSameExtensions=R;class T{constructor(S,f){this.version=f,this.id=S.id,this.uuid=S.uuid}key(){return`${this.id}-${this.version}`}equals(S){return S instanceof T?R(this,S)&&this.version===S.version:!1}}e.ExtensionIdentifierWithVersion=T;function k(u,S){return`${u}.${S}`}e.getExtensionId=k;function P(u){return u.toLocaleLowerCase()}e.adoptToGalleryExtensionId=P;function m(u,S){return P(k(u,S))}e.getGalleryExtensionId=m;function b(u,S){const f=[],I=y=>{for(const E of f)if(E.some(o=>R(S(o),S(y))))return E;return null};for(const y of u){const E=I(y);E?E.push(y):f.push([y])}return f}e.groupByExtension=b;function i(u){return{id:u.identifier.id,name:u.manifest.name,galleryId:null,publisherId:u.publisherId,publisherName:u.manifest.publisher,publisherDisplayName:u.publisherDisplayName,dependencies:u.manifest.extensionDependencies&&u.manifest.extensionDependencies.length>0}}e.getLocalExtensionTelemetryData=i;function C(u){return{id:u.identifier.id,name:u.name,galleryId:u.identifier.uuid,publisherId:u.publisherId,publisherName:u.publisher,publisherDisplayName:u.publisherDisplayName,dependencies:!!(u.properties.dependencies&&u.properties.dependencies.length>0),...u.telemetryData}}e.getGalleryExtensionTelemetryData=C,e.BetterMergeId=new L.ExtensionIdentifier("pprice.better-merge");function g(u){const S=new Set;for(const f of u)f.malicious&&S.add(f.id.id);return S}e.getMaliciousExtensionsSet=g;function w(u,S){const f=[],I=S.manifest.extensionDependencies?.slice(0)??[];for(;I.length;){const y=I.shift();if(y&&f.every(E=>!R(E.identifier,{id:y}))){const E=u.filter(o=>R(o.identifier,{id:y}));E.length===1&&(f.push(E[0]),I.push(...E[0].manifest.extensionDependencies?.slice(0)??[]))}}return f}e.getExtensionDependencies=w}),define(Z[154],te([0,1,2,8,19,77]),function(K,e,D,L,R,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionsManifestCache=void 0;class k extends D.Disposable{constructor(m,b){super();this.environmentService=m,this.extensionsManifestCache=(0,L.join)(this.environmentService.userDataPath,T.MANIFEST_CACHE_FOLDER,T.USER_MANIFEST_CACHE_FILE),this._register(b.onDidInstallExtensions(i=>this.onDidInstallExtensions(i))),this._register(b.onDidUninstallExtension(i=>this.onDidUnInstallExtension(i)))}onDidInstallExtensions(m){m.some(b=>!!b.local)&&this.invalidate()}onDidUnInstallExtension(m){m.error||this.invalidate()}invalidate(){R.Promises.rm(this.extensionsManifestCache,R.RimRafMode.MOVE).then(()=>{},()=>{})}}e.ExtensionsManifestCache=k}),define(Z[14],te([0,1,41,8,24,18,5,124,7]),function(K,e,D,L,R,T,k,P,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getPlatformLimits=e.Arch=e.ByteSize=e.FALLBACK_MAX_MEMORY_SIZE_MB=e.MIN_MAX_MEMORY_SIZE_MB=e.whenProviderRegistered=e.etag=e.ETAG_DISABLED=e.FileKind=e.FILES_EXCLUDE_CONFIG=e.FILES_ASSOCIATIONS_CONFIG=e.HotExitConfiguration=e.AutoSaveConfiguration=e.FileOperationResult=e.NotModifiedSinceFileOperationError=e.FileOperationError=e.isParent=e.FileChangesEvent=e.FileChangeType=e.FileOperationEvent=e.FileOperation=e.toFileOperationResult=e.toFileSystemProviderErrorCode=e.markAsFileSystemProviderError=e.ensureFileSystemProviderError=e.createFileSystemProviderError=e.FileSystemProviderError=e.FileSystemProviderErrorCode=e.hasFileReadStreamCapability=e.hasOpenReadWriteCloseCapability=e.hasFileFolderCopyCapability=e.hasReadWriteCapability=e.FileSystemProviderCapabilities=e.FilePermission=e.FileType=e.isFileOpenForWriteOptions=e.IFileService=void 0,e.IFileService=(0,m.createDecorator)("fileService");function b(M){return M.create===!0}e.isFileOpenForWriteOptions=b;var i;(function(M){M[M.Unknown=0]="Unknown",M[M.File=1]="File",M[M.Directory=2]="Directory",M[M.SymbolicLink=64]="SymbolicLink"})(i=e.FileType||(e.FileType={}));var C;(function(M){M[M.Readonly=1]="Readonly"})(C=e.FilePermission||(e.FilePermission={}));var g;(function(M){M[M.FileReadWrite=2]="FileReadWrite",M[M.FileOpenReadWriteClose=4]="FileOpenReadWriteClose",M[M.FileReadStream=16]="FileReadStream",M[M.FileFolderCopy=8]="FileFolderCopy",M[M.PathCaseSensitive=1024]="PathCaseSensitive",M[M.Readonly=2048]="Readonly",M[M.Trash=4096]="Trash",M[M.FileWriteUnlock=8192]="FileWriteUnlock"})(g=e.FileSystemProviderCapabilities||(e.FileSystemProviderCapabilities={}));function w(M){return!!(M.capabilities&2)}e.hasReadWriteCapability=w;function u(M){return!!(M.capabilities&8)}e.hasFileFolderCopyCapability=u;function S(M){return!!(M.capabilities&4)}e.hasOpenReadWriteCloseCapability=S;function f(M){return!!(M.capabilities&16)}e.hasFileReadStreamCapability=f;var I;(function(M){M.FileExists="EntryExists",M.FileNotFound="EntryNotFound",M.FileNotADirectory="EntryNotADirectory",M.FileIsADirectory="EntryIsADirectory",M.FileExceedsMemoryLimit="EntryExceedsMemoryLimit",M.FileTooLarge="EntryTooLarge",M.FileWriteLocked="EntryWriteLocked",M.NoPermissions="NoPermissions",M.Unavailable="Unavailable",M.Unknown="Unknown"})(I=e.FileSystemProviderErrorCode||(e.FileSystemProviderErrorCode={}));class y extends Error{constructor(j,q){super(j);this.code=q}}e.FileSystemProviderError=y;function E(M,j){const q=new y(M.toString(),j);return a(q,j),q}e.createFileSystemProviderError=E;function o(M){return M||E((0,P.localize)(0,null),I.Unknown)}e.ensureFileSystemProviderError=o;function a(M,j){return M.name=j?`${j} (FileSystemError)`:"FileSystemError",M}e.markAsFileSystemProviderError=a;function t(M){if(!M)return I.Unknown;if(M instanceof y)return M.code;const j=/^(.+) \(FileSystemError\)$/.exec(M.name);if(!j)return I.Unknown;switch(j[1]){case I.FileExists:return I.FileExists;case I.FileIsADirectory:return I.FileIsADirectory;case I.FileNotADirectory:return I.FileNotADirectory;case I.FileNotFound:return I.FileNotFound;case I.FileExceedsMemoryLimit:return I.FileExceedsMemoryLimit;case I.FileTooLarge:return I.FileTooLarge;case I.FileWriteLocked:return I.FileWriteLocked;case I.NoPermissions:return I.NoPermissions;case I.Unavailable:return I.Unavailable}return I.Unknown}e.toFileSystemProviderErrorCode=t;function r(M){if(M instanceof d)return M.fileOperationResult;switch(t(M)){case I.FileNotFound:return 1;case I.FileIsADirectory:return 0;case I.FileNotADirectory:return 10;case I.FileWriteLocked:return 5;case I.NoPermissions:return 6;case I.FileExists:return 4;case I.FileExceedsMemoryLimit:return 9;case I.FileTooLarge:return 7;default:return 11}}e.toFileOperationResult=r;var n;(function(M){M[M.CREATE=0]="CREATE",M[M.DELETE=1]="DELETE",M[M.MOVE=2]="MOVE",M[M.COPY=3]="COPY"})(n=e.FileOperation||(e.FileOperation={}));class s{constructor(j,q,x){this.resource=j,this.operation=q,this.target=x}isOperation(j){return this.operation===j}}e.FileOperationEvent=s;var c;(function(M){M[M.UPDATED=0]="UPDATED",M[M.ADDED=1]="ADDED",M[M.DELETED=2]="DELETED"})(c=e.FileChangeType||(e.FileChangeType={}));class l{constructor(j,q){this.added=void 0,this.updated=void 0,this.deleted=void 0;for(const x of j)switch(x.type){case 1:this.added||(this.added=D.TernarySearchTree.forUris(()=>q)),this.added.set(x.resource,x);break;case 0:this.updated||(this.updated=D.TernarySearchTree.forUris(()=>q)),this.updated.set(x.resource,x);break;case 2:this.deleted||(this.deleted=D.TernarySearchTree.forUris(()=>q)),this.deleted.set(x.resource,x);break}}contains(j,...q){return this.doContains(j,{includeChildren:!1},...q)}affects(j,...q){return this.doContains(j,{includeChildren:!0},...q)}doContains(j,q,...x){if(!j)return!1;const $=x.length>0;return!!((!$||x.includes(1))&&(this.added?.get(j)||q.includeChildren&&this.added?.findSuperstr(j))||(!$||x.includes(0))&&(this.updated?.get(j)||q.includeChildren&&this.updated?.findSuperstr(j))||(!$||x.includes(2))&&(this.deleted?.findSubstr(j)||q.includeChildren&&this.deleted?.findSuperstr(j)))}gotAdded(){return!!this.added}gotDeleted(){return!!this.deleted}gotUpdated(){return!!this.updated}get rawAdded(){return this.added}get rawDeleted(){return this.deleted}}e.FileChangesEvent=l;function h(M,j,q){return!M||!j||M===j||j.length>M.length?!1:(j.charAt(j.length-1)!==L.sep&&(j+=L.sep),q?(0,R.startsWithIgnoreCase)(M,j):M.indexOf(j)===0)}e.isParent=h;class d extends Error{constructor(j,q,x){super(j);this.fileOperationResult=q,this.options=x}}e.FileOperationError=d;class v extends d{constructor(j,q,x){super(j,2,x);this.stat=q}}e.NotModifiedSinceFileOperationError=v;var A;(function(M){M[M.FILE_IS_DIRECTORY=0]="FILE_IS_DIRECTORY",M[M.FILE_NOT_FOUND=1]="FILE_NOT_FOUND",M[M.FILE_NOT_MODIFIED_SINCE=2]="FILE_NOT_MODIFIED_SINCE",M[M.FILE_MODIFIED_SINCE=3]="FILE_MODIFIED_SINCE",M[M.FILE_MOVE_CONFLICT=4]="FILE_MOVE_CONFLICT",M[M.FILE_WRITE_LOCKED=5]="FILE_WRITE_LOCKED",M[M.FILE_PERMISSION_DENIED=6]="FILE_PERMISSION_DENIED",M[M.FILE_TOO_LARGE=7]="FILE_TOO_LARGE",M[M.FILE_INVALID_PATH=8]="FILE_INVALID_PATH",M[M.FILE_EXCEEDS_MEMORY_LIMIT=9]="FILE_EXCEEDS_MEMORY_LIMIT",M[M.FILE_NOT_DIRECTORY=10]="FILE_NOT_DIRECTORY",M[M.FILE_OTHER_ERROR=11]="FILE_OTHER_ERROR"})(A=e.FileOperationResult||(e.FileOperationResult={})),e.AutoSaveConfiguration={OFF:"off",AFTER_DELAY:"afterDelay",ON_FOCUS_CHANGE:"onFocusChange",ON_WINDOW_CHANGE:"onWindowChange"},e.HotExitConfiguration={OFF:"off",ON_EXIT:"onExit",ON_EXIT_AND_WINDOW_CLOSE:"onExitAndWindowClose"},e.FILES_ASSOCIATIONS_CONFIG="files.associations",e.FILES_EXCLUDE_CONFIG="files.exclude";var O;(function(M){M[M.FILE=0]="FILE",M[M.FOLDER=1]="FOLDER",M[M.ROOT_FOLDER=2]="ROOT_FOLDER"})(O=e.FileKind||(e.FileKind={})),e.ETAG_DISABLED="";function p(M){if(!(typeof M.size!="number"||typeof M.mtime!="number"))return M.mtime.toString(29)+M.size.toString(31)}e.etag=p;async function U(M,j){if(!j.canHandleResource(k.URI.from({scheme:M.scheme})))return new Promise(q=>{const x=j.onDidChangeFileSystemProviderRegistrations($=>{$.scheme===M.scheme&&$.added&&(x.dispose(),q())})})}e.whenProviderRegistered=U,e.MIN_MAX_MEMORY_SIZE_MB=2048,e.FALLBACK_MAX_MEMORY_SIZE_MB=4096;class F{static formatSize(j){return(0,T.isNumber)(j)||(j=0),j<F.KB?(0,P.localize)(1,null,j.toFixed(0)):j<F.MB?(0,P.localize)(2,null,(j/F.KB).toFixed(2)):j<F.GB?(0,P.localize)(3,null,(j/F.MB).toFixed(2)):j<F.TB?(0,P.localize)(4,null,(j/F.GB).toFixed(2)):(0,P.localize)(5,null,(j/F.TB).toFixed(2))}}e.ByteSize=F,F.KB=1024,F.MB=F.KB*F.KB,F.GB=F.MB*F.KB,F.TB=F.GB*F.KB;var z;(function(M){M[M.IA32=0]="IA32",M[M.OTHER=1]="OTHER"})(z=e.Arch||(e.Arch={}));function H(M){return{maxFileSize:M===0?300*F.MB:16*F.GB,maxHeapSize:M===0?700*F.MB:2*700*F.MB}}e.getPlatformLimits=H}),define(Z[155],te([0,1,156,50,14]),function(K,e,D,L,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ChecksumService=void 0;let T=class{constructor(P){this.fileService=P}checksum(P){return new Promise(async(m,b)=>{const i=(0,D.createHash)("md5"),C=(await this.fileService.readFileStream(P)).value;(0,L.listenStream)(C,{onData:g=>i.update(g.buffer),onError:g=>b(g),onEnd:()=>m(i.digest("base64").replace(/=+$/,""))})})}};T=fe([J(0,R.IFileService)],T),e.ChecksumService=T}),define(Z[157],te([0,1,223,115,136,14]),function(K,e,D,L,R,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.isLaunchedFromCli=e.addArg=e.parseCLIProcessArgv=e.parseMainProcessArgv=void 0;function k(g,w){const u={onUnknownOption:f=>{console.warn((0,L.localize)(0,null,f))},onMultipleValues:(f,I)=>{console.warn((0,L.localize)(1,null,f,I))}},S=(0,R.parseArgs)(g,R.OPTIONS,w?u:void 0);return S.goto&&S._.forEach(f=>D(/^(\w:)?[^:]+(:\d*){0,2}$/.test(f),(0,L.localize)(2,null))),S["max-memory"]&&D(parseInt(S["max-memory"])>=T.MIN_MAX_MEMORY_SIZE_MB,`The max-memory argument cannot be specified lower than ${T.MIN_MAX_MEMORY_SIZE_MB} MB.`),S}function P(g){const w=g.findIndex(u=>!/^-/.test(u));if(w>-1)return[...g.slice(0,w),...g.slice(w+1)]}function m(g){let[,...w]=g;process.env.VSCODE_DEV&&(w=P(w)||[]);const u=!C(process.env);return k(w,u)}e.parseMainProcessArgv=m;function b(g){const[,,...w]=g;return k(w,!0)}e.parseCLIProcessArgv=b;function i(g,...w){const u=g.indexOf("--");return u===-1?g.push(...w):g.splice(u,0,...w),g}e.addArg=i;function C(g){return g.VSCODE_CLI==="1"}e.isLaunchedFromCli=C}),define(Z[158],te([0,1,37,138,27,38,9,4,30,111,157]),function(K,e,D,L,R,T,k,P,m,b,i){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.resolveShellEnv=void 0;async function C(u,S,f){return S["force-disable-user-env"]?(u.trace("resolveShellEnv(): skipped (--force-disable-user-env)"),{}):P.isWindows?(u.trace("resolveShellEnv(): skipped (Windows)"),{}):(0,i.isLaunchedFromCli)(f)&&!S["force-user-env"]?(u.trace("resolveShellEnv(): skipped (VSCODE_CLI is set)"),{}):((0,i.isLaunchedFromCli)(f)?u.trace("resolveShellEnv(): running (--force-user-env)"):u.trace("resolveShellEnv(): running (macOS/Linux)"),g||(g=new Promise(async I=>{const y=new R.CancellationTokenSource,E=setTimeout(()=>{u.error("[resolve shell env] Could not resolve shell environment within 10 seconds. Proceeding without shell environment..."),y.dispose(!0),I({})},1e4);try{const o=await w(u,y.token);I(o)}catch(o){(0,k.isPromiseCanceledError)(o)||u.error(`[resolve shell env] Unable to resolve shell environment (${o}). Proceeding without shell environment...`),I({})}finally{clearTimeout(E),y.dispose()}})),g)}e.resolveShellEnv=C;let g;async function w(u,S){const f=new Promise(async(I,y)=>{const E=process.env.ELECTRON_RUN_AS_NODE;u.trace("getUnixShellEnvironment#runAsNode",E);const o=process.env.ELECTRON_NO_ATTACH_CONSOLE;u.trace("getUnixShellEnvironment#noAttach",o);const a=(0,m.generateUuid)().replace(/-/g,"").substr(0,12),t=new RegExp(a+"(.*)"+a),r={...process.env,ELECTRON_RUN_AS_NODE:"1",ELECTRON_NO_ATTACH_CONSOLE:"1"};u.trace("getUnixShellEnvironment#env",r);const n=await(0,b.getSystemShell)(P.OS,r);if(u.trace("getUnixShellEnvironment#shell",n),S.isCancellationRequested)return y(k.canceled);const s=L.basename(n);let c,l;/^pwsh(-preview)?$/.test(s)?(c=`& '${process.execPath}' -p '''${a}'' + JSON.stringify(process.env) + ''${a}'''`,l=["-Login","-Command"]):(c=`'${process.execPath}' -p '"${a}" + JSON.stringify(process.env) + "${a}"'`,l=["-ilc"]),u.trace("getUnixShellEnvironment#spawn",JSON.stringify(l),c);const h=(0,D.spawn)(n,[...l,c],{detached:!0,stdio:["ignore","pipe","pipe"],env:r});S.onCancellationRequested(()=>(h.kill(),y(k.canceled))),h.on("error",A=>{u.error("getUnixShellEnvironment#errorChildProcess",(0,T.toErrorMessage)(A)),I({})});const d=[];h.stdout.on("data",A=>d.push(A));const v=[];h.stderr.on("data",A=>v.push(A)),h.on("close",(A,O)=>{const p=Buffer.concat(d).toString("utf8");u.trace("getUnixShellEnvironment#raw",p);const U=Buffer.concat(v).toString("utf8");if(U.trim()&&u.trace("getUnixShellEnvironment#stderr",U),A||O)return y(new Error(`Failed to get environment (code ${A}, signal ${O})`));const F=t.exec(p),z=F?F[1]:"{}";try{const H=JSON.parse(z);E?H.ELECTRON_RUN_AS_NODE=E:delete H.ELECTRON_RUN_AS_NODE,o?H.ELECTRON_NO_ATTACH_CONSOLE=o:delete H.ELECTRON_NO_ATTACH_CONSOLE,delete H.XDG_RUNTIME_DIR,u.trace("getUnixShellEnvironment#result",H),I(H)}catch(H){u.error("getUnixShellEnvironment#errorCaught",(0,T.toErrorMessage)(H)),y(H)}})});try{return await f}catch(I){return u.error("getUnixShellEnvironment#error",(0,T.toErrorMessage)(I)),{}}}}),define(Z[78],te([0,1,4,5,14]),function(K,e,D,L,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.normalizeFileChanges=e.toFileChanges=void 0;function T(m){return m.map(b=>({type:b.type,resource:L.URI.file(b.path)}))}e.toFileChanges=T;function k(m){const b=new P;for(const i of m)b.processEvent(i);return b.normalize()}e.normalizeFileChanges=k;class P{constructor(){this.normalized=[],this.mapPathToChange=new Map}processEvent(b){const i=this.mapPathToChange.get(b.path);if(i){const C=i.type,g=b.type;C===1&&g===2?(this.mapPathToChange.delete(b.path),this.normalized.splice(this.normalized.indexOf(i),1)):C===2&&g===1?i.type=0:C===1&&g===0||(i.type=g)}else this.normalized.push(b),this.mapPathToChange.set(b.path,b)}normalize(){const b=[],i=[];return this.normalized.filter(C=>C.type!==2?(b.push(C),!1):!0).sort((C,g)=>C.path.length-g.path.length).filter(C=>i.some(g=>(0,R.isParent)(C.path,g,!D.isLinux))?!1:(i.push(C.path),!0)).concat(b)}}}),define(Z[159],te([0,1,6,2,8,101,19,103,78]),function(K,e,D,L,R,T,k,P,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.FileWatcher=void 0;class b extends L.Disposable{constructor(C,g,w,u){super();this.path=C,this.onDidFilesChange=g,this.onLogMessage=w,this.verboseLogging=u,this.fileChangesDelayer=this._register(new D.ThrottledDelayer(P.CHANGE_BUFFER_DELAY*2)),this.fileChangesBuffer=[],this.startWatching()}setVerboseLogging(C){this.verboseLogging=C}async startWatching(){try{const{stat:C,symbolicLink:g}=await k.SymlinkSupport.stat(this.path);if(this.isDisposed)return;let w=this.path;if(g)try{w=await(0,T.realpath)(w)}catch(u){if(this.onError(u),g.dangling)return}C.isDirectory()?this._register((0,P.watchFolder)(w,(u,S)=>{this.onFileChange({type:u==="changed"?0:u==="added"?1:2,path:(0,R.join)(this.path,(0,R.basename)(S))})},u=>this.onError(u))):this._register((0,P.watchFile)(w,u=>{this.onFileChange({type:u==="changed"?0:2,path:this.path})},u=>this.onError(u)))}catch(C){C.code!=="ENOENT"&&this.onError(C)}}onFileChange(C){this.fileChangesBuffer.push(C),this.verboseLogging&&this.onVerbose(`${C.type===1?"[ADDED]":C.type===2?"[DELETED]":"[CHANGED]"} ${C.path}`),this.fileChangesDelayer.trigger(async()=>{const g=this.fileChangesBuffer;this.fileChangesBuffer=[];const w=(0,m.normalizeFileChanges)(g);if(this.verboseLogging)for(const u of w)this.onVerbose(`>> normalized ${u.type===1?"[ADDED]":u.type===2?"[DELETED]":"[CHANGED]"} ${u.path}`);w.length>0&&this.onDidFilesChange(w)})}onError(C){this.isDisposed||this.onLogMessage({type:"error",message:`[File Watcher (node.js)] ${C}`})}onVerbose(C){this.isDisposed||this.onLogMessage({type:"trace",message:`[File Watcher (node.js)] ${C}`})}dispose(){this.isDisposed=!0,super.dispose()}}e.FileWatcher=b}),define(Z[79],te([0,1]),function(K,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ServiceCollection=void 0;class D{constructor(...R){this._entries=new Map;for(let[T,k]of R)this.set(T,k)}set(R,T){const k=this._entries.get(R);return this._entries.set(R,T),k}has(R){return this._entries.has(R)}get(R){return this._entries.get(R)}}e.ServiceCollection=D}),define(Z[160],te([0,1,6,9,53,148,7,79]),function(K,e,D,L,R,T,k,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.InstantiationService=void 0;const m=!1;class b extends Error{constructor(u){super("cyclic dependency between services");this.message=u.findCycleSlow()??`UNABLE to detect cycle, dumping graph: 
${u.toString()}`}}class i{constructor(u=new P.ServiceCollection,S=!1,f){this._activeInstantiations=new Set,this._services=u,this._strict=S,this._parent=f,this._services.set(k.IInstantiationService,this)}createChild(u){return new i(u,this._strict,this)}invokeFunction(u,...S){let f=g.traceInvocation(u),I=!1;try{return u({get:(E,o)=>{if(I)throw(0,L.illegalState)("service accessor is only valid during the invocation of its target method");const a=this._getOrCreateServiceInstance(E,f);if(!a&&o!==k.optional)throw new Error(`[invokeFunction] unknown service '${E}'`);return a}},...S)}finally{I=!0,f.stop()}}createInstance(u,...S){let f,I;return u instanceof R.SyncDescriptor?(f=g.traceCreation(u.ctor),I=this._createInstance(u.ctor,u.staticArguments.concat(S),f)):(f=g.traceCreation(u),I=this._createInstance(u,S,f)),f.stop(),I}_createInstance(u,S=[],f){let I=k._util.getServiceDependencies(u).sort((o,a)=>o.index-a.index),y=[];for(const o of I){let a=this._getOrCreateServiceInstance(o.id,f);if(!a&&this._strict&&!o.optional)throw new Error(`[createInstance] ${u.name} depends on UNKNOWN service ${o.id}.`);y.push(a)}let E=I.length>0?I[0].index:S.length;if(S.length!==E){console.warn(`[createInstance] First service dependency of ${u.name} at position ${E+1} conflicts with ${S.length} static arguments`);let o=E-S.length;o>0?S=S.concat(new Array(o)):S=S.slice(0,E)}return new u(...[...S,...y])}_setServiceInstance(u,S){if(this._services.get(u)instanceof R.SyncDescriptor)this._services.set(u,S);else if(this._parent)this._parent._setServiceInstance(u,S);else throw new Error("illegalState - setting UNKNOWN service instance")}_getServiceInstanceOrDescriptor(u){let S=this._services.get(u);return!S&&this._parent?this._parent._getServiceInstanceOrDescriptor(u):S}_getOrCreateServiceInstance(u,S){let f=this._getServiceInstanceOrDescriptor(u);return f instanceof R.SyncDescriptor?this._safeCreateAndCacheServiceInstance(u,f,S.branch(u,!0)):(S.branch(u,!1),f)}_safeCreateAndCacheServiceInstance(u,S,f){if(this._activeInstantiations.has(u))throw new Error(`illegal state - RECURSIVELY instantiating service '${u}'`);this._activeInstantiations.add(u);try{return this._createAndCacheServiceInstance(u,S,f)}finally{this._activeInstantiations.delete(u)}}_createAndCacheServiceInstance(u,S,f){const I=new T.Graph(o=>o.id.toString());let y=0;const E=[{id:u,desc:S,_trace:f}];for(;E.length;){const o=E.pop();if(I.lookupOrInsertNode(o),y++>1e3)throw new b(I);for(let a of k._util.getServiceDependencies(o.desc.ctor)){let t=this._getServiceInstanceOrDescriptor(a.id);if(!t&&!a.optional&&console.warn(`[createInstance] ${u} depends on ${a.id} which is NOT registered.`),t instanceof R.SyncDescriptor){const r={id:a.id,desc:t,_trace:o._trace.branch(a.id,!0)};I.insertEdge(o,r),E.push(r)}}}for(;;){const o=I.roots();if(o.length===0){if(!I.isEmpty())throw new b(I);break}for(const{data:a}of o){if(this._getServiceInstanceOrDescriptor(a.id)instanceof R.SyncDescriptor){const r=this._createServiceInstanceWithOwner(a.id,a.desc.ctor,a.desc.staticArguments,a.desc.supportsDelayedInstantiation,a._trace);this._setServiceInstance(a.id,r)}I.removeNode(a)}}return this._getServiceInstanceOrDescriptor(u)}_createServiceInstanceWithOwner(u,S,f=[],I,y){if(this._services.get(u)instanceof R.SyncDescriptor)return this._createServiceInstance(S,f,I,y);if(this._parent)return this._parent._createServiceInstanceWithOwner(u,S,f,I,y);throw new Error(`illegalState - creating UNKNOWN service instance ${S.name}`)}_createServiceInstance(u,S=[],f,I){if(f){const y=new D.IdleValue(()=>this._createInstance(u,S,I));return new Proxy(Object.create(null),{get(E,o){if(o in E)return E[o];let a=y.value,t=a[o];return typeof t!="function"||(t=t.bind(a),E[o]=t),t},set(E,o,a){return y.value[o]=a,!0}})}else return this._createInstance(u,S,I)}}e.InstantiationService=i;var C;(function(w){w[w.Creation=0]="Creation",w[w.Invocation=1]="Invocation",w[w.Branch=2]="Branch"})(C||(C={}));class g{constructor(u,S){this.type=u,this.name=S,this._start=Date.now(),this._dep=[]}static traceInvocation(u){return m?new g(1,u.name||u.toString().substring(0,42).replace(/\n/g,"")):g._None}static traceCreation(u){return m?new g(0,u.name):g._None}branch(u,S){let f=new g(2,u.toString());return this._dep.push([u,S,f]),f}stop(){let u=Date.now()-this._start;g._totals+=u;let S=!1;function f(y,E){let o=[],a=new Array(y+1).join("	");for(const[t,r,n]of E._dep)if(r&&n){S=!0,o.push(`${a}CREATES -> ${t}`);let s=f(y+1,n);s&&o.push(s)}else o.push(`${a}uses -> ${t}`);return o.join(`
`)}let I=[`${this.type===0?"CREATE":"CALL"} ${this.name}`,`${f(1,this)}`,`DONE, took ${u.toFixed(2)}ms (grand total ${g._totals.toFixed(2)}ms)`];(u>2||S)&&console.log(I.join(`
`))}}g._None=new class extends g{constructor(){super(-1,null)}stop(){}branch(){return this}},g._totals=0}),define(Z[161],te([0,1]),function(K,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.MessagePortMainProcessService=void 0;class D{constructor(R,T){this.server=R,this.router=T}getChannel(R){return this.server.getChannel(R,this.router)}registerChannel(R,T){this.server.registerChannel(R,T)}}e.MessagePortMainProcessService=D}),define(Z[162],te([0,1,36,53,147,7]),function(K,e,D,L,R,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.registerSharedProcessRemoteService=e.ISharedProcessService=e.registerMainProcessRemoteService=e.IMainProcessService=void 0;class k{constructor(w,u,S){const f=S.getChannel(w);return P(u)?new u.channelClientCtor(f):D.ProxyChannel.toService(f,u?.proxyOptions)}}function P(g){return!!g?.channelClientCtor}e.IMainProcessService=(0,T.createDecorator)("mainProcessService");let m=class extends k{constructor(w,u,S){super(w,u,S)}};m=fe([J(2,e.IMainProcessService)],m);function b(g,w,u){(0,R.registerSingleton)(g,new L.SyncDescriptor(m,[w,u],u?.supportsDelayedInstantiation))}e.registerMainProcessRemoteService=b,e.ISharedProcessService=(0,T.createDecorator)("sharedProcessService");let i=class extends k{constructor(w,u,S){super(w,u,S)}};i=fe([J(2,e.ISharedProcessService)],i);function C(g,w,u){(0,R.registerSingleton)(g,new L.SyncDescriptor(i,[w,u],u?.supportsDelayedInstantiation))}e.registerSharedProcessRemoteService=C}),define(Z[57],te([0,1,7]),function(K,e,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.isValidLocalization=e.ILocalizationsService=void 0,e.ILocalizationsService=(0,D.createDecorator)("localizationsService");function L(R){if(typeof R.languageId!="string"||!Array.isArray(R.translations)||R.translations.length===0)return!1;for(const T of R.translations)if(typeof T.id!="string"||typeof T.path!="string")return!1;return!(R.languageName&&typeof R.languageName!="string"||R.localizedLanguageName&&typeof R.localizedLanguageName!="string")}e.isValidLocalization=L}),define(Z[163],te([0,1,2,57]),function(K,e,D,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.LocalizationsUpdater=void 0;let R=class extends D.Disposable{constructor(k){super();this.localizationsService=k,this.updateLocalizations()}updateLocalizations(){this.localizationsService.update()}};R=fe([J(0,L.ILocalizationsService)],R),e.LocalizationsUpdater=R}),define(Z[13],te([0,1,38,3,2,4,7]),function(K,e,D,L,R,T,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.LogLevelToString=e.parseLogLevel=e.getLogLevel=e.NullLogService=e.AbstractLoggerService=e.LogService=e.MultiplexLogService=e.AdapterLogger=e.ConsoleLogger=e.ConsoleMainLogger=e.AbstractMessageLogger=e.AbstractLogger=e.DEFAULT_LOG_LEVEL=e.LogLevel=e.ILoggerService=e.ILogService=void 0,e.ILogService=(0,k.createDecorator)("logService"),e.ILoggerService=(0,k.createDecorator)("loggerService");function P(){return new Date().toISOString()}var m;(function(a){a[a.Trace=0]="Trace",a[a.Debug=1]="Debug",a[a.Info=2]="Info",a[a.Warning=3]="Warning",a[a.Error=4]="Error",a[a.Critical=5]="Critical",a[a.Off=6]="Off"})(m=e.LogLevel||(e.LogLevel={})),e.DEFAULT_LOG_LEVEL=m.Info;class b extends R.Disposable{constructor(){super(...arguments);this.level=e.DEFAULT_LOG_LEVEL,this._onDidChangeLogLevel=this._register(new L.Emitter),this.onDidChangeLogLevel=this._onDidChangeLogLevel.event}setLevel(t){this.level!==t&&(this.level=t,this._onDidChangeLogLevel.fire(this.level))}getLevel(){return this.level}}e.AbstractLogger=b;class i extends b{constructor(t){super();this.logAlways=t}checkLogLevel(t){return this.logAlways||this.getLevel()<=t}trace(t,...r){this.checkLogLevel(m.Trace)&&this.log(m.Trace,this.format([t,...r]))}debug(t,...r){this.checkLogLevel(m.Debug)&&this.log(m.Debug,this.format([t,...r]))}info(t,...r){this.checkLogLevel(m.Info)&&this.log(m.Info,this.format([t,...r]))}warn(t,...r){this.checkLogLevel(m.Warning)&&this.log(m.Warning,this.format([t,...r]))}error(t,...r){if(this.checkLogLevel(m.Error))if(t instanceof Error){const n=Array.prototype.slice.call(arguments);n[0]=t.stack,this.log(m.Error,this.format(n))}else this.log(m.Error,this.format([t,...r]))}critical(t,...r){this.checkLogLevel(m.Critical)&&this.log(m.Critical,this.format([t,...r]))}flush(){}format(t){let r="";for(let n=0;n<t.length;n++){let s=t[n];if(typeof s=="object")try{s=JSON.stringify(s)}catch(c){}r+=(n>0?" ":"")+s}return r}}e.AbstractMessageLogger=i;class C extends b{constructor(t=e.DEFAULT_LOG_LEVEL){super();this.setLevel(t),this.useColors=!T.isWindows}trace(t,...r){this.getLevel()<=m.Trace&&(this.useColors?console.log(`[90m[main ${P()}][0m`,t,...r):console.log(`[main ${P()}]`,t,...r))}debug(t,...r){this.getLevel()<=m.Debug&&(this.useColors?console.log(`[90m[main ${P()}][0m`,t,...r):console.log(`[main ${P()}]`,t,...r))}info(t,...r){this.getLevel()<=m.Info&&(this.useColors?console.log(`[90m[main ${P()}][0m`,t,...r):console.log(`[main ${P()}]`,t,...r))}warn(t,...r){this.getLevel()<=m.Warning&&(this.useColors?console.warn(`[93m[main ${P()}][0m`,t,...r):console.warn(`[main ${P()}]`,t,...r))}error(t,...r){this.getLevel()<=m.Error&&(this.useColors?console.error(`[91m[main ${P()}][0m`,t,...r):console.error(`[main ${P()}]`,t,...r))}critical(t,...r){this.getLevel()<=m.Critical&&(this.useColors?console.error(`[90m[main ${P()}][0m`,t,...r):console.error(`[main ${P()}]`,t,...r))}dispose(){}flush(){}}e.ConsoleMainLogger=C;class g extends b{constructor(t=e.DEFAULT_LOG_LEVEL){super();this.setLevel(t)}trace(t,...r){this.getLevel()<=m.Trace&&console.log("%cTRACE","color: #888",t,...r)}debug(t,...r){this.getLevel()<=m.Debug&&console.log("%cDEBUG","background: #eee; color: #888",t,...r)}info(t,...r){this.getLevel()<=m.Info&&console.log("%c INFO","color: #33f",t,...r)}warn(t,...r){this.getLevel()<=m.Warning&&console.log("%c WARN","color: #993",t,...r)}error(t,...r){this.getLevel()<=m.Error&&console.log("%c  ERR","color: #f33",t,...r)}critical(t,...r){this.getLevel()<=m.Critical&&console.log("%cCRITI","background: #f33; color: white",t,...r)}dispose(){}flush(){}}e.ConsoleLogger=g;class w extends b{constructor(t,r=e.DEFAULT_LOG_LEVEL){super();this.adapter=t,this.setLevel(r)}trace(t,...r){this.getLevel()<=m.Trace&&this.adapter.log(m.Trace,[this.extractMessage(t),...r])}debug(t,...r){this.getLevel()<=m.Debug&&this.adapter.log(m.Debug,[this.extractMessage(t),...r])}info(t,...r){this.getLevel()<=m.Info&&this.adapter.log(m.Info,[this.extractMessage(t),...r])}warn(t,...r){this.getLevel()<=m.Warning&&this.adapter.log(m.Warning,[this.extractMessage(t),...r])}error(t,...r){this.getLevel()<=m.Error&&this.adapter.log(m.Error,[this.extractMessage(t),...r])}critical(t,...r){this.getLevel()<=m.Critical&&this.adapter.log(m.Critical,[this.extractMessage(t),...r])}extractMessage(t){return typeof t=="string"?t:(0,D.toErrorMessage)(t,this.getLevel()<=m.Trace)}dispose(){}flush(){}}e.AdapterLogger=w;class u extends b{constructor(t){super();this.logServices=t,t.length&&this.setLevel(t[0].getLevel())}setLevel(t){for(const r of this.logServices)r.setLevel(t);super.setLevel(t)}trace(t,...r){for(const n of this.logServices)n.trace(t,...r)}debug(t,...r){for(const n of this.logServices)n.debug(t,...r)}info(t,...r){for(const n of this.logServices)n.info(t,...r)}warn(t,...r){for(const n of this.logServices)n.warn(t,...r)}error(t,...r){for(const n of this.logServices)n.error(t,...r)}critical(t,...r){for(const n of this.logServices)n.critical(t,...r)}flush(){for(const t of this.logServices)t.flush()}dispose(){for(const t of this.logServices)t.dispose()}}e.MultiplexLogService=u;class S extends R.Disposable{constructor(t){super();this.logger=t,this._register(t)}get onDidChangeLogLevel(){return this.logger.onDidChangeLogLevel}setLevel(t){this.logger.setLevel(t)}getLevel(){return this.logger.getLevel()}trace(t,...r){this.logger.trace(t,...r)}debug(t,...r){this.logger.debug(t,...r)}info(t,...r){this.logger.info(t,...r)}warn(t,...r){this.logger.warn(t,...r)}error(t,...r){this.logger.error(t,...r)}critical(t,...r){this.logger.critical(t,...r)}flush(){this.logger.flush()}}e.LogService=S;class f extends R.Disposable{constructor(t,r){super();this.logLevel=t,this.loggers=new Map,this.logLevelChangeableLoggers=[],this._register(r(n=>{this.logLevel=n,this.logLevelChangeableLoggers.forEach(s=>s.setLevel(n))}))}getLogger(t){return this.loggers.get(t.toString())}createLogger(t,r){let n=this.loggers.get(t.toString());return n||(n=this.doCreateLogger(t,r?.always?m.Trace:this.logLevel,r),this.loggers.set(t.toString(),n),r?.always||this.logLevelChangeableLoggers.push(n)),n}dispose(){this.logLevelChangeableLoggers.splice(0,this.logLevelChangeableLoggers.length),this.loggers.forEach(t=>t.dispose()),this.loggers.clear(),super.dispose()}}e.AbstractLoggerService=f;class I{constructor(){this.onDidChangeLogLevel=new L.Emitter().event}setLevel(t){}getLevel(){return m.Info}trace(t,...r){}debug(t,...r){}info(t,...r){}warn(t,...r){}error(t,...r){}critical(t,...r){}dispose(){}flush(){}}e.NullLogService=I;function y(a){if(a.verbose)return m.Trace;if(typeof a.logLevel=="string"){const t=E(a.logLevel.toLowerCase());if(t!==void 0)return t}return e.DEFAULT_LOG_LEVEL}e.getLogLevel=y;function E(a){switch(a){case"trace":return m.Trace;case"debug":return m.Debug;case"info":return m.Info;case"warn":return m.Warning;case"error":return m.Error;case"critical":return m.Critical;case"off":return m.Off}}e.parseLogLevel=E;function o(a){switch(a){case m.Trace:return"trace";case m.Debug:return"debug";case m.Info:return"info";case m.Warning:return"warn";case m.Error:return"error";case m.Critical:return"critical";case m.Off:return"off"}}e.LogLevelToString=o}),define(Z[164],te([0,1,6,9,2,8,19,12,13]),function(K,e,D,L,R,T,k,P,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.LogsDataCleaner=void 0;let b=class extends R.Disposable{constructor(C,g){super();this.environmentService=C,this.logService=g,this._register(new D.RunOnceScheduler(()=>{this.cleanUpOldLogs()},10*1e3)).schedule()}async cleanUpOldLogs(){this.logService.info("[logs cleanup]: Starting to clean up old logs.");try{const C=(0,T.basename)(this.environmentService.logsPath),g=(0,T.dirname)(this.environmentService.logsPath),S=(await k.Promises.readdir(g)).filter(I=>/^\d{8}T\d{6}$/.test(I)).sort().filter(I=>I!==C),f=S.slice(0,Math.max(0,S.length-9));f.length>0&&(this.logService.info(`[logs cleanup]: Removing log folders '${f.join(", ")}'`),await Promise.all(f.map(I=>k.Promises.rm((0,T.join)(g,I)))))}catch(C){(0,L.onUnexpectedError)(C)}}};b=fe([J(0,P.IEnvironmentService),J(1,m.ILogService)],b),e.LogsDataCleaner=b}),define(Z[165],te([0,1,6,9,2,8,19,12,13]),function(K,e,D,L,R,T,k,P,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.StorageDataCleaner=void 0;let b=class dt extends R.Disposable{constructor(C,g,w){super();this.backupWorkspacesPath=C,this.environmentService=g,this.logService=w,this._register(new D.RunOnceScheduler(()=>{this.cleanUpStorage()},30*1e3)).schedule()}async cleanUpStorage(){this.logService.info("[storage cleanup]: Starting to clean up storage folders.");try{const C=await k.Promises.readFile(this.backupWorkspacesPath,"utf8"),w=JSON.parse(C).emptyWorkspaceInfos.map(S=>S.backupFolder),u=await k.Promises.readdir(this.environmentService.workspaceStorageHome.fsPath);await Promise.all(u.map(async S=>{S.length!==dt.NON_EMPTY_WORKSPACE_ID_LENGTH&&w.indexOf(S)===-1&&(this.logService.info(`[storage cleanup]: Deleting storage folder ${S}.`),await k.Promises.rm((0,T.join)(this.environmentService.workspaceStorageHome.fsPath,S)))}))}catch(C){(0,L.onUnexpectedError)(C)}}};b.NON_EMPTY_WORKSPACE_ID_LENGTH=128/4,b=fe([J(1,P.INativeEnvironmentService),J(2,m.ILogService)],b),e.StorageDataCleaner=b}),define(Z[166],te([0,1,6,9,2,4,16,58,5,30,19,12,28,32,14,13]),function(K,e,D,L,R,T,k,P,m,b,i,C,g,w,u,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionsDownloader=void 0;const f=/^([^.]+\..+)-(\d+\.\d+\.\d+)$/;let I=class extends R.Disposable{constructor(E,o,a,t){super();this.fileService=o,this.extensionGalleryService=a,this.logService=t,this.extensionsDownloadDir=m.URI.file(E.extensionsDownloadPath),this.cache=20,this.cleanUpPromise=this.cleanUp()}async downloadExtension(E,o){await this.cleanUpPromise;const a=this.getName(E),t=(0,k.joinPath)(this.extensionsDownloadDir,a);if(!await this.fileService.exists(t)){const r=(0,k.joinPath)(this.extensionsDownloadDir,`.${(0,b.generateUuid)()}`);await this.fileService.exists(r)||await this.extensionGalleryService.download(E,r,o);try{await this.rename(r,t,Date.now()+2*60*1e3)}catch(n){try{await this.fileService.del(r)}catch(s){}if(n.code==="ENOTEMPTY")this.logService.info("Rename failed because vsix was downloaded by another source. So ignoring renaming.",E.identifier.id);else throw this.logService.info(`Rename failed because of ${(0,L.getErrorMessage)(n)}. Deleted the vsix from downloaded location`,r.path),n}}return t}async delete(E){}async rename(E,o,a){try{await i.Promises.rename(E.fsPath,o.fsPath)}catch(t){if(T.isWindows&&t&&t.code==="EPERM"&&Date.now()<a)return this.logService.info(`Failed renaming ${E} to ${o} with 'EPERM' error. Trying again...`),this.rename(E,o,a);throw t}}async cleanUp(){try{if(!await this.fileService.exists(this.extensionsDownloadDir)){this.logService.trace("Extension VSIX downlads cache dir does not exist");return}const E=await this.fileService.resolve(this.extensionsDownloadDir,{resolveMetadata:!0});if(E.children){const o=[],a=[];for(const n of E.children){const s=this.parse(n.name);s&&a.push([s,n])}const t=(0,w.groupByExtension)(a,([n])=>n),r=[];for(const n of t)n.sort((s,c)=>P.rcompare(s[0].version,c[0].version)),o.push(...n.slice(1).map(s=>s[1].resource)),r.push(n[0][1]);r.sort((n,s)=>n.mtime-s.mtime),o.push(...r.slice(0,Math.max(0,r.length-this.cache)).map(n=>n.resource)),await D.Promises.settled(o.map(n=>(this.logService.trace("Deleting vsix from cache",n.path),this.fileService.del(n))))}}catch(E){this.logService.error(E)}}getName(E){return this.cache?`${new w.ExtensionIdentifierWithVersion(E.identifier,E.version).key().toLowerCase()}${E.properties.targetPlatform!=="undefined"?`-${E.properties.targetPlatform}`:""}`:(0,b.generateUuid)()}parse(E){const o=f.exec(E);return o&&o[1]&&o[2]?new w.ExtensionIdentifierWithVersion({id:o[1]},o[2]):null}};I=fe([J(0,C.INativeEnvironmentService),J(1,u.IFileService),J(2,g.IExtensionGalleryService),J(3,S.ILogService)],I),e.ExtensionsDownloader=I}),define(Z[167],te([0,1,37,6,38,3,2,15,8,19,12,13]),function(K,e,D,L,R,T,k,P,m,b,i,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionsLifecycle=void 0;let g=class extends k.Disposable{constructor(u,S){super();this.environmentService=u,this.logService=S,this.processesLimiter=new L.Limiter(5)}async postUninstall(u){const S=this.parseScript(u,"uninstall");return S&&(this.logService.info(u.identifier.id,u.manifest.version,"Running post uninstall script"),await this.processesLimiter.queue(()=>this.runLifecycleHook(S.script,"uninstall",S.args,!0,u).then(()=>this.logService.info(u.identifier.id,u.manifest.version,"Finished running post uninstall script"),f=>this.logService.error(u.identifier.id,u.manifest.version,`Failed to run post uninstall script: ${f}`)))),b.Promises.rm(this.getExtensionStoragePath(u)).then(void 0,f=>this.logService.error("Error while removing extension storage path",f))}parseScript(u,S){const f=`vscode:${S}`;if(u.location.scheme===P.Schemas.file&&u.manifest&&u.manifest.scripts&&typeof u.manifest.scripts[f]=="string"){const I=u.manifest.scripts[f].split(" ");return I.length<2||I[0]!=="node"||!I[1]?(this.logService.warn(u.identifier.id,u.manifest.version,`${f} should be a node script`),null):{script:(0,m.join)(u.location.fsPath,I[1]),args:I.slice(2)||[]}}return null}runLifecycleHook(u,S,f,I,y){return new Promise((E,o)=>{const a=this.start(u,S,f,y);let t;const r=n=>{t&&(clearTimeout(t),t=null),n?o(n):E(void 0)};a.on("error",n=>{r((0,R.toErrorMessage)(n)||"Unknown")}),a.on("exit",(n,s)=>{r(n?`post-${S} process exited with code ${n}`:void 0)}),I&&(t=setTimeout(()=>{t=null,a.kill(),o("timed out")},5e3))})}start(u,S,f,I){const y={silent:!0,execArgv:void 0},E=(0,D.fork)(u,[`--type=extension-post-${S}`,...f],y);E.stdout.setEncoding("utf8"),E.stderr.setEncoding("utf8");const o=T.Event.fromNodeEventEmitter(E.stdout,"data"),a=T.Event.fromNodeEventEmitter(E.stderr,"data");o(n=>this.logService.info(I.identifier.id,I.manifest.version,`post-${S}`,n)),a(n=>this.logService.error(I.identifier.id,I.manifest.version,`post-${S}`,n));const t=T.Event.any(T.Event.map(o,n=>({data:`%c${n}`,format:[""]})),T.Event.map(a,n=>({data:`%c${n}`,format:["color: red"]})));return T.Event.debounce(t,(n,s)=>n?{data:n.data+s.data,format:[...n.format,...s.format]}:{data:s.data,format:s.format},100)(n=>{console.group(I.identifier.id),console.log(n.data,...n.format),console.groupEnd()}),E}getExtensionStoragePath(u){return(0,m.join)(this.environmentService.globalStorageHome.fsPath,u.identifier.id.toLowerCase())}};g=fe([J(0,i.IEnvironmentService),J(1,C.ILogService)],g),e.ExtensionsLifecycle=g}),define(Z[168],te([0,1,3,2,16,5,12,32,14,13]),function(K,e,D,L,R,T,k,P,m,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionsWatcher=void 0;let i=class extends L.Disposable{constructor(g,w,u,S){super();this.extensionsManagementService=g,this.logService=S,this._onDidChangeExtensionsByAnotherSource=this._register(new D.Emitter),this.onDidChangeExtensionsByAnotherSource=this._onDidChangeExtensionsByAnotherSource.event,this.startTimestamp=0,this.installingExtensions=[],this.extensionsManagementService.getInstalled(1).then(y=>{this.installedExtensions=y.map(E=>E.identifier),this.startTimestamp=Date.now()}),this._register(g.onInstallExtension(y=>this.onInstallExtension(y))),this._register(g.onDidInstallExtensions(y=>this.onDidInstallExtensions(y))),this._register(g.onDidUninstallExtension(y=>this.onDidUninstallExtension(y)));const f=T.URI.file(u.extensionsPath),I=new R.ExtUri(y=>!w.hasCapability(y,1024));this._register(w.watch(f)),this._register(D.Event.filter(w.onDidChangeFilesRaw,y=>y.changes.some(E=>this.doesChangeAffects(E,f,I)))(()=>this.onDidChange()))}doesChangeAffects(g,w,u){return u.isEqual(u.dirname(g.resource),w)?u.isEqual(g.resource,u.joinPath(w,".obsolete"))?!0:!(g.type!==1&&g.type!==2||u.basename(g.resource).startsWith(".")):!1}onInstallExtension(g){this.addInstallingExtension(g.identifier)}onDidInstallExtensions(g){for(const w of g)this.removeInstallingExtension(w.identifier),w.local&&this.addInstalledExtension(w.identifier)}onDidUninstallExtension(g){g.error||this.removeInstalledExtension(g.identifier)}addInstallingExtension(g){this.removeInstallingExtension(g),this.installingExtensions.push(g)}removeInstallingExtension(g){this.installingExtensions=this.installingExtensions.filter(w=>!(0,P.areSameExtensions)(w,g))}addInstalledExtension(g){this.installedExtensions&&(this.removeInstalledExtension(g),this.installedExtensions.push(g))}removeInstalledExtension(g){this.installedExtensions&&(this.installedExtensions=this.installedExtensions.filter(w=>!(0,P.areSameExtensions)(w,g)))}async onDidChange(){if(this.installedExtensions){const g=await this.extensionsManagementService.getInstalled(1),w=g.filter(S=>[...this.installingExtensions,...this.installedExtensions].some(f=>(0,P.areSameExtensions)(f,S.identifier))?!1:S.installedTimestamp&&S.installedTimestamp>this.startTimestamp?(this.logService.info("Detected extension installed from another source",S.identifier.id),!0):(this.logService.info("Ignored extension installed by another source because of invalid timestamp",S.identifier.id),!1)),u=this.installedExtensions.filter(S=>this.installingExtensions.some(f=>(0,P.areSameExtensions)(f,S))?!1:g.every(f=>!(0,P.areSameExtensions)(f.identifier,S))?(this.logService.info("Detected extension removed from another source",S.id),!0):!1);this.installedExtensions=g.map(S=>S.identifier),(w.length||u.length)&&this._onDidChangeExtensionsByAnotherSource.fire({added:w,removed:u})}}};i=fe([J(1,m.IFileService),J(2,k.INativeEnvironmentService),J(3,b.ILogService)],i),e.ExtensionsWatcher=i}),define(Z[169],te([0,1,9,2,3,37,15,98,4,13]),function(K,e,D,L,R,T,k,P,m,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionHostStarter=void 0;let i=class extends L.Disposable{constructor(w,u){super();this.id=w,this._logService=u,this._onStdout=this._register(new R.Emitter),this.onStdout=this._onStdout.event,this._onStderr=this._register(new R.Emitter),this.onStderr=this._onStderr.event,this._onMessage=this._register(new R.Emitter),this.onMessage=this._onMessage.event,this._onError=this._register(new R.Emitter),this.onError=this._onError.event,this._onExit=this._register(new R.Emitter),this.onExit=this._onExit.event,this._process=null}register(w){this._register(w)}start(w){this._process=(0,T.fork)(k.FileAccess.asFileUri("bootstrap-fork",K).fsPath,["--type=extensionHost","--skipWorkspaceStorageLock"],w),this._logService.info(`Starting extension host with pid ${this._process.pid}.`);const u=new P.StringDecoder("utf-8");this._process.stdout?.on("data",f=>{const I=typeof f=="string"?f:u.write(f);this._onStdout.fire(I)});const S=new P.StringDecoder("utf-8");return this._process.stderr?.on("data",f=>{const I=typeof f=="string"?f:S.write(f);this._onStderr.fire(I)}),this._process.on("message",f=>{this._onMessage.fire(f)}),this._process.on("error",f=>{this._onError.fire({error:(0,D.transformErrorForSerialization)(f)})}),this._process.on("exit",(f,I)=>{this._onExit.fire({code:f,signal:I})}),{pid:this._process.pid}}enableInspectPort(){return this._process?(this._logService.info(`Enabling inspect port on extension host with pid ${this._process.pid}.`),typeof process._debugProcess=="function"?(process._debugProcess(this._process.pid),!0):m.isWindows?!1:(this._process.kill("SIGUSR1"),!0)):!1}kill(){!this._process||(this._logService.info(`Killing extension host with pid ${this._process.pid}.`),this._process.kill())}};i=fe([J(1,b.ILogService)],i);let C=class gt{constructor(w){this._logService=w,this._extHosts=new Map}dispose(){}_getExtHost(w){const u=this._extHosts.get(w);if(!u)throw new Error("Unknown extension host!");return u}onScopedStdout(w){return this._getExtHost(w).onStdout}onScopedStderr(w){return this._getExtHost(w).onStderr}onScopedMessage(w){return this._getExtHost(w).onMessage}onScopedError(w){return this._getExtHost(w).onError}onScopedExit(w){return this._getExtHost(w).onExit}async createExtensionHost(){const w=String(++gt._lastId),u=new i(w,this._logService);return this._extHosts.set(w,u),u.onExit(()=>{setTimeout(()=>{u.dispose(),this._extHosts.delete(w)})}),{id:w}}async start(w,u){return this._getExtHost(w).start(u)}async enableInspectPort(w){return this._getExtHost(w).enableInspectPort()}async kill(w){this._getExtHost(w).kill()}};C._lastId=0,C=fe([J(0,b.ILogService)],C),e.ExtensionHostStarter=C}),define(Z[170],te([0,1,156,17,6,2,15,8,19,12,28,32,57,13]),function(K,e,D,L,R,T,k,P,m,b,i,C,g,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.LocalizationsService=void 0;let u=class extends T.Disposable{constructor(I,y,E){super();this.extensionManagementService=I,this.logService=E,this.cache=this._register(new S(y,E)),this.extensionManagementService.registerParticipant({postInstall:async o=>this.postInstallExtension(o),postUninstall:async o=>this.postUninstallExtension(o)})}async getLanguageIds(){const I=await this.cache.getLanguagePacks(),y=["en",...Object.keys(I)];return(0,L.distinct)(y)}async postInstallExtension(I){I&&I.manifest&&I.manifest.contributes&&I.manifest.contributes.localizations&&I.manifest.contributes.localizations.length&&(this.logService.info("Adding language packs from the extension",I.identifier.id),await this.update())}async postUninstallExtension(I){const y=await this.cache.getLanguagePacks();Object.keys(y).some(E=>y[E]&&y[E].extensions.some(o=>(0,C.areSameExtensions)(o.extensionIdentifier,I.identifier)))&&(this.logService.info("Removing language packs from the extension",I.identifier.id),await this.update())}async update(){const[I,y]=await Promise.all([this.cache.getLanguagePacks(),this.extensionManagementService.getInstalled()]),E=await this.cache.update(y);return!(0,L.equals)(Object.keys(I),Object.keys(E))}};u=fe([J(0,i.IExtensionManagementService),J(1,b.INativeEnvironmentService),J(2,w.ILogService)],u),e.LocalizationsService=u;let S=class extends T.Disposable{constructor(I,y){super();this.logService=y,this.languagePacks={},this.languagePacksFilePath=(0,P.join)(I.userDataPath,"languagepacks.json"),this.languagePacksFileLimiter=new R.Queue}getLanguagePacks(){return this.languagePacksFileLimiter.size||!this.initializedCache?this.withLanguagePacks().then(()=>this.languagePacks):Promise.resolve(this.languagePacks)}update(I){return this.withLanguagePacks(y=>{Object.keys(y).forEach(E=>delete y[E]),this.createLanguagePacksFromExtensions(y,...I)}).then(()=>this.languagePacks)}createLanguagePacksFromExtensions(I,...y){for(const E of y)E&&E.manifest&&E.manifest.contributes&&E.manifest.contributes.localizations&&E.manifest.contributes.localizations.length&&this.createLanguagePacksFromExtension(I,E);Object.keys(I).forEach(E=>this.updateHash(I[E]))}createLanguagePacksFromExtension(I,y){const E=y.identifier,o=y.manifest.contributes&&y.manifest.contributes.localizations?y.manifest.contributes.localizations:[];for(const a of o)if(y.location.scheme===k.Schemas.file&&(0,g.isValidLocalization)(a)){let t=I[a.languageId];t||(t={hash:"",extensions:[],translations:{}},I[a.languageId]=t);let r=t.extensions.filter(n=>(0,C.areSameExtensions)(n.extensionIdentifier,E))[0];r?r.version=y.manifest.version:t.extensions.push({extensionIdentifier:E,version:y.manifest.version});for(const n of a.translations)t.translations[n.id]=(0,P.join)(y.location.fsPath,n.path)}}updateHash(I){if(I){const y=(0,D.createHash)("md5");for(const E of I.extensions)y.update(E.extensionIdentifier.uuid||E.extensionIdentifier.id).update(E.version);I.hash=y.digest("hex")}}withLanguagePacks(I=()=>null){return this.languagePacksFileLimiter.queue(()=>{let y=null;return m.Promises.readFile(this.languagePacksFilePath,"utf8").then(void 0,E=>E.code==="ENOENT"?Promise.resolve("{}"):Promise.reject(E)).then(E=>{try{return JSON.parse(E)}catch(o){return{}}}).then(E=>(y=I(E),E)).then(E=>{for(const a of Object.keys(E))E[a]||delete E[a];this.languagePacks=E,this.initializedCache=!0;const o=JSON.stringify(this.languagePacks);return this.logService.debug("Writing language packs",o),m.Promises.writeFile(this.languagePacksFilePath,o)}).then(()=>y,E=>this.logService.error(E))})}};S=fe([J(0,b.INativeEnvironmentService),J(1,w.ILogService)],S)}),define(Z[80],te([0,1,3,5,13]),function(K,e,D,L,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.FollowerLogService=e.LoggerChannelClient=e.LoggerChannel=e.LogLevelChannelClient=e.LogLevelChannel=void 0;class T{constructor(g){this.service=g,this.onDidChangeLogLevel=D.Event.buffer(g.onDidChangeLogLevel,!0)}listen(g,w){switch(w){case"onDidChangeLogLevel":return this.onDidChangeLogLevel}throw new Error(`Event not found: ${w}`)}async call(g,w,u){switch(w){case"setLevel":return this.service.setLevel(u)}throw new Error(`Call not found: ${w}`)}}e.LogLevelChannel=T;class k{constructor(g){this.channel=g}get onDidChangeLogLevel(){return this.channel.listen("onDidChangeLogLevel")}setLevel(g){k.setLevel(this.channel,g)}static setLevel(g,w){return g.call("setLevel",w)}}e.LogLevelChannelClient=k;class P{constructor(g){this.loggerService=g,this.loggers=new Map}listen(g,w){throw new Error(`Event not found: ${w}`)}async call(g,w,u){switch(w){case"createLogger":this.createLogger(L.URI.revive(u[0]),u[1]);return;case"log":return this.log(L.URI.revive(u[0]),u[1]);case"consoleLog":return this.consoleLog(u[0],u[1])}throw new Error(`Call not found: ${w}`)}createLogger(g,w){this.loggers.set(g.toString(),this.loggerService.createLogger(g,w))}consoleLog(g,w){let u=console.log;switch(g){case R.LogLevel.Error:u=console.error;break;case R.LogLevel.Warning:u=console.warn;break;case R.LogLevel.Info:u=console.info;break}u.call(console,...w)}log(g,w){const u=this.loggers.get(g.toString());if(!u)throw new Error("Create the logger before logging");for(const[S,f]of w)switch(S){case R.LogLevel.Trace:u.trace(f);break;case R.LogLevel.Debug:u.debug(f);break;case R.LogLevel.Info:u.info(f);break;case R.LogLevel.Warning:u.warn(f);break;case R.LogLevel.Error:u.error(f);break;case R.LogLevel.Critical:u.critical(f);break;default:throw new Error("Invalid log level")}}}e.LoggerChannel=P;class m extends R.AbstractLoggerService{constructor(g,w,u){super(g,w);this.channel=u}createConsoleMainLogger(){return new R.AdapterLogger({log:(g,w)=>{this.channel.call("consoleLog",[g,w])}})}doCreateLogger(g,w,u){return new b(this.channel,g,w,u)}}e.LoggerChannelClient=m;class b extends R.AbstractMessageLogger{constructor(g,w,u,S){super(S?.always);this.channel=g,this.file=w,this.isLoggerCreated=!1,this.buffer=[],this.setLevel(u),this.channel.call("createLogger",[w,S]).then(()=>{this.doLog(this.buffer),this.isLoggerCreated=!0})}log(g,w){const u=[[g,w]];this.isLoggerCreated?this.doLog(u):this.buffer.push(...u)}doLog(g){this.channel.call("log",[this.file,g])}}class i extends R.LogService{constructor(g,w){super(w);this.parent=g,this._register(g.onDidChangeLogLevel(u=>w.setLevel(u)))}setLevel(g){super.setLevel(g),this.parent.setLevel(g)}}e.FollowerLogService=i}),define(Z[59],te([0,1,7]),function(K,e,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.INativeHostService=void 0,e.INativeHostService=(0,D.createDecorator)("nativeHostService")}),define(Z[42],te([0,1,15,4,31,16]),function(K,e,D,L,R,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0});let k;if(typeof L.globals.vscode!="undefined"&&typeof L.globals.vscode.context!="undefined"){const P=L.globals.vscode.context.configuration();if(P)k=P.product;else throw new Error("Sandbox: unable to resolve product configuration from preload script.")}else if(typeof K?.__$__nodeRequire=="function"){const P=(0,T.dirname)(D.FileAccess.asFileUri("",K));k=K.__$__nodeRequire((0,T.joinPath)(P,"product.json").fsPath);const m=K.__$__nodeRequire((0,T.joinPath)(P,"package.json").fsPath);R.env.VSCODE_DEV&&Object.assign(k,{nameShort:`${k.nameShort} Dev`,nameLong:`${k.nameLong} Dev`,dataFolderName:`${k.dataFolderName}-dev`}),Object.assign(k,{version:m.version})}else k={},Object.keys(k).length===0&&Object.assign(k,{version:"1.61.0-dev",nameShort:"Code - OSS Dev",nameLong:"Code - OSS Dev",applicationName:"code-oss",dataFolderName:".vscode-oss",urlProtocol:"code-oss",reportIssueUrl:"https://github.com/microsoft/vscode/issues/new",licenseName:"MIT",licenseUrl:"https://github.com/microsoft/vscode/blob/main/LICENSE.txt",extensionAllowedProposedApi:["ms-vscode.vscode-js-profile-flame","ms-vscode.vscode-js-profile-table","ms-vscode.remotehub","ms-vscode.remotehub-insiders","GitHub.remotehub","GitHub.remotehub-insiders"]});e.default=k}),define(Z[81],te([0,1,25,9,125,14,42]),function(K,e,D,L,R,T,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.readFileIntoStream=void 0;async function P(C,g,w,u,S,f){let I;try{await m(C,g,w,u,S,f)}catch(y){I=y}finally{I&&S.errorTransformer&&(I=S.errorTransformer(I)),typeof I!="undefined"&&w.error(I),w.end()}}e.readFileIntoStream=P;async function m(C,g,w,u,S,f){b(f);const I=await C.open(g,{create:!1});try{b(f);let y=0,E=0,o=S&&typeof S.length=="number"?S.length:void 0,a=D.VSBuffer.alloc(Math.min(S.bufferSize,typeof o=="number"?o:S.bufferSize)),t=S&&typeof S.position=="number"?S.position:0,r=0;do E=await C.read(I,t,a.buffer,r,a.byteLength-r),t+=E,r+=E,y+=E,typeof o=="number"&&(o-=E),r===a.byteLength&&(await w.write(u(a)),a=D.VSBuffer.alloc(Math.min(S.bufferSize,typeof o=="number"?o:S.bufferSize)),r=0);while(E>0&&(typeof o!="number"||o>0)&&b(f)&&i(y,S));if(r>0){let n=r;typeof o=="number"&&(n=Math.min(r,o)),w.write(u(a.slice(0,n)))}}catch(y){throw(0,T.ensureFileSystemProviderError)(y)}finally{await C.close(I)}}function b(C){if(C.isCancellationRequested)throw(0,L.canceled)();return!0}function i(C,g){if(g?.limits){if(typeof g.limits.memory=="number"&&C>g.limits.memory)throw(0,T.createFileSystemProviderError)((0,R.localize)(0,null,k.default.nameShort),T.FileSystemProviderErrorCode.FileExceedsMemoryLimit);if(typeof g.limits.size=="number"&&C>g.limits.size)throw(0,T.createFileSystemProviderError)((0,R.localize)(1,null),T.FileSystemProviderErrorCode.FileTooLarge)}return!0}}),define(Z[171],te([0,1,17,6,25,27,3,55,2,41,15,172,16,50,123,14,81,13]),function(K,e,D,L,R,T,k,P,m,b,i,C,g,w,u,S,f,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.FileService=void 0;let y=class Be extends m.Disposable{constructor(o){super();this.logService=o,this.BUFFER_SIZE=64*1024,this._onDidChangeFileSystemProviderRegistrations=this._register(new k.Emitter),this.onDidChangeFileSystemProviderRegistrations=this._onDidChangeFileSystemProviderRegistrations.event,this._onWillActivateFileSystemProvider=this._register(new k.Emitter),this.onWillActivateFileSystemProvider=this._onWillActivateFileSystemProvider.event,this._onDidChangeFileSystemProviderCapabilities=this._register(new k.Emitter),this.onDidChangeFileSystemProviderCapabilities=this._onDidChangeFileSystemProviderCapabilities.event,this.provider=new Map,this._onDidRunOperation=this._register(new k.Emitter),this.onDidRunOperation=this._onDidRunOperation.event,this._onError=this._register(new k.Emitter),this.onError=this._onError.event,this._onDidFilesChange=this._register(new k.Emitter),this.onDidFilesChange=this._onDidFilesChange.event,this._onDidChangeFilesRaw=this._register(new k.Emitter),this.onDidChangeFilesRaw=this._onDidChangeFilesRaw.event,this.activeWatchers=new Map,this.caseSensitiveFileEventsWorker=this._register(new L.ThrottledWorker(Be.FILE_EVENTS_THROTTLING.maxChangesChunkSize,Be.FILE_EVENTS_THROTTLING.maxChangesBufferSize,Be.FILE_EVENTS_THROTTLING.coolDownDelay,a=>this._onDidFilesChange.fire(new S.FileChangesEvent(a,!1)))),this.caseInsensitiveFileEventsWorker=this._register(new L.ThrottledWorker(Be.FILE_EVENTS_THROTTLING.maxChangesChunkSize,Be.FILE_EVENTS_THROTTLING.maxChangesBufferSize,Be.FILE_EVENTS_THROTTLING.coolDownDelay,a=>this._onDidFilesChange.fire(new S.FileChangesEvent(a,!0)))),this.watchedResources=b.TernarySearchTree.forUris(a=>{const t=this.getProvider(a.scheme);return t?!this.isPathCaseSensitive(t):!1}),this.writeQueue=this._register(new L.ResourceQueue)}registerProvider(o,a){if(this.provider.has(o))throw new Error(`A filesystem provider for the scheme '${o}' is already registered.`);(0,C.mark)(`code/registerFilesystem/${o}`),this.provider.set(o,a),this._onDidChangeFileSystemProviderRegistrations.fire({added:!0,scheme:o,provider:a});const t=new m.DisposableStore;return t.add(a.onDidChangeFile(r=>this.onDidChangeFile(r,this.isPathCaseSensitive(a)))),t.add(a.onDidChangeCapabilities(()=>this._onDidChangeFileSystemProviderCapabilities.fire({provider:a,scheme:o}))),typeof a.onDidErrorOccur=="function"&&t.add(a.onDidErrorOccur(r=>this._onError.fire(new Error(r)))),(0,m.toDisposable)(()=>{this._onDidChangeFileSystemProviderRegistrations.fire({added:!1,scheme:o,provider:a}),this.provider.delete(o),(0,m.dispose)(t)})}getProvider(o){return this.provider.get(o)}async activateProvider(o){const a=[];this._onWillActivateFileSystemProvider.fire({scheme:o,join(t){a.push(t)}}),!this.provider.has(o)&&await L.Promises.settled(a)}canHandleResource(o){return this.provider.has(o.scheme)}hasCapability(o,a){const t=this.provider.get(o.scheme);return!!(t&&t.capabilities&a)}listCapabilities(){return P.Iterable.map(this.provider,([o,a])=>({scheme:o,capabilities:a.capabilities}))}async withProvider(o){if(!(0,g.isAbsolutePath)(o))throw new S.FileOperationError((0,u.localize)(0,null,this.resourceForError(o)),8);await this.activateProvider(o.scheme);const a=this.provider.get(o.scheme);if(!a){const t=new Error;throw t.name="ENOPRO",t.message=(0,u.localize)(1,null,o.toString()),t}return a}async withReadProvider(o){const a=await this.withProvider(o);if((0,S.hasOpenReadWriteCloseCapability)(a)||(0,S.hasReadWriteCapability)(a)||(0,S.hasFileReadStreamCapability)(a))return a;throw new Error(`Filesystem provider for scheme '${o.scheme}' neither has FileReadWrite, FileReadStream nor FileOpenReadWriteClose capability which is needed for the read operation.`)}async withWriteProvider(o){const a=await this.withProvider(o);if((0,S.hasOpenReadWriteCloseCapability)(a)||(0,S.hasReadWriteCapability)(a))return a;throw new Error(`Filesystem provider for scheme '${o.scheme}' neither has FileReadWrite nor FileOpenReadWriteClose capability which is needed for the write operation.`)}async resolve(o,a){try{return await this.doResolveFile(o,a)}catch(t){throw(0,S.toFileSystemProviderErrorCode)(t)===S.FileSystemProviderErrorCode.FileNotFound?new S.FileOperationError((0,u.localize)(2,null,this.resourceForError(o)),1):(0,S.ensureFileSystemProviderError)(t)}}async doResolveFile(o,a){const t=await this.withProvider(o),r=this.isPathCaseSensitive(t),n=a?.resolveTo,s=a?.resolveSingleChildDescendants,c=a?.resolveMetadata,l=await t.stat(o);let h;return this.toFileStat(t,o,l,void 0,!!c,(d,v)=>{if(!h&&(h=b.TernarySearchTree.forUris(()=>!r),h.set(o,!0),n))for(const A of n)h.set(A,!0);return h.get(d.resource)||h.findSuperstr(d.resource.with({query:null,fragment:null}))?!0:d.isDirectory&&s?v===1:!1})}async toFileStat(o,a,t,r,n,s){const{providerExtUri:c}=this.getExtUri(o),l={resource:a,name:c.basename(a),isFile:(t.type&S.FileType.File)!=0,isDirectory:(t.type&S.FileType.Directory)!=0,isSymbolicLink:(t.type&S.FileType.SymbolicLink)!=0,mtime:t.mtime,ctime:t.ctime,size:t.size,readonly:Boolean((t.permissions??0)&S.FilePermission.Readonly)||Boolean(o.capabilities&2048),etag:(0,S.etag)({mtime:t.mtime,size:t.size})};if(l.isDirectory&&s(l,r)){try{const h=await o.readdir(a),d=await L.Promises.settled(h.map(async([v,A])=>{try{const O=c.joinPath(a,v),p=n?await o.stat(O):{type:A};return await this.toFileStat(o,O,p,h.length,n,s)}catch(O){return this.logService.trace(O),null}}));l.children=(0,D.coalesce)(d)}catch(h){this.logService.trace(h),l.children=[]}return l}return l}async resolveAll(o){return L.Promises.settled(o.map(async a=>{try{return{stat:await this.doResolveFile(a.resource,a.options),success:!0}}catch(t){return this.logService.trace(t),{stat:void 0,success:!1}}}))}async exists(o){const a=await this.withProvider(o);try{return!!await a.stat(o)}catch(t){return!1}}async canCreateFile(o,a){try{await this.doValidateCreateFile(o,a)}catch(t){return t}return!0}async doValidateCreateFile(o,a){if(!a?.overwrite&&await this.exists(o))throw new S.FileOperationError((0,u.localize)(3,null,this.resourceForError(o)),3,a)}async createFile(o,a=R.VSBuffer.fromString(""),t){await this.doValidateCreateFile(o,t);const r=await this.writeFile(o,a);return this._onDidRunOperation.fire(new S.FileOperationEvent(o,0,r)),r}async writeFile(o,a,t){const r=this.throwIfFileSystemIsReadonly(await this.withWriteProvider(o),o),{providerExtUri:n}=this.getExtUri(r);try{await this.validateWriteFile(r,o,t)||await this.mkdirp(r,n.dirname(o));let c;if((0,S.hasReadWriteCapability)(r)&&!(a instanceof R.VSBuffer))if((0,w.isReadableStream)(a)){const l=await(0,w.peekStream)(a,3);l.ended?c=R.VSBuffer.concat(l.buffer):c=l}else c=(0,w.peekReadable)(a,l=>R.VSBuffer.concat(l),3);else c=a;!(0,S.hasOpenReadWriteCloseCapability)(r)||(0,S.hasReadWriteCapability)(r)&&c instanceof R.VSBuffer?await this.doWriteUnbuffered(r,o,t,c):await this.doWriteBuffered(r,o,t,c instanceof R.VSBuffer?(0,R.bufferToReadable)(c):c)}catch(s){throw new S.FileOperationError((0,u.localize)(4,null,this.resourceForError(o),(0,S.ensureFileSystemProviderError)(s).toString()),(0,S.toFileOperationResult)(s),t)}return this.resolve(o,{resolveMetadata:!0})}async validateWriteFile(o,a,t){if(!!t?.unlock&&!(o.capabilities&8192))throw new Error((0,u.localize)(5,null,this.resourceForError(a)));let n;try{n=await o.stat(a)}catch(s){return}if((n.type&S.FileType.Directory)!=0)throw new S.FileOperationError((0,u.localize)(6,null,this.resourceForError(a)),0,t);if(this.throwIfFileIsReadonly(a,n),typeof t?.mtime=="number"&&typeof t.etag=="string"&&t.etag!==S.ETAG_DISABLED&&typeof n.mtime=="number"&&typeof n.size=="number"&&t.mtime<n.mtime&&t.etag!==(0,S.etag)({mtime:t.mtime,size:n.size}))throw new S.FileOperationError((0,u.localize)(7,null),3,t);return n}async readFile(o,a){const t=await this.withReadProvider(o);return a?.atomic?this.doReadFileAtomic(t,o,a):this.doReadFile(t,o,a)}async doReadFileAtomic(o,a,t){return new Promise((r,n)=>{this.writeQueue.queueFor(a,this.getExtUri(o).providerExtUri).queue(async()=>{try{const s=await this.doReadFile(o,a,t);r(s)}catch(s){n(s)}})})}async doReadFile(o,a,t){const r=await this.doReadFileStream(o,a,{...t,preferUnbuffered:!0});return{...r,value:await(0,R.streamToBuffer)(r.value)}}async readFileStream(o,a){const t=await this.withReadProvider(o);return this.doReadFileStream(t,o,a)}async doReadFileStream(o,a,t){const r=new T.CancellationTokenSource,n=this.validateReadFile(a,t).then(c=>c,c=>{throw r.cancel(),c});let s;try{return typeof t?.etag=="string"&&t.etag!==S.ETAG_DISABLED&&await n,!((0,S.hasOpenReadWriteCloseCapability)(o)||(0,S.hasFileReadStreamCapability)(o))||(0,S.hasReadWriteCapability)(o)&&t?.preferUnbuffered?s=this.readFileUnbuffered(o,a,t):(0,S.hasFileReadStreamCapability)(o)?s=this.readFileStreamed(o,a,r.token,t):s=this.readFileBuffered(o,a,r.token,t),{...await n,value:s}}catch(c){s&&await(0,w.consumeStream)(s);const l=(0,u.localize)(8,null,this.resourceForError(a),(0,S.ensureFileSystemProviderError)(c).toString());throw c instanceof S.NotModifiedSinceFileOperationError?new S.NotModifiedSinceFileOperationError(l,c.stat,t):new S.FileOperationError(l,(0,S.toFileOperationResult)(c),t)}}readFileStreamed(o,a,t,r=Object.create(null)){const n=o.readFileStream(a,r,t);return(0,w.transform)(n,{data:s=>s instanceof R.VSBuffer?s:R.VSBuffer.wrap(s),error:s=>new S.FileOperationError((0,u.localize)(9,null,this.resourceForError(a),(0,S.ensureFileSystemProviderError)(s).toString()),(0,S.toFileOperationResult)(s),r)},s=>R.VSBuffer.concat(s))}readFileBuffered(o,a,t,r=Object.create(null)){const n=(0,R.newWriteableBufferStream)();return(0,f.readFileIntoStream)(o,a,n,s=>s,{...r,bufferSize:this.BUFFER_SIZE,errorTransformer:s=>new S.FileOperationError((0,u.localize)(10,null,this.resourceForError(a),(0,S.ensureFileSystemProviderError)(s).toString()),(0,S.toFileOperationResult)(s),r)},t),n}readFileUnbuffered(o,a,t){const r=(0,w.newWriteableStream)(n=>R.VSBuffer.concat(n));return(async()=>{try{let n=await o.readFile(a);typeof t?.position=="number"&&(n=n.slice(t.position)),typeof t?.length=="number"&&(n=n.slice(0,t.length)),this.validateReadFileLimits(a,n.byteLength,t),r.end(R.VSBuffer.wrap(n))}catch(n){r.error(n),r.end()}})(),r}async validateReadFile(o,a){const t=await this.resolve(o,{resolveMetadata:!0});if(t.isDirectory)throw new S.FileOperationError((0,u.localize)(11,null,this.resourceForError(o)),0,a);if(typeof a?.etag=="string"&&a.etag!==S.ETAG_DISABLED&&a.etag===t.etag)throw new S.NotModifiedSinceFileOperationError((0,u.localize)(12,null),t,a);return this.validateReadFileLimits(o,t.size,a),t}validateReadFileLimits(o,a,t){if(t?.limits){let r;if(typeof t.limits.memory=="number"&&a>t.limits.memory&&(r=9),typeof t.limits.size=="number"&&a>t.limits.size&&(r=7),typeof r=="number")throw new S.FileOperationError((0,u.localize)(13,null,this.resourceForError(o)),r)}}async canMove(o,a,t){return this.doCanMoveCopy(o,a,"move",t)}async canCopy(o,a,t){return this.doCanMoveCopy(o,a,"copy",t)}async doCanMoveCopy(o,a,t,r){if(o.toString()!==a.toString())try{const n=t==="move"?this.throwIfFileSystemIsReadonly(await this.withWriteProvider(o),o):await this.withReadProvider(o),s=this.throwIfFileSystemIsReadonly(await this.withWriteProvider(a),a);await this.doValidateMoveCopy(n,o,s,a,t,r)}catch(n){return n}return!0}async move(o,a,t){const r=this.throwIfFileSystemIsReadonly(await this.withWriteProvider(o),o),n=this.throwIfFileSystemIsReadonly(await this.withWriteProvider(a),a),s=await this.doMoveCopy(r,o,n,a,"move",!!t),c=await this.resolve(a,{resolveMetadata:!0});return this._onDidRunOperation.fire(new S.FileOperationEvent(o,s==="move"?2:3,c)),c}async copy(o,a,t){const r=await this.withReadProvider(o),n=this.throwIfFileSystemIsReadonly(await this.withWriteProvider(a),a),s=await this.doMoveCopy(r,o,n,a,"copy",!!t),c=await this.resolve(a,{resolveMetadata:!0});return this._onDidRunOperation.fire(new S.FileOperationEvent(o,s==="copy"?3:2,c)),c}async doMoveCopy(o,a,t,r,n,s){if(a.toString()===r.toString())return n;const{exists:c,isSameResourceWithDifferentPathCase:l}=await this.doValidateMoveCopy(o,a,t,r,n,s);if(c&&!l&&s&&await this.del(r,{recursive:!0}),await this.mkdirp(t,this.getExtUri(t).providerExtUri.dirname(r)),n==="copy"){if(o===t&&(0,S.hasFileFolderCopyCapability)(o))await o.copy(a,r,{overwrite:s});else{const h=await this.resolve(a);h.isDirectory?await this.doCopyFolder(o,h,t,r):await this.doCopyFile(o,a,t,r)}return n}else return o===t?(await o.rename(a,r,{overwrite:s}),n):(await this.doMoveCopy(o,a,t,r,"copy",s),await this.del(a,{recursive:!0}),"copy")}async doCopyFile(o,a,t,r){if((0,S.hasOpenReadWriteCloseCapability)(o)&&(0,S.hasOpenReadWriteCloseCapability)(t))return this.doPipeBuffered(o,a,t,r);if((0,S.hasOpenReadWriteCloseCapability)(o)&&(0,S.hasReadWriteCapability)(t))return this.doPipeBufferedToUnbuffered(o,a,t,r);if((0,S.hasReadWriteCapability)(o)&&(0,S.hasOpenReadWriteCloseCapability)(t))return this.doPipeUnbufferedToBuffered(o,a,t,r);if((0,S.hasReadWriteCapability)(o)&&(0,S.hasReadWriteCapability)(t))return this.doPipeUnbuffered(o,a,t,r)}async doCopyFolder(o,a,t,r){await t.mkdir(r),Array.isArray(a.children)&&await L.Promises.settled(a.children.map(async n=>{const s=this.getExtUri(t).providerExtUri.joinPath(r,n.name);return n.isDirectory?this.doCopyFolder(o,await this.resolve(n.resource),t,s):this.doCopyFile(o,n.resource,t,s)}))}async doValidateMoveCopy(o,a,t,r,n,s){let c=!1;if(o===t){const{providerExtUri:h,isPathCaseSensitive:d}=this.getExtUri(o);if(d||(c=h.isEqual(a,r)),c&&n==="copy")throw new Error((0,u.localize)(14,null,this.resourceForError(a),this.resourceForError(r)));if(!c&&h.isEqualOrParent(r,a))throw new Error((0,u.localize)(15,null,this.resourceForError(a),this.resourceForError(r)))}const l=await this.exists(r);if(l&&!c){if(!s)throw new S.FileOperationError((0,u.localize)(16,null,this.resourceForError(a),this.resourceForError(r)),4);if(o===t){const{providerExtUri:h}=this.getExtUri(o);if(h.isEqualOrParent(a,r))throw new Error((0,u.localize)(17,null,this.resourceForError(a),this.resourceForError(r)))}}return{exists:l,isSameResourceWithDifferentPathCase:c}}getExtUri(o){const a=this.isPathCaseSensitive(o);return{providerExtUri:a?g.extUri:g.extUriIgnorePathCase,isPathCaseSensitive:a}}isPathCaseSensitive(o){return!!(o.capabilities&1024)}async createFolder(o){const a=this.throwIfFileSystemIsReadonly(await this.withProvider(o),o);await this.mkdirp(a,o);const t=await this.resolve(o,{resolveMetadata:!0});return this._onDidRunOperation.fire(new S.FileOperationEvent(o,0,t)),t}async mkdirp(o,a){const t=[],{providerExtUri:r}=this.getExtUri(o);for(;!r.isEqual(a,r.dirname(a));)try{if(((await o.stat(a)).type&S.FileType.Directory)==0)throw new Error((0,u.localize)(18,null,this.resourceForError(a)));break}catch(n){if((0,S.toFileSystemProviderErrorCode)(n)!==S.FileSystemProviderErrorCode.FileNotFound)throw n;t.push(r.basename(a)),a=r.dirname(a)}for(let n=t.length-1;n>=0;n--){a=r.joinPath(a,t[n]);try{await o.mkdir(a)}catch(s){if((0,S.toFileSystemProviderErrorCode)(s)!==S.FileSystemProviderErrorCode.FileExists)throw s}}}async canDelete(o,a){try{await this.doValidateDelete(o,a)}catch(t){return t}return!0}async doValidateDelete(o,a){const t=this.throwIfFileSystemIsReadonly(await this.withProvider(o),o);if(!!a?.useTrash&&!(t.capabilities&4096))throw new Error((0,u.localize)(19,null,this.resourceForError(o)));let n;try{n=await t.stat(o)}catch(c){}if(n)this.throwIfFileIsReadonly(o,n);else throw new S.FileOperationError((0,u.localize)(20,null,this.resourceForError(o)),1);if(!!!a?.recursive){const c=await this.resolve(o);if(c.isDirectory&&Array.isArray(c.children)&&c.children.length>0)throw new Error((0,u.localize)(21,null,this.resourceForError(o)))}return t}async del(o,a){const t=await this.doValidateDelete(o,a),r=!!a?.useTrash,n=!!a?.recursive;await t.delete(o,{recursive:n,useTrash:r}),this._onDidRunOperation.fire(new S.FileOperationEvent(o,1))}onDidChangeFile(o,a){this._onDidChangeFilesRaw.fire({changes:o});let t,r;{for(const n of o)this.watchedResources.has(n.resource)?(t||(t=[]),t.push(n)):(r||(r=[]),r.push(n));t&&this._onDidFilesChange.fire(new S.FileChangesEvent(t,!a))}if(r){const n=a?this.caseSensitiveFileEventsWorker:this.caseInsensitiveFileEventsWorker;!n.work(r)&&Be.FILE_EVENTS_THROTTLING.warningscounter++<10&&this.logService.warn(`[File watcher]: started ignoring events due to too many file change events at once (incoming: ${r.length}, most recent change: ${r[0].resource.toString()}). Use 'files.watcherExclude' setting to exclude folders with lots of changing files (e.g. compilation output).`),n.pending>0&&this.logService.trace(`[File watcher]: started throttling events due to large amount of file change events at once (pending: ${n.pending}, most recent change: ${r[0].resource.toString()}). Use 'files.watcherExclude' setting to exclude folders with lots of changing files (e.g. compilation output).`)}}watch(o,a={recursive:!1,excludes:[]}){const t=new m.DisposableStore;{let r=!1,n=()=>{r=!0};t.add((0,m.toDisposable)(()=>n())),this.doWatch(o,a).then(s=>{r?(0,m.dispose)(s):n=()=>(0,m.dispose)(s)},s=>this.logService.error(s))}return a.recursive||(this.watchedResources.set(o,(this.watchedResources.get(o)??0)+1),t.add((0,m.toDisposable)(()=>{const r=this.watchedResources.get(o);typeof r=="number"&&(r<=1?this.watchedResources.delete(o):this.watchedResources.set(o,r-1))}))),t}async doWatch(o,a){const t=await this.withProvider(o),r=this.toWatchKey(t,o,a),n=this.activeWatchers.get(r)||{count:0,disposable:t.watch(o,a)};return this.activeWatchers.has(r)||this.activeWatchers.set(r,n),n.count+=1,(0,m.toDisposable)(()=>{n.count--,n.count===0&&((0,m.dispose)(n.disposable),this.activeWatchers.delete(r))})}toWatchKey(o,a,t){const{providerExtUri:r}=this.getExtUri(o);return[r.getComparisonKey(a),String(t.recursive),t.excludes.join()].join()}dispose(){super.dispose();for(const[,o]of this.activeWatchers)(0,m.dispose)(o.disposable);this.activeWatchers.clear()}async doWriteBuffered(o,a,t,r){return this.writeQueue.queueFor(a,this.getExtUri(o).providerExtUri).queue(async()=>{const n=await o.open(a,{create:!0,unlock:t?.unlock??!1});try{(0,w.isReadableStream)(r)||(0,w.isReadableBufferedStream)(r)?await this.doWriteStreamBufferedQueued(o,n,r):await this.doWriteReadableBufferedQueued(o,n,r)}catch(s){throw(0,S.ensureFileSystemProviderError)(s)}finally{await o.close(n)}})}async doWriteStreamBufferedQueued(o,a,t){let r=0,n;if((0,w.isReadableBufferedStream)(t)){if(t.buffer.length>0){const s=R.VSBuffer.concat(t.buffer);await this.doWriteBuffer(o,a,s,s.byteLength,r,0),r+=s.byteLength}if(t.ended)return;n=t.stream}else n=t;return new Promise(async(s,c)=>{(0,w.listenStream)(n,{onData:async l=>{n.pause();try{await this.doWriteBuffer(o,a,l,l.byteLength,r,0)}catch(h){return c(h)}r+=l.byteLength,setTimeout(()=>n.resume())},onError:l=>c(l),onEnd:()=>s()})})}async doWriteReadableBufferedQueued(o,a,t){let r=0,n;for(;(n=t.read())!==null;)await this.doWriteBuffer(o,a,n,n.byteLength,r,0),r+=n.byteLength}async doWriteBuffer(o,a,t,r,n,s){let c=0;for(;c<r;)c+=await o.write(a,n+c,t.buffer,s+c,r-c)}async doWriteUnbuffered(o,a,t,r){return this.writeQueue.queueFor(a,this.getExtUri(o).providerExtUri).queue(()=>this.doWriteUnbufferedQueued(o,a,t,r))}async doWriteUnbufferedQueued(o,a,t,r){let n;r instanceof R.VSBuffer?n=r:(0,w.isReadableStream)(r)?n=await(0,R.streamToBuffer)(r):(0,w.isReadableBufferedStream)(r)?n=await(0,R.bufferedStreamToBuffer)(r):n=(0,R.readableToBuffer)(r),await o.writeFile(a,n.buffer,{create:!0,overwrite:!0,unlock:t?.unlock??!1})}async doPipeBuffered(o,a,t,r){return this.writeQueue.queueFor(r,this.getExtUri(t).providerExtUri).queue(()=>this.doPipeBufferedQueued(o,a,t,r))}async doPipeBufferedQueued(o,a,t,r){let n,s;try{n=await o.open(a,{create:!1}),s=await t.open(r,{create:!0,unlock:!1});const c=R.VSBuffer.alloc(this.BUFFER_SIZE);let l=0,h=0,d=0;do d=await o.read(n,l,c.buffer,h,c.byteLength-h),await this.doWriteBuffer(t,s,c,d,l,h),l+=d,h+=d,h===c.byteLength&&(h=0);while(d>0)}catch(c){throw(0,S.ensureFileSystemProviderError)(c)}finally{await L.Promises.settled([typeof n=="number"?o.close(n):Promise.resolve(),typeof s=="number"?t.close(s):Promise.resolve()])}}async doPipeUnbuffered(o,a,t,r){return this.writeQueue.queueFor(r,this.getExtUri(t).providerExtUri).queue(()=>this.doPipeUnbufferedQueued(o,a,t,r))}async doPipeUnbufferedQueued(o,a,t,r){return t.writeFile(r,await o.readFile(a),{create:!0,overwrite:!0,unlock:!1})}async doPipeUnbufferedToBuffered(o,a,t,r){return this.writeQueue.queueFor(r,this.getExtUri(t).providerExtUri).queue(()=>this.doPipeUnbufferedToBufferedQueued(o,a,t,r))}async doPipeUnbufferedToBufferedQueued(o,a,t,r){const n=await t.open(r,{create:!0,unlock:!1});try{const s=await o.readFile(a);await this.doWriteBuffer(t,n,R.VSBuffer.wrap(s),s.byteLength,0,0)}catch(s){throw(0,S.ensureFileSystemProviderError)(s)}finally{await t.close(n)}}async doPipeBufferedToUnbuffered(o,a,t,r){const n=await(0,R.streamToBuffer)(this.readFileBuffered(o,a,T.CancellationToken.None));await this.doWriteUnbuffered(t,r,void 0,n)}throwIfFileSystemIsReadonly(o,a){if(o.capabilities&2048)throw new S.FileOperationError((0,u.localize)(22,null,this.resourceForError(a)),6);return o}throwIfFileIsReadonly(o,a){if((a.permissions??0)&S.FilePermission.Readonly)throw new S.FileOperationError((0,u.localize)(23,null,this.resourceForError(o)),6)}resourceForError(o){return o.scheme===i.Schemas.file?o.fsPath:o.toString(!0)}};y.FILE_EVENTS_THROTTLING={maxChangesChunkSize:500,maxChangesBufferSize:3e4,coolDownDelay:200,warningscounter:0},y=fe([J(0,I.ILogService)],y),e.FileService=y}),define(Z[173],te([0,1,17,6,25,3,40,2,8,4,16,50,19,126,14,81,159,143,144,78,146,13,42]),function(K,e,D,L,R,T,k,P,m,b,i,C,g,w,u,S,f,I,y,E,o,a,t){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.DiskFileSystemProvider=void 0;class r extends P.Disposable{constructor(s,c){super();this.logService=s,this.options=c,this.BUFFER_SIZE=this.options?.bufferSize||64*1024,this.onDidChangeCapabilities=T.Event.None,this.mapHandleToPos=new Map,this.writeHandles=new Map,this.canFlush=!0,this._onDidWatchErrorOccur=this._register(new T.Emitter),this.onDidErrorOccur=this._onDidWatchErrorOccur.event,this._onDidChangeFile=this._register(new T.Emitter),this.onDidChangeFile=this._onDidChangeFile.event,this.recursiveFoldersToWatch=[],this.recursiveWatchRequestDelayer=this._register(new L.ThrottledDelayer(0))}get capabilities(){return this._capabilities||(this._capabilities=2|4|16|8|8192,b.isLinux&&(this._capabilities|=1024)),this._capabilities}async stat(s){try{const{stat:c,symbolicLink:l}=await g.SymlinkSupport.stat(this.toFilePath(s));return{type:this.toType(c,l),ctime:c.birthtime.getTime(),mtime:c.mtime.getTime(),size:c.size}}catch(c){throw this.toFileSystemProviderError(c)}}async readdir(s){try{const c=await g.Promises.readdir(this.toFilePath(s),{withFileTypes:!0}),l=[];return await Promise.all(c.map(async h=>{try{let d;h.isSymbolicLink()?d=(await this.stat((0,i.joinPath)(s,h.name))).type:d=this.toType(h),l.push([h.name,d])}catch(d){this.logService.trace(d)}})),l}catch(c){throw this.toFileSystemProviderError(c)}}toType(s,c){let l;return c?.dangling?l=u.FileType.Unknown:s.isFile()?l=u.FileType.File:s.isDirectory()?l=u.FileType.Directory:l=u.FileType.Unknown,c&&(l|=u.FileType.SymbolicLink),l}async readFile(s){try{const c=this.toFilePath(s);return await g.Promises.readFile(c)}catch(c){throw this.toFileSystemProviderError(c)}}readFileStream(s,c,l){const h=(0,C.newWriteableStream)(d=>R.VSBuffer.concat(d.map(v=>R.VSBuffer.wrap(v))).buffer);return(0,S.readFileIntoStream)(this,s,h,d=>d.buffer,{...c,bufferSize:this.BUFFER_SIZE},l),h}async writeFile(s,c,l){let h;try{const d=this.toFilePath(s);if(!l.create||!l.overwrite){if(await g.Promises.exists(d)){if(!l.overwrite)throw(0,u.createFileSystemProviderError)((0,w.localize)(0,null),u.FileSystemProviderErrorCode.FileExists)}else if(!l.create)throw(0,u.createFileSystemProviderError)((0,w.localize)(1,null),u.FileSystemProviderErrorCode.FileNotFound)}h=await this.open(s,{create:!0,unlock:l.unlock}),await this.write(h,0,c,0,c.byteLength)}catch(d){throw await this.toFileSystemProviderWriteError(s,d)}finally{typeof h=="number"&&await this.close(h)}}async open(s,c){try{const l=this.toFilePath(s);if((0,u.isFileOpenForWriteOptions)(c)&&c.unlock)try{const{stat:v}=await g.SymlinkSupport.stat(l);v.mode&128||await g.Promises.chmod(l,v.mode|128)}catch(v){this.logService.trace(v)}let h;if((0,u.isFileOpenForWriteOptions)(c)){if(b.isWindows)try{await g.Promises.truncate(l,0),h="r+"}catch(v){v.code!=="ENOENT"&&this.logService.trace(v)}h||(h="w")}else h="r";const d=await g.Promises.open(l,h);return this.mapHandleToPos.set(d,0),(0,u.isFileOpenForWriteOptions)(c)&&this.writeHandles.set(d,s),d}catch(l){throw(0,u.isFileOpenForWriteOptions)(c)?await this.toFileSystemProviderWriteError(s,l):this.toFileSystemProviderError(l)}}async close(s){try{if(this.mapHandleToPos.delete(s),this.writeHandles.delete(s)&&this.canFlush)try{await g.Promises.fdatasync(s)}catch(c){this.canFlush=!1,this.logService.error(c)}return await g.Promises.close(s)}catch(c){throw this.toFileSystemProviderError(c)}}async read(s,c,l,h,d){const v=this.normalizePos(s,c);let A=null;try{const O=await g.Promises.read(s,l,h,d,v);return typeof O=="number"?A=O:A=O.bytesRead,A}catch(O){throw this.toFileSystemProviderError(O)}finally{this.updatePos(s,v,A)}}normalizePos(s,c){return c===this.mapHandleToPos.get(s)?null:c}updatePos(s,c,l){const h=this.mapHandleToPos.get(s);typeof h=="number"&&(typeof c=="number"||(typeof l=="number"?this.mapHandleToPos.set(s,h+l):this.mapHandleToPos.delete(s)))}async write(s,c,l,h,d){return(0,L.retry)(()=>this.doWrite(s,c,l,h,d),100,3)}async doWrite(s,c,l,h,d){const v=this.normalizePos(s,c);let A=null;try{const O=await g.Promises.write(s,l,h,d,v);return typeof O=="number"?A=O:A=O.bytesWritten,A}catch(O){throw await this.toFileSystemProviderWriteError(this.writeHandles.get(s),O)}finally{this.updatePos(s,v,A)}}async mkdir(s){try{await g.Promises.mkdir(this.toFilePath(s))}catch(c){throw this.toFileSystemProviderError(c)}}async delete(s,c){try{const l=this.toFilePath(s);await this.doDelete(l,c)}catch(l){throw this.toFileSystemProviderError(l)}}async doDelete(s,c){c.recursive?await g.Promises.rm(s,g.RimRafMode.MOVE):await g.Promises.unlink(s)}async rename(s,c,l){const h=this.toFilePath(s),d=this.toFilePath(c);if(h!==d)try{await this.validateTargetDeleted(s,c,"move",l.overwrite),await g.Promises.move(h,d)}catch(v){throw(v.code==="EINVAL"||v.code==="EBUSY"||v.code==="ENAMETOOLONG")&&(v=new Error((0,w.localize)(2,null,(0,m.basename)(h),(0,m.basename)((0,m.dirname)(d)),v.toString()))),this.toFileSystemProviderError(v)}}async copy(s,c,l){const h=this.toFilePath(s),d=this.toFilePath(c);if(h!==d)try{await this.validateTargetDeleted(s,c,"copy",l.overwrite),await g.Promises.copy(h,d,{preserveSymlinks:!0})}catch(v){throw(v.code==="EINVAL"||v.code==="EBUSY"||v.code==="ENAMETOOLONG")&&(v=new Error((0,w.localize)(3,null,(0,m.basename)(h),(0,m.basename)((0,m.dirname)(d)),v.toString()))),this.toFileSystemProviderError(v)}}async validateTargetDeleted(s,c,l,h){const d=this.toFilePath(s),v=this.toFilePath(c);let A=!1;if(!!(this.capabilities&1024)||(A=(0,k.isEqual)(d,v,!0)),A&&l==="copy")throw(0,u.createFileSystemProviderError)((0,w.localize)(4,null),u.FileSystemProviderErrorCode.FileExists);if(!A&&await g.Promises.exists(v)){if(!h)throw(0,u.createFileSystemProviderError)((0,w.localize)(5,null),u.FileSystemProviderErrorCode.FileExists);await this.delete(c,{recursive:!0,useTrash:!1})}}watch(s,c){return c.recursive?this.watchRecursive(s,c):this.watchNonRecursive(s)}watchRecursive(s,c){const l={path:this.toFilePath(s),excludes:c.excludes},h=(0,D.insert)(this.recursiveFoldersToWatch,l);return this.refreshRecursiveWatchers(),(0,P.toDisposable)(()=>{h(),this.refreshRecursiveWatchers()})}refreshRecursiveWatchers(){this.recursiveWatchRequestDelayer.trigger(async()=>{this.doRefreshRecursiveWatchers()})}doRefreshRecursiveWatchers(){if(this.recursiveWatcher instanceof I.FileWatcher)this.recursiveWatcher.watch(this.recursiveFoldersToWatch);else if((0,P.dispose)(this.recursiveWatcher),this.recursiveWatcher=void 0,this.recursiveFoldersToWatch.length>0){let s,c;if(this.options?.watcher?.usePolling)s=y.FileWatcher,c=this.options?.watcher;else{let l;this.options?.enableLegacyRecursiveWatcher?l=!0:l=t.default.quality==="stable"&&b.isLinux,l&&this.recursiveFoldersToWatch.length===1?b.isWindows?s=o.FileWatcher:s=y.FileWatcher:s=I.FileWatcher}this.recursiveWatcher=new s(this.recursiveFoldersToWatch,l=>this._onDidChangeFile.fire((0,E.toFileChanges)(l)),l=>{l.type==="error"&&this._onDidWatchErrorOccur.fire(l.message),this.logService[l.type](l.message)},this.logService.getLevel()===a.LogLevel.Trace,c),this.recursiveWatcherLogLevelListener||(this.recursiveWatcherLogLevelListener=this.logService.onDidChangeLogLevel(()=>{this.recursiveWatcher?.setVerboseLogging(this.logService.getLevel()===a.LogLevel.Trace)}))}}watchNonRecursive(s){const c=new f.FileWatcher(this.toFilePath(s),h=>this._onDidChangeFile.fire((0,E.toFileChanges)(h)),h=>{h.type==="error"&&this._onDidWatchErrorOccur.fire(h.message),this.logService[h.type](h.message)},this.logService.getLevel()===a.LogLevel.Trace),l=this.logService.onDidChangeLogLevel(()=>{c.setVerboseLogging(this.logService.getLevel()===a.LogLevel.Trace)});return(0,P.combinedDisposable)(c,l)}toFilePath(s){return(0,m.normalize)(s.fsPath)}toFileSystemProviderError(s){if(s instanceof u.FileSystemProviderError)return s;let c;switch(s.code){case"ENOENT":c=u.FileSystemProviderErrorCode.FileNotFound;break;case"EISDIR":c=u.FileSystemProviderErrorCode.FileIsADirectory;break;case"ENOTDIR":c=u.FileSystemProviderErrorCode.FileNotADirectory;break;case"EEXIST":c=u.FileSystemProviderErrorCode.FileExists;break;case"EPERM":case"EACCES":c=u.FileSystemProviderErrorCode.NoPermissions;break;default:c=u.FileSystemProviderErrorCode.Unknown}return(0,u.createFileSystemProviderError)(s,c)}async toFileSystemProviderWriteError(s,c){let l=this.toFileSystemProviderError(c);if(s&&l.code===u.FileSystemProviderErrorCode.NoPermissions)try{const{stat:h}=await g.SymlinkSupport.stat(this.toFilePath(s));h.mode&128||(l=(0,u.createFileSystemProviderError)(c,u.FileSystemProviderErrorCode.FileWriteLocked))}catch(h){this.logService.trace(h)}return l}dispose(){super.dispose(),(0,P.dispose)(this.recursiveWatcher),this.recursiveWatcher=void 0,(0,P.dispose)(this.recursiveWatcherLogLevelListener),this.recursiveWatcherLogLevelListener=void 0}}e.DiskFileSystemProvider=r}),define(Z[29],te([0,1,7]),function(K,e,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IProductService=void 0,e.IProductService=(0,D.createDecorator)("productService")}),define(Z[174],te([0,1,6,9,2,8,19,13,29]),function(K,e,D,L,R,T,k,P,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.CodeCacheCleaner=void 0;let b=class extends R.Disposable{constructor(C,g,w){super();this.productService=g,this.logService=w,this._DataMaxAge=this.productService.quality!=="stable"?1e3*60*60*24*7:1e3*60*60*24*30*3,C&&this._register(new D.RunOnceScheduler(()=>{this.cleanUpCodeCaches(C)},30*1e3)).schedule()}async cleanUpCodeCaches(C){this.logService.info("[code cache cleanup]: Starting to clean up old code cache folders.");try{const g=Date.now(),w=(0,T.dirname)(C),u=(0,T.basename)(C),S=await k.Promises.readdir(w);await Promise.all(S.map(async f=>{if(f===u)return;const I=(0,T.join)(w,f),y=await k.Promises.stat(I);if(y.isDirectory()&&g-y.mtime.getTime()>this._DataMaxAge)return this.logService.info(`[code cache cleanup]: Removing code cache folder ${f}.`),k.Promises.rm(I)}))}catch(g){(0,L.onUnexpectedError)(g)}}};b=fe([J(1,m.IProductService),J(2,P.ILogService)],b),e.CodeCacheCleaner=b}),define(Z[175],te([0,1,6,9,2,8,19,12,13,29]),function(K,e,D,L,R,T,k,P,m,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.LanguagePackCachedDataCleaner=void 0;let i=class extends R.Disposable{constructor(g,w,u){super();this.environmentService=g,this.logService=w,this.productService=u,this._DataMaxAge=this.productService.quality!=="stable"?1e3*60*60*24*7:1e3*60*60*24*30*3,this.environmentService.isBuilt&&this._register(new D.RunOnceScheduler(()=>{this.cleanUpLanguagePackCache()},40*1e3)).schedule()}async cleanUpLanguagePackCache(){this.logService.info("[language pack cache cleanup]: Starting to clean up unused language packs.");try{const g=Object.create(null),w=JSON.parse(await k.Promises.readFile((0,T.join)(this.environmentService.userDataPath,"languagepacks.json"),"utf8"));for(let y of Object.keys(w)){const E=w[y];g[`${E.hash}.${y}`]=!0}const u=(0,T.join)(this.environmentService.userDataPath,"clp");if(!await k.Promises.exists(u))return;const f=await k.Promises.readdir(u);for(const y of f){if(g[y]){this.logService.info(`[language pack cache cleanup]: Skipping folder ${y}. Language pack still in use.`);continue}this.logService.info(`[language pack cache cleanup]: Removing unused language pack: ${y}`),await k.Promises.rm((0,T.join)(u,y))}const I=Date.now();for(const y of Object.keys(g)){const E=(0,T.join)(u,y),o=await k.Promises.readdir(E);for(const a of o){if(a==="tcf.json")continue;const t=(0,T.join)(E,a),r=await k.Promises.stat(t);r.isDirectory()&&I-r.mtime.getTime()>this._DataMaxAge&&(this.logService.info(`[language pack cache cleanup]: Removing language pack cache folder: ${(0,T.join)(y,a)}`),await k.Promises.rm(t))}}}catch(g){(0,L.onUnexpectedError)(g)}}};i=fe([J(0,P.INativeEnvironmentService),J(1,m.ILogService),J(2,b.IProductService)],i),e.LanguagePackCachedDataCleaner=i}),define(Z[33],te([0,1,91,18]),function(K,e,D,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Registry=void 0;class R{constructor(){this.data=new Map}add(k,P){D.ok(L.isString(k)),D.ok(L.isObject(P)),D.ok(!this.data.has(k),"There is already an extension with this id"),this.data.set(k,P)}knows(k){return this.data.has(k)}as(k){return this.data.get(k)||null}}e.Registry=new R}),define(Z[82],te([0,1,3,33]),function(K,e,D,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Extensions=void 0,e.Extensions={JSONContribution:"base.contributions.json"};function R(P){return P.length>0&&P.charAt(P.length-1)==="#"?P.substring(0,P.length-1):P}class T{constructor(){this._onDidChangeSchema=new D.Emitter,this.onDidChangeSchema=this._onDidChangeSchema.event,this.schemasById={}}registerSchema(m,b){this.schemasById[R(m)]=b,this._onDidChangeSchema.fire(m)}notifySchemaChanged(m){this._onDidChangeSchema.fire(m)}getSchemaContributions(){return{schemas:this.schemasById}}}const k=new T;L.Registry.add(e.Extensions.JSONContribution,k)}),define(Z[39],te([0,1,17,3,18,113,82,33]),function(K,e,D,L,R,T,k,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getScopes=e.validateProperty=e.getDefaultValue=e.overrideIdentifierFromKey=e.OVERRIDE_PROPERTY_PATTERN=e.resourceLanguageSettingsSchemaId=e.resourceSettings=e.windowSettings=e.machineOverridableSettings=e.machineSettings=e.applicationSettings=e.allSettings=e.ConfigurationScope=e.Extensions=e.EditPresentationTypes=void 0;var m;(function(y){y.Multiline="multilineText",y.Singleline="singlelineText"})(m=e.EditPresentationTypes||(e.EditPresentationTypes={})),e.Extensions={Configuration:"base.contributions.configuration"};var b;(function(y){y[y.APPLICATION=1]="APPLICATION",y[y.MACHINE=2]="MACHINE",y[y.WINDOW=3]="WINDOW",y[y.RESOURCE=4]="RESOURCE",y[y.LANGUAGE_OVERRIDABLE=5]="LANGUAGE_OVERRIDABLE",y[y.MACHINE_OVERRIDABLE=6]="MACHINE_OVERRIDABLE"})(b=e.ConfigurationScope||(e.ConfigurationScope={})),e.allSettings={properties:{},patternProperties:{}},e.applicationSettings={properties:{},patternProperties:{}},e.machineSettings={properties:{},patternProperties:{}},e.machineOverridableSettings={properties:{},patternProperties:{}},e.windowSettings={properties:{},patternProperties:{}},e.resourceSettings={properties:{},patternProperties:{}},e.resourceLanguageSettingsSchemaId="vscode://schemas/settings/resourceLanguage";const i=P.Registry.as(k.Extensions.JSONContribution);class C{constructor(){this.overrideIdentifiers=new Set,this._onDidSchemaChange=new L.Emitter,this.onDidSchemaChange=this._onDidSchemaChange.event,this._onDidUpdateConfiguration=new L.Emitter,this.onDidUpdateConfiguration=this._onDidUpdateConfiguration.event,this.defaultValues={},this.defaultLanguageConfigurationOverridesNode={id:"defaultOverrides",title:T.localize(0,null),properties:{}},this.configurationContributors=[this.defaultLanguageConfigurationOverridesNode],this.resourceLanguageSettingsSchema={properties:{},patternProperties:{},additionalProperties:!1,errorMessage:"Unknown editor configuration setting",allowTrailingCommas:!0,allowComments:!0},this.configurationProperties={},this.excludedConfigurationProperties={},i.registerSchema(e.resourceLanguageSettingsSchemaId,this.resourceLanguageSettingsSchema)}registerConfiguration(E,o=!0){this.registerConfigurations([E],o)}registerConfigurations(E,o=!0){const a=this.doRegisterConfigurations(E,o);i.registerSchema(e.resourceLanguageSettingsSchemaId,this.resourceLanguageSettingsSchema),this._onDidSchemaChange.fire(),this._onDidUpdateConfiguration.fire(a)}deregisterConfigurations(E){const o=this.doDeregisterConfigurations(E);i.registerSchema(e.resourceLanguageSettingsSchemaId,this.resourceLanguageSettingsSchema),this._onDidSchemaChange.fire(),this._onDidUpdateConfiguration.fire(o)}updateConfigurations({add:E,remove:o}){const a=[];a.push(...this.doDeregisterConfigurations(o)),a.push(...this.doRegisterConfigurations(E,!1)),i.registerSchema(e.resourceLanguageSettingsSchemaId,this.resourceLanguageSettingsSchema),this._onDidSchemaChange.fire(),this._onDidUpdateConfiguration.fire((0,D.distinct)(a))}registerDefaultConfigurations(E){const o=[],a=[];for(const t of E)for(const r in t)if(o.push(r),e.OVERRIDE_PROPERTY_PATTERN.test(r)){this.defaultValues[r]={...this.defaultValues[r]||{},...t[r]};const n={type:"object",default:this.defaultValues[r],description:T.localize(1,null,r),$ref:e.resourceLanguageSettingsSchemaId};a.push(w(r)),this.configurationProperties[r]=n,this.defaultLanguageConfigurationOverridesNode.properties[r]=n}else{this.defaultValues[r]=t[r];const n=this.configurationProperties[r];n&&(this.updatePropertyDefaultValue(r,n),this.updateSchema(r,n))}this.registerOverrideIdentifiers(a),this._onDidSchemaChange.fire(),this._onDidUpdateConfiguration.fire(o)}deregisterDefaultConfigurations(E){const o=[];for(const a of E)for(const t in a)if(o.push(t),delete this.defaultValues[t],e.OVERRIDE_PROPERTY_PATTERN.test(t))delete this.configurationProperties[t],delete this.defaultLanguageConfigurationOverridesNode.properties[t];else{const r=this.configurationProperties[t];r&&(this.updatePropertyDefaultValue(t,r),this.updateSchema(t,r))}this.updateOverridePropertyPatternKey(),this._onDidSchemaChange.fire(),this._onDidUpdateConfiguration.fire(o)}notifyConfigurationSchemaUpdated(...E){this._onDidSchemaChange.fire()}registerOverrideIdentifiers(E){for(const o of E)this.overrideIdentifiers.add(o);this.updateOverridePropertyPatternKey()}doRegisterConfigurations(E,o){const a=[];return E.forEach(t=>{a.push(...this.validateAndRegisterProperties(t,o,t.extensionInfo)),this.configurationContributors.push(t),this.registerJSONConfiguration(t)}),a}doDeregisterConfigurations(E){const o=[],a=t=>{if(t.properties)for(const r in t.properties)o.push(r),delete this.configurationProperties[r],this.removeFromSchema(r,t.properties[r]);t.allOf&&t.allOf.forEach(r=>a(r))};for(const t of E){a(t);const r=this.configurationContributors.indexOf(t);r!==-1&&this.configurationContributors.splice(r,1)}return o}validateAndRegisterProperties(E,o=!0,a,t=3){t=R.isUndefinedOrNull(E.scope)?t:E.scope;let r=[],n=E.properties;if(n)for(let c in n){if(o&&f(c)){delete n[c];continue}const l=n[c];if(this.updatePropertyDefaultValue(c,l),e.OVERRIDE_PROPERTY_PATTERN.test(c)?l.scope=void 0:(l.scope=R.isUndefinedOrNull(l.scope)?t:l.scope,l.restricted=R.isUndefinedOrNull(l.restricted)?!!a?.restrictedConfigurations?.includes(c):l.restricted),n[c].hasOwnProperty("included")&&!n[c].included){this.excludedConfigurationProperties[c]=n[c],delete n[c];continue}else this.configurationProperties[c]=n[c];!n[c].deprecationMessage&&n[c].markdownDeprecationMessage&&(n[c].deprecationMessage=n[c].markdownDeprecationMessage),r.push(c)}let s=E.allOf;if(s)for(let c of s)r.push(...this.validateAndRegisterProperties(c,o,a,t));return r}getConfigurations(){return this.configurationContributors}getConfigurationProperties(){return this.configurationProperties}getExcludedConfigurationProperties(){return this.excludedConfigurationProperties}registerJSONConfiguration(E){const o=a=>{let t=a.properties;if(t)for(const n in t)this.updateSchema(n,t[n]);let r=a.allOf;r&&r.forEach(o)};o(E)}updateSchema(E,o){switch(e.allSettings.properties[E]=o,o.scope){case 1:e.applicationSettings.properties[E]=o;break;case 2:e.machineSettings.properties[E]=o;break;case 6:e.machineOverridableSettings.properties[E]=o;break;case 3:e.windowSettings.properties[E]=o;break;case 4:e.resourceSettings.properties[E]=o;break;case 5:e.resourceSettings.properties[E]=o,this.resourceLanguageSettingsSchema.properties[E]=o;break}}removeFromSchema(E,o){switch(delete e.allSettings.properties[E],o.scope){case 1:delete e.applicationSettings.properties[E];break;case 2:delete e.machineSettings.properties[E];break;case 6:delete e.machineOverridableSettings.properties[E];break;case 3:delete e.windowSettings.properties[E];break;case 4:case 5:delete e.resourceSettings.properties[E];break}}updateOverridePropertyPatternKey(){for(const E of this.overrideIdentifiers.values()){const o=`[${E}]`,a={type:"object",description:T.localize(2,null),errorMessage:T.localize(3,null),$ref:e.resourceLanguageSettingsSchemaId};this.updatePropertyDefaultValue(o,a),e.allSettings.properties[o]=a,e.applicationSettings.properties[o]=a,e.machineSettings.properties[o]=a,e.machineOverridableSettings.properties[o]=a,e.windowSettings.properties[o]=a,e.resourceSettings.properties[o]=a}this._onDidSchemaChange.fire()}updatePropertyDefaultValue(E,o){let a=this.defaultValues[E];R.isUndefined(a)&&(a=o.default),R.isUndefined(a)&&(a=u(o.type)),o.default=a}}const g="\\[.*\\]$";e.OVERRIDE_PROPERTY_PATTERN=new RegExp(g);function w(y){return y.substring(1,y.length-1)}e.overrideIdentifierFromKey=w;function u(y){switch(Array.isArray(y)?y[0]:y){case"boolean":return!1;case"integer":case"number":return 0;case"string":return"";case"array":return[];case"object":return{};default:return null}}e.getDefaultValue=u;const S=new C;P.Registry.add(e.Extensions.Configuration,S);function f(y){return y.trim()?e.OVERRIDE_PROPERTY_PATTERN.test(y)?T.localize(5,null,y):S.getConfigurationProperties()[y]!==void 0?T.localize(6,null,y):null:T.localize(4,null)}e.validateProperty=f;function I(){const y=[],E=S.getConfigurationProperties();for(const o of Object.keys(E))y.push([o,E[o].scope]);return y.push(["launch",4]),y.push(["task",4]),y}e.getScopes=I}),define(Z[21],te([0,1,26,18,5,39,7,33]),function(K,e,D,L,R,T,k,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getMigratedSettingValue=e.keyFromOverrideIdentifier=e.getDefaultValues=e.getConfigurationKeys=e.merge=e.getConfigurationValue=e.removeFromValueTree=e.addToValueTree=e.toValuesTree=e.toOverrides=e.compare=e.ConfigurationTargetToString=e.ConfigurationTarget=e.isConfigurationOverrides=e.IConfigurationService=void 0,e.IConfigurationService=(0,k.createDecorator)("configurationService");function m(r){return r&&typeof r=="object"&&(!r.overrideIdentifier||typeof r.overrideIdentifier=="string")&&(!r.resource||r.resource instanceof R.URI)}e.isConfigurationOverrides=m;var b;(function(r){r[r.USER=1]="USER",r[r.USER_LOCAL=2]="USER_LOCAL",r[r.USER_REMOTE=3]="USER_REMOTE",r[r.WORKSPACE=4]="WORKSPACE",r[r.WORKSPACE_FOLDER=5]="WORKSPACE_FOLDER",r[r.DEFAULT=6]="DEFAULT",r[r.MEMORY=7]="MEMORY"})(b=e.ConfigurationTarget||(e.ConfigurationTarget={}));function i(r){switch(r){case 1:return"USER";case 2:return"USER_LOCAL";case 3:return"USER_REMOTE";case 4:return"WORKSPACE";case 5:return"WORKSPACE_FOLDER";case 6:return"DEFAULT";case 7:return"MEMORY"}}e.ConfigurationTargetToString=i;function C(r,n){const s=n?r?n.keys.filter(O=>r.keys.indexOf(O)===-1):[...n.keys]:[],c=r?n?r.keys.filter(O=>n.keys.indexOf(O)===-1):[...r.keys]:[],l=[];if(n&&r){for(const O of r.keys)if(n.keys.indexOf(O)!==-1){const p=I(r.contents,O),U=I(n.contents,O);D.equals(p,U)||l.push(O)}}const h=[],d=O=>{const p={};for(const U of O)for(const F of U.identifiers)p[a(F)]=U;return p},v=n?d(n.overrides):{},A=r?d(r.overrides):{};if(Object.keys(v).length)for(const O of s){const p=v[O];p&&h.push([(0,T.overrideIdentifierFromKey)(O),p.keys])}if(Object.keys(A).length)for(const O of c){const p=A[O];p&&h.push([(0,T.overrideIdentifierFromKey)(O),p.keys])}if(Object.keys(v).length&&Object.keys(A).length)for(const O of l){const p=A[O],U=v[O];if(p&&U){const F=C({contents:p.contents,keys:p.keys,overrides:[]},{contents:U.contents,keys:U.keys,overrides:[]});h.push([(0,T.overrideIdentifierFromKey)(O),[...F.added,...F.removed,...F.updated]])}}return{added:s,removed:c,updated:l,overrides:h}}e.compare=C;function g(r,n){const s=[];for(const c of Object.keys(r))if(T.OVERRIDE_PROPERTY_PATTERN.test(c)){const l={};for(const h in r[c])l[h]=r[c][h];s.push({identifiers:[(0,T.overrideIdentifierFromKey)(c).trim()],keys:Object.keys(l),contents:w(l,n)})}return s}e.toOverrides=g;function w(r,n){const s=Object.create(null);for(let c in r)u(s,c,r[c],n);return s}e.toValuesTree=w;function u(r,n,s,c){const l=n.split("."),h=l.pop();let d=r;for(let v=0;v<l.length;v++){let A=l[v],O=d[A];switch(typeof O){case"undefined":O=d[A]=Object.create(null);break;case"object":break;default:c(`Ignoring ${n} as ${l.slice(0,v+1).join(".")} is ${JSON.stringify(O)}`);return}d=O}if(typeof d=="object"&&d!==null)try{d[h]=s}catch(v){c(`Ignoring ${n} as ${l.join(".")} is ${JSON.stringify(d)}`)}else c(`Ignoring ${n} as ${l.join(".")} is ${JSON.stringify(d)}`)}e.addToValueTree=u;function S(r,n){const s=n.split(".");f(r,s)}e.removeFromValueTree=S;function f(r,n){const s=n.shift();if(n.length===0){delete r[s];return}if(Object.keys(r).indexOf(s)!==-1){const c=r[s];typeof c=="object"&&!Array.isArray(c)&&(f(c,n),Object.keys(c).length===0&&delete r[s])}}function I(r,n,s){function c(d,v){let A=d;for(const O of v){if(typeof A!="object"||A===null)return;A=A[O]}return A}const l=n.split("."),h=c(r,l);return typeof h=="undefined"?s:h}e.getConfigurationValue=I;function y(r,n,s){Object.keys(n).forEach(c=>{c!=="__proto__"&&(c in r?L.isObject(r[c])&&L.isObject(n[c])?y(r[c],n[c],s):s&&(r[c]=n[c]):r[c]=n[c])})}e.merge=y;function E(){const r=P.Registry.as(T.Extensions.Configuration).getConfigurationProperties();return Object.keys(r)}e.getConfigurationKeys=E;function o(){const r=Object.create(null),n=P.Registry.as(T.Extensions.Configuration).getConfigurationProperties();for(let s in n){let c=n[s].default;u(r,s,c,l=>console.error(`Conflict in default settings: ${l}`))}return r}e.getDefaultValues=o;function a(r){return`[${r}]`}e.keyFromOverrideIdentifier=a;function t(r,n,s){const c=r.inspect(n),l=r.inspect(s);return typeof c.userValue!="undefined"||typeof c.workspaceValue!="undefined"||typeof c.workspaceFolderValue!="undefined"?c.value:typeof l.userValue!="undefined"||typeof l.workspaceValue!="undefined"||typeof l.workspaceFolderValue!="undefined"?l.value:c.defaultValue}e.getMigratedSettingValue=t}),define(Z[176],te([0,1,17,3,34,2,41,26,18,5,21,39,33]),function(K,e,D,L,R,T,k,P,m,b,i,C,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.AllKeysConfigurationChangeEvent=e.ConfigurationChangeEvent=e.mergeChanges=e.Configuration=e.UserSettings=e.ConfigurationModelParser=e.DefaultConfigurationModel=e.ConfigurationModel=void 0;class w{constructor(t={},r=[],n=[]){this._contents=t,this._keys=r,this._overrides=n,this.isFrozen=!1}get contents(){return this.checkAndFreeze(this._contents)}get overrides(){return this.checkAndFreeze(this._overrides)}get keys(){return this.checkAndFreeze(this._keys)}isEmpty(){return this._keys.length===0&&Object.keys(this._contents).length===0&&this._overrides.length===0}getValue(t){return t?(0,i.getConfigurationValue)(this.contents,t):this.contents}getOverrideValue(t,r){const n=this.getContentsForOverrideIdentifer(r);return n?t?(0,i.getConfigurationValue)(n,t):n:void 0}getKeysForOverrideIdentifier(t){for(const r of this.overrides)if(r.identifiers.indexOf(t)!==-1)return r.keys;return[]}override(t){const r=this.getContentsForOverrideIdentifer(t);if(!r||typeof r!="object"||!Object.keys(r).length)return this;let n={};for(const s of D.distinct([...Object.keys(this.contents),...Object.keys(r)])){let c=this.contents[s],l=r[s];l&&(typeof c=="object"&&typeof l=="object"?(c=P.deepClone(c),this.mergeContents(c,l)):c=l),n[s]=c}return new w(n,this.keys,this.overrides)}merge(...t){const r=P.deepClone(this.contents),n=P.deepClone(this.overrides),s=[...this.keys];for(const c of t){this.mergeContents(r,c.contents);for(const l of c.overrides){const[h]=n.filter(d=>D.equals(d.identifiers,l.identifiers));h?this.mergeContents(h.contents,l.contents):n.push(P.deepClone(l))}for(const l of c.keys)s.indexOf(l)===-1&&s.push(l)}return new w(r,s,n)}freeze(){return this.isFrozen=!0,this}mergeContents(t,r){for(const n of Object.keys(r)){if(n in t&&m.isObject(t[n])&&m.isObject(r[n])){this.mergeContents(t[n],r[n]);continue}t[n]=P.deepClone(r[n])}}checkAndFreeze(t){return this.isFrozen&&!Object.isFrozen(t)?P.deepFreeze(t):t}getContentsForOverrideIdentifer(t){for(const r of this.overrides)if(r.identifiers.indexOf(t)!==-1)return r.contents;return null}toJSON(){return{contents:this.contents,overrides:this.overrides,keys:this.keys}}setValue(t,r){this.addKey(t),(0,i.addToValueTree)(this.contents,t,r,n=>{throw new Error(n)})}removeValue(t){this.removeKey(t)&&(0,i.removeFromValueTree)(this.contents,t)}addKey(t){let r=this.keys.length;for(let n=0;n<r;n++)t.indexOf(this.keys[n])===0&&(r=n);this.keys.splice(r,1,t)}removeKey(t){let r=this.keys.indexOf(t);return r!==-1?(this.keys.splice(r,1),!0):!1}}e.ConfigurationModel=w;class u extends w{constructor(){const t=(0,i.getDefaultValues)(),r=(0,i.getConfigurationKeys)(),n=[];for(const s of Object.keys(t))C.OVERRIDE_PROPERTY_PATTERN.test(s)&&n.push({identifiers:[(0,C.overrideIdentifierFromKey)(s).trim()],keys:Object.keys(t[s]),contents:(0,i.toValuesTree)(t[s],c=>console.error(`Conflict in default settings file: ${c}`))});super(t,r,n)}}e.DefaultConfigurationModel=u;class S{constructor(t){this._name=t,this._raw=null,this._configurationModel=null,this._restrictedConfigurations=[],this._parseErrors=[]}get configurationModel(){return this._configurationModel||new w}get restrictedConfigurations(){return this._restrictedConfigurations}get errors(){return this._parseErrors}parse(t,r){if(!m.isUndefinedOrNull(t)){const n=this.doParseContent(t);this.parseRaw(n,r)}}reparse(t){this._raw&&this.parseRaw(this._raw,t)}parseRaw(t,r){this._raw=t;const{contents:n,keys:s,overrides:c,restricted:l}=this.doParseRaw(t,r);this._configurationModel=new w(n,s,c),this._restrictedConfigurations=l||[]}doParseContent(t){let r={},n=null,s=[],c=[],l=[];function h(v){Array.isArray(s)?s.push(v):n!==null&&(s[n]=v)}let d={onObjectBegin:()=>{let v={};h(v),c.push(s),s=v,n=null},onObjectProperty:v=>{n=v},onObjectEnd:()=>{s=c.pop()},onArrayBegin:()=>{let v=[];h(v),c.push(s),s=v,n=null},onArrayEnd:()=>{s=c.pop()},onLiteralValue:h,onError:(v,A,O)=>{l.push({error:v,offset:A,length:O})}};if(t)try{R.visit(t,d),r=s[0]||{}}catch(v){console.error(`Error while parsing settings file ${this._name}: ${v}`),this._parseErrors=[v]}return r}doParseRaw(t,r){const n=g.Registry.as(C.Extensions.Configuration).getConfigurationProperties(),s=this.filter(t,n,!0,r);t=s.raw;const c=(0,i.toValuesTree)(t,d=>console.error(`Conflict in settings file ${this._name}: ${d}`)),l=Object.keys(t),h=(0,i.toOverrides)(t,d=>console.error(`Conflict in settings file ${this._name}: ${d}`));return{contents:c,keys:l,overrides:h,restricted:s.restricted}}filter(t,r,n,s){if(!s?.scopes&&!s?.skipRestricted)return{raw:t,restricted:[]};const c={},l=[];for(let h in t)if(C.OVERRIDE_PROPERTY_PATTERN.test(h)&&n){const d=this.filter(t[h],r,!1,s);c[h]=d.raw,l.push(...d.restricted)}else{const d=r[h],v=d?typeof d.scope!="undefined"?d.scope:3:void 0;d?.restricted&&l.push(h),(v===void 0||s.scopes===void 0||s.scopes.includes(v))&&(s.skipRestricted&&d?.restricted||(c[h]=t[h]))}return{raw:c,restricted:l}}}e.ConfigurationModelParser=S;class f extends T.Disposable{constructor(t,r,n,s){super();this.userSettingsResource=t,this.scopes=r,this.fileService=s,this._onDidChange=this._register(new L.Emitter),this.onDidChange=this._onDidChange.event,this.parser=new S(this.userSettingsResource.toString()),this.parseOptions={scopes:this.scopes},this._register(this.fileService.watch(n.dirname(this.userSettingsResource))),this._register(this.fileService.watch(this.userSettingsResource)),this._register(L.Event.filter(this.fileService.onDidFilesChange,c=>c.contains(this.userSettingsResource))(()=>this._onDidChange.fire()))}async loadConfiguration(){try{const t=await this.fileService.readFile(this.userSettingsResource);return this.parser.parse(t.value.toString()||"{}",this.parseOptions),this.parser.configurationModel}catch(t){return new w}}reparse(){return this.parser.reparse(this.parseOptions),this.parser.configurationModel}getRestrictedSettings(){return this.parser.restrictedConfigurations}}e.UserSettings=f;class I{constructor(t,r,n=new w,s=new w,c=new k.ResourceMap,l=new w,h=new k.ResourceMap,d=!0){this._defaultConfiguration=t,this._localUserConfiguration=r,this._remoteUserConfiguration=n,this._workspaceConfiguration=s,this._folderConfigurations=c,this._memoryConfiguration=l,this._memoryConfigurationByResource=h,this._freeze=d,this._workspaceConsolidatedConfiguration=null,this._foldersConsolidatedConfigurations=new k.ResourceMap,this._userConfiguration=null}getValue(t,r,n){return this.getConsolidateConfigurationModel(r,n).getValue(t)}updateValue(t,r,n={}){let s;n.resource?(s=this._memoryConfigurationByResource.get(n.resource),s||(s=new w,this._memoryConfigurationByResource.set(n.resource,s))):s=this._memoryConfiguration,r===void 0?s.removeValue(t):s.setValue(t,r),n.resource||(this._workspaceConsolidatedConfiguration=null)}inspect(t,r,n){const s=this.getConsolidateConfigurationModel(r,n),c=this.getFolderConfigurationModelForResource(r.resource,n),l=r.resource?this._memoryConfigurationByResource.get(r.resource)||this._memoryConfiguration:this._memoryConfiguration,h=r.overrideIdentifier?this._defaultConfiguration.freeze().override(r.overrideIdentifier).getValue(t):this._defaultConfiguration.freeze().getValue(t),d=r.overrideIdentifier?this.userConfiguration.freeze().override(r.overrideIdentifier).getValue(t):this.userConfiguration.freeze().getValue(t),v=r.overrideIdentifier?this.localUserConfiguration.freeze().override(r.overrideIdentifier).getValue(t):this.localUserConfiguration.freeze().getValue(t),A=r.overrideIdentifier?this.remoteUserConfiguration.freeze().override(r.overrideIdentifier).getValue(t):this.remoteUserConfiguration.freeze().getValue(t),O=n?r.overrideIdentifier?this._workspaceConfiguration.freeze().override(r.overrideIdentifier).getValue(t):this._workspaceConfiguration.freeze().getValue(t):void 0,p=c?r.overrideIdentifier?c.freeze().override(r.overrideIdentifier).getValue(t):c.freeze().getValue(t):void 0,U=r.overrideIdentifier?l.override(r.overrideIdentifier).getValue(t):l.getValue(t),F=s.getValue(t),z=D.distinct(D.flatten(s.overrides.map(H=>H.identifiers))).filter(H=>s.getOverrideValue(t,H)!==void 0);return{defaultValue:h,userValue:d,userLocalValue:v,userRemoteValue:A,workspaceValue:O,workspaceFolderValue:p,memoryValue:U,value:F,default:h!==void 0?{value:this._defaultConfiguration.freeze().getValue(t),override:r.overrideIdentifier?this._defaultConfiguration.freeze().getOverrideValue(t,r.overrideIdentifier):void 0}:void 0,user:d!==void 0?{value:this.userConfiguration.freeze().getValue(t),override:r.overrideIdentifier?this.userConfiguration.freeze().getOverrideValue(t,r.overrideIdentifier):void 0}:void 0,userLocal:v!==void 0?{value:this.localUserConfiguration.freeze().getValue(t),override:r.overrideIdentifier?this.localUserConfiguration.freeze().getOverrideValue(t,r.overrideIdentifier):void 0}:void 0,userRemote:A!==void 0?{value:this.remoteUserConfiguration.freeze().getValue(t),override:r.overrideIdentifier?this.remoteUserConfiguration.freeze().getOverrideValue(t,r.overrideIdentifier):void 0}:void 0,workspace:O!==void 0?{value:this._workspaceConfiguration.freeze().getValue(t),override:r.overrideIdentifier?this._workspaceConfiguration.freeze().getOverrideValue(t,r.overrideIdentifier):void 0}:void 0,workspaceFolder:p!==void 0?{value:c?.freeze().getValue(t),override:r.overrideIdentifier?c?.freeze().getOverrideValue(t,r.overrideIdentifier):void 0}:void 0,memory:U!==void 0?{value:l.getValue(t),override:r.overrideIdentifier?l.getOverrideValue(t,r.overrideIdentifier):void 0}:void 0,overrideIdentifiers:z.length?z:void 0}}keys(t){const r=this.getFolderConfigurationModelForResource(void 0,t);return{default:this._defaultConfiguration.freeze().keys,user:this.userConfiguration.freeze().keys,workspace:this._workspaceConfiguration.freeze().keys,workspaceFolder:r?r.freeze().keys:[]}}updateDefaultConfiguration(t){this._defaultConfiguration=t,this._workspaceConsolidatedConfiguration=null,this._foldersConsolidatedConfigurations.clear()}updateLocalUserConfiguration(t){this._localUserConfiguration=t,this._userConfiguration=null,this._workspaceConsolidatedConfiguration=null,this._foldersConsolidatedConfigurations.clear()}updateRemoteUserConfiguration(t){this._remoteUserConfiguration=t,this._userConfiguration=null,this._workspaceConsolidatedConfiguration=null,this._foldersConsolidatedConfigurations.clear()}updateWorkspaceConfiguration(t){this._workspaceConfiguration=t,this._workspaceConsolidatedConfiguration=null,this._foldersConsolidatedConfigurations.clear()}updateFolderConfiguration(t,r){this._folderConfigurations.set(t,r),this._foldersConsolidatedConfigurations.delete(t)}deleteFolderConfiguration(t){this.folderConfigurations.delete(t),this._foldersConsolidatedConfigurations.delete(t)}compareAndUpdateDefaultConfiguration(t,r){const n=r.filter(s=>C.OVERRIDE_PROPERTY_PATTERN.test(s)).map(s=>{const c=(0,C.overrideIdentifierFromKey)(s),l=this._defaultConfiguration.getKeysForOverrideIdentifier(c),h=t.getKeysForOverrideIdentifier(c),d=[...h.filter(v=>l.indexOf(v)===-1),...l.filter(v=>h.indexOf(v)===-1),...l.filter(v=>!P.equals(this._defaultConfiguration.override(c).getValue(v),t.override(c).getValue(v)))];return[c,d]});return this.updateDefaultConfiguration(t),{keys:r,overrides:n}}compareAndUpdateLocalUserConfiguration(t){const{added:r,updated:n,removed:s,overrides:c}=(0,i.compare)(this.localUserConfiguration,t),l=[...r,...n,...s];return l.length&&this.updateLocalUserConfiguration(t),{keys:l,overrides:c}}compareAndUpdateRemoteUserConfiguration(t){const{added:r,updated:n,removed:s,overrides:c}=(0,i.compare)(this.remoteUserConfiguration,t);let l=[...r,...n,...s];return l.length&&this.updateRemoteUserConfiguration(t),{keys:l,overrides:c}}compareAndUpdateWorkspaceConfiguration(t){const{added:r,updated:n,removed:s,overrides:c}=(0,i.compare)(this.workspaceConfiguration,t);let l=[...r,...n,...s];return l.length&&this.updateWorkspaceConfiguration(t),{keys:l,overrides:c}}compareAndUpdateFolderConfiguration(t,r){const n=this.folderConfigurations.get(t),{added:s,updated:c,removed:l,overrides:h}=(0,i.compare)(n,r);let d=[...s,...c,...l];return(d.length||!n)&&this.updateFolderConfiguration(t,r),{keys:d,overrides:h}}compareAndDeleteFolderConfiguration(t){const r=this.folderConfigurations.get(t);if(!r)throw new Error("Unknown folder");this.deleteFolderConfiguration(t);const{added:n,updated:s,removed:c,overrides:l}=(0,i.compare)(r,void 0);return{keys:[...n,...s,...c],overrides:l}}get defaults(){return this._defaultConfiguration}get userConfiguration(){return this._userConfiguration||(this._userConfiguration=this._remoteUserConfiguration.isEmpty()?this._localUserConfiguration:this._localUserConfiguration.merge(this._remoteUserConfiguration),this._freeze&&this._userConfiguration.freeze()),this._userConfiguration}get localUserConfiguration(){return this._localUserConfiguration}get remoteUserConfiguration(){return this._remoteUserConfiguration}get workspaceConfiguration(){return this._workspaceConfiguration}get folderConfigurations(){return this._folderConfigurations}getConsolidateConfigurationModel(t,r){let n=this.getConsolidatedConfigurationModelForResource(t,r);return t.overrideIdentifier?n.override(t.overrideIdentifier):n}getConsolidatedConfigurationModelForResource({resource:t},r){let n=this.getWorkspaceConsolidatedConfiguration();if(r&&t){const s=r.getFolder(t);s&&(n=this.getFolderConsolidatedConfiguration(s.uri)||n);const c=this._memoryConfigurationByResource.get(t);c&&(n=n.merge(c))}return n}getWorkspaceConsolidatedConfiguration(){return this._workspaceConsolidatedConfiguration||(this._workspaceConsolidatedConfiguration=this._defaultConfiguration.merge(this.userConfiguration,this._workspaceConfiguration,this._memoryConfiguration),this._freeze&&(this._workspaceConfiguration=this._workspaceConfiguration.freeze())),this._workspaceConsolidatedConfiguration}getFolderConsolidatedConfiguration(t){let r=this._foldersConsolidatedConfigurations.get(t);if(!r){const n=this.getWorkspaceConsolidatedConfiguration(),s=this._folderConfigurations.get(t);s?(r=n.merge(s),this._freeze&&(r=r.freeze()),this._foldersConsolidatedConfigurations.set(t,r)):r=n}return r}getFolderConfigurationModelForResource(t,r){if(r&&t){const n=r.getFolder(t);if(n)return this._folderConfigurations.get(n.uri)}}toData(){return{defaults:{contents:this._defaultConfiguration.contents,overrides:this._defaultConfiguration.overrides,keys:this._defaultConfiguration.keys},user:{contents:this.userConfiguration.contents,overrides:this.userConfiguration.overrides,keys:this.userConfiguration.keys},workspace:{contents:this._workspaceConfiguration.contents,overrides:this._workspaceConfiguration.overrides,keys:this._workspaceConfiguration.keys},folders:[...this._folderConfigurations.keys()].reduce((t,r)=>{const{contents:n,overrides:s,keys:c}=this._folderConfigurations.get(r);return t.push([r,{contents:n,overrides:s,keys:c}]),t},[])}}allKeys(){const t=new Set;return this._defaultConfiguration.freeze().keys.forEach(r=>t.add(r)),this.userConfiguration.freeze().keys.forEach(r=>t.add(r)),this._workspaceConfiguration.freeze().keys.forEach(r=>t.add(r)),this._folderConfigurations.forEach(r=>r.freeze().keys.forEach(n=>t.add(n))),[...t.values()]}getAllKeysForOverrideIdentifier(t){const r=new Set;return this._defaultConfiguration.getKeysForOverrideIdentifier(t).forEach(n=>r.add(n)),this.userConfiguration.getKeysForOverrideIdentifier(t).forEach(n=>r.add(n)),this._workspaceConfiguration.getKeysForOverrideIdentifier(t).forEach(n=>r.add(n)),this._folderConfigurations.forEach(n=>n.getKeysForOverrideIdentifier(t).forEach(s=>r.add(s))),[...r.values()]}static parse(t){const r=this.parseConfigurationModel(t.defaults),n=this.parseConfigurationModel(t.user),s=this.parseConfigurationModel(t.workspace),c=t.folders.reduce((l,h)=>(l.set(b.URI.revive(h[0]),this.parseConfigurationModel(h[1])),l),new k.ResourceMap);return new I(r,n,new w,s,c,new w,new k.ResourceMap,!1)}static parseConfigurationModel(t){return new w(t.contents,t.keys,t.overrides).freeze()}}e.Configuration=I;function y(...a){if(a.length===0)return{keys:[],overrides:[]};if(a.length===1)return a[0];const t=new Set,r=new Map;for(const s of a)s.keys.forEach(c=>t.add(c)),s.overrides.forEach(([c,l])=>{const h=(0,k.getOrSet)(r,c,new Set);l.forEach(d=>h.add(d))});const n=[];return r.forEach((s,c)=>n.push([c,[...s.values()]])),{keys:[...t.values()],overrides:n}}e.mergeChanges=y;class E{constructor(t,r,n,s){this.change=t,this.previous=r,this.currentConfiguraiton=n,this.currentWorkspace=s,this._previousConfiguration=void 0;const c=new Set;t.keys.forEach(h=>c.add(h)),t.overrides.forEach(([,h])=>h.forEach(d=>c.add(d))),this.affectedKeys=[...c.values()];const l=new w;this.affectedKeys.forEach(h=>l.setValue(h,{})),this.affectedKeysTree=l.contents}get previousConfiguration(){return!this._previousConfiguration&&this.previous&&(this._previousConfiguration=I.parse(this.previous.data)),this._previousConfiguration}affectsConfiguration(t,r){if(this.doesAffectedKeysTreeContains(this.affectedKeysTree,t)){if(r){const n=this.previousConfiguration?this.previousConfiguration.getValue(t,r,this.previous?.workspace):void 0,s=this.currentConfiguraiton.getValue(t,r,this.currentWorkspace);return!P.equals(n,s)}return!0}return!1}doesAffectedKeysTreeContains(t,r){let n=(0,i.toValuesTree)({[r]:!0},()=>{}),s;for(;typeof n=="object"&&(s=Object.keys(n)[0]);){if(t=t[s],!t)return!1;n=n[s]}return!0}}e.ConfigurationChangeEvent=E;class o extends E{constructor(t,r,n,s){super({keys:t.allKeys(),overrides:[]},void 0,t,r);this.source=n,this.sourceConfig=s}}e.AllKeysConfigurationChangeEvent=o}),define(Z[177],te([0,1,6,3,2,16,21,176,39,33]),function(K,e,D,L,R,T,k,P,m,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ConfigurationService=void 0;class i extends R.Disposable{constructor(g,w){super();this.settingsResource=g,this._onDidChangeConfiguration=this._register(new L.Emitter),this.onDidChangeConfiguration=this._onDidChangeConfiguration.event,this.userConfiguration=this._register(new P.UserSettings(this.settingsResource,void 0,T.extUriBiasedIgnorePathCase,w)),this.configuration=new P.Configuration(new P.DefaultConfigurationModel,new P.ConfigurationModel),this.reloadConfigurationScheduler=this._register(new D.RunOnceScheduler(()=>this.reloadConfiguration(),50)),this._register(b.Registry.as(m.Extensions.Configuration).onDidUpdateConfiguration(u=>this.onDidDefaultConfigurationChange(u))),this._register(this.userConfiguration.onDidChange(()=>this.reloadConfigurationScheduler.schedule()))}async initialize(){const g=await this.userConfiguration.loadConfiguration();this.configuration=new P.Configuration(new P.DefaultConfigurationModel,g)}getConfigurationData(){return this.configuration.toData()}getValue(g,w){const u=typeof g=="string"?g:void 0,S=(0,k.isConfigurationOverrides)(g)?g:(0,k.isConfigurationOverrides)(w)?w:{};return this.configuration.getValue(u,S,void 0)}updateValue(g,w,u,S){return Promise.reject(new Error("not supported"))}inspect(g){return this.configuration.inspect(g,{},void 0)}keys(){return this.configuration.keys(void 0)}async reloadConfiguration(){const g=await this.userConfiguration.loadConfiguration();this.onDidChangeUserConfiguration(g)}onDidChangeUserConfiguration(g){const w=this.configuration.toData(),u=this.configuration.compareAndUpdateLocalUserConfiguration(g);this.trigger(u,w,1)}onDidDefaultConfigurationChange(g){const w=this.configuration.toData(),u=this.configuration.compareAndUpdateDefaultConfiguration(new P.DefaultConfigurationModel,g);this.trigger(u,w,6)}trigger(g,w,u){const S=new P.ConfigurationChangeEvent(g,{data:w},this.configuration);S.source=u,S.sourceConfig=this.getTargetConfiguration(u),this._onDidChangeConfiguration.fire(S)}getTargetConfiguration(g){switch(g){case 6:return this.configuration.defaults.contents;case 1:return this.configuration.localUserConfiguration.contents}return{}}}e.ConfigurationService=i}),define(Z[178],te([0,1,107,21,13]),function(K,e,D,L,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.RequestService=void 0;let T=class{constructor(P,m){this.configurationService=P,this.logService=m}request(P,m){return this.logService.trace("RequestService#request",P.url),P.proxyAuthorization||(P.proxyAuthorization=this.configurationService.getValue("http.proxyAuthorization")),(0,D.request)(P,m)}async resolveProxy(P){}};T=fe([J(0,L.IConfigurationService),J(1,R.ILogService)],T),e.RequestService=T}),define(Z[43],te([0,1,25,127,39,7,33]),function(K,e,D,L,R,T,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.updateProxyConfigurationsScope=e.asJson=e.asText=e.isSuccess=e.IRequestService=void 0,e.IRequestService=(0,T.createDecorator)("requestService");function P(u){return u.res.statusCode&&u.res.statusCode>=200&&u.res.statusCode<300||u.res.statusCode===1223}e.isSuccess=P;function m(u){return u.res.statusCode===204}async function b(u){if(!P(u))throw new Error("Server returned "+u.res.statusCode);return m(u)?null:(await(0,D.streamToBuffer)(u.stream)).toString()}e.asText=b;async function i(u){if(!P(u))throw new Error("Server returned "+u.res.statusCode);if(m(u))return null;const f=(await(0,D.streamToBuffer)(u.stream)).toString();try{return JSON.parse(f)}catch(I){throw I.message+=`:
`+f,I}}e.asJson=i;function C(u){w(u)}e.updateProxyConfigurationsScope=C;let g;function w(u){const S=k.Registry.as(R.Extensions.Configuration),f=g;g={id:"http",order:15,title:(0,L.localize)(0,null),type:"object",scope:u,properties:{"http.proxy":{type:"string",pattern:"^https?://([^:]*(:[^@]*)?@)?([^:]+|\\[[:0-9a-fA-F]+\\])(:\\d+)?/?$|^$",markdownDescription:(0,L.localize)(1,null),restricted:!0},"http.proxyStrictSSL":{type:"boolean",default:!0,description:(0,L.localize)(2,null),restricted:!0},"http.proxyAuthorization":{type:["null","string"],default:null,markdownDescription:(0,L.localize)(3,null),restricted:!0},"http.proxySupport":{type:"string",enum:["off","on","fallback","override"],enumDescriptions:[(0,L.localize)(4,null),(0,L.localize)(5,null),(0,L.localize)(6,null),(0,L.localize)(7,null)],default:"override",description:(0,L.localize)(8,null),restricted:!0},"http.systemCertificates":{type:"boolean",default:!0,description:(0,L.localize)(9,null),restricted:!0}}},S.updateConfigurations({add:[g],remove:f?[f]:[]})}w(2)}),define(Z[179],te([0,1,27,15,14,43]),function(K,e,D,L,R,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.DownloadService=void 0;let k=class{constructor(m,b){this.requestService=m,this.fileService=b}async download(m,b,i=D.CancellationToken.None){if(m.scheme===L.Schemas.file||m.scheme===L.Schemas.vscodeRemote){await this.fileService.copy(m,b);return}const C={type:"GET",url:m.toString()},g=await this.requestService.request(C,i);if(g.res.statusCode===200)await this.fileService.writeFile(b,g.stream);else{const w=await(0,T.asText)(g);throw new Error(`Expected 200, got back ${g.res.statusCode} instead.

${w}`)}}};k=fe([J(0,T.IRequestService),J(1,R.IFileService)],k),e.DownloadService=k}),define(Z[180],te([0,1,17,27,63,2,16,140,14,13,29,43]),function(K,e,D,L,R,T,k,P,m,b,i,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionTipsService=void 0;let g=class extends T.Disposable{constructor(u,S,f,I){super();this.fileService=u,this.productService=S,this.requestService=f,this.logService=I,this.allConfigBasedTips=new Map,this.productService.configBasedExtensionTips&&(0,R.forEach)(this.productService.configBasedExtensionTips,({value:y})=>this.allConfigBasedTips.set(y.configPath,y))}getConfigBasedTips(u){return this.getValidConfigBasedTips(u)}getAllWorkspacesTips(){return this.fetchWorkspacesTips()}async getImportantExecutableBasedTips(){return[]}async getOtherExecutableBasedTips(){return[]}async getValidConfigBasedTips(u){const S=[];for(const[f,I]of this.allConfigBasedTips)if(!(I.configScheme&&I.configScheme!==u.scheme))try{const y=await this.fileService.readFile((0,k.joinPath)(u,f)),E=new Map;(0,R.forEach)(I.recommendations,({key:a,value:t})=>{if((0,D.isNonEmptyArray)(t.remotes))for(const r of t.remotes)E.set(r,{extensionId:a,extensionName:t.name,configName:I.configName,important:!!t.important,isExtensionPack:!!t.isExtensionPack});else S.push({extensionId:a,extensionName:t.name,configName:I.configName,important:!!t.important,isExtensionPack:!!t.isExtensionPack})});const o=(0,P.getDomainsOfRemotes)(y.value.toString(),[...E.keys()]);for(const a of o){const t=E.get(a);t&&S.push(t)}}catch(y){}return S}async fetchWorkspacesTips(){if(!this.productService.extensionsGallery?.recommendationsUrl)return[];try{const u=await this.requestService.request({type:"GET",url:this.productService.extensionsGallery?.recommendationsUrl},L.CancellationToken.None);if(u.res.statusCode!==200)return[];const S=await(0,C.asJson)(u);return S?S.workspaceRecommendations||[]:[]}catch(u){return this.logService.error(u),[]}}};g=fe([J(0,m.IFileService),J(1,i.IProductService),J(2,C.IRequestService),J(3,b.ILogService)],g),e.ExtensionTipsService=g}),define(Z[45],te([0,1,25,30]),function(K,e,D,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getServiceMachineId=void 0;async function R(T,k,P){let m=P&&P.get("storage.serviceMachineId",0)||null;if(m)return m;try{const i=(await k.readFile(T.serviceMachineIdResource)).value.toString();m=(0,L.isUUID)(i)?i:null}catch(b){m=null}if(!m){m=(0,L.generateUuid)();try{await k.writeFile(T.serviceMachineIdResource,D.VSBuffer.fromString(m))}catch(b){}}return P&&P.store("storage.serviceMachineId",m,0,1),m}e.getServiceMachineId=R}),define(Z[22],te([0,1,6,3,2,18,70,7]),function(K,e,D,L,R,T,k,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.logStorage=e.InMemoryStorageService=e.AbstractStorageService=e.StorageTarget=e.StorageScope=e.WillSaveStateReason=e.IStorageService=e.IS_NEW_KEY=void 0,e.IS_NEW_KEY="__$__isNewStorageMarker";const m="__$__targetStorageMarker";e.IStorageService=(0,P.createDecorator)("storageService");var b;(function(S){S[S.NONE=0]="NONE",S[S.SHUTDOWN=1]="SHUTDOWN"})(b=e.WillSaveStateReason||(e.WillSaveStateReason={}));var i;(function(S){S[S.GLOBAL=0]="GLOBAL",S[S.WORKSPACE=1]="WORKSPACE"})(i=e.StorageScope||(e.StorageScope={}));var C;(function(S){S[S.USER=0]="USER",S[S.MACHINE=1]="MACHINE"})(C=e.StorageTarget||(e.StorageTarget={}));class g extends R.Disposable{constructor(f={flushInterval:g.DEFAULT_FLUSH_INTERVAL}){super();this.options=f,this._onDidChangeValue=this._register(new L.PauseableEmitter),this.onDidChangeValue=this._onDidChangeValue.event,this._onDidChangeTarget=this._register(new L.PauseableEmitter),this.onDidChangeTarget=this._onDidChangeTarget.event,this._onWillSaveState=this._register(new L.Emitter),this.onWillSaveState=this._onWillSaveState.event,this.flushWhenIdleScheduler=this._register(new D.RunOnceScheduler(()=>this.doFlushWhenIdle(),this.options.flushInterval)),this.runFlushWhenIdle=this._register(new R.MutableDisposable),this._workspaceKeyTargets=void 0,this._globalKeyTargets=void 0}doFlushWhenIdle(){this.runFlushWhenIdle.value=(0,D.runWhenIdle)(()=>{this.shouldFlushWhenIdle()&&this.flush(),this.flushWhenIdleScheduler.schedule()})}shouldFlushWhenIdle(){return!0}stopFlushWhenIdle(){(0,R.dispose)([this.runFlushWhenIdle,this.flushWhenIdleScheduler])}initialize(){return this.initializationPromise||(this.initializationPromise=(async()=>{await this.doInitialize(),this.flushWhenIdleScheduler.schedule()})()),this.initializationPromise}emitDidChangeValue(f,I){I===m?(f===0?this._globalKeyTargets=void 0:f===1&&(this._workspaceKeyTargets=void 0),this._onDidChangeTarget.fire({scope:f})):this._onDidChangeValue.fire({scope:f,key:I,target:this.getKeyTargets(f)[I]})}emitWillSaveState(f){this._onWillSaveState.fire({reason:f})}get(f,I,y){return this.getStorage(I)?.get(f,y)}getBoolean(f,I,y){return this.getStorage(I)?.getBoolean(f,y)}getNumber(f,I,y){return this.getStorage(I)?.getNumber(f,y)}store(f,I,y,E){if((0,T.isUndefinedOrNull)(I)){this.remove(f,y);return}this.withPausedEmitters(()=>{this.updateKeyTarget(f,y,E),this.getStorage(y)?.set(f,I)})}remove(f,I){this.withPausedEmitters(()=>{this.updateKeyTarget(f,I,void 0),this.getStorage(I)?.delete(f)})}withPausedEmitters(f){this._onDidChangeValue.pause(),this._onDidChangeTarget.pause();try{f()}finally{this._onDidChangeValue.resume(),this._onDidChangeTarget.resume()}}keys(f,I){const y=[],E=this.getKeyTargets(f);for(const o of Object.keys(E))E[o]===I&&y.push(o);return y}updateKeyTarget(f,I,y){const E=this.getKeyTargets(I);typeof y=="number"?E[f]!==y&&(E[f]=y,this.getStorage(I)?.set(m,JSON.stringify(E))):typeof E[f]=="number"&&(delete E[f],this.getStorage(I)?.set(m,JSON.stringify(E)))}get workspaceKeyTargets(){return this._workspaceKeyTargets||(this._workspaceKeyTargets=this.loadKeyTargets(1)),this._workspaceKeyTargets}get globalKeyTargets(){return this._globalKeyTargets||(this._globalKeyTargets=this.loadKeyTargets(0)),this._globalKeyTargets}getKeyTargets(f){return f===0?this.globalKeyTargets:this.workspaceKeyTargets}loadKeyTargets(f){const I=this.get(m,f);if(I)try{return JSON.parse(I)}catch(y){}return Object.create(null)}isNew(f){return this.getBoolean(e.IS_NEW_KEY,f)===!0}async flush(f=b.NONE){this._onWillSaveState.fire({reason:f}),await D.Promises.settled([this.getStorage(0)?.whenFlushed()??Promise.resolve(),this.getStorage(1)?.whenFlushed()??Promise.resolve()])}async logStorage(){const f=this.getStorage(0)?.items??new Map,I=this.getStorage(1)?.items??new Map;return u(f,I,this.getLogDetails(0)??"",this.getLogDetails(1)??"")}}e.AbstractStorageService=g,g.DEFAULT_FLUSH_INTERVAL=60*1e3;class w extends g{constructor(){super();this.globalStorage=this._register(new k.Storage(new k.InMemoryStorageDatabase)),this.workspaceStorage=this._register(new k.Storage(new k.InMemoryStorageDatabase)),this._register(this.workspaceStorage.onDidChangeStorage(f=>this.emitDidChangeValue(1,f))),this._register(this.globalStorage.onDidChangeStorage(f=>this.emitDidChangeValue(0,f)))}getStorage(f){return f===0?this.globalStorage:this.workspaceStorage}getLogDetails(f){return f===0?"inMemory (global)":"inMemory (workspace)"}async doInitialize(){}async migrate(f){}}e.InMemoryStorageService=w;async function u(S,f,I,y){const E=c=>{try{return JSON.parse(c)}catch(l){return c}},o=new Map,a=new Map;S.forEach((c,l)=>{o.set(l,c),a.set(l,E(c))});const t=new Map,r=new Map;f.forEach((c,l)=>{t.set(l,c),r.set(l,E(c))}),console.group(`Storage: Global (path: ${I})`);let n=[];o.forEach((c,l)=>{n.push({key:l,value:c})}),console.table(n),console.groupEnd(),console.log(a),console.group(`Storage: Workspace (path: ${y})`);let s=[];t.forEach((c,l)=>{s.push({key:l,value:c})}),console.table(s),console.groupEnd(),console.log(r)}e.logStorage=u}),define(Z[181],te([0,1,3,2,18,28,32,22]),function(K,e,D,L,R,T,k,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.StorageManager=e.GlobalExtensionEnablementService=void 0;let m=class extends L.Disposable{constructor(C){super();this._onDidChangeEnablement=new D.Emitter,this.onDidChangeEnablement=this._onDidChangeEnablement.event,this.storageManger=this._register(new b(C)),this._register(this.storageManger.onDidChange(g=>this._onDidChangeEnablement.fire({extensions:g,source:"storage"})))}async enableExtension(C,g){return this._removeFromDisabledExtensions(C)?(this._onDidChangeEnablement.fire({extensions:[C],source:g}),!0):!1}async disableExtension(C,g){return this._addToDisabledExtensions(C)?(this._onDidChangeEnablement.fire({extensions:[C],source:g}),!0):!1}getDisabledExtensions(){return this._getExtensions(T.DISABLED_EXTENSIONS_STORAGE_PATH)}async getDisabledExtensionsAsync(){return this.getDisabledExtensions()}_addToDisabledExtensions(C){let g=this.getDisabledExtensions();return g.every(w=>!(0,k.areSameExtensions)(w,C))?(g.push(C),this._setDisabledExtensions(g),!0):!1}_removeFromDisabledExtensions(C){let g=this.getDisabledExtensions();for(let w=0;w<g.length;w++){const u=g[w];if((0,k.areSameExtensions)(u,C))return g.splice(w,1),this._setDisabledExtensions(g),!0}return!1}_setDisabledExtensions(C){this._setExtensions(T.DISABLED_EXTENSIONS_STORAGE_PATH,C)}_getExtensions(C){return this.storageManger.get(C,0)}_setExtensions(C,g){this.storageManger.set(C,g,0)}};m=fe([J(0,P.IStorageService)],m),e.GlobalExtensionEnablementService=m;class b extends L.Disposable{constructor(C){super();this.storageService=C,this.storage=Object.create(null),this._onDidChange=this._register(new D.Emitter),this.onDidChange=this._onDidChange.event,this._register(C.onDidChangeValue(g=>this.onDidStorageChange(g)))}get(C,g){let w;return g===0?((0,R.isUndefinedOrNull)(this.storage[C])&&(this.storage[C]=this._get(C,g)),w=this.storage[C]):w=this._get(C,g),JSON.parse(w)}set(C,g,w){let u=JSON.stringify(g.map(({id:f,uuid:I})=>({id:f,uuid:I})));this._get(C,w)!==u&&(w===0&&(g.length?this.storage[C]=u:delete this.storage[C]),this._set(C,g.length?u:void 0,w))}onDidStorageChange(C){if(C.scope===0&&!(0,R.isUndefinedOrNull)(this.storage[C.key])&&this._get(C.key,C.scope)!==this.storage[C.key]){const w=this.get(C.key,C.scope);delete this.storage[C.key];const u=this.get(C.key,C.scope),S=w.filter(I=>!u.some(y=>(0,k.areSameExtensions)(I,y))),f=u.filter(I=>!w.some(y=>(0,k.areSameExtensions)(y,I)));(S.length||f.length)&&this._onDidChange.fire([...S,...f])}}_get(C,g){return this.storageService.get(C,g,"[]")}_set(C,g,w){g?this.storageService.store(C,g,w,1):this.storageService.remove(C,w)}}e.StorageManager=b}),define(Z[182],te([0,1,3,2]),function(K,e,D,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.StorageDatabaseChannelClient=void 0;class R extends L.Disposable{constructor(b,i){super();this.channel=b,this.workspace=i}async getItems(){const b={workspace:this.workspace},i=await this.channel.call("getItems",b);return new Map(i)}updateItems(b){const i={workspace:this.workspace};return b.insert&&(i.insert=Array.from(b.insert.entries())),b.delete&&(i.delete=Array.from(b.delete.values())),this.channel.call("updateItems",i)}}class T extends R{constructor(b){super(b,void 0);this._onDidChangeItemsExternal=this._register(new D.Emitter),this.onDidChangeItemsExternal=this._onDidChangeItemsExternal.event,this.registerListeners()}registerListeners(){this._register(this.channel.listen("onDidChangeGlobalStorage")(b=>this.onDidChangeGlobalStorage(b)))}onDidChangeGlobalStorage(b){(Array.isArray(b.changed)||Array.isArray(b.deleted))&&this._onDidChangeItemsExternal.fire({changed:b.changed?new Map(b.changed):void 0,deleted:b.deleted?new Set(b.deleted):void 0})}async close(){this.dispose()}}class k extends R{constructor(b,i){super(b,i);this.onDidChangeItemsExternal=D.Event.None}async close(){const b={workspace:this.workspace};return this.channel.call("close",b)}}class P extends L.Disposable{constructor(b,i){super();this.channel=b,this.workspace=i,this._globalStorage=void 0,this._workspaceStorage=void 0}get globalStorage(){return this._globalStorage||(this._globalStorage=new T(this.channel)),this._globalStorage}get workspaceStorage(){return!this._workspaceStorage&&this.workspace&&(this._workspaceStorage=new k(this.channel,this.workspace)),this._workspaceStorage}}e.StorageDatabaseChannelClient=P}),define(Z[183],te([0,1,6,2,172,16,70,22,182]),function(K,e,D,L,R,T,k,P,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.NativeStorageService=void 0;class b extends P.AbstractStorageService{constructor(C,g,w){super();this.mainProcessService=g,this.environmentService=w,this.workspaceStorage=void 0,this.workspaceStorageId=void 0,this.workspaceStorageDisposable=this._register(new L.MutableDisposable),this.globalStorage=this.createGlobalStorage(),this.workspaceStorage=this.createWorkspaceStorage(C)}createGlobalStorage(){const C=new m.StorageDatabaseChannelClient(this.mainProcessService.getChannel("storage"),void 0),g=new k.Storage(C.globalStorage);return this._register(g.onDidChangeStorage(w=>this.emitDidChangeValue(0,w))),g}createWorkspaceStorage(C){const g=new m.StorageDatabaseChannelClient(this.mainProcessService.getChannel("storage"),C);if(g.workspaceStorage){const w=new k.Storage(g.workspaceStorage);return this.workspaceStorageDisposable.value=w.onDidChangeStorage(u=>this.emitDidChangeValue(1,u)),this.workspaceStorageId=C?.id,w}else{this.workspaceStorageDisposable.clear(),this.workspaceStorageId=void 0;return}}async doInitialize(){(0,R.mark)("code/willInitStorage");try{await D.Promises.settled([this.globalStorage.init(),this.workspaceStorage?.init()??Promise.resolve()])}finally{(0,R.mark)("code/didInitStorage")}}getStorage(C){return C===0?this.globalStorage:this.workspaceStorage}getLogDetails(C){return C===0?this.environmentService.globalStorageHome.fsPath:this.workspaceStorageId?`${(0,T.joinPath)(this.environmentService.workspaceStorageHome,this.workspaceStorageId,"state.vscdb").fsPath}`:void 0}async close(){this.stopFlushWhenIdle(),this.emitWillSaveState(P.WillSaveStateReason.SHUTDOWN),await D.Promises.settled([this.globalStorage.close(),this.workspaceStorage?.close()??Promise.resolve()])}async migrate(C){const g=this.workspaceStorage,w=g?.items??new Map;g&&(await g.close(),g.dispose()),this.workspaceStorage=this.createWorkspaceStorage(C),await this.workspaceStorage.init();for(const[u,S]of w)this.workspaceStorage.set(u,S)}}e.NativeStorageService=b}),define(Z[184],te([0,1,4,31,5,30]),function(K,e,D,L,R,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.verifyMicrosoftInternalDomain=e.resolveCommonProperties=void 0;function k(b){if(D.platform===2&&/^penguin(\.|$)/i.test(b))return"chromebook"}async function P(b,i,C,g,w,u,S,f,I,y){const E=Object.create(null);E["common.machineId"]=S,E.sessionID=(0,T.generateUuid)()+Date.now(),E.commitHash=w,E.version=u,E["common.platformVersion"]=(i||"").replace(/^(\d+)(\.\d+)?(\.\d+)?(.*)/,"$1$2$3"),E["common.platform"]=(0,D.PlatformToString)(D.platform),E["common.nodePlatform"]=L.platform,E["common.nodeArch"]=g,E["common.product"]=y||"desktop";const o=m(f||[]);o&&(E["common.msftInternal"]=o);let a=0;const t=Date.now();Object.defineProperties(E,{timestamp:{get:()=>new Date,enumerable:!0},"common.timesincesessionstart":{get:()=>Date.now()-t,enumerable:!0},"common.sequence":{get:()=>a++,enumerable:!0}}),D.isLinuxSnap&&(E["common.snap"]="true");const r=k(C);r&&(E["common.platformDetail"]=r);try{const n=await b.readFile(R.URI.file(I));E["common.source"]=n.value.toString().slice(0,30)}catch(n){}return E}e.resolveCommonProperties=P;function m(b){const i=L.env.USERDNSDOMAIN;if(!i)return!1;const C=i.toLowerCase();return b.some(g=>C===g)}e.verifyMicrosoftInternalDomain=m}),define(Z[20],te([0,1,7]),function(K,e,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TelemetryConfiguration=e.TelemetryLevel=e.TELEMETRY_OLD_SETTING_ID=e.TELEMETRY_SETTING_ID=e.TELEMETRY_SECTION_ID=e.machineIdKey=e.lastSessionDateStorageKey=e.firstSessionDateStorageKey=e.currentSessionDateStorageKey=e.instanceStorageKey=e.ICustomEndpointTelemetryService=e.ITelemetryService=void 0,e.ITelemetryService=(0,D.createDecorator)("telemetryService"),e.ICustomEndpointTelemetryService=(0,D.createDecorator)("customEndpointTelemetryService"),e.instanceStorageKey="telemetry.instanceId",e.currentSessionDateStorageKey="telemetry.currentSessionDate",e.firstSessionDateStorageKey="telemetry.firstSessionDate",e.lastSessionDateStorageKey="telemetry.lastSessionDate",e.machineIdKey="telemetry.machineId",e.TELEMETRY_SECTION_ID="telemetry",e.TELEMETRY_SETTING_ID="telemetry.telemetryLevel",e.TELEMETRY_OLD_SETTING_ID="telemetry.enableTelemetry";var L;(function(T){T[T.NONE=0]="NONE",T[T.ERROR=2]="ERROR",T[T.USAGE=3]="USAGE"})(L=e.TelemetryLevel||(e.TelemetryLevel={}));var R;(function(T){T.OFF="off",T.ERROR="error",T.ON="on"})(R=e.TelemetryConfiguration||(e.TelemetryConfiguration={}))}),define(Z[185],te([0,1,35,55,34,15,8,4,5,100,19,102,74,14,29,20]),function(K,e,D,L,R,T,k,P,m,b,i,C,g,w,u,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.DiagnosticsService=e.collectLaunchConfigs=e.getMachineInfo=e.collectWorkspaceStats=void 0;async function f(a,t){const r=[{tag:"grunt.js",filePattern:/^gruntfile\.js$/i},{tag:"gulp.js",filePattern:/^gulpfile\.js$/i},{tag:"tsconfig.json",filePattern:/^tsconfig\.json$/i},{tag:"package.json",filePattern:/^package\.json$/i},{tag:"jsconfig.json",filePattern:/^jsconfig\.json$/i},{tag:"tslint.json",filePattern:/^tslint\.json$/i},{tag:"eslint.json",filePattern:/^eslint\.json$/i},{tag:"tasks.json",filePattern:/^tasks\.json$/i},{tag:"launch.json",filePattern:/^launch\.json$/i},{tag:"settings.json",filePattern:/^settings\.json$/i},{tag:"webpack.config.js",filePattern:/^webpack\.config\.js$/i},{tag:"project.json",filePattern:/^project\.json$/i},{tag:"makefile",filePattern:/^makefile$/i},{tag:"sln",filePattern:/^.+\.sln$/i},{tag:"csproj",filePattern:/^.+\.csproj$/i},{tag:"cmake",filePattern:/^.+\.cmake$/i},{tag:"github-actions",filePattern:/^.+\.yml$/i,relativePathPattern:/^\.github(?:\/|\\)workflows$/i}],n=new Map,s=new Map,c=2e4;function l(v,A,O,p){const U=A.substring(v.length+1);return new Promise(async F=>{let z;try{z=await i.Promises.readdir(A,{withFileTypes:!0})}catch(j){F();return}if(p.count>=c){p.count+=z.length,p.maxReached=!0,F();return}let H=z.length;if(H===0){F();return}let M=z;p.count+z.length>c&&(p.maxReached=!0,H=c-p.count,M=z.slice(0,H)),p.count+=z.length;for(const j of M)if(j.isDirectory()){if(O.includes(j.name)||await l(v,(0,k.join)(A,j.name),O,p),--H==0){F();return}}else{const q=j.name.lastIndexOf(".");if(q>=0){const x=j.name.substring(q+1);x&&n.set(x,(n.get(x)??0)+1)}for(const x of r)x.relativePathPattern?.test(U)!==!1&&x.filePattern.test(j.name)&&s.set(x.tag,(s.get(x.tag)??0)+1);if(--H==0){F();return}}})}const h={count:0,maxReached:!1};await l(a,a,t,h);const d=await E(a);return{configFiles:I(s),fileTypes:I(n),fileCount:h.count,maxFilesReached:h.maxReached,launchConfigFiles:d}}e.collectWorkspaceStats=f;function I(a){return[...L.Iterable.map(a.entries(),([t,r])=>({name:t,count:r}))].sort((t,r)=>r.count-t.count)}function y(){const a={os:`${D.type()} ${D.arch()} ${D.release()}`,memory:`${(D.totalmem()/w.ByteSize.GB).toFixed(2)}GB (${(D.freemem()/w.ByteSize.GB).toFixed(2)}GB free)`,vmHint:`${Math.round(b.virtualMachineHint.value()*100)}%`},t=D.cpus();return t&&t.length>0&&(a.cpus=`${t[0].model} (${t.length} x ${t[0].speed})`),a}e.getMachineInfo=y;async function E(a){try{const t=new Map,r=(0,k.join)(a,".vscode","launch.json"),n=await i.Promises.readFile(r),s=[],c=(0,R.parse)(n.toString(),s);if(s.length)return console.log(`Unable to parse ${r}`),[];if((0,R.getNodeType)(c)==="object"&&c.configurations)for(const l of c.configurations){const h=l.type;h&&(t.has(h)?t.set(h,t.get(h)+1):t.set(h,1))}return I(t)}catch(t){return[]}}e.collectLaunchConfigs=E;let o=class{constructor(t,r){this.telemetryService=t,this.productService=r}formatMachineInfo(t){const r=[];return r.push(`OS Version:       ${t.os}`),r.push(`CPUs:             ${t.cpus}`),r.push(`Memory (System):  ${t.memory}`),r.push(`VM:               ${t.vmHint}`),r.join(`
`)}formatEnvironment(t){const r=[];r.push(`Version:          ${this.productService.nameShort} ${this.productService.version} (${this.productService.commit||"Commit unknown"}, ${this.productService.date||"Date unknown"})`),r.push(`OS Version:       ${D.type()} ${D.arch()} ${D.release()}`);const n=D.cpus();return n&&n.length>0&&r.push(`CPUs:             ${n[0].model} (${n.length} x ${n[0].speed})`),r.push(`Memory (System):  ${(D.totalmem()/w.ByteSize.GB).toFixed(2)}GB (${(D.freemem()/w.ByteSize.GB).toFixed(2)}GB free)`),P.isWindows||r.push(`Load (avg):       ${D.loadavg().map(s=>Math.round(s)).join(", ")}`),r.push(`VM:               ${Math.round(b.virtualMachineHint.value()*100)}%`),r.push(`Screen Reader:    ${t.screenReader?"yes":"no"}`),r.push(`Process Argv:     ${t.mainArguments.join(" ")}`),r.push(`GPU Status:       ${this.expandGPUFeatures(t.gpuFeatureStatus)}`),r.join(`
`)}async getPerformanceInfo(t,r){return Promise.all([(0,C.listProcesses)(t.mainPID),this.formatWorkspaceMetadata(t)]).then(async n=>{let[s,c]=n,l=this.formatProcessList(t,s);return r.forEach(h=>{if((0,g.isRemoteDiagnosticError)(h))l+=`
${h.errorMessage}`,c+=`
${h.errorMessage}`;else if(l+=`

Remote: ${h.hostName}`,h.processes&&(l+=`
${this.formatProcessList(t,h.processes)}`),h.workspaceMetadata){c+=`
|  Remote: ${h.hostName}`;for(const d of Object.keys(h.workspaceMetadata)){const v=h.workspaceMetadata[d];let A=`${v.fileCount} files`;v.maxFilesReached&&(A=`more than ${A}`),c+=`|    Folder (${d}): ${A}`,c+=this.formatWorkspaceStats(v)}}}),{processInfo:l,workspaceInfo:c}})}async getSystemInfo(t,r){const{memory:n,vmHint:s,os:c,cpus:l}=y(),h={os:c,memory:n,cpus:l,vmHint:s,processArgs:`${t.mainArguments.join(" ")}`,gpuStatus:t.gpuFeatureStatus,screenReader:`${t.screenReader?"yes":"no"}`,remoteData:r};return P.isWindows||(h.load=`${D.loadavg().map(d=>Math.round(d)).join(", ")}`),P.isLinux&&(h.linuxEnv={desktopSession:process.env.DESKTOP_SESSION,xdgSessionDesktop:process.env.XDG_SESSION_DESKTOP,xdgCurrentDesktop:process.env.XDG_CURRENT_DESKTOP,xdgSessionType:process.env.XDG_SESSION_TYPE}),Promise.resolve(h)}async getDiagnostics(t,r){const n=[];return(0,C.listProcesses)(t.mainPID).then(async s=>(n.push(""),n.push(this.formatEnvironment(t)),n.push(""),n.push(this.formatProcessList(t,s)),t.windows.some(c=>c.folderURIs&&c.folderURIs.length>0&&!c.remoteAuthority)&&(n.push(""),n.push("Workspace Stats: "),n.push(await this.formatWorkspaceMetadata(t))),r.forEach(c=>{if((0,g.isRemoteDiagnosticError)(c))n.push(`
${c.errorMessage}`);else if(n.push(`

`),n.push(`Remote:           ${c.hostName}`),n.push(this.formatMachineInfo(c.machineInfo)),c.processes&&n.push(this.formatProcessList(t,c.processes)),c.workspaceMetadata)for(const l of Object.keys(c.workspaceMetadata)){const h=c.workspaceMetadata[l];let d=`${h.fileCount} files`;h.maxFilesReached&&(d=`more than ${d}`),n.push(`Folder (${l}): ${d}`),n.push(this.formatWorkspaceStats(h))}}),n.push(""),n.push(""),n.join(`
`)))}formatWorkspaceStats(t){const r=[],n=60;let s=0;const c=(v,A)=>{const O=` ${v}(${A})`;s+O.length>n?(r.push(l),l="|                 ",s=l.length):s+=O.length,l+=O};let l="|      File types:";const h=10;let d=t.fileTypes.length>h?h:t.fileTypes.length;for(let v=0;v<d;v++){const A=t.fileTypes[v];c(A.name,A.count)}if(r.push(l),t.configFiles.length>=0&&(l="|      Conf files:",s=0,t.configFiles.forEach(v=>{c(v.name,v.count)}),r.push(l)),t.launchConfigFiles.length>0){let v="|      Launch Configs:";t.launchConfigFiles.forEach(A=>{v+=A.count>1?` ${A.name}(${A.count})`:` ${A.name}`}),r.push(v)}return r.join(`
`)}expandGPUFeatures(t){const r=Math.max(...Object.keys(t).map(n=>n.length));return Object.keys(t).map(n=>`${n}:  ${" ".repeat(r-n.length)}  ${t[n]}`).join(`
                  `)}formatWorkspaceMetadata(t){const r=[],n=[];return t.windows.forEach(s=>{s.folderURIs.length===0||!!s.remoteAuthority||(r.push(`|  Window (${s.title})`),s.folderURIs.forEach(c=>{const l=m.URI.revive(c);if(l.scheme===T.Schemas.file){const h=l.fsPath;n.push(f(h,["node_modules",".git"]).then(d=>{let v=`${d.fileCount} files`;d.maxFilesReached&&(v=`more than ${v}`),r.push(`|    Folder (${(0,k.basename)(h)}): ${v}`),r.push(this.formatWorkspaceStats(d))}).catch(d=>{r.push(`|      Error: Unable to collect workspace stats for folder ${h} (${d.toString()})`)}))}else r.push(`|    Folder (${l.toString()}): Workspace stats not available.`)}))}),Promise.all(n).then(s=>r.join(`
`)).catch(s=>`Unable to collect workspace stats: ${s}`)}formatProcessList(t,r){const n=new Map;t.windows.forEach(c=>n.set(c.pid,c.title));const s=[];return s.push("CPU %	Mem MB	   PID	Process"),r&&this.formatProcessItem(t.mainPID,n,s,r,0),s.join(`
`)}formatProcessItem(t,r,n,s,c){const l=c===0;let h;l?h=s.pid===t?`${this.productService.applicationName} main`:"remote agent":(h=`${"  ".repeat(c)} ${s.name}`,s.name==="window"&&(h=`${h} (${r.get(s.pid)})`));const d=process.platform==="win32"?s.mem:D.totalmem()*(s.mem/100);n.push(`${s.load.toFixed(0).padStart(5," ")}	${(d/w.ByteSize.MB).toFixed(0).padStart(6," ")}	${s.pid.toFixed(0).padStart(6," ")}	${h}`),Array.isArray(s.children)&&s.children.forEach(v=>this.formatProcessItem(t,r,n,v,c+1))}async reportWorkspaceStats(t){for(const{uri:r}of t.folders){const n=m.URI.revive(r);if(n.scheme!==T.Schemas.file)continue;const s=n.fsPath;try{const c=await f(s,["node_modules",".git"]);this.telemetryService.publicLog2("workspace.stats",{"workspace.id":t.telemetryId,rendererSessionId:t.rendererSessionId}),c.fileTypes.forEach(l=>{this.telemetryService.publicLog2("workspace.stats.file",{rendererSessionId:t.rendererSessionId,type:l.name,count:l.count})}),c.launchConfigFiles.forEach(l=>{this.telemetryService.publicLog2("workspace.stats.launchConfigFile",{rendererSessionId:t.rendererSessionId,type:l.name,count:l.count})}),c.configFiles.forEach(l=>{this.telemetryService.publicLog2("workspace.stats.configFiles",{rendererSessionId:t.rendererSessionId,type:l.name,count:l.count})})}catch{}}}};o=fe([J(0,S.ITelemetryService),J(1,u.IProductService)],o),e.DiagnosticsService=o}),define(Z[186],te([0,1,17,6,27,9,3,2,4,5,116,28,32,13,42,20]),function(K,e,D,L,R,T,k,P,m,b,i,C,g,w,u,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.AbstractExtensionTask=e.reportTelemetry=e.joinErrors=e.AbstractExtensionManagementService=e.INSTALL_ERROR_LOCAL=e.ERROR_UNKNOWN=e.INSTALL_ERROR_VALIDATING=void 0,e.INSTALL_ERROR_VALIDATING="validating",e.ERROR_UNKNOWN="unknown",e.INSTALL_ERROR_LOCAL="local";let f=class extends P.Disposable{constructor(a,t,r){super();this.galleryService=a,this.telemetryService=t,this.logService=r,this.lastReportTimestamp=0,this.installingExtensions=new Map,this.uninstallingExtensions=new Map,this._onInstallExtension=this._register(new k.Emitter),this.onInstallExtension=this._onInstallExtension.event,this._onDidInstallExtensions=this._register(new k.Emitter),this.onDidInstallExtensions=this._onDidInstallExtensions.event,this._onUninstallExtension=this._register(new k.Emitter),this.onUninstallExtension=this._onUninstallExtension.event,this._onDidUninstallExtension=this._register(new k.Emitter),this.onDidUninstallExtension=this._onDidUninstallExtension.event,this.participants=[],this._register((0,P.toDisposable)(()=>{this.installingExtensions.forEach(n=>n.cancel()),this.uninstallingExtensions.forEach(n=>n.cancel()),this.installingExtensions.clear(),this.uninstallingExtensions.clear()}))}async canInstall(a){const t=await this.getTargetPlatform();return a.allTargetPlatforms.some(r=>(0,C.isTargetPlatformCompatible)(r,a.allTargetPlatforms,t))}async installFromGallery(a,t={}){if(!this.galleryService.isEnabled())throw new Error(i.localize(0,null));if(!await this.canInstall(a)){const n=await this.getTargetPlatform(),s=new C.ExtensionManagementError(i.localize(1,null,a.identifier.id,u.default.nameLong,(0,C.TargetPlatformToString)(n)),e.INSTALL_ERROR_VALIDATING);throw this.logService.error("Cannot install extension.",a.identifier.id,s.message),y(this.telemetryService,"extensionGallery:install",(0,g.getGalleryExtensionTelemetryData)(a),void 0,s),s}try{a=await this.checkAndGetCompatibleVersion(a,!t.installGivenVersion)}catch(n){throw this.logService.error((0,T.getErrorMessage)(n)),y(this.telemetryService,"extensionGallery:install",(0,g.getGalleryExtensionTelemetryData)(a),void 0,n),n}const r=await this.galleryService.getManifest(a,R.CancellationToken.None);if(r===null){const n=new C.ExtensionManagementError(`Missing manifest for extension ${a.identifier.id}`,e.INSTALL_ERROR_VALIDATING);throw this.logService.error("Failed to install extension:",a.identifier.id,n.message),y(this.telemetryService,"extensionGallery:install",(0,g.getGalleryExtensionTelemetryData)(a),void 0,n),n}if(r.version!==a.version){const n=new C.ExtensionManagementError(`Cannot install '${a.identifier.id}' extension because of version mismatch in Marketplace`,e.INSTALL_ERROR_VALIDATING);throw this.logService.error(n.message),y(this.telemetryService,"extensionGallery:install",(0,g.getGalleryExtensionTelemetryData)(a),void 0,n),n}return this.installExtension(r,a,t)}async uninstall(a,t={}){return this.logService.trace("ExtensionManagementService#uninstall",a.identifier.id),this.unininstallExtension(a,t)}async reinstallFromGallery(a){if(this.logService.trace("ExtensionManagementService#reinstallFromGallery",a.identifier.id),!this.galleryService.isEnabled())throw new Error(i.localize(2,null));const t=await this.findGalleryExtension(a);if(!t)throw new Error(i.localize(3,null));await this.createUninstallExtensionTask(a,{remove:!0,versionOnly:!0}).run(),await this.installFromGallery(t)}getExtensionsReport(){const a=new Date().getTime();return(!this.reportedExtensions||a-this.lastReportTimestamp>1e3*60*5)&&(this.reportedExtensions=this.updateReportCache(),this.lastReportTimestamp=a),this.reportedExtensions}registerParticipant(a){this.participants.push(a)}async installExtension(a,t,r){if(!b.URI.isUri(t)){let h=this.installingExtensions.get(new g.ExtensionIdentifierWithVersion(t.identifier,t.version).key());if(h)return this.logService.info("Extensions is already requested to install",t.identifier.id),h.waitUntilTaskIsFinished();r={...r,installOnlyNewlyAddedFromExtensionPack:!0}}const n=[],s=[],c=this.createInstallExtensionTask(a,t,r);b.URI.isUri(t)||this.installingExtensions.set(new g.ExtensionIdentifierWithVersion(c.identifier,a.version).key(),c),this._onInstallExtension.fire({identifier:c.identifier,source:t}),this.logService.info("Installing extension:",c.identifier.id),n.push({task:c,manifest:a});let l=!1;try{if(r.donotIncludePackAndDependencies)this.logService.info("Installing the extension without checking dependencies and pack",c.identifier.id);else try{const d=await this.getAllDepsAndPackExtensionsToInstall(c.identifier,a,!!r.installOnlyNewlyAddedFromExtensionPack);for(const{gallery:v,manifest:A}of d)if(l=l||!!A.extensionDependencies?.some(O=>(0,g.areSameExtensions)({id:O},c.identifier)),this.installingExtensions.has(new g.ExtensionIdentifierWithVersion(v.identifier,v.version).key()))this.logService.info("Extension is already requested to install",v.identifier.id);else{const O=this.createInstallExtensionTask(A,v,{...r,donotIncludePackAndDependencies:!0});this.installingExtensions.set(new g.ExtensionIdentifierWithVersion(O.identifier,A.version).key(),O),this._onInstallExtension.fire({identifier:O.identifier,source:v}),this.logService.info("Installing extension:",O.identifier.id),n.push({task:O,manifest:A})}}catch(d){if(b.URI.isUri(c.source))(0,D.isNonEmptyArray)(a.extensionDependencies)&&this.logService.warn("Cannot install dependencies of extension:",c.identifier.id,d.message),(0,D.isNonEmptyArray)(a.extensionPack)&&this.logService.warn("Cannot install packed extensions of extension:",c.identifier.id,d.message);else throw this.logService.error("Error while preparing to install dependencies and extension packs of the extension:",c.identifier.id),this.logService.error(d),d}const h=n.reduce((d,{task:v,manifest:A})=>(d.set(v.identifier.id.toLowerCase(),{task:v,manifest:A}),d),new Map);for(;h.size;){let d;const v=[...h.values()].filter(({manifest:A})=>!A.extensionDependencies?.some(O=>h.has(O.toLowerCase())));v.length?d=h.size===1?v:v.filter(({task:A})=>!(A===c&&!l)):(this.logService.info("Found extensions with circular dependencies",v.map(({task:A})=>A.identifier.id)),d=[...h.values()]),await this.joinAllSettled(d.map(async({task:A})=>{const O=new Date().getTime();try{const p=await A.run();if(await this.joinAllSettled(this.participants.map(U=>U.postInstall(p,A.source,r,R.CancellationToken.None))),!b.URI.isUri(A.source)&&(y(this.telemetryService,A.operation===2?"extensionGallery:update":"extensionGallery:install",(0,g.getGalleryExtensionTelemetryData)(A.source),new Date().getTime()-O,void 0),m.isWeb&&A.operation===1))try{await this.galleryService.reportStatistic(p.manifest.publisher,p.manifest.name,p.manifest.version,"install")}catch(U){}s.push({local:p,identifier:A.identifier,operation:A.operation,source:A.source})}catch(p){throw b.URI.isUri(A.source)||y(this.telemetryService,A.operation===2?"extensionGallery:update":"extensionGallery:install",(0,g.getGalleryExtensionTelemetryData)(A.source),new Date().getTime()-O,p),this.logService.error("Error while installing the extension:",A.identifier.id),this.logService.error(p),p}finally{h.delete(A.identifier.id.toLowerCase())}}))}return s.forEach(({identifier:d})=>this.logService.info("Extension installed successfully:",d.id)),this._onDidInstallExtensions.fire(s),s.filter(({identifier:d})=>(0,g.areSameExtensions)(d,c.identifier))[0].local}catch(h){if(n.forEach(({task:d})=>d.cancel()),s.length)try{const d=await Promise.allSettled(s.map(({local:v})=>this.createUninstallExtensionTask(v,{versionOnly:!0}).run()));for(let v=0;v<d.length;v++){const A=d[v],{identifier:O}=s[v];A.status==="fulfilled"?this.logService.info("Rollback: Uninstalled extension",O.id):this.logService.warn("Rollback: Error while uninstalling extension",O.id,(0,T.getErrorMessage)(A.reason))}}catch(d){this.logService.warn("Error while rolling back extensions",(0,T.getErrorMessage)(d),s.map(({identifier:v})=>v.id))}throw this.logService.error("Failed to install extension:",c.identifier.id,(0,T.getErrorMessage)(h)),this._onDidInstallExtensions.fire(n.map(({task:d})=>({identifier:d.identifier,operation:1,source:d.source}))),h instanceof Error&&(h.name=h&&h.code?h.code:e.ERROR_UNKNOWN),h}finally{for(const{task:h,manifest:d}of n)if(!b.URI.isUri(h.source)){const v=new g.ExtensionIdentifierWithVersion(h.identifier,d.version).key();this.installingExtensions.delete(v)||this.logService.warn("Installation task is not found in the cache",v)}}}async joinAllSettled(a){const t=[],r=[],n=await Promise.allSettled(a);for(const s of n)s.status==="fulfilled"?t.push(s.value):r.push(s.reason);if(r.length)throw I(r);return t}async getAllDepsAndPackExtensionsToInstall(a,t,r){if(!this.galleryService.isEnabled())return[];let n=await this.getInstalled();const s=[a,...n.map(h=>h.identifier)],c=[],l=async(h,d)=>{const v=d.extensionDependencies||[],A=[...v];if(d.extensionPack){const O=r?n.find(p=>(0,g.areSameExtensions)(p.identifier,h)):void 0;for(const p of d.extensionPack)O&&O.manifest.extensionPack&&O.manifest.extensionPack.some(U=>(0,g.areSameExtensions)({id:U},{id:p}))||A.every(U=>!(0,g.areSameExtensions)({id:U},{id:p}))&&A.push(p)}if(A.length){const O=[...s,...c.map(U=>U.gallery.identifier)],p=A.filter(U=>O.every(F=>!(0,g.areSameExtensions)(F,{id:U})));if(p.length){const U=await this.galleryService.query({names:p,pageSize:A.length},R.CancellationToken.None);for(const F of U.firstPage){if(O.find(j=>(0,g.areSameExtensions)(j,F.identifier)))continue;if(!v.some(j=>(0,g.areSameExtensions)({id:j},F.identifier))&&!await this.canInstall(F)){this.logService.info("Skipping the packed extension as it cannot be installed",F.identifier.id);continue}const H=await this.checkAndGetCompatibleVersion(F,!0),M=await this.galleryService.getManifest(H,R.CancellationToken.None);if(M===null)throw new C.ExtensionManagementError(`Missing manifest for extension ${H.identifier.id}`,e.INSTALL_ERROR_VALIDATING);c.push({gallery:H,manifest:M}),await l(H.identifier,M)}}}};return await l(a,t),n=await this.getInstalled(),c.filter(h=>!n.some(d=>(0,g.areSameExtensions)(d.identifier,h.gallery.identifier)))}async checkAndGetCompatibleVersion(a,t){if(await this.isMalicious(a))throw new C.ExtensionManagementError(i.localize(4,null,a.identifier.id),C.INSTALL_ERROR_MALICIOUS);const r=await this.getCompatibleVersion(a,t);if(!r)throw new C.ExtensionManagementError(i.localize(5,null,a.identifier.id,u.default.version),C.INSTALL_ERROR_INCOMPATIBLE);return r}async getCompatibleVersion(a,t){const r=await this.getTargetPlatform();let n=null;return await this.galleryService.isExtensionCompatible(a,r)&&(n=a),!n&&t&&(n=await this.galleryService.getCompatibleExtension(a,r)),n}async isMalicious(a){const t=await this.getExtensionsReport();return(0,g.getMaliciousExtensionsSet)(t).has(a.identifier.id)}async unininstallExtension(a,t){const r=this.uninstallingExtensions.get(a.identifier.id.toLowerCase());if(r)return this.logService.info("Extensions is already requested to uninstall",a.identifier.id),r.waitUntilTaskIsFinished();const n=(h,d)=>{const v=this.createUninstallExtensionTask(h,d);return this.uninstallingExtensions.set(v.extension.identifier.id.toLowerCase(),v),this.logService.info("Uninstalling extension:",h.identifier.id),this._onUninstallExtension.fire(h.identifier),v},s=(h,d)=>{d?this.logService.error("Failed to uninstall extension:",h.identifier.id,d.message):this.logService.info("Successfully uninstalled extension:",h.identifier.id),y(this.telemetryService,"extensionGallery:uninstall",(0,g.getLocalExtensionTelemetryData)(h),void 0,d),this._onDidUninstallExtension.fire({identifier:h.identifier,error:d?.code})},c=[],l=[];try{c.push(n(a,{}));const h=await this.getInstalled(1);if(t.donotIncludePack)this.logService.info("Uninstalling the extension without including packed extension",a.identifier.id);else{const d=this.getAllPackExtensionsToUninstall(a,h);for(const v of d)this.uninstallingExtensions.has(v.identifier.id.toLowerCase())?this.logService.info("Extensions is already requested to uninstall",v.identifier.id):c.push(n(v,{}))}t.donotCheckDependents?this.logService.info("Uninstalling the extension without checking dependents",a.identifier.id):this.checkForDependents(c.map(d=>d.extension),h,a),await this.joinAllSettled(c.map(async d=>{try{if(await d.run(),await this.joinAllSettled(this.participants.map(v=>v.postUninstall(d.extension,t,R.CancellationToken.None))),d.extension.identifier.uuid)try{await this.galleryService.reportStatistic(d.extension.manifest.publisher,d.extension.manifest.name,d.extension.manifest.version,"uninstall")}catch(v){}s(d.extension)}catch(v){const A=v instanceof C.ExtensionManagementError?v:new C.ExtensionManagementError((0,T.getErrorMessage)(v),e.ERROR_UNKNOWN);throw s(d.extension,A),A}finally{l.push(d)}}))}catch(h){const d=h instanceof C.ExtensionManagementError?h:new C.ExtensionManagementError((0,T.getErrorMessage)(h),e.ERROR_UNKNOWN);for(const v of c){try{v.cancel()}catch(A){}l.includes(v)||s(v.extension,d)}throw d}finally{for(const h of c)this.uninstallingExtensions.delete(h.extension.identifier.id.toLowerCase())||this.logService.warn("Uninstallation task is not found in the cache",h.extension.identifier.id)}}checkForDependents(a,t,r){for(const n of a){const s=this.getDependents(n,t);if(s.length){const c=s.filter(l=>!a.some(h=>(0,g.areSameExtensions)(h.identifier,l.identifier)));if(c.length)throw new Error(this.getDependentsErrorMessage(n,c,r))}}}getDependentsErrorMessage(a,t,r){return r===a?t.length===1?i.localize(6,null,r.manifest.displayName||r.manifest.name,t[0].manifest.displayName||t[0].manifest.name):t.length===2?i.localize(7,null,r.manifest.displayName||r.manifest.name,t[0].manifest.displayName||t[0].manifest.name,t[1].manifest.displayName||t[1].manifest.name):i.localize(8,null,r.manifest.displayName||r.manifest.name,t[0].manifest.displayName||t[0].manifest.name,t[1].manifest.displayName||t[1].manifest.name):t.length===1?i.localize(9,null,r.manifest.displayName||r.manifest.name,a.manifest.displayName||a.manifest.name,t[0].manifest.displayName||t[0].manifest.name):t.length===2?i.localize(10,null,r.manifest.displayName||r.manifest.name,a.manifest.displayName||a.manifest.name,t[0].manifest.displayName||t[0].manifest.name,t[1].manifest.displayName||t[1].manifest.name):i.localize(11,null,r.manifest.displayName||r.manifest.name,a.manifest.displayName||a.manifest.name,t[0].manifest.displayName||t[0].manifest.name,t[1].manifest.displayName||t[1].manifest.name)}getAllPackExtensionsToUninstall(a,t,r=[]){if(r.indexOf(a)!==-1)return[];r.push(a);const n=a.manifest.extensionPack?a.manifest.extensionPack:[];if(n.length){const s=t.filter(l=>!l.isBuiltin&&n.some(h=>(0,g.areSameExtensions)({id:h},l.identifier))),c=[];for(const l of s)c.push(...this.getAllPackExtensionsToUninstall(l,t,r));return[...s,...c]}return[]}getDependents(a,t){return t.filter(r=>r.manifest.extensionDependencies&&r.manifest.extensionDependencies.some(n=>(0,g.areSameExtensions)({id:n},a.identifier)))}async findGalleryExtension(a){if(a.identifier.uuid){const t=await this.findGalleryExtensionById(a.identifier.uuid);return t||this.findGalleryExtensionByName(a.identifier.id)}return this.findGalleryExtensionByName(a.identifier.id)}async findGalleryExtensionById(a){return(await this.galleryService.query({ids:[a],pageSize:1},R.CancellationToken.None)).firstPage[0]}async findGalleryExtensionByName(a){return(await this.galleryService.query({names:[a],pageSize:1},R.CancellationToken.None)).firstPage[0]}async updateReportCache(){try{this.logService.trace("ExtensionManagementService.refreshReportedCache");const a=await this.galleryService.getExtensionsReport();return this.logService.trace(`ExtensionManagementService.refreshReportedCache - got ${a.length} reported extensions from service`),a}catch(a){return this.logService.trace("ExtensionManagementService.refreshReportedCache - failed to get extension report"),[]}}};f=fe([J(0,C.IExtensionGalleryService),J(1,S.ITelemetryService),J(2,w.ILogService)],f),e.AbstractExtensionManagementService=f;function I(o){const a=Array.isArray(o)?o:[o];return a.length===1?a[0]instanceof Error?a[0]:new Error(a[0]):a.reduce((t,r)=>new Error(`${t.message}${t.message?",":""}${r instanceof Error?r.message:r}`),new Error(""))}e.joinErrors=I;function y(o,a,t,r,n){const s=n?n instanceof C.ExtensionManagementError?n.code:e.ERROR_UNKNOWN:void 0;o.publicLogError(a,{...t,success:!n,duration:r,errorcode:s})}e.reportTelemetry=y;class E{constructor(){this.barrier=new L.Barrier}async waitUntilTaskIsFinished(){return await this.barrier.wait(),this.cancellablePromise}async run(){return this.cancellablePromise||(this.cancellablePromise=(0,L.createCancelablePromise)(a=>this.doRun(a))),this.barrier.open(),this.cancellablePromise}cancel(){this.cancellablePromise||(this.cancellablePromise=(0,L.createCancelablePromise)(a=>new Promise((t,r)=>{const n=a.onCancellationRequested(()=>{n.dispose(),r((0,T.canceled)())})})),this.barrier.open()),this.cancellablePromise.cancel()}}e.AbstractExtensionTask=E}),define(Z[187],te([0,1,17,6,63,3,8,4,31,5,118,12,28,180,76,14,13,59,29,43,22,20]),function(K,e,D,L,R,T,k,P,m,b,i,C,g,w,u,S,f,I,y,E,o,a){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionTipsService=void 0;const t="extensionTips/promptedExecutableTips",r="extensionTips/lastPromptedMediumImpExeTime";let n=class extends w.ExtensionTipsService{constructor(c,l,h,d,v,A,O,p,U,F){super(O,p,U,F);this.environmentService=c,this.telemetryService=l,this.extensionManagementService=h,this.storageService=d,this.nativeHostService=v,this.extensionRecommendationNotificationService=A,this.highImportanceExecutableTips=new Map,this.mediumImportanceExecutableTips=new Map,this.allOtherExecutableTips=new Map,this.highImportanceTipsByExe=new Map,this.mediumImportanceTipsByExe=new Map,p.exeBasedExtensionTips&&(0,R.forEach)(p.exeBasedExtensionTips,({key:z,value:H})=>{const M=[],j=[],q=[];(0,R.forEach)(H.recommendations,({key:x,value:$})=>{$.important?H.important?M.push({extensionId:x,extensionName:$.name,isExtensionPack:!!$.isExtensionPack}):j.push({extensionId:x,extensionName:$.name,isExtensionPack:!!$.isExtensionPack}):q.push({extensionId:x,extensionName:$.name,isExtensionPack:!!$.isExtensionPack})}),M.length&&this.highImportanceExecutableTips.set(z,{exeFriendlyName:H.friendlyName,windowsPath:H.windowsPath,recommendations:M}),j.length&&this.mediumImportanceExecutableTips.set(z,{exeFriendlyName:H.friendlyName,windowsPath:H.windowsPath,recommendations:j}),q.length&&this.allOtherExecutableTips.set(z,{exeFriendlyName:H.friendlyName,windowsPath:H.windowsPath,recommendations:q})}),(0,L.timeout)(3e3).then(async()=>{await this.collectTips(),this.promptHighImportanceExeBasedTip(),this.promptMediumImportanceExeBasedTip()})}async getImportantExecutableBasedTips(){const c=await this.getValidExecutableBasedExtensionTips(this.highImportanceExecutableTips),l=await this.getValidExecutableBasedExtensionTips(this.mediumImportanceExecutableTips);return[...c,...l]}getOtherExecutableBasedTips(){return this.getValidExecutableBasedExtensionTips(this.allOtherExecutableTips)}async collectTips(){const c=await this.getValidExecutableBasedExtensionTips(this.highImportanceExecutableTips),l=await this.getValidExecutableBasedExtensionTips(this.mediumImportanceExecutableTips),h=await this.extensionManagementService.getInstalled();this.highImportanceTipsByExe=this.groupImportantTipsByExe(c,h),this.mediumImportanceTipsByExe=this.groupImportantTipsByExe(l,h)}groupImportantTipsByExe(c,l){const h=new Map;c.forEach(p=>h.set(p.extensionId.toLowerCase(),p));const{installed:d,uninstalled:v}=this.groupByInstalled([...h.keys()],l);for(const p of d){const U=h.get(p);U&&this.telemetryService.publicLog2("exeExtensionRecommendations:alreadyInstalled",{extensionId:p,exeName:U.exeName})}for(const p of v){const U=h.get(p);U&&this.telemetryService.publicLog2("exeExtensionRecommendations:notInstalled",{extensionId:p,exeName:U.exeName})}const A=this.getPromptedExecutableTips(),O=new Map;for(const p of v){const U=h.get(p);if(U&&(!A[U.exeName]||!A[U.exeName].includes(U.extensionId))){let F=O.get(U.exeName);F||(F=[],O.set(U.exeName,F)),F.push(U)}}return O}promptHighImportanceExeBasedTip(){if(this.highImportanceTipsByExe.size===0)return;const[c,l]=[...this.highImportanceTipsByExe.entries()][0];this.promptExeRecommendations(l).then(h=>{switch(h){case"reacted":this.addToRecommendedExecutables(l[0].exeName,l);break;case"ignored":this.highImportanceTipsByExe.delete(c);break;case"incompatibleWindow":const d=T.Event.once(T.Event.latch(T.Event.any(this.nativeHostService.onDidOpenWindow,this.nativeHostService.onDidFocusWindow)));this._register(d(()=>this.promptHighImportanceExeBasedTip()));break;case"toomany":const v=this._register((0,L.disposableTimeout)(()=>{v.dispose(),this.promptHighImportanceExeBasedTip()},60*60*1e3));break}})}promptMediumImportanceExeBasedTip(){if(this.mediumImportanceTipsByExe.size===0)return;const c=this.getLastPromptedMediumExeTime(),l=Date.now()-c,h=7*24*60*60*1e3;if(l<h){const A=this._register((0,L.disposableTimeout)(()=>{A.dispose(),this.promptMediumImportanceExeBasedTip()},h-l));return}const[d,v]=[...this.mediumImportanceTipsByExe.entries()][0];this.promptExeRecommendations(v).then(A=>{switch(A){case"reacted":this.updateLastPromptedMediumExeTime(Date.now()),this.mediumImportanceTipsByExe.delete(d),this.addToRecommendedExecutables(v[0].exeName,v);const O=this._register((0,L.disposableTimeout)(()=>{O.dispose(),this.promptMediumImportanceExeBasedTip()},h));break;case"ignored":this.mediumImportanceTipsByExe.delete(d),this.promptMediumImportanceExeBasedTip();break;case"incompatibleWindow":const p=T.Event.once(T.Event.latch(T.Event.any(this.nativeHostService.onDidOpenWindow,this.nativeHostService.onDidFocusWindow)));this._register(p(()=>this.promptMediumImportanceExeBasedTip()));break;case"toomany":const U=this._register((0,L.disposableTimeout)(()=>{U.dispose(),this.promptMediumImportanceExeBasedTip()},60*60*1e3));break}})}promptExeRecommendations(c){const l=c.map(({extensionId:d})=>d.toLowerCase()),h=(0,i.localize)(0,null,c[0].exeFriendlyName);return this.extensionRecommendationNotificationService.promptImportantExtensionsInstallNotification(l,h,`@exe:"${c[0].exeName}"`,3)}getLastPromptedMediumExeTime(){let c=this.storageService.getNumber(r,0);return c||(c=Date.now(),this.updateLastPromptedMediumExeTime(c)),c}updateLastPromptedMediumExeTime(c){this.storageService.store(r,c,0,1)}getPromptedExecutableTips(){return JSON.parse(this.storageService.get(t,0,"{}"))}addToRecommendedExecutables(c,l){const h=this.getPromptedExecutableTips();h[c]=l.map(({extensionId:d})=>d.toLowerCase()),this.storageService.store(t,JSON.stringify(h),0,0)}groupByInstalled(c,l){const h=[],d=[],v=l.reduce((A,O)=>(A.add(O.identifier.id.toLowerCase()),A),new Set);return c.forEach(A=>{v.has(A.toLowerCase())?h.push(A):d.push(A)}),{installed:h,uninstalled:d}}async getValidExecutableBasedExtensionTips(c){const l=[],h=new Map;for(const d of c.keys()){const v=c.get(d);if(!v||!(0,D.isNonEmptyArray)(v.recommendations))continue;const A=[];P.isWindows?v.windowsPath&&A.push(v.windowsPath.replace("%USERPROFILE%",m.env.USERPROFILE).replace("%ProgramFiles(x86)%",m.env["ProgramFiles(x86)"]).replace("%ProgramFiles%",m.env.ProgramFiles).replace("%APPDATA%",m.env.APPDATA).replace("%WINDIR%",m.env.WINDIR)):(A.push((0,k.join)("/usr/local/bin",d)),A.push((0,k.join)("/usr/bin",d)),A.push((0,k.join)(this.environmentService.userHome.fsPath,d)));for(const O of A){let p=h.get(O);if(p===void 0&&(p=await this.fileService.exists(b.URI.file(O)),h.set(O,p)),p)for(const{extensionId:U,extensionName:F,isExtensionPack:z}of v.recommendations)l.push({extensionId:U,extensionName:F,isExtensionPack:z,exeName:d,exeFriendlyName:v.exeFriendlyName,windowsPath:v.windowsPath})}}return l}};n=fe([J(0,C.INativeEnvironmentService),J(1,a.ITelemetryService),J(2,g.IExtensionManagementService),J(3,o.IStorageService),J(4,I.INativeHostService),J(5,u.IExtensionRecommendationNotificationService),J(6,S.IFileService),J(7,y.IProductService),J(8,E.IRequestService),J(9,f.ILogService)],n),e.ExtensionTipsService=n}),define(Z[83],te([0,1]),function(K,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TelemetryAppenderClient=e.TelemetryAppenderChannel=void 0;class D{constructor(T){this.appender=T}listen(T,k){throw new Error(`Event not found: ${k}`)}call(T,k,{eventName:P,data:m}){return this.appender.log(P,m),Promise.resolve(null)}}e.TelemetryAppenderChannel=D;class L{constructor(T){this.channel=T}log(T,k){return this.channel.call("log",{eventName:T,data:k}).then(void 0,P=>`Failed to log telemetry: ${console.warn(P)}`),Promise.resolve(null)}flush(){return Promise.resolve()}}e.TelemetryAppenderClient=L}),define(Z[46],te([0,1,26,18,21,20]),function(K,e,D,L,R,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.cleanRemoteAuthority=e.validateTelemetryData=e.getTelemetryLevel=e.supportsTelemetry=e.configurationTelemetry=e.NullAppender=e.NullEndpointTelemetryService=e.NullTelemetryService=void 0,e.NullTelemetryService=new class{constructor(){this.sendErrorTelemetry=!1,this.telemetryLevel=0}publicLog(S,f){return Promise.resolve(void 0)}publicLog2(S,f){return this.publicLog(S,f)}publicLogError(S,f){return Promise.resolve(void 0)}publicLogError2(S,f){return this.publicLogError(S,f)}setExperimentProperty(){}getTelemetryInfo(){return Promise.resolve({instanceId:"someValue.instanceId",sessionId:"someValue.sessionId",machineId:"someValue.machineId",firstSessionDate:"someValue.firstSessionDate"})}};class k{async publicLog(f,I,y){}async publicLogError(f,I,y){}}e.NullEndpointTelemetryService=k,e.NullAppender={log:()=>null,flush:()=>Promise.resolve(null)};function P(S,f){return f.onDidChangeConfiguration(I=>{I.source!==6&&S.publicLog2("updateConfiguration",{configurationSource:(0,R.ConfigurationTargetToString)(I.source),configurationKeys:w(I.sourceConfig)})})}e.configurationTelemetry=P;function m(S,f){return!(f.disableTelemetry||!S.enableTelemetry)}e.supportsTelemetry=m;function b(S){const f=S.getValue(T.TELEMETRY_SETTING_ID),I=S.getValue(T.TELEMETRY_OLD_SETTING_ID);if(I!==void 0&&I===!1)return 0;switch(f??"on"){case"on":return 3;case"error":return 2;case"off":return 0}}e.getTelemetryLevel=b;function i(S){const f=Object.create(null),I=Object.create(null),y=Object.create(null);g(S,y);for(let E in y){E=E.length>150?E.substr(E.length-149):E;const o=y[E];typeof o=="number"?I[E]=o:typeof o=="boolean"?I[E]=o?1:0:typeof o=="string"?f[E]=o.substring(0,1023):typeof o!="undefined"&&o!==null&&(f[E]=o)}return{properties:f,measurements:I}}e.validateTelemetryData=i;function C(S){if(!S)return"none";let f="other";return["ssh-remote","dev-container","attached-container","wsl"].forEach(y=>{S.indexOf(`${y}+`)===0&&(f=y)}),f}e.cleanRemoteAuthority=C;function g(S,f,I=0,y){if(!!S)for(let E of Object.getOwnPropertyNames(S)){const o=S[E],a=y?y+E:E;Array.isArray(o)?f[a]=(0,D.safeStringify)(o):o instanceof Date?f[a]=o.toISOString():(0,L.isObject)(o)?I<2?g(o,f,I+1,a+"."):f[a]=(0,D.safeStringify)(o):f[a]=o}}function w(S){if(!S)return[];const f=[];return u(f,"",S),f}function u(S,f,I){I&&typeof I=="object"&&!Array.isArray(I)?Object.keys(I).forEach(y=>u(S,f?`${f}.${y}`:y,I[y])):S.push(f)}}),define(Z[188],te([0,1,17,27,9,26,4,31,5,21,12,28,32,73,14,13,29,43,45,22,20,46]),function(K,e,D,L,R,T,k,P,m,b,i,C,g,w,u,S,f,I,y,E,o,a){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.resolveMarketplaceHeaders=e.ExtensionGalleryServiceWithNoStorageService=e.ExtensionGalleryService=e.sortExtensionVersions=void 0;const t=k.isWeb?"web":(0,C.getTargetPlatform)(k.platform,P.arch);var r;(function(X){X[X.None=0]="None",X[X.IncludeVersions=1]="IncludeVersions",X[X.IncludeFiles=2]="IncludeFiles",X[X.IncludeCategoryAndTags=4]="IncludeCategoryAndTags",X[X.IncludeSharedAccounts=8]="IncludeSharedAccounts",X[X.IncludeVersionProperties=16]="IncludeVersionProperties",X[X.ExcludeNonValidated=32]="ExcludeNonValidated",X[X.IncludeInstallationTargets=64]="IncludeInstallationTargets",X[X.IncludeAssetUri=128]="IncludeAssetUri",X[X.IncludeStatistics=256]="IncludeStatistics",X[X.IncludeLatestVersionOnly=512]="IncludeLatestVersionOnly",X[X.Unpublished=4096]="Unpublished"})(r||(r={}));function n(...X){return String(X.reduce((B,re)=>B|re,0))}var s;(function(X){X[X.Tag=1]="Tag",X[X.ExtensionId=4]="ExtensionId",X[X.Category=5]="Category",X[X.ExtensionName=7]="ExtensionName",X[X.Target=8]="Target",X[X.Featured=9]="Featured",X[X.SearchText=10]="SearchText",X[X.ExcludeWithFlags=12]="ExcludeWithFlags"})(s||(s={}));const c={Icon:"Microsoft.VisualStudio.Services.Icons.Default",Details:"Microsoft.VisualStudio.Services.Content.Details",Changelog:"Microsoft.VisualStudio.Services.Content.Changelog",Manifest:"Microsoft.VisualStudio.Code.Manifest",VSIX:"Microsoft.VisualStudio.Services.VSIXPackage",License:"Microsoft.VisualStudio.Services.Content.License",Repository:"Microsoft.VisualStudio.Services.Links.Source"},l={Dependency:"Microsoft.VisualStudio.Code.ExtensionDependencies",ExtensionPack:"Microsoft.VisualStudio.Code.ExtensionPack",Engine:"Microsoft.VisualStudio.Code.Engine",LocalizedLanguages:"Microsoft.VisualStudio.Code.LocalizedLanguages",WebExtension:"Microsoft.VisualStudio.Code.WebExtension"},d={pageNumber:1,pageSize:10,sortBy:0,sortOrder:0,flags:r.None,criteria:[],assetTypes:[]};class v{constructor(B=d){this.state=B}get pageNumber(){return this.state.pageNumber}get pageSize(){return this.state.pageSize}get sortBy(){return this.state.sortBy}get sortOrder(){return this.state.sortOrder}get flags(){return this.state.flags}withPage(B,re=this.state.pageSize){return new v({...this.state,pageNumber:B,pageSize:re})}withFilter(B,...re){const ie=[...this.state.criteria,...re.length?re.map(ce=>({filterType:B,value:ce})):[{filterType:B}]];return new v({...this.state,criteria:ie})}withSortBy(B){return new v({...this.state,sortBy:B})}withSortOrder(B){return new v({...this.state,sortOrder:B})}withFlags(...B){return new v({...this.state,flags:B.reduce((re,ie)=>re|ie,0)})}withAssetTypes(...B){return new v({...this.state,assetTypes:B})}get raw(){const{criteria:B,pageNumber:re,pageSize:ie,sortBy:ce,sortOrder:ue,flags:ge,assetTypes:de}=this.state;return{filters:[{criteria:B,pageNumber:re,pageSize:ie,sortBy:ce,sortOrder:ue}],assetTypes:de,flags:ge}}get searchText(){const B=this.state.criteria.filter(re=>re.filterType===s.SearchText)[0];return B&&B.value?B.value:""}get telemetryData(){return{filterTypes:this.state.criteria.map(B=>String(B.filterType)),sortBy:String(this.sortBy),sortOrder:String(this.sortOrder)}}}function A(X,B){const re=(X||[]).filter(ie=>ie.statisticName===B)[0];return re?re.value:0}function O(X){const B="Microsoft.VisualStudio.Code.Translation.";return X.files.filter(ie=>ie.assetType.indexOf(B)===0).reduce((ie,ce)=>{const ue=z(X,ce.assetType);return ue&&ie.push([ce.assetType.substring(B.length),ue]),ie},[])}function p(X){if(X.properties){const B=X.properties.filter(ce=>ce.key===c.Repository),re=new RegExp("((git|ssh|http(s)?)|(git@[\\w.]+))(:(//)?)([\\w.@:/\\-~]+)(.git)(/)?"),ie=B.filter(ce=>re.test(ce.value))[0];return ie?{uri:ie.value,fallbackUri:ie.value}:null}return z(X,c.Repository)}function U(X){return{uri:`${X.fallbackAssetUri}/${c.VSIX}?redirect=true${X.targetPlatform?`&targetPlatform=${X.targetPlatform}`:""}`,fallbackUri:`${X.fallbackAssetUri}/${c.VSIX}${X.targetPlatform?`?targetPlatform=${X.targetPlatform}`:""}`}}function F(X){const B=z(X,c.Icon);if(B)return B;const re=C.DefaultIconPath;return{uri:re,fallbackUri:re}}function z(X,B){return X.files.filter(ie=>ie.assetType===B)[0]?{uri:`${X.assetUri}/${B}`,fallbackUri:`${X.fallbackAssetUri}/${B}`}:null}function H(X,B){const re=X.properties?X.properties.filter(ce=>ce.key===B):[],ie=re.length>0&&re[0].value;return ie?ie.split(",").map(ce=>(0,g.adoptToGalleryExtensionId)(ce)):[]}function M(X){const B=X.properties?X.properties.filter(re=>re.key===l.Engine):[];return B.length>0&&B[0].value||""}function j(X){const B=X.properties?X.properties.filter(ie=>ie.key===l.LocalizedLanguages):[],re=B.length>0&&B[0].value||"";return re?re.split(","):[]}function q(X){return X.indexOf("preview")!==-1}function x(X){return X.targetPlatform?(0,C.toTargetPlatform)(X.targetPlatform):"undefined"}function $(X){const B=(0,D.distinct)(X.versions.map(x)),re=!!X.tags?.includes(C.WEB_EXTENSION_TAG),ie=B.indexOf("web");return re?ie===-1&&B.push("web"):ie!==-1&&B.splice(ie,1),B}function N(X,B){const re=(0,C.getFallbackTargetPlarforms)(B);for(let ie=0;ie<X.length;ie++){const ce=X[ie];if(ce.version===X[ie-1]?.version){let ue=ie;const ge=x(ce);if(ge===B)for(;ue>0&&X[ue-1].version===ce.version;)ue--;else if(re.includes(ge))for(;ue>0&&X[ue-1].version===ce.version&&x(X[ue-1])!==B;)ue--;ue!==ie&&(X.splice(ie,1),X.splice(ue,0,ce))}}return X}e.sortExtensionVersions=N;function W(X,B,re,ie,ce){const ue=$(X);let ge=X.versions[0];return ge=X.versions.find(de=>de.version===ge.version&&(0,C.isTargetPlatformCompatible)(x(de),ue,ce))||ge,_(X,ge,ue,B,re,ie)}function _(X,B,re,ie,ce,ue){const ge={manifest:z(B,c.Manifest),readme:z(B,c.Details),changelog:z(B,c.Changelog),license:z(B,c.License),repository:p(B),download:U(B),icon:F(B),coreTranslations:O(B)};return{identifier:{id:(0,g.getGalleryExtensionId)(X.publisher.publisherName,X.extensionName),uuid:X.extensionId},name:X.extensionName,version:B.version,displayName:X.displayName,publisherId:X.publisher.publisherId,publisher:X.publisher.publisherName,publisherDisplayName:X.publisher.displayName,description:X.shortDescription||"",installCount:A(X.statistics,"install"),rating:A(X.statistics,"averagerating"),ratingCount:A(X.statistics,"ratingcount"),categories:X.categories||[],tags:X.tags||[],releaseDate:Date.parse(X.releaseDate),lastUpdated:Date.parse(X.lastUpdated),allTargetPlatforms:re,assets:ge,properties:{dependencies:H(B,l.Dependency),extensionPack:H(B,l.ExtensionPack),engine:M(B),localizedLanguages:j(B),targetPlatform:x(B)},preview:q(X.flags),telemetryData:{index:(ce.pageNumber-1)*ce.pageSize+ie,querySource:ue}}}let Y=class{constructor(B,re,ie,ce,ue,ge,de,Ie){this.requestService=re,this.logService=ie,this.environmentService=ce,this.telemetryService=ue,this.fileService=ge,this.productService=de,this.configurationService=Ie;const Pe=de.extensionsGallery;this.extensionsGalleryUrl=Pe&&Pe.serviceUrl,this.extensionsControlUrl=Pe&&Pe.controlUrl,this.commonHeadersPromise=ee(de.version,de,this.environmentService,this.configurationService,this.fileService,B)}api(B=""){return`${this.extensionsGalleryUrl}${B}`}isEnabled(){return!!this.extensionsGalleryUrl}async getExtensions(B,re){const ie=[];let ce=new v().withFlags(r.IncludeAssetUri,r.IncludeStatistics,r.IncludeCategoryAndTags,r.IncludeFiles,r.IncludeVersionProperties).withPage(1,B.length).withFilter(s.Target,"Microsoft.VisualStudio.Code").withFilter(s.ExtensionName,...B.map(({id:ge})=>ge.toLowerCase()));B.every(ge=>!ge.version)&&(ce=ce.withFlags(r.IncludeAssetUri,r.IncludeStatistics,r.IncludeCategoryAndTags,r.IncludeFiles,r.IncludeVersionProperties,r.IncludeLatestVersionOnly));const{galleryExtensions:ue}=await this.queryGallery(ce,t,L.CancellationToken.None);for(let ge=0;ge<ue.length;ge++){const de=ue[ge];if(!de.versions.length)continue;const Ie=(0,g.getGalleryExtensionId)(de.publisher.publisherName,de.extensionName),Pe=B.find(Ee=>(0,g.areSameExtensions)(Ee,{id:Ie}))?.version;if(Pe){const Ee=de.versions.find(Oe=>Oe.version===Pe);Ee&&ie.push(_(de,Ee,$(de),ge,ce))}else ie.push(W(de,ge,ce,void 0,t))}return ie}async getCompatibleExtension(B,re){const ie=(0,C.isIExtensionIdentifier)(B)?null:B;if(ie){if((0,C.isNotWebExtensionInWebTargetPlatform)(ie.allTargetPlatforms,re))return null;if(await this.isExtensionCompatible(ie,re))return ie}const{id:ce,uuid:ue}=ie?ie.identifier:B;let ge=new v().withFlags(r.IncludeAssetUri,r.IncludeStatistics,r.IncludeCategoryAndTags,r.IncludeFiles,r.IncludeVersionProperties).withPage(1,1).withFilter(s.Target,"Microsoft.VisualStudio.Code");ue?ge=ge.withFilter(s.ExtensionId,ue):ge=ge.withFilter(s.ExtensionName,ce);const{galleryExtensions:de}=await this.queryGallery(ge,re,L.CancellationToken.None),[Ie]=de;if(!Ie||!Ie.versions.length)return null;const Pe=$(Ie);if((0,C.isNotWebExtensionInWebTargetPlatform)(Pe,re))return null;for(let Ee of Ie.versions){if(!M(Ee)){const Oe=await this.getEngine(Ee);Ee={...Ee,properties:[...Ee.properties||[],{key:l.Engine,value:Oe}]}}if(await this.isRawExtensionVersionCompatible(Ee,Pe,re))return _(Ie,Ee,Pe,0,ge)}return null}async isExtensionCompatible(B,re){if(!(0,C.isTargetPlatformCompatible)(B.properties.targetPlatform,B.allTargetPlatforms,re))return!1;let ie=B.properties.engine;if(!ie){const ce=await this.getManifest(B,L.CancellationToken.None);if(!ce)throw new Error("Manifest was not found");ie=ce.engines.vscode}return(0,w.isEngineValid)(ie,this.productService.version,this.productService.date)}async isRawExtensionVersionCompatible(B,re,ie){if(!(0,C.isTargetPlatformCompatible)(x(B),re,ie))return!1;const ce=await this.getEngine(B);return(0,w.isEngineValid)(ce,this.productService.version,this.productService.date)}async query(B,re){const ie=L.CancellationToken.isCancellationToken(B)?{}:B,ce=L.CancellationToken.isCancellationToken(B)?B:re;if(!this.isEnabled())throw new Error("No extension gallery service configured.");let ue=ie.text||"";const ge=(0,T.getOrDefault)(ie,Re=>Re.pageSize,50);let de=new v().withFlags(r.IncludeLatestVersionOnly,r.IncludeAssetUri,r.IncludeStatistics,r.IncludeCategoryAndTags,r.IncludeFiles,r.IncludeVersionProperties).withPage(1,ge).withFilter(s.Target,"Microsoft.VisualStudio.Code");ue?(ue=ue.replace(/\bcategory:("([^"]*)"|([^"]\S*))(\s+|\b|$)/g,(Re,Te,Ne)=>(de=de.withFilter(s.Category,Ne||Te),"")),ue=ue.replace(/\btag:("([^"]*)"|([^"]\S*))(\s+|\b|$)/g,(Re,Te,Ne)=>(de=de.withFilter(s.Tag,Ne||Te),"")),ue=ue.replace(/\bfeatured(\s+|\b|$)/g,()=>(de=de.withFilter(s.Featured),"")),ue=ue.trim(),ue&&(ue=ue.length<200?ue:ue.substring(0,200),de=de.withFilter(s.SearchText,ue)),de=de.withSortBy(0)):ie.ids?de=de.withFilter(s.ExtensionId,...ie.ids):ie.names?de=de.withFilter(s.ExtensionName,...ie.names):de=de.withSortBy(4),typeof ie.sortBy=="number"&&(de=de.withSortBy(ie.sortBy)),typeof ie.sortOrder=="number"&&(de=de.withSortOrder(ie.sortOrder));const{galleryExtensions:Ie,total:Pe}=await this.queryGallery(de,t,ce),Ee=Ie.map((Re,Te)=>W(Re,Te,de,ie.source,t)),Oe=async(Re,Te)=>{if(Te.isCancellationRequested)throw(0,R.canceled)();const Ne=de.withPage(Re+1),{galleryExtensions:_e}=await this.queryGallery(Ne,t,Te);return _e.map((ze,$e)=>W(ze,$e,Ne,ie.source,t))};return{firstPage:Ee,total:Pe,pageSize:de.pageSize,getPage:Oe}}async queryGallery(B,re,ie){if(!this.isEnabled())throw new Error("No extension gallery service configured.");B=B.withFlags(B.flags,r.ExcludeNonValidated).withFilter(s.ExcludeWithFlags,n(r.Unpublished));const ce=await this.commonHeadersPromise,ue=JSON.stringify(B.raw),ge={...ce,"Content-Type":"application/json",Accept:"application/json;api-version=3.0-preview.1","Accept-Encoding":"gzip","Content-Length":String(ue.length)},de=new Date().getTime();let Ie,Pe,Ee=0;try{if(Ie=await this.requestService.request({type:"POST",url:this.api("/extensionquery"),data:ue,headers:ge},ie),Ie.res.statusCode&&Ie.res.statusCode>=400&&Ie.res.statusCode<500)return{galleryExtensions:[],total:Ee};const Oe=await(0,I.asJson)(Ie);if(Oe){const Re=Oe.results[0],Te=Re.extensions;Te.forEach(_e=>N(_e.versions,re));const Ne=Re.resultMetadata&&Re.resultMetadata.filter(_e=>_e.metadataType==="ResultCount")[0];return Ee=Ne&&Ne.metadataItems.filter(_e=>_e.name==="TotalCount")[0].count||0,{galleryExtensions:Te,total:Ee}}return{galleryExtensions:[],total:Ee}}catch(Oe){throw Pe=Oe,Oe}finally{this.telemetryService.publicLog2("galleryService:query",{...B.telemetryData,requestBodySize:String(ue.length),duration:new Date().getTime()-de,success:!!Ie&&(0,I.isSuccess)(Ie),responseBodySize:Ie?.res.headers["Content-Length"],statusCode:Ie?String(Ie.res.statusCode):void 0,errorCode:Pe?(0,R.isPromiseCanceledError)(Pe)?"canceled":(0,R.getErrorMessage)(Pe).startsWith("XHR timeout")?"timeout":"failed":void 0,count:String(Ee)})}}async reportStatistic(B,re,ie,ce){if(!this.isEnabled())return;const ue=k.isWeb?this.api(`/itemName/${B}.${re}/version/${ie}/statType/${ce==="install"?"1":"3"}/vscodewebextension`):this.api(`/publishers/${B}/extensions/${re}/${ie}/stats?statType=${ce}`),ge=k.isWeb?"api-version=6.1-preview.1":"*/*;api-version=4.0-preview.1",Ie={...await this.commonHeadersPromise,Accept:ge};try{await this.requestService.request({type:"POST",url:ue,headers:Ie},L.CancellationToken.None)}catch(Pe){}}async download(B,re,ie){this.logService.trace("ExtensionGalleryService#download",B.identifier.id);const ce=(0,g.getGalleryExtensionTelemetryData)(B),ue=new Date().getTime(),ge=Ee=>this.telemetryService.publicLog("galleryService:downloadVSIX",{...ce,duration:Ee}),de=ie===1?"install":ie===2?"update":"",Ie=de?{uri:`${B.assets.download.uri}${m.URI.parse(B.assets.download.uri).query?"&":"?"}${de}=true`,fallbackUri:`${B.assets.download.fallbackUri}${m.URI.parse(B.assets.download.fallbackUri).query?"&":"?"}${de}=true`}:B.assets.download,Pe=await this.getAsset(Ie);await this.fileService.writeFile(re,Pe.stream),ge(new Date().getTime()-ue)}async getReadme(B,re){if(B.assets.readme){const ie=await this.getAsset(B.assets.readme,{},re);return await(0,I.asText)(ie)||""}return""}async getManifest(B,re){if(B.assets.manifest){const ie=await this.getAsset(B.assets.manifest,{},re),ce=await(0,I.asText)(ie);return ce?JSON.parse(ce):null}return null}async getManifestFromRawExtensionVersion(B,re){const ie=z(B,c.Manifest);if(!ie)throw new Error("Manifest was not found");const ce={"Accept-Encoding":"gzip"},ue=await this.getAsset(ie,{headers:ce});return await(0,I.asJson)(ue)}async getCoreTranslation(B,re){const ie=B.assets.coreTranslations.filter(ce=>ce[0]===re.toUpperCase())[0];if(ie){const ce=await this.getAsset(ie[1]),ue=await(0,I.asText)(ce);return ue?JSON.parse(ue):null}return null}async getChangelog(B,re){if(B.assets.changelog){const ie=await this.getAsset(B.assets.changelog,{},re);return await(0,I.asText)(ie)||""}return""}async getAllCompatibleVersions(B,re){let ie=new v().withFlags(r.IncludeVersions,r.IncludeCategoryAndTags,r.IncludeFiles,r.IncludeVersionProperties).withPage(1,1).withFilter(s.Target,"Microsoft.VisualStudio.Code");B.identifier.uuid?ie=ie.withFilter(s.ExtensionId,B.identifier.uuid):ie=ie.withFilter(s.ExtensionName,B.identifier.id);const{galleryExtensions:ce}=await this.queryGallery(ie,re,L.CancellationToken.None);if(!ce.length)return[];const ue=$(ce[0]);if((0,C.isNotWebExtensionInWebTargetPlatform)(ue,re))return[];const ge=[];for(const de of ce[0].versions)try{ge[ge.length-1]?.version!==de.version&&await this.isRawExtensionVersionCompatible(de,ue,re)&&ge.push({version:de.version,date:de.lastUpdated})}catch(Ie){}return ge}async getAsset(B,re={},ie=L.CancellationToken.None){const ce=await this.commonHeadersPromise,ue={type:"GET"},ge={...ce,...re.headers||{}};re={...re,...ue,headers:ge};const de=B.uri,Ie=B.fallbackUri,Pe={...re,url:de};try{const Ee=await this.requestService.request(Pe,ie);if(Ee.res.statusCode===200)return Ee;const Oe=await(0,I.asText)(Ee);throw new Error(`Expected 200, got back ${Ee.res.statusCode} instead.

${Oe}`)}catch(Ee){if((0,R.isPromiseCanceledError)(Ee))throw Ee;const Oe=(0,R.getErrorMessage)(Ee);this.telemetryService.publicLog2("galleryService:cdnFallback",{url:de,message:Oe});const Re={...re,url:Ie};return this.requestService.request(Re,ie)}}async getEngine(B){let re=M(B);if(!re){const ie=await this.getManifestFromRawExtensionVersion(B,L.CancellationToken.None);if(!ie)throw new Error("Manifest was not found");re=ie.engines.vscode}return re}async getExtensionsReport(){if(!this.isEnabled())throw new Error("No extension gallery service configured.");if(!this.extensionsControlUrl)return[];const B=await this.requestService.request({type:"GET",url:this.extensionsControlUrl},L.CancellationToken.None);if(B.res.statusCode!==200)throw new Error("Could not get extensions report.");const re=await(0,I.asJson)(B),ie=new Map;if(re)for(const ce of re.malicious){const ue=ie.get(ce)||{id:{id:ce},malicious:!0,slow:!1};ue.malicious=!0,ie.set(ce,ue)}return[...ie.values()]}};Y=fe([J(1,I.IRequestService),J(2,S.ILogService),J(3,i.IEnvironmentService),J(4,o.ITelemetryService),J(5,u.IFileService),J(6,f.IProductService),J(7,b.IConfigurationService)],Y);let G=class extends Y{constructor(B,re,ie,ce,ue,ge,de,Ie){super(B,re,ie,ce,ue,ge,de,Ie)}};G=fe([J(0,E.IStorageService),J(1,I.IRequestService),J(2,S.ILogService),J(3,i.IEnvironmentService),J(4,o.ITelemetryService),J(5,u.IFileService),J(6,f.IProductService),J(7,b.IConfigurationService)],G),e.ExtensionGalleryService=G;let ne=class extends Y{constructor(B,re,ie,ce,ue,ge,de){super(void 0,B,re,ie,ce,ue,ge,de)}};ne=fe([J(0,I.IRequestService),J(1,S.ILogService),J(2,i.IEnvironmentService),J(3,o.ITelemetryService),J(4,u.IFileService),J(5,f.IProductService),J(6,b.IConfigurationService)],ne),e.ExtensionGalleryServiceWithNoStorageService=ne;async function ee(X,B,re,ie,ce,ue){const ge={"X-Market-Client-Id":`VSCode ${X}`,"User-Agent":`VSCode ${X}`},de=await(0,y.getServiceMachineId)(re,ce,ue);return(0,a.supportsTelemetry)(B,re)&&(0,a.getTelemetryLevel)(ie)===3&&(ge["X-Market-User-Id"]=de),ge}e.resolveMarketplaceHeaders=ee}),define(Z[84],te([0,1,2,12,13,46]),function(K,e,D,L,R,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TelemetryLogAppender=void 0;let k=class extends D.Disposable{constructor(m,b,i=""){super();this.prefix=i;const C=m.getLogger(b.telemetryLogResource);C?this.logger=this._register(C):(this.logger=this._register(m.createLogger(b.telemetryLogResource)),this.logger.info("The below are logs for every telemetry event sent from VS Code once the log level is set to trace."),this.logger.info("==========================================================="))}flush(){return Promise.resolve(void 0)}log(m,b){this.logger.trace(`${this.prefix}telemetry/${m}`,(0,T.validateTelemetryData)(b))}};k=fe([J(0,R.ILoggerService),J(1,L.IEnvironmentService)],k),e.TelemetryLogAppender=k}),define(Z[85],te([0,1,2,26,4,24,128,21,39,42,33,20,46]),function(K,e,D,L,R,T,k,P,m,b,i,C,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TelemetryService=void 0;let w=class{constructor(f,I){this._configurationService=I,this._experimentProperties={},this._disposables=new D.DisposableStore,this._cleanupPatterns=[],this._appenders=f.appenders,this._commonProperties=f.commonProperties||Promise.resolve({}),this._piiPaths=f.piiPaths||[],this._telemetryLevel=3,this.sendErrorTelemetry=!!f.sendErrorTelemetry,this._cleanupPatterns=[/file:\/\/\/.*?\/resources\/app\//gi];for(let y of this._piiPaths)this._cleanupPatterns.push(new RegExp((0,T.escapeRegExpCharacters)(y),"gi"));this._updateTelemetryLevel(),this._configurationService.onDidChangeConfiguration(this._updateTelemetryLevel,this,this._disposables),this.publicLog2("optInStatus",{optIn:this._telemetryLevel===3}),this._commonProperties.then(y=>{const E=/^[a-f0-9]+$/i.test(y["common.machineId"]);this.publicLog2("machineIdFallback",{usingFallbackGuid:!E})})}setExperimentProperty(f,I){this._experimentProperties[f]=I}_updateTelemetryLevel(){this._telemetryLevel=(0,g.getTelemetryLevel)(this._configurationService)}get telemetryLevel(){return this._telemetryLevel}async getTelemetryInfo(){const f=await this._commonProperties;let I=f.sessionID,y=f["common.instanceId"],E=f["common.machineId"],o=f["common.firstSessionDate"],a=f["common.msftInternal"];return{sessionId:I,instanceId:y,machineId:E,firstSessionDate:o,msftInternal:a}}dispose(){this._disposables.dispose()}_log(f,I,y,E){return this.telemetryLevel<I?Promise.resolve(void 0):this._commonProperties.then(o=>{y=(0,L.mixin)(y,o),y=(0,L.mixin)(y,this._experimentProperties),y=(0,L.cloneAndChange)(y,a=>{if(typeof a=="string")return this._cleanupInfo(a,E)}),this._appenders.forEach(a=>a.log(f,y))},o=>{console.error(o)})}publicLog(f,I,y){return this._log(f,3,I,y)}publicLog2(f,I,y){return this.publicLog(f,I,y)}publicLogError(f,I){return this.sendErrorTelemetry?this._log(f,2,I,!0):Promise.resolve(void 0)}publicLogError2(f,I){return this.publicLogError(f,I)}_anonymizeFilePaths(f){let I=f;const y=[];for(let t of this._cleanupPatterns)for(;;){const r=t.exec(f);if(!r)break;y.push([r.index,t.lastIndex])}const E=/^[\\\/]?(node_modules|node_modules\.asar)[\\\/]/,o=/(file:\/\/)?([a-zA-Z]:(\\\\|\\|\/)|(\\\\|\\|\/))?([\w-\._]+(\\\\|\\|\/))+[\w-\._]*/g;let a=0;for(I="";;){const t=o.exec(f);if(!t)break;!E.test(t[0])&&y.every(([r,n])=>t.index<r||t.index>=n)&&(I+=f.substring(a,t.index)+"<REDACTED: user-file-path>",a=o.lastIndex)}return a<f.length&&(I+=f.substr(a)),I}_removePropertiesWithPossibleUserInfo(f){if(!f)return f;const I=f.toLowerCase(),y=/@[a-zA-Z0-9-.]+/;return/\S*(key|token|sig|password|passwd|pwd)[="':\s]+\S*/.test(I)?"<REDACTED: secret>":y.test(I)?"<REDACTED: email>":f}_cleanupInfo(f,I){let y=f;I&&(y=this._anonymizeFilePaths(y));for(let E of this._cleanupPatterns)y=y.replace(E,"");return y=this._removePropertiesWithPossibleUserInfo(y),y}};w.IDLE_START_EVENT_NAME="UserIdleStart",w.IDLE_STOP_EVENT_NAME="UserIdleStop",w=fe([J(1,P.IConfigurationService)],w),e.TelemetryService=w;const u=R.isWeb?"":" "+(0,k.localize)(0,null);i.Registry.as(m.Extensions.Configuration).registerConfiguration({id:C.TELEMETRY_SECTION_ID,order:110,type:"object",title:(0,k.localize)(1,null),properties:{[C.TELEMETRY_SETTING_ID]:{type:"string",enum:["on","error","off"],enumDescriptions:[(0,k.localize)(2,null),(0,k.localize)(3,null),(0,k.localize)(4,null)],markdownDescription:b.default.privacyStatementUrl?(0,k.localize)(6,null,b.default.nameLong,b.default.privacyStatementUrl)+u:(0,k.localize)(5,null,b.default.nameLong)+u,default:"on",restricted:!0,scope:1,tags:["usesOnlineServices","telemetry"]}}}),i.Registry.as(m.Extensions.Configuration).registerConfiguration({id:C.TELEMETRY_SECTION_ID,order:110,type:"object",title:(0,k.localize)(7,null),properties:{[C.TELEMETRY_OLD_SETTING_ID]:{type:"boolean",markdownDescription:b.default.privacyStatementUrl?(0,k.localize)(9,null,b.default.nameLong,b.default.privacyStatementUrl):(0,k.localize)(8,null,b.default.nameLong),default:!0,restricted:!0,markdownDeprecationMessage:(0,k.localize)(10,null,`\`#${C.TELEMETRY_SETTING_ID}#\``),scope:1,tags:["usesOnlineServices","telemetry"]}}})}),define(Z[189],te([0,1,9,26,46]),function(K,e,D,L,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.AppInsightsAppender=void 0;async function T(P){const m=await new Promise((i,C)=>{K(["applicationinsights"],i,C)});let b;return m.defaultClient?(b=new m.TelemetryClient(P),b.channel.setUseDiskRetryCaching(!0)):(m.setup(P).setAutoCollectRequests(!1).setAutoCollectPerformance(!1).setAutoCollectExceptions(!1).setAutoCollectDependencies(!1).setAutoDependencyCorrelation(!1).setAutoCollectConsole(!1).setInternalLogging(!1,!1).setUseDiskRetryCaching(!0).start(),b=m.defaultClient),P.indexOf("AIF-")===0&&(b.config.endpointUrl="https://vortex.data.microsoft.com/collect/v1"),b}class k{constructor(m,b,i){this._eventPrefix=m,this._defaultData=b,this._defaultData||(this._defaultData=Object.create(null)),typeof i=="function"?this._aiClient=i():this._aiClient=i,this._asyncAIClient=null}_withAIClient(m){if(!!this._aiClient){if(typeof this._aiClient!="string"){m(this._aiClient);return}this._asyncAIClient||(this._asyncAIClient=T(this._aiClient)),this._asyncAIClient.then(b=>{m(b)},b=>{(0,D.onUnexpectedError)(b),console.error(b)})}}log(m,b){!this._aiClient||(b=(0,L.mixin)(b,this._defaultData),b=(0,R.validateTelemetryData)(b),this._withAIClient(i=>i.trackEvent({name:this._eventPrefix+"/"+m,properties:b.properties,measurements:b.measurements})))}flush(){return this._aiClient?new Promise(m=>{this._withAIClient(b=>{b.flush({callback:()=>{this._aiClient=void 0,m(void 0)}})})}):Promise.resolve(void 0)}}e.AppInsightsAppender=k}),define(Z[190],te([0,1,15,52,21,12,13,20,83,84,85]),function(K,e,D,L,R,T,k,P,m,b,i){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.CustomEndpointTelemetryService=void 0;let C=class{constructor(w,u,S,f){this.configurationService=w,this.telemetryService=u,this.loggerService=S,this.environmentService=f,this.customTelemetryServices=new Map}async getCustomTelemetryService(w){if(!this.customTelemetryServices.has(w.id)){const{machineId:u,sessionId:S}=await this.telemetryService.getTelemetryInfo(),f=Object.create(null);f["common.vscodemachineid"]=u,f["common.vscodesessionid"]=S;const I=[w.id,JSON.stringify(f),w.aiKey],E=new L.Client(D.FileAccess.asFileUri("bootstrap-fork",K).fsPath,{serverName:"Debug Telemetry",timeout:1e3*60*5,args:I,env:{ELECTRON_RUN_AS_NODE:1,VSCODE_PIPE_LOGGING:"true",VSCODE_AMD_ENTRYPOINT:"vs/workbench/contrib/debug/node/telemetryApp"}}).getChannel("telemetryAppender"),o=[new m.TelemetryAppenderClient(E),new b.TelemetryLogAppender(this.loggerService,this.environmentService,`[${w.id}] `)];this.customTelemetryServices.set(w.id,new i.TelemetryService({appenders:o,sendErrorTelemetry:w.sendErrorTelemetry},this.configurationService))}return this.customTelemetryServices.get(w.id)}async publicLog(w,u,S){await(await this.getCustomTelemetryService(w)).publicLog(u,S)}async publicLogError(w,u,S){await(await this.getCustomTelemetryService(w)).publicLogError(u,S)}};C=fe([J(0,R.IConfigurationService),J(1,P.ITelemetryService),J(2,k.ILoggerService),J(3,T.IEnvironmentService)],C),e.CustomEndpointTelemetryService=C}),define(Z[191],te([0,1,6,27,3,2,13]),function(K,e,D,L,R,T,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.RequestStore=void 0;let P=class extends T.Disposable{constructor(b,i){super();this._logService=i,this._lastRequestId=0,this._pendingRequests=new Map,this._pendingRequestDisposables=new Map,this._onCreateRequest=this._register(new R.Emitter),this.onCreateRequest=this._onCreateRequest.event,this._timeout=b===void 0?15e3:b}createRequest(b){return new Promise((i,C)=>{const g=++this._lastRequestId;this._pendingRequests.set(g,i),this._onCreateRequest.fire({requestId:g,...b});const w=new L.CancellationTokenSource;(0,D.timeout)(this._timeout,w.token).then(()=>C(`Request ${g} timed out (${this._timeout}ms)`)),this._pendingRequestDisposables.set(g,[(0,T.toDisposable)(()=>w.cancel())])})}acceptReply(b,i){const C=this._pendingRequests.get(b);C?(this._pendingRequests.delete(b),(0,T.dispose)(this._pendingRequestDisposables.get(b)||[]),this._pendingRequestDisposables.delete(b),C(i)):this._logService.warn(`RequestStore#acceptReply was called without receiving a matching request ${b}`)}};P=fe([J(1,k.ILogService)],P),e.RequestStore=P}),define(Z[86],te([0,1,7]),function(K,e,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ProfileSource=e.FlowControlConstants=e.LocalReconnectConstants=e.ProcessCapability=e.TerminalLocationString=e.TerminalLocation=e.HeartbeatConstants=e.ProcessPropertyType=e.IPtyService=e.TerminalIpcChannels=e.TitleEventSource=e.WindowsShellType=e.TerminalSettingId=e.TerminalSettingPrefix=void 0;var L;(function(f){f.Shell="terminal.integrated.shell.",f.ShellArgs="terminal.integrated.shellArgs.",f.DefaultProfile="terminal.integrated.defaultProfile.",f.Profiles="terminal.integrated.profiles."})(L=e.TerminalSettingPrefix||(e.TerminalSettingPrefix={}));var R;(function(f){f.ShellLinux="terminal.integrated.shell.linux",f.ShellMacOs="terminal.integrated.shell.osx",f.ShellWindows="terminal.integrated.shell.windows",f.SendKeybindingsToShell="terminal.integrated.sendKeybindingsToShell",f.AutomationShellLinux="terminal.integrated.automationShell.linux",f.AutomationShellMacOs="terminal.integrated.automationShell.osx",f.AutomationShellWindows="terminal.integrated.automationShell.windows",f.ShellArgsLinux="terminal.integrated.shellArgs.linux",f.ShellArgsMacOs="terminal.integrated.shellArgs.osx",f.ShellArgsWindows="terminal.integrated.shellArgs.windows",f.ProfilesWindows="terminal.integrated.profiles.windows",f.ProfilesMacOs="terminal.integrated.profiles.osx",f.ProfilesLinux="terminal.integrated.profiles.linux",f.DefaultProfileLinux="terminal.integrated.defaultProfile.linux",f.DefaultProfileMacOs="terminal.integrated.defaultProfile.osx",f.DefaultProfileWindows="terminal.integrated.defaultProfile.windows",f.UseWslProfiles="terminal.integrated.useWslProfiles",f.TabsEnabled="terminal.integrated.tabs.enabled",f.TabsEnableAnimation="terminal.integrated.tabs.enableAnimation",f.TabsHideCondition="terminal.integrated.tabs.hideCondition",f.TabsShowActiveTerminal="terminal.integrated.tabs.showActiveTerminal",f.TabsShowActions="terminal.integrated.tabs.showActions",f.TabsLocation="terminal.integrated.tabs.location",f.TabsFocusMode="terminal.integrated.tabs.focusMode",f.MacOptionIsMeta="terminal.integrated.macOptionIsMeta",f.MacOptionClickForcesSelection="terminal.integrated.macOptionClickForcesSelection",f.AltClickMovesCursor="terminal.integrated.altClickMovesCursor",f.CopyOnSelection="terminal.integrated.copyOnSelection",f.DrawBoldTextInBrightColors="terminal.integrated.drawBoldTextInBrightColors",f.FontFamily="terminal.integrated.fontFamily",f.FontSize="terminal.integrated.fontSize",f.LetterSpacing="terminal.integrated.letterSpacing",f.LineHeight="terminal.integrated.lineHeight",f.MinimumContrastRatio="terminal.integrated.minimumContrastRatio",f.FastScrollSensitivity="terminal.integrated.fastScrollSensitivity",f.MouseWheelScrollSensitivity="terminal.integrated.mouseWheelScrollSensitivity",f.BellDuration="terminal.integrated.bellDuration",f.FontWeight="terminal.integrated.fontWeight",f.FontWeightBold="terminal.integrated.fontWeightBold",f.CursorBlinking="terminal.integrated.cursorBlinking",f.CursorStyle="terminal.integrated.cursorStyle",f.CursorWidth="terminal.integrated.cursorWidth",f.Scrollback="terminal.integrated.scrollback",f.DetectLocale="terminal.integrated.detectLocale",f.DefaultLocation="terminal.integrated.defaultLocation",f.GpuAcceleration="terminal.integrated.gpuAcceleration",f.TerminalTitleSeparator="terminal.integrated.tabs.separator",f.TerminalTitle="terminal.integrated.tabs.title",f.TerminalDescription="terminal.integrated.tabs.description",f.RightClickBehavior="terminal.integrated.rightClickBehavior",f.Cwd="terminal.integrated.cwd",f.ConfirmOnExit="terminal.integrated.confirmOnExit",f.ConfirmOnKill="terminal.integrated.confirmOnKill",f.EnableBell="terminal.integrated.enableBell",f.CommandsToSkipShell="terminal.integrated.commandsToSkipShell",f.AllowChords="terminal.integrated.allowChords",f.AllowMnemonics="terminal.integrated.allowMnemonics",f.EnvMacOs="terminal.integrated.env.osx",f.EnvLinux="terminal.integrated.env.linux",f.EnvWindows="terminal.integrated.env.windows",f.EnvironmentChangesIndicator="terminal.integrated.environmentChangesIndicator",f.EnvironmentChangesRelaunch="terminal.integrated.environmentChangesRelaunch",f.ShowExitAlert="terminal.integrated.showExitAlert",f.SplitCwd="terminal.integrated.splitCwd",f.WindowsEnableConpty="terminal.integrated.windowsEnableConpty",f.WordSeparators="terminal.integrated.wordSeparators",f.EnableFileLinks="terminal.integrated.enableFileLinks",f.UnicodeVersion="terminal.integrated.unicodeVersion",f.ExperimentalLinkProvider="terminal.integrated.experimentalLinkProvider",f.LocalEchoLatencyThreshold="terminal.integrated.localEchoLatencyThreshold",f.LocalEchoExcludePrograms="terminal.integrated.localEchoExcludePrograms",f.LocalEchoStyle="terminal.integrated.localEchoStyle",f.EnablePersistentSessions="terminal.integrated.enablePersistentSessions",f.PersistentSessionReviveProcess="terminal.integrated.persistentSessionReviveProcess",f.CustomGlyphs="terminal.integrated.customGlyphs",f.PersistentSessionScrollback="terminal.integrated.persistentSessionScrollback",f.InheritEnv="terminal.integrated.inheritEnv",f.ShowLinkHover="terminal.integrated.showLinkHover"})(R=e.TerminalSettingId||(e.TerminalSettingId={}));var T;(function(f){f.CommandPrompt="cmd",f.PowerShell="pwsh",f.Wsl="wsl",f.GitBash="gitbash"})(T=e.WindowsShellType||(e.WindowsShellType={}));var k;(function(f){f[f.Api=0]="Api",f[f.Process=1]="Process",f[f.Sequence=2]="Sequence",f[f.Config=3]="Config"})(k=e.TitleEventSource||(e.TitleEventSource={}));var P;(function(f){f.LocalPty="localPty",f.PtyHost="ptyHost",f.Log="log",f.Heartbeat="heartbeat"})(P=e.TerminalIpcChannels||(e.TerminalIpcChannels={})),e.IPtyService=(0,D.createDecorator)("ptyService");var m;(function(f){f.Cwd="cwd",f.InitialCwd="initialCwd"})(m=e.ProcessPropertyType||(e.ProcessPropertyType={}));var b;(function(f){f[f.BeatInterval=5e3]="BeatInterval",f[f.FirstWaitMultiplier=1.2]="FirstWaitMultiplier",f[f.SecondWaitMultiplier=1]="SecondWaitMultiplier",f[f.CreateProcessTimeout=5e3]="CreateProcessTimeout"})(b=e.HeartbeatConstants||(e.HeartbeatConstants={}));var i;(function(f){f[f.Panel=1]="Panel",f[f.Editor=2]="Editor"})(i=e.TerminalLocation||(e.TerminalLocation={}));var C;(function(f){f.TerminalView="view",f.Editor="editor"})(C=e.TerminalLocationString||(e.TerminalLocationString={}));var g;(function(f){f.CwdDetection="cwdDetection"})(g=e.ProcessCapability||(e.ProcessCapability={}));var w;(function(f){f[f.GraceTime=6e4]="GraceTime",f[f.ShortGraceTime=6e3]="ShortGraceTime"})(w=e.LocalReconnectConstants||(e.LocalReconnectConstants={}));var u;(function(f){f[f.HighWatermarkChars=1e5]="HighWatermarkChars",f[f.LowWatermarkChars=5e3]="LowWatermarkChars",f[f.CharCountAckSize=5e3]="CharCountAckSize"})(u=e.FlowControlConstants||(e.FlowControlConstants={}));var S;(function(f){f.GitBash="Git Bash",f.Pwsh="PowerShell"})(S=e.ProfileSource||(e.ProfileSource={}))}),define(Z[192],te([0,1,7]),function(K,e,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ILocalPtyService=void 0,e.ILocalPtyService=(0,D.createDecorator)("localPtyService")}),define(Z[193],te([0,1,35,26,8,4,31,18,19]),function(K,e,D,L,R,T,k,P,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.findExecutable=e.getWindowsBuildNumber=void 0;function b(){const C=/(\d+)\.(\d+)\.(\d+)/g.exec(D.release());let g=0;return C&&C.length===4&&(g=parseInt(C[3])),g}e.getWindowsBuildNumber=b;async function i(C,g,w,u=k.env,S=m.Promises.exists){if(R.isAbsolute(C))return await S(C)?C:void 0;if(g===void 0&&(g=k.cwd()),R.dirname(C)!=="."){const E=R.join(g,C);return await S(E)?E:void 0}const I=(0,L.getCaseInsensitive)(u,"PATH");if(w===void 0&&(0,P.isString)(I)&&(w=I.split(R.delimiter)),w===void 0||w.length===0){const E=R.join(g,C);return await S(E)?E:void 0}for(let E of w){let o;if(R.isAbsolute(E)?o=R.join(E,C):o=R.join(g,E,C),await S(o))return o;if(T.isWindows){let a=o+".com";if(await S(a)||(a=o+".exe",await S(a)))return a}}const y=R.join(g,C);return await S(y)?y:void 0}e.findExecutable=i}),define(Z[194],te([0,1]),function(K,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ColorScheme=void 0;var D;(function(L){L.DARK="dark",L.LIGHT="light",L.HIGH_CONTRAST="hc"})(D=e.ColorScheme||(e.ColorScheme={}))}),define(Z[87],te([0,1,49,3,2,7,33,194]),function(K,e,D,L,R,T,k,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Themable=e.registerThemingParticipant=e.Extensions=e.getThemeTypeSelector=e.FolderThemeIcon=e.FileThemeIcon=e.ThemeIcon=e.themeColorFromId=e.ThemeColor=e.IThemeService=void 0,e.IThemeService=(0,T.createDecorator)("themeService");var m;(function(f){function I(y){return y&&typeof y=="object"&&typeof y.id=="string"}f.isThemeColor=I})(m=e.ThemeColor||(e.ThemeColor={}));function b(f){return{id:f}}e.themeColorFromId=b;var i;(function(f){function I(r){return r&&typeof r=="object"&&typeof r.id=="string"&&(typeof r.color=="undefined"||m.isThemeColor(r.color))}f.isThemeIcon=I;const y=new RegExp(`^\\$\\((${D.CSSIcon.iconNameExpression}(?:${D.CSSIcon.iconModifierExpression})?)\\)$`);function E(r){const n=y.exec(r);if(!n)return;let[,s]=n;return{id:s}}f.fromString=E;function o(r,n){let s=r.id;const c=s.lastIndexOf("~");return c!==-1&&(s=s.substring(0,c)),n&&(s=`${s}~${n}`),{id:s}}f.modify=o;function a(r,n){return r.id===n.id&&r.color?.id===n.color?.id}f.isEqual=a;function t(r,n){return{id:r.id,color:n?b(n):void 0}}f.asThemeIcon=t,f.asClassNameArray=D.CSSIcon.asClassNameArray,f.asClassName=D.CSSIcon.asClassName,f.asCSSSelector=D.CSSIcon.asCSSSelector})(i=e.ThemeIcon||(e.ThemeIcon={})),e.FileThemeIcon=D.Codicon.file,e.FolderThemeIcon=D.Codicon.folder;function C(f){switch(f){case P.ColorScheme.DARK:return"vs-dark";case P.ColorScheme.HIGH_CONTRAST:return"hc-black";default:return"vs"}}e.getThemeTypeSelector=C,e.Extensions={ThemingContribution:"base.contributions.theming"};class g{constructor(){this.themingParticipants=[],this.themingParticipants=[],this.onThemingParticipantAddedEmitter=new L.Emitter}onColorThemeChange(I){return this.themingParticipants.push(I),this.onThemingParticipantAddedEmitter.fire(I),(0,R.toDisposable)(()=>{const y=this.themingParticipants.indexOf(I);this.themingParticipants.splice(y,1)})}get onThemingParticipantAdded(){return this.onThemingParticipantAddedEmitter.event}getThemingParticipants(){return this.themingParticipants}}let w=new g;k.Registry.add(e.Extensions.ThemingContribution,w);function u(f){return w.onColorThemeChange(f)}e.registerThemingParticipant=u;class S extends R.Disposable{constructor(I){super();this.themeService=I,this.theme=I.getColorTheme(),this._register(this.themeService.onDidColorThemeChange(y=>this.onThemeChange(y)))}onThemeChange(I){this.theme=I,this.updateStyles()}updateStyles(){}getColor(I,y){let E=this.theme.getColor(I);return E&&y&&(E=y(E,this.theme)),E?E.toString():null}}e.Themable=S}),define(Z[195],te([0,1,49,87]),function(K,e,D,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.createProfileSchemaEnums=void 0;function R(P,m){const b=P.map(i=>({name:i.profileName,description:T(i)}));return m&&b.push(...m.map(i=>({name:i.title,description:k(i)}))),{values:b.map(i=>i.name),markdownDescriptions:b.map(i=>i.description)}}e.createProfileSchemaEnums=R;function T(P){let m=`$(${L.ThemeIcon.isThemeIcon(P.icon)?P.icon.id:P.icon?P.icon:D.Codicon.terminal.id}) ${P.profileName}
- path: ${P.path}`;return P.args&&(typeof P.args=="string"?m+=`
- args: "${P.args}"`:m+=`
- args: [${P.args.length===0?"":`'${P.args.join("','")}'`}]`),P.overrideName!==void 0&&(m+=`
- overrideName: ${P.overrideName}`),P.color&&(m+=`
- color: ${P.color}`),P.env&&(m+=`
- env: ${JSON.stringify(P.env)}`),m}function k(P){return`$(${L.ThemeIcon.isThemeIcon(P.icon)?P.icon.id:P.icon?P.icon:D.Codicon.terminal.id}) ${P.title}
- extensionIdenfifier: ${P.extensionIdentifier}`}}),define(Z[196],te([0,1,49,129,39,33,195]),function(K,e,D,L,R,T,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.registerTerminalDefaultProfileConfiguration=e.registerTerminalPlatformConfiguration=void 0;const P={args:{description:(0,L.localize)(0,null),type:"array",items:{type:"string"}},overrideName:{description:(0,L.localize)(1,null),type:"boolean"},icon:{description:(0,L.localize)(2,null),type:"string",enum:Array.from(D.iconRegistry.all,f=>f.id),markdownEnumDescriptions:Array.from(D.iconRegistry.all,f=>`$(${f.id})`)},color:{description:(0,L.localize)(3,null),type:["string","null"],enum:["terminal.ansiBlack","terminal.ansiRed","terminal.ansiGreen","terminal.ansiYellow","terminal.ansiBlue","terminal.ansiMagenta","terminal.ansiCyan","terminal.ansiWhite"],default:null},env:{markdownDescription:(0,L.localize)(4,null),type:"object",additionalProperties:{type:["string","null"]},default:{}}},m={type:"object",required:["path"],properties:{path:{description:(0,L.localize)(5,null),type:["string","array"],items:{type:"string"}},...P}},b=(0,L.localize)(6,null,"`#terminal.integrated.profiles.linux#`","`#terminal.integrated.defaultProfile.linux#`"),i=(0,L.localize)(7,null,"`#terminal.integrated.profiles.osx#`","`#terminal.integrated.defaultProfile.osx#`"),C=(0,L.localize)(8,null,"`#terminal.integrated.profiles.windows#`","`#terminal.integrated.defaultProfile.windows#`"),g={id:"terminal",order:100,title:(0,L.localize)(9,null),type:"object",properties:{["terminal.integrated.automationShell.linux"]:{restricted:!0,markdownDescription:(0,L.localize)(10,null,"`terminal.integrated.shell.linux`","`shellArgs`"),type:["string","null"],default:null},["terminal.integrated.automationShell.osx"]:{restricted:!0,markdownDescription:(0,L.localize)(11,null,"`terminal.integrated.shell.osx`","`shellArgs`"),type:["string","null"],default:null},["terminal.integrated.automationShell.windows"]:{restricted:!0,markdownDescription:(0,L.localize)(12,null,"`terminal.integrated.shell.windows`","`shellArgs`"),type:["string","null"],default:null},["terminal.integrated.shell.linux"]:{restricted:!0,markdownDescription:(0,L.localize)(13,null),type:["string","null"],default:null,markdownDeprecationMessage:b},["terminal.integrated.shell.osx"]:{restricted:!0,markdownDescription:(0,L.localize)(14,null),type:["string","null"],default:null,markdownDeprecationMessage:i},["terminal.integrated.shell.windows"]:{restricted:!0,markdownDescription:(0,L.localize)(15,null),type:["string","null"],default:null,markdownDeprecationMessage:C},["terminal.integrated.shellArgs.linux"]:{restricted:!0,markdownDescription:(0,L.localize)(16,null),type:"array",items:{type:"string"},default:[],markdownDeprecationMessage:b},["terminal.integrated.shellArgs.osx"]:{restricted:!0,markdownDescription:(0,L.localize)(17,null),type:"array",items:{type:"string"},default:["-l"],markdownDeprecationMessage:i},["terminal.integrated.shellArgs.windows"]:{restricted:!0,markdownDescription:(0,L.localize)(18,null),anyOf:[{type:"array",items:{type:"string",markdownDescription:(0,L.localize)(19,null)}},{type:"string",markdownDescription:(0,L.localize)(20,null)}],default:[],markdownDeprecationMessage:C},["terminal.integrated.profiles.windows"]:{restricted:!0,markdownDescription:(0,L.localize)(21,null,"`source`","`path`","`args`."),type:"object",default:{PowerShell:{source:"PowerShell",icon:"terminal-powershell"},"Command Prompt":{path:["${env:windir}\\Sysnative\\cmd.exe","${env:windir}\\System32\\cmd.exe"],args:[],icon:"terminal-cmd"},"Git Bash":{source:"Git Bash"}},additionalProperties:{anyOf:[{type:"object",required:["source"],properties:{source:{description:(0,L.localize)(22,null),enum:["PowerShell","Git Bash"]},...P}},{type:"object",required:["extensionIdentifier","id","title"],properties:{extensionIdentifier:{description:(0,L.localize)(23,null),type:"string"},id:{description:(0,L.localize)(24,null),type:"string"},title:{description:(0,L.localize)(25,null),type:"string"},...P}},{type:"null"},m]}},["terminal.integrated.profiles.osx"]:{restricted:!0,markdownDescription:(0,L.localize)(26,null,"`path`","`args`."),type:"object",default:{bash:{path:"bash",args:["-l"],icon:"terminal-bash"},zsh:{path:"zsh",args:["-l"]},fish:{path:"fish",args:["-l"]},tmux:{path:"tmux",icon:"terminal-tmux"},pwsh:{path:"pwsh",icon:"terminal-powershell"}},additionalProperties:{anyOf:[{type:"object",required:["extensionIdentifier","id","title"],properties:{extensionIdentifier:{description:(0,L.localize)(27,null),type:"string"},id:{description:(0,L.localize)(28,null),type:"string"},title:{description:(0,L.localize)(29,null),type:"string"},...P}},{type:"null"},m]}},["terminal.integrated.profiles.linux"]:{restricted:!0,markdownDescription:(0,L.localize)(30,null,"`path`","`args`."),type:"object",default:{bash:{path:"bash",icon:"terminal-bash"},zsh:{path:"zsh"},fish:{path:"fish"},tmux:{path:"tmux",icon:"terminal-tmux"},pwsh:{path:"pwsh",icon:"terminal-powershell"}},additionalProperties:{anyOf:[{type:"object",required:["extensionIdentifier","id","title"],properties:{extensionIdentifier:{description:(0,L.localize)(31,null),type:"string"},id:{description:(0,L.localize)(32,null),type:"string"},title:{description:(0,L.localize)(33,null),type:"string"},...P}},{type:"null"},m]}},["terminal.integrated.useWslProfiles"]:{description:(0,L.localize)(34,null),type:"boolean",default:!0},["terminal.integrated.inheritEnv"]:{scope:1,description:(0,L.localize)(35,null),type:"boolean",default:!0},["terminal.integrated.persistentSessionScrollback"]:{scope:1,markdownDescription:(0,L.localize)(36,null),type:"number",default:100},["terminal.integrated.showLinkHover"]:{scope:1,description:(0,L.localize)(37,null),type:"boolean",default:!0}}};function w(){T.Registry.as(R.Extensions.Configuration).registerConfiguration(g),S()}e.registerTerminalPlatformConfiguration=w;let u;function S(f,I){const y=T.Registry.as(R.Extensions.Configuration);let E;f&&(E=(0,k.createProfileSchemaEnums)(f?.profiles,I));const o=u;u={id:"terminal",order:100,title:(0,L.localize)(38,null),type:"object",properties:{["terminal.integrated.defaultProfile.linux"]:{restricted:!0,markdownDescription:(0,L.localize)(39,null,"`terminal.integrated.shell.linux`","`terminal.integrated.shellArgs.linux`"),type:["string","null"],default:null,enum:f?.os===3?E?.values:void 0,markdownEnumDescriptions:f?.os===3?E?.markdownDescriptions:void 0},["terminal.integrated.defaultProfile.osx"]:{restricted:!0,markdownDescription:(0,L.localize)(40,null,"`terminal.integrated.shell.osx`","`terminal.integrated.shellArgs.osx`"),type:["string","null"],default:null,enum:f?.os===2?E?.values:void 0,markdownEnumDescriptions:f?.os===2?E?.markdownDescriptions:void 0},["terminal.integrated.defaultProfile.windows"]:{restricted:!0,markdownDescription:(0,L.localize)(41,null,"`terminal.integrated.shell.windows`","`terminal.integrated.shellArgs.windows`"),type:["string","null"],default:null,enum:f?.os===1?E?.values:void 0,markdownEnumDescriptions:f?.os===1?E?.markdownDescriptions:void 0}}},y.updateConfigurations({add:[u],remove:o?[o]:[]})}e.registerTerminalDefaultProfileConfiguration=S}),define(Z[197],te([0,1,37,49,8,4,19,69,193,87]),function(K,e,D,L,R,T,k,P,m,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.detectAvailableProfiles=void 0;let i;function C(t,r,n,s,c=process.env,l,h,d,v){return l=l||{existsFile:k.SymlinkSupport.existsFile,readFile:k.Promises.readFile},T.isWindows?g(n,l,c,h,s.getValue("terminal.integrated.useWslProfiles")!==!1,t&&typeof t=="object"?{...t}:s.getValue("terminal.integrated.profiles.windows"),typeof r=="string"?r:s.getValue("terminal.integrated.defaultProfile.windows"),v,d):E(l,h,n,t&&typeof t=="object"?{...t}:s.getValue(T.isLinux?"terminal.integrated.profiles.linux":"terminal.integrated.profiles.osx"),typeof r=="string"?r:s.getValue(T.isLinux?"terminal.integrated.defaultProfile.linux":"terminal.integrated.defaultProfile.osx"),v,d,c)}e.detectAvailableProfiles=C;async function g(t,r,n,s,c,l,h,d,v){const A=process.env.hasOwnProperty("PROCESSOR_ARCHITEW6432"),O=`${process.env.windir}\\${A?"Sysnative":"System32"}`;let p=!1;(0,m.getWindowsBuildNumber)()>=16299&&(p=!0),await S(d);const U=new Map;t&&(U.set("PowerShell",{source:"PowerShell",icon:L.Codicon.terminalPowershell,isAutoDetected:!0}),U.set("Windows PowerShell",{path:`${O}\\WindowsPowerShell\\v1.0\\powershell.exe`,icon:L.Codicon.terminalPowershell,isAutoDetected:!0}),U.set("Git Bash",{source:"Git Bash",isAutoDetected:!0}),U.set("Cygwin",{path:[`${process.env.HOMEDRIVE}\\cygwin64\\bin\\bash.exe`,`${process.env.HOMEDRIVE}\\cygwin\\bin\\bash.exe`],args:["--login"],isAutoDetected:!0}),U.set("Command Prompt",{path:`${O}\\cmd.exe`,icon:L.Codicon.terminalCmd,isAutoDetected:!0})),o(l,U);const F=await w(U.entries(),h,r,n,s,v);if(t||!t&&c)try{const z=await I(`${O}\\${p?"wsl":"bash"}.exe`,h);for(const H of z)(!l||!(H.profileName in l))&&F.push(H)}catch(z){s?.info("WSL is not installed, so could not detect WSL profiles")}return F}async function w(t,r,n,s=process.env,c,l){const h=[];for(const[d,v]of t){if(v===null)continue;let A,O,p;if("source"in v){const z=i?.get(v.source);if(!z)continue;A=z.paths,O=v.args||z.args,v.icon?p=u(v.icon):z.icon&&(p=z.icon)}else A=Array.isArray(v.path)?v.path:[v.path],O=T.isWindows||Array.isArray(v.args)?v.args:void 0,p=u(v.icon)||void 0;const U=await l?.(A)||A.slice(),F=await a(d,r,U,n,s,O,v.env,v.overrideName,v.isAutoDetected,c);F?(F.isAutoDetected=v.isAutoDetected,F.icon=p,F.color=v.color,h.push(F)):c?.trace("profile not validated",d,A)}return h}function u(t){return typeof t=="string"?{id:t}:t}async function S(t){i&&!t||(i=new Map,i.set("Git Bash",{profileName:"Git Bash",paths:[`${process.env.ProgramW6432}\\Git\\bin\\bash.exe`,`${process.env.ProgramW6432}\\Git\\usr\\bin\\bash.exe`,`${process.env.ProgramFiles}\\Git\\bin\\bash.exe`,`${process.env.ProgramFiles}\\Git\\usr\\bin\\bash.exe`,`${process.env.LocalAppData}\\Programs\\Git\\bin\\bash.exe`,`${process.env.UserProfile}\\scoop\\apps\\git-with-openssh\\current\\bin\\bash.exe`,`${process.env.AllUsersProfile}\\scoop\\apps\\git-with-openssh\\current\\bin\\bash.exe`],args:["--login"]}),i.set("PowerShell",{profileName:"PowerShell",paths:t||await f(),icon:b.ThemeIcon.asThemeIcon(L.Codicon.terminalPowershell)}))}async function f(){const t=[];for await(const r of(0,P.enumeratePowerShellInstallations)())t.push(r.exePath);return t}async function I(t,r){const n=[],s=await new Promise((h,d)=>{D.exec("wsl.exe -l -q",{encoding:"utf16le"},(v,A)=>{if(v)return d("Problem occurred when getting wsl distros");h(A)})});if(!s)return[];const c=new RegExp(/[\r?\n]/),l=s.split(c).filter(h=>h.trim().length>0&&h!=="");for(const h of l){if(h===""||h.startsWith("docker-desktop"))continue;const d=`${h} (WSL)`,v={profileName:d,path:t,args:["-d",`${h}`],isDefault:d===r,icon:y(h)};n.push(v)}return n}function y(t){return t.includes("Ubuntu")?b.ThemeIcon.asThemeIcon(L.Codicon.terminalUbuntu):t.includes("Debian")?b.ThemeIcon.asThemeIcon(L.Codicon.terminalDebian):b.ThemeIcon.asThemeIcon(L.Codicon.terminalLinux)}async function E(t,r,n,s,c,l,h,d){const v=new Map;if(n){const A=(await t.readFile("/etc/shells")).toString(),O=l||A.split(`
`).filter(U=>U.trim().indexOf("#")!==0&&U.trim().length>0),p=new Map;for(const U of O){let F=(0,R.basename)(U),z=p.get(F)||0;z++,z>1&&(F=`${F} (${z})`),p.set(F,z),v.set(F,{path:U,isAutoDetected:!0})}}return o(s,v),await w(v.entries(),c,t,d,r,h)}function o(t,r){if(!!t)for(const[n,s]of Object.entries(t))s===null||!("path"in s)&&!("source"in s)?r.delete(n):r.set(n,s)}async function a(t,r,n,s,c,l,h,d,v,A){if(n.length===0)return Promise.resolve(void 0);const O=n.shift();if(O==="")return a(t,r,n,s,c,l,h,d,v);const p={profileName:t,path:O,args:l,env:h,overrideName:d,isAutoDetected:v,isDefault:t===r};if((0,R.basename)(O)===O){const F=c.PATH?c.PATH.split(R.delimiter):void 0;return await(0,m.findExecutable)(O,void 0,F,void 0,s.existsFile)?p:a(t,r,n,s,c,l)}return await s.existsFile((0,R.normalize)(O))?p:a(t,r,n,s,c,l,h,d,v)}}),define(Z[198],te([0,1,3,2,15,4,36,52,21,12,72,158,13,80,20,191,86,196,197]),function(K,e,D,L,R,T,k,P,m,b,i,C,g,w,u,S,f,I,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.PtyHostService=void 0;var E;(function(t){t[t.MaxRestarts=5]="MaxRestarts"})(E||(E={}));let o=0,a=class extends L.Disposable{constructor(r,n,s,c,l){super();this._reconnectConstants=r,this._configurationService=n,this._environmentService=s,this._logService=c,this._telemetryService=l,this._restartCount=0,this._isResponsive=!0,this._isDisposed=!1,this._onPtyHostExit=this._register(new D.Emitter),this.onPtyHostExit=this._onPtyHostExit.event,this._onPtyHostStart=this._register(new D.Emitter),this.onPtyHostStart=this._onPtyHostStart.event,this._onPtyHostUnresponsive=this._register(new D.Emitter),this.onPtyHostUnresponsive=this._onPtyHostUnresponsive.event,this._onPtyHostResponsive=this._register(new D.Emitter),this.onPtyHostResponsive=this._onPtyHostResponsive.event,this._onPtyHostRequestResolveVariables=this._register(new D.Emitter),this.onPtyHostRequestResolveVariables=this._onPtyHostRequestResolveVariables.event,this._onProcessData=this._register(new D.Emitter),this.onProcessData=this._onProcessData.event,this._onProcessExit=this._register(new D.Emitter),this.onProcessExit=this._onProcessExit.event,this._onProcessReady=this._register(new D.Emitter),this.onProcessReady=this._onProcessReady.event,this._onProcessReplay=this._register(new D.Emitter),this.onProcessReplay=this._onProcessReplay.event,this._onProcessTitleChanged=this._register(new D.Emitter),this.onProcessTitleChanged=this._onProcessTitleChanged.event,this._onProcessShellTypeChanged=this._register(new D.Emitter),this.onProcessShellTypeChanged=this._onProcessShellTypeChanged.event,this._onProcessOverrideDimensions=this._register(new D.Emitter),this.onProcessOverrideDimensions=this._onProcessOverrideDimensions.event,this._onProcessResolvedShellLaunchConfig=this._register(new D.Emitter),this.onProcessResolvedShellLaunchConfig=this._onProcessResolvedShellLaunchConfig.event,this._onProcessOrphanQuestion=this._register(new D.Emitter),this.onProcessOrphanQuestion=this._onProcessOrphanQuestion.event,this._onDidRequestDetach=this._register(new D.Emitter),this.onDidRequestDetach=this._onDidRequestDetach.event,this._onProcessDidChangeHasChildProcesses=this._register(new D.Emitter),this.onProcessDidChangeHasChildProcesses=this._onProcessDidChangeHasChildProcesses.event,this._onDidChangeProperty=this._register(new D.Emitter),this.onDidChangeProperty=this._onDidChangeProperty.event,(0,I.registerTerminalPlatformConfiguration)(),this._shellEnv=T.isWindows?Promise.resolve(process.env):(0,C.resolveShellEnv)(this._logService,{_:[]},process.env),this._register((0,L.toDisposable)(()=>this._disposePtyHost())),this._resolveVariablesRequestStore=this._register(new S.RequestStore(void 0,this._logService)),this._resolveVariablesRequestStore.onCreateRequest(this._onPtyHostRequestResolveVariables.fire,this._onPtyHostRequestResolveVariables),[this._client,this._proxy]=this._startPtyHost()}_startPtyHost(){const r={serverName:"Pty Host",args:["--type=ptyHost"],env:{VSCODE_LAST_PTY_ID:o,VSCODE_AMD_ENTRYPOINT:"vs/platform/terminal/node/ptyHostMain",VSCODE_PIPE_LOGGING:"true",VSCODE_VERBOSE_LOGGING:"true",VSCODE_RECONNECT_GRACE_TIME:this._reconnectConstants.graceTime,VSCODE_RECONNECT_SHORT_GRACE_TIME:this._reconnectConstants.shortGraceTime,VSCODE_RECONNECT_SCROLLBACK:this._reconnectConstants.scrollback}},n=(0,i.parsePtyHostPort)(this._environmentService.args,this._environmentService.isBuilt);n&&(n.break&&n.port?r.debugBrk=n.port:!n.break&&n.port&&(r.debug=n.port));const s=new P.Client(R.FileAccess.asFileUri("bootstrap-fork",K).fsPath,r);this._onPtyHostStart.fire(),k.ProxyChannel.toService(s.getChannel(f.TerminalIpcChannels.Heartbeat)).onBeat(()=>this._handleHeartbeat()),this._handleHeartbeat(),this._register(s.onDidProcessExit(d=>{this._telemetryService.publicLog("ptyHost/exit"),this._onPtyHostExit.fire(d.code),this._isDisposed||(this._restartCount<=E.MaxRestarts?(this._logService.error(`ptyHost terminated unexpectedly with code ${d.code}`),this._restartCount++,this.restartPtyHost()):this._logService.error(`ptyHost terminated unexpectedly with code ${d.code}, giving up`))}));const l=s.getChannel(f.TerminalIpcChannels.Log);w.LogLevelChannelClient.setLevel(l,this._logService.getLevel()),this._register(this._logService.onDidChangeLogLevel(()=>{w.LogLevelChannelClient.setLevel(l,this._logService.getLevel())}));const h=k.ProxyChannel.toService(s.getChannel(f.TerminalIpcChannels.PtyHost));return this._register(h.onProcessData(d=>this._onProcessData.fire(d))),this._register(h.onProcessExit(d=>this._onProcessExit.fire(d))),this._register(h.onProcessReady(d=>this._onProcessReady.fire(d))),this._register(h.onProcessTitleChanged(d=>this._onProcessTitleChanged.fire(d))),this._register(h.onProcessShellTypeChanged(d=>this._onProcessShellTypeChanged.fire(d))),this._register(h.onProcessOverrideDimensions(d=>this._onProcessOverrideDimensions.fire(d))),this._register(h.onProcessResolvedShellLaunchConfig(d=>this._onProcessResolvedShellLaunchConfig.fire(d))),this._register(h.onProcessDidChangeHasChildProcesses(d=>this._onProcessDidChangeHasChildProcesses.fire(d))),this._register(h.onDidChangeProperty(d=>this._onDidChangeProperty.fire(d))),this._register(h.onProcessReplay(d=>this._onProcessReplay.fire(d))),this._register(h.onProcessOrphanQuestion(d=>this._onProcessOrphanQuestion.fire(d))),this._register(h.onDidRequestDetach(d=>this._onDidRequestDetach.fire(d))),[s,h]}dispose(){this._isDisposed=!0,super.dispose()}async createProcess(r,n,s,c,l,h,d,v,A,O,p){const U=setTimeout(()=>this._handleUnresponsiveCreateProcess(),f.HeartbeatConstants.CreateProcessTimeout),F=await this._proxy.createProcess(r,n,s,c,l,h,d,v,A,O,p);return clearTimeout(U),o=Math.max(o,F),F}updateTitle(r,n,s){return this._proxy.updateTitle(r,n,s)}updateIcon(r,n,s){return this._proxy.updateIcon(r,n,s)}attachToProcess(r){return this._proxy.attachToProcess(r)}detachFromProcess(r){return this._proxy.detachFromProcess(r)}listProcesses(){return this._proxy.listProcesses()}reduceConnectionGraceTime(){return this._proxy.reduceConnectionGraceTime()}start(r){return this._proxy.start(r)}shutdown(r,n){return this._proxy.shutdown(r,n)}input(r,n){return this._proxy.input(r,n)}processBinary(r,n){return this._proxy.processBinary(r,n)}resize(r,n,s){return this._proxy.resize(r,n,s)}acknowledgeDataEvent(r,n){return this._proxy.acknowledgeDataEvent(r,n)}setUnicodeVersion(r,n){return this._proxy.setUnicodeVersion(r,n)}getInitialCwd(r){return this._proxy.getInitialCwd(r)}getCwd(r){return this._proxy.getCwd(r)}getLatency(r){return this._proxy.getLatency(r)}orphanQuestionReply(r){return this._proxy.orphanQuestionReply(r)}getDefaultSystemShell(r){return this._proxy.getDefaultSystemShell(r)}async getProfiles(r,n,s,c=!1){const l=await this._shellEnv;return(0,y.detectAvailableProfiles)(n,s,c,this._configurationService,l,void 0,this._logService,this._resolveVariables.bind(this,r))}getEnvironment(){return this._proxy.getEnvironment()}getWslPath(r){return this._proxy.getWslPath(r)}setTerminalLayoutInfo(r){return this._proxy.setTerminalLayoutInfo(r)}async getTerminalLayoutInfo(r){return await this._proxy.getTerminalLayoutInfo(r)}async requestDetachInstance(r,n){return this._proxy.requestDetachInstance(r,n)}async acceptDetachInstanceReply(r,n){return this._proxy.acceptDetachInstanceReply(r,n)}async serializeTerminalState(r){return this._proxy.serializeTerminalState(r)}async reviveTerminalProcesses(r){return this._proxy.reviveTerminalProcesses(r)}async refreshProperty(r,n){return this._proxy.refreshProperty(r,n)}async restartPtyHost(){this._telemetryService.publicLog("ptyHost/restart"),this._isResponsive=!0,this._disposePtyHost(),[this._client,this._proxy]=this._startPtyHost()}_disposePtyHost(){this._proxy.shutdownAll?.(),this._client.dispose()}_handleHeartbeat(){this._clearHeartbeatTimeouts(),this._heartbeatFirstTimeout=setTimeout(()=>this._handleHeartbeatFirstTimeout(),f.HeartbeatConstants.BeatInterval*f.HeartbeatConstants.FirstWaitMultiplier),this._isResponsive||(this._telemetryService.publicLog("ptyHost/responsive"),this._isResponsive=!0),this._onPtyHostResponsive.fire()}_handleHeartbeatFirstTimeout(){this._logService.warn(`No ptyHost heartbeat after ${f.HeartbeatConstants.BeatInterval*f.HeartbeatConstants.FirstWaitMultiplier/1e3} seconds`),this._heartbeatFirstTimeout=void 0,this._heartbeatSecondTimeout=setTimeout(()=>this._handleHeartbeatSecondTimeout(),f.HeartbeatConstants.BeatInterval*f.HeartbeatConstants.SecondWaitMultiplier)}_handleHeartbeatSecondTimeout(){this._logService.error(`No ptyHost heartbeat after ${(f.HeartbeatConstants.BeatInterval*f.HeartbeatConstants.FirstWaitMultiplier+f.HeartbeatConstants.BeatInterval*f.HeartbeatConstants.FirstWaitMultiplier)/1e3} seconds`),this._heartbeatSecondTimeout=void 0,this._isResponsive&&(this._telemetryService.publicLog("ptyHost/unresponsive"),this._isResponsive=!1),this._onPtyHostUnresponsive.fire()}_handleUnresponsiveCreateProcess(){this._clearHeartbeatTimeouts(),this._logService.error(`No ptyHost response to createProcess after ${f.HeartbeatConstants.CreateProcessTimeout/1e3} seconds`),this._telemetryService.publicLog("ptyHost/responsive"),this._onPtyHostUnresponsive.fire()}_clearHeartbeatTimeouts(){this._heartbeatFirstTimeout&&(clearTimeout(this._heartbeatFirstTimeout),this._heartbeatFirstTimeout=void 0),this._heartbeatSecondTimeout&&(clearTimeout(this._heartbeatSecondTimeout),this._heartbeatSecondTimeout=void 0)}_resolveVariables(r,n){return this._resolveVariablesRequestStore.createRequest({workspaceId:r,originalText:n})}async acceptPtyHostResolvedVariables(r,n){this._resolveVariablesRequestStore.acceptReply(r,n)}};a=fe([J(1,m.IConfigurationService),J(2,b.IEnvironmentService),J(3,g.ILogService),J(4,u.ITelemetryService)],a),e.PtyHostService=a}),define(Z[54],te([0,1,44]),function(K,e,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getLineEndOffset=e.getLineStartOffset=e.edit=void 0;function L(k,P,m,b){const i=(0,D.setProperty)(k,P,m,b)[0];return i&&(k=k.substring(0,i.offset)+i.content+k.substring(i.offset+i.length)),k}e.edit=L;function R(k,P,m){let b=m;for(;b>=0;){if(k.charAt(b)===P.charAt(P.length-1)&&P.length===1)return b+1;if(b--,P.length===2&&b>=0&&k.charAt(b)===P.charAt(0))return b+2}return 0}e.getLineStartOffset=R;function T(k,P,m){let b=m;for(;b>=0;)if(k.charAt(b)===P.charAt(P.length-1)&&P.length===1||(b++,P.length===2&&b>=0&&k.charAt(b)===P.charAt(1)))return b;return k.length-1}e.getLineEndOffset=T}),define(Z[199],te([0,1,26,58]),function(K,e,D,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.merge=void 0;function R(C,g,w,u,S){const f=[],I=[],y=[];if(!g){const O=C.filter(({identifier:p})=>S.every(U=>U.toLowerCase()!==p.id.toLowerCase()));return{local:{added:f,removed:I,updated:y},remote:O.length>0?{added:O,updated:[],removed:[],all:O}:null}}C=C.map(b),g=g.map(b),w=w?w.map(b):null;const E=new Map,o=O=>{O.uuid&&E.set(O.id.toLowerCase(),O.uuid)};C.forEach(({identifier:O})=>o(O)),g.forEach(({identifier:O})=>o(O)),w&&w.forEach(({identifier:O})=>o(O));const a=O=>{const p=O.identifier.uuid||E.get(O.identifier.id.toLowerCase());return p?`uuid:${p}`:`id:${O.identifier.id.toLowerCase()}`},t=(O,p)=>(O.set(a(p),p),O),r=C.reduce(t,new Map),n=g.reduce(t,new Map),s=g.reduce((O,p)=>{const U=a(p);p=(0,D.deepClone)(p);const F=r.get(U);return F&&(F.installed&&(p.installed=!0),p.version||(p.version=F.version)),t(O,p)},new Map),c=w?w.reduce(t,new Map):null,l=u.reduce(t,new Map),h=S.reduce((O,p)=>{const U=E.get(p.toLowerCase());return O.add(U?`uuid:${U}`:`id:${p.toLowerCase()}`)},new Set),d=T(r,n,h);if(d.added.size>0||d.removed.size>0||d.updated.size>0){const O=T(c,r,h),p=T(c,n,h),U=(F,z)=>{const H=r.get(F);if(H){const M=n.get(F);return{...z?M:H,version:(M.version&&L.gt(M.version,H.version),H.version),state:k(H,M,c?.get(F))}}};for(const F of p.removed.values()){const z=r.get(F);z&&I.push(z.identifier)}for(const F of p.added.values())if(O.added.has(F)){if(d.updated.has(F)){const z=U(F,!0);z&&(y.push(i(z,F)),s.set(F,z))}}else{const z=n.get(F);z.installed&&f.push(i(z,F))}for(const F of p.updated.values()){const z=U(F,!0);z&&(y.push(i(z,F)),s.set(F,z))}for(const F of O.added.values())p.added.has(F)||s.set(F,r.get(F));for(const F of O.updated.values())if(!p.removed.has(F)&&!p.updated.has(F)){const z=U(F,!1);z&&(s.get(F)?.installed&&(z.installed=!0),s.set(F,z))}for(const F of O.removed.values())!l.has(F)&&!p.updated.has(F)&&c?.get(F)?.installed&&s.delete(F)}const v=[],A=T(n,s,new Set,{checkInstalledProperty:!0,checkVersionProperty:!0});return(A.added.size>0||A.updated.size>0||A.removed.size>0)&&s.forEach((O,p)=>v.push(i(O,p))),{local:{added:f,removed:I,updated:y},remote:v.length?{added:[...A.added].map(O=>s.get(O)),updated:[...A.updated].map(O=>s.get(O)),removed:[...A.removed].map(O=>n.get(O)),all:v}:null}}e.merge=R;function T(C,g,w,{checkInstalledProperty:u,checkVersionProperty:S}={checkInstalledProperty:!1,checkVersionProperty:!1}){const f=C?[...C.keys()].filter(a=>!w.has(a)):[],I=[...g.keys()].filter(a=>!w.has(a)),y=I.filter(a=>f.indexOf(a)===-1).reduce((a,t)=>(a.add(t),a),new Set),E=f.filter(a=>I.indexOf(a)===-1).reduce((a,t)=>(a.add(t),a),new Set),o=new Set;for(const a of f){if(E.has(a))continue;const t=C.get(a),r=g.get(a);(!r||t.disabled!==r.disabled||!m(t.state,r.state)||S&&t.version!==r.version||u&&t.installed!==r.installed)&&o.add(a)}return{added:y,removed:E,updated:o}}function k(C,g,w){const u=C.state,S=g.state,f=w?.state;if(!g.version||u&&L.gt(C.version,g.version))return u;if(S&&L.gt(g.version,C.version)||!u)return S;if(!S)return u;const I=(0,D.deepClone)(u),y=f?P(f,S):{added:Object.keys(S).reduce((o,a)=>(o.add(a),o),new Set),removed:new Set,updated:new Set},E=f?P(f,u):{added:Object.keys(u).reduce((o,a)=>(o.add(a),o),new Set),removed:new Set,updated:new Set};for(const o of[...y.added.values(),...y.updated.values()])I[o]=S[o];for(const o of y.removed.values())E.updated.has(o)||delete I[o];return I}function P(C,g){const w=Object.keys(C),u=Object.keys(g),S=u.filter(y=>w.indexOf(y)===-1).reduce((y,E)=>(y.add(E),y),new Set),f=w.filter(y=>u.indexOf(y)===-1).reduce((y,E)=>(y.add(E),y),new Set),I=new Set;for(const y of w){if(f.has(y))continue;const E=C[y],o=g[y];(0,D.equals)(E,o)||I.add(y)}return{added:S,removed:f,updated:I}}function m(C={},g={}){const{added:w,removed:u,updated:S}=P(C,g);return w.size===0&&u.size===0&&S.size===0}function b(C){return{...C,disabled:!!C.disabled,installed:!!C.installed}}function i(C,g){const w={identifier:{id:C.identifier.id,uuid:g.startsWith("uuid:")?g.substring("uuid:".length):void 0}};return C.version&&(w.version=C.version),C.disabled&&(w.disabled=!0),C.installed&&(w.installed=!0),C.state&&(w.state=C.state),w}}),define(Z[88],te([0,1,17,3,2,32,7,29,22]),function(K,e,D,L,R,T,k,P,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionsStorageSyncService=e.IExtensionsStorageSyncService=void 0,e.IExtensionsStorageSyncService=(0,k.createDecorator)("IExtensionsStorageSyncService");const b=/^extensionKeys\/([^.]+\..+)@(\d+\.\d+\.\d+(-.*)?)$/;let i=class et extends R.Disposable{constructor(g,w){super();this.storageService=g,this.productService=w,this._onDidChangeExtensionsStorage=this._register(new L.Emitter),this.onDidChangeExtensionsStorage=this._onDidChangeExtensionsStorage.event,this.extensionsWithKeysForSync=new Set,this.initialize(),this._register(this.storageService.onDidChangeValue(u=>this.onDidChangeStorageValue(u)))}static toKey(g){return`extensionKeys/${(0,T.adoptToGalleryExtensionId)(g.id)}@${g.version}`}static fromKey(g){const w=b.exec(g);if(w&&w[1])return{id:w[1],version:w[2]}}initialize(){const g=this.storageService.keys(0,1);for(const w of g){const u=et.fromKey(w);u&&this.extensionsWithKeysForSync.add(u.id.toLowerCase())}}onDidChangeStorageValue(g){if(g.scope!==0)return;if(this.extensionsWithKeysForSync.has(g.key.toLowerCase())){this._onDidChangeExtensionsStorage.fire();return}const w=et.fromKey(g.key);if(w){this.extensionsWithKeysForSync.add(w.id.toLowerCase()),this._onDidChangeExtensionsStorage.fire();return}}setKeysForSync(g,w){this.storageService.store(et.toKey(g),JSON.stringify(w),0,1)}getKeysForSync(g){const w=this.productService.extensionSyncedKeys?.[g.id.toLowerCase()],u=this.storageService.get(et.toKey(g),0),S=u?JSON.parse(u):void 0;return S&&w?(0,D.distinct)([...S,...w]):S||w}};i=fe([J(0,m.IStorageService),J(1,P.IProductService)],i),e.ExtensionsStorageSyncService=i}),define(Z[89],te([0,1,17,21,7]),function(K,e,D,L,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IgnoredExtensionsManagementService=e.IIgnoredExtensionsManagementService=void 0,e.IIgnoredExtensionsManagementService=(0,R.createDecorator)("IIgnoredExtensionsManagementService");let T=class{constructor(P){this.configurationService=P}hasToNeverSyncExtension(P){return this.getConfiguredIgnoredExtensions().includes(P.toLowerCase())}hasToAlwaysSyncExtension(P){return this.getConfiguredIgnoredExtensions().includes(`-${P.toLowerCase()}`)}updateIgnoredExtensions(P,m){let b=[...this.configurationService.getValue("settingsSync.ignoredExtensions")].map(i=>i.toLowerCase());return b=b.filter(i=>i!==P&&i!==`-${P}`),m&&b.push(P.toLowerCase()),this.configurationService.updateValue("settingsSync.ignoredExtensions",b.length?b:void 0,1)}updateSynchronizedExtensions(P,m){let b=[...this.configurationService.getValue("settingsSync.ignoredExtensions")].map(i=>i.toLowerCase());return b=b.filter(i=>i!==P&&i!==`-${P}`),m&&b.push(`-${P.toLowerCase()}`),this.configurationService.updateValue("settingsSync.ignoredExtensions",b.length?b:void 0,1)}getIgnoredExtensions(P){const m=P.filter(g=>g.isMachineScoped).map(g=>g.identifier.id.toLowerCase()),b=this.getConfiguredIgnoredExtensions().map(g=>g.toLowerCase()),i=[],C=[];if(Array.isArray(b))for(const g of b)g.startsWith("-")?C.push(g.substring(1)):i.push(g);return(0,D.distinct)([...m,...i].filter(g=>C.indexOf(g)===-1))}getConfiguredIgnoredExtensions(){let P=this.configurationService.inspect("settingsSync.ignoredExtensions").userValue;return P!==void 0||(P=this.configurationService.inspect("sync.ignoredExtensions").userValue,P!==void 0)?P:(this.configurationService.getValue("settingsSync.ignoredExtensions")||[]).map(m=>m.toLowerCase())}};T=fe([J(0,L.IConfigurationService)],T),e.IgnoredExtensionsManagementService=T}),define(Z[200],te([0,1,17,34,26,150,54]),function(K,e,D,L,R,T,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.merge=e.parseKeybindings=void 0;function P(o){return(0,L.parse)(o)||[]}e.parseKeybindings=P;async function m(o,a,t,r,n){const s=P(o),c=P(a),l=t?P(t):null,h=[...s,...c,...l||[]].map(j=>j.key),d=await n.resolveUserBindings(h);let v=i(s,c,l,d);if(!v.hasLocalForwarded&&!v.hasRemoteForwarded)return{mergeContent:o,hasChanges:!1,hasConflicts:!1};if(!v.hasLocalForwarded&&v.hasRemoteForwarded)return{mergeContent:a,hasChanges:!0,hasConflicts:!1};if(v.hasLocalForwarded&&!v.hasRemoteForwarded)return{mergeContent:o,hasChanges:!0,hasConflicts:!1};const A=g(s),O=g(c),p=l?g(l):null,U=u(A,O,d),F=p?u(p,A,d):{added:[...A.keys()].reduce((j,q)=>(j.add(q),j),new Set),removed:new Set,updated:new Set},z=p?u(p,O,d):{added:[...O.keys()].reduce((j,q)=>(j.add(q),j),new Set),removed:new Set,updated:new Set},H=b(U,F,z);let M=o;for(const j of H.removed.values())H.conflicts.has(j)||(M=y(M,j,r));for(const j of H.added.values()){if(H.conflicts.has(j))continue;const q=O.get(j);if(q.some(x=>x.command!==`-${j}`&&v.conflicts.has(d[x.key]))){H.conflicts.add(j);continue}M=I(M,q,r)}for(const j of H.updated.values()){if(H.conflicts.has(j))continue;const q=O.get(j);if(q.some(x=>x.command!==`-${j}`&&v.conflicts.has(d[x.key]))){H.conflicts.add(j);continue}M=E(M,j,q,r)}return{mergeContent:M,hasChanges:!0,hasConflicts:H.conflicts.size>0}}e.merge=m;function b(o,a,t){const r=new Set,n=new Set,s=new Set,c=new Set;for(const l of a.removed.values())t.updated.has(l)&&c.add(l);for(const l of t.removed.values())c.has(l)||(a.updated.has(l)?c.add(l):n.add(l));for(const l of a.added.values())c.has(l)||t.added.has(l)&&o.updated.has(l)&&c.add(l);for(const l of t.added.values())c.has(l)||(a.added.has(l)?o.updated.has(l)&&c.add(l):r.add(l));for(const l of a.updated.values())c.has(l)||t.updated.has(l)&&o.updated.has(l)&&c.add(l);for(const l of t.updated.values())c.has(l)||(a.updated.has(l)?o.updated.has(l)&&c.add(l):s.add(l));return{added:r,removed:n,updated:s,conflicts:c}}function i(o,a,t,r){const n=new Set,s=C(o,r),c=C(a,r),l=t?C(t,r):null,h=w(s,c);if(h.added.size===0&&h.removed.size===0&&h.updated.size===0)return{hasLocalForwarded:!1,hasRemoteForwarded:!1,added:n,removed:n,updated:n,conflicts:n};const d=l?w(l,s):{added:[...s.keys()].reduce((F,z)=>(F.add(z),F),new Set),removed:new Set,updated:new Set};if(d.added.size===0&&d.removed.size===0&&d.updated.size===0)return{hasLocalForwarded:!1,hasRemoteForwarded:!0,added:n,removed:n,updated:n,conflicts:n};const v=l?w(l,c):{added:[...c.keys()].reduce((F,z)=>(F.add(z),F),new Set),removed:new Set,updated:new Set};if(v.added.size===0&&v.removed.size===0&&v.updated.size===0)return{hasLocalForwarded:!0,hasRemoteForwarded:!1,added:n,removed:n,updated:n,conflicts:n};const{added:A,removed:O,updated:p,conflicts:U}=b(h,d,v);return{hasLocalForwarded:!0,hasRemoteForwarded:!0,added:A,removed:O,updated:p,conflicts:U}}function C(o,a){const t=new Map;for(const r of o){const n=a[r.key];let s=t.get(n);s||(s=[],t.set(n,s)),s.push(r)}return t}function g(o){const a=new Map;for(const t of o){const r=t.command[0]==="-"?t.command.substring(1):t.command;let n=a.get(r);n||(n=[],a.set(r,n)),n.push(t)}return a}function w(o,a){const t=[...o.keys()],r=[...a.keys()],n=r.filter(l=>t.indexOf(l)===-1).reduce((l,h)=>(l.add(h),l),new Set),s=t.filter(l=>r.indexOf(l)===-1).reduce((l,h)=>(l.add(h),l),new Set),c=new Set;for(const l of t){if(s.has(l))continue;const h=o.get(l).map(v=>({...v,key:l})),d=a.get(l).map(v=>({...v,key:l}));(0,D.equals)(h,d,(v,A)=>f(v,A))||c.add(l)}return{added:n,removed:s,updated:c}}function u(o,a,t){const r=[...o.keys()],n=[...a.keys()],s=n.filter(h=>r.indexOf(h)===-1).reduce((h,d)=>(h.add(d),h),new Set),c=r.filter(h=>n.indexOf(h)===-1).reduce((h,d)=>(h.add(d),h),new Set),l=new Set;for(const h of r){if(c.has(h))continue;const d=o.get(h).map(A=>({...A,key:t[A.key]})),v=a.get(h).map(A=>({...A,key:t[A.key]}));S(d,v)||l.add(h)}return{added:s,removed:c,updated:l}}function S(o,a){return!(!(0,D.equals)(o.filter(({command:t})=>t[0]!=="-"),a.filter(({command:t})=>t[0]!=="-"),(t,r)=>f(t,r))||!(0,D.equals)(o.filter(({command:t})=>t[0]==="-"),a.filter(({command:t})=>t[0]==="-"),(t,r)=>f(t,r)))}function f(o,a){if(o.command!==a.command||o.key!==a.key)return!1;const t=T.ContextKeyExpr.deserialize(o.when),r=T.ContextKeyExpr.deserialize(a.when);return!(t&&!r||!t&&r||t&&r&&!t.equals(r)||!R.equals(o.args,a.args))}function I(o,a,t){for(const r of a)o=k.edit(o,[-1],r,t);return o}function y(o,a,t){const r=P(o);for(let n=r.length-1;n>=0;n--)(r[n].command===a||r[n].command===`-${a}`)&&(o=k.edit(o,[n],void 0,t));return o}function E(o,a,t,r){const n=P(o),s=n.findIndex(c=>c.command===a||c.command===`-${a}`);for(let c=n.length-1;c>=0;c--)(n[c].command===a||n[c].command===`-${a}`)&&(o=k.edit(o,[c],void 0,r));for(let c=t.length-1;c>=0;c--)o=k.edit(o,[s],t[c],r);return o}}),define(Z[201],te([0,1]),function(K,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.areSame=e.merge=void 0;function D(T,k,P){const m={},b={},i=new Set;if(!k)return{local:{added:m,updated:b,removed:[...i.values()]},remote:{added:T,updated:{},removed:[]},conflicts:[]};const C=L(T,k);if(C.added.size===0&&C.removed.size===0&&C.updated.size===0)return{local:{added:m,updated:b,removed:[...i.values()]},remote:{added:{},updated:{},removed:[]},conflicts:[]};const g=L(P,T),w=L(P,k),u={},S={},f=new Set,I=new Set;for(const y of g.removed.values())w.updated.has(y)?m[y]=k[y]:f.add(y);for(const y of w.removed.values())I.has(y)||(g.updated.has(y)?I.add(y):i.add(y));for(const y of g.updated.values())I.has(y)||(w.updated.has(y)?C.updated.has(y)&&I.add(y):S[y]=T[y]);for(const y of w.updated.values())I.has(y)||(g.updated.has(y)?C.updated.has(y)&&I.add(y):T[y]!==void 0&&(b[y]=k[y]));for(const y of g.added.values())I.has(y)||(w.added.has(y)?C.updated.has(y)&&I.add(y):u[y]=T[y]);for(const y of w.added.values())I.has(y)||(g.added.has(y)?C.updated.has(y)&&I.add(y):m[y]=k[y]);return{local:{added:m,removed:[...i.values()],updated:b},remote:{added:u,removed:[...f.values()],updated:S},conflicts:[...I.values()]}}e.merge=D;function L(T,k){const P=T?Object.keys(T):[],m=k?Object.keys(k):[],b=m.filter(g=>P.indexOf(g)===-1).reduce((g,w)=>(g.add(w),g),new Set),i=P.filter(g=>m.indexOf(g)===-1).reduce((g,w)=>(g.add(w),g),new Set),C=new Set;for(const g of P){if(i.has(g))continue;const w=T[g],u=k[g];w!==u&&C.add(g)}return{added:b,removed:i,updated:C}}function R(T,k){const{added:P,removed:m,updated:b}=L(T,k);return P.size===0&&m.size===0&&b.size===0}e.areSame=R}),define(Z[23],te([0,1,17,16,18,134,39,28,7,82,33]),function(K,e,D,L,R,T,k,P,m,b,i){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getSyncResourceFromLocalPreview=e.PREVIEW_DIR_NAME=e.USER_DATA_SYNC_SCHEME=e.IUserDataSyncLogService=e.IUserDataSyncUtilService=e.IUserDataAutoSyncService=e.IUserDataAutoSyncEnablementService=e.IUserDataSyncService=e.IUserDataSyncResourceEnablementService=e.getEnablementKey=e.SYNC_SERVICE_URL_TYPE=e.MergeState=e.Change=e.SyncStatus=e.UserDataAutoSyncError=e.UserDataSyncStoreError=e.UserDataSyncError=e.UserDataSyncErrorCode=e.createSyncHeaders=e.HEADER_EXECUTION_ID=e.HEADER_OPERATION_ID=e.IUserDataSyncBackupStoreService=e.IUserDataSyncStoreService=e.IUserDataSyncStoreManagementService=e.getLastSyncResourceUri=e.ALL_SYNC_RESOURCES=e.SyncResource=e.isAuthenticationProvider=e.registerConfiguration=e.getDefaultIgnoredSettings=e.getDisallowedIgnoredSettings=e.CONFIGURATION_SYNC_STORE_KEY=void 0,e.CONFIGURATION_SYNC_STORE_KEY="configurationSync.store";function C(){const l=i.Registry.as(k.Extensions.Configuration).getConfigurationProperties();return Object.keys(l).filter(h=>!!l[h].disallowSyncIgnore)}e.getDisallowedIgnoredSettings=C;function g(){const l=i.Registry.as(k.Extensions.Configuration).getConfigurationProperties(),h=Object.keys(l).filter(A=>!!l[A].ignoreSync),d=Object.keys(l).filter(A=>l[A].scope===2||l[A].scope===6),v=C();return(0,D.distinct)([e.CONFIGURATION_SYNC_STORE_KEY,...h,...d,...v])}e.getDefaultIgnoredSettings=g;function w(){const l="vscode://schemas/ignoredSettings",h=i.Registry.as(k.Extensions.Configuration);h.registerConfiguration({id:"settingsSync",order:30,title:(0,T.localize)(0,null),type:"object",properties:{"settingsSync.keybindingsPerPlatform":{type:"boolean",description:(0,T.localize)(1,null),default:!0,scope:1,tags:["sync","usesOnlineServices"]},"settingsSync.ignoredExtensions":{type:"array",markdownDescription:(0,T.localize)(2,null),items:[{type:"string",pattern:P.EXTENSION_IDENTIFIER_PATTERN,errorMessage:(0,T.localize)(3,null)}],default:[],scope:1,uniqueItems:!0,disallowSyncIgnore:!0,tags:["sync","usesOnlineServices"]},"settingsSync.ignoredSettings":{type:"array",description:(0,T.localize)(4,null),default:[],scope:1,$ref:l,additionalProperties:!0,uniqueItems:!0,disallowSyncIgnore:!0,tags:["sync","usesOnlineServices"]}}});const d=i.Registry.as(b.Extensions.JSONContribution),v=()=>{const A=C(),O=g().filter(z=>z!==e.CONFIGURATION_SYNC_STORE_KEY),p=Object.keys(k.allSettings.properties).filter(z=>O.indexOf(z)===-1),U=O.filter(z=>A.indexOf(z)===-1),F={items:{type:"string",enum:[...p,...U.map(z=>`-${z}`)]}};d.registerSchema(l,F)};return h.onDidUpdateConfiguration(()=>v())}e.registerConfiguration=w;function u(l){return l&&(0,R.isObject)(l)&&(0,R.isString)(l.id)&&(0,R.isArray)(l.scopes)}e.isAuthenticationProvider=u;var S;(function(l){l.Settings="settings",l.Keybindings="keybindings",l.Snippets="snippets",l.Extensions="extensions",l.GlobalState="globalState"})(S=e.SyncResource||(e.SyncResource={})),e.ALL_SYNC_RESOURCES=["settings","keybindings","snippets","extensions","globalState"];function f(l,h,d){return d.joinPath(h.userDataSyncHome,l,`lastSync${l}.json`)}e.getLastSyncResourceUri=f,e.IUserDataSyncStoreManagementService=(0,m.createDecorator)("IUserDataSyncStoreManagementService"),e.IUserDataSyncStoreService=(0,m.createDecorator)("IUserDataSyncStoreService"),e.IUserDataSyncBackupStoreService=(0,m.createDecorator)("IUserDataSyncBackupStoreService"),e.HEADER_OPERATION_ID="x-operation-id",e.HEADER_EXECUTION_ID="X-Execution-Id";function I(l){const h={};return h[e.HEADER_EXECUTION_ID]=l,h}e.createSyncHeaders=I;var y;(function(l){l.Unauthorized="Unauthorized",l.Conflict="Conflict",l.Gone="Gone",l.PreconditionFailed="PreconditionFailed",l.TooLarge="TooLarge",l.UpgradeRequired="UpgradeRequired",l.PreconditionRequired="PreconditionRequired",l.TooManyRequests="RemoteTooManyRequests",l.TooManyRequestsAndRetryAfter="TooManyRequestsAndRetryAfter",l.RequestFailed="RequestFailed",l.RequestCanceled="RequestCanceled",l.RequestTimeout="RequestTimeout",l.RequestProtocolNotSupported="RequestProtocolNotSupported",l.RequestPathNotEscaped="RequestPathNotEscaped",l.RequestHeadersNotObject="RequestHeadersNotObject",l.NoRef="NoRef",l.EmptyResponse="EmptyResponse",l.TurnedOff="TurnedOff",l.SessionExpired="SessionExpired",l.ServiceChanged="ServiceChanged",l.DefaultServiceChanged="DefaultServiceChanged",l.LocalTooManyRequests="LocalTooManyRequests",l.LocalPreconditionFailed="LocalPreconditionFailed",l.LocalInvalidContent="LocalInvalidContent",l.LocalError="LocalError",l.IncompatibleLocalContent="IncompatibleLocalContent",l.IncompatibleRemoteContent="IncompatibleRemoteContent",l.UnresolvedConflicts="UnresolvedConflicts",l.Unknown="Unknown"})(y=e.UserDataSyncErrorCode||(e.UserDataSyncErrorCode={}));class E extends Error{constructor(h,d,v,A){super(h);this.code=d,this.resource=v,this.operationId=A,this.name=`${this.code} (UserDataSyncError) syncResource:${this.resource||"unknown"} operationId:${this.operationId||"unknown"}`}}e.UserDataSyncError=E;class o extends E{constructor(h,d,v,A,O){super(h,v,void 0,O);this.url=d,this.serverCode=A}}e.UserDataSyncStoreError=o;class a extends E{constructor(h,d){super(h,d)}}e.UserDataAutoSyncError=a,function(l){function h(d){if(d instanceof l)return d;const v=/^(.+) \(UserDataSyncError\) syncResource:(.+) operationId:(.+)$/.exec(d.name);if(v&&v[1]){const A=v[2]==="unknown"?void 0:v[2],O=v[3]==="unknown"?void 0:v[3];return new l(d.message,v[1],A,O)}return new l(d.message,"Unknown")}l.toUserDataSyncError=h}(E=e.UserDataSyncError||(e.UserDataSyncError={}));var t;(function(l){l.Uninitialized="uninitialized",l.Idle="idle",l.Syncing="syncing",l.HasConflicts="hasConflicts"})(t=e.SyncStatus||(e.SyncStatus={}));var r;(function(l){l[l.None=0]="None",l[l.Added=1]="Added",l[l.Modified=2]="Modified",l[l.Deleted=3]="Deleted"})(r=e.Change||(e.Change={}));var n;(function(l){l.Preview="preview",l.Conflict="conflict",l.Accepted="accepted"})(n=e.MergeState||(e.MergeState={})),e.SYNC_SERVICE_URL_TYPE="sync.store.url.type";function s(l){return`sync.enable.${l}`}e.getEnablementKey=s,e.IUserDataSyncResourceEnablementService=(0,m.createDecorator)("IUserDataSyncResourceEnablementService"),e.IUserDataSyncService=(0,m.createDecorator)("IUserDataSyncService"),e.IUserDataAutoSyncEnablementService=(0,m.createDecorator)("IUserDataAutoSyncEnablementService"),e.IUserDataAutoSyncService=(0,m.createDecorator)("IUserDataAutoSyncService"),e.IUserDataSyncUtilService=(0,m.createDecorator)("IUserDataSyncUtilService"),e.IUserDataSyncLogService=(0,m.createDecorator)("IUserDataSyncLogService"),e.USER_DATA_SYNC_SCHEME="vscode-userdata-sync",e.PREVIEW_DIR_NAME="preview";function c(l,h){if(l.scheme!==e.USER_DATA_SYNC_SCHEME)return l=l.with({scheme:h.userDataSyncHome.scheme}),e.ALL_SYNC_RESOURCES.filter(d=>(0,L.isEqualOrParent)(l,(0,L.joinPath)(h.userDataSyncHome,d,e.PREVIEW_DIR_NAME)))[0]}e.getSyncResourceFromLocalPreview=c}),define(Z[47],te([0,1,17,6,25,27,3,34,2,16,24,18,5,130,21,12,14,45,22,20,23]),function(K,e,D,L,R,T,k,P,m,b,i,C,g,w,u,S,f,I,y,E,o){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.AbstractInitializer=e.AbstractJsonFileSynchroniser=e.AbstractFileSynchroniser=e.AbstractSynchroniser=e.isSyncData=void 0;function a(c){return!!(c&&c.version!==void 0&&typeof c.version=="number"&&c.content!==void 0&&typeof c.content=="string"&&(Object.keys(c).length===2||Object.keys(c).length===3&&c.machineId!==void 0&&typeof c.machineId=="string"))}e.isSyncData=a;let t=class extends m.Disposable{constructor(l,h,d,v,A,O,p,U,F,z){super();this.resource=l,this.fileService=h,this.environmentService=d,this.userDataSyncStoreService=A,this.userDataSyncBackupStoreService=O,this.userDataSyncResourceEnablementService=p,this.telemetryService=U,this.logService=F,this.configurationService=z,this.syncPreviewPromise=null,this._status="idle",this._onDidChangStatus=this._register(new k.Emitter),this.onDidChangeStatus=this._onDidChangStatus.event,this._conflicts=[],this._onDidChangeConflicts=this._register(new k.Emitter),this.onDidChangeConflicts=this._onDidChangeConflicts.event,this.localChangeTriggerScheduler=new L.RunOnceScheduler(()=>this.doTriggerLocalChange(),50),this._onDidChangeLocal=this._register(new k.Emitter),this.onDidChangeLocal=this._onDidChangeLocal.event,this.hasSyncResourceStateVersionChanged=!1,this.syncHeaders={},this.syncResourceLogLabel=(0,i.uppercaseFirstLetter)(this.resource),this.extUri=this.fileService.hasCapability(d.userDataSyncHome,1024)?b.extUri:b.extUriIgnorePathCase,this.syncFolder=this.extUri.joinPath(d.userDataSyncHome,l),this.syncPreviewFolder=this.extUri.joinPath(this.syncFolder,o.PREVIEW_DIR_NAME),this.lastSyncResource=(0,o.getLastSyncResourceUri)(l,d,this.extUri),this.currentMachineIdPromise=(0,I.getServiceMachineId)(d,h,v)}get status(){return this._status}get conflicts(){return this._conflicts}isEnabled(){return this.userDataSyncResourceEnablementService.isResourceEnabled(this.resource)}async triggerLocalChange(){this.isEnabled()&&this.localChangeTriggerScheduler.schedule()}async doTriggerLocalChange(){if(this.status==="hasConflicts"){this.logService.info(`${this.syncResourceLogLabel}: In conflicts state and local change detected. Syncing again...`);const l=await this.syncPreviewPromise;this.syncPreviewPromise=null;const h=await this.performSync(l.remoteUserData,l.lastSyncUserData,!0);this.setStatus(h)}else{this.logService.trace(`${this.syncResourceLogLabel}: Checking for local changes...`);const l=await this.getLastSyncUserData();(l?(await this.doGenerateSyncResourcePreview(l,l,!0,T.CancellationToken.None)).resourcePreviews.some(({remoteChange:d})=>d!==0):!0)&&this._onDidChangeLocal.fire()}}setStatus(l){if(this._status!==l){const h=this._status;l==="hasConflicts"&&this.telemetryService.publicLog2("sync/conflictsDetected",{source:this.resource}),h==="hasConflicts"&&l==="idle"&&this.telemetryService.publicLog2("sync/conflictsResolved",{source:this.resource}),this._status=l,this._onDidChangStatus.fire(l)}}async sync(l,h={}){await this._sync(l,!0,h)}async preview(l,h={}){return this._sync(l,!1,h)}async apply(l,h={}){try{this.syncHeaders={...h};const d=await this.doApply(l);return this.setStatus(d),this.syncPreviewPromise}finally{this.syncHeaders={}}}async _sync(l,h,d){try{if(this.syncHeaders={...d},!this.isEnabled())return this.status!=="idle"&&await this.stop(),this.logService.info(`${this.syncResourceLogLabel}: Skipped synchronizing ${this.resource.toLowerCase()} as it is disabled.`),null;if(this.status==="hasConflicts")return this.logService.info(`${this.syncResourceLogLabel}: Skipped synchronizing ${this.resource.toLowerCase()} as there are conflicts.`),this.syncPreviewPromise;if(this.status==="syncing")return this.logService.info(`${this.syncResourceLogLabel}: Skipped synchronizing ${this.resource.toLowerCase()} as it is running already.`),this.syncPreviewPromise;this.logService.trace(`${this.syncResourceLogLabel}: Started synchronizing ${this.resource.toLowerCase()}...`),this.setStatus("syncing");let v="idle";try{const A=await this.getLastSyncUserData(),O=await this.getLatestRemoteUserData(l,A);return v=await this.performSync(O,A,h),v==="hasConflicts"?this.logService.info(`${this.syncResourceLogLabel}: Detected conflicts while synchronizing ${this.resource.toLowerCase()}.`):v==="idle"&&this.logService.trace(`${this.syncResourceLogLabel}: Finished synchronizing ${this.resource.toLowerCase()}.`),this.syncPreviewPromise||null}finally{this.setStatus(v)}}finally{this.syncHeaders={}}}async replace(l){const h=await this.resolveContent(l);if(!h)return!1;const d=this.parseSyncData(h);if(!d)return!1;await this.stop();try{this.logService.trace(`${this.syncResourceLogLabel}: Started resetting ${this.resource.toLowerCase()}...`),this.setStatus("syncing");const v=await this.getLastSyncUserData(),A=await this.getLatestRemoteUserData(null,v),O=await this.isRemoteDataFromCurrentMachine(A),p=await this.generateSyncPreview({ref:A.ref,syncData:d},v,O,T.CancellationToken.None),U=[];for(const F of p){const z=await this.getAcceptResult(F,F.remoteResource,void 0,T.CancellationToken.None),{remoteChange:H}=await this.getAcceptResult(F,F.previewResource,F.remoteContent,T.CancellationToken.None);U.push([F,{...z,remoteChange:H!==0?H:2}])}await this.applyResult(A,v,U,!1),this.logService.info(`${this.syncResourceLogLabel}: Finished resetting ${this.resource.toLowerCase()}.`)}finally{this.setStatus("idle")}return!0}async isRemoteDataFromCurrentMachine(l){const h=await this.currentMachineIdPromise;return!!l.syncData?.machineId&&l.syncData.machineId===h}async getLatestRemoteUserData(l,h){if(h){const d=l&&l.latest?l.latest[this.resource]:void 0;if(h.ref===d||d===void 0&&h.syncData===null)return h}return this.getRemoteUserData(h)}async performSync(l,h,d){if(l.syncData&&l.syncData.version>this.version)throw this.telemetryService.publicLog2("sync/incompatible",{source:this.resource}),new o.UserDataSyncError((0,w.localize)(0,null,this.resource,this.version,l.syncData.version),"IncompatibleLocalContent",this.resource);try{return await this.doSync(l,h,d)}catch(v){if(v instanceof o.UserDataSyncError)switch(v.code){case"LocalPreconditionFailed":return this.logService.info(`${this.syncResourceLogLabel}: Failed to synchronize ${this.syncResourceLogLabel} as there is a new local version available. Synchronizing again...`),this.performSync(l,h,d);case"Conflict":case"PreconditionFailed":return this.logService.info(`${this.syncResourceLogLabel}: Failed to synchronize as there is a new remote version available. Synchronizing again...`),l=await this.getRemoteUserData(null),h=await this.getLastSyncUserData(),this.performSync(l,h,d)}throw v}}async doSync(l,h,d){try{this.syncPreviewPromise||(this.syncPreviewPromise=(0,L.createCancelablePromise)(A=>this.doGenerateSyncResourcePreview(l,h,d,A)));const v=await this.syncPreviewPromise;return this.updateConflicts(v.resourcePreviews),v.resourcePreviews.some(({mergeState:A})=>A==="conflict")?"hasConflicts":d?await this.doApply(!1):"syncing"}catch(v){throw this.syncPreviewPromise=null,v}}async merge(l){return await this.updateSyncResourcePreview(l,async h=>{const d=await this.getMergeResult(h,T.CancellationToken.None);await this.fileService.writeFile(h.previewResource,R.VSBuffer.fromString(d?.content||""));const v=d&&!d.hasConflicts?await this.getAcceptResult(h,h.previewResource,void 0,T.CancellationToken.None):void 0;return h.acceptResult=v,h.mergeState=d.hasConflicts?"conflict":v?"accepted":"preview",h.localChange=v?v.localChange:d.localChange,h.remoteChange=v?v.remoteChange:d.remoteChange,h}),this.syncPreviewPromise}async accept(l,h){return await this.updateSyncResourcePreview(l,async d=>{const v=await this.getAcceptResult(d,l,h,T.CancellationToken.None);return d.acceptResult=v,d.mergeState="accepted",d.localChange=v.localChange,d.remoteChange=v.remoteChange,d}),this.syncPreviewPromise}async discard(l){return await this.updateSyncResourcePreview(l,async h=>{const d=await this.getMergeResult(h,T.CancellationToken.None);return await this.fileService.writeFile(h.previewResource,R.VSBuffer.fromString(d.content||"")),h.acceptResult=void 0,h.mergeState="preview",h.localChange=d.localChange,h.remoteChange=d.remoteChange,h}),this.syncPreviewPromise}async updateSyncResourcePreview(l,h){if(!this.syncPreviewPromise)return;let d=await this.syncPreviewPromise;const v=d.resourcePreviews.findIndex(({localResource:A,remoteResource:O,previewResource:p})=>this.extUri.isEqual(A,l)||this.extUri.isEqual(O,l)||this.extUri.isEqual(p,l));v!==-1&&(this.syncPreviewPromise=(0,L.createCancelablePromise)(async A=>{const O=[...d.resourcePreviews];return O[v]=await h(O[v]),{...d,resourcePreviews:O}}),d=await this.syncPreviewPromise,this.updateConflicts(d.resourcePreviews),d.resourcePreviews.some(({mergeState:A})=>A==="conflict")?this.setStatus("hasConflicts"):this.setStatus("syncing"))}async doApply(l){if(!this.syncPreviewPromise)return"idle";const h=await this.syncPreviewPromise;return h.resourcePreviews.some(({mergeState:d})=>d==="conflict")?"hasConflicts":h.resourcePreviews.some(({mergeState:d})=>d!=="accepted")?"syncing":(await this.applyResult(h.remoteUserData,h.lastSyncUserData,h.resourcePreviews.map(d=>[d,d.acceptResult]),l),this.syncPreviewPromise=null,await this.clearPreviewFolder(),"idle")}async clearPreviewFolder(){try{await this.fileService.del(this.syncPreviewFolder,{recursive:!0})}catch(l){}}updateConflicts(l){const h=l.filter(({mergeState:d})=>d==="conflict");(0,D.equals)(this._conflicts,h,(d,v)=>this.extUri.isEqual(d.previewResource,v.previewResource))||(this._conflicts=h,this._onDidChangeConflicts.fire(h))}async hasPreviouslySynced(){return!!await this.getLastSyncUserData()}async getRemoteSyncResourceHandles(){return(await this.userDataSyncStoreService.getAllRefs(this.resource)).map(({created:h,ref:d})=>({created:h,uri:this.toRemoteBackupResource(d)}))}async getLocalSyncResourceHandles(){return(await this.userDataSyncBackupStoreService.getAllRefs(this.resource)).map(({created:h,ref:d})=>({created:h,uri:this.toLocalBackupResource(d)}))}toRemoteBackupResource(l){return g.URI.from({scheme:o.USER_DATA_SYNC_SCHEME,authority:"remote-backup",path:`/${this.resource}/${l}`})}toLocalBackupResource(l){return g.URI.from({scheme:o.USER_DATA_SYNC_SCHEME,authority:"local-backup",path:`/${this.resource}/${l}`})}async getMachineId({uri:l}){const h=this.extUri.basename(l);if(this.extUri.isEqual(l,this.toRemoteBackupResource(h))){const{content:d}=await this.getUserData(h);if(d)return this.parseSyncData(d)?.machineId}}async resolveContent(l){const h=this.extUri.basename(l);if(this.extUri.isEqual(l,this.toRemoteBackupResource(h))){const{content:d}=await this.getUserData(h);return d}return this.extUri.isEqual(l,this.toLocalBackupResource(h))?this.userDataSyncBackupStoreService.resolveContent(this.resource,h):null}async resolvePreviewContent(l){const h=this.syncPreviewPromise?await this.syncPreviewPromise:null;if(h)for(const d of h.resourcePreviews){if(this.extUri.isEqual(d.acceptedResource,l))return d.acceptResult?d.acceptResult.content:null;if(this.extUri.isEqual(d.remoteResource,l))return d.remoteContent;if(this.extUri.isEqual(d.localResource,l))return d.localContent}return null}async resetLocal(){try{await this.fileService.del(this.lastSyncResource)}catch(l){}}async doGenerateSyncResourcePreview(l,h,d,v){const A=await this.isRemoteDataFromCurrentMachine(l),O=await this.generateSyncPreview(l,h,A,v),p=[];for(const U of O){const F=U.previewResource.with({scheme:o.USER_DATA_SYNC_SCHEME,authority:"accepted"});if(U.localChange===0&&U.remoteChange===0)p.push({...U,acceptedResource:F,acceptResult:{content:null,localChange:0,remoteChange:0},mergeState:"accepted"});else{const z=d?await this.getMergeResult(U,v):void 0;if(v.isCancellationRequested)break;await this.fileService.writeFile(U.previewResource,R.VSBuffer.fromString(z?.content||""));const H=z&&!z.hasConflicts?await this.getAcceptResult(U,U.previewResource,void 0,v):void 0;p.push({...U,acceptResult:H,mergeState:z?.hasConflicts?"conflict":H?"accepted":"preview",localChange:H?H.localChange:z?z.localChange:U.localChange,remoteChange:H?H.remoteChange:z?z.remoteChange:U.remoteChange})}}return{remoteUserData:l,lastSyncUserData:h,resourcePreviews:p,isLastSyncFromCurrentMachine:A}}async getLastSyncUserData(){try{const l=await this.fileService.readFile(this.lastSyncResource),h=JSON.parse(l.value.toString()),d=this.userDataSyncResourceEnablementService.getResourceSyncStateVersion(this.resource);if(this.hasSyncResourceStateVersionChanged=h.version&&d&&h.version!==d,this.hasSyncResourceStateVersionChanged)return this.logService.info(`${this.syncResourceLogLabel}: Reset last sync state because last sync state version ${h.version} is not compatible with current sync state version ${d}.`),await this.resetLocal(),null;const v=h;if(v.content===null)return{ref:h.ref,syncData:null};const A=JSON.parse(v.content);if(a(A))return{...h,syncData:A,content:void 0}}catch(l){l instanceof f.FileOperationError&&l.fileOperationResult===1||this.logService.error(l)}return null}async updateLastSyncUserData(l,h={}){if(h.ref||h.content||h.version)throw new Error("Cannot have core properties as additional");const d=this.userDataSyncResourceEnablementService.getResourceSyncStateVersion(this.resource),v={ref:l.ref,content:l.syncData?JSON.stringify(l.syncData):null,version:d,...h};await this.fileService.writeFile(this.lastSyncResource,R.VSBuffer.fromString(JSON.stringify(v)))}async getRemoteUserData(l){const{ref:h,content:d}=await this.getUserData(l);let v=null;return d!==null&&(v=this.parseSyncData(d)),{ref:h,syncData:v}}parseSyncData(l){try{const h=JSON.parse(l);if(a(h))return h}catch(h){this.logService.error(h)}throw new o.UserDataSyncError((0,w.localize)(1,null),"IncompatibleRemoteContent",this.resource)}async getUserData(l){if((0,C.isString)(l)){const h=await this.userDataSyncStoreService.resolveContent(this.resource,l);return{ref:l,content:h}}else{const h=l?{ref:l.ref,content:l.syncData?JSON.stringify(l.syncData):null}:null;return this.userDataSyncStoreService.read(this.resource,h,this.syncHeaders)}}async updateRemoteUserData(l,h){const d=await this.currentMachineIdPromise,v={version:this.version,machineId:d,content:l};return h=await this.userDataSyncStoreService.write(this.resource,JSON.stringify(v),h,this.syncHeaders),{ref:h,syncData:v}}async backupLocal(l){const h={version:this.version,content:l};return this.userDataSyncBackupStoreService.backup(this.resource,JSON.stringify(h))}async stop(){this.status!=="idle"&&(this.logService.trace(`${this.syncResourceLogLabel}: Stopping synchronizing ${this.resource.toLowerCase()}.`),this.syncPreviewPromise&&(this.syncPreviewPromise.cancel(),this.syncPreviewPromise=null),this.updateConflicts([]),await this.clearPreviewFolder(),this.setStatus("idle"),this.logService.info(`${this.syncResourceLogLabel}: Stopped synchronizing ${this.resource.toLowerCase()}.`))}};t=fe([J(1,f.IFileService),J(2,S.IEnvironmentService),J(3,y.IStorageService),J(4,o.IUserDataSyncStoreService),J(5,o.IUserDataSyncBackupStoreService),J(6,o.IUserDataSyncResourceEnablementService),J(7,E.ITelemetryService),J(8,o.IUserDataSyncLogService),J(9,u.IConfigurationService)],t),e.AbstractSynchroniser=t;let r=class extends t{constructor(l,h,d,v,A,O,p,U,F,z,H){super(h,d,v,A,O,p,U,F,z,H);this.file=l,this._register(this.fileService.watch(this.extUri.dirname(l))),this._register(this.fileService.onDidFilesChange(M=>this.onFileChanges(M)))}async getLocalFileContent(){try{return await this.fileService.readFile(this.file)}catch(l){return null}}async updateLocalFileContent(l,h,d){try{h?await this.fileService.writeFile(this.file,R.VSBuffer.fromString(l),d?void 0:h):await this.fileService.createFile(this.file,R.VSBuffer.fromString(l),{overwrite:d})}catch(v){throw v instanceof f.FileOperationError&&v.fileOperationResult===1||v instanceof f.FileOperationError&&v.fileOperationResult===3?new o.UserDataSyncError(v.message,"LocalPreconditionFailed"):v}}onFileChanges(l){!l.contains(this.file)||this.triggerLocalChange()}};r=fe([J(2,f.IFileService),J(3,S.IEnvironmentService),J(4,y.IStorageService),J(5,o.IUserDataSyncStoreService),J(6,o.IUserDataSyncBackupStoreService),J(7,o.IUserDataSyncResourceEnablementService),J(8,E.ITelemetryService),J(9,o.IUserDataSyncLogService),J(10,u.IConfigurationService)],r),e.AbstractFileSynchroniser=r;let n=class extends r{constructor(l,h,d,v,A,O,p,U,F,z,H,M){super(l,h,d,v,A,O,p,U,F,z,M);this.userDataSyncUtilService=H,this._formattingOptions=void 0}hasErrors(l){const h=[];return(0,P.parse)(l,h,{allowEmptyContent:!0,allowTrailingComma:!0}),h.length>0}getFormattingOptions(){return this._formattingOptions||(this._formattingOptions=this.userDataSyncUtilService.resolveFormattingOptions(this.file)),this._formattingOptions}};n=fe([J(2,f.IFileService),J(3,S.IEnvironmentService),J(4,y.IStorageService),J(5,o.IUserDataSyncStoreService),J(6,o.IUserDataSyncBackupStoreService),J(7,o.IUserDataSyncResourceEnablementService),J(8,E.ITelemetryService),J(9,o.IUserDataSyncLogService),J(10,o.IUserDataSyncUtilService),J(11,u.IConfigurationService)],n),e.AbstractJsonFileSynchroniser=n;let s=class{constructor(l,h,d,v){this.resource=l,this.environmentService=h,this.logService=d,this.fileService=v,this.extUri=this.fileService.hasCapability(h.userDataSyncHome,1024)?b.extUri:b.extUriIgnorePathCase,this.lastSyncResource=(0,o.getLastSyncResourceUri)(this.resource,h,b.extUri)}async initialize({ref:l,content:h}){if(!h){this.logService.info("Remote content does not exist.",this.resource);return}const d=this.parseSyncData(h);if(!d)return;if(await this.fileService.exists(this.lastSyncResource)){this.logService.info("Remote content does not exist.",this.resource);return}try{await this.doInitialize({ref:l,syncData:d})}catch(A){this.logService.error(A)}}parseSyncData(l){try{const h=JSON.parse(l);if(a(h))return h}catch(h){this.logService.error(h)}this.logService.info("Cannot parse sync data as it is not compatible with the current version.",this.resource)}async updateLastSyncUserData(l,h={}){const d={ref:l.ref,content:l.syncData?JSON.stringify(l.syncData):null,...h};await this.fileService.writeFile(this.lastSyncResource,R.VSBuffer.fromString(JSON.stringify(d)))}};s=fe([J(1,S.IEnvironmentService),J(2,o.IUserDataSyncLogService),J(3,f.IFileService)],s),e.AbstractInitializer=s}),define(Z[202],te([0,1,6,27,9,3,44,48,24,5,21,12,28,32,14,22,20,47,199,88,89,23]),function(K,e,D,L,R,T,k,P,m,b,i,C,g,w,u,S,f,I,y,E,o,a){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.AbstractExtensionsInitializer=e.ExtensionsSynchroniser=e.storeExtensionStorageState=e.getExtensionStorageState=void 0;async function t(l,h){const d=JSON.parse(l.content);if(l.version===1||l.version===2){const v=(await h.getInstalled(0)).filter(A=>A.isBuiltin);for(const A of d)l.version===1&&(A.enabled===!1&&(A.disabled=!0),delete A.enabled),l.version===2&&v.every(O=>!(0,w.areSameExtensions)(O.identifier,A.identifier))&&(A.installed=!0)}return d}function r(l,h,d){const v=d.get((0,w.getExtensionId)(l,h),0)||"{}";return JSON.parse(v)}e.getExtensionStorageState=r;function n(l,h,d,v){v.store((0,w.getExtensionId)(l,h),JSON.stringify(d),0,1)}e.storeExtensionStorageState=n;let s=class ut extends I.AbstractSynchroniser{constructor(h,d,v,A,O,p,U,F,z,H,M,j,q,x){super("extensions",d,h,v,A,O,j,q,z,M);this.storageService=v,this.extensionManagementService=p,this.extensionEnablementService=U,this.ignoredExtensionsManagementService=F,this.extensionGalleryService=H,this.extensionsStorageSyncService=x,this.version=5,this.previewResource=this.extUri.joinPath(this.syncPreviewFolder,"extensions.json"),this.localResource=this.previewResource.with({scheme:a.USER_DATA_SYNC_SCHEME,authority:"local"}),this.remoteResource=this.previewResource.with({scheme:a.USER_DATA_SYNC_SCHEME,authority:"remote"}),this.acceptedResource=this.previewResource.with({scheme:a.USER_DATA_SYNC_SCHEME,authority:"accepted"}),this._register(T.Event.debounce(T.Event.any(T.Event.filter(this.extensionManagementService.onDidInstallExtensions,$=>$.some(({local:N})=>!!N)),T.Event.filter(this.extensionManagementService.onDidUninstallExtension,$=>!$.error),this.extensionEnablementService.onDidChangeEnablement,this.extensionsStorageSyncService.onDidChangeExtensionsStorage),()=>{},500)(()=>this.triggerLocalChange()))}isEnabled(){return super.isEnabled()&&this.extensionGalleryService.isEnabled()}async generateSyncPreview(h,d){const v=h.syncData?await t(h.syncData,this.extensionManagementService):null,A=d?.skippedExtensions||[],O=d?.syncData?await t(d.syncData,this.extensionManagementService):null,p=await this.extensionManagementService.getInstalled(),U=this.getLocalExtensions(p),F=this.ignoredExtensionsManagementService.getIgnoredExtensions(p);v?this.logService.trace(`${this.syncResourceLogLabel}: Merging remote extensions with local extensions...`):this.logService.trace(`${this.syncResourceLogLabel}: Remote extensions does not exist. Synchronizing extensions for the first time.`);const{local:z,remote:H}=(0,y.merge)(U,v,O,A,F),M={local:z,remote:H,content:this.getPreviewContent(U,z.added,z.updated,z.removed),localChange:z.added.length>0||z.removed.length>0||z.updated.length>0?2:0,remoteChange:H!==null?2:0};return[{skippedExtensions:A,localResource:this.localResource,localContent:this.format(U),localExtensions:U,remoteResource:this.remoteResource,remoteContent:v?this.format(v):null,previewResource:this.previewResource,previewResult:M,localChange:M.localChange,remoteChange:M.remoteChange,acceptedResource:this.acceptedResource}]}getPreviewContent(h,d,v,A){const O=[...d,...v],p=new Set,U=F=>{p.add(F.id.toLowerCase()),F.uuid&&p.add(F.uuid)};O.forEach(({identifier:F})=>U(F)),A.forEach(U);for(const F of h)p.has(F.identifier.id.toLowerCase())||F.identifier.uuid&&p.has(F.identifier.uuid)||O.push(F);return this.format(O)}async getMergeResult(h,d){return{...h.previewResult,hasConflicts:!1}}async getAcceptResult(h,d,v,A){if(this.extUri.isEqual(d,this.localResource))return this.acceptLocal(h);if(this.extUri.isEqual(d,this.remoteResource))return this.acceptRemote(h);if(this.extUri.isEqual(d,this.previewResource))return h.previewResult;throw new Error(`Invalid Resource: ${d.toString()}`)}async acceptLocal(h){const d=await this.extensionManagementService.getInstalled(),v=this.ignoredExtensionsManagementService.getIgnoredExtensions(d),A=(0,y.merge)(h.localExtensions,null,null,h.skippedExtensions,v),{local:O,remote:p}=A;return{content:h.localContent,local:O,remote:p,localChange:O.added.length>0||O.removed.length>0||O.updated.length>0?2:0,remoteChange:p!==null?2:0}}async acceptRemote(h){const d=await this.extensionManagementService.getInstalled(),v=this.ignoredExtensionsManagementService.getIgnoredExtensions(d),A=h.remoteContent?JSON.parse(h.remoteContent):null;if(A!==null){const O=(0,y.merge)(h.localExtensions,A,h.localExtensions,[],v),{local:p,remote:U}=O;return{content:h.remoteContent,local:p,remote:U,localChange:p.added.length>0||p.removed.length>0||p.updated.length>0?2:0,remoteChange:U!==null?2:0}}else return{content:h.remoteContent,local:{added:[],removed:[],updated:[]},remote:null,localChange:0,remoteChange:0}}async applyResult(h,d,v,A){let{skippedExtensions:O,localExtensions:p}=v[0][0],{local:U,remote:F,localChange:z,remoteChange:H}=v[0][1];if(z===0&&H===0&&this.logService.info(`${this.syncResourceLogLabel}: No changes found during synchronizing extensions.`),z!==0&&(await this.backupLocal(JSON.stringify(p)),O=await this.updateLocalExtensions(U.added,U.removed,U.updated,O)),F){this.logService.trace(`${this.syncResourceLogLabel}: Updating remote extensions...`);const M=JSON.stringify(F.all);h=await this.updateRemoteUserData(M,A?null:h.ref),this.logService.info(`${this.syncResourceLogLabel}: Updated remote extensions.${F.added.length?` Added: ${JSON.stringify(F.added.map(j=>j.identifier.id))}.`:""}${F.updated.length?` Updated: ${JSON.stringify(F.updated.map(j=>j.identifier.id))}.`:""}${F.removed.length?` Removed: ${JSON.stringify(F.removed.map(j=>j.identifier.id))}.`:""}`)}d?.ref!==h.ref&&(this.logService.trace(`${this.syncResourceLogLabel}: Updating last synchronized extensions...`),await this.updateLastSyncUserData(h,{skippedExtensions:O}),this.logService.info(`${this.syncResourceLogLabel}: Updated last synchronized extensions.${O.length?` Skipped: ${JSON.stringify(O.map(M=>M.identifier.id))}.`:""}`))}async getAssociatedResources({uri:h}){return[{resource:this.extUri.joinPath(h,"extensions.json"),comparableResource:ut.EXTENSIONS_DATA_URI}]}async resolveContent(h){if(this.extUri.isEqual(h,ut.EXTENSIONS_DATA_URI)){const v=await this.extensionManagementService.getInstalled(),A=this.ignoredExtensionsManagementService.getIgnoredExtensions(v),O=this.getLocalExtensions(v).filter(p=>!A.some(U=>(0,w.areSameExtensions)({id:U},p.identifier)));return this.format(O)}if(this.extUri.isEqual(this.remoteResource,h)||this.extUri.isEqual(this.localResource,h)||this.extUri.isEqual(this.acceptedResource,h))return this.resolvePreviewContent(h);let d=await super.resolveContent(h);if(d)return d;if(d=await super.resolveContent(this.extUri.dirname(h)),d){const v=this.parseSyncData(d);if(v)switch(this.extUri.basename(h)){case"extensions.json":return this.format(this.parseExtensions(v))}}return null}format(h){h.sort((A,O)=>!A.identifier.uuid&&O.identifier.uuid?-1:A.identifier.uuid&&!O.identifier.uuid?1:(0,m.compare)(A.identifier.id,O.identifier.id));const d=JSON.stringify(h),v=(0,P.format)(d,void 0,{});return(0,k.applyEdits)(d,v)}async hasLocalData(){try{const h=await this.extensionManagementService.getInstalled();if(this.getLocalExtensions(h).some(v=>v.installed||v.disabled))return!0}catch(h){}return!1}async updateLocalExtensions(h,d,v,A){const O=[],p=[],U=await this.extensionManagementService.getInstalled();if(d.length){const z=U.filter(({identifier:H,isBuiltin:M})=>!M&&d.some(j=>(0,w.areSameExtensions)(H,j)));await D.Promises.settled(z.map(async H=>{this.logService.trace(`${this.syncResourceLogLabel}: Uninstalling local extension...`,H.identifier.id),await this.extensionManagementService.uninstall(H,{donotIncludePack:!0,donotCheckDependents:!0}),this.logService.info(`${this.syncResourceLogLabel}: Uninstalled local extension.`,H.identifier.id),O.push(H.identifier)}))}(h.length||v.length)&&await D.Promises.settled([...h,...v].map(async z=>{const H=U.find(j=>(0,w.areSameExtensions)(j.identifier,z.identifier));if(H&&H.isBuiltin){z.state&&H.manifest.version===z.version&&this.updateExtensionState(z.state,H.manifest.publisher,H.manifest.name,H.manifest.version),z.disabled?(this.logService.trace(`${this.syncResourceLogLabel}: Disabling extension...`,z.identifier.id),await this.extensionEnablementService.disableExtension(z.identifier),this.logService.info(`${this.syncResourceLogLabel}: Disabled extension`,z.identifier.id)):(this.logService.trace(`${this.syncResourceLogLabel}: Enabling extension...`,z.identifier.id),await this.extensionEnablementService.enableExtension(z.identifier),this.logService.info(`${this.syncResourceLogLabel}: Enabled extension`,z.identifier.id)),O.push(z.identifier);return}const M=(await this.extensionGalleryService.getExtensions([z.identifier],L.CancellationToken.None))[0];if(z.state&&(H?H.manifest.version===z.version:!!M)){const j=H?H.manifest.publisher:M.publisher,q=H?H.manifest.name:M.name;this.updateExtensionState(z.state,j,q,H?.manifest.version)}if(M)try{z.disabled?(this.logService.trace(`${this.syncResourceLogLabel}: Disabling extension...`,z.identifier.id,M.version),await this.extensionEnablementService.disableExtension(M.identifier),this.logService.info(`${this.syncResourceLogLabel}: Disabled extension`,z.identifier.id,M.version)):(this.logService.trace(`${this.syncResourceLogLabel}: Enabling extension...`,z.identifier.id,M.version),await this.extensionEnablementService.enableExtension(M.identifier),this.logService.info(`${this.syncResourceLogLabel}: Enabled extension`,z.identifier.id,M.version)),H||(await this.extensionManagementService.canInstall(M)?(this.logService.trace(`${this.syncResourceLogLabel}: Installing extension...`,z.identifier.id,M.version),await this.extensionManagementService.installFromGallery(M,{isMachineScoped:!1,donotIncludePackAndDependencies:!0}),this.logService.info(`${this.syncResourceLogLabel}: Installed extension.`,z.identifier.id,M.version),O.push(M.identifier)):(this.logService.info(`${this.syncResourceLogLabel}: Skipped synchronizing extension because it cannot be installed.`,M.displayName||M.identifier.id),p.push(z)))}catch(j){p.push(z),j instanceof g.ExtensionManagementError&&j.code===g.INSTALL_ERROR_INCOMPATIBLE?this.logService.info(`${this.syncResourceLogLabel}: Skipped synchronizing extension because the compatible extension is not found.`,M.displayName||M.identifier.id):(this.logService.error(j),this.logService.info(`${this.syncResourceLogLabel}: Skipped synchronizing extension`,M.displayName||M.identifier.id))}else p.push(z),this.logService.info(`${this.syncResourceLogLabel}: Skipped synchronizing extension because the extension is not found.`,z.identifier.id)}));const F=[];for(const z of A)O.some(H=>(0,w.areSameExtensions)(H,z.identifier))||F.push(z);for(const z of p)F.some(H=>(0,w.areSameExtensions)(H.identifier,z.identifier))||F.push(z);return F}updateExtensionState(h,d,v,A){const O=r(d,v,this.storageService),p=A?this.extensionsStorageSyncService.getKeysForSync({id:(0,w.getGalleryExtensionId)(d,v),version:A}):void 0;p?p.forEach(U=>{O[U]=h[U]}):Object.keys(h).forEach(U=>O[U]=h[U]),n(d,v,O,this.storageService)}parseExtensions(h){return JSON.parse(h.content)}getLocalExtensions(h){const d=this.extensionEnablementService.getDisabledExtensions();return h.map(({identifier:v,isBuiltin:A,manifest:O})=>{const p={identifier:v,version:O.version};d.some(U=>(0,w.areSameExtensions)(U,v))&&(p.disabled=!0),A||(p.installed=!0);try{const U=this.extensionsStorageSyncService.getKeysForSync({id:v.id,version:O.version});if(U){const F=r(O.publisher,O.name,this.storageService);p.state=Object.keys(F).reduce((z,H)=>(U.includes(H)&&(z[H]=F[H]),z),{})}}catch(U){this.logService.info(`${this.syncResourceLogLabel}: Error while parsing extension state`,(0,R.getErrorMessage)(U))}return p})}};s.EXTENSIONS_DATA_URI=b.URI.from({scheme:a.USER_DATA_SYNC_SCHEME,authority:"extensions",path:"/extensions.json"}),s=fe([J(0,C.IEnvironmentService),J(1,u.IFileService),J(2,S.IStorageService),J(3,a.IUserDataSyncStoreService),J(4,a.IUserDataSyncBackupStoreService),J(5,g.IExtensionManagementService),J(6,g.IGlobalExtensionEnablementService),J(7,o.IIgnoredExtensionsManagementService),J(8,a.IUserDataSyncLogService),J(9,g.IExtensionGalleryService),J(10,i.IConfigurationService),J(11,a.IUserDataSyncResourceEnablementService),J(12,f.ITelemetryService),J(13,E.IExtensionsStorageSyncService)],s),e.ExtensionsSynchroniser=s;let c=class extends I.AbstractInitializer{constructor(h,d,v,A,O){super("extensions",A,O,v);this.extensionManagementService=h,this.ignoredExtensionsManagementService=d}async parseExtensions(h){return h.syncData?await t(h.syncData,this.extensionManagementService):null}generatePreview(h,d){const v=[],A=[],O=[];for(const p of h){if(this.ignoredExtensionsManagementService.hasToNeverSyncExtension(p.identifier.id))continue;const U=d.find(F=>(0,w.areSameExtensions)(F.identifier,p.identifier));U?(v.push(U),p.disabled&&O.push(p.identifier)):p.installed&&(A.push(p.identifier),p.disabled&&O.push(p.identifier))}return{installedExtensions:v,newExtensions:A,disabledExtensions:O,remoteExtensions:h}}};c=fe([J(0,g.IExtensionManagementService),J(1,o.IIgnoredExtensionsManagementService),J(2,u.IFileService),J(3,C.IEnvironmentService),J(4,a.IUserDataSyncLogService)],c),e.AbstractExtensionsInitializer=c}),define(Z[203],te([0,1,26,23]),function(K,e,D,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.merge=void 0;function R(P,m,b,i,C){if(!m)return{remote:Object.keys(P).length>0?P:null,local:{added:{},removed:[],updated:{}}};const g=T(P,m);if(g.added.size===0&&g.removed.size===0&&g.updated.size===0)return{remote:null,local:{added:{},removed:[],updated:{}}};const w=b?T(b,m):{added:Object.keys(m).reduce((y,E)=>(y.add(E),y),new Set),removed:new Set,updated:new Set},u=b?T(b,P):{added:Object.keys(P).reduce((y,E)=>(y.add(E),y),new Set),removed:new Set,updated:new Set},S={added:{},removed:[],updated:{}},f=D.deepClone(m),I=!b;for(const y of u.added.values())y!==L.SYNC_SERVICE_URL_TYPE&&I&&w.added.has(y)||(f[y]=P[y]);for(const y of u.updated.values())f[y]=P[y];for(const y of u.removed.values())i.unregistered.includes(y)||delete f[y];for(const y of w.added.values()){const E=m[y];if(i.machine.includes(y)){C.info(`GlobalState: Skipped adding ${y} in local storage because it is declared as machine scoped.`);continue}if(b&&u.added.has(y))continue;const o=P[y];o&&o.value===E.value||y===L.SYNC_SERVICE_URL_TYPE&&I&&u.added.has(y)||(o?S.updated[y]=E:S.added[y]=E)}for(const y of w.updated.values()){const E=m[y];if(i.machine.includes(y)){C.info(`GlobalState: Skipped updating ${y} in local storage because it is declared as machine scoped.`);continue}if(u.updated.has(y)||u.removed.has(y))continue;const o=P[y];o&&o.value===E.value||(S.updated[y]=E)}for(const y of w.removed.values()){if(i.machine.includes(y)){C.trace(`GlobalState: Skipped removing ${y} in local storage because it is declared as machine scoped.`);continue}u.updated.has(y)||u.removed.has(y)||S.removed.push(y)}return{local:S,remote:k(f,m)?null:f}}e.merge=R;function T(P,m){const b=Object.keys(P),i=Object.keys(m),C=i.filter(u=>b.indexOf(u)===-1).reduce((u,S)=>(u.add(S),u),new Set),g=b.filter(u=>i.indexOf(u)===-1).reduce((u,S)=>(u.add(S),u),new Set),w=new Set;for(const u of b){if(g.has(u))continue;const S=P[u],f=m[u];D.equals(S,f)||w.add(u)}return{added:C,removed:g,updated:w}}function k(P,m){const{added:b,removed:i,updated:C}=T(P,m);return b.size===0&&i.size===0&&C.size===0}}),define(Z[204],te([0,1,25,3,34,44,48,4,5,30,21,12,14,13,45,22,20,47,54,203,23]),function(K,e,D,L,R,T,k,P,m,b,i,C,g,w,u,S,f,I,y,E,o){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.UserDataSyncStoreTypeSynchronizer=e.GlobalStateInitializer=e.GlobalStateSynchroniser=void 0;const a="globalState.argv.",t=["locale"];function r(h){const d=h.storage?Object.keys(h.storage).sort():[],v={};d.forEach(p=>v[p]=h.storage[p]),h.storage=v;const A=JSON.stringify(h),O=(0,k.format)(A,void 0,{});return(0,T.applyEdits)(A,O)}const n=1;let s=class ht extends I.AbstractSynchroniser{constructor(d,v,A,O,p,U,F,z,H){super("globalState",d,p,H,v,A,U,F,O,z);this.storageService=H,this.version=n,this.previewResource=this.extUri.joinPath(this.syncPreviewFolder,"globalState.json"),this.localResource=this.previewResource.with({scheme:o.USER_DATA_SYNC_SCHEME,authority:"local"}),this.remoteResource=this.previewResource.with({scheme:o.USER_DATA_SYNC_SCHEME,authority:"remote"}),this.acceptedResource=this.previewResource.with({scheme:o.USER_DATA_SYNC_SCHEME,authority:"accepted"}),this._register(d.watch(this.extUri.dirname(this.environmentService.argvResource))),this._register(L.Event.any(L.Event.filter(d.onDidFilesChange,M=>M.contains(this.environmentService.argvResource)),L.Event.filter(H.onDidChangeValue,M=>M.scope===0&&M.target!==void 0?M.target===0:H.keys(0,0).includes(M.key)),this.storageService.onDidChangeTarget)(()=>this.triggerLocalChange()))}async generateSyncPreview(d,v,A,O){const p=d.syncData?JSON.parse(d.syncData.content):null;v=v===null&&A?d:v;const U=v&&v.syncData?JSON.parse(v.syncData.content):null,F=await this.getLocalGlobalState();p?this.logService.trace(`${this.syncResourceLogLabel}: Merging remote ui state with local ui state...`):this.logService.trace(`${this.syncResourceLogLabel}: Remote ui state does not exist. Synchronizing ui state for the first time.`);const z=this.getStorageKeys(U),{local:H,remote:M}=(0,E.merge)(F.storage,p?p.storage:null,U?U.storage:null,z,this.logService),j={content:null,local:H,remote:M,localChange:Object.keys(H.added).length>0||Object.keys(H.updated).length>0||H.removed.length>0?2:0,remoteChange:M!==null?2:0};return[{localResource:this.localResource,localContent:r(F),localUserData:F,remoteResource:this.remoteResource,remoteContent:p?r(p):null,previewResource:this.previewResource,previewResult:j,localChange:j.localChange,remoteChange:j.remoteChange,acceptedResource:this.acceptedResource,storageKeys:z}]}async getMergeResult(d,v){return{...d.previewResult,hasConflicts:!1}}async getAcceptResult(d,v,A,O){if(this.extUri.isEqual(v,this.localResource))return this.acceptLocal(d);if(this.extUri.isEqual(v,this.remoteResource))return this.acceptRemote(d);if(this.extUri.isEqual(v,this.previewResource))return d.previewResult;throw new Error(`Invalid Resource: ${v.toString()}`)}async acceptLocal(d){return{content:d.localContent,local:{added:{},removed:[],updated:{}},remote:d.localUserData.storage,localChange:0,remoteChange:2}}async acceptRemote(d){if(d.remoteContent!==null){const v=JSON.parse(d.remoteContent),{local:A,remote:O}=(0,E.merge)(d.localUserData.storage,v.storage,null,d.storageKeys,this.logService);return{content:d.remoteContent,local:A,remote:O,localChange:Object.keys(A.added).length>0||Object.keys(A.updated).length>0||A.removed.length>0?2:0,remoteChange:O!==null?2:0}}else return{content:d.remoteContent,local:{added:{},removed:[],updated:{}},remote:null,localChange:0,remoteChange:0}}async applyResult(d,v,A,O){let{localUserData:p}=A[0][0],{local:U,remote:F,localChange:z,remoteChange:H}=A[0][1];if(z===0&&H===0&&this.logService.info(`${this.syncResourceLogLabel}: No changes found during synchronizing ui state.`),z!==0&&(this.logService.trace(`${this.syncResourceLogLabel}: Updating local ui state...`),await this.backupLocal(JSON.stringify(p)),await this.writeLocalGlobalState(U),this.logService.info(`${this.syncResourceLogLabel}: Updated local ui state`)),H!==0){this.logService.trace(`${this.syncResourceLogLabel}: Updating remote ui state...`);const M=JSON.stringify({storage:F});d=await this.updateRemoteUserData(M,O?null:d.ref),this.logService.info(`${this.syncResourceLogLabel}: Updated remote ui state`)}v?.ref!==d.ref&&(this.logService.trace(`${this.syncResourceLogLabel}: Updating last synchronized ui state...`),await this.updateLastSyncUserData(d),this.logService.info(`${this.syncResourceLogLabel}: Updated last synchronized ui state`))}async getAssociatedResources({uri:d}){return[{resource:this.extUri.joinPath(d,"globalState.json"),comparableResource:ht.GLOBAL_STATE_DATA_URI}]}async resolveContent(d){if(this.extUri.isEqual(d,ht.GLOBAL_STATE_DATA_URI)){const A=await this.getLocalGlobalState();return r(A)}if(this.extUri.isEqual(this.remoteResource,d)||this.extUri.isEqual(this.localResource,d)||this.extUri.isEqual(this.acceptedResource,d))return this.resolvePreviewContent(d);let v=await super.resolveContent(d);if(v)return v;if(v=await super.resolveContent(this.extUri.dirname(d)),v){const A=this.parseSyncData(v);if(A)switch(this.extUri.basename(d)){case"globalState.json":return r(JSON.parse(A.content))}}return null}async hasLocalData(){try{const{storage:d}=await this.getLocalGlobalState();if(Object.keys(d).length>1||d[`${a}.locale`]?.value!=="en")return!0}catch(d){}return!1}async getLocalGlobalState(){const d={},v=await this.getLocalArgvContent(),A=(0,R.parse)(v);for(const O of t)A[O]!==void 0&&(d[`${a}${O}`]={version:1,value:A[O]});for(const O of this.storageService.keys(0,0)){const p=this.storageService.get(O,0);p&&(d[O]={version:1,value:p})}return{storage:d}}async getLocalArgvContent(){try{return(await this.fileService.readFile(this.environmentService.argvResource)).value.toString()}catch(d){}return"{}"}async writeLocalGlobalState({added:d,removed:v,updated:A}){const O={},p={},U=(z,H)=>{for(const M of z){if(M.startsWith(a)){O[M.substring(a.length)]=H?H[M].value:void 0;continue}if(H){const j=H[M];j.value!==String(this.storageService.get(M,0))&&(p[M]=j.value)}else this.storageService.get(M,0)!==void 0&&(p[M]=void 0)}};if(U(Object.keys(d),d),U(Object.keys(A),A),U(v),Object.keys(O).length&&(this.logService.trace(`${this.syncResourceLogLabel}: Updating locale...`),await this.updateArgv(O),this.logService.info(`${this.syncResourceLogLabel}: Updated locale`)),Object.keys(p).length){this.logService.trace(`${this.syncResourceLogLabel}: Updating global state...`);for(const z of Object.keys(p))this.storageService.store(z,p[z],0,0);this.logService.info(`${this.syncResourceLogLabel}: Updated global state`,Object.keys(p))}}async updateArgv(d){const v=await this.getLocalArgvContent();let A=v;for(const O of Object.keys(d))A=(0,y.edit)(A,[O],d[O],{});v!==A&&(this.logService.trace(`${this.syncResourceLogLabel}: Updating locale...`),await this.fileService.writeFile(this.environmentService.argvResource,D.VSBuffer.fromString(A)),this.logService.info(`${this.syncResourceLogLabel}: Updated locale.`))}getStorageKeys(d){const v=this.storageService.keys(0,0),A=this.storageService.keys(0,1),O=[...v,...A],p=d?.storage?Object.keys(d.storage).filter(U=>!U.startsWith(a)&&!O.includes(U)&&this.storageService.get(U,0)!==void 0):[];if(!P.isWeb){const U=[...o.ALL_SYNC_RESOURCES.map(F=>(0,o.getEnablementKey)(F)),o.SYNC_SERVICE_URL_TYPE];p.push(...U),A.push(...U)}return{user:v,machine:A,unregistered:p}}};s.GLOBAL_STATE_DATA_URI=m.URI.from({scheme:o.USER_DATA_SYNC_SCHEME,authority:"globalState",path:"/globalState.json"}),s=fe([J(0,g.IFileService),J(1,o.IUserDataSyncStoreService),J(2,o.IUserDataSyncBackupStoreService),J(3,o.IUserDataSyncLogService),J(4,C.IEnvironmentService),J(5,o.IUserDataSyncResourceEnablementService),J(6,f.ITelemetryService),J(7,i.IConfigurationService),J(8,S.IStorageService)],s),e.GlobalStateSynchroniser=s;let c=class extends I.AbstractInitializer{constructor(d,v,A,O){super("globalState",A,O,v);this.storageService=d}async doInitialize(d){const v=d.syncData?JSON.parse(d.syncData.content):null;if(!v){this.logService.info("Skipping initializing global state because remote global state does not exist.");return}const A={},O={};for(const p of Object.keys(v.storage))p.startsWith(a)?A[p.substring(a.length)]=v.storage[p].value:this.storageService.get(p,0)===void 0&&(O[p]=v.storage[p].value);if(Object.keys(A).length){let p="{}";try{p=(await this.fileService.readFile(this.environmentService.argvResource)).value.toString()}catch(U){}for(const U of Object.keys(A))p=(0,y.edit)(p,[U],A[U],{});await this.fileService.writeFile(this.environmentService.argvResource,D.VSBuffer.fromString(p))}if(Object.keys(O).length)for(const p of Object.keys(O))this.storageService.store(p,O[p],0,0)}};c=fe([J(0,S.IStorageService),J(1,g.IFileService),J(2,C.IEnvironmentService),J(3,o.IUserDataSyncLogService)],c),e.GlobalStateInitializer=c;let l=class{constructor(d,v,A,O,p){this.userDataSyncStoreClient=d,this.storageService=v,this.environmentService=A,this.fileService=O,this.logService=p}getSyncStoreType(d){return this.parseGlobalState(d)?.storage[o.SYNC_SERVICE_URL_TYPE]?.value}async sync(d){const v=(0,o.createSyncHeaders)((0,b.generateUuid)());try{return await this.doSync(d,v)}catch(A){if(A instanceof o.UserDataSyncError)switch(A.code){case"PreconditionFailed":return this.logService.info("Failed to synchronize UserDataSyncStoreType as there is a new remote version available. Synchronizing again..."),this.doSync(d,v)}throw A}}async doSync(d,v){const A=await this.userDataSyncStoreClient.read("globalState",null,v),O=this.parseGlobalState(A)||{storage:{}};O.storage[o.SYNC_SERVICE_URL_TYPE]={value:d,version:n};const p=await(0,u.getServiceMachineId)(this.environmentService,this.fileService,this.storageService),U={version:n,machineId:p,content:r(O)};await this.userDataSyncStoreClient.write("globalState",JSON.stringify(U),A.ref,v)}parseGlobalState({content:d}){if(!d)return null;const v=JSON.parse(d);if((0,I.isSyncData)(v))return v?JSON.parse(v.content):null;throw new Error("Invalid remote data")}};l=fe([J(1,S.IStorageService),J(2,C.IEnvironmentService),J(3,g.IFileService),J(4,w.ILogService)],l),e.UserDataSyncStoreTypeSynchronizer=l}),define(Z[205],te([0,1,17,25,3,34,4,18,131,21,12,14,22,20,47,200,23]),function(K,e,D,L,R,T,k,P,m,b,i,C,g,w,u,S,f){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.KeybindingsInitializer=e.KeybindingsSynchroniser=e.getKeybindingsContentFromSyncContent=void 0;function I(o,a){const t=JSON.parse(o);if(!a)return(0,P.isUndefined)(t.all)?null:t.all;switch(k.OS){case 2:return(0,P.isUndefined)(t.mac)?null:t.mac;case 3:return(0,P.isUndefined)(t.linux)?null:t.linux;case 1:return(0,P.isUndefined)(t.windows)?null:t.windows}}e.getKeybindingsContentFromSyncContent=I;let y=class extends u.AbstractJsonFileSynchroniser{constructor(a,t,r,n,s,c,l,h,d,v){super(l.keybindingsResource,"keybindings",c,l,h,a,t,s,v,r,d,n);this.version=2,this.previewResource=this.extUri.joinPath(this.syncPreviewFolder,"keybindings.json"),this.localResource=this.previewResource.with({scheme:f.USER_DATA_SYNC_SCHEME,authority:"local"}),this.remoteResource=this.previewResource.with({scheme:f.USER_DATA_SYNC_SCHEME,authority:"remote"}),this.acceptedResource=this.previewResource.with({scheme:f.USER_DATA_SYNC_SCHEME,authority:"accepted"}),this._register(R.Event.filter(n.onDidChangeConfiguration,A=>A.affectsConfiguration("settingsSync.keybindingsPerPlatform"))(()=>this.triggerLocalChange()))}async generateSyncPreview(a,t,r,n){const s=a.syncData?this.getKeybindingsContentFromSyncContent(a.syncData.content):null;t=t===null&&r?a:t;const c=t?this.getKeybindingsContentFromLastSyncUserData(t):null,l=await this.getLocalFileContent(),h=await this.getFormattingOptions();let d=null,v=!1,A=!1,O=!1;if(s){let U=l?l.value.toString():"[]";if(U=U||"[]",this.hasErrors(U))throw new f.UserDataSyncError((0,m.localize)(0,null),"LocalInvalidContent",this.resource);if(!c||c!==U||c!==s){this.logService.trace(`${this.syncResourceLogLabel}: Merging remote keybindings with local keybindings...`);const F=await(0,S.merge)(U,s,c,h,this.userDataSyncUtilService);F.hasChanges&&(d=F.mergeContent,O=F.hasConflicts,v=O||F.mergeContent!==U,A=O||F.mergeContent!==s)}}else l&&(this.logService.trace(`${this.syncResourceLogLabel}: Remote keybindings does not exist. Synchronizing keybindings for the first time.`),d=l.value.toString(),A=!0);const p={content:d,localChange:v?l?2:1:0,remoteChange:A?2:0,hasConflicts:O};return[{fileContent:l,localResource:this.localResource,localContent:l?l.value.toString():null,localChange:p.localChange,remoteResource:this.remoteResource,remoteContent:s,remoteChange:p.remoteChange,previewResource:this.previewResource,previewResult:p,acceptedResource:this.acceptedResource}]}async getMergeResult(a,t){return a.previewResult}async getAcceptResult(a,t,r,n){if(this.extUri.isEqual(t,this.localResource))return{content:a.fileContent?a.fileContent.value.toString():null,localChange:0,remoteChange:2};if(this.extUri.isEqual(t,this.remoteResource))return{content:a.remoteContent,localChange:2,remoteChange:0};if(this.extUri.isEqual(t,this.previewResource))return r===void 0?{content:a.previewResult.content,localChange:a.previewResult.localChange,remoteChange:a.previewResult.remoteChange}:{content:r,localChange:2,remoteChange:2};throw new Error(`Invalid Resource: ${t.toString()}`)}async applyResult(a,t,r,n){const{fileContent:s}=r[0][0];let{content:c,localChange:l,remoteChange:h}=r[0][1];if(l===0&&h===0&&this.logService.info(`${this.syncResourceLogLabel}: No changes found during synchronizing keybindings.`),c!==null&&(c=c.trim(),c=c||"[]",this.hasErrors(c)))throw new f.UserDataSyncError((0,m.localize)(1,null),"LocalInvalidContent",this.resource);if(l!==0&&(this.logService.trace(`${this.syncResourceLogLabel}: Updating local keybindings...`),s&&await this.backupLocal(this.toSyncContent(s.value.toString())),await this.updateLocalFileContent(c||"[]",s,n),this.logService.info(`${this.syncResourceLogLabel}: Updated local keybindings`)),h!==0){this.logService.trace(`${this.syncResourceLogLabel}: Updating remote keybindings...`);const d=this.toSyncContent(c||"[]",a.syncData?.content);a=await this.updateRemoteUserData(d,n?null:a.ref),this.logService.info(`${this.syncResourceLogLabel}: Updated remote keybindings`)}try{await this.fileService.del(this.previewResource)}catch(d){}t?.ref!==a.ref&&(this.logService.trace(`${this.syncResourceLogLabel}: Updating last synchronized keybindings...`),await this.updateLastSyncUserData(a,{platformSpecific:this.syncKeybindingsPerPlatform()}),this.logService.info(`${this.syncResourceLogLabel}: Updated last synchronized keybindings`))}async hasLocalData(){try{const a=await this.getLocalFileContent();if(a){const t=(0,T.parse)(a.value.toString());if((0,D.isNonEmptyArray)(t))return!0}}catch(a){if(a.fileOperationResult!==1)return!0}return!1}async getAssociatedResources({uri:a}){const t=await this.fileService.exists(this.file)?this.file:this.localResource;return[{resource:this.extUri.joinPath(a,"keybindings.json"),comparableResource:t}]}async resolveContent(a){if(this.extUri.isEqual(this.remoteResource,a)||this.extUri.isEqual(this.localResource,a)||this.extUri.isEqual(this.acceptedResource,a))return this.resolvePreviewContent(a);let t=await super.resolveContent(a);if(t)return t;if(t=await super.resolveContent(this.extUri.dirname(a)),t){const r=this.parseSyncData(t);if(r)switch(this.extUri.basename(a)){case"keybindings.json":return this.getKeybindingsContentFromSyncContent(r.content)}}return null}getKeybindingsContentFromLastSyncUserData(a){return!a.syncData||a.platformSpecific!==void 0&&a.platformSpecific!==this.syncKeybindingsPerPlatform()?null:this.getKeybindingsContentFromSyncContent(a.syncData.content)}getKeybindingsContentFromSyncContent(a){try{return I(a,this.syncKeybindingsPerPlatform())}catch(t){return this.logService.error(t),null}}toSyncContent(a,t){let r={};try{r=JSON.parse(t||"{}")}catch(n){this.logService.error(n)}switch(this.syncKeybindingsPerPlatform()?delete r.all:r.all=a,k.OS){case 2:r.mac=a;break;case 3:r.linux=a;break;case 1:r.windows=a;break}return JSON.stringify(r)}syncKeybindingsPerPlatform(){return!!this.configurationService.getValue("settingsSync.keybindingsPerPlatform")}};y=fe([J(0,f.IUserDataSyncStoreService),J(1,f.IUserDataSyncBackupStoreService),J(2,f.IUserDataSyncLogService),J(3,b.IConfigurationService),J(4,f.IUserDataSyncResourceEnablementService),J(5,C.IFileService),J(6,i.IEnvironmentService),J(7,g.IStorageService),J(8,f.IUserDataSyncUtilService),J(9,w.ITelemetryService)],y),e.KeybindingsSynchroniser=y;let E=class extends u.AbstractInitializer{constructor(a,t,r){super("keybindings",t,r,a)}async doInitialize(a){const t=a.syncData?this.getKeybindingsContentFromSyncContent(a.syncData.content):null;if(!t){this.logService.info("Skipping initializing keybindings because remote keybindings does not exist.");return}if(!await this.isEmpty()){this.logService.info("Skipping initializing keybindings because local keybindings exist.");return}await this.fileService.writeFile(this.environmentService.keybindingsResource,L.VSBuffer.fromString(t)),await this.updateLastSyncUserData(a)}async isEmpty(){try{const a=await this.fileService.readFile(this.environmentService.settingsResource),t=(0,T.parse)(a.value.toString());return!(0,D.isNonEmptyArray)(t)}catch(a){return a.fileOperationResult===1}}getKeybindingsContentFromSyncContent(a){try{return I(a,!0)}catch(t){return this.logService.error(t),null}}};E=fe([J(0,C.IFileService),J(1,i.IEnvironmentService),J(2,f.IUserDataSyncLogService)],E),e.KeybindingsInitializer=E}),define(Z[206],te([0,1,17,34,44,48,26,54,23]),function(K,e,D,L,R,T,k,P,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.addSetting=e.isEmpty=e.areSame=e.merge=e.updateIgnoredSettings=e.getIgnoredSettings=void 0;function b(l,h,d){let v=[];d?v=C(d):v=i(h);const A=[],O=[...(0,m.getDisallowedIgnoredSettings)()];if(Array.isArray(v))for(const p of v)p.startsWith("-")?O.push(p.substring(1)):A.push(p);return(0,D.distinct)([...l,...A].filter(p=>O.indexOf(p)===-1))}e.getIgnoredSettings=b;function i(l){let h=l.inspect("settingsSync.ignoredSettings").userValue;return h!==void 0||(h=l.inspect("sync.ignoredSettings").userValue,h!==void 0)?h:l.getValue("settingsSync.ignoredSettings")||[]}function C(l){const h=(0,L.parse)(l);return h?h["settingsSync.ignoredSettings"]||h["sync.ignoredSettings"]||[]:[]}function g(l,h,d,v){if(d.length){const A=c(h),O=(0,L.parse)(h),p=(0,L.parse)(l),U=[];for(const F of d){const z=O[F],H=p[F];z===void 0?l=P.edit(l,[F],void 0,v):H!==void 0?l=P.edit(l,[F],z,v):U.push(a(F,A))}U.sort((F,z)=>F.startOffset-z.startOffset),U.forEach(F=>l=I(F.setting.key,h,l,v))}return l}e.updateIgnoredSettings=g;function w(l,h,d,v,A,O){const p=g(l,h,v,O),U=d!==p,F=d!==h;if(!U&&!F)return{conflictsSettings:[],localContent:null,remoteContent:null,hasConflicts:!1};if(U&&!F)return{conflictsSettings:[],localContent:null,remoteContent:p,hasConflicts:!1};if(F&&!U)return{conflictsSettings:[],localContent:g(h,l,v,O),remoteContent:null,hasConflicts:!1};if(d===null&&S(l)){const B=u(l,h,v)?null:g(h,l,v,O);return{conflictsSettings:[],localContent:B,remoteContent:null,hasConflicts:!1}}let z=l,H=h;const M=(0,L.parse)(l),j=(0,L.parse)(h),q=d?(0,L.parse)(d):null,x=v.reduce((B,re)=>(B.add(re),B),new Set),$=f(M,j,x),N=f(q,M,x),W=f(q,j,x),_=new Map,Y=new Set,G=B=>{Y.add(B);const re=A.filter(({key:ie})=>ie===B)[0];re?(z=P.edit(z,[B],re.value,O),H=P.edit(H,[B],re.value,O)):_.set(B,{key:B,localValue:M[B],remoteValue:j[B]})};for(const B of N.removed.values())W.updated.has(B)?G(B):H=P.edit(H,[B],void 0,O);for(const B of W.removed.values())Y.has(B)||(N.updated.has(B)?G(B):z=P.edit(z,[B],void 0,O));for(const B of N.updated.values())Y.has(B)||(W.updated.has(B)?$.updated.has(B)&&G(B):H=P.edit(H,[B],M[B],O));for(const B of W.updated.values())Y.has(B)||(N.updated.has(B)?$.updated.has(B)&&G(B):z=P.edit(z,[B],j[B],O));for(const B of N.added.values())Y.has(B)||(W.added.has(B)?$.updated.has(B)&&G(B):H=I(B,z,H,O));for(const B of W.added.values())Y.has(B)||(N.added.has(B)?$.updated.has(B)&&G(B):z=I(B,H,z,O));const ne=_.size>0||!u(z,H,v),ee=ne||!u(z,l,[]),X=ne||!u(H,h,[]);return{localContent:ee?z:null,remoteContent:X?H:null,conflictsSettings:[..._.values()],hasConflicts:ne}}e.merge=w;function u(l,h,d){if(l===h)return!0;const v=(0,L.parse)(l),A=(0,L.parse)(h),O=d.reduce((F,z)=>(F.add(z),F),new Set),p=c(l).filter(F=>!(F.setting&&O.has(F.setting.key))),U=c(h).filter(F=>!(F.setting&&O.has(F.setting.key)));if(p.length!==U.length)return!1;for(let F=0;F<p.length;F++){const z=p[F],H=U[F];if(z.setting&&H.setting){if(z.setting.key!==H.setting.key||!k.equals(v[z.setting.key],A[z.setting.key]))return!1}else if(!z.setting&&!H.setting){if(z.value!==H.value)return!1}else return!1}return!0}e.areSame=u;function S(l){return l?c(l).length===0:!0}e.isEmpty=S;function f(l,h,d){const v=l?Object.keys(l).filter(F=>!d.has(F)):[],A=Object.keys(h).filter(F=>!d.has(F)),O=A.filter(F=>v.indexOf(F)===-1).reduce((F,z)=>(F.add(z),F),new Set),p=v.filter(F=>A.indexOf(F)===-1).reduce((F,z)=>(F.add(z),F),new Set),U=new Set;if(l)for(const F of v){if(p.has(F))continue;const z=l[F],H=h[F];k.equals(z,H)||U.add(F)}return{added:O,removed:p,updated:U}}function I(l,h,d,v){const A=(0,L.parse)(h),O=c(h),p=c(d),U=y(l,O,p);return E(d,l,A[l],U,p,v)}e.addSetting=I;function y(l,h,d){const v=h.findIndex(O=>O.setting?.key===l),A=h[v-1];if(A){if(A.setting){const p=a(A.setting.key,d);if(p)return{index:d.indexOf(p),insertAfter:!0}}else{const p=t(v,h);if(p){const U=a(p.setting.key,d);if(U){const F=r(d.indexOf(U),d),z=n(h,p,h[v]);if(F){const H=n(d,U,F),M=s(z,H);return M?{index:d.indexOf(M),insertAfter:!0}:{index:d.indexOf(F),insertAfter:!1}}else{const H=n(d,U,d[d.length-1]),M=s(z,H);return M?{index:d.indexOf(M),insertAfter:!0}:{index:d.length-1,insertAfter:!0}}}}}const O=h[v+1];if(O)if(O.setting){const p=a(O.setting.key,d);if(p)return{index:d.indexOf(p),insertAfter:!1}}else{const p=r(v,h);if(p){const U=a(p.setting.key,d);if(U){const F=t(d.indexOf(U),d),z=n(h,h[v],p);if(F){const H=n(d,F,U),M=s(z.reverse(),H.reverse());return M?{index:d.indexOf(M),insertAfter:!1}:{index:d.indexOf(F),insertAfter:!0}}else{const H=n(d,d[0],U),M=s(z.reverse(),H.reverse());return M?{index:d.indexOf(M),insertAfter:!1}:{index:0,insertAfter:!1}}}}}}return{index:d.length-1,insertAfter:!0}}function E(l,h,d,v,A,O){let p;return v.index===-1?p=(0,R.setProperty)(l,[h],d,O):p=o(l,h,d,v,A,O).map(U=>(0,R.withFormatting)(l,U,O)[0]),(0,R.applyEdits)(l,p)}function o(l,h,d,v,A,O){const p=`${JSON.stringify(h)}: ${JSON.stringify(d)}`,U=(0,T.getEOL)(O,l),F=A[v.index];if(v.insertAfter){const z=[];if(F.setting)z.push({offset:F.endOffset,length:0,content:","+p});else{const H=r(v.index,A),M=t(v.index,A),j=M?.setting?.commaOffset;M&&j===void 0&&z.push({offset:M.endOffset,length:0,content:","});const q=j!==void 0&&j>F.endOffset;z.push({offset:q?j+1:F.endOffset,length:0,content:H?U+p+",":U+p})}return z}else{if(F.setting)return[{offset:F.startOffset,length:0,content:p+","}];const z=(A[v.index-1]&&!A[v.index-1].setting?U:"")+p+(r(v.index,A)?",":"")+U;return[{offset:F.startOffset,length:0,content:z}]}}function a(l,h){return h.filter(d=>d.setting?.key===l)[0]}function t(l,h){for(let d=l-1;d>=0;d--)if(h[d].setting)return h[d]}function r(l,h){for(let d=l+1;d<h.length;d++)if(h[d].setting)return h[d]}function n(l,h,d){const v=l.indexOf(h),A=l.indexOf(d);return l.filter((O,p)=>v<p&&p<A)}function s(l,h){if(l.length&&h.length){let d=0;for(;d<h.length&&d<l.length;d++)if(l[d].value!==h[d].value)return h[d-1];return h[d-1]}}function c(l){const h=[];let d=-1,v,A;const O={onObjectBegin:p=>{d++},onObjectProperty:(p,U,F)=>{d===0&&(v=U,A=p)},onObjectEnd:(p,U)=>{d--,d===0&&h.push({startOffset:v,endOffset:p+U,value:l.substring(v,p+U),setting:{key:A,commaOffset:void 0}})},onArrayBegin:(p,U)=>{d++},onArrayEnd:(p,U)=>{d--,d===0&&h.push({startOffset:v,endOffset:p+U,value:l.substring(v,p+U),setting:{key:A,commaOffset:void 0}})},onLiteralValue:(p,U,F)=>{d===0&&h.push({startOffset:v,endOffset:U+F,value:l.substring(v,U+F),setting:{key:A,commaOffset:void 0}})},onSeparator:(p,U,F)=>{if(d===0&&p===","){let z=h.length-1;for(;z>=0&&!h[z].setting;z--);const H=h[z];H&&h.splice(z,1,{startOffset:H.startOffset,endOffset:H.endOffset,value:H.value,setting:{key:H.setting.key,commaOffset:U}})}},onComment:(p,U)=>{d===0&&h.push({startOffset:p,endOffset:p+U,value:l.substring(p,p+U)})}};return(0,L.visit)(l,O),h}}),define(Z[207],te([0,1,25,3,44,132,21,12,28,14,22,20,47,54,206,23]),function(K,e,D,L,R,T,k,P,m,b,i,C,g,w,u,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.SettingsInitializer=e.SettingsSynchroniser=e.parseSettingsSyncContent=void 0;function f(a){return a&&a.settings&&typeof a.settings=="string"&&Object.keys(a).length===1}function I(a){const t=JSON.parse(a);return f(t)?t:{settings:a}}e.parseSettingsSyncContent=I;let y=class extends g.AbstractJsonFileSynchroniser{constructor(t,r,n,s,c,l,h,d,v,A,O){super(r.settingsResource,"settings",t,r,n,s,c,v,A,l,h,d);this.extensionManagementService=O,this.version=2,this.previewResource=this.extUri.joinPath(this.syncPreviewFolder,"settings.json"),this.localResource=this.previewResource.with({scheme:S.USER_DATA_SYNC_SCHEME,authority:"local"}),this.remoteResource=this.previewResource.with({scheme:S.USER_DATA_SYNC_SCHEME,authority:"remote"}),this.acceptedResource=this.previewResource.with({scheme:S.USER_DATA_SYNC_SCHEME,authority:"accepted"}),this._defaultIgnoredSettings=void 0}async generateSyncPreview(t,r,n,s){const c=await this.getLocalFileContent(),l=await this.getFormattingOptions(),h=this.getSettingsSyncContent(t);r=r===null&&n?t:r;const d=r?this.getSettingsSyncContent(r):null,v=await this.getIgnoredSettings();let A=null,O=!1,p=!1,U=!1;if(h){let z=c?c.value.toString().trim():"{}";z=z||"{}",this.validateContent(z),this.logService.trace(`${this.syncResourceLogLabel}: Merging remote settings with local settings...`);const H=(0,u.merge)(z,h.settings,d?d.settings:null,v,[],l);A=H.localContent||H.remoteContent,O=H.localContent!==null,p=H.remoteContent!==null,U=H.hasConflicts}else c&&(this.logService.trace(`${this.syncResourceLogLabel}: Remote settings does not exist. Synchronizing settings for the first time.`),A=c.value.toString(),p=!0);const F={content:A,localChange:O?2:0,remoteChange:p?2:0,hasConflicts:U};return[{fileContent:c,localResource:this.localResource,localContent:c?c.value.toString():null,localChange:F.localChange,remoteResource:this.remoteResource,remoteContent:h?h.settings:null,remoteChange:F.remoteChange,previewResource:this.previewResource,previewResult:F,acceptedResource:this.acceptedResource}]}async getMergeResult(t,r){const n=await this.getFormattingOptions(),s=await this.getIgnoredSettings();return{...t.previewResult,content:t.previewResult.content?(0,u.updateIgnoredSettings)(t.previewResult.content,"{}",s,n):null}}async getAcceptResult(t,r,n,s){const c=await this.getFormattingOptions(),l=await this.getIgnoredSettings();if(this.extUri.isEqual(r,this.localResource))return{content:t.fileContent?(0,u.updateIgnoredSettings)(t.fileContent.value.toString(),"{}",l,c):null,localChange:0,remoteChange:2};if(this.extUri.isEqual(r,this.remoteResource))return{content:t.remoteContent!==null?(0,u.updateIgnoredSettings)(t.remoteContent,t.fileContent?t.fileContent.value.toString():"{}",l,c):null,localChange:2,remoteChange:0};if(this.extUri.isEqual(r,this.previewResource))return n===void 0?{content:t.previewResult.content,localChange:t.previewResult.localChange,remoteChange:t.previewResult.remoteChange}:{content:n!==null?(0,u.updateIgnoredSettings)(n,t.fileContent?t.fileContent.value.toString():"{}",l,c):null,localChange:2,remoteChange:2};throw new Error(`Invalid Resource: ${r.toString()}`)}async applyResult(t,r,n,s){const{fileContent:c}=n[0][0];let{content:l,localChange:h,remoteChange:d}=n[0][1];if(h===0&&d===0&&this.logService.info(`${this.syncResourceLogLabel}: No changes found during synchronizing settings.`),l=l?l.trim():"{}",l=l||"{}",this.validateContent(l),h!==0&&(this.logService.trace(`${this.syncResourceLogLabel}: Updating local settings...`),c&&await this.backupLocal(JSON.stringify(this.toSettingsSyncContent(c.value.toString()))),await this.updateLocalFileContent(l,c,s),await this.configurationService.reloadConfiguration(2),this.logService.info(`${this.syncResourceLogLabel}: Updated local settings`)),d!==0){const v=await this.getFormattingOptions(),A=this.getSettingsSyncContent(t),O=await this.getIgnoredSettings(l);l=(0,u.updateIgnoredSettings)(l,A?A.settings:"{}",O,v),this.logService.trace(`${this.syncResourceLogLabel}: Updating remote settings...`),t=await this.updateRemoteUserData(JSON.stringify(this.toSettingsSyncContent(l)),s?null:t.ref),this.logService.info(`${this.syncResourceLogLabel}: Updated remote settings`)}try{await this.fileService.del(this.previewResource)}catch(v){}r?.ref!==t.ref&&(this.logService.trace(`${this.syncResourceLogLabel}: Updating last synchronized settings...`),await this.updateLastSyncUserData(t),this.logService.info(`${this.syncResourceLogLabel}: Updated last synchronized settings`))}async hasLocalData(){try{const t=await this.getLocalFileContent();if(t){const r=await this.getFormattingOptions(),n=(0,w.edit)(t.value.toString(),[S.CONFIGURATION_SYNC_STORE_KEY],void 0,r);return!(0,u.isEmpty)(n)}}catch(t){if(t.fileOperationResult!==1)return!0}return!1}async getAssociatedResources({uri:t}){const r=await this.fileService.exists(this.file)?this.file:this.localResource;return[{resource:this.extUri.joinPath(t,"settings.json"),comparableResource:r}]}async resolveContent(t){if(this.extUri.isEqual(this.remoteResource,t)||this.extUri.isEqual(this.localResource,t)||this.extUri.isEqual(this.acceptedResource,t))return this.resolvePreviewContent(t);let r=await super.resolveContent(t);if(r)return r;if(r=await super.resolveContent(this.extUri.dirname(t)),r){const n=this.parseSyncData(r);if(n){const s=this.parseSettingsSyncContent(n.content);if(s)switch(this.extUri.basename(t)){case"settings.json":return s.settings}}}return null}async resolvePreviewContent(t){let r=await super.resolvePreviewContent(t);if(r){const n=await this.getFormattingOptions(),s=await this.getIgnoredSettings();r=(0,u.updateIgnoredSettings)(r,"{}",s,n)}return r}getSettingsSyncContent(t){return t.syncData?this.parseSettingsSyncContent(t.syncData.content):null}parseSettingsSyncContent(t){try{return I(t)}catch(r){this.logService.error(r)}return null}toSettingsSyncContent(t){return{settings:t}}async getIgnoredSettings(t){if(!this._defaultIgnoredSettings){this._defaultIgnoredSettings=this.userDataSyncUtilService.resolveDefaultIgnoredSettings();const n=L.Event.any(L.Event.filter(this.extensionManagementService.onDidInstallExtensions,s=>s.some(({local:c})=>!!c)),L.Event.filter(this.extensionManagementService.onDidUninstallExtension,s=>!s.error))(()=>{n.dispose(),this._defaultIgnoredSettings=void 0})}const r=await this._defaultIgnoredSettings;return(0,u.getIgnoredSettings)(r,this.configurationService,t)}validateContent(t){if(this.hasErrors(t))throw new S.UserDataSyncError((0,T.localize)(0,null),"LocalInvalidContent",this.resource)}async recoverSettings(){try{const t=await this.getLocalFileContent();if(!t)return;const r=JSON.parse(t.value.toString());if(!o(r))return;this.telemetryService.publicLog2("sync/settingsCorrupted");const n=this.parseSettingsSyncContent(r.content);if(!n||!n.settings)return;let s=n.settings;const c=await this.getFormattingOptions();for(const l in r)if(["version","content","machineId"].indexOf(l)===-1&&r[l]!==void 0){const h=(0,R.setProperty)(s,[l],r[l],c);h.length&&(s=(0,R.applyEdits)(s,h))}await this.fileService.writeFile(this.file,D.VSBuffer.fromString(s))}catch(t){}}};y=fe([J(0,b.IFileService),J(1,P.IEnvironmentService),J(2,i.IStorageService),J(3,S.IUserDataSyncStoreService),J(4,S.IUserDataSyncBackupStoreService),J(5,S.IUserDataSyncLogService),J(6,S.IUserDataSyncUtilService),J(7,k.IConfigurationService),J(8,S.IUserDataSyncResourceEnablementService),J(9,C.ITelemetryService),J(10,m.IExtensionManagementService)],y),e.SettingsSynchroniser=y;let E=class extends g.AbstractInitializer{constructor(t,r,n){super("settings",r,n,t)}async doInitialize(t){const r=t.syncData?this.parseSettingsSyncContent(t.syncData.content):null;if(!r){this.logService.info("Skipping initializing settings because remote settings does not exist.");return}if(!await this.isEmpty()){this.logService.info("Skipping initializing settings because local settings exist.");return}await this.fileService.writeFile(this.environmentService.settingsResource,D.VSBuffer.fromString(r.settings)),await this.updateLastSyncUserData(t)}async isEmpty(){try{const t=await this.fileService.readFile(this.environmentService.settingsResource);return(0,u.isEmpty)(t.value.toString().trim())}catch(t){return t.fileOperationResult===1}}parseSettingsSyncContent(t){try{return I(t)}catch(r){this.logService.error(r)}return null}};E=fe([J(0,b.IFileService),J(1,P.IEnvironmentService),J(2,S.IUserDataSyncLogService)],E),e.SettingsInitializer=E;function o(a){return!!(a&&a.version!==void 0&&typeof a.version=="number"&&a.content!==void 0&&typeof a.content=="string"&&a.machineId!==void 0&&typeof a.machineId=="string")}}),define(Z[208],te([0,1,25,3,26,21,12,14,22,20,47,201,23]),function(K,e,D,L,R,T,k,P,m,b,i,C,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.SnippetsInitializer=e.SnippetsSynchroniser=void 0;let w=class extends i.AbstractSynchroniser{constructor(f,I,y,E,o,a,t,r,n){super("snippets",I,f,y,E,o,r,n,a,t);this.version=1,this.snippetsFolder=f.snippetsHome,this._register(this.fileService.watch(f.userRoamingDataHome)),this._register(this.fileService.watch(this.snippetsFolder)),this._register(L.Event.filter(this.fileService.onDidFilesChange,s=>s.affects(this.snippetsFolder))(()=>this.triggerLocalChange()))}async generateSyncPreview(f,I,y,E){const o=await this.getSnippetsFileContents(),a=this.toSnippetsContents(o),t=f.syncData?this.parseSnippets(f.syncData):null;I=I===null&&y?f:I;const r=I&&I.syncData?this.parseSnippets(I.syncData):null;t?this.logService.trace(`${this.syncResourceLogLabel}: Merging remote snippets with local snippets...`):this.logService.trace(`${this.syncResourceLogLabel}: Remote snippets does not exist. Synchronizing snippets for the first time.`);const n=(0,C.merge)(a,t,r);return this.getResourcePreviews(n,o,t||{})}async getMergeResult(f,I){return f.previewResult}async getAcceptResult(f,I,y,E){if(this.extUri.isEqualOrParent(I,this.syncPreviewFolder.with({scheme:g.USER_DATA_SYNC_SCHEME,authority:"local"})))return{content:f.fileContent?f.fileContent.value.toString():null,localChange:0,remoteChange:f.fileContent?f.remoteContent!==null?2:1:3};if(this.extUri.isEqualOrParent(I,this.syncPreviewFolder.with({scheme:g.USER_DATA_SYNC_SCHEME,authority:"remote"})))return{content:f.remoteContent,localChange:f.remoteContent!==null?f.fileContent?2:1:3,remoteChange:0};if(this.extUri.isEqualOrParent(I,this.syncPreviewFolder))return y===void 0?{content:f.previewResult.content,localChange:f.previewResult.localChange,remoteChange:f.previewResult.remoteChange}:{content:y,localChange:y===null?f.fileContent!==null?3:0:2,remoteChange:y===null?f.remoteContent!==null?3:0:2};throw new Error(`Invalid Resource: ${I.toString()}`)}async applyResult(f,I,y,E){const o=y.map(([a,t])=>({...a,acceptResult:t}));o.every(({localChange:a,remoteChange:t})=>a===0&&t===0)&&this.logService.info(`${this.syncResourceLogLabel}: No changes found during synchronizing snippets.`),o.some(({localChange:a})=>a!==0)&&(await this.updateLocalBackup(o),await this.updateLocalSnippets(o,E)),o.some(({remoteChange:a})=>a!==0)&&(f=await this.updateRemoteSnippets(o,f,E)),I?.ref!==f.ref&&(this.logService.trace(`${this.syncResourceLogLabel}: Updating last synchronized snippets...`),await this.updateLastSyncUserData(f),this.logService.info(`${this.syncResourceLogLabel}: Updated last synchronized snippets`));for(const{previewResource:a}of o)try{await this.fileService.del(a)}catch(t){}}getResourcePreviews(f,I,y){const E=new Map;for(const o of Object.keys(f.local.added)){const a={content:f.local.added[o],hasConflicts:!1,localChange:1,remoteChange:0};E.set(o,{fileContent:null,localResource:this.extUri.joinPath(this.syncPreviewFolder,o).with({scheme:g.USER_DATA_SYNC_SCHEME,authority:"local"}),localContent:null,remoteResource:this.extUri.joinPath(this.syncPreviewFolder,o).with({scheme:g.USER_DATA_SYNC_SCHEME,authority:"remote"}),remoteContent:y[o],previewResource:this.extUri.joinPath(this.syncPreviewFolder,o),previewResult:a,localChange:a.localChange,remoteChange:a.remoteChange,acceptedResource:this.extUri.joinPath(this.syncPreviewFolder,o).with({scheme:g.USER_DATA_SYNC_SCHEME,authority:"accepted"})})}for(const o of Object.keys(f.local.updated)){const a={content:f.local.updated[o],hasConflicts:!1,localChange:2,remoteChange:0};E.set(o,{localResource:this.extUri.joinPath(this.syncPreviewFolder,o).with({scheme:g.USER_DATA_SYNC_SCHEME,authority:"local"}),fileContent:I[o],localContent:I[o].value.toString(),remoteResource:this.extUri.joinPath(this.syncPreviewFolder,o).with({scheme:g.USER_DATA_SYNC_SCHEME,authority:"remote"}),remoteContent:y[o],previewResource:this.extUri.joinPath(this.syncPreviewFolder,o),previewResult:a,localChange:a.localChange,remoteChange:a.remoteChange,acceptedResource:this.extUri.joinPath(this.syncPreviewFolder,o).with({scheme:g.USER_DATA_SYNC_SCHEME,authority:"accepted"})})}for(const o of f.local.removed){const a={content:null,hasConflicts:!1,localChange:3,remoteChange:0};E.set(o,{localResource:this.extUri.joinPath(this.syncPreviewFolder,o).with({scheme:g.USER_DATA_SYNC_SCHEME,authority:"local"}),fileContent:I[o],localContent:I[o].value.toString(),remoteResource:this.extUri.joinPath(this.syncPreviewFolder,o).with({scheme:g.USER_DATA_SYNC_SCHEME,authority:"remote"}),remoteContent:null,previewResource:this.extUri.joinPath(this.syncPreviewFolder,o),previewResult:a,localChange:a.localChange,remoteChange:a.remoteChange,acceptedResource:this.extUri.joinPath(this.syncPreviewFolder,o).with({scheme:g.USER_DATA_SYNC_SCHEME,authority:"accepted"})})}for(const o of Object.keys(f.remote.added)){const a={content:f.remote.added[o],hasConflicts:!1,localChange:0,remoteChange:1};E.set(o,{localResource:this.extUri.joinPath(this.syncPreviewFolder,o).with({scheme:g.USER_DATA_SYNC_SCHEME,authority:"local"}),fileContent:I[o],localContent:I[o].value.toString(),remoteResource:this.extUri.joinPath(this.syncPreviewFolder,o).with({scheme:g.USER_DATA_SYNC_SCHEME,authority:"remote"}),remoteContent:null,previewResource:this.extUri.joinPath(this.syncPreviewFolder,o),previewResult:a,localChange:a.localChange,remoteChange:a.remoteChange,acceptedResource:this.extUri.joinPath(this.syncPreviewFolder,o).with({scheme:g.USER_DATA_SYNC_SCHEME,authority:"accepted"})})}for(const o of Object.keys(f.remote.updated)){const a={content:f.remote.updated[o],hasConflicts:!1,localChange:0,remoteChange:2};E.set(o,{localResource:this.extUri.joinPath(this.syncPreviewFolder,o).with({scheme:g.USER_DATA_SYNC_SCHEME,authority:"local"}),fileContent:I[o],localContent:I[o].value.toString(),remoteResource:this.extUri.joinPath(this.syncPreviewFolder,o).with({scheme:g.USER_DATA_SYNC_SCHEME,authority:"remote"}),remoteContent:y[o],previewResource:this.extUri.joinPath(this.syncPreviewFolder,o),previewResult:a,localChange:a.localChange,remoteChange:a.remoteChange,acceptedResource:this.extUri.joinPath(this.syncPreviewFolder,o).with({scheme:g.USER_DATA_SYNC_SCHEME,authority:"accepted"})})}for(const o of f.remote.removed){const a={content:null,hasConflicts:!1,localChange:0,remoteChange:3};E.set(o,{localResource:this.extUri.joinPath(this.syncPreviewFolder,o).with({scheme:g.USER_DATA_SYNC_SCHEME,authority:"local"}),fileContent:null,localContent:null,remoteResource:this.extUri.joinPath(this.syncPreviewFolder,o).with({scheme:g.USER_DATA_SYNC_SCHEME,authority:"remote"}),remoteContent:y[o],previewResource:this.extUri.joinPath(this.syncPreviewFolder,o),previewResult:a,localChange:a.localChange,remoteChange:a.remoteChange,acceptedResource:this.extUri.joinPath(this.syncPreviewFolder,o).with({scheme:g.USER_DATA_SYNC_SCHEME,authority:"accepted"})})}for(const o of f.conflicts){const a={content:I[o]?I[o].value.toString():null,hasConflicts:!0,localChange:I[o]?2:1,remoteChange:y[o]?2:1};E.set(o,{localResource:this.extUri.joinPath(this.syncPreviewFolder,o).with({scheme:g.USER_DATA_SYNC_SCHEME,authority:"local"}),fileContent:I[o]||null,localContent:I[o]?I[o].value.toString():null,remoteResource:this.extUri.joinPath(this.syncPreviewFolder,o).with({scheme:g.USER_DATA_SYNC_SCHEME,authority:"remote"}),remoteContent:y[o]||null,previewResource:this.extUri.joinPath(this.syncPreviewFolder,o),previewResult:a,localChange:a.localChange,remoteChange:a.remoteChange,acceptedResource:this.extUri.joinPath(this.syncPreviewFolder,o).with({scheme:g.USER_DATA_SYNC_SCHEME,authority:"accepted"})})}for(const o of Object.keys(I))if(!E.has(o)){const a={content:I[o]?I[o].value.toString():null,hasConflicts:!1,localChange:0,remoteChange:0};E.set(o,{localResource:this.extUri.joinPath(this.syncPreviewFolder,o).with({scheme:g.USER_DATA_SYNC_SCHEME,authority:"local"}),fileContent:I[o]||null,localContent:I[o]?I[o].value.toString():null,remoteResource:this.extUri.joinPath(this.syncPreviewFolder,o).with({scheme:g.USER_DATA_SYNC_SCHEME,authority:"remote"}),remoteContent:y[o]||null,previewResource:this.extUri.joinPath(this.syncPreviewFolder,o),previewResult:a,localChange:a.localChange,remoteChange:a.remoteChange,acceptedResource:this.extUri.joinPath(this.syncPreviewFolder,o).with({scheme:g.USER_DATA_SYNC_SCHEME,authority:"accepted"})})}return[...E.values()]}async getAssociatedResources({uri:f}){let I=await super.resolveContent(f);if(I){const y=this.parseSyncData(I);if(y){const E=this.parseSnippets(y),o=[];for(const a of Object.keys(E)){const t=this.extUri.joinPath(f,a),r=this.extUri.joinPath(this.snippetsFolder,a),n=await this.fileService.exists(r);o.push({resource:t,comparableResource:n?r:this.extUri.joinPath(this.syncPreviewFolder,a).with({scheme:g.USER_DATA_SYNC_SCHEME,authority:"local"})})}return o}}return[]}async resolveContent(f){if(this.extUri.isEqualOrParent(f,this.syncPreviewFolder.with({scheme:g.USER_DATA_SYNC_SCHEME,authority:"remote"}))||this.extUri.isEqualOrParent(f,this.syncPreviewFolder.with({scheme:g.USER_DATA_SYNC_SCHEME,authority:"local"}))||this.extUri.isEqualOrParent(f,this.syncPreviewFolder.with({scheme:g.USER_DATA_SYNC_SCHEME,authority:"accepted"})))return this.resolvePreviewContent(f);let I=await super.resolveContent(f);if(I)return I;if(I=await super.resolveContent(this.extUri.dirname(f)),I){const y=this.parseSyncData(I);if(y)return this.parseSnippets(y)[this.extUri.basename(f)]||null}return null}async hasLocalData(){try{const f=await this.getSnippetsFileContents();if(Object.keys(f).length)return!0}catch(f){}return!1}async updateLocalBackup(f){const I={};for(const y of f)y.fileContent&&(I[this.extUri.basename(y.localResource)]=y.fileContent);await this.backupLocal(JSON.stringify(this.toSnippetsContents(I)))}async updateLocalSnippets(f,I){for(const{fileContent:y,acceptResult:E,localResource:o,remoteResource:a,localChange:t}of f)if(t!==0){const r=a?this.extUri.basename(a):this.extUri.basename(o),n=this.extUri.joinPath(this.snippetsFolder,r);t===3?(this.logService.trace(`${this.syncResourceLogLabel}: Deleting snippet...`,this.extUri.basename(n)),await this.fileService.del(n),this.logService.info(`${this.syncResourceLogLabel}: Deleted snippet`,this.extUri.basename(n))):t===1?(this.logService.trace(`${this.syncResourceLogLabel}: Creating snippet...`,this.extUri.basename(n)),await this.fileService.createFile(n,D.VSBuffer.fromString(E.content),{overwrite:I}),this.logService.info(`${this.syncResourceLogLabel}: Created snippet`,this.extUri.basename(n))):(this.logService.trace(`${this.syncResourceLogLabel}: Updating snippet...`,this.extUri.basename(n)),await this.fileService.writeFile(n,D.VSBuffer.fromString(E.content),I?void 0:y),this.logService.info(`${this.syncResourceLogLabel}: Updated snippet`,this.extUri.basename(n)))}}async updateRemoteSnippets(f,I,y){const E=I.syncData?this.parseSnippets(I.syncData):{},o=(0,R.deepClone)(E);for(const{acceptResult:a,localResource:t,remoteResource:r,remoteChange:n}of f)if(n!==0){const s=t?this.extUri.basename(t):this.extUri.basename(r);n===3?delete o[s]:o[s]=a.content}return(0,C.areSame)(E,o)||(this.logService.trace(`${this.syncResourceLogLabel}: Updating remote snippets...`),I=await this.updateRemoteUserData(JSON.stringify(o),y?null:I.ref),this.logService.info(`${this.syncResourceLogLabel}: Updated remote snippets`)),I}parseSnippets(f){return JSON.parse(f.content)}toSnippetsContents(f){const I={};for(const y of Object.keys(f))I[y]=f[y].value.toString();return I}async getSnippetsFileContents(){const f={};let I;try{I=await this.fileService.resolve(this.snippetsFolder)}catch(y){if(y instanceof P.FileOperationError&&y.fileOperationResult===1)return f;throw y}for(const y of I.children||[]){const E=y.resource,o=this.extUri.extname(E);if(o===".json"||o===".code-snippets"){const a=this.extUri.relativePath(this.snippetsFolder,E),t=await this.fileService.readFile(E);f[a]=t}}return f}};w=fe([J(0,k.IEnvironmentService),J(1,P.IFileService),J(2,m.IStorageService),J(3,g.IUserDataSyncStoreService),J(4,g.IUserDataSyncBackupStoreService),J(5,g.IUserDataSyncLogService),J(6,T.IConfigurationService),J(7,g.IUserDataSyncResourceEnablementService),J(8,b.ITelemetryService)],w),e.SnippetsSynchroniser=w;let u=class extends i.AbstractInitializer{constructor(f,I,y){super("snippets",I,y,f)}async doInitialize(f){const I=f.syncData?JSON.parse(f.syncData.content):null;if(!I){this.logService.info("Skipping initializing snippets because remote snippets does not exist.");return}if(!await this.isEmpty()){this.logService.info("Skipping initializing snippets because local snippets exist.");return}for(const E of Object.keys(I)){const o=I[E];if(o){const a=this.extUri.joinPath(this.environmentService.snippetsHome,E);await this.fileService.createFile(a,D.VSBuffer.fromString(o)),this.logService.info("Created snippet",this.extUri.basename(a))}}await this.updateLastSyncUserData(f)}async isEmpty(){try{return!(await this.fileService.resolve(this.environmentService.snippetsHome)).children?.length}catch(f){return f.fileOperationResult===1}}};u=fe([J(0,P.IFileService),J(1,k.IEnvironmentService),J(2,g.IUserDataSyncLogService)],u),e.SnippetsInitializer=u}),define(Z[60],te([0,1,3,2,7,23]),function(K,e,D,L,R,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.UserDataSyncAccountService=e.IUserDataSyncAccountService=void 0,e.IUserDataSyncAccountService=(0,R.createDecorator)("IUserDataSyncAccountService");let k=class extends L.Disposable{constructor(m){super();this.userDataSyncStoreService=m,this._onDidChangeAccount=this._register(new D.Emitter),this.onDidChangeAccount=this._onDidChangeAccount.event,this._onTokenFailed=this._register(new D.Emitter),this.onTokenFailed=this._onTokenFailed.event,this.wasTokenFailed=!1,this._register(m.onTokenFailed(()=>{this.updateAccount(void 0),this._onTokenFailed.fire(this.wasTokenFailed),this.wasTokenFailed=!0})),this._register(m.onTokenSucceed(()=>this.wasTokenFailed=!1))}get account(){return this._account}async updateAccount(m){(m&&this._account?m.token!==this._account.token||m.authenticationProviderId!==this._account.authenticationProviderId:m!==this._account)&&(this._account=m,this._account&&this.userDataSyncStoreService.setAuthToken(this._account.token,this._account.authenticationProviderId),this._onDidChangeAccount.fire(m))}};k=fe([J(0,T.IUserDataSyncStoreService)],k),e.UserDataSyncAccountService=k}),define(Z[209],te([0,1,6,25,56,2,16,21,12,14,23]),function(K,e,D,L,R,T,k,P,m,b,i){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.UserDataSyncBackupStoreService=void 0;let C=class extends T.Disposable{constructor(w,u,S,f){super();this.environmentService=w,this.fileService=u,this.configurationService=S,this.logService=f,i.ALL_SYNC_RESOURCES.forEach(I=>this.cleanUpBackup(I))}async getAllRefs(w){const u=(0,k.joinPath)(this.environmentService.userDataSyncHome,w),S=await this.fileService.resolve(u);return S.children?S.children.filter(I=>I.isFile&&/^\d{8}T\d{6}(\.json)?$/.test(I.name)).sort().reverse().map(I=>({ref:I.name,created:this.getCreationTime(I)})):[]}async resolveContent(w,u){if(!u){const S=await this.getAllRefs(w);S.length&&(u=S[S.length-1].ref)}if(u){const S=(0,k.joinPath)(this.environmentService.userDataSyncHome,w,u);return(await this.fileService.readFile(S)).value.toString()}return null}async backup(w,u){const S=(0,k.joinPath)(this.environmentService.userDataSyncHome,w),f=(0,k.joinPath)(S,`${(0,R.toLocalISOString)(new Date).replace(/-|:|\.\d+Z$/g,"")}.json`);try{await this.fileService.writeFile(f,L.VSBuffer.fromString(u))}catch(I){this.logService.error(I)}try{this.cleanUpBackup(w)}catch(I){}}async cleanUpBackup(w){const u=(0,k.joinPath)(this.environmentService.userDataSyncHome,w);try{try{if(!await this.fileService.exists(u))return}catch(f){return}const S=await this.fileService.resolve(u);if(S.children){const f=S.children.filter(o=>o.isFile&&/^\d{8}T\d{6}(\.json)?$/.test(o.name)).sort(),I=1e3*60*60*24*(this.configurationService.getValue("sync.localBackupDuration")||30);let y=f.filter(o=>Date.now()-this.getCreationTime(o)>I);const E=f.length-y.length;E<10&&(y=y.slice(10-E)),await D.Promises.settled(y.map(async o=>{this.logService.info("Deleting from backup",o.resource.path),await this.fileService.del(o.resource)}))}}catch(S){this.logService.error(S)}}getCreationTime(w){return w.ctime||new Date(parseInt(w.name.substring(0,4)),parseInt(w.name.substring(4,6))-1,parseInt(w.name.substring(6,8)),parseInt(w.name.substring(9,11)),parseInt(w.name.substring(11,13)),parseInt(w.name.substring(13,15))).getTime()}};C=fe([J(0,m.IEnvironmentService),J(1,b.IFileService),J(2,P.IConfigurationService),J(3,i.IUserDataSyncLogService)],C),e.UserDataSyncBackupStoreService=C}),define(Z[210],te([0,1,2,5]),function(K,e,D,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.UserDataSyncStoreManagementServiceChannelClient=e.UserDataSyncStoreManagementServiceChannel=e.UserDataSyncAccountServiceChannel=e.UserDataSyncMachinesServiceChannel=e.UserDataSyncUtilServiceClient=e.UserDataSycnUtilServiceChannel=e.UserDataAutoSyncChannel=void 0;class R{constructor(g){this.service=g}listen(g,w){switch(w){case"onError":return this.service.onError}throw new Error(`Event not found: ${w}`)}call(g,w,u){switch(w){case"triggerSync":return this.service.triggerSync(u[0],u[1],u[2]);case"turnOn":return this.service.turnOn();case"turnOff":return this.service.turnOff(u[0])}throw new Error("Invalid call")}}e.UserDataAutoSyncChannel=R;class T{constructor(g){this.service=g}listen(g,w){throw new Error(`Event not found: ${w}`)}call(g,w,u){switch(w){case"resolveDefaultIgnoredSettings":return this.service.resolveDefaultIgnoredSettings();case"resolveUserKeybindings":return this.service.resolveUserBindings(u[0]);case"resolveFormattingOptions":return this.service.resolveFormattingOptions(L.URI.revive(u[0]))}throw new Error("Invalid call")}}e.UserDataSycnUtilServiceChannel=T;class k{constructor(g){this.channel=g}async resolveDefaultIgnoredSettings(){return this.channel.call("resolveDefaultIgnoredSettings")}async resolveUserBindings(g){return this.channel.call("resolveUserKeybindings",[g])}async resolveFormattingOptions(g){return this.channel.call("resolveFormattingOptions",[g])}}e.UserDataSyncUtilServiceClient=k;class P{constructor(g){this.service=g}listen(g,w){switch(w){case"onDidChange":return this.service.onDidChange}throw new Error(`Event not found: ${w}`)}async call(g,w,u){switch(w){case"getMachines":return this.service.getMachines();case"addCurrentMachine":return this.service.addCurrentMachine();case"removeCurrentMachine":return this.service.removeCurrentMachine();case"renameMachine":return this.service.renameMachine(u[0],u[1]);case"setEnablement":return this.service.setEnablement(u[0],u[1])}throw new Error("Invalid call")}}e.UserDataSyncMachinesServiceChannel=P;class m{constructor(g){this.service=g}listen(g,w){switch(w){case"onDidChangeAccount":return this.service.onDidChangeAccount;case"onTokenFailed":return this.service.onTokenFailed}throw new Error(`Event not found: ${w}`)}call(g,w,u){switch(w){case"_getInitialData":return Promise.resolve(this.service.account);case"updateAccount":return this.service.updateAccount(u)}throw new Error("Invalid call")}}e.UserDataSyncAccountServiceChannel=m;class b{constructor(g){this.service=g}listen(g,w){switch(w){case"onDidChangeUserDataSyncStore":return this.service.onDidChangeUserDataSyncStore}throw new Error(`Event not found: ${w}`)}call(g,w,u){switch(w){case"switch":return this.service.switch(u[0]);case"getPreviousUserDataSyncStore":return this.service.getPreviousUserDataSyncStore()}throw new Error("Invalid call")}}e.UserDataSyncStoreManagementServiceChannel=b;class i extends D.Disposable{constructor(g){super();this.channel=g,this.onDidChangeUserDataSyncStore=this.channel.listen("onDidChangeUserDataSyncStore")}async switch(g){return this.channel.call("switch",[g])}async getPreviousUserDataSyncStore(){const g=await this.channel.call("getPreviousUserDataSyncStore");return this.revive(g)}revive(g){return{url:L.URI.revive(g.url),type:g.type,defaultUrl:L.URI.revive(g.defaultUrl),insidersUrl:L.URI.revive(g.insidersUrl),stableUrl:L.URI.revive(g.stableUrl),canSwitch:g.canSwitch,authenticationProviders:g.authenticationProviders}}}e.UserDataSyncStoreManagementServiceChannelClient=i}),define(Z[211],te([0,1,12,13]),function(K,e,D,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.UserDataSyncLogService=void 0;let R=class extends L.AbstractLogger{constructor(k,P){super();this.logger=this._register(k.createLogger(P.userDataSyncLogResource,{name:"settingssync"}))}trace(k,...P){this.logger.trace(k,...P)}debug(k,...P){this.logger.debug(k,...P)}info(k,...P){this.logger.info(k,...P)}warn(k,...P){this.logger.warn(k,...P)}error(k,...P){this.logger.error(k,...P)}critical(k,...P){this.logger.critical(k,...P)}flush(){this.logger.flush()}};R=fe([J(0,L.ILoggerService),J(1,D.IEnvironmentService)],R),e.UserDataSyncLogService=R}),define(Z[61],te([0,1,3,2,4,24,135,12,14,7,29,45,22,23]),function(K,e,D,L,R,T,k,P,m,b,i,C,g,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.UserDataSyncMachinesService=e.IUserDataSyncMachinesService=void 0,e.IUserDataSyncMachinesService=(0,b.createDecorator)("IUserDataSyncMachinesService");const u="sync.currentMachineName";let S=class Je extends L.Disposable{constructor(I,y,E,o,a,t){super();this.storageService=E,this.userDataSyncStoreService=o,this.logService=a,this.productService=t,this._onDidChange=this._register(new D.Emitter),this.onDidChange=this._onDidChange.event,this.userData=null,this.currentMachineIdPromise=(0,C.getServiceMachineId)(I,y,E)}async getMachines(I){const y=await this.currentMachineIdPromise;return(await this.readMachinesData(I)).machines.map(o=>({...o,isCurrent:o.id===y}))}async addCurrentMachine(I){const y=await this.currentMachineIdPromise,E=await this.readMachinesData(I);E.machines.some(({id:o})=>o===y)||(E.machines.push({id:y,name:this.computeCurrentMachineName(E.machines)}),await this.writeMachinesData(E))}async removeCurrentMachine(I){const y=await this.currentMachineIdPromise,E=await this.readMachinesData(I),o=E.machines.filter(({id:a})=>a!==y);o.length!==E.machines.length&&(E.machines=o,await this.writeMachinesData(E))}async renameMachine(I,y,E){const o=await this.currentMachineIdPromise,a=await this.readMachinesData(E),t=a.machines.find(({id:r})=>r===I);t&&(t.name=y,await this.writeMachinesData(a),a.machines.some(({id:r})=>r===o)&&this.storageService.store(u,y,0,1))}async setEnablement(I,y){const E=await this.readMachinesData(),o=E.machines.find(({id:a})=>a===I);o&&(o.disabled=y?void 0:!0,await this.writeMachinesData(E))}computeCurrentMachineName(I){const y=this.storageService.get(u,0);if(y)return y;const E=`${this.productService.nameLong} (${(0,R.PlatformToString)(R.isWeb?0:R.platform)})`,o=new RegExp(`${(0,T.escapeRegExpCharacters)(E)}\\s#(\\d+)`);let a=0;for(const t of I){const r=o.exec(t.name),n=r?parseInt(r[1]):0;a=n>a?n:a}return`${E} #${a+1}`}async readMachinesData(I){this.userData=await this.readUserData(I);const y=this.parse(this.userData);if(y.version!==Je.VERSION)throw new Error((0,k.localize)(0,null,this.productService.nameLong));return y}async writeMachinesData(I){const y=JSON.stringify(I),E=await this.userDataSyncStoreService.write(Je.RESOURCE,y,this.userData?.ref||null);this.userData={ref:E,content:y},this._onDidChange.fire()}async readUserData(I){if(this.userData){const y=I&&I.latest?I.latest[Je.RESOURCE]:void 0;if(this.userData.ref===y)return this.userData;if(y===void 0&&this.userData.content===null)return this.userData}return this.userDataSyncStoreService.read(Je.RESOURCE,this.userData)}parse(I){if(I.content!==null)try{return JSON.parse(I.content)}catch(y){this.logService.error(y)}return{version:Je.VERSION,machines:[]}}};S.VERSION=1,S.RESOURCE="machines",S=fe([J(0,P.IEnvironmentService),J(1,m.IFileService),J(2,g.IStorageService),J(3,w.IUserDataSyncStoreService),J(4,w.IUserDataSyncLogService),J(5,i.IProductService)],S),e.UserDataSyncMachinesService=S}),define(Z[90],te([0,1,6,56,38,9,3,2,4,16,5,133,12,29,22,20,23,60,61]),function(K,e,D,L,R,T,k,P,m,b,i,C,g,w,u,S,f,I,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.UserDataAutoSyncService=e.UserDataAutoSyncEnablementService=void 0;const E="sync.enable",o="sync.disableMachineEventually",a="sync.sessionId",t="sync.storeUrl",r="sync.productQuality";let n=class extends P.Disposable{constructor(h,d,v){super();this.storageService=h,this.environmentService=d,this.userDataSyncStoreManagementService=v,this._onDidChangeEnablement=new k.Emitter,this.onDidChangeEnablement=this._onDidChangeEnablement.event,this._register(h.onDidChangeValue(A=>this.onDidStorageChange(A)))}isEnabled(){switch(this.environmentService.sync){case"on":return!0;case"off":return!1}return this.storageService.getBoolean(E,0,!1)}canToggleEnablement(){return this.userDataSyncStoreManagementService.userDataSyncStore!==void 0&&this.environmentService.sync===void 0}setEnablement(h){h&&!this.canToggleEnablement()||this.storageService.store(E,h,0,1)}onDidStorageChange(h){if(h.scope===0&&E===h.key){this._onDidChangeEnablement.fire(this.isEnabled());return}}};n=fe([J(0,u.IStorageService),J(1,g.IEnvironmentService),J(2,f.IUserDataSyncStoreManagementService)],n),e.UserDataAutoSyncEnablementService=n;let s=class extends P.Disposable{constructor(h,d,v,A,O,p,U,F,z,H,M){super();this.userDataSyncStoreManagementService=d,this.userDataSyncStoreService=v,this.userDataSyncResourceEnablementService=A,this.userDataSyncService=O,this.logService=p,this.userDataSyncAccountService=U,this.telemetryService=F,this.userDataSyncMachinesService=z,this.storageService=H,this.autoSync=this._register(new P.MutableDisposable),this.successiveFailures=0,this.lastSyncTriggerTime=void 0,this._onError=this._register(new k.Emitter),this.onError=this._onError.event,this.sources=[],this.userDataAutoSyncEnablementService=M,this.syncTriggerDelayer=this._register(new D.Delayer(0)),this.lastSyncUrl=this.syncUrl,this.syncUrl=d.userDataSyncStore?.url,this.previousProductQuality=this.productQuality,this.productQuality=h.quality,this.syncUrl&&(this.logService.info("Using settings sync service",this.syncUrl.toString()),this._register(d.onDidChangeUserDataSyncStore(()=>{(0,b.isEqual)(this.syncUrl,d.userDataSyncStore?.url)||(this.lastSyncUrl=this.syncUrl,this.syncUrl=d.userDataSyncStore?.url,this.syncUrl&&this.logService.info("Using settings sync service",this.syncUrl.toString()))})),this.userDataAutoSyncEnablementService.isEnabled()?this.logService.info("Auto Sync is enabled."):this.logService.info("Auto Sync is disabled."),this.updateAutoSync(),this.hasToDisableMachineEventually()&&this.disableMachineEventually(),this._register(U.onDidChangeAccount(()=>this.updateAutoSync())),this._register(v.onDidChangeDonotMakeRequestsUntil(()=>this.updateAutoSync())),this._register(k.Event.debounce(O.onDidChangeLocal,(j,q)=>j?[...j,q]:[q],1e3)(j=>this.triggerSync(j,!1,!1))),this._register(k.Event.filter(this.userDataSyncResourceEnablementService.onDidChangeResourceEnablement,([,j])=>j)(()=>this.triggerSync(["resourceEnablement"],!1,!1))),this._register(this.userDataSyncStoreManagementService.onDidChangeUserDataSyncStore(()=>this.triggerSync(["userDataSyncStoreChanged"],!1,!1))))}get syncUrl(){const h=this.storageService.get(t,0);return h?i.URI.parse(h):void 0}set syncUrl(h){h?this.storageService.store(t,h.toString(),0,1):this.storageService.remove(t,0)}get productQuality(){return this.storageService.get(r,0)}set productQuality(h){h?this.storageService.store(r,h,0,1):this.storageService.remove(r,0)}updateAutoSync(){const{enabled:h,message:d}=this.isAutoSyncEnabled();h?this.autoSync.value===void 0&&(this.autoSync.value=new c(this.lastSyncUrl,1e3*60*5,this.userDataSyncStoreManagementService,this.userDataSyncStoreService,this.userDataSyncService,this.userDataSyncMachinesService,this.logService,this.storageService),this.autoSync.value.register(this.autoSync.value.onDidStartSync(()=>this.lastSyncTriggerTime=new Date().getTime())),this.autoSync.value.register(this.autoSync.value.onDidFinishSync(v=>this.onDidFinishSync(v))),this.startAutoSync()&&this.autoSync.value.start()):(this.syncTriggerDelayer.cancel(),this.autoSync.value!==void 0?(d&&this.logService.info(d),this.autoSync.clear()):d&&this.userDataAutoSyncEnablementService.isEnabled()&&this.logService.info(d))}startAutoSync(){return!0}isAutoSyncEnabled(){return this.userDataAutoSyncEnablementService.isEnabled()?this.userDataSyncAccountService.account?this.userDataSyncStoreService.donotMakeRequestsUntil?{enabled:!1,message:`Auto Sync: Suspended until ${(0,L.toLocalISOString)(this.userDataSyncStoreService.donotMakeRequestsUntil)} because server is not accepting requests until then.`}:{enabled:!0}:{enabled:!1,message:"Auto Sync: Suspended until auth token is available."}:{enabled:!1,message:"Auto Sync: Disabled."}}async turnOn(){this.stopDisableMachineEventually(),this.lastSyncUrl=this.syncUrl,this.updateEnablement(!0)}async turnOff(h,d,v){try{this.userDataSyncAccountService.account&&!v&&await this.userDataSyncMachinesService.removeCurrentMachine(),this.updateEnablement(!1),this.storageService.remove(a,0),h?(this.telemetryService.publicLog2("sync/turnOffEveryWhere"),await this.userDataSyncService.reset()):await this.userDataSyncService.resetLocal()}catch(A){if(d)this.logService.error(A),this.updateEnablement(!1);else throw A}}updateEnablement(h){this.userDataAutoSyncEnablementService.isEnabled()!==h&&(this.telemetryService.publicLog2(E,{enabled:h}),this.userDataAutoSyncEnablementService.setEnablement(h),this.updateAutoSync())}hasProductQualityChanged(){return!!this.previousProductQuality&&!!this.productQuality&&this.previousProductQuality!==this.productQuality}async onDidFinishSync(h){if(!h){this.successiveFailures=0;return}const d=f.UserDataSyncError.toUserDataSyncError(h);d instanceof f.UserDataAutoSyncError&&this.telemetryService.publicLog2("autosync/error",{code:d.code,service:this.userDataSyncStoreManagementService.userDataSyncStore.url.toString()}),d.code==="SessionExpired"?(await this.turnOff(!1,!0),this.logService.info("Auto Sync: Turned off sync because current session is expired")):d.code==="TurnedOff"?(await this.turnOff(!1,!0),this.logService.info("Auto Sync: Turned off sync because sync is turned off in the cloud")):d.code==="LocalTooManyRequests"||d.code==="RemoteTooManyRequests"?(await this.turnOff(!1,!0,!0),this.disableMachineEventually(),this.logService.info("Auto Sync: Turned off sync because of making too many requests to server")):d.code==="UpgradeRequired"||d.code==="Gone"?(await this.turnOff(!1,!0,!0),this.disableMachineEventually(),this.logService.info("Auto Sync: Turned off sync because current client is not compatible with server. Requires client upgrade.")):d.code==="IncompatibleLocalContent"?(await this.turnOff(!1,!0),this.logService.info(`Auto Sync: Turned off sync because server has ${d.resource} content with newer version than of client. Requires client upgrade.`)):d.code==="IncompatibleRemoteContent"?(await this.turnOff(!1,!0),this.logService.info(`Auto Sync: Turned off sync because server has ${d.resource} content with older version than of client. Requires server reset.`)):d.code==="ServiceChanged"||d.code==="DefaultServiceChanged"?m.isWeb&&d.code==="DefaultServiceChanged"&&!this.hasProductQualityChanged()?(await this.turnOff(!1,!0),this.logService.info("Auto Sync: Turned off sync because default sync service is changed.")):(await this.turnOff(!1,!0,!0),await this.turnOn(),this.logService.info("Auto Sync: Sync Service changed. Turned off auto sync, reset local state and turned on auto sync.")):(this.logService.error(d),this.successiveFailures++),this._onError.fire(d)}async disableMachineEventually(){this.storageService.store(o,!0,0,1),await(0,D.timeout)(1e3*60*10),!!this.hasToDisableMachineEventually()&&(this.stopDisableMachineEventually(),!this.userDataAutoSyncEnablementService.isEnabled()&&this.userDataSyncAccountService.account&&await this.userDataSyncMachinesService.removeCurrentMachine())}hasToDisableMachineEventually(){return this.storageService.getBoolean(o,0,!1)}stopDisableMachineEventually(){this.storageService.remove(o,0)}async triggerSync(h,d,v){if(this.autoSync.value===void 0)return this.syncTriggerDelayer.cancel();if(d&&this.lastSyncTriggerTime&&Math.round((new Date().getTime()-this.lastSyncTriggerTime)/1e3)<10){this.logService.debug("Auto Sync: Skipped. Limited to once per 10 seconds.");return}return this.sources.push(...h),this.syncTriggerDelayer.trigger(async()=>{this.logService.trace("activity sources",...this.sources),this.telemetryService.publicLog2("sync/triggered",{sources:this.sources}),this.sources=[],this.autoSync.value&&await this.autoSync.value.sync("Activity",v)},this.successiveFailures?this.getSyncTriggerDelayTime()*1*Math.min(Math.pow(2,this.successiveFailures),60):this.getSyncTriggerDelayTime())}getSyncTriggerDelayTime(){return 1e3}};s=fe([J(0,w.IProductService),J(1,f.IUserDataSyncStoreManagementService),J(2,f.IUserDataSyncStoreService),J(3,f.IUserDataSyncResourceEnablementService),J(4,f.IUserDataSyncService),J(5,f.IUserDataSyncLogService),J(6,I.IUserDataSyncAccountService),J(7,S.ITelemetryService),J(8,y.IUserDataSyncMachinesService),J(9,u.IStorageService),J(10,f.IUserDataAutoSyncEnablementService)],s),e.UserDataAutoSyncService=s;class c extends P.Disposable{constructor(h,d,v,A,O,p,U,F){super();this.lastSyncUrl=h,this.interval=d,this.userDataSyncStoreManagementService=v,this.userDataSyncStoreService=A,this.userDataSyncService=O,this.userDataSyncMachinesService=p,this.logService=U,this.storageService=F,this.intervalHandler=this._register(new P.MutableDisposable),this._onDidStartSync=this._register(new k.Emitter),this.onDidStartSync=this._onDidStartSync.event,this._onDidFinishSync=this._register(new k.Emitter),this.onDidFinishSync=this._onDidFinishSync.event,this.manifest=null}start(){this._register(this.onDidFinishSync(()=>this.waitUntilNextIntervalAndSync())),this._register((0,P.toDisposable)(()=>{this.syncPromise&&(this.syncPromise.cancel(),this.logService.info("Auto sync: Cancelled sync that is in progress"),this.syncPromise=void 0),this.syncTask&&this.syncTask.stop(),this.logService.info("Auto Sync: Stopped")})),this.logService.info("Auto Sync: Started"),this.sync(c.INTERVAL_SYNCING,!1)}waitUntilNextIntervalAndSync(){this.intervalHandler.value=(0,D.disposableTimeout)(()=>this.sync(c.INTERVAL_SYNCING,!1),this.interval)}sync(h,d){const v=(0,D.createCancelablePromise)(async A=>{if(this.syncPromise)try{this.logService.debug("Auto Sync: Waiting until sync is finished."),await this.syncPromise}catch(O){if((0,T.isPromiseCanceledError)(O))return}return this.doSync(h,d,A)});return this.syncPromise=v,this.syncPromise.finally(()=>this.syncPromise=void 0),this.syncPromise}hasSyncServiceChanged(){return this.lastSyncUrl!==void 0&&!(0,b.isEqual)(this.lastSyncUrl,this.userDataSyncStoreManagementService.userDataSyncStore?.url)}async hasDefaultServiceChanged(){const h=await this.userDataSyncStoreManagementService.getPreviousUserDataSyncStore(),d=this.userDataSyncStoreManagementService.userDataSyncStore;return!!d&&!!h&&(!(0,b.isEqual)(d.defaultUrl,h.defaultUrl)||!(0,b.isEqual)(d.insidersUrl,h.insidersUrl)||!(0,b.isEqual)(d.stableUrl,h.stableUrl))}async doSync(h,d,v){this.logService.info(`Auto Sync: Triggered by ${h}`),this._onDidStartSync.fire();let A;try{if(this.syncTask=await this.userDataSyncService.createSyncTask(this.manifest,d),v.isCancellationRequested)return;if(this.manifest=this.syncTask.manifest,this.manifest===null&&await this.userDataSyncService.hasPreviouslySynced())throw this.hasSyncServiceChanged()?await this.hasDefaultServiceChanged()?new f.UserDataAutoSyncError((0,C.localize)(0,null),"DefaultServiceChanged"):new f.UserDataAutoSyncError((0,C.localize)(1,null),"ServiceChanged"):new f.UserDataAutoSyncError((0,C.localize)(2,null),"TurnedOff");const O=this.storageService.get(a,0);if(O&&this.manifest&&O!==this.manifest.session)throw this.hasSyncServiceChanged()?await this.hasDefaultServiceChanged()?new f.UserDataAutoSyncError((0,C.localize)(3,null),"DefaultServiceChanged"):new f.UserDataAutoSyncError((0,C.localize)(4,null),"ServiceChanged"):new f.UserDataAutoSyncError((0,C.localize)(5,null),"SessionExpired");const p=await this.userDataSyncMachinesService.getMachines(this.manifest||void 0);if(v.isCancellationRequested)return;const U=p.find(F=>F.isCurrent);if(U?.disabled)throw new f.UserDataAutoSyncError((0,C.localize)(6,null),"TurnedOff");if(await this.syncTask.run(),this.manifest===null)try{this.manifest=await this.userDataSyncStoreService.manifest(null)}catch(F){throw new f.UserDataAutoSyncError((0,R.toErrorMessage)(F),F instanceof f.UserDataSyncError?F.code:"Unknown")}if(this.manifest&&this.manifest.session!==O&&this.storageService.store(a,this.manifest.session,0,1),v.isCancellationRequested)return;U||await this.userDataSyncMachinesService.addCurrentMachine(this.manifest||void 0)}catch(O){this.logService.error(O),A=O}this._onDidFinishSync.fire(A)}register(h){return super._register(h)}}c.INTERVAL_SYNCING="Interval"}),define(Z[212],te([0,1,3,2,4,22,20,23]),function(K,e,D,L,R,T,k,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.UserDataSyncResourceEnablementService=void 0;let m=class extends L.Disposable{constructor(i,C){super();this.storageService=i,this.telemetryService=C,this._onDidChangeResourceEnablement=new D.Emitter,this.onDidChangeResourceEnablement=this._onDidChangeResourceEnablement.event,this._register(i.onDidChangeValue(g=>this.onDidStorageChange(g)))}isResourceEnabled(i){return this.storageService.getBoolean((0,P.getEnablementKey)(i),0,!0)}setResourceEnablement(i,C){if(this.isResourceEnabled(i)!==C){const g=(0,P.getEnablementKey)(i);this.telemetryService.publicLog2(g,{enabled:C}),this.storeResourceEnablement(g,C)}}getResourceSyncStateVersion(i){}storeResourceEnablement(i,C){this.storageService.store(i,C,0,R.isWeb?0:1)}onDidStorageChange(i){if(i.scope===0){const C=P.ALL_SYNC_RESOURCES.filter(g=>(0,P.getEnablementKey)(g)===i.key)[0];if(C){this._onDidChangeResourceEnablement.fire([C,this.isResourceEnabled(C)]);return}}}};m=fe([J(0,T.IStorageService),J(1,k.ITelemetryService)],m),e.UserDataSyncResourceEnablementService=m}),define(Z[213],te([0,1,17,6,38,9,3,2,16,30,7,22,20,202,204,205,207,208,23]),function(K,e,D,L,R,T,k,P,m,b,i,C,g,w,u,S,f,I,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.UserDataSyncService=void 0;const E="sync.lastSyncTime";let o=class extends P.Disposable{constructor(n,s,c,l,h,d){super();this.userDataSyncStoreService=n,this.userDataSyncStoreManagementService=s,this.instantiationService=c,this.logService=l,this.telemetryService=h,this.storageService=d,this._status="uninitialized",this._onDidChangeStatus=this._register(new k.Emitter),this.onDidChangeStatus=this._onDidChangeStatus.event,this._conflicts=[],this._onDidChangeConflicts=this._register(new k.Emitter),this.onDidChangeConflicts=this._onDidChangeConflicts.event,this._syncErrors=[],this._onSyncErrors=this._register(new k.Emitter),this.onSyncErrors=this._onSyncErrors.event,this._lastSyncTime=void 0,this._onDidChangeLastSyncTime=this._register(new k.Emitter),this.onDidChangeLastSyncTime=this._onDidChangeLastSyncTime.event,this._onDidResetLocal=this._register(new k.Emitter),this.onDidResetLocal=this._onDidResetLocal.event,this._onDidResetRemote=this._register(new k.Emitter),this.onDidResetRemote=this._onDidResetRemote.event,this.recoveredSettings=!1,this.settingsSynchroniser=this._register(this.instantiationService.createInstance(f.SettingsSynchroniser)),this.keybindingsSynchroniser=this._register(this.instantiationService.createInstance(S.KeybindingsSynchroniser)),this.snippetsSynchroniser=this._register(this.instantiationService.createInstance(I.SnippetsSynchroniser)),this.globalStateSynchroniser=this._register(this.instantiationService.createInstance(u.GlobalStateSynchroniser)),this.extensionsSynchroniser=this._register(this.instantiationService.createInstance(w.ExtensionsSynchroniser)),this.synchronisers=[this.settingsSynchroniser,this.keybindingsSynchroniser,this.snippetsSynchroniser,this.globalStateSynchroniser,this.extensionsSynchroniser],this.updateStatus(),this.userDataSyncStoreManagementService.userDataSyncStore&&(this._register(k.Event.any(...this.synchronisers.map(v=>k.Event.map(v.onDidChangeStatus,()=>{})))(()=>this.updateStatus())),this._register(k.Event.any(...this.synchronisers.map(v=>k.Event.map(v.onDidChangeConflicts,()=>{})))(()=>this.updateConflicts()))),this._lastSyncTime=this.storageService.getNumber(E,0,void 0),this.onDidChangeLocal=k.Event.any(...this.synchronisers.map(v=>k.Event.map(v.onDidChangeLocal,()=>v.resource)))}get status(){return this._status}get conflicts(){return this._conflicts}get lastSyncTime(){return this._lastSyncTime}async createSyncTask(n,s){await this.checkEnablement();const c=(0,b.generateUuid)();try{const v=(0,y.createSyncHeaders)(c);s&&(v["Cache-Control"]="no-cache"),n=await this.userDataSyncStoreService.manifest(n,v)}catch(v){const A=y.UserDataSyncError.toUserDataSyncError(v);throw this.reportUserDataSyncError(A,c),A}let l=!1;const h=this;let d;return{manifest:n,run(){if(l)throw new Error("Can run a task only once");return d=(0,L.createCancelablePromise)(v=>h.sync(n,c,v)),d.finally(()=>d=void 0)},async stop(){if(d&&d.cancel(),h.status!=="idle")return h.stop()}}}async createManualSyncTask(){await this.checkEnablement();const n=(0,b.generateUuid)(),s=(0,y.createSyncHeaders)(n);let c;try{c=await this.userDataSyncStoreService.manifest(null,s)}catch(l){const h=y.UserDataSyncError.toUserDataSyncError(l);throw this.reportUserDataSyncError(h,n),h}return new a(n,c,s,this.synchronisers,this.logService)}async sync(n,s,c){if(this.recoveredSettings||(await this.settingsSynchroniser.recoverSettings(),this.recoveredSettings=!0),c.isCancellationRequested)return;const l=new Date().getTime();this._syncErrors=[];try{this.logService.trace("Sync started."),this.status!=="hasConflicts"&&this.setStatus("syncing");const h=(0,y.createSyncHeaders)(s);for(const d of this.synchronisers){if(c.isCancellationRequested)return;try{await d.sync(n,h)}catch(v){let A=!1;if(v instanceof y.UserDataSyncError)switch(v.code){case"TooLarge":v=new y.UserDataSyncError(v.message,v.code,d.resource),A=!0;break;case"RemoteTooManyRequests":case"TooManyRequestsAndRetryAfter":case"LocalTooManyRequests":case"Gone":case"UpgradeRequired":case"IncompatibleRemoteContent":case"IncompatibleLocalContent":A=!0;break}const O=y.UserDataSyncError.toUserDataSyncError(v);if(this.reportUserDataSyncError(O,s),A)throw O;this.logService.error(v),this.logService.error(`${d.resource}: ${(0,R.toErrorMessage)(v)}`),this._syncErrors.push([d.resource,O])}}this.logService.info(`Sync done. Took ${new Date().getTime()-l}ms`),this.updateLastSyncTime()}catch(h){const d=y.UserDataSyncError.toUserDataSyncError(h);throw this.reportUserDataSyncError(d,s),d}finally{this.updateStatus(),this._onSyncErrors.fire(this._syncErrors)}}async stop(){if(this.status!=="idle")for(const n of this.synchronisers)try{n.status!=="idle"&&await n.stop()}catch(s){this.logService.error(s)}}async replace(n){await this.checkEnablement();for(const s of this.synchronisers)if(await s.replace(n))return}async accept(n,s,c,l){await this.checkEnablement();const h=this.getSynchroniser(n);await h.accept(s,c),l&&await h.apply(!1,(0,y.createSyncHeaders)((0,b.generateUuid)()))}async resolveContent(n){for(const s of this.synchronisers){const c=await s.resolveContent(n);if(c)return c}return null}getRemoteSyncResourceHandles(n){return this.getSynchroniser(n).getRemoteSyncResourceHandles()}getLocalSyncResourceHandles(n){return this.getSynchroniser(n).getLocalSyncResourceHandles()}getAssociatedResources(n,s){return this.getSynchroniser(n).getAssociatedResources(s)}getMachineId(n,s){return this.getSynchroniser(n).getMachineId(s)}async hasLocalData(){const n=[this.settingsSynchroniser,this.keybindingsSynchroniser,this.snippetsSynchroniser,this.extensionsSynchroniser];for(const s of n)if(await s.hasLocalData())return!0;return!1}async reset(){await this.checkEnablement(),await this.resetRemote(),await this.resetLocal()}async resetRemote(){await this.checkEnablement();try{await this.userDataSyncStoreService.clear(),this.logService.info("Cleared data on server")}catch(n){this.logService.error(n)}this._onDidResetRemote.fire()}async resetLocal(){await this.checkEnablement(),this.storageService.remove(E,0);for(const n of this.synchronisers)try{await n.resetLocal()}catch(s){this.logService.error(`${n.resource}: ${(0,R.toErrorMessage)(s)}`),this.logService.error(s)}this._onDidResetLocal.fire(),this.logService.info("Did reset the local sync state.")}async hasPreviouslySynced(){for(const n of this.synchronisers)if(await n.hasPreviouslySynced())return!0;return!1}setStatus(n){const s=this._status;this._status!==n&&(this._status=n,this._onDidChangeStatus.fire(n),s==="hasConflicts"&&this.updateLastSyncTime())}updateStatus(){this.updateConflicts();const n=this.computeStatus();this.setStatus(n)}updateConflicts(){const n=this.computeConflicts();(0,D.equals)(this._conflicts,n,([s,c],[l,h])=>s===s&&(0,D.equals)(c,h,(d,v)=>(0,m.isEqual)(d.previewResource,v.previewResource)))||(this._conflicts=this.computeConflicts(),this._onDidChangeConflicts.fire(n))}computeStatus(){return this.userDataSyncStoreManagementService.userDataSyncStore?this.synchronisers.some(n=>n.status==="hasConflicts")?"hasConflicts":this.synchronisers.some(n=>n.status==="syncing")?"syncing":"idle":"uninitialized"}updateLastSyncTime(){this.status==="idle"&&(this._lastSyncTime=new Date().getTime(),this.storageService.store(E,this._lastSyncTime,0,1),this._onDidChangeLastSyncTime.fire(this._lastSyncTime))}reportUserDataSyncError(n,s){this.telemetryService.publicLog2("sync/error",{code:n.code,serverCode:n instanceof y.UserDataSyncStoreError?String(n.serverCode):void 0,url:n instanceof y.UserDataSyncStoreError?n.url:void 0,resource:n.resource,executionId:s,service:this.userDataSyncStoreManagementService.userDataSyncStore.url.toString()})}computeConflicts(){return this.synchronisers.filter(n=>n.status==="hasConflicts").map(n=>[n.resource,n.conflicts.map(t)])}getSynchroniser(n){return this.synchronisers.find(s=>s.resource===n)}async checkEnablement(){if(!this.userDataSyncStoreManagementService.userDataSyncStore)throw new Error("Not enabled")}};o=fe([J(0,y.IUserDataSyncStoreService),J(1,y.IUserDataSyncStoreManagementService),J(2,i.IInstantiationService),J(3,y.IUserDataSyncLogService),J(4,g.ITelemetryService),J(5,C.IStorageService)],o),e.UserDataSyncService=o;class a extends P.Disposable{constructor(n,s,c,l,h){super();this.id=n,this.manifest=s,this.syncHeaders=c,this.synchronisers=l,this.logService=h,this.synchronizingResources=[],this._onSynchronizeResources=this._register(new k.Emitter),this.onSynchronizeResources=this._onSynchronizeResources.event,this.isDisposed=!1}get status(){return this.synchronisers.some(n=>n.status==="hasConflicts")?"hasConflicts":this.synchronisers.some(n=>n.status==="syncing")?"syncing":"idle"}async preview(){try{if(this.isDisposed)throw new Error("Disposed");return this.previewsPromise||(this.previewsPromise=(0,L.createCancelablePromise)(n=>this.getPreviews(n))),this.previews||(this.previews=await this.previewsPromise),this.previews}catch(n){throw this.logService.error(n),n}}async accept(n,s){try{return await this.performAction(n,c=>c.accept(n,s))}catch(c){throw this.logService.error(c),c}}async merge(n){try{return n?await this.performAction(n,s=>s.merge(n)):await this.mergeAll()}catch(s){throw this.logService.error(s),s}}async discard(n){try{return await this.performAction(n,s=>s.discard(n))}catch(s){throw this.logService.error(s),s}}async discardConflicts(){try{if(!this.previews)throw new Error("Missing preview. Create preview and try again.");if(this.synchronizingResources.length)throw new Error("Cannot discard while synchronizing resources");const n=[];for(const[,s]of this.previews)for(const c of s.resourcePreviews)c.mergeState==="conflict"&&n.push(c.previewResource);for(const s of n)await this.discard(s);return this.previews}catch(n){throw this.logService.error(n),n}}async apply(){try{if(!this.previews)throw new Error("You need to create preview before applying");if(this.synchronizingResources.length)throw new Error("Cannot pull while synchronizing resources");const n=[];for(const[s,c]of this.previews){this.synchronizingResources.push([s,c.resourcePreviews.map(d=>d.localResource)]),this._onSynchronizeResources.fire(this.synchronizingResources);const l=this.synchronisers.find(d=>d.resource===s);for(const d of c.resourcePreviews)(d.localChange!==0||d.remoteChange!==0)&&d.mergeState==="preview"&&await l.merge(d.previewResource);const h=await l.apply(!1,this.syncHeaders);h&&n.push(this.toSyncResourcePreview(l.resource,h)),this.synchronizingResources.splice(this.synchronizingResources.findIndex(d=>d[0]===s),1),this._onSynchronizeResources.fire(this.synchronizingResources)}return this.previews=n,this.previews}catch(n){throw this.logService.error(n),n}}async pull(){try{if(!this.previews)throw new Error("You need to create preview before applying");if(this.synchronizingResources.length)throw new Error("Cannot pull while synchronizing resources");for(const[n,s]of this.previews){this.synchronizingResources.push([n,s.resourcePreviews.map(l=>l.localResource)]),this._onSynchronizeResources.fire(this.synchronizingResources);const c=this.synchronisers.find(l=>l.resource===n);for(const l of s.resourcePreviews)await c.accept(l.remoteResource);await c.apply(!0,this.syncHeaders),this.synchronizingResources.splice(this.synchronizingResources.findIndex(l=>l[0]===n),1),this._onSynchronizeResources.fire(this.synchronizingResources)}this.previews=[]}catch(n){throw this.logService.error(n),n}}async push(){try{if(!this.previews)throw new Error("You need to create preview before applying");if(this.synchronizingResources.length)throw new Error("Cannot pull while synchronizing resources");for(const[n,s]of this.previews){this.synchronizingResources.push([n,s.resourcePreviews.map(l=>l.localResource)]),this._onSynchronizeResources.fire(this.synchronizingResources);const c=this.synchronisers.find(l=>l.resource===n);for(const l of s.resourcePreviews)await c.accept(l.localResource);await c.apply(!0,this.syncHeaders),this.synchronizingResources.splice(this.synchronizingResources.findIndex(l=>l[0]===n),1),this._onSynchronizeResources.fire(this.synchronizingResources)}this.previews=[]}catch(n){throw this.logService.error(n),n}}async stop(){for(const n of this.synchronisers)try{await n.stop()}catch(s){(0,T.isPromiseCanceledError)(s)||this.logService.error(s)}this.reset()}async performAction(n,s){if(!this.previews)throw new Error("Missing preview. Create preview and try again.");const c=this.previews.findIndex(([,U])=>U.resourcePreviews.some(({localResource:F,previewResource:z,remoteResource:H})=>(0,m.isEqual)(n,F)||(0,m.isEqual)(n,z)||(0,m.isEqual)(n,H)));if(c===-1)return this.previews;const[l,h]=this.previews[c],d=h.resourcePreviews.find(({localResource:U,remoteResource:F,previewResource:z})=>(0,m.isEqual)(U,n)||(0,m.isEqual)(F,n)||(0,m.isEqual)(z,n));if(!d)return this.previews;let v=this.synchronizingResources.find(U=>U[0]===l);v||(v=[l,[]],this.synchronizingResources.push(v)),v[1].some(U=>(0,m.isEqual)(U,d.localResource))||(v[1].push(d.localResource),this._onSynchronizeResources.fire(this.synchronizingResources));const A=this.synchronisers.find(U=>U.resource===this.previews[c][0]),O=await s(A);O?this.previews.splice(c,1,this.toSyncResourcePreview(A.resource,O)):this.previews.splice(c,1);const p=this.synchronizingResources.findIndex(U=>U[0]===l);return this.synchronizingResources[p][1].splice(v[1].findIndex(U=>(0,m.isEqual)(U,d.localResource)),1),v[1].length||(this.synchronizingResources.splice(p,1),this._onSynchronizeResources.fire(this.synchronizingResources)),this.previews}async mergeAll(){if(!this.previews)throw new Error("You need to create preview before merging or applying");if(this.synchronizingResources.length)throw new Error("Cannot merge or apply while synchronizing resources");const n=[];for(const[s,c]of this.previews){this.synchronizingResources.push([s,c.resourcePreviews.map(d=>d.localResource)]),this._onSynchronizeResources.fire(this.synchronizingResources);const l=this.synchronisers.find(d=>d.resource===s);let h=c;for(const d of c.resourcePreviews)(d.localChange!==0||d.remoteChange!==0)&&d.mergeState==="preview"&&(h=await l.merge(d.previewResource));h&&n.push(this.toSyncResourcePreview(l.resource,h)),this.synchronizingResources.splice(this.synchronizingResources.findIndex(d=>d[0]===s),1),this._onSynchronizeResources.fire(this.synchronizingResources)}return this.previews=n,this.previews}async getPreviews(n){const s=[];for(const c of this.synchronisers){if(n.isCancellationRequested)return[];const l=await c.preview(this.manifest,this.syncHeaders);l&&s.push(this.toSyncResourcePreview(c.resource,l))}return s}toSyncResourcePreview(n,s){return[n,{isLastSyncFromCurrentMachine:s.isLastSyncFromCurrentMachine,resourcePreviews:s.resourcePreviews.map(t)}]}reset(){this.previewsPromise&&(this.previewsPromise.cancel(),this.previewsPromise=void 0),this.previews=void 0,this.synchronizingResources=[]}dispose(){this.reset(),this.isDisposed=!0}}function t(r){return{localResource:r.localResource,previewResource:r.previewResource,remoteResource:r.remoteResource,acceptedResource:r.acceptedResource,localChange:r.localChange,remoteChange:r.remoteChange,mergeState:r.mergeState}}}),define(Z[214],te([0,1,3,2,18,5,23]),function(K,e,D,L,R,T,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.UserDataSyncChannelClient=e.UserDataSyncChannel=void 0;class P{constructor(C,g){this.service=C,this.logService=g,this.manualSyncTasks=new Map,this.onManualSynchronizeResources=new D.Emitter}listen(C,g){switch(g){case"onDidChangeStatus":return this.service.onDidChangeStatus;case"onDidChangeConflicts":return this.service.onDidChangeConflicts;case"onDidChangeLocal":return this.service.onDidChangeLocal;case"onDidChangeLastSyncTime":return this.service.onDidChangeLastSyncTime;case"onSyncErrors":return this.service.onSyncErrors;case"onDidResetLocal":return this.service.onDidResetLocal;case"onDidResetRemote":return this.service.onDidResetRemote;case"manualSync/onSynchronizeResources":return this.onManualSynchronizeResources.event}throw new Error(`Event not found: ${g}`)}async call(C,g,w){try{return await this._call(C,g,w)}catch(u){throw this.logService.error(u),u}}async _call(C,g,w){switch(g){case"_getInitialData":return Promise.resolve([this.service.status,this.service.conflicts,this.service.lastSyncTime]);case"replace":return this.service.replace(T.URI.revive(w[0]));case"reset":return this.service.reset();case"resetRemote":return this.service.resetRemote();case"resetLocal":return this.service.resetLocal();case"hasPreviouslySynced":return this.service.hasPreviouslySynced();case"hasLocalData":return this.service.hasLocalData();case"accept":return this.service.accept(w[0],T.URI.revive(w[1]),w[2],w[3]);case"resolveContent":return this.service.resolveContent(T.URI.revive(w[0]));case"getLocalSyncResourceHandles":return this.service.getLocalSyncResourceHandles(w[0]);case"getRemoteSyncResourceHandles":return this.service.getRemoteSyncResourceHandles(w[0]);case"getAssociatedResources":return this.service.getAssociatedResources(w[0],{created:w[1].created,uri:T.URI.revive(w[1].uri)});case"getMachineId":return this.service.getMachineId(w[0],{created:w[1].created,uri:T.URI.revive(w[1].uri)});case"createManualSyncTask":return this.createManualSyncTask()}if(g.startsWith("manualSync/")){const u=g.substring("manualSync/".length),S=w[0],f=this.getManualSyncTask(S);switch(w=w.slice(1),u){case"preview":return f.preview();case"accept":return f.accept(T.URI.revive(w[0]),w[1]);case"merge":return f.merge(T.URI.revive(w[0]));case"discard":return f.discard(T.URI.revive(w[0]));case"discardConflicts":return f.discardConflicts();case"apply":return f.apply();case"pull":return f.pull();case"push":return f.push();case"stop":return f.stop();case"_getStatus":return f.status;case"dispose":return this.disposeManualSyncTask(f)}}throw new Error("Invalid call")}getManualSyncTask(C){const g=this.manualSyncTasks.get(this.createKey(C));if(!g)throw new Error(`Manual sync taks not found: ${C}`);return g.manualSyncTask}async createManualSyncTask(){const C=new L.DisposableStore,g=C.add(await this.service.createManualSyncTask());return C.add(g.onSynchronizeResources(w=>this.onManualSynchronizeResources.fire({manualSyncTaskId:g.id,data:w}))),this.manualSyncTasks.set(this.createKey(g.id),{manualSyncTask:g,disposables:C}),{id:g.id,manifest:g.manifest,status:g.status}}disposeManualSyncTask(C){C.dispose();const g=this.createKey(C.id);this.manualSyncTasks.get(g)?.disposables.dispose(),this.manualSyncTasks.delete(g)}createKey(C){return`manualSyncTask-${C}`}}e.UserDataSyncChannel=P;class m extends L.Disposable{constructor(C){super();this._status="uninitialized",this._onDidChangeStatus=this._register(new D.Emitter),this.onDidChangeStatus=this._onDidChangeStatus.event,this._conflicts=[],this._onDidChangeConflicts=this._register(new D.Emitter),this.onDidChangeConflicts=this._onDidChangeConflicts.event,this._lastSyncTime=void 0,this._onDidChangeLastSyncTime=this._register(new D.Emitter),this.onDidChangeLastSyncTime=this._onDidChangeLastSyncTime.event,this._onSyncErrors=this._register(new D.Emitter),this.onSyncErrors=this._onSyncErrors.event,this.channel={call(g,w,u){return C.call(g,w,u).then(null,S=>{throw k.UserDataSyncError.toUserDataSyncError(S)})},listen(g,w){return C.listen(g,w)}},this.channel.call("_getInitialData").then(([g,w,u])=>{this.updateStatus(g),this.updateConflicts(w),u&&this.updateLastSyncTime(u),this._register(this.channel.listen("onDidChangeStatus")(S=>this.updateStatus(S))),this._register(this.channel.listen("onDidChangeLastSyncTime")(S=>this.updateLastSyncTime(S)))}),this._register(this.channel.listen("onDidChangeConflicts")(g=>this.updateConflicts(g))),this._register(this.channel.listen("onSyncErrors")(g=>this._onSyncErrors.fire(g.map(([w,u])=>[w,k.UserDataSyncError.toUserDataSyncError(u)]))))}get status(){return this._status}get onDidChangeLocal(){return this.channel.listen("onDidChangeLocal")}get conflicts(){return this._conflicts}get lastSyncTime(){return this._lastSyncTime}get onDidResetLocal(){return this.channel.listen("onDidResetLocal")}get onDidResetRemote(){return this.channel.listen("onDidResetRemote")}createSyncTask(){throw new Error("not supported")}async createManualSyncTask(){const{id:C,manifest:g,status:w}=await this.channel.call("createManualSyncTask"),u=this,S=new b(C,g,w,{async call(f,I,y){return u.channel.call(`manualSync/${f}`,[C,...(0,R.isArray)(I)?I:[I]],y)},listen(f,I){return D.Event.map(D.Event.filter(u.channel.listen(`manualSync/${f}`,I),y=>!S.isDiposed()&&y.manualSyncTaskId===C),y=>y.data)}});return S}replace(C){return this.channel.call("replace",[C])}reset(){return this.channel.call("reset")}resetRemote(){return this.channel.call("resetRemote")}resetLocal(){return this.channel.call("resetLocal")}hasPreviouslySynced(){return this.channel.call("hasPreviouslySynced")}hasLocalData(){return this.channel.call("hasLocalData")}accept(C,g,w,u){return this.channel.call("accept",[C,g,w,u])}resolveContent(C){return this.channel.call("resolveContent",[C])}async getLocalSyncResourceHandles(C){return(await this.channel.call("getLocalSyncResourceHandles",[C])).map(({created:w,uri:u})=>({created:w,uri:T.URI.revive(u)}))}async getRemoteSyncResourceHandles(C){return(await this.channel.call("getRemoteSyncResourceHandles",[C])).map(({created:w,uri:u})=>({created:w,uri:T.URI.revive(u)}))}async getAssociatedResources(C,g){return(await this.channel.call("getAssociatedResources",[C,g])).map(({resource:u,comparableResource:S})=>({resource:T.URI.revive(u),comparableResource:T.URI.revive(S)}))}async getMachineId(C,g){return this.channel.call("getMachineId",[C,g])}async updateStatus(C){this._status=C,this._onDidChangeStatus.fire(C)}async updateConflicts(C){this._conflicts=C.map(([g,w])=>[g,w.map(u=>({...u,localResource:T.URI.revive(u.localResource),remoteResource:T.URI.revive(u.remoteResource),previewResource:T.URI.revive(u.previewResource)}))]),this._onDidChangeConflicts.fire(this._conflicts)}updateLastSyncTime(C){this._lastSyncTime!==C&&(this._lastSyncTime=C,this._onDidChangeLastSyncTime.fire(C))}}e.UserDataSyncChannelClient=m;class b extends L.Disposable{constructor(C,g,w,u){super();this.id=C,this.manifest=g,this._disposed=!1,this._status=w;const S=this;this.channel={async call(f,I,y){try{const E=await u.call(f,I,y);return S.isDiposed()||(S._status=await u.call("_getStatus")),E}catch(E){throw k.UserDataSyncError.toUserDataSyncError(E)}},listen(f,I){return u.listen(f,I)}}}get onSynchronizeResources(){return this.channel.listen("onSynchronizeResources")}get status(){return this._status}async preview(){const C=await this.channel.call("preview");return this.deserializePreviews(C)}async accept(C,g){const w=await this.channel.call("accept",[C,g]);return this.deserializePreviews(w)}async merge(C){const g=await this.channel.call("merge",[C]);return this.deserializePreviews(g)}async discard(C){const g=await this.channel.call("discard",[C]);return this.deserializePreviews(g)}async discardConflicts(){const C=await this.channel.call("discardConflicts");return this.deserializePreviews(C)}async apply(){const C=await this.channel.call("apply");return this.deserializePreviews(C)}pull(){return this.channel.call("pull")}push(){return this.channel.call("push")}stop(){return this.channel.call("stop")}isDiposed(){return this._disposed}dispose(){this._disposed=!0,this.channel.call("dispose")}deserializePreviews(C){return C.map(([g,w])=>[g,{isLastSyncFromCurrentMachine:w.isLastSyncFromCurrentMachine,resourcePreviews:w.resourcePreviews.map(u=>({...u,localResource:T.URI.revive(u.localResource),remoteResource:T.URI.revive(u.remoteResource),previewResource:T.URI.revive(u.previewResource),acceptedResource:T.URI.revive(u.acceptedResource)}))}])}}}),define(Z[215],te([0,1,6,27,9,3,2,96,4,16,18,5,30,21,12,14,29,43,45,22,23]),function(K,e,D,L,R,T,k,P,m,b,i,C,g,w,u,S,f,I,y,E,o){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.RequestsSession=e.UserDataSyncStoreService=e.UserDataSyncStoreClient=e.UserDataSyncStoreManagementService=e.AbstractUserDataSyncStoreManagementService=void 0;const a="sync.previous.store",t="sync.donot-make-requests-until",r="sync.user-session-id",n="sync.machine-session-id",s=100,c=1e3*60*5;let l=class extends k.Disposable{constructor(p,U,F){super();this.productService=p,this.configurationService=U,this.storageService=F,this._onDidChangeUserDataSyncStore=this._register(new T.Emitter),this.onDidChangeUserDataSyncStore=this._onDidChangeUserDataSyncStore.event,this.updateUserDataSyncStore(),this._register(T.Event.filter(F.onDidChangeValue,z=>z.key===o.SYNC_SERVICE_URL_TYPE&&z.scope===0&&this.userDataSyncStoreType!==this.userDataSyncStore?.type)(()=>this.updateUserDataSyncStore()))}get userDataSyncStore(){return this._userDataSyncStore}get userDataSyncStoreType(){return this.storageService.get(o.SYNC_SERVICE_URL_TYPE,0)}set userDataSyncStoreType(p){this.storageService.store(o.SYNC_SERVICE_URL_TYPE,p,0,m.isWeb?0:1)}updateUserDataSyncStore(){this._userDataSyncStore=this.toUserDataSyncStore(this.productService[o.CONFIGURATION_SYNC_STORE_KEY],this.configurationService.getValue(o.CONFIGURATION_SYNC_STORE_KEY)),this._onDidChangeUserDataSyncStore.fire()}toUserDataSyncStore(p,U){p=m.isWeb&&p?.web?{...p,...p.web}:p;const F={...p||{},...U||{}};if(F&&(0,i.isString)(F.url)&&(0,i.isObject)(F.authenticationProviders)&&Object.keys(F.authenticationProviders).every(z=>(0,i.isArray)(F.authenticationProviders[z].scopes))){const z=F,H=!!z.canSwitch&&!U?.url,M=z.url===z.insidersUrl?"insiders":"stable",j=(H?this.userDataSyncStoreType:void 0)||M,q=U?.url||(j==="insiders"?z.insidersUrl:j==="stable"?z.stableUrl:z.url);return{url:C.URI.parse(q),type:j,defaultType:M,defaultUrl:C.URI.parse(z.url),stableUrl:C.URI.parse(z.stableUrl),insidersUrl:C.URI.parse(z.insidersUrl),canSwitch:H,authenticationProviders:Object.keys(z.authenticationProviders).reduce((x,$)=>(x.push({id:$,scopes:z.authenticationProviders[$].scopes}),x),[])}}}};l=fe([J(0,f.IProductService),J(1,w.IConfigurationService),J(2,E.IStorageService)],l),e.AbstractUserDataSyncStoreManagementService=l;let h=class extends l{constructor(p,U,F){super(p,U,F);const z=this.storageService.get(a,0);z&&(this.previousConfigurationSyncStore=JSON.parse(z));const H=this.productService[o.CONFIGURATION_SYNC_STORE_KEY];H?this.storageService.store(a,JSON.stringify(H),0,1):this.storageService.remove(a,0)}async switch(p){p!==this.userDataSyncStoreType&&(this.userDataSyncStoreType=p,this.updateUserDataSyncStore())}async getPreviousUserDataSyncStore(){return this.toUserDataSyncStore(this.previousConfigurationSyncStore)}};h=fe([J(0,f.IProductService),J(1,w.IConfigurationService),J(2,E.IStorageService)],h),e.UserDataSyncStoreManagementService=h;let d=class extends k.Disposable{constructor(p,U,F,z,H,M,j){super();this.requestService=F,this.logService=z,this.storageService=j,this._onTokenFailed=this._register(new T.Emitter),this.onTokenFailed=this._onTokenFailed.event,this._onTokenSucceed=this._register(new T.Emitter),this.onTokenSucceed=this._onTokenSucceed.event,this._donotMakeRequestsUntil=void 0,this._onDidChangeDonotMakeRequestsUntil=this._register(new T.Emitter),this.onDidChangeDonotMakeRequestsUntil=this._onDidChangeDonotMakeRequestsUntil.event,this.resetDonotMakeRequestsUntilPromise=void 0,this.updateUserDataSyncStoreUrl(p),this.commonHeadersPromise=(0,y.getServiceMachineId)(H,M,j).then(q=>{const x={"X-Client-Name":`${U.applicationName}${m.isWeb?"-web":""}`,"X-Client-Version":U.version};return U.commit&&(x["X-Client-Commit"]=U.commit),x}),this.session=new A(s,c,this.requestService,this.logService),this.initDonotMakeRequestsUntil(),this._register((0,k.toDisposable)(()=>{this.resetDonotMakeRequestsUntilPromise&&(this.resetDonotMakeRequestsUntilPromise.cancel(),this.resetDonotMakeRequestsUntilPromise=void 0)}))}get donotMakeRequestsUntil(){return this._donotMakeRequestsUntil}setAuthToken(p,U){this.authToken={token:p,type:U}}updateUserDataSyncStoreUrl(p){this.userDataSyncStoreUrl=p?(0,b.joinPath)(p,"v1"):void 0}initDonotMakeRequestsUntil(){const p=this.storageService.getNumber(t,0);p&&Date.now()<p&&this.setDonotMakeRequestsUntil(new Date(p))}setDonotMakeRequestsUntil(p){this._donotMakeRequestsUntil?.getTime()!==p?.getTime()&&(this._donotMakeRequestsUntil=p,this.resetDonotMakeRequestsUntilPromise&&(this.resetDonotMakeRequestsUntilPromise.cancel(),this.resetDonotMakeRequestsUntilPromise=void 0),this._donotMakeRequestsUntil?(this.storageService.store(t,this._donotMakeRequestsUntil.getTime(),0,1),this.resetDonotMakeRequestsUntilPromise=(0,D.createCancelablePromise)(U=>(0,D.timeout)(this._donotMakeRequestsUntil.getTime()-Date.now(),U).then(()=>this.setDonotMakeRequestsUntil(void 0))),this.resetDonotMakeRequestsUntilPromise.then(null,U=>null)):this.storageService.remove(t,0),this._onDidChangeDonotMakeRequestsUntil.fire())}async getAllRefs(p){if(!this.userDataSyncStoreUrl)throw new Error("No settings sync store url configured.");const U=(0,b.joinPath)(this.userDataSyncStoreUrl,"resource",p),F={},z=await this.request(U.toString(),{type:"GET",headers:F},[],L.CancellationToken.None);return(await(0,I.asJson)(z)||[]).map(({url:M,created:j})=>({ref:(0,b.relativePath)(U,U.with({path:M})),created:j*1e3}))}async resolveContent(p,U){if(!this.userDataSyncStoreUrl)throw new Error("No settings sync store url configured.");const F=(0,b.joinPath)(this.userDataSyncStoreUrl,"resource",p,U).toString(),z={};z["Cache-Control"]="no-cache";const H=await this.request(F,{type:"GET",headers:z},[],L.CancellationToken.None);return await(0,I.asText)(H)}async delete(p){if(!this.userDataSyncStoreUrl)throw new Error("No settings sync store url configured.");const U=(0,b.joinPath)(this.userDataSyncStoreUrl,"resource",p).toString(),F={};await this.request(U,{type:"DELETE",headers:F},[],L.CancellationToken.None)}async read(p,U,F={}){if(!this.userDataSyncStoreUrl)throw new Error("No settings sync store url configured.");const z=(0,b.joinPath)(this.userDataSyncStoreUrl,"resource",p,"latest").toString();F={...F},F["Cache-Control"]="no-cache",U&&(F["If-None-Match"]=U.ref);const H=await this.request(z,{type:"GET",headers:F},[304],L.CancellationToken.None);let M=null;if(H.res.statusCode===304&&(M=U),M===null){const j=H.res.headers.etag;if(!j)throw new o.UserDataSyncStoreError("Server did not return the ref",z,"NoRef",H.res.statusCode,H.res.headers[o.HEADER_OPERATION_ID]);const q=await(0,I.asText)(H);if(!q&&H.res.statusCode===304)throw new o.UserDataSyncStoreError("Empty response",z,"EmptyResponse",H.res.statusCode,H.res.headers[o.HEADER_OPERATION_ID]);M={ref:j,content:q}}return M}async write(p,U,F,z={}){if(!this.userDataSyncStoreUrl)throw new Error("No settings sync store url configured.");const H=(0,b.joinPath)(this.userDataSyncStoreUrl,"resource",p).toString();z={...z},z["Content-Type"]=P.Mimes.text,F&&(z["If-Match"]=F);const M=await this.request(H,{type:"POST",data:U,headers:z},[],L.CancellationToken.None),j=M.res.headers.etag;if(!j)throw new o.UserDataSyncStoreError("Server did not return the ref",H,"NoRef",M.res.statusCode,M.res.headers[o.HEADER_OPERATION_ID]);return j}async manifest(p,U={}){if(!this.userDataSyncStoreUrl)throw new Error("No settings sync store url configured.");const F=(0,b.joinPath)(this.userDataSyncStoreUrl,"manifest").toString();U={...U},U["Content-Type"]="application/json",p&&(U["If-None-Match"]=p.ref);const z=await this.request(F,{type:"GET",headers:U},[304],L.CancellationToken.None);let H=null;if(z.res.statusCode===304&&(H=p),!H){const j=z.res.headers.etag;if(!j)throw new o.UserDataSyncStoreError("Server did not return the ref",F,"NoRef",z.res.statusCode,z.res.headers[o.HEADER_OPERATION_ID]);const q=await(0,I.asText)(z);if(!q&&z.res.statusCode===304)throw new o.UserDataSyncStoreError("Empty response",F,"EmptyResponse",z.res.statusCode,z.res.headers[o.HEADER_OPERATION_ID]);q&&(H={...JSON.parse(q),ref:j})}const M=this.storageService.get(r,0);return M&&H&&M!==H.session&&this.clearSession(),H===null&&M&&this.clearSession(),H&&this.storageService.store(r,H.session,0,1),H}async clear(){if(!this.userDataSyncStoreUrl)throw new Error("No settings sync store url configured.");const p=(0,b.joinPath)(this.userDataSyncStoreUrl,"resource").toString(),U={"Content-Type":P.Mimes.text};await this.request(p,{type:"DELETE",headers:U},[],L.CancellationToken.None),this.clearSession()}clearSession(){this.storageService.remove(r,0),this.storageService.remove(n,0)}async request(p,U,F,z){if(!this.authToken)throw new o.UserDataSyncStoreError("No Auth Token Available",p,"Unauthorized",void 0,void 0);if(this._donotMakeRequestsUntil&&Date.now()<this._donotMakeRequestsUntil.getTime())throw new o.UserDataSyncStoreError(`${U.type} request '${p}' failed because of too many requests (429).`,p,"TooManyRequestsAndRetryAfter",void 0,void 0);this.setDonotMakeRequestsUntil(void 0);const H=await this.commonHeadersPromise;U.headers={...U.headers||{},...H,"X-Account-Type":this.authToken.type,authorization:`Bearer ${this.authToken.token}`},this.addSessionHeaders(U.headers),this.logService.trace("Sending request to server",{url:p,type:U.type,headers:{...U.headers,authorization:void 0}});let M;try{M=await this.session.request(p,U,z)}catch($){if(!($ instanceof o.UserDataSyncStoreError)){let N="RequestFailed";const W=(0,R.getErrorMessage)($).toLowerCase();W.includes("xhr timeout")?N="RequestTimeout":W.includes("protocol")&&W.includes("not supported")?N="RequestProtocolNotSupported":W.includes("request path contains unescaped characters")?N="RequestPathNotEscaped":W.includes("headers must be an object")?N="RequestHeadersNotObject":(0,R.isPromiseCanceledError)($)&&(N="RequestCanceled"),$=new o.UserDataSyncStoreError(`Connection refused for the request '${p}'.`,p,N,void 0,void 0)}throw this.logService.info("Request failed",p),$}const j=M.res.headers[o.HEADER_OPERATION_ID],q={url:p,status:M.res.statusCode,"execution-id":U.headers[o.HEADER_EXECUTION_ID],"operation-id":j},x=(0,I.isSuccess)(M)||M.res.statusCode&&F.indexOf(M.res.statusCode)!==-1;if(x?this.logService.trace("Request succeeded",q):this.logService.info("Request failed",q),M.res.statusCode===401)throw this.authToken=void 0,this._onTokenFailed.fire(),new o.UserDataSyncStoreError(`Request '${p}' failed because of Unauthorized (401).`,p,"Unauthorized",M.res.statusCode,j);if(this._onTokenSucceed.fire(),M.res.statusCode===409)throw new o.UserDataSyncStoreError(`${U.type} request '${p}' failed because of Conflict (409). There is new data for this resource. Make the request again with latest data.`,p,"Conflict",M.res.statusCode,j);if(M.res.statusCode===410)throw new o.UserDataSyncStoreError(`${U.type} request '${p}' failed because the requested resource is not longer available (410).`,p,"Gone",M.res.statusCode,j);if(M.res.statusCode===412)throw new o.UserDataSyncStoreError(`${U.type} request '${p}' failed because of Precondition Failed (412). There is new data for this resource. Make the request again with latest data.`,p,"PreconditionFailed",M.res.statusCode,j);if(M.res.statusCode===413)throw new o.UserDataSyncStoreError(`${U.type} request '${p}' failed because of too large payload (413).`,p,"TooLarge",M.res.statusCode,j);if(M.res.statusCode===426)throw new o.UserDataSyncStoreError(`${U.type} request '${p}' failed with status Upgrade Required (426). Please upgrade the client and try again.`,p,"UpgradeRequired",M.res.statusCode,j);if(M.res.statusCode===429){const $=M.res.headers["retry-after"];throw $?(this.setDonotMakeRequestsUntil(new Date(Date.now()+parseInt($)*1e3)),new o.UserDataSyncStoreError(`${U.type} request '${p}' failed because of too many requests (429).`,p,"TooManyRequestsAndRetryAfter",M.res.statusCode,j)):new o.UserDataSyncStoreError(`${U.type} request '${p}' failed because of too many requests (429).`,p,"RemoteTooManyRequests",M.res.statusCode,j)}if(!x)throw new o.UserDataSyncStoreError("Server returned "+M.res.statusCode,p,"Unknown",M.res.statusCode,j);return M}addSessionHeaders(p){let U=this.storageService.get(n,0);U===void 0&&(U=(0,g.generateUuid)(),this.storageService.store(n,U,0,1)),p["X-Machine-Session-Id"]=U;const F=this.storageService.get(r,0);F!==void 0&&(p["X-User-Session-Id"]=F)}};d=fe([J(1,f.IProductService),J(2,I.IRequestService),J(3,o.IUserDataSyncLogService),J(4,u.IEnvironmentService),J(5,S.IFileService),J(6,E.IStorageService)],d),e.UserDataSyncStoreClient=d;let v=class extends d{constructor(p,U,F,z,H,M,j){super(p.userDataSyncStore?.url,U,F,z,H,M,j);this._register(p.onDidChangeUserDataSyncStore(()=>this.updateUserDataSyncStoreUrl(p.userDataSyncStore?.url)))}};v=fe([J(0,o.IUserDataSyncStoreManagementService),J(1,f.IProductService),J(2,I.IRequestService),J(3,o.IUserDataSyncLogService),J(4,u.IEnvironmentService),J(5,S.IFileService),J(6,E.IStorageService)],v),e.UserDataSyncStoreService=v;class A{constructor(p,U,F,z){this.limit=p,this.interval=U,this.requestService=F,this.logService=z,this.requests=[],this.startTime=void 0}request(p,U,F){if(this.isExpired()&&this.reset(),U.url=p,this.requests.length>=this.limit)throw this.logService.info("Too many requests",...this.requests),new o.UserDataSyncStoreError(`Too many requests. Only ${this.limit} requests allowed in ${this.interval/(1e3*60)} minutes.`,p,"LocalTooManyRequests",void 0,void 0);return this.startTime=this.startTime||new Date,this.requests.push(p),this.requestService.request(U,F)}isExpired(){return this.startTime!==void 0&&new Date().getTime()-this.startTime.getTime()>this.interval}reset(){this.requests=[],this.startTime=void 0}}e.RequestsSession=A}),define(Z[216],te([0,1,3,59,29,22,20,90,23,60,61]),function(K,e,D,L,R,T,k,P,m,b,i){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.UserDataAutoSyncService=void 0;let C=class extends P.UserDataAutoSyncService{constructor(w,u,S,f,I,y,E,o,a,t,r,n){super(w,u,S,f,I,E,o,a,t,r,n);this._register(D.Event.debounce(D.Event.any(D.Event.map(y.onDidFocusWindow,()=>"windowFocus"),D.Event.map(y.onDidOpenWindow,()=>"windowOpen")),(s,c)=>s?[...s,c]:[c],1e3)(s=>this.triggerSync(s,!0,!1)))}};C=fe([J(0,R.IProductService),J(1,m.IUserDataSyncStoreManagementService),J(2,m.IUserDataSyncStoreService),J(3,m.IUserDataSyncResourceEnablementService),J(4,m.IUserDataSyncService),J(5,L.INativeHostService),J(6,m.IUserDataSyncLogService),J(7,b.IUserDataSyncAccountService),J(8,k.ITelemetryService),J(9,i.IUserDataSyncMachinesService),J(10,T.IStorageService),J(11,m.IUserDataAutoSyncEnablementService)],C),e.UserDataAutoSyncService=C}),define(Z[217],te([0,1,6,3,2]),function(K,e,D,L,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ActiveWindowManager=void 0;class T extends R.Disposable{constructor({onDidOpenWindow:P,onDidFocusWindow:m,getActiveWindowId:b}){super();this.disposables=this._register(new R.DisposableStore),L.Event.latch(L.Event.any(P,m))(this.setActiveWindow,this,this.disposables),this.firstActiveWindowIdPromise=(0,D.createCancelablePromise)(()=>b()),(async()=>{try{const C=await this.firstActiveWindowIdPromise;this.activeWindowId=typeof this.activeWindowId=="number"?this.activeWindowId:C}catch(C){}finally{this.firstActiveWindowIdPromise=void 0}})()}setActiveWindow(P){this.firstActiveWindowIdPromise&&(this.firstActiveWindowIdPromise.cancel(),this.firstActiveWindowIdPromise=void 0),this.activeWindowId=P}async getActiveClientId(){return`window:${this.firstActiveWindowIdPromise?await this.firstActiveWindowIdPromise:this.activeWindowId}`}}e.ActiveWindowManager=T}),define(Z[62],te([0,1,51,6,8,18,19,112,224,225]),function(K,e,D,L,R,T,k,P,m,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.buffer=e.extract=e.zip=e.ExtractError=void 0;class i extends Error{constructor(t,r){let n=r.message;switch(t){case"CorruptZip":n=`Corrupt ZIP: ${n}`;break}super(n);this.type=t,this.cause=r}}e.ExtractError=i;function C(a){const t=a.externalFileAttributes>>16||33188;return[448,56,7].map(r=>t&r).reduce((r,n)=>r+n,t&61440)}function g(a){if(a instanceof i)return a;let t;return/end of central directory record signature not found/.test(a.message)&&(t="CorruptZip"),new i(t,a)}function w(a,t,r,n,s,c){const l=R.dirname(t),h=R.join(n,l);if(!h.startsWith(n))return Promise.reject(new Error(P.localize(0,null,t)));const d=R.join(n,t);let v;return c.onCancellationRequested(()=>{v&&v.destroy()}),Promise.resolve(k.Promises.mkdir(h,{recursive:!0})).then(()=>new Promise((A,O)=>{if(!c.isCancellationRequested)try{v=(0,D.createWriteStream)(d,{mode:r}),v.once("close",()=>A()),v.once("error",O),a.once("error",O),a.pipe(v)}catch(p){O(p)}}))}function u(a,t,r,n){let s=(0,L.createCancelablePromise)(()=>Promise.resolve()),c=0;return n.onCancellationRequested(()=>{s.cancel(),a.close()}),new Promise((l,h)=>{const d=new L.Sequencer,v=A=>{A.isCancellationRequested||(c++,a.readEntry())};a.once("error",h),a.once("close",()=>s.then(()=>{n.isCancellationRequested||a.entryCount===c?l():h(new i("Incomplete",new Error(P.localize(1,null,c,a.entryCount))))},h)),a.readEntry(),a.on("entry",A=>{if(n.isCancellationRequested)return;if(!r.sourcePathRegex.test(A.fileName)){v(n);return}const O=A.fileName.replace(r.sourcePathRegex,"");if(/\/$/.test(O)){const F=R.join(t,O);s=(0,L.createCancelablePromise)(z=>k.Promises.mkdir(F,{recursive:!0}).then(()=>v(z)).then(void 0,h));return}const p=f(a,A),U=C(A);s=(0,L.createCancelablePromise)(F=>d.queue(()=>p.then(z=>w(z,O,U,t,r,F).then(()=>v(F)))).then(null,h))})})}function S(a,t=!1){return new Promise((r,n)=>{(0,m.open)(a,t?{lazyEntries:!0}:void 0,(s,c)=>{s?n(g(s)):r((0,T.assertIsDefined)(c))})})}function f(a,t){return new Promise((r,n)=>{a.openReadStream(t,(s,c)=>{s?n(g(s)):r((0,T.assertIsDefined)(c))})})}function I(a,t){return new Promise((r,n)=>{const s=new b.ZipFile;t.forEach(l=>{l.contents?s.addBuffer(typeof l.contents=="string"?Buffer.from(l.contents,"utf8"):l.contents,l.path):l.localPath&&s.addFile(l.localPath,l.path)}),s.end();const c=(0,D.createWriteStream)(a);s.outputStream.pipe(c),s.outputStream.once("error",n),c.once("error",n),c.once("finish",()=>r(a))})}e.zip=I;function y(a,t,r={},n){const s=new RegExp(r.sourcePath?`^${r.sourcePath}`:"");let c=S(a,!0);return r.overwrite&&(c=c.then(l=>k.Promises.rm(t).then(()=>l))),c.then(l=>u(l,t,{sourcePathRegex:s},n))}e.extract=y;function E(a,t){return S(a).then(r=>new Promise((n,s)=>{r.on("entry",c=>{c.fileName===t&&f(r,c).then(l=>n(l),l=>s(l))}),r.once("close",()=>s(new Error(P.localize(2,null,t))))}))}function o(a,t){return E(a,t).then(r=>new Promise((n,s)=>{const c=[];r.once("error",s),r.on("data",l=>c.push(l)),r.on("end",()=>n(Buffer.concat(c)))}))}e.buffer=o}),define(Z[218],te([0,1,62,120]),function(K,e,D,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getManifest=void 0;function R(T){return(0,D.buffer)(T,"extension/package.json").then(k=>{try{return JSON.parse(k.toString("utf8"))}catch(P){throw new Error((0,L.localize)(0,null))}})}e.getManifest=R}),define(Z[219],te([0,1,17,6,9,2,15,8,4,16,58,5,30,19,62,121,12,28,32,141,14,13,29]),function(K,e,D,L,R,T,k,P,m,b,i,C,g,w,u,S,f,I,y,E,o,a,t){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionsScanner=void 0;const r="scanningSystem",n="scanningUser",s="extracting",c="deleting",l="renaming";let h=class extends T.Disposable{constructor(v,A,O,p,U){super();this.beforeRemovingExtension=v,this.fileService=A,this.logService=O,this.environmentService=p,this.productService=U,this._devSystemExtensionsPath=null,this.systemExtensionsPath=p.builtinExtensionsPath,this.extensionsPath=p.extensionsPath,this.uninstalledPath=P.join(this.extensionsPath,".obsolete"),this.uninstalledFileLimiter=new L.Queue}async cleanUp(){await this.removeUninstalledExtensions(),await this.removeOutdatedExtensions()}async scanExtensions(v){const A=[];(v===null||v===0)&&A.push(this.scanSystemExtensions().then(null,O=>Promise.reject(new I.ExtensionManagementError(this.joinErrors(O).message,r)))),(v===null||v===1)&&A.push(this.scanUserExtensions(!0).then(null,O=>Promise.reject(new I.ExtensionManagementError(this.joinErrors(O).message,n))));try{const O=await Promise.all(A);return(0,D.flatten)(O)}catch(O){throw this.joinErrors(O)}}async scanUserExtensions(v){this.logService.trace("Started scanning user extensions");let[A,O]=await Promise.all([this.getUninstalledExtensions(),this.scanAllUserExtensions()]);return O=O.filter(p=>!A[new y.ExtensionIdentifierWithVersion(p.identifier,p.manifest.version).key()]),v&&(O=(0,y.groupByExtension)(O,U=>U.identifier).map(U=>U.sort((F,z)=>i.rcompare(F.manifest.version,z.manifest.version))[0])),this.logService.trace("Scanned user extensions:",O.length),O}async scanAllUserExtensions(){return this.scanExtensionsInDir(this.extensionsPath,1)}async extractUserExtension(v,A,O,p){const U=v.key(),F=P.join(this.extensionsPath,`.${(0,g.generateUuid)()}`),z=P.join(this.extensionsPath,U);try{await w.Promises.rm(z)}catch(M){try{await w.Promises.rm(z)}catch(j){}throw new I.ExtensionManagementError((0,S.localize)(0,null,z,v.id),c)}await this.extractAtLocation(v,A,F,p);let H=await this.scanExtension(C.URI.file(F),1);if(!H)throw new Error((0,S.localize)(1,null,F));await this.storeMetadata(H,{...O,installedTimestamp:Date.now()});try{await this.rename(v,F,z,Date.now()+2*60*1e3),this.logService.info("Renamed to",z)}catch(M){try{await w.Promises.rm(F)}catch(j){}if(M.code==="ENOTEMPTY")this.logService.info("Rename failed because extension was installed by another source. So ignoring renaming.",v.id);else throw this.logService.info(`Rename failed because of ${(0,R.getErrorMessage)(M)}. Deleted from extracted location`,F),M}try{H=await this.scanExtension(C.URI.file(z),1)}catch(M){}if(H)return H;throw new Error((0,S.localize)(2,null,this.extensionsPath))}async saveMetadataForLocalExtension(v,A){return this.setMetadata(v,A),await this.storeMetadata(v,{...A,installedTimestamp:v.installedTimestamp}),v}async storeMetadata(v,A){A.isMachineScoped=A.isMachineScoped||void 0,A.isBuiltin=A.isBuiltin||void 0,A.installedTimestamp=A.installedTimestamp||void 0;const O=P.join(v.location.fsPath,"package.json"),p=await w.Promises.readFile(O,"utf8"),{manifest:U}=await this.parseManifest(p);return U.__metadata=A,await w.Promises.writeFile(O,JSON.stringify(U,null,"	")),v}getUninstalledExtensions(){return this.withUninstalledExtensions()}async setUninstalled(...v){const A=v.map(O=>new y.ExtensionIdentifierWithVersion(O.identifier,O.manifest.version));await this.withUninstalledExtensions(O=>{A.forEach(p=>O[p.key()]=!0)})}async setInstalled(v){await this.withUninstalledExtensions(p=>delete p[v.key()]);const O=(await this.scanExtensions(1)).find(p=>new y.ExtensionIdentifierWithVersion(p.identifier,p.manifest.version).equals(v))||null;return O?(await this.storeMetadata(O,{installedTimestamp:Date.now()}),this.scanExtension(O.location,1)):null}async withUninstalledExtensions(v){return this.uninstalledFileLimiter.queue(async()=>{let A;try{A=await w.Promises.readFile(this.uninstalledPath,"utf8")}catch(p){if(p.code!=="ENOENT")throw p}let O={};if(A)try{O=JSON.parse(A)}catch(p){}return v&&(v(O),Object.keys(O).length?await w.Promises.writeFile(this.uninstalledPath,JSON.stringify(O)):await w.Promises.rm(this.uninstalledPath)),O})}async removeExtension(v,A){this.logService.trace(`Deleting ${A} extension from disk`,v.identifier.id,v.location.fsPath),await w.Promises.rm(v.location.fsPath),this.logService.info("Deleted from disk",v.identifier.id,v.location.fsPath)}async removeUninstalledExtension(v){await this.removeExtension(v,"uninstalled"),await this.withUninstalledExtensions(A=>delete A[new y.ExtensionIdentifierWithVersion(v.identifier,v.manifest.version).key()])}async extractAtLocation(v,A,O,p){this.logService.trace(`Started extracting the extension from ${A} to ${O}`);try{await w.Promises.rm(O)}catch(U){throw new I.ExtensionManagementError(this.joinErrors(U).message,c)}try{await(0,u.extract)(A,O,{sourcePath:"extension",overwrite:!0},p),this.logService.info(`Extracted extension to ${O}:`,v.id)}catch(U){try{await w.Promises.rm(O)}catch(F){}throw new I.ExtensionManagementError(U.message,U instanceof u.ExtractError&&U.type?U.type:s)}}async rename(v,A,O,p){try{await w.Promises.rename(A,O)}catch(U){if(m.isWindows&&U&&U.code==="EPERM"&&Date.now()<p)return this.logService.info(`Failed renaming ${A} to ${O} with 'EPERM' error. Trying again...`,v.id),this.rename(v,A,O,p);throw new I.ExtensionManagementError(U.message||(0,S.localize)(3,null,A,O),U.code||l)}}async scanSystemExtensions(){this.logService.trace("Started scanning system extensions");const v=this.scanDefaultSystemExtensions();if(this.environmentService.isBuilt)return v;const A=this.scanDevSystemExtensions(),[O,p]=await Promise.all([v,A]);return[...O,...p]}async scanExtensionsInDir(v,A){const O=new L.Limiter(10),p=await this.fileService.resolve(C.URI.file(v));return p.children?(await Promise.all(p.children.filter(F=>F.isDirectory).map(F=>O.queue(async()=>A===1&&(0,b.basename)(F.resource).indexOf(".")===0?null:this.scanExtension(F.resource,A))))).filter(F=>F&&F.identifier):[]}async scanExtension(v,A){try{const O=await this.fileService.resolve(v);if(O.children){const{manifest:p,metadata:U}=await this.readManifest(v.fsPath),F=O.children.find(({name:j})=>/^readme(\.txt|\.md|)$/i.test(j))?.resource,z=O.children.find(({name:j})=>/^changelog(\.txt|\.md|)$/i.test(j))?.resource,H={id:(0,y.getGalleryExtensionId)(p.publisher,p.name)},M={type:A,identifier:H,manifest:p,location:v,readmeUrl:F,changelogUrl:z,publisherDisplayName:null,publisherId:null,isMachineScoped:!1,isBuiltin:A===0};return U&&(this.setMetadata(M,U),M.installedTimestamp=U.installedTimestamp),M}}catch(O){A!==0&&this.logService.trace(O)}return null}async scanDefaultSystemExtensions(){const v=await this.scanExtensionsInDir(this.systemExtensionsPath,0);return this.logService.trace("Scanned system extensions:",v.length),v}async scanDevSystemExtensions(){const v=this.getDevSystemExtensionsList();if(v.length){const A=await this.scanExtensionsInDir(this.devSystemExtensionsPath,0);return this.logService.trace("Scanned dev system extensions:",A.length),A.filter(O=>v.some(p=>(0,y.areSameExtensions)(O.identifier,{id:p})))}else return[]}setMetadata(v,A){v.publisherDisplayName=A.publisherDisplayName||null,v.publisherId=A.publisherId||null,v.identifier.uuid=A.id,v.isMachineScoped=!!A.isMachineScoped,v.isBuiltin=v.type===0||!!A.isBuiltin}async removeUninstalledExtensions(){const v=await this.getUninstalledExtensions(),A=await this.scanAllUserExtensions(),O=new Set;for(const F of A)v[new y.ExtensionIdentifierWithVersion(F.identifier,F.manifest.version).key()]||O.add(F.identifier.id.toLowerCase());const p=(0,y.groupByExtension)(A,F=>F.identifier);await L.Promises.settled(p.map(async F=>{const z=F.sort((H,M)=>i.rcompare(H.manifest.version,M.manifest.version))[0];O.has(z.identifier.id.toLowerCase())||await this.beforeRemovingExtension(z)}));const U=A.filter(F=>v[new y.ExtensionIdentifierWithVersion(F.identifier,F.manifest.version).key()]);await L.Promises.settled(U.map(F=>this.removeUninstalledExtension(F)))}async removeOutdatedExtensions(){const v=await this.scanAllUserExtensions(),A=[],O=(0,y.groupByExtension)(v,p=>p.identifier);A.push(...(0,D.flatten)(O.map(p=>p.sort((U,F)=>i.rcompare(U.manifest.version,F.manifest.version)).slice(1)))),await L.Promises.settled(A.map(p=>this.removeExtension(p,"outdated")))}getDevSystemExtensionsList(){return(this.productService.builtInExtensions||[]).map(v=>v.name)}joinErrors(v){const A=Array.isArray(v)?v:[v];return A.length===1?A[0]instanceof Error?A[0]:new Error(A[0]):A.reduce((O,p)=>new Error(`${O.message}${O.message?",":""}${p instanceof Error?p.message:p}`),new Error(""))}get devSystemExtensionsPath(){return this._devSystemExtensionsPath||(this._devSystemExtensionsPath=P.normalize(P.join(k.FileAccess.asFileUri("",K).fsPath,"..",".build","builtInExtensions"))),this._devSystemExtensionsPath}async readManifest(v){const A=[w.Promises.readFile(P.join(v,"package.json"),"utf8").then(F=>this.parseManifest(F)),w.Promises.readFile(P.join(v,"package.nls.json"),"utf8").then(void 0,F=>F.code!=="ENOENT"?Promise.reject(F):"{}").then(F=>JSON.parse(F))],[{manifest:O,metadata:p},U]=await Promise.all(A);return{manifest:(0,E.localizeManifest)(O,U),metadata:p}}parseManifest(v){return new Promise((A,O)=>{try{const p=JSON.parse(v),U=p.__metadata||null;A({manifest:p,metadata:U})}catch(p){O(new Error((0,S.localize)(4,null)))}})}};h=fe([J(1,o.IFileService),J(2,a.ILogService),J(3,f.INativeEnvironmentService),J(4,t.IProductService)],h),e.ExtensionsScanner=h}),define(Z[220],te([0,1,38,9,15,8,4,31,16,58,5,30,19,62,119,75,12,186,28,32,166,167,218,154,219,168,73,14,7,13,42,20]),function(K,e,D,L,R,T,k,P,m,b,i,C,g,w,u,S,f,I,y,E,o,a,t,r,n,s,c,l,h,d,v,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionManagementService=void 0;const O="unsetUninstalled",p="downloading";let U=class extends I.AbstractExtensionManagementService{constructor(q,x,$,N,W,_,Y){super(q,x,$);this.environmentService=N,this.downloadService=W,this.fileService=Y;const G=this._register(_.createInstance(a.ExtensionsLifecycle));this.extensionsScanner=this._register(_.createInstance(n.ExtensionsScanner,ee=>G.postUninstall(ee))),this.manifestCache=this._register(new r.ExtensionsManifestCache(N,this)),this.extensionsDownloader=this._register(_.createInstance(o.ExtensionsDownloader));const ne=this._register(new s.ExtensionsWatcher(this,Y,N,$));this._register(ne.onDidChangeExtensionsByAnotherSource(({added:ee,removed:X})=>{ee.length&&this._onDidInstallExtensions.fire(ee.map(B=>({identifier:B.identifier,operation:0,local:B}))),X.forEach(B=>this._onDidUninstallExtension.fire({identifier:B}))}))}getTargetPlatform(){return this._targetPlatformPromise||(this._targetPlatformPromise=(async()=>{const q=await this.isAlpineLinux(),x=(0,y.getTargetPlatform)(q?"alpine":k.platform,P.arch);return this.logService.debug("ExtensionManagementService#TargetPlatform:",x),x})()),this._targetPlatformPromise}async isAlpineLinux(){if(!k.isLinux)return!1;let q;try{q=(await this.fileService.readFile(i.URI.file("/etc/os-release"))).value.toString()}catch(x){try{q=(await this.fileService.readFile(i.URI.file("/usr/lib/os-release"))).value.toString()}catch($){this.logService.debug("Error while getting the os-release file.",(0,L.getErrorMessage)($))}}return!!q&&(q.match(/^ID=([^\u001b\r\n]*)/m)||[])[1]==="alpine"}async zip(q){this.logService.trace("ExtensionManagementService#zip",q.identifier.id);const x=await this.collectFiles(q),$=await(0,w.zip)((0,m.joinPath)(this.environmentService.tmpDir,(0,C.generateUuid)()).fsPath,x);return i.URI.file($)}async unzip(q){return this.logService.trace("ExtensionManagementService#unzip",q.toString()),(await this.install(q)).identifier}async getManifest(q){const x=await this.downloadVsix(q),$=T.resolve(x.fsPath);return(0,t.getManifest)($)}getInstalled(q=null){return this.extensionsScanner.scanExtensions(q)}async install(q,x={}){this.logService.trace("ExtensionManagementService#install",q.toString());const $=await this.downloadVsix(q),N=await(0,t.getManifest)(T.resolve($.fsPath));if(N.engines&&N.engines.vscode&&!(0,c.isEngineValid)(N.engines.vscode,v.default.version,v.default.date))throw new Error(u.localize(0,null,(0,E.getGalleryExtensionId)(N.publisher,N.name),v.default.version));return this.installExtension(N,$,x)}async updateMetadata(q,x){return this.logService.trace("ExtensionManagementService#updateMetadata",q.identifier.id),q=await this.extensionsScanner.saveMetadataForLocalExtension(q,{...q.manifest.__metadata||{},...x}),this.manifestCache.invalidate(),q}async updateExtensionScope(q,x){return this.logService.trace("ExtensionManagementService#updateExtensionScope",q.identifier.id),q=await this.extensionsScanner.saveMetadataForLocalExtension(q,{...q.manifest.__metadata||{},isMachineScoped:x}),this.manifestCache.invalidate(),q}removeDeprecatedExtensions(){return this.extensionsScanner.cleanUp()}async downloadVsix(q){if(q.scheme===R.Schemas.file)return q;const x=(0,m.joinPath)(this.environmentService.tmpDir,(0,C.generateUuid)());return await this.downloadService.download(q,x),x}createInstallExtensionTask(q,x,$){return i.URI.isUri(x)?new H(q,x,$,this.galleryService,this.extensionsScanner,this.logService):new z(x,$,this.extensionsDownloader,this.extensionsScanner,this.logService)}createUninstallExtensionTask(q,x){return new M(q,x,this.extensionsScanner)}async collectFiles(q){const x=async N=>{let W=await g.Promises.readdir(N);W=W.map(G=>T.join(N,G));const _=await Promise.all(W.map(G=>g.Promises.stat(G)));let Y=Promise.resolve([]);return _.forEach((G,ne)=>{const ee=W[ne];G.isFile()&&(Y=Y.then(X=>[...X,ee])),G.isDirectory()&&(Y=Y.then(X=>x(ee).then(B=>[...X,...B])))}),Y};return(await x(q.location.fsPath)).map(N=>({path:`extension/${T.relative(q.location.fsPath,N)}`,localPath:N}))}};U=fe([J(0,y.IExtensionGalleryService),J(1,A.ITelemetryService),J(2,d.ILogService),J(3,f.INativeEnvironmentService),J(4,S.IDownloadService),J(5,h.IInstantiationService),J(6,l.IFileService)],U),e.ExtensionManagementService=U;class F extends I.AbstractExtensionTask{constructor(q,x,$,N){super();this.identifier=q,this.source=x,this.extensionsScanner=$,this.logService=N,this._operation=1}get operation(){return this._operation}async installExtension(q,x){try{const $=await this.unsetUninstalledAndGetLocal(q.identifierWithVersion);if($)return q.metadata?this.extensionsScanner.saveMetadataForLocalExtension($,q.metadata):$}catch($){throw k.isMacintosh?new y.ExtensionManagementError(u.localize(1,null),O):new y.ExtensionManagementError(u.localize(2,null),O)}return this.extract(q,x)}async unsetUninstalledAndGetLocal(q){if(!await this.isUninstalled(q))return null;this.logService.trace("Removing the extension from uninstalled list:",q.id);const $=await this.extensionsScanner.setInstalled(q);return this.logService.info("Removed the extension from uninstalled list:",q.id),$}async isUninstalled(q){return!!(await this.extensionsScanner.getUninstalledExtensions())[q.key()]}async extract({zipPath:q,identifierWithVersion:x,metadata:$},N){let W=await this.extensionsScanner.extractUserExtension(x,q,$,N);return this.logService.info("Extracting completed.",x.id),W}}class z extends F{constructor(q,x,$,N,W){super(q.identifier,q,N,W);this.gallery=q,this.options=x,this.extensionsDownloader=$}async doRun(q){const $=(await this.extensionsScanner.scanExtensions(null)).find(_=>(0,E.areSameExtensions)(_.identifier,this.gallery.identifier));$&&(this._operation=2);const N=await this.downloadInstallableExtension(this.gallery,this._operation);N.metadata.isMachineScoped=this.options.isMachineScoped||$?.isMachineScoped,N.metadata.isBuiltin=this.options.isBuiltin||$?.isBuiltin;const W=await this.installExtension(N,q);$&&b.neq($.manifest.version,this.gallery.version)&&await this.extensionsScanner.setUninstalled($);try{await this.extensionsDownloader.delete(i.URI.file(N.zipPath))}catch(_){}return W}async downloadInstallableExtension(q,x){const $={id:q.identifier.uuid,publisherId:q.publisherId,publisherDisplayName:q.publisherDisplayName};let N;try{this.logService.trace("Started downloading extension:",q.identifier.id),N=(await this.extensionsDownloader.downloadExtension(q,x)).fsPath,this.logService.info("Downloaded extension:",q.identifier.id,N)}catch(W){throw new y.ExtensionManagementError((0,I.joinErrors)(W).message,p)}try{const W=await(0,t.getManifest)(N);return{zipPath:N,identifierWithVersion:new E.ExtensionIdentifierWithVersion(q.identifier,W.version),metadata:$}}catch(W){throw new y.ExtensionManagementError((0,I.joinErrors)(W).message,I.INSTALL_ERROR_VALIDATING)}}}class H extends F{constructor(q,x,$,N,W,_){super({id:(0,E.getGalleryExtensionId)(q.publisher,q.name)},x,W,_);this.manifest=q,this.location=x,this.options=$,this.galleryService=N}async doRun(q){const x=new E.ExtensionIdentifierWithVersion(this.identifier,this.manifest.version),N=(await this.extensionsScanner.scanExtensions(1)).find(_=>(0,E.areSameExtensions)(this.identifier,_.identifier)),W=await this.getMetadata(this.identifier.id,q);if(W.isMachineScoped=this.options.isMachineScoped||N?.isMachineScoped,W.isBuiltin=this.options.isBuiltin||N?.isBuiltin,N)if(this._operation=2,x.equals(new E.ExtensionIdentifierWithVersion(N.identifier,N.manifest.version)))try{await this.extensionsScanner.removeExtension(N,"existing")}catch(_){throw new Error(u.localize(3,null,this.manifest.displayName||this.manifest.name))}else b.gt(N.manifest.version,this.manifest.version)&&await this.extensionsScanner.setUninstalled(N);else{const _=await this.unsetUninstalledAndGetLocal(x);if(_)try{await this.extensionsScanner.removeExtension(_,"existing")}catch(Y){throw new Error(u.localize(4,null,this.manifest.displayName||this.manifest.name))}}return this.installExtension({zipPath:T.resolve(this.location.fsPath),identifierWithVersion:x,metadata:W},q)}async getMetadata(q,x){try{const $=(await this.galleryService.query({names:[q],pageSize:1},x)).firstPage[0];if($)return{id:$.identifier.uuid,publisherDisplayName:$.publisherDisplayName,publisherId:$.publisherId}}catch($){}return{}}}class M extends I.AbstractExtensionTask{constructor(q,x,$){super();this.extension=q,this.options=x,this.extensionsScanner=$}async doRun(q){const x=[],$=await this.extensionsScanner.scanUserExtensions(!1);if(this.options.versionOnly){const N=new E.ExtensionIdentifierWithVersion(this.extension.identifier,this.extension.manifest.version);x.push(...$.filter(W=>N.equals(new E.ExtensionIdentifierWithVersion(W.identifier,W.manifest.version))))}else x.push(...$.filter(N=>(0,E.areSameExtensions)(N.identifier,this.extension.identifier)));if(!x.length)throw new Error(u.localize(5,null,this.extension.manifest.displayName||this.extension.manifest.name));if(await this.extensionsScanner.setUninstalled(...x),this.options.remove)for(const N of x)try{q.isCancellationRequested||await this.extensionsScanner.removeUninstalledExtension(N)}catch(W){throw new Error(u.localize(6,null,(0,D.toErrorMessage)(W)))}}}}),define(Z[226],te([0,1,106,51,227,35,38,9,2,15,16,5,36,105,174,151,175,163,164,165,149,155,21,177,74,185,75,179,12,139,181,188,28,152,187,220,76,142,14,171,173,53,7,160,79,161,162,57,170,13,80,59,42,29,178,43,22,183,184,20,83,84,85,46,189,190,86,192,198,88,89,90,23,60,209,210,211,61,212,213,214,215,216,217,153,169]),function(K,e,D,L,R,T,k,P,m,b,i,C,g,w,u,S,f,I,y,E,o,a,t,r,n,s,c,l,h,d,v,A,O,p,U,F,z,H,M,j,q,x,$,N,W,_,Y,G,ne,ee,X,B,re,ie,ce,ue,ge,de,Ie,Pe,Ee,Oe,Re,Te,Ne,_e,ze,$e,Q,ae,oe,pe,Se,Fe,Le,Me,Ae,V,se,le,he,me,be,ve,we,Ce){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.main=void 0;class De extends m.Disposable{constructor(ye){super();this.configuration=ye,this.server=this._register(new w.Server),(0,R.gracefulify)(L),this.registerListeners()}registerListeners(){const ye=()=>this.dispose();process.once("exit",ye),D.ipcRenderer.once("vscode:electron-main->shared-process=exit",ye)}async open(){const ye=await this.initServices();(0,Se.registerConfiguration)(),ye.invokeFunction(Ue=>{const qe=Ue.get(ee.ILogService);qe.trace("sharedProcess configuration",JSON.stringify(this.configuration)),this.initChannels(Ue),this.registerErrorHandler(qe)}),this._register((0,m.combinedDisposable)(ye.createInstance(u.CodeCacheCleaner,this.configuration.codeCachePath),ye.createInstance(f.LanguagePackCachedDataCleaner),ye.createInstance(E.StorageDataCleaner,this.configuration.backupWorkspacesPath),ye.createInstance(y.LogsDataCleaner),ye.createInstance(I.LocalizationsUpdater),ye.createInstance(S.DeprecatedExtensionsCleaner)))}async initServices(){const ye=new W.ServiceCollection,Ue={_serviceBrand:void 0,...re.default};ye.set(ie.IProductService,Ue);const qe=new g.StaticRouter(He=>He==="main"),Ge=new _.MessagePortMainProcessService(this.server,qe);ye.set(Y.IMainProcessService,Ge);const xe=new d.NativeEnvironmentService(this.configuration.args,Ue);ye.set(h.INativeEnvironmentService,xe);const tt=new X.LogLevelChannelClient(this.server.getChannel("logLevel",qe)),Ke=new X.LoggerChannelClient(this.configuration.logLevel,tt.onDidChangeLogLevel,Ge.getChannel("logger"));ye.set(ee.ILoggerService,Ke);const rt=this._register(new ee.MultiplexLogService([this._register(new ee.ConsoleLogger(this.configuration.logLevel)),this._register(Ke.createLogger((0,i.joinPath)(C.URI.file(xe.logsPath),"sharedprocess.log"),{name:"sharedprocess"}))])),Ve=this._register(new X.FollowerLogService(tt,rt));ye.set(ee.ILogService,Ve);const Ye=this._register(new j.FileService(Ve));ye.set(M.IFileService,Ye);const st=this._register(new q.DiskFileSystemProvider(Ve));Ye.registerProvider(b.Schemas.file,st);const We=this._register(new r.ConfigurationService(xe.settingsResource,Ye));ye.set(t.IConfigurationService,We),await We.initialize();const Qe=new de.NativeStorageService(void 0,Ge,xe);ye.set(ge.IStorageService,Qe),await Qe.initialize(),this._register((0,m.toDisposable)(()=>Qe.flush())),ye.set(ue.IRequestService,new x.SyncDescriptor(ce.RequestService)),ye.set(o.IChecksumService,new x.SyncDescriptor(a.ChecksumService));const nt=g.ProxyChannel.toService(Ge.getChannel("nativeHost"),{context:this.configuration.windowId});ye.set(B.INativeHostService,nt),ye.set(c.IDownloadService,new x.SyncDescriptor(l.DownloadService));const at=this._register(new ve.ActiveWindowManager(nt)),ot=new g.StaticRouter(He=>at.getActiveClientId().then(lt=>He===lt));ye.set(z.IExtensionRecommendationNotificationService,new H.ExtensionRecommendationNotificationServiceChannelClient(this.server.getChannel("extensionRecommendationNotification",ot)));let Ze,it;const ct=[];if((0,Te.supportsTelemetry)(Ue,xe)){it=new Oe.TelemetryLogAppender(Ke,xe),ct.push(it);const{appRoot:He,extensionsPath:lt,installSourcePath:vt}=xe;if(Ue.aiConfig&&Ue.aiConfig.asimovKey){const ft=new Ne.AppInsightsAppender("monacoworkbench",null,Ue.aiConfig.asimovKey);this._register((0,m.toDisposable)(()=>ft.flush())),ct.push(ft)}Ze=new Re.TelemetryService({appenders:ct,commonProperties:(0,Ie.resolveCommonProperties)(Ye,(0,T.release)(),(0,T.hostname)(),process.arch,Ue.commit,Ue.version,this.configuration.machineId,Ue.msftInternalDomains,vt),sendErrorTelemetry:!0,piiPaths:[He,lt]},We)}else Ze=Te.NullTelemetryService,it=Te.NullAppender;this.server.registerChannel("telemetryAppender",new Ee.TelemetryAppenderChannel(it)),ye.set(Pe.ITelemetryService,Ze);const yt=new _e.CustomEndpointTelemetryService(We,Ze,Ke,xe);return ye.set(Pe.ICustomEndpointTelemetryService,yt),ye.set(O.IExtensionManagementService,new x.SyncDescriptor(F.ExtensionManagementService)),ye.set(O.IExtensionGalleryService,new x.SyncDescriptor(A.ExtensionGalleryService)),ye.set(O.IExtensionTipsService,new x.SyncDescriptor(U.ExtensionTipsService)),ye.set(G.ILocalizationsService,new x.SyncDescriptor(ne.LocalizationsService)),ye.set(n.IDiagnosticsService,new x.SyncDescriptor(s.DiagnosticsService)),ye.set(Fe.IUserDataSyncAccountService,new x.SyncDescriptor(Fe.UserDataSyncAccountService)),ye.set(Se.IUserDataSyncLogService,new x.SyncDescriptor(Ae.UserDataSyncLogService)),ye.set(Se.IUserDataSyncUtilService,new Me.UserDataSyncUtilServiceClient(this.server.getChannel("userDataSyncUtil",He=>He.ctx!=="main"))),ye.set(O.IGlobalExtensionEnablementService,new x.SyncDescriptor(v.GlobalExtensionEnablementService)),ye.set(oe.IIgnoredExtensionsManagementService,new x.SyncDescriptor(oe.IgnoredExtensionsManagementService)),ye.set(ae.IExtensionsStorageSyncService,new x.SyncDescriptor(ae.ExtensionsStorageSyncService)),ye.set(Se.IUserDataSyncStoreManagementService,new x.SyncDescriptor(me.UserDataSyncStoreManagementService)),ye.set(Se.IUserDataSyncStoreService,new x.SyncDescriptor(me.UserDataSyncStoreService)),ye.set(V.IUserDataSyncMachinesService,new x.SyncDescriptor(V.UserDataSyncMachinesService)),ye.set(Se.IUserDataSyncBackupStoreService,new x.SyncDescriptor(Le.UserDataSyncBackupStoreService)),ye.set(Se.IUserDataAutoSyncEnablementService,new x.SyncDescriptor(pe.UserDataAutoSyncEnablementService)),ye.set(Se.IUserDataSyncResourceEnablementService,new x.SyncDescriptor(se.UserDataSyncResourceEnablementService)),ye.set(Se.IUserDataSyncService,new x.SyncDescriptor(le.UserDataSyncService)),ye.set($e.ILocalPtyService,this._register(new Q.PtyHostService({graceTime:6e4,shortGraceTime:6e3,scrollback:We.getValue("terminal.integrated.persistentSessionScrollback")??100},We,xe,Ve,Ze))),ye.set(we.IExtensionHostStarter,this._register(new Ce.ExtensionHostStarter(Ve))),new N.InstantiationService(ye)}initChannels(ye){const Ue=new p.ExtensionManagementChannel(ye.get(O.IExtensionManagementService),()=>null);this.server.registerChannel("extensions",Ue);const qe=g.ProxyChannel.fromService(ye.get(G.ILocalizationsService));this.server.registerChannel("localizations",qe);const Ge=g.ProxyChannel.fromService(ye.get(n.IDiagnosticsService));this.server.registerChannel("diagnostics",Ge);const xe=new p.ExtensionTipsChannel(ye.get(O.IExtensionTipsService));this.server.registerChannel("extensionTipsService",xe);const tt=g.ProxyChannel.fromService(ye.get(o.IChecksumService));this.server.registerChannel("checksum",tt);const Ke=new Me.UserDataSyncMachinesServiceChannel(ye.get(V.IUserDataSyncMachinesService));this.server.registerChannel("userDataSyncMachines",Ke);const rt=g.ProxyChannel.fromService(ye.get(Pe.ICustomEndpointTelemetryService));this.server.registerChannel("customEndpointTelemetry",rt);const Ve=new Me.UserDataSyncAccountServiceChannel(ye.get(Fe.IUserDataSyncAccountService));this.server.registerChannel("userDataSyncAccount",Ve);const Ye=new Me.UserDataSyncStoreManagementServiceChannel(ye.get(Se.IUserDataSyncStoreManagementService));this.server.registerChannel("userDataSyncStoreManagement",Ye);const st=new he.UserDataSyncChannel(ye.get(Se.IUserDataSyncService),ye.get(ee.ILogService));this.server.registerChannel("userDataSync",st);const We=this._register(ye.get($.IInstantiationService).createInstance(be.UserDataAutoSyncService)),Qe=new Me.UserDataAutoSyncChannel(We);this.server.registerChannel("userDataAutoSync",Qe);const nt=ye.get($e.ILocalPtyService),at=g.ProxyChannel.fromService(nt);this.server.registerChannel(ze.TerminalIpcChannels.LocalPty,at);const ot=g.ProxyChannel.fromService(ye.get(we.IExtensionHostStarter));this.server.registerChannel(we.ipcExtensionHostStarterChannelName,ot)}registerErrorHandler(ye){window.addEventListener("unhandledrejection",Ue=>{(0,P.onUnexpectedError)(Ue.reason),Ue.preventDefault()}),(0,P.setUnexpectedErrorHandler)(Ue=>{const qe=(0,k.toErrorMessage)(Ue,!0);!qe||ye.error(`[uncaught exception in sharedProcess]: ${qe}`)})}}async function ke(Xe){const ye=new De(Xe);D.ipcRenderer.send("vscode:shared-process->electron-main=ipc-ready"),await ye.open(),D.ipcRenderer.send("vscode:shared-process->electron-main=init-done")}e.main=ke})}).call(this);

//# sourceMappingURL=https://ticino.blob.core.windows.net/sourcemaps/53aff5e347865fe22f9487ebd54dec9db23773b2/core/vs/code/electron-browser/sharedProcess/sharedProcessMain.js.map
