/*!--------------------------------------------------------
 * Copyright (C) Microsoft Corporation. All rights reserved.
 *--------------------------------------------------------*/(function(){var Z=["require","exports","vs/base/common/lifecycle","vs/base/common/async","vs/base/common/path","vs/nls","vs/nls!vs/code/node/cliProcessMain","vs/base/common/uri","vs/base/common/network","vs/base/common/errors","vs/base/common/platform","vs/base/common/types","vs/base/node/pfs","vs/base/common/event","vs/platform/log/common/log","vs/platform/instantiation/common/instantiation","vs/platform/files/common/files","vs/base/common/buffer","vs/base/common/objects","vs/base/common/resources","vs/base/common/arrays","vs/platform/environment/common/environment","vs/base/common/strings","vs/platform/extensionManagement/common/extensionManagement","vs/platform/extensionManagement/common/extensionManagementUtil","vs/base/common/cancellation","vs/platform/registry/common/platform","vs/platform/configuration/common/configuration","vs/base/common/process","vs/platform/telemetry/common/telemetry","vs/base/common/errorMessage","vs/base/common/uuid","vs/platform/product/common/product","vs/platform/configuration/common/configurationRegistry","os","child_process","vs/platform/telemetry/common/telemetryUtils","vs/base/common/stream","vs/base/common/extpath","vs/base/parts/ipc/common/ipc","vs/platform/extensions/common/extensions","vs/base/common/semver/semver","vs/platform/product/common/productService","vs/platform/request/common/request","vs/base/node/zip","vs/base/common/decorators","vs/base/common/map","vs/base/node/decoder","fs","vs/base/node/processes","vs/base/parts/ipc/node/ipc.cp","vs/platform/extensions/common/extensionValidator","vs/platform/instantiation/common/descriptors","vs/platform/download/common/download","vs/platform/files/node/watcher/watcher","vs/platform/instantiation/common/serviceCollection","vs/platform/localizations/common/localizations","vs/platform/files/common/io","vs/base/common/assert","vs/base/common/json","vs/base/common/console","vs/base/common/marshalling","vs/base/common/glob","vs/base/common/labels","vs/base/node/extpath","vs/base/node/powershell","vs/base/parts/storage/common/storage","vs/nls!vs/base/common/date","vs/base/common/date","vs/nls!vs/base/common/errorMessage","vs/nls!vs/base/node/processes","vs/base/node/shell","vs/nls!vs/base/node/zip","vs/nls!vs/platform/configuration/common/configurationRegistry","vs/nls!vs/platform/extensionManagement/common/abstractExtensionManagementService","vs/nls!vs/platform/extensionManagement/common/extensionManagement","vs/nls!vs/platform/extensionManagement/common/extensionManagementCLIService","vs/nls!vs/platform/extensionManagement/node/extensionManagementService","vs/nls!vs/platform/extensionManagement/node/extensionManagementUtil","vs/nls!vs/platform/extensionManagement/node/extensionsScanner","vs/nls!vs/platform/extensions/common/extensionValidator","vs/nls!vs/platform/files/common/fileService","vs/nls!vs/platform/files/common/io","vs/nls!vs/platform/files/node/diskFileSystemProvider","vs/nls!vs/platform/request/common/request","vs/nls!vs/platform/telemetry/common/telemetryService","vs/platform/environment/common/environmentService","vs/platform/environment/node/userDataPath","path","vs/platform/environment/node/environmentService","vs/platform/extensionManagement/common/extensionNls","vs/platform/files/node/watcher/nsfw/watcherService","vs/platform/files/node/watcher/unix/watcherService","vs/platform/files/node/watcher/win32/csharpWatcherService","vs/platform/files/node/watcher/win32/watcherService","vs/platform/instantiation/common/graph","vs/platform/extensionManagement/common/extensionManagementCLIService","vs/platform/extensionManagement/node/extensionsManifestCache","vs/platform/environment/node/shellEnv","vs/platform/files/node/watcher/nodejs/watcherService","vs/platform/instantiation/common/instantiationService","vs/platform/extensionManagement/node/extensionDownloader","vs/platform/extensionManagement/node/extensionLifecycle","vs/platform/extensionManagement/node/extensionsWatcher","vs/platform/localizations/node/localizations","vs/platform/log/node/spdlogLog","vs/platform/files/common/fileService","vs/platform/files/node/diskFileSystemProvider","vs/platform/jsonschemas/common/jsonContributionRegistry","vs/platform/configuration/common/configurationModels","vs/platform/configuration/common/configurationService","vs/platform/download/common/downloadService","vs/platform/request/node/proxy","url","vs/platform/serviceMachineId/common/serviceMachineId","vs/platform/storage/common/storage","vs/platform/telemetry/common/commonProperties","vs/platform/extensionManagement/common/abstractExtensionManagementService","vs/platform/extensionManagement/common/extensionGalleryService","vs/platform/telemetry/common/telemetryService","vs/platform/telemetry/node/appInsightsAppender","vs/platform/telemetry/node/telemetry","vs/platform/extensionManagement/node/extensionManagementUtil","vs/platform/extensionManagement/node/extensionsScanner","vs/platform/extensionManagement/node/extensionManagementService","vs/platform/request/node/requestService","string_decoder","vs/platform/environment/node/argvHelper","vs/base/node/watcher","crypto","vs/base/common/iterator","vs/base/common/performance","yauzl","yazl","zlib","vs/code/node/cliProcessMain","graceful-fs"],te=function($){for(var t=[],O=0,b=$.length;O<b;O++)t[O]=Z[$[O]];return t};define(Z[58],te([0,1]),function($,t){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.ok=void 0;function O(b,w){if(!b)throw new Error(w?`Assertion failed (${w})`:"Assertion Failed")}t.ok=O}),define(Z[45],te([0,1]),function($,t){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.throttle=t.debounce=t.memoize=t.createDecorator=void 0;function O(L){return(T,c,d)=>{let v=null,P=null;if(typeof d.value=="function"?(v="value",P=d.value):typeof d.get=="function"&&(v="get",P=d.get),!P)throw new Error("not supported");d[v]=L(P,c)}}t.createDecorator=O;function b(L,T,c){let d=null,v=null;if(typeof c.value=="function"?(d="value",v=c.value,v.length!==0&&console.warn("Memoize should only be used in functions with zero parameters")):typeof c.get=="function"&&(d="get",v=c.get),!v)throw new Error("not supported");const P=`$memoize$${T}`;c[d]=function(...g){return this.hasOwnProperty(P)||Object.defineProperty(this,P,{configurable:!1,enumerable:!1,writable:!1,value:v.apply(this,g)}),this[P]}}t.memoize=b;function w(L,T,c){return O((d,v)=>{const P=`$debounce$${v}`,g=`$debounce$result$${v}`;return function(...I){this[g]||(this[g]=c?c():void 0),clearTimeout(this[P]),T&&(this[g]=T(this[g],...I),I=[this[g]]),this[P]=setTimeout(()=>{d.apply(this,I),this[g]=c?c():void 0},L)}})}t.debounce=w;function R(L,T,c){return O((d,v)=>{const P=`$throttle$timer$${v}`,g=`$throttle$result$${v}`,I=`$throttle$lastRun$${v}`,u=`$throttle$pending$${v}`;return function(...l){if(this[g]||(this[g]=c?c():void 0),(this[I]===null||this[I]===void 0)&&(this[I]=-Number.MAX_VALUE),T&&(this[g]=T(this[g],...l)),this[u])return;const y=this[I]+L;y<=Date.now()?(this[I]=Date.now(),d.apply(this,[this[g]]),this[g]=c?c():void 0):(this[u]=!0,this[P]=setTimeout(()=>{this[u]=!1,this[I]=Date.now(),d.apply(this,[this[g]]),this[g]=c?c():void 0},y-Date.now()))}})}t.throttle=R}),define(Z[59],te([0,1]),function($,t){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.getNodeType=t.stripComments=t.visit=t.findNodeAtOffset=t.contains=t.getNodeValue=t.getNodePath=t.findNodeAtLocation=t.parseTree=t.parse=t.getLocation=t.createScanner=t.ParseOptions=t.ParseErrorCode=t.SyntaxKind=t.ScanError=void 0;var O;(function(e){e[e.None=0]="None",e[e.UnexpectedEndOfComment=1]="UnexpectedEndOfComment",e[e.UnexpectedEndOfString=2]="UnexpectedEndOfString",e[e.UnexpectedEndOfNumber=3]="UnexpectedEndOfNumber",e[e.InvalidUnicode=4]="InvalidUnicode",e[e.InvalidEscapeCharacter=5]="InvalidEscapeCharacter",e[e.InvalidCharacter=6]="InvalidCharacter"})(O=t.ScanError||(t.ScanError={}));var b;(function(e){e[e.OpenBraceToken=1]="OpenBraceToken",e[e.CloseBraceToken=2]="CloseBraceToken",e[e.OpenBracketToken=3]="OpenBracketToken",e[e.CloseBracketToken=4]="CloseBracketToken",e[e.CommaToken=5]="CommaToken",e[e.ColonToken=6]="ColonToken",e[e.NullKeyword=7]="NullKeyword",e[e.TrueKeyword=8]="TrueKeyword",e[e.FalseKeyword=9]="FalseKeyword",e[e.StringLiteral=10]="StringLiteral",e[e.NumericLiteral=11]="NumericLiteral",e[e.LineCommentTrivia=12]="LineCommentTrivia",e[e.BlockCommentTrivia=13]="BlockCommentTrivia",e[e.LineBreakTrivia=14]="LineBreakTrivia",e[e.Trivia=15]="Trivia",e[e.Unknown=16]="Unknown",e[e.EOF=17]="EOF"})(b=t.SyntaxKind||(t.SyntaxKind={}));var w;(function(e){e[e.InvalidSymbol=1]="InvalidSymbol",e[e.InvalidNumberFormat=2]="InvalidNumberFormat",e[e.PropertyNameExpected=3]="PropertyNameExpected",e[e.ValueExpected=4]="ValueExpected",e[e.ColonExpected=5]="ColonExpected",e[e.CommaExpected=6]="CommaExpected",e[e.CloseBraceExpected=7]="CloseBraceExpected",e[e.CloseBracketExpected=8]="CloseBracketExpected",e[e.EndOfFileExpected=9]="EndOfFileExpected",e[e.InvalidCommentToken=10]="InvalidCommentToken",e[e.UnexpectedEndOfComment=11]="UnexpectedEndOfComment",e[e.UnexpectedEndOfString=12]="UnexpectedEndOfString",e[e.UnexpectedEndOfNumber=13]="UnexpectedEndOfNumber",e[e.InvalidUnicode=14]="InvalidUnicode",e[e.InvalidEscapeCharacter=15]="InvalidEscapeCharacter",e[e.InvalidCharacter=16]="InvalidCharacter"})(w=t.ParseErrorCode||(t.ParseErrorCode={}));var R;(function(e){e.DEFAULT={allowTrailingComma:!0}})(R=t.ParseOptions||(t.ParseOptions={}));function L(e,i=!1){let n=0,r=e.length,a="",m=0,S=16,F=0;function p(ee){let ue=0,ce=0;for(;ue<ee;){const G=e.charCodeAt(n);if(G>=48&&G<=57)ce=ce*16+G-48;else if(G>=65&&G<=70)ce=ce*16+G-65+10;else if(G>=97&&G<=102)ce=ce*16+G-97+10;else break;n++,ue++}return ue<ee&&(ce=-1),ce}function C(ee){n=ee,a="",m=0,S=16,F=0}function N(){const ee=n;if(e.charCodeAt(n)===48)n++;else for(n++;n<e.length&&d(e.charCodeAt(n));)n++;if(n<e.length&&e.charCodeAt(n)===46)if(n++,n<e.length&&d(e.charCodeAt(n)))for(n++;n<e.length&&d(e.charCodeAt(n));)n++;else return F=3,e.substring(ee,n);let ue=n;if(n<e.length&&(e.charCodeAt(n)===69||e.charCodeAt(n)===101))if(n++,(n<e.length&&e.charCodeAt(n)===43||e.charCodeAt(n)===45)&&n++,n<e.length&&d(e.charCodeAt(n))){for(n++;n<e.length&&d(e.charCodeAt(n));)n++;ue=n}else F=3;return e.substring(ee,ue)}function V(){let ee="",ue=n;for(;;){if(n>=r){ee+=e.substring(ue,n),F=2;break}const ce=e.charCodeAt(n);if(ce===34){ee+=e.substring(ue,n),n++;break}if(ce===92){if(ee+=e.substring(ue,n),n++,n>=r){F=2;break}switch(e.charCodeAt(n++)){case 34:ee+='"';break;case 92:ee+="\\";break;case 47:ee+="/";break;case 98:ee+="\b";break;case 102:ee+="\f";break;case 110:ee+=`
`;break;case 114:ee+="\r";break;case 116:ee+="	";break;case 117:const ne=p(4);ne>=0?ee+=String.fromCharCode(ne):F=4;break;default:F=5}ue=n;continue}if(ce>=0&&ce<=31)if(c(ce)){ee+=e.substring(ue,n),F=2;break}else F=6;n++}return ee}function Y(){if(a="",F=0,m=n,n>=r)return m=r,S=17;let ee=e.charCodeAt(n);if(T(ee)){do n++,a+=String.fromCharCode(ee),ee=e.charCodeAt(n);while(T(ee));return S=15}if(c(ee))return n++,a+=String.fromCharCode(ee),ee===13&&e.charCodeAt(n)===10&&(n++,a+=`
`),S=14;switch(ee){case 123:return n++,S=1;case 125:return n++,S=2;case 91:return n++,S=3;case 93:return n++,S=4;case 58:return n++,S=6;case 44:return n++,S=5;case 34:return n++,a=V(),S=10;case 47:const ue=n-1;if(e.charCodeAt(n+1)===47){for(n+=2;n<r&&!c(e.charCodeAt(n));)n++;return a=e.substring(ue,n),S=12}if(e.charCodeAt(n+1)===42){n+=2;const ce=r-1;let G=!1;for(;n<ce;){if(e.charCodeAt(n)===42&&e.charCodeAt(n+1)===47){n+=2,G=!0;break}n++}return G||(n++,F=1),a=e.substring(ue,n),S=13}return a+=String.fromCharCode(ee),n++,S=16;case 45:if(a+=String.fromCharCode(ee),n++,n===r||!d(e.charCodeAt(n)))return S=16;case 48:case 49:case 50:case 51:case 52:case 53:case 54:case 55:case 56:case 57:return a+=N(),S=11;default:for(;n<r&&ie(ee);)n++,ee=e.charCodeAt(n);if(m!==n){switch(a=e.substring(m,n),a){case"true":return S=8;case"false":return S=9;case"null":return S=7}return S=16}return a+=String.fromCharCode(ee),n++,S=16}}function ie(ee){if(T(ee)||c(ee))return!1;switch(ee){case 125:case 93:case 123:case 91:case 34:case 58:case 44:case 47:return!1}return!0}function oe(){let ee;do ee=Y();while(ee>=12&&ee<=15);return ee}return{setPosition:C,getPosition:()=>n,scan:i?oe:Y,getToken:()=>S,getTokenValue:()=>a,getTokenOffset:()=>m,getTokenLength:()=>n-m,getTokenError:()=>F}}t.createScanner=L;function T(e){return e===32||e===9||e===11||e===12||e===160||e===5760||e>=8192&&e<=8203||e===8239||e===8287||e===12288||e===65279}function c(e){return e===10||e===13||e===8232||e===8233}function d(e){return e>=48&&e<=57}var v;(function(e){e[e.nullCharacter=0]="nullCharacter",e[e.maxAsciiCharacter=127]="maxAsciiCharacter",e[e.lineFeed=10]="lineFeed",e[e.carriageReturn=13]="carriageReturn",e[e.lineSeparator=8232]="lineSeparator",e[e.paragraphSeparator=8233]="paragraphSeparator",e[e.nextLine=133]="nextLine",e[e.space=32]="space",e[e.nonBreakingSpace=160]="nonBreakingSpace",e[e.enQuad=8192]="enQuad",e[e.emQuad=8193]="emQuad",e[e.enSpace=8194]="enSpace",e[e.emSpace=8195]="emSpace",e[e.threePerEmSpace=8196]="threePerEmSpace",e[e.fourPerEmSpace=8197]="fourPerEmSpace",e[e.sixPerEmSpace=8198]="sixPerEmSpace",e[e.figureSpace=8199]="figureSpace",e[e.punctuationSpace=8200]="punctuationSpace",e[e.thinSpace=8201]="thinSpace",e[e.hairSpace=8202]="hairSpace",e[e.zeroWidthSpace=8203]="zeroWidthSpace",e[e.narrowNoBreakSpace=8239]="narrowNoBreakSpace",e[e.ideographicSpace=12288]="ideographicSpace",e[e.mathematicalSpace=8287]="mathematicalSpace",e[e.ogham=5760]="ogham",e[e._=95]="_",e[e.$=36]="$",e[e._0=48]="_0",e[e._1=49]="_1",e[e._2=50]="_2",e[e._3=51]="_3",e[e._4=52]="_4",e[e._5=53]="_5",e[e._6=54]="_6",e[e._7=55]="_7",e[e._8=56]="_8",e[e._9=57]="_9",e[e.a=97]="a",e[e.b=98]="b",e[e.c=99]="c",e[e.d=100]="d",e[e.e=101]="e",e[e.f=102]="f",e[e.g=103]="g",e[e.h=104]="h",e[e.i=105]="i",e[e.j=106]="j",e[e.k=107]="k",e[e.l=108]="l",e[e.m=109]="m",e[e.n=110]="n",e[e.o=111]="o",e[e.p=112]="p",e[e.q=113]="q",e[e.r=114]="r",e[e.s=115]="s",e[e.t=116]="t",e[e.u=117]="u",e[e.v=118]="v",e[e.w=119]="w",e[e.x=120]="x",e[e.y=121]="y",e[e.z=122]="z",e[e.A=65]="A",e[e.B=66]="B",e[e.C=67]="C",e[e.D=68]="D",e[e.E=69]="E",e[e.F=70]="F",e[e.G=71]="G",e[e.H=72]="H",e[e.I=73]="I",e[e.J=74]="J",e[e.K=75]="K",e[e.L=76]="L",e[e.M=77]="M",e[e.N=78]="N",e[e.O=79]="O",e[e.P=80]="P",e[e.Q=81]="Q",e[e.R=82]="R",e[e.S=83]="S",e[e.T=84]="T",e[e.U=85]="U",e[e.V=86]="V",e[e.W=87]="W",e[e.X=88]="X",e[e.Y=89]="Y",e[e.Z=90]="Z",e[e.ampersand=38]="ampersand",e[e.asterisk=42]="asterisk",e[e.at=64]="at",e[e.backslash=92]="backslash",e[e.bar=124]="bar",e[e.caret=94]="caret",e[e.closeBrace=125]="closeBrace",e[e.closeBracket=93]="closeBracket",e[e.closeParen=41]="closeParen",e[e.colon=58]="colon",e[e.comma=44]="comma",e[e.dot=46]="dot",e[e.doubleQuote=34]="doubleQuote",e[e.equals=61]="equals",e[e.exclamation=33]="exclamation",e[e.greaterThan=62]="greaterThan",e[e.lessThan=60]="lessThan",e[e.minus=45]="minus",e[e.openBrace=123]="openBrace",e[e.openBracket=91]="openBracket",e[e.openParen=40]="openParen",e[e.percent=37]="percent",e[e.plus=43]="plus",e[e.question=63]="question",e[e.semicolon=59]="semicolon",e[e.singleQuote=39]="singleQuote",e[e.slash=47]="slash",e[e.tilde=126]="tilde",e[e.backspace=8]="backspace",e[e.formFeed=12]="formFeed",e[e.byteOrderMark=65279]="byteOrderMark",e[e.tab=9]="tab",e[e.verticalTab=11]="verticalTab"})(v||(v={}));function P(e,i){const n=[],r=new Object;let a;const m={value:{},offset:0,length:0,type:"object",parent:void 0};let S=!1;function F(p,C,N,V){m.value=p,m.offset=C,m.length=N,m.type=V,m.colonOffset=void 0,a=m}try{h(e,{onObjectBegin:(p,C)=>{if(i<=p)throw r;a=void 0,S=i>p,n.push("")},onObjectProperty:(p,C,N)=>{if(i<C||(F(p,C,N,"property"),n[n.length-1]=p,i<=C+N))throw r},onObjectEnd:(p,C)=>{if(i<=p)throw r;a=void 0,n.pop()},onArrayBegin:(p,C)=>{if(i<=p)throw r;a=void 0,n.push(0)},onArrayEnd:(p,C)=>{if(i<=p)throw r;a=void 0,n.pop()},onLiteralValue:(p,C,N)=>{if(i<C||(F(p,C,N,s(p)),i<=C+N))throw r},onSeparator:(p,C,N)=>{if(i<=C)throw r;if(p===":"&&a&&a.type==="property")a.colonOffset=C,S=!1,a=void 0;else if(p===","){const V=n[n.length-1];typeof V=="number"?n[n.length-1]=V+1:(S=!0,n[n.length-1]=""),a=void 0}}})}catch(p){if(p!==r)throw p}return{path:n,previousNode:a,isAtPropertyKey:S,matches:p=>{let C=0;for(let N=0;C<p.length&&N<n.length;N++)if(p[C]===n[N]||p[C]==="*")C++;else if(p[C]!=="**")return!1;return C===p.length}}}t.getLocation=P;function g(e,i=[],n=R.DEFAULT){let r=null,a=[];const m=[];function S(p){Array.isArray(a)?a.push(p):r!==null&&(a[r]=p)}return h(e,{onObjectBegin:()=>{const p={};S(p),m.push(a),a=p,r=null},onObjectProperty:p=>{r=p},onObjectEnd:()=>{a=m.pop()},onArrayBegin:()=>{const p=[];S(p),m.push(a),a=p,r=null},onArrayEnd:()=>{a=m.pop()},onLiteralValue:S,onError:(p,C,N)=>{i.push({error:p,offset:C,length:N})}},n),a[0]}t.parse=g;function I(e,i=[],n=R.DEFAULT){let r={type:"array",offset:-1,length:-1,children:[],parent:void 0};function a(p){r.type==="property"&&(r.length=p-r.offset,r=r.parent)}function m(p){return r.children.push(p),p}h(e,{onObjectBegin:p=>{r=m({type:"object",offset:p,length:-1,parent:r,children:[]})},onObjectProperty:(p,C,N)=>{r=m({type:"property",offset:C,length:-1,parent:r,children:[]}),r.children.push({type:"string",value:p,offset:C,length:N,parent:r})},onObjectEnd:(p,C)=>{r.length=p+C-r.offset,r=r.parent,a(p+C)},onArrayBegin:(p,C)=>{r=m({type:"array",offset:p,length:-1,parent:r,children:[]})},onArrayEnd:(p,C)=>{r.length=p+C-r.offset,r=r.parent,a(p+C)},onLiteralValue:(p,C,N)=>{m({type:s(p),offset:C,length:N,parent:r,value:p}),a(C+N)},onSeparator:(p,C,N)=>{r.type==="property"&&(p===":"?r.colonOffset=C:p===","&&a(C))},onError:(p,C,N)=>{i.push({error:p,offset:C,length:N})}},n);const F=r.children[0];return F&&delete F.parent,F}t.parseTree=I;function u(e,i){if(!e)return;let n=e;for(let r of i)if(typeof r=="string"){if(n.type!=="object"||!Array.isArray(n.children))return;let a=!1;for(const m of n.children)if(Array.isArray(m.children)&&m.children[0].value===r){n=m.children[1],a=!0;break}if(!a)return}else{const a=r;if(n.type!=="array"||a<0||!Array.isArray(n.children)||a>=n.children.length)return;n=n.children[a]}return n}t.findNodeAtLocation=u;function l(e){if(!e.parent||!e.parent.children)return[];const i=l(e.parent);if(e.parent.type==="property"){const n=e.parent.children[0].value;i.push(n)}else if(e.parent.type==="array"){const n=e.parent.children.indexOf(e);n!==-1&&i.push(n)}return i}t.getNodePath=l;function y(e){switch(e.type){case"array":return e.children.map(y);case"object":const i=Object.create(null);for(let n of e.children){const r=n.children[1];r&&(i[n.children[0].value]=y(r))}return i;case"null":case"string":case"number":case"boolean":return e.value;default:return}}t.getNodeValue=y;function E(e,i,n=!1){return i>=e.offset&&i<e.offset+e.length||n&&i===e.offset+e.length}t.contains=E;function f(e,i,n=!1){if(E(e,i,n)){const r=e.children;if(Array.isArray(r))for(let a=0;a<r.length&&r[a].offset<=i;a++){const m=f(r[a],i,n);if(m)return m}return e}}t.findNodeAtOffset=f;function h(e,i,n=R.DEFAULT){const r=L(e,!1);function a(B){return B?()=>B(r.getTokenOffset(),r.getTokenLength()):()=>!0}function m(B){return B?J=>B(J,r.getTokenOffset(),r.getTokenLength()):()=>!0}const S=a(i.onObjectBegin),F=m(i.onObjectProperty),p=a(i.onObjectEnd),C=a(i.onArrayBegin),N=a(i.onArrayEnd),V=m(i.onLiteralValue),Y=m(i.onSeparator),ie=a(i.onComment),oe=m(i.onError),ee=n&&n.disallowComments,ue=n&&n.allowTrailingComma;function ce(){for(;;){const B=r.scan();switch(r.getTokenError()){case 4:G(14);break;case 5:G(15);break;case 3:G(13);break;case 1:ee||G(11);break;case 2:G(12);break;case 6:G(16);break}switch(B){case 12:case 13:ee?G(10):ie();break;case 16:G(1);break;case 15:case 14:break;default:return B}}}function G(B,J=[],q=[]){if(oe(B),J.length+q.length>0){let k=r.getToken();for(;k!==17;){if(J.indexOf(k)!==-1){ce();break}else if(q.indexOf(k)!==-1)break;k=ce()}}}function ne(B){const J=r.getTokenValue();return B?V(J):F(J),ce(),!0}function z(){switch(r.getToken()){case 11:let B=0;try{B=JSON.parse(r.getTokenValue()),typeof B!="number"&&(G(2),B=0)}catch(J){G(2)}V(B);break;case 7:V(null);break;case 8:V(!0);break;case 9:V(!1);break;default:return!1}return ce(),!0}function D(){return r.getToken()!==10?(G(3,[],[2,5]),!1):(ne(!1),r.getToken()===6?(Y(":"),ce(),K()||G(4,[],[2,5])):G(5,[],[2,5]),!0)}function M(){S(),ce();let B=!1;for(;r.getToken()!==2&&r.getToken()!==17;){if(r.getToken()===5){if(B||G(4,[],[]),Y(","),ce(),r.getToken()===2&&ue)break}else B&&G(6,[],[]);D()||G(4,[],[2,5]),B=!0}return p(),r.getToken()!==2?G(7,[2],[]):ce(),!0}function U(){C(),ce();let B=!1;for(;r.getToken()!==4&&r.getToken()!==17;){if(r.getToken()===5){if(B||G(4,[],[]),Y(","),ce(),r.getToken()===4&&ue)break}else B&&G(6,[],[]);K()||G(4,[],[4,5]),B=!0}return N(),r.getToken()!==4?G(8,[4],[]):ce(),!0}function K(){switch(r.getToken()){case 3:return U();case 1:return M();case 10:return ne(!0);default:return z()}}return ce(),r.getToken()===17?n.allowEmptyContent?!0:(G(4,[],[]),!1):K()?(r.getToken()!==17&&G(9,[],[]),!0):(G(4,[],[]),!1)}t.visit=h;function o(e,i){let n=L(e),r=[],a,m=0,S;do switch(S=n.getPosition(),a=n.scan(),a){case 12:case 13:case 17:m!==S&&r.push(e.substring(m,S)),i!==void 0&&r.push(n.getTokenValue().replace(/[^\r\n]/g,i)),m=n.getPosition();break}while(a!==17);return r.join("")}t.stripComments=o;function s(e){switch(typeof e){case"boolean":return"boolean";case"number":return"number";case"string":return"string";case"object":{if(e){if(Array.isArray(e))return"array"}else return"null";return"object"}default:return"null"}}t.getNodeType=s}),function(){function $(w){const R=[];typeof w=="number"&&R.push("code/timeOrigin",w);function L(c){R.push(c,Date.now())}function T(){const c=[];for(let d=0;d<R.length;d+=2)c.push({name:R[d],startTime:R[d+1]});return c}return{mark:L,getMarks:T}}function t(){if(typeof performance=="object"&&typeof performance.mark=="function")return typeof performance.timeOrigin!="number"&&!performance.timing?$():{mark(w){performance.mark(w)},getMarks(){let w=performance.timeOrigin;typeof w!="number"&&(w=performance.timing.navigationStart||performance.timing.redirectStart||performance.timing.fetchStart);const R=[{name:"code/timeOrigin",startTime:Math.round(w)}];for(const L of performance.getEntriesByType("mark"))R.push({name:L.name,startTime:Math.round(w+L.startTime)});return R}};if(typeof process=="object"){const w=Math.round((require.nodeRequire||require)("perf_hooks").performance.timeOrigin);return $(w)}else return console.trace("perf-util loaded in UNKNOWN environment"),$()}function O(w){return w.MonacoPerformanceMarks||(w.MonacoPerformanceMarks=t()),w.MonacoPerformanceMarks}var b;typeof global=="object"?b=global:typeof self=="object"?b=self:b={},typeof define=="function"?define("vs/base/common/performance",[],function(){return O(b)}):typeof module=="object"&&typeof module.exports=="object"?module.exports=O(b):(console.trace("perf-util defined in UNKNOWN context (neither requirejs or commonjs)"),b.perf=O(b))}(),function($,t){if(typeof exports=="object"&&typeof module=="object")module.exports=t();else if(typeof define=="function"&&define.amd)define("vs/base/common/semver/semver",[],t);else{var O=t();for(var b in O)(typeof exports=="object"?exports:$)[b]=O[b]}}(typeof self!="undefined"?self:this,function(){return function($){var t={};function O(b){if(t[b])return t[b].exports;var w=t[b]={i:b,l:!1,exports:{}};return $[b].call(w.exports,w,w.exports,O),w.l=!0,w.exports}return O.m=$,O.c=t,O.d=function(b,w,R){O.o(b,w)||Object.defineProperty(b,w,{enumerable:!0,get:R})},O.r=function(b){typeof Symbol!="undefined"&&Symbol.toStringTag&&Object.defineProperty(b,Symbol.toStringTag,{value:"Module"}),Object.defineProperty(b,"__esModule",{value:!0})},O.t=function(b,w){if(1&w&&(b=O(b)),8&w||4&w&&typeof b=="object"&&b&&b.__esModule)return b;var R=Object.create(null);if(O.r(R),Object.defineProperty(R,"default",{enumerable:!0,value:b}),2&w&&typeof b!="string")for(var L in b)O.d(R,L,function(T){return b[T]}.bind(null,L));return R},O.n=function(b){var w=b&&b.__esModule?function(){return b.default}:function(){return b};return O.d(w,"a",w),w},O.o=function(b,w){return Object.prototype.hasOwnProperty.call(b,w)},O.p="",O(O.s=0)}([function($,t,O){(function(b){var w;t=$.exports=q,w=typeof b=="object"&&b.env&&b.env.NODE_DEBUG&&/\bsemver\b/i.test(b.env.NODE_DEBUG)?function(){var x=Array.prototype.slice.call(arguments,0);x.unshift("SEMVER"),console.log.apply(console,x)}:function(){},t.SEMVER_SPEC_VERSION="2.0.0";var R=256,L=Number.MAX_SAFE_INTEGER||9007199254740991,T=t.re=[],c=t.src=[],d=0,v=d++;c[v]="0|[1-9]\\d*";var P=d++;c[P]="[0-9]+";var g=d++;c[g]="\\d*[a-zA-Z-][a-zA-Z0-9-]*";var I=d++;c[I]="("+c[v]+")\\.("+c[v]+")\\.("+c[v]+")";var u=d++;c[u]="("+c[P]+")\\.("+c[P]+")\\.("+c[P]+")";var l=d++;c[l]="(?:"+c[v]+"|"+c[g]+")";var y=d++;c[y]="(?:"+c[P]+"|"+c[g]+")";var E=d++;c[E]="(?:-("+c[l]+"(?:\\."+c[l]+")*))";var f=d++;c[f]="(?:-?("+c[y]+"(?:\\."+c[y]+")*))";var h=d++;c[h]="[0-9A-Za-z-]+";var o=d++;c[o]="(?:\\+("+c[h]+"(?:\\."+c[h]+")*))";var s=d++,e="v?"+c[I]+c[E]+"?"+c[o]+"?";c[s]="^"+e+"$";var i="[v=\\s]*"+c[u]+c[f]+"?"+c[o]+"?",n=d++;c[n]="^"+i+"$";var r=d++;c[r]="((?:<|>)?=?)";var a=d++;c[a]=c[P]+"|x|X|\\*";var m=d++;c[m]=c[v]+"|x|X|\\*";var S=d++;c[S]="[v=\\s]*("+c[m]+")(?:\\.("+c[m]+")(?:\\.("+c[m]+")(?:"+c[E]+")?"+c[o]+"?)?)?";var F=d++;c[F]="[v=\\s]*("+c[a]+")(?:\\.("+c[a]+")(?:\\.("+c[a]+")(?:"+c[f]+")?"+c[o]+"?)?)?";var p=d++;c[p]="^"+c[r]+"\\s*"+c[S]+"$";var C=d++;c[C]="^"+c[r]+"\\s*"+c[F]+"$";var N=d++;c[N]="(?:^|[^\\d])(\\d{1,16})(?:\\.(\\d{1,16}))?(?:\\.(\\d{1,16}))?(?:$|[^\\d])";var V=d++;c[V]="(?:~>?)";var Y=d++;c[Y]="(\\s*)"+c[V]+"\\s+",T[Y]=new RegExp(c[Y],"g");var ie=d++;c[ie]="^"+c[V]+c[S]+"$";var oe=d++;c[oe]="^"+c[V]+c[F]+"$";var ee=d++;c[ee]="(?:\\^)";var ue=d++;c[ue]="(\\s*)"+c[ee]+"\\s+",T[ue]=new RegExp(c[ue],"g");var ce=d++;c[ce]="^"+c[ee]+c[S]+"$";var G=d++;c[G]="^"+c[ee]+c[F]+"$";var ne=d++;c[ne]="^"+c[r]+"\\s*("+i+")$|^$";var z=d++;c[z]="^"+c[r]+"\\s*("+e+")$|^$";var D=d++;c[D]="(\\s*)"+c[r]+"\\s*("+i+"|"+c[S]+")",T[D]=new RegExp(c[D],"g");var M=d++;c[M]="^\\s*("+c[S]+")\\s+-\\s+("+c[S]+")\\s*$";var U=d++;c[U]="^\\s*("+c[F]+")\\s+-\\s+("+c[F]+")\\s*$";var K=d++;c[K]="(<|>)?=?\\s*\\*";for(var B=0;B<35;B++)w(B,c[B]),T[B]||(T[B]=new RegExp(c[B]));function J(x,_){if(x instanceof q)return x;if(typeof x!="string"||x.length>R||!(_?T[n]:T[s]).test(x))return null;try{return new q(x,_)}catch(H){return null}}function q(x,_){if(x instanceof q){if(x.loose===_)return x;x=x.version}else if(typeof x!="string")throw new TypeError("Invalid Version: "+x);if(x.length>R)throw new TypeError("version is longer than "+R+" characters");if(!(this instanceof q))return new q(x,_);w("SemVer",x,_),this.loose=_;var H=x.trim().match(_?T[n]:T[s]);if(!H)throw new TypeError("Invalid Version: "+x);if(this.raw=x,this.major=+H[1],this.minor=+H[2],this.patch=+H[3],this.major>L||this.major<0)throw new TypeError("Invalid major version");if(this.minor>L||this.minor<0)throw new TypeError("Invalid minor version");if(this.patch>L||this.patch<0)throw new TypeError("Invalid patch version");H[4]?this.prerelease=H[4].split(".").map(function(ae){if(/^[0-9]+$/.test(ae)){var he=+ae;if(he>=0&&he<L)return he}return ae}):this.prerelease=[],this.build=H[5]?H[5].split("."):[],this.format()}t.parse=J,t.valid=function(x,_){var H=J(x,_);return H?H.version:null},t.clean=function(x,_){var H=J(x.trim().replace(/^[=v]+/,""),_);return H?H.version:null},t.SemVer=q,q.prototype.format=function(){return this.version=this.major+"."+this.minor+"."+this.patch,this.prerelease.length&&(this.version+="-"+this.prerelease.join(".")),this.version},q.prototype.toString=function(){return this.version},q.prototype.compare=function(x){return w("SemVer.compare",this.version,this.loose,x),x instanceof q||(x=new q(x,this.loose)),this.compareMain(x)||this.comparePre(x)},q.prototype.compareMain=function(x){return x instanceof q||(x=new q(x,this.loose)),A(this.major,x.major)||A(this.minor,x.minor)||A(this.patch,x.patch)},q.prototype.comparePre=function(x){if(x instanceof q||(x=new q(x,this.loose)),this.prerelease.length&&!x.prerelease.length)return-1;if(!this.prerelease.length&&x.prerelease.length)return 1;if(!this.prerelease.length&&!x.prerelease.length)return 0;var _=0;do{var H=this.prerelease[_],ae=x.prerelease[_];if(w("prerelease compare",_,H,ae),H===void 0&&ae===void 0)return 0;if(ae===void 0)return 1;if(H===void 0)return-1;if(H!==ae)return A(H,ae)}while(++_)},q.prototype.inc=function(x,_){switch(x){case"premajor":this.prerelease.length=0,this.patch=0,this.minor=0,this.major++,this.inc("pre",_);break;case"preminor":this.prerelease.length=0,this.patch=0,this.minor++,this.inc("pre",_);break;case"prepatch":this.prerelease.length=0,this.inc("patch",_),this.inc("pre",_);break;case"prerelease":this.prerelease.length===0&&this.inc("patch",_),this.inc("pre",_);break;case"major":this.minor===0&&this.patch===0&&this.prerelease.length!==0||this.major++,this.minor=0,this.patch=0,this.prerelease=[];break;case"minor":this.patch===0&&this.prerelease.length!==0||this.minor++,this.patch=0,this.prerelease=[];break;case"patch":this.prerelease.length===0&&this.patch++,this.prerelease=[];break;case"pre":if(this.prerelease.length===0)this.prerelease=[0];else{for(var H=this.prerelease.length;--H>=0;)typeof this.prerelease[H]=="number"&&(this.prerelease[H]++,H=-2);H===-1&&this.prerelease.push(0)}_&&(this.prerelease[0]===_?isNaN(this.prerelease[1])&&(this.prerelease=[_,0]):this.prerelease=[_,0]);break;default:throw new Error("invalid increment argument: "+x)}return this.format(),this.raw=this.version,this},t.inc=function(x,_,H,ae){typeof H=="string"&&(ae=H,H=void 0);try{return new q(x,H).inc(_,ae).version}catch(he){return null}},t.diff=function(x,_){if(Q(x,_))return null;var H=J(x),ae=J(_);if(H.prerelease.length||ae.prerelease.length){for(var he in H)if((he==="major"||he==="minor"||he==="patch")&&H[he]!==ae[he])return"pre"+he;return"prerelease"}for(var he in H)if((he==="major"||he==="minor"||he==="patch")&&H[he]!==ae[he])return he},t.compareIdentifiers=A;var k=/^[0-9]+$/;function A(x,_){var H=k.test(x),ae=k.test(_);return H&&ae&&(x=+x,_=+_),H&&!ae?-1:ae&&!H?1:x<_?-1:x>_?1:0}function j(x,_,H){return new q(x,H).compare(new q(_,H))}function W(x,_,H){return j(x,_,H)>0}function X(x,_,H){return j(x,_,H)<0}function Q(x,_,H){return j(x,_,H)===0}function se(x,_,H){return j(x,_,H)!==0}function re(x,_,H){return j(x,_,H)>=0}function me(x,_,H){return j(x,_,H)<=0}function ye(x,_,H,ae){var he;switch(_){case"===":typeof x=="object"&&(x=x.version),typeof H=="object"&&(H=H.version),he=x===H;break;case"!==":typeof x=="object"&&(x=x.version),typeof H=="object"&&(H=H.version),he=x!==H;break;case"":case"=":case"==":he=Q(x,H,ae);break;case"!=":he=se(x,H,ae);break;case">":he=W(x,H,ae);break;case">=":he=re(x,H,ae);break;case"<":he=X(x,H,ae);break;case"<=":he=me(x,H,ae);break;default:throw new TypeError("Invalid operator: "+_)}return he}function fe(x,_){if(x instanceof fe){if(x.loose===_)return x;x=x.value}if(!(this instanceof fe))return new fe(x,_);w("comparator",x,_),this.loose=_,this.parse(x),this.semver===Pe?this.value="":this.value=this.operator+this.semver.version,w("comp",this)}t.rcompareIdentifiers=function(x,_){return A(_,x)},t.major=function(x,_){return new q(x,_).major},t.minor=function(x,_){return new q(x,_).minor},t.patch=function(x,_){return new q(x,_).patch},t.compare=j,t.compareLoose=function(x,_){return j(x,_,!0)},t.rcompare=function(x,_,H){return j(_,x,H)},t.sort=function(x,_){return x.sort(function(H,ae){return t.compare(H,ae,_)})},t.rsort=function(x,_){return x.sort(function(H,ae){return t.rcompare(H,ae,_)})},t.gt=W,t.lt=X,t.eq=Q,t.neq=se,t.gte=re,t.lte=me,t.cmp=ye,t.Comparator=fe;var Pe={};function pe(x,_){if(x instanceof pe)return x.loose===_?x:new pe(x.raw,_);if(x instanceof fe)return new pe(x.value,_);if(!(this instanceof pe))return new pe(x,_);if(this.loose=_,this.raw=x,this.set=x.split(/\s*\|\|\s*/).map(function(H){return this.parseRange(H.trim())},this).filter(function(H){return H.length}),!this.set.length)throw new TypeError("Invalid SemVer Range: "+x);this.format()}function Ee(x){return!x||x.toLowerCase()==="x"||x==="*"}function Ae(x,_,H,ae,he,Le,we,Oe,Ie,Ce,Ne,Re,Te){return((_=Ee(H)?"":Ee(ae)?">="+H+".0.0":Ee(he)?">="+H+"."+ae+".0":">="+_)+" "+(Oe=Ee(Ie)?"":Ee(Ce)?"<"+(+Ie+1)+".0.0":Ee(Ne)?"<"+Ie+"."+(+Ce+1)+".0":Re?"<="+Ie+"."+Ce+"."+Ne+"-"+Re:"<="+Oe)).trim()}function Me(x,_){for(var H=0;H<x.length;H++)if(!x[H].test(_))return!1;if(_.prerelease.length){for(H=0;H<x.length;H++)if(w(x[H].semver),x[H].semver!==Pe&&x[H].semver.prerelease.length>0){var ae=x[H].semver;if(ae.major===_.major&&ae.minor===_.minor&&ae.patch===_.patch)return!0}return!1}return!0}function Ue(x,_,H){try{_=new pe(_,H)}catch(ae){return!1}return _.test(x)}function ze(x,_,H,ae){var he,Le,we,Oe,Ie;switch(x=new q(x,ae),_=new pe(_,ae),H){case">":he=W,Le=me,we=X,Oe=">",Ie=">=";break;case"<":he=X,Le=re,we=W,Oe="<",Ie="<=";break;default:throw new TypeError('Must provide a hilo val of "<" or ">"')}if(Ue(x,_,ae))return!1;for(var Ce=0;Ce<_.set.length;++Ce){var Ne=_.set[Ce],Re=null,Te=null;if(Ne.forEach(function(Fe){Fe.semver===Pe&&(Fe=new fe(">=0.0.0")),Re=Re||Fe,Te=Te||Fe,he(Fe.semver,Re.semver,ae)?Re=Fe:we(Fe.semver,Te.semver,ae)&&(Te=Fe)}),Re.operator===Oe||Re.operator===Ie||(!Te.operator||Te.operator===Oe)&&Le(x,Te.semver)||Te.operator===Ie&&we(x,Te.semver))return!1}return!0}fe.prototype.parse=function(x){var _=this.loose?T[ne]:T[z],H=x.match(_);if(!H)throw new TypeError("Invalid comparator: "+x);this.operator=H[1],this.operator==="="&&(this.operator=""),H[2]?this.semver=new q(H[2],this.loose):this.semver=Pe},fe.prototype.toString=function(){return this.value},fe.prototype.test=function(x){return w("Comparator.test",x,this.loose),this.semver===Pe||(typeof x=="string"&&(x=new q(x,this.loose)),ye(x,this.operator,this.semver,this.loose))},fe.prototype.intersects=function(x,_){if(!(x instanceof fe))throw new TypeError("a Comparator is required");var H;if(this.operator==="")return H=new pe(x.value,_),Ue(this.value,H,_);if(x.operator==="")return H=new pe(this.value,_),Ue(x.semver,H,_);var ae=!(this.operator!==">="&&this.operator!==">"||x.operator!==">="&&x.operator!==">"),he=!(this.operator!=="<="&&this.operator!=="<"||x.operator!=="<="&&x.operator!=="<"),Le=this.semver.version===x.semver.version,we=!(this.operator!==">="&&this.operator!=="<="||x.operator!==">="&&x.operator!=="<="),Oe=ye(this.semver,"<",x.semver,_)&&(this.operator===">="||this.operator===">")&&(x.operator==="<="||x.operator==="<"),Ie=ye(this.semver,">",x.semver,_)&&(this.operator==="<="||this.operator==="<")&&(x.operator===">="||x.operator===">");return ae||he||Le&&we||Oe||Ie},t.Range=pe,pe.prototype.format=function(){return this.range=this.set.map(function(x){return x.join(" ").trim()}).join("||").trim(),this.range},pe.prototype.toString=function(){return this.range},pe.prototype.parseRange=function(x){var _=this.loose;x=x.trim(),w("range",x,_);var H=_?T[U]:T[M];x=x.replace(H,Ae),w("hyphen replace",x),x=x.replace(T[D],"$1$2$3"),w("comparator trim",x,T[D]),x=(x=(x=x.replace(T[Y],"$1~")).replace(T[ue],"$1^")).split(/\s+/).join(" ");var ae=_?T[ne]:T[z],he=x.split(" ").map(function(Le){return function(we,Oe){return w("comp",we),we=function(Ie,Ce){return Ie.trim().split(/\s+/).map(function(Ne){return function(Re,Te){w("caret",Re,Te);var Fe=Te?T[G]:T[ce];return Re.replace(Fe,function(ke,ge,ve,Se,be){var De;return w("caret",Re,ke,ge,ve,Se,be),Ee(ge)?De="":Ee(ve)?De=">="+ge+".0.0 <"+(+ge+1)+".0.0":Ee(Se)?De=ge==="0"?">="+ge+"."+ve+".0 <"+ge+"."+(+ve+1)+".0":">="+ge+"."+ve+".0 <"+(+ge+1)+".0.0":be?(w("replaceCaret pr",be),be.charAt(0)!=="-"&&(be="-"+be),De=ge==="0"?ve==="0"?">="+ge+"."+ve+"."+Se+be+" <"+ge+"."+ve+"."+(+Se+1):">="+ge+"."+ve+"."+Se+be+" <"+ge+"."+(+ve+1)+".0":">="+ge+"."+ve+"."+Se+be+" <"+(+ge+1)+".0.0"):(w("no pr"),De=ge==="0"?ve==="0"?">="+ge+"."+ve+"."+Se+" <"+ge+"."+ve+"."+(+Se+1):">="+ge+"."+ve+"."+Se+" <"+ge+"."+(+ve+1)+".0":">="+ge+"."+ve+"."+Se+" <"+(+ge+1)+".0.0"),w("caret return",De),De})}(Ne,Ce)}).join(" ")}(we,Oe),w("caret",we),we=function(Ie,Ce){return Ie.trim().split(/\s+/).map(function(Ne){return function(Re,Te){var Fe=Te?T[oe]:T[ie];return Re.replace(Fe,function(ke,ge,ve,Se,be){var De;return w("tilde",Re,ke,ge,ve,Se,be),Ee(ge)?De="":Ee(ve)?De=">="+ge+".0.0 <"+(+ge+1)+".0.0":Ee(Se)?De=">="+ge+"."+ve+".0 <"+ge+"."+(+ve+1)+".0":be?(w("replaceTilde pr",be),be.charAt(0)!=="-"&&(be="-"+be),De=">="+ge+"."+ve+"."+Se+be+" <"+ge+"."+(+ve+1)+".0"):De=">="+ge+"."+ve+"."+Se+" <"+ge+"."+(+ve+1)+".0",w("tilde return",De),De})}(Ne,Ce)}).join(" ")}(we,Oe),w("tildes",we),we=function(Ie,Ce){return w("replaceXRanges",Ie,Ce),Ie.split(/\s+/).map(function(Ne){return function(Re,Te){Re=Re.trim();var Fe=Te?T[C]:T[p];return Re.replace(Fe,function(ke,ge,ve,Se,be,De){w("xRange",Re,ke,ge,ve,Se,be,De);var je=Ee(ve),We=je||Ee(Se),Ve=We||Ee(be);return ge==="="&&Ve&&(ge=""),je?ke=ge===">"||ge==="<"?"<0.0.0":"*":ge&&Ve?(We&&(Se=0),Ve&&(be=0),ge===">"?(ge=">=",We?(ve=+ve+1,Se=0,be=0):Ve&&(Se=+Se+1,be=0)):ge==="<="&&(ge="<",We?ve=+ve+1:Se=+Se+1),ke=ge+ve+"."+Se+"."+be):We?ke=">="+ve+".0.0 <"+(+ve+1)+".0.0":Ve&&(ke=">="+ve+"."+Se+".0 <"+ve+"."+(+Se+1)+".0"),w("xRange return",ke),ke})}(Ne,Ce)}).join(" ")}(we,Oe),w("xrange",we),we=function(Ie,Ce){return w("replaceStars",Ie,Ce),Ie.trim().replace(T[K],"")}(we,Oe),w("stars",we),we}(Le,_)}).join(" ").split(/\s+/);return this.loose&&(he=he.filter(function(Le){return!!Le.match(ae)})),he=he.map(function(Le){return new fe(Le,_)})},pe.prototype.intersects=function(x,_){if(!(x instanceof pe))throw new TypeError("a Range is required");return this.set.some(function(H){return H.every(function(ae){return x.set.some(function(he){return he.every(function(Le){return ae.intersects(Le,_)})})})})},t.toComparators=function(x,_){return new pe(x,_).set.map(function(H){return H.map(function(ae){return ae.value}).join(" ").trim().split(" ")})},pe.prototype.test=function(x){if(!x)return!1;typeof x=="string"&&(x=new q(x,this.loose));for(var _=0;_<this.set.length;_++)if(Me(this.set[_],x))return!0;return!1},t.satisfies=Ue,t.maxSatisfying=function(x,_,H){var ae=null,he=null;try{var Le=new pe(_,H)}catch(we){return null}return x.forEach(function(we){Le.test(we)&&(ae&&he.compare(we)!==-1||(he=new q(ae=we,H)))}),ae},t.minSatisfying=function(x,_,H){var ae=null,he=null;try{var Le=new pe(_,H)}catch(we){return null}return x.forEach(function(we){Le.test(we)&&(ae&&he.compare(we)!==1||(he=new q(ae=we,H)))}),ae},t.validRange=function(x,_){try{return new pe(x,_).range||"*"}catch(H){return null}},t.ltr=function(x,_,H){return ze(x,_,"<",H)},t.gtr=function(x,_,H){return ze(x,_,">",H)},t.outside=ze,t.prerelease=function(x,_){var H=J(x,_);return H&&H.prerelease.length?H.prerelease:null},t.intersects=function(x,_,H){return x=new pe(x,H),_=new pe(_,H),x.intersects(_)},t.coerce=function(x){if(x instanceof q)return x;if(typeof x!="string")return null;var _=x.match(T[N]);return _==null?null:J((_[1]||"0")+"."+(_[2]||"0")+"."+(_[3]||"0"))}}).call(this,O(1))},function($,t){var O,b,w=$.exports={};function R(){throw new Error("setTimeout has not been defined")}function L(){throw new Error("clearTimeout has not been defined")}function T(y){if(O===setTimeout)return setTimeout(y,0);if((O===R||!O)&&setTimeout)return O=setTimeout,setTimeout(y,0);try{return O(y,0)}catch(E){try{return O.call(null,y,0)}catch(f){return O.call(this,y,0)}}}(function(){try{O=typeof setTimeout=="function"?setTimeout:R}catch(y){O=R}try{b=typeof clearTimeout=="function"?clearTimeout:L}catch(y){b=L}})();var c,d=[],v=!1,P=-1;function g(){v&&c&&(v=!1,c.length?d=c.concat(d):P=-1,d.length&&I())}function I(){if(!v){var y=T(g);v=!0;for(var E=d.length;E;){for(c=d,d=[];++P<E;)c&&c[P].run();P=-1,E=d.length}c=null,v=!1,function(f){if(b===clearTimeout)return clearTimeout(f);if((b===L||!b)&&clearTimeout)return b=clearTimeout,clearTimeout(f);try{b(f)}catch(h){try{return b.call(null,f)}catch(o){return b.call(this,f)}}}(y)}}function u(y,E){this.fun=y,this.array=E}function l(){}w.nextTick=function(y){var E=new Array(arguments.length-1);if(arguments.length>1)for(var f=1;f<arguments.length;f++)E[f-1]=arguments[f];d.push(new u(y,E)),d.length!==1||v||T(I)},u.prototype.run=function(){this.fun.apply(null,this.array)},w.title="browser",w.browser=!0,w.env={},w.argv=[],w.version="",w.versions={},w.on=l,w.addListener=l,w.once=l,w.off=l,w.removeListener=l,w.removeAllListeners=l,w.emit=l,w.prependListener=l,w.prependOnceListener=l,w.listeners=function(y){return[]},w.binding=function(y){throw new Error("process.binding is not supported")},w.cwd=function(){return"/"},w.chdir=function(y){throw new Error("process.chdir is not supported")},w.umask=function(){return 0}}])}),define(Z[37],te([0,1,9,2]),function($,t,O,b){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.prefixedStream=t.prefixedReadable=t.transform=t.toReadable=t.emptyStream=t.toStream=t.peekStream=t.listenStream=t.consumeStream=t.peekReadable=t.consumeReadable=t.newWriteableStream=t.isReadableBufferedStream=t.isReadableStream=void 0;function w(h){const o=h;return o?[o.on,o.pause,o.resume,o.destroy].every(s=>typeof s=="function"):!1}t.isReadableStream=w;function R(h){const o=h;return o?w(o.stream)&&Array.isArray(o.buffer)&&typeof o.ended=="boolean":!1}t.isReadableBufferedStream=R;function L(h,o){return new T(h,o)}t.newWriteableStream=L;class T{constructor(o,s){this.reducer=o,this.options=s,this.state={flowing:!1,ended:!1,destroyed:!1},this.buffer={data:[],error:[]},this.listeners={data:[],error:[],end:[]},this.pendingWritePromises=[]}pause(){this.state.destroyed||(this.state.flowing=!1)}resume(){this.state.destroyed||this.state.flowing||(this.state.flowing=!0,this.flowData(),this.flowErrors(),this.flowEnd())}write(o){if(!this.state.destroyed){if(this.state.flowing)this.emitData(o);else if(this.buffer.data.push(o),typeof this.options?.highWaterMark=="number"&&this.buffer.data.length>this.options.highWaterMark)return new Promise(s=>this.pendingWritePromises.push(s))}}error(o){this.state.destroyed||(this.state.flowing?this.emitError(o):this.buffer.error.push(o))}end(o){this.state.destroyed||(typeof o!="undefined"&&this.write(o),this.state.flowing?(this.emitEnd(),this.destroy()):this.state.ended=!0)}emitData(o){this.listeners.data.slice(0).forEach(s=>s(o))}emitError(o){this.listeners.error.length===0?(0,O.onUnexpectedError)(o):this.listeners.error.slice(0).forEach(s=>s(o))}emitEnd(){this.listeners.end.slice(0).forEach(o=>o())}on(o,s){if(!this.state.destroyed)switch(o){case"data":this.listeners.data.push(s),this.resume();break;case"end":this.listeners.end.push(s),this.state.flowing&&this.flowEnd()&&this.destroy();break;case"error":this.listeners.error.push(s),this.state.flowing&&this.flowErrors();break}}removeListener(o,s){if(this.state.destroyed)return;let e;switch(o){case"data":e=this.listeners.data;break;case"end":e=this.listeners.end;break;case"error":e=this.listeners.error;break}if(e){const i=e.indexOf(s);i>=0&&e.splice(i,1)}}flowData(){if(this.buffer.data.length>0){const o=this.reducer(this.buffer.data);this.emitData(o),this.buffer.data.length=0;const s=[...this.pendingWritePromises];this.pendingWritePromises.length=0,s.forEach(e=>e())}}flowErrors(){if(this.listeners.error.length>0){for(const o of this.buffer.error)this.emitError(o);this.buffer.error.length=0}}flowEnd(){return this.state.ended?(this.emitEnd(),this.listeners.end.length>0):!1}destroy(){this.state.destroyed||(this.state.destroyed=!0,this.state.ended=!0,this.buffer.data.length=0,this.buffer.error.length=0,this.listeners.data.length=0,this.listeners.error.length=0,this.listeners.end.length=0,this.pendingWritePromises.length=0)}}function c(h,o){const s=[];let e;for(;(e=h.read())!==null;)s.push(e);return o(s)}t.consumeReadable=c;function d(h,o,s){const e=[];let i;for(;(i=h.read())!==null&&e.length<s;)e.push(i);return i===null&&e.length>0?o(e):{read:()=>{if(e.length>0)return e.shift();if(typeof i!="undefined"){const n=i;return i=void 0,n}return h.read()}}}t.peekReadable=d;function v(h,o){return new Promise((s,e)=>{const i=[];P(h,{onData:n=>{o&&i.push(n)},onError:n=>{o?e(n):s(void 0)},onEnd:()=>{s(o?o(i):void 0)}})})}t.consumeStream=v;function P(h,o){h.on("error",s=>o.onError(s)),h.on("end",()=>o.onEnd()),h.on("data",s=>o.onData(s))}t.listenStream=P;function g(h,o){return new Promise((s,e)=>{const i=new b.DisposableStore,n=[],r=S=>{if(n.push(S),n.length>o)return i.dispose(),h.pause(),s({stream:h,buffer:n,ended:!1})},a=S=>e(S),m=()=>s({stream:h,buffer:n,ended:!0});i.add((0,b.toDisposable)(()=>h.removeListener("error",a))),h.on("error",a),i.add((0,b.toDisposable)(()=>h.removeListener("end",m))),h.on("end",m),i.add((0,b.toDisposable)(()=>h.removeListener("data",r))),h.on("data",r)})}t.peekStream=g;function I(h,o){const s=L(o);return s.end(h),s}t.toStream=I;function u(){const h=L(()=>{throw new Error("not supported")});return h.end(),h}t.emptyStream=u;function l(h){let o=!1;return{read:()=>o?null:(o=!0,h)}}t.toReadable=l;function y(h,o,s){const e=L(s);return P(h,{onData:i=>e.write(o.data(i)),onError:i=>e.error(o.error?o.error(i):i),onEnd:()=>e.end()}),e}t.transform=y;function E(h,o,s){let e=!1;return{read:()=>{const i=o.read();return e?i:(e=!0,i!==null?s([h,i]):h)}}}t.prefixedReadable=E;function f(h,o,s){let e=!1;const i=L(s);return P(o,{onData:n=>e?i.write(n):(e=!0,i.write(s([h,n]))),onError:n=>i.error(n),onEnd:()=>{e||(e=!0,i.write(h)),i.end()}}),i}t.prefixedStream=f}),define(Z[17],te([0,1,37]),function($,t,O){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.prefixedBufferStream=t.prefixedBufferReadable=t.newWriteableBufferStream=t.streamToBufferReadableStream=t.bufferToStream=t.bufferedStreamToBuffer=t.streamToBuffer=t.bufferToReadable=t.readableToBuffer=t.writeUInt8=t.readUInt8=t.writeUInt32LE=t.readUInt32LE=t.writeUInt32BE=t.readUInt32BE=t.writeUInt16LE=t.readUInt16LE=t.VSBuffer=void 0;const b=typeof Buffer!="undefined";let w,R;class L{constructor(r){this.buffer=r,this.byteLength=this.buffer.byteLength}static alloc(r){return b?new L(Buffer.allocUnsafe(r)):new L(new Uint8Array(r))}static wrap(r){return b&&!Buffer.isBuffer(r)&&(r=Buffer.from(r.buffer,r.byteOffset,r.byteLength)),new L(r)}static fromString(r,a){return!(a?.dontUseNodeBuffer||!1)&&b?new L(Buffer.from(r)):(w||(w=new TextEncoder),new L(w.encode(r)))}static concat(r,a){if(typeof a=="undefined"){a=0;for(let F=0,p=r.length;F<p;F++)a+=r[F].byteLength}const m=L.alloc(a);let S=0;for(let F=0,p=r.length;F<p;F++){const C=r[F];m.set(C,S),S+=C.byteLength}return m}toString(){return b?this.buffer.toString():(R||(R=new TextDecoder),R.decode(this.buffer))}slice(r,a){return new L(this.buffer.subarray(r,a))}set(r,a){r instanceof L?this.buffer.set(r.buffer,a):this.buffer.set(r,a)}readUInt32BE(r){return d(this.buffer,r)}writeUInt32BE(r,a){v(this.buffer,r,a)}readUInt32LE(r){return P(this.buffer,r)}writeUInt32LE(r,a){g(this.buffer,r,a)}readUInt8(r){return I(this.buffer,r)}writeUInt8(r,a){u(this.buffer,r,a)}}t.VSBuffer=L;function T(n,r){return n[r+0]<<0>>>0|n[r+1]<<8>>>0}t.readUInt16LE=T;function c(n,r,a){n[a+0]=r&255,r=r>>>8,n[a+1]=r&255}t.writeUInt16LE=c;function d(n,r){return n[r]*2**24+n[r+1]*2**16+n[r+2]*2**8+n[r+3]}t.readUInt32BE=d;function v(n,r,a){n[a+3]=r,r=r>>>8,n[a+2]=r,r=r>>>8,n[a+1]=r,r=r>>>8,n[a]=r}t.writeUInt32BE=v;function P(n,r){return n[r+0]<<0>>>0|n[r+1]<<8>>>0|n[r+2]<<16>>>0|n[r+3]<<24>>>0}t.readUInt32LE=P;function g(n,r,a){n[a+0]=r&255,r=r>>>8,n[a+1]=r&255,r=r>>>8,n[a+2]=r&255,r=r>>>8,n[a+3]=r&255}t.writeUInt32LE=g;function I(n,r){return n[r]}t.readUInt8=I;function u(n,r,a){n[a]=r}t.writeUInt8=u;function l(n){return O.consumeReadable(n,r=>L.concat(r))}t.readableToBuffer=l;function y(n){return O.toReadable(n)}t.bufferToReadable=y;function E(n){return O.consumeStream(n,r=>L.concat(r))}t.streamToBuffer=E;async function f(n){return n.ended?L.concat(n.buffer):L.concat([...n.buffer,await E(n.stream)])}t.bufferedStreamToBuffer=f;function h(n){return O.toStream(n,r=>L.concat(r))}t.bufferToStream=h;function o(n){return O.transform(n,{data:r=>typeof r=="string"?L.fromString(r):L.wrap(r)},r=>L.concat(r))}t.streamToBufferReadableStream=o;function s(n){return O.newWriteableStream(r=>L.concat(r),n)}t.newWriteableBufferStream=s;function e(n,r){return O.prefixedReadable(n,r,a=>L.concat(a))}t.prefixedBufferReadable=e;function i(n,r){return O.prefixedStream(n,r,a=>L.concat(a))}t.prefixedBufferStream=i}),define(Z[18],te([0,1,11]),function($,t,O){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.filter=t.getCaseInsensitive=t.distinct=t.getOrDefault=t.safeStringify=t.equals=t.mixin=t.cloneAndChange=t.deepFreeze=t.deepClone=void 0;function b(l){if(!l||typeof l!="object"||l instanceof RegExp)return l;const y=Array.isArray(l)?[]:{};return Object.keys(l).forEach(E=>{l[E]&&typeof l[E]=="object"?y[E]=b(l[E]):y[E]=l[E]}),y}t.deepClone=b;function w(l){if(!l||typeof l!="object")return l;const y=[l];for(;y.length>0;){const E=y.shift();Object.freeze(E);for(const f in E)if(R.call(E,f)){const h=E[f];typeof h=="object"&&!Object.isFrozen(h)&&y.push(h)}}return l}t.deepFreeze=w;const R=Object.prototype.hasOwnProperty;function L(l,y){return T(l,y,new Set)}t.cloneAndChange=L;function T(l,y,E){if((0,O.isUndefinedOrNull)(l))return l;const f=y(l);if(typeof f!="undefined")return f;if((0,O.isArray)(l)){const h=[];for(const o of l)h.push(T(o,y,E));return h}if((0,O.isObject)(l)){if(E.has(l))throw new Error("Cannot clone recursive data-structure");E.add(l);const h={};for(let o in l)R.call(l,o)&&(h[o]=T(l[o],y,E));return E.delete(l),h}return l}function c(l,y,E=!0){return(0,O.isObject)(l)?((0,O.isObject)(y)&&Object.keys(y).forEach(f=>{f in l?E&&((0,O.isObject)(l[f])&&(0,O.isObject)(y[f])?c(l[f],y[f],E):l[f]=y[f]):l[f]=y[f]}),l):y}t.mixin=c;function d(l,y){if(l===y)return!0;if(l==null||y===null||y===void 0||typeof l!=typeof y||typeof l!="object"||Array.isArray(l)!==Array.isArray(y))return!1;let E,f;if(Array.isArray(l)){if(l.length!==y.length)return!1;for(E=0;E<l.length;E++)if(!d(l[E],y[E]))return!1}else{const h=[];for(f in l)h.push(f);h.sort();const o=[];for(f in y)o.push(f);if(o.sort(),!d(h,o))return!1;for(E=0;E<h.length;E++)if(!d(l[h[E]],y[h[E]]))return!1}return!0}t.equals=d;function v(l){const y=new Set;return JSON.stringify(l,(E,f)=>{if((0,O.isObject)(f)||Array.isArray(f)){if(y.has(f))return"[Circular]";y.add(f)}return f})}t.safeStringify=v;function P(l,y,E){const f=y(l);return typeof f=="undefined"?E:f}t.getOrDefault=P;function g(l,y){const E=Object.create(null);return!l||!y||Object.keys(y).forEach(h=>{const o=l[h],s=y[h];d(o,s)||(E[h]=s)}),E}t.distinct=g;function I(l,y){const E=y.toLowerCase(),f=Object.keys(l).find(h=>h.toLowerCase()===E);return f?l[f]:l[y]}t.getCaseInsensitive=I;function u(l,y){const E=Object.create(null);for(const f of Object.keys(l))y(f,l[f])&&(E[f]=l[f]);return E}t.filter=u}),define(Z[60],te([0,1,7]),function($,t,O){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.log=t.getFirstFrame=t.parse=t.isRemoteConsoleLog=void 0;function b(d){const v=d;return v&&typeof v.type=="string"&&typeof v.severity=="string"}t.isRemoteConsoleLog=b;function w(d){const v=[];let P;try{const g=JSON.parse(d.arguments),I=g[g.length-1];I&&I.__$stack&&(g.pop(),P=I.__$stack),v.push(...g)}catch(g){v.push("Unable to log remote console arguments",d.arguments)}return{args:v,stack:P}}t.parse=w;function R(d){if(typeof d!="string")return R(w(d).stack);const v=d;if(v){const P=L(v),g=/at [^\/]*((?:(?:[a-zA-Z]+:)|(?:[\/])|(?:\\\\))(?:.+)):(\d+):(\d+)/.exec(P||"");if(g&&g.length===4)return{uri:O.URI.file(g[1]),line:Number(g[2]),column:Number(g[3])}}}t.getFirstFrame=R;function L(d){if(!d)return d;const v=d.indexOf(`
`);return v===-1?d:d.substring(0,v)}function T(d,v){const{args:P,stack:g}=w(d),I=typeof P[0]=="string"&&P.length===1;let u=L(g);u&&(u=`(${u.trim()})`);let l=[];if(typeof P[0]=="string"?u&&I?l=[`%c[${v}] %c${P[0]} %c${u}`,c("blue"),c(""),c("grey")]:l=[`%c[${v}] %c${P[0]}`,c("blue"),c(""),...P.slice(1)]:l=[`%c[${v}]%`,c("blue"),...P],u&&!I&&l.push(u),typeof console[d.severity]!="function")throw new Error("Unknown console method");console[d.severity].apply(console,l)}t.log=T;function c(d){return`color: ${d}`}}),define(Z[61],te([0,1,17,22,7]),function($,t,O,b,w){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.revive=t.MarshalledId=t.parse=t.stringify=void 0;function R(v){return JSON.stringify(v,c)}t.stringify=R;function L(v){let P=JSON.parse(v);return P=d(P),P}t.parse=L;var T;(function(v){v[v.Uri=1]="Uri",v[v.Regexp=2]="Regexp",v[v.ScmResource=3]="ScmResource",v[v.ScmResourceGroup=4]="ScmResourceGroup",v[v.ScmProvider=5]="ScmProvider",v[v.CommentController=6]="CommentController",v[v.CommentThread=7]="CommentThread",v[v.CommentThreadReply=8]="CommentThreadReply",v[v.CommentNode=9]="CommentNode",v[v.CommentThreadNode=10]="CommentThreadNode",v[v.TimelineActionContext=11]="TimelineActionContext",v[v.NotebookCellActionContext=12]="NotebookCellActionContext",v[v.TestItemContext=13]="TestItemContext"})(T=t.MarshalledId||(t.MarshalledId={}));function c(v,P){return P instanceof RegExp?{$mid:2,source:P.source,flags:(0,b.regExpFlags)(P)}:P}function d(v,P=0){if(!v||P>200)return v;if(typeof v=="object"){switch(v.$mid){case 1:return w.URI.revive(v);case 2:return new RegExp(v.source,v.flags)}if(v instanceof O.VSBuffer||v instanceof Uint8Array)return v;if(Array.isArray(v))for(let g=0;g<v.length;++g)v[g]=d(v[g],P+1);else for(const g in v)Object.hasOwnProperty.call(v,g)&&(v[g]=d(v[g],P+1))}return v}t.revive=d}),define(Z[62],te([0,1,3,38,46,4,22]),function($,t,O,b,w,R,L){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.getPathTerms=t.getBasenameTerms=t.isRelativePattern=t.hasSiblingFn=t.hasSiblingPromiseFn=t.parse=t.match=t.splitGlobAware=t.getEmptyExpression=void 0;function T(){return Object.create(null)}t.getEmptyExpression=T;const c="**",d="/",v="[/\\\\]",P="[^/\\\\]",g=/\//g;function I(D){switch(D){case 0:return"";case 1:return`${P}*?`;default:return`(?:${v}|${P}+${v}|${v}${P}+)*?`}}function u(D,M){if(!D)return[];const U=[];let K=!1,B=!1,J="";for(const q of D){switch(q){case M:if(!K&&!B){U.push(J),J="";continue}break;case"{":K=!0;break;case"}":K=!1;break;case"[":B=!0;break;case"]":B=!1;break}J+=q}return J&&U.push(J),U}t.splitGlobAware=u;function l(D){if(!D)return"";let M="";const U=u(D,d);if(U.every(K=>K===c))M=".*";else{let K=!1;U.forEach((B,J)=>{if(B===c){K||(M+=I(2),K=!0);return}let q=!1,k="",A=!1,j="";for(const W of B){if(W!=="}"&&q){k+=W;continue}if(A&&(W!=="]"||!j)){let X;W==="-"?X=W:(W==="^"||W==="!")&&!j?X="^":W===d?X="":X=L.escapeRegExpCharacters(W),j+=X;continue}switch(W){case"{":q=!0;continue;case"[":A=!0;continue;case"}":M+=`(?:${u(k,",").map(se=>l(se)).join("|")})`,q=!1,k="";break;case"]":M+="["+j+"]",A=!1,j="";break;case"?":M+=P;continue;case"*":M+=I(1);continue;default:M+=L.escapeRegExpCharacters(W)}}J<U.length-1&&(U[J+1]!==c||J+2<U.length)&&(M+=v),K=!1})}return M}const y=/^\*\*\/\*\.[\w\.-]+$/,E=/^\*\*\/([\w\.-]+)\/?$/,f=/^{\*\*\/[\*\.]?[\w\.-]+\/?(,\*\*\/[\*\.]?[\w\.-]+\/?)*}$/,h=/^{\*\*\/[\*\.]?[\w\.-]+(\/(\*\*)?)?(,\*\*\/[\*\.]?[\w\.-]+(\/(\*\*)?)?)*}$/,o=/^\*\*((\/[\w\.-]+)+)\/?$/,s=/^([\w\.-]+(\/[\w\.-]+)*)\/?$/,e=new w.LRUCache(1e4),i=function(){return!1},n=function(){return null};function r(D,M){if(!D)return n;let U;typeof D!="string"?U=D.pattern:U=D,U=U.trim();const K=`${U}_${!!M.trimForExclusions}`;let B=e.get(K);if(B)return a(B,D);let J;if(y.test(U)){const q=U.substr(4);B=function(k,A){return typeof k=="string"&&k.endsWith(q)?U:null}}else(J=E.exec(m(U,M)))?B=S(J[1],U):(M.trimForExclusions?h:f).test(U)?B=F(U,M):(J=o.exec(m(U,M)))?B=p(J[1].substr(1),U,!0):(J=s.exec(m(U,M)))?B=p(J[1],U,!1):B=C(U);return e.set(K,B),a(B,D)}function a(D,M){return typeof M=="string"?D:function(U,K){return b.isEqualOrParent(U,M.base)?D(R.relative(M.base,U),K):null}}function m(D,M){return M.trimForExclusions&&D.endsWith("/**")?D.substr(0,D.length-2):D}function S(D,M){const U=`/${D}`,K=`\\${D}`,B=function(q,k){return typeof q!="string"?null:k?k===D?M:null:q===D||q.endsWith(U)||q.endsWith(K)?M:null},J=[D];return B.basenames=J,B.patterns=[M],B.allBasenames=J,B}function F(D,M){const U=z(D.slice(1,-1).split(",").map(k=>r(k,M)).filter(k=>k!==n),D),K=U.length;if(!K)return n;if(K===1)return U[0];const B=function(k,A){for(let j=0,W=U.length;j<W;j++)if(U[j](k,A))return D;return null},J=U.find(k=>!!k.allBasenames);J&&(B.allBasenames=J.allBasenames);const q=U.reduce((k,A)=>A.allPaths?k.concat(A.allPaths):k,[]);return q.length&&(B.allPaths=q),B}function p(D,M,U){const K=R.sep===R.posix.sep,B=K?D:D.replace(g,R.sep),J=R.sep+B,q=R.posix.sep+D,k=U?function(A,j){return typeof A=="string"&&(A===B||A.endsWith(J)||!K&&(A===D||A.endsWith(q)))?M:null}:function(A,j){return typeof A=="string"&&(A===B||!K&&A===D)?M:null};return k.allPaths=[(U?"*/":"./")+D],k}function C(D){try{const M=new RegExp(`^${l(D)}$`);return function(U){return M.lastIndex=0,typeof U=="string"&&M.test(U)?D:null}}catch(M){return n}}function N(D,M,U){return!D||typeof M!="string"?!1:V(D)(M,void 0,U)}t.match=N;function V(D,M={}){if(!D)return i;if(typeof D=="string"||ee(D)){const U=r(D,M);if(U===n)return i;const K=function(B,J){return!!U(B,J)};return U.allBasenames&&(K.allBasenames=U.allBasenames),U.allPaths&&(K.allPaths=U.allPaths),K}return G(D,M)}t.parse=V;function Y(D){if(!D)return;let M;return U=>(M||(M=(D()||Promise.resolve([])).then(K=>K?oe(K):{})),M.then(K=>!!K[U]))}t.hasSiblingPromiseFn=Y;function ie(D){if(!D)return;let M;return U=>{if(!M){const K=D();M=K?oe(K):{}}return!!M[U]}}t.hasSiblingFn=ie;function oe(D){const M={};for(const U of D)M[U]=!0;return M}function ee(D){const M=D;return M&&typeof M.base=="string"&&typeof M.pattern=="string"}t.isRelativePattern=ee;function ue(D){return D.allBasenames||[]}t.getBasenameTerms=ue;function ce(D){return D.allPaths||[]}t.getPathTerms=ce;function G(D,M){const U=z(Object.getOwnPropertyNames(D).map(k=>ne(k,D[k],M)).filter(k=>k!==n)),K=U.length;if(!K)return n;if(!U.some(k=>!!k.requiresSiblings)){if(K===1)return U[0];const k=function(W,X){for(let Q=0,se=U.length;Q<se;Q++){const re=U[Q](W,X);if(re)return re}return null},A=U.find(W=>!!W.allBasenames);A&&(k.allBasenames=A.allBasenames);const j=U.reduce((W,X)=>X.allPaths?W.concat(X.allPaths):W,[]);return j.length&&(k.allPaths=j),k}const B=function(k,A,j){let W;for(let X=0,Q=U.length;X<Q;X++){const se=U[X];se.requiresSiblings&&j&&(A||(A=R.basename(k)),W||(W=A.substr(0,A.length-R.extname(k).length)));const re=se(k,A,W,j);if(re)return re}return null},J=U.find(k=>!!k.allBasenames);J&&(B.allBasenames=J.allBasenames);const q=U.reduce((k,A)=>A.allPaths?k.concat(A.allPaths):k,[]);return q.length&&(B.allPaths=q),B}function ne(D,M,U){if(M===!1)return n;const K=r(D,U);if(K===n)return n;if(typeof M=="boolean")return K;if(M){const B=M.when;if(typeof B=="string"){const J=(q,k,A,j)=>{if(!j||!K(q,k))return null;const W=B.replace("$(basename)",A),X=j(W);return(0,O.isThenable)(X)?X.then(Q=>Q?D:null):X?D:null};return J.requiresSiblings=!0,J}}return K}function z(D,M){const U=D.filter(k=>!!k.basenames);if(U.length<2)return D;const K=U.reduce((k,A)=>{const j=A.basenames;return j?k.concat(j):k},[]);let B;if(M){B=[];for(let k=0,A=K.length;k<A;k++)B.push(M)}else B=U.reduce((k,A)=>{const j=A.patterns;return j?k.concat(j):k},[]);const J=function(k,A){if(typeof k!="string")return null;if(!A){let W;for(W=k.length;W>0;W--){const X=k.charCodeAt(W-1);if(X===47||X===92)break}A=k.substr(W)}const j=K.indexOf(A);return j!==-1?B[j]:null};J.basenames=K,J.patterns=B,J.allBasenames=K;const q=D.filter(k=>!k.basenames);return q.push(J),q}}),define(Z[63],te([0,1,38,8,4,10,19,22,7]),function($,t,O,b,w,R,L,T,c){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.splitName=t.unmnemonicLabel=t.mnemonicButtonLabel=t.mnemonicMenuLabel=t.template=t.shorten=t.untildify=t.tildify=t.normalizeDriveLetter=t.getBaseLabel=t.getPathLabel=void 0;function d(r,a,m){if(typeof r=="string"&&(r=c.URI.file(r)),m){const F=m.getWorkspaceFolder(r);if(F){const p=m.getWorkspace().folders.length>1;let C;if((0,L.isEqual)(F.uri,r)?C="":C=(0,L.relativePath)(F.uri,r),p){const N=F.name?F.name:(0,L.basename)(F.uri);C=C?N+" \u2022 "+C:N}return C}}if(r.scheme!==b.Schemas.file&&r.scheme!==b.Schemas.untitled)return r.with({query:null,fragment:null}).toString(!0);if((0,O.hasDriveLetter)(r.fsPath))return(0,w.normalize)(P(r.fsPath));let S=(0,w.normalize)(r.fsPath);return!R.isWindows&&a?.userHome&&(S=I(S,a.userHome.fsPath)),S}t.getPathLabel=d;function v(r){if(!r)return;typeof r=="string"&&(r=c.URI.file(r));const a=(0,L.basename)(r)||(r.scheme===b.Schemas.file?r.fsPath:r.path);return R.isWindows&&(0,O.isRootOrDriveLetter)(a)?P(a):a}t.getBaseLabel=v;function P(r){return(0,O.hasDriveLetter)(r)?r.charAt(0).toUpperCase()+r.slice(1):r}t.normalizeDriveLetter=P;let g=Object.create(null);function I(r,a){if(R.isWindows||!r||!a)return r;let m=g.original===a?g.normalized:void 0;return m||(m=`${(0,T.rtrim)(a,w.posix.sep)}${w.posix.sep}`,g={original:a,normalized:m}),(R.isLinux?r.startsWith(m):(0,T.startsWithIgnoreCase)(r,m))&&(r=`~/${r.substr(m.length)}`),r}t.tildify=I;function u(r,a){return r.replace(/^~($|\/|\\)/,`${a}$1`)}t.untildify=u;const l="\u2026",y="\\\\",E="~";function f(r,a=w.sep){const m=new Array(r.length);let S=!1;for(let F=0;F<r.length;F++){let p=r[F];if(p===""){m[F]=`.${a}`;continue}if(!p){m[F]=p;continue}S=!0;let C="";p.indexOf(y)===0?(C=p.substr(0,p.indexOf(y)+y.length),p=p.substr(p.indexOf(y)+y.length)):p.indexOf(a)===0?(C=p.substr(0,p.indexOf(a)+a.length),p=p.substr(p.indexOf(a)+a.length)):p.indexOf(E)===0&&(C=p.substr(0,p.indexOf(E)+E.length),p=p.substr(p.indexOf(E)+E.length));const N=p.split(a);for(let V=1;S&&V<=N.length;V++)for(let Y=N.length-V;S&&Y>=0;Y--){S=!1;let ie=N.slice(Y,Y+V).join(a);for(let oe=0;!S&&oe<r.length;oe++)if(oe!==F&&r[oe]&&r[oe].indexOf(ie)>-1){const ee=Y+V===N.length,ue=Y>0&&r[oe].indexOf(a)>-1?a+ie:ie,ce=r[oe].endsWith(ue);S=!ee||ce}if(!S){let oe="";(N[0].endsWith(":")||C!=="")&&(Y===1&&(Y=0,V++,ie=N[0]+a+ie),Y>0&&(oe=N[0]+a),oe=C+oe),Y>0&&(oe=oe+l+a),oe=oe+ie,Y+V<N.length&&(oe=oe+a+l),m[F]=oe}}S&&(m[F]=p)}return m}t.shorten=f;var h;(function(r){r[r.TEXT=0]="TEXT",r[r.VARIABLE=1]="VARIABLE",r[r.SEPARATOR=2]="SEPARATOR"})(h||(h={}));function o(r,a=Object.create(null)){const m=[];let S=!1,F="";for(const p of r)if(p==="$"||S&&p==="{")F&&m.push({value:F,type:h.TEXT}),F="",S=!0;else if(p==="}"&&S){const C=a[F];if(typeof C=="string")C.length&&m.push({value:C,type:h.VARIABLE});else if(C){const N=m[m.length-1];(!N||N.type!==h.SEPARATOR)&&m.push({value:C.label,type:h.SEPARATOR})}F="",S=!1}else F+=p;return F&&!S&&m.push({value:F,type:h.TEXT}),m.filter((p,C)=>{if(p.type===h.SEPARATOR){const N=m[C-1],V=m[C+1];return[N,V].every(Y=>Y&&(Y.type===h.VARIABLE||Y.type===h.TEXT)&&Y.value.length>0)}return!0}).map(p=>p.value).join("")}t.template=o;function s(r,a){return R.isMacintosh||a?r.replace(/\(&&\w\)|&&/g,"").replace(/&/g,R.isMacintosh?"&":"&&"):r.replace(/&&|&/g,m=>m==="&"?"&&":"&")}t.mnemonicMenuLabel=s;function e(r,a){return R.isMacintosh||a?r.replace(/\(&&\w\)|&&/g,""):R.isWindows?r.replace(/&&|&/g,m=>m==="&"?"&&":"&"):r.replace(/&&/g,"_")}t.mnemonicButtonLabel=e;function i(r){return r.replace(/&/g,"&&")}t.unmnemonicLabel=i;function n(r){const a=r.indexOf("/")!==-1?w.posix:w.win32,m=a.basename(r),S=a.dirname(r);return m.length?{name:m,parentPath:S}:{name:S,parentPath:""}}t.splitName=n}),define(Z[47],te([0,1,126]),function($,t,O){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.LineDecoder=void 0;class b{constructor(R="utf8"){this.stringDecoder=new O.StringDecoder(R),this.remaining=null}write(R){const L=[],T=this.remaining?this.remaining+this.stringDecoder.write(R):this.stringDecoder.write(R);if(T.length<1)return L;let c=0,d,v=c;for(;v<T.length;)if(d=T.charCodeAt(v),d===13||d===10){if(L.push(T.substring(c,v)),v++,v<T.length){const P=d;d=T.charCodeAt(v),(P===13&&d===10||P===10&&d===13)&&v++}c=v}else v++;return this.remaining=c<T.length?T.substr(c):null,L}end(){return this.remaining}}t.LineDecoder=b}),define(Z[64],te([0,1,48,4,22,12]),function($,t,O,b,w,R){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.realpathSync=t.realpath=t.realcaseSync=void 0;function L(v){const P=(0,b.dirname)(v);if(v===P)return v;const g=((0,b.basename)(v)||v).toLowerCase();try{const u=(0,R.readdirSync)(P).filter(l=>l.toLowerCase()===g);if(u.length===1){const l=L(P);if(l)return(0,b.join)(l,u[0])}else if(u.length>1){const l=u.indexOf(g);if(l>=0){const y=L(P);if(y)return(0,b.join)(y,u[l])}}}catch(I){}return null}t.realcaseSync=L;async function T(v){try{return await R.Promises.realpath(v)}catch(P){const g=d(v);return await R.Promises.access(g,O.constants.R_OK),g}}t.realpath=T;function c(v){try{return O.realpathSync(v)}catch(P){const g=d(v);return O.accessSync(g,O.constants.R_OK),g}}t.realpathSync=c;function d(v){return(0,w.rtrim)((0,b.normalize)(v),b.sep)}}),define(Z[65],te([0,1,34,4,12]),function($,t,O,b,w){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.getFirstAvailablePowerShellInstallation=t.enumeratePowerShellInstallations=void 0;const R=/^\d+$/,L=/^Microsoft.PowerShell_.*/,T=/^Microsoft.PowerShellPreview_.*/;var c;(function(o){o[o.x64=0]="x64",o[o.x86=1]="x86",o[o.ARM=2]="ARM"})(c||(c={}));let d;switch(process.arch){case"ia32":case"x32":d=1;break;case"arm":case"arm64":d=2;break;default:d=0;break}let v;process.env.PROCESSOR_ARCHITEW6432?v=process.env.PROCESSOR_ARCHITEW6432==="ARM64"?2:0:process.env.PROCESSOR_ARCHITECTURE==="ARM64"?v=2:process.env.PROCESSOR_ARCHITECTURE==="X86"?v=1:v=0;class P{constructor(s,e,i){this.exePath=s,this.displayName=e,this.knownToExist=i}async exists(){return this.knownToExist===void 0&&(this.knownToExist=await w.SymlinkSupport.existsFile(this.exePath)),this.knownToExist}}function g({useAlternateBitness:o=!1}={}){return o?d===0?process.env["ProgramFiles(x86)"]||null:v===0&&process.env.ProgramW6432||null:process.env.ProgramFiles||null}async function I({useAlternateBitness:o=!1,findPreview:s=!1}={}){const e=g({useAlternateBitness:o});if(!e)return null;const i=b.join(e,"PowerShell");if(!await w.SymlinkSupport.existsDirectory(i))return null;let n=-1,r=null;for(const S of await w.Promises.readdir(i)){let F=-1;if(s){const C=S.indexOf("-");if(C<0)continue;const N=S.substring(0,C);if(!R.test(N)||S.substring(C+1)!=="preview")continue;F=parseInt(N,10)}else{if(!R.test(S))continue;F=parseInt(S,10)}if(F<=n)continue;const p=b.join(i,S,"pwsh.exe");!await w.SymlinkSupport.existsFile(p)||(r=p,n=F)}if(!r)return null;const a=e.includes("x86")?" (x86)":"",m=s?" Preview":"";return new P(r,`PowerShell${m}${a}`,!0)}async function u({findPreview:o}={}){if(!process.env.LOCALAPPDATA)return null;const s=b.join(process.env.LOCALAPPDATA,"Microsoft","WindowsApps");if(!await w.SymlinkSupport.existsDirectory(s))return null;const{pwshMsixDirRegex:e,pwshMsixName:i}=o?{pwshMsixDirRegex:T,pwshMsixName:"PowerShell Preview (Store)"}:{pwshMsixDirRegex:L,pwshMsixName:"PowerShell (Store)"};for(const n of await w.Promises.readdir(s))if(e.test(n)){const r=b.join(s,n,"pwsh.exe");return new P(r,i)}return null}function l(){const o=b.join(O.homedir(),".dotnet","tools","pwsh.exe");return new P(o,".NET Core PowerShell Global Tool")}function y(){const o=b.join(process.env.windir,d===1&&v!==1?"SysNative":"System32","WindowsPowerShell","v1.0","powershell.exe");return new P(o,"Windows PowerShell",!0)}async function*E(){let o=await I();o&&(yield o),o=await I({useAlternateBitness:!0}),o&&(yield o),o=await u(),o&&(yield o),o=l(),o&&(yield o),o=await I({findPreview:!0}),o&&(yield o),o=await u({findPreview:!0}),o&&(yield o),o=await I({useAlternateBitness:!0,findPreview:!0}),o&&(yield o),o=y(),o&&(yield o)}async function*f(){for await(const o of E())await o.exists()&&(yield o)}t.enumeratePowerShellInstallations=f;async function h(){for await(const o of f())return o;return null}t.getFirstAvailablePowerShellInstallation=h});var de=this&&this.__decorate||function($,t,O,b){var w=arguments.length,R=w<3?t:b===null?b=Object.getOwnPropertyDescriptor(t,O):b,L;if(typeof Reflect=="object"&&typeof Reflect.decorate=="function")R=Reflect.decorate($,t,O,b);else for(var T=$.length-1;T>=0;T--)(L=$[T])&&(R=(w<3?L(R):w>3?L(t,O,R):L(t,O))||R);return w>3&&R&&Object.defineProperty(t,O,R),R};define(Z[39],te([0,1,20,3,17,25,45,9,13,2,61,22,11]),function($,t,O,b,w,R,L,T,c,d,v,P,g){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.IPCLogger=t.logWithColors=t.ProxyChannel=t.StaticRouter=t.getNextTickChannel=t.getDelayedChannel=t.IPCClient=t.IPCServer=t.ChannelClient=t.RequestInitiator=t.ChannelServer=t.ResponseType=t.RequestType=void 0;var I;(function(z){z[z.Promise=100]="Promise",z[z.PromiseCancel=101]="PromiseCancel",z[z.EventListen=102]="EventListen",z[z.EventDispose=103]="EventDispose"})(I=t.RequestType||(t.RequestType={}));function u(z){switch(z){case 100:return"req";case 101:return"cancel";case 102:return"subscribe";case 103:return"unsubscribe"}}var l;(function(z){z[z.Initialize=200]="Initialize",z[z.PromiseSuccess=201]="PromiseSuccess",z[z.PromiseError=202]="PromiseError",z[z.PromiseErrorObj=203]="PromiseErrorObj",z[z.EventFire=204]="EventFire"})(l=t.ResponseType||(t.ResponseType={}));function y(z){switch(z){case 200:return"init";case 201:return"reply:";case 202:case 203:return"replyErr:";case 204:return"event:"}}var E;(function(z){z[z.Uninitialized=0]="Uninitialized",z[z.Idle=1]="Idle"})(E||(E={}));class f{constructor(D){this.buffer=D,this.pos=0}read(D){const M=this.buffer.slice(this.pos,this.pos+D);return this.pos+=M.byteLength,M}}class h{constructor(){this.buffers=[]}get buffer(){return w.VSBuffer.concat(this.buffers)}write(D){this.buffers.push(D)}}var o;(function(z){z[z.Undefined=0]="Undefined",z[z.String=1]="String",z[z.Buffer=2]="Buffer",z[z.VSBuffer=3]="VSBuffer",z[z.Array=4]="Array",z[z.Object=5]="Object"})(o||(o={}));function s(z){const D=w.VSBuffer.alloc(4);return D.writeUInt32BE(z,0),D}function e(z){return z.read(4).readUInt32BE(0)}function i(z){const D=w.VSBuffer.alloc(1);return D.writeUInt8(z,0),D}const n={Undefined:i(o.Undefined),String:i(o.String),Buffer:i(o.Buffer),VSBuffer:i(o.VSBuffer),Array:i(o.Array),Object:i(o.Object)},r=typeof Buffer!="undefined";function a(z,D){if(typeof D=="undefined")z.write(n.Undefined);else if(typeof D=="string"){const M=w.VSBuffer.fromString(D);z.write(n.String),z.write(s(M.byteLength)),z.write(M)}else if(r&&Buffer.isBuffer(D)){const M=w.VSBuffer.wrap(D);z.write(n.Buffer),z.write(s(M.byteLength)),z.write(M)}else if(D instanceof w.VSBuffer)z.write(n.VSBuffer),z.write(s(D.byteLength)),z.write(D);else if(Array.isArray(D)){z.write(n.Array),z.write(s(D.length));for(const M of D)a(z,M)}else{const M=w.VSBuffer.fromString(JSON.stringify(D));z.write(n.Object),z.write(s(M.byteLength)),z.write(M)}}function m(z){switch(z.read(1).readUInt8(0)){case o.Undefined:return;case o.String:return z.read(e(z)).toString();case o.Buffer:return z.read(e(z)).buffer;case o.VSBuffer:return z.read(e(z));case o.Array:{const M=e(z),U=[];for(let K=0;K<M;K++)U.push(m(z));return U}case o.Object:return JSON.parse(z.read(e(z)).toString())}}class S{constructor(D,M,U=null,K=1e3){this.protocol=D,this.ctx=M,this.logger=U,this.timeoutDelay=K,this.channels=new Map,this.activeRequests=new Map,this.pendingRequests=new Map,this.protocolListener=this.protocol.onMessage(B=>this.onRawMessage(B)),this.sendResponse({type:200})}registerChannel(D,M){this.channels.set(D,M),setTimeout(()=>this.flushPendingRequests(D),0)}sendResponse(D){switch(D.type){case 200:{const M=this.send([D.type]);this.logger&&this.logger.logOutgoing(M,0,1,y(D.type));return}case 201:case 202:case 204:case 203:{const M=this.send([D.type,D.id],D.data);this.logger&&this.logger.logOutgoing(M,D.id,1,y(D.type),D.data);return}}}send(D,M=void 0){const U=new h;return a(U,D),a(U,M),this.sendBuffer(U.buffer)}sendBuffer(D){try{return this.protocol.send(D),D.byteLength}catch(M){return 0}}onRawMessage(D){const M=new f(D),U=m(M),K=m(M),B=U[0];switch(B){case 100:return this.logger&&this.logger.logIncoming(D.byteLength,U[1],1,`${u(B)}: ${U[2]}.${U[3]}`,K),this.onPromise({type:B,id:U[1],channelName:U[2],name:U[3],arg:K});case 102:return this.logger&&this.logger.logIncoming(D.byteLength,U[1],1,`${u(B)}: ${U[2]}.${U[3]}`,K),this.onEventListen({type:B,id:U[1],channelName:U[2],name:U[3],arg:K});case 101:return this.logger&&this.logger.logIncoming(D.byteLength,U[1],1,`${u(B)}`),this.disposeActiveRequest({type:B,id:U[1]});case 103:return this.logger&&this.logger.logIncoming(D.byteLength,U[1],1,`${u(B)}`),this.disposeActiveRequest({type:B,id:U[1]})}}onPromise(D){const M=this.channels.get(D.channelName);if(!M){this.collectPendingRequest(D);return}const U=new R.CancellationTokenSource;let K;try{K=M.call(this.ctx,D.name,D.arg,U.token)}catch(q){K=Promise.reject(q)}const B=D.id;K.then(q=>{this.sendResponse({id:B,data:q,type:201}),this.activeRequests.delete(D.id)},q=>{q instanceof Error?this.sendResponse({id:B,data:{message:q.message,name:q.name,stack:q.stack?q.stack.split?q.stack.split(`
`):q.stack:void 0},type:202}):this.sendResponse({id:B,data:q,type:203}),this.activeRequests.delete(D.id)});const J=(0,d.toDisposable)(()=>U.cancel());this.activeRequests.set(D.id,J)}onEventListen(D){const M=this.channels.get(D.channelName);if(!M){this.collectPendingRequest(D);return}const U=D.id,B=M.listen(this.ctx,D.name,D.arg)(J=>this.sendResponse({id:U,data:J,type:204}));this.activeRequests.set(D.id,B)}disposeActiveRequest(D){const M=this.activeRequests.get(D.id);M&&(M.dispose(),this.activeRequests.delete(D.id))}collectPendingRequest(D){let M=this.pendingRequests.get(D.channelName);M||(M=[],this.pendingRequests.set(D.channelName,M));const U=setTimeout(()=>{console.error(`Unknown channel: ${D.channelName}`),D.type===100&&this.sendResponse({id:D.id,data:{name:"Unknown channel",message:`Channel name '${D.channelName}' timed out after ${this.timeoutDelay}ms`,stack:void 0},type:202})},this.timeoutDelay);M.push({request:D,timeoutTimer:U})}flushPendingRequests(D){const M=this.pendingRequests.get(D);if(M){for(const U of M)switch(clearTimeout(U.timeoutTimer),U.request.type){case 100:this.onPromise(U.request);break;case 102:this.onEventListen(U.request);break}this.pendingRequests.delete(D)}}dispose(){this.protocolListener&&(this.protocolListener.dispose(),this.protocolListener=null),this.activeRequests.forEach(D=>D.dispose()),this.activeRequests.clear()}}t.ChannelServer=S;var F;(function(z){z[z.LocalSide=0]="LocalSide",z[z.OtherSide=1]="OtherSide"})(F=t.RequestInitiator||(t.RequestInitiator={}));class p{constructor(D,M=null){this.protocol=D,this.isDisposed=!1,this.state=E.Uninitialized,this.activeRequests=new Set,this.handlers=new Map,this.lastRequestId=0,this._onDidInitialize=new c.Emitter,this.onDidInitialize=this._onDidInitialize.event,this.protocolListener=this.protocol.onMessage(U=>this.onBuffer(U)),this.logger=M}getChannel(D){const M=this;return{call(U,K,B){return M.isDisposed?Promise.reject(T.canceled()):M.requestPromise(D,U,K,B)},listen(U,K){return M.isDisposed?Promise.reject(T.canceled()):M.requestEvent(D,U,K)}}}requestPromise(D,M,U,K=R.CancellationToken.None){const B=this.lastRequestId++,q={id:B,type:100,channelName:D,name:M,arg:U};if(K.isCancellationRequested)return Promise.reject(T.canceled());let k;return new Promise((j,W)=>{if(K.isCancellationRequested)return W(T.canceled());const X=()=>{const me=ye=>{switch(ye.type){case 201:this.handlers.delete(B),j(ye.data);break;case 202:this.handlers.delete(B);const fe=new Error(ye.data.message);fe.stack=ye.data.stack,fe.name=ye.data.name,W(fe);break;case 203:this.handlers.delete(B),W(ye.data);break}};this.handlers.set(B,me),this.sendRequest(q)};let Q=null;this.state===E.Idle?X():(Q=(0,b.createCancelablePromise)(me=>this.whenInitialized()),Q.then(()=>{Q=null,X()}));const se=()=>{Q?(Q.cancel(),Q=null):this.sendRequest({id:B,type:101}),W(T.canceled())},re=K.onCancellationRequested(se);k=(0,d.combinedDisposable)((0,d.toDisposable)(se),re),this.activeRequests.add(k)}).finally(()=>{this.activeRequests.delete(k)})}requestEvent(D,M,U){const K=this.lastRequestId++,J={id:K,type:102,channelName:D,name:M,arg:U};let q=null;const k=new c.Emitter({onFirstListenerAdd:()=>{q=(0,b.createCancelablePromise)(j=>this.whenInitialized()),q.then(()=>{q=null,this.activeRequests.add(k),this.sendRequest(J)})},onLastListenerRemove:()=>{q?(q.cancel(),q=null):(this.activeRequests.delete(k),this.sendRequest({id:K,type:103}))}}),A=j=>k.fire(j.data);return this.handlers.set(K,A),k.event}sendRequest(D){switch(D.type){case 100:case 102:{const M=this.send([D.type,D.id,D.channelName,D.name],D.arg);this.logger&&this.logger.logOutgoing(M,D.id,0,`${u(D.type)}: ${D.channelName}.${D.name}`,D.arg);return}case 101:case 103:{const M=this.send([D.type,D.id]);this.logger&&this.logger.logOutgoing(M,D.id,0,u(D.type));return}}}send(D,M=void 0){const U=new h;return a(U,D),a(U,M),this.sendBuffer(U.buffer)}sendBuffer(D){try{return this.protocol.send(D),D.byteLength}catch(M){return 0}}onBuffer(D){const M=new f(D),U=m(M),K=m(M),B=U[0];switch(B){case 200:return this.logger&&this.logger.logIncoming(D.byteLength,0,0,y(B)),this.onResponse({type:U[0]});case 201:case 202:case 204:case 203:return this.logger&&this.logger.logIncoming(D.byteLength,U[1],0,y(B),K),this.onResponse({type:U[0],id:U[1],data:K})}}onResponse(D){if(D.type===200){this.state=E.Idle,this._onDidInitialize.fire();return}const M=this.handlers.get(D.id);M&&M(D)}get onDidInitializePromise(){return c.Event.toPromise(this.onDidInitialize)}whenInitialized(){return this.state===E.Idle?Promise.resolve():this.onDidInitializePromise}dispose(){this.isDisposed=!0,this.protocolListener&&(this.protocolListener.dispose(),this.protocolListener=null),this.activeRequests.forEach(D=>D.dispose()),this.activeRequests.clear()}}de([L.memoize],p.prototype,"onDidInitializePromise",null),t.ChannelClient=p;class C{constructor(D){this.channels=new Map,this._connections=new Set,this._onDidAddConnection=new c.Emitter,this.onDidAddConnection=this._onDidAddConnection.event,this._onDidRemoveConnection=new c.Emitter,this.onDidRemoveConnection=this._onDidRemoveConnection.event,D(({protocol:M,onDidClientDisconnect:U})=>{c.Event.once(M.onMessage)(B=>{const J=new f(B),q=m(J),k=new S(M,q),A=new p(M);this.channels.forEach((W,X)=>k.registerChannel(X,W));const j={channelServer:k,channelClient:A,ctx:q};this._connections.add(j),this._onDidAddConnection.fire(j),U(()=>{k.dispose(),A.dispose(),this._connections.delete(j),this._onDidRemoveConnection.fire(j)})})})}get connections(){const D=[];return this._connections.forEach(M=>D.push(M)),D}getChannel(D,M){const U=this;return{call(K,B,J){let q;if((0,g.isFunction)(M)){let A=(0,O.getRandomElement)(U.connections.filter(M));q=A?Promise.resolve(A):c.Event.toPromise(c.Event.filter(U.onDidAddConnection,M))}else q=M.routeCall(U,K,B);const k=q.then(A=>A.channelClient.getChannel(D));return V(k).call(K,B,J)},listen(K,B){if((0,g.isFunction)(M))return U.getMulticastEvent(D,M,K,B);const J=M.routeEvent(U,K,B).then(q=>q.channelClient.getChannel(D));return V(J).listen(K,B)}}}getMulticastEvent(D,M,U,K){const B=this;let J=new d.DisposableStore;const q=new c.Emitter({onFirstListenerAdd:()=>{J=new d.DisposableStore;const k=new c.EventMultiplexer,A=new Map,j=X=>{const se=X.channelClient.getChannel(D).listen(U,K),re=k.add(se);A.set(X,re)},W=X=>{const Q=A.get(X);!Q||(Q.dispose(),A.delete(X))};B.connections.filter(M).forEach(j),c.Event.filter(B.onDidAddConnection,M)(j,void 0,J),B.onDidRemoveConnection(W,void 0,J),k.event(q.fire,q,J),J.add(k)},onLastListenerRemove:()=>{J.dispose()}});return q.event}registerChannel(D,M){this.channels.set(D,M),this._connections.forEach(U=>{U.channelServer.registerChannel(D,M)})}dispose(){this.channels.clear(),this._connections.clear(),this._onDidAddConnection.dispose(),this._onDidRemoveConnection.dispose()}}t.IPCServer=C;class N{constructor(D,M,U=null){const K=new h;a(K,M),D.send(K.buffer),this.channelClient=new p(D,U),this.channelServer=new S(D,M,U)}getChannel(D){return this.channelClient.getChannel(D)}registerChannel(D,M){this.channelServer.registerChannel(D,M)}dispose(){this.channelClient.dispose(),this.channelServer.dispose()}}t.IPCClient=N;function V(z){return{call(D,M,U){return z.then(K=>K.call(D,M,U))},listen(D,M){const U=new c.Relay;return z.then(K=>U.input=K.listen(D,M)),U.event}}}t.getDelayedChannel=V;function Y(z){let D=!1;return{call(M,U,K){return D?z.call(M,U,K):(0,b.timeout)(0).then(()=>D=!0).then(()=>z.call(M,U,K))},listen(M,U){if(D)return z.listen(M,U);const K=new c.Relay;return(0,b.timeout)(0).then(()=>D=!0).then(()=>K.input=z.listen(M,U)),K.event}}}t.getNextTickChannel=Y;class ie{constructor(D){this.fn=D}routeCall(D){return this.route(D)}routeEvent(D){return this.route(D)}async route(D){for(const M of D.connections)if(await Promise.resolve(this.fn(M.ctx)))return Promise.resolve(M);return await c.Event.toPromise(D.onDidAddConnection),await this.route(D)}}t.StaticRouter=ie;var oe;(function(z){function D(B,J){const q=B,k=J&&J.disableMarshalling,A=new Map;for(const j in q)U(j)&&A.set(j,c.Event.buffer(q[j],!0));return new class{listen(j,W,X){const Q=A.get(W);if(Q)return Q;if(K(W)){const se=q[W];if(typeof se=="function")return se.call(q,X)}throw new Error(`Event not found: ${W}`)}call(j,W,X){const Q=q[W];if(typeof Q=="function"){if(!k&&Array.isArray(X))for(let se=0;se<X.length;se++)X[se]=(0,v.revive)(X[se]);return Q.apply(q,X)}throw new Error(`Method not found: ${W}`)}}}z.fromService=D;function M(B,J){const q=J&&J.disableMarshalling;return new Proxy({},{get(k,A){if(typeof A=="string")return J?.properties?.has(A)?J.properties.get(A):K(A)?function(j){return B.listen(A,j)}:U(A)?B.listen(A):async function(...j){let W;J&&!(0,g.isUndefinedOrNull)(J.context)?W=[J.context,...j]:W=j;const X=await B.call(A,W);return q?X:(0,v.revive)(X)};throw new Error(`Property not found: ${String(A)}`)}})}z.toService=M;function U(B){return B[0]==="o"&&B[1]==="n"&&P.isUpperAsciiLetter(B.charCodeAt(2))}function K(B){return/^onScoped/.test(B)&&P.isUpperAsciiLetter(B.charCodeAt(8))}})(oe=t.ProxyChannel||(t.ProxyChannel={}));const ee=[["#2977B1","#FC802D","#34A13A","#D3282F","#9366BA"],["#8B564C","#E177C0","#7F7F7F","#BBBE3D","#2EBECD"]];function ue(z){if(Array.isArray(z))return z;if(z&&typeof z=="object"&&typeof z.toString=="function"){let D=z.toString();if(D!=="[object Object]")return D}return z}function ce(z){return Array.isArray(z)?z.map(ue):ue(z)}function G(z,D,M,U,K,B,J){J=ce(J);const q=ee[K],k=q[U%q.length];let A=[`%c[${z}]%c[${String(D).padStart(7," ")}]%c[len: ${String(M).padStart(5," ")}]%c${String(U).padStart(5," ")} - ${B}`,"color: darkgreen","color: grey","color: grey",`color: ${k}`];/\($/.test(B)?(A=A.concat(J),A.push(")")):A.push(J),console.log.apply(console,A)}t.logWithColors=G;class ne{constructor(D,M){this._outgoingPrefix=D,this._incomingPrefix=M,this._totalIncoming=0,this._totalOutgoing=0}logOutgoing(D,M,U,K,B){this._totalOutgoing+=D,G(this._outgoingPrefix,this._totalOutgoing,D,M,U,K,B)}logIncoming(D,M,U,K,B){this._totalIncoming+=D,G(this._incomingPrefix,this._totalIncoming,D,M,U,K,B)}}t.IPCLogger=ne}),define(Z[66],te([0,1,3,13,2,11]),function($,t,O,b,w,R){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.InMemoryStorageDatabase=t.Storage=t.isStorageItemsChangeEvent=t.StorageHint=void 0;var L;(function(P){P[P.STORAGE_DOES_NOT_EXIST=0]="STORAGE_DOES_NOT_EXIST"})(L=t.StorageHint||(t.StorageHint={}));function T(P){const g=P;return g?.changed instanceof Map||g?.deleted instanceof Set}t.isStorageItemsChangeEvent=T;var c;(function(P){P[P.None=0]="None",P[P.Initialized=1]="Initialized",P[P.Closed=2]="Closed"})(c||(c={}));class d extends w.Disposable{constructor(g,I=Object.create(null)){super();this.database=g,this.options=I,this._onDidChangeStorage=this._register(new b.Emitter),this.onDidChangeStorage=this._onDidChangeStorage.event,this.state=c.None,this.cache=new Map,this.flushDelayer=new O.ThrottledDelayer(d.DEFAULT_FLUSH_DELAY),this.pendingDeletes=new Set,this.pendingInserts=new Map,this.pendingClose=void 0,this.whenFlushedCallbacks=[],this.registerListeners()}registerListeners(){this._register(this.database.onDidChangeItemsExternal(g=>this.onDidChangeItemsExternal(g)))}onDidChangeItemsExternal(g){g.changed?.forEach((I,u)=>this.accept(u,I)),g.deleted?.forEach(I=>this.accept(I,void 0))}accept(g,I){if(this.state===c.Closed)return;let u=!1;(0,R.isUndefinedOrNull)(I)?u=this.cache.delete(g):this.cache.get(g)!==I&&(this.cache.set(g,I),u=!0),u&&this._onDidChangeStorage.fire(g)}get items(){return this.cache}get size(){return this.cache.size}async init(){this.state===c.None&&(this.state=c.Initialized,this.options.hint!==L.STORAGE_DOES_NOT_EXIST&&(this.cache=await this.database.getItems()))}get(g,I){const u=this.cache.get(g);return(0,R.isUndefinedOrNull)(u)?I:u}getBoolean(g,I){const u=this.get(g);return(0,R.isUndefinedOrNull)(u)?I:u==="true"}getNumber(g,I){const u=this.get(g);return(0,R.isUndefinedOrNull)(u)?I:parseInt(u,10)}async set(g,I){if(this.state===c.Closed)return;if((0,R.isUndefinedOrNull)(I))return this.delete(g);const u=String(I);if(this.cache.get(g)!==u)return this.cache.set(g,u),this.pendingInserts.set(g,u),this.pendingDeletes.delete(g),this._onDidChangeStorage.fire(g),this.flushDelayer.trigger(()=>this.flushPending())}async delete(g){if(!(this.state===c.Closed||!this.cache.delete(g)))return this.pendingDeletes.has(g)||this.pendingDeletes.add(g),this.pendingInserts.delete(g),this._onDidChangeStorage.fire(g),this.flushDelayer.trigger(()=>this.flushPending())}async close(){return this.pendingClose||(this.pendingClose=this.doClose()),this.pendingClose}async doClose(){this.state=c.Closed;try{await this.flushDelayer.trigger(()=>this.flushPending(),0)}catch(g){}await this.database.close(()=>this.cache)}get hasPending(){return this.pendingInserts.size>0||this.pendingDeletes.size>0}async flushPending(){if(!this.hasPending)return;const g={insert:this.pendingInserts,delete:this.pendingDeletes};return this.pendingDeletes=new Set,this.pendingInserts=new Map,this.database.updateItems(g).finally(()=>{if(!this.hasPending)for(;this.whenFlushedCallbacks.length;)this.whenFlushedCallbacks.pop()?.()})}async whenFlushed(){if(!!this.hasPending)return new Promise(g=>this.whenFlushedCallbacks.push(g))}dispose(){this.flushDelayer.dispose(),super.dispose()}}t.Storage=d,d.DEFAULT_FLUSH_DELAY=100;class v{constructor(){this.onDidChangeItemsExternal=b.Event.None,this.items=new Map}async getItems(){return this.items}async updateItems(g){g.insert&&g.insert.forEach((I,u)=>this.items.set(u,I)),g.delete&&g.delete.forEach(I=>this.items.delete(I))}async close(){}}t.InMemoryStorageDatabase=v}),define(Z[67],te([5,6]),function($,t){return $.create("vs/base/common/date",t)}),define(Z[68],te([0,1,67]),function($,t,O){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.toLocalISOString=t.fromNow=void 0;const b=60,w=b*60,R=w*24,L=R*7,T=R*30,c=R*365;function d(P,g){typeof P!="number"&&(P=P.getTime());const I=Math.round((new Date().getTime()-P)/1e3);if(I<-30)return(0,O.localize)(0,null,d(new Date().getTime()+I*1e3,!1));if(I<30)return(0,O.localize)(1,null);let u;return I<b?(u=I,g?u===1?(0,O.localize)(2,null,u):(0,O.localize)(3,null,u):u===1?(0,O.localize)(4,null,u):(0,O.localize)(5,null,u)):I<w?(u=Math.floor(I/b),g?u===1?(0,O.localize)(6,null,u):(0,O.localize)(7,null,u):u===1?(0,O.localize)(8,null,u):(0,O.localize)(9,null,u)):I<R?(u=Math.floor(I/w),g?u===1?(0,O.localize)(10,null,u):(0,O.localize)(11,null,u):u===1?(0,O.localize)(12,null,u):(0,O.localize)(13,null,u)):I<L?(u=Math.floor(I/R),g?u===1?(0,O.localize)(14,null,u):(0,O.localize)(15,null,u):u===1?(0,O.localize)(16,null,u):(0,O.localize)(17,null,u)):I<T?(u=Math.floor(I/L),g?u===1?(0,O.localize)(18,null,u):(0,O.localize)(19,null,u):u===1?(0,O.localize)(20,null,u):(0,O.localize)(21,null,u)):I<c?(u=Math.floor(I/T),g?u===1?(0,O.localize)(22,null,u):(0,O.localize)(23,null,u):u===1?(0,O.localize)(24,null,u):(0,O.localize)(25,null,u)):(u=Math.floor(I/c),g?u===1?(0,O.localize)(26,null,u):(0,O.localize)(27,null,u):u===1?(0,O.localize)(28,null,u):(0,O.localize)(29,null,u))}t.fromNow=d;function v(P){return P.getFullYear()+"-"+String(P.getMonth()+1).padStart(2,"0")+"-"+String(P.getDate()).padStart(2,"0")+"T"+String(P.getHours()).padStart(2,"0")+":"+String(P.getMinutes()).padStart(2,"0")+":"+String(P.getSeconds()).padStart(2,"0")+"."+(P.getMilliseconds()/1e3).toFixed(3).slice(2,5)+"Z"}t.toLocalISOString=v}),define(Z[69],te([5,6]),function($,t){return $.create("vs/base/common/errorMessage",t)}),define(Z[30],te([0,1,20,11,69]),function($,t,O,b,w){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.toErrorMessage=void 0;function R(d,v){return v&&(d.stack||d.stacktrace)?w.localize(0,null,T(d),L(d.stack)||L(d.stacktrace)):T(d)}function L(d){return Array.isArray(d)?d.join(`
`):d}function T(d){return typeof d.code=="string"&&typeof d.errno=="number"&&typeof d.syscall=="string"?w.localize(1,null,d.message):d.message||w.localize(2,null)}function c(d=null,v=!1){if(!d)return w.localize(3,null);if(Array.isArray(d)){const P=O.coalesce(d),g=c(P[0],v);return P.length>1?w.localize(4,null,g,P.length):g}if(b.isString(d))return d;if(d.detail){const P=d.detail;if(P.error)return R(P.error,v);if(P.exception)return R(P.exception,v)}return d.stack?R(d,v):d.message?d.message:w.localize(5,null)}t.toErrorMessage=c}),define(Z[70],te([5,6]),function($,t){return $.create("vs/base/node/processes",t)}),define(Z[49],te([0,1,35,38,8,18,4,10,28,11,47,12,70]),function($,t,O,b,w,R,L,T,c,d,v,P,g){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.win32=t.createQueuedSender=t.LineProcess=t.AbstractProcess=t.getWindowsShell=t.TerminateResponseCode=t.Source=void 0;function I(o){switch(o){case 0:return 0;case 1:return 2;case 128:return 3;default:return 1}}function u(o,s){if(T.isWindows)try{const e={stdio:["pipe","pipe","ignore"]};s&&(e.cwd=s);const i=O.execFile("taskkill",["/T","/F","/PID",o.pid.toString()],e);return new Promise(n=>{i.once("error",r=>{n({success:!1,error:r})}),i.once("exit",(r,a)=>{n(r===0?{success:!0}:{success:!1,code:r!==null?r:1})})})}catch(e){return Promise.resolve({success:!1,error:e,code:e.status?I(e.status):1})}else if(T.isLinux||T.isMacintosh)try{const e=w.FileAccess.asFileUri("vs/base/node/terminateProcess.sh",$).fsPath;return new Promise(i=>{O.execFile(e,[o.pid.toString()],{encoding:"utf8",shell:!0},(n,r,a)=>{i(n?{success:!1,error:n}:{success:!0})})})}catch(e){return Promise.resolve({success:!1,error:e})}else o.kill("SIGKILL");return Promise.resolve({success:!0})}function l(o=c.env){return o.comspec||"cmd.exe"}t.getWindowsShell=l;class y{constructor(s,e,i,n){if(e!==void 0&&i!==void 0&&n!==void 0)this.cmd=s,this.args=e,this.shell=i,this.options=n;else{const r=s;this.cmd=r.command,this.shell=r.isShellCommand,this.args=r.args.slice(0),this.options=r.options||{}}if(this.childProcess=null,this.childProcessPromise=null,this.terminateRequested=!1,this.options.env){const r=Object.create(null);Object.keys(c.env).forEach(a=>{r[a]=c.env[a]}),Object.keys(this.options.env).forEach(a=>{r[a]=this.options.env[a]}),this.options.env=r}}getSanitizedCommand(){let s=this.cmd.toLowerCase();const e=s.lastIndexOf(L.sep);return e!==-1&&(s=s.substring(e+1)),y.WellKnowCommands[s]?s:"other"}start(s){return T.isWindows&&(this.options&&this.options.cwd&&b.isUNC(this.options.cwd)||!this.options&&b.isUNC(c.cwd()))?Promise.reject(new Error(g.localize(0,null))):this.useExec().then(e=>{let i,n;const r=new Promise((a,m)=>{i=a,n=m});if(e){let a=this.cmd;this.args&&(a=a+" "+this.args.join(" ")),this.childProcess=O.exec(a,this.options,(m,S,F)=>{this.childProcess=null;const p=m;p&&p.killed?n({killed:this.terminateRequested,stdout:S.toString(),stderr:F.toString()}):this.handleExec(i,s,m,S,F)})}else{let a=null;const m=S=>{this.childProcess=null,this.childProcessPromise=null,this.handleClose(S,i,s,n);const F={terminated:this.terminateRequested};d.isNumber(S)&&(F.cmdCode=S),i(F)};if(this.shell&&T.isWindows){const S=R.deepClone(this.options);S.windowsVerbatimArguments=!0,S.detached=!1;let F=!1,p=!1;const C=[];let N=this.ensureQuotes(this.cmd);C.push(N.value),F=N.quoted,this.args&&this.args.forEach(Y=>{N=this.ensureQuotes(Y),C.push(N.value),p=p&&N.quoted});const V=["/s","/c"];F?p?V.push('"'+C.join(" ")+'"'):C.length>1?V.push('"'+C[0]+'" '+C.slice(1).join(" ")):V.push('"'+C[0]+'"'):V.push(C.join(" ")),a=O.spawn(l(),V,S)}else this.cmd&&(a=O.spawn(this.cmd,this.args,this.options));a&&(this.childProcess=a,this.childProcessPromise=Promise.resolve(a),this.pidResolve&&(this.pidResolve(d.isNumber(a.pid)?a.pid:-1),this.pidResolve=void 0),a.on("error",S=>{this.childProcess=null,n({terminated:this.terminateRequested,error:S})}),a.pid&&(this.childProcess.on("close",m),this.handleSpawn(a,i,s,n,!0)))}return r})}handleClose(s,e,i,n){}ensureQuotes(s){return y.regexp.test(s)?{value:'"'+s+'"',quoted:!0}:{value:s,quoted:s.length>0&&s[0]==='"'&&s[s.length-1]==='"'}}get pid(){return this.childProcessPromise?this.childProcessPromise.then(s=>s.pid,s=>-1):new Promise(s=>{this.pidResolve=s})}terminate(){return this.childProcessPromise?this.childProcessPromise.then(s=>(this.terminateRequested=!0,u(s,this.options.cwd).then(e=>(e.success&&(this.childProcess=null),e))),s=>({success:!0})):Promise.resolve({success:!0})}useExec(){return new Promise(s=>{if(!this.shell||!T.isWindows)return s(!1);const e=O.spawn(l(),["/s","/c"]);e.on("error",i=>s(!0)),e.on("exit",i=>s(!1))})}}t.AbstractProcess=y,y.WellKnowCommands={ant:!0,cmake:!0,eslint:!0,gradle:!0,grunt:!0,gulp:!0,jake:!0,jenkins:!0,jshint:!0,make:!0,maven:!0,msbuild:!0,msc:!0,nmake:!0,npm:!0,rake:!0,tsc:!0,xbuild:!0},y.regexp=/^[^"].* .*[^"]/;class E extends y{constructor(s,e,i,n){super(s,e,i,n);this.stdoutLineDecoder=null,this.stderrLineDecoder=null}handleExec(s,e,i,n,r){[n,r].forEach((a,m)=>{const S=new v.LineDecoder;S.write(a).forEach(C=>{e({line:C,source:m===0?0:1})});const p=S.end();p&&e({line:p,source:m===0?0:1})}),s({terminated:this.terminateRequested,error:i})}handleSpawn(s,e,i,n,r){const a=new v.LineDecoder,m=new v.LineDecoder;s.stdout.on("data",S=>{a.write(S).forEach(p=>i({line:p,source:0}))}),s.stderr.on("data",S=>{m.write(S).forEach(p=>i({line:p,source:1}))}),this.stdoutLineDecoder=a,this.stderrLineDecoder=m}handleClose(s,e,i,n){const r=this.stdoutLineDecoder?this.stdoutLineDecoder.end():null;r&&i({line:r,source:0});const a=this.stderrLineDecoder?this.stderrLineDecoder.end():null;a&&i({line:a,source:1})}}t.LineProcess=E;function f(o){let s=[],e=!1;const i=function(n){if(e){s.push(n);return}(!o.send(n,a=>{if(a&&console.error(a),e=!1,s.length>0){const m=s.slice(0);s=[],m.forEach(S=>i(S))}})||T.isWindows)&&(e=!0)};return{send:i}}t.createQueuedSender=f;var h;(function(o){async function s(e,i,n){if(L.isAbsolute(e))return e;if(i===void 0&&(i=c.cwd()),L.dirname(e)!=="."||(n===void 0&&d.isString(c.env.PATH)&&(n=c.env.PATH.split(L.delimiter)),n===void 0||n.length===0))return L.join(i,e);async function a(m){if(await P.Promises.exists(m)){let S;try{S=await P.Promises.stat(m)}catch(F){F.message.startsWith("EACCES")&&(S=await P.Promises.lstat(m))}return S?!S.isDirectory():!1}return!1}for(let m of n){let S;if(L.isAbsolute(m)?S=L.join(m,e):S=L.join(i,m,e),await a(S))return S;let F=S+".com";if(await a(F)||(F=S+".exe",await a(F)))return F}return L.join(i,e)}o.findExecutable=s})(h=t.win32||(t.win32={}))}),define(Z[71],te([0,1,34,10,65,49]),function($,t,O,b,w,R){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.getSystemShellSync=t.getSystemShell=void 0;async function L(I,u){return I===1?b.isWindows?P():R.getWindowsShell(u):d(I,u)}t.getSystemShell=L;function T(I,u){return I===1?b.isWindows?g(u):R.getWindowsShell(u):d(I,u)}t.getSystemShellSync=T;let c=null;function d(I,u){if(b.isLinux&&I===2||b.isMacintosh&&I===3)return"/bin/bash";if(!c){let l;if(b.isWindows)l="/bin/bash";else{if(l=u.SHELL,!l)try{l=(0,O.userInfo)().shell}catch(y){}l||(l="sh"),l==="/bin/false"&&(l="/bin/bash")}c=l}return c}let v=null;async function P(){return v||(v=(await(0,w.getFirstAvailablePowerShellInstallation)()).exePath),v}function g(I){if(v)return v;const u=b.isWindows&&parseFloat((0,O.release)())>=10,l=I.hasOwnProperty("PROCESSOR_ARCHITEW6432"),y=`${I.windir}\\${l?"Sysnative":"System32"}\\WindowsPowerShell\\v1.0\\powershell.exe`;return u?y:R.getWindowsShell(I)}}),define(Z[50],te([0,1,35,3,17,25,60,9,13,2,18,10,49,39]),function($,t,O,b,w,R,L,T,c,d,v,P,g,I){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.Client=t.Server=void 0;class u extends I.ChannelServer{constructor(E){super({send:f=>{try{process.send&&process.send(f.buffer.toString("base64"))}catch(h){}},onMessage:c.Event.fromNodeEventEmitter(process,"message",f=>w.VSBuffer.wrap(Buffer.from(f,"base64")))},E);process.once("disconnect",()=>this.dispose())}}t.Server=u;class l{constructor(E,f){this.modulePath=E,this.options=f,this.activeRequests=new Set,this.channels=new Map,this._onDidProcessExit=new c.Emitter,this.onDidProcessExit=this._onDidProcessExit.event;const h=f&&f.timeout?f.timeout:6e4;this.disposeDelayer=new b.Delayer(h),this.child=null,this._client=null}getChannel(E){const f=this;return{call(h,o,s){return f.requestPromise(E,h,o,s)},listen(h,o){return f.requestEvent(E,h,o)}}}requestPromise(E,f,h,o=R.CancellationToken.None){if(!this.disposeDelayer)return Promise.reject(new Error("disposed"));if(o.isCancellationRequested)return Promise.reject(T.canceled());this.disposeDelayer.cancel();const s=this.getCachedChannel(E),e=(0,b.createCancelablePromise)(r=>s.call(f,h,r)),i=o.onCancellationRequested(()=>e.cancel()),n=(0,d.toDisposable)(()=>e.cancel());return this.activeRequests.add(n),e.finally(()=>{i.dispose(),this.activeRequests.delete(n),this.activeRequests.size===0&&this.disposeDelayer&&this.disposeDelayer.trigger(()=>this.disposeClient())}),e}requestEvent(E,f,h){if(!this.disposeDelayer)return c.Event.None;this.disposeDelayer.cancel();let o;const s=new c.Emitter({onFirstListenerAdd:()=>{o=this.getCachedChannel(E).listen(f,h)(s.fire,s),this.activeRequests.add(o)},onLastListenerRemove:()=>{this.activeRequests.delete(o),o.dispose(),this.activeRequests.size===0&&this.disposeDelayer&&this.disposeDelayer.trigger(()=>this.disposeClient())}});return s.event}get client(){if(!this._client){const E=this.options&&this.options.args?this.options.args:[],f=Object.create(null);f.env={...(0,v.deepClone)(process.env),VSCODE_PARENT_PID:String(process.pid)},this.options&&this.options.env&&(f.env={...f.env,...this.options.env}),this.options&&this.options.freshExecArgv&&(f.execArgv=[]),this.options&&typeof this.options.debug=="number"&&(f.execArgv=["--nolazy","--inspect="+this.options.debug]),this.options&&typeof this.options.debugBrk=="number"&&(f.execArgv=["--nolazy","--inspect-brk="+this.options.debugBrk]),f.execArgv===void 0&&(f.execArgv=process.execArgv.filter(a=>!/^--inspect(-brk)?=/.test(a))),P.isMacintosh&&f.env&&delete f.env.DYLD_LIBRARY_PATH,this.child=(0,O.fork)(this.modulePath,E,f);const h=new c.Emitter;c.Event.fromNodeEventEmitter(this.child,"message",a=>a)(a=>{if((0,L.isRemoteConsoleLog)(a)){(0,L.log)(a,`IPC Library: ${this.options.serverName}`);return}h.fire(w.VSBuffer.wrap(Buffer.from(a,"base64")))});const s=this.options.useQueue?(0,g.createQueuedSender)(this.child):this.child,e=a=>this.child&&this.child.connected&&s.send(a.buffer.toString("base64")),i=h.event,n={send:e,onMessage:i};this._client=new I.ChannelClient(n);const r=()=>this.disposeClient();process.once("exit",r),this.child.on("error",a=>console.warn('IPC "'+this.options.serverName+'" errored with '+a)),this.child.on("exit",(a,m)=>{process.removeListener("exit",r),this.activeRequests.forEach(S=>(0,d.dispose)(S)),this.activeRequests.clear(),a!==0&&m!=="SIGTERM"&&console.warn('IPC "'+this.options.serverName+'" crashed with exit code '+a+" and signal "+m),this.disposeDelayer&&this.disposeDelayer.cancel(),this.disposeClient(),this._onDidProcessExit.fire({code:a,signal:m})})}return this._client}getCachedChannel(E){let f=this.channels.get(E);return f||(f=this.client.getChannel(E),this.channels.set(E,f)),f}disposeClient(){this._client&&(this.child&&(this.child.kill(),this.child=null),this._client=null,this.channels.clear())}dispose(){this._onDidProcessExit.dispose(),this.disposeDelayer&&(this.disposeDelayer.cancel(),this.disposeDelayer=void 0),this.disposeClient(),this.activeRequests.clear()}}t.Client=l}),define(Z[72],te([5,6]),function($,t){return $.create("vs/base/node/zip",t)}),define(Z[73],te([5,6]),function($,t){return $.create("vs/platform/configuration/common/configurationRegistry",t)}),define(Z[74],te([5,6]),function($,t){return $.create("vs/platform/extensionManagement/common/abstractExtensionManagementService",t)}),define(Z[75],te([5,6]),function($,t){return $.create("vs/platform/extensionManagement/common/extensionManagement",t)}),define(Z[76],te([5,6]),function($,t){return $.create("vs/platform/extensionManagement/common/extensionManagementCLIService",t)}),define(Z[77],te([5,6]),function($,t){return $.create("vs/platform/extensionManagement/node/extensionManagementService",t)}),define(Z[78],te([5,6]),function($,t){return $.create("vs/platform/extensionManagement/node/extensionManagementUtil",t)}),define(Z[79],te([5,6]),function($,t){return $.create("vs/platform/extensionManagement/node/extensionsScanner",t)}),define(Z[80],te([5,6]),function($,t){return $.create("vs/platform/extensions/common/extensionValidator",t)}),define(Z[81],te([5,6]),function($,t){return $.create("vs/platform/files/common/fileService",t)}),define(Z[82],te([5,6]),function($,t){return $.create("vs/platform/files/common/io",t)}),define(Z[83],te([5,6]),function($,t){return $.create("vs/platform/files/node/diskFileSystemProvider",t)}),define(Z[84],te([5,6]),function($,t){return $.create("vs/platform/request/common/request",t)}),define(Z[85],te([5,6]),function($,t){return $.create("vs/platform/telemetry/common/telemetryService",t)}),define(Z[86],te([0,1,68,45,8,4,28,19,7]),function($,t,O,b,w,R,L,T,c){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.parsePtyHostPort=t.parseSearchPort=t.parseExtensionHostPort=t.AbstractNativeEnvironmentService=void 0;class d{constructor(l,y,E){this._args=l,this.paths=y,this.productService=E}get appRoot(){return(0,R.dirname)(w.FileAccess.asFileUri("",$).fsPath)}get userHome(){return c.URI.file(this.paths.homeDir)}get userDataPath(){return this.paths.userDataDir}get appSettingsHome(){return c.URI.file((0,R.join)(this.userDataPath,"User"))}get tmpDir(){return c.URI.file(this.paths.tmpDir)}get userRoamingDataHome(){return this.appSettingsHome}get settingsResource(){return(0,T.joinPath)(this.userRoamingDataHome,"settings.json")}get userDataSyncHome(){return(0,T.joinPath)(this.userRoamingDataHome,"sync")}get logsPath(){if(!this.args.logsPath){const l=(0,O.toLocalISOString)(new Date).replace(/-|:|\.\d+Z$/g,"");this.args.logsPath=(0,R.join)(this.userDataPath,"logs",l)}return this.args.logsPath}get userDataSyncLogResource(){return c.URI.file((0,R.join)(this.logsPath,"userDataSync.log"))}get sync(){return this.args.sync}get machineSettingsResource(){return(0,T.joinPath)(c.URI.file((0,R.join)(this.userDataPath,"Machine")),"settings.json")}get globalStorageHome(){return c.URI.joinPath(this.appSettingsHome,"globalStorage")}get workspaceStorageHome(){return c.URI.joinPath(this.appSettingsHome,"workspaceStorage")}get keybindingsResource(){return(0,T.joinPath)(this.userRoamingDataHome,"keybindings.json")}get keyboardLayoutResource(){return(0,T.joinPath)(this.userRoamingDataHome,"keyboardLayout.json")}get argvResource(){const l=L.env.VSCODE_PORTABLE;return l?c.URI.file((0,R.join)(l,"argv.json")):(0,T.joinPath)(this.userHome,this.productService.dataFolderName,"argv.json")}get snippetsHome(){return(0,T.joinPath)(this.userRoamingDataHome,"snippets")}get isExtensionDevelopment(){return!!this.args.extensionDevelopmentPath}get untitledWorkspacesHome(){return c.URI.file((0,R.join)(this.userDataPath,"Workspaces"))}get installSourcePath(){return(0,R.join)(this.userDataPath,"installSource")}get builtinExtensionsPath(){const l=this.args["builtin-extensions-dir"];return l?(0,R.resolve)(l):(0,R.normalize)((0,R.join)(w.FileAccess.asFileUri("",$).fsPath,"..","extensions"))}get extensionsDownloadPath(){const l=this.args["extensions-download-dir"];return l?(0,R.resolve)(l):(0,R.join)(this.userDataPath,"CachedExtensionVSIXs")}get extensionsPath(){const l=this.args["extensions-dir"];if(l)return(0,R.resolve)(l);const y=L.env.VSCODE_EXTENSIONS;if(y)return y;const E=L.env.VSCODE_PORTABLE;return E?(0,R.join)(E,"extensions"):(0,T.joinPath)(this.userHome,this.productService.dataFolderName,"extensions").fsPath}get extensionDevelopmentLocationURI(){const l=this.args.extensionDevelopmentPath;if(Array.isArray(l))return l.map(y=>/^[^:/?#]+?:\/\//.test(y)?c.URI.parse(y):c.URI.file((0,R.normalize)(y)))}get extensionDevelopmentKind(){return this.args.extensionDevelopmentKind?.map(l=>l==="ui"||l==="workspace"||l==="web"?l:"workspace")}get extensionTestsLocationURI(){const l=this.args.extensionTestsPath;if(l)return/^[^:/?#]+?:\/\//.test(l)?c.URI.parse(l):c.URI.file((0,R.normalize)(l))}get disableExtensions(){if(this.args["disable-extensions"])return!0;const l=this.args["disable-extension"];if(l){if(typeof l=="string")return[l];if(Array.isArray(l)&&l.length>0)return l}return!1}get debugExtensionHost(){return v(this.args,this.isBuilt)}get debugRenderer(){return!!this.args.debugRenderer}get isBuilt(){return!L.env.VSCODE_DEV}get verbose(){return!!this.args.verbose}get logLevel(){return this.args.log}get serviceMachineIdResource(){return(0,T.joinPath)(c.URI.file(this.userDataPath),"machineid")}get crashReporterId(){return this.args["crash-reporter-id"]}get crashReporterDirectory(){return this.args["crash-reporter-directory"]}get driverHandle(){return this.args.driver}get telemetryLogResource(){return c.URI.file((0,R.join)(this.logsPath,"telemetry.log"))}get disableTelemetry(){return!!this.args["disable-telemetry"]}get disableWorkspaceTrust(){return!!this.args["disable-workspace-trust"]}get args(){return this._args}}de([b.memoize],d.prototype,"appRoot",null),de([b.memoize],d.prototype,"userHome",null),de([b.memoize],d.prototype,"userDataPath",null),de([b.memoize],d.prototype,"appSettingsHome",null),de([b.memoize],d.prototype,"tmpDir",null),de([b.memoize],d.prototype,"userRoamingDataHome",null),de([b.memoize],d.prototype,"settingsResource",null),de([b.memoize],d.prototype,"userDataSyncHome",null),de([b.memoize],d.prototype,"userDataSyncLogResource",null),de([b.memoize],d.prototype,"sync",null),de([b.memoize],d.prototype,"machineSettingsResource",null),de([b.memoize],d.prototype,"globalStorageHome",null),de([b.memoize],d.prototype,"workspaceStorageHome",null),de([b.memoize],d.prototype,"keybindingsResource",null),de([b.memoize],d.prototype,"keyboardLayoutResource",null),de([b.memoize],d.prototype,"argvResource",null),de([b.memoize],d.prototype,"snippetsHome",null),de([b.memoize],d.prototype,"isExtensionDevelopment",null),de([b.memoize],d.prototype,"untitledWorkspacesHome",null),de([b.memoize],d.prototype,"installSourcePath",null),de([b.memoize],d.prototype,"builtinExtensionsPath",null),de([b.memoize],d.prototype,"extensionsPath",null),de([b.memoize],d.prototype,"extensionDevelopmentLocationURI",null),de([b.memoize],d.prototype,"extensionDevelopmentKind",null),de([b.memoize],d.prototype,"extensionTestsLocationURI",null),de([b.memoize],d.prototype,"debugExtensionHost",null),de([b.memoize],d.prototype,"serviceMachineIdResource",null),de([b.memoize],d.prototype,"telemetryLogResource",null),de([b.memoize],d.prototype,"disableWorkspaceTrust",null),t.AbstractNativeEnvironmentService=d;function v(u,l){return I(u["inspect-extensions"],u["inspect-brk-extensions"],5870,l,u.debugId)}t.parseExtensionHostPort=v;function P(u,l){return I(u["inspect-search"],u["inspect-brk-search"],5876,l)}t.parseSearchPort=P;function g(u,l){return I(u["inspect-ptyhost"],u["inspect-brk-ptyhost"],5877,l)}t.parsePtyHostPort=g;function I(u,l,y,E,f){const o=Number(l||u)||(E?null:y),s=o?Boolean(!!l):!1;return{port:o,break:s,debugId:f}}}),function(){"use strict";function $(t,O,b,w){function R(T){const c=L(T),d=[c];return t.isAbsolute(c)||d.unshift(w),t.resolve(...d)}function L(T){const c=process.env.VSCODE_PORTABLE;if(c)return t.join(c,"user-data");let d=process.env.VSCODE_APPDATA;if(d)return t.join(d,b);const v=T["user-data-dir"];if(v)return v;switch(process.platform){case"win32":if(d=process.env.APPDATA,!d){const P=process.env.USERPROFILE;if(typeof P!="string")throw new Error("Windows: Unexpected undefined %USERPROFILE% environment variable");d=t.join(P,"AppData","Roaming")}break;case"darwin":d=t.join(O.homedir(),"Library","Application Support");break;case"linux":d=process.env.XDG_CONFIG_HOME||t.join(O.homedir(),".config");break;default:throw new Error("Platform not supported")}return t.join(d,b)}return{getUserDataPath:R}}if(typeof define=="function")define(Z[87],te([0,88,34,8,19,28]),function(t,O,b,w,R,L){const T=R.dirname(w.FileAccess.asFileUri("",t)),c=t.__$__nodeRequire(R.joinPath(T,"package.json").fsPath);return $(O,b,c.name,L.cwd())});else if(typeof module=="object"&&typeof module.exports=="object"){const t=require("../../../../../package.json"),O=require("path"),b=require("os");module.exports=$(O,b,t.name,process.env.VSCODE_CWD||process.cwd())}else throw new Error("Unknown context")}(),define(Z[89],te([0,1,34,86,87]),function($,t,O,b,w){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.NativeEnvironmentService=void 0;class R extends b.AbstractNativeEnvironmentService{constructor(T,c){super(T,{homeDir:(0,O.homedir)(),tmpDir:(0,O.tmpdir)(),userDataDir:(0,w.getUserDataPath)(T)},c)}}t.NativeEnvironmentService=R}),define(Z[90],te([0,1,18]),function($,t,O){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.localizeManifest=void 0;const b=/^%([\w\d.-]+)%$/i;function w(R,L){const T=c=>{if(typeof c!="string")return;const d=b.exec(c);if(!d)return;const v=L[d[1]]??c;return typeof v=="string"?v:typeof v.message=="string"?v.message:c};return(0,O.cloneAndChange)(R,T)}t.localizeManifest=w}),define(Z[51],te([0,1,80]),function($,t,O){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.isEngineValid=t.isValidExtensionVersion=t.isValidVersion=t.normalizeVersion=t.parseVersion=t.isValidVersionStr=void 0;const b=/^(\^|>=)?((\d+)|x)\.((\d+)|x)\.((\d+)|x)(\-.*)?$/,w=/^-(\d{4})(\d{2})(\d{2})$/;function R(g){return g=g.trim(),g==="*"||b.test(g)}t.isValidVersionStr=R;function L(g){if(!R(g))return null;if(g=g.trim(),g==="*")return{hasCaret:!1,hasGreaterEquals:!1,majorBase:0,majorMustEqual:!1,minorBase:0,minorMustEqual:!1,patchBase:0,patchMustEqual:!1,preRelease:null};let I=g.match(b);return I?{hasCaret:I[1]==="^",hasGreaterEquals:I[1]===">=",majorBase:I[2]==="x"?0:parseInt(I[2],10),majorMustEqual:I[2]!=="x",minorBase:I[4]==="x"?0:parseInt(I[4],10),minorMustEqual:I[4]!=="x",patchBase:I[6]==="x"?0:parseInt(I[6],10),patchMustEqual:I[6]!=="x",preRelease:I[8]||null}:null}t.parseVersion=L;function T(g){if(!g)return null;let I=g.majorBase,u=g.majorMustEqual,l=g.minorBase,y=g.minorMustEqual,E=g.patchBase,f=g.patchMustEqual;g.hasCaret&&(I===0||(y=!1),f=!1);let h=0;if(g.preRelease){const o=w.exec(g.preRelease);if(o){const[,s,e,i]=o;h=Date.UTC(Number(s),Number(e)-1,Number(i))}}return{majorBase:I,majorMustEqual:u,minorBase:l,minorMustEqual:y,patchBase:E,patchMustEqual:f,isMinimum:g.hasGreaterEquals,notBefore:h}}t.normalizeVersion=T;function c(g,I,u){let l;typeof g=="string"?l=T(L(g)):l=g;let y;I instanceof Date?y=I.getTime():typeof I=="string"&&(y=new Date(I).getTime());let E;if(typeof u=="string"?E=T(L(u)):E=u,!l||!E)return!1;let f=l.majorBase,h=l.minorBase,o=l.patchBase,s=E.majorBase,e=E.minorBase,i=E.patchBase,n=E.notBefore,r=E.majorMustEqual,a=E.minorMustEqual,m=E.patchMustEqual;return E.isMinimum?f>s?!0:f<s?!1:h>e?!0:h<e||y&&y<n?!1:o>=i:(f===1&&s===0&&(!r||!a||!m)&&(s=1,e=0,i=0,r=!0,a=!1,m=!1),f<s?!1:f>s?!r:h<e?!1:h>e?!a:o<i?!1:o>i?!m:!(y&&y<n))}t.isValidVersion=c;function d(g,I,u,l){return u.isBuiltin||typeof u.main=="undefined"?!0:P(g,I,u.engines.vscode,l)}t.isValidExtensionVersion=d;function v(g,I,u){return g==="*"||P(I,u,g)}t.isEngineValid=v;function P(g,I,u,l=[]){let y=T(L(u));if(!y)return l.push(O.localize(0,null,u)),!1;if(y.majorBase===0){if(!y.majorMustEqual||!y.minorMustEqual)return l.push(O.localize(1,null,u)),!1}else if(!y.majorMustEqual)return l.push(O.localize(2,null,u)),!1;return c(g,I,y)?!0:(l.push(O.localize(3,null,g,u)),!1)}}),define(Z[91],te([0,1,2,8,39,50]),function($,t,O,b,w,R){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.FileWatcher=void 0;class L extends O.Disposable{constructor(c,d,v,P){super();this.requests=c,this.onDidFilesChange=d,this.onLogMessage=v,this.verboseLogging=P,this.isDisposed=!1,this.restartCounter=0,this.startWatching()}startWatching(){const c=this._register(new R.Client(b.FileAccess.asFileUri("bootstrap-fork",$).fsPath,{serverName:"File Watcher (nsfw)",args:["--type=watcherService"],env:{VSCODE_AMD_ENTRYPOINT:"vs/platform/files/node/watcher/nsfw/watcherApp",VSCODE_PIPE_LOGGING:"true",VSCODE_VERBOSE_LOGGING:"true"}}));this._register(c.onDidProcessExit(()=>{this.isDisposed||(this.restartCounter<=L.MAX_RESTARTS?(this.error("terminated unexpectedly and is restarted again..."),this.restartCounter++,this.startWatching()):this.error("failed to start after retrying for some time, giving up. Please report this as a bug report!"))})),this.service=w.ProxyChannel.toService((0,w.getNextTickChannel)(c.getChannel("watcher"))),this.service.setVerboseLogging(this.verboseLogging),this._register(this.service.onDidChangeFile(d=>!this.isDisposed&&this.onDidFilesChange(d))),this._register(this.service.onDidLogMessage(d=>this.onLogMessage(d))),this.watch(this.requests)}setVerboseLogging(c){this.verboseLogging=c,this.isDisposed||this.service?.setVerboseLogging(c)}error(c){this.onLogMessage({type:"error",message:`[File Watcher (nsfw)] ${c}`})}watch(c){this.requests=c,this.service?.watch(c)}dispose(){this.isDisposed=!0,super.dispose()}}t.FileWatcher=L,L.MAX_RESTARTS=5}),define(Z[92],te([0,1,2,8,39,50]),function($,t,O,b,w,R){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.FileWatcher=void 0;class L extends O.Disposable{constructor(c,d,v,P,g={}){super();this.folders=c,this.onDidFilesChange=d,this.onLogMessage=v,this.verboseLogging=P,this.watcherOptions=g,this.isDisposed=!1,this.restartCounter=0,this.startWatching()}startWatching(){const c=this._register(new R.Client(b.FileAccess.asFileUri("bootstrap-fork",$).fsPath,{serverName:"File Watcher (chokidar)",args:["--type=watcherService"],env:{VSCODE_AMD_ENTRYPOINT:"vs/platform/files/node/watcher/unix/watcherApp",VSCODE_PIPE_LOGGING:"true",VSCODE_VERBOSE_LOGGING:"true"}}));this._register(c.onDidProcessExit(()=>{this.isDisposed||(this.restartCounter<=L.MAX_RESTARTS?(this.error("terminated unexpectedly and is restarted again..."),this.restartCounter++,this.startWatching()):this.error("failed to start after retrying for some time, giving up. Please report this as a bug report!"))})),this.service=w.ProxyChannel.toService((0,w.getNextTickChannel)(c.getChannel("watcher"))),this.service.init({...this.watcherOptions,verboseLogging:this.verboseLogging}),this._register(this.service.onDidChangeFile(d=>!this.isDisposed&&this.onDidFilesChange(d))),this._register(this.service.onDidLogMessage(d=>this.onLogMessage(d))),this.service.watch(this.folders)}error(c){this.onLogMessage({type:"error",message:`[File Watcher (chokidar)] ${c}`})}setVerboseLogging(c){this.verboseLogging=c,this.service&&this.service.setVerboseLogging(c)}watch(c){this.folders=c,this.service&&this.service.watch(c)}dispose(){this.isDisposed=!0,super.dispose()}}t.FileWatcher=L,L.MAX_RESTARTS=5}),define(Z[93],te([0,1,35,62,8,47]),function($,t,O,b,w,R){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.OutOfProcessWin32FolderWatcher=void 0;class L{constructor(c,d,v,P,g){this.watchedFolder=c,this.eventCallback=v,this.logCallback=P,this.verboseLogging=g,this.restartCounter=0,Array.isArray(d)?this.ignored=d.map(I=>(0,b.parse)(I)):this.ignored=[],this.verboseLogging&&this.log(`Start watching: ${c}, excludes: ${d.join(",")}`),this.startWatcher()}startWatcher(){const c=[this.watchedFolder];this.verboseLogging&&c.push("-verbose"),this.handle=(0,O.spawn)(w.FileAccess.asFileUri("vs/platform/files/node/watcher/win32/CodeHelper.exe",$).fsPath,c);const d=new R.LineDecoder;this.handle.stdout.on("data",v=>{const P=[];for(const g of d.write(v)){const I=g.split("|");if(I.length===2){const u=Number(I[0]),l=I[1];if(u>=0&&u<3){if(this.ignored&&this.ignored.some(y=>y(l))){this.verboseLogging&&this.log(l);continue}P.push({type:L.changeTypeMap[u],path:l})}else this.log(I[1])}}P.length>0&&this.eventCallback(P)}),this.handle.on("error",v=>this.onError(v)),this.handle.stderr.on("data",v=>this.onError(v)),this.handle.on("exit",(v,P)=>this.onExit(v,P))}onError(c){this.error("process error: "+c.toString())}onExit(c,d){this.handle&&(this.error(`terminated unexpectedly (code: ${c}, signal: ${d})`),this.restartCounter<=L.MAX_RESTARTS?(this.error("is restarted again..."),this.restartCounter++,this.startWatcher()):this.error("Watcher failed to start after retrying for some time, giving up. Please report this as a bug report!"))}error(c){this.logCallback({type:"error",message:`[File Watcher (C#)] ${c}`})}log(c){this.logCallback({type:"trace",message:`[File Watcher (C#)] ${c}`})}dispose(){this.handle&&(this.handle.kill(),this.handle=void 0)}}t.OutOfProcessWin32FolderWatcher=L,L.MAX_RESTARTS=5,L.changeTypeMap=[0,1,2]}),define(Z[94],te([0,1,4,22,93]),function($,t,O,b,w){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.FileWatcher=void 0;class R{constructor(T,c,d,v){this.onDidFilesChange=c,this.onLogMessage=d,this.verboseLogging=v,this.service=void 0,this.folder=T[0],this.folder.path.indexOf("\\\\")===0&&this.folder.path.endsWith(O.posix.sep)&&(this.folder.path=(0,b.rtrim)(this.folder.path,O.posix.sep)),this.service=this.startWatching()}get isDisposed(){return!this.service}startWatching(){return new w.OutOfProcessWin32FolderWatcher(this.folder.path,this.folder.excludes,T=>this.onFileEvents(T),T=>this.onLogMessage(T),this.verboseLogging)}setVerboseLogging(T){this.verboseLogging=T,this.service&&(this.service.dispose(),this.service=this.startWatching())}onFileEvents(T){this.isDisposed||T.length>0&&this.onDidFilesChange(T)}dispose(){this.service&&(this.service.dispose(),this.service=void 0)}}t.FileWatcher=R}),define(Z[52],te([0,1]),function($,t){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.SyncDescriptor=void 0;class O{constructor(w,R=[],L=!1){this.ctor=w,this.staticArguments=R,this.supportsDelayedInstantiation=L}}t.SyncDescriptor=O}),define(Z[95],te([0,1]),function($,t){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.Graph=t.Node=void 0;class O{constructor(R){this.incoming=new Map,this.outgoing=new Map,this.data=R}}t.Node=O;class b{constructor(R){this._hashFn=R,this._nodes=new Map}roots(){const R=[];for(let L of this._nodes.values())L.outgoing.size===0&&R.push(L);return R}insertEdge(R,L){const T=this.lookupOrInsertNode(R),c=this.lookupOrInsertNode(L);T.outgoing.set(this._hashFn(L),c),c.incoming.set(this._hashFn(R),T)}removeNode(R){const L=this._hashFn(R);this._nodes.delete(L);for(let T of this._nodes.values())T.outgoing.delete(L),T.incoming.delete(L)}lookupOrInsertNode(R){const L=this._hashFn(R);let T=this._nodes.get(L);return T||(T=new O(R),this._nodes.set(L,T)),T}lookup(R){return this._nodes.get(this._hashFn(R))}isEmpty(){return this._nodes.size===0}toString(){let R=[];for(let[L,T]of this._nodes)R.push(`${L}, (incoming)[${[...T.incoming.keys()].join(", ")}], (outgoing)[${[...T.outgoing.keys()].join(",")}]`);return R.join(`
`)}findCycleSlow(){for(let[R,L]of this._nodes){const T=new Set([R]),c=this._findCycle(L,T);if(c)return c}}_findCycle(R,L){for(let[T,c]of R.outgoing){if(L.has(T))return[...L,T].join(" -> ");L.add(T);const d=this._findCycle(c,L);if(d)return d;L.delete(T)}}}t.Graph=b}),define(Z[53],te([0,1,15]),function($,t,O){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.IDownloadService=void 0,t.IDownloadService=(0,O.createDecorator)("downloadService")}),define(Z[21],te([0,1,15]),function($,t,O){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.INativeEnvironmentService=t.IEnvironmentService=void 0,t.IEnvironmentService=(0,O.createDecorator)("environmentService"),t.INativeEnvironmentService=(0,O.refineServiceDecorator)(t.IEnvironmentService)}),define(Z[23],te([0,1,8,75,15]),function($,t,O,b,w){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.IExtensionManagementCLIService=t.PreferencesLocalizedLabel=t.PreferencesLabel=t.ExtensionsChannelId=t.ExtensionsLocalizedLabel=t.ExtensionsLabel=t.DefaultIconPath=t.IExtensionTipsService=t.IGlobalExtensionEnablementService=t.ENABLED_EXTENSIONS_STORAGE_PATH=t.DISABLED_EXTENSIONS_STORAGE_PATH=t.IExtensionManagementService=t.ExtensionManagementError=t.INSTALL_ERROR_INCOMPATIBLE=t.INSTALL_ERROR_MALICIOUS=t.INSTALL_ERROR_NOT_SUPPORTED=t.IExtensionGalleryService=t.InstallOperation=t.StatisticType=t.SortOrder=t.SortBy=t.isIExtensionIdentifier=t.getFallbackTargetPlarforms=t.isTargetPlatformCompatible=t.isNotWebExtensionInWebTargetPlatform=t.getTargetPlatform=t.toTargetPlatform=t.TargetPlatformToString=t.TargetPlatform=t.WEB_EXTENSION_TAG=t.EXTENSION_IDENTIFIER_REGEX=t.EXTENSION_IDENTIFIER_PATTERN=void 0,t.EXTENSION_IDENTIFIER_PATTERN="^([a-z0-9A-Z][a-z0-9-A-Z]*)\\.([a-z0-9A-Z][a-z0-9-A-Z]*)$",t.EXTENSION_IDENTIFIER_REGEX=new RegExp(t.EXTENSION_IDENTIFIER_PATTERN),t.WEB_EXTENSION_TAG="__web_extension";var R;(function(f){f.WIN32_X64="win32-x64",f.WIN32_IA32="win32-ia32",f.WIN32_ARM64="win32-arm64",f.LINUX_X64="linux-x64",f.LINUX_ARM64="linux-arm64",f.LINUX_ARMHF="linux-armhf",f.ALPINE_X64="alpine-x64",f.ALPINE_ARM64="alpine-arm64",f.DARWIN_X64="darwin-x64",f.DARWIN_ARM64="darwin-arm64",f.WEB="web",f.UNIVERSAL="universal",f.UNKNOWN="unknown",f.UNDEFINED="undefined"})(R=t.TargetPlatform||(t.TargetPlatform={}));function L(f){switch(f){case"win32-x64":return"Windows 64 bit";case"win32-ia32":return"Windows 32 bit";case"win32-arm64":return"Windows ARM";case"linux-x64":return"Linux 64 bit";case"linux-arm64":return"Linux ARM 64";case"linux-armhf":return"Linux ARM";case"alpine-x64":return"Alpine Linux 64 bit";case"alpine-arm64":return"Alpine ARM 64";case"darwin-x64":return"Mac";case"darwin-arm64":return"Mac Silicon";case"web":return"Web";case"universal":return"universal";case"unknown":return"unknown";case"undefined":return"undefined"}}t.TargetPlatformToString=L;function T(f){switch(f){case"win32-x64":return"win32-x64";case"win32-ia32":return"win32-ia32";case"win32-arm64":return"win32-arm64";case"linux-x64":return"linux-x64";case"linux-arm64":return"linux-arm64";case"linux-armhf":return"linux-armhf";case"alpine-x64":return"alpine-x64";case"alpine-arm64":return"alpine-arm64";case"darwin-x64":return"darwin-x64";case"darwin-arm64":return"darwin-arm64";case"web":return"web";case"universal":return"universal";default:return"unknown"}}t.toTargetPlatform=T;function c(f,h){switch(f){case 3:return h==="x64"?"win32-x64":h==="ia32"?"win32-ia32":h==="arm64"?"win32-arm64":"unknown";case 2:return h==="x64"?"linux-x64":h==="arm64"?"linux-arm64":h==="arm"?"linux-armhf":"unknown";case"alpine":return h==="x64"?"alpine-x64":h==="arm64"?"alpine-arm64":"unknown";case 1:return h==="x64"?"darwin-x64":h==="arm64"?"darwin-arm64":"unknown";case 0:return"web"}}t.getTargetPlatform=c;function d(f,h){return h==="web"&&!f.includes("web")}t.isNotWebExtensionInWebTargetPlatform=d;function v(f,h,o){return d(h,o)?!1:f==="undefined"||f==="universal"?!0:f==="unknown"?!1:f===o?!0:P(o).includes(f)}t.isTargetPlatformCompatible=v;function P(f){switch(f){case"win32-x64":return["win32-ia32"];case"win32-arm64":return["win32-ia32"]}return[]}t.getFallbackTargetPlarforms=P;function g(f){return f&&typeof f=="object"&&typeof f.id=="string"&&(!f.uuid||typeof f.uuid=="string")}t.isIExtensionIdentifier=g;var I;(function(f){f[f.NoneOrRelevance=0]="NoneOrRelevance",f[f.LastUpdatedDate=1]="LastUpdatedDate",f[f.Title=2]="Title",f[f.PublisherName=3]="PublisherName",f[f.InstallCount=4]="InstallCount",f[f.PublishedDate=10]="PublishedDate",f[f.AverageRating=6]="AverageRating",f[f.WeightedRating=12]="WeightedRating"})(I=t.SortBy||(t.SortBy={}));var u;(function(f){f[f.Default=0]="Default",f[f.Ascending=1]="Ascending",f[f.Descending=2]="Descending"})(u=t.SortOrder||(t.SortOrder={}));var l;(function(f){f.Install="install",f.Uninstall="uninstall"})(l=t.StatisticType||(t.StatisticType={}));var y;(function(f){f[f.None=0]="None",f[f.Install=1]="Install",f[f.Update=2]="Update"})(y=t.InstallOperation||(t.InstallOperation={})),t.IExtensionGalleryService=(0,w.createDecorator)("extensionGalleryService"),t.INSTALL_ERROR_NOT_SUPPORTED="notsupported",t.INSTALL_ERROR_MALICIOUS="malicious",t.INSTALL_ERROR_INCOMPATIBLE="incompatible";class E extends Error{constructor(h,o){super(h);this.code=o,this.name=o}}t.ExtensionManagementError=E,t.IExtensionManagementService=(0,w.createDecorator)("extensionManagementService"),t.DISABLED_EXTENSIONS_STORAGE_PATH="extensionsIdentifiers/disabled",t.ENABLED_EXTENSIONS_STORAGE_PATH="extensionsIdentifiers/enabled",t.IGlobalExtensionEnablementService=(0,w.createDecorator)("IGlobalExtensionEnablementService"),t.IExtensionTipsService=(0,w.createDecorator)("IExtensionTipsService"),t.DefaultIconPath=O.FileAccess.asBrowserUri("./media/defaultIcon.png",$).toString(!0),t.ExtensionsLabel=(0,b.localize)(0,null),t.ExtensionsLocalizedLabel={value:t.ExtensionsLabel,original:"Extensions"},t.ExtensionsChannelId="extensions",t.PreferencesLabel=(0,b.localize)(1,null),t.PreferencesLocalizedLabel={value:t.PreferencesLabel,original:"Preferences"},t.IExtensionManagementCLIService=(0,w.createDecorator)("IExtensionManagementCLIService")}),define(Z[40],te([0,1,22,15]),function($,t,O,b){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.IBuiltinExtensionsScannerService=t.isAuthenticaionProviderExtension=t.isLanguagePackExtension=t.ExtensionIdentifier=t.ExtensionType=t.EXTENSION_CATEGORIES=t.isIExtensionIdentifier=t.getWorkspaceSupportTypeMessage=t.ALL_EXTENSION_KINDS=t.BUILTIN_MANIFEST_CACHE_FILE=t.USER_MANIFEST_CACHE_FILE=t.MANIFEST_CACHE_FOLDER=void 0,t.MANIFEST_CACHE_FOLDER="CachedExtensions",t.USER_MANIFEST_CACHE_FILE="user",t.BUILTIN_MANIFEST_CACHE_FILE="builtin",t.ALL_EXTENSION_KINDS=["ui","workspace","web"];function w(v){if(typeof v=="object"&&v!==null&&v.supported!==!0)return v.description}t.getWorkspaceSupportTypeMessage=w;function R(v){return v&&typeof v=="object"&&typeof v.id=="string"&&(!v.uuid||typeof v.uuid=="string")}t.isIExtensionIdentifier=R,t.EXTENSION_CATEGORIES=["Azure","Data Science","Debuggers","Extension Packs","Education","Formatters","Keymaps","Language Packs","Linters","Machine Learning","Notebooks","Programming Languages","SCM Providers","Snippets","Testing","Themes","Visualization","Other"];var L;(function(v){v[v.System=0]="System",v[v.User=1]="User"})(L=t.ExtensionType||(t.ExtensionType={}));class T{constructor(P){this.value=P,this._lower=P.toLowerCase()}static equals(P,g){if(typeof P=="undefined"||P===null)return typeof g=="undefined"||g===null;if(typeof g=="undefined"||g===null)return!1;if(typeof P=="string"||typeof g=="string"){let I=typeof P=="string"?P:P.value,u=typeof g=="string"?g:g.value;return O.equalsIgnoreCase(I,u)}return P._lower===g._lower}static toKey(P){return typeof P=="string"?P.toLowerCase():P._lower}}t.ExtensionIdentifier=T;function c(v){return v.contributes&&v.contributes.localizations?v.contributes.localizations.length>0:!1}t.isLanguagePackExtension=c;function d(v){return v.contributes&&v.contributes.authentication?v.contributes.authentication.length>0:!1}t.isAuthenticaionProviderExtension=d,t.IBuiltinExtensionsScannerService=(0,b.createDecorator)("IBuiltinExtensionsScannerService")}),define(Z[24],te([0,1,22,40]),function($,t,O,b){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.getExtensionDependencies=t.getMaliciousExtensionsSet=t.BetterMergeId=t.getGalleryExtensionTelemetryData=t.getLocalExtensionTelemetryData=t.groupByExtension=t.getGalleryExtensionId=t.adoptToGalleryExtensionId=t.getExtensionId=t.ExtensionIdentifierWithVersion=t.areSameExtensions=void 0;function w(u,l){return u.uuid&&l.uuid?u.uuid===l.uuid:u.id===l.id?!0:(0,O.compareIgnoreCase)(u.id,l.id)===0}t.areSameExtensions=w;class R{constructor(l,y){this.version=y,this.id=l.id,this.uuid=l.uuid}key(){return`${this.id}-${this.version}`}equals(l){return l instanceof R?w(this,l)&&this.version===l.version:!1}}t.ExtensionIdentifierWithVersion=R;function L(u,l){return`${u}.${l}`}t.getExtensionId=L;function T(u){return u.toLocaleLowerCase()}t.adoptToGalleryExtensionId=T;function c(u,l){return T(L(u,l))}t.getGalleryExtensionId=c;function d(u,l){const y=[],E=f=>{for(const h of y)if(h.some(o=>w(l(o),l(f))))return h;return null};for(const f of u){const h=E(f);h?h.push(f):y.push([f])}return y}t.groupByExtension=d;function v(u){return{id:u.identifier.id,name:u.manifest.name,galleryId:null,publisherId:u.publisherId,publisherName:u.manifest.publisher,publisherDisplayName:u.publisherDisplayName,dependencies:u.manifest.extensionDependencies&&u.manifest.extensionDependencies.length>0}}t.getLocalExtensionTelemetryData=v;function P(u){return{id:u.identifier.id,name:u.name,galleryId:u.identifier.uuid,publisherId:u.publisherId,publisherName:u.publisher,publisherDisplayName:u.publisherDisplayName,dependencies:!!(u.properties.dependencies&&u.properties.dependencies.length>0),...u.telemetryData}}t.getGalleryExtensionTelemetryData=P,t.BetterMergeId=new b.ExtensionIdentifier("pprice.better-merge");function g(u){const l=new Set;for(const y of u)y.malicious&&l.add(y.id.id);return l}t.getMaliciousExtensionsSet=g;function I(u,l){const y=[],E=l.manifest.extensionDependencies?.slice(0)??[];for(;E.length;){const f=E.shift();if(f&&y.every(h=>!w(h.identifier,{id:f}))){const h=u.filter(o=>w(o.identifier,{id:f}));h.length===1&&(y.push(h[0]),E.push(...h[0].manifest.extensionDependencies?.slice(0)??[]))}}return y}t.getExtensionDependencies=I});var le=this&&this.__param||function($,t){return function(O,b){t(O,b,$)}};define(Z[96],te([0,1,25,9,63,8,41,7,76,23,24,40]),function($,t,O,b,w,R,L,T,c,d,v,P){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.ExtensionManagementCLIService=t.getIdAndVersion=void 0;const g=f=>(0,c.localize)(0,null,f),I=(0,c.localize)(1,null,"ms-dotnettools.csharp");function u(f,h){return h?`${f.publisher}.${f.name}@${f.version}`:`${f.publisher}.${f.name}`}const l=/^([^.]+\..+)@(\d+\.\d+\.\d+(-.*)?)$/;function y(f){const h=l.exec(f);return h&&h[1]?[(0,v.adoptToGalleryExtensionId)(h[1]),h[2]]:[(0,v.adoptToGalleryExtensionId)(f),void 0]}t.getIdAndVersion=y;let E=class{constructor(h,o){this.extensionManagementService=h,this.extensionGalleryService=o}get location(){}async listExtensions(h,o,s=console){let e=await this.extensionManagementService.getInstalled(1);const i=P.EXTENSION_CATEGORIES.map(r=>r.toLowerCase());if(o&&o!==""){if(i.indexOf(o.toLowerCase())<0){s.log("Invalid category please enter a valid category. To list valid categories run --category without a category specified");return}e=e.filter(r=>r.manifest.categories?r.manifest.categories.map(m=>m.toLowerCase()).indexOf(o.toLowerCase())>-1:!1)}else if(o===""){s.log("Possible Categories: "),i.forEach(r=>{s.log(r)});return}this.location&&s.log((0,c.localize)(2,null,this.location)),e=e.sort((r,a)=>r.identifier.id.localeCompare(a.identifier.id));let n;for(let r of e)n!==r.identifier.id&&(n=r.identifier.id,s.log(u(r.manifest,h)))}async installExtensions(h,o,s,e,i=console){const n=[],r=[];h.length&&i.log(this.location?(0,c.localize)(3,null,this.location):(0,c.localize)(4,null));const a=await this.extensionManagementService.getInstalled(1),m=(p,C)=>{const N=a.find(V=>(0,v.areSameExtensions)(V.identifier,{id:p}));if(N){if(!C&&!e)return i.log((0,c.localize)(5,null,p,N.manifest.version,p)),!1;if(C&&N.manifest.version===C)return i.log((0,c.localize)(6,null,`${p}@${C}`)),!1}return!0},S=[],F=[];for(const p of h)if(p instanceof T.URI)S.push(p);else{const[C,N]=y(p);m(C,N)&&F.push({id:C,version:N,installOptions:{isBuiltin:!1,isMachineScoped:s}})}for(const p of o){const[C,N]=y(p);m(C,N)&&F.push({id:C,version:N,installOptions:{isBuiltin:!0,isMachineScoped:!1}})}if(S.length&&await Promise.all(S.map(async p=>{try{const C=await this.installVSIX(p,{isBuiltin:!1,isMachineScoped:s},e,i);C&&r.push(C)}catch(C){i.error(C.message||C.stack||C),n.push(p.toString())}})),F.length){const p=await this.getGalleryExtensions(F);await Promise.all(F.map(async C=>{const N=p.get(C.id.toLowerCase());if(N)try{const V=await this.installFromGallery(C,N,a,e,i);V&&r.push(V)}catch(V){i.error(V.message||V.stack||V),n.push(C.id)}else i.error(`${g(C.version?`${C.id}@${C.version}`:C.id)}
${I}`),n.push(C.id)}))}if(n.length)throw new Error((0,c.localize)(7,null,n.join(", ")))}async installVSIX(h,o,s,e){const i=await this.extensionManagementService.getManifest(h);if(!i)throw new Error("Invalid vsix");if(await this.validateVSIX(i,s,e))try{return await this.extensionManagementService.install(h,o),e.log((0,c.localize)(8,null,(0,w.getBaseLabel)(h))),i}catch(r){if((0,b.isPromiseCanceledError)(r))return e.log((0,c.localize)(9,null,(0,w.getBaseLabel)(h))),null;throw r}return null}async getGalleryExtensions(h){const o=new Map,s=await this.extensionGalleryService.getExtensions(h,O.CancellationToken.None);for(const e of s)o.set(e.identifier.id.toLowerCase(),e);return o}async installFromGallery({id:h,version:o,installOptions:s},e,i,n,r){const a=await this.extensionGalleryService.getManifest(e,O.CancellationToken.None);if(a&&!this.validateExtensionKind(a,r))return null;const m=i.find(S=>(0,v.areSameExtensions)(S.identifier,e.identifier));if(m){if(e.version===m.manifest.version)return r.log((0,c.localize)(10,null,o?`${h}@${o}`:h)),null;r.log((0,c.localize)(11,null,h,e.version))}try{return s.isBuiltin?r.log(o?(0,c.localize)(12,null,h,o):(0,c.localize)(13,null,h)):r.log(o?(0,c.localize)(14,null,h,o):(0,c.localize)(15,null,h)),await this.extensionManagementService.installFromGallery(e,{...s,installGivenVersion:!!o}),r.log((0,c.localize)(16,null,h,e.version)),a}catch(S){if((0,b.isPromiseCanceledError)(S))return r.log((0,c.localize)(17,null,h)),null;throw S}}validateExtensionKind(h,o){return!0}async validateVSIX(h,o,s){const e={id:(0,v.getGalleryExtensionId)(h.publisher,h.name)},n=(await this.extensionManagementService.getInstalled(1)).find(r=>(0,v.areSameExtensions)(e,r.identifier)&&(0,L.gt)(r.manifest.version,h.version));return n&&!o?(s.log((0,c.localize)(18,null,n.identifier.id,n.manifest.version,h.version)),!1):this.validateExtensionKind(h,s)}async uninstallExtensions(h,o,s=console){const e=async n=>{if(n instanceof T.URI){const r=await this.extensionManagementService.getManifest(n);return u(r)}return n},i=[];for(const n of h){const r=await e(n),m=(await this.extensionManagementService.getInstalled()).filter(S=>(0,v.areSameExtensions)(S.identifier,{id:r}));if(!m.length)throw new Error(`${this.notInstalled(r)}
${I}`);if(m.some(S=>S.type===0)){s.log((0,c.localize)(19,null,r));return}if(!o&&m.some(S=>S.isBuiltin)){s.log((0,c.localize)(20,null,r));return}s.log((0,c.localize)(21,null,r));for(const S of m)await this.extensionManagementService.uninstall(S),i.push(S);this.location?s.log((0,c.localize)(22,null,r,this.location)):s.log((0,c.localize)(23,null,r))}}async locateExtension(h,o=console){const s=await this.extensionManagementService.getInstalled();h.forEach(e=>{s.forEach(i=>{if(i.identifier.id===e&&i.location.scheme===R.Schemas.file){o.log(i.location.fsPath);return}})})}notInstalled(h){return this.location?(0,c.localize)(24,null,h,this.location):(0,c.localize)(25,null,h)}};E=de([le(0,d.IExtensionManagementService),le(1,d.IExtensionGalleryService)],E),t.ExtensionManagementCLIService=E}),define(Z[97],te([0,1,2,4,12,40]),function($,t,O,b,w,R){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.ExtensionsManifestCache=void 0;class L extends O.Disposable{constructor(c,d){super();this.environmentService=c,this.extensionsManifestCache=(0,b.join)(this.environmentService.userDataPath,R.MANIFEST_CACHE_FOLDER,R.USER_MANIFEST_CACHE_FILE),this._register(d.onDidInstallExtensions(v=>this.onDidInstallExtensions(v))),this._register(d.onDidUninstallExtension(v=>this.onDidUnInstallExtension(v)))}onDidInstallExtensions(c){c.some(d=>!!d.local)&&this.invalidate()}onDidUnInstallExtension(c){c.error||this.invalidate()}invalidate(){w.Promises.rm(this.extensionsManifestCache,w.RimRafMode.MOVE).then(()=>{},()=>{})}}t.ExtensionsManifestCache=L}),define(Z[98],te([0,1,35,88,25,30,9,10,31,71,127]),function($,t,O,b,w,R,L,T,c,d,v){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.resolveShellEnv=void 0;async function P(u,l,y){return l["force-disable-user-env"]?(u.trace("resolveShellEnv(): skipped (--force-disable-user-env)"),{}):T.isWindows?(u.trace("resolveShellEnv(): skipped (Windows)"),{}):(0,v.isLaunchedFromCli)(y)&&!l["force-user-env"]?(u.trace("resolveShellEnv(): skipped (VSCODE_CLI is set)"),{}):((0,v.isLaunchedFromCli)(y)?u.trace("resolveShellEnv(): running (--force-user-env)"):u.trace("resolveShellEnv(): running (macOS/Linux)"),g||(g=new Promise(async E=>{const f=new w.CancellationTokenSource,h=setTimeout(()=>{u.error("[resolve shell env] Could not resolve shell environment within 10 seconds. Proceeding without shell environment..."),f.dispose(!0),E({})},1e4);try{const o=await I(u,f.token);E(o)}catch(o){(0,L.isPromiseCanceledError)(o)||u.error(`[resolve shell env] Unable to resolve shell environment (${o}). Proceeding without shell environment...`),E({})}finally{clearTimeout(h),f.dispose()}})),g)}t.resolveShellEnv=P;let g;async function I(u,l){const y=new Promise(async(E,f)=>{const h=process.env.ELECTRON_RUN_AS_NODE;u.trace("getUnixShellEnvironment#runAsNode",h);const o=process.env.ELECTRON_NO_ATTACH_CONSOLE;u.trace("getUnixShellEnvironment#noAttach",o);const s=(0,c.generateUuid)().replace(/-/g,"").substr(0,12),e=new RegExp(s+"(.*)"+s),i={...process.env,ELECTRON_RUN_AS_NODE:"1",ELECTRON_NO_ATTACH_CONSOLE:"1"};u.trace("getUnixShellEnvironment#env",i);const n=await(0,d.getSystemShell)(T.OS,i);if(u.trace("getUnixShellEnvironment#shell",n),l.isCancellationRequested)return f(L.canceled);const r=b.basename(n);let a,m;/^pwsh(-preview)?$/.test(r)?(a=`& '${process.execPath}' -p '''${s}'' + JSON.stringify(process.env) + ''${s}'''`,m=["-Login","-Command"]):(a=`'${process.execPath}' -p '"${s}" + JSON.stringify(process.env) + "${s}"'`,m=["-ilc"]),u.trace("getUnixShellEnvironment#spawn",JSON.stringify(m),a);const S=(0,O.spawn)(n,[...m,a],{detached:!0,stdio:["ignore","pipe","pipe"],env:i});l.onCancellationRequested(()=>(S.kill(),f(L.canceled))),S.on("error",C=>{u.error("getUnixShellEnvironment#errorChildProcess",(0,R.toErrorMessage)(C)),E({})});const F=[];S.stdout.on("data",C=>F.push(C));const p=[];S.stderr.on("data",C=>p.push(C)),S.on("close",(C,N)=>{const V=Buffer.concat(F).toString("utf8");u.trace("getUnixShellEnvironment#raw",V);const Y=Buffer.concat(p).toString("utf8");if(Y.trim()&&u.trace("getUnixShellEnvironment#stderr",Y),C||N)return f(new Error(`Failed to get environment (code ${C}, signal ${N})`));const ie=e.exec(V),oe=ie?ie[1]:"{}";try{const ee=JSON.parse(oe);h?ee.ELECTRON_RUN_AS_NODE=h:delete ee.ELECTRON_RUN_AS_NODE,o?ee.ELECTRON_NO_ATTACH_CONSOLE=o:delete ee.ELECTRON_NO_ATTACH_CONSOLE,delete ee.XDG_RUNTIME_DIR,u.trace("getUnixShellEnvironment#result",ee),E(ee)}catch(ee){u.error("getUnixShellEnvironment#errorCaught",(0,R.toErrorMessage)(ee)),f(ee)}})});try{return await y}catch(E){return u.error("getUnixShellEnvironment#error",(0,R.toErrorMessage)(E)),{}}}}),define(Z[54],te([0,1,10,7,16]),function($,t,O,b,w){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.normalizeFileChanges=t.toFileChanges=void 0;function R(c){return c.map(d=>({type:d.type,resource:b.URI.file(d.path)}))}t.toFileChanges=R;function L(c){const d=new T;for(const v of c)d.processEvent(v);return d.normalize()}t.normalizeFileChanges=L;class T{constructor(){this.normalized=[],this.mapPathToChange=new Map}processEvent(d){const v=this.mapPathToChange.get(d.path);if(v){const P=v.type,g=d.type;P===1&&g===2?(this.mapPathToChange.delete(d.path),this.normalized.splice(this.normalized.indexOf(v),1)):P===2&&g===1?v.type=0:P===1&&g===0||(v.type=g)}else this.normalized.push(d),this.mapPathToChange.set(d.path,d)}normalize(){const d=[],v=[];return this.normalized.filter(P=>P.type!==2?(d.push(P),!1):!0).sort((P,g)=>P.path.length-g.path.length).filter(P=>v.some(g=>(0,w.isParent)(P.path,g,!O.isLinux))?!1:(v.push(P.path),!0)).concat(d)}}}),define(Z[99],te([0,1,3,2,4,64,12,128,54]),function($,t,O,b,w,R,L,T,c){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.FileWatcher=void 0;class d extends b.Disposable{constructor(P,g,I,u){super();this.path=P,this.onDidFilesChange=g,this.onLogMessage=I,this.verboseLogging=u,this.fileChangesDelayer=this._register(new O.ThrottledDelayer(T.CHANGE_BUFFER_DELAY*2)),this.fileChangesBuffer=[],this.startWatching()}setVerboseLogging(P){this.verboseLogging=P}async startWatching(){try{const{stat:P,symbolicLink:g}=await L.SymlinkSupport.stat(this.path);if(this.isDisposed)return;let I=this.path;if(g)try{I=await(0,R.realpath)(I)}catch(u){if(this.onError(u),g.dangling)return}P.isDirectory()?this._register((0,T.watchFolder)(I,(u,l)=>{this.onFileChange({type:u==="changed"?0:u==="added"?1:2,path:(0,w.join)(this.path,(0,w.basename)(l))})},u=>this.onError(u))):this._register((0,T.watchFile)(I,u=>{this.onFileChange({type:u==="changed"?0:2,path:this.path})},u=>this.onError(u)))}catch(P){P.code!=="ENOENT"&&this.onError(P)}}onFileChange(P){this.fileChangesBuffer.push(P),this.verboseLogging&&this.onVerbose(`${P.type===1?"[ADDED]":P.type===2?"[DELETED]":"[CHANGED]"} ${P.path}`),this.fileChangesDelayer.trigger(async()=>{const g=this.fileChangesBuffer;this.fileChangesBuffer=[];const I=(0,c.normalizeFileChanges)(g);if(this.verboseLogging)for(const u of I)this.onVerbose(`>> normalized ${u.type===1?"[ADDED]":u.type===2?"[DELETED]":"[CHANGED]"} ${u.path}`);I.length>0&&this.onDidFilesChange(I)})}onError(P){this.isDisposed||this.onLogMessage({type:"error",message:`[File Watcher (node.js)] ${P}`})}onVerbose(P){this.isDisposed||this.onLogMessage({type:"trace",message:`[File Watcher (node.js)] ${P}`})}dispose(){this.isDisposed=!0,super.dispose()}}t.FileWatcher=d}),define(Z[55],te([0,1]),function($,t){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.ServiceCollection=void 0;class O{constructor(...w){this._entries=new Map;for(let[R,L]of w)this.set(R,L)}set(w,R){const L=this._entries.get(w);return this._entries.set(w,R),L}has(w){return this._entries.has(w)}get(w){return this._entries.get(w)}}t.ServiceCollection=O}),define(Z[100],te([0,1,3,9,52,95,15,55]),function($,t,O,b,w,R,L,T){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.InstantiationService=void 0;const c=!1;class d extends Error{constructor(u){super("cyclic dependency between services");this.message=u.findCycleSlow()??`UNABLE to detect cycle, dumping graph: 
${u.toString()}`}}class v{constructor(u=new T.ServiceCollection,l=!1,y){this._activeInstantiations=new Set,this._services=u,this._strict=l,this._parent=y,this._services.set(L.IInstantiationService,this)}createChild(u){return new v(u,this._strict,this)}invokeFunction(u,...l){let y=g.traceInvocation(u),E=!1;try{return u({get:(h,o)=>{if(E)throw(0,b.illegalState)("service accessor is only valid during the invocation of its target method");const s=this._getOrCreateServiceInstance(h,y);if(!s&&o!==L.optional)throw new Error(`[invokeFunction] unknown service '${h}'`);return s}},...l)}finally{E=!0,y.stop()}}createInstance(u,...l){let y,E;return u instanceof w.SyncDescriptor?(y=g.traceCreation(u.ctor),E=this._createInstance(u.ctor,u.staticArguments.concat(l),y)):(y=g.traceCreation(u),E=this._createInstance(u,l,y)),y.stop(),E}_createInstance(u,l=[],y){let E=L._util.getServiceDependencies(u).sort((o,s)=>o.index-s.index),f=[];for(const o of E){let s=this._getOrCreateServiceInstance(o.id,y);if(!s&&this._strict&&!o.optional)throw new Error(`[createInstance] ${u.name} depends on UNKNOWN service ${o.id}.`);f.push(s)}let h=E.length>0?E[0].index:l.length;if(l.length!==h){console.warn(`[createInstance] First service dependency of ${u.name} at position ${h+1} conflicts with ${l.length} static arguments`);let o=h-l.length;o>0?l=l.concat(new Array(o)):l=l.slice(0,h)}return new u(...[...l,...f])}_setServiceInstance(u,l){if(this._services.get(u)instanceof w.SyncDescriptor)this._services.set(u,l);else if(this._parent)this._parent._setServiceInstance(u,l);else throw new Error("illegalState - setting UNKNOWN service instance")}_getServiceInstanceOrDescriptor(u){let l=this._services.get(u);return!l&&this._parent?this._parent._getServiceInstanceOrDescriptor(u):l}_getOrCreateServiceInstance(u,l){let y=this._getServiceInstanceOrDescriptor(u);return y instanceof w.SyncDescriptor?this._safeCreateAndCacheServiceInstance(u,y,l.branch(u,!0)):(l.branch(u,!1),y)}_safeCreateAndCacheServiceInstance(u,l,y){if(this._activeInstantiations.has(u))throw new Error(`illegal state - RECURSIVELY instantiating service '${u}'`);this._activeInstantiations.add(u);try{return this._createAndCacheServiceInstance(u,l,y)}finally{this._activeInstantiations.delete(u)}}_createAndCacheServiceInstance(u,l,y){const E=new R.Graph(o=>o.id.toString());let f=0;const h=[{id:u,desc:l,_trace:y}];for(;h.length;){const o=h.pop();if(E.lookupOrInsertNode(o),f++>1e3)throw new d(E);for(let s of L._util.getServiceDependencies(o.desc.ctor)){let e=this._getServiceInstanceOrDescriptor(s.id);if(!e&&!s.optional&&console.warn(`[createInstance] ${u} depends on ${s.id} which is NOT registered.`),e instanceof w.SyncDescriptor){const i={id:s.id,desc:e,_trace:o._trace.branch(s.id,!0)};E.insertEdge(o,i),h.push(i)}}}for(;;){const o=E.roots();if(o.length===0){if(!E.isEmpty())throw new d(E);break}for(const{data:s}of o){if(this._getServiceInstanceOrDescriptor(s.id)instanceof w.SyncDescriptor){const i=this._createServiceInstanceWithOwner(s.id,s.desc.ctor,s.desc.staticArguments,s.desc.supportsDelayedInstantiation,s._trace);this._setServiceInstance(s.id,i)}E.removeNode(s)}}return this._getServiceInstanceOrDescriptor(u)}_createServiceInstanceWithOwner(u,l,y=[],E,f){if(this._services.get(u)instanceof w.SyncDescriptor)return this._createServiceInstance(l,y,E,f);if(this._parent)return this._parent._createServiceInstanceWithOwner(u,l,y,E,f);throw new Error(`illegalState - creating UNKNOWN service instance ${l.name}`)}_createServiceInstance(u,l=[],y,E){if(y){const f=new O.IdleValue(()=>this._createInstance(u,l,E));return new Proxy(Object.create(null),{get(h,o){if(o in h)return h[o];let s=f.value,e=s[o];return typeof e!="function"||(e=e.bind(s),h[o]=e),e},set(h,o,s){return f.value[o]=s,!0}})}else return this._createInstance(u,l,E)}}t.InstantiationService=v;var P;(function(I){I[I.Creation=0]="Creation",I[I.Invocation=1]="Invocation",I[I.Branch=2]="Branch"})(P||(P={}));class g{constructor(u,l){this.type=u,this.name=l,this._start=Date.now(),this._dep=[]}static traceInvocation(u){return c?new g(1,u.name||u.toString().substring(0,42).replace(/\n/g,"")):g._None}static traceCreation(u){return c?new g(0,u.name):g._None}branch(u,l){let y=new g(2,u.toString());return this._dep.push([u,l,y]),y}stop(){let u=Date.now()-this._start;g._totals+=u;let l=!1;function y(f,h){let o=[],s=new Array(f+1).join("	");for(const[e,i,n]of h._dep)if(i&&n){l=!0,o.push(`${s}CREATES -> ${e}`);let r=y(f+1,n);r&&o.push(r)}else o.push(`${s}uses -> ${e}`);return o.join(`
`)}let E=[`${this.type===0?"CREATE":"CALL"} ${this.name}`,`${y(1,this)}`,`DONE, took ${u.toFixed(2)}ms (grand total ${g._totals.toFixed(2)}ms)`];(u>2||l)&&console.log(E.join(`
`))}}g._None=new class extends g{constructor(){super(-1,null)}stop(){}branch(){return this}},g._totals=0}),define(Z[56],te([0,1,15]),function($,t,O){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.isValidLocalization=t.ILocalizationsService=void 0,t.ILocalizationsService=(0,O.createDecorator)("localizationsService");function b(w){if(typeof w.languageId!="string"||!Array.isArray(w.translations)||w.translations.length===0)return!1;for(const R of w.translations)if(typeof R.id!="string"||typeof R.path!="string")return!1;return!(w.languageName&&typeof w.languageName!="string"||w.localizedLanguageName&&typeof w.localizedLanguageName!="string")}t.isValidLocalization=b}),define(Z[14],te([0,1,30,13,2,10,15]),function($,t,O,b,w,R,L){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.LogLevelToString=t.parseLogLevel=t.getLogLevel=t.NullLogService=t.AbstractLoggerService=t.LogService=t.MultiplexLogService=t.AdapterLogger=t.ConsoleLogger=t.ConsoleMainLogger=t.AbstractMessageLogger=t.AbstractLogger=t.DEFAULT_LOG_LEVEL=t.LogLevel=t.ILoggerService=t.ILogService=void 0,t.ILogService=(0,L.createDecorator)("logService"),t.ILoggerService=(0,L.createDecorator)("loggerService");function T(){return new Date().toISOString()}var c;(function(s){s[s.Trace=0]="Trace",s[s.Debug=1]="Debug",s[s.Info=2]="Info",s[s.Warning=3]="Warning",s[s.Error=4]="Error",s[s.Critical=5]="Critical",s[s.Off=6]="Off"})(c=t.LogLevel||(t.LogLevel={})),t.DEFAULT_LOG_LEVEL=c.Info;class d extends w.Disposable{constructor(){super(...arguments);this.level=t.DEFAULT_LOG_LEVEL,this._onDidChangeLogLevel=this._register(new b.Emitter),this.onDidChangeLogLevel=this._onDidChangeLogLevel.event}setLevel(e){this.level!==e&&(this.level=e,this._onDidChangeLogLevel.fire(this.level))}getLevel(){return this.level}}t.AbstractLogger=d;class v extends d{constructor(e){super();this.logAlways=e}checkLogLevel(e){return this.logAlways||this.getLevel()<=e}trace(e,...i){this.checkLogLevel(c.Trace)&&this.log(c.Trace,this.format([e,...i]))}debug(e,...i){this.checkLogLevel(c.Debug)&&this.log(c.Debug,this.format([e,...i]))}info(e,...i){this.checkLogLevel(c.Info)&&this.log(c.Info,this.format([e,...i]))}warn(e,...i){this.checkLogLevel(c.Warning)&&this.log(c.Warning,this.format([e,...i]))}error(e,...i){if(this.checkLogLevel(c.Error))if(e instanceof Error){const n=Array.prototype.slice.call(arguments);n[0]=e.stack,this.log(c.Error,this.format(n))}else this.log(c.Error,this.format([e,...i]))}critical(e,...i){this.checkLogLevel(c.Critical)&&this.log(c.Critical,this.format([e,...i]))}flush(){}format(e){let i="";for(let n=0;n<e.length;n++){let r=e[n];if(typeof r=="object")try{r=JSON.stringify(r)}catch(a){}i+=(n>0?" ":"")+r}return i}}t.AbstractMessageLogger=v;class P extends d{constructor(e=t.DEFAULT_LOG_LEVEL){super();this.setLevel(e),this.useColors=!R.isWindows}trace(e,...i){this.getLevel()<=c.Trace&&(this.useColors?console.log(`[90m[main ${T()}][0m`,e,...i):console.log(`[main ${T()}]`,e,...i))}debug(e,...i){this.getLevel()<=c.Debug&&(this.useColors?console.log(`[90m[main ${T()}][0m`,e,...i):console.log(`[main ${T()}]`,e,...i))}info(e,...i){this.getLevel()<=c.Info&&(this.useColors?console.log(`[90m[main ${T()}][0m`,e,...i):console.log(`[main ${T()}]`,e,...i))}warn(e,...i){this.getLevel()<=c.Warning&&(this.useColors?console.warn(`[93m[main ${T()}][0m`,e,...i):console.warn(`[main ${T()}]`,e,...i))}error(e,...i){this.getLevel()<=c.Error&&(this.useColors?console.error(`[91m[main ${T()}][0m`,e,...i):console.error(`[main ${T()}]`,e,...i))}critical(e,...i){this.getLevel()<=c.Critical&&(this.useColors?console.error(`[90m[main ${T()}][0m`,e,...i):console.error(`[main ${T()}]`,e,...i))}dispose(){}flush(){}}t.ConsoleMainLogger=P;class g extends d{constructor(e=t.DEFAULT_LOG_LEVEL){super();this.setLevel(e)}trace(e,...i){this.getLevel()<=c.Trace&&console.log("%cTRACE","color: #888",e,...i)}debug(e,...i){this.getLevel()<=c.Debug&&console.log("%cDEBUG","background: #eee; color: #888",e,...i)}info(e,...i){this.getLevel()<=c.Info&&console.log("%c INFO","color: #33f",e,...i)}warn(e,...i){this.getLevel()<=c.Warning&&console.log("%c WARN","color: #993",e,...i)}error(e,...i){this.getLevel()<=c.Error&&console.log("%c  ERR","color: #f33",e,...i)}critical(e,...i){this.getLevel()<=c.Critical&&console.log("%cCRITI","background: #f33; color: white",e,...i)}dispose(){}flush(){}}t.ConsoleLogger=g;class I extends d{constructor(e,i=t.DEFAULT_LOG_LEVEL){super();this.adapter=e,this.setLevel(i)}trace(e,...i){this.getLevel()<=c.Trace&&this.adapter.log(c.Trace,[this.extractMessage(e),...i])}debug(e,...i){this.getLevel()<=c.Debug&&this.adapter.log(c.Debug,[this.extractMessage(e),...i])}info(e,...i){this.getLevel()<=c.Info&&this.adapter.log(c.Info,[this.extractMessage(e),...i])}warn(e,...i){this.getLevel()<=c.Warning&&this.adapter.log(c.Warning,[this.extractMessage(e),...i])}error(e,...i){this.getLevel()<=c.Error&&this.adapter.log(c.Error,[this.extractMessage(e),...i])}critical(e,...i){this.getLevel()<=c.Critical&&this.adapter.log(c.Critical,[this.extractMessage(e),...i])}extractMessage(e){return typeof e=="string"?e:(0,O.toErrorMessage)(e,this.getLevel()<=c.Trace)}dispose(){}flush(){}}t.AdapterLogger=I;class u extends d{constructor(e){super();this.logServices=e,e.length&&this.setLevel(e[0].getLevel())}setLevel(e){for(const i of this.logServices)i.setLevel(e);super.setLevel(e)}trace(e,...i){for(const n of this.logServices)n.trace(e,...i)}debug(e,...i){for(const n of this.logServices)n.debug(e,...i)}info(e,...i){for(const n of this.logServices)n.info(e,...i)}warn(e,...i){for(const n of this.logServices)n.warn(e,...i)}error(e,...i){for(const n of this.logServices)n.error(e,...i)}critical(e,...i){for(const n of this.logServices)n.critical(e,...i)}flush(){for(const e of this.logServices)e.flush()}dispose(){for(const e of this.logServices)e.dispose()}}t.MultiplexLogService=u;class l extends w.Disposable{constructor(e){super();this.logger=e,this._register(e)}get onDidChangeLogLevel(){return this.logger.onDidChangeLogLevel}setLevel(e){this.logger.setLevel(e)}getLevel(){return this.logger.getLevel()}trace(e,...i){this.logger.trace(e,...i)}debug(e,...i){this.logger.debug(e,...i)}info(e,...i){this.logger.info(e,...i)}warn(e,...i){this.logger.warn(e,...i)}error(e,...i){this.logger.error(e,...i)}critical(e,...i){this.logger.critical(e,...i)}flush(){this.logger.flush()}}t.LogService=l;class y extends w.Disposable{constructor(e,i){super();this.logLevel=e,this.loggers=new Map,this.logLevelChangeableLoggers=[],this._register(i(n=>{this.logLevel=n,this.logLevelChangeableLoggers.forEach(r=>r.setLevel(n))}))}getLogger(e){return this.loggers.get(e.toString())}createLogger(e,i){let n=this.loggers.get(e.toString());return n||(n=this.doCreateLogger(e,i?.always?c.Trace:this.logLevel,i),this.loggers.set(e.toString(),n),i?.always||this.logLevelChangeableLoggers.push(n)),n}dispose(){this.logLevelChangeableLoggers.splice(0,this.logLevelChangeableLoggers.length),this.loggers.forEach(e=>e.dispose()),this.loggers.clear(),super.dispose()}}t.AbstractLoggerService=y;class E{constructor(){this.onDidChangeLogLevel=new b.Emitter().event}setLevel(e){}getLevel(){return c.Info}trace(e,...i){}debug(e,...i){}info(e,...i){}warn(e,...i){}error(e,...i){}critical(e,...i){}dispose(){}flush(){}}t.NullLogService=E;function f(s){if(s.verbose)return c.Trace;if(typeof s.logLevel=="string"){const e=h(s.logLevel.toLowerCase());if(e!==void 0)return e}return t.DEFAULT_LOG_LEVEL}t.getLogLevel=f;function h(s){switch(s){case"trace":return c.Trace;case"debug":return c.Debug;case"info":return c.Info;case"warn":return c.Warning;case"error":return c.Error;case"critical":return c.Critical;case"off":return c.Off}}t.parseLogLevel=h;function o(s){switch(s){case c.Trace:return"trace";case c.Debug:return"debug";case c.Info:return"info";case c.Warning:return"warn";case c.Error:return"error";case c.Critical:return"critical";case c.Off:return"off"}}t.LogLevelToString=o}),define(Z[101],te([0,1,3,9,2,10,19,41,7,31,12,21,23,24,16,14]),function($,t,O,b,w,R,L,T,c,d,v,P,g,I,u,l){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.ExtensionsDownloader=void 0;const y=/^([^.]+\..+)-(\d+\.\d+\.\d+)$/;let E=class extends w.Disposable{constructor(h,o,s,e){super();this.fileService=o,this.extensionGalleryService=s,this.logService=e,this.extensionsDownloadDir=c.URI.file(h.extensionsDownloadPath),this.cache=20,this.cleanUpPromise=this.cleanUp()}async downloadExtension(h,o){await this.cleanUpPromise;const s=this.getName(h),e=(0,L.joinPath)(this.extensionsDownloadDir,s);if(!await this.fileService.exists(e)){const i=(0,L.joinPath)(this.extensionsDownloadDir,`.${(0,d.generateUuid)()}`);await this.fileService.exists(i)||await this.extensionGalleryService.download(h,i,o);try{await this.rename(i,e,Date.now()+2*60*1e3)}catch(n){try{await this.fileService.del(i)}catch(r){}if(n.code==="ENOTEMPTY")this.logService.info("Rename failed because vsix was downloaded by another source. So ignoring renaming.",h.identifier.id);else throw this.logService.info(`Rename failed because of ${(0,b.getErrorMessage)(n)}. Deleted the vsix from downloaded location`,i.path),n}}return e}async delete(h){}async rename(h,o,s){try{await v.Promises.rename(h.fsPath,o.fsPath)}catch(e){if(R.isWindows&&e&&e.code==="EPERM"&&Date.now()<s)return this.logService.info(`Failed renaming ${h} to ${o} with 'EPERM' error. Trying again...`),this.rename(h,o,s);throw e}}async cleanUp(){try{if(!await this.fileService.exists(this.extensionsDownloadDir)){this.logService.trace("Extension VSIX downlads cache dir does not exist");return}const h=await this.fileService.resolve(this.extensionsDownloadDir,{resolveMetadata:!0});if(h.children){const o=[],s=[];for(const n of h.children){const r=this.parse(n.name);r&&s.push([r,n])}const e=(0,I.groupByExtension)(s,([n])=>n),i=[];for(const n of e)n.sort((r,a)=>T.rcompare(r[0].version,a[0].version)),o.push(...n.slice(1).map(r=>r[1].resource)),i.push(n[0][1]);i.sort((n,r)=>n.mtime-r.mtime),o.push(...i.slice(0,Math.max(0,i.length-this.cache)).map(n=>n.resource)),await O.Promises.settled(o.map(n=>(this.logService.trace("Deleting vsix from cache",n.path),this.fileService.del(n))))}}catch(h){this.logService.error(h)}}getName(h){return this.cache?`${new I.ExtensionIdentifierWithVersion(h.identifier,h.version).key().toLowerCase()}${h.properties.targetPlatform!=="undefined"?`-${h.properties.targetPlatform}`:""}`:(0,d.generateUuid)()}parse(h){const o=y.exec(h);return o&&o[1]&&o[2]?new I.ExtensionIdentifierWithVersion({id:o[1]},o[2]):null}};E=de([le(0,P.INativeEnvironmentService),le(1,u.IFileService),le(2,g.IExtensionGalleryService),le(3,l.ILogService)],E),t.ExtensionsDownloader=E}),define(Z[102],te([0,1,35,3,30,13,2,8,4,12,21,14]),function($,t,O,b,w,R,L,T,c,d,v,P){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.ExtensionsLifecycle=void 0;let g=class extends L.Disposable{constructor(u,l){super();this.environmentService=u,this.logService=l,this.processesLimiter=new b.Limiter(5)}async postUninstall(u){const l=this.parseScript(u,"uninstall");return l&&(this.logService.info(u.identifier.id,u.manifest.version,"Running post uninstall script"),await this.processesLimiter.queue(()=>this.runLifecycleHook(l.script,"uninstall",l.args,!0,u).then(()=>this.logService.info(u.identifier.id,u.manifest.version,"Finished running post uninstall script"),y=>this.logService.error(u.identifier.id,u.manifest.version,`Failed to run post uninstall script: ${y}`)))),d.Promises.rm(this.getExtensionStoragePath(u)).then(void 0,y=>this.logService.error("Error while removing extension storage path",y))}parseScript(u,l){const y=`vscode:${l}`;if(u.location.scheme===T.Schemas.file&&u.manifest&&u.manifest.scripts&&typeof u.manifest.scripts[y]=="string"){const E=u.manifest.scripts[y].split(" ");return E.length<2||E[0]!=="node"||!E[1]?(this.logService.warn(u.identifier.id,u.manifest.version,`${y} should be a node script`),null):{script:(0,c.join)(u.location.fsPath,E[1]),args:E.slice(2)||[]}}return null}runLifecycleHook(u,l,y,E,f){return new Promise((h,o)=>{const s=this.start(u,l,y,f);let e;const i=n=>{e&&(clearTimeout(e),e=null),n?o(n):h(void 0)};s.on("error",n=>{i((0,w.toErrorMessage)(n)||"Unknown")}),s.on("exit",(n,r)=>{i(n?`post-${l} process exited with code ${n}`:void 0)}),E&&(e=setTimeout(()=>{e=null,s.kill(),o("timed out")},5e3))})}start(u,l,y,E){const f={silent:!0,execArgv:void 0},h=(0,O.fork)(u,[`--type=extension-post-${l}`,...y],f);h.stdout.setEncoding("utf8"),h.stderr.setEncoding("utf8");const o=R.Event.fromNodeEventEmitter(h.stdout,"data"),s=R.Event.fromNodeEventEmitter(h.stderr,"data");o(n=>this.logService.info(E.identifier.id,E.manifest.version,`post-${l}`,n)),s(n=>this.logService.error(E.identifier.id,E.manifest.version,`post-${l}`,n));const e=R.Event.any(R.Event.map(o,n=>({data:`%c${n}`,format:[""]})),R.Event.map(s,n=>({data:`%c${n}`,format:["color: red"]})));return R.Event.debounce(e,(n,r)=>n?{data:n.data+r.data,format:[...n.format,...r.format]}:{data:r.data,format:r.format},100)(n=>{console.group(E.identifier.id),console.log(n.data,...n.format),console.groupEnd()}),h}getExtensionStoragePath(u){return(0,c.join)(this.environmentService.globalStorageHome.fsPath,u.identifier.id.toLowerCase())}};g=de([le(0,v.IEnvironmentService),le(1,P.ILogService)],g),t.ExtensionsLifecycle=g}),define(Z[103],te([0,1,13,2,19,7,21,24,16,14]),function($,t,O,b,w,R,L,T,c,d){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.ExtensionsWatcher=void 0;let v=class extends b.Disposable{constructor(g,I,u,l){super();this.extensionsManagementService=g,this.logService=l,this._onDidChangeExtensionsByAnotherSource=this._register(new O.Emitter),this.onDidChangeExtensionsByAnotherSource=this._onDidChangeExtensionsByAnotherSource.event,this.startTimestamp=0,this.installingExtensions=[],this.extensionsManagementService.getInstalled(1).then(f=>{this.installedExtensions=f.map(h=>h.identifier),this.startTimestamp=Date.now()}),this._register(g.onInstallExtension(f=>this.onInstallExtension(f))),this._register(g.onDidInstallExtensions(f=>this.onDidInstallExtensions(f))),this._register(g.onDidUninstallExtension(f=>this.onDidUninstallExtension(f)));const y=R.URI.file(u.extensionsPath),E=new w.ExtUri(f=>!I.hasCapability(f,1024));this._register(I.watch(y)),this._register(O.Event.filter(I.onDidChangeFilesRaw,f=>f.changes.some(h=>this.doesChangeAffects(h,y,E)))(()=>this.onDidChange()))}doesChangeAffects(g,I,u){return u.isEqual(u.dirname(g.resource),I)?u.isEqual(g.resource,u.joinPath(I,".obsolete"))?!0:!(g.type!==1&&g.type!==2||u.basename(g.resource).startsWith(".")):!1}onInstallExtension(g){this.addInstallingExtension(g.identifier)}onDidInstallExtensions(g){for(const I of g)this.removeInstallingExtension(I.identifier),I.local&&this.addInstalledExtension(I.identifier)}onDidUninstallExtension(g){g.error||this.removeInstalledExtension(g.identifier)}addInstallingExtension(g){this.removeInstallingExtension(g),this.installingExtensions.push(g)}removeInstallingExtension(g){this.installingExtensions=this.installingExtensions.filter(I=>!(0,T.areSameExtensions)(I,g))}addInstalledExtension(g){this.installedExtensions&&(this.removeInstalledExtension(g),this.installedExtensions.push(g))}removeInstalledExtension(g){this.installedExtensions&&(this.installedExtensions=this.installedExtensions.filter(I=>!(0,T.areSameExtensions)(I,g)))}async onDidChange(){if(this.installedExtensions){const g=await this.extensionsManagementService.getInstalled(1),I=g.filter(l=>[...this.installingExtensions,...this.installedExtensions].some(y=>(0,T.areSameExtensions)(y,l.identifier))?!1:l.installedTimestamp&&l.installedTimestamp>this.startTimestamp?(this.logService.info("Detected extension installed from another source",l.identifier.id),!0):(this.logService.info("Ignored extension installed by another source because of invalid timestamp",l.identifier.id),!1)),u=this.installedExtensions.filter(l=>this.installingExtensions.some(y=>(0,T.areSameExtensions)(y,l))?!1:g.every(y=>!(0,T.areSameExtensions)(y.identifier,l))?(this.logService.info("Detected extension removed from another source",l.id),!0):!1);this.installedExtensions=g.map(l=>l.identifier),(I.length||u.length)&&this._onDidChangeExtensionsByAnotherSource.fire({added:I,removed:u})}}};v=de([le(1,c.IFileService),le(2,L.INativeEnvironmentService),le(3,d.ILogService)],v),t.ExtensionsWatcher=v}),define(Z[104],te([0,1,129,20,3,2,8,4,12,21,23,24,56,14]),function($,t,O,b,w,R,L,T,c,d,v,P,g,I){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.LocalizationsService=void 0;let u=class extends R.Disposable{constructor(E,f,h){super();this.extensionManagementService=E,this.logService=h,this.cache=this._register(new l(f,h)),this.extensionManagementService.registerParticipant({postInstall:async o=>this.postInstallExtension(o),postUninstall:async o=>this.postUninstallExtension(o)})}async getLanguageIds(){const E=await this.cache.getLanguagePacks(),f=["en",...Object.keys(E)];return(0,b.distinct)(f)}async postInstallExtension(E){E&&E.manifest&&E.manifest.contributes&&E.manifest.contributes.localizations&&E.manifest.contributes.localizations.length&&(this.logService.info("Adding language packs from the extension",E.identifier.id),await this.update())}async postUninstallExtension(E){const f=await this.cache.getLanguagePacks();Object.keys(f).some(h=>f[h]&&f[h].extensions.some(o=>(0,P.areSameExtensions)(o.extensionIdentifier,E.identifier)))&&(this.logService.info("Removing language packs from the extension",E.identifier.id),await this.update())}async update(){const[E,f]=await Promise.all([this.cache.getLanguagePacks(),this.extensionManagementService.getInstalled()]),h=await this.cache.update(f);return!(0,b.equals)(Object.keys(E),Object.keys(h))}};u=de([le(0,v.IExtensionManagementService),le(1,d.INativeEnvironmentService),le(2,I.ILogService)],u),t.LocalizationsService=u;let l=class extends R.Disposable{constructor(E,f){super();this.logService=f,this.languagePacks={},this.languagePacksFilePath=(0,T.join)(E.userDataPath,"languagepacks.json"),this.languagePacksFileLimiter=new w.Queue}getLanguagePacks(){return this.languagePacksFileLimiter.size||!this.initializedCache?this.withLanguagePacks().then(()=>this.languagePacks):Promise.resolve(this.languagePacks)}update(E){return this.withLanguagePacks(f=>{Object.keys(f).forEach(h=>delete f[h]),this.createLanguagePacksFromExtensions(f,...E)}).then(()=>this.languagePacks)}createLanguagePacksFromExtensions(E,...f){for(const h of f)h&&h.manifest&&h.manifest.contributes&&h.manifest.contributes.localizations&&h.manifest.contributes.localizations.length&&this.createLanguagePacksFromExtension(E,h);Object.keys(E).forEach(h=>this.updateHash(E[h]))}createLanguagePacksFromExtension(E,f){const h=f.identifier,o=f.manifest.contributes&&f.manifest.contributes.localizations?f.manifest.contributes.localizations:[];for(const s of o)if(f.location.scheme===L.Schemas.file&&(0,g.isValidLocalization)(s)){let e=E[s.languageId];e||(e={hash:"",extensions:[],translations:{}},E[s.languageId]=e);let i=e.extensions.filter(n=>(0,P.areSameExtensions)(n.extensionIdentifier,h))[0];i?i.version=f.manifest.version:e.extensions.push({extensionIdentifier:h,version:f.manifest.version});for(const n of s.translations)e.translations[n.id]=(0,T.join)(f.location.fsPath,n.path)}}updateHash(E){if(E){const f=(0,O.createHash)("md5");for(const h of E.extensions)f.update(h.extensionIdentifier.uuid||h.extensionIdentifier.id).update(h.version);E.hash=f.digest("hex")}}withLanguagePacks(E=()=>null){return this.languagePacksFileLimiter.queue(()=>{let f=null;return c.Promises.readFile(this.languagePacksFilePath,"utf8").then(void 0,h=>h.code==="ENOENT"?Promise.resolve("{}"):Promise.reject(h)).then(h=>{try{return JSON.parse(h)}catch(o){return{}}}).then(h=>(f=E(h),h)).then(h=>{for(const s of Object.keys(h))h[s]||delete h[s];this.languagePacks=h,this.initializedCache=!0;const o=JSON.stringify(this.languagePacks);return this.logService.debug("Writing language packs",o),c.Promises.writeFile(this.languagePacksFilePath,o)}).then(()=>f,h=>this.logService.error(h))})}};l=de([le(0,d.INativeEnvironmentService),le(1,I.ILogService)],l)}),define(Z[105],te([0,1,16,14]),function($,t,O,b){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.SpdLogLogger=t.createRotatingLogger=void 0;async function w(c,d,v,P){try{const g=await new Promise((I,u)=>{$(["spdlog"],I,u)});return g.setFlushOn(b.LogLevel.Trace),g.createAsyncRotatingLogger(c,d,v,P)}catch(g){console.error(g)}return null}function R(c,d,v,P){const g=$.__$__nodeRequire("spdlog");return g.setFlushOn(b.LogLevel.Trace),g.createRotatingLogger(c,d,v,P)}t.createRotatingLogger=R;function L(c,d,v){switch(d){case b.LogLevel.Trace:c.trace(v);break;case b.LogLevel.Debug:c.debug(v);break;case b.LogLevel.Info:c.info(v);break;case b.LogLevel.Warning:c.warn(v);break;case b.LogLevel.Error:c.error(v);break;case b.LogLevel.Critical:c.critical(v);break;default:throw new Error("Invalid log level")}}class T extends b.AbstractMessageLogger{constructor(d,v,P,g){super();this.name=d,this.filepath=v,this.rotating=P,this.buffer=[],this.setLevel(g),this._loggerCreationPromise=this._createSpdLogLogger(),this._register(this.onDidChangeLogLevel(I=>{this._logger&&this._logger.setLevel(I)}))}_createSpdLogLogger(){const d=this.rotating?6:1,v=30/d*O.ByteSize.MB;return w(this.name,this.filepath,v,d).then(P=>{if(P){this._logger=P,this._logger.setLevel(this.getLevel());for(const{level:g,message:I}of this.buffer)L(this._logger,g,I);this.buffer=[]}})}log(d,v){this._logger?L(this._logger,d,v):this.getLevel()<=d&&this.buffer.push({level:d,message:v})}clearFormatters(){this._logger?this._logger.clearFormatters():this._loggerCreationPromise.then(()=>this.clearFormatters())}flush(){this._logger?this._logger.flush():this._loggerCreationPromise.then(()=>this.flush())}dispose(){this._logger?this.disposeLogger():this._loggerCreationPromise.then(()=>this.disposeLogger())}disposeLogger(){this._logger&&(this._logger.drop(),this._logger=void 0)}}t.SpdLogLogger=T}),define(Z[57],te([0,1,17,9,82,16,32]),function($,t,O,b,w,R,L){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.readFileIntoStream=void 0;async function T(P,g,I,u,l,y){let E;try{await c(P,g,I,u,l,y)}catch(f){E=f}finally{E&&l.errorTransformer&&(E=l.errorTransformer(E)),typeof E!="undefined"&&I.error(E),I.end()}}t.readFileIntoStream=T;async function c(P,g,I,u,l,y){d(y);const E=await P.open(g,{create:!1});try{d(y);let f=0,h=0,o=l&&typeof l.length=="number"?l.length:void 0,s=O.VSBuffer.alloc(Math.min(l.bufferSize,typeof o=="number"?o:l.bufferSize)),e=l&&typeof l.position=="number"?l.position:0,i=0;do h=await P.read(E,e,s.buffer,i,s.byteLength-i),e+=h,i+=h,f+=h,typeof o=="number"&&(o-=h),i===s.byteLength&&(await I.write(u(s)),s=O.VSBuffer.alloc(Math.min(l.bufferSize,typeof o=="number"?o:l.bufferSize)),i=0);while(h>0&&(typeof o!="number"||o>0)&&d(y)&&v(f,l));if(i>0){let n=i;typeof o=="number"&&(n=Math.min(i,o)),I.write(u(s.slice(0,n)))}}catch(f){throw(0,R.ensureFileSystemProviderError)(f)}finally{await P.close(E)}}function d(P){if(P.isCancellationRequested)throw(0,b.canceled)();return!0}function v(P,g){if(g?.limits){if(typeof g.limits.memory=="number"&&P>g.limits.memory)throw(0,R.createFileSystemProviderError)((0,w.localize)(0,null,L.default.nameShort),R.FileSystemProviderErrorCode.FileExceedsMemoryLimit);if(typeof g.limits.size=="number"&&P>g.limits.size)throw(0,R.createFileSystemProviderError)((0,w.localize)(1,null),R.FileSystemProviderErrorCode.FileTooLarge)}return!0}}),define(Z[106],te([0,1,20,3,17,25,13,130,2,46,8,131,19,37,81,16,57,14]),function($,t,O,b,w,R,L,T,c,d,v,P,g,I,u,l,y,E){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.FileService=void 0;let f=class xe extends c.Disposable{constructor(o){super();this.logService=o,this.BUFFER_SIZE=64*1024,this._onDidChangeFileSystemProviderRegistrations=this._register(new L.Emitter),this.onDidChangeFileSystemProviderRegistrations=this._onDidChangeFileSystemProviderRegistrations.event,this._onWillActivateFileSystemProvider=this._register(new L.Emitter),this.onWillActivateFileSystemProvider=this._onWillActivateFileSystemProvider.event,this._onDidChangeFileSystemProviderCapabilities=this._register(new L.Emitter),this.onDidChangeFileSystemProviderCapabilities=this._onDidChangeFileSystemProviderCapabilities.event,this.provider=new Map,this._onDidRunOperation=this._register(new L.Emitter),this.onDidRunOperation=this._onDidRunOperation.event,this._onError=this._register(new L.Emitter),this.onError=this._onError.event,this._onDidFilesChange=this._register(new L.Emitter),this.onDidFilesChange=this._onDidFilesChange.event,this._onDidChangeFilesRaw=this._register(new L.Emitter),this.onDidChangeFilesRaw=this._onDidChangeFilesRaw.event,this.activeWatchers=new Map,this.caseSensitiveFileEventsWorker=this._register(new b.ThrottledWorker(xe.FILE_EVENTS_THROTTLING.maxChangesChunkSize,xe.FILE_EVENTS_THROTTLING.maxChangesBufferSize,xe.FILE_EVENTS_THROTTLING.coolDownDelay,s=>this._onDidFilesChange.fire(new l.FileChangesEvent(s,!1)))),this.caseInsensitiveFileEventsWorker=this._register(new b.ThrottledWorker(xe.FILE_EVENTS_THROTTLING.maxChangesChunkSize,xe.FILE_EVENTS_THROTTLING.maxChangesBufferSize,xe.FILE_EVENTS_THROTTLING.coolDownDelay,s=>this._onDidFilesChange.fire(new l.FileChangesEvent(s,!0)))),this.watchedResources=d.TernarySearchTree.forUris(s=>{const e=this.getProvider(s.scheme);return e?!this.isPathCaseSensitive(e):!1}),this.writeQueue=this._register(new b.ResourceQueue)}registerProvider(o,s){if(this.provider.has(o))throw new Error(`A filesystem provider for the scheme '${o}' is already registered.`);(0,P.mark)(`code/registerFilesystem/${o}`),this.provider.set(o,s),this._onDidChangeFileSystemProviderRegistrations.fire({added:!0,scheme:o,provider:s});const e=new c.DisposableStore;return e.add(s.onDidChangeFile(i=>this.onDidChangeFile(i,this.isPathCaseSensitive(s)))),e.add(s.onDidChangeCapabilities(()=>this._onDidChangeFileSystemProviderCapabilities.fire({provider:s,scheme:o}))),typeof s.onDidErrorOccur=="function"&&e.add(s.onDidErrorOccur(i=>this._onError.fire(new Error(i)))),(0,c.toDisposable)(()=>{this._onDidChangeFileSystemProviderRegistrations.fire({added:!1,scheme:o,provider:s}),this.provider.delete(o),(0,c.dispose)(e)})}getProvider(o){return this.provider.get(o)}async activateProvider(o){const s=[];this._onWillActivateFileSystemProvider.fire({scheme:o,join(e){s.push(e)}}),!this.provider.has(o)&&await b.Promises.settled(s)}canHandleResource(o){return this.provider.has(o.scheme)}hasCapability(o,s){const e=this.provider.get(o.scheme);return!!(e&&e.capabilities&s)}listCapabilities(){return T.Iterable.map(this.provider,([o,s])=>({scheme:o,capabilities:s.capabilities}))}async withProvider(o){if(!(0,g.isAbsolutePath)(o))throw new l.FileOperationError((0,u.localize)(0,null,this.resourceForError(o)),8);await this.activateProvider(o.scheme);const s=this.provider.get(o.scheme);if(!s){const e=new Error;throw e.name="ENOPRO",e.message=(0,u.localize)(1,null,o.toString()),e}return s}async withReadProvider(o){const s=await this.withProvider(o);if((0,l.hasOpenReadWriteCloseCapability)(s)||(0,l.hasReadWriteCapability)(s)||(0,l.hasFileReadStreamCapability)(s))return s;throw new Error(`Filesystem provider for scheme '${o.scheme}' neither has FileReadWrite, FileReadStream nor FileOpenReadWriteClose capability which is needed for the read operation.`)}async withWriteProvider(o){const s=await this.withProvider(o);if((0,l.hasOpenReadWriteCloseCapability)(s)||(0,l.hasReadWriteCapability)(s))return s;throw new Error(`Filesystem provider for scheme '${o.scheme}' neither has FileReadWrite nor FileOpenReadWriteClose capability which is needed for the write operation.`)}async resolve(o,s){try{return await this.doResolveFile(o,s)}catch(e){throw(0,l.toFileSystemProviderErrorCode)(e)===l.FileSystemProviderErrorCode.FileNotFound?new l.FileOperationError((0,u.localize)(2,null,this.resourceForError(o)),1):(0,l.ensureFileSystemProviderError)(e)}}async doResolveFile(o,s){const e=await this.withProvider(o),i=this.isPathCaseSensitive(e),n=s?.resolveTo,r=s?.resolveSingleChildDescendants,a=s?.resolveMetadata,m=await e.stat(o);let S;return this.toFileStat(e,o,m,void 0,!!a,(F,p)=>{if(!S&&(S=d.TernarySearchTree.forUris(()=>!i),S.set(o,!0),n))for(const C of n)S.set(C,!0);return S.get(F.resource)||S.findSuperstr(F.resource.with({query:null,fragment:null}))?!0:F.isDirectory&&r?p===1:!1})}async toFileStat(o,s,e,i,n,r){const{providerExtUri:a}=this.getExtUri(o),m={resource:s,name:a.basename(s),isFile:(e.type&l.FileType.File)!=0,isDirectory:(e.type&l.FileType.Directory)!=0,isSymbolicLink:(e.type&l.FileType.SymbolicLink)!=0,mtime:e.mtime,ctime:e.ctime,size:e.size,readonly:Boolean((e.permissions??0)&l.FilePermission.Readonly)||Boolean(o.capabilities&2048),etag:(0,l.etag)({mtime:e.mtime,size:e.size})};if(m.isDirectory&&r(m,i)){try{const S=await o.readdir(s),F=await b.Promises.settled(S.map(async([p,C])=>{try{const N=a.joinPath(s,p),V=n?await o.stat(N):{type:C};return await this.toFileStat(o,N,V,S.length,n,r)}catch(N){return this.logService.trace(N),null}}));m.children=(0,O.coalesce)(F)}catch(S){this.logService.trace(S),m.children=[]}return m}return m}async resolveAll(o){return b.Promises.settled(o.map(async s=>{try{return{stat:await this.doResolveFile(s.resource,s.options),success:!0}}catch(e){return this.logService.trace(e),{stat:void 0,success:!1}}}))}async exists(o){const s=await this.withProvider(o);try{return!!await s.stat(o)}catch(e){return!1}}async canCreateFile(o,s){try{await this.doValidateCreateFile(o,s)}catch(e){return e}return!0}async doValidateCreateFile(o,s){if(!s?.overwrite&&await this.exists(o))throw new l.FileOperationError((0,u.localize)(3,null,this.resourceForError(o)),3,s)}async createFile(o,s=w.VSBuffer.fromString(""),e){await this.doValidateCreateFile(o,e);const i=await this.writeFile(o,s);return this._onDidRunOperation.fire(new l.FileOperationEvent(o,0,i)),i}async writeFile(o,s,e){const i=this.throwIfFileSystemIsReadonly(await this.withWriteProvider(o),o),{providerExtUri:n}=this.getExtUri(i);try{await this.validateWriteFile(i,o,e)||await this.mkdirp(i,n.dirname(o));let a;if((0,l.hasReadWriteCapability)(i)&&!(s instanceof w.VSBuffer))if((0,I.isReadableStream)(s)){const m=await(0,I.peekStream)(s,3);m.ended?a=w.VSBuffer.concat(m.buffer):a=m}else a=(0,I.peekReadable)(s,m=>w.VSBuffer.concat(m),3);else a=s;!(0,l.hasOpenReadWriteCloseCapability)(i)||(0,l.hasReadWriteCapability)(i)&&a instanceof w.VSBuffer?await this.doWriteUnbuffered(i,o,e,a):await this.doWriteBuffered(i,o,e,a instanceof w.VSBuffer?(0,w.bufferToReadable)(a):a)}catch(r){throw new l.FileOperationError((0,u.localize)(4,null,this.resourceForError(o),(0,l.ensureFileSystemProviderError)(r).toString()),(0,l.toFileOperationResult)(r),e)}return this.resolve(o,{resolveMetadata:!0})}async validateWriteFile(o,s,e){if(!!e?.unlock&&!(o.capabilities&8192))throw new Error((0,u.localize)(5,null,this.resourceForError(s)));let n;try{n=await o.stat(s)}catch(r){return}if((n.type&l.FileType.Directory)!=0)throw new l.FileOperationError((0,u.localize)(6,null,this.resourceForError(s)),0,e);if(this.throwIfFileIsReadonly(s,n),typeof e?.mtime=="number"&&typeof e.etag=="string"&&e.etag!==l.ETAG_DISABLED&&typeof n.mtime=="number"&&typeof n.size=="number"&&e.mtime<n.mtime&&e.etag!==(0,l.etag)({mtime:e.mtime,size:n.size}))throw new l.FileOperationError((0,u.localize)(7,null),3,e);return n}async readFile(o,s){const e=await this.withReadProvider(o);return s?.atomic?this.doReadFileAtomic(e,o,s):this.doReadFile(e,o,s)}async doReadFileAtomic(o,s,e){return new Promise((i,n)=>{this.writeQueue.queueFor(s,this.getExtUri(o).providerExtUri).queue(async()=>{try{const r=await this.doReadFile(o,s,e);i(r)}catch(r){n(r)}})})}async doReadFile(o,s,e){const i=await this.doReadFileStream(o,s,{...e,preferUnbuffered:!0});return{...i,value:await(0,w.streamToBuffer)(i.value)}}async readFileStream(o,s){const e=await this.withReadProvider(o);return this.doReadFileStream(e,o,s)}async doReadFileStream(o,s,e){const i=new R.CancellationTokenSource,n=this.validateReadFile(s,e).then(a=>a,a=>{throw i.cancel(),a});let r;try{return typeof e?.etag=="string"&&e.etag!==l.ETAG_DISABLED&&await n,!((0,l.hasOpenReadWriteCloseCapability)(o)||(0,l.hasFileReadStreamCapability)(o))||(0,l.hasReadWriteCapability)(o)&&e?.preferUnbuffered?r=this.readFileUnbuffered(o,s,e):(0,l.hasFileReadStreamCapability)(o)?r=this.readFileStreamed(o,s,i.token,e):r=this.readFileBuffered(o,s,i.token,e),{...await n,value:r}}catch(a){r&&await(0,I.consumeStream)(r);const m=(0,u.localize)(8,null,this.resourceForError(s),(0,l.ensureFileSystemProviderError)(a).toString());throw a instanceof l.NotModifiedSinceFileOperationError?new l.NotModifiedSinceFileOperationError(m,a.stat,e):new l.FileOperationError(m,(0,l.toFileOperationResult)(a),e)}}readFileStreamed(o,s,e,i=Object.create(null)){const n=o.readFileStream(s,i,e);return(0,I.transform)(n,{data:r=>r instanceof w.VSBuffer?r:w.VSBuffer.wrap(r),error:r=>new l.FileOperationError((0,u.localize)(9,null,this.resourceForError(s),(0,l.ensureFileSystemProviderError)(r).toString()),(0,l.toFileOperationResult)(r),i)},r=>w.VSBuffer.concat(r))}readFileBuffered(o,s,e,i=Object.create(null)){const n=(0,w.newWriteableBufferStream)();return(0,y.readFileIntoStream)(o,s,n,r=>r,{...i,bufferSize:this.BUFFER_SIZE,errorTransformer:r=>new l.FileOperationError((0,u.localize)(10,null,this.resourceForError(s),(0,l.ensureFileSystemProviderError)(r).toString()),(0,l.toFileOperationResult)(r),i)},e),n}readFileUnbuffered(o,s,e){const i=(0,I.newWriteableStream)(n=>w.VSBuffer.concat(n));return(async()=>{try{let n=await o.readFile(s);typeof e?.position=="number"&&(n=n.slice(e.position)),typeof e?.length=="number"&&(n=n.slice(0,e.length)),this.validateReadFileLimits(s,n.byteLength,e),i.end(w.VSBuffer.wrap(n))}catch(n){i.error(n),i.end()}})(),i}async validateReadFile(o,s){const e=await this.resolve(o,{resolveMetadata:!0});if(e.isDirectory)throw new l.FileOperationError((0,u.localize)(11,null,this.resourceForError(o)),0,s);if(typeof s?.etag=="string"&&s.etag!==l.ETAG_DISABLED&&s.etag===e.etag)throw new l.NotModifiedSinceFileOperationError((0,u.localize)(12,null),e,s);return this.validateReadFileLimits(o,e.size,s),e}validateReadFileLimits(o,s,e){if(e?.limits){let i;if(typeof e.limits.memory=="number"&&s>e.limits.memory&&(i=9),typeof e.limits.size=="number"&&s>e.limits.size&&(i=7),typeof i=="number")throw new l.FileOperationError((0,u.localize)(13,null,this.resourceForError(o)),i)}}async canMove(o,s,e){return this.doCanMoveCopy(o,s,"move",e)}async canCopy(o,s,e){return this.doCanMoveCopy(o,s,"copy",e)}async doCanMoveCopy(o,s,e,i){if(o.toString()!==s.toString())try{const n=e==="move"?this.throwIfFileSystemIsReadonly(await this.withWriteProvider(o),o):await this.withReadProvider(o),r=this.throwIfFileSystemIsReadonly(await this.withWriteProvider(s),s);await this.doValidateMoveCopy(n,o,r,s,e,i)}catch(n){return n}return!0}async move(o,s,e){const i=this.throwIfFileSystemIsReadonly(await this.withWriteProvider(o),o),n=this.throwIfFileSystemIsReadonly(await this.withWriteProvider(s),s),r=await this.doMoveCopy(i,o,n,s,"move",!!e),a=await this.resolve(s,{resolveMetadata:!0});return this._onDidRunOperation.fire(new l.FileOperationEvent(o,r==="move"?2:3,a)),a}async copy(o,s,e){const i=await this.withReadProvider(o),n=this.throwIfFileSystemIsReadonly(await this.withWriteProvider(s),s),r=await this.doMoveCopy(i,o,n,s,"copy",!!e),a=await this.resolve(s,{resolveMetadata:!0});return this._onDidRunOperation.fire(new l.FileOperationEvent(o,r==="copy"?3:2,a)),a}async doMoveCopy(o,s,e,i,n,r){if(s.toString()===i.toString())return n;const{exists:a,isSameResourceWithDifferentPathCase:m}=await this.doValidateMoveCopy(o,s,e,i,n,r);if(a&&!m&&r&&await this.del(i,{recursive:!0}),await this.mkdirp(e,this.getExtUri(e).providerExtUri.dirname(i)),n==="copy"){if(o===e&&(0,l.hasFileFolderCopyCapability)(o))await o.copy(s,i,{overwrite:r});else{const S=await this.resolve(s);S.isDirectory?await this.doCopyFolder(o,S,e,i):await this.doCopyFile(o,s,e,i)}return n}else return o===e?(await o.rename(s,i,{overwrite:r}),n):(await this.doMoveCopy(o,s,e,i,"copy",r),await this.del(s,{recursive:!0}),"copy")}async doCopyFile(o,s,e,i){if((0,l.hasOpenReadWriteCloseCapability)(o)&&(0,l.hasOpenReadWriteCloseCapability)(e))return this.doPipeBuffered(o,s,e,i);if((0,l.hasOpenReadWriteCloseCapability)(o)&&(0,l.hasReadWriteCapability)(e))return this.doPipeBufferedToUnbuffered(o,s,e,i);if((0,l.hasReadWriteCapability)(o)&&(0,l.hasOpenReadWriteCloseCapability)(e))return this.doPipeUnbufferedToBuffered(o,s,e,i);if((0,l.hasReadWriteCapability)(o)&&(0,l.hasReadWriteCapability)(e))return this.doPipeUnbuffered(o,s,e,i)}async doCopyFolder(o,s,e,i){await e.mkdir(i),Array.isArray(s.children)&&await b.Promises.settled(s.children.map(async n=>{const r=this.getExtUri(e).providerExtUri.joinPath(i,n.name);return n.isDirectory?this.doCopyFolder(o,await this.resolve(n.resource),e,r):this.doCopyFile(o,n.resource,e,r)}))}async doValidateMoveCopy(o,s,e,i,n,r){let a=!1;if(o===e){const{providerExtUri:S,isPathCaseSensitive:F}=this.getExtUri(o);if(F||(a=S.isEqual(s,i)),a&&n==="copy")throw new Error((0,u.localize)(14,null,this.resourceForError(s),this.resourceForError(i)));if(!a&&S.isEqualOrParent(i,s))throw new Error((0,u.localize)(15,null,this.resourceForError(s),this.resourceForError(i)))}const m=await this.exists(i);if(m&&!a){if(!r)throw new l.FileOperationError((0,u.localize)(16,null,this.resourceForError(s),this.resourceForError(i)),4);if(o===e){const{providerExtUri:S}=this.getExtUri(o);if(S.isEqualOrParent(s,i))throw new Error((0,u.localize)(17,null,this.resourceForError(s),this.resourceForError(i)))}}return{exists:m,isSameResourceWithDifferentPathCase:a}}getExtUri(o){const s=this.isPathCaseSensitive(o);return{providerExtUri:s?g.extUri:g.extUriIgnorePathCase,isPathCaseSensitive:s}}isPathCaseSensitive(o){return!!(o.capabilities&1024)}async createFolder(o){const s=this.throwIfFileSystemIsReadonly(await this.withProvider(o),o);await this.mkdirp(s,o);const e=await this.resolve(o,{resolveMetadata:!0});return this._onDidRunOperation.fire(new l.FileOperationEvent(o,0,e)),e}async mkdirp(o,s){const e=[],{providerExtUri:i}=this.getExtUri(o);for(;!i.isEqual(s,i.dirname(s));)try{if(((await o.stat(s)).type&l.FileType.Directory)==0)throw new Error((0,u.localize)(18,null,this.resourceForError(s)));break}catch(n){if((0,l.toFileSystemProviderErrorCode)(n)!==l.FileSystemProviderErrorCode.FileNotFound)throw n;e.push(i.basename(s)),s=i.dirname(s)}for(let n=e.length-1;n>=0;n--){s=i.joinPath(s,e[n]);try{await o.mkdir(s)}catch(r){if((0,l.toFileSystemProviderErrorCode)(r)!==l.FileSystemProviderErrorCode.FileExists)throw r}}}async canDelete(o,s){try{await this.doValidateDelete(o,s)}catch(e){return e}return!0}async doValidateDelete(o,s){const e=this.throwIfFileSystemIsReadonly(await this.withProvider(o),o);if(!!s?.useTrash&&!(e.capabilities&4096))throw new Error((0,u.localize)(19,null,this.resourceForError(o)));let n;try{n=await e.stat(o)}catch(a){}if(n)this.throwIfFileIsReadonly(o,n);else throw new l.FileOperationError((0,u.localize)(20,null,this.resourceForError(o)),1);if(!!!s?.recursive){const a=await this.resolve(o);if(a.isDirectory&&Array.isArray(a.children)&&a.children.length>0)throw new Error((0,u.localize)(21,null,this.resourceForError(o)))}return e}async del(o,s){const e=await this.doValidateDelete(o,s),i=!!s?.useTrash,n=!!s?.recursive;await e.delete(o,{recursive:n,useTrash:i}),this._onDidRunOperation.fire(new l.FileOperationEvent(o,1))}onDidChangeFile(o,s){this._onDidChangeFilesRaw.fire({changes:o});let e,i;{for(const n of o)this.watchedResources.has(n.resource)?(e||(e=[]),e.push(n)):(i||(i=[]),i.push(n));e&&this._onDidFilesChange.fire(new l.FileChangesEvent(e,!s))}if(i){const n=s?this.caseSensitiveFileEventsWorker:this.caseInsensitiveFileEventsWorker;!n.work(i)&&xe.FILE_EVENTS_THROTTLING.warningscounter++<10&&this.logService.warn(`[File watcher]: started ignoring events due to too many file change events at once (incoming: ${i.length}, most recent change: ${i[0].resource.toString()}). Use 'files.watcherExclude' setting to exclude folders with lots of changing files (e.g. compilation output).`),n.pending>0&&this.logService.trace(`[File watcher]: started throttling events due to large amount of file change events at once (pending: ${n.pending}, most recent change: ${i[0].resource.toString()}). Use 'files.watcherExclude' setting to exclude folders with lots of changing files (e.g. compilation output).`)}}watch(o,s={recursive:!1,excludes:[]}){const e=new c.DisposableStore;{let i=!1,n=()=>{i=!0};e.add((0,c.toDisposable)(()=>n())),this.doWatch(o,s).then(r=>{i?(0,c.dispose)(r):n=()=>(0,c.dispose)(r)},r=>this.logService.error(r))}return s.recursive||(this.watchedResources.set(o,(this.watchedResources.get(o)??0)+1),e.add((0,c.toDisposable)(()=>{const i=this.watchedResources.get(o);typeof i=="number"&&(i<=1?this.watchedResources.delete(o):this.watchedResources.set(o,i-1))}))),e}async doWatch(o,s){const e=await this.withProvider(o),i=this.toWatchKey(e,o,s),n=this.activeWatchers.get(i)||{count:0,disposable:e.watch(o,s)};return this.activeWatchers.has(i)||this.activeWatchers.set(i,n),n.count+=1,(0,c.toDisposable)(()=>{n.count--,n.count===0&&((0,c.dispose)(n.disposable),this.activeWatchers.delete(i))})}toWatchKey(o,s,e){const{providerExtUri:i}=this.getExtUri(o);return[i.getComparisonKey(s),String(e.recursive),e.excludes.join()].join()}dispose(){super.dispose();for(const[,o]of this.activeWatchers)(0,c.dispose)(o.disposable);this.activeWatchers.clear()}async doWriteBuffered(o,s,e,i){return this.writeQueue.queueFor(s,this.getExtUri(o).providerExtUri).queue(async()=>{const n=await o.open(s,{create:!0,unlock:e?.unlock??!1});try{(0,I.isReadableStream)(i)||(0,I.isReadableBufferedStream)(i)?await this.doWriteStreamBufferedQueued(o,n,i):await this.doWriteReadableBufferedQueued(o,n,i)}catch(r){throw(0,l.ensureFileSystemProviderError)(r)}finally{await o.close(n)}})}async doWriteStreamBufferedQueued(o,s,e){let i=0,n;if((0,I.isReadableBufferedStream)(e)){if(e.buffer.length>0){const r=w.VSBuffer.concat(e.buffer);await this.doWriteBuffer(o,s,r,r.byteLength,i,0),i+=r.byteLength}if(e.ended)return;n=e.stream}else n=e;return new Promise(async(r,a)=>{(0,I.listenStream)(n,{onData:async m=>{n.pause();try{await this.doWriteBuffer(o,s,m,m.byteLength,i,0)}catch(S){return a(S)}i+=m.byteLength,setTimeout(()=>n.resume())},onError:m=>a(m),onEnd:()=>r()})})}async doWriteReadableBufferedQueued(o,s,e){let i=0,n;for(;(n=e.read())!==null;)await this.doWriteBuffer(o,s,n,n.byteLength,i,0),i+=n.byteLength}async doWriteBuffer(o,s,e,i,n,r){let a=0;for(;a<i;)a+=await o.write(s,n+a,e.buffer,r+a,i-a)}async doWriteUnbuffered(o,s,e,i){return this.writeQueue.queueFor(s,this.getExtUri(o).providerExtUri).queue(()=>this.doWriteUnbufferedQueued(o,s,e,i))}async doWriteUnbufferedQueued(o,s,e,i){let n;i instanceof w.VSBuffer?n=i:(0,I.isReadableStream)(i)?n=await(0,w.streamToBuffer)(i):(0,I.isReadableBufferedStream)(i)?n=await(0,w.bufferedStreamToBuffer)(i):n=(0,w.readableToBuffer)(i),await o.writeFile(s,n.buffer,{create:!0,overwrite:!0,unlock:e?.unlock??!1})}async doPipeBuffered(o,s,e,i){return this.writeQueue.queueFor(i,this.getExtUri(e).providerExtUri).queue(()=>this.doPipeBufferedQueued(o,s,e,i))}async doPipeBufferedQueued(o,s,e,i){let n,r;try{n=await o.open(s,{create:!1}),r=await e.open(i,{create:!0,unlock:!1});const a=w.VSBuffer.alloc(this.BUFFER_SIZE);let m=0,S=0,F=0;do F=await o.read(n,m,a.buffer,S,a.byteLength-S),await this.doWriteBuffer(e,r,a,F,m,S),m+=F,S+=F,S===a.byteLength&&(S=0);while(F>0)}catch(a){throw(0,l.ensureFileSystemProviderError)(a)}finally{await b.Promises.settled([typeof n=="number"?o.close(n):Promise.resolve(),typeof r=="number"?e.close(r):Promise.resolve()])}}async doPipeUnbuffered(o,s,e,i){return this.writeQueue.queueFor(i,this.getExtUri(e).providerExtUri).queue(()=>this.doPipeUnbufferedQueued(o,s,e,i))}async doPipeUnbufferedQueued(o,s,e,i){return e.writeFile(i,await o.readFile(s),{create:!0,overwrite:!0,unlock:!1})}async doPipeUnbufferedToBuffered(o,s,e,i){return this.writeQueue.queueFor(i,this.getExtUri(e).providerExtUri).queue(()=>this.doPipeUnbufferedToBufferedQueued(o,s,e,i))}async doPipeUnbufferedToBufferedQueued(o,s,e,i){const n=await e.open(i,{create:!0,unlock:!1});try{const r=await o.readFile(s);await this.doWriteBuffer(e,n,w.VSBuffer.wrap(r),r.byteLength,0,0)}catch(r){throw(0,l.ensureFileSystemProviderError)(r)}finally{await e.close(n)}}async doPipeBufferedToUnbuffered(o,s,e,i){const n=await(0,w.streamToBuffer)(this.readFileBuffered(o,s,R.CancellationToken.None));await this.doWriteUnbuffered(e,i,void 0,n)}throwIfFileSystemIsReadonly(o,s){if(o.capabilities&2048)throw new l.FileOperationError((0,u.localize)(22,null,this.resourceForError(s)),6);return o}throwIfFileIsReadonly(o,s){if((s.permissions??0)&l.FilePermission.Readonly)throw new l.FileOperationError((0,u.localize)(23,null,this.resourceForError(o)),6)}resourceForError(o){return o.scheme===v.Schemas.file?o.fsPath:o.toString(!0)}};f.FILE_EVENTS_THROTTLING={maxChangesChunkSize:500,maxChangesBufferSize:3e4,coolDownDelay:200,warningscounter:0},f=de([le(0,E.ILogService)],f),t.FileService=f}),define(Z[107],te([0,1,20,3,17,13,38,2,4,10,19,37,12,83,16,57,99,91,92,54,94,14,32]),function($,t,O,b,w,R,L,T,c,d,v,P,g,I,u,l,y,E,f,h,o,s,e){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.DiskFileSystemProvider=void 0;class i extends T.Disposable{constructor(r,a){super();this.logService=r,this.options=a,this.BUFFER_SIZE=this.options?.bufferSize||64*1024,this.onDidChangeCapabilities=R.Event.None,this.mapHandleToPos=new Map,this.writeHandles=new Map,this.canFlush=!0,this._onDidWatchErrorOccur=this._register(new R.Emitter),this.onDidErrorOccur=this._onDidWatchErrorOccur.event,this._onDidChangeFile=this._register(new R.Emitter),this.onDidChangeFile=this._onDidChangeFile.event,this.recursiveFoldersToWatch=[],this.recursiveWatchRequestDelayer=this._register(new b.ThrottledDelayer(0))}get capabilities(){return this._capabilities||(this._capabilities=2|4|16|8|8192,d.isLinux&&(this._capabilities|=1024)),this._capabilities}async stat(r){try{const{stat:a,symbolicLink:m}=await g.SymlinkSupport.stat(this.toFilePath(r));return{type:this.toType(a,m),ctime:a.birthtime.getTime(),mtime:a.mtime.getTime(),size:a.size}}catch(a){throw this.toFileSystemProviderError(a)}}async readdir(r){try{const a=await g.Promises.readdir(this.toFilePath(r),{withFileTypes:!0}),m=[];return await Promise.all(a.map(async S=>{try{let F;S.isSymbolicLink()?F=(await this.stat((0,v.joinPath)(r,S.name))).type:F=this.toType(S),m.push([S.name,F])}catch(F){this.logService.trace(F)}})),m}catch(a){throw this.toFileSystemProviderError(a)}}toType(r,a){let m;return a?.dangling?m=u.FileType.Unknown:r.isFile()?m=u.FileType.File:r.isDirectory()?m=u.FileType.Directory:m=u.FileType.Unknown,a&&(m|=u.FileType.SymbolicLink),m}async readFile(r){try{const a=this.toFilePath(r);return await g.Promises.readFile(a)}catch(a){throw this.toFileSystemProviderError(a)}}readFileStream(r,a,m){const S=(0,P.newWriteableStream)(F=>w.VSBuffer.concat(F.map(p=>w.VSBuffer.wrap(p))).buffer);return(0,l.readFileIntoStream)(this,r,S,F=>F.buffer,{...a,bufferSize:this.BUFFER_SIZE},m),S}async writeFile(r,a,m){let S;try{const F=this.toFilePath(r);if(!m.create||!m.overwrite){if(await g.Promises.exists(F)){if(!m.overwrite)throw(0,u.createFileSystemProviderError)((0,I.localize)(0,null),u.FileSystemProviderErrorCode.FileExists)}else if(!m.create)throw(0,u.createFileSystemProviderError)((0,I.localize)(1,null),u.FileSystemProviderErrorCode.FileNotFound)}S=await this.open(r,{create:!0,unlock:m.unlock}),await this.write(S,0,a,0,a.byteLength)}catch(F){throw await this.toFileSystemProviderWriteError(r,F)}finally{typeof S=="number"&&await this.close(S)}}async open(r,a){try{const m=this.toFilePath(r);if((0,u.isFileOpenForWriteOptions)(a)&&a.unlock)try{const{stat:p}=await g.SymlinkSupport.stat(m);p.mode&128||await g.Promises.chmod(m,p.mode|128)}catch(p){this.logService.trace(p)}let S;if((0,u.isFileOpenForWriteOptions)(a)){if(d.isWindows)try{await g.Promises.truncate(m,0),S="r+"}catch(p){p.code!=="ENOENT"&&this.logService.trace(p)}S||(S="w")}else S="r";const F=await g.Promises.open(m,S);return this.mapHandleToPos.set(F,0),(0,u.isFileOpenForWriteOptions)(a)&&this.writeHandles.set(F,r),F}catch(m){throw(0,u.isFileOpenForWriteOptions)(a)?await this.toFileSystemProviderWriteError(r,m):this.toFileSystemProviderError(m)}}async close(r){try{if(this.mapHandleToPos.delete(r),this.writeHandles.delete(r)&&this.canFlush)try{await g.Promises.fdatasync(r)}catch(a){this.canFlush=!1,this.logService.error(a)}return await g.Promises.close(r)}catch(a){throw this.toFileSystemProviderError(a)}}async read(r,a,m,S,F){const p=this.normalizePos(r,a);let C=null;try{const N=await g.Promises.read(r,m,S,F,p);return typeof N=="number"?C=N:C=N.bytesRead,C}catch(N){throw this.toFileSystemProviderError(N)}finally{this.updatePos(r,p,C)}}normalizePos(r,a){return a===this.mapHandleToPos.get(r)?null:a}updatePos(r,a,m){const S=this.mapHandleToPos.get(r);typeof S=="number"&&(typeof a=="number"||(typeof m=="number"?this.mapHandleToPos.set(r,S+m):this.mapHandleToPos.delete(r)))}async write(r,a,m,S,F){return(0,b.retry)(()=>this.doWrite(r,a,m,S,F),100,3)}async doWrite(r,a,m,S,F){const p=this.normalizePos(r,a);let C=null;try{const N=await g.Promises.write(r,m,S,F,p);return typeof N=="number"?C=N:C=N.bytesWritten,C}catch(N){throw await this.toFileSystemProviderWriteError(this.writeHandles.get(r),N)}finally{this.updatePos(r,p,C)}}async mkdir(r){try{await g.Promises.mkdir(this.toFilePath(r))}catch(a){throw this.toFileSystemProviderError(a)}}async delete(r,a){try{const m=this.toFilePath(r);await this.doDelete(m,a)}catch(m){throw this.toFileSystemProviderError(m)}}async doDelete(r,a){a.recursive?await g.Promises.rm(r,g.RimRafMode.MOVE):await g.Promises.unlink(r)}async rename(r,a,m){const S=this.toFilePath(r),F=this.toFilePath(a);if(S!==F)try{await this.validateTargetDeleted(r,a,"move",m.overwrite),await g.Promises.move(S,F)}catch(p){throw(p.code==="EINVAL"||p.code==="EBUSY"||p.code==="ENAMETOOLONG")&&(p=new Error((0,I.localize)(2,null,(0,c.basename)(S),(0,c.basename)((0,c.dirname)(F)),p.toString()))),this.toFileSystemProviderError(p)}}async copy(r,a,m){const S=this.toFilePath(r),F=this.toFilePath(a);if(S!==F)try{await this.validateTargetDeleted(r,a,"copy",m.overwrite),await g.Promises.copy(S,F,{preserveSymlinks:!0})}catch(p){throw(p.code==="EINVAL"||p.code==="EBUSY"||p.code==="ENAMETOOLONG")&&(p=new Error((0,I.localize)(3,null,(0,c.basename)(S),(0,c.basename)((0,c.dirname)(F)),p.toString()))),this.toFileSystemProviderError(p)}}async validateTargetDeleted(r,a,m,S){const F=this.toFilePath(r),p=this.toFilePath(a);let C=!1;if(!!(this.capabilities&1024)||(C=(0,L.isEqual)(F,p,!0)),C&&m==="copy")throw(0,u.createFileSystemProviderError)((0,I.localize)(4,null),u.FileSystemProviderErrorCode.FileExists);if(!C&&await g.Promises.exists(p)){if(!S)throw(0,u.createFileSystemProviderError)((0,I.localize)(5,null),u.FileSystemProviderErrorCode.FileExists);await this.delete(a,{recursive:!0,useTrash:!1})}}watch(r,a){return a.recursive?this.watchRecursive(r,a):this.watchNonRecursive(r)}watchRecursive(r,a){const m={path:this.toFilePath(r),excludes:a.excludes},S=(0,O.insert)(this.recursiveFoldersToWatch,m);return this.refreshRecursiveWatchers(),(0,T.toDisposable)(()=>{S(),this.refreshRecursiveWatchers()})}refreshRecursiveWatchers(){this.recursiveWatchRequestDelayer.trigger(async()=>{this.doRefreshRecursiveWatchers()})}doRefreshRecursiveWatchers(){if(this.recursiveWatcher instanceof E.FileWatcher)this.recursiveWatcher.watch(this.recursiveFoldersToWatch);else if((0,T.dispose)(this.recursiveWatcher),this.recursiveWatcher=void 0,this.recursiveFoldersToWatch.length>0){let r,a;if(this.options?.watcher?.usePolling)r=f.FileWatcher,a=this.options?.watcher;else{let m;this.options?.enableLegacyRecursiveWatcher?m=!0:m=e.default.quality==="stable"&&d.isLinux,m&&this.recursiveFoldersToWatch.length===1?d.isWindows?r=o.FileWatcher:r=f.FileWatcher:r=E.FileWatcher}this.recursiveWatcher=new r(this.recursiveFoldersToWatch,m=>this._onDidChangeFile.fire((0,h.toFileChanges)(m)),m=>{m.type==="error"&&this._onDidWatchErrorOccur.fire(m.message),this.logService[m.type](m.message)},this.logService.getLevel()===s.LogLevel.Trace,a),this.recursiveWatcherLogLevelListener||(this.recursiveWatcherLogLevelListener=this.logService.onDidChangeLogLevel(()=>{this.recursiveWatcher?.setVerboseLogging(this.logService.getLevel()===s.LogLevel.Trace)}))}}watchNonRecursive(r){const a=new y.FileWatcher(this.toFilePath(r),S=>this._onDidChangeFile.fire((0,h.toFileChanges)(S)),S=>{S.type==="error"&&this._onDidWatchErrorOccur.fire(S.message),this.logService[S.type](S.message)},this.logService.getLevel()===s.LogLevel.Trace),m=this.logService.onDidChangeLogLevel(()=>{a.setVerboseLogging(this.logService.getLevel()===s.LogLevel.Trace)});return(0,T.combinedDisposable)(a,m)}toFilePath(r){return(0,c.normalize)(r.fsPath)}toFileSystemProviderError(r){if(r instanceof u.FileSystemProviderError)return r;let a;switch(r.code){case"ENOENT":a=u.FileSystemProviderErrorCode.FileNotFound;break;case"EISDIR":a=u.FileSystemProviderErrorCode.FileIsADirectory;break;case"ENOTDIR":a=u.FileSystemProviderErrorCode.FileNotADirectory;break;case"EEXIST":a=u.FileSystemProviderErrorCode.FileExists;break;case"EPERM":case"EACCES":a=u.FileSystemProviderErrorCode.NoPermissions;break;default:a=u.FileSystemProviderErrorCode.Unknown}return(0,u.createFileSystemProviderError)(r,a)}async toFileSystemProviderWriteError(r,a){let m=this.toFileSystemProviderError(a);if(r&&m.code===u.FileSystemProviderErrorCode.NoPermissions)try{const{stat:S}=await g.SymlinkSupport.stat(this.toFilePath(r));S.mode&128||(m=(0,u.createFileSystemProviderError)(a,u.FileSystemProviderErrorCode.FileWriteLocked))}catch(S){this.logService.trace(S)}return m}dispose(){super.dispose(),(0,T.dispose)(this.recursiveWatcher),this.recursiveWatcher=void 0,(0,T.dispose)(this.recursiveWatcherLogLevelListener),this.recursiveWatcherLogLevelListener=void 0}}t.DiskFileSystemProvider=i}),define(Z[42],te([0,1,15]),function($,t,O){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.IProductService=void 0,t.IProductService=(0,O.createDecorator)("productService")}),define(Z[26],te([0,1,58,11]),function($,t,O,b){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.Registry=void 0;class w{constructor(){this.data=new Map}add(L,T){O.ok(b.isString(L)),O.ok(b.isObject(T)),O.ok(!this.data.has(L),"There is already an extension with this id"),this.data.set(L,T)}knows(L){return this.data.has(L)}as(L){return this.data.get(L)||null}}t.Registry=new w}),define(Z[108],te([0,1,13,26]),function($,t,O,b){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.Extensions=void 0,t.Extensions={JSONContribution:"base.contributions.json"};function w(T){return T.length>0&&T.charAt(T.length-1)==="#"?T.substring(0,T.length-1):T}class R{constructor(){this._onDidChangeSchema=new O.Emitter,this.onDidChangeSchema=this._onDidChangeSchema.event,this.schemasById={}}registerSchema(c,d){this.schemasById[w(c)]=d,this._onDidChangeSchema.fire(c)}notifySchemaChanged(c){this._onDidChangeSchema.fire(c)}getSchemaContributions(){return{schemas:this.schemasById}}}const L=new R;b.Registry.add(t.Extensions.JSONContribution,L)}),define(Z[33],te([0,1,20,13,11,73,108,26]),function($,t,O,b,w,R,L,T){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.getScopes=t.validateProperty=t.getDefaultValue=t.overrideIdentifierFromKey=t.OVERRIDE_PROPERTY_PATTERN=t.resourceLanguageSettingsSchemaId=t.resourceSettings=t.windowSettings=t.machineOverridableSettings=t.machineSettings=t.applicationSettings=t.allSettings=t.ConfigurationScope=t.Extensions=t.EditPresentationTypes=void 0;var c;(function(f){f.Multiline="multilineText",f.Singleline="singlelineText"})(c=t.EditPresentationTypes||(t.EditPresentationTypes={})),t.Extensions={Configuration:"base.contributions.configuration"};var d;(function(f){f[f.APPLICATION=1]="APPLICATION",f[f.MACHINE=2]="MACHINE",f[f.WINDOW=3]="WINDOW",f[f.RESOURCE=4]="RESOURCE",f[f.LANGUAGE_OVERRIDABLE=5]="LANGUAGE_OVERRIDABLE",f[f.MACHINE_OVERRIDABLE=6]="MACHINE_OVERRIDABLE"})(d=t.ConfigurationScope||(t.ConfigurationScope={})),t.allSettings={properties:{},patternProperties:{}},t.applicationSettings={properties:{},patternProperties:{}},t.machineSettings={properties:{},patternProperties:{}},t.machineOverridableSettings={properties:{},patternProperties:{}},t.windowSettings={properties:{},patternProperties:{}},t.resourceSettings={properties:{},patternProperties:{}},t.resourceLanguageSettingsSchemaId="vscode://schemas/settings/resourceLanguage";const v=T.Registry.as(L.Extensions.JSONContribution);class P{constructor(){this.overrideIdentifiers=new Set,this._onDidSchemaChange=new b.Emitter,this.onDidSchemaChange=this._onDidSchemaChange.event,this._onDidUpdateConfiguration=new b.Emitter,this.onDidUpdateConfiguration=this._onDidUpdateConfiguration.event,this.defaultValues={},this.defaultLanguageConfigurationOverridesNode={id:"defaultOverrides",title:R.localize(0,null),properties:{}},this.configurationContributors=[this.defaultLanguageConfigurationOverridesNode],this.resourceLanguageSettingsSchema={properties:{},patternProperties:{},additionalProperties:!1,errorMessage:"Unknown editor configuration setting",allowTrailingCommas:!0,allowComments:!0},this.configurationProperties={},this.excludedConfigurationProperties={},v.registerSchema(t.resourceLanguageSettingsSchemaId,this.resourceLanguageSettingsSchema)}registerConfiguration(h,o=!0){this.registerConfigurations([h],o)}registerConfigurations(h,o=!0){const s=this.doRegisterConfigurations(h,o);v.registerSchema(t.resourceLanguageSettingsSchemaId,this.resourceLanguageSettingsSchema),this._onDidSchemaChange.fire(),this._onDidUpdateConfiguration.fire(s)}deregisterConfigurations(h){const o=this.doDeregisterConfigurations(h);v.registerSchema(t.resourceLanguageSettingsSchemaId,this.resourceLanguageSettingsSchema),this._onDidSchemaChange.fire(),this._onDidUpdateConfiguration.fire(o)}updateConfigurations({add:h,remove:o}){const s=[];s.push(...this.doDeregisterConfigurations(o)),s.push(...this.doRegisterConfigurations(h,!1)),v.registerSchema(t.resourceLanguageSettingsSchemaId,this.resourceLanguageSettingsSchema),this._onDidSchemaChange.fire(),this._onDidUpdateConfiguration.fire((0,O.distinct)(s))}registerDefaultConfigurations(h){const o=[],s=[];for(const e of h)for(const i in e)if(o.push(i),t.OVERRIDE_PROPERTY_PATTERN.test(i)){this.defaultValues[i]={...this.defaultValues[i]||{},...e[i]};const n={type:"object",default:this.defaultValues[i],description:R.localize(1,null,i),$ref:t.resourceLanguageSettingsSchemaId};s.push(I(i)),this.configurationProperties[i]=n,this.defaultLanguageConfigurationOverridesNode.properties[i]=n}else{this.defaultValues[i]=e[i];const n=this.configurationProperties[i];n&&(this.updatePropertyDefaultValue(i,n),this.updateSchema(i,n))}this.registerOverrideIdentifiers(s),this._onDidSchemaChange.fire(),this._onDidUpdateConfiguration.fire(o)}deregisterDefaultConfigurations(h){const o=[];for(const s of h)for(const e in s)if(o.push(e),delete this.defaultValues[e],t.OVERRIDE_PROPERTY_PATTERN.test(e))delete this.configurationProperties[e],delete this.defaultLanguageConfigurationOverridesNode.properties[e];else{const i=this.configurationProperties[e];i&&(this.updatePropertyDefaultValue(e,i),this.updateSchema(e,i))}this.updateOverridePropertyPatternKey(),this._onDidSchemaChange.fire(),this._onDidUpdateConfiguration.fire(o)}notifyConfigurationSchemaUpdated(...h){this._onDidSchemaChange.fire()}registerOverrideIdentifiers(h){for(const o of h)this.overrideIdentifiers.add(o);this.updateOverridePropertyPatternKey()}doRegisterConfigurations(h,o){const s=[];return h.forEach(e=>{s.push(...this.validateAndRegisterProperties(e,o,e.extensionInfo)),this.configurationContributors.push(e),this.registerJSONConfiguration(e)}),s}doDeregisterConfigurations(h){const o=[],s=e=>{if(e.properties)for(const i in e.properties)o.push(i),delete this.configurationProperties[i],this.removeFromSchema(i,e.properties[i]);e.allOf&&e.allOf.forEach(i=>s(i))};for(const e of h){s(e);const i=this.configurationContributors.indexOf(e);i!==-1&&this.configurationContributors.splice(i,1)}return o}validateAndRegisterProperties(h,o=!0,s,e=3){e=w.isUndefinedOrNull(h.scope)?e:h.scope;let i=[],n=h.properties;if(n)for(let a in n){if(o&&y(a)){delete n[a];continue}const m=n[a];if(this.updatePropertyDefaultValue(a,m),t.OVERRIDE_PROPERTY_PATTERN.test(a)?m.scope=void 0:(m.scope=w.isUndefinedOrNull(m.scope)?e:m.scope,m.restricted=w.isUndefinedOrNull(m.restricted)?!!s?.restrictedConfigurations?.includes(a):m.restricted),n[a].hasOwnProperty("included")&&!n[a].included){this.excludedConfigurationProperties[a]=n[a],delete n[a];continue}else this.configurationProperties[a]=n[a];!n[a].deprecationMessage&&n[a].markdownDeprecationMessage&&(n[a].deprecationMessage=n[a].markdownDeprecationMessage),i.push(a)}let r=h.allOf;if(r)for(let a of r)i.push(...this.validateAndRegisterProperties(a,o,s,e));return i}getConfigurations(){return this.configurationContributors}getConfigurationProperties(){return this.configurationProperties}getExcludedConfigurationProperties(){return this.excludedConfigurationProperties}registerJSONConfiguration(h){const o=s=>{let e=s.properties;if(e)for(const n in e)this.updateSchema(n,e[n]);let i=s.allOf;i&&i.forEach(o)};o(h)}updateSchema(h,o){switch(t.allSettings.properties[h]=o,o.scope){case 1:t.applicationSettings.properties[h]=o;break;case 2:t.machineSettings.properties[h]=o;break;case 6:t.machineOverridableSettings.properties[h]=o;break;case 3:t.windowSettings.properties[h]=o;break;case 4:t.resourceSettings.properties[h]=o;break;case 5:t.resourceSettings.properties[h]=o,this.resourceLanguageSettingsSchema.properties[h]=o;break}}removeFromSchema(h,o){switch(delete t.allSettings.properties[h],o.scope){case 1:delete t.applicationSettings.properties[h];break;case 2:delete t.machineSettings.properties[h];break;case 6:delete t.machineOverridableSettings.properties[h];break;case 3:delete t.windowSettings.properties[h];break;case 4:case 5:delete t.resourceSettings.properties[h];break}}updateOverridePropertyPatternKey(){for(const h of this.overrideIdentifiers.values()){const o=`[${h}]`,s={type:"object",description:R.localize(2,null),errorMessage:R.localize(3,null),$ref:t.resourceLanguageSettingsSchemaId};this.updatePropertyDefaultValue(o,s),t.allSettings.properties[o]=s,t.applicationSettings.properties[o]=s,t.machineSettings.properties[o]=s,t.machineOverridableSettings.properties[o]=s,t.windowSettings.properties[o]=s,t.resourceSettings.properties[o]=s}this._onDidSchemaChange.fire()}updatePropertyDefaultValue(h,o){let s=this.defaultValues[h];w.isUndefined(s)&&(s=o.default),w.isUndefined(s)&&(s=u(o.type)),o.default=s}}const g="\\[.*\\]$";t.OVERRIDE_PROPERTY_PATTERN=new RegExp(g);function I(f){return f.substring(1,f.length-1)}t.overrideIdentifierFromKey=I;function u(f){switch(Array.isArray(f)?f[0]:f){case"boolean":return!1;case"integer":case"number":return 0;case"string":return"";case"array":return[];case"object":return{};default:return null}}t.getDefaultValue=u;const l=new P;T.Registry.add(t.Extensions.Configuration,l);function y(f){return f.trim()?t.OVERRIDE_PROPERTY_PATTERN.test(f)?R.localize(5,null,f):l.getConfigurationProperties()[f]!==void 0?R.localize(6,null,f):null:R.localize(4,null)}t.validateProperty=y;function E(){const f=[],h=l.getConfigurationProperties();for(const o of Object.keys(h))f.push([o,h[o].scope]);return f.push(["launch",4]),f.push(["task",4]),f}t.getScopes=E}),define(Z[27],te([0,1,18,11,7,33,15,26]),function($,t,O,b,w,R,L,T){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.getMigratedSettingValue=t.keyFromOverrideIdentifier=t.getDefaultValues=t.getConfigurationKeys=t.merge=t.getConfigurationValue=t.removeFromValueTree=t.addToValueTree=t.toValuesTree=t.toOverrides=t.compare=t.ConfigurationTargetToString=t.ConfigurationTarget=t.isConfigurationOverrides=t.IConfigurationService=void 0,t.IConfigurationService=(0,L.createDecorator)("configurationService");function c(i){return i&&typeof i=="object"&&(!i.overrideIdentifier||typeof i.overrideIdentifier=="string")&&(!i.resource||i.resource instanceof w.URI)}t.isConfigurationOverrides=c;var d;(function(i){i[i.USER=1]="USER",i[i.USER_LOCAL=2]="USER_LOCAL",i[i.USER_REMOTE=3]="USER_REMOTE",i[i.WORKSPACE=4]="WORKSPACE",i[i.WORKSPACE_FOLDER=5]="WORKSPACE_FOLDER",i[i.DEFAULT=6]="DEFAULT",i[i.MEMORY=7]="MEMORY"})(d=t.ConfigurationTarget||(t.ConfigurationTarget={}));function v(i){switch(i){case 1:return"USER";case 2:return"USER_LOCAL";case 3:return"USER_REMOTE";case 4:return"WORKSPACE";case 5:return"WORKSPACE_FOLDER";case 6:return"DEFAULT";case 7:return"MEMORY"}}t.ConfigurationTargetToString=v;function P(i,n){const r=n?i?n.keys.filter(N=>i.keys.indexOf(N)===-1):[...n.keys]:[],a=i?n?i.keys.filter(N=>n.keys.indexOf(N)===-1):[...i.keys]:[],m=[];if(n&&i){for(const N of i.keys)if(n.keys.indexOf(N)!==-1){const V=E(i.contents,N),Y=E(n.contents,N);O.equals(V,Y)||m.push(N)}}const S=[],F=N=>{const V={};for(const Y of N)for(const ie of Y.identifiers)V[s(ie)]=Y;return V},p=n?F(n.overrides):{},C=i?F(i.overrides):{};if(Object.keys(p).length)for(const N of r){const V=p[N];V&&S.push([(0,R.overrideIdentifierFromKey)(N),V.keys])}if(Object.keys(C).length)for(const N of a){const V=C[N];V&&S.push([(0,R.overrideIdentifierFromKey)(N),V.keys])}if(Object.keys(p).length&&Object.keys(C).length)for(const N of m){const V=C[N],Y=p[N];if(V&&Y){const ie=P({contents:V.contents,keys:V.keys,overrides:[]},{contents:Y.contents,keys:Y.keys,overrides:[]});S.push([(0,R.overrideIdentifierFromKey)(N),[...ie.added,...ie.removed,...ie.updated]])}}return{added:r,removed:a,updated:m,overrides:S}}t.compare=P;function g(i,n){const r=[];for(const a of Object.keys(i))if(R.OVERRIDE_PROPERTY_PATTERN.test(a)){const m={};for(const S in i[a])m[S]=i[a][S];r.push({identifiers:[(0,R.overrideIdentifierFromKey)(a).trim()],keys:Object.keys(m),contents:I(m,n)})}return r}t.toOverrides=g;function I(i,n){const r=Object.create(null);for(let a in i)u(r,a,i[a],n);return r}t.toValuesTree=I;function u(i,n,r,a){const m=n.split("."),S=m.pop();let F=i;for(let p=0;p<m.length;p++){let C=m[p],N=F[C];switch(typeof N){case"undefined":N=F[C]=Object.create(null);break;case"object":break;default:a(`Ignoring ${n} as ${m.slice(0,p+1).join(".")} is ${JSON.stringify(N)}`);return}F=N}if(typeof F=="object"&&F!==null)try{F[S]=r}catch(p){a(`Ignoring ${n} as ${m.join(".")} is ${JSON.stringify(F)}`)}else a(`Ignoring ${n} as ${m.join(".")} is ${JSON.stringify(F)}`)}t.addToValueTree=u;function l(i,n){const r=n.split(".");y(i,r)}t.removeFromValueTree=l;function y(i,n){const r=n.shift();if(n.length===0){delete i[r];return}if(Object.keys(i).indexOf(r)!==-1){const a=i[r];typeof a=="object"&&!Array.isArray(a)&&(y(a,n),Object.keys(a).length===0&&delete i[r])}}function E(i,n,r){function a(F,p){let C=F;for(const N of p){if(typeof C!="object"||C===null)return;C=C[N]}return C}const m=n.split("."),S=a(i,m);return typeof S=="undefined"?r:S}t.getConfigurationValue=E;function f(i,n,r){Object.keys(n).forEach(a=>{a!=="__proto__"&&(a in i?b.isObject(i[a])&&b.isObject(n[a])?f(i[a],n[a],r):r&&(i[a]=n[a]):i[a]=n[a])})}t.merge=f;function h(){const i=T.Registry.as(R.Extensions.Configuration).getConfigurationProperties();return Object.keys(i)}t.getConfigurationKeys=h;function o(){const i=Object.create(null),n=T.Registry.as(R.Extensions.Configuration).getConfigurationProperties();for(let r in n){let a=n[r].default;u(i,r,a,m=>console.error(`Conflict in default settings: ${m}`))}return i}t.getDefaultValues=o;function s(i){return`[${i}]`}t.keyFromOverrideIdentifier=s;function e(i,n,r){const a=i.inspect(n),m=i.inspect(r);return typeof a.userValue!="undefined"||typeof a.workspaceValue!="undefined"||typeof a.workspaceFolderValue!="undefined"?a.value:typeof m.userValue!="undefined"||typeof m.workspaceValue!="undefined"||typeof m.workspaceFolderValue!="undefined"?m.value:a.defaultValue}t.getMigratedSettingValue=e}),define(Z[109],te([0,1,20,13,59,2,46,18,11,7,27,33,26]),function($,t,O,b,w,R,L,T,c,d,v,P,g){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.AllKeysConfigurationChangeEvent=t.ConfigurationChangeEvent=t.mergeChanges=t.Configuration=t.UserSettings=t.ConfigurationModelParser=t.DefaultConfigurationModel=t.ConfigurationModel=void 0;class I{constructor(e={},i=[],n=[]){this._contents=e,this._keys=i,this._overrides=n,this.isFrozen=!1}get contents(){return this.checkAndFreeze(this._contents)}get overrides(){return this.checkAndFreeze(this._overrides)}get keys(){return this.checkAndFreeze(this._keys)}isEmpty(){return this._keys.length===0&&Object.keys(this._contents).length===0&&this._overrides.length===0}getValue(e){return e?(0,v.getConfigurationValue)(this.contents,e):this.contents}getOverrideValue(e,i){const n=this.getContentsForOverrideIdentifer(i);return n?e?(0,v.getConfigurationValue)(n,e):n:void 0}getKeysForOverrideIdentifier(e){for(const i of this.overrides)if(i.identifiers.indexOf(e)!==-1)return i.keys;return[]}override(e){const i=this.getContentsForOverrideIdentifer(e);if(!i||typeof i!="object"||!Object.keys(i).length)return this;let n={};for(const r of O.distinct([...Object.keys(this.contents),...Object.keys(i)])){let a=this.contents[r],m=i[r];m&&(typeof a=="object"&&typeof m=="object"?(a=T.deepClone(a),this.mergeContents(a,m)):a=m),n[r]=a}return new I(n,this.keys,this.overrides)}merge(...e){const i=T.deepClone(this.contents),n=T.deepClone(this.overrides),r=[...this.keys];for(const a of e){this.mergeContents(i,a.contents);for(const m of a.overrides){const[S]=n.filter(F=>O.equals(F.identifiers,m.identifiers));S?this.mergeContents(S.contents,m.contents):n.push(T.deepClone(m))}for(const m of a.keys)r.indexOf(m)===-1&&r.push(m)}return new I(i,r,n)}freeze(){return this.isFrozen=!0,this}mergeContents(e,i){for(const n of Object.keys(i)){if(n in e&&c.isObject(e[n])&&c.isObject(i[n])){this.mergeContents(e[n],i[n]);continue}e[n]=T.deepClone(i[n])}}checkAndFreeze(e){return this.isFrozen&&!Object.isFrozen(e)?T.deepFreeze(e):e}getContentsForOverrideIdentifer(e){for(const i of this.overrides)if(i.identifiers.indexOf(e)!==-1)return i.contents;return null}toJSON(){return{contents:this.contents,overrides:this.overrides,keys:this.keys}}setValue(e,i){this.addKey(e),(0,v.addToValueTree)(this.contents,e,i,n=>{throw new Error(n)})}removeValue(e){this.removeKey(e)&&(0,v.removeFromValueTree)(this.contents,e)}addKey(e){let i=this.keys.length;for(let n=0;n<i;n++)e.indexOf(this.keys[n])===0&&(i=n);this.keys.splice(i,1,e)}removeKey(e){let i=this.keys.indexOf(e);return i!==-1?(this.keys.splice(i,1),!0):!1}}t.ConfigurationModel=I;class u extends I{constructor(){const e=(0,v.getDefaultValues)(),i=(0,v.getConfigurationKeys)(),n=[];for(const r of Object.keys(e))P.OVERRIDE_PROPERTY_PATTERN.test(r)&&n.push({identifiers:[(0,P.overrideIdentifierFromKey)(r).trim()],keys:Object.keys(e[r]),contents:(0,v.toValuesTree)(e[r],a=>console.error(`Conflict in default settings file: ${a}`))});super(e,i,n)}}t.DefaultConfigurationModel=u;class l{constructor(e){this._name=e,this._raw=null,this._configurationModel=null,this._restrictedConfigurations=[],this._parseErrors=[]}get configurationModel(){return this._configurationModel||new I}get restrictedConfigurations(){return this._restrictedConfigurations}get errors(){return this._parseErrors}parse(e,i){if(!c.isUndefinedOrNull(e)){const n=this.doParseContent(e);this.parseRaw(n,i)}}reparse(e){this._raw&&this.parseRaw(this._raw,e)}parseRaw(e,i){this._raw=e;const{contents:n,keys:r,overrides:a,restricted:m}=this.doParseRaw(e,i);this._configurationModel=new I(n,r,a),this._restrictedConfigurations=m||[]}doParseContent(e){let i={},n=null,r=[],a=[],m=[];function S(p){Array.isArray(r)?r.push(p):n!==null&&(r[n]=p)}let F={onObjectBegin:()=>{let p={};S(p),a.push(r),r=p,n=null},onObjectProperty:p=>{n=p},onObjectEnd:()=>{r=a.pop()},onArrayBegin:()=>{let p=[];S(p),a.push(r),r=p,n=null},onArrayEnd:()=>{r=a.pop()},onLiteralValue:S,onError:(p,C,N)=>{m.push({error:p,offset:C,length:N})}};if(e)try{w.visit(e,F),i=r[0]||{}}catch(p){console.error(`Error while parsing settings file ${this._name}: ${p}`),this._parseErrors=[p]}return i}doParseRaw(e,i){const n=g.Registry.as(P.Extensions.Configuration).getConfigurationProperties(),r=this.filter(e,n,!0,i);e=r.raw;const a=(0,v.toValuesTree)(e,F=>console.error(`Conflict in settings file ${this._name}: ${F}`)),m=Object.keys(e),S=(0,v.toOverrides)(e,F=>console.error(`Conflict in settings file ${this._name}: ${F}`));return{contents:a,keys:m,overrides:S,restricted:r.restricted}}filter(e,i,n,r){if(!r?.scopes&&!r?.skipRestricted)return{raw:e,restricted:[]};const a={},m=[];for(let S in e)if(P.OVERRIDE_PROPERTY_PATTERN.test(S)&&n){const F=this.filter(e[S],i,!1,r);a[S]=F.raw,m.push(...F.restricted)}else{const F=i[S],p=F?typeof F.scope!="undefined"?F.scope:3:void 0;F?.restricted&&m.push(S),(p===void 0||r.scopes===void 0||r.scopes.includes(p))&&(r.skipRestricted&&F?.restricted||(a[S]=e[S]))}return{raw:a,restricted:m}}}t.ConfigurationModelParser=l;class y extends R.Disposable{constructor(e,i,n,r){super();this.userSettingsResource=e,this.scopes=i,this.fileService=r,this._onDidChange=this._register(new b.Emitter),this.onDidChange=this._onDidChange.event,this.parser=new l(this.userSettingsResource.toString()),this.parseOptions={scopes:this.scopes},this._register(this.fileService.watch(n.dirname(this.userSettingsResource))),this._register(this.fileService.watch(this.userSettingsResource)),this._register(b.Event.filter(this.fileService.onDidFilesChange,a=>a.contains(this.userSettingsResource))(()=>this._onDidChange.fire()))}async loadConfiguration(){try{const e=await this.fileService.readFile(this.userSettingsResource);return this.parser.parse(e.value.toString()||"{}",this.parseOptions),this.parser.configurationModel}catch(e){return new I}}reparse(){return this.parser.reparse(this.parseOptions),this.parser.configurationModel}getRestrictedSettings(){return this.parser.restrictedConfigurations}}t.UserSettings=y;class E{constructor(e,i,n=new I,r=new I,a=new L.ResourceMap,m=new I,S=new L.ResourceMap,F=!0){this._defaultConfiguration=e,this._localUserConfiguration=i,this._remoteUserConfiguration=n,this._workspaceConfiguration=r,this._folderConfigurations=a,this._memoryConfiguration=m,this._memoryConfigurationByResource=S,this._freeze=F,this._workspaceConsolidatedConfiguration=null,this._foldersConsolidatedConfigurations=new L.ResourceMap,this._userConfiguration=null}getValue(e,i,n){return this.getConsolidateConfigurationModel(i,n).getValue(e)}updateValue(e,i,n={}){let r;n.resource?(r=this._memoryConfigurationByResource.get(n.resource),r||(r=new I,this._memoryConfigurationByResource.set(n.resource,r))):r=this._memoryConfiguration,i===void 0?r.removeValue(e):r.setValue(e,i),n.resource||(this._workspaceConsolidatedConfiguration=null)}inspect(e,i,n){const r=this.getConsolidateConfigurationModel(i,n),a=this.getFolderConfigurationModelForResource(i.resource,n),m=i.resource?this._memoryConfigurationByResource.get(i.resource)||this._memoryConfiguration:this._memoryConfiguration,S=i.overrideIdentifier?this._defaultConfiguration.freeze().override(i.overrideIdentifier).getValue(e):this._defaultConfiguration.freeze().getValue(e),F=i.overrideIdentifier?this.userConfiguration.freeze().override(i.overrideIdentifier).getValue(e):this.userConfiguration.freeze().getValue(e),p=i.overrideIdentifier?this.localUserConfiguration.freeze().override(i.overrideIdentifier).getValue(e):this.localUserConfiguration.freeze().getValue(e),C=i.overrideIdentifier?this.remoteUserConfiguration.freeze().override(i.overrideIdentifier).getValue(e):this.remoteUserConfiguration.freeze().getValue(e),N=n?i.overrideIdentifier?this._workspaceConfiguration.freeze().override(i.overrideIdentifier).getValue(e):this._workspaceConfiguration.freeze().getValue(e):void 0,V=a?i.overrideIdentifier?a.freeze().override(i.overrideIdentifier).getValue(e):a.freeze().getValue(e):void 0,Y=i.overrideIdentifier?m.override(i.overrideIdentifier).getValue(e):m.getValue(e),ie=r.getValue(e),oe=O.distinct(O.flatten(r.overrides.map(ee=>ee.identifiers))).filter(ee=>r.getOverrideValue(e,ee)!==void 0);return{defaultValue:S,userValue:F,userLocalValue:p,userRemoteValue:C,workspaceValue:N,workspaceFolderValue:V,memoryValue:Y,value:ie,default:S!==void 0?{value:this._defaultConfiguration.freeze().getValue(e),override:i.overrideIdentifier?this._defaultConfiguration.freeze().getOverrideValue(e,i.overrideIdentifier):void 0}:void 0,user:F!==void 0?{value:this.userConfiguration.freeze().getValue(e),override:i.overrideIdentifier?this.userConfiguration.freeze().getOverrideValue(e,i.overrideIdentifier):void 0}:void 0,userLocal:p!==void 0?{value:this.localUserConfiguration.freeze().getValue(e),override:i.overrideIdentifier?this.localUserConfiguration.freeze().getOverrideValue(e,i.overrideIdentifier):void 0}:void 0,userRemote:C!==void 0?{value:this.remoteUserConfiguration.freeze().getValue(e),override:i.overrideIdentifier?this.remoteUserConfiguration.freeze().getOverrideValue(e,i.overrideIdentifier):void 0}:void 0,workspace:N!==void 0?{value:this._workspaceConfiguration.freeze().getValue(e),override:i.overrideIdentifier?this._workspaceConfiguration.freeze().getOverrideValue(e,i.overrideIdentifier):void 0}:void 0,workspaceFolder:V!==void 0?{value:a?.freeze().getValue(e),override:i.overrideIdentifier?a?.freeze().getOverrideValue(e,i.overrideIdentifier):void 0}:void 0,memory:Y!==void 0?{value:m.getValue(e),override:i.overrideIdentifier?m.getOverrideValue(e,i.overrideIdentifier):void 0}:void 0,overrideIdentifiers:oe.length?oe:void 0}}keys(e){const i=this.getFolderConfigurationModelForResource(void 0,e);return{default:this._defaultConfiguration.freeze().keys,user:this.userConfiguration.freeze().keys,workspace:this._workspaceConfiguration.freeze().keys,workspaceFolder:i?i.freeze().keys:[]}}updateDefaultConfiguration(e){this._defaultConfiguration=e,this._workspaceConsolidatedConfiguration=null,this._foldersConsolidatedConfigurations.clear()}updateLocalUserConfiguration(e){this._localUserConfiguration=e,this._userConfiguration=null,this._workspaceConsolidatedConfiguration=null,this._foldersConsolidatedConfigurations.clear()}updateRemoteUserConfiguration(e){this._remoteUserConfiguration=e,this._userConfiguration=null,this._workspaceConsolidatedConfiguration=null,this._foldersConsolidatedConfigurations.clear()}updateWorkspaceConfiguration(e){this._workspaceConfiguration=e,this._workspaceConsolidatedConfiguration=null,this._foldersConsolidatedConfigurations.clear()}updateFolderConfiguration(e,i){this._folderConfigurations.set(e,i),this._foldersConsolidatedConfigurations.delete(e)}deleteFolderConfiguration(e){this.folderConfigurations.delete(e),this._foldersConsolidatedConfigurations.delete(e)}compareAndUpdateDefaultConfiguration(e,i){const n=i.filter(r=>P.OVERRIDE_PROPERTY_PATTERN.test(r)).map(r=>{const a=(0,P.overrideIdentifierFromKey)(r),m=this._defaultConfiguration.getKeysForOverrideIdentifier(a),S=e.getKeysForOverrideIdentifier(a),F=[...S.filter(p=>m.indexOf(p)===-1),...m.filter(p=>S.indexOf(p)===-1),...m.filter(p=>!T.equals(this._defaultConfiguration.override(a).getValue(p),e.override(a).getValue(p)))];return[a,F]});return this.updateDefaultConfiguration(e),{keys:i,overrides:n}}compareAndUpdateLocalUserConfiguration(e){const{added:i,updated:n,removed:r,overrides:a}=(0,v.compare)(this.localUserConfiguration,e),m=[...i,...n,...r];return m.length&&this.updateLocalUserConfiguration(e),{keys:m,overrides:a}}compareAndUpdateRemoteUserConfiguration(e){const{added:i,updated:n,removed:r,overrides:a}=(0,v.compare)(this.remoteUserConfiguration,e);let m=[...i,...n,...r];return m.length&&this.updateRemoteUserConfiguration(e),{keys:m,overrides:a}}compareAndUpdateWorkspaceConfiguration(e){const{added:i,updated:n,removed:r,overrides:a}=(0,v.compare)(this.workspaceConfiguration,e);let m=[...i,...n,...r];return m.length&&this.updateWorkspaceConfiguration(e),{keys:m,overrides:a}}compareAndUpdateFolderConfiguration(e,i){const n=this.folderConfigurations.get(e),{added:r,updated:a,removed:m,overrides:S}=(0,v.compare)(n,i);let F=[...r,...a,...m];return(F.length||!n)&&this.updateFolderConfiguration(e,i),{keys:F,overrides:S}}compareAndDeleteFolderConfiguration(e){const i=this.folderConfigurations.get(e);if(!i)throw new Error("Unknown folder");this.deleteFolderConfiguration(e);const{added:n,updated:r,removed:a,overrides:m}=(0,v.compare)(i,void 0);return{keys:[...n,...r,...a],overrides:m}}get defaults(){return this._defaultConfiguration}get userConfiguration(){return this._userConfiguration||(this._userConfiguration=this._remoteUserConfiguration.isEmpty()?this._localUserConfiguration:this._localUserConfiguration.merge(this._remoteUserConfiguration),this._freeze&&this._userConfiguration.freeze()),this._userConfiguration}get localUserConfiguration(){return this._localUserConfiguration}get remoteUserConfiguration(){return this._remoteUserConfiguration}get workspaceConfiguration(){return this._workspaceConfiguration}get folderConfigurations(){return this._folderConfigurations}getConsolidateConfigurationModel(e,i){let n=this.getConsolidatedConfigurationModelForResource(e,i);return e.overrideIdentifier?n.override(e.overrideIdentifier):n}getConsolidatedConfigurationModelForResource({resource:e},i){let n=this.getWorkspaceConsolidatedConfiguration();if(i&&e){const r=i.getFolder(e);r&&(n=this.getFolderConsolidatedConfiguration(r.uri)||n);const a=this._memoryConfigurationByResource.get(e);a&&(n=n.merge(a))}return n}getWorkspaceConsolidatedConfiguration(){return this._workspaceConsolidatedConfiguration||(this._workspaceConsolidatedConfiguration=this._defaultConfiguration.merge(this.userConfiguration,this._workspaceConfiguration,this._memoryConfiguration),this._freeze&&(this._workspaceConfiguration=this._workspaceConfiguration.freeze())),this._workspaceConsolidatedConfiguration}getFolderConsolidatedConfiguration(e){let i=this._foldersConsolidatedConfigurations.get(e);if(!i){const n=this.getWorkspaceConsolidatedConfiguration(),r=this._folderConfigurations.get(e);r?(i=n.merge(r),this._freeze&&(i=i.freeze()),this._foldersConsolidatedConfigurations.set(e,i)):i=n}return i}getFolderConfigurationModelForResource(e,i){if(i&&e){const n=i.getFolder(e);if(n)return this._folderConfigurations.get(n.uri)}}toData(){return{defaults:{contents:this._defaultConfiguration.contents,overrides:this._defaultConfiguration.overrides,keys:this._defaultConfiguration.keys},user:{contents:this.userConfiguration.contents,overrides:this.userConfiguration.overrides,keys:this.userConfiguration.keys},workspace:{contents:this._workspaceConfiguration.contents,overrides:this._workspaceConfiguration.overrides,keys:this._workspaceConfiguration.keys},folders:[...this._folderConfigurations.keys()].reduce((e,i)=>{const{contents:n,overrides:r,keys:a}=this._folderConfigurations.get(i);return e.push([i,{contents:n,overrides:r,keys:a}]),e},[])}}allKeys(){const e=new Set;return this._defaultConfiguration.freeze().keys.forEach(i=>e.add(i)),this.userConfiguration.freeze().keys.forEach(i=>e.add(i)),this._workspaceConfiguration.freeze().keys.forEach(i=>e.add(i)),this._folderConfigurations.forEach(i=>i.freeze().keys.forEach(n=>e.add(n))),[...e.values()]}getAllKeysForOverrideIdentifier(e){const i=new Set;return this._defaultConfiguration.getKeysForOverrideIdentifier(e).forEach(n=>i.add(n)),this.userConfiguration.getKeysForOverrideIdentifier(e).forEach(n=>i.add(n)),this._workspaceConfiguration.getKeysForOverrideIdentifier(e).forEach(n=>i.add(n)),this._folderConfigurations.forEach(n=>n.getKeysForOverrideIdentifier(e).forEach(r=>i.add(r))),[...i.values()]}static parse(e){const i=this.parseConfigurationModel(e.defaults),n=this.parseConfigurationModel(e.user),r=this.parseConfigurationModel(e.workspace),a=e.folders.reduce((m,S)=>(m.set(d.URI.revive(S[0]),this.parseConfigurationModel(S[1])),m),new L.ResourceMap);return new E(i,n,new I,r,a,new I,new L.ResourceMap,!1)}static parseConfigurationModel(e){return new I(e.contents,e.keys,e.overrides).freeze()}}t.Configuration=E;function f(...s){if(s.length===0)return{keys:[],overrides:[]};if(s.length===1)return s[0];const e=new Set,i=new Map;for(const r of s)r.keys.forEach(a=>e.add(a)),r.overrides.forEach(([a,m])=>{const S=(0,L.getOrSet)(i,a,new Set);m.forEach(F=>S.add(F))});const n=[];return i.forEach((r,a)=>n.push([a,[...r.values()]])),{keys:[...e.values()],overrides:n}}t.mergeChanges=f;class h{constructor(e,i,n,r){this.change=e,this.previous=i,this.currentConfiguraiton=n,this.currentWorkspace=r,this._previousConfiguration=void 0;const a=new Set;e.keys.forEach(S=>a.add(S)),e.overrides.forEach(([,S])=>S.forEach(F=>a.add(F))),this.affectedKeys=[...a.values()];const m=new I;this.affectedKeys.forEach(S=>m.setValue(S,{})),this.affectedKeysTree=m.contents}get previousConfiguration(){return!this._previousConfiguration&&this.previous&&(this._previousConfiguration=E.parse(this.previous.data)),this._previousConfiguration}affectsConfiguration(e,i){if(this.doesAffectedKeysTreeContains(this.affectedKeysTree,e)){if(i){const n=this.previousConfiguration?this.previousConfiguration.getValue(e,i,this.previous?.workspace):void 0,r=this.currentConfiguraiton.getValue(e,i,this.currentWorkspace);return!T.equals(n,r)}return!0}return!1}doesAffectedKeysTreeContains(e,i){let n=(0,v.toValuesTree)({[i]:!0},()=>{}),r;for(;typeof n=="object"&&(r=Object.keys(n)[0]);){if(e=e[r],!e)return!1;n=n[r]}return!0}}t.ConfigurationChangeEvent=h;class o extends h{constructor(e,i,n,r){super({keys:e.allKeys(),overrides:[]},void 0,e,i);this.source=n,this.sourceConfig=r}}t.AllKeysConfigurationChangeEvent=o}),define(Z[110],te([0,1,3,13,2,19,27,109,33,26]),function($,t,O,b,w,R,L,T,c,d){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.ConfigurationService=void 0;class v extends w.Disposable{constructor(g,I){super();this.settingsResource=g,this._onDidChangeConfiguration=this._register(new b.Emitter),this.onDidChangeConfiguration=this._onDidChangeConfiguration.event,this.userConfiguration=this._register(new T.UserSettings(this.settingsResource,void 0,R.extUriBiasedIgnorePathCase,I)),this.configuration=new T.Configuration(new T.DefaultConfigurationModel,new T.ConfigurationModel),this.reloadConfigurationScheduler=this._register(new O.RunOnceScheduler(()=>this.reloadConfiguration(),50)),this._register(d.Registry.as(c.Extensions.Configuration).onDidUpdateConfiguration(u=>this.onDidDefaultConfigurationChange(u))),this._register(this.userConfiguration.onDidChange(()=>this.reloadConfigurationScheduler.schedule()))}async initialize(){const g=await this.userConfiguration.loadConfiguration();this.configuration=new T.Configuration(new T.DefaultConfigurationModel,g)}getConfigurationData(){return this.configuration.toData()}getValue(g,I){const u=typeof g=="string"?g:void 0,l=(0,L.isConfigurationOverrides)(g)?g:(0,L.isConfigurationOverrides)(I)?I:{};return this.configuration.getValue(u,l,void 0)}updateValue(g,I,u,l){return Promise.reject(new Error("not supported"))}inspect(g){return this.configuration.inspect(g,{},void 0)}keys(){return this.configuration.keys(void 0)}async reloadConfiguration(){const g=await this.userConfiguration.loadConfiguration();this.onDidChangeUserConfiguration(g)}onDidChangeUserConfiguration(g){const I=this.configuration.toData(),u=this.configuration.compareAndUpdateLocalUserConfiguration(g);this.trigger(u,I,1)}onDidDefaultConfigurationChange(g){const I=this.configuration.toData(),u=this.configuration.compareAndUpdateDefaultConfiguration(new T.DefaultConfigurationModel,g);this.trigger(u,I,6)}trigger(g,I,u){const l=new T.ConfigurationChangeEvent(g,{data:I},this.configuration);l.source=u,l.sourceConfig=this.getTargetConfiguration(u),this._onDidChangeConfiguration.fire(l)}getTargetConfiguration(g){switch(g){case 6:return this.configuration.defaults.contents;case 1:return this.configuration.localUserConfiguration.contents}return{}}}t.ConfigurationService=v}),define(Z[43],te([0,1,17,84,33,15,26]),function($,t,O,b,w,R,L){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.updateProxyConfigurationsScope=t.asJson=t.asText=t.isSuccess=t.IRequestService=void 0,t.IRequestService=(0,R.createDecorator)("requestService");function T(u){return u.res.statusCode&&u.res.statusCode>=200&&u.res.statusCode<300||u.res.statusCode===1223}t.isSuccess=T;function c(u){return u.res.statusCode===204}async function d(u){if(!T(u))throw new Error("Server returned "+u.res.statusCode);return c(u)?null:(await(0,O.streamToBuffer)(u.stream)).toString()}t.asText=d;async function v(u){if(!T(u))throw new Error("Server returned "+u.res.statusCode);if(c(u))return null;const y=(await(0,O.streamToBuffer)(u.stream)).toString();try{return JSON.parse(y)}catch(E){throw E.message+=`:
`+y,E}}t.asJson=v;function P(u){I(u)}t.updateProxyConfigurationsScope=P;let g;function I(u){const l=L.Registry.as(w.Extensions.Configuration),y=g;g={id:"http",order:15,title:(0,b.localize)(0,null),type:"object",scope:u,properties:{"http.proxy":{type:"string",pattern:"^https?://([^:]*(:[^@]*)?@)?([^:]+|\\[[:0-9a-fA-F]+\\])(:\\d+)?/?$|^$",markdownDescription:(0,b.localize)(1,null),restricted:!0},"http.proxyStrictSSL":{type:"boolean",default:!0,description:(0,b.localize)(2,null),restricted:!0},"http.proxyAuthorization":{type:["null","string"],default:null,markdownDescription:(0,b.localize)(3,null),restricted:!0},"http.proxySupport":{type:"string",enum:["off","on","fallback","override"],enumDescriptions:[(0,b.localize)(4,null),(0,b.localize)(5,null),(0,b.localize)(6,null),(0,b.localize)(7,null)],default:"override",description:(0,b.localize)(8,null),restricted:!0},"http.systemCertificates":{type:"boolean",default:!0,description:(0,b.localize)(9,null),restricted:!0}}},l.updateConfigurations({add:[g],remove:y?[y]:[]})}I(2)}),define(Z[111],te([0,1,25,8,16,43]),function($,t,O,b,w,R){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.DownloadService=void 0;let L=class{constructor(c,d){this.requestService=c,this.fileService=d}async download(c,d,v=O.CancellationToken.None){if(c.scheme===b.Schemas.file||c.scheme===b.Schemas.vscodeRemote){await this.fileService.copy(c,d);return}const P={type:"GET",url:c.toString()},g=await this.requestService.request(P,v);if(g.res.statusCode===200)await this.fileService.writeFile(d,g.stream);else{const I=await(0,R.asText)(g);throw new Error(`Expected 200, got back ${g.res.statusCode} instead.

${I}`)}}};L=de([le(0,R.IRequestService),le(1,w.IFileService)],L),t.DownloadService=L}),define(Z[112],te([0,1,113,11]),function($,t,O,b){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.getProxyAgent=void 0;function w(L,T){return L.protocol==="http:"?T.HTTP_PROXY||T.http_proxy||null:L.protocol==="https:"&&(T.HTTPS_PROXY||T.https_proxy||T.HTTP_PROXY||T.http_proxy)||null}async function R(L,T,c={}){const d=(0,O.parse)(L),v=c.proxyUrl||w(d,T);if(!v)return null;const P=(0,O.parse)(v);if(!/^https?:$/.test(P.protocol||""))return null;const g={host:P.hostname||"",port:P.port||(P.protocol==="https"?"443":"80"),auth:P.auth,rejectUnauthorized:(0,b.isBoolean)(c.strictSSL)?c.strictSSL:!0};return d.protocol==="http:"?new(await new Promise((I,u)=>{$(["http-proxy-agent"],I,u)}))(g):new(await new Promise((I,u)=>{$(["https-proxy-agent"],I,u)}))(g)}t.getProxyAgent=R}),define(Z[114],te([0,1,17,31]),function($,t,O,b){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.getServiceMachineId=void 0;async function w(R,L,T){let c=T&&T.get("storage.serviceMachineId",0)||null;if(c)return c;try{const v=(await L.readFile(R.serviceMachineIdResource)).value.toString();c=(0,b.isUUID)(v)?v:null}catch(d){c=null}if(!c){c=(0,b.generateUuid)();try{await L.writeFile(R.serviceMachineIdResource,O.VSBuffer.fromString(c))}catch(d){}}return T&&T.store("storage.serviceMachineId",c,0,1),c}t.getServiceMachineId=w}),define(Z[115],te([0,1,3,13,2,11,66,15]),function($,t,O,b,w,R,L,T){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.logStorage=t.InMemoryStorageService=t.AbstractStorageService=t.StorageTarget=t.StorageScope=t.WillSaveStateReason=t.IStorageService=t.IS_NEW_KEY=void 0,t.IS_NEW_KEY="__$__isNewStorageMarker";const c="__$__targetStorageMarker";t.IStorageService=(0,T.createDecorator)("storageService");var d;(function(l){l[l.NONE=0]="NONE",l[l.SHUTDOWN=1]="SHUTDOWN"})(d=t.WillSaveStateReason||(t.WillSaveStateReason={}));var v;(function(l){l[l.GLOBAL=0]="GLOBAL",l[l.WORKSPACE=1]="WORKSPACE"})(v=t.StorageScope||(t.StorageScope={}));var P;(function(l){l[l.USER=0]="USER",l[l.MACHINE=1]="MACHINE"})(P=t.StorageTarget||(t.StorageTarget={}));class g extends w.Disposable{constructor(y={flushInterval:g.DEFAULT_FLUSH_INTERVAL}){super();this.options=y,this._onDidChangeValue=this._register(new b.PauseableEmitter),this.onDidChangeValue=this._onDidChangeValue.event,this._onDidChangeTarget=this._register(new b.PauseableEmitter),this.onDidChangeTarget=this._onDidChangeTarget.event,this._onWillSaveState=this._register(new b.Emitter),this.onWillSaveState=this._onWillSaveState.event,this.flushWhenIdleScheduler=this._register(new O.RunOnceScheduler(()=>this.doFlushWhenIdle(),this.options.flushInterval)),this.runFlushWhenIdle=this._register(new w.MutableDisposable),this._workspaceKeyTargets=void 0,this._globalKeyTargets=void 0}doFlushWhenIdle(){this.runFlushWhenIdle.value=(0,O.runWhenIdle)(()=>{this.shouldFlushWhenIdle()&&this.flush(),this.flushWhenIdleScheduler.schedule()})}shouldFlushWhenIdle(){return!0}stopFlushWhenIdle(){(0,w.dispose)([this.runFlushWhenIdle,this.flushWhenIdleScheduler])}initialize(){return this.initializationPromise||(this.initializationPromise=(async()=>{await this.doInitialize(),this.flushWhenIdleScheduler.schedule()})()),this.initializationPromise}emitDidChangeValue(y,E){E===c?(y===0?this._globalKeyTargets=void 0:y===1&&(this._workspaceKeyTargets=void 0),this._onDidChangeTarget.fire({scope:y})):this._onDidChangeValue.fire({scope:y,key:E,target:this.getKeyTargets(y)[E]})}emitWillSaveState(y){this._onWillSaveState.fire({reason:y})}get(y,E,f){return this.getStorage(E)?.get(y,f)}getBoolean(y,E,f){return this.getStorage(E)?.getBoolean(y,f)}getNumber(y,E,f){return this.getStorage(E)?.getNumber(y,f)}store(y,E,f,h){if((0,R.isUndefinedOrNull)(E)){this.remove(y,f);return}this.withPausedEmitters(()=>{this.updateKeyTarget(y,f,h),this.getStorage(f)?.set(y,E)})}remove(y,E){this.withPausedEmitters(()=>{this.updateKeyTarget(y,E,void 0),this.getStorage(E)?.delete(y)})}withPausedEmitters(y){this._onDidChangeValue.pause(),this._onDidChangeTarget.pause();try{y()}finally{this._onDidChangeValue.resume(),this._onDidChangeTarget.resume()}}keys(y,E){const f=[],h=this.getKeyTargets(y);for(const o of Object.keys(h))h[o]===E&&f.push(o);return f}updateKeyTarget(y,E,f){const h=this.getKeyTargets(E);typeof f=="number"?h[y]!==f&&(h[y]=f,this.getStorage(E)?.set(c,JSON.stringify(h))):typeof h[y]=="number"&&(delete h[y],this.getStorage(E)?.set(c,JSON.stringify(h)))}get workspaceKeyTargets(){return this._workspaceKeyTargets||(this._workspaceKeyTargets=this.loadKeyTargets(1)),this._workspaceKeyTargets}get globalKeyTargets(){return this._globalKeyTargets||(this._globalKeyTargets=this.loadKeyTargets(0)),this._globalKeyTargets}getKeyTargets(y){return y===0?this.globalKeyTargets:this.workspaceKeyTargets}loadKeyTargets(y){const E=this.get(c,y);if(E)try{return JSON.parse(E)}catch(f){}return Object.create(null)}isNew(y){return this.getBoolean(t.IS_NEW_KEY,y)===!0}async flush(y=d.NONE){this._onWillSaveState.fire({reason:y}),await O.Promises.settled([this.getStorage(0)?.whenFlushed()??Promise.resolve(),this.getStorage(1)?.whenFlushed()??Promise.resolve()])}async logStorage(){const y=this.getStorage(0)?.items??new Map,E=this.getStorage(1)?.items??new Map;return u(y,E,this.getLogDetails(0)??"",this.getLogDetails(1)??"")}}t.AbstractStorageService=g,g.DEFAULT_FLUSH_INTERVAL=60*1e3;class I extends g{constructor(){super();this.globalStorage=this._register(new L.Storage(new L.InMemoryStorageDatabase)),this.workspaceStorage=this._register(new L.Storage(new L.InMemoryStorageDatabase)),this._register(this.workspaceStorage.onDidChangeStorage(y=>this.emitDidChangeValue(1,y))),this._register(this.globalStorage.onDidChangeStorage(y=>this.emitDidChangeValue(0,y)))}getStorage(y){return y===0?this.globalStorage:this.workspaceStorage}getLogDetails(y){return y===0?"inMemory (global)":"inMemory (workspace)"}async doInitialize(){}async migrate(y){}}t.InMemoryStorageService=I;async function u(l,y,E,f){const h=a=>{try{return JSON.parse(a)}catch(m){return a}},o=new Map,s=new Map;l.forEach((a,m)=>{o.set(m,a),s.set(m,h(a))});const e=new Map,i=new Map;y.forEach((a,m)=>{e.set(m,a),i.set(m,h(a))}),console.group(`Storage: Global (path: ${E})`);let n=[];o.forEach((a,m)=>{n.push({key:m,value:a})}),console.table(n),console.groupEnd(),console.log(s),console.group(`Storage: Workspace (path: ${f})`);let r=[];e.forEach((a,m)=>{r.push({key:m,value:a})}),console.table(r),console.groupEnd(),console.log(i)}t.logStorage=u}),define(Z[116],te([0,1,10,28,7,31]),function($,t,O,b,w,R){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.verifyMicrosoftInternalDomain=t.resolveCommonProperties=void 0;function L(d){if(O.platform===2&&/^penguin(\.|$)/i.test(d))return"chromebook"}async function T(d,v,P,g,I,u,l,y,E,f){const h=Object.create(null);h["common.machineId"]=l,h.sessionID=(0,R.generateUuid)()+Date.now(),h.commitHash=I,h.version=u,h["common.platformVersion"]=(v||"").replace(/^(\d+)(\.\d+)?(\.\d+)?(.*)/,"$1$2$3"),h["common.platform"]=(0,O.PlatformToString)(O.platform),h["common.nodePlatform"]=b.platform,h["common.nodeArch"]=g,h["common.product"]=f||"desktop";const o=c(y||[]);o&&(h["common.msftInternal"]=o);let s=0;const e=Date.now();Object.defineProperties(h,{timestamp:{get:()=>new Date,enumerable:!0},"common.timesincesessionstart":{get:()=>Date.now()-e,enumerable:!0},"common.sequence":{get:()=>s++,enumerable:!0}}),O.isLinuxSnap&&(h["common.snap"]="true");const i=L(P);i&&(h["common.platformDetail"]=i);try{const n=await d.readFile(w.URI.file(E));h["common.source"]=n.value.toString().slice(0,30)}catch(n){}return h}t.resolveCommonProperties=T;function c(d){const v=b.env.USERDNSDOMAIN;if(!v)return!1;const P=v.toLowerCase();return d.some(g=>P===g)}t.verifyMicrosoftInternalDomain=c}),define(Z[29],te([0,1,15]),function($,t,O){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.TelemetryConfiguration=t.TelemetryLevel=t.TELEMETRY_OLD_SETTING_ID=t.TELEMETRY_SETTING_ID=t.TELEMETRY_SECTION_ID=t.machineIdKey=t.lastSessionDateStorageKey=t.firstSessionDateStorageKey=t.currentSessionDateStorageKey=t.instanceStorageKey=t.ICustomEndpointTelemetryService=t.ITelemetryService=void 0,t.ITelemetryService=(0,O.createDecorator)("telemetryService"),t.ICustomEndpointTelemetryService=(0,O.createDecorator)("customEndpointTelemetryService"),t.instanceStorageKey="telemetry.instanceId",t.currentSessionDateStorageKey="telemetry.currentSessionDate",t.firstSessionDateStorageKey="telemetry.firstSessionDate",t.lastSessionDateStorageKey="telemetry.lastSessionDate",t.machineIdKey="telemetry.machineId",t.TELEMETRY_SECTION_ID="telemetry",t.TELEMETRY_SETTING_ID="telemetry.telemetryLevel",t.TELEMETRY_OLD_SETTING_ID="telemetry.enableTelemetry";var b;(function(R){R[R.NONE=0]="NONE",R[R.ERROR=2]="ERROR",R[R.USAGE=3]="USAGE"})(b=t.TelemetryLevel||(t.TelemetryLevel={}));var w;(function(R){R.OFF="off",R.ERROR="error",R.ON="on"})(w=t.TelemetryConfiguration||(t.TelemetryConfiguration={}))}),define(Z[117],te([0,1,20,3,25,9,13,2,10,7,74,23,24,14,32,29]),function($,t,O,b,w,R,L,T,c,d,v,P,g,I,u,l){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.AbstractExtensionTask=t.reportTelemetry=t.joinErrors=t.AbstractExtensionManagementService=t.INSTALL_ERROR_LOCAL=t.ERROR_UNKNOWN=t.INSTALL_ERROR_VALIDATING=void 0,t.INSTALL_ERROR_VALIDATING="validating",t.ERROR_UNKNOWN="unknown",t.INSTALL_ERROR_LOCAL="local";let y=class extends T.Disposable{constructor(s,e,i){super();this.galleryService=s,this.telemetryService=e,this.logService=i,this.lastReportTimestamp=0,this.installingExtensions=new Map,this.uninstallingExtensions=new Map,this._onInstallExtension=this._register(new L.Emitter),this.onInstallExtension=this._onInstallExtension.event,this._onDidInstallExtensions=this._register(new L.Emitter),this.onDidInstallExtensions=this._onDidInstallExtensions.event,this._onUninstallExtension=this._register(new L.Emitter),this.onUninstallExtension=this._onUninstallExtension.event,this._onDidUninstallExtension=this._register(new L.Emitter),this.onDidUninstallExtension=this._onDidUninstallExtension.event,this.participants=[],this._register((0,T.toDisposable)(()=>{this.installingExtensions.forEach(n=>n.cancel()),this.uninstallingExtensions.forEach(n=>n.cancel()),this.installingExtensions.clear(),this.uninstallingExtensions.clear()}))}async canInstall(s){const e=await this.getTargetPlatform();return s.allTargetPlatforms.some(i=>(0,P.isTargetPlatformCompatible)(i,s.allTargetPlatforms,e))}async installFromGallery(s,e={}){if(!this.galleryService.isEnabled())throw new Error(v.localize(0,null));if(!await this.canInstall(s)){const n=await this.getTargetPlatform(),r=new P.ExtensionManagementError(v.localize(1,null,s.identifier.id,u.default.nameLong,(0,P.TargetPlatformToString)(n)),t.INSTALL_ERROR_VALIDATING);throw this.logService.error("Cannot install extension.",s.identifier.id,r.message),f(this.telemetryService,"extensionGallery:install",(0,g.getGalleryExtensionTelemetryData)(s),void 0,r),r}try{s=await this.checkAndGetCompatibleVersion(s,!e.installGivenVersion)}catch(n){throw this.logService.error((0,R.getErrorMessage)(n)),f(this.telemetryService,"extensionGallery:install",(0,g.getGalleryExtensionTelemetryData)(s),void 0,n),n}const i=await this.galleryService.getManifest(s,w.CancellationToken.None);if(i===null){const n=new P.ExtensionManagementError(`Missing manifest for extension ${s.identifier.id}`,t.INSTALL_ERROR_VALIDATING);throw this.logService.error("Failed to install extension:",s.identifier.id,n.message),f(this.telemetryService,"extensionGallery:install",(0,g.getGalleryExtensionTelemetryData)(s),void 0,n),n}if(i.version!==s.version){const n=new P.ExtensionManagementError(`Cannot install '${s.identifier.id}' extension because of version mismatch in Marketplace`,t.INSTALL_ERROR_VALIDATING);throw this.logService.error(n.message),f(this.telemetryService,"extensionGallery:install",(0,g.getGalleryExtensionTelemetryData)(s),void 0,n),n}return this.installExtension(i,s,e)}async uninstall(s,e={}){return this.logService.trace("ExtensionManagementService#uninstall",s.identifier.id),this.unininstallExtension(s,e)}async reinstallFromGallery(s){if(this.logService.trace("ExtensionManagementService#reinstallFromGallery",s.identifier.id),!this.galleryService.isEnabled())throw new Error(v.localize(2,null));const e=await this.findGalleryExtension(s);if(!e)throw new Error(v.localize(3,null));await this.createUninstallExtensionTask(s,{remove:!0,versionOnly:!0}).run(),await this.installFromGallery(e)}getExtensionsReport(){const s=new Date().getTime();return(!this.reportedExtensions||s-this.lastReportTimestamp>1e3*60*5)&&(this.reportedExtensions=this.updateReportCache(),this.lastReportTimestamp=s),this.reportedExtensions}registerParticipant(s){this.participants.push(s)}async installExtension(s,e,i){if(!d.URI.isUri(e)){let S=this.installingExtensions.get(new g.ExtensionIdentifierWithVersion(e.identifier,e.version).key());if(S)return this.logService.info("Extensions is already requested to install",e.identifier.id),S.waitUntilTaskIsFinished();i={...i,installOnlyNewlyAddedFromExtensionPack:!0}}const n=[],r=[],a=this.createInstallExtensionTask(s,e,i);d.URI.isUri(e)||this.installingExtensions.set(new g.ExtensionIdentifierWithVersion(a.identifier,s.version).key(),a),this._onInstallExtension.fire({identifier:a.identifier,source:e}),this.logService.info("Installing extension:",a.identifier.id),n.push({task:a,manifest:s});let m=!1;try{if(i.donotIncludePackAndDependencies)this.logService.info("Installing the extension without checking dependencies and pack",a.identifier.id);else try{const F=await this.getAllDepsAndPackExtensionsToInstall(a.identifier,s,!!i.installOnlyNewlyAddedFromExtensionPack);for(const{gallery:p,manifest:C}of F)if(m=m||!!C.extensionDependencies?.some(N=>(0,g.areSameExtensions)({id:N},a.identifier)),this.installingExtensions.has(new g.ExtensionIdentifierWithVersion(p.identifier,p.version).key()))this.logService.info("Extension is already requested to install",p.identifier.id);else{const N=this.createInstallExtensionTask(C,p,{...i,donotIncludePackAndDependencies:!0});this.installingExtensions.set(new g.ExtensionIdentifierWithVersion(N.identifier,C.version).key(),N),this._onInstallExtension.fire({identifier:N.identifier,source:p}),this.logService.info("Installing extension:",N.identifier.id),n.push({task:N,manifest:C})}}catch(F){if(d.URI.isUri(a.source))(0,O.isNonEmptyArray)(s.extensionDependencies)&&this.logService.warn("Cannot install dependencies of extension:",a.identifier.id,F.message),(0,O.isNonEmptyArray)(s.extensionPack)&&this.logService.warn("Cannot install packed extensions of extension:",a.identifier.id,F.message);else throw this.logService.error("Error while preparing to install dependencies and extension packs of the extension:",a.identifier.id),this.logService.error(F),F}const S=n.reduce((F,{task:p,manifest:C})=>(F.set(p.identifier.id.toLowerCase(),{task:p,manifest:C}),F),new Map);for(;S.size;){let F;const p=[...S.values()].filter(({manifest:C})=>!C.extensionDependencies?.some(N=>S.has(N.toLowerCase())));p.length?F=S.size===1?p:p.filter(({task:C})=>!(C===a&&!m)):(this.logService.info("Found extensions with circular dependencies",p.map(({task:C})=>C.identifier.id)),F=[...S.values()]),await this.joinAllSettled(F.map(async({task:C})=>{const N=new Date().getTime();try{const V=await C.run();if(await this.joinAllSettled(this.participants.map(Y=>Y.postInstall(V,C.source,i,w.CancellationToken.None))),!d.URI.isUri(C.source)&&(f(this.telemetryService,C.operation===2?"extensionGallery:update":"extensionGallery:install",(0,g.getGalleryExtensionTelemetryData)(C.source),new Date().getTime()-N,void 0),c.isWeb&&C.operation===1))try{await this.galleryService.reportStatistic(V.manifest.publisher,V.manifest.name,V.manifest.version,"install")}catch(Y){}r.push({local:V,identifier:C.identifier,operation:C.operation,source:C.source})}catch(V){throw d.URI.isUri(C.source)||f(this.telemetryService,C.operation===2?"extensionGallery:update":"extensionGallery:install",(0,g.getGalleryExtensionTelemetryData)(C.source),new Date().getTime()-N,V),this.logService.error("Error while installing the extension:",C.identifier.id),this.logService.error(V),V}finally{S.delete(C.identifier.id.toLowerCase())}}))}return r.forEach(({identifier:F})=>this.logService.info("Extension installed successfully:",F.id)),this._onDidInstallExtensions.fire(r),r.filter(({identifier:F})=>(0,g.areSameExtensions)(F,a.identifier))[0].local}catch(S){if(n.forEach(({task:F})=>F.cancel()),r.length)try{const F=await Promise.allSettled(r.map(({local:p})=>this.createUninstallExtensionTask(p,{versionOnly:!0}).run()));for(let p=0;p<F.length;p++){const C=F[p],{identifier:N}=r[p];C.status==="fulfilled"?this.logService.info("Rollback: Uninstalled extension",N.id):this.logService.warn("Rollback: Error while uninstalling extension",N.id,(0,R.getErrorMessage)(C.reason))}}catch(F){this.logService.warn("Error while rolling back extensions",(0,R.getErrorMessage)(F),r.map(({identifier:p})=>p.id))}throw this.logService.error("Failed to install extension:",a.identifier.id,(0,R.getErrorMessage)(S)),this._onDidInstallExtensions.fire(n.map(({task:F})=>({identifier:F.identifier,operation:1,source:F.source}))),S instanceof Error&&(S.name=S&&S.code?S.code:t.ERROR_UNKNOWN),S}finally{for(const{task:S,manifest:F}of n)if(!d.URI.isUri(S.source)){const p=new g.ExtensionIdentifierWithVersion(S.identifier,F.version).key();this.installingExtensions.delete(p)||this.logService.warn("Installation task is not found in the cache",p)}}}async joinAllSettled(s){const e=[],i=[],n=await Promise.allSettled(s);for(const r of n)r.status==="fulfilled"?e.push(r.value):i.push(r.reason);if(i.length)throw E(i);return e}async getAllDepsAndPackExtensionsToInstall(s,e,i){if(!this.galleryService.isEnabled())return[];let n=await this.getInstalled();const r=[s,...n.map(S=>S.identifier)],a=[],m=async(S,F)=>{const p=F.extensionDependencies||[],C=[...p];if(F.extensionPack){const N=i?n.find(V=>(0,g.areSameExtensions)(V.identifier,S)):void 0;for(const V of F.extensionPack)N&&N.manifest.extensionPack&&N.manifest.extensionPack.some(Y=>(0,g.areSameExtensions)({id:Y},{id:V}))||C.every(Y=>!(0,g.areSameExtensions)({id:Y},{id:V}))&&C.push(V)}if(C.length){const N=[...r,...a.map(Y=>Y.gallery.identifier)],V=C.filter(Y=>N.every(ie=>!(0,g.areSameExtensions)(ie,{id:Y})));if(V.length){const Y=await this.galleryService.query({names:V,pageSize:C.length},w.CancellationToken.None);for(const ie of Y.firstPage){if(N.find(ce=>(0,g.areSameExtensions)(ce,ie.identifier)))continue;if(!p.some(ce=>(0,g.areSameExtensions)({id:ce},ie.identifier))&&!await this.canInstall(ie)){this.logService.info("Skipping the packed extension as it cannot be installed",ie.identifier.id);continue}const ee=await this.checkAndGetCompatibleVersion(ie,!0),ue=await this.galleryService.getManifest(ee,w.CancellationToken.None);if(ue===null)throw new P.ExtensionManagementError(`Missing manifest for extension ${ee.identifier.id}`,t.INSTALL_ERROR_VALIDATING);a.push({gallery:ee,manifest:ue}),await m(ee.identifier,ue)}}}};return await m(s,e),n=await this.getInstalled(),a.filter(S=>!n.some(F=>(0,g.areSameExtensions)(F.identifier,S.gallery.identifier)))}async checkAndGetCompatibleVersion(s,e){if(await this.isMalicious(s))throw new P.ExtensionManagementError(v.localize(4,null,s.identifier.id),P.INSTALL_ERROR_MALICIOUS);const i=await this.getCompatibleVersion(s,e);if(!i)throw new P.ExtensionManagementError(v.localize(5,null,s.identifier.id,u.default.version),P.INSTALL_ERROR_INCOMPATIBLE);return i}async getCompatibleVersion(s,e){const i=await this.getTargetPlatform();let n=null;return await this.galleryService.isExtensionCompatible(s,i)&&(n=s),!n&&e&&(n=await this.galleryService.getCompatibleExtension(s,i)),n}async isMalicious(s){const e=await this.getExtensionsReport();return(0,g.getMaliciousExtensionsSet)(e).has(s.identifier.id)}async unininstallExtension(s,e){const i=this.uninstallingExtensions.get(s.identifier.id.toLowerCase());if(i)return this.logService.info("Extensions is already requested to uninstall",s.identifier.id),i.waitUntilTaskIsFinished();const n=(S,F)=>{const p=this.createUninstallExtensionTask(S,F);return this.uninstallingExtensions.set(p.extension.identifier.id.toLowerCase(),p),this.logService.info("Uninstalling extension:",S.identifier.id),this._onUninstallExtension.fire(S.identifier),p},r=(S,F)=>{F?this.logService.error("Failed to uninstall extension:",S.identifier.id,F.message):this.logService.info("Successfully uninstalled extension:",S.identifier.id),f(this.telemetryService,"extensionGallery:uninstall",(0,g.getLocalExtensionTelemetryData)(S),void 0,F),this._onDidUninstallExtension.fire({identifier:S.identifier,error:F?.code})},a=[],m=[];try{a.push(n(s,{}));const S=await this.getInstalled(1);if(e.donotIncludePack)this.logService.info("Uninstalling the extension without including packed extension",s.identifier.id);else{const F=this.getAllPackExtensionsToUninstall(s,S);for(const p of F)this.uninstallingExtensions.has(p.identifier.id.toLowerCase())?this.logService.info("Extensions is already requested to uninstall",p.identifier.id):a.push(n(p,{}))}e.donotCheckDependents?this.logService.info("Uninstalling the extension without checking dependents",s.identifier.id):this.checkForDependents(a.map(F=>F.extension),S,s),await this.joinAllSettled(a.map(async F=>{try{if(await F.run(),await this.joinAllSettled(this.participants.map(p=>p.postUninstall(F.extension,e,w.CancellationToken.None))),F.extension.identifier.uuid)try{await this.galleryService.reportStatistic(F.extension.manifest.publisher,F.extension.manifest.name,F.extension.manifest.version,"uninstall")}catch(p){}r(F.extension)}catch(p){const C=p instanceof P.ExtensionManagementError?p:new P.ExtensionManagementError((0,R.getErrorMessage)(p),t.ERROR_UNKNOWN);throw r(F.extension,C),C}finally{m.push(F)}}))}catch(S){const F=S instanceof P.ExtensionManagementError?S:new P.ExtensionManagementError((0,R.getErrorMessage)(S),t.ERROR_UNKNOWN);for(const p of a){try{p.cancel()}catch(C){}m.includes(p)||r(p.extension,F)}throw F}finally{for(const S of a)this.uninstallingExtensions.delete(S.extension.identifier.id.toLowerCase())||this.logService.warn("Uninstallation task is not found in the cache",S.extension.identifier.id)}}checkForDependents(s,e,i){for(const n of s){const r=this.getDependents(n,e);if(r.length){const a=r.filter(m=>!s.some(S=>(0,g.areSameExtensions)(S.identifier,m.identifier)));if(a.length)throw new Error(this.getDependentsErrorMessage(n,a,i))}}}getDependentsErrorMessage(s,e,i){return i===s?e.length===1?v.localize(6,null,i.manifest.displayName||i.manifest.name,e[0].manifest.displayName||e[0].manifest.name):e.length===2?v.localize(7,null,i.manifest.displayName||i.manifest.name,e[0].manifest.displayName||e[0].manifest.name,e[1].manifest.displayName||e[1].manifest.name):v.localize(8,null,i.manifest.displayName||i.manifest.name,e[0].manifest.displayName||e[0].manifest.name,e[1].manifest.displayName||e[1].manifest.name):e.length===1?v.localize(9,null,i.manifest.displayName||i.manifest.name,s.manifest.displayName||s.manifest.name,e[0].manifest.displayName||e[0].manifest.name):e.length===2?v.localize(10,null,i.manifest.displayName||i.manifest.name,s.manifest.displayName||s.manifest.name,e[0].manifest.displayName||e[0].manifest.name,e[1].manifest.displayName||e[1].manifest.name):v.localize(11,null,i.manifest.displayName||i.manifest.name,s.manifest.displayName||s.manifest.name,e[0].manifest.displayName||e[0].manifest.name,e[1].manifest.displayName||e[1].manifest.name)}getAllPackExtensionsToUninstall(s,e,i=[]){if(i.indexOf(s)!==-1)return[];i.push(s);const n=s.manifest.extensionPack?s.manifest.extensionPack:[];if(n.length){const r=e.filter(m=>!m.isBuiltin&&n.some(S=>(0,g.areSameExtensions)({id:S},m.identifier))),a=[];for(const m of r)a.push(...this.getAllPackExtensionsToUninstall(m,e,i));return[...r,...a]}return[]}getDependents(s,e){return e.filter(i=>i.manifest.extensionDependencies&&i.manifest.extensionDependencies.some(n=>(0,g.areSameExtensions)({id:n},s.identifier)))}async findGalleryExtension(s){if(s.identifier.uuid){const e=await this.findGalleryExtensionById(s.identifier.uuid);return e||this.findGalleryExtensionByName(s.identifier.id)}return this.findGalleryExtensionByName(s.identifier.id)}async findGalleryExtensionById(s){return(await this.galleryService.query({ids:[s],pageSize:1},w.CancellationToken.None)).firstPage[0]}async findGalleryExtensionByName(s){return(await this.galleryService.query({names:[s],pageSize:1},w.CancellationToken.None)).firstPage[0]}async updateReportCache(){try{this.logService.trace("ExtensionManagementService.refreshReportedCache");const s=await this.galleryService.getExtensionsReport();return this.logService.trace(`ExtensionManagementService.refreshReportedCache - got ${s.length} reported extensions from service`),s}catch(s){return this.logService.trace("ExtensionManagementService.refreshReportedCache - failed to get extension report"),[]}}};y=de([le(0,P.IExtensionGalleryService),le(1,l.ITelemetryService),le(2,I.ILogService)],y),t.AbstractExtensionManagementService=y;function E(o){const s=Array.isArray(o)?o:[o];return s.length===1?s[0]instanceof Error?s[0]:new Error(s[0]):s.reduce((e,i)=>new Error(`${e.message}${e.message?",":""}${i instanceof Error?i.message:i}`),new Error(""))}t.joinErrors=E;function f(o,s,e,i,n){const r=n?n instanceof P.ExtensionManagementError?n.code:t.ERROR_UNKNOWN:void 0;o.publicLogError(s,{...e,success:!n,duration:i,errorcode:r})}t.reportTelemetry=f;class h{constructor(){this.barrier=new b.Barrier}async waitUntilTaskIsFinished(){return await this.barrier.wait(),this.cancellablePromise}async run(){return this.cancellablePromise||(this.cancellablePromise=(0,b.createCancelablePromise)(s=>this.doRun(s))),this.barrier.open(),this.cancellablePromise}cancel(){this.cancellablePromise||(this.cancellablePromise=(0,b.createCancelablePromise)(s=>new Promise((e,i)=>{const n=s.onCancellationRequested(()=>{n.dispose(),i((0,R.canceled)())})})),this.barrier.open()),this.cancellablePromise.cancel()}}t.AbstractExtensionTask=h}),define(Z[36],te([0,1,18,11,27,29]),function($,t,O,b,w,R){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.cleanRemoteAuthority=t.validateTelemetryData=t.getTelemetryLevel=t.supportsTelemetry=t.configurationTelemetry=t.NullAppender=t.NullEndpointTelemetryService=t.NullTelemetryService=void 0,t.NullTelemetryService=new class{constructor(){this.sendErrorTelemetry=!1,this.telemetryLevel=0}publicLog(l,y){return Promise.resolve(void 0)}publicLog2(l,y){return this.publicLog(l,y)}publicLogError(l,y){return Promise.resolve(void 0)}publicLogError2(l,y){return this.publicLogError(l,y)}setExperimentProperty(){}getTelemetryInfo(){return Promise.resolve({instanceId:"someValue.instanceId",sessionId:"someValue.sessionId",machineId:"someValue.machineId",firstSessionDate:"someValue.firstSessionDate"})}};class L{async publicLog(y,E,f){}async publicLogError(y,E,f){}}t.NullEndpointTelemetryService=L,t.NullAppender={log:()=>null,flush:()=>Promise.resolve(null)};function T(l,y){return y.onDidChangeConfiguration(E=>{E.source!==6&&l.publicLog2("updateConfiguration",{configurationSource:(0,w.ConfigurationTargetToString)(E.source),configurationKeys:I(E.sourceConfig)})})}t.configurationTelemetry=T;function c(l,y){return!(y.disableTelemetry||!l.enableTelemetry)}t.supportsTelemetry=c;function d(l){const y=l.getValue(R.TELEMETRY_SETTING_ID),E=l.getValue(R.TELEMETRY_OLD_SETTING_ID);if(E!==void 0&&E===!1)return 0;switch(y??"on"){case"on":return 3;case"error":return 2;case"off":return 0}}t.getTelemetryLevel=d;function v(l){const y=Object.create(null),E=Object.create(null),f=Object.create(null);g(l,f);for(let h in f){h=h.length>150?h.substr(h.length-149):h;const o=f[h];typeof o=="number"?E[h]=o:typeof o=="boolean"?E[h]=o?1:0:typeof o=="string"?y[h]=o.substring(0,1023):typeof o!="undefined"&&o!==null&&(y[h]=o)}return{properties:y,measurements:E}}t.validateTelemetryData=v;function P(l){if(!l)return"none";let y="other";return["ssh-remote","dev-container","attached-container","wsl"].forEach(f=>{l.indexOf(`${f}+`)===0&&(y=f)}),y}t.cleanRemoteAuthority=P;function g(l,y,E=0,f){if(!!l)for(let h of Object.getOwnPropertyNames(l)){const o=l[h],s=f?f+h:h;Array.isArray(o)?y[s]=(0,O.safeStringify)(o):o instanceof Date?y[s]=o.toISOString():(0,b.isObject)(o)?E<2?g(o,y,E+1,s+"."):y[s]=(0,O.safeStringify)(o):y[s]=o}}function I(l){if(!l)return[];const y=[];return u(y,"",l),y}function u(l,y,E){E&&typeof E=="object"&&!Array.isArray(E)?Object.keys(E).forEach(f=>u(l,y?`${y}.${f}`:f,E[f])):l.push(y)}}),define(Z[118],te([0,1,20,25,9,18,10,28,7,27,21,23,24,51,16,14,42,43,114,115,29,36]),function($,t,O,b,w,R,L,T,c,d,v,P,g,I,u,l,y,E,f,h,o,s){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.resolveMarketplaceHeaders=t.ExtensionGalleryServiceWithNoStorageService=t.ExtensionGalleryService=t.sortExtensionVersions=void 0;const e=L.isWeb?"web":(0,P.getTargetPlatform)(L.platform,T.arch);var i;(function(k){k[k.None=0]="None",k[k.IncludeVersions=1]="IncludeVersions",k[k.IncludeFiles=2]="IncludeFiles",k[k.IncludeCategoryAndTags=4]="IncludeCategoryAndTags",k[k.IncludeSharedAccounts=8]="IncludeSharedAccounts",k[k.IncludeVersionProperties=16]="IncludeVersionProperties",k[k.ExcludeNonValidated=32]="ExcludeNonValidated",k[k.IncludeInstallationTargets=64]="IncludeInstallationTargets",k[k.IncludeAssetUri=128]="IncludeAssetUri",k[k.IncludeStatistics=256]="IncludeStatistics",k[k.IncludeLatestVersionOnly=512]="IncludeLatestVersionOnly",k[k.Unpublished=4096]="Unpublished"})(i||(i={}));function n(...k){return String(k.reduce((A,j)=>A|j,0))}var r;(function(k){k[k.Tag=1]="Tag",k[k.ExtensionId=4]="ExtensionId",k[k.Category=5]="Category",k[k.ExtensionName=7]="ExtensionName",k[k.Target=8]="Target",k[k.Featured=9]="Featured",k[k.SearchText=10]="SearchText",k[k.ExcludeWithFlags=12]="ExcludeWithFlags"})(r||(r={}));const a={Icon:"Microsoft.VisualStudio.Services.Icons.Default",Details:"Microsoft.VisualStudio.Services.Content.Details",Changelog:"Microsoft.VisualStudio.Services.Content.Changelog",Manifest:"Microsoft.VisualStudio.Code.Manifest",VSIX:"Microsoft.VisualStudio.Services.VSIXPackage",License:"Microsoft.VisualStudio.Services.Content.License",Repository:"Microsoft.VisualStudio.Services.Links.Source"},m={Dependency:"Microsoft.VisualStudio.Code.ExtensionDependencies",ExtensionPack:"Microsoft.VisualStudio.Code.ExtensionPack",Engine:"Microsoft.VisualStudio.Code.Engine",LocalizedLanguages:"Microsoft.VisualStudio.Code.LocalizedLanguages",WebExtension:"Microsoft.VisualStudio.Code.WebExtension"},F={pageNumber:1,pageSize:10,sortBy:0,sortOrder:0,flags:i.None,criteria:[],assetTypes:[]};class p{constructor(A=F){this.state=A}get pageNumber(){return this.state.pageNumber}get pageSize(){return this.state.pageSize}get sortBy(){return this.state.sortBy}get sortOrder(){return this.state.sortOrder}get flags(){return this.state.flags}withPage(A,j=this.state.pageSize){return new p({...this.state,pageNumber:A,pageSize:j})}withFilter(A,...j){const W=[...this.state.criteria,...j.length?j.map(X=>({filterType:A,value:X})):[{filterType:A}]];return new p({...this.state,criteria:W})}withSortBy(A){return new p({...this.state,sortBy:A})}withSortOrder(A){return new p({...this.state,sortOrder:A})}withFlags(...A){return new p({...this.state,flags:A.reduce((j,W)=>j|W,0)})}withAssetTypes(...A){return new p({...this.state,assetTypes:A})}get raw(){const{criteria:A,pageNumber:j,pageSize:W,sortBy:X,sortOrder:Q,flags:se,assetTypes:re}=this.state;return{filters:[{criteria:A,pageNumber:j,pageSize:W,sortBy:X,sortOrder:Q}],assetTypes:re,flags:se}}get searchText(){const A=this.state.criteria.filter(j=>j.filterType===r.SearchText)[0];return A&&A.value?A.value:""}get telemetryData(){return{filterTypes:this.state.criteria.map(A=>String(A.filterType)),sortBy:String(this.sortBy),sortOrder:String(this.sortOrder)}}}function C(k,A){const j=(k||[]).filter(W=>W.statisticName===A)[0];return j?j.value:0}function N(k){const A="Microsoft.VisualStudio.Code.Translation.";return k.files.filter(W=>W.assetType.indexOf(A)===0).reduce((W,X)=>{const Q=oe(k,X.assetType);return Q&&W.push([X.assetType.substring(A.length),Q]),W},[])}function V(k){if(k.properties){const A=k.properties.filter(X=>X.key===a.Repository),j=new RegExp("((git|ssh|http(s)?)|(git@[\\w.]+))(:(//)?)([\\w.@:/\\-~]+)(.git)(/)?"),W=A.filter(X=>j.test(X.value))[0];return W?{uri:W.value,fallbackUri:W.value}:null}return oe(k,a.Repository)}function Y(k){return{uri:`${k.fallbackAssetUri}/${a.VSIX}?redirect=true${k.targetPlatform?`&targetPlatform=${k.targetPlatform}`:""}`,fallbackUri:`${k.fallbackAssetUri}/${a.VSIX}${k.targetPlatform?`?targetPlatform=${k.targetPlatform}`:""}`}}function ie(k){const A=oe(k,a.Icon);if(A)return A;const j=P.DefaultIconPath;return{uri:j,fallbackUri:j}}function oe(k,A){return k.files.filter(W=>W.assetType===A)[0]?{uri:`${k.assetUri}/${A}`,fallbackUri:`${k.fallbackAssetUri}/${A}`}:null}function ee(k,A){const j=k.properties?k.properties.filter(X=>X.key===A):[],W=j.length>0&&j[0].value;return W?W.split(",").map(X=>(0,g.adoptToGalleryExtensionId)(X)):[]}function ue(k){const A=k.properties?k.properties.filter(j=>j.key===m.Engine):[];return A.length>0&&A[0].value||""}function ce(k){const A=k.properties?k.properties.filter(W=>W.key===m.LocalizedLanguages):[],j=A.length>0&&A[0].value||"";return j?j.split(","):[]}function G(k){return k.indexOf("preview")!==-1}function ne(k){return k.targetPlatform?(0,P.toTargetPlatform)(k.targetPlatform):"undefined"}function z(k){const A=(0,O.distinct)(k.versions.map(ne)),j=!!k.tags?.includes(P.WEB_EXTENSION_TAG),W=A.indexOf("web");return j?W===-1&&A.push("web"):W!==-1&&A.splice(W,1),A}function D(k,A){const j=(0,P.getFallbackTargetPlarforms)(A);for(let W=0;W<k.length;W++){const X=k[W];if(X.version===k[W-1]?.version){let Q=W;const se=ne(X);if(se===A)for(;Q>0&&k[Q-1].version===X.version;)Q--;else if(j.includes(se))for(;Q>0&&k[Q-1].version===X.version&&ne(k[Q-1])!==A;)Q--;Q!==W&&(k.splice(W,1),k.splice(Q,0,X))}}return k}t.sortExtensionVersions=D;function M(k,A,j,W,X){const Q=z(k);let se=k.versions[0];return se=k.versions.find(re=>re.version===se.version&&(0,P.isTargetPlatformCompatible)(ne(re),Q,X))||se,U(k,se,Q,A,j,W)}function U(k,A,j,W,X,Q){const se={manifest:oe(A,a.Manifest),readme:oe(A,a.Details),changelog:oe(A,a.Changelog),license:oe(A,a.License),repository:V(A),download:Y(A),icon:ie(A),coreTranslations:N(A)};return{identifier:{id:(0,g.getGalleryExtensionId)(k.publisher.publisherName,k.extensionName),uuid:k.extensionId},name:k.extensionName,version:A.version,displayName:k.displayName,publisherId:k.publisher.publisherId,publisher:k.publisher.publisherName,publisherDisplayName:k.publisher.displayName,description:k.shortDescription||"",installCount:C(k.statistics,"install"),rating:C(k.statistics,"averagerating"),ratingCount:C(k.statistics,"ratingcount"),categories:k.categories||[],tags:k.tags||[],releaseDate:Date.parse(k.releaseDate),lastUpdated:Date.parse(k.lastUpdated),allTargetPlatforms:j,assets:se,properties:{dependencies:ee(A,m.Dependency),extensionPack:ee(A,m.ExtensionPack),engine:ue(A),localizedLanguages:ce(A),targetPlatform:ne(A)},preview:G(k.flags),telemetryData:{index:(X.pageNumber-1)*X.pageSize+W,querySource:Q}}}let K=class{constructor(A,j,W,X,Q,se,re,me){this.requestService=j,this.logService=W,this.environmentService=X,this.telemetryService=Q,this.fileService=se,this.productService=re,this.configurationService=me;const ye=re.extensionsGallery;this.extensionsGalleryUrl=ye&&ye.serviceUrl,this.extensionsControlUrl=ye&&ye.controlUrl,this.commonHeadersPromise=q(re.version,re,this.environmentService,this.configurationService,this.fileService,A)}api(A=""){return`${this.extensionsGalleryUrl}${A}`}isEnabled(){return!!this.extensionsGalleryUrl}async getExtensions(A,j){const W=[];let X=new p().withFlags(i.IncludeAssetUri,i.IncludeStatistics,i.IncludeCategoryAndTags,i.IncludeFiles,i.IncludeVersionProperties).withPage(1,A.length).withFilter(r.Target,"Microsoft.VisualStudio.Code").withFilter(r.ExtensionName,...A.map(({id:se})=>se.toLowerCase()));A.every(se=>!se.version)&&(X=X.withFlags(i.IncludeAssetUri,i.IncludeStatistics,i.IncludeCategoryAndTags,i.IncludeFiles,i.IncludeVersionProperties,i.IncludeLatestVersionOnly));const{galleryExtensions:Q}=await this.queryGallery(X,e,b.CancellationToken.None);for(let se=0;se<Q.length;se++){const re=Q[se];if(!re.versions.length)continue;const me=(0,g.getGalleryExtensionId)(re.publisher.publisherName,re.extensionName),ye=A.find(fe=>(0,g.areSameExtensions)(fe,{id:me}))?.version;if(ye){const fe=re.versions.find(Pe=>Pe.version===ye);fe&&W.push(U(re,fe,z(re),se,X))}else W.push(M(re,se,X,void 0,e))}return W}async getCompatibleExtension(A,j){const W=(0,P.isIExtensionIdentifier)(A)?null:A;if(W){if((0,P.isNotWebExtensionInWebTargetPlatform)(W.allTargetPlatforms,j))return null;if(await this.isExtensionCompatible(W,j))return W}const{id:X,uuid:Q}=W?W.identifier:A;let se=new p().withFlags(i.IncludeAssetUri,i.IncludeStatistics,i.IncludeCategoryAndTags,i.IncludeFiles,i.IncludeVersionProperties).withPage(1,1).withFilter(r.Target,"Microsoft.VisualStudio.Code");Q?se=se.withFilter(r.ExtensionId,Q):se=se.withFilter(r.ExtensionName,X);const{galleryExtensions:re}=await this.queryGallery(se,j,b.CancellationToken.None),[me]=re;if(!me||!me.versions.length)return null;const ye=z(me);if((0,P.isNotWebExtensionInWebTargetPlatform)(ye,j))return null;for(let fe of me.versions){if(!ue(fe)){const Pe=await this.getEngine(fe);fe={...fe,properties:[...fe.properties||[],{key:m.Engine,value:Pe}]}}if(await this.isRawExtensionVersionCompatible(fe,ye,j))return U(me,fe,ye,0,se)}return null}async isExtensionCompatible(A,j){if(!(0,P.isTargetPlatformCompatible)(A.properties.targetPlatform,A.allTargetPlatforms,j))return!1;let W=A.properties.engine;if(!W){const X=await this.getManifest(A,b.CancellationToken.None);if(!X)throw new Error("Manifest was not found");W=X.engines.vscode}return(0,I.isEngineValid)(W,this.productService.version,this.productService.date)}async isRawExtensionVersionCompatible(A,j,W){if(!(0,P.isTargetPlatformCompatible)(ne(A),j,W))return!1;const X=await this.getEngine(A);return(0,I.isEngineValid)(X,this.productService.version,this.productService.date)}async query(A,j){const W=b.CancellationToken.isCancellationToken(A)?{}:A,X=b.CancellationToken.isCancellationToken(A)?A:j;if(!this.isEnabled())throw new Error("No extension gallery service configured.");let Q=W.text||"";const se=(0,R.getOrDefault)(W,pe=>pe.pageSize,50);let re=new p().withFlags(i.IncludeLatestVersionOnly,i.IncludeAssetUri,i.IncludeStatistics,i.IncludeCategoryAndTags,i.IncludeFiles,i.IncludeVersionProperties).withPage(1,se).withFilter(r.Target,"Microsoft.VisualStudio.Code");Q?(Q=Q.replace(/\bcategory:("([^"]*)"|([^"]\S*))(\s+|\b|$)/g,(pe,Ee,Ae)=>(re=re.withFilter(r.Category,Ae||Ee),"")),Q=Q.replace(/\btag:("([^"]*)"|([^"]\S*))(\s+|\b|$)/g,(pe,Ee,Ae)=>(re=re.withFilter(r.Tag,Ae||Ee),"")),Q=Q.replace(/\bfeatured(\s+|\b|$)/g,()=>(re=re.withFilter(r.Featured),"")),Q=Q.trim(),Q&&(Q=Q.length<200?Q:Q.substring(0,200),re=re.withFilter(r.SearchText,Q)),re=re.withSortBy(0)):W.ids?re=re.withFilter(r.ExtensionId,...W.ids):W.names?re=re.withFilter(r.ExtensionName,...W.names):re=re.withSortBy(4),typeof W.sortBy=="number"&&(re=re.withSortBy(W.sortBy)),typeof W.sortOrder=="number"&&(re=re.withSortOrder(W.sortOrder));const{galleryExtensions:me,total:ye}=await this.queryGallery(re,e,X),fe=me.map((pe,Ee)=>M(pe,Ee,re,W.source,e)),Pe=async(pe,Ee)=>{if(Ee.isCancellationRequested)throw(0,w.canceled)();const Ae=re.withPage(pe+1),{galleryExtensions:Me}=await this.queryGallery(Ae,e,Ee);return Me.map((Ue,ze)=>M(Ue,ze,Ae,W.source,e))};return{firstPage:fe,total:ye,pageSize:re.pageSize,getPage:Pe}}async queryGallery(A,j,W){if(!this.isEnabled())throw new Error("No extension gallery service configured.");A=A.withFlags(A.flags,i.ExcludeNonValidated).withFilter(r.ExcludeWithFlags,n(i.Unpublished));const X=await this.commonHeadersPromise,Q=JSON.stringify(A.raw),se={...X,"Content-Type":"application/json",Accept:"application/json;api-version=3.0-preview.1","Accept-Encoding":"gzip","Content-Length":String(Q.length)},re=new Date().getTime();let me,ye,fe=0;try{if(me=await this.requestService.request({type:"POST",url:this.api("/extensionquery"),data:Q,headers:se},W),me.res.statusCode&&me.res.statusCode>=400&&me.res.statusCode<500)return{galleryExtensions:[],total:fe};const Pe=await(0,E.asJson)(me);if(Pe){const pe=Pe.results[0],Ee=pe.extensions;Ee.forEach(Me=>D(Me.versions,j));const Ae=pe.resultMetadata&&pe.resultMetadata.filter(Me=>Me.metadataType==="ResultCount")[0];return fe=Ae&&Ae.metadataItems.filter(Me=>Me.name==="TotalCount")[0].count||0,{galleryExtensions:Ee,total:fe}}return{galleryExtensions:[],total:fe}}catch(Pe){throw ye=Pe,Pe}finally{this.telemetryService.publicLog2("galleryService:query",{...A.telemetryData,requestBodySize:String(Q.length),duration:new Date().getTime()-re,success:!!me&&(0,E.isSuccess)(me),responseBodySize:me?.res.headers["Content-Length"],statusCode:me?String(me.res.statusCode):void 0,errorCode:ye?(0,w.isPromiseCanceledError)(ye)?"canceled":(0,w.getErrorMessage)(ye).startsWith("XHR timeout")?"timeout":"failed":void 0,count:String(fe)})}}async reportStatistic(A,j,W,X){if(!this.isEnabled())return;const Q=L.isWeb?this.api(`/itemName/${A}.${j}/version/${W}/statType/${X==="install"?"1":"3"}/vscodewebextension`):this.api(`/publishers/${A}/extensions/${j}/${W}/stats?statType=${X}`),se=L.isWeb?"api-version=6.1-preview.1":"*/*;api-version=4.0-preview.1",me={...await this.commonHeadersPromise,Accept:se};try{await this.requestService.request({type:"POST",url:Q,headers:me},b.CancellationToken.None)}catch(ye){}}async download(A,j,W){this.logService.trace("ExtensionGalleryService#download",A.identifier.id);const X=(0,g.getGalleryExtensionTelemetryData)(A),Q=new Date().getTime(),se=fe=>this.telemetryService.publicLog("galleryService:downloadVSIX",{...X,duration:fe}),re=W===1?"install":W===2?"update":"",me=re?{uri:`${A.assets.download.uri}${c.URI.parse(A.assets.download.uri).query?"&":"?"}${re}=true`,fallbackUri:`${A.assets.download.fallbackUri}${c.URI.parse(A.assets.download.fallbackUri).query?"&":"?"}${re}=true`}:A.assets.download,ye=await this.getAsset(me);await this.fileService.writeFile(j,ye.stream),se(new Date().getTime()-Q)}async getReadme(A,j){if(A.assets.readme){const W=await this.getAsset(A.assets.readme,{},j);return await(0,E.asText)(W)||""}return""}async getManifest(A,j){if(A.assets.manifest){const W=await this.getAsset(A.assets.manifest,{},j),X=await(0,E.asText)(W);return X?JSON.parse(X):null}return null}async getManifestFromRawExtensionVersion(A,j){const W=oe(A,a.Manifest);if(!W)throw new Error("Manifest was not found");const X={"Accept-Encoding":"gzip"},Q=await this.getAsset(W,{headers:X});return await(0,E.asJson)(Q)}async getCoreTranslation(A,j){const W=A.assets.coreTranslations.filter(X=>X[0]===j.toUpperCase())[0];if(W){const X=await this.getAsset(W[1]),Q=await(0,E.asText)(X);return Q?JSON.parse(Q):null}return null}async getChangelog(A,j){if(A.assets.changelog){const W=await this.getAsset(A.assets.changelog,{},j);return await(0,E.asText)(W)||""}return""}async getAllCompatibleVersions(A,j){let W=new p().withFlags(i.IncludeVersions,i.IncludeCategoryAndTags,i.IncludeFiles,i.IncludeVersionProperties).withPage(1,1).withFilter(r.Target,"Microsoft.VisualStudio.Code");A.identifier.uuid?W=W.withFilter(r.ExtensionId,A.identifier.uuid):W=W.withFilter(r.ExtensionName,A.identifier.id);const{galleryExtensions:X}=await this.queryGallery(W,j,b.CancellationToken.None);if(!X.length)return[];const Q=z(X[0]);if((0,P.isNotWebExtensionInWebTargetPlatform)(Q,j))return[];const se=[];for(const re of X[0].versions)try{se[se.length-1]?.version!==re.version&&await this.isRawExtensionVersionCompatible(re,Q,j)&&se.push({version:re.version,date:re.lastUpdated})}catch(me){}return se}async getAsset(A,j={},W=b.CancellationToken.None){const X=await this.commonHeadersPromise,Q={type:"GET"},se={...X,...j.headers||{}};j={...j,...Q,headers:se};const re=A.uri,me=A.fallbackUri,ye={...j,url:re};try{const fe=await this.requestService.request(ye,W);if(fe.res.statusCode===200)return fe;const Pe=await(0,E.asText)(fe);throw new Error(`Expected 200, got back ${fe.res.statusCode} instead.

${Pe}`)}catch(fe){if((0,w.isPromiseCanceledError)(fe))throw fe;const Pe=(0,w.getErrorMessage)(fe);this.telemetryService.publicLog2("galleryService:cdnFallback",{url:re,message:Pe});const pe={...j,url:me};return this.requestService.request(pe,W)}}async getEngine(A){let j=ue(A);if(!j){const W=await this.getManifestFromRawExtensionVersion(A,b.CancellationToken.None);if(!W)throw new Error("Manifest was not found");j=W.engines.vscode}return j}async getExtensionsReport(){if(!this.isEnabled())throw new Error("No extension gallery service configured.");if(!this.extensionsControlUrl)return[];const A=await this.requestService.request({type:"GET",url:this.extensionsControlUrl},b.CancellationToken.None);if(A.res.statusCode!==200)throw new Error("Could not get extensions report.");const j=await(0,E.asJson)(A),W=new Map;if(j)for(const X of j.malicious){const Q=W.get(X)||{id:{id:X},malicious:!0,slow:!1};Q.malicious=!0,W.set(X,Q)}return[...W.values()]}};K=de([le(1,E.IRequestService),le(2,l.ILogService),le(3,v.IEnvironmentService),le(4,o.ITelemetryService),le(5,u.IFileService),le(6,y.IProductService),le(7,d.IConfigurationService)],K);let B=class extends K{constructor(A,j,W,X,Q,se,re,me){super(A,j,W,X,Q,se,re,me)}};B=de([le(0,h.IStorageService),le(1,E.IRequestService),le(2,l.ILogService),le(3,v.IEnvironmentService),le(4,o.ITelemetryService),le(5,u.IFileService),le(6,y.IProductService),le(7,d.IConfigurationService)],B),t.ExtensionGalleryService=B;let J=class extends K{constructor(A,j,W,X,Q,se,re){super(void 0,A,j,W,X,Q,se,re)}};J=de([le(0,E.IRequestService),le(1,l.ILogService),le(2,v.IEnvironmentService),le(3,o.ITelemetryService),le(4,u.IFileService),le(5,y.IProductService),le(6,d.IConfigurationService)],J),t.ExtensionGalleryServiceWithNoStorageService=J;async function q(k,A,j,W,X,Q){const se={"X-Market-Client-Id":`VSCode ${k}`,"User-Agent":`VSCode ${k}`},re=await(0,f.getServiceMachineId)(j,X,Q);return(0,s.supportsTelemetry)(A,j)&&(0,s.getTelemetryLevel)(W)===3&&(se["X-Market-User-Id"]=re),se}t.resolveMarketplaceHeaders=q}),define(Z[119],te([0,1,2,18,10,22,85,27,33,32,26,29,36]),function($,t,O,b,w,R,L,T,c,d,v,P,g){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.TelemetryService=void 0;let I=class{constructor(y,E){this._configurationService=E,this._experimentProperties={},this._disposables=new O.DisposableStore,this._cleanupPatterns=[],this._appenders=y.appenders,this._commonProperties=y.commonProperties||Promise.resolve({}),this._piiPaths=y.piiPaths||[],this._telemetryLevel=3,this.sendErrorTelemetry=!!y.sendErrorTelemetry,this._cleanupPatterns=[/file:\/\/\/.*?\/resources\/app\//gi];for(let f of this._piiPaths)this._cleanupPatterns.push(new RegExp((0,R.escapeRegExpCharacters)(f),"gi"));this._updateTelemetryLevel(),this._configurationService.onDidChangeConfiguration(this._updateTelemetryLevel,this,this._disposables),this.publicLog2("optInStatus",{optIn:this._telemetryLevel===3}),this._commonProperties.then(f=>{const h=/^[a-f0-9]+$/i.test(f["common.machineId"]);this.publicLog2("machineIdFallback",{usingFallbackGuid:!h})})}setExperimentProperty(y,E){this._experimentProperties[y]=E}_updateTelemetryLevel(){this._telemetryLevel=(0,g.getTelemetryLevel)(this._configurationService)}get telemetryLevel(){return this._telemetryLevel}async getTelemetryInfo(){const y=await this._commonProperties;let E=y.sessionID,f=y["common.instanceId"],h=y["common.machineId"],o=y["common.firstSessionDate"],s=y["common.msftInternal"];return{sessionId:E,instanceId:f,machineId:h,firstSessionDate:o,msftInternal:s}}dispose(){this._disposables.dispose()}_log(y,E,f,h){return this.telemetryLevel<E?Promise.resolve(void 0):this._commonProperties.then(o=>{f=(0,b.mixin)(f,o),f=(0,b.mixin)(f,this._experimentProperties),f=(0,b.cloneAndChange)(f,s=>{if(typeof s=="string")return this._cleanupInfo(s,h)}),this._appenders.forEach(s=>s.log(y,f))},o=>{console.error(o)})}publicLog(y,E,f){return this._log(y,3,E,f)}publicLog2(y,E,f){return this.publicLog(y,E,f)}publicLogError(y,E){return this.sendErrorTelemetry?this._log(y,2,E,!0):Promise.resolve(void 0)}publicLogError2(y,E){return this.publicLogError(y,E)}_anonymizeFilePaths(y){let E=y;const f=[];for(let e of this._cleanupPatterns)for(;;){const i=e.exec(y);if(!i)break;f.push([i.index,e.lastIndex])}const h=/^[\\\/]?(node_modules|node_modules\.asar)[\\\/]/,o=/(file:\/\/)?([a-zA-Z]:(\\\\|\\|\/)|(\\\\|\\|\/))?([\w-\._]+(\\\\|\\|\/))+[\w-\._]*/g;let s=0;for(E="";;){const e=o.exec(y);if(!e)break;!h.test(e[0])&&f.every(([i,n])=>e.index<i||e.index>=n)&&(E+=y.substring(s,e.index)+"<REDACTED: user-file-path>",s=o.lastIndex)}return s<y.length&&(E+=y.substr(s)),E}_removePropertiesWithPossibleUserInfo(y){if(!y)return y;const E=y.toLowerCase(),f=/@[a-zA-Z0-9-.]+/;return/\S*(key|token|sig|password|passwd|pwd)[="':\s]+\S*/.test(E)?"<REDACTED: secret>":f.test(E)?"<REDACTED: email>":y}_cleanupInfo(y,E){let f=y;E&&(f=this._anonymizeFilePaths(f));for(let h of this._cleanupPatterns)f=f.replace(h,"");return f=this._removePropertiesWithPossibleUserInfo(f),f}};I.IDLE_START_EVENT_NAME="UserIdleStart",I.IDLE_STOP_EVENT_NAME="UserIdleStop",I=de([le(1,T.IConfigurationService)],I),t.TelemetryService=I;const u=w.isWeb?"":" "+(0,L.localize)(0,null);v.Registry.as(c.Extensions.Configuration).registerConfiguration({id:P.TELEMETRY_SECTION_ID,order:110,type:"object",title:(0,L.localize)(1,null),properties:{[P.TELEMETRY_SETTING_ID]:{type:"string",enum:["on","error","off"],enumDescriptions:[(0,L.localize)(2,null),(0,L.localize)(3,null),(0,L.localize)(4,null)],markdownDescription:d.default.privacyStatementUrl?(0,L.localize)(6,null,d.default.nameLong,d.default.privacyStatementUrl)+u:(0,L.localize)(5,null,d.default.nameLong)+u,default:"on",restricted:!0,scope:1,tags:["usesOnlineServices","telemetry"]}}}),v.Registry.as(c.Extensions.Configuration).registerConfiguration({id:P.TELEMETRY_SECTION_ID,order:110,type:"object",title:(0,L.localize)(7,null),properties:{[P.TELEMETRY_OLD_SETTING_ID]:{type:"boolean",markdownDescription:d.default.privacyStatementUrl?(0,L.localize)(9,null,d.default.nameLong,d.default.privacyStatementUrl):(0,L.localize)(8,null,d.default.nameLong),default:!0,restricted:!0,markdownDeprecationMessage:(0,L.localize)(10,null,`\`#${P.TELEMETRY_SETTING_ID}#\``),scope:1,tags:["usesOnlineServices","telemetry"]}}})}),define(Z[120],te([0,1,9,18,36]),function($,t,O,b,w){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.AppInsightsAppender=void 0;async function R(T){const c=await new Promise((v,P)=>{$(["applicationinsights"],v,P)});let d;return c.defaultClient?(d=new c.TelemetryClient(T),d.channel.setUseDiskRetryCaching(!0)):(c.setup(T).setAutoCollectRequests(!1).setAutoCollectPerformance(!1).setAutoCollectExceptions(!1).setAutoCollectDependencies(!1).setAutoDependencyCorrelation(!1).setAutoCollectConsole(!1).setInternalLogging(!1,!1).setUseDiskRetryCaching(!0).start(),d=c.defaultClient),T.indexOf("AIF-")===0&&(d.config.endpointUrl="https://vortex.data.microsoft.com/collect/v1"),d}class L{constructor(c,d,v){this._eventPrefix=c,this._defaultData=d,this._defaultData||(this._defaultData=Object.create(null)),typeof v=="function"?this._aiClient=v():this._aiClient=v,this._asyncAIClient=null}_withAIClient(c){if(!!this._aiClient){if(typeof this._aiClient!="string"){c(this._aiClient);return}this._asyncAIClient||(this._asyncAIClient=R(this._aiClient)),this._asyncAIClient.then(d=>{c(d)},d=>{(0,O.onUnexpectedError)(d),console.error(d)})}}log(c,d){!this._aiClient||(d=(0,b.mixin)(d,this._defaultData),d=(0,w.validateTelemetryData)(d),this._withAIClient(v=>v.trackEvent({name:this._eventPrefix+"/"+c,properties:d.properties,measurements:d.measurements})))}flush(){return this._aiClient?new Promise(c=>{this._withAIClient(d=>{d.flush({callback:()=>{this._aiClient=void 0,c(void 0)}})})}):Promise.resolve(void 0)}}t.AppInsightsAppender=L}),define(Z[121],te([0,1,4,12]),function($,t,O,b){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.buildTelemetryMessage=void 0;async function w(R,L){const T=Object.create(null),c=(v,P)=>{const g=JSON.parse(v);T[P]=g};if(L){const v=[],P=await b.Promises.readdir(L);for(const I of P)try{(await b.Promises.stat((0,O.join)(L,I))).isDirectory()&&v.push(I)}catch{}const g=[];for(const I of v)(await b.Promises.readdir((0,O.join)(L,I))).filter(l=>l==="telemetry.json").length===1&&g.push(I);for(const I of g){const u=(await b.Promises.readFile((0,O.join)(L,I,"telemetry.json"))).toString();c(u,I)}}let d=(await b.Promises.readFile((0,O.join)(R,"telemetry-core.json"))).toString();return c(d,"vscode-core"),d=(await b.Promises.readFile((0,O.join)(R,"telemetry-extensions.json"))).toString(),c(d,"vscode-extensions"),JSON.stringify(T,null,4)}t.buildTelemetryMessage=w}),define(Z[44],te([0,1,48,3,4,11,12,72,132,133]),function($,t,O,b,w,R,L,T,c,d){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.buffer=t.extract=t.zip=t.ExtractError=void 0;class v extends Error{constructor(e,i){let n=i.message;switch(e){case"CorruptZip":n=`Corrupt ZIP: ${n}`;break}super(n);this.type=e,this.cause=i}}t.ExtractError=v;function P(s){const e=s.externalFileAttributes>>16||33188;return[448,56,7].map(i=>e&i).reduce((i,n)=>i+n,e&61440)}function g(s){if(s instanceof v)return s;let e;return/end of central directory record signature not found/.test(s.message)&&(e="CorruptZip"),new v(e,s)}function I(s,e,i,n,r,a){const m=w.dirname(e),S=w.join(n,m);if(!S.startsWith(n))return Promise.reject(new Error(T.localize(0,null,e)));const F=w.join(n,e);let p;return a.onCancellationRequested(()=>{p&&p.destroy()}),Promise.resolve(L.Promises.mkdir(S,{recursive:!0})).then(()=>new Promise((C,N)=>{if(!a.isCancellationRequested)try{p=(0,O.createWriteStream)(F,{mode:i}),p.once("close",()=>C()),p.once("error",N),s.once("error",N),s.pipe(p)}catch(V){N(V)}}))}function u(s,e,i,n){let r=(0,b.createCancelablePromise)(()=>Promise.resolve()),a=0;return n.onCancellationRequested(()=>{r.cancel(),s.close()}),new Promise((m,S)=>{const F=new b.Sequencer,p=C=>{C.isCancellationRequested||(a++,s.readEntry())};s.once("error",S),s.once("close",()=>r.then(()=>{n.isCancellationRequested||s.entryCount===a?m():S(new v("Incomplete",new Error(T.localize(1,null,a,s.entryCount))))},S)),s.readEntry(),s.on("entry",C=>{if(n.isCancellationRequested)return;if(!i.sourcePathRegex.test(C.fileName)){p(n);return}const N=C.fileName.replace(i.sourcePathRegex,"");if(/\/$/.test(N)){const ie=w.join(e,N);r=(0,b.createCancelablePromise)(oe=>L.Promises.mkdir(ie,{recursive:!0}).then(()=>p(oe)).then(void 0,S));return}const V=y(s,C),Y=P(C);r=(0,b.createCancelablePromise)(ie=>F.queue(()=>V.then(oe=>I(oe,N,Y,e,i,ie).then(()=>p(ie)))).then(null,S))})})}function l(s,e=!1){return new Promise((i,n)=>{(0,c.open)(s,e?{lazyEntries:!0}:void 0,(r,a)=>{r?n(g(r)):i((0,R.assertIsDefined)(a))})})}function y(s,e){return new Promise((i,n)=>{s.openReadStream(e,(r,a)=>{r?n(g(r)):i((0,R.assertIsDefined)(a))})})}function E(s,e){return new Promise((i,n)=>{const r=new d.ZipFile;e.forEach(m=>{m.contents?r.addBuffer(typeof m.contents=="string"?Buffer.from(m.contents,"utf8"):m.contents,m.path):m.localPath&&r.addFile(m.localPath,m.path)}),r.end();const a=(0,O.createWriteStream)(s);r.outputStream.pipe(a),r.outputStream.once("error",n),a.once("error",n),a.once("finish",()=>i(s))})}t.zip=E;function f(s,e,i={},n){const r=new RegExp(i.sourcePath?`^${i.sourcePath}`:"");let a=l(s,!0);return i.overwrite&&(a=a.then(m=>L.Promises.rm(e).then(()=>m))),a.then(m=>u(m,e,{sourcePathRegex:r},n))}t.extract=f;function h(s,e){return l(s).then(i=>new Promise((n,r)=>{i.on("entry",a=>{a.fileName===e&&y(i,a).then(m=>n(m),m=>r(m))}),i.once("close",()=>r(new Error(T.localize(2,null,e))))}))}function o(s,e){return h(s,e).then(i=>new Promise((n,r)=>{const a=[];i.once("error",r),i.on("data",m=>a.push(m)),i.on("end",()=>n(Buffer.concat(a)))}))}t.buffer=o}),define(Z[122],te([0,1,44,78]),function($,t,O,b){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.getManifest=void 0;function w(R){return(0,O.buffer)(R,"extension/package.json").then(L=>{try{return JSON.parse(L.toString("utf8"))}catch(T){throw new Error((0,b.localize)(0,null))}})}t.getManifest=w}),define(Z[123],te([0,1,20,3,9,2,8,4,10,19,41,7,31,12,44,79,21,23,24,90,16,14,42]),function($,t,O,b,w,R,L,T,c,d,v,P,g,I,u,l,y,E,f,h,o,s,e){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.ExtensionsScanner=void 0;const i="scanningSystem",n="scanningUser",r="extracting",a="deleting",m="renaming";let S=class extends R.Disposable{constructor(p,C,N,V,Y){super();this.beforeRemovingExtension=p,this.fileService=C,this.logService=N,this.environmentService=V,this.productService=Y,this._devSystemExtensionsPath=null,this.systemExtensionsPath=V.builtinExtensionsPath,this.extensionsPath=V.extensionsPath,this.uninstalledPath=T.join(this.extensionsPath,".obsolete"),this.uninstalledFileLimiter=new b.Queue}async cleanUp(){await this.removeUninstalledExtensions(),await this.removeOutdatedExtensions()}async scanExtensions(p){const C=[];(p===null||p===0)&&C.push(this.scanSystemExtensions().then(null,N=>Promise.reject(new E.ExtensionManagementError(this.joinErrors(N).message,i)))),(p===null||p===1)&&C.push(this.scanUserExtensions(!0).then(null,N=>Promise.reject(new E.ExtensionManagementError(this.joinErrors(N).message,n))));try{const N=await Promise.all(C);return(0,O.flatten)(N)}catch(N){throw this.joinErrors(N)}}async scanUserExtensions(p){this.logService.trace("Started scanning user extensions");let[C,N]=await Promise.all([this.getUninstalledExtensions(),this.scanAllUserExtensions()]);return N=N.filter(V=>!C[new f.ExtensionIdentifierWithVersion(V.identifier,V.manifest.version).key()]),p&&(N=(0,f.groupByExtension)(N,Y=>Y.identifier).map(Y=>Y.sort((ie,oe)=>v.rcompare(ie.manifest.version,oe.manifest.version))[0])),this.logService.trace("Scanned user extensions:",N.length),N}async scanAllUserExtensions(){return this.scanExtensionsInDir(this.extensionsPath,1)}async extractUserExtension(p,C,N,V){const Y=p.key(),ie=T.join(this.extensionsPath,`.${(0,g.generateUuid)()}`),oe=T.join(this.extensionsPath,Y);try{await I.Promises.rm(oe)}catch(ue){try{await I.Promises.rm(oe)}catch(ce){}throw new E.ExtensionManagementError((0,l.localize)(0,null,oe,p.id),a)}await this.extractAtLocation(p,C,ie,V);let ee=await this.scanExtension(P.URI.file(ie),1);if(!ee)throw new Error((0,l.localize)(1,null,ie));await this.storeMetadata(ee,{...N,installedTimestamp:Date.now()});try{await this.rename(p,ie,oe,Date.now()+2*60*1e3),this.logService.info("Renamed to",oe)}catch(ue){try{await I.Promises.rm(ie)}catch(ce){}if(ue.code==="ENOTEMPTY")this.logService.info("Rename failed because extension was installed by another source. So ignoring renaming.",p.id);else throw this.logService.info(`Rename failed because of ${(0,w.getErrorMessage)(ue)}. Deleted from extracted location`,ie),ue}try{ee=await this.scanExtension(P.URI.file(oe),1)}catch(ue){}if(ee)return ee;throw new Error((0,l.localize)(2,null,this.extensionsPath))}async saveMetadataForLocalExtension(p,C){return this.setMetadata(p,C),await this.storeMetadata(p,{...C,installedTimestamp:p.installedTimestamp}),p}async storeMetadata(p,C){C.isMachineScoped=C.isMachineScoped||void 0,C.isBuiltin=C.isBuiltin||void 0,C.installedTimestamp=C.installedTimestamp||void 0;const N=T.join(p.location.fsPath,"package.json"),V=await I.Promises.readFile(N,"utf8"),{manifest:Y}=await this.parseManifest(V);return Y.__metadata=C,await I.Promises.writeFile(N,JSON.stringify(Y,null,"	")),p}getUninstalledExtensions(){return this.withUninstalledExtensions()}async setUninstalled(...p){const C=p.map(N=>new f.ExtensionIdentifierWithVersion(N.identifier,N.manifest.version));await this.withUninstalledExtensions(N=>{C.forEach(V=>N[V.key()]=!0)})}async setInstalled(p){await this.withUninstalledExtensions(V=>delete V[p.key()]);const N=(await this.scanExtensions(1)).find(V=>new f.ExtensionIdentifierWithVersion(V.identifier,V.manifest.version).equals(p))||null;return N?(await this.storeMetadata(N,{installedTimestamp:Date.now()}),this.scanExtension(N.location,1)):null}async withUninstalledExtensions(p){return this.uninstalledFileLimiter.queue(async()=>{let C;try{C=await I.Promises.readFile(this.uninstalledPath,"utf8")}catch(V){if(V.code!=="ENOENT")throw V}let N={};if(C)try{N=JSON.parse(C)}catch(V){}return p&&(p(N),Object.keys(N).length?await I.Promises.writeFile(this.uninstalledPath,JSON.stringify(N)):await I.Promises.rm(this.uninstalledPath)),N})}async removeExtension(p,C){this.logService.trace(`Deleting ${C} extension from disk`,p.identifier.id,p.location.fsPath),await I.Promises.rm(p.location.fsPath),this.logService.info("Deleted from disk",p.identifier.id,p.location.fsPath)}async removeUninstalledExtension(p){await this.removeExtension(p,"uninstalled"),await this.withUninstalledExtensions(C=>delete C[new f.ExtensionIdentifierWithVersion(p.identifier,p.manifest.version).key()])}async extractAtLocation(p,C,N,V){this.logService.trace(`Started extracting the extension from ${C} to ${N}`);try{await I.Promises.rm(N)}catch(Y){throw new E.ExtensionManagementError(this.joinErrors(Y).message,a)}try{await(0,u.extract)(C,N,{sourcePath:"extension",overwrite:!0},V),this.logService.info(`Extracted extension to ${N}:`,p.id)}catch(Y){try{await I.Promises.rm(N)}catch(ie){}throw new E.ExtensionManagementError(Y.message,Y instanceof u.ExtractError&&Y.type?Y.type:r)}}async rename(p,C,N,V){try{await I.Promises.rename(C,N)}catch(Y){if(c.isWindows&&Y&&Y.code==="EPERM"&&Date.now()<V)return this.logService.info(`Failed renaming ${C} to ${N} with 'EPERM' error. Trying again...`,p.id),this.rename(p,C,N,V);throw new E.ExtensionManagementError(Y.message||(0,l.localize)(3,null,C,N),Y.code||m)}}async scanSystemExtensions(){this.logService.trace("Started scanning system extensions");const p=this.scanDefaultSystemExtensions();if(this.environmentService.isBuilt)return p;const C=this.scanDevSystemExtensions(),[N,V]=await Promise.all([p,C]);return[...N,...V]}async scanExtensionsInDir(p,C){const N=new b.Limiter(10),V=await this.fileService.resolve(P.URI.file(p));return V.children?(await Promise.all(V.children.filter(ie=>ie.isDirectory).map(ie=>N.queue(async()=>C===1&&(0,d.basename)(ie.resource).indexOf(".")===0?null:this.scanExtension(ie.resource,C))))).filter(ie=>ie&&ie.identifier):[]}async scanExtension(p,C){try{const N=await this.fileService.resolve(p);if(N.children){const{manifest:V,metadata:Y}=await this.readManifest(p.fsPath),ie=N.children.find(({name:ce})=>/^readme(\.txt|\.md|)$/i.test(ce))?.resource,oe=N.children.find(({name:ce})=>/^changelog(\.txt|\.md|)$/i.test(ce))?.resource,ee={id:(0,f.getGalleryExtensionId)(V.publisher,V.name)},ue={type:C,identifier:ee,manifest:V,location:p,readmeUrl:ie,changelogUrl:oe,publisherDisplayName:null,publisherId:null,isMachineScoped:!1,isBuiltin:C===0};return Y&&(this.setMetadata(ue,Y),ue.installedTimestamp=Y.installedTimestamp),ue}}catch(N){C!==0&&this.logService.trace(N)}return null}async scanDefaultSystemExtensions(){const p=await this.scanExtensionsInDir(this.systemExtensionsPath,0);return this.logService.trace("Scanned system extensions:",p.length),p}async scanDevSystemExtensions(){const p=this.getDevSystemExtensionsList();if(p.length){const C=await this.scanExtensionsInDir(this.devSystemExtensionsPath,0);return this.logService.trace("Scanned dev system extensions:",C.length),C.filter(N=>p.some(V=>(0,f.areSameExtensions)(N.identifier,{id:V})))}else return[]}setMetadata(p,C){p.publisherDisplayName=C.publisherDisplayName||null,p.publisherId=C.publisherId||null,p.identifier.uuid=C.id,p.isMachineScoped=!!C.isMachineScoped,p.isBuiltin=p.type===0||!!C.isBuiltin}async removeUninstalledExtensions(){const p=await this.getUninstalledExtensions(),C=await this.scanAllUserExtensions(),N=new Set;for(const ie of C)p[new f.ExtensionIdentifierWithVersion(ie.identifier,ie.manifest.version).key()]||N.add(ie.identifier.id.toLowerCase());const V=(0,f.groupByExtension)(C,ie=>ie.identifier);await b.Promises.settled(V.map(async ie=>{const oe=ie.sort((ee,ue)=>v.rcompare(ee.manifest.version,ue.manifest.version))[0];N.has(oe.identifier.id.toLowerCase())||await this.beforeRemovingExtension(oe)}));const Y=C.filter(ie=>p[new f.ExtensionIdentifierWithVersion(ie.identifier,ie.manifest.version).key()]);await b.Promises.settled(Y.map(ie=>this.removeUninstalledExtension(ie)))}async removeOutdatedExtensions(){const p=await this.scanAllUserExtensions(),C=[],N=(0,f.groupByExtension)(p,V=>V.identifier);C.push(...(0,O.flatten)(N.map(V=>V.sort((Y,ie)=>v.rcompare(Y.manifest.version,ie.manifest.version)).slice(1)))),await b.Promises.settled(C.map(V=>this.removeExtension(V,"outdated")))}getDevSystemExtensionsList(){return(this.productService.builtInExtensions||[]).map(p=>p.name)}joinErrors(p){const C=Array.isArray(p)?p:[p];return C.length===1?C[0]instanceof Error?C[0]:new Error(C[0]):C.reduce((N,V)=>new Error(`${N.message}${N.message?",":""}${V instanceof Error?V.message:V}`),new Error(""))}get devSystemExtensionsPath(){return this._devSystemExtensionsPath||(this._devSystemExtensionsPath=T.normalize(T.join(L.FileAccess.asFileUri("",$).fsPath,"..",".build","builtInExtensions"))),this._devSystemExtensionsPath}async readManifest(p){const C=[I.Promises.readFile(T.join(p,"package.json"),"utf8").then(ie=>this.parseManifest(ie)),I.Promises.readFile(T.join(p,"package.nls.json"),"utf8").then(void 0,ie=>ie.code!=="ENOENT"?Promise.reject(ie):"{}").then(ie=>JSON.parse(ie))],[{manifest:N,metadata:V},Y]=await Promise.all(C);return{manifest:(0,h.localizeManifest)(N,Y),metadata:V}}parseManifest(p){return new Promise((C,N)=>{try{const V=JSON.parse(p),Y=V.__metadata||null;C({manifest:V,metadata:Y})}catch(V){N(new Error((0,l.localize)(4,null)))}})}};S=de([le(1,o.IFileService),le(2,s.ILogService),le(3,y.INativeEnvironmentService),le(4,e.IProductService)],S),t.ExtensionsScanner=S}),define(Z[124],te([0,1,30,9,8,4,10,28,19,41,7,31,12,44,77,53,21,117,23,24,101,102,122,97,123,103,51,16,15,14,32,29]),function($,t,O,b,w,R,L,T,c,d,v,P,g,I,u,l,y,E,f,h,o,s,e,i,n,r,a,m,S,F,p,C){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.ExtensionManagementService=void 0;const N="unsetUninstalled",V="downloading";let Y=class extends E.AbstractExtensionManagementService{constructor(G,ne,z,D,M,U,K){super(G,ne,z);this.environmentService=D,this.downloadService=M,this.fileService=K;const B=this._register(U.createInstance(s.ExtensionsLifecycle));this.extensionsScanner=this._register(U.createInstance(n.ExtensionsScanner,q=>B.postUninstall(q))),this.manifestCache=this._register(new i.ExtensionsManifestCache(D,this)),this.extensionsDownloader=this._register(U.createInstance(o.ExtensionsDownloader));const J=this._register(new r.ExtensionsWatcher(this,K,D,z));this._register(J.onDidChangeExtensionsByAnotherSource(({added:q,removed:k})=>{q.length&&this._onDidInstallExtensions.fire(q.map(A=>({identifier:A.identifier,operation:0,local:A}))),k.forEach(A=>this._onDidUninstallExtension.fire({identifier:A}))}))}getTargetPlatform(){return this._targetPlatformPromise||(this._targetPlatformPromise=(async()=>{const G=await this.isAlpineLinux(),ne=(0,f.getTargetPlatform)(G?"alpine":L.platform,T.arch);return this.logService.debug("ExtensionManagementService#TargetPlatform:",ne),ne})()),this._targetPlatformPromise}async isAlpineLinux(){if(!L.isLinux)return!1;let G;try{G=(await this.fileService.readFile(v.URI.file("/etc/os-release"))).value.toString()}catch(ne){try{G=(await this.fileService.readFile(v.URI.file("/usr/lib/os-release"))).value.toString()}catch(z){this.logService.debug("Error while getting the os-release file.",(0,b.getErrorMessage)(z))}}return!!G&&(G.match(/^ID=([^\u001b\r\n]*)/m)||[])[1]==="alpine"}async zip(G){this.logService.trace("ExtensionManagementService#zip",G.identifier.id);const ne=await this.collectFiles(G),z=await(0,I.zip)((0,c.joinPath)(this.environmentService.tmpDir,(0,P.generateUuid)()).fsPath,ne);return v.URI.file(z)}async unzip(G){return this.logService.trace("ExtensionManagementService#unzip",G.toString()),(await this.install(G)).identifier}async getManifest(G){const ne=await this.downloadVsix(G),z=R.resolve(ne.fsPath);return(0,e.getManifest)(z)}getInstalled(G=null){return this.extensionsScanner.scanExtensions(G)}async install(G,ne={}){this.logService.trace("ExtensionManagementService#install",G.toString());const z=await this.downloadVsix(G),D=await(0,e.getManifest)(R.resolve(z.fsPath));if(D.engines&&D.engines.vscode&&!(0,a.isEngineValid)(D.engines.vscode,p.default.version,p.default.date))throw new Error(u.localize(0,null,(0,h.getGalleryExtensionId)(D.publisher,D.name),p.default.version));return this.installExtension(D,z,ne)}async updateMetadata(G,ne){return this.logService.trace("ExtensionManagementService#updateMetadata",G.identifier.id),G=await this.extensionsScanner.saveMetadataForLocalExtension(G,{...G.manifest.__metadata||{},...ne}),this.manifestCache.invalidate(),G}async updateExtensionScope(G,ne){return this.logService.trace("ExtensionManagementService#updateExtensionScope",G.identifier.id),G=await this.extensionsScanner.saveMetadataForLocalExtension(G,{...G.manifest.__metadata||{},isMachineScoped:ne}),this.manifestCache.invalidate(),G}removeDeprecatedExtensions(){return this.extensionsScanner.cleanUp()}async downloadVsix(G){if(G.scheme===w.Schemas.file)return G;const ne=(0,c.joinPath)(this.environmentService.tmpDir,(0,P.generateUuid)());return await this.downloadService.download(G,ne),ne}createInstallExtensionTask(G,ne,z){return v.URI.isUri(ne)?new ee(G,ne,z,this.galleryService,this.extensionsScanner,this.logService):new oe(ne,z,this.extensionsDownloader,this.extensionsScanner,this.logService)}createUninstallExtensionTask(G,ne){return new ue(G,ne,this.extensionsScanner)}async collectFiles(G){const ne=async D=>{let M=await g.Promises.readdir(D);M=M.map(B=>R.join(D,B));const U=await Promise.all(M.map(B=>g.Promises.stat(B)));let K=Promise.resolve([]);return U.forEach((B,J)=>{const q=M[J];B.isFile()&&(K=K.then(k=>[...k,q])),B.isDirectory()&&(K=K.then(k=>ne(q).then(A=>[...k,...A])))}),K};return(await ne(G.location.fsPath)).map(D=>({path:`extension/${R.relative(G.location.fsPath,D)}`,localPath:D}))}};Y=de([le(0,f.IExtensionGalleryService),le(1,C.ITelemetryService),le(2,F.ILogService),le(3,y.INativeEnvironmentService),le(4,l.IDownloadService),le(5,S.IInstantiationService),le(6,m.IFileService)],Y),t.ExtensionManagementService=Y;class ie extends E.AbstractExtensionTask{constructor(G,ne,z,D){super();this.identifier=G,this.source=ne,this.extensionsScanner=z,this.logService=D,this._operation=1}get operation(){return this._operation}async installExtension(G,ne){try{const z=await this.unsetUninstalledAndGetLocal(G.identifierWithVersion);if(z)return G.metadata?this.extensionsScanner.saveMetadataForLocalExtension(z,G.metadata):z}catch(z){throw L.isMacintosh?new f.ExtensionManagementError(u.localize(1,null),N):new f.ExtensionManagementError(u.localize(2,null),N)}return this.extract(G,ne)}async unsetUninstalledAndGetLocal(G){if(!await this.isUninstalled(G))return null;this.logService.trace("Removing the extension from uninstalled list:",G.id);const z=await this.extensionsScanner.setInstalled(G);return this.logService.info("Removed the extension from uninstalled list:",G.id),z}async isUninstalled(G){return!!(await this.extensionsScanner.getUninstalledExtensions())[G.key()]}async extract({zipPath:G,identifierWithVersion:ne,metadata:z},D){let M=await this.extensionsScanner.extractUserExtension(ne,G,z,D);return this.logService.info("Extracting completed.",ne.id),M}}class oe extends ie{constructor(G,ne,z,D,M){super(G.identifier,G,D,M);this.gallery=G,this.options=ne,this.extensionsDownloader=z}async doRun(G){const z=(await this.extensionsScanner.scanExtensions(null)).find(U=>(0,h.areSameExtensions)(U.identifier,this.gallery.identifier));z&&(this._operation=2);const D=await this.downloadInstallableExtension(this.gallery,this._operation);D.metadata.isMachineScoped=this.options.isMachineScoped||z?.isMachineScoped,D.metadata.isBuiltin=this.options.isBuiltin||z?.isBuiltin;const M=await this.installExtension(D,G);z&&d.neq(z.manifest.version,this.gallery.version)&&await this.extensionsScanner.setUninstalled(z);try{await this.extensionsDownloader.delete(v.URI.file(D.zipPath))}catch(U){}return M}async downloadInstallableExtension(G,ne){const z={id:G.identifier.uuid,publisherId:G.publisherId,publisherDisplayName:G.publisherDisplayName};let D;try{this.logService.trace("Started downloading extension:",G.identifier.id),D=(await this.extensionsDownloader.downloadExtension(G,ne)).fsPath,this.logService.info("Downloaded extension:",G.identifier.id,D)}catch(M){throw new f.ExtensionManagementError((0,E.joinErrors)(M).message,V)}try{const M=await(0,e.getManifest)(D);return{zipPath:D,identifierWithVersion:new h.ExtensionIdentifierWithVersion(G.identifier,M.version),metadata:z}}catch(M){throw new f.ExtensionManagementError((0,E.joinErrors)(M).message,E.INSTALL_ERROR_VALIDATING)}}}class ee extends ie{constructor(G,ne,z,D,M,U){super({id:(0,h.getGalleryExtensionId)(G.publisher,G.name)},ne,M,U);this.manifest=G,this.location=ne,this.options=z,this.galleryService=D}async doRun(G){const ne=new h.ExtensionIdentifierWithVersion(this.identifier,this.manifest.version),D=(await this.extensionsScanner.scanExtensions(1)).find(U=>(0,h.areSameExtensions)(this.identifier,U.identifier)),M=await this.getMetadata(this.identifier.id,G);if(M.isMachineScoped=this.options.isMachineScoped||D?.isMachineScoped,M.isBuiltin=this.options.isBuiltin||D?.isBuiltin,D)if(this._operation=2,ne.equals(new h.ExtensionIdentifierWithVersion(D.identifier,D.manifest.version)))try{await this.extensionsScanner.removeExtension(D,"existing")}catch(U){throw new Error(u.localize(3,null,this.manifest.displayName||this.manifest.name))}else d.gt(D.manifest.version,this.manifest.version)&&await this.extensionsScanner.setUninstalled(D);else{const U=await this.unsetUninstalledAndGetLocal(ne);if(U)try{await this.extensionsScanner.removeExtension(U,"existing")}catch(K){throw new Error(u.localize(4,null,this.manifest.displayName||this.manifest.name))}}return this.installExtension({zipPath:R.resolve(this.location.fsPath),identifierWithVersion:ne,metadata:M},G)}async getMetadata(G,ne){try{const z=(await this.galleryService.query({names:[G],pageSize:1},ne)).firstPage[0];if(z)return{id:z.identifier.uuid,publisherDisplayName:z.publisherDisplayName,publisherId:z.publisherId}}catch(z){}return{}}}class ue extends E.AbstractExtensionTask{constructor(G,ne,z){super();this.extension=G,this.options=ne,this.extensionsScanner=z}async doRun(G){const ne=[],z=await this.extensionsScanner.scanUserExtensions(!1);if(this.options.versionOnly){const D=new h.ExtensionIdentifierWithVersion(this.extension.identifier,this.extension.manifest.version);ne.push(...z.filter(M=>D.equals(new h.ExtensionIdentifierWithVersion(M.identifier,M.manifest.version))))}else ne.push(...z.filter(D=>(0,h.areSameExtensions)(D.identifier,this.extension.identifier)));if(!ne.length)throw new Error(u.localize(5,null,this.extension.manifest.displayName||this.extension.manifest.name));if(await this.extensionsScanner.setUninstalled(...ne),this.options.remove)for(const D of ne)try{G.isCancellationRequested||await this.extensionsScanner.removeUninstalledExtension(D)}catch(M){throw new Error(u.localize(6,null,(0,O.toErrorMessage)(M)))}}}}),define(Z[125],te([0,1,113,17,9,2,11,27,21,98,14,112,134]),function($,t,O,b,w,R,L,T,c,d,v,P,g){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.RequestService=void 0;let I=class extends R.Disposable{constructor(l,y,E){super();this.environmentService=y,this.logService=E,this.configure(l.getValue()),this._register(l.onDidChangeConfiguration(()=>this.configure(l.getValue()),this))}configure(l){this.proxyUrl=l.http&&l.http.proxy,this.strictSSL=!!(l.http&&l.http.proxyStrictSSL),this.authorization=l.http&&l.http.proxyAuthorization}async request(l,y){this.logService.trace("RequestService#request",l.url);const{proxyUrl:E,strictSSL:f}=this,h={...process.env,...await(0,d.resolveShellEnv)(this.logService,this.environmentService.args,process.env)},o=l.agent?l.agent:await(0,P.getProxyAgent)(l.url||"",h,{proxyUrl:E,strictSSL:f});return l.agent=o,l.strictSSL=f,this.authorization&&(l.headers={...l.headers||{},"Proxy-Authorization":this.authorization}),this._request(l,y)}async getNodeRequest(l){return((0,O.parse)(l.url).protocol==="https:"?await new Promise((f,h)=>{$(["https"],f,h)}):await new Promise((f,h)=>{$(["http"],f,h)})).request}_request(l,y){return new Promise(async(E,f)=>{let h;const o=(0,O.parse)(l.url),s=l.getRawRequest?l.getRawRequest(l):await this.getNodeRequest(l),e={hostname:o.hostname,port:o.port?parseInt(o.port):o.protocol==="https:"?443:80,protocol:o.protocol,path:o.path,method:l.type||"GET",headers:l.headers,agent:l.agent,rejectUnauthorized:(0,L.isBoolean)(l.strictSSL)?l.strictSSL:!0};l.user&&l.password&&(e.auth=l.user+":"+l.password),h=s(e,i=>{const n=(0,L.isNumber)(l.followRedirects)?l.followRedirects:3;if(i.statusCode&&i.statusCode>=300&&i.statusCode<400&&n>0&&i.headers.location)this._request({...l,url:i.headers.location,followRedirects:n-1},y).then(E,f);else{let r=i;i.headers["content-encoding"]==="gzip"&&(r=i.pipe((0,g.createGunzip)())),E({res:i,stream:(0,b.streamToBufferReadableStream)(r)})}}),h.on("error",f),l.timeout&&h.setTimeout(l.timeout),l.data&&typeof l.data=="string"&&h.write(l.data),h.end(),y.onCancellationRequested(()=>{h.abort(),f((0,w.canceled)())})})}async resolveProxy(l){}};I=de([le(0,T.IConfigurationService),le(1,c.INativeEnvironmentService),le(2,v.ILogService)],I),t.RequestService=I}),define(Z[135],te([0,1,48,136,34,3,17,30,9,2,8,4,28,7,12,27,110,53,111,21,89,118,23,96,124,16,106,107,52,100,55,56,104,14,105,32,42,43,125,116,29,119,36,120,121]),function($,t,O,b,w,R,L,T,c,d,v,P,g,I,u,l,y,E,f,h,o,s,e,i,n,r,a,m,S,F,p,C,N,V,Y,ie,oe,ee,ue,ce,G,ne,z,D,M){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.main=void 0;class U extends d.Disposable{constructor(J){super();this.argv=J,(0,b.gracefulify)(O),this.registerListeners()}registerListeners(){process.once("exit",()=>this.dispose())}async run(){const[J,q]=await this.initServices();return J.invokeFunction(async k=>{const A=k.get(V.ILogService),j=k.get(r.IFileService),W=k.get(h.INativeEnvironmentService),X=k.get(e.IExtensionManagementCLIService);A.info("CLI main",this.argv),this.registerErrorHandler(A),await this.doRun(W,X,j),await Promise.all(q.map(Q=>{(0,R.raceTimeout)(Q.flush(),1e3)}))})}async initServices(){const J=new p.ServiceCollection,q={_serviceBrand:void 0,...ie.default};J.set(oe.IProductService,q);const k=new o.NativeEnvironmentService(this.argv,q);J.set(h.INativeEnvironmentService,k),await Promise.all([k.appSettingsHome.fsPath,k.extensionsPath].map(me=>me?u.Promises.mkdir(me,{recursive:!0}):void 0));const A=(0,V.getLogLevel)(k),j=[];j.push(new Y.SpdLogLogger("cli",(0,P.join)(k.logsPath,"cli.log"),!0,A)),A===V.LogLevel.Trace&&j.push(new V.ConsoleLogger(A));const W=this._register(new V.MultiplexLogService(j));J.set(V.ILogService,W);const X=this._register(new a.FileService(W));J.set(r.IFileService,X);const Q=this._register(new m.DiskFileSystemProvider(W));X.registerProvider(v.Schemas.file,Q);const se=this._register(new y.ConfigurationService(k.settingsResource,X));J.set(l.IConfigurationService,se),await se.initialize(),J.set(ee.IRequestService,new S.SyncDescriptor(ue.RequestService)),J.set(E.IDownloadService,new S.SyncDescriptor(f.DownloadService)),J.set(e.IExtensionManagementService,new S.SyncDescriptor(n.ExtensionManagementService)),J.set(e.IExtensionGalleryService,new S.SyncDescriptor(s.ExtensionGalleryServiceWithNoStorageService)),J.set(e.IExtensionManagementCLIService,new S.SyncDescriptor(i.ExtensionManagementCLIService)),J.set(C.ILocalizationsService,new S.SyncDescriptor(N.LocalizationsService));const re=[];if((0,z.supportsTelemetry)(q,k)){q.aiConfig&&q.aiConfig.asimovKey&&re.push(new D.AppInsightsAppender("monacoworkbench",null,q.aiConfig.asimovKey));const{appRoot:me,extensionsPath:ye,installSourcePath:fe}=k,Pe={appenders:re,sendErrorTelemetry:!1,commonProperties:(async()=>{let pe;try{const Ee=await u.Promises.readFile((0,P.join)(k.userDataPath,"storage.json"));pe=JSON.parse(Ee.toString())[G.machineIdKey]}catch(Ee){Ee.code!=="ENOENT"&&W.error(Ee)}return(0,ce.resolveCommonProperties)(X,(0,w.release)(),(0,w.hostname)(),process.arch,q.commit,q.version,pe,q.msftInternalDomains,fe)})(),piiPaths:[me,ye]};J.set(G.ITelemetryService,new S.SyncDescriptor(ne.TelemetryService,[Pe]))}else J.set(G.ITelemetryService,z.NullTelemetryService);return[new F.InstantiationService(J),re]}registerErrorHandler(J){(0,c.setUnexpectedErrorHandler)(q=>{const k=(0,T.toErrorMessage)(q,!0);!k||J.error(`[uncaught exception in CLI]: ${k}`)}),process.on("uncaughtException",q=>(0,c.onUnexpectedError)(q)),process.on("unhandledRejection",q=>(0,c.onUnexpectedError)(q))}async doRun(J,q,k){if(this.argv["install-source"])return this.setInstallSource(J,k,this.argv["install-source"]);if(this.argv["list-extensions"])return q.listExtensions(!!this.argv["show-versions"],this.argv.category);if(this.argv["install-extension"]||this.argv["install-builtin-extension"])return q.installExtensions(this.asExtensionIdOrVSIX(this.argv["install-extension"]||[]),this.argv["install-builtin-extension"]||[],!!this.argv["do-not-sync"],!!this.argv.force);if(this.argv["uninstall-extension"])return q.uninstallExtensions(this.asExtensionIdOrVSIX(this.argv["uninstall-extension"]),!!this.argv.force);if(this.argv["locate-extension"])return q.locateExtension(this.argv["locate-extension"]);this.argv.telemetry&&console.log(await(0,M.buildTelemetryMessage)(J.appRoot,J.extensionsPath))}asExtensionIdOrVSIX(J){return J.map(q=>/\.vsix$/i.test(q)?I.URI.file((0,P.isAbsolute)(q)?q:(0,P.join)((0,g.cwd)(),q)):q)}async setInstallSource(J,q,k){await q.writeFile(I.URI.file(J.installSourcePath),L.VSBuffer.fromString(k.slice(0,30)))}}async function K(B){const J=new U(B);try{await J.run()}finally{J.dispose()}}t.main=K})}).call(this);

//# sourceMappingURL=https://ticino.blob.core.windows.net/sourcemaps/53aff5e347865fe22f9487ebd54dec9db23773b2/core/vs/code/node/cliProcessMain.js.map
