/*!--------------------------------------------------------
 * Copyright (C) Microsoft Corporation. All rights reserved.
 *--------------------------------------------------------*/(function(){var we=["require","exports","vs/base/common/uri","vs/base/common/event","vs/platform/instantiation/common/instantiation","vs/workbench/api/common/extHost.protocol","vs/base/common/lifecycle","vs/workbench/api/common/extHostTypes","vs/workbench/api/common/extHostTypeConverters","vs/base/common/strings","vs/base/common/types","vs/base/common/network","vs/base/common/arrays","vs/workbench/api/common/extHostRpcService","vs/base/common/async","vs/platform/log/common/log","vs/base/common/errors","vs/base/common/path","vs/nls","vs/nls!vs/workbench/services/extensions/worker/extensionHostWorker","vs/base/common/map","vs/base/common/cancellation","vs/base/common/buffer","vs/base/common/objects","vs/base/common/resources","vs/platform/extensions/common/extensions","vs/base/common/platform","vs/base/common/glob","vs/platform/registry/common/platform","vs/workbench/api/common/extHostInitDataService","vs/workbench/services/extensions/common/extensions","vs/workbench/api/common/extHostWorkspace","vs/workbench/api/common/extHostConfiguration","vs/workbench/api/common/extHostExtensionService","vs/base/common/codicons","vs/base/common/severity","vs/base/common/uuid","vs/workbench/api/common/extHostFileSystemInfo","vs/workbench/services/extensions/common/proxyIdentifier","vs/workbench/api/common/extHostCommands","vs/workbench/api/common/extHostTerminalService","vs/workbench/services/search/common/search","vs/base/common/assert","vs/base/common/extpath","vs/editor/common/core/range","vs/platform/contextkey/common/contextkey","vs/platform/theme/common/themeService","vs/platform/workspace/common/workspace","vs/workbench/api/common/extHostTestingPrivateApi","vs/workbench/api/common/extHostDocumentsAndEditors","vs/workbench/api/common/extHostWebview","vs/base/common/collections","vs/base/common/decorators","vs/base/common/idGenerator","vs/base/common/marshalling","vs/editor/common/modes/languageSelector","vs/base/common/errorMessage","vs/platform/instantiation/common/extensions","vs/base/common/hash","vs/editor/common/modes","vs/platform/files/common/files","vs/platform/instantiation/common/serviceCollection","vs/platform/configuration/common/configurationRegistry","vs/workbench/api/common/cache","vs/workbench/api/common/extHostTunnelService","vs/workbench/api/common/extHostUriTransformerService","vs/workbench/api/common/shared/webview","vs/workbench/contrib/testing/common/testId","vs/workbench/api/common/extHostEditorTabs","vs/workbench/api/common/exHostSecretState","vs/workbench/api/common/extHostApiDeprecationService","vs/workbench/api/common/extHostFileSystemConsumer","vs/workbench/api/common/extHostStorage","vs/workbench/api/common/extHostStoragePaths","vs/base/common/performance","vs/base/common/numbers","vs/base/common/htmlContent","vs/base/common/labels","vs/base/common/mime","vs/editor/common/model","vs/editor/common/services/semanticTokensDto","vs/platform/instantiation/common/descriptors","vs/platform/markers/common/markers","vs/platform/jsonschemas/common/jsonContributionRegistry","vs/platform/configuration/common/configuration","vs/platform/remote/common/remoteAuthorityResolver","vs/platform/remote/common/remoteHosts","vs/workbench/api/common/extHostTelemetry","vs/workbench/api/common/extHostDocumentData","vs/workbench/contrib/notebook/common/notebookCommon","vs/workbench/contrib/testing/common/testCollection","vs/base/common/process","vs/workbench/services/editor/common/editorGroupsService","vs/workbench/api/common/extHostNotebookEditor","vs/workbench/api/common/extHostTextEditor","vs/workbench/api/common/extHostDecorations","vs/workbench/api/common/extHostOutput","vs/workbench/api/common/extHostWindow","vs/workbench/services/search/common/searchExtTypes","vs/workbench/api/common/extHostTask","vs/workbench/api/common/extHostDebugService","vs/workbench/api/common/extHostSearch","vs/base/common/json","vs/base/common/lazy","vs/base/common/skipList","vs/base/common/stream","vs/base/common/filters","vs/base/common/iconLabels","vs/base/common/comparers","vs/base/common/uriIpc","vs/editor/common/controller/wordCharacterClassifier","vs/editor/common/model/textModelSearch","vs/editor/common/core/position","vs/editor/common/modes/languageConfiguration","vs/editor/common/modes/tokenizationRegistry","vs/nls!vs/base/common/errorMessage","vs/nls!vs/editor/common/config/editorOptions","vs/editor/common/config/editorOptions","vs/editor/common/model/wordHelper","vs/nls!vs/platform/configuration/common/configurationRegistry","vs/nls!vs/platform/extensions/common/extensionValidator","vs/nls!vs/platform/files/common/files","vs/nls!vs/platform/markers/common/markers","vs/nls!vs/platform/theme/common/iconRegistry","vs/nls!vs/workbench/api/common/extHostDiagnostics","vs/nls!vs/workbench/api/common/extHostExtensionService","vs/nls!vs/workbench/api/common/extHostProgress","vs/nls!vs/workbench/api/common/extHostStatusBar","vs/nls!vs/workbench/api/common/extHostTerminalService","vs/nls!vs/workbench/api/common/extHostTreeViews","vs/nls!vs/workbench/api/common/extHostWorkspace","vs/nls!vs/workbench/common/editor","vs/nls!vs/workbench/common/views","vs/nls!vs/workbench/contrib/debug/common/abstractDebugAdapter","vs/nls!vs/workbench/contrib/search/common/queryBuilder","vs/nls!vs/workbench/contrib/tasks/common/taskService","vs/nls!vs/workbench/services/configurationResolver/common/variableResolver","vs/platform/editor/common/editor","vs/platform/extensions/common/extensionValidator","vs/platform/instantiation/common/graph","vs/editor/common/services/modelService","vs/editor/common/modes/languageFeatureRegistry","vs/platform/environment/common/environment","vs/platform/extensionManagement/common/extensionManagementUtil","vs/platform/instantiation/common/instantiationService","vs/platform/notification/common/notification","vs/platform/opener/common/opener","vs/platform/progress/common/progress","vs/platform/configuration/common/configurationModels","vs/platform/terminal/common/terminalDataBuffering","vs/platform/theme/common/theme","vs/platform/theme/common/iconRegistry","vs/workbench/api/common/extHostMemento","vs/workbench/api/common/extHostNotebookDocuments","vs/workbench/api/common/extHostSecrets","vs/workbench/api/common/extHostNotebookConcatDocument","vs/workbench/api/common/extHostTheming","vs/workbench/api/common/extHostWebviewMessaging","vs/workbench/api/common/shared/treeDataTransfer","vs/workbench/api/common/extHostCodeInsets","vs/workbench/common/editor","vs/workbench/common/views","vs/workbench/contrib/debug/common/abstractDebugAdapter","vs/workbench/contrib/debug/common/debugUtils","vs/workbench/contrib/notebook/common/notebookExecutionService","vs/workbench/contrib/tasks/common/taskService","vs/workbench/contrib/terminal/common/environmentVariableShared","vs/workbench/services/configurationResolver/common/variableResolver","vs/workbench/services/editor/common/editorService","vs/workbench/api/common/extHostDocumentSaveParticipant","vs/workbench/api/common/extHostFileSystemEventService","vs/workbench/api/common/extHostNotebookDocument","vs/workbench/api/common/extHostProgress","vs/workbench/api/common/extHostTreeViews","vs/workbench/contrib/testing/common/ownedTestCollection","vs/workbench/services/environment/common/environmentService","vs/workbench/services/extensions/common/extensionDescriptionRegistry","vs/workbench/services/extensions/common/extensionHostProtocol","vs/workbench/api/common/extHostExtensionActivator","vs/workbench/services/extensions/common/lazyPromise","vs/workbench/api/common/extHostAuthentication","vs/workbench/api/common/extHostBulkEdits","vs/workbench/api/common/extHostClipboard","vs/workbench/api/common/extHostApiCommands","vs/workbench/api/common/extHostComments","vs/workbench/api/common/extHostDiagnostics","vs/workbench/api/common/extHostDialogs","vs/workbench/api/common/extHostDocumentContentProviders","vs/workbench/api/common/extHostDocuments","vs/workbench/api/common/extHostFileSystem","vs/workbench/api/common/extHostInteractive","vs/workbench/api/common/extHostLabelService","vs/workbench/api/common/extHostLanguageFeatures","vs/base/common/stopwatch","vs/workbench/api/common/extHostLanguages","vs/workbench/api/common/extHostMessageService","vs/workbench/api/common/extHostNotebook","vs/workbench/api/common/extHostNotebookEditors","vs/workbench/api/common/extHostNotebookKernels","vs/workbench/api/common/extHostNotebookRenderers","vs/workbench/api/common/extHostQuickOpen","vs/workbench/api/common/extHostSCM","vs/workbench/api/common/extHostStatusBar","vs/workbench/api/common/extHostTesting","vs/workbench/api/common/extHostTextEditors","vs/workbench/api/common/extHostTimeline","vs/workbench/api/common/extHostUriOpener","vs/workbench/api/common/extHostUrls","vs/workbench/api/common/extHostCustomEditors","vs/workbench/api/common/extHostWebviewPanels","vs/workbench/api/common/extHostWebviewView","vs/workbench/api/worker/extHostLogService","vs/workbench/services/extensions/common/rpcProtocol","vs/workbench/services/extensions/worker/polyfillNestedWorker","vs/workbench/services/remote/common/remoteAgentService","vs/workbench/services/path/common/pathService","vs/workbench/contrib/search/common/queryBuilder","vs/workbench/api/common/shared/workspaceContains","vs/workbench/api/common/extHostRequireInterceptor","vs/workbench/services/extensions/common/extensionHostMain","vs/workbench/services/search/common/fileSearchManager","vs/workbench/services/search/common/textSearchManager","vs/workbench/api/common/extHost.api.impl","vs/workbench/api/common/extHost.common.services","vs/workbench/api/worker/extHostExtensionService","vs/workbench/api/worker/extHost.worker.services","vs/editor/common/core/characterClassifier","vs/editor/common/model/mirrorTextModel","vs/editor/common/viewModel/prefixSumComputer","vs/base/common/marked/marked","vs/base/common/linkedList","vs/base/common/iterator","vs/editor/common/modes/linkComputer","vs/editor/common/core/selection","vs/base/common/functional","vs/workbench/services/extensions/worker/extensionHostWorker"],Ee=function(re){for(var e=[],c=0,M=re.length;c<M;c++)e[c]=we[re[c]];return e};define(we[42],Ee([0,1]),function(re,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ok=void 0;function c(M,b){if(!M)throw new Error(b?`Assertion failed (${b})`:"Assertion Failed")}e.ok=c}),define(we[51],Ee([0,1]),function(re,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.SetMap=e.diffMaps=e.diffSets=e.fromMap=e.groupBy=e.forEach=e.values=void 0;const c=Object.prototype.hasOwnProperty;function M(t){const E=[];for(let n in t)c.call(t,n)&&E.push(t[n]);return E}e.values=M;function b(t,E){for(let n in t)if(c.call(t,n)&&E({key:n,value:t[n]},function(){delete t[n]})===!1)return}e.forEach=b;function R(t,E){const n=Object.create(null);for(const f of t){const a=E(f);let l=n[a];l||(l=n[a]=[]),l.push(f)}return n}e.groupBy=R;function F(t){const E=Object.create(null);return t&&t.forEach((n,f)=>{E[f]=n}),E}e.fromMap=F;function C(t,E){const n=[],f=[];for(let a of t)E.has(a)||n.push(a);for(let a of E)t.has(a)||f.push(a);return{removed:n,added:f}}e.diffSets=C;function _(t,E){const n=[],f=[];for(let[a,l]of t)E.has(a)||n.push(l);for(let[a,l]of E)t.has(a)||f.push(l);return{removed:n,added:f}}e.diffMaps=_;class P{constructor(){this.map=new Map}add(E,n){let f=this.map.get(E);f||(f=new Set,this.map.set(E,f)),f.add(n)}delete(E,n){const f=this.map.get(E);!f||(f.delete(n),f.size===0&&this.map.delete(E))}forEach(E,n){const f=this.map.get(E);!f||f.forEach(n)}}e.SetMap=P}),define(we[52],Ee([0,1]),function(re,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.throttle=e.debounce=e.memoize=e.createDecorator=void 0;function c(F){return(C,_,P)=>{let t=null,E=null;if(typeof P.value=="function"?(t="value",E=P.value):typeof P.get=="function"&&(t="get",E=P.get),!E)throw new Error("not supported");P[t]=F(E,_)}}e.createDecorator=c;function M(F,C,_){let P=null,t=null;if(typeof _.value=="function"?(P="value",t=_.value,t.length!==0&&console.warn("Memoize should only be used in functions with zero parameters")):typeof _.get=="function"&&(P="get",t=_.get),!t)throw new Error("not supported");const E=`$memoize$${C}`;_[P]=function(...n){return this.hasOwnProperty(E)||Object.defineProperty(this,E,{configurable:!1,enumerable:!1,writable:!1,value:t.apply(this,n)}),this[E]}}e.memoize=M;function b(F,C,_){return c((P,t)=>{const E=`$debounce$${t}`,n=`$debounce$result$${t}`;return function(...f){this[n]||(this[n]=_?_():void 0),clearTimeout(this[E]),C&&(this[n]=C(this[n],...f),f=[this[n]]),this[E]=setTimeout(()=>{P.apply(this,f),this[n]=_?_():void 0},F)}})}e.debounce=b;function R(F,C,_){return c((P,t)=>{const E=`$throttle$timer$${t}`,n=`$throttle$result$${t}`,f=`$throttle$lastRun$${t}`,a=`$throttle$pending$${t}`;return function(...l){if(this[n]||(this[n]=_?_():void 0),(this[f]===null||this[f]===void 0)&&(this[f]=-Number.MAX_VALUE),C&&(this[n]=C(this[n],...l)),this[a])return;const w=this[f]+F;w<=Date.now()?(this[f]=Date.now(),P.apply(this,[this[n]]),this[n]=_?_():void 0):(this[a]=!0,this[E]=setTimeout(()=>{this[a]=!1,this[f]=Date.now(),P.apply(this,[this[n]]),this[n]=_?_():void 0},w-Date.now()))}})}e.throttle=R}),define(we[12],Ee([0,1,16]),function(re,e,c){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ArrayQueue=e.maxIndex=e.minIndex=e.splice=e.insertInto=e.mapFind=e.getRandomElement=e.asArray=e.mapArrayOrNot=e.pushToEnd=e.pushToStart=e.shuffle=e.arrayInsert=e.remove=e.insert=e.index=e.range=e.flatten=e.commonPrefixLength=e.firstOrDefault=e.lastIndex=e.uniqueFilter=e.distinctES6=e.distinct=e.isNonEmptyArray=e.isFalsyOrEmpty=e.move=e.coalesceInPlace=e.coalesce=e.topAsync=e.top=e.delta=e.sortedDiff=e.groupBy=e.quickSelect=e.findFirstInSorted=e.binarySearch=e.equals=e.tail2=e.tail=void 0;function M(j,le=0){return j[j.length-(1+le)]}e.tail=M;function b(j){if(j.length===0)throw new Error("Invalid tail call");return[j.slice(0,j.length-1),j[j.length-1]]}e.tail2=b;function R(j,le,oe=(ve,Re)=>ve===Re){if(j===le)return!0;if(!j||!le||j.length!==le.length)return!1;for(let ve=0,Re=j.length;ve<Re;ve++)if(!oe(j[ve],le[ve]))return!1;return!0}e.equals=R;function F(j,le,oe){let ve=0,Re=j.length-1;for(;ve<=Re;){const Me=(ve+Re)/2|0,Oe=oe(j[Me],le);if(Oe<0)ve=Me+1;else if(Oe>0)Re=Me-1;else return Me}return-(ve+1)}e.binarySearch=F;function C(j,le){let oe=0,ve=j.length;if(ve===0)return 0;for(;oe<ve;){const Re=Math.floor((oe+ve)/2);le(j[Re])?ve=Re:oe=Re+1}return oe}e.findFirstInSorted=C;function _(j,le,oe){if(j=j|0,j>=le.length)throw new TypeError("invalid index");let ve=le[Math.floor(le.length*Math.random())],Re=[],Me=[],Oe=[];for(let Ye of le){const Ve=oe(Ye,ve);Ve<0?Re.push(Ye):Ve>0?Me.push(Ye):Oe.push(Ye)}return j<Re.length?_(j,Re,oe):j<Re.length+Oe.length?Oe[0]:_(j-(Re.length+Oe.length),Me,oe)}e.quickSelect=_;function P(j,le){const oe=[];let ve;for(const Re of j.slice(0).sort(le))!ve||le(ve[0],Re)!==0?(ve=[Re],oe.push(ve)):ve.push(Re);return oe}e.groupBy=P;function t(j,le,oe){const ve=[];function Re(Ye,Ve,qe){if(Ve===0&&qe.length===0)return;const x=ve[ve.length-1];x&&x.start+x.deleteCount===Ye?(x.deleteCount+=Ve,x.toInsert.push(...qe)):ve.push({start:Ye,deleteCount:Ve,toInsert:qe})}let Me=0,Oe=0;for(;;){if(Me===j.length){Re(Me,0,le.slice(Oe));break}if(Oe===le.length){Re(Me,j.length-Me,[]);break}const Ye=j[Me],Ve=le[Oe],qe=oe(Ye,Ve);qe===0?(Me+=1,Oe+=1):qe<0?(Re(Me,1,[]),Me+=1):qe>0&&(Re(Me,0,[Ve]),Oe+=1)}return ve}e.sortedDiff=t;function E(j,le,oe){const ve=t(j,le,oe),Re=[],Me=[];for(const Oe of ve)Re.push(...j.slice(Oe.start,Oe.start+Oe.deleteCount)),Me.push(...Oe.toInsert);return{removed:Re,added:Me}}e.delta=E;function n(j,le,oe){if(oe===0)return[];const ve=j.slice(0,oe).sort(le);return a(j,le,ve,oe,j.length),ve}e.top=n;function f(j,le,oe,ve,Re){return oe===0?Promise.resolve([]):new Promise((Me,Oe)=>{(async()=>{const Ye=j.length,Ve=j.slice(0,oe).sort(le);for(let qe=oe,x=Math.min(oe+ve,Ye);qe<Ye;qe=x,x=Math.min(x+ve,Ye)){if(qe>oe&&await new Promise(Q=>setTimeout(Q)),Re&&Re.isCancellationRequested)throw(0,c.canceled)();a(j,le,Ve,qe,x)}return Ve})().then(Me,Oe)})}e.topAsync=f;function a(j,le,oe,ve,Re){for(const Me=oe.length;ve<Re;ve++){const Oe=j[ve];if(le(Oe,oe[Me-1])<0){oe.pop();const Ye=C(oe,Ve=>le(Oe,Ve)<0);oe.splice(Ye,0,Oe)}}}function l(j){return j.filter(le=>!!le)}e.coalesce=l;function w(j){let le=0;for(let oe=0;oe<j.length;oe++)j[oe]&&(j[le]=j[oe],le+=1);j.length=le}e.coalesceInPlace=w;function I(j,le,oe){j.splice(oe,0,j.splice(le,1)[0])}e.move=I;function S(j){return!Array.isArray(j)||j.length===0}e.isFalsyOrEmpty=S;function o(j){return Array.isArray(j)&&j.length>0}e.isNonEmptyArray=o;function h(j,le){if(!le)return j.filter((ve,Re)=>j.indexOf(ve)===Re);const oe=Object.create(null);return j.filter(ve=>{const Re=le(ve);return oe[Re]?!1:(oe[Re]=!0,!0)})}e.distinct=h;function y(j){const le=new Set;return j.filter(oe=>le.has(oe)?!1:(le.add(oe),!0))}e.distinctES6=y;function i(j){const le=Object.create(null);return oe=>{const ve=j(oe);return le[ve]?!1:(le[ve]=!0,!0)}}e.uniqueFilter=i;function v(j,le){for(let oe=j.length-1;oe>=0;oe--){const ve=j[oe];if(le(ve))return oe}return-1}e.lastIndex=v;function r(j,le){return j.length>0?j[0]:le}e.firstOrDefault=r;function s(j,le,oe=(ve,Re)=>ve===Re){let ve=0;for(let Re=0,Me=Math.min(j.length,le.length);Re<Me&&oe(j[Re],le[Re]);Re++)ve++;return ve}e.commonPrefixLength=s;function u(j){return[].concat(...j)}e.flatten=u;function d(j,le){let oe=typeof le=="number"?j:0;typeof le=="number"?oe=j:(oe=0,le=j);const ve=[];if(oe<=le)for(let Re=oe;Re<le;Re++)ve.push(Re);else for(let Re=oe;Re>le;Re--)ve.push(Re);return ve}e.range=d;function p(j,le,oe){return j.reduce((ve,Re)=>(ve[le(Re)]=oe?oe(Re):Re,ve),Object.create(null))}e.index=p;function k(j,le){return j.push(le),()=>T(j,le)}e.insert=k;function T(j,le){const oe=j.indexOf(le);if(oe>-1)return j.splice(oe,1),le}e.remove=T;function g(j,le,oe){const ve=j.slice(0,le),Re=j.slice(le);return ve.concat(oe,Re)}e.arrayInsert=g;function D(j,le){let oe;if(typeof le=="number"){let ve=le;oe=()=>{const Re=Math.sin(ve++)*179426549;return Re-Math.floor(Re)}}else oe=Math.random;for(let ve=j.length-1;ve>0;ve-=1){const Re=Math.floor(oe()*(ve+1)),Me=j[ve];j[ve]=j[Re],j[Re]=Me}}e.shuffle=D;function m(j,le){const oe=j.indexOf(le);oe>-1&&(j.splice(oe,1),j.unshift(le))}e.pushToStart=m;function A(j,le){const oe=j.indexOf(le);oe>-1&&(j.splice(oe,1),j.push(le))}e.pushToEnd=A;function L(j,le){return Array.isArray(j)?j.map(le):le(j)}e.mapArrayOrNot=L;function V(j){return Array.isArray(j)?j:[j]}e.asArray=V;function G(j){return j[Math.floor(Math.random()*j.length)]}e.getRandomElement=G;function U(j,le){for(const oe of j){const ve=le(oe);if(ve!==void 0)return ve}}e.mapFind=U;function K(j,le,oe){const ve=B(j,le),Re=j.length,Me=oe.length;j.length=Re+Me;for(let Oe=Re-1;Oe>=ve;Oe--)j[Oe+Me]=j[Oe];for(let Oe=0;Oe<Me;Oe++)j[Oe+ve]=oe[Oe]}e.insertInto=K;function $(j,le,oe,ve){const Re=B(j,le),Me=j.splice(Re,oe);return K(j,Re,ve),Me}e.splice=$;function B(j,le){return le<0?Math.max(le+j.length,0):Math.min(le,j.length)}function z(j,le){let oe=Number.MAX_SAFE_INTEGER,ve=0;return j.forEach((Re,Me)=>{const Oe=le(Re);Oe<oe&&(oe=Oe,ve=Me)}),ve}e.minIndex=z;function Y(j,le){let oe=Number.MIN_SAFE_INTEGER,ve=0;return j.forEach((Re,Me)=>{const Oe=le(Re);Oe>oe&&(oe=Oe,ve=Me)}),ve}e.maxIndex=Y;class ne{constructor(le){this.items=le,this.firstIdx=0,this.lastIdx=this.items.length-1}get length(){return this.lastIdx-this.firstIdx+1}takeWhile(le){let oe=this.firstIdx;for(;oe<this.items.length&&le(this.items[oe]);)oe++;const ve=oe===this.firstIdx?null:this.items.slice(this.firstIdx,oe);return this.firstIdx=oe,ve}takeFromEndWhile(le){let oe=this.lastIdx;for(;oe>=0&&le(this.items[oe]);)oe--;const ve=oe===this.lastIdx?null:this.items.slice(oe+1,this.lastIdx+1);return this.lastIdx=oe,ve}}e.ArrayQueue=ne}),define(we[53],Ee([0,1]),function(re,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.defaultGenerator=e.IdGenerator=void 0;class c{constructor(b){this._prefix=b,this._lastId=0}nextId(){return this._prefix+ ++this._lastId}}e.IdGenerator=c,e.defaultGenerator=new c("id#")}),define(we[102],Ee([0,1]),function(re,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getNodeType=e.stripComments=e.visit=e.findNodeAtOffset=e.contains=e.getNodeValue=e.getNodePath=e.findNodeAtLocation=e.parseTree=e.parse=e.getLocation=e.createScanner=e.ParseOptions=e.ParseErrorCode=e.SyntaxKind=e.ScanError=void 0;var c;(function(i){i[i.None=0]="None",i[i.UnexpectedEndOfComment=1]="UnexpectedEndOfComment",i[i.UnexpectedEndOfString=2]="UnexpectedEndOfString",i[i.UnexpectedEndOfNumber=3]="UnexpectedEndOfNumber",i[i.InvalidUnicode=4]="InvalidUnicode",i[i.InvalidEscapeCharacter=5]="InvalidEscapeCharacter",i[i.InvalidCharacter=6]="InvalidCharacter"})(c=e.ScanError||(e.ScanError={}));var M;(function(i){i[i.OpenBraceToken=1]="OpenBraceToken",i[i.CloseBraceToken=2]="CloseBraceToken",i[i.OpenBracketToken=3]="OpenBracketToken",i[i.CloseBracketToken=4]="CloseBracketToken",i[i.CommaToken=5]="CommaToken",i[i.ColonToken=6]="ColonToken",i[i.NullKeyword=7]="NullKeyword",i[i.TrueKeyword=8]="TrueKeyword",i[i.FalseKeyword=9]="FalseKeyword",i[i.StringLiteral=10]="StringLiteral",i[i.NumericLiteral=11]="NumericLiteral",i[i.LineCommentTrivia=12]="LineCommentTrivia",i[i.BlockCommentTrivia=13]="BlockCommentTrivia",i[i.LineBreakTrivia=14]="LineBreakTrivia",i[i.Trivia=15]="Trivia",i[i.Unknown=16]="Unknown",i[i.EOF=17]="EOF"})(M=e.SyntaxKind||(e.SyntaxKind={}));var b;(function(i){i[i.InvalidSymbol=1]="InvalidSymbol",i[i.InvalidNumberFormat=2]="InvalidNumberFormat",i[i.PropertyNameExpected=3]="PropertyNameExpected",i[i.ValueExpected=4]="ValueExpected",i[i.ColonExpected=5]="ColonExpected",i[i.CommaExpected=6]="CommaExpected",i[i.CloseBraceExpected=7]="CloseBraceExpected",i[i.CloseBracketExpected=8]="CloseBracketExpected",i[i.EndOfFileExpected=9]="EndOfFileExpected",i[i.InvalidCommentToken=10]="InvalidCommentToken",i[i.UnexpectedEndOfComment=11]="UnexpectedEndOfComment",i[i.UnexpectedEndOfString=12]="UnexpectedEndOfString",i[i.UnexpectedEndOfNumber=13]="UnexpectedEndOfNumber",i[i.InvalidUnicode=14]="InvalidUnicode",i[i.InvalidEscapeCharacter=15]="InvalidEscapeCharacter",i[i.InvalidCharacter=16]="InvalidCharacter"})(b=e.ParseErrorCode||(e.ParseErrorCode={}));var R;(function(i){i.DEFAULT={allowTrailingComma:!0}})(R=e.ParseOptions||(e.ParseOptions={}));function F(i,v=!1){let r=0,s=i.length,u="",d=0,p=16,k=0;function T(G){let U=0,K=0;for(;U<G;){const $=i.charCodeAt(r);if($>=48&&$<=57)K=K*16+$-48;else if($>=65&&$<=70)K=K*16+$-65+10;else if($>=97&&$<=102)K=K*16+$-97+10;else break;r++,U++}return U<G&&(K=-1),K}function g(G){r=G,u="",d=0,p=16,k=0}function D(){const G=r;if(i.charCodeAt(r)===48)r++;else for(r++;r<i.length&&P(i.charCodeAt(r));)r++;if(r<i.length&&i.charCodeAt(r)===46)if(r++,r<i.length&&P(i.charCodeAt(r)))for(r++;r<i.length&&P(i.charCodeAt(r));)r++;else return k=3,i.substring(G,r);let U=r;if(r<i.length&&(i.charCodeAt(r)===69||i.charCodeAt(r)===101))if(r++,(r<i.length&&i.charCodeAt(r)===43||i.charCodeAt(r)===45)&&r++,r<i.length&&P(i.charCodeAt(r))){for(r++;r<i.length&&P(i.charCodeAt(r));)r++;U=r}else k=3;return i.substring(G,U)}function m(){let G="",U=r;for(;;){if(r>=s){G+=i.substring(U,r),k=2;break}const K=i.charCodeAt(r);if(K===34){G+=i.substring(U,r),r++;break}if(K===92){if(G+=i.substring(U,r),r++,r>=s){k=2;break}switch(i.charCodeAt(r++)){case 34:G+='"';break;case 92:G+="\\";break;case 47:G+="/";break;case 98:G+="\b";break;case 102:G+="\f";break;case 110:G+=`
`;break;case 114:G+="\r";break;case 116:G+="	";break;case 117:const B=T(4);B>=0?G+=String.fromCharCode(B):k=4;break;default:k=5}U=r;continue}if(K>=0&&K<=31)if(_(K)){G+=i.substring(U,r),k=2;break}else k=6;r++}return G}function A(){if(u="",k=0,d=r,r>=s)return d=s,p=17;let G=i.charCodeAt(r);if(C(G)){do r++,u+=String.fromCharCode(G),G=i.charCodeAt(r);while(C(G));return p=15}if(_(G))return r++,u+=String.fromCharCode(G),G===13&&i.charCodeAt(r)===10&&(r++,u+=`
`),p=14;switch(G){case 123:return r++,p=1;case 125:return r++,p=2;case 91:return r++,p=3;case 93:return r++,p=4;case 58:return r++,p=6;case 44:return r++,p=5;case 34:return r++,u=m(),p=10;case 47:const U=r-1;if(i.charCodeAt(r+1)===47){for(r+=2;r<s&&!_(i.charCodeAt(r));)r++;return u=i.substring(U,r),p=12}if(i.charCodeAt(r+1)===42){r+=2;const K=s-1;let $=!1;for(;r<K;){if(i.charCodeAt(r)===42&&i.charCodeAt(r+1)===47){r+=2,$=!0;break}r++}return $||(r++,k=1),u=i.substring(U,r),p=13}return u+=String.fromCharCode(G),r++,p=16;case 45:if(u+=String.fromCharCode(G),r++,r===s||!P(i.charCodeAt(r)))return p=16;case 48:case 49:case 50:case 51:case 52:case 53:case 54:case 55:case 56:case 57:return u+=D(),p=11;default:for(;r<s&&L(G);)r++,G=i.charCodeAt(r);if(d!==r){switch(u=i.substring(d,r),u){case"true":return p=8;case"false":return p=9;case"null":return p=7}return p=16}return u+=String.fromCharCode(G),r++,p=16}}function L(G){if(C(G)||_(G))return!1;switch(G){case 125:case 93:case 123:case 91:case 34:case 58:case 44:case 47:return!1}return!0}function V(){let G;do G=A();while(G>=12&&G<=15);return G}return{setPosition:g,getPosition:()=>r,scan:v?V:A,getToken:()=>p,getTokenValue:()=>u,getTokenOffset:()=>d,getTokenLength:()=>r-d,getTokenError:()=>k}}e.createScanner=F;function C(i){return i===32||i===9||i===11||i===12||i===160||i===5760||i>=8192&&i<=8203||i===8239||i===8287||i===12288||i===65279}function _(i){return i===10||i===13||i===8232||i===8233}function P(i){return i>=48&&i<=57}var t;(function(i){i[i.nullCharacter=0]="nullCharacter",i[i.maxAsciiCharacter=127]="maxAsciiCharacter",i[i.lineFeed=10]="lineFeed",i[i.carriageReturn=13]="carriageReturn",i[i.lineSeparator=8232]="lineSeparator",i[i.paragraphSeparator=8233]="paragraphSeparator",i[i.nextLine=133]="nextLine",i[i.space=32]="space",i[i.nonBreakingSpace=160]="nonBreakingSpace",i[i.enQuad=8192]="enQuad",i[i.emQuad=8193]="emQuad",i[i.enSpace=8194]="enSpace",i[i.emSpace=8195]="emSpace",i[i.threePerEmSpace=8196]="threePerEmSpace",i[i.fourPerEmSpace=8197]="fourPerEmSpace",i[i.sixPerEmSpace=8198]="sixPerEmSpace",i[i.figureSpace=8199]="figureSpace",i[i.punctuationSpace=8200]="punctuationSpace",i[i.thinSpace=8201]="thinSpace",i[i.hairSpace=8202]="hairSpace",i[i.zeroWidthSpace=8203]="zeroWidthSpace",i[i.narrowNoBreakSpace=8239]="narrowNoBreakSpace",i[i.ideographicSpace=12288]="ideographicSpace",i[i.mathematicalSpace=8287]="mathematicalSpace",i[i.ogham=5760]="ogham",i[i._=95]="_",i[i.$=36]="$",i[i._0=48]="_0",i[i._1=49]="_1",i[i._2=50]="_2",i[i._3=51]="_3",i[i._4=52]="_4",i[i._5=53]="_5",i[i._6=54]="_6",i[i._7=55]="_7",i[i._8=56]="_8",i[i._9=57]="_9",i[i.a=97]="a",i[i.b=98]="b",i[i.c=99]="c",i[i.d=100]="d",i[i.e=101]="e",i[i.f=102]="f",i[i.g=103]="g",i[i.h=104]="h",i[i.i=105]="i",i[i.j=106]="j",i[i.k=107]="k",i[i.l=108]="l",i[i.m=109]="m",i[i.n=110]="n",i[i.o=111]="o",i[i.p=112]="p",i[i.q=113]="q",i[i.r=114]="r",i[i.s=115]="s",i[i.t=116]="t",i[i.u=117]="u",i[i.v=118]="v",i[i.w=119]="w",i[i.x=120]="x",i[i.y=121]="y",i[i.z=122]="z",i[i.A=65]="A",i[i.B=66]="B",i[i.C=67]="C",i[i.D=68]="D",i[i.E=69]="E",i[i.F=70]="F",i[i.G=71]="G",i[i.H=72]="H",i[i.I=73]="I",i[i.J=74]="J",i[i.K=75]="K",i[i.L=76]="L",i[i.M=77]="M",i[i.N=78]="N",i[i.O=79]="O",i[i.P=80]="P",i[i.Q=81]="Q",i[i.R=82]="R",i[i.S=83]="S",i[i.T=84]="T",i[i.U=85]="U",i[i.V=86]="V",i[i.W=87]="W",i[i.X=88]="X",i[i.Y=89]="Y",i[i.Z=90]="Z",i[i.ampersand=38]="ampersand",i[i.asterisk=42]="asterisk",i[i.at=64]="at",i[i.backslash=92]="backslash",i[i.bar=124]="bar",i[i.caret=94]="caret",i[i.closeBrace=125]="closeBrace",i[i.closeBracket=93]="closeBracket",i[i.closeParen=41]="closeParen",i[i.colon=58]="colon",i[i.comma=44]="comma",i[i.dot=46]="dot",i[i.doubleQuote=34]="doubleQuote",i[i.equals=61]="equals",i[i.exclamation=33]="exclamation",i[i.greaterThan=62]="greaterThan",i[i.lessThan=60]="lessThan",i[i.minus=45]="minus",i[i.openBrace=123]="openBrace",i[i.openBracket=91]="openBracket",i[i.openParen=40]="openParen",i[i.percent=37]="percent",i[i.plus=43]="plus",i[i.question=63]="question",i[i.semicolon=59]="semicolon",i[i.singleQuote=39]="singleQuote",i[i.slash=47]="slash",i[i.tilde=126]="tilde",i[i.backspace=8]="backspace",i[i.formFeed=12]="formFeed",i[i.byteOrderMark=65279]="byteOrderMark",i[i.tab=9]="tab",i[i.verticalTab=11]="verticalTab"})(t||(t={}));function E(i,v){const r=[],s=new Object;let u;const d={value:{},offset:0,length:0,type:"object",parent:void 0};let p=!1;function k(T,g,D,m){d.value=T,d.offset=g,d.length=D,d.type=m,d.colonOffset=void 0,u=d}try{o(i,{onObjectBegin:(T,g)=>{if(v<=T)throw s;u=void 0,p=v>T,r.push("")},onObjectProperty:(T,g,D)=>{if(v<g||(k(T,g,D,"property"),r[r.length-1]=T,v<=g+D))throw s},onObjectEnd:(T,g)=>{if(v<=T)throw s;u=void 0,r.pop()},onArrayBegin:(T,g)=>{if(v<=T)throw s;u=void 0,r.push(0)},onArrayEnd:(T,g)=>{if(v<=T)throw s;u=void 0,r.pop()},onLiteralValue:(T,g,D)=>{if(v<g||(k(T,g,D,y(T)),v<=g+D))throw s},onSeparator:(T,g,D)=>{if(v<=g)throw s;if(T===":"&&u&&u.type==="property")u.colonOffset=g,p=!1,u=void 0;else if(T===","){const m=r[r.length-1];typeof m=="number"?r[r.length-1]=m+1:(p=!0,r[r.length-1]=""),u=void 0}}})}catch(T){if(T!==s)throw T}return{path:r,previousNode:u,isAtPropertyKey:p,matches:T=>{let g=0;for(let D=0;g<T.length&&D<r.length;D++)if(T[g]===r[D]||T[g]==="*")g++;else if(T[g]!=="**")return!1;return g===T.length}}}e.getLocation=E;function n(i,v=[],r=R.DEFAULT){let s=null,u=[];const d=[];function p(T){Array.isArray(u)?u.push(T):s!==null&&(u[s]=T)}return o(i,{onObjectBegin:()=>{const T={};p(T),d.push(u),u=T,s=null},onObjectProperty:T=>{s=T},onObjectEnd:()=>{u=d.pop()},onArrayBegin:()=>{const T=[];p(T),d.push(u),u=T,s=null},onArrayEnd:()=>{u=d.pop()},onLiteralValue:p,onError:(T,g,D)=>{v.push({error:T,offset:g,length:D})}},r),u[0]}e.parse=n;function f(i,v=[],r=R.DEFAULT){let s={type:"array",offset:-1,length:-1,children:[],parent:void 0};function u(T){s.type==="property"&&(s.length=T-s.offset,s=s.parent)}function d(T){return s.children.push(T),T}o(i,{onObjectBegin:T=>{s=d({type:"object",offset:T,length:-1,parent:s,children:[]})},onObjectProperty:(T,g,D)=>{s=d({type:"property",offset:g,length:-1,parent:s,children:[]}),s.children.push({type:"string",value:T,offset:g,length:D,parent:s})},onObjectEnd:(T,g)=>{s.length=T+g-s.offset,s=s.parent,u(T+g)},onArrayBegin:(T,g)=>{s=d({type:"array",offset:T,length:-1,parent:s,children:[]})},onArrayEnd:(T,g)=>{s.length=T+g-s.offset,s=s.parent,u(T+g)},onLiteralValue:(T,g,D)=>{d({type:y(T),offset:g,length:D,parent:s,value:T}),u(g+D)},onSeparator:(T,g,D)=>{s.type==="property"&&(T===":"?s.colonOffset=g:T===","&&u(g))},onError:(T,g,D)=>{v.push({error:T,offset:g,length:D})}},r);const k=s.children[0];return k&&delete k.parent,k}e.parseTree=f;function a(i,v){if(!i)return;let r=i;for(let s of v)if(typeof s=="string"){if(r.type!=="object"||!Array.isArray(r.children))return;let u=!1;for(const d of r.children)if(Array.isArray(d.children)&&d.children[0].value===s){r=d.children[1],u=!0;break}if(!u)return}else{const u=s;if(r.type!=="array"||u<0||!Array.isArray(r.children)||u>=r.children.length)return;r=r.children[u]}return r}e.findNodeAtLocation=a;function l(i){if(!i.parent||!i.parent.children)return[];const v=l(i.parent);if(i.parent.type==="property"){const r=i.parent.children[0].value;v.push(r)}else if(i.parent.type==="array"){const r=i.parent.children.indexOf(i);r!==-1&&v.push(r)}return v}e.getNodePath=l;function w(i){switch(i.type){case"array":return i.children.map(w);case"object":const v=Object.create(null);for(let r of i.children){const s=r.children[1];s&&(v[r.children[0].value]=w(s))}return v;case"null":case"string":case"number":case"boolean":return i.value;default:return}}e.getNodeValue=w;function I(i,v,r=!1){return v>=i.offset&&v<i.offset+i.length||r&&v===i.offset+i.length}e.contains=I;function S(i,v,r=!1){if(I(i,v,r)){const s=i.children;if(Array.isArray(s))for(let u=0;u<s.length&&s[u].offset<=v;u++){const d=S(s[u],v,r);if(d)return d}return i}}e.findNodeAtOffset=S;function o(i,v,r=R.DEFAULT){const s=F(i,!1);function u(oe){return oe?()=>oe(s.getTokenOffset(),s.getTokenLength()):()=>!0}function d(oe){return oe?ve=>oe(ve,s.getTokenOffset(),s.getTokenLength()):()=>!0}const p=u(v.onObjectBegin),k=d(v.onObjectProperty),T=u(v.onObjectEnd),g=u(v.onArrayBegin),D=u(v.onArrayEnd),m=d(v.onLiteralValue),A=d(v.onSeparator),L=u(v.onComment),V=d(v.onError),G=r&&r.disallowComments,U=r&&r.allowTrailingComma;function K(){for(;;){const oe=s.scan();switch(s.getTokenError()){case 4:$(14);break;case 5:$(15);break;case 3:$(13);break;case 1:G||$(11);break;case 2:$(12);break;case 6:$(16);break}switch(oe){case 12:case 13:G?$(10):L();break;case 16:$(1);break;case 15:case 14:break;default:return oe}}}function $(oe,ve=[],Re=[]){if(V(oe),ve.length+Re.length>0){let Me=s.getToken();for(;Me!==17;){if(ve.indexOf(Me)!==-1){K();break}else if(Re.indexOf(Me)!==-1)break;Me=K()}}}function B(oe){const ve=s.getTokenValue();return oe?m(ve):k(ve),K(),!0}function z(){switch(s.getToken()){case 11:let oe=0;try{oe=JSON.parse(s.getTokenValue()),typeof oe!="number"&&($(2),oe=0)}catch(ve){$(2)}m(oe);break;case 7:m(null);break;case 8:m(!0);break;case 9:m(!1);break;default:return!1}return K(),!0}function Y(){return s.getToken()!==10?($(3,[],[2,5]),!1):(B(!1),s.getToken()===6?(A(":"),K(),le()||$(4,[],[2,5])):$(5,[],[2,5]),!0)}function ne(){p(),K();let oe=!1;for(;s.getToken()!==2&&s.getToken()!==17;){if(s.getToken()===5){if(oe||$(4,[],[]),A(","),K(),s.getToken()===2&&U)break}else oe&&$(6,[],[]);Y()||$(4,[],[2,5]),oe=!0}return T(),s.getToken()!==2?$(7,[2],[]):K(),!0}function j(){g(),K();let oe=!1;for(;s.getToken()!==4&&s.getToken()!==17;){if(s.getToken()===5){if(oe||$(4,[],[]),A(","),K(),s.getToken()===4&&U)break}else oe&&$(6,[],[]);le()||$(4,[],[4,5]),oe=!0}return D(),s.getToken()!==4?$(8,[4],[]):K(),!0}function le(){switch(s.getToken()){case 3:return j();case 1:return ne();case 10:return B(!0);default:return z()}}return K(),s.getToken()===17?r.allowEmptyContent?!0:($(4,[],[]),!1):le()?(s.getToken()!==17&&$(9,[],[]),!0):($(4,[],[]),!1)}e.visit=o;function h(i,v){let r=F(i),s=[],u,d=0,p;do switch(p=r.getPosition(),u=r.scan(),u){case 12:case 13:case 17:d!==p&&s.push(i.substring(d,p)),v!==void 0&&s.push(r.getTokenValue().replace(/[^\r\n]/g,v)),d=r.getPosition();break}while(u!==17);return s.join("")}e.stripComments=h;function y(i){switch(typeof i){case"boolean":return"boolean";case"number":return"number";case"string":return"string";case"object":{if(i){if(Array.isArray(i))return"array"}else return"null";return"object"}default:return"null"}}e.getNodeType=y}),define(we[103],Ee([0,1]),function(re,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Lazy=void 0;class c{constructor(b){this.executor=b,this._didRun=!1}hasValue(){return this._didRun}getValue(){if(!this._didRun)try{this._value=this.executor()}catch(b){this._error=b}finally{this._didRun=!0}if(this._error)throw this._error;return this._value}get rawValue(){return this._value}map(b){return new c(()=>b(this.getValue()))}}e.Lazy=c}),function(re,e){typeof exports=="object"&&typeof module!="undefined"?module.exports=e():typeof define=="function"&&define.amd?define("vs/base/common/marked/marked",e):(re=typeof globalThis!="undefined"?globalThis:re||self,re.marked=e())}(this,function(){"use strict";function re(Pe,Se){for(var De=0;De<Se.length;De++){var ee=Se[De];ee.enumerable=ee.enumerable||!1,ee.configurable=!0,"value"in ee&&(ee.writable=!0),Object.defineProperty(Pe,ee.key,ee)}}function e(Pe,Se,De){return Se&&re(Pe.prototype,Se),De&&re(Pe,De),Pe}function c(Pe,Se){if(!!Pe){if(typeof Pe=="string")return M(Pe,Se);var De=Object.prototype.toString.call(Pe).slice(8,-1);if(De==="Object"&&Pe.constructor&&(De=Pe.constructor.name),De==="Map"||De==="Set")return Array.from(Pe);if(De==="Arguments"||/^(?:Ui|I)nt(?:8|16|32)(?:Clamped)?Array$/.test(De))return M(Pe,Se)}}function M(Pe,Se){(Se==null||Se>Pe.length)&&(Se=Pe.length);for(var De=0,ee=new Array(Se);De<Se;De++)ee[De]=Pe[De];return ee}function b(Pe,Se){var De=typeof Symbol!="undefined"&&Pe[Symbol.iterator]||Pe["@@iterator"];if(De)return(De=De.call(Pe)).next.bind(De);if(Array.isArray(Pe)||(De=c(Pe))||Se&&Pe&&typeof Pe.length=="number"){De&&(Pe=De);var ee=0;return function(){return ee>=Pe.length?{done:!0}:{done:!1,value:Pe[ee++]}}}throw new TypeError(`Invalid attempt to iterate non-iterable instance.
In order to be iterable, non-array objects must have a [Symbol.iterator]() method.`)}var R={exports:{}};function F(){return{baseUrl:null,breaks:!1,extensions:null,gfm:!0,headerIds:!0,headerPrefix:"",highlight:null,langPrefix:"language-",mangle:!0,pedantic:!1,renderer:null,sanitize:!1,sanitizer:null,silent:!1,smartLists:!1,smartypants:!1,tokenizer:null,walkTokens:null,xhtml:!1}}function C(Pe){R.exports.defaults=Pe}R.exports={defaults:F(),getDefaults:F,changeDefaults:C};var _=/[&<>"']/,P=/[&<>"']/g,t=/[<>"']|&(?!#?\w+;)/,E=/[<>"']|&(?!#?\w+;)/g,n={"&":"&amp;","<":"&lt;",">":"&gt;",'"':"&quot;","'":"&#39;"},f=function(Se){return n[Se]};function a(Pe,Se){if(Se){if(_.test(Pe))return Pe.replace(P,f)}else if(t.test(Pe))return Pe.replace(E,f);return Pe}var l=/&(#(?:\d+)|(?:#x[0-9A-Fa-f]+)|(?:\w+));?/ig;function w(Pe){return Pe.replace(l,function(Se,De){return De=De.toLowerCase(),De==="colon"?":":De.charAt(0)==="#"?De.charAt(1)==="x"?String.fromCharCode(parseInt(De.substring(2),16)):String.fromCharCode(+De.substring(1)):""})}var I=/(^|[^\[])\^/g;function S(Pe,Se){Pe=Pe.source||Pe,Se=Se||"";var De={replace:function(ue,pe){return pe=pe.source||pe,pe=pe.replace(I,"$1"),Pe=Pe.replace(ue,pe),De},getRegex:function(){return new RegExp(Pe,Se)}};return De}var o=/[^\w:]/g,h=/^$|^[a-z][a-z0-9+.-]*:|^[?#]/i;function y(Pe,Se,De){if(Pe){var ee;try{ee=decodeURIComponent(w(De)).replace(o,"").toLowerCase()}catch(ue){return null}if(ee.indexOf("javascript:")===0||ee.indexOf("vbscript:")===0||ee.indexOf("data:")===0)return null}Se&&!h.test(De)&&(De=u(Se,De));try{De=encodeURI(De).replace(/%25/g,"%")}catch(ue){return null}return De}var i={},v=/^[^:]+:\/*[^/]*$/,r=/^([^:]+:)[\s\S]*$/,s=/^([^:]+:\/*[^/]*)[\s\S]*$/;function u(Pe,Se){i[" "+Pe]||(v.test(Pe)?i[" "+Pe]=Pe+"/":i[" "+Pe]=T(Pe,"/",!0)),Pe=i[" "+Pe];var De=Pe.indexOf(":")===-1;return Se.substring(0,2)==="//"?De?Se:Pe.replace(r,"$1")+Se:Se.charAt(0)==="/"?De?Se:Pe.replace(s,"$1")+Se:Pe+Se}var d={exec:function(){}};function p(Pe){for(var Se=1,De,ee;Se<arguments.length;Se++){De=arguments[Se];for(ee in De)Object.prototype.hasOwnProperty.call(De,ee)&&(Pe[ee]=De[ee])}return Pe}function k(Pe,Se){var De=Pe.replace(/\|/g,function(pe,me,Ie){for(var Be=!1,Ne=me;--Ne>=0&&Ie[Ne]==="\\";)Be=!Be;return Be?"|":" |"}),ee=De.split(/ \|/),ue=0;if(ee[0].trim()||ee.shift(),ee[ee.length-1].trim()||ee.pop(),ee.length>Se)ee.splice(Se);else for(;ee.length<Se;)ee.push("");for(;ue<ee.length;ue++)ee[ue]=ee[ue].trim().replace(/\\\|/g,"|");return ee}function T(Pe,Se,De){var ee=Pe.length;if(ee===0)return"";for(var ue=0;ue<ee;){var pe=Pe.charAt(ee-ue-1);if(pe===Se&&!De)ue++;else if(pe!==Se&&De)ue++;else break}return Pe.substr(0,ee-ue)}function g(Pe,Se){if(Pe.indexOf(Se[1])===-1)return-1;for(var De=Pe.length,ee=0,ue=0;ue<De;ue++)if(Pe[ue]==="\\")ue++;else if(Pe[ue]===Se[0])ee++;else if(Pe[ue]===Se[1]&&(ee--,ee<0))return ue;return-1}function D(Pe){Pe&&Pe.sanitize&&!Pe.silent&&console.warn("marked(): sanitize and sanitizer parameters are deprecated since version 0.7.0, should not be used and will be removed in the future. Read more here: https://marked.js.org/#/USING_ADVANCED.md#options")}function m(Pe,Se){if(Se<1)return"";for(var De="";Se>1;)Se&1&&(De+=Pe),Se>>=1,Pe+=Pe;return De+Pe}var A={escape:a,unescape:w,edit:S,cleanUrl:y,resolveUrl:u,noopTest:d,merge:p,splitCells:k,rtrim:T,findClosingBracket:g,checkSanitizeDeprecation:D,repeatString:m},L=R.exports.defaults,V=A.rtrim,G=A.splitCells,U=A.escape,K=A.findClosingBracket;function $(Pe,Se,De,ee){var ue=Se.href,pe=Se.title?U(Se.title):null,me=Pe[1].replace(/\\([\[\]])/g,"$1");if(Pe[0].charAt(0)!=="!"){ee.state.inLink=!0;var Ie={type:"link",raw:De,href:ue,title:pe,text:me,tokens:ee.inlineTokens(me,[])};return ee.state.inLink=!1,Ie}else return{type:"image",raw:De,href:ue,title:pe,text:U(me)}}function B(Pe,Se){var De=Pe.match(/^(\s+)(?:```)/);if(De===null)return Se;var ee=De[1];return Se.split(`
`).map(function(ue){var pe=ue.match(/^\s+/);if(pe===null)return ue;var me=pe[0];return me.length>=ee.length?ue.slice(ee.length):ue}).join(`
`)}var z=function(){function Pe(De){this.options=De||L}var Se=Pe.prototype;return Se.space=function(ee){var ue=this.rules.block.newline.exec(ee);if(ue)return ue[0].length>1?{type:"space",raw:ue[0]}:{raw:`
`}},Se.code=function(ee){var ue=this.rules.block.code.exec(ee);if(ue){var pe=ue[0].replace(/^ {1,4}/gm,"");return{type:"code",raw:ue[0],codeBlockStyle:"indented",text:this.options.pedantic?pe:V(pe,`
`)}}},Se.fences=function(ee){var ue=this.rules.block.fences.exec(ee);if(ue){var pe=ue[0],me=B(pe,ue[3]||"");return{type:"code",raw:pe,lang:ue[2]?ue[2].trim():ue[2],text:me}}},Se.heading=function(ee){var ue=this.rules.block.heading.exec(ee);if(ue){var pe=ue[2].trim();if(/#$/.test(pe)){var me=V(pe,"#");(this.options.pedantic||!me||/ $/.test(me))&&(pe=me.trim())}var Ie={type:"heading",raw:ue[0],depth:ue[1].length,text:pe,tokens:[]};return this.lexer.inline(Ie.text,Ie.tokens),Ie}},Se.hr=function(ee){var ue=this.rules.block.hr.exec(ee);if(ue)return{type:"hr",raw:ue[0]}},Se.blockquote=function(ee){var ue=this.rules.block.blockquote.exec(ee);if(ue){var pe=ue[0].replace(/^ *> ?/gm,"");return{type:"blockquote",raw:ue[0],tokens:this.lexer.blockTokens(pe,[]),text:pe}}},Se.list=function(ee){var ue=this.rules.block.list.exec(ee);if(ue){var pe,me,Ie,Be,Ne,je,et,Le,de,ge,X=ue[1].trim(),W=X.length>1,be={type:"list",raw:"",ordered:W,start:W?+X.slice(0,-1):"",loose:!1,items:[]};X=W?"\\d{1,9}\\"+X.slice(-1):"\\"+X,this.options.pedantic&&(X=W?X:"[*+-]");for(var ke=new RegExp("^( {0,3}"+X+")((?: [^\\n]*| *)(?:\\n[^\\n]*)*(?:\\n|$))");ee&&!(this.rules.block.hr.test(ee)||!(ue=ke.exec(ee)));){de=ue[2].split(`
`),this.options.pedantic?(Be=2,ge=de[0].trimLeft()):(Be=ue[2].search(/[^ ]/),Be=ue[1].length+(Be>4?1:Be),ge=de[0].slice(Be-ue[1].length)),je=!1,pe=ue[0],!de[0]&&/^ *$/.test(de[1])&&(pe=ue[1]+de.slice(0,2).join(`
`)+`
`,be.loose=!0,de=[]);var Je=new RegExp("^ {0,"+Math.min(3,Be-1)+"}(?:[*+-]|\\d{1,9}[.)])");for(Ne=1;Ne<de.length;Ne++){if(Le=de[Ne],this.options.pedantic&&(Le=Le.replace(/^ {1,4}(?=( {4})*[^ ])/g,"  ")),Je.test(Le)){pe=ue[1]+de.slice(0,Ne).join(`
`)+`
`;break}if(!je){Le.trim()||(je=!0),Le.search(/[^ ]/)>=Be?ge+=`
`+Le.slice(Be):ge+=`
`+Le;continue}if(Le.search(/[^ ]/)>=Be||!Le.trim()){ge+=`
`+Le.slice(Be);continue}else{pe=ue[1]+de.slice(0,Ne).join(`
`)+`
`;break}}be.loose||(et?be.loose=!0:/\n *\n *$/.test(pe)&&(et=!0)),this.options.gfm&&(me=/^\[[ xX]\] /.exec(ge),me&&(Ie=me[0]!=="[ ] ",ge=ge.replace(/^\[[ xX]\] +/,""))),be.items.push({type:"list_item",raw:pe,task:!!me,checked:Ie,loose:!1,text:ge}),be.raw+=pe,ee=ee.slice(pe.length)}be.items[be.items.length-1].raw=pe.trimRight(),be.items[be.items.length-1].text=ge.trimRight(),be.raw=be.raw.trimRight();var $e=be.items.length;for(Ne=0;Ne<$e;Ne++)this.lexer.state.top=!1,be.items[Ne].tokens=this.lexer.blockTokens(be.items[Ne].text,[]),be.items[Ne].tokens.some(function(ut){return ut.type==="space"})&&(be.loose=!0,be.items[Ne].loose=!0);return be}},Se.html=function(ee){var ue=this.rules.block.html.exec(ee);if(ue){var pe={type:"html",raw:ue[0],pre:!this.options.sanitizer&&(ue[1]==="pre"||ue[1]==="script"||ue[1]==="style"),text:ue[0]};return this.options.sanitize&&(pe.type="paragraph",pe.text=this.options.sanitizer?this.options.sanitizer(ue[0]):U(ue[0]),pe.tokens=[],this.lexer.inline(pe.text,pe.tokens)),pe}},Se.def=function(ee){var ue=this.rules.block.def.exec(ee);if(ue){ue[3]&&(ue[3]=ue[3].substring(1,ue[3].length-1));var pe=ue[1].toLowerCase().replace(/\s+/g," ");return{type:"def",tag:pe,raw:ue[0],href:ue[2],title:ue[3]}}},Se.table=function(ee){var ue=this.rules.block.table.exec(ee);if(ue){var pe={type:"table",header:G(ue[1]).map(function(et){return{text:et}}),align:ue[2].replace(/^ *|\| *$/g,"").split(/ *\| */),rows:ue[3]?ue[3].replace(/\n$/,"").split(`
`):[]};if(pe.header.length===pe.align.length){pe.raw=ue[0];var me=pe.align.length,Ie,Be,Ne,je;for(Ie=0;Ie<me;Ie++)/^ *-+: *$/.test(pe.align[Ie])?pe.align[Ie]="right":/^ *:-+: *$/.test(pe.align[Ie])?pe.align[Ie]="center":/^ *:-+ *$/.test(pe.align[Ie])?pe.align[Ie]="left":pe.align[Ie]=null;for(me=pe.rows.length,Ie=0;Ie<me;Ie++)pe.rows[Ie]=G(pe.rows[Ie],pe.header.length).map(function(et){return{text:et}});for(me=pe.header.length,Be=0;Be<me;Be++)pe.header[Be].tokens=[],this.lexer.inlineTokens(pe.header[Be].text,pe.header[Be].tokens);for(me=pe.rows.length,Be=0;Be<me;Be++)for(je=pe.rows[Be],Ne=0;Ne<je.length;Ne++)je[Ne].tokens=[],this.lexer.inlineTokens(je[Ne].text,je[Ne].tokens);return pe}}},Se.lheading=function(ee){var ue=this.rules.block.lheading.exec(ee);if(ue){var pe={type:"heading",raw:ue[0],depth:ue[2].charAt(0)==="="?1:2,text:ue[1],tokens:[]};return this.lexer.inline(pe.text,pe.tokens),pe}},Se.paragraph=function(ee){var ue=this.rules.block.paragraph.exec(ee);if(ue){var pe={type:"paragraph",raw:ue[0],text:ue[1].charAt(ue[1].length-1)===`
`?ue[1].slice(0,-1):ue[1],tokens:[]};return this.lexer.inline(pe.text,pe.tokens),pe}},Se.text=function(ee){var ue=this.rules.block.text.exec(ee);if(ue){var pe={type:"text",raw:ue[0],text:ue[0],tokens:[]};return this.lexer.inline(pe.text,pe.tokens),pe}},Se.escape=function(ee){var ue=this.rules.inline.escape.exec(ee);if(ue)return{type:"escape",raw:ue[0],text:U(ue[1])}},Se.tag=function(ee){var ue=this.rules.inline.tag.exec(ee);if(ue)return!this.lexer.state.inLink&&/^<a /i.test(ue[0])?this.lexer.state.inLink=!0:this.lexer.state.inLink&&/^<\/a>/i.test(ue[0])&&(this.lexer.state.inLink=!1),!this.lexer.state.inRawBlock&&/^<(pre|code|kbd|script)(\s|>)/i.test(ue[0])?this.lexer.state.inRawBlock=!0:this.lexer.state.inRawBlock&&/^<\/(pre|code|kbd|script)(\s|>)/i.test(ue[0])&&(this.lexer.state.inRawBlock=!1),{type:this.options.sanitize?"text":"html",raw:ue[0],inLink:this.lexer.state.inLink,inRawBlock:this.lexer.state.inRawBlock,text:this.options.sanitize?this.options.sanitizer?this.options.sanitizer(ue[0]):U(ue[0]):ue[0]}},Se.link=function(ee){var ue=this.rules.inline.link.exec(ee);if(ue){var pe=ue[2].trim();if(!this.options.pedantic&&/^</.test(pe)){if(!/>$/.test(pe))return;var me=V(pe.slice(0,-1),"\\");if((pe.length-me.length)%2==0)return}else{var Ie=K(ue[2],"()");if(Ie>-1){var Be=ue[0].indexOf("!")===0?5:4,Ne=Be+ue[1].length+Ie;ue[2]=ue[2].substring(0,Ie),ue[0]=ue[0].substring(0,Ne).trim(),ue[3]=""}}var je=ue[2],et="";if(this.options.pedantic){var Le=/^([^'"]*[^\s])\s+(['"])(.*)\2/.exec(je);Le&&(je=Le[1],et=Le[3])}else et=ue[3]?ue[3].slice(1,-1):"";return je=je.trim(),/^</.test(je)&&(this.options.pedantic&&!/>$/.test(pe)?je=je.slice(1):je=je.slice(1,-1)),$(ue,{href:je&&je.replace(this.rules.inline._escapes,"$1"),title:et&&et.replace(this.rules.inline._escapes,"$1")},ue[0],this.lexer)}},Se.reflink=function(ee,ue){var pe;if((pe=this.rules.inline.reflink.exec(ee))||(pe=this.rules.inline.nolink.exec(ee))){var me=(pe[2]||pe[1]).replace(/\s+/g," ");if(me=ue[me.toLowerCase()],!me||!me.href){var Ie=pe[0].charAt(0);return{type:"text",raw:Ie,text:Ie}}return $(pe,me,pe[0],this.lexer)}},Se.emStrong=function(ee,ue,pe){pe===void 0&&(pe="");var me=this.rules.inline.emStrong.lDelim.exec(ee);if(!!me&&!(me[3]&&pe.match(/(?:[0-9A-Za-z\xAA\xB2\xB3\xB5\xB9\xBA\xBC-\xBE\xC0-\xD6\xD8-\xF6\xF8-\u02C1\u02C6-\u02D1\u02E0-\u02E4\u02EC\u02EE\u0370-\u0374\u0376\u0377\u037A-\u037D\u037F\u0386\u0388-\u038A\u038C\u038E-\u03A1\u03A3-\u03F5\u03F7-\u0481\u048A-\u052F\u0531-\u0556\u0559\u0560-\u0588\u05D0-\u05EA\u05EF-\u05F2\u0620-\u064A\u0660-\u0669\u066E\u066F\u0671-\u06D3\u06D5\u06E5\u06E6\u06EE-\u06FC\u06FF\u0710\u0712-\u072F\u074D-\u07A5\u07B1\u07C0-\u07EA\u07F4\u07F5\u07FA\u0800-\u0815\u081A\u0824\u0828\u0840-\u0858\u0860-\u086A\u08A0-\u08B4\u08B6-\u08C7\u0904-\u0939\u093D\u0950\u0958-\u0961\u0966-\u096F\u0971-\u0980\u0985-\u098C\u098F\u0990\u0993-\u09A8\u09AA-\u09B0\u09B2\u09B6-\u09B9\u09BD\u09CE\u09DC\u09DD\u09DF-\u09E1\u09E6-\u09F1\u09F4-\u09F9\u09FC\u0A05-\u0A0A\u0A0F\u0A10\u0A13-\u0A28\u0A2A-\u0A30\u0A32\u0A33\u0A35\u0A36\u0A38\u0A39\u0A59-\u0A5C\u0A5E\u0A66-\u0A6F\u0A72-\u0A74\u0A85-\u0A8D\u0A8F-\u0A91\u0A93-\u0AA8\u0AAA-\u0AB0\u0AB2\u0AB3\u0AB5-\u0AB9\u0ABD\u0AD0\u0AE0\u0AE1\u0AE6-\u0AEF\u0AF9\u0B05-\u0B0C\u0B0F\u0B10\u0B13-\u0B28\u0B2A-\u0B30\u0B32\u0B33\u0B35-\u0B39\u0B3D\u0B5C\u0B5D\u0B5F-\u0B61\u0B66-\u0B6F\u0B71-\u0B77\u0B83\u0B85-\u0B8A\u0B8E-\u0B90\u0B92-\u0B95\u0B99\u0B9A\u0B9C\u0B9E\u0B9F\u0BA3\u0BA4\u0BA8-\u0BAA\u0BAE-\u0BB9\u0BD0\u0BE6-\u0BF2\u0C05-\u0C0C\u0C0E-\u0C10\u0C12-\u0C28\u0C2A-\u0C39\u0C3D\u0C58-\u0C5A\u0C60\u0C61\u0C66-\u0C6F\u0C78-\u0C7E\u0C80\u0C85-\u0C8C\u0C8E-\u0C90\u0C92-\u0CA8\u0CAA-\u0CB3\u0CB5-\u0CB9\u0CBD\u0CDE\u0CE0\u0CE1\u0CE6-\u0CEF\u0CF1\u0CF2\u0D04-\u0D0C\u0D0E-\u0D10\u0D12-\u0D3A\u0D3D\u0D4E\u0D54-\u0D56\u0D58-\u0D61\u0D66-\u0D78\u0D7A-\u0D7F\u0D85-\u0D96\u0D9A-\u0DB1\u0DB3-\u0DBB\u0DBD\u0DC0-\u0DC6\u0DE6-\u0DEF\u0E01-\u0E30\u0E32\u0E33\u0E40-\u0E46\u0E50-\u0E59\u0E81\u0E82\u0E84\u0E86-\u0E8A\u0E8C-\u0EA3\u0EA5\u0EA7-\u0EB0\u0EB2\u0EB3\u0EBD\u0EC0-\u0EC4\u0EC6\u0ED0-\u0ED9\u0EDC-\u0EDF\u0F00\u0F20-\u0F33\u0F40-\u0F47\u0F49-\u0F6C\u0F88-\u0F8C\u1000-\u102A\u103F-\u1049\u1050-\u1055\u105A-\u105D\u1061\u1065\u1066\u106E-\u1070\u1075-\u1081\u108E\u1090-\u1099\u10A0-\u10C5\u10C7\u10CD\u10D0-\u10FA\u10FC-\u1248\u124A-\u124D\u1250-\u1256\u1258\u125A-\u125D\u1260-\u1288\u128A-\u128D\u1290-\u12B0\u12B2-\u12B5\u12B8-\u12BE\u12C0\u12C2-\u12C5\u12C8-\u12D6\u12D8-\u1310\u1312-\u1315\u1318-\u135A\u1369-\u137C\u1380-\u138F\u13A0-\u13F5\u13F8-\u13FD\u1401-\u166C\u166F-\u167F\u1681-\u169A\u16A0-\u16EA\u16EE-\u16F8\u1700-\u170C\u170E-\u1711\u1720-\u1731\u1740-\u1751\u1760-\u176C\u176E-\u1770\u1780-\u17B3\u17D7\u17DC\u17E0-\u17E9\u17F0-\u17F9\u1810-\u1819\u1820-\u1878\u1880-\u1884\u1887-\u18A8\u18AA\u18B0-\u18F5\u1900-\u191E\u1946-\u196D\u1970-\u1974\u1980-\u19AB\u19B0-\u19C9\u19D0-\u19DA\u1A00-\u1A16\u1A20-\u1A54\u1A80-\u1A89\u1A90-\u1A99\u1AA7\u1B05-\u1B33\u1B45-\u1B4B\u1B50-\u1B59\u1B83-\u1BA0\u1BAE-\u1BE5\u1C00-\u1C23\u1C40-\u1C49\u1C4D-\u1C7D\u1C80-\u1C88\u1C90-\u1CBA\u1CBD-\u1CBF\u1CE9-\u1CEC\u1CEE-\u1CF3\u1CF5\u1CF6\u1CFA\u1D00-\u1DBF\u1E00-\u1F15\u1F18-\u1F1D\u1F20-\u1F45\u1F48-\u1F4D\u1F50-\u1F57\u1F59\u1F5B\u1F5D\u1F5F-\u1F7D\u1F80-\u1FB4\u1FB6-\u1FBC\u1FBE\u1FC2-\u1FC4\u1FC6-\u1FCC\u1FD0-\u1FD3\u1FD6-\u1FDB\u1FE0-\u1FEC\u1FF2-\u1FF4\u1FF6-\u1FFC\u2070\u2071\u2074-\u2079\u207F-\u2089\u2090-\u209C\u2102\u2107\u210A-\u2113\u2115\u2119-\u211D\u2124\u2126\u2128\u212A-\u212D\u212F-\u2139\u213C-\u213F\u2145-\u2149\u214E\u2150-\u2189\u2460-\u249B\u24EA-\u24FF\u2776-\u2793\u2C00-\u2C2E\u2C30-\u2C5E\u2C60-\u2CE4\u2CEB-\u2CEE\u2CF2\u2CF3\u2CFD\u2D00-\u2D25\u2D27\u2D2D\u2D30-\u2D67\u2D6F\u2D80-\u2D96\u2DA0-\u2DA6\u2DA8-\u2DAE\u2DB0-\u2DB6\u2DB8-\u2DBE\u2DC0-\u2DC6\u2DC8-\u2DCE\u2DD0-\u2DD6\u2DD8-\u2DDE\u2E2F\u3005-\u3007\u3021-\u3029\u3031-\u3035\u3038-\u303C\u3041-\u3096\u309D-\u309F\u30A1-\u30FA\u30FC-\u30FF\u3105-\u312F\u3131-\u318E\u3192-\u3195\u31A0-\u31BF\u31F0-\u31FF\u3220-\u3229\u3248-\u324F\u3251-\u325F\u3280-\u3289\u32B1-\u32BF\u3400-\u4DBF\u4E00-\u9FFC\uA000-\uA48C\uA4D0-\uA4FD\uA500-\uA60C\uA610-\uA62B\uA640-\uA66E\uA67F-\uA69D\uA6A0-\uA6EF\uA717-\uA71F\uA722-\uA788\uA78B-\uA7BF\uA7C2-\uA7CA\uA7F5-\uA801\uA803-\uA805\uA807-\uA80A\uA80C-\uA822\uA830-\uA835\uA840-\uA873\uA882-\uA8B3\uA8D0-\uA8D9\uA8F2-\uA8F7\uA8FB\uA8FD\uA8FE\uA900-\uA925\uA930-\uA946\uA960-\uA97C\uA984-\uA9B2\uA9CF-\uA9D9\uA9E0-\uA9E4\uA9E6-\uA9FE\uAA00-\uAA28\uAA40-\uAA42\uAA44-\uAA4B\uAA50-\uAA59\uAA60-\uAA76\uAA7A\uAA7E-\uAAAF\uAAB1\uAAB5\uAAB6\uAAB9-\uAABD\uAAC0\uAAC2\uAADB-\uAADD\uAAE0-\uAAEA\uAAF2-\uAAF4\uAB01-\uAB06\uAB09-\uAB0E\uAB11-\uAB16\uAB20-\uAB26\uAB28-\uAB2E\uAB30-\uAB5A\uAB5C-\uAB69\uAB70-\uABE2\uABF0-\uABF9\uAC00-\uD7A3\uD7B0-\uD7C6\uD7CB-\uD7FB\uF900-\uFA6D\uFA70-\uFAD9\uFB00-\uFB06\uFB13-\uFB17\uFB1D\uFB1F-\uFB28\uFB2A-\uFB36\uFB38-\uFB3C\uFB3E\uFB40\uFB41\uFB43\uFB44\uFB46-\uFBB1\uFBD3-\uFD3D\uFD50-\uFD8F\uFD92-\uFDC7\uFDF0-\uFDFB\uFE70-\uFE74\uFE76-\uFEFC\uFF10-\uFF19\uFF21-\uFF3A\uFF41-\uFF5A\uFF66-\uFFBE\uFFC2-\uFFC7\uFFCA-\uFFCF\uFFD2-\uFFD7\uFFDA-\uFFDC]|\uD800[\uDC00-\uDC0B\uDC0D-\uDC26\uDC28-\uDC3A\uDC3C\uDC3D\uDC3F-\uDC4D\uDC50-\uDC5D\uDC80-\uDCFA\uDD07-\uDD33\uDD40-\uDD78\uDD8A\uDD8B\uDE80-\uDE9C\uDEA0-\uDED0\uDEE1-\uDEFB\uDF00-\uDF23\uDF2D-\uDF4A\uDF50-\uDF75\uDF80-\uDF9D\uDFA0-\uDFC3\uDFC8-\uDFCF\uDFD1-\uDFD5]|\uD801[\uDC00-\uDC9D\uDCA0-\uDCA9\uDCB0-\uDCD3\uDCD8-\uDCFB\uDD00-\uDD27\uDD30-\uDD63\uDE00-\uDF36\uDF40-\uDF55\uDF60-\uDF67]|\uD802[\uDC00-\uDC05\uDC08\uDC0A-\uDC35\uDC37\uDC38\uDC3C\uDC3F-\uDC55\uDC58-\uDC76\uDC79-\uDC9E\uDCA7-\uDCAF\uDCE0-\uDCF2\uDCF4\uDCF5\uDCFB-\uDD1B\uDD20-\uDD39\uDD80-\uDDB7\uDDBC-\uDDCF\uDDD2-\uDE00\uDE10-\uDE13\uDE15-\uDE17\uDE19-\uDE35\uDE40-\uDE48\uDE60-\uDE7E\uDE80-\uDE9F\uDEC0-\uDEC7\uDEC9-\uDEE4\uDEEB-\uDEEF\uDF00-\uDF35\uDF40-\uDF55\uDF58-\uDF72\uDF78-\uDF91\uDFA9-\uDFAF]|\uD803[\uDC00-\uDC48\uDC80-\uDCB2\uDCC0-\uDCF2\uDCFA-\uDD23\uDD30-\uDD39\uDE60-\uDE7E\uDE80-\uDEA9\uDEB0\uDEB1\uDF00-\uDF27\uDF30-\uDF45\uDF51-\uDF54\uDFB0-\uDFCB\uDFE0-\uDFF6]|\uD804[\uDC03-\uDC37\uDC52-\uDC6F\uDC83-\uDCAF\uDCD0-\uDCE8\uDCF0-\uDCF9\uDD03-\uDD26\uDD36-\uDD3F\uDD44\uDD47\uDD50-\uDD72\uDD76\uDD83-\uDDB2\uDDC1-\uDDC4\uDDD0-\uDDDA\uDDDC\uDDE1-\uDDF4\uDE00-\uDE11\uDE13-\uDE2B\uDE80-\uDE86\uDE88\uDE8A-\uDE8D\uDE8F-\uDE9D\uDE9F-\uDEA8\uDEB0-\uDEDE\uDEF0-\uDEF9\uDF05-\uDF0C\uDF0F\uDF10\uDF13-\uDF28\uDF2A-\uDF30\uDF32\uDF33\uDF35-\uDF39\uDF3D\uDF50\uDF5D-\uDF61]|\uD805[\uDC00-\uDC34\uDC47-\uDC4A\uDC50-\uDC59\uDC5F-\uDC61\uDC80-\uDCAF\uDCC4\uDCC5\uDCC7\uDCD0-\uDCD9\uDD80-\uDDAE\uDDD8-\uDDDB\uDE00-\uDE2F\uDE44\uDE50-\uDE59\uDE80-\uDEAA\uDEB8\uDEC0-\uDEC9\uDF00-\uDF1A\uDF30-\uDF3B]|\uD806[\uDC00-\uDC2B\uDCA0-\uDCF2\uDCFF-\uDD06\uDD09\uDD0C-\uDD13\uDD15\uDD16\uDD18-\uDD2F\uDD3F\uDD41\uDD50-\uDD59\uDDA0-\uDDA7\uDDAA-\uDDD0\uDDE1\uDDE3\uDE00\uDE0B-\uDE32\uDE3A\uDE50\uDE5C-\uDE89\uDE9D\uDEC0-\uDEF8]|\uD807[\uDC00-\uDC08\uDC0A-\uDC2E\uDC40\uDC50-\uDC6C\uDC72-\uDC8F\uDD00-\uDD06\uDD08\uDD09\uDD0B-\uDD30\uDD46\uDD50-\uDD59\uDD60-\uDD65\uDD67\uDD68\uDD6A-\uDD89\uDD98\uDDA0-\uDDA9\uDEE0-\uDEF2\uDFB0\uDFC0-\uDFD4]|\uD808[\uDC00-\uDF99]|\uD809[\uDC00-\uDC6E\uDC80-\uDD43]|[\uD80C\uD81C-\uD820\uD822\uD840-\uD868\uD86A-\uD86C\uD86F-\uD872\uD874-\uD879\uD880-\uD883][\uDC00-\uDFFF]|\uD80D[\uDC00-\uDC2E]|\uD811[\uDC00-\uDE46]|\uD81A[\uDC00-\uDE38\uDE40-\uDE5E\uDE60-\uDE69\uDED0-\uDEED\uDF00-\uDF2F\uDF40-\uDF43\uDF50-\uDF59\uDF5B-\uDF61\uDF63-\uDF77\uDF7D-\uDF8F]|\uD81B[\uDE40-\uDE96\uDF00-\uDF4A\uDF50\uDF93-\uDF9F\uDFE0\uDFE1\uDFE3]|\uD821[\uDC00-\uDFF7]|\uD823[\uDC00-\uDCD5\uDD00-\uDD08]|\uD82C[\uDC00-\uDD1E\uDD50-\uDD52\uDD64-\uDD67\uDD70-\uDEFB]|\uD82F[\uDC00-\uDC6A\uDC70-\uDC7C\uDC80-\uDC88\uDC90-\uDC99]|\uD834[\uDEE0-\uDEF3\uDF60-\uDF78]|\uD835[\uDC00-\uDC54\uDC56-\uDC9C\uDC9E\uDC9F\uDCA2\uDCA5\uDCA6\uDCA9-\uDCAC\uDCAE-\uDCB9\uDCBB\uDCBD-\uDCC3\uDCC5-\uDD05\uDD07-\uDD0A\uDD0D-\uDD14\uDD16-\uDD1C\uDD1E-\uDD39\uDD3B-\uDD3E\uDD40-\uDD44\uDD46\uDD4A-\uDD50\uDD52-\uDEA5\uDEA8-\uDEC0\uDEC2-\uDEDA\uDEDC-\uDEFA\uDEFC-\uDF14\uDF16-\uDF34\uDF36-\uDF4E\uDF50-\uDF6E\uDF70-\uDF88\uDF8A-\uDFA8\uDFAA-\uDFC2\uDFC4-\uDFCB\uDFCE-\uDFFF]|\uD838[\uDD00-\uDD2C\uDD37-\uDD3D\uDD40-\uDD49\uDD4E\uDEC0-\uDEEB\uDEF0-\uDEF9]|\uD83A[\uDC00-\uDCC4\uDCC7-\uDCCF\uDD00-\uDD43\uDD4B\uDD50-\uDD59]|\uD83B[\uDC71-\uDCAB\uDCAD-\uDCAF\uDCB1-\uDCB4\uDD01-\uDD2D\uDD2F-\uDD3D\uDE00-\uDE03\uDE05-\uDE1F\uDE21\uDE22\uDE24\uDE27\uDE29-\uDE32\uDE34-\uDE37\uDE39\uDE3B\uDE42\uDE47\uDE49\uDE4B\uDE4D-\uDE4F\uDE51\uDE52\uDE54\uDE57\uDE59\uDE5B\uDE5D\uDE5F\uDE61\uDE62\uDE64\uDE67-\uDE6A\uDE6C-\uDE72\uDE74-\uDE77\uDE79-\uDE7C\uDE7E\uDE80-\uDE89\uDE8B-\uDE9B\uDEA1-\uDEA3\uDEA5-\uDEA9\uDEAB-\uDEBB]|\uD83C[\uDD00-\uDD0C]|\uD83E[\uDFF0-\uDFF9]|\uD869[\uDC00-\uDEDD\uDF00-\uDFFF]|\uD86D[\uDC00-\uDF34\uDF40-\uDFFF]|\uD86E[\uDC00-\uDC1D\uDC20-\uDFFF]|\uD873[\uDC00-\uDEA1\uDEB0-\uDFFF]|\uD87A[\uDC00-\uDFE0]|\uD87E[\uDC00-\uDE1D]|\uD884[\uDC00-\uDF4A])/))){var Ie=me[1]||me[2]||"";if(!Ie||Ie&&(pe===""||this.rules.inline.punctuation.exec(pe))){var Be=me[0].length-1,Ne,je,et=Be,Le=0,de=me[0][0]==="*"?this.rules.inline.emStrong.rDelimAst:this.rules.inline.emStrong.rDelimUnd;for(de.lastIndex=0,ue=ue.slice(-1*ee.length+Be);(me=de.exec(ue))!=null;)if(Ne=me[1]||me[2]||me[3]||me[4]||me[5]||me[6],!!Ne){if(je=Ne.length,me[3]||me[4]){et+=je;continue}else if((me[5]||me[6])&&Be%3&&!((Be+je)%3)){Le+=je;continue}if(et-=je,!(et>0)){if(je=Math.min(je,je+et+Le),Math.min(Be,je)%2){var ge=ee.slice(1,Be+me.index+je);return{type:"em",raw:ee.slice(0,Be+me.index+je+1),text:ge,tokens:this.lexer.inlineTokens(ge,[])}}var X=ee.slice(2,Be+me.index+je-1);return{type:"strong",raw:ee.slice(0,Be+me.index+je+1),text:X,tokens:this.lexer.inlineTokens(X,[])}}}}}},Se.codespan=function(ee){var ue=this.rules.inline.code.exec(ee);if(ue){var pe=ue[2].replace(/\n/g," "),me=/[^ ]/.test(pe),Ie=/^ /.test(pe)&&/ $/.test(pe);return me&&Ie&&(pe=pe.substring(1,pe.length-1)),pe=U(pe,!0),{type:"codespan",raw:ue[0],text:pe}}},Se.br=function(ee){var ue=this.rules.inline.br.exec(ee);if(ue)return{type:"br",raw:ue[0]}},Se.del=function(ee){var ue=this.rules.inline.del.exec(ee);if(ue)return{type:"del",raw:ue[0],text:ue[2],tokens:this.lexer.inlineTokens(ue[2],[])}},Se.autolink=function(ee,ue){var pe=this.rules.inline.autolink.exec(ee);if(pe){var me,Ie;return pe[2]==="@"?(me=U(this.options.mangle?ue(pe[1]):pe[1]),Ie="mailto:"+me):(me=U(pe[1]),Ie=me),{type:"link",raw:pe[0],text:me,href:Ie,tokens:[{type:"text",raw:me,text:me}]}}},Se.url=function(ee,ue){var pe;if(pe=this.rules.inline.url.exec(ee)){var me,Ie;if(pe[2]==="@")me=U(this.options.mangle?ue(pe[0]):pe[0]),Ie="mailto:"+me;else{var Be;do Be=pe[0],pe[0]=this.rules.inline._backpedal.exec(pe[0])[0];while(Be!==pe[0]);me=U(pe[0]),pe[1]==="www."?Ie="http://"+me:Ie=me}return{type:"link",raw:pe[0],text:me,href:Ie,tokens:[{type:"text",raw:me,text:me}]}}},Se.inlineText=function(ee,ue){var pe=this.rules.inline.text.exec(ee);if(pe){var me;return this.lexer.state.inRawBlock?me=this.options.sanitize?this.options.sanitizer?this.options.sanitizer(pe[0]):U(pe[0]):pe[0]:me=U(this.options.smartypants?ue(pe[0]):pe[0]),{type:"text",raw:pe[0],text:me}}},Pe}(),Y=A.noopTest,ne=A.edit,j=A.merge,le={newline:/^(?: *(?:\n|$))+/,code:/^( {4}[^\n]+(?:\n(?: *(?:\n|$))*)?)+/,fences:/^ {0,3}(`{3,}(?=[^`\n]*\n)|~{3,})([^\n]*)\n(?:|([\s\S]*?)\n)(?: {0,3}\1[~`]* *(?=\n|$)|$)/,hr:/^ {0,3}((?:- *){3,}|(?:_ *){3,}|(?:\* *){3,})(?:\n+|$)/,heading:/^ {0,3}(#{1,6})(?=\s|$)(.*)(?:\n+|$)/,blockquote:/^( {0,3}> ?(paragraph|[^\n]*)(?:\n|$))+/,list:/^( {0,3}bull)( [^\n]+?)?(?:\n|$)/,html:"^ {0,3}(?:<(script|pre|style|textarea)[\\s>][\\s\\S]*?(?:</\\1>[^\\n]*\\n+|$)|comment[^\\n]*(\\n+|$)|<\\?[\\s\\S]*?(?:\\?>\\n*|$)|<![A-Z][\\s\\S]*?(?:>\\n*|$)|<!\\[CDATA\\[[\\s\\S]*?(?:\\]\\]>\\n*|$)|</?(tag)(?: +|\\n|/?>)[\\s\\S]*?(?:(?:\\n *)+\\n|$)|<(?!script|pre|style|textarea)([a-z][\\w-]*)(?:attribute)*? */?>(?=[ \\t]*(?:\\n|$))[\\s\\S]*?(?:(?:\\n *)+\\n|$)|</(?!script|pre|style|textarea)[a-z][\\w-]*\\s*>(?=[ \\t]*(?:\\n|$))[\\s\\S]*?(?:(?:\\n *)+\\n|$))",def:/^ {0,3}\[(label)\]: *\n? *<?([^\s>]+)>?(?:(?: +\n? *| *\n *)(title))? *(?:\n+|$)/,table:Y,lheading:/^([^\n]+)\n {0,3}(=+|-+) *(?:\n+|$)/,_paragraph:/^([^\n]+(?:\n(?!hr|heading|lheading|blockquote|fences|list|html| +\n)[^\n]+)*)/,text:/^[^\n]+/};le._label=/(?!\s*\])(?:\\[\[\]]|[^\[\]])+/,le._title=/(?:"(?:\\"?|[^"\\])*"|'[^'\n]*(?:\n[^'\n]+)*\n?'|\([^()]*\))/,le.def=ne(le.def).replace("label",le._label).replace("title",le._title).getRegex(),le.bullet=/(?:[*+-]|\d{1,9}[.)])/,le.listItemStart=ne(/^( *)(bull) */).replace("bull",le.bullet).getRegex(),le.list=ne(le.list).replace(/bull/g,le.bullet).replace("hr","\\n+(?=\\1?(?:(?:- *){3,}|(?:_ *){3,}|(?:\\* *){3,})(?:\\n+|$))").replace("def","\\n+(?="+le.def.source+")").getRegex(),le._tag="address|article|aside|base|basefont|blockquote|body|caption|center|col|colgroup|dd|details|dialog|dir|div|dl|dt|fieldset|figcaption|figure|footer|form|frame|frameset|h[1-6]|head|header|hr|html|iframe|legend|li|link|main|menu|menuitem|meta|nav|noframes|ol|optgroup|option|p|param|section|source|summary|table|tbody|td|tfoot|th|thead|title|tr|track|ul",le._comment=/<!--(?!-?>)[\s\S]*?(?:-->|$)/,le.html=ne(le.html,"i").replace("comment",le._comment).replace("tag",le._tag).replace("attribute",/ +[a-zA-Z:_][\w.:-]*(?: *= *"[^"\n]*"| *= *'[^'\n]*'| *= *[^\s"'=<>`]+)?/).getRegex(),le.paragraph=ne(le._paragraph).replace("hr",le.hr).replace("heading"," {0,3}#{1,6} ").replace("|lheading","").replace("blockquote"," {0,3}>").replace("fences"," {0,3}(?:`{3,}(?=[^`\\n]*\\n)|~{3,})[^\\n]*\\n").replace("list"," {0,3}(?:[*+-]|1[.)]) ").replace("html","</?(?:tag)(?: +|\\n|/?>)|<(?:script|pre|style|textarea|!--)").replace("tag",le._tag).getRegex(),le.blockquote=ne(le.blockquote).replace("paragraph",le.paragraph).getRegex(),le.normal=j({},le),le.gfm=j({},le.normal,{table:"^ *([^\\n ].*\\|.*)\\n {0,3}(?:\\| *)?(:?-+:? *(?:\\| *:?-+:? *)*)\\|?(?:\\n((?:(?! *\\n|hr|heading|blockquote|code|fences|list|html).*(?:\\n|$))*)\\n*|$)"}),le.gfm.table=ne(le.gfm.table).replace("hr",le.hr).replace("heading"," {0,3}#{1,6} ").replace("blockquote"," {0,3}>").replace("code"," {4}[^\\n]").replace("fences"," {0,3}(?:`{3,}(?=[^`\\n]*\\n)|~{3,})[^\\n]*\\n").replace("list"," {0,3}(?:[*+-]|1[.)]) ").replace("html","</?(?:tag)(?: +|\\n|/?>)|<(?:script|pre|style|textarea|!--)").replace("tag",le._tag).getRegex(),le.pedantic=j({},le.normal,{html:ne(`^ *(?:comment *(?:\\n|\\s*$)|<(tag)[\\s\\S]+?</\\1> *(?:\\n{2,}|\\s*$)|<tag(?:"[^"]*"|'[^']*'|\\s[^'"/>\\s]*)*?/?> *(?:\\n{2,}|\\s*$))`).replace("comment",le._comment).replace(/tag/g,"(?!(?:a|em|strong|small|s|cite|q|dfn|abbr|data|time|code|var|samp|kbd|sub|sup|i|b|u|mark|ruby|rt|rp|bdi|bdo|span|br|wbr|ins|del|img)\\b)\\w+(?!:|[^\\w\\s@]*@)\\b").getRegex(),def:/^ *\[([^\]]+)\]: *<?([^\s>]+)>?(?: +(["(][^\n]+[")]))? *(?:\n+|$)/,heading:/^(#{1,6})(.*)(?:\n+|$)/,fences:Y,paragraph:ne(le.normal._paragraph).replace("hr",le.hr).replace("heading",` *#{1,6} *[^
]`).replace("lheading",le.lheading).replace("blockquote"," {0,3}>").replace("|fences","").replace("|list","").replace("|html","").getRegex()});var oe={escape:/^\\([!"#$%&'()*+,\-./:;<=>?@\[\]\\^_`{|}~])/,autolink:/^<(scheme:[^\s\x00-\x1f<>]*|email)>/,url:Y,tag:"^comment|^</[a-zA-Z][\\w:-]*\\s*>|^<[a-zA-Z][\\w-]*(?:attribute)*?\\s*/?>|^<\\?[\\s\\S]*?\\?>|^<![a-zA-Z]+\\s[\\s\\S]*?>|^<!\\[CDATA\\[[\\s\\S]*?\\]\\]>",link:/^!?\[(label)\]\(\s*(href)(?:\s+(title))?\s*\)/,reflink:/^!?\[(label)\]\[(?!\s*\])((?:\\[\[\]]?|[^\[\]\\])+)\]/,nolink:/^!?\[(?!\s*\])((?:\[[^\[\]]*\]|\\[\[\]]|[^\[\]])*)\](?:\[\])?/,reflinkSearch:"reflink|nolink(?!\\()",emStrong:{lDelim:/^(?:\*+(?:([punct_])|[^\s*]))|^_+(?:([punct*])|([^\s_]))/,rDelimAst:/\_\_[^_*]*?\*[^_*]*?\_\_|[punct_](\*+)(?=[\s]|$)|[^punct*_\s](\*+)(?=[punct_\s]|$)|[punct_\s](\*+)(?=[^punct*_\s])|[\s](\*+)(?=[punct_])|[punct_](\*+)(?=[punct_])|[^punct*_\s](\*+)(?=[^punct*_\s])/,rDelimUnd:/\*\*[^_*]*?\_[^_*]*?\*\*|[punct*](\_+)(?=[\s]|$)|[^punct*_\s](\_+)(?=[punct*\s]|$)|[punct*\s](\_+)(?=[^punct*_\s])|[\s](\_+)(?=[punct*])|[punct*](\_+)(?=[punct*])/},code:/^(`+)([^`]|[^`][\s\S]*?[^`])\1(?!`)/,br:/^( {2,}|\\)\n(?!\s*$)/,del:Y,text:/^(`+|[^`])(?:(?= {2,}\n)|[\s\S]*?(?:(?=[\\<!\[`*_]|\b_|$)|[^ ](?= {2,}\n)))/,punctuation:/^([\spunctuation])/};oe._punctuation="!\"#$%&'()+\\-.,/:;<=>?@\\[\\]`^{|}~",oe.punctuation=ne(oe.punctuation).replace(/punctuation/g,oe._punctuation).getRegex(),oe.blockSkip=/\[[^\]]*?\]\([^\)]*?\)|`[^`]*?`|<[^>]*?>/g,oe.escapedEmSt=/\\\*|\\_/g,oe._comment=ne(le._comment).replace("(?:-->|$)","-->").getRegex(),oe.emStrong.lDelim=ne(oe.emStrong.lDelim).replace(/punct/g,oe._punctuation).getRegex(),oe.emStrong.rDelimAst=ne(oe.emStrong.rDelimAst,"g").replace(/punct/g,oe._punctuation).getRegex(),oe.emStrong.rDelimUnd=ne(oe.emStrong.rDelimUnd,"g").replace(/punct/g,oe._punctuation).getRegex(),oe._escapes=/\\([!"#$%&'()*+,\-./:;<=>?@\[\]\\^_`{|}~])/g,oe._scheme=/[a-zA-Z][a-zA-Z0-9+.-]{1,31}/,oe._email=/[a-zA-Z0-9.!#$%&'*+/=?^_`{|}~-]+(@)[a-zA-Z0-9](?:[a-zA-Z0-9-]{0,61}[a-zA-Z0-9])?(?:\.[a-zA-Z0-9](?:[a-zA-Z0-9-]{0,61}[a-zA-Z0-9])?)+(?![-_])/,oe.autolink=ne(oe.autolink).replace("scheme",oe._scheme).replace("email",oe._email).getRegex(),oe._attribute=/\s+[a-zA-Z:_][\w.:-]*(?:\s*=\s*"[^"]*"|\s*=\s*'[^']*'|\s*=\s*[^\s"'=<>`]+)?/,oe.tag=ne(oe.tag).replace("comment",oe._comment).replace("attribute",oe._attribute).getRegex(),oe._label=/(?:\[(?:\\.|[^\[\]\\])*\]|\\.|`[^`]*`|[^\[\]\\`])*?/,oe._href=/<(?:\\.|[^\n<>\\])+>|[^\s\x00-\x1f]*/,oe._title=/"(?:\\"?|[^"\\])*"|'(?:\\'?|[^'\\])*'|\((?:\\\)?|[^)\\])*\)/,oe.link=ne(oe.link).replace("label",oe._label).replace("href",oe._href).replace("title",oe._title).getRegex(),oe.reflink=ne(oe.reflink).replace("label",oe._label).getRegex(),oe.reflinkSearch=ne(oe.reflinkSearch,"g").replace("reflink",oe.reflink).replace("nolink",oe.nolink).getRegex(),oe.normal=j({},oe),oe.pedantic=j({},oe.normal,{strong:{start:/^__|\*\*/,middle:/^__(?=\S)([\s\S]*?\S)__(?!_)|^\*\*(?=\S)([\s\S]*?\S)\*\*(?!\*)/,endAst:/\*\*(?!\*)/g,endUnd:/__(?!_)/g},em:{start:/^_|\*/,middle:/^()\*(?=\S)([\s\S]*?\S)\*(?!\*)|^_(?=\S)([\s\S]*?\S)_(?!_)/,endAst:/\*(?!\*)/g,endUnd:/_(?!_)/g},link:ne(/^!?\[(label)\]\((.*?)\)/).replace("label",oe._label).getRegex(),reflink:ne(/^!?\[(label)\]\s*\[([^\]]*)\]/).replace("label",oe._label).getRegex()}),oe.gfm=j({},oe.normal,{escape:ne(oe.escape).replace("])","~|])").getRegex(),_extended_email:/[A-Za-z0-9._+-]+(@)[a-zA-Z0-9-_]+(?:\.[a-zA-Z0-9-_]*[a-zA-Z0-9])+(?![-_])/,url:/^((?:ftp|https?):\/\/|www\.)(?:[a-zA-Z0-9\-]+\.?)+[^\s<]*|^email/,_backpedal:/(?:[^?!.,:;*_~()&]+|\([^)]*\)|&(?![a-zA-Z0-9]+;$)|[?!.,:;*_~)]+(?!$))+/,del:/^(~~?)(?=[^\s~])([\s\S]*?[^\s~])\1(?=[^~]|$)/,text:/^([`~]+|[^`~])(?:(?= {2,}\n)|(?=[a-zA-Z0-9.!#$%&'*+\/=?_`{\|}~-]+@)|[\s\S]*?(?:(?=[\\<!\[`*~_]|\b_|https?:\/\/|ftp:\/\/|www\.|$)|[^ ](?= {2,}\n)|[^a-zA-Z0-9.!#$%&'*+\/=?_`{\|}~-](?=[a-zA-Z0-9.!#$%&'*+\/=?_`{\|}~-]+@)))/}),oe.gfm.url=ne(oe.gfm.url,"i").replace("email",oe.gfm._extended_email).getRegex(),oe.breaks=j({},oe.gfm,{br:ne(oe.br).replace("{2,}","*").getRegex(),text:ne(oe.gfm.text).replace("\\b_","\\b_| {2,}\\n").replace(/\{2,\}/g,"*").getRegex()});var ve={block:le,inline:oe},Re=z,Me=R.exports.defaults,Oe=ve.block,Ye=ve.inline,Ve=A.repeatString;function qe(Pe){return Pe.replace(/---/g,"\u2014").replace(/--/g,"\u2013").replace(/(^|[-\u2014/(\[{"\s])'/g,"$1\u2018").replace(/'/g,"\u2019").replace(/(^|[-\u2014/(\[{\u2018\s])"/g,"$1\u201C").replace(/"/g,"\u201D").replace(/\.{3}/g,"\u2026")}function x(Pe){var Se="",De,ee,ue=Pe.length;for(De=0;De<ue;De++)ee=Pe.charCodeAt(De),Math.random()>.5&&(ee="x"+ee.toString(16)),Se+="&#"+ee+";";return Se}var Q=function(){function Pe(De){this.tokens=[],this.tokens.links=Object.create(null),this.options=De||Me,this.options.tokenizer=this.options.tokenizer||new Re,this.tokenizer=this.options.tokenizer,this.tokenizer.options=this.options,this.tokenizer.lexer=this,this.inlineQueue=[],this.state={inLink:!1,inRawBlock:!1,top:!0};var ee={block:Oe.normal,inline:Ye.normal};this.options.pedantic?(ee.block=Oe.pedantic,ee.inline=Ye.pedantic):this.options.gfm&&(ee.block=Oe.gfm,this.options.breaks?ee.inline=Ye.breaks:ee.inline=Ye.gfm),this.tokenizer.rules=ee}Pe.lex=function(ee,ue){var pe=new Pe(ue);return pe.lex(ee)},Pe.lexInline=function(ee,ue){var pe=new Pe(ue);return pe.inlineTokens(ee)};var Se=Pe.prototype;return Se.lex=function(ee){ee=ee.replace(/\r\n|\r/g,`
`).replace(/\t/g,"    "),this.blockTokens(ee,this.tokens);for(var ue;ue=this.inlineQueue.shift();)this.inlineTokens(ue.src,ue.tokens);return this.tokens},Se.blockTokens=function(ee,ue){var pe=this;ue===void 0&&(ue=[]),this.options.pedantic&&(ee=ee.replace(/^ +$/gm,""));for(var me,Ie,Be,Ne;ee;)if(!(this.options.extensions&&this.options.extensions.block&&this.options.extensions.block.some(function(et){return(me=et.call({lexer:pe},ee,ue))?(ee=ee.substring(me.raw.length),ue.push(me),!0):!1}))){if(me=this.tokenizer.space(ee)){ee=ee.substring(me.raw.length),me.type&&ue.push(me);continue}if(me=this.tokenizer.code(ee)){ee=ee.substring(me.raw.length),Ie=ue[ue.length-1],Ie&&(Ie.type==="paragraph"||Ie.type==="text")?(Ie.raw+=`
`+me.raw,Ie.text+=`
`+me.text,this.inlineQueue[this.inlineQueue.length-1].src=Ie.text):ue.push(me);continue}if(me=this.tokenizer.fences(ee)){ee=ee.substring(me.raw.length),ue.push(me);continue}if(me=this.tokenizer.heading(ee)){ee=ee.substring(me.raw.length),ue.push(me);continue}if(me=this.tokenizer.hr(ee)){ee=ee.substring(me.raw.length),ue.push(me);continue}if(me=this.tokenizer.blockquote(ee)){ee=ee.substring(me.raw.length),ue.push(me);continue}if(me=this.tokenizer.list(ee)){ee=ee.substring(me.raw.length),ue.push(me);continue}if(me=this.tokenizer.html(ee)){ee=ee.substring(me.raw.length),ue.push(me);continue}if(me=this.tokenizer.def(ee)){ee=ee.substring(me.raw.length),Ie=ue[ue.length-1],Ie&&(Ie.type==="paragraph"||Ie.type==="text")?(Ie.raw+=`
`+me.raw,Ie.text+=`
`+me.raw,this.inlineQueue[this.inlineQueue.length-1].src=Ie.text):this.tokens.links[me.tag]||(this.tokens.links[me.tag]={href:me.href,title:me.title});continue}if(me=this.tokenizer.table(ee)){ee=ee.substring(me.raw.length),ue.push(me);continue}if(me=this.tokenizer.lheading(ee)){ee=ee.substring(me.raw.length),ue.push(me);continue}if(Be=ee,this.options.extensions&&this.options.extensions.startBlock&&function(){var et=Infinity,Le=ee.slice(1),de=void 0;pe.options.extensions.startBlock.forEach(function(ge){de=ge.call({lexer:this},Le),typeof de=="number"&&de>=0&&(et=Math.min(et,de))}),et<Infinity&&et>=0&&(Be=ee.substring(0,et+1))}(),this.state.top&&(me=this.tokenizer.paragraph(Be))){Ie=ue[ue.length-1],Ne&&Ie.type==="paragraph"?(Ie.raw+=`
`+me.raw,Ie.text+=`
`+me.text,this.inlineQueue.pop(),this.inlineQueue[this.inlineQueue.length-1].src=Ie.text):ue.push(me),Ne=Be.length!==ee.length,ee=ee.substring(me.raw.length);continue}if(me=this.tokenizer.text(ee)){ee=ee.substring(me.raw.length),Ie=ue[ue.length-1],Ie&&Ie.type==="text"?(Ie.raw+=`
`+me.raw,Ie.text+=`
`+me.text,this.inlineQueue.pop(),this.inlineQueue[this.inlineQueue.length-1].src=Ie.text):ue.push(me);continue}if(ee){var je="Infinite loop on byte: "+ee.charCodeAt(0);if(this.options.silent){console.error(je);break}else throw new Error(je)}}return this.state.top=!0,ue},Se.inline=function(ee,ue){this.inlineQueue.push({src:ee,tokens:ue})},Se.inlineTokens=function(ee,ue){var pe=this;ue===void 0&&(ue=[]);var me,Ie,Be,Ne=ee,je,et,Le;if(this.tokens.links){var de=Object.keys(this.tokens.links);if(de.length>0)for(;(je=this.tokenizer.rules.inline.reflinkSearch.exec(Ne))!=null;)de.includes(je[0].slice(je[0].lastIndexOf("[")+1,-1))&&(Ne=Ne.slice(0,je.index)+"["+Ve("a",je[0].length-2)+"]"+Ne.slice(this.tokenizer.rules.inline.reflinkSearch.lastIndex))}for(;(je=this.tokenizer.rules.inline.blockSkip.exec(Ne))!=null;)Ne=Ne.slice(0,je.index)+"["+Ve("a",je[0].length-2)+"]"+Ne.slice(this.tokenizer.rules.inline.blockSkip.lastIndex);for(;(je=this.tokenizer.rules.inline.escapedEmSt.exec(Ne))!=null;)Ne=Ne.slice(0,je.index)+"++"+Ne.slice(this.tokenizer.rules.inline.escapedEmSt.lastIndex);for(;ee;)if(et||(Le=""),et=!1,!(this.options.extensions&&this.options.extensions.inline&&this.options.extensions.inline.some(function(X){return(me=X.call({lexer:pe},ee,ue))?(ee=ee.substring(me.raw.length),ue.push(me),!0):!1}))){if(me=this.tokenizer.escape(ee)){ee=ee.substring(me.raw.length),ue.push(me);continue}if(me=this.tokenizer.tag(ee)){ee=ee.substring(me.raw.length),Ie=ue[ue.length-1],Ie&&me.type==="text"&&Ie.type==="text"?(Ie.raw+=me.raw,Ie.text+=me.text):ue.push(me);continue}if(me=this.tokenizer.link(ee)){ee=ee.substring(me.raw.length),ue.push(me);continue}if(me=this.tokenizer.reflink(ee,this.tokens.links)){ee=ee.substring(me.raw.length),Ie=ue[ue.length-1],Ie&&me.type==="text"&&Ie.type==="text"?(Ie.raw+=me.raw,Ie.text+=me.text):ue.push(me);continue}if(me=this.tokenizer.emStrong(ee,Ne,Le)){ee=ee.substring(me.raw.length),ue.push(me);continue}if(me=this.tokenizer.codespan(ee)){ee=ee.substring(me.raw.length),ue.push(me);continue}if(me=this.tokenizer.br(ee)){ee=ee.substring(me.raw.length),ue.push(me);continue}if(me=this.tokenizer.del(ee)){ee=ee.substring(me.raw.length),ue.push(me);continue}if(me=this.tokenizer.autolink(ee,x)){ee=ee.substring(me.raw.length),ue.push(me);continue}if(!this.state.inLink&&(me=this.tokenizer.url(ee,x))){ee=ee.substring(me.raw.length),ue.push(me);continue}if(Be=ee,this.options.extensions&&this.options.extensions.startInline&&function(){var X=Infinity,W=ee.slice(1),be=void 0;pe.options.extensions.startInline.forEach(function(ke){be=ke.call({lexer:this},W),typeof be=="number"&&be>=0&&(X=Math.min(X,be))}),X<Infinity&&X>=0&&(Be=ee.substring(0,X+1))}(),me=this.tokenizer.inlineText(Be,qe)){ee=ee.substring(me.raw.length),me.raw.slice(-1)!=="_"&&(Le=me.raw.slice(-1)),et=!0,Ie=ue[ue.length-1],Ie&&Ie.type==="text"?(Ie.raw+=me.raw,Ie.text+=me.text):ue.push(me);continue}if(ee){var ge="Infinite loop on byte: "+ee.charCodeAt(0);if(this.options.silent){console.error(ge);break}else throw new Error(ge)}}return ue},e(Pe,null,[{key:"rules",get:function(){return{block:Oe,inline:Ye}}}]),Pe}(),te=R.exports.defaults,ae=A.cleanUrl,q=A.escape,se=function(){function Pe(De){this.options=De||te}var Se=Pe.prototype;return Se.code=function(ee,ue,pe){var me=(ue||"").match(/\S*/)[0];if(this.options.highlight){var Ie=this.options.highlight(ee,me);Ie!=null&&Ie!==ee&&(pe=!0,ee=Ie)}return ee=ee.replace(/\n$/,"")+`
`,me?'<pre><code class="'+this.options.langPrefix+q(me,!0)+'">'+(pe?ee:q(ee,!0))+`</code></pre>
`:"<pre><code>"+(pe?ee:q(ee,!0))+`</code></pre>
`},Se.blockquote=function(ee){return`<blockquote>
`+ee+`</blockquote>
`},Se.html=function(ee){return ee},Se.heading=function(ee,ue,pe,me){return this.options.headerIds?"<h"+ue+' id="'+this.options.headerPrefix+me.slug(pe)+'">'+ee+"</h"+ue+`>
`:"<h"+ue+">"+ee+"</h"+ue+`>
`},Se.hr=function(){return this.options.xhtml?`<hr/>
`:`<hr>
`},Se.list=function(ee,ue,pe){var me=ue?"ol":"ul",Ie=ue&&pe!==1?' start="'+pe+'"':"";return"<"+me+Ie+`>
`+ee+"</"+me+`>
`},Se.listitem=function(ee){return"<li>"+ee+`</li>
`},Se.checkbox=function(ee){return"<input "+(ee?'checked="" ':"")+'disabled="" type="checkbox"'+(this.options.xhtml?" /":"")+"> "},Se.paragraph=function(ee){return"<p>"+ee+`</p>
`},Se.table=function(ee,ue){return ue&&(ue="<tbody>"+ue+"</tbody>"),`<table>
<thead>
`+ee+`</thead>
`+ue+`</table>
`},Se.tablerow=function(ee){return`<tr>
`+ee+`</tr>
`},Se.tablecell=function(ee,ue){var pe=ue.header?"th":"td",me=ue.align?"<"+pe+' align="'+ue.align+'">':"<"+pe+">";return me+ee+"</"+pe+`>
`},Se.strong=function(ee){return"<strong>"+ee+"</strong>"},Se.em=function(ee){return"<em>"+ee+"</em>"},Se.codespan=function(ee){return"<code>"+ee+"</code>"},Se.br=function(){return this.options.xhtml?"<br/>":"<br>"},Se.del=function(ee){return"<del>"+ee+"</del>"},Se.link=function(ee,ue,pe){if(ee=ae(this.options.sanitize,this.options.baseUrl,ee),ee===null)return pe;var me='<a href="'+q(ee)+'"';return ue&&(me+=' title="'+ue+'"'),me+=">"+pe+"</a>",me},Se.image=function(ee,ue,pe){if(ee=ae(this.options.sanitize,this.options.baseUrl,ee),ee===null)return pe;var me='<img src="'+ee+'" alt="'+pe+'"';return ue&&(me+=' title="'+ue+'"'),me+=this.options.xhtml?"/>":">",me},Se.text=function(ee){return ee},Pe}(),he=function(){function Pe(){}var Se=Pe.prototype;return Se.strong=function(ee){return ee},Se.em=function(ee){return ee},Se.codespan=function(ee){return ee},Se.del=function(ee){return ee},Se.html=function(ee){return ee},Se.text=function(ee){return ee},Se.link=function(ee,ue,pe){return""+pe},Se.image=function(ee,ue,pe){return""+pe},Se.br=function(){return""},Pe}(),Te=function(){function Pe(){this.seen={}}var Se=Pe.prototype;return Se.serialize=function(ee){return ee.toLowerCase().trim().replace(/<[!\/a-z].*?>/ig,"").replace(/[\u2000-\u206F\u2E00-\u2E7F\\'!"#$%&()*+,./:;<=>?@[\]^`{|}~]/g,"").replace(/\s/g,"-")},Se.getNextSafeSlug=function(ee,ue){var pe=ee,me=0;if(this.seen.hasOwnProperty(pe)){me=this.seen[ee];do me++,pe=ee+"-"+me;while(this.seen.hasOwnProperty(pe))}return ue||(this.seen[ee]=me,this.seen[pe]=0),pe},Se.slug=function(ee,ue){ue===void 0&&(ue={});var pe=this.serialize(ee);return this.getNextSafeSlug(pe,ue.dryrun)},Pe}(),Ue=se,He=he,Ke=Te,ye=R.exports.defaults,nt=A.unescape,H=function(){function Pe(De){this.options=De||ye,this.options.renderer=this.options.renderer||new Ue,this.renderer=this.options.renderer,this.renderer.options=this.options,this.textRenderer=new He,this.slugger=new Ke}Pe.parse=function(ee,ue){var pe=new Pe(ue);return pe.parse(ee)},Pe.parseInline=function(ee,ue){var pe=new Pe(ue);return pe.parseInline(ee)};var Se=Pe.prototype;return Se.parse=function(ee,ue){ue===void 0&&(ue=!0);var pe="",me,Ie,Be,Ne,je,et,Le,de,ge,X,W,be,ke,Je,$e,ut,gt,at,dt,ot=ee.length;for(me=0;me<ot;me++){if(X=ee[me],this.options.extensions&&this.options.extensions.renderers&&this.options.extensions.renderers[X.type]&&(dt=this.options.extensions.renderers[X.type].call({parser:this},X),dt!==!1||!["space","hr","heading","code","table","blockquote","list","html","paragraph","text"].includes(X.type))){pe+=dt||"";continue}switch(X.type){case"space":continue;case"hr":{pe+=this.renderer.hr();continue}case"heading":{pe+=this.renderer.heading(this.parseInline(X.tokens),X.depth,nt(this.parseInline(X.tokens,this.textRenderer)),this.slugger);continue}case"code":{pe+=this.renderer.code(X.text,X.lang,X.escaped);continue}case"table":{for(de="",Le="",Ne=X.header.length,Ie=0;Ie<Ne;Ie++)Le+=this.renderer.tablecell(this.parseInline(X.header[Ie].tokens),{header:!0,align:X.align[Ie]});for(de+=this.renderer.tablerow(Le),ge="",Ne=X.rows.length,Ie=0;Ie<Ne;Ie++){for(et=X.rows[Ie],Le="",je=et.length,Be=0;Be<je;Be++)Le+=this.renderer.tablecell(this.parseInline(et[Be].tokens),{header:!1,align:X.align[Be]});ge+=this.renderer.tablerow(Le)}pe+=this.renderer.table(de,ge);continue}case"blockquote":{ge=this.parse(X.tokens),pe+=this.renderer.blockquote(ge);continue}case"list":{for(W=X.ordered,be=X.start,ke=X.loose,Ne=X.items.length,ge="",Ie=0;Ie<Ne;Ie++)$e=X.items[Ie],ut=$e.checked,gt=$e.task,Je="",$e.task&&(at=this.renderer.checkbox(ut),ke?$e.tokens.length>0&&$e.tokens[0].type==="paragraph"?($e.tokens[0].text=at+" "+$e.tokens[0].text,$e.tokens[0].tokens&&$e.tokens[0].tokens.length>0&&$e.tokens[0].tokens[0].type==="text"&&($e.tokens[0].tokens[0].text=at+" "+$e.tokens[0].tokens[0].text)):$e.tokens.unshift({type:"text",text:at}):Je+=at),Je+=this.parse($e.tokens,ke),ge+=this.renderer.listitem(Je,gt,ut);pe+=this.renderer.list(ge,W,be);continue}case"html":{pe+=this.renderer.html(X.text);continue}case"paragraph":{pe+=this.renderer.paragraph(this.parseInline(X.tokens));continue}case"text":{for(ge=X.tokens?this.parseInline(X.tokens):X.text;me+1<ot&&ee[me+1].type==="text";)X=ee[++me],ge+=`
`+(X.tokens?this.parseInline(X.tokens):X.text);pe+=ue?this.renderer.paragraph(ge):ge;continue}default:{var pt='Token with "'+X.type+'" type was not found.';if(this.options.silent){console.error(pt);return}else throw new Error(pt)}}}return pe},Se.parseInline=function(ee,ue){ue=ue||this.renderer;var pe="",me,Ie,Be,Ne=ee.length;for(me=0;me<Ne;me++){if(Ie=ee[me],this.options.extensions&&this.options.extensions.renderers&&this.options.extensions.renderers[Ie.type]&&(Be=this.options.extensions.renderers[Ie.type].call({parser:this},Ie),Be!==!1||!["escape","html","link","image","strong","em","codespan","br","del","text"].includes(Ie.type))){pe+=Be||"";continue}switch(Ie.type){case"escape":{pe+=ue.text(Ie.text);break}case"html":{pe+=ue.html(Ie.text);break}case"link":{pe+=ue.link(Ie.href,Ie.title,this.parseInline(Ie.tokens,ue));break}case"image":{pe+=ue.image(Ie.href,Ie.title,Ie.text);break}case"strong":{pe+=ue.strong(this.parseInline(Ie.tokens,ue));break}case"em":{pe+=ue.em(this.parseInline(Ie.tokens,ue));break}case"codespan":{pe+=ue.codespan(Ie.text);break}case"br":{pe+=ue.br();break}case"del":{pe+=ue.del(this.parseInline(Ie.tokens,ue));break}case"text":{pe+=ue.text(Ie.text);break}default:{var je='Token with "'+Ie.type+'" type was not found.';if(this.options.silent){console.error(je);return}else throw new Error(je)}}}return pe},Pe}(),J=Q,fe=H,xe=z,Qe=se,rt=he,ct=Te,ft=A.merge,Pt=A.checkSanitizeDeprecation,mt=A.escape,Dt=R.exports.getDefaults,kt=R.exports.changeDefaults,vt=R.exports.defaults;function Xe(Pe,Se,De){if(typeof Pe=="undefined"||Pe===null)throw new Error("marked(): input parameter is undefined or null");if(typeof Pe!="string")throw new Error("marked(): input parameter is of type "+Object.prototype.toString.call(Pe)+", string expected");if(typeof Se=="function"&&(De=Se,Se=null),Se=ft({},Xe.defaults,Se||{}),Pt(Se),De){var ee=Se.highlight,ue;try{ue=J.lex(Pe,Se)}catch(Be){return De(Be)}var pe=function(Ne){var je;if(!Ne)try{Se.walkTokens&&Xe.walkTokens(ue,Se.walkTokens),je=fe.parse(ue,Se)}catch(et){Ne=et}return Se.highlight=ee,Ne?De(Ne):De(null,je)};if(!ee||ee.length<3||(delete Se.highlight,!ue.length))return pe();var me=0;Xe.walkTokens(ue,function(Be){Be.type==="code"&&(me++,setTimeout(function(){ee(Be.text,Be.lang,function(Ne,je){if(Ne)return pe(Ne);je!=null&&je!==Be.text&&(Be.text=je,Be.escaped=!0),me--,me===0&&pe()})},0))}),me===0&&pe();return}try{var Ie=J.lex(Pe,Se);return Se.walkTokens&&Xe.walkTokens(Ie,Se.walkTokens),fe.parse(Ie,Se)}catch(Be){if(Be.message+=`
Please report this to https://github.com/markedjs/marked.`,Se.silent)return"<p>An error occurred:</p><pre>"+mt(Be.message+"",!0)+"</pre>";throw Be}}Xe.options=Xe.setOptions=function(Pe){return ft(Xe.defaults,Pe),kt(Xe.defaults),Xe},Xe.getDefaults=Dt,Xe.defaults=vt,Xe.use=function(){for(var Pe=this,Se=arguments.length,De=new Array(Se),ee=0;ee<Se;ee++)De[ee]=arguments[ee];var ue=ft.apply(void 0,[{}].concat(De)),pe=Xe.defaults.extensions||{renderers:{},childTokens:{}},me;De.forEach(function(Ie){if(Ie.extensions&&(me=!0,Ie.extensions.forEach(function(Ne){if(!Ne.name)throw new Error("extension name required");if(Ne.renderer){var je=pe.renderers?pe.renderers[Ne.name]:null;je?pe.renderers[Ne.name]=function(){for(var et=arguments.length,Le=new Array(et),de=0;de<et;de++)Le[de]=arguments[de];var ge=Ne.renderer.apply(this,Le);return ge===!1&&(ge=je.apply(this,Le)),ge}:pe.renderers[Ne.name]=Ne.renderer}if(Ne.tokenizer){if(!Ne.level||Ne.level!=="block"&&Ne.level!=="inline")throw new Error("extension level must be 'block' or 'inline'");pe[Ne.level]?pe[Ne.level].unshift(Ne.tokenizer):pe[Ne.level]=[Ne.tokenizer],Ne.start&&(Ne.level==="block"?pe.startBlock?pe.startBlock.push(Ne.start):pe.startBlock=[Ne.start]:Ne.level==="inline"&&(pe.startInline?pe.startInline.push(Ne.start):pe.startInline=[Ne.start]))}Ne.childTokens&&(pe.childTokens[Ne.name]=Ne.childTokens)})),Ie.renderer&&function(){var Ne=Xe.defaults.renderer||new Qe,je=function(de){var ge=Ne[de];Ne[de]=function(){for(var X=arguments.length,W=new Array(X),be=0;be<X;be++)W[be]=arguments[be];var ke=Ie.renderer[de].apply(Ne,W);return ke===!1&&(ke=ge.apply(Ne,W)),ke}};for(var et in Ie.renderer)je(et);ue.renderer=Ne}(),Ie.tokenizer&&function(){var Ne=Xe.defaults.tokenizer||new xe,je=function(de){var ge=Ne[de];Ne[de]=function(){for(var X=arguments.length,W=new Array(X),be=0;be<X;be++)W[be]=arguments[be];var ke=Ie.tokenizer[de].apply(Ne,W);return ke===!1&&(ke=ge.apply(Ne,W)),ke}};for(var et in Ie.tokenizer)je(et);ue.tokenizer=Ne}(),Ie.walkTokens){var Be=Xe.defaults.walkTokens;ue.walkTokens=function(Ne){Ie.walkTokens.call(Pe,Ne),Be&&Be(Ne)}}me&&(ue.extensions=pe),Xe.setOptions(ue)})},Xe.walkTokens=function(Pe,Se){for(var De=function(){var me=ue.value;switch(Se(me),me.type){case"table":{for(var Ie=b(me.header),Be;!(Be=Ie()).done;){var Ne=Be.value;Xe.walkTokens(Ne.tokens,Se)}for(var je=b(me.rows),et;!(et=je()).done;)for(var Le=et.value,de=b(Le),ge;!(ge=de()).done;){var X=ge.value;Xe.walkTokens(X.tokens,Se)}break}case"list":{Xe.walkTokens(me.items,Se);break}default:Xe.defaults.extensions&&Xe.defaults.extensions.childTokens&&Xe.defaults.extensions.childTokens[me.type]?Xe.defaults.extensions.childTokens[me.type].forEach(function(W){Xe.walkTokens(me[W],Se)}):me.tokens&&Xe.walkTokens(me.tokens,Se)}},ee=b(Pe),ue;!(ue=ee()).done;)De()},Xe.parseInline=function(Pe,Se){if(typeof Pe=="undefined"||Pe===null)throw new Error("marked.parseInline(): input parameter is undefined or null");if(typeof Pe!="string")throw new Error("marked.parseInline(): input parameter is of type "+Object.prototype.toString.call(Pe)+", string expected");Se=ft({},Xe.defaults,Se||{}),Pt(Se);try{var De=J.lexInline(Pe,Se);return Se.walkTokens&&Xe.walkTokens(De,Se.walkTokens),fe.parseInline(De,Se)}catch(ee){if(ee.message+=`
Please report this to https://github.com/markedjs/marked.`,Se.silent)return"<p>An error occurred:</p><pre>"+mt(ee.message+"",!0)+"</pre>";throw ee}},Xe.Parser=fe,Xe.parser=fe.parse,Xe.Renderer=Qe,Xe.TextRenderer=rt,Xe.Lexer=J,Xe.lexer=J.lex,Xe.Tokenizer=xe,Xe.Slugger=ct,Xe.parse=Xe;var _t=Xe;return _t}),define(we[75],Ee([0,1]),function(re,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.MovingAverage=e.Counter=e.rot=e.clamp=void 0;function c(F,C,_){return Math.min(Math.max(F,C),_)}e.clamp=c;function M(F,C){return(C+F%C)%C}e.rot=M;class b{constructor(){this._next=0}getNext(){return this._next++}}e.Counter=b;class R{constructor(){this._n=1,this._val=0}update(C){return this._val=this._val+(C-this._val)/this._n,this._n+=1,this}get value(){return this._val}}e.MovingAverage=R}),function(){function re(b){const R=[];typeof b=="number"&&R.push("code/timeOrigin",b);function F(_){R.push(_,Date.now())}function C(){const _=[];for(let P=0;P<R.length;P+=2)_.push({name:R[P],startTime:R[P+1]});return _}return{mark:F,getMarks:C}}function e(){if(typeof performance=="object"&&typeof performance.mark=="function")return typeof performance.timeOrigin!="number"&&!performance.timing?re():{mark(b){performance.mark(b)},getMarks(){let b=performance.timeOrigin;typeof b!="number"&&(b=performance.timing.navigationStart||performance.timing.redirectStart||performance.timing.fetchStart);const R=[{name:"code/timeOrigin",startTime:Math.round(b)}];for(const F of performance.getEntriesByType("mark"))R.push({name:F.name,startTime:Math.round(b+F.startTime)});return R}};if(typeof process=="object"){const b=Math.round((require.nodeRequire||require)("perf_hooks").performance.timeOrigin);return re(b)}else return console.trace("perf-util loaded in UNKNOWN environment"),re()}function c(b){return b.MonacoPerformanceMarks||(b.MonacoPerformanceMarks=e()),b.MonacoPerformanceMarks}var M;typeof global=="object"?M=global:typeof self=="object"?M=self:M={},typeof define=="function"?define("vs/base/common/performance",[],function(){return c(M)}):typeof module=="object"&&typeof module.exports=="object"?module.exports=c(M):(console.trace("perf-util defined in UNKNOWN context (neither requirejs or commonjs)"),M.perf=c(M))}(),define(we[104],Ee([0,1]),function(re,e){"use strict";var c;Object.defineProperty(e,"__esModule",{value:!0}),e.SkipList=void 0;class M{constructor(C,_,P){this.level=C,this.key=_,this.value=P,this.forward=[]}}const b=void 0;class R{constructor(C,_=2**16){this.comparator=C,this[c]="SkipList",this._level=0,this._size=0,this._maxLevel=Math.max(1,Math.log2(_)|0),this._header=new M(this._maxLevel,b,b)}get size(){return this._size}clear(){this._header=new M(this._maxLevel,b,b)}has(C){return Boolean(R._search(this,C,this.comparator))}get(C){return R._search(this,C,this.comparator)?.value}set(C,_){return R._insert(this,C,_,this.comparator)&&(this._size+=1),this}delete(C){const _=R._delete(this,C,this.comparator);return _&&(this._size-=1),_}forEach(C,_){let P=this._header.forward[0];for(;P;)C.call(_,P.value,P.key,this),P=P.forward[0]}[(c=Symbol.toStringTag,Symbol.iterator)](){return this.entries()}*entries(){let C=this._header.forward[0];for(;C;)yield[C.key,C.value],C=C.forward[0]}*keys(){let C=this._header.forward[0];for(;C;)yield C.key,C=C.forward[0]}*values(){let C=this._header.forward[0];for(;C;)yield C.value,C=C.forward[0]}toString(){let C="[SkipList]:",_=this._header.forward[0];for(;_;)C+=`node(${_.key}, ${_.value}, lvl:${_.level})`,_=_.forward[0];return C}static _search(C,_,P){let t=C._header;for(let E=C._level-1;E>=0;E--)for(;t.forward[E]&&P(t.forward[E].key,_)<0;)t=t.forward[E];if(t=t.forward[0],t&&P(t.key,_)===0)return t}static _insert(C,_,P,t){let E=[],n=C._header;for(let f=C._level-1;f>=0;f--){for(;n.forward[f]&&t(n.forward[f].key,_)<0;)n=n.forward[f];E[f]=n}if(n=n.forward[0],n&&t(n.key,_)===0)return n.value=P,!1;{let f=R._randomLevel(C);if(f>C._level){for(let a=C._level;a<f;a++)E[a]=C._header;C._level=f}n=new M(f,_,P);for(let a=0;a<f;a++)n.forward[a]=E[a].forward[a],E[a].forward[a]=n;return!0}}static _randomLevel(C,_=.5){let P=1;for(;Math.random()<_&&P<C._maxLevel;)P+=1;return P}static _delete(C,_,P){let t=[],E=C._header;for(let n=C._level-1;n>=0;n--){for(;E.forward[n]&&P(E.forward[n].key,_)<0;)E=E.forward[n];t[n]=E}if(E=E.forward[0],!E||P(E.key,_)!==0)return!1;for(let n=0;n<C._level&&t[n].forward[n]===E;n++)t[n].forward[n]=E.forward[n];for(;C._level>0&&C._header.forward[C._level-1]===b;)C._level-=1;return!0}}e.SkipList=R}),define(we[34],Ee([0,1,3]),function(re,e,c){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.CSSIcon=e.getClassNamesArray=e.Codicon=e.getCodiconAriaLabel=e.registerCodicon=e.iconRegistry=void 0;class M{constructor(){this._icons=new Map,this._onDidRegister=new c.Emitter}add(E){const n=this._icons.get(E.id);n?E.description?n.description=E.description:console.error(`Duplicate registration of codicon ${E.id}`):(this._icons.set(E.id,E),this._onDidRegister.fire(E))}get(E){return this._icons.get(E)}get all(){return this._icons.values()}get onDidRegister(){return this._onDidRegister.event}}const b=new M;e.iconRegistry=b;function R(t,E){return new C(t,E)}e.registerCodicon=R;function F(t){return t?t.replace(/\$\((.*?)\)/g,(E,n)=>` ${n} `).trim():""}e.getCodiconAriaLabel=F;class C{constructor(E,n,f){this.id=E,this.definition=n,this.description=f,b.add(this)}get classNames(){return"codicon codicon-"+this.id}get classNamesArray(){return["codicon","codicon-"+this.id]}get cssSelector(){return".codicon.codicon-"+this.id}}e.Codicon=C;function _(t,E){const n=["codicon","codicon-"+t];return E&&n.push("codicon-modifier-"+E),n}e.getClassNamesArray=_;var P;(function(t){t.iconNameSegment="[A-Za-z0-9]+",t.iconNameExpression="[A-Za-z0-9\\-]+",t.iconModifierExpression="~[A-Za-z]+";const E=new RegExp(`^(${t.iconNameExpression})(${t.iconModifierExpression})?$`);function n(l){if(l instanceof C)return["codicon","codicon-"+l.id];const w=E.exec(l.id);if(!w)return n(C.error);let[,I,S]=w;const o=["codicon","codicon-"+I];return S&&o.push("codicon-modifier-"+S.substr(1)),o}t.asClassNameArray=n;function f(l){return n(l).join(" ")}t.asClassName=f;function a(l){return"."+n(l).join(".")}t.asCSSSelector=a})(P=e.CSSIcon||(e.CSSIcon={})),function(t){t.add=new t("add",{fontCharacter:"\\ea60"}),t.plus=new t("plus",{fontCharacter:"\\ea60"}),t.gistNew=new t("gist-new",{fontCharacter:"\\ea60"}),t.repoCreate=new t("repo-create",{fontCharacter:"\\ea60"}),t.lightbulb=new t("lightbulb",{fontCharacter:"\\ea61"}),t.lightBulb=new t("light-bulb",{fontCharacter:"\\ea61"}),t.repo=new t("repo",{fontCharacter:"\\ea62"}),t.repoDelete=new t("repo-delete",{fontCharacter:"\\ea62"}),t.gistFork=new t("gist-fork",{fontCharacter:"\\ea63"}),t.repoForked=new t("repo-forked",{fontCharacter:"\\ea63"}),t.gitPullRequest=new t("git-pull-request",{fontCharacter:"\\ea64"}),t.gitPullRequestAbandoned=new t("git-pull-request-abandoned",{fontCharacter:"\\ea64"}),t.recordKeys=new t("record-keys",{fontCharacter:"\\ea65"}),t.keyboard=new t("keyboard",{fontCharacter:"\\ea65"}),t.tag=new t("tag",{fontCharacter:"\\ea66"}),t.tagAdd=new t("tag-add",{fontCharacter:"\\ea66"}),t.tagRemove=new t("tag-remove",{fontCharacter:"\\ea66"}),t.person=new t("person",{fontCharacter:"\\ea67"}),t.personFollow=new t("person-follow",{fontCharacter:"\\ea67"}),t.personOutline=new t("person-outline",{fontCharacter:"\\ea67"}),t.personFilled=new t("person-filled",{fontCharacter:"\\ea67"}),t.gitBranch=new t("git-branch",{fontCharacter:"\\ea68"}),t.gitBranchCreate=new t("git-branch-create",{fontCharacter:"\\ea68"}),t.gitBranchDelete=new t("git-branch-delete",{fontCharacter:"\\ea68"}),t.sourceControl=new t("source-control",{fontCharacter:"\\ea68"}),t.mirror=new t("mirror",{fontCharacter:"\\ea69"}),t.mirrorPublic=new t("mirror-public",{fontCharacter:"\\ea69"}),t.star=new t("star",{fontCharacter:"\\ea6a"}),t.starAdd=new t("star-add",{fontCharacter:"\\ea6a"}),t.starDelete=new t("star-delete",{fontCharacter:"\\ea6a"}),t.starEmpty=new t("star-empty",{fontCharacter:"\\ea6a"}),t.comment=new t("comment",{fontCharacter:"\\ea6b"}),t.commentAdd=new t("comment-add",{fontCharacter:"\\ea6b"}),t.alert=new t("alert",{fontCharacter:"\\ea6c"}),t.warning=new t("warning",{fontCharacter:"\\ea6c"}),t.search=new t("search",{fontCharacter:"\\ea6d"}),t.searchSave=new t("search-save",{fontCharacter:"\\ea6d"}),t.logOut=new t("log-out",{fontCharacter:"\\ea6e"}),t.signOut=new t("sign-out",{fontCharacter:"\\ea6e"}),t.logIn=new t("log-in",{fontCharacter:"\\ea6f"}),t.signIn=new t("sign-in",{fontCharacter:"\\ea6f"}),t.eye=new t("eye",{fontCharacter:"\\ea70"}),t.eyeUnwatch=new t("eye-unwatch",{fontCharacter:"\\ea70"}),t.eyeWatch=new t("eye-watch",{fontCharacter:"\\ea70"}),t.circleFilled=new t("circle-filled",{fontCharacter:"\\ea71"}),t.primitiveDot=new t("primitive-dot",{fontCharacter:"\\ea71"}),t.closeDirty=new t("close-dirty",{fontCharacter:"\\ea71"}),t.debugBreakpoint=new t("debug-breakpoint",{fontCharacter:"\\ea71"}),t.debugBreakpointDisabled=new t("debug-breakpoint-disabled",{fontCharacter:"\\ea71"}),t.debugHint=new t("debug-hint",{fontCharacter:"\\ea71"}),t.primitiveSquare=new t("primitive-square",{fontCharacter:"\\ea72"}),t.edit=new t("edit",{fontCharacter:"\\ea73"}),t.pencil=new t("pencil",{fontCharacter:"\\ea73"}),t.info=new t("info",{fontCharacter:"\\ea74"}),t.issueOpened=new t("issue-opened",{fontCharacter:"\\ea74"}),t.gistPrivate=new t("gist-private",{fontCharacter:"\\ea75"}),t.gitForkPrivate=new t("git-fork-private",{fontCharacter:"\\ea75"}),t.lock=new t("lock",{fontCharacter:"\\ea75"}),t.mirrorPrivate=new t("mirror-private",{fontCharacter:"\\ea75"}),t.close=new t("close",{fontCharacter:"\\ea76"}),t.removeClose=new t("remove-close",{fontCharacter:"\\ea76"}),t.x=new t("x",{fontCharacter:"\\ea76"}),t.repoSync=new t("repo-sync",{fontCharacter:"\\ea77"}),t.sync=new t("sync",{fontCharacter:"\\ea77"}),t.clone=new t("clone",{fontCharacter:"\\ea78"}),t.desktopDownload=new t("desktop-download",{fontCharacter:"\\ea78"}),t.beaker=new t("beaker",{fontCharacter:"\\ea79"}),t.microscope=new t("microscope",{fontCharacter:"\\ea79"}),t.vm=new t("vm",{fontCharacter:"\\ea7a"}),t.deviceDesktop=new t("device-desktop",{fontCharacter:"\\ea7a"}),t.file=new t("file",{fontCharacter:"\\ea7b"}),t.fileText=new t("file-text",{fontCharacter:"\\ea7b"}),t.more=new t("more",{fontCharacter:"\\ea7c"}),t.ellipsis=new t("ellipsis",{fontCharacter:"\\ea7c"}),t.kebabHorizontal=new t("kebab-horizontal",{fontCharacter:"\\ea7c"}),t.mailReply=new t("mail-reply",{fontCharacter:"\\ea7d"}),t.reply=new t("reply",{fontCharacter:"\\ea7d"}),t.organization=new t("organization",{fontCharacter:"\\ea7e"}),t.organizationFilled=new t("organization-filled",{fontCharacter:"\\ea7e"}),t.organizationOutline=new t("organization-outline",{fontCharacter:"\\ea7e"}),t.newFile=new t("new-file",{fontCharacter:"\\ea7f"}),t.fileAdd=new t("file-add",{fontCharacter:"\\ea7f"}),t.newFolder=new t("new-folder",{fontCharacter:"\\ea80"}),t.fileDirectoryCreate=new t("file-directory-create",{fontCharacter:"\\ea80"}),t.trash=new t("trash",{fontCharacter:"\\ea81"}),t.trashcan=new t("trashcan",{fontCharacter:"\\ea81"}),t.history=new t("history",{fontCharacter:"\\ea82"}),t.clock=new t("clock",{fontCharacter:"\\ea82"}),t.folder=new t("folder",{fontCharacter:"\\ea83"}),t.fileDirectory=new t("file-directory",{fontCharacter:"\\ea83"}),t.symbolFolder=new t("symbol-folder",{fontCharacter:"\\ea83"}),t.logoGithub=new t("logo-github",{fontCharacter:"\\ea84"}),t.markGithub=new t("mark-github",{fontCharacter:"\\ea84"}),t.github=new t("github",{fontCharacter:"\\ea84"}),t.terminal=new t("terminal",{fontCharacter:"\\ea85"}),t.console=new t("console",{fontCharacter:"\\ea85"}),t.repl=new t("repl",{fontCharacter:"\\ea85"}),t.zap=new t("zap",{fontCharacter:"\\ea86"}),t.symbolEvent=new t("symbol-event",{fontCharacter:"\\ea86"}),t.error=new t("error",{fontCharacter:"\\ea87"}),t.stop=new t("stop",{fontCharacter:"\\ea87"}),t.variable=new t("variable",{fontCharacter:"\\ea88"}),t.symbolVariable=new t("symbol-variable",{fontCharacter:"\\ea88"}),t.array=new t("array",{fontCharacter:"\\ea8a"}),t.symbolArray=new t("symbol-array",{fontCharacter:"\\ea8a"}),t.symbolModule=new t("symbol-module",{fontCharacter:"\\ea8b"}),t.symbolPackage=new t("symbol-package",{fontCharacter:"\\ea8b"}),t.symbolNamespace=new t("symbol-namespace",{fontCharacter:"\\ea8b"}),t.symbolObject=new t("symbol-object",{fontCharacter:"\\ea8b"}),t.symbolMethod=new t("symbol-method",{fontCharacter:"\\ea8c"}),t.symbolFunction=new t("symbol-function",{fontCharacter:"\\ea8c"}),t.symbolConstructor=new t("symbol-constructor",{fontCharacter:"\\ea8c"}),t.symbolBoolean=new t("symbol-boolean",{fontCharacter:"\\ea8f"}),t.symbolNull=new t("symbol-null",{fontCharacter:"\\ea8f"}),t.symbolNumeric=new t("symbol-numeric",{fontCharacter:"\\ea90"}),t.symbolNumber=new t("symbol-number",{fontCharacter:"\\ea90"}),t.symbolStructure=new t("symbol-structure",{fontCharacter:"\\ea91"}),t.symbolStruct=new t("symbol-struct",{fontCharacter:"\\ea91"}),t.symbolParameter=new t("symbol-parameter",{fontCharacter:"\\ea92"}),t.symbolTypeParameter=new t("symbol-type-parameter",{fontCharacter:"\\ea92"}),t.symbolKey=new t("symbol-key",{fontCharacter:"\\ea93"}),t.symbolText=new t("symbol-text",{fontCharacter:"\\ea93"}),t.symbolReference=new t("symbol-reference",{fontCharacter:"\\ea94"}),t.goToFile=new t("go-to-file",{fontCharacter:"\\ea94"}),t.symbolEnum=new t("symbol-enum",{fontCharacter:"\\ea95"}),t.symbolValue=new t("symbol-value",{fontCharacter:"\\ea95"}),t.symbolRuler=new t("symbol-ruler",{fontCharacter:"\\ea96"}),t.symbolUnit=new t("symbol-unit",{fontCharacter:"\\ea96"}),t.activateBreakpoints=new t("activate-breakpoints",{fontCharacter:"\\ea97"}),t.archive=new t("archive",{fontCharacter:"\\ea98"}),t.arrowBoth=new t("arrow-both",{fontCharacter:"\\ea99"}),t.arrowDown=new t("arrow-down",{fontCharacter:"\\ea9a"}),t.arrowLeft=new t("arrow-left",{fontCharacter:"\\ea9b"}),t.arrowRight=new t("arrow-right",{fontCharacter:"\\ea9c"}),t.arrowSmallDown=new t("arrow-small-down",{fontCharacter:"\\ea9d"}),t.arrowSmallLeft=new t("arrow-small-left",{fontCharacter:"\\ea9e"}),t.arrowSmallRight=new t("arrow-small-right",{fontCharacter:"\\ea9f"}),t.arrowSmallUp=new t("arrow-small-up",{fontCharacter:"\\eaa0"}),t.arrowUp=new t("arrow-up",{fontCharacter:"\\eaa1"}),t.bell=new t("bell",{fontCharacter:"\\eaa2"}),t.bold=new t("bold",{fontCharacter:"\\eaa3"}),t.book=new t("book",{fontCharacter:"\\eaa4"}),t.bookmark=new t("bookmark",{fontCharacter:"\\eaa5"}),t.debugBreakpointConditionalUnverified=new t("debug-breakpoint-conditional-unverified",{fontCharacter:"\\eaa6"}),t.debugBreakpointConditional=new t("debug-breakpoint-conditional",{fontCharacter:"\\eaa7"}),t.debugBreakpointConditionalDisabled=new t("debug-breakpoint-conditional-disabled",{fontCharacter:"\\eaa7"}),t.debugBreakpointDataUnverified=new t("debug-breakpoint-data-unverified",{fontCharacter:"\\eaa8"}),t.debugBreakpointData=new t("debug-breakpoint-data",{fontCharacter:"\\eaa9"}),t.debugBreakpointDataDisabled=new t("debug-breakpoint-data-disabled",{fontCharacter:"\\eaa9"}),t.debugBreakpointLogUnverified=new t("debug-breakpoint-log-unverified",{fontCharacter:"\\eaaa"}),t.debugBreakpointLog=new t("debug-breakpoint-log",{fontCharacter:"\\eaab"}),t.debugBreakpointLogDisabled=new t("debug-breakpoint-log-disabled",{fontCharacter:"\\eaab"}),t.briefcase=new t("briefcase",{fontCharacter:"\\eaac"}),t.broadcast=new t("broadcast",{fontCharacter:"\\eaad"}),t.browser=new t("browser",{fontCharacter:"\\eaae"}),t.bug=new t("bug",{fontCharacter:"\\eaaf"}),t.calendar=new t("calendar",{fontCharacter:"\\eab0"}),t.caseSensitive=new t("case-sensitive",{fontCharacter:"\\eab1"}),t.check=new t("check",{fontCharacter:"\\eab2"}),t.checklist=new t("checklist",{fontCharacter:"\\eab3"}),t.chevronDown=new t("chevron-down",{fontCharacter:"\\eab4"}),t.chevronLeft=new t("chevron-left",{fontCharacter:"\\eab5"}),t.chevronRight=new t("chevron-right",{fontCharacter:"\\eab6"}),t.chevronUp=new t("chevron-up",{fontCharacter:"\\eab7"}),t.chromeClose=new t("chrome-close",{fontCharacter:"\\eab8"}),t.chromeMaximize=new t("chrome-maximize",{fontCharacter:"\\eab9"}),t.chromeMinimize=new t("chrome-minimize",{fontCharacter:"\\eaba"}),t.chromeRestore=new t("chrome-restore",{fontCharacter:"\\eabb"}),t.circleOutline=new t("circle-outline",{fontCharacter:"\\eabc"}),t.debugBreakpointUnverified=new t("debug-breakpoint-unverified",{fontCharacter:"\\eabc"}),t.circleSlash=new t("circle-slash",{fontCharacter:"\\eabd"}),t.circuitBoard=new t("circuit-board",{fontCharacter:"\\eabe"}),t.clearAll=new t("clear-all",{fontCharacter:"\\eabf"}),t.clippy=new t("clippy",{fontCharacter:"\\eac0"}),t.closeAll=new t("close-all",{fontCharacter:"\\eac1"}),t.cloudDownload=new t("cloud-download",{fontCharacter:"\\eac2"}),t.cloudUpload=new t("cloud-upload",{fontCharacter:"\\eac3"}),t.code=new t("code",{fontCharacter:"\\eac4"}),t.collapseAll=new t("collapse-all",{fontCharacter:"\\eac5"}),t.colorMode=new t("color-mode",{fontCharacter:"\\eac6"}),t.commentDiscussion=new t("comment-discussion",{fontCharacter:"\\eac7"}),t.compareChanges=new t("compare-changes",{fontCharacter:"\\eafd"}),t.creditCard=new t("credit-card",{fontCharacter:"\\eac9"}),t.dash=new t("dash",{fontCharacter:"\\eacc"}),t.dashboard=new t("dashboard",{fontCharacter:"\\eacd"}),t.database=new t("database",{fontCharacter:"\\eace"}),t.debugContinue=new t("debug-continue",{fontCharacter:"\\eacf"}),t.debugDisconnect=new t("debug-disconnect",{fontCharacter:"\\ead0"}),t.debugPause=new t("debug-pause",{fontCharacter:"\\ead1"}),t.debugRestart=new t("debug-restart",{fontCharacter:"\\ead2"}),t.debugStart=new t("debug-start",{fontCharacter:"\\ead3"}),t.debugStepInto=new t("debug-step-into",{fontCharacter:"\\ead4"}),t.debugStepOut=new t("debug-step-out",{fontCharacter:"\\ead5"}),t.debugStepOver=new t("debug-step-over",{fontCharacter:"\\ead6"}),t.debugStop=new t("debug-stop",{fontCharacter:"\\ead7"}),t.debug=new t("debug",{fontCharacter:"\\ead8"}),t.deviceCameraVideo=new t("device-camera-video",{fontCharacter:"\\ead9"}),t.deviceCamera=new t("device-camera",{fontCharacter:"\\eada"}),t.deviceMobile=new t("device-mobile",{fontCharacter:"\\eadb"}),t.diffAdded=new t("diff-added",{fontCharacter:"\\eadc"}),t.diffIgnored=new t("diff-ignored",{fontCharacter:"\\eadd"}),t.diffModified=new t("diff-modified",{fontCharacter:"\\eade"}),t.diffRemoved=new t("diff-removed",{fontCharacter:"\\eadf"}),t.diffRenamed=new t("diff-renamed",{fontCharacter:"\\eae0"}),t.diff=new t("diff",{fontCharacter:"\\eae1"}),t.discard=new t("discard",{fontCharacter:"\\eae2"}),t.editorLayout=new t("editor-layout",{fontCharacter:"\\eae3"}),t.emptyWindow=new t("empty-window",{fontCharacter:"\\eae4"}),t.exclude=new t("exclude",{fontCharacter:"\\eae5"}),t.extensions=new t("extensions",{fontCharacter:"\\eae6"}),t.eyeClosed=new t("eye-closed",{fontCharacter:"\\eae7"}),t.fileBinary=new t("file-binary",{fontCharacter:"\\eae8"}),t.fileCode=new t("file-code",{fontCharacter:"\\eae9"}),t.fileMedia=new t("file-media",{fontCharacter:"\\eaea"}),t.filePdf=new t("file-pdf",{fontCharacter:"\\eaeb"}),t.fileSubmodule=new t("file-submodule",{fontCharacter:"\\eaec"}),t.fileSymlinkDirectory=new t("file-symlink-directory",{fontCharacter:"\\eaed"}),t.fileSymlinkFile=new t("file-symlink-file",{fontCharacter:"\\eaee"}),t.fileZip=new t("file-zip",{fontCharacter:"\\eaef"}),t.files=new t("files",{fontCharacter:"\\eaf0"}),t.filter=new t("filter",{fontCharacter:"\\eaf1"}),t.flame=new t("flame",{fontCharacter:"\\eaf2"}),t.foldDown=new t("fold-down",{fontCharacter:"\\eaf3"}),t.foldUp=new t("fold-up",{fontCharacter:"\\eaf4"}),t.fold=new t("fold",{fontCharacter:"\\eaf5"}),t.folderActive=new t("folder-active",{fontCharacter:"\\eaf6"}),t.folderOpened=new t("folder-opened",{fontCharacter:"\\eaf7"}),t.gear=new t("gear",{fontCharacter:"\\eaf8"}),t.gift=new t("gift",{fontCharacter:"\\eaf9"}),t.gistSecret=new t("gist-secret",{fontCharacter:"\\eafa"}),t.gist=new t("gist",{fontCharacter:"\\eafb"}),t.gitCommit=new t("git-commit",{fontCharacter:"\\eafc"}),t.gitCompare=new t("git-compare",{fontCharacter:"\\eafd"}),t.gitMerge=new t("git-merge",{fontCharacter:"\\eafe"}),t.githubAction=new t("github-action",{fontCharacter:"\\eaff"}),t.githubAlt=new t("github-alt",{fontCharacter:"\\eb00"}),t.globe=new t("globe",{fontCharacter:"\\eb01"}),t.grabber=new t("grabber",{fontCharacter:"\\eb02"}),t.graph=new t("graph",{fontCharacter:"\\eb03"}),t.gripper=new t("gripper",{fontCharacter:"\\eb04"}),t.heart=new t("heart",{fontCharacter:"\\eb05"}),t.home=new t("home",{fontCharacter:"\\eb06"}),t.horizontalRule=new t("horizontal-rule",{fontCharacter:"\\eb07"}),t.hubot=new t("hubot",{fontCharacter:"\\eb08"}),t.inbox=new t("inbox",{fontCharacter:"\\eb09"}),t.issueClosed=new t("issue-closed",{fontCharacter:"\\eba4"}),t.issueReopened=new t("issue-reopened",{fontCharacter:"\\eb0b"}),t.issues=new t("issues",{fontCharacter:"\\eb0c"}),t.italic=new t("italic",{fontCharacter:"\\eb0d"}),t.jersey=new t("jersey",{fontCharacter:"\\eb0e"}),t.json=new t("json",{fontCharacter:"\\eb0f"}),t.kebabVertical=new t("kebab-vertical",{fontCharacter:"\\eb10"}),t.key=new t("key",{fontCharacter:"\\eb11"}),t.law=new t("law",{fontCharacter:"\\eb12"}),t.lightbulbAutofix=new t("lightbulb-autofix",{fontCharacter:"\\eb13"}),t.linkExternal=new t("link-external",{fontCharacter:"\\eb14"}),t.link=new t("link",{fontCharacter:"\\eb15"}),t.listOrdered=new t("list-ordered",{fontCharacter:"\\eb16"}),t.listUnordered=new t("list-unordered",{fontCharacter:"\\eb17"}),t.liveShare=new t("live-share",{fontCharacter:"\\eb18"}),t.loading=new t("loading",{fontCharacter:"\\eb19"}),t.location=new t("location",{fontCharacter:"\\eb1a"}),t.mailRead=new t("mail-read",{fontCharacter:"\\eb1b"}),t.mail=new t("mail",{fontCharacter:"\\eb1c"}),t.markdown=new t("markdown",{fontCharacter:"\\eb1d"}),t.megaphone=new t("megaphone",{fontCharacter:"\\eb1e"}),t.mention=new t("mention",{fontCharacter:"\\eb1f"}),t.milestone=new t("milestone",{fontCharacter:"\\eb20"}),t.mortarBoard=new t("mortar-board",{fontCharacter:"\\eb21"}),t.move=new t("move",{fontCharacter:"\\eb22"}),t.multipleWindows=new t("multiple-windows",{fontCharacter:"\\eb23"}),t.mute=new t("mute",{fontCharacter:"\\eb24"}),t.noNewline=new t("no-newline",{fontCharacter:"\\eb25"}),t.note=new t("note",{fontCharacter:"\\eb26"}),t.octoface=new t("octoface",{fontCharacter:"\\eb27"}),t.openPreview=new t("open-preview",{fontCharacter:"\\eb28"}),t.package_=new t("package",{fontCharacter:"\\eb29"}),t.paintcan=new t("paintcan",{fontCharacter:"\\eb2a"}),t.pin=new t("pin",{fontCharacter:"\\eb2b"}),t.play=new t("play",{fontCharacter:"\\eb2c"}),t.run=new t("run",{fontCharacter:"\\eb2c"}),t.plug=new t("plug",{fontCharacter:"\\eb2d"}),t.preserveCase=new t("preserve-case",{fontCharacter:"\\eb2e"}),t.preview=new t("preview",{fontCharacter:"\\eb2f"}),t.project=new t("project",{fontCharacter:"\\eb30"}),t.pulse=new t("pulse",{fontCharacter:"\\eb31"}),t.question=new t("question",{fontCharacter:"\\eb32"}),t.quote=new t("quote",{fontCharacter:"\\eb33"}),t.radioTower=new t("radio-tower",{fontCharacter:"\\eb34"}),t.reactions=new t("reactions",{fontCharacter:"\\eb35"}),t.references=new t("references",{fontCharacter:"\\eb36"}),t.refresh=new t("refresh",{fontCharacter:"\\eb37"}),t.regex=new t("regex",{fontCharacter:"\\eb38"}),t.remoteExplorer=new t("remote-explorer",{fontCharacter:"\\eb39"}),t.remote=new t("remote",{fontCharacter:"\\eb3a"}),t.remove=new t("remove",{fontCharacter:"\\eb3b"}),t.replaceAll=new t("replace-all",{fontCharacter:"\\eb3c"}),t.replace=new t("replace",{fontCharacter:"\\eb3d"}),t.repoClone=new t("repo-clone",{fontCharacter:"\\eb3e"}),t.repoForcePush=new t("repo-force-push",{fontCharacter:"\\eb3f"}),t.repoPull=new t("repo-pull",{fontCharacter:"\\eb40"}),t.repoPush=new t("repo-push",{fontCharacter:"\\eb41"}),t.report=new t("report",{fontCharacter:"\\eb42"}),t.requestChanges=new t("request-changes",{fontCharacter:"\\eb43"}),t.rocket=new t("rocket",{fontCharacter:"\\eb44"}),t.rootFolderOpened=new t("root-folder-opened",{fontCharacter:"\\eb45"}),t.rootFolder=new t("root-folder",{fontCharacter:"\\eb46"}),t.rss=new t("rss",{fontCharacter:"\\eb47"}),t.ruby=new t("ruby",{fontCharacter:"\\eb48"}),t.saveAll=new t("save-all",{fontCharacter:"\\eb49"}),t.saveAs=new t("save-as",{fontCharacter:"\\eb4a"}),t.save=new t("save",{fontCharacter:"\\eb4b"}),t.screenFull=new t("screen-full",{fontCharacter:"\\eb4c"}),t.screenNormal=new t("screen-normal",{fontCharacter:"\\eb4d"}),t.searchStop=new t("search-stop",{fontCharacter:"\\eb4e"}),t.server=new t("server",{fontCharacter:"\\eb50"}),t.settingsGear=new t("settings-gear",{fontCharacter:"\\eb51"}),t.settings=new t("settings",{fontCharacter:"\\eb52"}),t.shield=new t("shield",{fontCharacter:"\\eb53"}),t.smiley=new t("smiley",{fontCharacter:"\\eb54"}),t.sortPrecedence=new t("sort-precedence",{fontCharacter:"\\eb55"}),t.splitHorizontal=new t("split-horizontal",{fontCharacter:"\\eb56"}),t.splitVertical=new t("split-vertical",{fontCharacter:"\\eb57"}),t.squirrel=new t("squirrel",{fontCharacter:"\\eb58"}),t.starFull=new t("star-full",{fontCharacter:"\\eb59"}),t.starHalf=new t("star-half",{fontCharacter:"\\eb5a"}),t.symbolClass=new t("symbol-class",{fontCharacter:"\\eb5b"}),t.symbolColor=new t("symbol-color",{fontCharacter:"\\eb5c"}),t.symbolConstant=new t("symbol-constant",{fontCharacter:"\\eb5d"}),t.symbolEnumMember=new t("symbol-enum-member",{fontCharacter:"\\eb5e"}),t.symbolField=new t("symbol-field",{fontCharacter:"\\eb5f"}),t.symbolFile=new t("symbol-file",{fontCharacter:"\\eb60"}),t.symbolInterface=new t("symbol-interface",{fontCharacter:"\\eb61"}),t.symbolKeyword=new t("symbol-keyword",{fontCharacter:"\\eb62"}),t.symbolMisc=new t("symbol-misc",{fontCharacter:"\\eb63"}),t.symbolOperator=new t("symbol-operator",{fontCharacter:"\\eb64"}),t.symbolProperty=new t("symbol-property",{fontCharacter:"\\eb65"}),t.wrench=new t("wrench",{fontCharacter:"\\eb65"}),t.wrenchSubaction=new t("wrench-subaction",{fontCharacter:"\\eb65"}),t.symbolSnippet=new t("symbol-snippet",{fontCharacter:"\\eb66"}),t.tasklist=new t("tasklist",{fontCharacter:"\\eb67"}),t.telescope=new t("telescope",{fontCharacter:"\\eb68"}),t.textSize=new t("text-size",{fontCharacter:"\\eb69"}),t.threeBars=new t("three-bars",{fontCharacter:"\\eb6a"}),t.thumbsdown=new t("thumbsdown",{fontCharacter:"\\eb6b"}),t.thumbsup=new t("thumbsup",{fontCharacter:"\\eb6c"}),t.tools=new t("tools",{fontCharacter:"\\eb6d"}),t.triangleDown=new t("triangle-down",{fontCharacter:"\\eb6e"}),t.triangleLeft=new t("triangle-left",{fontCharacter:"\\eb6f"}),t.triangleRight=new t("triangle-right",{fontCharacter:"\\eb70"}),t.triangleUp=new t("triangle-up",{fontCharacter:"\\eb71"}),t.twitter=new t("twitter",{fontCharacter:"\\eb72"}),t.unfold=new t("unfold",{fontCharacter:"\\eb73"}),t.unlock=new t("unlock",{fontCharacter:"\\eb74"}),t.unmute=new t("unmute",{fontCharacter:"\\eb75"}),t.unverified=new t("unverified",{fontCharacter:"\\eb76"}),t.verified=new t("verified",{fontCharacter:"\\eb77"}),t.versions=new t("versions",{fontCharacter:"\\eb78"}),t.vmActive=new t("vm-active",{fontCharacter:"\\eb79"}),t.vmOutline=new t("vm-outline",{fontCharacter:"\\eb7a"}),t.vmRunning=new t("vm-running",{fontCharacter:"\\eb7b"}),t.watch=new t("watch",{fontCharacter:"\\eb7c"}),t.whitespace=new t("whitespace",{fontCharacter:"\\eb7d"}),t.wholeWord=new t("whole-word",{fontCharacter:"\\eb7e"}),t.window=new t("window",{fontCharacter:"\\eb7f"}),t.wordWrap=new t("word-wrap",{fontCharacter:"\\eb80"}),t.zoomIn=new t("zoom-in",{fontCharacter:"\\eb81"}),t.zoomOut=new t("zoom-out",{fontCharacter:"\\eb82"}),t.listFilter=new t("list-filter",{fontCharacter:"\\eb83"}),t.listFlat=new t("list-flat",{fontCharacter:"\\eb84"}),t.listSelection=new t("list-selection",{fontCharacter:"\\eb85"}),t.selection=new t("selection",{fontCharacter:"\\eb85"}),t.listTree=new t("list-tree",{fontCharacter:"\\eb86"}),t.debugBreakpointFunctionUnverified=new t("debug-breakpoint-function-unverified",{fontCharacter:"\\eb87"}),t.debugBreakpointFunction=new t("debug-breakpoint-function",{fontCharacter:"\\eb88"}),t.debugBreakpointFunctionDisabled=new t("debug-breakpoint-function-disabled",{fontCharacter:"\\eb88"}),t.debugStackframeActive=new t("debug-stackframe-active",{fontCharacter:"\\eb89"}),t.debugStackframeDot=new t("debug-stackframe-dot",{fontCharacter:"\\eb8a"}),t.debugStackframe=new t("debug-stackframe",{fontCharacter:"\\eb8b"}),t.debugStackframeFocused=new t("debug-stackframe-focused",{fontCharacter:"\\eb8b"}),t.debugBreakpointUnsupported=new t("debug-breakpoint-unsupported",{fontCharacter:"\\eb8c"}),t.symbolString=new t("symbol-string",{fontCharacter:"\\eb8d"}),t.debugReverseContinue=new t("debug-reverse-continue",{fontCharacter:"\\eb8e"}),t.debugStepBack=new t("debug-step-back",{fontCharacter:"\\eb8f"}),t.debugRestartFrame=new t("debug-restart-frame",{fontCharacter:"\\eb90"}),t.callIncoming=new t("call-incoming",{fontCharacter:"\\eb92"}),t.callOutgoing=new t("call-outgoing",{fontCharacter:"\\eb93"}),t.menu=new t("menu",{fontCharacter:"\\eb94"}),t.expandAll=new t("expand-all",{fontCharacter:"\\eb95"}),t.feedback=new t("feedback",{fontCharacter:"\\eb96"}),t.groupByRefType=new t("group-by-ref-type",{fontCharacter:"\\eb97"}),t.ungroupByRefType=new t("ungroup-by-ref-type",{fontCharacter:"\\eb98"}),t.account=new t("account",{fontCharacter:"\\eb99"}),t.bellDot=new t("bell-dot",{fontCharacter:"\\eb9a"}),t.debugConsole=new t("debug-console",{fontCharacter:"\\eb9b"}),t.library=new t("library",{fontCharacter:"\\eb9c"}),t.output=new t("output",{fontCharacter:"\\eb9d"}),t.runAll=new t("run-all",{fontCharacter:"\\eb9e"}),t.syncIgnored=new t("sync-ignored",{fontCharacter:"\\eb9f"}),t.pinned=new t("pinned",{fontCharacter:"\\eba0"}),t.githubInverted=new t("github-inverted",{fontCharacter:"\\eba1"}),t.debugAlt=new t("debug-alt",{fontCharacter:"\\eb91"}),t.serverProcess=new t("server-process",{fontCharacter:"\\eba2"}),t.serverEnvironment=new t("server-environment",{fontCharacter:"\\eba3"}),t.pass=new t("pass",{fontCharacter:"\\eba4"}),t.stopCircle=new t("stop-circle",{fontCharacter:"\\eba5"}),t.playCircle=new t("play-circle",{fontCharacter:"\\eba6"}),t.record=new t("record",{fontCharacter:"\\eba7"}),t.debugAltSmall=new t("debug-alt-small",{fontCharacter:"\\eba8"}),t.vmConnect=new t("vm-connect",{fontCharacter:"\\eba9"}),t.cloud=new t("cloud",{fontCharacter:"\\ebaa"}),t.merge=new t("merge",{fontCharacter:"\\ebab"}),t.exportIcon=new t("export",{fontCharacter:"\\ebac"}),t.graphLeft=new t("graph-left",{fontCharacter:"\\ebad"}),t.magnet=new t("magnet",{fontCharacter:"\\ebae"}),t.notebook=new t("notebook",{fontCharacter:"\\ebaf"}),t.redo=new t("redo",{fontCharacter:"\\ebb0"}),t.checkAll=new t("check-all",{fontCharacter:"\\ebb1"}),t.pinnedDirty=new t("pinned-dirty",{fontCharacter:"\\ebb2"}),t.passFilled=new t("pass-filled",{fontCharacter:"\\ebb3"}),t.circleLargeFilled=new t("circle-large-filled",{fontCharacter:"\\ebb4"}),t.circleLargeOutline=new t("circle-large-outline",{fontCharacter:"\\ebb5"}),t.combine=new t("combine",{fontCharacter:"\\ebb6"}),t.gather=new t("gather",{fontCharacter:"\\ebb6"}),t.table=new t("table",{fontCharacter:"\\ebb7"}),t.variableGroup=new t("variable-group",{fontCharacter:"\\ebb8"}),t.typeHierarchy=new t("type-hierarchy",{fontCharacter:"\\ebb9"}),t.typeHierarchySub=new t("type-hierarchy-sub",{fontCharacter:"\\ebba"}),t.typeHierarchySuper=new t("type-hierarchy-super",{fontCharacter:"\\ebbb"}),t.gitPullRequestCreate=new t("git-pull-request-create",{fontCharacter:"\\ebbc"}),t.runAbove=new t("run-above",{fontCharacter:"\\ebbd"}),t.runBelow=new t("run-below",{fontCharacter:"\\ebbe"}),t.notebookTemplate=new t("notebook-template",{fontCharacter:"\\ebbf"}),t.debugRerun=new t("debug-rerun",{fontCharacter:"\\ebc0"}),t.workspaceTrusted=new t("workspace-trusted",{fontCharacter:"\\ebc1"}),t.workspaceUntrusted=new t("workspace-untrusted",{fontCharacter:"\\ebc2"}),t.workspaceUnspecified=new t("workspace-unspecified",{fontCharacter:"\\ebc3"}),t.terminalCmd=new t("terminal-cmd",{fontCharacter:"\\ebc4"}),t.terminalDebian=new t("terminal-debian",{fontCharacter:"\\ebc5"}),t.terminalLinux=new t("terminal-linux",{fontCharacter:"\\ebc6"}),t.terminalPowershell=new t("terminal-powershell",{fontCharacter:"\\ebc7"}),t.terminalTmux=new t("terminal-tmux",{fontCharacter:"\\ebc8"}),t.terminalUbuntu=new t("terminal-ubuntu",{fontCharacter:"\\ebc9"}),t.terminalBash=new t("terminal-bash",{fontCharacter:"\\ebca"}),t.arrowSwap=new t("arrow-swap",{fontCharacter:"\\ebcb"}),t.copy=new t("copy",{fontCharacter:"\\ebcc"}),t.personAdd=new t("person-add",{fontCharacter:"\\ebcd"}),t.filterFilled=new t("filter-filled",{fontCharacter:"\\ebce"}),t.wand=new t("wand",{fontCharacter:"\\ebcf"}),t.debugLineByLine=new t("debug-line-by-line",{fontCharacter:"\\ebd0"}),t.inspect=new t("inspect",{fontCharacter:"\\ebd1"}),t.layers=new t("layers",{fontCharacter:"\\ebd2"}),t.layersDot=new t("layers-dot",{fontCharacter:"\\ebd3"}),t.layersActive=new t("layers-active",{fontCharacter:"\\ebd4"}),t.compass=new t("compass",{fontCharacter:"\\ebd5"}),t.compassDot=new t("compass-dot",{fontCharacter:"\\ebd6"}),t.compassActive=new t("compass-active",{fontCharacter:"\\ebd7"}),t.azure=new t("azure",{fontCharacter:"\\ebd8"}),t.issueDraft=new t("issue-draft",{fontCharacter:"\\ebd9"}),t.gitPullRequestClosed=new t("git-pull-request-closed",{fontCharacter:"\\ebda"}),t.gitPullRequestDraft=new t("git-pull-request-draft",{fontCharacter:"\\ebdb"}),t.debugAll=new t("debug-all",{fontCharacter:"\\ebdc"}),t.debugCoverage=new t("debug-coverage",{fontCharacter:"\\ebdd"}),t.runErrors=new t("run-errors",{fontCharacter:"\\ebde"}),t.folderLibrary=new t("folder-library",{fontCharacter:"\\ebdf"}),t.dropDownButton=new t("drop-down-button",t.chevronDown.definition)}(C=e.Codicon||(e.Codicon={}))}),define(we[105],Ee([0,1,16,6]),function(re,e,c,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.prefixedStream=e.prefixedReadable=e.transform=e.toReadable=e.emptyStream=e.toStream=e.peekStream=e.listenStream=e.consumeStream=e.peekReadable=e.consumeReadable=e.newWriteableStream=e.isReadableBufferedStream=e.isReadableStream=void 0;function b(o){const h=o;return h?[h.on,h.pause,h.resume,h.destroy].every(y=>typeof y=="function"):!1}e.isReadableStream=b;function R(o){const h=o;return h?b(h.stream)&&Array.isArray(h.buffer)&&typeof h.ended=="boolean":!1}e.isReadableBufferedStream=R;function F(o,h){return new C(o,h)}e.newWriteableStream=F;class C{constructor(h,y){this.reducer=h,this.options=y,this.state={flowing:!1,ended:!1,destroyed:!1},this.buffer={data:[],error:[]},this.listeners={data:[],error:[],end:[]},this.pendingWritePromises=[]}pause(){this.state.destroyed||(this.state.flowing=!1)}resume(){this.state.destroyed||this.state.flowing||(this.state.flowing=!0,this.flowData(),this.flowErrors(),this.flowEnd())}write(h){if(!this.state.destroyed){if(this.state.flowing)this.emitData(h);else if(this.buffer.data.push(h),typeof this.options?.highWaterMark=="number"&&this.buffer.data.length>this.options.highWaterMark)return new Promise(y=>this.pendingWritePromises.push(y))}}error(h){this.state.destroyed||(this.state.flowing?this.emitError(h):this.buffer.error.push(h))}end(h){this.state.destroyed||(typeof h!="undefined"&&this.write(h),this.state.flowing?(this.emitEnd(),this.destroy()):this.state.ended=!0)}emitData(h){this.listeners.data.slice(0).forEach(y=>y(h))}emitError(h){this.listeners.error.length===0?(0,c.onUnexpectedError)(h):this.listeners.error.slice(0).forEach(y=>y(h))}emitEnd(){this.listeners.end.slice(0).forEach(h=>h())}on(h,y){if(!this.state.destroyed)switch(h){case"data":this.listeners.data.push(y),this.resume();break;case"end":this.listeners.end.push(y),this.state.flowing&&this.flowEnd()&&this.destroy();break;case"error":this.listeners.error.push(y),this.state.flowing&&this.flowErrors();break}}removeListener(h,y){if(this.state.destroyed)return;let i;switch(h){case"data":i=this.listeners.data;break;case"end":i=this.listeners.end;break;case"error":i=this.listeners.error;break}if(i){const v=i.indexOf(y);v>=0&&i.splice(v,1)}}flowData(){if(this.buffer.data.length>0){const h=this.reducer(this.buffer.data);this.emitData(h),this.buffer.data.length=0;const y=[...this.pendingWritePromises];this.pendingWritePromises.length=0,y.forEach(i=>i())}}flowErrors(){if(this.listeners.error.length>0){for(const h of this.buffer.error)this.emitError(h);this.buffer.error.length=0}}flowEnd(){return this.state.ended?(this.emitEnd(),this.listeners.end.length>0):!1}destroy(){this.state.destroyed||(this.state.destroyed=!0,this.state.ended=!0,this.buffer.data.length=0,this.buffer.error.length=0,this.listeners.data.length=0,this.listeners.error.length=0,this.listeners.end.length=0,this.pendingWritePromises.length=0)}}function _(o,h){const y=[];let i;for(;(i=o.read())!==null;)y.push(i);return h(y)}e.consumeReadable=_;function P(o,h,y){const i=[];let v;for(;(v=o.read())!==null&&i.length<y;)i.push(v);return v===null&&i.length>0?h(i):{read:()=>{if(i.length>0)return i.shift();if(typeof v!="undefined"){const r=v;return v=void 0,r}return o.read()}}}e.peekReadable=P;function t(o,h){return new Promise((y,i)=>{const v=[];E(o,{onData:r=>{h&&v.push(r)},onError:r=>{h?i(r):y(void 0)},onEnd:()=>{y(h?h(v):void 0)}})})}e.consumeStream=t;function E(o,h){o.on("error",y=>h.onError(y)),o.on("end",()=>h.onEnd()),o.on("data",y=>h.onData(y))}e.listenStream=E;function n(o,h){return new Promise((y,i)=>{const v=new M.DisposableStore,r=[],s=p=>{if(r.push(p),r.length>h)return v.dispose(),o.pause(),y({stream:o,buffer:r,ended:!1})},u=p=>i(p),d=()=>y({stream:o,buffer:r,ended:!0});v.add((0,M.toDisposable)(()=>o.removeListener("error",u))),o.on("error",u),v.add((0,M.toDisposable)(()=>o.removeListener("end",d))),o.on("end",d),v.add((0,M.toDisposable)(()=>o.removeListener("data",s))),o.on("data",s)})}e.peekStream=n;function f(o,h){const y=F(h);return y.end(o),y}e.toStream=f;function a(){const o=F(()=>{throw new Error("not supported")});return o.end(),o}e.emptyStream=a;function l(o){let h=!1;return{read:()=>h?null:(h=!0,o)}}e.toReadable=l;function w(o,h,y){const i=F(y);return E(o,{onData:v=>i.write(h.data(v)),onError:v=>i.error(h.error?h.error(v):v),onEnd:()=>i.end()}),i}e.transform=w;function I(o,h,y){let i=!1;return{read:()=>{const v=h.read();return i?v:(i=!0,v!==null?y([o,v]):o)}}}e.prefixedReadable=I;function S(o,h,y){let i=!1;const v=F(y);return E(h,{onData:r=>i?v.write(r):(i=!0,v.write(y([o,r]))),onError:r=>v.error(r),onEnd:()=>{i||(i=!0,v.write(o)),v.end()}}),v}e.prefixedStream=S}),define(we[22],Ee([0,1,105]),function(re,e,c){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.prefixedBufferStream=e.prefixedBufferReadable=e.newWriteableBufferStream=e.streamToBufferReadableStream=e.bufferToStream=e.bufferedStreamToBuffer=e.streamToBuffer=e.bufferToReadable=e.readableToBuffer=e.writeUInt8=e.readUInt8=e.writeUInt32LE=e.readUInt32LE=e.writeUInt32BE=e.readUInt32BE=e.writeUInt16LE=e.readUInt16LE=e.VSBuffer=void 0;const M=typeof Buffer!="undefined";let b,R;class F{constructor(s){this.buffer=s,this.byteLength=this.buffer.byteLength}static alloc(s){return M?new F(Buffer.allocUnsafe(s)):new F(new Uint8Array(s))}static wrap(s){return M&&!Buffer.isBuffer(s)&&(s=Buffer.from(s.buffer,s.byteOffset,s.byteLength)),new F(s)}static fromString(s,u){return!(u?.dontUseNodeBuffer||!1)&&M?new F(Buffer.from(s)):(b||(b=new TextEncoder),new F(b.encode(s)))}static concat(s,u){if(typeof u=="undefined"){u=0;for(let k=0,T=s.length;k<T;k++)u+=s[k].byteLength}const d=F.alloc(u);let p=0;for(let k=0,T=s.length;k<T;k++){const g=s[k];d.set(g,p),p+=g.byteLength}return d}toString(){return M?this.buffer.toString():(R||(R=new TextDecoder),R.decode(this.buffer))}slice(s,u){return new F(this.buffer.subarray(s,u))}set(s,u){s instanceof F?this.buffer.set(s.buffer,u):this.buffer.set(s,u)}readUInt32BE(s){return P(this.buffer,s)}writeUInt32BE(s,u){t(this.buffer,s,u)}readUInt32LE(s){return E(this.buffer,s)}writeUInt32LE(s,u){n(this.buffer,s,u)}readUInt8(s){return f(this.buffer,s)}writeUInt8(s,u){a(this.buffer,s,u)}}e.VSBuffer=F;function C(r,s){return r[s+0]<<0>>>0|r[s+1]<<8>>>0}e.readUInt16LE=C;function _(r,s,u){r[u+0]=s&255,s=s>>>8,r[u+1]=s&255}e.writeUInt16LE=_;function P(r,s){return r[s]*2**24+r[s+1]*2**16+r[s+2]*2**8+r[s+3]}e.readUInt32BE=P;function t(r,s,u){r[u+3]=s,s=s>>>8,r[u+2]=s,s=s>>>8,r[u+1]=s,s=s>>>8,r[u]=s}e.writeUInt32BE=t;function E(r,s){return r[s+0]<<0>>>0|r[s+1]<<8>>>0|r[s+2]<<16>>>0|r[s+3]<<24>>>0}e.readUInt32LE=E;function n(r,s,u){r[u+0]=s&255,s=s>>>8,r[u+1]=s&255,s=s>>>8,r[u+2]=s&255,s=s>>>8,r[u+3]=s&255}e.writeUInt32LE=n;function f(r,s){return r[s]}e.readUInt8=f;function a(r,s,u){r[u]=s}e.writeUInt8=a;function l(r){return c.consumeReadable(r,s=>F.concat(s))}e.readableToBuffer=l;function w(r){return c.toReadable(r)}e.bufferToReadable=w;function I(r){return c.consumeStream(r,s=>F.concat(s))}e.streamToBuffer=I;async function S(r){return r.ended?F.concat(r.buffer):F.concat([...r.buffer,await I(r.stream)])}e.bufferedStreamToBuffer=S;function o(r){return c.toStream(r,s=>F.concat(s))}e.bufferToStream=o;function h(r){return c.transform(r,{data:s=>typeof s=="string"?F.fromString(s):F.wrap(s)},s=>F.concat(s))}e.streamToBufferReadableStream=h;function y(r){return c.newWriteableStream(s=>F.concat(s),r)}e.newWriteableBufferStream=y;function i(r,s){return c.prefixedReadable(r,s,u=>F.concat(u))}e.prefixedBufferReadable=i;function v(r,s){return c.prefixedStream(r,s,u=>F.concat(u))}e.prefixedBufferStream=v}),define(we[35],Ee([0,1,9]),function(re,e,c){"use strict";Object.defineProperty(e,"__esModule",{value:!0});var M;(function(b){b[b.Ignore=0]="Ignore",b[b.Info=1]="Info",b[b.Warning=2]="Warning",b[b.Error=3]="Error"})(M||(M={})),function(b){const R="error",F="warning",C="warn",_="info",P="ignore";function t(n){return n?c.equalsIgnoreCase(R,n)?b.Error:c.equalsIgnoreCase(F,n)||c.equalsIgnoreCase(C,n)?b.Warning:c.equalsIgnoreCase(_,n)?b.Info:b.Ignore:b.Ignore}b.fromValue=t;function E(n){switch(n){case b.Error:return R;case b.Warning:return F;case b.Info:return _;default:return P}}b.toString=E}(M||(M={})),e.default=M}),define(we[43],Ee([0,1,17,26,9,10]),function(re,e,c,M,b,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.parseLineAndColumnAware=e.indexOfPath=e.getDriveLetter=e.hasDriveLetter=e.isRootOrDriveLetter=e.sanitizeFilePath=e.isWindowsDriveLetter=e.isEqualOrParent=e.isEqual=e.isValidBasename=e.isUNC=e.getRoot=e.toPosixPath=e.toSlashes=e.isPathSeparator=void 0;function F(r){return r===47||r===92}e.isPathSeparator=F;function C(r){return r.replace(/[\\/]/g,c.posix.sep)}e.toSlashes=C;function _(r){return r.indexOf("/")===-1&&(r=C(r)),/^[a-zA-Z]:(\/|$)/.test(r)&&(r="/"+r),r}e.toPosixPath=_;function P(r,s=c.posix.sep){if(!r)return"";const u=r.length,d=r.charCodeAt(0);if(F(d)){if(F(r.charCodeAt(1))&&!F(r.charCodeAt(2))){let k=3;const T=k;for(;k<u&&!F(r.charCodeAt(k));k++);if(T!==k&&!F(r.charCodeAt(k+1))){for(k+=1;k<u;k++)if(F(r.charCodeAt(k)))return r.slice(0,k+1).replace(/[\\/]/g,s)}}return s}else if(I(d)&&r.charCodeAt(1)===58)return F(r.charCodeAt(2))?r.slice(0,2)+s:r.slice(0,2);let p=r.indexOf("://");if(p!==-1){for(p+=3;p<u;p++)if(F(r.charCodeAt(p)))return r.slice(0,p+1)}return""}e.getRoot=P;function t(r){if(!M.isWindows||!r||r.length<5)return!1;let s=r.charCodeAt(0);if(s!==92||(s=r.charCodeAt(1),s!==92))return!1;let u=2;const d=u;for(;u<r.length&&(s=r.charCodeAt(u),s!==92);u++);return!(d===u||(s=r.charCodeAt(u+1),isNaN(s)||s===92))}e.isUNC=t;const E=/[\\/:\*\?"<>\|]/g,n=/[\\/]/g,f=/^(con|prn|aux|clock\$|nul|lpt[0-9]|com[0-9])(\.(.*?))?$/i;function a(r,s=M.isWindows){const u=s?E:n;return!(!r||r.length===0||/^\s+$/.test(r)||(u.lastIndex=0,u.test(r))||s&&f.test(r)||r==="."||r===".."||s&&r[r.length-1]==="."||s&&r.length!==r.trim().length||r.length>255)}e.isValidBasename=a;function l(r,s,u){const d=r===s;return!u||d?d:!r||!s?!1:(0,b.equalsIgnoreCase)(r,s)}e.isEqual=l;function w(r,s,u,d=c.sep){if(r===s)return!0;if(!r||!s||s.length>r.length)return!1;if(u){if(!(0,b.startsWithIgnoreCase)(r,s))return!1;if(s.length===r.length)return!0;let k=s.length;return s.charAt(s.length-1)===d&&k--,r.charAt(k)===d}return s.charAt(s.length-1)!==d&&(s+=d),r.indexOf(s)===0}e.isEqualOrParent=w;function I(r){return r>=65&&r<=90||r>=97&&r<=122}e.isWindowsDriveLetter=I;function S(r,s){return M.isWindows&&r.endsWith(":")&&(r+=c.sep),(0,c.isAbsolute)(r)||(r=(0,c.join)(s,r)),r=(0,c.normalize)(r),M.isWindows?(r=(0,b.rtrim)(r,c.sep),r.endsWith(":")&&(r+=c.sep)):(r=(0,b.rtrim)(r,c.sep),r||(r=c.sep)),r}e.sanitizeFilePath=S;function o(r){const s=(0,c.normalize)(r);return M.isWindows?r.length>3?!1:h(s)&&(r.length===2||s.charCodeAt(2)===92):s===c.posix.sep}e.isRootOrDriveLetter=o;function h(r){return M.isWindows?I(r.charCodeAt(0))&&r.charCodeAt(1)===58:!1}e.hasDriveLetter=h;function y(r){return h(r)?r[0]:void 0}e.getDriveLetter=y;function i(r,s,u){return s.length>r.length?-1:r===s?0:(u&&(r=r.toLowerCase(),s=s.toLowerCase()),r.indexOf(s))}e.indexOfPath=i;function v(r){const s=r.split(":");let u,d,p;if(s.forEach(k=>{const T=Number(k);(0,R.isNumber)(T)?d===void 0?d=T:p===void 0&&(p=T):u=u?[u,k].join(":"):k}),!u)throw new Error("Format for `--goto` should be: `FILE:LINE(:COLUMN)`");return{path:u,line:d!==void 0?d:void 0,column:p!==void 0?p:d!==void 0?1:void 0}}e.parseLineAndColumnAware=v}),define(we[23],Ee([0,1,10]),function(re,e,c){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.filter=e.getCaseInsensitive=e.distinct=e.getOrDefault=e.safeStringify=e.equals=e.mixin=e.cloneAndChange=e.deepFreeze=e.deepClone=void 0;function M(l){if(!l||typeof l!="object"||l instanceof RegExp)return l;const w=Array.isArray(l)?[]:{};return Object.keys(l).forEach(I=>{l[I]&&typeof l[I]=="object"?w[I]=M(l[I]):w[I]=l[I]}),w}e.deepClone=M;function b(l){if(!l||typeof l!="object")return l;const w=[l];for(;w.length>0;){const I=w.shift();Object.freeze(I);for(const S in I)if(R.call(I,S)){const o=I[S];typeof o=="object"&&!Object.isFrozen(o)&&w.push(o)}}return l}e.deepFreeze=b;const R=Object.prototype.hasOwnProperty;function F(l,w){return C(l,w,new Set)}e.cloneAndChange=F;function C(l,w,I){if((0,c.isUndefinedOrNull)(l))return l;const S=w(l);if(typeof S!="undefined")return S;if((0,c.isArray)(l)){const o=[];for(const h of l)o.push(C(h,w,I));return o}if((0,c.isObject)(l)){if(I.has(l))throw new Error("Cannot clone recursive data-structure");I.add(l);const o={};for(let h in l)R.call(l,h)&&(o[h]=C(l[h],w,I));return I.delete(l),o}return l}function _(l,w,I=!0){return(0,c.isObject)(l)?((0,c.isObject)(w)&&Object.keys(w).forEach(S=>{S in l?I&&((0,c.isObject)(l[S])&&(0,c.isObject)(w[S])?_(l[S],w[S],I):l[S]=w[S]):l[S]=w[S]}),l):w}e.mixin=_;function P(l,w){if(l===w)return!0;if(l==null||w===null||w===void 0||typeof l!=typeof w||typeof l!="object"||Array.isArray(l)!==Array.isArray(w))return!1;let I,S;if(Array.isArray(l)){if(l.length!==w.length)return!1;for(I=0;I<l.length;I++)if(!P(l[I],w[I]))return!1}else{const o=[];for(S in l)o.push(S);o.sort();const h=[];for(S in w)h.push(S);if(h.sort(),!P(o,h))return!1;for(I=0;I<o.length;I++)if(!P(l[o[I]],w[o[I]]))return!1}return!0}e.equals=P;function t(l){const w=new Set;return JSON.stringify(l,(I,S)=>{if((0,c.isObject)(S)||Array.isArray(S)){if(w.has(S))return"[Circular]";w.add(S)}return S})}e.safeStringify=t;function E(l,w,I){const S=w(l);return typeof S=="undefined"?I:S}e.getOrDefault=E;function n(l,w){const I=Object.create(null);return!l||!w||Object.keys(w).forEach(o=>{const h=l[o],y=w[o];P(h,y)||(I[o]=y)}),I}e.distinct=n;function f(l,w){const I=w.toLowerCase(),S=Object.keys(l).find(o=>o.toLowerCase()===I);return S?l[S]:l[w]}e.getCaseInsensitive=f;function a(l,w){const I=Object.create(null);for(const S of Object.keys(l))w(S,l[S])&&(I[S]=l[S]);return I}e.filter=a});var Ze=this&&this.__classPrivateFieldSet||function(re,e,c,M,b){if(M==="m")throw new TypeError("Private method is not writable");if(M==="a"&&!b)throw new TypeError("Private accessor was defined without a setter");if(typeof e=="function"?re!==e||!b:!e.has(re))throw new TypeError("Cannot write private member to an object whose class did not declare it");return M==="a"?b.call(re,c):b?b.value=c:e.set(re,c),c},Ae=this&&this.__classPrivateFieldGet||function(re,e,c,M){if(c==="a"&&!M)throw new TypeError("Private accessor was defined without a getter");if(typeof e=="function"?re!==e||!M:!e.has(re))throw new TypeError("Cannot read private member from an object whose class did not declare it");return c==="m"?M:c==="a"?M.call(re):M?M.value:e.get(re)};define(we[20],Ee([0,1,12,9,2]),function(re,e,c,M,b){"use strict";var R,F,C;Object.defineProperty(e,"__esModule",{value:!0}),e.ReadonlyMapView=e.LRUCache=e.LinkedMap=e.Touch=e.ResourceMap=e.TernarySearchTree=e.UriIterator=e.PathIterator=e.ConfigKeysIterator=e.StringIterator=e.setToString=e.mapToString=e.getOrSet=void 0;function _(v,r,s){let u=v.get(r);return u===void 0&&(u=s,v.set(r,u)),u}e.getOrSet=_;function P(v){const r=[];return v.forEach((s,u)=>{r.push(`${u} => ${s}`)}),`Map(${v.size}) {${r.join(", ")}}`}e.mapToString=P;function t(v){const r=[];return v.forEach(s=>{r.push(s)}),`Set(${v.size}) {${r.join(", ")}}`}e.setToString=t;class E{constructor(){this._value="",this._pos=0}reset(r){return this._value=r,this._pos=0,this}next(){return this._pos+=1,this}hasNext(){return this._pos<this._value.length-1}cmp(r){const s=r.charCodeAt(0),u=this._value.charCodeAt(this._pos);return s-u}value(){return this._value[this._pos]}}e.StringIterator=E;class n{constructor(r=!0){this._caseSensitive=r}reset(r){return this._value=r,this._from=0,this._to=0,this.next()}hasNext(){return this._to<this._value.length}next(){this._from=this._to;let r=!0;for(;this._to<this._value.length;this._to++)if(this._value.charCodeAt(this._to)===46)if(r)this._from++;else break;else r=!1;return this}cmp(r){return this._caseSensitive?(0,M.compareSubstring)(r,this._value,0,r.length,this._from,this._to):(0,M.compareSubstringIgnoreCase)(r,this._value,0,r.length,this._from,this._to)}value(){return this._value.substring(this._from,this._to)}}e.ConfigKeysIterator=n;class f{constructor(r=!0,s=!0){this._splitOnBackslash=r,this._caseSensitive=s}reset(r){return this._value=r.replace(/\\$|\/$/,""),this._from=0,this._to=0,this.next()}hasNext(){return this._to<this._value.length}next(){this._from=this._to;let r=!0;for(;this._to<this._value.length;this._to++){const s=this._value.charCodeAt(this._to);if(s===47||this._splitOnBackslash&&s===92)if(r)this._from++;else break;else r=!1}return this}cmp(r){return this._caseSensitive?(0,M.compareSubstring)(r,this._value,0,r.length,this._from,this._to):(0,M.compareSubstringIgnoreCase)(r,this._value,0,r.length,this._from,this._to)}value(){return this._value.substring(this._from,this._to)}}e.PathIterator=f;var a;(function(v){v[v.Scheme=1]="Scheme",v[v.Authority=2]="Authority",v[v.Path=3]="Path",v[v.Query=4]="Query",v[v.Fragment=5]="Fragment"})(a||(a={}));class l{constructor(r){this._ignorePathCasing=r,this._states=[],this._stateIdx=0}reset(r){return this._value=r,this._states=[],this._value.scheme&&this._states.push(1),this._value.authority&&this._states.push(2),this._value.path&&(this._pathIterator=new f(!1,!this._ignorePathCasing(r)),this._pathIterator.reset(r.path),this._pathIterator.value()&&this._states.push(3)),this._value.query&&this._states.push(4),this._value.fragment&&this._states.push(5),this._stateIdx=0,this}next(){return this._states[this._stateIdx]===3&&this._pathIterator.hasNext()?this._pathIterator.next():this._stateIdx+=1,this}hasNext(){return this._states[this._stateIdx]===3&&this._pathIterator.hasNext()||this._stateIdx<this._states.length-1}cmp(r){if(this._states[this._stateIdx]===1)return(0,M.compareIgnoreCase)(r,this._value.scheme);if(this._states[this._stateIdx]===2)return(0,M.compareIgnoreCase)(r,this._value.authority);if(this._states[this._stateIdx]===3)return this._pathIterator.cmp(r);if(this._states[this._stateIdx]===4)return(0,M.compare)(r,this._value.query);if(this._states[this._stateIdx]===5)return(0,M.compare)(r,this._value.fragment);throw new Error}value(){if(this._states[this._stateIdx]===1)return this._value.scheme;if(this._states[this._stateIdx]===2)return this._value.authority;if(this._states[this._stateIdx]===3)return this._pathIterator.value();if(this._states[this._stateIdx]===4)return this._value.query;if(this._states[this._stateIdx]===5)return this._value.fragment;throw new Error}}e.UriIterator=l;class w{isEmpty(){return!this.left&&!this.mid&&!this.right&&!this.value}}class I{constructor(r){this._iter=r}static forUris(r=()=>!1){return new I(new l(r))}static forPaths(){return new I(new f)}static forStrings(){return new I(new E)}static forConfigKeys(){return new I(new n)}clear(){this._root=void 0}set(r,s){const u=this._iter.reset(r);let d;for(this._root||(this._root=new w,this._root.segment=u.value()),d=this._root;;){const k=u.cmp(d.segment);if(k>0)d.left||(d.left=new w,d.left.segment=u.value()),d=d.left;else if(k<0)d.right||(d.right=new w,d.right.segment=u.value()),d=d.right;else if(u.hasNext())u.next(),d.mid||(d.mid=new w,d.mid.segment=u.value()),d=d.mid;else break}const p=d.value;return d.value=s,d.key=r,p}fill(r,s){const u=s.slice(0);(0,c.shuffle)(u);for(let d of u)this.set(d,r)}get(r){return this._getNode(r)?.value}_getNode(r){const s=this._iter.reset(r);let u=this._root;for(;u;){const d=s.cmp(u.segment);if(d>0)u=u.left;else if(d<0)u=u.right;else if(s.hasNext())s.next(),u=u.mid;else break}return u}has(r){const s=this._getNode(r);return!(s?.value===void 0&&s?.mid===void 0)}delete(r){return this._delete(r,!1)}deleteSuperstr(r){return this._delete(r,!0)}_delete(r,s){const u=this._iter.reset(r),d=[];let p=this._root;for(;p;){const k=u.cmp(p.segment);if(k>0)d.push([1,p]),p=p.left;else if(k<0)d.push([-1,p]),p=p.right;else if(u.hasNext())u.next(),d.push([0,p]),p=p.mid;else{for(s?(p.left=void 0,p.mid=void 0,p.right=void 0):p.value=void 0;d.length>0&&p.isEmpty();){let[T,g]=d.pop();switch(T){case 1:g.left=void 0;break;case 0:g.mid=void 0;break;case-1:g.right=void 0;break}p=g}break}}}findSubstr(r){const s=this._iter.reset(r);let u=this._root,d;for(;u;){const p=s.cmp(u.segment);if(p>0)u=u.left;else if(p<0)u=u.right;else if(s.hasNext())s.next(),d=u.value||d,u=u.mid;else break}return u&&u.value||d}findSuperstr(r){const s=this._iter.reset(r);let u=this._root;for(;u;){const d=s.cmp(u.segment);if(d>0)u=u.left;else if(d<0)u=u.right;else if(s.hasNext())s.next(),u=u.mid;else return u.mid?this._entries(u.mid):void 0}}forEach(r){for(const[s,u]of this)r(u,s)}*[Symbol.iterator](){yield*this._entries(this._root)}*_entries(r){if(!r)return;const s=[r];for(;s.length>0;){const u=s.pop();u&&(u.value&&(yield[u.key,u.value]),u.left&&s.push(u.left),u.mid&&s.push(u.mid),u.right&&s.push(u.right))}}}e.TernarySearchTree=I;class S{constructor(r,s){this[R]="ResourceMap",r instanceof S?(this.map=new Map(r.map),this.toKey=s??S.defaultToKey):(this.map=new Map,this.toKey=r??S.defaultToKey)}set(r,s){return this.map.set(this.toKey(r),s),this}get(r){return this.map.get(this.toKey(r))}has(r){return this.map.has(this.toKey(r))}get size(){return this.map.size}clear(){this.map.clear()}delete(r){return this.map.delete(this.toKey(r))}forEach(r,s){typeof s!="undefined"&&(r=r.bind(s));for(let[u,d]of this.map)r(d,b.URI.parse(u),this)}values(){return this.map.values()}*keys(){for(let r of this.map.keys())yield b.URI.parse(r)}*entries(){for(let r of this.map.entries())yield[b.URI.parse(r[0]),r[1]]}*[(R=Symbol.toStringTag,Symbol.iterator)](){for(let r of this.map)yield[b.URI.parse(r[0]),r[1]]}}e.ResourceMap=S,S.defaultToKey=v=>v.toString();var o;(function(v){v[v.None=0]="None",v[v.AsOld=1]="AsOld",v[v.AsNew=2]="AsNew"})(o=e.Touch||(e.Touch={}));class h{constructor(){this[F]="LinkedMap",this._map=new Map,this._head=void 0,this._tail=void 0,this._size=0,this._state=0}clear(){this._map.clear(),this._head=void 0,this._tail=void 0,this._size=0,this._state++}isEmpty(){return!this._head&&!this._tail}get size(){return this._size}get first(){return this._head?.value}get last(){return this._tail?.value}has(r){return this._map.has(r)}get(r,s=0){const u=this._map.get(r);if(!!u)return s!==0&&this.touch(u,s),u.value}set(r,s,u=0){let d=this._map.get(r);if(d)d.value=s,u!==0&&this.touch(d,u);else{switch(d={key:r,value:s,next:void 0,previous:void 0},u){case 0:this.addItemLast(d);break;case 1:this.addItemFirst(d);break;case 2:this.addItemLast(d);break;default:this.addItemLast(d);break}this._map.set(r,d),this._size++}return this}delete(r){return!!this.remove(r)}remove(r){const s=this._map.get(r);if(!!s)return this._map.delete(r),this.removeItem(s),this._size--,s.value}shift(){if(!this._head&&!this._tail)return;if(!this._head||!this._tail)throw new Error("Invalid list");const r=this._head;return this._map.delete(r.key),this.removeItem(r),this._size--,r.value}forEach(r,s){const u=this._state;let d=this._head;for(;d;){if(s?r.bind(s)(d.value,d.key,this):r(d.value,d.key,this),this._state!==u)throw new Error("LinkedMap got modified during iteration.");d=d.next}}keys(){const r=this,s=this._state;let u=this._head;const d={[Symbol.iterator](){return d},next(){if(r._state!==s)throw new Error("LinkedMap got modified during iteration.");if(u){const p={value:u.key,done:!1};return u=u.next,p}else return{value:void 0,done:!0}}};return d}values(){const r=this,s=this._state;let u=this._head;const d={[Symbol.iterator](){return d},next(){if(r._state!==s)throw new Error("LinkedMap got modified during iteration.");if(u){const p={value:u.value,done:!1};return u=u.next,p}else return{value:void 0,done:!0}}};return d}entries(){const r=this,s=this._state;let u=this._head;const d={[Symbol.iterator](){return d},next(){if(r._state!==s)throw new Error("LinkedMap got modified during iteration.");if(u){const p={value:[u.key,u.value],done:!1};return u=u.next,p}else return{value:void 0,done:!0}}};return d}[(F=Symbol.toStringTag,Symbol.iterator)](){return this.entries()}trimOld(r){if(r>=this.size)return;if(r===0){this.clear();return}let s=this._head,u=this.size;for(;s&&u>r;)this._map.delete(s.key),s=s.next,u--;this._head=s,this._size=u,s&&(s.previous=void 0),this._state++}addItemFirst(r){if(!this._head&&!this._tail)this._tail=r;else if(this._head)r.next=this._head,this._head.previous=r;else throw new Error("Invalid list");this._head=r,this._state++}addItemLast(r){if(!this._head&&!this._tail)this._head=r;else if(this._tail)r.previous=this._tail,this._tail.next=r;else throw new Error("Invalid list");this._tail=r,this._state++}removeItem(r){if(r===this._head&&r===this._tail)this._head=void 0,this._tail=void 0;else if(r===this._head){if(!r.next)throw new Error("Invalid list");r.next.previous=void 0,this._head=r.next}else if(r===this._tail){if(!r.previous)throw new Error("Invalid list");r.previous.next=void 0,this._tail=r.previous}else{const s=r.next,u=r.previous;if(!s||!u)throw new Error("Invalid list");s.previous=u,u.next=s}r.next=void 0,r.previous=void 0,this._state++}touch(r,s){if(!this._head||!this._tail)throw new Error("Invalid list");if(!(s!==1&&s!==2)){if(s===1){if(r===this._head)return;const u=r.next,d=r.previous;r===this._tail?(d.next=void 0,this._tail=d):(u.previous=d,d.next=u),r.previous=void 0,r.next=this._head,this._head.previous=r,this._head=r,this._state++}else if(s===2){if(r===this._tail)return;const u=r.next,d=r.previous;r===this._head?(u.previous=void 0,this._head=u):(u.previous=d,d.next=u),r.next=void 0,r.previous=this._tail,this._tail.next=r,this._tail=r,this._state++}}}toJSON(){const r=[];return this.forEach((s,u)=>{r.push([u,s])}),r}fromJSON(r){this.clear();for(const[s,u]of r)this.set(s,u)}}e.LinkedMap=h;class y extends h{constructor(r,s=1){super();this._limit=r,this._ratio=Math.min(Math.max(0,s),1)}get limit(){return this._limit}set limit(r){this._limit=r,this.checkTrim()}get ratio(){return this._ratio}set ratio(r){this._ratio=Math.min(Math.max(0,r),1),this.checkTrim()}get(r,s=2){return super.get(r,s)}peek(r){return super.get(r,0)}set(r,s){return super.set(r,s,2),this.checkTrim(),this}checkTrim(){this.size>this._limit&&this.trimOld(Math.round(this._limit*this._ratio))}}e.LRUCache=y;class i{constructor(r){C.set(this,void 0),Ze(this,C,r,"f")}get size(){return Ae(this,C,"f").size}forEach(r,s){Ae(this,C,"f").forEach(r,s)}get(r){return Ae(this,C,"f").get(r)}has(r){return Ae(this,C,"f").has(r)}entries(){return Ae(this,C,"f").entries()}keys(){return Ae(this,C,"f").keys()}values(){return Ae(this,C,"f").values()}[(C=new WeakMap,Symbol.iterator)](){return Ae(this,C,"f").entries()}}e.ReadonlyMapView=i}),define(we[106],Ee([0,1,20,9]),function(re,e,c,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.fuzzyScoreGraceful=e.fuzzyScoreGracefulAggressive=e.fuzzyScore=e.FuzzyScore=e.isPatternInWord=e.createMatches=e.anyScore=e.matchesFuzzy2=e.matchesFuzzy=e.matchesWords=e.matchesCamelCase=e.isUpper=e.matchesSubString=e.matchesContiguousSubString=e.matchesPrefix=e.matchesStrictPrefix=e.or=void 0;function b(...q){return function(se,he){for(let Te=0,Ue=q.length;Te<Ue;Te++){const He=q[Te](se,he);if(He)return He}return null}}e.or=b,e.matchesStrictPrefix=R.bind(void 0,!1),e.matchesPrefix=R.bind(void 0,!0);function R(q,se,he){if(!he||he.length<se.length)return null;let Te;return q?Te=M.startsWithIgnoreCase(he,se):Te=he.indexOf(se)===0,Te?se.length>0?[{start:0,end:se.length}]:[]:null}function F(q,se){const he=se.toLowerCase().indexOf(q.toLowerCase());return he===-1?null:[{start:he,end:he+q.length}]}e.matchesContiguousSubString=F;function C(q,se){return _(q.toLowerCase(),se.toLowerCase(),0,0)}e.matchesSubString=C;function _(q,se,he,Te){if(he===q.length)return[];if(Te===se.length)return null;if(q[he]===se[Te]){let Ue=null;return(Ue=_(q,se,he+1,Te+1))?I({start:Te,end:Te+1},Ue):null}return _(q,se,he,Te+1)}function P(q){return 97<=q&&q<=122}function t(q){return 65<=q&&q<=90}e.isUpper=t;function E(q){return 48<=q&&q<=57}function n(q){return q===32||q===9||q===10||q===13}const f=new Set;"`~!@#$%^&*()-=+[{]}\\|;:'\",.<>/?".split("").forEach(q=>f.add(q.charCodeAt(0)));function a(q){return n(q)||f.has(q)}function l(q,se){return q===se||a(q)&&a(se)}function w(q){return P(q)||t(q)||E(q)}function I(q,se){return se.length===0?se=[q]:q.end===se[0].start?se[0].start=q.start:se.unshift(q),se}function S(q,se){for(let he=se;he<q.length;he++){const Te=q.charCodeAt(he);if(t(Te)||E(Te)||he>0&&!w(q.charCodeAt(he-1)))return he}return q.length}function o(q,se,he,Te){if(he===q.length)return[];if(Te===se.length)return null;if(q[he]!==se[Te].toLowerCase())return null;{let Ue=null,He=Te+1;for(Ue=o(q,se,he+1,Te+1);!Ue&&(He=S(se,He))<se.length;)Ue=o(q,se,he+1,He),He++;return Ue===null?null:I({start:Te,end:Te+1},Ue)}}function h(q){let se=0,he=0,Te=0,Ue=0,He=0;for(let J=0;J<q.length;J++)He=q.charCodeAt(J),t(He)&&se++,P(He)&&he++,w(He)&&Te++,E(He)&&Ue++;const Ke=se/q.length,ye=he/q.length,nt=Te/q.length,H=Ue/q.length;return{upperPercent:Ke,lowerPercent:ye,alphaPercent:nt,numericPercent:H}}function y(q){const{upperPercent:se,lowerPercent:he}=q;return he===0&&se>.6}function i(q){const{upperPercent:se,lowerPercent:he,alphaPercent:Te,numericPercent:Ue}=q;return he>.2&&se<.8&&Te>.6&&Ue<.2}function v(q){let se=0,he=0,Te=0,Ue=0;for(let He=0;He<q.length;He++)Te=q.charCodeAt(He),t(Te)&&se++,P(Te)&&he++,n(Te)&&Ue++;return(se===0||he===0)&&Ue===0?q.length<=30:se<=5}function r(q,se){if(!se||(se=se.trim(),se.length===0)||!v(q)||se.length>60)return null;const he=h(se);if(!i(he)){if(!y(he))return null;se=se.toLowerCase()}let Te=null,Ue=0;for(q=q.toLowerCase();Ue<se.length&&(Te=o(q,se,0,Ue))===null;)Ue=S(se,Ue+1);return Te}e.matchesCamelCase=r;function s(q,se,he=!1){if(!se||se.length===0)return null;let Te=null,Ue=0;for(q=q.toLowerCase(),se=se.toLowerCase();Ue<se.length&&(Te=u(q,se,0,Ue,he))===null;)Ue=d(se,Ue+1);return Te}e.matchesWords=s;function u(q,se,he,Te,Ue){if(he===q.length)return[];if(Te===se.length)return null;if(l(q.charCodeAt(he),se.charCodeAt(Te))){let He=null,Ke=Te+1;if(He=u(q,se,he+1,Te+1,Ue),!Ue)for(;!He&&(Ke=d(se,Ke))<se.length;)He=u(q,se,he+1,Ke,Ue),Ke++;return He===null?null:I({start:Te,end:Te+1},He)}else return null}function d(q,se){for(let he=se;he<q.length;he++)if(a(q.charCodeAt(he))||he>0&&a(q.charCodeAt(he-1)))return he;return q.length}const p=b(e.matchesPrefix,r,F),k=b(e.matchesPrefix,r,C),T=new c.LRUCache(1e4);function g(q,se,he=!1){if(typeof q!="string"||typeof se!="string")return null;let Te=T.get(q);Te||(Te=new RegExp(M.convertSimple2RegExpPattern(q),"i"),T.set(q,Te));const Ue=Te.exec(se);return Ue?[{start:Ue.index,end:Ue.index+Ue[0].length}]:he?k(q,se):p(q,se)}e.matchesFuzzy=g;function D(q,se){const he=Ye(q,q.toLowerCase(),0,se,se.toLowerCase(),0,!0);return he?A(he):null}e.matchesFuzzy2=D;function m(q,se,he,Te,Ue,He){const Ke=Math.min(13,q.length);for(;he<Ke;he++){const ye=Ye(q,se,he,Te,Ue,He,!1);if(ye)return ye}return[0,He]}e.anyScore=m;function A(q){if(typeof q=="undefined")return[];const se=[],he=q[1];for(let Te=q.length-1;Te>1;Te--){const Ue=q[Te]+he,He=se[se.length-1];He&&He.end===Ue?He.end=Ue+1:se.push({start:Ue,end:Ue+1})}return se}e.createMatches=A;const L=128;function V(){const q=[],se=[];for(let he=0;he<=L;he++)se[he]=0;for(let he=0;he<=L;he++)q.push(se.slice(0));return q}function G(q){const se=[];for(let he=0;he<=q;he++)se[he]=0;return se}const U=G(2*L),K=G(2*L),$=V(),B=V(),z=V(),Y=!1;function ne(q,se,he,Te,Ue){function He(ye,nt,H=" "){for(;ye.length<nt;)ye=H+ye;return ye}let Ke=` |   |${Te.split("").map(ye=>He(ye,3)).join("|")}
`;for(let ye=0;ye<=he;ye++)ye===0?Ke+=" |":Ke+=`${se[ye-1]}|`,Ke+=q[ye].slice(0,Ue+1).map(nt=>He(nt.toString(),3)).join("|")+`
`;return Ke}function j(q,se,he,Te){q=q.substr(se),he=he.substr(Te),console.log(ne(B,q,q.length,he,he.length)),console.log(ne(z,q,q.length,he,he.length)),console.log(ne($,q,q.length,he,he.length))}function le(q,se){if(se<0||se>=q.length)return!1;const he=q.codePointAt(se);switch(he){case 95:case 45:case 46:case 32:case 47:case 92:case 39:case 34:case 58:case 36:case 60:case 40:case 91:return!0;case void 0:return!1;default:return!!M.isEmojiImprecise(he)}}function oe(q,se){if(se<0||se>=q.length)return!1;switch(q.charCodeAt(se)){case 32:case 9:return!0;default:return!1}}function ve(q,se,he){return se[q]!==he[q]}function Re(q,se,he,Te,Ue,He,Ke=!1){for(;se<he&&Ue<He;)q[se]===Te[Ue]&&(Ke&&(U[se]=Ue),se+=1),Ue+=1;return se===he}e.isPatternInWord=Re;var Me;(function(q){q[q.Diag=1]="Diag",q[q.Left=2]="Left",q[q.LeftLeft=3]="LeftLeft"})(Me||(Me={}));var Oe;(function(q){q.Default=[-100,0];function se(he){return!he||he.length===2&&he[0]===-100&&he[1]===0}q.isDefault=se})(Oe=e.FuzzyScore||(e.FuzzyScore={}));function Ye(q,se,he,Te,Ue,He,Ke){const ye=q.length>L?L:q.length,nt=Te.length>L?L:Te.length;if(he>=ye||He>=nt||ye-he>nt-He||!Re(se,he,ye,Ue,He,nt,!0))return;Ve(ye,nt,he,He,se,Ue);let H=1,J=1,fe=he,xe=He;const Qe=[!1];for(H=1,fe=he;fe<ye;H++,fe++){const mt=U[fe],Dt=K[fe],kt=fe+1<ye?K[fe+1]:nt;for(J=mt-He+1,xe=mt;xe<kt;J++,xe++){let vt=Number.MIN_SAFE_INTEGER,Xe=!1;xe<=Dt&&(vt=qe(q,se,fe,he,Te,Ue,xe,nt,He,$[H-1][J-1]===0,Qe));let _t=0;vt!==Number.MAX_SAFE_INTEGER&&(Xe=!0,_t=vt+B[H-1][J-1]);const Pe=xe>mt,Se=Pe?B[H][J-1]+($[H][J-1]>0?-5:0):0,De=xe>mt+1&&$[H][J-1]>0,ee=De?B[H][J-2]+($[H][J-2]>0?-5:0):0;if(De&&(!Pe||ee>=Se)&&(!Xe||ee>=_t))B[H][J]=ee,z[H][J]=3,$[H][J]=0;else if(Pe&&(!Xe||Se>=_t))B[H][J]=Se,z[H][J]=2,$[H][J]=0;else if(Xe)B[H][J]=_t,z[H][J]=1,$[H][J]=$[H-1][J-1]+1;else throw new Error("not possible")}}if(Y&&j(q,he,Te,He),!Qe[0]&&!Ke)return;H--,J--;const rt=[B[H][J],He];let ct=0,ft=0;for(;H>=1;){let mt=J;do{const Dt=z[H][mt];if(Dt===3)mt=mt-2;else if(Dt===2)mt=mt-1;else break}while(mt>=1);ct>1&&se[he+H-1]===Ue[He+J-1]&&!ve(mt+He-1,Te,Ue)&&ct+1>$[H][mt]&&(mt=J),mt===J?ct++:ct=1,ft||(ft=mt),H--,J=mt-1,rt.push(J)}nt===ye&&(rt[0]+=2);const Pt=ft-ye;return rt[0]-=Pt,rt}e.fuzzyScore=Ye;function Ve(q,se,he,Te,Ue,He){let Ke=q-1,ye=se-1;for(;Ke>=he&&ye>=Te;)Ue[Ke]===He[ye]&&(K[Ke]=ye,Ke--),ye--}function qe(q,se,he,Te,Ue,He,Ke,ye,nt,H,J){if(se[he]!==He[Ke])return Number.MIN_SAFE_INTEGER;let fe=1,xe=!1;return Ke===he-Te?fe=q[he]===Ue[Ke]?7:5:ve(Ke,Ue,He)&&(Ke===0||!ve(Ke-1,Ue,He))?(fe=q[he]===Ue[Ke]?7:5,xe=!0):le(He,Ke)&&(Ke===0||!le(He,Ke-1))?fe=5:(le(He,Ke-1)||oe(He,Ke-1))&&(fe=5,xe=!0),fe>1&&he===Te&&(J[0]=!0),xe||(xe=ve(Ke,Ue,He)||le(He,Ke-1)||oe(He,Ke-1)),he===Te?Ke>nt&&(fe-=xe?3:5):H?fe+=xe?2:0:fe+=xe?0:1,Ke+1===ye&&(fe-=xe?3:5),fe}function x(q,se,he,Te,Ue,He,Ke){return te(q,se,he,Te,Ue,He,!0,Ke)}e.fuzzyScoreGracefulAggressive=x;function Q(q,se,he,Te,Ue,He,Ke){return te(q,se,he,Te,Ue,He,!1,Ke)}e.fuzzyScoreGraceful=Q;function te(q,se,he,Te,Ue,He,Ke,ye){let nt=Ye(q,se,he,Te,Ue,He,ye);if(nt&&!Ke)return nt;if(q.length>=3){const H=Math.min(7,q.length-1);for(let J=he+1;J<H;J++){const fe=ae(q,J);if(fe){const xe=Ye(fe,fe.toLowerCase(),he,Te,Ue,He,ye);xe&&(xe[0]-=3,(!nt||xe[0]>nt[0])&&(nt=xe))}}}return nt}function ae(q,se){if(se+1>=q.length)return;const he=q[se],Te=q[se+1];if(he!==Te)return q.slice(0,se)+Te+he+q.slice(se+2)}}),define(we[107],Ee([0,1,34,106,9]),function(re,e,c,M,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.matchesFuzzyIconAware=e.parseLabelWithIcons=e.stripIcons=e.markdownEscapeEscapedIcons=e.escapeIcons=e.iconStartMarker=void 0,e.iconStartMarker="$(";const R=new RegExp(`\\$\\(${c.CSSIcon.iconNameExpression}(?:${c.CSSIcon.iconModifierExpression})?\\)`,"g"),F=new RegExp(`(\\\\)?${R.source}`,"g");function C(l){return l.replace(F,(w,I)=>I?w:`\\${w}`)}e.escapeIcons=C;const _=new RegExp(`\\\\${R.source}`,"g");function P(l){return l.replace(_,w=>`\\${w}`)}e.markdownEscapeEscapedIcons=P;const t=new RegExp(`(\\s)?(\\\\)?${R.source}(\\s)?`,"g");function E(l){return l.indexOf(e.iconStartMarker)===-1?l:l.replace(t,(w,I,S,o)=>S?w:I||o||"")}e.stripIcons=E;function n(l){const w=l.indexOf(e.iconStartMarker);return w===-1?{text:l}:f(l,w)}e.parseLabelWithIcons=n;function f(l,w){const I=[];let S="";function o(d){if(d){S+=d;for(const p of d)I.push(i)}}let h=-1,y="",i=0,v,r,s=w;const u=l.length;for(o(l.substr(0,w));s<u;)v=l[s],r=l[s+1],v===e.iconStartMarker[0]&&r===e.iconStartMarker[1]?(h=s,o(y),y=e.iconStartMarker,s++):v===")"&&h!==-1?(i+=s-h+1,h=-1,y=""):h!==-1?/^[a-z0-9\-]$/i.test(v)?y+=v:(o(y),h=-1,y=""):o(v),s++;return o(y),{text:S,iconOffsets:I}}function a(l,w,I=!1){const{text:S,iconOffsets:o}=w;if(!o||o.length===0)return(0,M.matchesFuzzy)(l,S,I);const h=(0,b.ltrim)(S," "),y=S.length-h.length,i=(0,M.matchesFuzzy)(l,h,I);if(i)for(const v of i){const r=o[v.start+y]+y;v.start+=r,v.end+=r}return i}e.matchesFuzzyIconAware=a}),define(we[76],Ee([0,1,16,107]),function(re,e,c,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.parseHrefAndDimensions=e.removeMarkdownEscapes=e.escapeMarkdownSyntaxTokens=e.markdownStringEqual=e.isMarkdownString=e.isEmptyMarkdownString=e.MarkdownString=e.MarkdownStringTextNewlineStyle=void 0;var b;(function(n){n[n.Paragraph=0]="Paragraph",n[n.Break=1]="Break"})(b=e.MarkdownStringTextNewlineStyle||(e.MarkdownStringTextNewlineStyle={}));class R{constructor(f="",a=!1){if(this.value=f,typeof this.value!="string")throw(0,c.illegalArgument)("value");typeof a=="boolean"?(this.isTrusted=a,this.supportThemeIcons=!1,this.supportHtml=!1):(this.isTrusted=a.isTrusted??void 0,this.supportThemeIcons=a.supportThemeIcons??!1,this.supportHtml=a.supportHtml??!1)}appendText(f,a=0){return this.value+=P(this.supportThemeIcons?(0,M.escapeIcons)(f):f).replace(/([ \t]+)/g,(l,w)=>"&nbsp;".repeat(w.length)).replace(/\>/gm,"\\>").replace(/\n/g,a===1?`\\
`:`

`),this}appendMarkdown(f){return this.value+=f,this}appendCodeblock(f,a){return this.value+="\n```",this.value+=f,this.value+=`
`,this.value+=a,this.value+="\n```\n",this}}e.MarkdownString=R;function F(n){return C(n)?!n.value:Array.isArray(n)?n.every(F):!0}e.isEmptyMarkdownString=F;function C(n){return n instanceof R?!0:n&&typeof n=="object"?typeof n.value=="string"&&(typeof n.isTrusted=="boolean"||n.isTrusted===void 0)&&(typeof n.supportThemeIcons=="boolean"||n.supportThemeIcons===void 0):!1}e.isMarkdownString=C;function _(n,f){return n===f?!0:!n||!f?!1:n.value===f.value&&n.isTrusted===f.isTrusted&&n.supportThemeIcons===f.supportThemeIcons}e.markdownStringEqual=_;function P(n){return n.replace(/[\\`*_{}[\]()#+\-.!]/g,"\\$&")}e.escapeMarkdownSyntaxTokens=P;function t(n){return n&&n.replace(/\\([\\`*_{}[\]()#+\-.!])/g,"$1")}e.removeMarkdownEscapes=t;function E(n){const f=[],a=n.split("|").map(w=>w.trim());n=a[0];const l=a[1];if(l){const w=/height=(\d+)/.exec(l),I=/width=(\d+)/.exec(l),S=w?w[1]:"",o=I?I[1]:"",h=isFinite(parseInt(o)),y=isFinite(parseInt(S));h&&f.push(`width="${o}"`),y&&f.push(`height="${S}"`)}return{href:n,dimensions:f}}e.parseHrefAndDimensions=E}),define(we[54],Ee([0,1,22,9,2]),function(re,e,c,M,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.revive=e.MarshalledId=e.parse=e.stringify=void 0;function R(t){return JSON.stringify(t,_)}e.stringify=R;function F(t){let E=JSON.parse(t);return E=P(E),E}e.parse=F;var C;(function(t){t[t.Uri=1]="Uri",t[t.Regexp=2]="Regexp",t[t.ScmResource=3]="ScmResource",t[t.ScmResourceGroup=4]="ScmResourceGroup",t[t.ScmProvider=5]="ScmProvider",t[t.CommentController=6]="CommentController",t[t.CommentThread=7]="CommentThread",t[t.CommentThreadReply=8]="CommentThreadReply",t[t.CommentNode=9]="CommentNode",t[t.CommentThreadNode=10]="CommentThreadNode",t[t.TimelineActionContext=11]="TimelineActionContext",t[t.NotebookCellActionContext=12]="NotebookCellActionContext",t[t.TestItemContext=13]="TestItemContext"})(C=e.MarshalledId||(e.MarshalledId={}));function _(t,E){return E instanceof RegExp?{$mid:2,source:E.source,flags:(0,M.regExpFlags)(E)}:E}function P(t,E=0){if(!t||E>200)return t;if(typeof t=="object"){switch(t.$mid){case 1:return b.URI.revive(t);case 2:return new RegExp(t.source,t.flags)}if(t instanceof c.VSBuffer||t instanceof Uint8Array)return t;if(Array.isArray(t))for(let n=0;n<t.length;++n)t[n]=P(t[n],E+1);else for(const n in t)Object.hasOwnProperty.call(t,n)&&(t[n]=P(t[n],E+1))}return t}e.revive=P}),define(we[11],Ee([0,1,26,2]),function(re,e,c,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.FileAccess=e.RemoteAuthorities=e.Schemas=void 0;var b;(function(C){C.inMemory="inmemory",C.vscode="vscode",C.internal="private",C.walkThrough="walkThrough",C.walkThroughSnippet="walkThroughSnippet",C.http="http",C.https="https",C.file="file",C.mailto="mailto",C.untitled="untitled",C.data="data",C.command="command",C.vscodeRemote="vscode-remote",C.vscodeRemoteResource="vscode-remote-resource",C.userData="vscode-userdata",C.vscodeCustomEditor="vscode-custom-editor",C.vscodeNotebook="vscode-notebook",C.vscodeNotebookCell="vscode-notebook-cell",C.vscodeNotebookCellMetadata="vscode-notebook-cell-metadata",C.vscodeNotebookCellOutput="vscode-notebook-cell-output",C.vscodeInteractive="vscode-interactive",C.vscodeInteractiveInput="vscode-interactive-input",C.vscodeSettings="vscode-settings",C.vscodeWorkspaceTrust="vscode-workspace-trust",C.vscodeTerminal="vscode-terminal",C.webviewPanel="webview-panel",C.vscodeWebview="vscode-webview",C.extension="extension",C.vscodeFileResource="vscode-file",C.tmp="tmp"})(b=e.Schemas||(e.Schemas={}));class R{constructor(){this._hosts=Object.create(null),this._ports=Object.create(null),this._connectionTokens=Object.create(null),this._preferredWebSchema="http",this._delegate=null}setPreferredWebSchema(_){this._preferredWebSchema=_}setDelegate(_){this._delegate=_}set(_,P,t){this._hosts[_]=P,this._ports[_]=t}setConnectionToken(_,P){this._connectionTokens[_]=P}rewrite(_){if(this._delegate)return this._delegate(_);const P=_.authority;let t=this._hosts[P];t&&t.indexOf(":")!==-1&&(t=`[${t}]`);const E=this._ports[P],n=this._connectionTokens[P];let f=`path=${encodeURIComponent(_.path)}`;return typeof n=="string"&&(f+=`&tkn=${encodeURIComponent(n)}`),M.URI.from({scheme:c.isWeb?this._preferredWebSchema:b.vscodeRemoteResource,authority:`${t}:${E}`,path:"/vscode-remote-resource",query:f})}}e.RemoteAuthorities=new R;class F{asBrowserUri(_,P){const t=this.toUri(_,P);return t.scheme===b.vscodeRemote?e.RemoteAuthorities.rewrite(t):t.scheme===b.file&&(c.isNative||typeof c.globals.importScripts=="function"&&c.globals.origin===`${b.vscodeFileResource}://${F.FALLBACK_AUTHORITY}`)?t.with({scheme:b.vscodeFileResource,authority:t.authority||F.FALLBACK_AUTHORITY,query:null,fragment:null}):t}asFileUri(_,P){const t=this.toUri(_,P);return t.scheme===b.vscodeFileResource?t.with({scheme:b.file,authority:t.authority!==F.FALLBACK_AUTHORITY?t.authority:null,query:null,fragment:null}):t}toUri(_,P){return M.URI.isUri(_)?_:M.URI.parse(P.toUrl(_))}}F.FALLBACK_AUTHORITY="vscode-app",e.FileAccess=new F}),define(we[24],Ee([0,1,43,11,17,26,9,2]),function(re,e,c,M,b,R,F,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.toLocalResource=e.DataUri=e.distinctParents=e.addTrailingPathSeparator=e.removeTrailingPathSeparator=e.hasTrailingPathSeparator=e.isEqualAuthority=e.isAbsolutePath=e.resolvePath=e.relativePath=e.normalizePath=e.joinPath=e.dirname=e.extname=e.basename=e.basenameOrAuthority=e.getComparisonKey=e.isEqualOrParent=e.isEqual=e.extUriIgnorePathCase=e.extUriBiasedIgnorePathCase=e.extUri=e.ExtUri=e.originalFSPath=void 0;function _(f){return(0,C.uriToFsPath)(f,!0)}e.originalFSPath=_;class P{constructor(a){this._ignorePathCasing=a}compare(a,l,w=!1){return a===l?0:(0,F.compare)(this.getComparisonKey(a,w),this.getComparisonKey(l,w))}isEqual(a,l,w=!1){return a===l?!0:!a||!l?!1:this.getComparisonKey(a,w)===this.getComparisonKey(l,w)}getComparisonKey(a,l=!1){return a.with({path:this._ignorePathCasing(a)?a.path.toLowerCase():void 0,fragment:l?null:void 0}).toString()}ignorePathCasing(a){return this._ignorePathCasing(a)}isEqualOrParent(a,l,w=!1){if(a.scheme===l.scheme){if(a.scheme===M.Schemas.file)return c.isEqualOrParent(_(a),_(l),this._ignorePathCasing(a))&&a.query===l.query&&(w||a.fragment===l.fragment);if((0,e.isEqualAuthority)(a.authority,l.authority))return c.isEqualOrParent(a.path,l.path,this._ignorePathCasing(a),"/")&&a.query===l.query&&(w||a.fragment===l.fragment)}return!1}joinPath(a,...l){return C.URI.joinPath(a,...l)}basenameOrAuthority(a){return(0,e.basename)(a)||a.authority}basename(a){return b.posix.basename(a.path)}extname(a){return b.posix.extname(a.path)}dirname(a){if(a.path.length===0)return a;let l;return a.scheme===M.Schemas.file?l=C.URI.file(b.dirname(_(a))).path:(l=b.posix.dirname(a.path),a.authority&&l.length&&l.charCodeAt(0)!==47&&(console.error(`dirname("${a.toString})) resulted in a relative path`),l="/")),a.with({path:l})}normalizePath(a){if(!a.path.length)return a;let l;return a.scheme===M.Schemas.file?l=C.URI.file(b.normalize(_(a))).path:l=b.posix.normalize(a.path),a.with({path:l})}relativePath(a,l){if(a.scheme!==l.scheme||!(0,e.isEqualAuthority)(a.authority,l.authority))return;if(a.scheme===M.Schemas.file){const S=b.relative(_(a),_(l));return R.isWindows?c.toSlashes(S):S}let w=a.path||"/",I=l.path||"/";if(this._ignorePathCasing(a)){let S=0;for(const o=Math.min(w.length,I.length);S<o&&!(w.charCodeAt(S)!==I.charCodeAt(S)&&w.charAt(S).toLowerCase()!==I.charAt(S).toLowerCase());S++);w=I.substr(0,S)+w.substr(S)}return b.posix.relative(w,I)}resolvePath(a,l){if(a.scheme===M.Schemas.file){const w=C.URI.file(b.resolve(_(a),l));return a.with({authority:w.authority,path:w.path})}return l=c.toPosixPath(l),a.with({path:b.posix.resolve(a.path,l)})}isAbsolutePath(a){return!!a.path&&a.path[0]==="/"}isEqualAuthority(a,l){return a===l||(0,F.equalsIgnoreCase)(a,l)}hasTrailingPathSeparator(a,l=b.sep){if(a.scheme===M.Schemas.file){const w=_(a);return w.length>c.getRoot(w).length&&w[w.length-1]===l}else{const w=a.path;return w.length>1&&w.charCodeAt(w.length-1)===47&&!/^[a-zA-Z]:(\/$|\\$)/.test(a.fsPath)}}removeTrailingPathSeparator(a,l=b.sep){return(0,e.hasTrailingPathSeparator)(a,l)?a.with({path:a.path.substr(0,a.path.length-1)}):a}addTrailingPathSeparator(a,l=b.sep){let w=!1;if(a.scheme===M.Schemas.file){const I=_(a);w=I!==void 0&&I.length===c.getRoot(I).length&&I[I.length-1]===l}else{l="/";const I=a.path;w=I.length===1&&I.charCodeAt(I.length-1)===47}return!w&&!(0,e.hasTrailingPathSeparator)(a,l)?a.with({path:a.path+"/"}):a}}e.ExtUri=P,e.extUri=new P(()=>!1),e.extUriBiasedIgnorePathCase=new P(f=>f.scheme===M.Schemas.file?!R.isLinux:!0),e.extUriIgnorePathCase=new P(f=>!0),e.isEqual=e.extUri.isEqual.bind(e.extUri),e.isEqualOrParent=e.extUri.isEqualOrParent.bind(e.extUri),e.getComparisonKey=e.extUri.getComparisonKey.bind(e.extUri),e.basenameOrAuthority=e.extUri.basenameOrAuthority.bind(e.extUri),e.basename=e.extUri.basename.bind(e.extUri),e.extname=e.extUri.extname.bind(e.extUri),e.dirname=e.extUri.dirname.bind(e.extUri),e.joinPath=e.extUri.joinPath.bind(e.extUri),e.normalizePath=e.extUri.normalizePath.bind(e.extUri),e.relativePath=e.extUri.relativePath.bind(e.extUri),e.resolvePath=e.extUri.resolvePath.bind(e.extUri),e.isAbsolutePath=e.extUri.isAbsolutePath.bind(e.extUri),e.isEqualAuthority=e.extUri.isEqualAuthority.bind(e.extUri),e.hasTrailingPathSeparator=e.extUri.hasTrailingPathSeparator.bind(e.extUri),e.removeTrailingPathSeparator=e.extUri.removeTrailingPathSeparator.bind(e.extUri),e.addTrailingPathSeparator=e.extUri.addTrailingPathSeparator.bind(e.extUri);function t(f,a){const l=[];for(let w=0;w<f.length;w++){const I=a(f[w]);f.some((S,o)=>o===w?!1:(0,e.isEqualOrParent)(I,a(S)))||l.push(f[w])}return l}e.distinctParents=t;var E;(function(f){f.META_DATA_LABEL="label",f.META_DATA_DESCRIPTION="description",f.META_DATA_SIZE="size",f.META_DATA_MIME="mime";function a(l){const w=new Map;l.path.substring(l.path.indexOf(";")+1,l.path.lastIndexOf(";")).split(";").forEach(o=>{const[h,y]=o.split(":");h&&y&&w.set(h,y)});const S=l.path.substring(0,l.path.indexOf(";"));return S&&w.set(f.META_DATA_MIME,S),w}f.parseMetaData=a})(E=e.DataUri||(e.DataUri={}));function n(f,a,l){if(a){let w=f.path;return w&&w[0]!==b.posix.sep&&(w=b.posix.sep+w),f.with({scheme:l,authority:a,path:w})}return f.with({scheme:l})}e.toLocalResource=n}),define(we[14],Ee([0,1,21,16,3,6,24]),function(re,e,c,M,b,R,F){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Promises=e.DeferredPromise=e.IntervalCounter=e.TaskSequentializer=e.retry=e.IdleValue=e.runWhenIdle=e.ThrottledWorker=e.RunOnceWorker=e.ProcessTimeRunOnceScheduler=e.RunOnceScheduler=e.IntervalTimer=e.TimeoutTimer=e.ResourceQueue=e.Queue=e.Limiter=e.firstParallel=e.first=e.sequence=e.disposableTimeout=e.timeout=e.AutoOpenBarrier=e.Barrier=e.ThrottledDelayer=e.Delayer=e.SequencerByKey=e.Sequencer=e.Throttler=e.asPromise=e.raceTimeout=e.raceCancellablePromises=e.raceCancellation=e.createCancelablePromise=e.isThenable=void 0;function C($){return!!$&&typeof $.then=="function"}e.isThenable=C;function _($){const B=new c.CancellationTokenSource,z=$(B.token),Y=new Promise((ne,j)=>{const le=B.token.onCancellationRequested(()=>{le.dispose(),B.dispose(),j((0,M.canceled)())});Promise.resolve(z).then(oe=>{le.dispose(),B.dispose(),ne(oe)},oe=>{le.dispose(),B.dispose(),j(oe)})});return new class{cancel(){B.cancel()}then(ne,j){return Y.then(ne,j)}catch(ne){return this.then(void 0,ne)}finally(ne){return Y.finally(ne)}}}e.createCancelablePromise=_;function P($,B,z){return Promise.race([$,new Promise(Y=>B.onCancellationRequested(()=>Y(z)))])}e.raceCancellation=P;async function t($){let B=-1;const z=$.map((ne,j)=>ne.then(le=>(B=j,le))),Y=await Promise.race(z);return $.forEach((ne,j)=>{j!==B&&ne.cancel()}),Y}e.raceCancellablePromises=t;function E($,B,z){let Y;const ne=setTimeout(()=>{Y?.(void 0),z?.()},B);return Promise.race([$.finally(()=>clearTimeout(ne)),new Promise(j=>Y=j)])}e.raceTimeout=E;function n($){return new Promise((B,z)=>{const Y=$();C(Y)?Y.then(B,z):B(Y)})}e.asPromise=n;class f{constructor(){this.activePromise=null,this.queuedPromise=null,this.queuedPromiseFactory=null}queue(B){if(this.activePromise){if(this.queuedPromiseFactory=B,!this.queuedPromise){const z=()=>{this.queuedPromise=null;const Y=this.queue(this.queuedPromiseFactory);return this.queuedPromiseFactory=null,Y};this.queuedPromise=new Promise(Y=>{this.activePromise.then(z,z).then(Y)})}return new Promise((z,Y)=>{this.queuedPromise.then(z,Y)})}return this.activePromise=B(),new Promise((z,Y)=>{this.activePromise.then(ne=>{this.activePromise=null,z(ne)},ne=>{this.activePromise=null,Y(ne)})})}}e.Throttler=f;class a{constructor(){this.current=Promise.resolve(null)}queue(B){return this.current=this.current.then(()=>B(),()=>B())}}e.Sequencer=a;class l{constructor(){this.promiseMap=new Map}queue(B,z){const ne=(this.promiseMap.get(B)??Promise.resolve()).catch(()=>{}).then(z).finally(()=>{this.promiseMap.get(B)===ne&&this.promiseMap.delete(B)});return this.promiseMap.set(B,ne),ne}}e.SequencerByKey=l;class w{constructor(B){this.defaultDelay=B,this.timeout=null,this.completionPromise=null,this.doResolve=null,this.doReject=null,this.task=null}trigger(B,z=this.defaultDelay){return this.task=B,this.cancelTimeout(),this.completionPromise||(this.completionPromise=new Promise((Y,ne)=>{this.doResolve=Y,this.doReject=ne}).then(()=>{if(this.completionPromise=null,this.doResolve=null,this.task){const Y=this.task;return this.task=null,Y()}})),this.timeout=setTimeout(()=>{this.timeout=null,this.doResolve&&this.doResolve(null)},z),this.completionPromise}isTriggered(){return this.timeout!==null}cancel(){this.cancelTimeout(),this.completionPromise&&(this.doReject&&this.doReject((0,M.canceled)()),this.completionPromise=null)}cancelTimeout(){this.timeout!==null&&(clearTimeout(this.timeout),this.timeout=null)}dispose(){this.cancel()}}e.Delayer=w;class I{constructor(B){this.delayer=new w(B),this.throttler=new f}trigger(B,z){return this.delayer.trigger(()=>this.throttler.queue(B),z)}isTriggered(){return this.delayer.isTriggered()}cancel(){this.delayer.cancel()}dispose(){this.delayer.dispose()}}e.ThrottledDelayer=I;class S{constructor(){this._isOpen=!1,this._promise=new Promise((B,z)=>{this._completePromise=B})}isOpen(){return this._isOpen}open(){this._isOpen=!0,this._completePromise(!0)}wait(){return this._promise}}e.Barrier=S;class o extends S{constructor(B){super();this._timeout=setTimeout(()=>this.open(),B)}open(){clearTimeout(this._timeout),super.open()}}e.AutoOpenBarrier=o;function h($,B){return B?new Promise((z,Y)=>{const ne=setTimeout(()=>{j.dispose(),z()},$),j=B.onCancellationRequested(()=>{clearTimeout(ne),j.dispose(),Y((0,M.canceled)())})}):_(z=>h($,z))}e.timeout=h;function y($,B=0){const z=setTimeout($,B);return(0,R.toDisposable)(()=>clearTimeout(z))}e.disposableTimeout=y;function i($){const B=[];let z=0;const Y=$.length;function ne(){return z<Y?$[z++]():null}function j(le){le!=null&&B.push(le);const oe=ne();return oe?oe.then(j):Promise.resolve(B)}return Promise.resolve(null).then(j)}e.sequence=i;function v($,B=Y=>!!Y,z=null){let Y=0;const ne=$.length,j=()=>{if(Y>=ne)return Promise.resolve(z);const le=$[Y++];return Promise.resolve(le()).then(ve=>B(ve)?Promise.resolve(ve):j())};return j()}e.first=v;function r($,B=Y=>!!Y,z=null){if($.length===0)return Promise.resolve(z);let Y=$.length;const ne=()=>{Y=-1;for(const j of $)j.cancel?.()};return new Promise((j,le)=>{for(const oe of $)oe.then(ve=>{--Y>=0&&B(ve)?(ne(),j(ve)):Y===0&&j(z)}).catch(ve=>{--Y>=0&&(ne(),le(ve))})})}e.firstParallel=r;class s{constructor(B){this._size=0,this.maxDegreeOfParalellism=B,this.outstandingPromises=[],this.runningPromises=0,this._onFinished=new b.Emitter}get onFinished(){return this._onFinished.event}get size(){return this._size}queue(B){return this._size++,new Promise((z,Y)=>{this.outstandingPromises.push({factory:B,c:z,e:Y}),this.consume()})}consume(){for(;this.outstandingPromises.length&&this.runningPromises<this.maxDegreeOfParalellism;){const B=this.outstandingPromises.shift();this.runningPromises++;const z=B.factory();z.then(B.c,B.e),z.then(()=>this.consumed(),()=>this.consumed())}}consumed(){this._size--,this.runningPromises--,this.outstandingPromises.length>0?this.consume():this._onFinished.fire()}dispose(){this._onFinished.dispose()}}e.Limiter=s;class u extends s{constructor(){super(1)}}e.Queue=u;class d{constructor(){this.queues=new Map}queueFor(B,z=F.extUri){const Y=z.getComparisonKey(B);let ne=this.queues.get(Y);return ne||(ne=new u,b.Event.once(ne.onFinished)(()=>{ne?.dispose(),this.queues.delete(Y)}),this.queues.set(Y,ne)),ne}dispose(){this.queues.forEach(B=>B.dispose()),this.queues.clear()}}e.ResourceQueue=d;class p{constructor(B,z){this._token=-1,typeof B=="function"&&typeof z=="number"&&this.setIfNotSet(B,z)}dispose(){this.cancel()}cancel(){this._token!==-1&&(clearTimeout(this._token),this._token=-1)}cancelAndSet(B,z){this.cancel(),this._token=setTimeout(()=>{this._token=-1,B()},z)}setIfNotSet(B,z){this._token===-1&&(this._token=setTimeout(()=>{this._token=-1,B()},z))}}e.TimeoutTimer=p;class k{constructor(){this._token=-1}dispose(){this.cancel()}cancel(){this._token!==-1&&(clearInterval(this._token),this._token=-1)}cancelAndSet(B,z){this.cancel(),this._token=setInterval(()=>{B()},z)}}e.IntervalTimer=k;class T{constructor(B,z){this.timeoutToken=-1,this.runner=B,this.timeout=z,this.timeoutHandler=this.onTimeout.bind(this)}dispose(){this.cancel(),this.runner=null}cancel(){this.isScheduled()&&(clearTimeout(this.timeoutToken),this.timeoutToken=-1)}schedule(B=this.timeout){this.cancel(),this.timeoutToken=setTimeout(this.timeoutHandler,B)}get delay(){return this.timeout}set delay(B){this.timeout=B}isScheduled(){return this.timeoutToken!==-1}onTimeout(){this.timeoutToken=-1,this.runner&&this.doRun()}doRun(){this.runner&&this.runner()}}e.RunOnceScheduler=T;class g{constructor(B,z){z%1e3!=0&&console.warn(`ProcessTimeRunOnceScheduler resolution is 1s, ${z}ms is not a multiple of 1000ms.`),this.runner=B,this.timeout=z,this.counter=0,this.intervalToken=-1,this.intervalHandler=this.onInterval.bind(this)}dispose(){this.cancel(),this.runner=null}cancel(){this.isScheduled()&&(clearInterval(this.intervalToken),this.intervalToken=-1)}schedule(B=this.timeout){B%1e3!=0&&console.warn(`ProcessTimeRunOnceScheduler resolution is 1s, ${B}ms is not a multiple of 1000ms.`),this.cancel(),this.counter=Math.ceil(B/1e3),this.intervalToken=setInterval(this.intervalHandler,1e3)}isScheduled(){return this.intervalToken!==-1}onInterval(){this.counter--,!(this.counter>0)&&(clearInterval(this.intervalToken),this.intervalToken=-1,this.runner&&this.runner())}}e.ProcessTimeRunOnceScheduler=g;class D extends T{constructor(B,z){super(B,z);this.units=[]}work(B){this.units.push(B),this.isScheduled()||this.schedule()}doRun(){const B=this.units;this.units=[],this.runner&&this.runner(B)}dispose(){this.units=[],super.dispose()}}e.RunOnceWorker=D;class m extends R.Disposable{constructor(B,z,Y,ne){super();this.maxWorkChunkSize=B,this.maxPendingWork=z,this.throttleDelay=Y,this.handler=ne,this.pendingWork=[],this.throttler=this._register(new R.MutableDisposable),this.disposed=!1}get pending(){return this.pendingWork.length}work(B){if(this.disposed)return!1;if(typeof this.maxPendingWork=="number"){if(this.throttler.value){if(this.pending+B.length>this.maxPendingWork)return!1}else if(this.pending+B.length-this.maxWorkChunkSize>this.maxPendingWork)return!1}return this.pendingWork.push(...B),this.throttler.value||this.doWork(),!0}doWork(){this.handler(this.pendingWork.splice(0,this.maxWorkChunkSize)),this.pendingWork.length>0&&(this.throttler.value=new T(()=>{this.throttler.clear(),this.doWork()},this.throttleDelay),this.throttler.value.schedule())}dispose(){super.dispose(),this.disposed=!0}}e.ThrottledWorker=m,function(){if(typeof requestIdleCallback!="function"||typeof cancelIdleCallback!="function"){const $=Object.freeze({didTimeout:!0,timeRemaining(){return 15}});e.runWhenIdle=B=>{const z=setTimeout(()=>B($));let Y=!1;return{dispose(){Y||(Y=!0,clearTimeout(z))}}}}else e.runWhenIdle=($,B)=>{const z=requestIdleCallback($,typeof B=="number"?{timeout:B}:void 0);let Y=!1;return{dispose(){Y||(Y=!0,cancelIdleCallback(z))}}}}();class A{constructor(B){this._didRun=!1,this._executor=()=>{try{this._value=B()}catch(z){this._error=z}finally{this._didRun=!0}},this._handle=(0,e.runWhenIdle)(()=>this._executor())}dispose(){this._handle.dispose()}get value(){if(this._didRun||(this._handle.dispose(),this._executor()),this._error)throw this._error;return this._value}get isInitialized(){return this._didRun}}e.IdleValue=A;async function L($,B,z){let Y;for(let ne=0;ne<z;ne++)try{return await $()}catch(j){Y=j,await h(B)}throw Y}e.retry=L;class V{hasPending(B){return this._pending?typeof B=="number"?this._pending.taskId===B:!!this._pending:!1}get pending(){return this._pending?this._pending.promise:void 0}cancelPending(){this._pending?.cancel()}setPending(B,z,Y){return this._pending={taskId:B,cancel:()=>Y?.(),promise:z},z.then(()=>this.donePending(B),()=>this.donePending(B)),z}donePending(B){this._pending&&B===this._pending.taskId&&(this._pending=void 0,this.triggerNext())}triggerNext(){if(this._next){const B=this._next;this._next=void 0,B.run().then(B.promiseResolve,B.promiseReject)}}setNext(B){if(this._next)this._next.run=B;else{let z,Y;const ne=new Promise((j,le)=>{z=j,Y=le});this._next={run:B,promise:ne,promiseResolve:z,promiseReject:Y}}return this._next.promise}}e.TaskSequentializer=V;class G{constructor(B){this.interval=B,this.lastIncrementTime=0,this.value=0}increment(){const B=Date.now();return B-this.lastIncrementTime>this.interval&&(this.lastIncrementTime=B,this.value=0),this.value++,this.value}}e.IntervalCounter=G;class U{constructor(){this.rejected=!1,this.resolved=!1,this.p=new Promise((B,z)=>{this.completeCallback=B,this.errorCallback=z})}get isRejected(){return this.rejected}get isResolved(){return this.resolved}get isSettled(){return this.rejected||this.resolved}complete(B){return new Promise(z=>{this.completeCallback(B),this.resolved=!0,z()})}error(B){return new Promise(z=>{this.errorCallback(B),this.rejected=!0,z()})}cancel(){new Promise(B=>{this.errorCallback((0,M.canceled)()),this.rejected=!0,B()})}}e.DeferredPromise=U;var K;(function($){async function B(z){let Y;const ne=await Promise.all(z.map(j=>j.then(le=>le,le=>{Y||(Y=le)})));if(typeof Y!="undefined")throw Y;return ne}$.settled=B})(K=e.Promises||(e.Promises={}))}),define(we[108],Ee([0,1,14,17]),function(re,e,c,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.compareByPrefix=e.compareAnything=e.comparePaths=e.compareFileExtensionsUnicode=e.compareFileExtensionsLower=e.compareFileExtensionsUpper=e.compareFileExtensionsDefault=e.compareFileExtensions=e.noIntlCompareFileNames=e.compareFileNamesUnicode=e.compareFileNamesLower=e.compareFileNamesUpper=e.compareFileNamesDefault=e.compareFileNames=void 0;const b=new c.IdleValue(()=>{const T=new Intl.Collator(void 0,{numeric:!0,sensitivity:"base"});return{collator:T,collatorIsNumeric:T.resolvedOptions().numeric}}),R=new c.IdleValue(()=>({collator:new Intl.Collator(void 0,{numeric:!0})})),F=new c.IdleValue(()=>({collator:new Intl.Collator(void 0,{numeric:!0,sensitivity:"accent"})}));function C(T,g,D=!1){const m=T||"",A=g||"",L=b.value.collator.compare(m,A);return b.value.collatorIsNumeric&&L===0&&m!==A?m<A?-1:1:L}e.compareFileNames=C;function _(T,g){const D=R.value.collator;return T=T||"",g=g||"",y(D,T,g)}e.compareFileNamesDefault=_;function P(T,g){const D=R.value.collator;return T=T||"",g=g||"",s(T,g)||y(D,T,g)}e.compareFileNamesUpper=P;function t(T,g){const D=R.value.collator;return T=T||"",g=g||"",r(T,g)||y(D,T,g)}e.compareFileNamesLower=t;function E(T,g){return T=T||"",g=g||"",T===g?0:T<g?-1:1}e.compareFileNamesUnicode=E;function n(T,g,D=!1){D||(T=T&&T.toLowerCase(),g=g&&g.toLowerCase());const[m,A]=o(T),[L,V]=o(g);return m!==L?m<L?-1:1:A===V?0:A<V?-1:1}e.noIntlCompareFileNames=n;function f(T,g){const[D,m]=o(T),[A,L]=o(g);let V=b.value.collator.compare(m,L);if(V===0){if(b.value.collatorIsNumeric&&m!==L)return m<L?-1:1;if(V=b.value.collator.compare(D,A),b.value.collatorIsNumeric&&V===0&&D!==A)return D<A?-1:1}return V}e.compareFileExtensions=f;function a(T,g){T=T||"",g=g||"";const D=h(T),m=h(g),A=R.value.collator,L=F.value.collator;return y(L,D,m)||y(A,T,g)}e.compareFileExtensionsDefault=a;function l(T,g){T=T||"",g=g||"";const D=h(T),m=h(g),A=R.value.collator,L=F.value.collator;return y(L,D,m)||s(T,g)||y(A,T,g)}e.compareFileExtensionsUpper=l;function w(T,g){T=T||"",g=g||"";const D=h(T),m=h(g),A=R.value.collator,L=F.value.collator;return y(L,D,m)||r(T,g)||y(A,T,g)}e.compareFileExtensionsLower=w;function I(T,g){T=T||"",g=g||"";const D=h(T).toLowerCase(),m=h(g).toLowerCase();return D!==m?D<m?-1:1:T!==g?T<g?-1:1:0}e.compareFileExtensionsUnicode=I;const S=/^(.*?)(\.([^.]*))?$/;function o(T,g=!1){const D=T?S.exec(T):[];let m=[D&&D[1]||"",D&&D[3]||""];return g&&(!m[0]&&m[1]||m[0]&&m[0].charAt(0)===".")&&(m=[m[0]+"."+m[1],""]),m}function h(T){const g=T?S.exec(T):[];return g&&g[1]&&g[1].charAt(0)!=="."&&g[3]||""}function y(T,g,D){let m=T.compare(g,D);return m!==0?m:g.length!==D.length?g.length<D.length?-1:1:0}function i(T){const g=T.charAt(0);return g.toLocaleUpperCase()!==g}function v(T){const g=T.charAt(0);return g.toLocaleLowerCase()!==g}function r(T,g){return i(T)&&v(g)?-1:v(T)&&i(g)?1:0}function s(T,g){return v(T)&&i(g)?-1:i(T)&&v(g)?1:0}function u(T,g,D=!1){return D||(T=T&&T.toLowerCase(),g=g&&g.toLowerCase()),T===g?0:T<g?-1:1}function d(T,g,D=!1){const m=T.split(M.sep),A=g.split(M.sep),L=m.length-1,V=A.length-1;let G,U;for(let K=0;;K++){if(G=L===K,U=V===K,G&&U)return C(m[K],A[K],D);if(G)return-1;if(U)return 1;const $=u(m[K],A[K],D);if($!==0)return $}}e.comparePaths=d;function p(T,g,D){const m=T.toLowerCase(),A=g.toLowerCase(),L=k(T,g,D);if(L)return L;const V=m.endsWith(D),G=A.endsWith(D);if(V!==G)return V?-1:1;const U=C(m,A);return U!==0?U:m.localeCompare(A)}e.compareAnything=p;function k(T,g,D){const m=T.toLowerCase(),A=g.toLowerCase(),L=m.startsWith(D),V=A.startsWith(D);if(L!==V)return L?-1:1;if(L&&V){if(m.length<A.length)return-1;if(m.length>A.length)return 1}return 0}e.compareByPrefix=k}),define(we[27],Ee([0,1,14,43,20,17,9]),function(re,e,c,M,b,R,F){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getPathTerms=e.getBasenameTerms=e.isRelativePattern=e.hasSiblingFn=e.hasSiblingPromiseFn=e.parse=e.match=e.splitGlobAware=e.getEmptyExpression=void 0;function C(){return Object.create(null)}e.getEmptyExpression=C;const _="**",P="/",t="[/\\\\]",E="[^/\\\\]",n=/\//g;function f(Y){switch(Y){case 0:return"";case 1:return`${E}*?`;default:return`(?:${t}|${E}+${t}|${t}${E}+)*?`}}function a(Y,ne){if(!Y)return[];const j=[];let le=!1,oe=!1,ve="";for(const Re of Y){switch(Re){case ne:if(!le&&!oe){j.push(ve),ve="";continue}break;case"{":le=!0;break;case"}":le=!1;break;case"[":oe=!0;break;case"]":oe=!1;break}ve+=Re}return ve&&j.push(ve),j}e.splitGlobAware=a;function l(Y){if(!Y)return"";let ne="";const j=a(Y,P);if(j.every(le=>le===_))ne=".*";else{let le=!1;j.forEach((oe,ve)=>{if(oe===_){le||(ne+=f(2),le=!0);return}let Re=!1,Me="",Oe=!1,Ye="";for(const Ve of oe){if(Ve!=="}"&&Re){Me+=Ve;continue}if(Oe&&(Ve!=="]"||!Ye)){let qe;Ve==="-"?qe=Ve:(Ve==="^"||Ve==="!")&&!Ye?qe="^":Ve===P?qe="":qe=F.escapeRegExpCharacters(Ve),Ye+=qe;continue}switch(Ve){case"{":Re=!0;continue;case"[":Oe=!0;continue;case"}":ne+=`(?:${a(Me,",").map(Q=>l(Q)).join("|")})`,Re=!1,Me="";break;case"]":ne+="["+Ye+"]",Oe=!1,Ye="";break;case"?":ne+=E;continue;case"*":ne+=f(1);continue;default:ne+=F.escapeRegExpCharacters(Ve)}}ve<j.length-1&&(j[ve+1]!==_||ve+2<j.length)&&(ne+=t),le=!1})}return ne}const w=/^\*\*\/\*\.[\w\.-]+$/,I=/^\*\*\/([\w\.-]+)\/?$/,S=/^{\*\*\/[\*\.]?[\w\.-]+\/?(,\*\*\/[\*\.]?[\w\.-]+\/?)*}$/,o=/^{\*\*\/[\*\.]?[\w\.-]+(\/(\*\*)?)?(,\*\*\/[\*\.]?[\w\.-]+(\/(\*\*)?)?)*}$/,h=/^\*\*((\/[\w\.-]+)+)\/?$/,y=/^([\w\.-]+(\/[\w\.-]+)*)\/?$/,i=new b.LRUCache(1e4),v=function(){return!1},r=function(){return null};function s(Y,ne){if(!Y)return r;let j;typeof Y!="string"?j=Y.pattern:j=Y,j=j.trim();const le=`${j}_${!!ne.trimForExclusions}`;let oe=i.get(le);if(oe)return u(oe,Y);let ve;if(w.test(j)){const Re=j.substr(4);oe=function(Me,Oe){return typeof Me=="string"&&Me.endsWith(Re)?j:null}}else(ve=I.exec(d(j,ne)))?oe=p(ve[1],j):(ne.trimForExclusions?o:S).test(j)?oe=k(j,ne):(ve=h.exec(d(j,ne)))?oe=T(ve[1].substr(1),j,!0):(ve=y.exec(d(j,ne)))?oe=T(ve[1],j,!1):oe=g(j);return i.set(le,oe),u(oe,Y)}function u(Y,ne){return typeof ne=="string"?Y:function(j,le){return M.isEqualOrParent(j,ne.base)?Y(R.relative(ne.base,j),le):null}}function d(Y,ne){return ne.trimForExclusions&&Y.endsWith("/**")?Y.substr(0,Y.length-2):Y}function p(Y,ne){const j=`/${Y}`,le=`\\${Y}`,oe=function(Re,Me){return typeof Re!="string"?null:Me?Me===Y?ne:null:Re===Y||Re.endsWith(j)||Re.endsWith(le)?ne:null},ve=[Y];return oe.basenames=ve,oe.patterns=[ne],oe.allBasenames=ve,oe}function k(Y,ne){const j=z(Y.slice(1,-1).split(",").map(Me=>s(Me,ne)).filter(Me=>Me!==r),Y),le=j.length;if(!le)return r;if(le===1)return j[0];const oe=function(Me,Oe){for(let Ye=0,Ve=j.length;Ye<Ve;Ye++)if(j[Ye](Me,Oe))return Y;return null},ve=j.find(Me=>!!Me.allBasenames);ve&&(oe.allBasenames=ve.allBasenames);const Re=j.reduce((Me,Oe)=>Oe.allPaths?Me.concat(Oe.allPaths):Me,[]);return Re.length&&(oe.allPaths=Re),oe}function T(Y,ne,j){const le=R.sep===R.posix.sep,oe=le?Y:Y.replace(n,R.sep),ve=R.sep+oe,Re=R.posix.sep+Y,Me=j?function(Oe,Ye){return typeof Oe=="string"&&(Oe===oe||Oe.endsWith(ve)||!le&&(Oe===Y||Oe.endsWith(Re)))?ne:null}:function(Oe,Ye){return typeof Oe=="string"&&(Oe===oe||!le&&Oe===Y)?ne:null};return Me.allPaths=[(j?"*/":"./")+Y],Me}function g(Y){try{const ne=new RegExp(`^${l(Y)}$`);return function(j){return ne.lastIndex=0,typeof j=="string"&&ne.test(j)?Y:null}}catch(ne){return r}}function D(Y,ne,j){return!Y||typeof ne!="string"?!1:m(Y)(ne,void 0,j)}e.match=D;function m(Y,ne={}){if(!Y)return v;if(typeof Y=="string"||G(Y)){const j=s(Y,ne);if(j===r)return v;const le=function(oe,ve){return!!j(oe,ve)};return j.allBasenames&&(le.allBasenames=j.allBasenames),j.allPaths&&(le.allPaths=j.allPaths),le}return $(Y,ne)}e.parse=m;function A(Y){if(!Y)return;let ne;return j=>(ne||(ne=(Y()||Promise.resolve([])).then(le=>le?V(le):{})),ne.then(le=>!!le[j]))}e.hasSiblingPromiseFn=A;function L(Y){if(!Y)return;let ne;return j=>{if(!ne){const le=Y();ne=le?V(le):{}}return!!ne[j]}}e.hasSiblingFn=L;function V(Y){const ne={};for(const j of Y)ne[j]=!0;return ne}function G(Y){const ne=Y;return ne&&typeof ne.base=="string"&&typeof ne.pattern=="string"}e.isRelativePattern=G;function U(Y){return Y.allBasenames||[]}e.getBasenameTerms=U;function K(Y){return Y.allPaths||[]}e.getPathTerms=K;function $(Y,ne){const j=z(Object.getOwnPropertyNames(Y).map(Me=>B(Me,Y[Me],ne)).filter(Me=>Me!==r)),le=j.length;if(!le)return r;if(!j.some(Me=>!!Me.requiresSiblings)){if(le===1)return j[0];const Me=function(Ve,qe){for(let x=0,Q=j.length;x<Q;x++){const te=j[x](Ve,qe);if(te)return te}return null},Oe=j.find(Ve=>!!Ve.allBasenames);Oe&&(Me.allBasenames=Oe.allBasenames);const Ye=j.reduce((Ve,qe)=>qe.allPaths?Ve.concat(qe.allPaths):Ve,[]);return Ye.length&&(Me.allPaths=Ye),Me}const oe=function(Me,Oe,Ye){let Ve;for(let qe=0,x=j.length;qe<x;qe++){const Q=j[qe];Q.requiresSiblings&&Ye&&(Oe||(Oe=R.basename(Me)),Ve||(Ve=Oe.substr(0,Oe.length-R.extname(Me).length)));const te=Q(Me,Oe,Ve,Ye);if(te)return te}return null},ve=j.find(Me=>!!Me.allBasenames);ve&&(oe.allBasenames=ve.allBasenames);const Re=j.reduce((Me,Oe)=>Oe.allPaths?Me.concat(Oe.allPaths):Me,[]);return Re.length&&(oe.allPaths=Re),oe}function B(Y,ne,j){if(ne===!1)return r;const le=s(Y,j);if(le===r)return r;if(typeof ne=="boolean")return le;if(ne){const oe=ne.when;if(typeof oe=="string"){const ve=(Re,Me,Oe,Ye)=>{if(!Ye||!le(Re,Me))return null;const Ve=oe.replace("$(basename)",Oe),qe=Ye(Ve);return(0,c.isThenable)(qe)?qe.then(x=>x?Y:null):qe?Y:null};return ve.requiresSiblings=!0,ve}}return le}function z(Y,ne){const j=Y.filter(Me=>!!Me.basenames);if(j.length<2)return Y;const le=j.reduce((Me,Oe)=>{const Ye=Oe.basenames;return Ye?Me.concat(Ye):Me},[]);let oe;if(ne){oe=[];for(let Me=0,Oe=le.length;Me<Oe;Me++)oe.push(ne)}else oe=j.reduce((Me,Oe)=>{const Ye=Oe.patterns;return Ye?Me.concat(Ye):Me},[]);const ve=function(Me,Oe){if(typeof Me!="string")return null;if(!Oe){let Ve;for(Ve=Me.length;Ve>0;Ve--){const qe=Me.charCodeAt(Ve-1);if(qe===47||qe===92)break}Oe=Me.substr(Ve)}const Ye=le.indexOf(Oe);return Ye!==-1?oe[Ye]:null};ve.basenames=le,ve.patterns=oe,ve.allBasenames=le;const Re=Y.filter(Me=>!Me.basenames);return Re.push(ve),Re}}),define(we[77],Ee([0,1,43,11,17,26,24,9,2]),function(re,e,c,M,b,R,F,C,_){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.splitName=e.unmnemonicLabel=e.mnemonicButtonLabel=e.mnemonicMenuLabel=e.template=e.shorten=e.untildify=e.tildify=e.normalizeDriveLetter=e.getBaseLabel=e.getPathLabel=void 0;function P(s,u,d){if(typeof s=="string"&&(s=_.URI.file(s)),d){const k=d.getWorkspaceFolder(s);if(k){const T=d.getWorkspace().folders.length>1;let g;if((0,F.isEqual)(k.uri,s)?g="":g=(0,F.relativePath)(k.uri,s),T){const D=k.name?k.name:(0,F.basename)(k.uri);g=g?D+" \u2022 "+g:D}return g}}if(s.scheme!==M.Schemas.file&&s.scheme!==M.Schemas.untitled)return s.with({query:null,fragment:null}).toString(!0);if((0,c.hasDriveLetter)(s.fsPath))return(0,b.normalize)(E(s.fsPath));let p=(0,b.normalize)(s.fsPath);return!R.isWindows&&u?.userHome&&(p=f(p,u.userHome.fsPath)),p}e.getPathLabel=P;function t(s){if(!s)return;typeof s=="string"&&(s=_.URI.file(s));const u=(0,F.basename)(s)||(s.scheme===M.Schemas.file?s.fsPath:s.path);return R.isWindows&&(0,c.isRootOrDriveLetter)(u)?E(u):u}e.getBaseLabel=t;function E(s){return(0,c.hasDriveLetter)(s)?s.charAt(0).toUpperCase()+s.slice(1):s}e.normalizeDriveLetter=E;let n=Object.create(null);function f(s,u){if(R.isWindows||!s||!u)return s;let d=n.original===u?n.normalized:void 0;return d||(d=`${(0,C.rtrim)(u,b.posix.sep)}${b.posix.sep}`,n={original:u,normalized:d}),(R.isLinux?s.startsWith(d):(0,C.startsWithIgnoreCase)(s,d))&&(s=`~/${s.substr(d.length)}`),s}e.tildify=f;function a(s,u){return s.replace(/^~($|\/|\\)/,`${u}$1`)}e.untildify=a;const l="\u2026",w="\\\\",I="~";function S(s,u=b.sep){const d=new Array(s.length);let p=!1;for(let k=0;k<s.length;k++){let T=s[k];if(T===""){d[k]=`.${u}`;continue}if(!T){d[k]=T;continue}p=!0;let g="";T.indexOf(w)===0?(g=T.substr(0,T.indexOf(w)+w.length),T=T.substr(T.indexOf(w)+w.length)):T.indexOf(u)===0?(g=T.substr(0,T.indexOf(u)+u.length),T=T.substr(T.indexOf(u)+u.length)):T.indexOf(I)===0&&(g=T.substr(0,T.indexOf(I)+I.length),T=T.substr(T.indexOf(I)+I.length));const D=T.split(u);for(let m=1;p&&m<=D.length;m++)for(let A=D.length-m;p&&A>=0;A--){p=!1;let L=D.slice(A,A+m).join(u);for(let V=0;!p&&V<s.length;V++)if(V!==k&&s[V]&&s[V].indexOf(L)>-1){const G=A+m===D.length,U=A>0&&s[V].indexOf(u)>-1?u+L:L,K=s[V].endsWith(U);p=!G||K}if(!p){let V="";(D[0].endsWith(":")||g!=="")&&(A===1&&(A=0,m++,L=D[0]+u+L),A>0&&(V=D[0]+u),V=g+V),A>0&&(V=V+l+u),V=V+L,A+m<D.length&&(V=V+u+l),d[k]=V}}p&&(d[k]=T)}return d}e.shorten=S;var o;(function(s){s[s.TEXT=0]="TEXT",s[s.VARIABLE=1]="VARIABLE",s[s.SEPARATOR=2]="SEPARATOR"})(o||(o={}));function h(s,u=Object.create(null)){const d=[];let p=!1,k="";for(const T of s)if(T==="$"||p&&T==="{")k&&d.push({value:k,type:o.TEXT}),k="",p=!0;else if(T==="}"&&p){const g=u[k];if(typeof g=="string")g.length&&d.push({value:g,type:o.VARIABLE});else if(g){const D=d[d.length-1];(!D||D.type!==o.SEPARATOR)&&d.push({value:g.label,type:o.SEPARATOR})}k="",p=!1}else k+=T;return k&&!p&&d.push({value:k,type:o.TEXT}),d.filter((T,g)=>{if(T.type===o.SEPARATOR){const D=d[g-1],m=d[g+1];return[D,m].every(A=>A&&(A.type===o.VARIABLE||A.type===o.TEXT)&&A.value.length>0)}return!0}).map(T=>T.value).join("")}e.template=h;function y(s,u){return R.isMacintosh||u?s.replace(/\(&&\w\)|&&/g,"").replace(/&/g,R.isMacintosh?"&":"&&"):s.replace(/&&|&/g,d=>d==="&"?"&&":"&")}e.mnemonicMenuLabel=y;function i(s,u){return R.isMacintosh||u?s.replace(/\(&&\w\)|&&/g,""):R.isWindows?s.replace(/&&|&/g,d=>d==="&"?"&&":"&"):s.replace(/&&/g,"_")}e.mnemonicButtonLabel=i;function v(s){return s.replace(/&/g,"&&")}e.unmnemonicLabel=v;function r(s){const u=s.indexOf("/")!==-1?b.posix:b.win32,d=u.basename(s),p=u.dirname(s);return d.length?{name:d,parentPath:p}:{name:p,parentPath:""}}e.splitName=r}),define(we[78],Ee([0,1,27,11,17,24,9]),function(re,e,c,M,b,R,F){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.normalizeMimeType=e.getExtensionForMimeType=e.getMediaMime=e.getMediaOrTextMime=e.isUnspecific=e.guessMimeTypes=e.clearTextMimes=e.registerTextMime=e.Mimes=void 0;var C;(function(s){s.text="text/plain",s.binary="application/octet-stream",s.unknown="application/unknown",s.markdown="text/markdown"})(C=e.Mimes||(e.Mimes={}));let _=[],P=[],t=[];function E(s,u=!1){const d=n(s);_.push(d),d.userConfigured?t.push(d):P.push(d),u&&!d.userConfigured&&_.forEach(p=>{p.mime===d.mime||p.userConfigured||(d.extension&&p.extension===d.extension&&console.warn(`Overwriting extension <<${d.extension}>> to now point to mime <<${d.mime}>>`),d.filename&&p.filename===d.filename&&console.warn(`Overwriting filename <<${d.filename}>> to now point to mime <<${d.mime}>>`),d.filepattern&&p.filepattern===d.filepattern&&console.warn(`Overwriting filepattern <<${d.filepattern}>> to now point to mime <<${d.mime}>>`),d.firstline&&p.firstline===d.firstline&&console.warn(`Overwriting firstline <<${d.firstline}>> to now point to mime <<${d.mime}>>`))})}e.registerTextMime=E;function n(s){return{id:s.id,mime:s.mime,filename:s.filename,extension:s.extension,filepattern:s.filepattern,firstline:s.firstline,userConfigured:s.userConfigured,filenameLowercase:s.filename?s.filename.toLowerCase():void 0,extensionLowercase:s.extension?s.extension.toLowerCase():void 0,filepatternLowercase:s.filepattern?(0,c.parse)(s.filepattern.toLowerCase()):void 0,filepatternOnPath:s.filepattern?s.filepattern.indexOf(b.posix.sep)>=0:!1}}function f(s){s?(_=_.filter(u=>!u.userConfigured),t=[]):(_=[],P=[],t=[])}e.clearTextMimes=f;function a(s,u){let d;if(s)switch(s.scheme){case M.Schemas.file:d=s.fsPath;break;case M.Schemas.data:d=R.DataUri.parseMetaData(s).get(R.DataUri.META_DATA_LABEL);break;default:d=s.path}if(!d)return[C.unknown];d=d.toLowerCase();const p=(0,b.basename)(d),k=l(d,p,t);if(k)return[k,C.text];const T=l(d,p,P);if(T)return[T,C.text];if(u){const g=w(u);if(g)return[g,C.text]}return[C.unknown]}e.guessMimeTypes=a;function l(s,u,d){let p=null,k=null,T=null;for(let g=d.length-1;g>=0;g--){const D=d[g];if(u===D.filenameLowercase){p=D;break}if(D.filepattern&&(!k||D.filepattern.length>k.filepattern.length)){const m=D.filepatternOnPath?s:u;D.filepatternLowercase?.(m)&&(k=D)}D.extension&&(!T||D.extension.length>T.extension.length)&&u.endsWith(D.extensionLowercase)&&(T=D)}return p?p.mime:k?k.mime:T?T.mime:null}function w(s){if((0,F.startsWithUTF8BOM)(s)&&(s=s.substr(1)),s.length>0)for(let u=_.length-1;u>=0;u--){const d=_[u];if(!d.firstline)continue;const p=s.match(d.firstline);if(p&&p.length>0)return d.mime}return null}function I(s){return s?typeof s=="string"?s===C.binary||s===C.text||s===C.unknown:s.length===1&&I(s[0]):!0}e.isUnspecific=I;const S={".css":"text/css",".csv":"text/csv",".htm":"text/html",".html":"text/html",".ics":"text/calendar",".js":"text/javascript",".mjs":"text/javascript",".txt":"text/plain",".xml":"text/xml"},o={".aac":"audio/x-aac",".avi":"video/x-msvideo",".bmp":"image/bmp",".flv":"video/x-flv",".gif":"image/gif",".ico":"image/x-icon",".jpe":"image/jpg",".jpeg":"image/jpg",".jpg":"image/jpg",".m1v":"video/mpeg",".m2a":"audio/mpeg",".m2v":"video/mpeg",".m3a":"audio/mpeg",".mid":"audio/midi",".midi":"audio/midi",".mk3d":"video/x-matroska",".mks":"video/x-matroska",".mkv":"video/x-matroska",".mov":"video/quicktime",".movie":"video/x-sgi-movie",".mp2":"audio/mpeg",".mp2a":"audio/mpeg",".mp3":"audio/mpeg",".mp4":"video/mp4",".mp4a":"audio/mp4",".mp4v":"video/mp4",".mpe":"video/mpeg",".mpeg":"video/mpeg",".mpg":"video/mpeg",".mpg4":"video/mp4",".mpga":"audio/mpeg",".oga":"audio/ogg",".ogg":"audio/ogg",".ogv":"video/ogg",".png":"image/png",".psd":"image/vnd.adobe.photoshop",".qt":"video/quicktime",".spx":"audio/ogg",".svg":"image/svg+xml",".tga":"image/x-tga",".tif":"image/tiff",".tiff":"image/tiff",".wav":"audio/x-wav",".webm":"video/webm",".webp":"image/webp",".wma":"audio/x-ms-wma",".wmv":"video/x-ms-wmv",".woff":"application/font-woff"};function h(s){const u=(0,b.extname)(s),d=S[u.toLowerCase()];return d!==void 0?d:y(s)}e.getMediaOrTextMime=h;function y(s){const u=(0,b.extname)(s);return o[u.toLowerCase()]}e.getMediaMime=y;function i(s){for(const u in o)if(o[u]===s)return u}e.getExtensionForMimeType=i;const v=/^(.+)\/(.+?)(;.+)?$/;function r(s,u){const d=v.exec(s);return d?`${d[1].toLowerCase()}/${d[2].toLowerCase()}${d[3]??""}`:u?void 0:s}e.normalizeMimeType=r}),define(we[109],Ee([0,1,2]),function(re,e,c){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.transformAndReviveIncomingURIs=e.transformIncomingURIs=e.transformOutgoingURIs=e.DefaultURITransformer=e.URITransformer=void 0;function M(t){return t.toJSON()}class b{constructor(E){this._uriTransformer=E}transformIncoming(E){const n=this._uriTransformer.transformIncoming(E);return n===E?E:M(c.URI.from(n))}transformOutgoing(E){const n=this._uriTransformer.transformOutgoing(E);return n===E?E:M(c.URI.from(n))}transformOutgoingURI(E){const n=this._uriTransformer.transformOutgoing(E);return n===E?E:c.URI.from(n)}transformOutgoingScheme(E){return this._uriTransformer.transformOutgoingScheme(E)}}e.URITransformer=b,e.DefaultURITransformer=new class{transformIncoming(t){return t}transformOutgoing(t){return t}transformOutgoingURI(t){return t}transformOutgoingScheme(t){return t}};function R(t,E,n){if(!t||n>200)return null;if(typeof t=="object"){if(t instanceof c.URI)return E.transformOutgoing(t);for(let f in t)if(Object.hasOwnProperty.call(t,f)){const a=R(t[f],E,n+1);a!==null&&(t[f]=a)}}return null}function F(t,E){const n=R(t,E,0);return n===null?t:n}e.transformOutgoingURIs=F;function C(t,E,n,f){if(!t||f>200)return null;if(typeof t=="object"){if(t.$mid===1)return n?c.URI.revive(E.transformIncoming(t)):E.transformIncoming(t);for(let a in t)if(Object.hasOwnProperty.call(t,a)){const l=C(t[a],E,n,f+1);l!==null&&(t[a]=l)}}return null}function _(t,E){const n=C(t,E,!1,0);return n===null?t:n}e.transformIncomingURIs=_;function P(t,E){const n=C(t,E,!0,0);return n===null?t:n}e.transformAndReviveIncomingURIs=P}),define(we[36],Ee([0,1]),function(re,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.generateUuid=e.isUUID=void 0;const c=/^[0-9a-f]{8}-[0-9a-f]{4}-[0-9a-f]{4}-[0-9a-f]{4}-[0-9a-f]{12}$/i;function M(_){return c.test(_)}e.isUUID=M;const b=new Uint8Array(16),R=[];for(let _=0;_<256;_++)R.push(_.toString(16).padStart(2,"0"));let F;typeof crypto=="object"&&typeof crypto.getRandomValues=="function"?F=crypto.getRandomValues.bind(crypto):F=function(_){for(let P=0;P<_.length;P++)_[P]=Math.floor(Math.random()*256);return _};function C(){F(b),b[6]=b[6]&15|64,b[8]=b[8]&63|128;let _=0,P="";return P+=R[b[_++]],P+=R[b[_++]],P+=R[b[_++]],P+=R[b[_++]],P+="-",P+=R[b[_++]],P+=R[b[_++]],P+="-",P+=R[b[_++]],P+=R[b[_++]],P+="-",P+=R[b[_++]],P+=R[b[_++]],P+="-",P+=R[b[_++]],P+=R[b[_++]],P+=R[b[_++]],P+=R[b[_++]],P+=R[b[_++]],P+=R[b[_++]],P}e.generateUuid=C}),define(we[110],Ee([0,1,226]),function(re,e,c){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getMapForWordSeparators=e.WordCharacterClassifier=e.WordCharacterClass=void 0;var M;(function(F){F[F.Regular=0]="Regular",F[F.Whitespace=1]="Whitespace",F[F.WordSeparator=2]="WordSeparator"})(M=e.WordCharacterClass||(e.WordCharacterClass={}));class b extends c.CharacterClassifier{constructor(C){super(0);for(let _=0,P=C.length;_<P;_++)this.set(C.charCodeAt(_),2);this.set(32,1),this.set(9,1)}}e.WordCharacterClassifier=b;function R(F){let C={};return _=>(C.hasOwnProperty(_)||(C[_]=F(_)),C[_])}e.getMapForWordSeparators=R(F=>new b(F))}),define(we[79],Ee([0,1,23]),function(re,e,c){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ApplyEditsResult=e.ValidAnnotatedEditOperation=e.ModelConstants=e.PositionAffinity=e.TrackedRangeStickiness=e.FindMatch=e.TextModelResolvedOptions=e.EndOfLineSequence=e.DefaultEndOfLine=e.EndOfLinePreference=e.MinimapPosition=e.OverviewRulerLane=void 0;var M;(function(l){l[l.Left=1]="Left",l[l.Center=2]="Center",l[l.Right=4]="Right",l[l.Full=7]="Full"})(M=e.OverviewRulerLane||(e.OverviewRulerLane={}));var b;(function(l){l[l.Inline=1]="Inline",l[l.Gutter=2]="Gutter"})(b=e.MinimapPosition||(e.MinimapPosition={}));var R;(function(l){l[l.TextDefined=0]="TextDefined",l[l.LF=1]="LF",l[l.CRLF=2]="CRLF"})(R=e.EndOfLinePreference||(e.EndOfLinePreference={}));var F;(function(l){l[l.LF=1]="LF",l[l.CRLF=2]="CRLF"})(F=e.DefaultEndOfLine||(e.DefaultEndOfLine={}));var C;(function(l){l[l.LF=0]="LF",l[l.CRLF=1]="CRLF"})(C=e.EndOfLineSequence||(e.EndOfLineSequence={}));class _{constructor(w){this._textModelResolvedOptionsBrand=void 0,this.tabSize=Math.max(1,w.tabSize|0),this.indentSize=w.tabSize|0,this.insertSpaces=Boolean(w.insertSpaces),this.defaultEOL=w.defaultEOL|0,this.trimAutoWhitespace=Boolean(w.trimAutoWhitespace),this.bracketPairColorizationOptions=w.bracketPairColorizationOptions}equals(w){return this.tabSize===w.tabSize&&this.indentSize===w.indentSize&&this.insertSpaces===w.insertSpaces&&this.defaultEOL===w.defaultEOL&&this.trimAutoWhitespace===w.trimAutoWhitespace&&(0,c.equals)(this.bracketPairColorizationOptions,w.bracketPairColorizationOptions)}createChangeEvent(w){return{tabSize:this.tabSize!==w.tabSize,indentSize:this.indentSize!==w.indentSize,insertSpaces:this.insertSpaces!==w.insertSpaces,trimAutoWhitespace:this.trimAutoWhitespace!==w.trimAutoWhitespace}}}e.TextModelResolvedOptions=_;class P{constructor(w,I){this._findMatchBrand=void 0,this.range=w,this.matches=I}}e.FindMatch=P;var t;(function(l){l[l.AlwaysGrowsWhenTypingAtEdges=0]="AlwaysGrowsWhenTypingAtEdges",l[l.NeverGrowsWhenTypingAtEdges=1]="NeverGrowsWhenTypingAtEdges",l[l.GrowsOnlyWhenTypingBefore=2]="GrowsOnlyWhenTypingBefore",l[l.GrowsOnlyWhenTypingAfter=3]="GrowsOnlyWhenTypingAfter"})(t=e.TrackedRangeStickiness||(e.TrackedRangeStickiness={}));var E;(function(l){l[l.Left=0]="Left",l[l.Right=1]="Right",l[l.None=2]="None"})(E=e.PositionAffinity||(e.PositionAffinity={}));var n;(function(l){l[l.FIRST_LINE_DETECTION_LENGTH_LIMIT=1e3]="FIRST_LINE_DETECTION_LENGTH_LIMIT"})(n=e.ModelConstants||(e.ModelConstants={}));class f{constructor(w,I,S,o,h,y){this.identifier=w,this.range=I,this.text=S,this.forceMoveMarkers=o,this.isAutoWhitespaceEdit=h,this._isTracked=y}}e.ValidAnnotatedEditOperation=f;class a{constructor(w,I,S){this.reverseEdits=w,this.changes=I,this.trimAutoWhitespaceLineNumbers=S}}e.ApplyEditsResult=a}),define(we[111],Ee([0,1,9,110,112,44,79]),function(re,e,c,M,b,R,F){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Searcher=e.isValidMatch=e.TextModelSearch=e.createFindMatch=e.SearchData=e.isMultilineRegexSource=e.SearchParams=void 0;const C=999;class _{constructor(o,h,y,i){this.searchString=o,this.isRegex=h,this.matchCase=y,this.wordSeparators=i}parseSearchRequest(){if(this.searchString==="")return null;let o;this.isRegex?o=P(this.searchString):o=this.searchString.indexOf(`
`)>=0;let h=null;try{h=c.createRegExp(this.searchString,this.isRegex,{matchCase:this.matchCase,wholeWord:!1,multiline:o,global:!0,unicode:!0})}catch(i){return null}if(!h)return null;let y=!this.isRegex&&!o;return y&&this.searchString.toLowerCase()!==this.searchString.toUpperCase()&&(y=this.matchCase),new t(h,this.wordSeparators?(0,M.getMapForWordSeparators)(this.wordSeparators):null,y?this.searchString:null)}}e.SearchParams=_;function P(S){if(!S||S.length===0)return!1;for(let o=0,h=S.length;o<h;o++)if(S.charCodeAt(o)===92){if(o++,o>=h)break;const i=S.charCodeAt(o);if(i===110||i===114||i===87||i===119)return!0}return!1}e.isMultilineRegexSource=P;class t{constructor(o,h,y){this.regex=o,this.wordSeparators=h,this.simpleSearch=y}}e.SearchData=t;function E(S,o,h){if(!h)return new F.FindMatch(S,null);let y=[];for(let i=0,v=o.length;i<v;i++)y[i]=o[i];return new F.FindMatch(S,y)}e.createFindMatch=E;class n{constructor(o){let h=[],y=0;for(let i=0,v=o.length;i<v;i++)o.charCodeAt(i)===10&&(h[y++]=i);this._lineFeedsOffsets=h}findLineFeedCountBeforeOffset(o){const h=this._lineFeedsOffsets;let y=0,i=h.length-1;if(i===-1||o<=h[0])return 0;for(;y<i;){const v=y+((i-y)/2>>0);h[v]>=o?i=v-1:h[v+1]>=o?(y=v,i=v):y=v+1}return y+1}}class f{static findMatches(o,h,y,i,v){const r=h.parseSearchRequest();return r?r.regex.multiline?this._doFindMatchesMultiline(o,y,new I(r.wordSeparators,r.regex),i,v):this._doFindMatchesLineByLine(o,y,r,i,v):[]}static _getMultilineMatchRange(o,h,y,i,v,r){let s,u=0;i?(u=i.findLineFeedCountBeforeOffset(v),s=h+v+u):s=h+v;let d;if(i){let g=i.findLineFeedCountBeforeOffset(v+r.length)-u;d=s+r.length+g}else d=s+r.length;const p=o.getPositionAt(s),k=o.getPositionAt(d);return new R.Range(p.lineNumber,p.column,k.lineNumber,k.column)}static _doFindMatchesMultiline(o,h,y,i,v){const r=o.getOffsetAt(h.getStartPosition()),s=o.getValueInRange(h,1),u=o.getEOL()===`\r
`?new n(s):null,d=[];let p=0,k;for(y.reset(0);k=y.next(s);)if(d[p++]=E(this._getMultilineMatchRange(o,r,s,u,k.index,k[0]),k,i),p>=v)return d;return d}static _doFindMatchesLineByLine(o,h,y,i,v){const r=[];let s=0;if(h.startLineNumber===h.endLineNumber){const d=o.getLineContent(h.startLineNumber).substring(h.startColumn-1,h.endColumn-1);return s=this._findMatchesInLine(y,d,h.startLineNumber,h.startColumn-1,s,r,i,v),r}const u=o.getLineContent(h.startLineNumber).substring(h.startColumn-1);s=this._findMatchesInLine(y,u,h.startLineNumber,h.startColumn-1,s,r,i,v);for(let d=h.startLineNumber+1;d<h.endLineNumber&&s<v;d++)s=this._findMatchesInLine(y,o.getLineContent(d),d,0,s,r,i,v);if(s<v){const d=o.getLineContent(h.endLineNumber).substring(0,h.endColumn-1);s=this._findMatchesInLine(y,d,h.endLineNumber,0,s,r,i,v)}return r}static _findMatchesInLine(o,h,y,i,v,r,s,u){const d=o.wordSeparators;if(!s&&o.simpleSearch){const T=o.simpleSearch,g=T.length,D=h.length;let m=-g;for(;(m=h.indexOf(T,m+g))!==-1;)if((!d||w(d,h,D,m,g))&&(r[v++]=new F.FindMatch(new R.Range(y,m+1+i,y,m+1+g+i),null),v>=u))return v;return v}const p=new I(o.wordSeparators,o.regex);let k;p.reset(0);do if(k=p.next(h),k&&(r[v++]=E(new R.Range(y,k.index+1+i,y,k.index+1+k[0].length+i),k,s),v>=u))return v;while(k);return v}static findNextMatch(o,h,y,i){const v=h.parseSearchRequest();if(!v)return null;const r=new I(v.wordSeparators,v.regex);return v.regex.multiline?this._doFindNextMatchMultiline(o,y,r,i):this._doFindNextMatchLineByLine(o,y,r,i)}static _doFindNextMatchMultiline(o,h,y,i){const v=new b.Position(h.lineNumber,1),r=o.getOffsetAt(v),s=o.getLineCount(),u=o.getValueInRange(new R.Range(v.lineNumber,v.column,s,o.getLineMaxColumn(s)),1),d=o.getEOL()===`\r
`?new n(u):null;y.reset(h.column-1);let p=y.next(u);return p?E(this._getMultilineMatchRange(o,r,u,d,p.index,p[0]),p,i):h.lineNumber!==1||h.column!==1?this._doFindNextMatchMultiline(o,new b.Position(1,1),y,i):null}static _doFindNextMatchLineByLine(o,h,y,i){const v=o.getLineCount(),r=h.lineNumber,s=o.getLineContent(r),u=this._findFirstMatchInLine(y,s,r,h.column,i);if(u)return u;for(let d=1;d<=v;d++){const p=(r+d-1)%v,k=o.getLineContent(p+1),T=this._findFirstMatchInLine(y,k,p+1,1,i);if(T)return T}return null}static _findFirstMatchInLine(o,h,y,i,v){o.reset(i-1);const r=o.next(h);return r?E(new R.Range(y,r.index+1,y,r.index+1+r[0].length),r,v):null}static findPreviousMatch(o,h,y,i){const v=h.parseSearchRequest();if(!v)return null;const r=new I(v.wordSeparators,v.regex);return v.regex.multiline?this._doFindPreviousMatchMultiline(o,y,r,i):this._doFindPreviousMatchLineByLine(o,y,r,i)}static _doFindPreviousMatchMultiline(o,h,y,i){const v=this._doFindMatchesMultiline(o,new R.Range(1,1,h.lineNumber,h.column),y,i,10*C);if(v.length>0)return v[v.length-1];const r=o.getLineCount();return h.lineNumber!==r||h.column!==o.getLineMaxColumn(r)?this._doFindPreviousMatchMultiline(o,new b.Position(r,o.getLineMaxColumn(r)),y,i):null}static _doFindPreviousMatchLineByLine(o,h,y,i){const v=o.getLineCount(),r=h.lineNumber,s=o.getLineContent(r).substring(0,h.column-1),u=this._findLastMatchInLine(y,s,r,i);if(u)return u;for(let d=1;d<=v;d++){const p=(v+r-d-1)%v,k=o.getLineContent(p+1),T=this._findLastMatchInLine(y,k,p+1,i);if(T)return T}return null}static _findLastMatchInLine(o,h,y,i){let v=null,r;for(o.reset(0);r=o.next(h);)v=E(new R.Range(y,r.index+1,y,r.index+1+r[0].length),r,i);return v}}e.TextModelSearch=f;function a(S,o,h,y,i){if(y===0)return!0;const v=o.charCodeAt(y-1);if(S.get(v)!==0||v===13||v===10)return!0;if(i>0){const r=o.charCodeAt(y);if(S.get(r)!==0)return!0}return!1}function l(S,o,h,y,i){if(y+i===h)return!0;const v=o.charCodeAt(y+i);if(S.get(v)!==0||v===13||v===10)return!0;if(i>0){const r=o.charCodeAt(y+i-1);if(S.get(r)!==0)return!0}return!1}function w(S,o,h,y,i){return a(S,o,h,y,i)&&l(S,o,h,y,i)}e.isValidMatch=w;class I{constructor(o,h){this._wordSeparators=o,this._searchRegex=h,this._prevMatchStartIndex=-1,this._prevMatchLength=0}reset(o){this._searchRegex.lastIndex=o,this._prevMatchStartIndex=-1,this._prevMatchLength=0}next(o){const h=o.length;let y;do{if(this._prevMatchStartIndex+this._prevMatchLength===h||(y=this._searchRegex.exec(o),!y))return null;const i=y.index,v=y[0].length;if(i===this._prevMatchStartIndex&&v===this._prevMatchLength){if(v===0){c.getNextCodePoint(o,h,this._searchRegex.lastIndex)>65535?this._searchRegex.lastIndex+=2:this._searchRegex.lastIndex+=1;continue}return null}if(this._prevMatchStartIndex=i,this._prevMatchLength=v,!this._wordSeparators||w(this._wordSeparators,o,h,i,v))return y}while(y);return null}}e.Searcher=I}),define(we[113],Ee([0,1]),function(re,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.AutoClosingPairs=e.StandardAutoClosingPairConditional=e.IndentAction=void 0;var c;(function(F){F[F.None=0]="None",F[F.Indent=1]="Indent",F[F.IndentOutdent=2]="IndentOutdent",F[F.Outdent=3]="Outdent"})(c=e.IndentAction||(e.IndentAction={}));class M{constructor(C){if(this._standardAutoClosingPairConditionalBrand=void 0,this.open=C.open,this.close=C.close,this._standardTokenMask=0,Array.isArray(C.notIn))for(let _=0,P=C.notIn.length;_<P;_++)switch(C.notIn[_]){case"string":this._standardTokenMask|=2;break;case"comment":this._standardTokenMask|=1;break;case"regex":this._standardTokenMask|=4;break}}isOK(C){return(this._standardTokenMask&C)==0}}e.StandardAutoClosingPairConditional=M;class b{constructor(C){this.autoClosingPairsOpenByStart=new Map,this.autoClosingPairsOpenByEnd=new Map,this.autoClosingPairsCloseByStart=new Map,this.autoClosingPairsCloseByEnd=new Map,this.autoClosingPairsCloseSingleChar=new Map;for(const _ of C)R(this.autoClosingPairsOpenByStart,_.open.charAt(0),_),R(this.autoClosingPairsOpenByEnd,_.open.charAt(_.open.length-1),_),R(this.autoClosingPairsCloseByStart,_.close.charAt(0),_),R(this.autoClosingPairsCloseByEnd,_.close.charAt(_.close.length-1),_),_.close.length===1&&_.open.length===1&&R(this.autoClosingPairsCloseSingleChar,_.close,_)}}e.AutoClosingPairs=b;function R(F,C,_){F.has(C)?F.get(C).push(_):F.set(C,[_])}}),define(we[55],Ee([0,1,27,17]),function(re,e,c,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.score=void 0;function b(R,F,C,_){if(Array.isArray(R)){let P=0;for(const t of R){const E=b(t,F,C,_);if(E===10)return E;E>P&&(P=E)}return P}else{if(typeof R=="string")return _?R==="*"?5:R===C?10:0:0;if(R){const{language:P,pattern:t,scheme:E,hasAccessToAllModels:n}=R;if(!_&&!n)return 0;let f=0;if(E)if(E===F.scheme)f=10;else if(E==="*")f=5;else return 0;if(P)if(P===C)f=10;else if(P==="*")f=Math.max(f,5);else return 0;if(t){let a;if(typeof t=="string"?a=t:a={...t,base:(0,M.normalize)(t.base)},a===F.fsPath||(0,c.match)(a,F.fsPath))f=10;else return 0}return f}else return 0}}e.score=b}),define(we[114],Ee([0,1,3,6]),function(re,e,c,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TokenizationRegistryImpl=void 0;class b{constructor(){this._map=new Map,this._promises=new Map,this._onDidChange=new c.Emitter,this.onDidChange=this._onDidChange.event,this._colorMap=null}fire(F){this._onDidChange.fire({changedLanguages:F,changedColorMap:!1})}register(F,C){return this._map.set(F,C),this.fire([F]),(0,M.toDisposable)(()=>{this._map.get(F)===C&&(this._map.delete(F),this.fire([F]))})}registerPromise(F,C){let _=null,P=!1;return this._promises.set(F,C.then(t=>{this._promises.delete(F),!(P||!t)&&(_=this.register(F,t))})),(0,M.toDisposable)(()=>{P=!0,_&&_.dispose()})}getPromise(F){const C=this.get(F);if(C)return Promise.resolve(C);const _=this._promises.get(F);return _?_.then(P=>this.get(F)):null}get(F){return this._map.get(F)||null}setColorMap(F){this._colorMap=F,this._onDidChange.fire({changedLanguages:Array.from(this._map.keys()),changedColorMap:!0})}getColorMap(){return this._colorMap}getDefaultBackground(){return this._colorMap&&this._colorMap.length>2?this._colorMap[2]:null}}e.TokenizationRegistryImpl=b}),define(we[80],Ee([0,1,22,26]),function(re,e,c,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.decodeSemanticTokensDto=e.encodeSemanticTokensDto=void 0;var b;(function(E){E[E.Full=1]="Full",E[E.Delta=2]="Delta"})(b||(b={}));function R(E){for(let n=0,f=E.length;n<f;n+=4){const a=E[n+0],l=E[n+1],w=E[n+2],I=E[n+3];E[n+0]=I,E[n+1]=w,E[n+2]=l,E[n+3]=a}}function F(E){const n=new Uint8Array(E.buffer,E.byteOffset,E.length*4);return M.isLittleEndian()||R(n),c.VSBuffer.wrap(n)}function C(E){const n=E.buffer;if(M.isLittleEndian()||R(n),n.byteOffset%4==0)return new Uint32Array(n.buffer,n.byteOffset,n.length/4);{const f=new Uint8Array(n.byteLength);return f.set(n),new Uint32Array(f.buffer,f.byteOffset,f.length/4)}}function _(E){const n=new Uint32Array(P(E));let f=0;if(n[f++]=E.id,E.type==="full")n[f++]=1,n[f++]=E.data.length,n.set(E.data,f),f+=E.data.length;else{n[f++]=2,n[f++]=E.deltas.length;for(const a of E.deltas)n[f++]=a.start,n[f++]=a.deleteCount,a.data?(n[f++]=a.data.length,n.set(a.data,f),f+=a.data.length):n[f++]=0}return F(n)}e.encodeSemanticTokensDto=_;function P(E){let n=0;if(n+=1+1,E.type==="full")n+=1+E.data.length;else{n+=1,n+=(1+1+1)*E.deltas.length;for(const f of E.deltas)f.data&&(n+=f.data.length)}return n}function t(E){const n=C(E);let f=0;const a=n[f++];if(n[f++]===1){const S=n[f++],o=n.subarray(f,f+S);return f+=S,{id:a,type:"full",data:o}}const w=n[f++];let I=[];for(let S=0;S<w;S++){const o=n[f++],h=n[f++],y=n[f++];let i;y>0&&(i=n.subarray(f,f+y),f+=y),I[S]={start:o,deleteCount:h,data:i}}return{id:a,type:"delta",deltas:I}}e.decodeSemanticTokensDto=t}),define(we[115],Ee([18,19]),function(re,e){return re.create("vs/base/common/errorMessage",e)}),define(we[56],Ee([0,1,12,10,115]),function(re,e,c,M,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.toErrorMessage=void 0;function R(P,t){return t&&(P.stack||P.stacktrace)?b.localize(0,null,C(P),F(P.stack)||F(P.stacktrace)):C(P)}function F(P){return Array.isArray(P)?P.join(`
`):P}function C(P){return typeof P.code=="string"&&typeof P.errno=="number"&&typeof P.syscall=="string"?b.localize(1,null,P.message):P.message||b.localize(2,null)}function _(P=null,t=!1){if(!P)return b.localize(3,null);if(Array.isArray(P)){const E=c.coalesce(P),n=_(E[0],t);return E.length>1?b.localize(4,null,n,E.length):n}if(M.isString(P))return P;if(P.detail){const E=P.detail;if(E.error)return R(E.error,t);if(E.exception)return R(E.exception,t)}return P.stack?R(P,t):P.message?P.message:b.localize(5,null)}e.toErrorMessage=_}),define(we[116],Ee([18,19]),function(re,e){return re.create("vs/editor/common/config/editorOptions",e)}),define(we[117],Ee([0,1,116,26,118]),function(re,e,c,M,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.EditorOptions=e.EditorOption=e.editorOptionsRegistry=e.EDITOR_MODEL_DEFAULTS=e.EDITOR_FONT_DEFAULTS=e.WrappingIndent=e.filterValidationDecorations=e.RenderLineNumbersType=e.EditorLayoutInfoComputer=e.RenderMinimap=e.EditorFontLigatures=e.cursorStyleToString=e.TextEditorCursorStyle=e.TextEditorCursorBlinkingStyle=e.stringSet=e.clampedInt=e.boolean=e.ComputeOptionsMemory=e.ValidatedEditorOptions=e.ConfigurationChangedEvent=e.MINIMAP_GUTTER_WIDTH=e.EditorAutoIndentStrategy=void 0;var R;(function(H){H[H.None=0]="None",H[H.Keep=1]="Keep",H[H.Brackets=2]="Brackets",H[H.Advanced=3]="Advanced",H[H.Full=4]="Full"})(R=e.EditorAutoIndentStrategy||(e.EditorAutoIndentStrategy={})),e.MINIMAP_GUTTER_WIDTH=8;class F{constructor(J){this._values=J}hasChanged(J){return this._values[J]}}e.ConfigurationChangedEvent=F;class C{constructor(){this._values=[]}_read(J){return this._values[J]}get(J){return this._values[J]}_write(J,fe){this._values[J]=fe}}e.ValidatedEditorOptions=C;class _{constructor(){this.stableMinimapLayoutInput=null,this.stableFitMaxMinimapScale=0,this.stableFitRemainingWidth=0}}e.ComputeOptionsMemory=_;class P{constructor(J,fe,xe,Qe){this.id=J,this.name=fe,this.defaultValue=xe,this.schema=Qe}compute(J,fe,xe){return xe}}class t{constructor(J,fe=null){this.schema=void 0,this.id=J,this.name="_never_",this.defaultValue=void 0,this.deps=fe}validate(J){return this.defaultValue}}class E{constructor(J,fe,xe,Qe){this.id=J,this.name=fe,this.defaultValue=xe,this.schema=Qe}validate(J){return typeof J=="undefined"?this.defaultValue:J}compute(J,fe,xe){return xe}}function n(H,J){return typeof H=="undefined"?J:H==="false"?!1:Boolean(H)}e.boolean=n;class f extends E{constructor(J,fe,xe,Qe=void 0){typeof Qe!="undefined"&&(Qe.type="boolean",Qe.default=xe),super(J,fe,xe,Qe)}validate(J){return n(J,this.defaultValue)}}function a(H,J,fe,xe){if(typeof H=="undefined")return J;let Qe=parseInt(H,10);return isNaN(Qe)?J:(Qe=Math.max(fe,Qe),Qe=Math.min(xe,Qe),Qe|0)}e.clampedInt=a;class l extends E{constructor(J,fe,xe,Qe,rt,ct=void 0){typeof ct!="undefined"&&(ct.type="integer",ct.default=xe,ct.minimum=Qe,ct.maximum=rt),super(J,fe,xe,ct),this.minimum=Qe,this.maximum=rt}static clampedInt(J,fe,xe,Qe){return a(J,fe,xe,Qe)}validate(J){return l.clampedInt(J,this.defaultValue,this.minimum,this.maximum)}}class w extends E{constructor(J,fe,xe,Qe,rt){typeof rt!="undefined"&&(rt.type="number",rt.default=xe),super(J,fe,xe,rt),this.validationFn=Qe}static clamp(J,fe,xe){return J<fe?fe:J>xe?xe:J}static float(J,fe){if(typeof J=="number")return J;if(typeof J=="undefined")return fe;const xe=parseFloat(J);return isNaN(xe)?fe:xe}validate(J){return this.validationFn(w.float(J,this.defaultValue))}}class I extends E{static string(J,fe){return typeof J!="string"?fe:J}constructor(J,fe,xe,Qe=void 0){typeof Qe!="undefined"&&(Qe.type="string",Qe.default=xe),super(J,fe,xe,Qe)}validate(J){return I.string(J,this.defaultValue)}}function S(H,J,fe){return typeof H!="string"||fe.indexOf(H)===-1?J:H}e.stringSet=S;class o extends E{constructor(J,fe,xe,Qe,rt=void 0){typeof rt!="undefined"&&(rt.type="string",rt.enum=Qe,rt.default=xe),super(J,fe,xe,rt),this._allowedValues=Qe}validate(J){return S(J,this.defaultValue,this._allowedValues)}}class h extends P{constructor(J,fe,xe,Qe,rt,ct,ft=void 0){typeof ft!="undefined"&&(ft.type="string",ft.enum=rt,ft.default=Qe),super(J,fe,xe,ft),this._allowedValues=rt,this._convert=ct}validate(J){return typeof J!="string"?this.defaultValue:this._allowedValues.indexOf(J)===-1?this.defaultValue:this._convert(J)}}function y(H){switch(H){case"none":return 0;case"keep":return 1;case"brackets":return 2;case"advanced":return 3;case"full":return 4}}class i extends P{constructor(){super(2,"accessibilitySupport",0,{type:"string",enum:["auto","on","off"],enumDescriptions:[c.localize(0,null),c.localize(1,null),c.localize(2,null)],default:"auto",description:c.localize(3,null)})}validate(J){switch(J){case"auto":return 0;case"off":return 1;case"on":return 2}return this.defaultValue}compute(J,fe,xe){return xe===0?J.accessibilitySupport:xe}}class v extends P{constructor(){const J={insertSpace:!0,ignoreEmptyLines:!0};super(18,"comments",J,{"editor.comments.insertSpace":{type:"boolean",default:J.insertSpace,description:c.localize(4,null)},"editor.comments.ignoreEmptyLines":{type:"boolean",default:J.ignoreEmptyLines,description:c.localize(5,null)}})}validate(J){if(!J||typeof J!="object")return this.defaultValue;const fe=J;return{insertSpace:n(fe.insertSpace,this.defaultValue.insertSpace),ignoreEmptyLines:n(fe.ignoreEmptyLines,this.defaultValue.ignoreEmptyLines)}}}var r;(function(H){H[H.Hidden=0]="Hidden",H[H.Blink=1]="Blink",H[H.Smooth=2]="Smooth",H[H.Phase=3]="Phase",H[H.Expand=4]="Expand",H[H.Solid=5]="Solid"})(r=e.TextEditorCursorBlinkingStyle||(e.TextEditorCursorBlinkingStyle={}));function s(H){switch(H){case"blink":return 1;case"smooth":return 2;case"phase":return 3;case"expand":return 4;case"solid":return 5}}var u;(function(H){H[H.Line=1]="Line",H[H.Block=2]="Block",H[H.Underline=3]="Underline",H[H.LineThin=4]="LineThin",H[H.BlockOutline=5]="BlockOutline",H[H.UnderlineThin=6]="UnderlineThin"})(u=e.TextEditorCursorStyle||(e.TextEditorCursorStyle={}));function d(H){switch(H){case u.Line:return"line";case u.Block:return"block";case u.Underline:return"underline";case u.LineThin:return"line-thin";case u.BlockOutline:return"block-outline";case u.UnderlineThin:return"underline-thin"}}e.cursorStyleToString=d;function p(H){switch(H){case"line":return u.Line;case"block":return u.Block;case"underline":return u.Underline;case"line-thin":return u.LineThin;case"block-outline":return u.BlockOutline;case"underline-thin":return u.UnderlineThin}}class k extends t{constructor(){super(128,[66,32])}compute(J,fe,xe){const Qe=["monaco-editor"];return fe.get(32)&&Qe.push(fe.get(32)),J.extraEditorClassName&&Qe.push(J.extraEditorClassName),fe.get(66)==="default"?Qe.push("mouse-default"):fe.get(66)==="copy"&&Qe.push("mouse-copy"),fe.get(101)&&Qe.push("showUnused"),fe.get(126)&&Qe.push("showDeprecated"),Qe.join(" ")}}class T extends f{constructor(){super(31,"emptySelectionClipboard",!0,{description:c.localize(6,null)})}compute(J,fe,xe){return xe&&J.emptySelectionClipboard}}class g extends P{constructor(){const J={cursorMoveOnType:!0,seedSearchStringFromSelection:"always",autoFindInSelection:"never",globalFindClipboard:!1,addExtraSpaceOnTop:!0,loop:!0};super(34,"find",J,{"editor.find.cursorMoveOnType":{type:"boolean",default:J.cursorMoveOnType,description:c.localize(7,null)},"editor.find.seedSearchStringFromSelection":{type:"string",enum:["never","always","selection"],default:J.seedSearchStringFromSelection,enumDescriptions:[c.localize(8,null),c.localize(9,null),c.localize(10,null)],description:c.localize(11,null)},"editor.find.autoFindInSelection":{type:"string",enum:["never","always","multiline"],default:J.autoFindInSelection,enumDescriptions:[c.localize(12,null),c.localize(13,null),c.localize(14,null)],description:c.localize(15,null)},"editor.find.globalFindClipboard":{type:"boolean",default:J.globalFindClipboard,description:c.localize(16,null),included:M.isMacintosh},"editor.find.addExtraSpaceOnTop":{type:"boolean",default:J.addExtraSpaceOnTop,description:c.localize(17,null)},"editor.find.loop":{type:"boolean",default:J.loop,description:c.localize(18,null)}})}validate(J){if(!J||typeof J!="object")return this.defaultValue;const fe=J;return{cursorMoveOnType:n(fe.cursorMoveOnType,this.defaultValue.cursorMoveOnType),seedSearchStringFromSelection:typeof J.seedSearchStringFromSelection=="boolean"?J.seedSearchStringFromSelection?"always":"never":S(fe.seedSearchStringFromSelection,this.defaultValue.seedSearchStringFromSelection,["never","always","selection"]),autoFindInSelection:typeof J.autoFindInSelection=="boolean"?J.autoFindInSelection?"always":"never":S(fe.autoFindInSelection,this.defaultValue.autoFindInSelection,["never","always","multiline"]),globalFindClipboard:n(fe.globalFindClipboard,this.defaultValue.globalFindClipboard),addExtraSpaceOnTop:n(fe.addExtraSpaceOnTop,this.defaultValue.addExtraSpaceOnTop),loop:n(fe.loop,this.defaultValue.loop)}}}class D extends P{constructor(){super(43,"fontLigatures",D.OFF,{anyOf:[{type:"boolean",description:c.localize(19,null)},{type:"string",description:c.localize(20,null)}],description:c.localize(21,null),default:!1})}validate(J){return typeof J=="undefined"?this.defaultValue:typeof J=="string"?J==="false"?D.OFF:J==="true"?D.ON:J:Boolean(J)?D.ON:D.OFF}}e.EditorFontLigatures=D,D.OFF='"liga" off, "calt" off',D.ON='"liga" on, "calt" on';class m extends t{constructor(){super(42)}compute(J,fe,xe){return J.fontInfo}}class A extends E{constructor(){super(44,"fontSize",e.EDITOR_FONT_DEFAULTS.fontSize,{type:"number",minimum:6,maximum:100,default:e.EDITOR_FONT_DEFAULTS.fontSize,description:c.localize(22,null)})}validate(J){let fe=w.float(J,this.defaultValue);return fe===0?e.EDITOR_FONT_DEFAULTS.fontSize:w.clamp(fe,6,100)}compute(J,fe,xe){return J.fontInfo.fontSize}}class L extends P{constructor(){super(45,"fontWeight",e.EDITOR_FONT_DEFAULTS.fontWeight,{anyOf:[{type:"number",minimum:L.MINIMUM_VALUE,maximum:L.MAXIMUM_VALUE,errorMessage:c.localize(23,null)},{type:"string",pattern:"^(normal|bold|1000|[1-9][0-9]{0,2})$"},{enum:L.SUGGESTION_VALUES}],default:e.EDITOR_FONT_DEFAULTS.fontWeight,description:c.localize(24,null)})}validate(J){return J==="normal"||J==="bold"?J:String(l.clampedInt(J,e.EDITOR_FONT_DEFAULTS.fontWeight,L.MINIMUM_VALUE,L.MAXIMUM_VALUE))}}L.SUGGESTION_VALUES=["normal","bold","100","200","300","400","500","600","700","800","900"],L.MINIMUM_VALUE=1,L.MAXIMUM_VALUE=1e3;class V extends P{constructor(){const J={multiple:"peek",multipleDefinitions:"peek",multipleTypeDefinitions:"peek",multipleDeclarations:"peek",multipleImplementations:"peek",multipleReferences:"peek",alternativeDefinitionCommand:"editor.action.goToReferences",alternativeTypeDefinitionCommand:"editor.action.goToReferences",alternativeDeclarationCommand:"editor.action.goToReferences",alternativeImplementationCommand:"",alternativeReferenceCommand:""},fe={type:"string",enum:["peek","gotoAndPeek","goto"],default:J.multiple,enumDescriptions:[c.localize(25,null),c.localize(26,null),c.localize(27,null)]},xe=["","editor.action.referenceSearch.trigger","editor.action.goToReferences","editor.action.peekImplementation","editor.action.goToImplementation","editor.action.peekTypeDefinition","editor.action.goToTypeDefinition","editor.action.peekDeclaration","editor.action.revealDeclaration","editor.action.peekDefinition","editor.action.revealDefinitionAside","editor.action.revealDefinition"];super(50,"gotoLocation",J,{"editor.gotoLocation.multiple":{deprecationMessage:c.localize(28,null)},"editor.gotoLocation.multipleDefinitions":{description:c.localize(29,null),...fe},"editor.gotoLocation.multipleTypeDefinitions":{description:c.localize(30,null),...fe},"editor.gotoLocation.multipleDeclarations":{description:c.localize(31,null),...fe},"editor.gotoLocation.multipleImplementations":{description:c.localize(32,null),...fe},"editor.gotoLocation.multipleReferences":{description:c.localize(33,null),...fe},"editor.gotoLocation.alternativeDefinitionCommand":{type:"string",default:J.alternativeDefinitionCommand,enum:xe,description:c.localize(34,null)},"editor.gotoLocation.alternativeTypeDefinitionCommand":{type:"string",default:J.alternativeTypeDefinitionCommand,enum:xe,description:c.localize(35,null)},"editor.gotoLocation.alternativeDeclarationCommand":{type:"string",default:J.alternativeDeclarationCommand,enum:xe,description:c.localize(36,null)},"editor.gotoLocation.alternativeImplementationCommand":{type:"string",default:J.alternativeImplementationCommand,enum:xe,description:c.localize(37,null)},"editor.gotoLocation.alternativeReferenceCommand":{type:"string",default:J.alternativeReferenceCommand,enum:xe,description:c.localize(38,null)}})}validate(J){if(!J||typeof J!="object")return this.defaultValue;const fe=J;return{multiple:S(fe.multiple,this.defaultValue.multiple,["peek","gotoAndPeek","goto"]),multipleDefinitions:fe.multipleDefinitions??S(fe.multipleDefinitions,"peek",["peek","gotoAndPeek","goto"]),multipleTypeDefinitions:fe.multipleTypeDefinitions??S(fe.multipleTypeDefinitions,"peek",["peek","gotoAndPeek","goto"]),multipleDeclarations:fe.multipleDeclarations??S(fe.multipleDeclarations,"peek",["peek","gotoAndPeek","goto"]),multipleImplementations:fe.multipleImplementations??S(fe.multipleImplementations,"peek",["peek","gotoAndPeek","goto"]),multipleReferences:fe.multipleReferences??S(fe.multipleReferences,"peek",["peek","gotoAndPeek","goto"]),alternativeDefinitionCommand:I.string(fe.alternativeDefinitionCommand,this.defaultValue.alternativeDefinitionCommand),alternativeTypeDefinitionCommand:I.string(fe.alternativeTypeDefinitionCommand,this.defaultValue.alternativeTypeDefinitionCommand),alternativeDeclarationCommand:I.string(fe.alternativeDeclarationCommand,this.defaultValue.alternativeDeclarationCommand),alternativeImplementationCommand:I.string(fe.alternativeImplementationCommand,this.defaultValue.alternativeImplementationCommand),alternativeReferenceCommand:I.string(fe.alternativeReferenceCommand,this.defaultValue.alternativeReferenceCommand)}}}class G extends P{constructor(){const J={enabled:!0,delay:300,sticky:!0};super(53,"hover",J,{"editor.hover.enabled":{type:"boolean",default:J.enabled,description:c.localize(39,null)},"editor.hover.delay":{type:"number",default:J.delay,description:c.localize(40,null)},"editor.hover.sticky":{type:"boolean",default:J.sticky,description:c.localize(41,null)}})}validate(J){if(!J||typeof J!="object")return this.defaultValue;const fe=J;return{enabled:n(fe.enabled,this.defaultValue.enabled),delay:l.clampedInt(fe.delay,this.defaultValue.delay,0,1e4),sticky:n(fe.sticky,this.defaultValue.sticky)}}}var U;(function(H){H[H.None=0]="None",H[H.Text=1]="Text",H[H.Blocks=2]="Blocks"})(U=e.RenderMinimap||(e.RenderMinimap={}));class K extends t{constructor(){super(131,[48,58,36,65,93,60,61,95,118,121,122,123,2])}compute(J,fe,xe){return K.computeLayout(fe,{memory:J.memory,outerWidth:J.outerWidth,outerHeight:J.outerHeight,isDominatedByLongLines:J.isDominatedByLongLines,lineHeight:J.fontInfo.lineHeight,viewLineCount:J.viewLineCount,lineNumbersDigitCount:J.lineNumbersDigitCount,typicalHalfwidthCharacterWidth:J.fontInfo.typicalHalfwidthCharacterWidth,maxDigitWidth:J.fontInfo.maxDigitWidth,pixelRatio:J.pixelRatio})}static computeContainedMinimapLineCount(J){const fe=J.height/J.lineHeight,xe=J.scrollBeyondLastLine?fe-1:0,Qe=(J.viewLineCount+xe)/(J.pixelRatio*J.height),rt=Math.floor(J.viewLineCount/Qe);return{typicalViewportLineCount:fe,extraLinesBeyondLastLine:xe,desiredRatio:Qe,minimapLineCount:rt}}static _computeMinimapLayout(J,fe){const xe=J.outerWidth,Qe=J.outerHeight,rt=J.pixelRatio;if(!J.minimap.enabled)return{renderMinimap:0,minimapLeft:0,minimapWidth:0,minimapHeightIsEditorHeight:!1,minimapIsSampling:!1,minimapScale:1,minimapLineHeight:1,minimapCanvasInnerWidth:0,minimapCanvasInnerHeight:Math.floor(rt*Qe),minimapCanvasOuterWidth:0,minimapCanvasOuterHeight:Qe};const ct=fe.stableMinimapLayoutInput,ft=ct&&J.outerHeight===ct.outerHeight&&J.lineHeight===ct.lineHeight&&J.typicalHalfwidthCharacterWidth===ct.typicalHalfwidthCharacterWidth&&J.pixelRatio===ct.pixelRatio&&J.scrollBeyondLastLine===ct.scrollBeyondLastLine&&J.minimap.enabled===ct.minimap.enabled&&J.minimap.side===ct.minimap.side&&J.minimap.size===ct.minimap.size&&J.minimap.showSlider===ct.minimap.showSlider&&J.minimap.renderCharacters===ct.minimap.renderCharacters&&J.minimap.maxColumn===ct.minimap.maxColumn&&J.minimap.scale===ct.minimap.scale&&J.verticalScrollbarWidth===ct.verticalScrollbarWidth&&J.isViewportWrapping===ct.isViewportWrapping,Pt=J.lineHeight,mt=J.typicalHalfwidthCharacterWidth,Dt=J.scrollBeyondLastLine,kt=J.minimap.renderCharacters;let vt=rt>=2?Math.round(J.minimap.scale*2):J.minimap.scale;const Xe=J.minimap.maxColumn,_t=J.minimap.size,Pe=J.minimap.side,Se=J.verticalScrollbarWidth,De=J.viewLineCount,ee=J.remainingWidth,ue=J.isViewportWrapping,pe=kt?2:3;let me=Math.floor(rt*Qe);const Ie=me/rt;let Be=!1,Ne=!1,je=pe*vt,et=vt/rt,Le=1;if(_t==="fill"||_t==="fit"){const{typicalViewportLineCount:Je,extraLinesBeyondLastLine:$e,desiredRatio:ut,minimapLineCount:gt}=K.computeContainedMinimapLineCount({viewLineCount:De,scrollBeyondLastLine:Dt,height:Qe,lineHeight:Pt,pixelRatio:rt});if(De/gt>1)Be=!0,Ne=!0,vt=1,je=1,et=vt/rt;else{let dt=!1,ot=vt+1;if(_t==="fit"){const pt=Math.ceil((De+$e)*je);ue&&ft&&ee<=fe.stableFitRemainingWidth?(dt=!0,ot=fe.stableFitMaxMinimapScale):dt=pt>me}if(_t==="fill"||dt){Be=!0;const pt=vt;je=Math.min(Pt*rt,Math.max(1,Math.floor(1/ut))),ue&&ft&&ee<=fe.stableFitRemainingWidth&&(ot=fe.stableFitMaxMinimapScale),vt=Math.min(ot,Math.max(1,Math.floor(je/pe))),vt>pt&&(Le=Math.min(2,vt/pt)),et=vt/rt/Le,me=Math.ceil(Math.max(Je,De+$e)*je),ue?(fe.stableMinimapLayoutInput=J,fe.stableFitRemainingWidth=ee,fe.stableFitMaxMinimapScale=vt):(fe.stableMinimapLayoutInput=null,fe.stableFitRemainingWidth=0)}}}const de=Math.floor(Xe*et),ge=Math.min(de,Math.max(0,Math.floor((ee-Se-2)*et/(mt+et)))+e.MINIMAP_GUTTER_WIDTH);let X=Math.floor(rt*ge);const W=X/rt;X=Math.floor(X*Le);const be=kt?1:2,ke=Pe==="left"?0:xe-ge-Se;return{renderMinimap:be,minimapLeft:ke,minimapWidth:ge,minimapHeightIsEditorHeight:Be,minimapIsSampling:Ne,minimapScale:vt,minimapLineHeight:je,minimapCanvasInnerWidth:X,minimapCanvasInnerHeight:me,minimapCanvasOuterWidth:W,minimapCanvasOuterHeight:Ie}}static computeLayout(J,fe){const xe=fe.outerWidth|0,Qe=fe.outerHeight|0,rt=fe.lineHeight|0,ct=fe.lineNumbersDigitCount|0,ft=fe.typicalHalfwidthCharacterWidth,Pt=fe.maxDigitWidth,mt=fe.pixelRatio,Dt=fe.viewLineCount,kt=J.get(123),vt=kt==="inherit"?J.get(122):kt,Xe=vt==="inherit"?J.get(118):vt,_t=J.get(121),Pe=J.get(2),Se=fe.isDominatedByLongLines,De=J.get(48),ee=J.get(60).renderType!==0,ue=J.get(61),pe=J.get(95),me=J.get(65),Ie=J.get(93),Be=Ie.verticalScrollbarSize,Ne=Ie.verticalHasArrows,je=Ie.arrowSize,et=Ie.horizontalScrollbarSize,Le=J.get(58),de=J.get(36);let ge;if(typeof Le=="string"&&/^\d+(\.\d+)?ch$/.test(Le)){const yt=parseFloat(Le.substr(0,Le.length-2));ge=l.clampedInt(yt*ft,0,0,1e3)}else ge=l.clampedInt(Le,0,0,1e3);de&&(ge+=16);let X=0;if(ee){const yt=Math.max(ct,ue);X=Math.round(yt*Pt)}let W=0;De&&(W=rt);let be=De?J.get(49)??0:0,ke=0,Je=ke+W+be,$e=Je+X,ut=$e+ge;const gt=xe-W-X-ge-be;let at=!1,dt=!1,ot=-1;Pe!==2&&(vt==="inherit"&&Se?(at=!0,dt=!0):Xe==="on"||Xe==="bounded"?dt=!0:Xe==="wordWrapColumn"&&(ot=_t));const pt=K._computeMinimapLayout({outerWidth:xe,outerHeight:Qe,lineHeight:rt,typicalHalfwidthCharacterWidth:ft,pixelRatio:mt,scrollBeyondLastLine:pe,minimap:me,verticalScrollbarWidth:Be,viewLineCount:Dt,remainingWidth:gt,isViewportWrapping:dt},fe.memory||new _);pt.renderMinimap!==0&&pt.minimapLeft===0&&(ke+=pt.minimapWidth,Je+=pt.minimapWidth,$e+=pt.minimapWidth,ut+=pt.minimapWidth);const St=gt-pt.minimapWidth,Ut=Math.max(1,Math.floor((St-Be-2)/ft)),Vt=Ne?je:0;return dt&&(ot=Math.max(1,Ut),Xe==="bounded"&&(ot=Math.min(ot,_t))),{width:xe,height:Qe,glyphMarginLeft:ke,glyphMarginWidth:W,lineNumbersLeft:Je,lineNumbersWidth:X,decorationsLeft:$e,decorationsWidth:ge,contentLeft:ut,contentWidth:St,minimap:pt,viewportColumn:Ut,isWordWrapMinified:at,isViewportWrapping:dt,wrappingColumn:ot,verticalScrollbarWidth:Be,horizontalScrollbarHeight:et,overviewRuler:{top:Vt,width:Be,height:Qe-2*Vt,right:0}}}}e.EditorLayoutInfoComputer=K;class $ extends P{constructor(){const J={enabled:!0};super(57,"lightbulb",J,{"editor.lightbulb.enabled":{type:"boolean",default:J.enabled,description:c.localize(42,null)}})}validate(J){return!J||typeof J!="object"?this.defaultValue:{enabled:n(J.enabled,this.defaultValue.enabled)}}}class B extends P{constructor(){const J={enabled:!0,fontSize:0,fontFamily:""};super(127,"inlayHints",J,{"editor.inlayHints.enabled":{type:"boolean",default:J.enabled,description:c.localize(43,null)},"editor.inlayHints.fontSize":{type:"number",default:J.fontSize,markdownDescription:c.localize(44,null)},"editor.inlayHints.fontFamily":{type:"string",default:J.fontFamily,markdownDescription:c.localize(45,null)}})}validate(J){if(!J||typeof J!="object")return this.defaultValue;const fe=J;return{enabled:n(fe.enabled,this.defaultValue.enabled),fontSize:l.clampedInt(fe.fontSize,this.defaultValue.fontSize,0,100),fontFamily:I.string(fe.fontFamily,this.defaultValue.fontFamily)}}}class z extends w{constructor(){super(59,"lineHeight",e.EDITOR_FONT_DEFAULTS.lineHeight,J=>w.clamp(J,0,150),{markdownDescription:c.localize(46,null)})}compute(J,fe,xe){return J.fontInfo.lineHeight}}class Y extends P{constructor(){const J={enabled:!0,size:"proportional",side:"right",showSlider:"mouseover",renderCharacters:!0,maxColumn:120,scale:1};super(65,"minimap",J,{"editor.minimap.enabled":{type:"boolean",default:J.enabled,description:c.localize(47,null)},"editor.minimap.size":{type:"string",enum:["proportional","fill","fit"],enumDescriptions:[c.localize(48,null),c.localize(49,null),c.localize(50,null)],default:J.size,description:c.localize(51,null)},"editor.minimap.side":{type:"string",enum:["left","right"],default:J.side,description:c.localize(52,null)},"editor.minimap.showSlider":{type:"string",enum:["always","mouseover"],default:J.showSlider,description:c.localize(53,null)},"editor.minimap.scale":{type:"number",default:J.scale,minimum:1,maximum:3,enum:[1,2,3],description:c.localize(54,null)},"editor.minimap.renderCharacters":{type:"boolean",default:J.renderCharacters,description:c.localize(55,null)},"editor.minimap.maxColumn":{type:"number",default:J.maxColumn,description:c.localize(56,null)}})}validate(J){if(!J||typeof J!="object")return this.defaultValue;const fe=J;return{enabled:n(fe.enabled,this.defaultValue.enabled),size:S(fe.size,this.defaultValue.size,["proportional","fill","fit"]),side:S(fe.side,this.defaultValue.side,["right","left"]),showSlider:S(fe.showSlider,this.defaultValue.showSlider,["always","mouseover"]),renderCharacters:n(fe.renderCharacters,this.defaultValue.renderCharacters),scale:l.clampedInt(fe.scale,1,1,3),maxColumn:l.clampedInt(fe.maxColumn,this.defaultValue.maxColumn,1,1e4)}}}function ne(H){return H==="ctrlCmd"?M.isMacintosh?"metaKey":"ctrlKey":"altKey"}class j extends P{constructor(){super(75,"padding",{top:0,bottom:0},{"editor.padding.top":{type:"number",default:0,minimum:0,maximum:1e3,description:c.localize(57,null)},"editor.padding.bottom":{type:"number",default:0,minimum:0,maximum:1e3,description:c.localize(58,null)}})}validate(J){if(!J||typeof J!="object")return this.defaultValue;const fe=J;return{top:l.clampedInt(fe.top,0,0,1e3),bottom:l.clampedInt(fe.bottom,0,0,1e3)}}}class le extends P{constructor(){const J={enabled:!0,cycle:!1};super(76,"parameterHints",J,{"editor.parameterHints.enabled":{type:"boolean",default:J.enabled,description:c.localize(59,null)},"editor.parameterHints.cycle":{type:"boolean",default:J.cycle,description:c.localize(60,null)}})}validate(J){if(!J||typeof J!="object")return this.defaultValue;const fe=J;return{enabled:n(fe.enabled,this.defaultValue.enabled),cycle:n(fe.cycle,this.defaultValue.cycle)}}}class oe extends t{constructor(){super(129)}compute(J,fe,xe){return J.pixelRatio}}class ve extends P{constructor(){const J={other:!0,comments:!1,strings:!1};super(79,"quickSuggestions",J,{anyOf:[{type:"boolean"},{type:"object",properties:{strings:{type:"boolean",default:J.strings,description:c.localize(61,null)},comments:{type:"boolean",default:J.comments,description:c.localize(62,null)},other:{type:"boolean",default:J.other,description:c.localize(63,null)}}}],default:J,description:c.localize(64,null)});this.defaultValue=J}validate(J){if(typeof J=="boolean")return J;if(J&&typeof J=="object"){const fe=J,xe={other:n(fe.other,this.defaultValue.other),comments:n(fe.comments,this.defaultValue.comments),strings:n(fe.strings,this.defaultValue.strings)};return xe.other&&xe.comments&&xe.strings?!0:!xe.other&&!xe.comments&&!xe.strings?!1:xe}return this.defaultValue}}var Re;(function(H){H[H.Off=0]="Off",H[H.On=1]="On",H[H.Relative=2]="Relative",H[H.Interval=3]="Interval",H[H.Custom=4]="Custom"})(Re=e.RenderLineNumbersType||(e.RenderLineNumbersType={}));class Me extends P{constructor(){super(60,"lineNumbers",{renderType:1,renderFn:null},{type:"string",enum:["off","on","relative","interval"],enumDescriptions:[c.localize(65,null),c.localize(66,null),c.localize(67,null),c.localize(68,null)],default:"on",description:c.localize(69,null)})}validate(J){let fe=this.defaultValue.renderType,xe=this.defaultValue.renderFn;return typeof J!="undefined"&&(typeof J=="function"?(fe=4,xe=J):J==="interval"?fe=3:J==="relative"?fe=2:J==="on"?fe=1:fe=0),{renderType:fe,renderFn:xe}}}function Oe(H){const J=H.get(88);return J==="editable"?H.get(81):J!=="on"}e.filterValidationDecorations=Oe;class Ye extends P{constructor(){const J=[],fe={type:"number",description:c.localize(70,null)};super(92,"rulers",J,{type:"array",items:{anyOf:[fe,{type:["object"],properties:{column:fe,color:{type:"string",description:c.localize(71,null),format:"color-hex"}}}]},default:J,description:c.localize(72,null)})}validate(J){if(Array.isArray(J)){let fe=[];for(let xe of J)if(typeof xe=="number")fe.push({column:l.clampedInt(xe,0,0,1e4),color:null});else if(xe&&typeof xe=="object"){const Qe=xe;fe.push({column:l.clampedInt(Qe.column,0,0,1e4),color:Qe.color})}return fe.sort((xe,Qe)=>xe.column-Qe.column),fe}return this.defaultValue}}function Ve(H,J){if(typeof H!="string")return J;switch(H){case"hidden":return 2;case"visible":return 3;default:return 1}}class qe extends P{constructor(){const J={vertical:1,horizontal:1,arrowSize:11,useShadows:!0,verticalHasArrows:!1,horizontalHasArrows:!1,horizontalScrollbarSize:12,horizontalSliderSize:12,verticalScrollbarSize:14,verticalSliderSize:14,handleMouseWheel:!0,alwaysConsumeMouseWheel:!0,scrollByPage:!1};super(93,"scrollbar",J,{"editor.scrollbar.vertical":{type:"string",enum:["auto","visible","hidden"],enumDescriptions:[c.localize(73,null),c.localize(74,null),c.localize(75,null)],default:"auto",description:c.localize(76,null)},"editor.scrollbar.horizontal":{type:"string",enum:["auto","visible","hidden"],enumDescriptions:[c.localize(77,null),c.localize(78,null),c.localize(79,null)],default:"auto",description:c.localize(80,null)},"editor.scrollbar.verticalScrollbarSize":{type:"number",default:J.verticalScrollbarSize,description:c.localize(81,null)},"editor.scrollbar.horizontalScrollbarSize":{type:"number",default:J.horizontalScrollbarSize,description:c.localize(82,null)},"editor.scrollbar.scrollByPage":{type:"boolean",default:J.scrollByPage,description:c.localize(83,null)}})}validate(J){if(!J||typeof J!="object")return this.defaultValue;const fe=J,xe=l.clampedInt(fe.horizontalScrollbarSize,this.defaultValue.horizontalScrollbarSize,0,1e3),Qe=l.clampedInt(fe.verticalScrollbarSize,this.defaultValue.verticalScrollbarSize,0,1e3);return{arrowSize:l.clampedInt(fe.arrowSize,this.defaultValue.arrowSize,0,1e3),vertical:Ve(fe.vertical,this.defaultValue.vertical),horizontal:Ve(fe.horizontal,this.defaultValue.horizontal),useShadows:n(fe.useShadows,this.defaultValue.useShadows),verticalHasArrows:n(fe.verticalHasArrows,this.defaultValue.verticalHasArrows),horizontalHasArrows:n(fe.horizontalHasArrows,this.defaultValue.horizontalHasArrows),handleMouseWheel:n(fe.handleMouseWheel,this.defaultValue.handleMouseWheel),alwaysConsumeMouseWheel:n(fe.alwaysConsumeMouseWheel,this.defaultValue.alwaysConsumeMouseWheel),horizontalScrollbarSize:xe,horizontalSliderSize:l.clampedInt(fe.horizontalSliderSize,xe,0,1e3),verticalScrollbarSize:Qe,verticalSliderSize:l.clampedInt(fe.verticalSliderSize,Qe,0,1e3),scrollByPage:n(fe.scrollByPage,this.defaultValue.scrollByPage)}}}class x extends P{constructor(){const J={enabled:!0,mode:"subwordSmart"};super(55,"inlineSuggest",J,{"editor.inlineSuggest.enabled":{type:"boolean",default:J.enabled,description:c.localize(84,null)}})}validate(J){if(!J||typeof J!="object")return this.defaultValue;const fe=J;return{enabled:n(fe.enabled,this.defaultValue.enabled),mode:S(fe.mode,this.defaultValue.mode,["prefix","subword","subwordSmart"])}}}class Q extends P{constructor(){const J={enabled:e.EDITOR_MODEL_DEFAULTS.bracketPairColorizationOptions.enabled};super(12,"bracketPairColorization",J,{"editor.bracketPairColorization.enabled":{type:"boolean",default:J.enabled,description:c.localize(85,null)}})}validate(J){return!J||typeof J!="object"?this.defaultValue:{enabled:n(J.enabled,this.defaultValue.enabled)}}}class te extends P{constructor(){const J={insertMode:"insert",filterGraceful:!0,snippetsPreventQuickSuggestions:!0,localityBonus:!1,shareSuggestSelections:!1,showIcons:!0,showStatusBar:!1,preview:!1,previewMode:"subwordSmart",showInlineDetails:!0,showMethods:!0,showFunctions:!0,showConstructors:!0,showDeprecated:!0,showFields:!0,showVariables:!0,showClasses:!0,showStructs:!0,showInterfaces:!0,showModules:!0,showProperties:!0,showEvents:!0,showOperators:!0,showUnits:!0,showValues:!0,showConstants:!0,showEnums:!0,showEnumMembers:!0,showKeywords:!0,showWords:!0,showColors:!0,showFiles:!0,showReferences:!0,showFolders:!0,showTypeParameters:!0,showSnippets:!0,showUsers:!0,showIssues:!0};super(107,"suggest",J,{"editor.suggest.insertMode":{type:"string",enum:["insert","replace"],enumDescriptions:[c.localize(86,null),c.localize(87,null)],default:J.insertMode,description:c.localize(88,null)},"editor.suggest.filterGraceful":{type:"boolean",default:J.filterGraceful,description:c.localize(89,null)},"editor.suggest.localityBonus":{type:"boolean",default:J.localityBonus,description:c.localize(90,null)},"editor.suggest.shareSuggestSelections":{type:"boolean",default:J.shareSuggestSelections,markdownDescription:c.localize(91,null)},"editor.suggest.snippetsPreventQuickSuggestions":{type:"boolean",default:J.snippetsPreventQuickSuggestions,description:c.localize(92,null)},"editor.suggest.showIcons":{type:"boolean",default:J.showIcons,description:c.localize(93,null)},"editor.suggest.showStatusBar":{type:"boolean",default:J.showStatusBar,description:c.localize(94,null)},"editor.suggest.preview":{type:"boolean",default:J.preview,description:c.localize(95,null)},"editor.suggest.showInlineDetails":{type:"boolean",default:J.showInlineDetails,description:c.localize(96,null)},"editor.suggest.maxVisibleSuggestions":{type:"number",deprecationMessage:c.localize(97,null)},"editor.suggest.filteredTypes":{type:"object",deprecationMessage:c.localize(98,null)},"editor.suggest.showMethods":{type:"boolean",default:!0,markdownDescription:c.localize(99,null)},"editor.suggest.showFunctions":{type:"boolean",default:!0,markdownDescription:c.localize(100,null)},"editor.suggest.showConstructors":{type:"boolean",default:!0,markdownDescription:c.localize(101,null)},"editor.suggest.showDeprecated":{type:"boolean",default:!0,markdownDescription:c.localize(102,null)},"editor.suggest.showFields":{type:"boolean",default:!0,markdownDescription:c.localize(103,null)},"editor.suggest.showVariables":{type:"boolean",default:!0,markdownDescription:c.localize(104,null)},"editor.suggest.showClasses":{type:"boolean",default:!0,markdownDescription:c.localize(105,null)},"editor.suggest.showStructs":{type:"boolean",default:!0,markdownDescription:c.localize(106,null)},"editor.suggest.showInterfaces":{type:"boolean",default:!0,markdownDescription:c.localize(107,null)},"editor.suggest.showModules":{type:"boolean",default:!0,markdownDescription:c.localize(108,null)},"editor.suggest.showProperties":{type:"boolean",default:!0,markdownDescription:c.localize(109,null)},"editor.suggest.showEvents":{type:"boolean",default:!0,markdownDescription:c.localize(110,null)},"editor.suggest.showOperators":{type:"boolean",default:!0,markdownDescription:c.localize(111,null)},"editor.suggest.showUnits":{type:"boolean",default:!0,markdownDescription:c.localize(112,null)},"editor.suggest.showValues":{type:"boolean",default:!0,markdownDescription:c.localize(113,null)},"editor.suggest.showConstants":{type:"boolean",default:!0,markdownDescription:c.localize(114,null)},"editor.suggest.showEnums":{type:"boolean",default:!0,markdownDescription:c.localize(115,null)},"editor.suggest.showEnumMembers":{type:"boolean",default:!0,markdownDescription:c.localize(116,null)},"editor.suggest.showKeywords":{type:"boolean",default:!0,markdownDescription:c.localize(117,null)},"editor.suggest.showWords":{type:"boolean",default:!0,markdownDescription:c.localize(118,null)},"editor.suggest.showColors":{type:"boolean",default:!0,markdownDescription:c.localize(119,null)},"editor.suggest.showFiles":{type:"boolean",default:!0,markdownDescription:c.localize(120,null)},"editor.suggest.showReferences":{type:"boolean",default:!0,markdownDescription:c.localize(121,null)},"editor.suggest.showCustomcolors":{type:"boolean",default:!0,markdownDescription:c.localize(122,null)},"editor.suggest.showFolders":{type:"boolean",default:!0,markdownDescription:c.localize(123,null)},"editor.suggest.showTypeParameters":{type:"boolean",default:!0,markdownDescription:c.localize(124,null)},"editor.suggest.showSnippets":{type:"boolean",default:!0,markdownDescription:c.localize(125,null)},"editor.suggest.showUsers":{type:"boolean",default:!0,markdownDescription:c.localize(126,null)},"editor.suggest.showIssues":{type:"boolean",default:!0,markdownDescription:c.localize(127,null)}})}validate(J){if(!J||typeof J!="object")return this.defaultValue;const fe=J;return{insertMode:S(fe.insertMode,this.defaultValue.insertMode,["insert","replace"]),filterGraceful:n(fe.filterGraceful,this.defaultValue.filterGraceful),snippetsPreventQuickSuggestions:n(fe.snippetsPreventQuickSuggestions,this.defaultValue.filterGraceful),localityBonus:n(fe.localityBonus,this.defaultValue.localityBonus),shareSuggestSelections:n(fe.shareSuggestSelections,this.defaultValue.shareSuggestSelections),showIcons:n(fe.showIcons,this.defaultValue.showIcons),showStatusBar:n(fe.showStatusBar,this.defaultValue.showStatusBar),preview:n(fe.preview,this.defaultValue.preview),previewMode:S(fe.previewMode,this.defaultValue.previewMode,["prefix","subword","subwordSmart"]),showInlineDetails:n(fe.showInlineDetails,this.defaultValue.showInlineDetails),showMethods:n(fe.showMethods,this.defaultValue.showMethods),showFunctions:n(fe.showFunctions,this.defaultValue.showFunctions),showConstructors:n(fe.showConstructors,this.defaultValue.showConstructors),showDeprecated:n(fe.showDeprecated,this.defaultValue.showDeprecated),showFields:n(fe.showFields,this.defaultValue.showFields),showVariables:n(fe.showVariables,this.defaultValue.showVariables),showClasses:n(fe.showClasses,this.defaultValue.showClasses),showStructs:n(fe.showStructs,this.defaultValue.showStructs),showInterfaces:n(fe.showInterfaces,this.defaultValue.showInterfaces),showModules:n(fe.showModules,this.defaultValue.showModules),showProperties:n(fe.showProperties,this.defaultValue.showProperties),showEvents:n(fe.showEvents,this.defaultValue.showEvents),showOperators:n(fe.showOperators,this.defaultValue.showOperators),showUnits:n(fe.showUnits,this.defaultValue.showUnits),showValues:n(fe.showValues,this.defaultValue.showValues),showConstants:n(fe.showConstants,this.defaultValue.showConstants),showEnums:n(fe.showEnums,this.defaultValue.showEnums),showEnumMembers:n(fe.showEnumMembers,this.defaultValue.showEnumMembers),showKeywords:n(fe.showKeywords,this.defaultValue.showKeywords),showWords:n(fe.showWords,this.defaultValue.showWords),showColors:n(fe.showColors,this.defaultValue.showColors),showFiles:n(fe.showFiles,this.defaultValue.showFiles),showReferences:n(fe.showReferences,this.defaultValue.showReferences),showFolders:n(fe.showFolders,this.defaultValue.showFolders),showTypeParameters:n(fe.showTypeParameters,this.defaultValue.showTypeParameters),showSnippets:n(fe.showSnippets,this.defaultValue.showSnippets),showUsers:n(fe.showUsers,this.defaultValue.showUsers),showIssues:n(fe.showIssues,this.defaultValue.showIssues)}}}class ae extends P{constructor(){super(103,"smartSelect",{selectLeadingAndTrailingWhitespace:!0},{"editor.smartSelect.selectLeadingAndTrailingWhitespace":{description:c.localize(128,null),default:!0,type:"boolean"}})}validate(J){return!J||typeof J!="object"?this.defaultValue:{selectLeadingAndTrailingWhitespace:n(J.selectLeadingAndTrailingWhitespace,this.defaultValue.selectLeadingAndTrailingWhitespace)}}}class q extends t{constructor(){super(130,[81])}compute(J,fe,xe){return fe.get(81)?!0:J.tabFocusMode}}var se;(function(H){H[H.None=0]="None",H[H.Same=1]="Same",H[H.Indent=2]="Indent",H[H.DeepIndent=3]="DeepIndent"})(se=e.WrappingIndent||(e.WrappingIndent={}));function he(H){switch(H){case"none":return 0;case"same":return 1;case"indent":return 2;case"deepIndent":return 3}}class Te extends t{constructor(){super(132,[131])}compute(J,fe,xe){const Qe=fe.get(131);return{isDominatedByLongLines:J.isDominatedByLongLines,isWordWrapMinified:Qe.isWordWrapMinified,isViewportWrapping:Qe.isViewportWrapping,wrappingColumn:Qe.wrappingColumn}}}const Ue="Consolas, 'Courier New', monospace",He="Menlo, Monaco, 'Courier New', monospace",Ke="'Droid Sans Mono', 'monospace', monospace, 'Droid Sans Fallback'";e.EDITOR_FONT_DEFAULTS={fontFamily:M.isMacintosh?He:M.isLinux?Ke:Ue,fontWeight:"normal",fontSize:M.isMacintosh?12:14,lineHeight:0,letterSpacing:0},e.EDITOR_MODEL_DEFAULTS={tabSize:4,indentSize:4,insertSpaces:!0,detectIndentation:!0,trimAutoWhitespace:!0,largeFileOptimizations:!0,bracketPairColorizationOptions:{enabled:!1}},e.editorOptionsRegistry=[];function ye(H){return e.editorOptionsRegistry[H.id]=H,H}var nt;(function(H){H[H.acceptSuggestionOnCommitCharacter=0]="acceptSuggestionOnCommitCharacter",H[H.acceptSuggestionOnEnter=1]="acceptSuggestionOnEnter",H[H.accessibilitySupport=2]="accessibilitySupport",H[H.accessibilityPageSize=3]="accessibilityPageSize",H[H.ariaLabel=4]="ariaLabel",H[H.autoClosingBrackets=5]="autoClosingBrackets",H[H.autoClosingDelete=6]="autoClosingDelete",H[H.autoClosingOvertype=7]="autoClosingOvertype",H[H.autoClosingQuotes=8]="autoClosingQuotes",H[H.autoIndent=9]="autoIndent",H[H.automaticLayout=10]="automaticLayout",H[H.autoSurround=11]="autoSurround",H[H.bracketPairColorization=12]="bracketPairColorization",H[H.codeLens=13]="codeLens",H[H.codeLensFontFamily=14]="codeLensFontFamily",H[H.codeLensFontSize=15]="codeLensFontSize",H[H.colorDecorators=16]="colorDecorators",H[H.columnSelection=17]="columnSelection",H[H.comments=18]="comments",H[H.contextmenu=19]="contextmenu",H[H.copyWithSyntaxHighlighting=20]="copyWithSyntaxHighlighting",H[H.cursorBlinking=21]="cursorBlinking",H[H.cursorSmoothCaretAnimation=22]="cursorSmoothCaretAnimation",H[H.cursorStyle=23]="cursorStyle",H[H.cursorSurroundingLines=24]="cursorSurroundingLines",H[H.cursorSurroundingLinesStyle=25]="cursorSurroundingLinesStyle",H[H.cursorWidth=26]="cursorWidth",H[H.disableLayerHinting=27]="disableLayerHinting",H[H.disableMonospaceOptimizations=28]="disableMonospaceOptimizations",H[H.domReadOnly=29]="domReadOnly",H[H.dragAndDrop=30]="dragAndDrop",H[H.emptySelectionClipboard=31]="emptySelectionClipboard",H[H.extraEditorClassName=32]="extraEditorClassName",H[H.fastScrollSensitivity=33]="fastScrollSensitivity",H[H.find=34]="find",H[H.fixedOverflowWidgets=35]="fixedOverflowWidgets",H[H.folding=36]="folding",H[H.foldingStrategy=37]="foldingStrategy",H[H.foldingHighlight=38]="foldingHighlight",H[H.foldingImportsByDefault=39]="foldingImportsByDefault",H[H.unfoldOnClickAfterEndOfLine=40]="unfoldOnClickAfterEndOfLine",H[H.fontFamily=41]="fontFamily",H[H.fontInfo=42]="fontInfo",H[H.fontLigatures=43]="fontLigatures",H[H.fontSize=44]="fontSize",H[H.fontWeight=45]="fontWeight",H[H.formatOnPaste=46]="formatOnPaste",H[H.formatOnType=47]="formatOnType",H[H.glyphMargin=48]="glyphMargin",H[H.glyphMarginRightPadding=49]="glyphMarginRightPadding",H[H.gotoLocation=50]="gotoLocation",H[H.hideCursorInOverviewRuler=51]="hideCursorInOverviewRuler",H[H.highlightActiveIndentGuide=52]="highlightActiveIndentGuide",H[H.hover=53]="hover",H[H.inDiffEditor=54]="inDiffEditor",H[H.inlineSuggest=55]="inlineSuggest",H[H.letterSpacing=56]="letterSpacing",H[H.lightbulb=57]="lightbulb",H[H.lineDecorationsWidth=58]="lineDecorationsWidth",H[H.lineHeight=59]="lineHeight",H[H.lineNumbers=60]="lineNumbers",H[H.lineNumbersMinChars=61]="lineNumbersMinChars",H[H.linkedEditing=62]="linkedEditing",H[H.links=63]="links",H[H.matchBrackets=64]="matchBrackets",H[H.minimap=65]="minimap",H[H.mouseStyle=66]="mouseStyle",H[H.mouseWheelScrollSensitivity=67]="mouseWheelScrollSensitivity",H[H.mouseWheelZoom=68]="mouseWheelZoom",H[H.multiCursorMergeOverlapping=69]="multiCursorMergeOverlapping",H[H.multiCursorModifier=70]="multiCursorModifier",H[H.multiCursorPaste=71]="multiCursorPaste",H[H.occurrencesHighlight=72]="occurrencesHighlight",H[H.overviewRulerBorder=73]="overviewRulerBorder",H[H.overviewRulerLanes=74]="overviewRulerLanes",H[H.padding=75]="padding",H[H.parameterHints=76]="parameterHints",H[H.peekWidgetDefaultFocus=77]="peekWidgetDefaultFocus",H[H.definitionLinkOpensInPeek=78]="definitionLinkOpensInPeek",H[H.quickSuggestions=79]="quickSuggestions",H[H.quickSuggestionsDelay=80]="quickSuggestionsDelay",H[H.readOnly=81]="readOnly",H[H.renameOnType=82]="renameOnType",H[H.renderControlCharacters=83]="renderControlCharacters",H[H.renderIndentGuides=84]="renderIndentGuides",H[H.renderFinalNewline=85]="renderFinalNewline",H[H.renderLineHighlight=86]="renderLineHighlight",H[H.renderLineHighlightOnlyWhenFocus=87]="renderLineHighlightOnlyWhenFocus",H[H.renderValidationDecorations=88]="renderValidationDecorations",H[H.renderWhitespace=89]="renderWhitespace",H[H.revealHorizontalRightPadding=90]="revealHorizontalRightPadding",H[H.roundedSelection=91]="roundedSelection",H[H.rulers=92]="rulers",H[H.scrollbar=93]="scrollbar",H[H.scrollBeyondLastColumn=94]="scrollBeyondLastColumn",H[H.scrollBeyondLastLine=95]="scrollBeyondLastLine",H[H.scrollPredominantAxis=96]="scrollPredominantAxis",H[H.selectionClipboard=97]="selectionClipboard",H[H.selectionHighlight=98]="selectionHighlight",H[H.selectOnLineNumbers=99]="selectOnLineNumbers",H[H.showFoldingControls=100]="showFoldingControls",H[H.showUnused=101]="showUnused",H[H.snippetSuggestions=102]="snippetSuggestions",H[H.smartSelect=103]="smartSelect",H[H.smoothScrolling=104]="smoothScrolling",H[H.stickyTabStops=105]="stickyTabStops",H[H.stopRenderingLineAfter=106]="stopRenderingLineAfter",H[H.suggest=107]="suggest",H[H.suggestFontSize=108]="suggestFontSize",H[H.suggestLineHeight=109]="suggestLineHeight",H[H.suggestOnTriggerCharacters=110]="suggestOnTriggerCharacters",H[H.suggestSelection=111]="suggestSelection",H[H.tabCompletion=112]="tabCompletion",H[H.tabIndex=113]="tabIndex",H[H.unusualLineTerminators=114]="unusualLineTerminators",H[H.useShadowDOM=115]="useShadowDOM",H[H.useTabStops=116]="useTabStops",H[H.wordSeparators=117]="wordSeparators",H[H.wordWrap=118]="wordWrap",H[H.wordWrapBreakAfterCharacters=119]="wordWrapBreakAfterCharacters",H[H.wordWrapBreakBeforeCharacters=120]="wordWrapBreakBeforeCharacters",H[H.wordWrapColumn=121]="wordWrapColumn",H[H.wordWrapOverride1=122]="wordWrapOverride1",H[H.wordWrapOverride2=123]="wordWrapOverride2",H[H.wrappingIndent=124]="wrappingIndent",H[H.wrappingStrategy=125]="wrappingStrategy",H[H.showDeprecated=126]="showDeprecated",H[H.inlayHints=127]="inlayHints",H[H.editorClassName=128]="editorClassName",H[H.pixelRatio=129]="pixelRatio",H[H.tabFocusMode=130]="tabFocusMode",H[H.layoutInfo=131]="layoutInfo",H[H.wrappingInfo=132]="wrappingInfo"})(nt=e.EditorOption||(e.EditorOption={})),e.EditorOptions={acceptSuggestionOnCommitCharacter:ye(new f(0,"acceptSuggestionOnCommitCharacter",!0,{markdownDescription:c.localize(129,null)})),acceptSuggestionOnEnter:ye(new o(1,"acceptSuggestionOnEnter","on",["on","smart","off"],{markdownEnumDescriptions:["",c.localize(130,null),""],markdownDescription:c.localize(131,null)})),accessibilitySupport:ye(new i),accessibilityPageSize:ye(new l(3,"accessibilityPageSize",10,1,1073741824,{description:c.localize(132,null)})),ariaLabel:ye(new I(4,"ariaLabel",c.localize(133,null))),autoClosingBrackets:ye(new o(5,"autoClosingBrackets","languageDefined",["always","languageDefined","beforeWhitespace","never"],{enumDescriptions:["",c.localize(134,null),c.localize(135,null),""],description:c.localize(136,null)})),autoClosingDelete:ye(new o(6,"autoClosingDelete","auto",["always","auto","never"],{enumDescriptions:["",c.localize(137,null),""],description:c.localize(138,null)})),autoClosingOvertype:ye(new o(7,"autoClosingOvertype","auto",["always","auto","never"],{enumDescriptions:["",c.localize(139,null),""],description:c.localize(140,null)})),autoClosingQuotes:ye(new o(8,"autoClosingQuotes","languageDefined",["always","languageDefined","beforeWhitespace","never"],{enumDescriptions:["",c.localize(141,null),c.localize(142,null),""],description:c.localize(143,null)})),autoIndent:ye(new h(9,"autoIndent",4,"full",["none","keep","brackets","advanced","full"],y,{enumDescriptions:[c.localize(144,null),c.localize(145,null),c.localize(146,null),c.localize(147,null),c.localize(148,null)],description:c.localize(149,null)})),automaticLayout:ye(new f(10,"automaticLayout",!1)),autoSurround:ye(new o(11,"autoSurround","languageDefined",["languageDefined","quotes","brackets","never"],{enumDescriptions:[c.localize(150,null),c.localize(151,null),c.localize(152,null),""],description:c.localize(153,null)})),bracketPairColorization:ye(new Q),stickyTabStops:ye(new f(105,"stickyTabStops",!1,{description:c.localize(154,null)})),codeLens:ye(new f(13,"codeLens",!0,{description:c.localize(155,null)})),codeLensFontFamily:ye(new I(14,"codeLensFontFamily","",{description:c.localize(156,null)})),codeLensFontSize:ye(new l(15,"codeLensFontSize",0,0,100,{type:"number",default:0,minimum:0,maximum:100,markdownDescription:c.localize(157,null)})),colorDecorators:ye(new f(16,"colorDecorators",!0,{description:c.localize(158,null)})),columnSelection:ye(new f(17,"columnSelection",!1,{description:c.localize(159,null)})),comments:ye(new v),contextmenu:ye(new f(19,"contextmenu",!0)),copyWithSyntaxHighlighting:ye(new f(20,"copyWithSyntaxHighlighting",!0,{description:c.localize(160,null)})),cursorBlinking:ye(new h(21,"cursorBlinking",1,"blink",["blink","smooth","phase","expand","solid"],s,{description:c.localize(161,null)})),cursorSmoothCaretAnimation:ye(new f(22,"cursorSmoothCaretAnimation",!1,{description:c.localize(162,null)})),cursorStyle:ye(new h(23,"cursorStyle",u.Line,"line",["line","block","underline","line-thin","block-outline","underline-thin"],p,{description:c.localize(163,null)})),cursorSurroundingLines:ye(new l(24,"cursorSurroundingLines",0,0,1073741824,{description:c.localize(164,null)})),cursorSurroundingLinesStyle:ye(new o(25,"cursorSurroundingLinesStyle","default",["default","all"],{enumDescriptions:[c.localize(165,null),c.localize(166,null)],description:c.localize(167,null)})),cursorWidth:ye(new l(26,"cursorWidth",0,0,1073741824,{markdownDescription:c.localize(168,null)})),disableLayerHinting:ye(new f(27,"disableLayerHinting",!1)),disableMonospaceOptimizations:ye(new f(28,"disableMonospaceOptimizations",!1)),domReadOnly:ye(new f(29,"domReadOnly",!1)),dragAndDrop:ye(new f(30,"dragAndDrop",!0,{description:c.localize(169,null)})),emptySelectionClipboard:ye(new T),extraEditorClassName:ye(new I(32,"extraEditorClassName","")),fastScrollSensitivity:ye(new w(33,"fastScrollSensitivity",5,H=>H<=0?5:H,{markdownDescription:c.localize(170,null)})),find:ye(new g),fixedOverflowWidgets:ye(new f(35,"fixedOverflowWidgets",!1)),folding:ye(new f(36,"folding",!0,{description:c.localize(171,null)})),foldingStrategy:ye(new o(37,"foldingStrategy","auto",["auto","indentation"],{enumDescriptions:[c.localize(172,null),c.localize(173,null)],description:c.localize(174,null)})),foldingHighlight:ye(new f(38,"foldingHighlight",!0,{description:c.localize(175,null)})),foldingImportsByDefault:ye(new f(39,"foldingImportsByDefault",!1,{description:c.localize(176,null)})),unfoldOnClickAfterEndOfLine:ye(new f(40,"unfoldOnClickAfterEndOfLine",!1,{description:c.localize(177,null)})),fontFamily:ye(new I(41,"fontFamily",e.EDITOR_FONT_DEFAULTS.fontFamily,{description:c.localize(178,null)})),fontInfo:ye(new m),fontLigatures2:ye(new D),fontSize:ye(new A),fontWeight:ye(new L),formatOnPaste:ye(new f(46,"formatOnPaste",!1,{description:c.localize(179,null)})),formatOnType:ye(new f(47,"formatOnType",!1,{description:c.localize(180,null)})),glyphMargin:ye(new f(48,"glyphMargin",!0,{description:c.localize(181,null)})),glyphMarginRightPadding:ye(new l(49,"glyphMarginRightPadding",0,0,1e3,{description:c.localize(182,null)})),gotoLocation:ye(new V),hideCursorInOverviewRuler:ye(new f(51,"hideCursorInOverviewRuler",!1,{description:c.localize(183,null)})),highlightActiveIndentGuide:ye(new f(52,"highlightActiveIndentGuide",!0,{description:c.localize(184,null)})),hover:ye(new G),inDiffEditor:ye(new f(54,"inDiffEditor",!1)),letterSpacing:ye(new w(56,"letterSpacing",e.EDITOR_FONT_DEFAULTS.letterSpacing,H=>w.clamp(H,-5,20),{description:c.localize(185,null)})),lightbulb:ye(new $),lineDecorationsWidth:ye(new E(58,"lineDecorationsWidth",10)),lineHeight:ye(new z),lineNumbers:ye(new Me),lineNumbersMinChars:ye(new l(61,"lineNumbersMinChars",5,1,300)),linkedEditing:ye(new f(62,"linkedEditing",!1,{description:c.localize(186,null)})),links:ye(new f(63,"links",!0,{description:c.localize(187,null)})),matchBrackets:ye(new o(64,"matchBrackets","always",["always","near","never"],{description:c.localize(188,null)})),minimap:ye(new Y),mouseStyle:ye(new o(66,"mouseStyle","text",["text","default","copy"])),mouseWheelScrollSensitivity:ye(new w(67,"mouseWheelScrollSensitivity",1,H=>H===0?1:H,{markdownDescription:c.localize(189,null)})),mouseWheelZoom:ye(new f(68,"mouseWheelZoom",!1,{markdownDescription:c.localize(190,null)})),multiCursorMergeOverlapping:ye(new f(69,"multiCursorMergeOverlapping",!0,{description:c.localize(191,null)})),multiCursorModifier:ye(new h(70,"multiCursorModifier","altKey","alt",["ctrlCmd","alt"],ne,{markdownEnumDescriptions:[c.localize(192,null),c.localize(193,null)],markdownDescription:c.localize(194,null)})),multiCursorPaste:ye(new o(71,"multiCursorPaste","spread",["spread","full"],{markdownEnumDescriptions:[c.localize(195,null),c.localize(196,null)],markdownDescription:c.localize(197,null)})),occurrencesHighlight:ye(new f(72,"occurrencesHighlight",!0,{description:c.localize(198,null)})),overviewRulerBorder:ye(new f(73,"overviewRulerBorder",!0,{description:c.localize(199,null)})),overviewRulerLanes:ye(new l(74,"overviewRulerLanes",3,0,3)),padding:ye(new j),parameterHints:ye(new le),peekWidgetDefaultFocus:ye(new o(77,"peekWidgetDefaultFocus","tree",["tree","editor"],{enumDescriptions:[c.localize(200,null),c.localize(201,null)],description:c.localize(202,null)})),definitionLinkOpensInPeek:ye(new f(78,"definitionLinkOpensInPeek",!1,{description:c.localize(203,null)})),quickSuggestions:ye(new ve),quickSuggestionsDelay:ye(new l(80,"quickSuggestionsDelay",10,0,1073741824,{description:c.localize(204,null)})),readOnly:ye(new f(81,"readOnly",!1)),renameOnType:ye(new f(82,"renameOnType",!1,{description:c.localize(205,null),markdownDeprecationMessage:c.localize(206,null)})),renderControlCharacters:ye(new f(83,"renderControlCharacters",!1,{description:c.localize(207,null)})),renderIndentGuides:ye(new f(84,"renderIndentGuides",!0,{description:c.localize(208,null)})),renderFinalNewline:ye(new f(85,"renderFinalNewline",!0,{description:c.localize(209,null)})),renderLineHighlight:ye(new o(86,"renderLineHighlight","line",["none","gutter","line","all"],{enumDescriptions:["","","",c.localize(210,null)],description:c.localize(211,null)})),renderLineHighlightOnlyWhenFocus:ye(new f(87,"renderLineHighlightOnlyWhenFocus",!1,{description:c.localize(212,null)})),renderValidationDecorations:ye(new o(88,"renderValidationDecorations","editable",["editable","on","off"])),renderWhitespace:ye(new o(89,"renderWhitespace","selection",["none","boundary","selection","trailing","all"],{enumDescriptions:["",c.localize(213,null),c.localize(214,null),c.localize(215,null),""],description:c.localize(216,null)})),revealHorizontalRightPadding:ye(new l(90,"revealHorizontalRightPadding",30,0,1e3)),roundedSelection:ye(new f(91,"roundedSelection",!0,{description:c.localize(217,null)})),rulers:ye(new Ye),scrollbar:ye(new qe),scrollBeyondLastColumn:ye(new l(94,"scrollBeyondLastColumn",5,0,1073741824,{description:c.localize(218,null)})),scrollBeyondLastLine:ye(new f(95,"scrollBeyondLastLine",!0,{description:c.localize(219,null)})),scrollPredominantAxis:ye(new f(96,"scrollPredominantAxis",!0,{description:c.localize(220,null)})),selectionClipboard:ye(new f(97,"selectionClipboard",!0,{description:c.localize(221,null),included:M.isLinux})),selectionHighlight:ye(new f(98,"selectionHighlight",!0,{description:c.localize(222,null)})),selectOnLineNumbers:ye(new f(99,"selectOnLineNumbers",!0)),showFoldingControls:ye(new o(100,"showFoldingControls","mouseover",["always","mouseover"],{enumDescriptions:[c.localize(223,null),c.localize(224,null)],description:c.localize(225,null)})),showUnused:ye(new f(101,"showUnused",!0,{description:c.localize(226,null)})),showDeprecated:ye(new f(126,"showDeprecated",!0,{description:c.localize(227,null)})),inlayHints:ye(new B),snippetSuggestions:ye(new o(102,"snippetSuggestions","inline",["top","bottom","inline","none"],{enumDescriptions:[c.localize(228,null),c.localize(229,null),c.localize(230,null),c.localize(231,null)],description:c.localize(232,null)})),smartSelect:ye(new ae),smoothScrolling:ye(new f(104,"smoothScrolling",!1,{description:c.localize(233,null)})),stopRenderingLineAfter:ye(new l(106,"stopRenderingLineAfter",1e4,-1,1073741824)),suggest:ye(new te),inlineSuggest:ye(new x),suggestFontSize:ye(new l(108,"suggestFontSize",0,0,1e3,{markdownDescription:c.localize(234,null)})),suggestLineHeight:ye(new l(109,"suggestLineHeight",0,0,1e3,{markdownDescription:c.localize(235,null)})),suggestOnTriggerCharacters:ye(new f(110,"suggestOnTriggerCharacters",!0,{description:c.localize(236,null)})),suggestSelection:ye(new o(111,"suggestSelection","recentlyUsed",["first","recentlyUsed","recentlyUsedByPrefix"],{markdownEnumDescriptions:[c.localize(237,null),c.localize(238,null),c.localize(239,null)],description:c.localize(240,null)})),tabCompletion:ye(new o(112,"tabCompletion","off",["on","off","onlySnippets"],{enumDescriptions:[c.localize(241,null),c.localize(242,null),c.localize(243,null)],description:c.localize(244,null)})),tabIndex:ye(new l(113,"tabIndex",0,-1,1073741824)),unusualLineTerminators:ye(new o(114,"unusualLineTerminators","prompt",["auto","off","prompt"],{enumDescriptions:[c.localize(245,null),c.localize(246,null),c.localize(247,null)],description:c.localize(248,null)})),useShadowDOM:ye(new f(115,"useShadowDOM",!0)),useTabStops:ye(new f(116,"useTabStops",!0,{description:c.localize(249,null)})),wordSeparators:ye(new I(117,"wordSeparators",b.USUAL_WORD_SEPARATORS,{description:c.localize(250,null)})),wordWrap:ye(new o(118,"wordWrap","off",["off","on","wordWrapColumn","bounded"],{markdownEnumDescriptions:[c.localize(251,null),c.localize(252,null),c.localize(253,null),c.localize(254,null)],description:c.localize(255,null)})),wordWrapBreakAfterCharacters:ye(new I(119,"wordWrapBreakAfterCharacters"," 	})]?|/&.,;\xA2\xB0\u2032\u2033\u2030\u2103\u3001\u3002\uFF61\uFF64\uFFE0\uFF0C\uFF0E\uFF1A\uFF1B\uFF1F\uFF01\uFF05\u30FB\uFF65\u309D\u309E\u30FD\u30FE\u30FC\u30A1\u30A3\u30A5\u30A7\u30A9\u30C3\u30E3\u30E5\u30E7\u30EE\u30F5\u30F6\u3041\u3043\u3045\u3047\u3049\u3063\u3083\u3085\u3087\u308E\u3095\u3096\u31F0\u31F1\u31F2\u31F3\u31F4\u31F5\u31F6\u31F7\u31F8\u31F9\u31FA\u31FB\u31FC\u31FD\u31FE\u31FF\u3005\u303B\uFF67\uFF68\uFF69\uFF6A\uFF6B\uFF6C\uFF6D\uFF6E\uFF6F\uFF70\u201D\u3009\u300B\u300D\u300F\u3011\u3015\uFF09\uFF3D\uFF5D\uFF63")),wordWrapBreakBeforeCharacters:ye(new I(120,"wordWrapBreakBeforeCharacters","([{\u2018\u201C\u3008\u300A\u300C\u300E\u3010\u3014\uFF08\uFF3B\uFF5B\uFF62\xA3\xA5\uFF04\uFFE1\uFFE5+\uFF0B")),wordWrapColumn:ye(new l(121,"wordWrapColumn",80,1,1073741824,{markdownDescription:c.localize(256,null)})),wordWrapOverride1:ye(new o(122,"wordWrapOverride1","inherit",["off","on","inherit"])),wordWrapOverride2:ye(new o(123,"wordWrapOverride2","inherit",["off","on","inherit"])),wrappingIndent:ye(new h(124,"wrappingIndent",1,"same",["none","same","indent","deepIndent"],he,{enumDescriptions:[c.localize(257,null),c.localize(258,null),c.localize(259,null),c.localize(260,null)],description:c.localize(261,null)})),wrappingStrategy:ye(new o(125,"wrappingStrategy","simple",["simple","advanced"],{enumDescriptions:[c.localize(262,null),c.localize(263,null)],description:c.localize(264,null)})),editorClassName:ye(new k),pixelRatio:ye(new oe),tabFocusMode:ye(new q),layoutInfo:ye(new K),wrappingInfo:ye(new Te)}}),define(we[119],Ee([18,19]),function(re,e){return re.create("vs/platform/configuration/common/configurationRegistry",e)}),define(we[120],Ee([18,19]),function(re,e){return re.create("vs/platform/extensions/common/extensionValidator",e)}),define(we[121],Ee([18,19]),function(re,e){return re.create("vs/platform/files/common/files",e)}),define(we[122],Ee([18,19]),function(re,e){return re.create("vs/platform/markers/common/markers",e)}),define(we[123],Ee([18,19]),function(re,e){return re.create("vs/platform/theme/common/iconRegistry",e)}),define(we[124],Ee([18,19]),function(re,e){return re.create("vs/workbench/api/common/extHostDiagnostics",e)}),define(we[125],Ee([18,19]),function(re,e){return re.create("vs/workbench/api/common/extHostExtensionService",e)}),define(we[126],Ee([18,19]),function(re,e){return re.create("vs/workbench/api/common/extHostProgress",e)}),define(we[127],Ee([18,19]),function(re,e){return re.create("vs/workbench/api/common/extHostStatusBar",e)}),define(we[128],Ee([18,19]),function(re,e){return re.create("vs/workbench/api/common/extHostTerminalService",e)}),define(we[129],Ee([18,19]),function(re,e){return re.create("vs/workbench/api/common/extHostTreeViews",e)}),define(we[130],Ee([18,19]),function(re,e){return re.create("vs/workbench/api/common/extHostWorkspace",e)}),define(we[131],Ee([18,19]),function(re,e){return re.create("vs/workbench/common/editor",e)}),define(we[132],Ee([18,19]),function(re,e){return re.create("vs/workbench/common/views",e)}),define(we[133],Ee([18,19]),function(re,e){return re.create("vs/workbench/contrib/debug/common/abstractDebugAdapter",e)}),define(we[134],Ee([18,19]),function(re,e){return re.create("vs/workbench/contrib/search/common/queryBuilder",e)}),define(we[135],Ee([18,19]),function(re,e){return re.create("vs/workbench/contrib/tasks/common/taskService",e)}),define(we[136],Ee([18,19]),function(re,e){return re.create("vs/workbench/services/configurationResolver/common/variableResolver",e)}),define(we[137],Ee([0,1]),function(re,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TextEditorSelectionRevealType=e.EditorOpenContext=e.EditorResolution=e.EditorActivation=void 0;var c;(function(F){F[F.ACTIVATE=1]="ACTIVATE",F[F.RESTORE=2]="RESTORE",F[F.PRESERVE=3]="PRESERVE"})(c=e.EditorActivation||(e.EditorActivation={}));var M;(function(F){F[F.PICK=0]="PICK",F[F.DISABLED=1]="DISABLED",F[F.EXCLUSIVE_ONLY=2]="EXCLUSIVE_ONLY"})(M=e.EditorResolution||(e.EditorResolution={}));var b;(function(F){F[F.API=0]="API",F[F.USER=1]="USER"})(b=e.EditorOpenContext||(e.EditorOpenContext={}));var R;(function(F){F[F.Center=0]="Center",F[F.CenterIfOutsideViewport=1]="CenterIfOutsideViewport",F[F.NearTop=2]="NearTop",F[F.NearTopIfOutsideViewport=3]="NearTopIfOutsideViewport"})(R=e.TextEditorSelectionRevealType||(e.TextEditorSelectionRevealType={}))}),define(we[138],Ee([0,1,120]),function(re,e,c){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.isEngineValid=e.isValidExtensionVersion=e.isValidVersion=e.normalizeVersion=e.parseVersion=e.isValidVersionStr=void 0;const M=/^(\^|>=)?((\d+)|x)\.((\d+)|x)\.((\d+)|x)(\-.*)?$/,b=/^-(\d{4})(\d{2})(\d{2})$/;function R(n){return n=n.trim(),n==="*"||M.test(n)}e.isValidVersionStr=R;function F(n){if(!R(n))return null;if(n=n.trim(),n==="*")return{hasCaret:!1,hasGreaterEquals:!1,majorBase:0,majorMustEqual:!1,minorBase:0,minorMustEqual:!1,patchBase:0,patchMustEqual:!1,preRelease:null};let f=n.match(M);return f?{hasCaret:f[1]==="^",hasGreaterEquals:f[1]===">=",majorBase:f[2]==="x"?0:parseInt(f[2],10),majorMustEqual:f[2]!=="x",minorBase:f[4]==="x"?0:parseInt(f[4],10),minorMustEqual:f[4]!=="x",patchBase:f[6]==="x"?0:parseInt(f[6],10),patchMustEqual:f[6]!=="x",preRelease:f[8]||null}:null}e.parseVersion=F;function C(n){if(!n)return null;let f=n.majorBase,a=n.majorMustEqual,l=n.minorBase,w=n.minorMustEqual,I=n.patchBase,S=n.patchMustEqual;n.hasCaret&&(f===0||(w=!1),S=!1);let o=0;if(n.preRelease){const h=b.exec(n.preRelease);if(h){const[,y,i,v]=h;o=Date.UTC(Number(y),Number(i)-1,Number(v))}}return{majorBase:f,majorMustEqual:a,minorBase:l,minorMustEqual:w,patchBase:I,patchMustEqual:S,isMinimum:n.hasGreaterEquals,notBefore:o}}e.normalizeVersion=C;function _(n,f,a){let l;typeof n=="string"?l=C(F(n)):l=n;let w;f instanceof Date?w=f.getTime():typeof f=="string"&&(w=new Date(f).getTime());let I;if(typeof a=="string"?I=C(F(a)):I=a,!l||!I)return!1;let S=l.majorBase,o=l.minorBase,h=l.patchBase,y=I.majorBase,i=I.minorBase,v=I.patchBase,r=I.notBefore,s=I.majorMustEqual,u=I.minorMustEqual,d=I.patchMustEqual;return I.isMinimum?S>y?!0:S<y?!1:o>i?!0:o<i||w&&w<r?!1:h>=v:(S===1&&y===0&&(!s||!u||!d)&&(y=1,i=0,v=0,s=!0,u=!1,d=!1),S<y?!1:S>y?!s:o<i?!1:o>i?!u:h<v?!1:h>v?!d:!(w&&w<r))}e.isValidVersion=_;function P(n,f,a,l){return a.isBuiltin||typeof a.main=="undefined"?!0:E(n,f,a.engines.vscode,l)}e.isValidExtensionVersion=P;function t(n,f,a){return n==="*"||E(f,a,n)}e.isEngineValid=t;function E(n,f,a,l=[]){let w=C(F(a));if(!w)return l.push(c.localize(0,null,a)),!1;if(w.majorBase===0){if(!w.majorMustEqual||!w.minorMustEqual)return l.push(c.localize(1,null,a)),!1}else if(!w.majorMustEqual)return l.push(c.localize(2,null,a)),!1;return _(n,f,w)?!0:(l.push(c.localize(3,null,n,a)),!1)}}),define(we[81],Ee([0,1]),function(re,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.SyncDescriptor=void 0;class c{constructor(b,R=[],F=!1){this.ctor=b,this.staticArguments=R,this.supportsDelayedInstantiation=F}}e.SyncDescriptor=c}),define(we[57],Ee([0,1,81]),function(re,e,c){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getSingletonServiceDescriptors=e.registerSingleton=void 0;const M=[];function b(F,C,_){C instanceof c.SyncDescriptor||(C=new c.SyncDescriptor(C,[],_)),M.push([F,C])}e.registerSingleton=b;function R(){return M}e.getSingletonServiceDescriptors=R}),define(we[139],Ee([0,1]),function(re,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Graph=e.Node=void 0;class c{constructor(R){this.incoming=new Map,this.outgoing=new Map,this.data=R}}e.Node=c;class M{constructor(R){this._hashFn=R,this._nodes=new Map}roots(){const R=[];for(let F of this._nodes.values())F.outgoing.size===0&&R.push(F);return R}insertEdge(R,F){const C=this.lookupOrInsertNode(R),_=this.lookupOrInsertNode(F);C.outgoing.set(this._hashFn(F),_),_.incoming.set(this._hashFn(R),C)}removeNode(R){const F=this._hashFn(R);this._nodes.delete(F);for(let C of this._nodes.values())C.outgoing.delete(F),C.incoming.delete(F)}lookupOrInsertNode(R){const F=this._hashFn(R);let C=this._nodes.get(F);return C||(C=new c(R),this._nodes.set(F,C)),C}lookup(R){return this._nodes.get(this._hashFn(R))}isEmpty(){return this._nodes.size===0}toString(){let R=[];for(let[F,C]of this._nodes)R.push(`${F}, (incoming)[${[...C.incoming.keys()].join(", ")}], (outgoing)[${[...C.outgoing.keys()].join(",")}]`);return R.join(`
`)}findCycleSlow(){for(let[R,F]of this._nodes){const C=new Set([R]),_=this._findCycle(F,C);if(_)return _}}_findCycle(R,F){for(let[C,_]of R.outgoing){if(F.has(C))return[...F,C].join(" -> ");F.add(C);const P=this._findCycle(_,F);if(P)return P;F.delete(C)}}}e.Graph=M}),define(we[4],Ee([0,1]),function(re,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.optional=e.refineServiceDecorator=e.createDecorator=e.IInstantiationService=e._util=void 0;var c;(function(C){C.serviceIds=new Map,C.DI_TARGET="$di$target",C.DI_DEPENDENCIES="$di$dependencies";function _(P){return P[C.DI_DEPENDENCIES]||[]}C.getServiceDependencies=_})(c=e._util||(e._util={})),e.IInstantiationService=b("instantiationService");function M(C,_,P,t){_[c.DI_TARGET]===_?_[c.DI_DEPENDENCIES].push({id:C,index:P,optional:t}):(_[c.DI_DEPENDENCIES]=[{id:C,index:P,optional:t}],_[c.DI_TARGET]=_)}function b(C){if(c.serviceIds.has(C))return c.serviceIds.get(C);const _=function(P,t,E){if(arguments.length!==3)throw new Error("@IServiceName-decorator can only be used to decorate a parameter");M(_,P,E,!1)};return _.toString=()=>C,c.serviceIds.set(C,_),_}e.createDecorator=b;function R(C){return C}e.refineServiceDecorator=R;function F(C){return function(_,P,t){if(arguments.length!==3)throw new Error("@optional-decorator can only be used to decorate a parameter");M(C,_,t,!0)}}e.optional=F}),define(we[140],Ee([0,1,4]),function(re,e,c){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.shouldSynchronizeModel=e.IModelService=void 0,e.IModelService=(0,c.createDecorator)("modelService");function M(b){return!b.isTooLargeForSyncing()&&!b.isForSimpleWidget}e.shouldSynchronizeModel=M}),define(we[141],Ee([0,1,3,58,6,20,75,55,140]),function(re,e,c,M,b,R,F,C,_){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.LanguageFeatureRequestDelays=e.LanguageFeatureRegistry=void 0;function P(l){return typeof l=="string"?!1:Array.isArray(l)?l.every(P):!!l.exclusive}class t{constructor(){this._clock=0,this._entries=[],this._onDidChange=new c.Emitter}get onDidChange(){return this._onDidChange.event}register(w,I){let S={selector:w,provider:I,_score:-1,_time:this._clock++};return this._entries.push(S),this._lastCandidate=void 0,this._onDidChange.fire(this._entries.length),(0,b.toDisposable)(()=>{if(S){let o=this._entries.indexOf(S);o>=0&&(this._entries.splice(o,1),this._lastCandidate=void 0,this._onDidChange.fire(this._entries.length),S=void 0)}})}has(w){return this.all(w).length>0}all(w){if(!w)return[];this._updateScores(w);const I=[];for(let S of this._entries)S._score>0&&I.push(S.provider);return I}ordered(w){const I=[];return this._orderedForEach(w,S=>I.push(S.provider)),I}orderedGroups(w){const I=[];let S,o;return this._orderedForEach(w,h=>{S&&o===h._score?S.push(h.provider):(o=h._score,S=[h.provider],I.push(S))}),I}_orderedForEach(w,I){if(!!w){this._updateScores(w);for(const S of this._entries)S._score>0&&I(S)}}_updateScores(w){let I={uri:w.uri.toString(),language:w.getLanguageIdentifier().language};if(!(this._lastCandidate&&this._lastCandidate.language===I.language&&this._lastCandidate.uri===I.uri)){this._lastCandidate=I;for(let S of this._entries)if(S._score=(0,C.score)(S.selector,w.uri,w.getLanguageIdentifier().language,(0,_.shouldSynchronizeModel)(w)),P(S.selector)&&S._score>0){for(let o of this._entries)o._score=0;S._score=1e3;break}this._entries.sort(t._compareByScoreAndTime)}}static _compareByScoreAndTime(w,I){return w._score<I._score?1:w._score>I._score?-1:w._time<I._time?1:w._time>I._time?-1:0}}e.LanguageFeatureRegistry=t;const E=new WeakMap;let n=0;function f(l){let w=E.get(l);return w===void 0&&(w=++n,E.set(l,w)),w}class a{constructor(w,I,S=Number.MAX_SAFE_INTEGER){this._registry=w,this.min=I,this.max=S,this._cache=new R.LRUCache(50,.7)}_key(w){return w.id+this._registry.all(w).reduce((I,S)=>(0,M.doHash)(f(S),I),0)}_clamp(w){return w===void 0?this.min:Math.min(this.max,Math.max(this.min,Math.floor(w*1.3)))}get(w){const I=this._key(w),S=this._cache.get(I);return this._clamp(S?.value)}update(w,I){const S=this._key(w);let o=this._cache.get(S);return o||(o=new F.MovingAverage,this._cache.set(S,o)),o.update(I),this.get(w)}}e.LanguageFeatureRequestDelays=a}),define(we[59],Ee([0,1,2,44,141,114,34]),function(re,e,c,M,b,R,F){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExternalUriOpenerPriority=e.TokenizationRegistry=e.DocumentRangeSemanticTokensProviderRegistry=e.DocumentSemanticTokensProviderRegistry=e.FoldingRangeProviderRegistry=e.SelectionRangeRegistry=e.ColorProviderRegistry=e.LinkProviderRegistry=e.OnTypeFormattingEditProviderRegistry=e.DocumentRangeFormattingEditProviderRegistry=e.DocumentFormattingEditProviderRegistry=e.CodeActionProviderRegistry=e.InlayHintsProviderRegistry=e.CodeLensProviderRegistry=e.TypeDefinitionProviderRegistry=e.ImplementationProviderRegistry=e.DeclarationProviderRegistry=e.DefinitionProviderRegistry=e.LinkedEditingRangeProviderRegistry=e.DocumentHighlightProviderRegistry=e.DocumentSymbolProviderRegistry=e.InlineValuesProviderRegistry=e.EvaluatableExpressionProviderRegistry=e.HoverProviderRegistry=e.SignatureHelpProviderRegistry=e.InlineCompletionsProviderRegistry=e.CompletionProviderRegistry=e.RenameProviderRegistry=e.ReferenceProviderRegistry=e.InlayHintKind=e.CommentMode=e.CommentThreadCollapsibleState=e.FoldingRangeKind=e.SymbolKinds=e.SymbolTag=e.SymbolKind=e.isLocationLink=e.DocumentHighlightKind=e.SignatureHelpTriggerKind=e.CodeActionTriggerType=e.InlineCompletionTriggerKind=e.CompletionTriggerKind=e.CompletionItemInsertTextRule=e.CompletionItemTag=e.completionKindFromString=e.completionKindToCssClass=e.CompletionItemKind=e.TokenMetadata=e.MetadataConsts=e.StandardTokenType=e.ColorId=e.FontStyle=e.LanguageIdentifier=e.LanguageId=void 0;var C;(function(g){g[g.Null=0]="Null",g[g.PlainText=1]="PlainText"})(C=e.LanguageId||(e.LanguageId={}));class _{constructor(D,m){this.language=D,this.id=m}}e.LanguageIdentifier=_;var P;(function(g){g[g.NotSet=-1]="NotSet",g[g.None=0]="None",g[g.Italic=1]="Italic",g[g.Bold=2]="Bold",g[g.Underline=4]="Underline"})(P=e.FontStyle||(e.FontStyle={}));var t;(function(g){g[g.None=0]="None",g[g.DefaultForeground=1]="DefaultForeground",g[g.DefaultBackground=2]="DefaultBackground"})(t=e.ColorId||(e.ColorId={}));var E;(function(g){g[g.Other=0]="Other",g[g.Comment=1]="Comment",g[g.String=2]="String",g[g.RegEx=4]="RegEx"})(E=e.StandardTokenType||(e.StandardTokenType={}));var n;(function(g){g[g.LANGUAGEID_MASK=255]="LANGUAGEID_MASK",g[g.TOKEN_TYPE_MASK=1792]="TOKEN_TYPE_MASK",g[g.FONT_STYLE_MASK=14336]="FONT_STYLE_MASK",g[g.FOREGROUND_MASK=8372224]="FOREGROUND_MASK",g[g.BACKGROUND_MASK=4286578688]="BACKGROUND_MASK",g[g.ITALIC_MASK=2048]="ITALIC_MASK",g[g.BOLD_MASK=4096]="BOLD_MASK",g[g.UNDERLINE_MASK=8192]="UNDERLINE_MASK",g[g.SEMANTIC_USE_ITALIC=1]="SEMANTIC_USE_ITALIC",g[g.SEMANTIC_USE_BOLD=2]="SEMANTIC_USE_BOLD",g[g.SEMANTIC_USE_UNDERLINE=4]="SEMANTIC_USE_UNDERLINE",g[g.SEMANTIC_USE_FOREGROUND=8]="SEMANTIC_USE_FOREGROUND",g[g.SEMANTIC_USE_BACKGROUND=16]="SEMANTIC_USE_BACKGROUND",g[g.LANGUAGEID_OFFSET=0]="LANGUAGEID_OFFSET",g[g.TOKEN_TYPE_OFFSET=8]="TOKEN_TYPE_OFFSET",g[g.FONT_STYLE_OFFSET=11]="FONT_STYLE_OFFSET",g[g.FOREGROUND_OFFSET=14]="FOREGROUND_OFFSET",g[g.BACKGROUND_OFFSET=23]="BACKGROUND_OFFSET"})(n=e.MetadataConsts||(e.MetadataConsts={}));class f{static getLanguageId(D){return(D&255)>>>0}static getTokenType(D){return(D&1792)>>>8}static getFontStyle(D){return(D&14336)>>>11}static getForeground(D){return(D&8372224)>>>14}static getBackground(D){return(D&4286578688)>>>23}static getClassNameFromMetadata(D){let m=this.getForeground(D),A="mtk"+m,L=this.getFontStyle(D);return L&1&&(A+=" mtki"),L&2&&(A+=" mtkb"),L&4&&(A+=" mtku"),A}static getInlineStyleFromMetadata(D,m){const A=this.getForeground(D),L=this.getFontStyle(D);let V=`color: ${m[A]};`;return L&1&&(V+="font-style: italic;"),L&2&&(V+="font-weight: bold;"),L&4&&(V+="text-decoration: underline;"),V}}e.TokenMetadata=f;var a;(function(g){g[g.Method=0]="Method",g[g.Function=1]="Function",g[g.Constructor=2]="Constructor",g[g.Field=3]="Field",g[g.Variable=4]="Variable",g[g.Class=5]="Class",g[g.Struct=6]="Struct",g[g.Interface=7]="Interface",g[g.Module=8]="Module",g[g.Property=9]="Property",g[g.Event=10]="Event",g[g.Operator=11]="Operator",g[g.Unit=12]="Unit",g[g.Value=13]="Value",g[g.Constant=14]="Constant",g[g.Enum=15]="Enum",g[g.EnumMember=16]="EnumMember",g[g.Keyword=17]="Keyword",g[g.Text=18]="Text",g[g.Color=19]="Color",g[g.File=20]="File",g[g.Reference=21]="Reference",g[g.Customcolor=22]="Customcolor",g[g.Folder=23]="Folder",g[g.TypeParameter=24]="TypeParameter",g[g.User=25]="User",g[g.Issue=26]="Issue",g[g.Snippet=27]="Snippet"})(a=e.CompletionItemKind||(e.CompletionItemKind={})),e.completionKindToCssClass=function(){let g=Object.create(null);return g[0]="symbol-method",g[1]="symbol-function",g[2]="symbol-constructor",g[3]="symbol-field",g[4]="symbol-variable",g[5]="symbol-class",g[6]="symbol-struct",g[7]="symbol-interface",g[8]="symbol-module",g[9]="symbol-property",g[10]="symbol-event",g[11]="symbol-operator",g[12]="symbol-unit",g[13]="symbol-value",g[14]="symbol-constant",g[15]="symbol-enum",g[16]="symbol-enum-member",g[17]="symbol-keyword",g[27]="symbol-snippet",g[18]="symbol-text",g[19]="symbol-color",g[20]="symbol-file",g[21]="symbol-reference",g[22]="symbol-customcolor",g[23]="symbol-folder",g[24]="symbol-type-parameter",g[25]="account",g[26]="issues",function(D){const m=g[D];let A=m&&F.iconRegistry.get(m);return A||(console.info("No codicon found for CompletionItemKind "+D),A=F.Codicon.symbolProperty),A.classNames}}(),e.completionKindFromString=function(){let g=Object.create(null);return g.method=0,g.function=1,g.constructor=2,g.field=3,g.variable=4,g.class=5,g.struct=6,g.interface=7,g.module=8,g.property=9,g.event=10,g.operator=11,g.unit=12,g.value=13,g.constant=14,g.enum=15,g["enum-member"]=16,g.enumMember=16,g.keyword=17,g.snippet=27,g.text=18,g.color=19,g.file=20,g.reference=21,g.customcolor=22,g.folder=23,g["type-parameter"]=24,g.typeParameter=24,g.account=25,g.issue=26,function(D,m){let A=g[D];return typeof A=="undefined"&&!m&&(A=9),A}}();var l;(function(g){g[g.Deprecated=1]="Deprecated"})(l=e.CompletionItemTag||(e.CompletionItemTag={}));var w;(function(g){g[g.KeepWhitespace=1]="KeepWhitespace",g[g.InsertAsSnippet=4]="InsertAsSnippet"})(w=e.CompletionItemInsertTextRule||(e.CompletionItemInsertTextRule={}));var I;(function(g){g[g.Invoke=0]="Invoke",g[g.TriggerCharacter=1]="TriggerCharacter",g[g.TriggerForIncompleteCompletions=2]="TriggerForIncompleteCompletions"})(I=e.CompletionTriggerKind||(e.CompletionTriggerKind={}));var S;(function(g){g[g.Automatic=0]="Automatic",g[g.Explicit=1]="Explicit"})(S=e.InlineCompletionTriggerKind||(e.InlineCompletionTriggerKind={}));var o;(function(g){g[g.Invoke=1]="Invoke",g[g.Auto=2]="Auto"})(o=e.CodeActionTriggerType||(e.CodeActionTriggerType={}));var h;(function(g){g[g.Invoke=1]="Invoke",g[g.TriggerCharacter=2]="TriggerCharacter",g[g.ContentChange=3]="ContentChange"})(h=e.SignatureHelpTriggerKind||(e.SignatureHelpTriggerKind={}));var y;(function(g){g[g.Text=0]="Text",g[g.Read=1]="Read",g[g.Write=2]="Write"})(y=e.DocumentHighlightKind||(e.DocumentHighlightKind={}));function i(g){return g&&c.URI.isUri(g.uri)&&M.Range.isIRange(g.range)&&(M.Range.isIRange(g.originSelectionRange)||M.Range.isIRange(g.targetSelectionRange))}e.isLocationLink=i;var v;(function(g){g[g.File=0]="File",g[g.Module=1]="Module",g[g.Namespace=2]="Namespace",g[g.Package=3]="Package",g[g.Class=4]="Class",g[g.Method=5]="Method",g[g.Property=6]="Property",g[g.Field=7]="Field",g[g.Constructor=8]="Constructor",g[g.Enum=9]="Enum",g[g.Interface=10]="Interface",g[g.Function=11]="Function",g[g.Variable=12]="Variable",g[g.Constant=13]="Constant",g[g.String=14]="String",g[g.Number=15]="Number",g[g.Boolean=16]="Boolean",g[g.Array=17]="Array",g[g.Object=18]="Object",g[g.Key=19]="Key",g[g.Null=20]="Null",g[g.EnumMember=21]="EnumMember",g[g.Struct=22]="Struct",g[g.Event=23]="Event",g[g.Operator=24]="Operator",g[g.TypeParameter=25]="TypeParameter"})(v=e.SymbolKind||(e.SymbolKind={}));var r;(function(g){g[g.Deprecated=1]="Deprecated"})(r=e.SymbolTag||(e.SymbolTag={}));var s;(function(g){const D=new Map;D.set("file",0),D.set("module",1),D.set("namespace",2),D.set("package",3),D.set("class",4),D.set("method",5),D.set("property",6),D.set("field",7),D.set("constructor",8),D.set("enum",9),D.set("interface",10),D.set("function",11),D.set("variable",12),D.set("constant",13),D.set("string",14),D.set("number",15),D.set("boolean",16),D.set("array",17),D.set("object",18),D.set("key",19),D.set("null",20),D.set("enum-member",21),D.set("struct",22),D.set("event",23),D.set("operator",24),D.set("type-parameter",25);const m=new Map;m.set(0,"file"),m.set(1,"module"),m.set(2,"namespace"),m.set(3,"package"),m.set(4,"class"),m.set(5,"method"),m.set(6,"property"),m.set(7,"field"),m.set(8,"constructor"),m.set(9,"enum"),m.set(10,"interface"),m.set(11,"function"),m.set(12,"variable"),m.set(13,"constant"),m.set(14,"string"),m.set(15,"number"),m.set(16,"boolean"),m.set(17,"array"),m.set(18,"object"),m.set(19,"key"),m.set(20,"null"),m.set(21,"enum-member"),m.set(22,"struct"),m.set(23,"event"),m.set(24,"operator"),m.set(25,"type-parameter");function A(G){return D.get(G)}g.fromString=A;function L(G){return m.get(G)}g.toString=L;function V(G,U){const K=m.get(G);let $=K&&F.iconRegistry.get("symbol-"+K);return $||(console.info("No codicon found for SymbolKind "+G),$=F.Codicon.symbolProperty),`${U?"inline":"block"} ${$.classNames}`}g.toCssClassName=V})(s=e.SymbolKinds||(e.SymbolKinds={}));class u{constructor(D){this.value=D}}e.FoldingRangeKind=u,u.Comment=new u("comment"),u.Imports=new u("imports"),u.Region=new u("region");var d;(function(g){g[g.Collapsed=0]="Collapsed",g[g.Expanded=1]="Expanded"})(d=e.CommentThreadCollapsibleState||(e.CommentThreadCollapsibleState={}));var p;(function(g){g[g.Editing=0]="Editing",g[g.Preview=1]="Preview"})(p=e.CommentMode||(e.CommentMode={}));var k;(function(g){g[g.Other=0]="Other",g[g.Type=1]="Type",g[g.Parameter=2]="Parameter"})(k=e.InlayHintKind||(e.InlayHintKind={})),e.ReferenceProviderRegistry=new b.LanguageFeatureRegistry,e.RenameProviderRegistry=new b.LanguageFeatureRegistry,e.CompletionProviderRegistry=new b.LanguageFeatureRegistry,e.InlineCompletionsProviderRegistry=new b.LanguageFeatureRegistry,e.SignatureHelpProviderRegistry=new b.LanguageFeatureRegistry,e.HoverProviderRegistry=new b.LanguageFeatureRegistry,e.EvaluatableExpressionProviderRegistry=new b.LanguageFeatureRegistry,e.InlineValuesProviderRegistry=new b.LanguageFeatureRegistry,e.DocumentSymbolProviderRegistry=new b.LanguageFeatureRegistry,e.DocumentHighlightProviderRegistry=new b.LanguageFeatureRegistry,e.LinkedEditingRangeProviderRegistry=new b.LanguageFeatureRegistry,e.DefinitionProviderRegistry=new b.LanguageFeatureRegistry,e.DeclarationProviderRegistry=new b.LanguageFeatureRegistry,e.ImplementationProviderRegistry=new b.LanguageFeatureRegistry,e.TypeDefinitionProviderRegistry=new b.LanguageFeatureRegistry,e.CodeLensProviderRegistry=new b.LanguageFeatureRegistry,e.InlayHintsProviderRegistry=new b.LanguageFeatureRegistry,e.CodeActionProviderRegistry=new b.LanguageFeatureRegistry,e.DocumentFormattingEditProviderRegistry=new b.LanguageFeatureRegistry,e.DocumentRangeFormattingEditProviderRegistry=new b.LanguageFeatureRegistry,e.OnTypeFormattingEditProviderRegistry=new b.LanguageFeatureRegistry,e.LinkProviderRegistry=new b.LanguageFeatureRegistry,e.ColorProviderRegistry=new b.LanguageFeatureRegistry,e.SelectionRangeRegistry=new b.LanguageFeatureRegistry,e.FoldingRangeProviderRegistry=new b.LanguageFeatureRegistry,e.DocumentSemanticTokensProviderRegistry=new b.LanguageFeatureRegistry,e.DocumentRangeSemanticTokensProviderRegistry=new b.LanguageFeatureRegistry,e.TokenizationRegistry=new R.TokenizationRegistryImpl;var T;(function(g){g[g.None=0]="None",g[g.Option=1]="Option",g[g.Default=2]="Default",g[g.Preferred=3]="Preferred"})(T=e.ExternalUriOpenerPriority||(e.ExternalUriOpenerPriority={}))}),define(we[45],Ee([0,1,26,9,4]),function(re,e,c,M,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.implies=e.SET_CONTEXT_COMMAND_ID=e.IContextKeyService=e.RawContextKey=e.ContextKeyNotRegexExpr=e.ContextKeyRegexExpr=e.ContextKeySmallerEqualsExpr=e.ContextKeySmallerExpr=e.ContextKeyGreaterEqualsExpr=e.ContextKeyGreaterExpr=e.ContextKeyNotExpr=e.ContextKeyNotEqualsExpr=e.ContextKeyNotInExpr=e.ContextKeyInExpr=e.ContextKeyEqualsExpr=e.ContextKeyDefinedExpr=e.ContextKeyTrueExpr=e.ContextKeyFalseExpr=e.ContextKeyExpr=e.ContextKeyExprType=void 0;let R=c.userAgent||"";const F=new Map;F.set("false",!1),F.set("true",!0),F.set("isMac",c.isMacintosh),F.set("isLinux",c.isLinux),F.set("isWindows",c.isWindows),F.set("isWeb",c.isWeb),F.set("isMacNative",c.isMacintosh&&!c.isWeb),F.set("isEdge",R.indexOf("Edg/")>=0),F.set("isFirefox",R.indexOf("Firefox")>=0),F.set("isChrome",R.indexOf("Chrome")>=0),F.set("isSafari",R.indexOf("Safari")>=0);const C=Object.prototype.hasOwnProperty;var _;(function(D){D[D.False=0]="False",D[D.True=1]="True",D[D.Defined=2]="Defined",D[D.Not=3]="Not",D[D.Equals=4]="Equals",D[D.NotEquals=5]="NotEquals",D[D.And=6]="And",D[D.Regex=7]="Regex",D[D.NotRegex=8]="NotRegex",D[D.Or=9]="Or",D[D.In=10]="In",D[D.NotIn=11]="NotIn",D[D.Greater=12]="Greater",D[D.GreaterEquals=13]="GreaterEquals",D[D.Smaller=14]="Smaller",D[D.SmallerEquals=15]="SmallerEquals"})(_=e.ContextKeyExprType||(e.ContextKeyExprType={}));class P{static false(){return E.INSTANCE}static true(){return n.INSTANCE}static has(m){return f.create(m)}static equals(m,A){return a.create(m,A)}static notEquals(m,A){return I.create(m,A)}static regex(m,A){return v.create(m,A)}static in(m,A){return l.create(m,A)}static not(m){return S.create(m)}static and(...m){return s.create(m,null)}static or(...m){return u.create(m,null,!0)}static greater(m,A){return o.create(m,A)}static less(m,A){return y.create(m,A)}static deserialize(m,A=!1){if(!!m)return this._deserializeOrExpression(m,A)}static _deserializeOrExpression(m,A){let L=m.split("||");return u.create(L.map(V=>this._deserializeAndExpression(V,A)),null,!0)}static _deserializeAndExpression(m,A){let L=m.split("&&");return s.create(L.map(V=>this._deserializeOne(V,A)),null)}static _deserializeOne(m,A){if(m=m.trim(),m.indexOf("!=")>=0){let L=m.split("!=");return I.create(L[0].trim(),this._deserializeValue(L[1],A))}if(m.indexOf("==")>=0){let L=m.split("==");return a.create(L[0].trim(),this._deserializeValue(L[1],A))}if(m.indexOf("=~")>=0){let L=m.split("=~");return v.create(L[0].trim(),this._deserializeRegexValue(L[1],A))}if(m.indexOf(" in ")>=0){let L=m.split(" in ");return l.create(L[0].trim(),L[1].trim())}if(/^[^<=>]+>=[^<=>]+$/.test(m)){const L=m.split(">=");return h.create(L[0].trim(),L[1].trim())}if(/^[^<=>]+>[^<=>]+$/.test(m)){const L=m.split(">");return o.create(L[0].trim(),L[1].trim())}if(/^[^<=>]+<=[^<=>]+$/.test(m)){const L=m.split("<=");return i.create(L[0].trim(),L[1].trim())}if(/^[^<=>]+<[^<=>]+$/.test(m)){const L=m.split("<");return y.create(L[0].trim(),L[1].trim())}return/^\!\s*/.test(m)?S.create(m.substr(1).trim()):f.create(m)}static _deserializeValue(m,A){if(m=m.trim(),m==="true")return!0;if(m==="false")return!1;let L=/^'([^']*)'$/.exec(m);return L?L[1].trim():m}static _deserializeRegexValue(m,A){if((0,M.isFalsyOrWhitespace)(m)){if(A)throw new Error("missing regexp-value for =~-expression");return console.warn("missing regexp-value for =~-expression"),null}let L=m.indexOf("/"),V=m.lastIndexOf("/");if(L===V||L<0){if(A)throw new Error(`bad regexp-value '${m}', missing /-enclosure`);return console.warn(`bad regexp-value '${m}', missing /-enclosure`),null}let G=m.slice(L+1,V),U=m[V+1]==="i"?"i":"";try{return new RegExp(G,U)}catch(K){if(A)throw new Error(`bad regexp-value '${m}', parse error: ${K}`);return console.warn(`bad regexp-value '${m}', parse error: ${K}`),null}}}e.ContextKeyExpr=P;function t(D,m){return D.cmp(m)}class E{constructor(){this.type=0}cmp(m){return this.type-m.type}equals(m){return m.type===this.type}evaluate(m){return!1}serialize(){return"false"}keys(){return[]}map(m){return this}negate(){return n.INSTANCE}}e.ContextKeyFalseExpr=E,E.INSTANCE=new E;class n{constructor(){this.type=1}cmp(m){return this.type-m.type}equals(m){return m.type===this.type}evaluate(m){return!0}serialize(){return"true"}keys(){return[]}map(m){return this}negate(){return E.INSTANCE}}e.ContextKeyTrueExpr=n,n.INSTANCE=new n;class f{constructor(m,A){this.key=m,this.negated=A,this.type=2}static create(m,A=null){const L=F.get(m);return typeof L=="boolean"?L?n.INSTANCE:E.INSTANCE:new f(m,A)}cmp(m){return m.type!==this.type?this.type-m.type:p(this.key,m.key)}equals(m){return m.type===this.type?this.key===m.key:!1}evaluate(m){return!!m.getValue(this.key)}serialize(){return this.key}keys(){return[this.key]}map(m){return m.mapDefined(this.key)}negate(){return this.negated||(this.negated=S.create(this.key,this)),this.negated}}e.ContextKeyDefinedExpr=f;class a{constructor(m,A,L){this.key=m,this.value=A,this.negated=L,this.type=4}static create(m,A,L=null){if(typeof A=="boolean")return A?f.create(m,L):S.create(m,L);const V=F.get(m);return typeof V=="boolean"?A===(V?"true":"false")?n.INSTANCE:E.INSTANCE:new a(m,A,L)}cmp(m){return m.type!==this.type?this.type-m.type:k(this.key,this.value,m.key,m.value)}equals(m){return m.type===this.type?this.key===m.key&&this.value===m.value:!1}evaluate(m){return m.getValue(this.key)==this.value}serialize(){return`${this.key} == '${this.value}'`}keys(){return[this.key]}map(m){return m.mapEquals(this.key,this.value)}negate(){return this.negated||(this.negated=I.create(this.key,this.value,this)),this.negated}}e.ContextKeyEqualsExpr=a;class l{constructor(m,A){this.key=m,this.valueKey=A,this.type=10,this.negated=null}static create(m,A){return new l(m,A)}cmp(m){return m.type!==this.type?this.type-m.type:k(this.key,this.valueKey,m.key,m.valueKey)}equals(m){return m.type===this.type?this.key===m.key&&this.valueKey===m.valueKey:!1}evaluate(m){const A=m.getValue(this.valueKey),L=m.getValue(this.key);return Array.isArray(A)?A.indexOf(L)>=0:typeof L=="string"&&typeof A=="object"&&A!==null?C.call(A,L):!1}serialize(){return`${this.key} in '${this.valueKey}'`}keys(){return[this.key,this.valueKey]}map(m){return m.mapIn(this.key,this.valueKey)}negate(){return this.negated||(this.negated=w.create(this)),this.negated}}e.ContextKeyInExpr=l;class w{constructor(m){this._actual=m,this.type=11}static create(m){return new w(m)}cmp(m){return m.type!==this.type?this.type-m.type:this._actual.cmp(m._actual)}equals(m){return m.type===this.type?this._actual.equals(m._actual):!1}evaluate(m){return!this._actual.evaluate(m)}serialize(){throw new Error("Method not implemented.")}keys(){return this._actual.keys()}map(m){return new w(this._actual.map(m))}negate(){return this._actual}}e.ContextKeyNotInExpr=w;class I{constructor(m,A,L){this.key=m,this.value=A,this.negated=L,this.type=5}static create(m,A,L=null){if(typeof A=="boolean")return A?S.create(m,L):f.create(m,L);const V=F.get(m);return typeof V=="boolean"?A===(V?"true":"false")?E.INSTANCE:n.INSTANCE:new I(m,A,L)}cmp(m){return m.type!==this.type?this.type-m.type:k(this.key,this.value,m.key,m.value)}equals(m){return m.type===this.type?this.key===m.key&&this.value===m.value:!1}evaluate(m){return m.getValue(this.key)!=this.value}serialize(){return`${this.key} != '${this.value}'`}keys(){return[this.key]}map(m){return m.mapNotEquals(this.key,this.value)}negate(){return this.negated||(this.negated=a.create(this.key,this.value,this)),this.negated}}e.ContextKeyNotEqualsExpr=I;class S{constructor(m,A){this.key=m,this.negated=A,this.type=3}static create(m,A=null){const L=F.get(m);return typeof L=="boolean"?L?E.INSTANCE:n.INSTANCE:new S(m,A)}cmp(m){return m.type!==this.type?this.type-m.type:p(this.key,m.key)}equals(m){return m.type===this.type?this.key===m.key:!1}evaluate(m){return!m.getValue(this.key)}serialize(){return`!${this.key}`}keys(){return[this.key]}map(m){return m.mapNot(this.key)}negate(){return this.negated||(this.negated=f.create(this.key,this)),this.negated}}e.ContextKeyNotExpr=S;class o{constructor(m,A,L){this.key=m,this.value=A,this.negated=L,this.type=12}static create(m,A,L=null){return new o(m,A,L)}cmp(m){return m.type!==this.type?this.type-m.type:k(this.key,this.value,m.key,m.value)}equals(m){return m.type===this.type?this.key===m.key&&this.value===m.value:!1}evaluate(m){return parseFloat(m.getValue(this.key))>parseFloat(this.value)}serialize(){return`${this.key} > ${this.value}`}keys(){return[this.key]}map(m){return m.mapGreater(this.key,this.value)}negate(){return this.negated||(this.negated=i.create(this.key,this.value,this)),this.negated}}e.ContextKeyGreaterExpr=o;class h{constructor(m,A,L){this.key=m,this.value=A,this.negated=L,this.type=13}static create(m,A,L=null){return new h(m,A,L)}cmp(m){return m.type!==this.type?this.type-m.type:k(this.key,this.value,m.key,m.value)}equals(m){return m.type===this.type?this.key===m.key&&this.value===m.value:!1}evaluate(m){return parseFloat(m.getValue(this.key))>=parseFloat(this.value)}serialize(){return`${this.key} >= ${this.value}`}keys(){return[this.key]}map(m){return m.mapGreaterEquals(this.key,this.value)}negate(){return this.negated||(this.negated=y.create(this.key,this.value,this)),this.negated}}e.ContextKeyGreaterEqualsExpr=h;class y{constructor(m,A,L){this.key=m,this.value=A,this.negated=L,this.type=14}static create(m,A,L=null){return new y(m,A,L)}cmp(m){return m.type!==this.type?this.type-m.type:k(this.key,this.value,m.key,m.value)}equals(m){return m.type===this.type?this.key===m.key&&this.value===m.value:!1}evaluate(m){return parseFloat(m.getValue(this.key))<parseFloat(this.value)}serialize(){return`${this.key} < ${this.value}`}keys(){return[this.key]}map(m){return m.mapSmaller(this.key,this.value)}negate(){return this.negated||(this.negated=h.create(this.key,this.value,this)),this.negated}}e.ContextKeySmallerExpr=y;class i{constructor(m,A,L){this.key=m,this.value=A,this.negated=L,this.type=15}static create(m,A,L=null){return new i(m,A,L)}cmp(m){return m.type!==this.type?this.type-m.type:k(this.key,this.value,m.key,m.value)}equals(m){return m.type===this.type?this.key===m.key&&this.value===m.value:!1}evaluate(m){return parseFloat(m.getValue(this.key))<=parseFloat(this.value)}serialize(){return`${this.key} <= ${this.value}`}keys(){return[this.key]}map(m){return m.mapSmallerEquals(this.key,this.value)}negate(){return this.negated||(this.negated=o.create(this.key,this.value,this)),this.negated}}e.ContextKeySmallerEqualsExpr=i;class v{constructor(m,A){this.key=m,this.regexp=A,this.type=7,this.negated=null}static create(m,A){return new v(m,A)}cmp(m){if(m.type!==this.type)return this.type-m.type;if(this.key<m.key)return-1;if(this.key>m.key)return 1;const A=this.regexp?this.regexp.source:"",L=m.regexp?m.regexp.source:"";return A<L?-1:A>L?1:0}equals(m){if(m.type===this.type){const A=this.regexp?this.regexp.source:"",L=m.regexp?m.regexp.source:"";return this.key===m.key&&A===L}return!1}evaluate(m){let A=m.getValue(this.key);return this.regexp?this.regexp.test(A):!1}serialize(){const m=this.regexp?`/${this.regexp.source}/${this.regexp.ignoreCase?"i":""}`:"/invalid/";return`${this.key} =~ ${m}`}keys(){return[this.key]}map(m){return m.mapRegex(this.key,this.regexp)}negate(){return this.negated||(this.negated=r.create(this)),this.negated}}e.ContextKeyRegexExpr=v;class r{constructor(m){this._actual=m,this.type=8}static create(m){return new r(m)}cmp(m){return m.type!==this.type?this.type-m.type:this._actual.cmp(m._actual)}equals(m){return m.type===this.type?this._actual.equals(m._actual):!1}evaluate(m){return!this._actual.evaluate(m)}serialize(){throw new Error("Method not implemented.")}keys(){return this._actual.keys()}map(m){return new r(this._actual.map(m))}negate(){return this._actual}}e.ContextKeyNotRegexExpr=r;class s{constructor(m,A){this.expr=m,this.negated=A,this.type=6}static create(m,A){return s._normalizeArr(m,A)}cmp(m){if(m.type!==this.type)return this.type-m.type;if(this.expr.length<m.expr.length)return-1;if(this.expr.length>m.expr.length)return 1;for(let A=0,L=this.expr.length;A<L;A++){const V=t(this.expr[A],m.expr[A]);if(V!==0)return V}return 0}equals(m){if(m.type===this.type){if(this.expr.length!==m.expr.length)return!1;for(let A=0,L=this.expr.length;A<L;A++)if(!this.expr[A].equals(m.expr[A]))return!1;return!0}return!1}evaluate(m){for(let A=0,L=this.expr.length;A<L;A++)if(!this.expr[A].evaluate(m))return!1;return!0}static _normalizeArr(m,A){const L=[];let V=!1;for(const G of m)if(!!G){if(G.type===1){V=!0;continue}if(G.type===0)return E.INSTANCE;if(G.type===6){L.push(...G.expr);continue}L.push(G)}if(L.length===0&&V)return n.INSTANCE;if(L.length!==0){if(L.length===1)return L[0];L.sort(t);for(let G=1;G<L.length;G++)L[G-1].equals(L[G])&&(L.splice(G,1),G--);if(L.length===1)return L[0];for(;L.length>1;){const G=L[L.length-1];if(G.type!==9)break;L.pop();const U=L.pop(),K=L.length===0,$=u.create(G.expr.map(B=>s.create([B,U],null)),null,K);$&&(L.push($),L.sort(t))}return L.length===1?L[0]:new s(L,A)}}serialize(){return this.expr.map(m=>m.serialize()).join(" && ")}keys(){const m=[];for(let A of this.expr)m.push(...A.keys());return m}map(m){return new s(this.expr.map(A=>A.map(m)),null)}negate(){if(!this.negated){const m=[];for(let A of this.expr)m.push(A.negate());this.negated=u.create(m,this,!0)}return this.negated}}class u{constructor(m,A){this.expr=m,this.negated=A,this.type=9}static create(m,A,L){return u._normalizeArr(m,A,L)}cmp(m){if(m.type!==this.type)return this.type-m.type;if(this.expr.length<m.expr.length)return-1;if(this.expr.length>m.expr.length)return 1;for(let A=0,L=this.expr.length;A<L;A++){const V=t(this.expr[A],m.expr[A]);if(V!==0)return V}return 0}equals(m){if(m.type===this.type){if(this.expr.length!==m.expr.length)return!1;for(let A=0,L=this.expr.length;A<L;A++)if(!this.expr[A].equals(m.expr[A]))return!1;return!0}return!1}evaluate(m){for(let A=0,L=this.expr.length;A<L;A++)if(this.expr[A].evaluate(m))return!0;return!1}static _normalizeArr(m,A,L){let V=[],G=!1;if(m){for(let U=0,K=m.length;U<K;U++){const $=m[U];if(!!$){if($.type===0){G=!0;continue}if($.type===1)return n.INSTANCE;if($.type===9){V=V.concat($.expr);continue}V.push($)}}if(V.length===0&&G)return E.INSTANCE;V.sort(t)}if(V.length!==0){if(V.length===1)return V[0];for(let U=1;U<V.length;U++)V[U-1].equals(V[U])&&(V.splice(U,1),U--);if(V.length===1)return V[0];if(L){for(let U=0;U<V.length;U++)for(let K=U+1;K<V.length;K++)T(V[U],V[K])&&(V.splice(K,1),K--);if(V.length===1)return V[0]}return new u(V,A)}}serialize(){return this.expr.map(m=>m.serialize()).join(" || ")}keys(){const m=[];for(let A of this.expr)m.push(...A.keys());return m}map(m){return new u(this.expr.map(A=>A.map(m)),null)}negate(){if(!this.negated){let m=[];for(let A of this.expr)m.push(A.negate());for(;m.length>1;){const A=m.shift(),L=m.shift(),V=[];for(const U of g(A))for(const K of g(L))V.push(s.create([U,K],null));const G=m.length===0;m.unshift(u.create(V,null,G))}this.negated=m[0]}return this.negated}}class d extends f{constructor(m,A,L){super(m,null);this._defaultValue=A,typeof L=="object"?d._info.push({...L,key:m}):L!==!0&&d._info.push({key:m,description:L,type:A!=null?typeof A:void 0})}static all(){return d._info.values()}bindTo(m){return m.createKey(this.key,this._defaultValue)}getValue(m){return m.getContextKeyValue(this.key)}toNegated(){return this.negate()}isEqualTo(m){return a.create(this.key,m)}notEqualsTo(m){return I.create(this.key,m)}}e.RawContextKey=d,d._info=[],e.IContextKeyService=(0,b.createDecorator)("contextKeyService"),e.SET_CONTEXT_COMMAND_ID="setContext";function p(D,m){return D<m?-1:D>m?1:0}function k(D,m,A,L){return D<A?-1:D>A?1:m<L?-1:m>L?1:0}function T(D,m){if(m.type===6&&D.type!==9&&D.type!==6){for(const V of m.expr)if(D.equals(V))return!0}const A=D.negate(),L=g(A).concat(g(m));L.sort(t);for(let V=0;V<L.length;V++){const U=L[V].negate();for(let K=V+1;K<L.length;K++){const $=L[K];if(U.equals($))return!0}}return!1}e.implies=T;function g(D){return D.type===9?D.expr:[D]}}),define(we[142],Ee([0,1,4]),function(re,e,c){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.INativeEnvironmentService=e.IEnvironmentService=void 0,e.IEnvironmentService=(0,c.createDecorator)("environmentService"),e.INativeEnvironmentService=(0,c.refineServiceDecorator)(e.IEnvironmentService)}),define(we[25],Ee([0,1,9,4]),function(re,e,c,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IBuiltinExtensionsScannerService=e.isAuthenticaionProviderExtension=e.isLanguagePackExtension=e.ExtensionIdentifier=e.ExtensionType=e.EXTENSION_CATEGORIES=e.isIExtensionIdentifier=e.getWorkspaceSupportTypeMessage=e.ALL_EXTENSION_KINDS=e.BUILTIN_MANIFEST_CACHE_FILE=e.USER_MANIFEST_CACHE_FILE=e.MANIFEST_CACHE_FOLDER=void 0,e.MANIFEST_CACHE_FOLDER="CachedExtensions",e.USER_MANIFEST_CACHE_FILE="user",e.BUILTIN_MANIFEST_CACHE_FILE="builtin",e.ALL_EXTENSION_KINDS=["ui","workspace","web"];function b(t){if(typeof t=="object"&&t!==null&&t.supported!==!0)return t.description}e.getWorkspaceSupportTypeMessage=b;function R(t){return t&&typeof t=="object"&&typeof t.id=="string"&&(!t.uuid||typeof t.uuid=="string")}e.isIExtensionIdentifier=R,e.EXTENSION_CATEGORIES=["Azure","Data Science","Debuggers","Extension Packs","Education","Formatters","Keymaps","Language Packs","Linters","Machine Learning","Notebooks","Programming Languages","SCM Providers","Snippets","Testing","Themes","Visualization","Other"];var F;(function(t){t[t.System=0]="System",t[t.User=1]="User"})(F=e.ExtensionType||(e.ExtensionType={}));class C{constructor(E){this.value=E,this._lower=E.toLowerCase()}static equals(E,n){if(typeof E=="undefined"||E===null)return typeof n=="undefined"||n===null;if(typeof n=="undefined"||n===null)return!1;if(typeof E=="string"||typeof n=="string"){let f=typeof E=="string"?E:E.value,a=typeof n=="string"?n:n.value;return c.equalsIgnoreCase(f,a)}return E._lower===n._lower}static toKey(E){return typeof E=="string"?E.toLowerCase():E._lower}}e.ExtensionIdentifier=C;function _(t){return t.contributes&&t.contributes.localizations?t.contributes.localizations.length>0:!1}e.isLanguagePackExtension=_;function P(t){return t.contributes&&t.contributes.authentication?t.contributes.authentication.length>0:!1}e.isAuthenticaionProviderExtension=P,e.IBuiltinExtensionsScannerService=(0,M.createDecorator)("IBuiltinExtensionsScannerService")}),define(we[143],Ee([0,1,9,25]),function(re,e,c,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getExtensionDependencies=e.getMaliciousExtensionsSet=e.BetterMergeId=e.getGalleryExtensionTelemetryData=e.getLocalExtensionTelemetryData=e.groupByExtension=e.getGalleryExtensionId=e.adoptToGalleryExtensionId=e.getExtensionId=e.ExtensionIdentifierWithVersion=e.areSameExtensions=void 0;function b(a,l){return a.uuid&&l.uuid?a.uuid===l.uuid:a.id===l.id?!0:(0,c.compareIgnoreCase)(a.id,l.id)===0}e.areSameExtensions=b;class R{constructor(l,w){this.version=w,this.id=l.id,this.uuid=l.uuid}key(){return`${this.id}-${this.version}`}equals(l){return l instanceof R?b(this,l)&&this.version===l.version:!1}}e.ExtensionIdentifierWithVersion=R;function F(a,l){return`${a}.${l}`}e.getExtensionId=F;function C(a){return a.toLocaleLowerCase()}e.adoptToGalleryExtensionId=C;function _(a,l){return C(F(a,l))}e.getGalleryExtensionId=_;function P(a,l){const w=[],I=S=>{for(const o of w)if(o.some(h=>b(l(h),l(S))))return o;return null};for(const S of a){const o=I(S);o?o.push(S):w.push([S])}return w}e.groupByExtension=P;function t(a){return{id:a.identifier.id,name:a.manifest.name,galleryId:null,publisherId:a.publisherId,publisherName:a.manifest.publisher,publisherDisplayName:a.publisherDisplayName,dependencies:a.manifest.extensionDependencies&&a.manifest.extensionDependencies.length>0}}e.getLocalExtensionTelemetryData=t;function E(a){return{id:a.identifier.id,name:a.name,galleryId:a.identifier.uuid,publisherId:a.publisherId,publisherName:a.publisher,publisherDisplayName:a.publisherDisplayName,dependencies:!!(a.properties.dependencies&&a.properties.dependencies.length>0),...a.telemetryData}}e.getGalleryExtensionTelemetryData=E,e.BetterMergeId=new M.ExtensionIdentifier("pprice.better-merge");function n(a){const l=new Set;for(const w of a)w.malicious&&l.add(w.id.id);return l}e.getMaliciousExtensionsSet=n;function f(a,l){const w=[],I=l.manifest.extensionDependencies?.slice(0)??[];for(;I.length;){const S=I.shift();if(S&&w.every(o=>!b(o.identifier,{id:S}))){const o=a.filter(h=>b(h.identifier,{id:S}));o.length===1&&(w.push(o[0]),I.push(...o[0].manifest.extensionDependencies?.slice(0)??[]))}}return w}e.getExtensionDependencies=f}),define(we[60],Ee([0,1,20,17,9,10,2,121,4]),function(re,e,c,M,b,R,F,C,_){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getPlatformLimits=e.Arch=e.ByteSize=e.FALLBACK_MAX_MEMORY_SIZE_MB=e.MIN_MAX_MEMORY_SIZE_MB=e.whenProviderRegistered=e.etag=e.ETAG_DISABLED=e.FileKind=e.FILES_EXCLUDE_CONFIG=e.FILES_ASSOCIATIONS_CONFIG=e.HotExitConfiguration=e.AutoSaveConfiguration=e.FileOperationResult=e.NotModifiedSinceFileOperationError=e.FileOperationError=e.isParent=e.FileChangesEvent=e.FileChangeType=e.FileOperationEvent=e.FileOperation=e.toFileOperationResult=e.toFileSystemProviderErrorCode=e.markAsFileSystemProviderError=e.ensureFileSystemProviderError=e.createFileSystemProviderError=e.FileSystemProviderError=e.FileSystemProviderErrorCode=e.hasFileReadStreamCapability=e.hasOpenReadWriteCloseCapability=e.hasFileFolderCopyCapability=e.hasReadWriteCapability=e.FileSystemProviderCapabilities=e.FilePermission=e.FileType=e.isFileOpenForWriteOptions=e.IFileService=void 0,e.IFileService=(0,_.createDecorator)("fileService");function P(U){return U.create===!0}e.isFileOpenForWriteOptions=P;var t;(function(U){U[U.Unknown=0]="Unknown",U[U.File=1]="File",U[U.Directory=2]="Directory",U[U.SymbolicLink=64]="SymbolicLink"})(t=e.FileType||(e.FileType={}));var E;(function(U){U[U.Readonly=1]="Readonly"})(E=e.FilePermission||(e.FilePermission={}));var n;(function(U){U[U.FileReadWrite=2]="FileReadWrite",U[U.FileOpenReadWriteClose=4]="FileOpenReadWriteClose",U[U.FileReadStream=16]="FileReadStream",U[U.FileFolderCopy=8]="FileFolderCopy",U[U.PathCaseSensitive=1024]="PathCaseSensitive",U[U.Readonly=2048]="Readonly",U[U.Trash=4096]="Trash",U[U.FileWriteUnlock=8192]="FileWriteUnlock"})(n=e.FileSystemProviderCapabilities||(e.FileSystemProviderCapabilities={}));function f(U){return!!(U.capabilities&2)}e.hasReadWriteCapability=f;function a(U){return!!(U.capabilities&8)}e.hasFileFolderCopyCapability=a;function l(U){return!!(U.capabilities&4)}e.hasOpenReadWriteCloseCapability=l;function w(U){return!!(U.capabilities&16)}e.hasFileReadStreamCapability=w;var I;(function(U){U.FileExists="EntryExists",U.FileNotFound="EntryNotFound",U.FileNotADirectory="EntryNotADirectory",U.FileIsADirectory="EntryIsADirectory",U.FileExceedsMemoryLimit="EntryExceedsMemoryLimit",U.FileTooLarge="EntryTooLarge",U.FileWriteLocked="EntryWriteLocked",U.NoPermissions="NoPermissions",U.Unavailable="Unavailable",U.Unknown="Unknown"})(I=e.FileSystemProviderErrorCode||(e.FileSystemProviderErrorCode={}));class S extends Error{constructor(K,$){super(K);this.code=$}}e.FileSystemProviderError=S;function o(U,K){const $=new S(U.toString(),K);return y($,K),$}e.createFileSystemProviderError=o;function h(U){return U||o((0,C.localize)(0,null),I.Unknown)}e.ensureFileSystemProviderError=h;function y(U,K){return U.name=K?`${K} (FileSystemError)`:"FileSystemError",U}e.markAsFileSystemProviderError=y;function i(U){if(!U)return I.Unknown;if(U instanceof S)return U.code;const K=/^(.+) \(FileSystemError\)$/.exec(U.name);if(!K)return I.Unknown;switch(K[1]){case I.FileExists:return I.FileExists;case I.FileIsADirectory:return I.FileIsADirectory;case I.FileNotADirectory:return I.FileNotADirectory;case I.FileNotFound:return I.FileNotFound;case I.FileExceedsMemoryLimit:return I.FileExceedsMemoryLimit;case I.FileTooLarge:return I.FileTooLarge;case I.FileWriteLocked:return I.FileWriteLocked;case I.NoPermissions:return I.NoPermissions;case I.Unavailable:return I.Unavailable}return I.Unknown}e.toFileSystemProviderErrorCode=i;function v(U){if(U instanceof k)return U.fileOperationResult;switch(i(U)){case I.FileNotFound:return 1;case I.FileIsADirectory:return 0;case I.FileNotADirectory:return 10;case I.FileWriteLocked:return 5;case I.NoPermissions:return 6;case I.FileExists:return 4;case I.FileExceedsMemoryLimit:return 9;case I.FileTooLarge:return 7;default:return 11}}e.toFileOperationResult=v;var r;(function(U){U[U.CREATE=0]="CREATE",U[U.DELETE=1]="DELETE",U[U.MOVE=2]="MOVE",U[U.COPY=3]="COPY"})(r=e.FileOperation||(e.FileOperation={}));class s{constructor(K,$,B){this.resource=K,this.operation=$,this.target=B}isOperation(K){return this.operation===K}}e.FileOperationEvent=s;var u;(function(U){U[U.UPDATED=0]="UPDATED",U[U.ADDED=1]="ADDED",U[U.DELETED=2]="DELETED"})(u=e.FileChangeType||(e.FileChangeType={}));class d{constructor(K,$){this.added=void 0,this.updated=void 0,this.deleted=void 0;for(const B of K)switch(B.type){case 1:this.added||(this.added=c.TernarySearchTree.forUris(()=>$)),this.added.set(B.resource,B);break;case 0:this.updated||(this.updated=c.TernarySearchTree.forUris(()=>$)),this.updated.set(B.resource,B);break;case 2:this.deleted||(this.deleted=c.TernarySearchTree.forUris(()=>$)),this.deleted.set(B.resource,B);break}}contains(K,...$){return this.doContains(K,{includeChildren:!1},...$)}affects(K,...$){return this.doContains(K,{includeChildren:!0},...$)}doContains(K,$,...B){if(!K)return!1;const z=B.length>0;return!!((!z||B.includes(1))&&(this.added?.get(K)||$.includeChildren&&this.added?.findSuperstr(K))||(!z||B.includes(0))&&(this.updated?.get(K)||$.includeChildren&&this.updated?.findSuperstr(K))||(!z||B.includes(2))&&(this.deleted?.findSubstr(K)||$.includeChildren&&this.deleted?.findSuperstr(K)))}gotAdded(){return!!this.added}gotDeleted(){return!!this.deleted}gotUpdated(){return!!this.updated}get rawAdded(){return this.added}get rawDeleted(){return this.deleted}}e.FileChangesEvent=d;function p(U,K,$){return!U||!K||U===K||K.length>U.length?!1:(K.charAt(K.length-1)!==M.sep&&(K+=M.sep),$?(0,b.startsWithIgnoreCase)(U,K):U.indexOf(K)===0)}e.isParent=p;class k extends Error{constructor(K,$,B){super(K);this.fileOperationResult=$,this.options=B}}e.FileOperationError=k;class T extends k{constructor(K,$,B){super(K,2,B);this.stat=$}}e.NotModifiedSinceFileOperationError=T;var g;(function(U){U[U.FILE_IS_DIRECTORY=0]="FILE_IS_DIRECTORY",U[U.FILE_NOT_FOUND=1]="FILE_NOT_FOUND",U[U.FILE_NOT_MODIFIED_SINCE=2]="FILE_NOT_MODIFIED_SINCE",U[U.FILE_MODIFIED_SINCE=3]="FILE_MODIFIED_SINCE",U[U.FILE_MOVE_CONFLICT=4]="FILE_MOVE_CONFLICT",U[U.FILE_WRITE_LOCKED=5]="FILE_WRITE_LOCKED",U[U.FILE_PERMISSION_DENIED=6]="FILE_PERMISSION_DENIED",U[U.FILE_TOO_LARGE=7]="FILE_TOO_LARGE",U[U.FILE_INVALID_PATH=8]="FILE_INVALID_PATH",U[U.FILE_EXCEEDS_MEMORY_LIMIT=9]="FILE_EXCEEDS_MEMORY_LIMIT",U[U.FILE_NOT_DIRECTORY=10]="FILE_NOT_DIRECTORY",U[U.FILE_OTHER_ERROR=11]="FILE_OTHER_ERROR"})(g=e.FileOperationResult||(e.FileOperationResult={})),e.AutoSaveConfiguration={OFF:"off",AFTER_DELAY:"afterDelay",ON_FOCUS_CHANGE:"onFocusChange",ON_WINDOW_CHANGE:"onWindowChange"},e.HotExitConfiguration={OFF:"off",ON_EXIT:"onExit",ON_EXIT_AND_WINDOW_CLOSE:"onExitAndWindowClose"},e.FILES_ASSOCIATIONS_CONFIG="files.associations",e.FILES_EXCLUDE_CONFIG="files.exclude";var D;(function(U){U[U.FILE=0]="FILE",U[U.FOLDER=1]="FOLDER",U[U.ROOT_FOLDER=2]="ROOT_FOLDER"})(D=e.FileKind||(e.FileKind={})),e.ETAG_DISABLED="";function m(U){if(!(typeof U.size!="number"||typeof U.mtime!="number"))return U.mtime.toString(29)+U.size.toString(31)}e.etag=m;async function A(U,K){if(!K.canHandleResource(F.URI.from({scheme:U.scheme})))return new Promise($=>{const B=K.onDidChangeFileSystemProviderRegistrations(z=>{z.scheme===U.scheme&&z.added&&(B.dispose(),$())})})}e.whenProviderRegistered=A,e.MIN_MAX_MEMORY_SIZE_MB=2048,e.FALLBACK_MAX_MEMORY_SIZE_MB=4096;class L{static formatSize(K){return(0,R.isNumber)(K)||(K=0),K<L.KB?(0,C.localize)(1,null,K.toFixed(0)):K<L.MB?(0,C.localize)(2,null,(K/L.KB).toFixed(2)):K<L.GB?(0,C.localize)(3,null,(K/L.MB).toFixed(2)):K<L.TB?(0,C.localize)(4,null,(K/L.GB).toFixed(2)):(0,C.localize)(5,null,(K/L.TB).toFixed(2))}}e.ByteSize=L,L.KB=1024,L.MB=L.KB*L.KB,L.GB=L.MB*L.KB,L.TB=L.GB*L.KB;var V;(function(U){U[U.IA32=0]="IA32",U[U.OTHER=1]="OTHER"})(V=e.Arch||(e.Arch={}));function G(U){return{maxFileSize:U===0?300*L.MB:16*L.GB,maxHeapSize:U===0?700*L.MB:2*700*L.MB}}e.getPlatformLimits=G}),define(we[61],Ee([0,1]),function(re,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ServiceCollection=void 0;class c{constructor(...b){this._entries=new Map;for(let[R,F]of b)this.set(R,F)}set(b,R){const F=this._entries.get(b);return this._entries.set(b,R),F}has(b){return this._entries.has(b)}get(b){return this._entries.get(b)}}e.ServiceCollection=c}),define(we[144],Ee([0,1,14,16,81,139,4,61]),function(re,e,c,M,b,R,F,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.InstantiationService=void 0;const _=!1;class P extends Error{constructor(a){super("cyclic dependency between services");this.message=a.findCycleSlow()??`UNABLE to detect cycle, dumping graph: 
${a.toString()}`}}class t{constructor(a=new C.ServiceCollection,l=!1,w){this._activeInstantiations=new Set,this._services=a,this._strict=l,this._parent=w,this._services.set(F.IInstantiationService,this)}createChild(a){return new t(a,this._strict,this)}invokeFunction(a,...l){let w=n.traceInvocation(a),I=!1;try{return a({get:(o,h)=>{if(I)throw(0,M.illegalState)("service accessor is only valid during the invocation of its target method");const y=this._getOrCreateServiceInstance(o,w);if(!y&&h!==F.optional)throw new Error(`[invokeFunction] unknown service '${o}'`);return y}},...l)}finally{I=!0,w.stop()}}createInstance(a,...l){let w,I;return a instanceof b.SyncDescriptor?(w=n.traceCreation(a.ctor),I=this._createInstance(a.ctor,a.staticArguments.concat(l),w)):(w=n.traceCreation(a),I=this._createInstance(a,l,w)),w.stop(),I}_createInstance(a,l=[],w){let I=F._util.getServiceDependencies(a).sort((h,y)=>h.index-y.index),S=[];for(const h of I){let y=this._getOrCreateServiceInstance(h.id,w);if(!y&&this._strict&&!h.optional)throw new Error(`[createInstance] ${a.name} depends on UNKNOWN service ${h.id}.`);S.push(y)}let o=I.length>0?I[0].index:l.length;if(l.length!==o){console.warn(`[createInstance] First service dependency of ${a.name} at position ${o+1} conflicts with ${l.length} static arguments`);let h=o-l.length;h>0?l=l.concat(new Array(h)):l=l.slice(0,o)}return new a(...[...l,...S])}_setServiceInstance(a,l){if(this._services.get(a)instanceof b.SyncDescriptor)this._services.set(a,l);else if(this._parent)this._parent._setServiceInstance(a,l);else throw new Error("illegalState - setting UNKNOWN service instance")}_getServiceInstanceOrDescriptor(a){let l=this._services.get(a);return!l&&this._parent?this._parent._getServiceInstanceOrDescriptor(a):l}_getOrCreateServiceInstance(a,l){let w=this._getServiceInstanceOrDescriptor(a);return w instanceof b.SyncDescriptor?this._safeCreateAndCacheServiceInstance(a,w,l.branch(a,!0)):(l.branch(a,!1),w)}_safeCreateAndCacheServiceInstance(a,l,w){if(this._activeInstantiations.has(a))throw new Error(`illegal state - RECURSIVELY instantiating service '${a}'`);this._activeInstantiations.add(a);try{return this._createAndCacheServiceInstance(a,l,w)}finally{this._activeInstantiations.delete(a)}}_createAndCacheServiceInstance(a,l,w){const I=new R.Graph(h=>h.id.toString());let S=0;const o=[{id:a,desc:l,_trace:w}];for(;o.length;){const h=o.pop();if(I.lookupOrInsertNode(h),S++>1e3)throw new P(I);for(let y of F._util.getServiceDependencies(h.desc.ctor)){let i=this._getServiceInstanceOrDescriptor(y.id);if(!i&&!y.optional&&console.warn(`[createInstance] ${a} depends on ${y.id} which is NOT registered.`),i instanceof b.SyncDescriptor){const v={id:y.id,desc:i,_trace:h._trace.branch(y.id,!0)};I.insertEdge(h,v),o.push(v)}}}for(;;){const h=I.roots();if(h.length===0){if(!I.isEmpty())throw new P(I);break}for(const{data:y}of h){if(this._getServiceInstanceOrDescriptor(y.id)instanceof b.SyncDescriptor){const v=this._createServiceInstanceWithOwner(y.id,y.desc.ctor,y.desc.staticArguments,y.desc.supportsDelayedInstantiation,y._trace);this._setServiceInstance(y.id,v)}I.removeNode(y)}}return this._getServiceInstanceOrDescriptor(a)}_createServiceInstanceWithOwner(a,l,w=[],I,S){if(this._services.get(a)instanceof b.SyncDescriptor)return this._createServiceInstance(l,w,I,S);if(this._parent)return this._parent._createServiceInstanceWithOwner(a,l,w,I,S);throw new Error(`illegalState - creating UNKNOWN service instance ${l.name}`)}_createServiceInstance(a,l=[],w,I){if(w){const S=new c.IdleValue(()=>this._createInstance(a,l,I));return new Proxy(Object.create(null),{get(o,h){if(h in o)return o[h];let y=S.value,i=y[h];return typeof i!="function"||(i=i.bind(y),o[h]=i),i},set(o,h,y){return S.value[h]=y,!0}})}else return this._createInstance(a,l,I)}}e.InstantiationService=t;var E;(function(f){f[f.Creation=0]="Creation",f[f.Invocation=1]="Invocation",f[f.Branch=2]="Branch"})(E||(E={}));class n{constructor(a,l){this.type=a,this.name=l,this._start=Date.now(),this._dep=[]}static traceInvocation(a){return _?new n(1,a.name||a.toString().substring(0,42).replace(/\n/g,"")):n._None}static traceCreation(a){return _?new n(0,a.name):n._None}branch(a,l){let w=new n(2,a.toString());return this._dep.push([a,l,w]),w}stop(){let a=Date.now()-this._start;n._totals+=a;let l=!1;function w(S,o){let h=[],y=new Array(S+1).join("	");for(const[i,v,r]of o._dep)if(v&&r){l=!0,h.push(`${y}CREATES -> ${i}`);let s=w(S+1,r);s&&h.push(s)}else h.push(`${y}uses -> ${i}`);return h.join(`
`)}let I=[`${this.type===0?"CREATE":"CALL"} ${this.name}`,`${w(1,this)}`,`DONE, took ${a.toFixed(2)}ms (grand total ${n._totals.toFixed(2)}ms)`];(a>2||l)&&console.log(I.join(`
`))}}n._None=new class extends n{constructor(){super(-1,null)}stop(){}branch(){return this}},n._totals=0}),define(we[15],Ee([0,1,56,3,6,26,4]),function(re,e,c,M,b,R,F){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.LogLevelToString=e.parseLogLevel=e.getLogLevel=e.NullLogService=e.AbstractLoggerService=e.LogService=e.MultiplexLogService=e.AdapterLogger=e.ConsoleLogger=e.ConsoleMainLogger=e.AbstractMessageLogger=e.AbstractLogger=e.DEFAULT_LOG_LEVEL=e.LogLevel=e.ILoggerService=e.ILogService=void 0,e.ILogService=(0,F.createDecorator)("logService"),e.ILoggerService=(0,F.createDecorator)("loggerService");function C(){return new Date().toISOString()}var _;(function(y){y[y.Trace=0]="Trace",y[y.Debug=1]="Debug",y[y.Info=2]="Info",y[y.Warning=3]="Warning",y[y.Error=4]="Error",y[y.Critical=5]="Critical",y[y.Off=6]="Off"})(_=e.LogLevel||(e.LogLevel={})),e.DEFAULT_LOG_LEVEL=_.Info;class P extends b.Disposable{constructor(){super(...arguments);this.level=e.DEFAULT_LOG_LEVEL,this._onDidChangeLogLevel=this._register(new M.Emitter),this.onDidChangeLogLevel=this._onDidChangeLogLevel.event}setLevel(i){this.level!==i&&(this.level=i,this._onDidChangeLogLevel.fire(this.level))}getLevel(){return this.level}}e.AbstractLogger=P;class t extends P{constructor(i){super();this.logAlways=i}checkLogLevel(i){return this.logAlways||this.getLevel()<=i}trace(i,...v){this.checkLogLevel(_.Trace)&&this.log(_.Trace,this.format([i,...v]))}debug(i,...v){this.checkLogLevel(_.Debug)&&this.log(_.Debug,this.format([i,...v]))}info(i,...v){this.checkLogLevel(_.Info)&&this.log(_.Info,this.format([i,...v]))}warn(i,...v){this.checkLogLevel(_.Warning)&&this.log(_.Warning,this.format([i,...v]))}error(i,...v){if(this.checkLogLevel(_.Error))if(i instanceof Error){const r=Array.prototype.slice.call(arguments);r[0]=i.stack,this.log(_.Error,this.format(r))}else this.log(_.Error,this.format([i,...v]))}critical(i,...v){this.checkLogLevel(_.Critical)&&this.log(_.Critical,this.format([i,...v]))}flush(){}format(i){let v="";for(let r=0;r<i.length;r++){let s=i[r];if(typeof s=="object")try{s=JSON.stringify(s)}catch(u){}v+=(r>0?" ":"")+s}return v}}e.AbstractMessageLogger=t;class E extends P{constructor(i=e.DEFAULT_LOG_LEVEL){super();this.setLevel(i),this.useColors=!R.isWindows}trace(i,...v){this.getLevel()<=_.Trace&&(this.useColors?console.log(`[90m[main ${C()}][0m`,i,...v):console.log(`[main ${C()}]`,i,...v))}debug(i,...v){this.getLevel()<=_.Debug&&(this.useColors?console.log(`[90m[main ${C()}][0m`,i,...v):console.log(`[main ${C()}]`,i,...v))}info(i,...v){this.getLevel()<=_.Info&&(this.useColors?console.log(`[90m[main ${C()}][0m`,i,...v):console.log(`[main ${C()}]`,i,...v))}warn(i,...v){this.getLevel()<=_.Warning&&(this.useColors?console.warn(`[93m[main ${C()}][0m`,i,...v):console.warn(`[main ${C()}]`,i,...v))}error(i,...v){this.getLevel()<=_.Error&&(this.useColors?console.error(`[91m[main ${C()}][0m`,i,...v):console.error(`[main ${C()}]`,i,...v))}critical(i,...v){this.getLevel()<=_.Critical&&(this.useColors?console.error(`[90m[main ${C()}][0m`,i,...v):console.error(`[main ${C()}]`,i,...v))}dispose(){}flush(){}}e.ConsoleMainLogger=E;class n extends P{constructor(i=e.DEFAULT_LOG_LEVEL){super();this.setLevel(i)}trace(i,...v){this.getLevel()<=_.Trace&&console.log("%cTRACE","color: #888",i,...v)}debug(i,...v){this.getLevel()<=_.Debug&&console.log("%cDEBUG","background: #eee; color: #888",i,...v)}info(i,...v){this.getLevel()<=_.Info&&console.log("%c INFO","color: #33f",i,...v)}warn(i,...v){this.getLevel()<=_.Warning&&console.log("%c WARN","color: #993",i,...v)}error(i,...v){this.getLevel()<=_.Error&&console.log("%c  ERR","color: #f33",i,...v)}critical(i,...v){this.getLevel()<=_.Critical&&console.log("%cCRITI","background: #f33; color: white",i,...v)}dispose(){}flush(){}}e.ConsoleLogger=n;class f extends P{constructor(i,v=e.DEFAULT_LOG_LEVEL){super();this.adapter=i,this.setLevel(v)}trace(i,...v){this.getLevel()<=_.Trace&&this.adapter.log(_.Trace,[this.extractMessage(i),...v])}debug(i,...v){this.getLevel()<=_.Debug&&this.adapter.log(_.Debug,[this.extractMessage(i),...v])}info(i,...v){this.getLevel()<=_.Info&&this.adapter.log(_.Info,[this.extractMessage(i),...v])}warn(i,...v){this.getLevel()<=_.Warning&&this.adapter.log(_.Warning,[this.extractMessage(i),...v])}error(i,...v){this.getLevel()<=_.Error&&this.adapter.log(_.Error,[this.extractMessage(i),...v])}critical(i,...v){this.getLevel()<=_.Critical&&this.adapter.log(_.Critical,[this.extractMessage(i),...v])}extractMessage(i){return typeof i=="string"?i:(0,c.toErrorMessage)(i,this.getLevel()<=_.Trace)}dispose(){}flush(){}}e.AdapterLogger=f;class a extends P{constructor(i){super();this.logServices=i,i.length&&this.setLevel(i[0].getLevel())}setLevel(i){for(const v of this.logServices)v.setLevel(i);super.setLevel(i)}trace(i,...v){for(const r of this.logServices)r.trace(i,...v)}debug(i,...v){for(const r of this.logServices)r.debug(i,...v)}info(i,...v){for(const r of this.logServices)r.info(i,...v)}warn(i,...v){for(const r of this.logServices)r.warn(i,...v)}error(i,...v){for(const r of this.logServices)r.error(i,...v)}critical(i,...v){for(const r of this.logServices)r.critical(i,...v)}flush(){for(const i of this.logServices)i.flush()}dispose(){for(const i of this.logServices)i.dispose()}}e.MultiplexLogService=a;class l extends b.Disposable{constructor(i){super();this.logger=i,this._register(i)}get onDidChangeLogLevel(){return this.logger.onDidChangeLogLevel}setLevel(i){this.logger.setLevel(i)}getLevel(){return this.logger.getLevel()}trace(i,...v){this.logger.trace(i,...v)}debug(i,...v){this.logger.debug(i,...v)}info(i,...v){this.logger.info(i,...v)}warn(i,...v){this.logger.warn(i,...v)}error(i,...v){this.logger.error(i,...v)}critical(i,...v){this.logger.critical(i,...v)}flush(){this.logger.flush()}}e.LogService=l;class w extends b.Disposable{constructor(i,v){super();this.logLevel=i,this.loggers=new Map,this.logLevelChangeableLoggers=[],this._register(v(r=>{this.logLevel=r,this.logLevelChangeableLoggers.forEach(s=>s.setLevel(r))}))}getLogger(i){return this.loggers.get(i.toString())}createLogger(i,v){let r=this.loggers.get(i.toString());return r||(r=this.doCreateLogger(i,v?.always?_.Trace:this.logLevel,v),this.loggers.set(i.toString(),r),v?.always||this.logLevelChangeableLoggers.push(r)),r}dispose(){this.logLevelChangeableLoggers.splice(0,this.logLevelChangeableLoggers.length),this.loggers.forEach(i=>i.dispose()),this.loggers.clear(),super.dispose()}}e.AbstractLoggerService=w;class I{constructor(){this.onDidChangeLogLevel=new M.Emitter().event}setLevel(i){}getLevel(){return _.Info}trace(i,...v){}debug(i,...v){}info(i,...v){}warn(i,...v){}error(i,...v){}critical(i,...v){}dispose(){}flush(){}}e.NullLogService=I;function S(y){if(y.verbose)return _.Trace;if(typeof y.logLevel=="string"){const i=o(y.logLevel.toLowerCase());if(i!==void 0)return i}return e.DEFAULT_LOG_LEVEL}e.getLogLevel=S;function o(y){switch(y){case"trace":return _.Trace;case"debug":return _.Debug;case"info":return _.Info;case"warn":return _.Warning;case"error":return _.Error;case"critical":return _.Critical;case"off":return _.Off}}e.parseLogLevel=o;function h(y){switch(y){case _.Trace:return"trace";case _.Debug:return"debug";case _.Info:return"info";case _.Warning:return"warn";case _.Error:return"error";case _.Critical:return"critical";case _.Off:return"off"}}e.LogLevelToString=h}),define(we[82],Ee([0,1,35,122,4]),function(re,e,c,M,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IMarkerService=e.IMarkerData=e.MarkerSeverity=e.MarkerTag=void 0;var R;(function(_){_[_.Unnecessary=1]="Unnecessary",_[_.Deprecated=2]="Deprecated"})(R=e.MarkerTag||(e.MarkerTag={}));var F;(function(_){_[_.Hint=1]="Hint",_[_.Info=2]="Info",_[_.Warning=4]="Warning",_[_.Error=8]="Error"})(F=e.MarkerSeverity||(e.MarkerSeverity={})),function(_){function P(a,l){return l-a}_.compare=P;const t=Object.create(null);t[_.Error]=(0,M.localize)(0,null),t[_.Warning]=(0,M.localize)(1,null),t[_.Info]=(0,M.localize)(2,null);function E(a){return t[a]||""}_.toString=E;function n(a){switch(a){case c.default.Error:return _.Error;case c.default.Warning:return _.Warning;case c.default.Info:return _.Info;case c.default.Ignore:return _.Hint}}_.fromSeverity=n;function f(a){switch(a){case _.Error:return c.default.Error;case _.Warning:return c.default.Warning;case _.Info:return c.default.Info;case _.Hint:return c.default.Ignore}}_.toSeverity=f}(F=e.MarkerSeverity||(e.MarkerSeverity={}));var C;(function(_){const P="";function t(n){return E(n,!0)}_.makeKey=t;function E(n,f){let a=[P];return n.source?a.push(n.source.replace("\xA6","\\\xA6")):a.push(P),n.code?typeof n.code=="string"?a.push(n.code.replace("\xA6","\\\xA6")):a.push(n.code.value.replace("\xA6","\\\xA6")):a.push(P),n.severity!==void 0&&n.severity!==null?a.push(F.toString(n.severity)):a.push(P),n.message&&f?a.push(n.message.replace("\xA6","\\\xA6")):a.push(P),n.startLineNumber!==void 0&&n.startLineNumber!==null?a.push(n.startLineNumber.toString()):a.push(P),n.startColumn!==void 0&&n.startColumn!==null?a.push(n.startColumn.toString()):a.push(P),n.endLineNumber!==void 0&&n.endLineNumber!==null?a.push(n.endLineNumber.toString()):a.push(P),n.endColumn!==void 0&&n.endColumn!==null?a.push(n.endColumn.toString()):a.push(P),a.push(P),a.join("\xA6")}_.makeKeyOptionalMessage=E})(C=e.IMarkerData||(e.IMarkerData={})),e.IMarkerService=(0,b.createDecorator)("markerService")}),define(we[145],Ee([0,1,3,35,4]),function(re,e,c,M,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.NoOpProgress=e.NoOpNotification=e.NotificationsFilter=e.NeverShowAgainScope=e.INotificationService=e.Severity=void 0,e.Severity=M.default,e.INotificationService=(0,b.createDecorator)("notificationService");var R;(function(P){P[P.WORKSPACE=0]="WORKSPACE",P[P.GLOBAL=1]="GLOBAL"})(R=e.NeverShowAgainScope||(e.NeverShowAgainScope={}));var F;(function(P){P[P.OFF=0]="OFF",P[P.SILENT=1]="SILENT",P[P.ERROR=2]="ERROR"})(F=e.NotificationsFilter||(e.NotificationsFilter={}));class C{constructor(){this.progress=new _,this.onDidClose=c.Event.None,this.onDidChangeVisibility=c.Event.None}updateSeverity(t){}updateMessage(t){}updateActions(t){}close(){}}e.NoOpNotification=C;class _{infinite(){}done(){}total(t){}worked(t){}}e.NoOpProgress=_}),define(we[146],Ee([0,1,6,9,2,4]),function(re,e,c,M,b,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.matchesScheme=e.NullOpenerService=e.IOpenerService=void 0,e.IOpenerService=(0,R.createDecorator)("openerService"),e.NullOpenerService=Object.freeze({_serviceBrand:void 0,registerOpener(){return c.Disposable.None},registerValidator(){return c.Disposable.None},registerExternalUriResolver(){return c.Disposable.None},setDefaultExternalOpener(){},registerExternalOpener(){return c.Disposable.None},async open(){return!1},async resolveExternalUri(C){return{resolved:C,dispose(){}}}});function F(C,_){return b.URI.isUri(C)?(0,M.equalsIgnoreCase)(C.scheme,_):(0,M.startsWithIgnoreCase)(C,_+":")}e.matchesScheme=F});var We=this&&this.__decorate||function(re,e,c,M){var b=arguments.length,R=b<3?e:M===null?M=Object.getOwnPropertyDescriptor(e,c):M,F;if(typeof Reflect=="object"&&typeof Reflect.decorate=="function")R=Reflect.decorate(re,e,c,M);else for(var C=re.length-1;C>=0;C--)(F=re[C])&&(R=(b<3?F(R):b>3?F(e,c,R):F(e,c))||R);return b>3&&R&&Object.defineProperty(e,c,R),R},ze=this&&this.__param||function(re,e){return function(c,M){e(c,M,re)}};define(we[147],Ee([0,1,14,21,6,4]),function(re,e,c,M,b,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IEditorProgressService=e.LongRunningOperation=e.UnmanagedProgress=e.Progress=e.emptyProgressRunner=e.ProgressLocation=e.IProgressService=void 0,e.IProgressService=(0,R.createDecorator)("progressService");var F;(function(t){t[t.Explorer=1]="Explorer",t[t.Scm=3]="Scm",t[t.Extensions=5]="Extensions",t[t.Window=10]="Window",t[t.Notification=15]="Notification",t[t.Dialog=20]="Dialog"})(F=e.ProgressLocation||(e.ProgressLocation={})),e.emptyProgressRunner=Object.freeze({total(){},worked(){},done(){}});class C{constructor(E){this.callback=E}get value(){return this._value}report(E){this._value=E,this.callback(this._value)}}e.Progress=C,C.None=Object.freeze({report(){}});let _=class extends b.Disposable{constructor(E,n){super();this.deferred=new c.DeferredPromise,n.withProgress(E,f=>(this.reporter=f,this.lastStep&&f.report(this.lastStep),this.deferred.p)),this._register((0,b.toDisposable)(()=>this.deferred.complete()))}report(E){this.reporter?this.reporter.report(E):this.lastStep=E}};_=We([ze(1,e.IProgressService)],_),e.UnmanagedProgress=_;class P extends b.Disposable{constructor(E){super();this.progressIndicator=E,this.currentOperationId=0,this.currentOperationDisposables=this._register(new b.DisposableStore)}start(E){this.stop();const n=++this.currentOperationId,f=new M.CancellationTokenSource;return this.currentProgressTimeout=setTimeout(()=>{n===this.currentOperationId&&(this.currentProgressRunner=this.progressIndicator.show(!0))},E),this.currentOperationDisposables.add((0,b.toDisposable)(()=>clearTimeout(this.currentProgressTimeout))),this.currentOperationDisposables.add((0,b.toDisposable)(()=>f.cancel())),this.currentOperationDisposables.add((0,b.toDisposable)(()=>this.currentProgressRunner?this.currentProgressRunner.done():void 0)),{id:n,token:f.token,stop:()=>this.doStop(n),isCurrent:()=>this.currentOperationId===n}}stop(){this.doStop(this.currentOperationId)}doStop(E){this.currentOperationId===E&&this.currentOperationDisposables.clear()}}e.LongRunningOperation=P,e.IEditorProgressService=(0,R.createDecorator)("editorProgressService")}),define(we[28],Ee([0,1,42,10]),function(re,e,c,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Registry=void 0;class b{constructor(){this.data=new Map}add(F,C){c.ok(M.isString(F)),c.ok(M.isObject(C)),c.ok(!this.data.has(F),"There is already an extension with this id"),this.data.set(F,C)}knows(F){return this.data.has(F)}as(F){return this.data.get(F)||null}}e.Registry=new b}),define(we[83],Ee([0,1,3,28]),function(re,e,c,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Extensions=void 0,e.Extensions={JSONContribution:"base.contributions.json"};function b(C){return C.length>0&&C.charAt(C.length-1)==="#"?C.substring(0,C.length-1):C}class R{constructor(){this._onDidChangeSchema=new c.Emitter,this.onDidChangeSchema=this._onDidChangeSchema.event,this.schemasById={}}registerSchema(_,P){this.schemasById[b(_)]=P,this._onDidChangeSchema.fire(_)}notifySchemaChanged(_){this._onDidChangeSchema.fire(_)}getSchemaContributions(){return{schemas:this.schemasById}}}const F=new R;M.Registry.add(e.Extensions.JSONContribution,F)}),define(we[62],Ee([0,1,12,3,10,119,83,28]),function(re,e,c,M,b,R,F,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getScopes=e.validateProperty=e.getDefaultValue=e.overrideIdentifierFromKey=e.OVERRIDE_PROPERTY_PATTERN=e.resourceLanguageSettingsSchemaId=e.resourceSettings=e.windowSettings=e.machineOverridableSettings=e.machineSettings=e.applicationSettings=e.allSettings=e.ConfigurationScope=e.Extensions=e.EditPresentationTypes=void 0;var _;(function(S){S.Multiline="multilineText",S.Singleline="singlelineText"})(_=e.EditPresentationTypes||(e.EditPresentationTypes={})),e.Extensions={Configuration:"base.contributions.configuration"};var P;(function(S){S[S.APPLICATION=1]="APPLICATION",S[S.MACHINE=2]="MACHINE",S[S.WINDOW=3]="WINDOW",S[S.RESOURCE=4]="RESOURCE",S[S.LANGUAGE_OVERRIDABLE=5]="LANGUAGE_OVERRIDABLE",S[S.MACHINE_OVERRIDABLE=6]="MACHINE_OVERRIDABLE"})(P=e.ConfigurationScope||(e.ConfigurationScope={})),e.allSettings={properties:{},patternProperties:{}},e.applicationSettings={properties:{},patternProperties:{}},e.machineSettings={properties:{},patternProperties:{}},e.machineOverridableSettings={properties:{},patternProperties:{}},e.windowSettings={properties:{},patternProperties:{}},e.resourceSettings={properties:{},patternProperties:{}},e.resourceLanguageSettingsSchemaId="vscode://schemas/settings/resourceLanguage";const t=C.Registry.as(F.Extensions.JSONContribution);class E{constructor(){this.overrideIdentifiers=new Set,this._onDidSchemaChange=new M.Emitter,this.onDidSchemaChange=this._onDidSchemaChange.event,this._onDidUpdateConfiguration=new M.Emitter,this.onDidUpdateConfiguration=this._onDidUpdateConfiguration.event,this.defaultValues={},this.defaultLanguageConfigurationOverridesNode={id:"defaultOverrides",title:R.localize(0,null),properties:{}},this.configurationContributors=[this.defaultLanguageConfigurationOverridesNode],this.resourceLanguageSettingsSchema={properties:{},patternProperties:{},additionalProperties:!1,errorMessage:"Unknown editor configuration setting",allowTrailingCommas:!0,allowComments:!0},this.configurationProperties={},this.excludedConfigurationProperties={},t.registerSchema(e.resourceLanguageSettingsSchemaId,this.resourceLanguageSettingsSchema)}registerConfiguration(o,h=!0){this.registerConfigurations([o],h)}registerConfigurations(o,h=!0){const y=this.doRegisterConfigurations(o,h);t.registerSchema(e.resourceLanguageSettingsSchemaId,this.resourceLanguageSettingsSchema),this._onDidSchemaChange.fire(),this._onDidUpdateConfiguration.fire(y)}deregisterConfigurations(o){const h=this.doDeregisterConfigurations(o);t.registerSchema(e.resourceLanguageSettingsSchemaId,this.resourceLanguageSettingsSchema),this._onDidSchemaChange.fire(),this._onDidUpdateConfiguration.fire(h)}updateConfigurations({add:o,remove:h}){const y=[];y.push(...this.doDeregisterConfigurations(h)),y.push(...this.doRegisterConfigurations(o,!1)),t.registerSchema(e.resourceLanguageSettingsSchemaId,this.resourceLanguageSettingsSchema),this._onDidSchemaChange.fire(),this._onDidUpdateConfiguration.fire((0,c.distinct)(y))}registerDefaultConfigurations(o){const h=[],y=[];for(const i of o)for(const v in i)if(h.push(v),e.OVERRIDE_PROPERTY_PATTERN.test(v)){this.defaultValues[v]={...this.defaultValues[v]||{},...i[v]};const r={type:"object",default:this.defaultValues[v],description:R.localize(1,null,v),$ref:e.resourceLanguageSettingsSchemaId};y.push(f(v)),this.configurationProperties[v]=r,this.defaultLanguageConfigurationOverridesNode.properties[v]=r}else{this.defaultValues[v]=i[v];const r=this.configurationProperties[v];r&&(this.updatePropertyDefaultValue(v,r),this.updateSchema(v,r))}this.registerOverrideIdentifiers(y),this._onDidSchemaChange.fire(),this._onDidUpdateConfiguration.fire(h)}deregisterDefaultConfigurations(o){const h=[];for(const y of o)for(const i in y)if(h.push(i),delete this.defaultValues[i],e.OVERRIDE_PROPERTY_PATTERN.test(i))delete this.configurationProperties[i],delete this.defaultLanguageConfigurationOverridesNode.properties[i];else{const v=this.configurationProperties[i];v&&(this.updatePropertyDefaultValue(i,v),this.updateSchema(i,v))}this.updateOverridePropertyPatternKey(),this._onDidSchemaChange.fire(),this._onDidUpdateConfiguration.fire(h)}notifyConfigurationSchemaUpdated(...o){this._onDidSchemaChange.fire()}registerOverrideIdentifiers(o){for(const h of o)this.overrideIdentifiers.add(h);this.updateOverridePropertyPatternKey()}doRegisterConfigurations(o,h){const y=[];return o.forEach(i=>{y.push(...this.validateAndRegisterProperties(i,h,i.extensionInfo)),this.configurationContributors.push(i),this.registerJSONConfiguration(i)}),y}doDeregisterConfigurations(o){const h=[],y=i=>{if(i.properties)for(const v in i.properties)h.push(v),delete this.configurationProperties[v],this.removeFromSchema(v,i.properties[v]);i.allOf&&i.allOf.forEach(v=>y(v))};for(const i of o){y(i);const v=this.configurationContributors.indexOf(i);v!==-1&&this.configurationContributors.splice(v,1)}return h}validateAndRegisterProperties(o,h=!0,y,i=3){i=b.isUndefinedOrNull(o.scope)?i:o.scope;let v=[],r=o.properties;if(r)for(let u in r){if(h&&w(u)){delete r[u];continue}const d=r[u];if(this.updatePropertyDefaultValue(u,d),e.OVERRIDE_PROPERTY_PATTERN.test(u)?d.scope=void 0:(d.scope=b.isUndefinedOrNull(d.scope)?i:d.scope,d.restricted=b.isUndefinedOrNull(d.restricted)?!!y?.restrictedConfigurations?.includes(u):d.restricted),r[u].hasOwnProperty("included")&&!r[u].included){this.excludedConfigurationProperties[u]=r[u],delete r[u];continue}else this.configurationProperties[u]=r[u];!r[u].deprecationMessage&&r[u].markdownDeprecationMessage&&(r[u].deprecationMessage=r[u].markdownDeprecationMessage),v.push(u)}let s=o.allOf;if(s)for(let u of s)v.push(...this.validateAndRegisterProperties(u,h,y,i));return v}getConfigurations(){return this.configurationContributors}getConfigurationProperties(){return this.configurationProperties}getExcludedConfigurationProperties(){return this.excludedConfigurationProperties}registerJSONConfiguration(o){const h=y=>{let i=y.properties;if(i)for(const r in i)this.updateSchema(r,i[r]);let v=y.allOf;v&&v.forEach(h)};h(o)}updateSchema(o,h){switch(e.allSettings.properties[o]=h,h.scope){case 1:e.applicationSettings.properties[o]=h;break;case 2:e.machineSettings.properties[o]=h;break;case 6:e.machineOverridableSettings.properties[o]=h;break;case 3:e.windowSettings.properties[o]=h;break;case 4:e.resourceSettings.properties[o]=h;break;case 5:e.resourceSettings.properties[o]=h,this.resourceLanguageSettingsSchema.properties[o]=h;break}}removeFromSchema(o,h){switch(delete e.allSettings.properties[o],h.scope){case 1:delete e.applicationSettings.properties[o];break;case 2:delete e.machineSettings.properties[o];break;case 6:delete e.machineOverridableSettings.properties[o];break;case 3:delete e.windowSettings.properties[o];break;case 4:case 5:delete e.resourceSettings.properties[o];break}}updateOverridePropertyPatternKey(){for(const o of this.overrideIdentifiers.values()){const h=`[${o}]`,y={type:"object",description:R.localize(2,null),errorMessage:R.localize(3,null),$ref:e.resourceLanguageSettingsSchemaId};this.updatePropertyDefaultValue(h,y),e.allSettings.properties[h]=y,e.applicationSettings.properties[h]=y,e.machineSettings.properties[h]=y,e.machineOverridableSettings.properties[h]=y,e.windowSettings.properties[h]=y,e.resourceSettings.properties[h]=y}this._onDidSchemaChange.fire()}updatePropertyDefaultValue(o,h){let y=this.defaultValues[o];b.isUndefined(y)&&(y=h.default),b.isUndefined(y)&&(y=a(h.type)),h.default=y}}const n="\\[.*\\]$";e.OVERRIDE_PROPERTY_PATTERN=new RegExp(n);function f(S){return S.substring(1,S.length-1)}e.overrideIdentifierFromKey=f;function a(S){switch(Array.isArray(S)?S[0]:S){case"boolean":return!1;case"integer":case"number":return 0;case"string":return"";case"array":return[];case"object":return{};default:return null}}e.getDefaultValue=a;const l=new E;C.Registry.add(e.Extensions.Configuration,l);function w(S){return S.trim()?e.OVERRIDE_PROPERTY_PATTERN.test(S)?R.localize(5,null,S):l.getConfigurationProperties()[S]!==void 0?R.localize(6,null,S):null:R.localize(4,null)}e.validateProperty=w;function I(){const S=[],o=l.getConfigurationProperties();for(const h of Object.keys(o))S.push([h,o[h].scope]);return S.push(["launch",4]),S.push(["task",4]),S}e.getScopes=I}),define(we[84],Ee([0,1,23,10,2,62,4,28]),function(re,e,c,M,b,R,F,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getMigratedSettingValue=e.keyFromOverrideIdentifier=e.getDefaultValues=e.getConfigurationKeys=e.merge=e.getConfigurationValue=e.removeFromValueTree=e.addToValueTree=e.toValuesTree=e.toOverrides=e.compare=e.ConfigurationTargetToString=e.ConfigurationTarget=e.isConfigurationOverrides=e.IConfigurationService=void 0,e.IConfigurationService=(0,F.createDecorator)("configurationService");function _(v){return v&&typeof v=="object"&&(!v.overrideIdentifier||typeof v.overrideIdentifier=="string")&&(!v.resource||v.resource instanceof b.URI)}e.isConfigurationOverrides=_;var P;(function(v){v[v.USER=1]="USER",v[v.USER_LOCAL=2]="USER_LOCAL",v[v.USER_REMOTE=3]="USER_REMOTE",v[v.WORKSPACE=4]="WORKSPACE",v[v.WORKSPACE_FOLDER=5]="WORKSPACE_FOLDER",v[v.DEFAULT=6]="DEFAULT",v[v.MEMORY=7]="MEMORY"})(P=e.ConfigurationTarget||(e.ConfigurationTarget={}));function t(v){switch(v){case 1:return"USER";case 2:return"USER_LOCAL";case 3:return"USER_REMOTE";case 4:return"WORKSPACE";case 5:return"WORKSPACE_FOLDER";case 6:return"DEFAULT";case 7:return"MEMORY"}}e.ConfigurationTargetToString=t;function E(v,r){const s=r?v?r.keys.filter(D=>v.keys.indexOf(D)===-1):[...r.keys]:[],u=v?r?v.keys.filter(D=>r.keys.indexOf(D)===-1):[...v.keys]:[],d=[];if(r&&v){for(const D of v.keys)if(r.keys.indexOf(D)!==-1){const m=I(v.contents,D),A=I(r.contents,D);c.equals(m,A)||d.push(D)}}const p=[],k=D=>{const m={};for(const A of D)for(const L of A.identifiers)m[y(L)]=A;return m},T=r?k(r.overrides):{},g=v?k(v.overrides):{};if(Object.keys(T).length)for(const D of s){const m=T[D];m&&p.push([(0,R.overrideIdentifierFromKey)(D),m.keys])}if(Object.keys(g).length)for(const D of u){const m=g[D];m&&p.push([(0,R.overrideIdentifierFromKey)(D),m.keys])}if(Object.keys(T).length&&Object.keys(g).length)for(const D of d){const m=g[D],A=T[D];if(m&&A){const L=E({contents:m.contents,keys:m.keys,overrides:[]},{contents:A.contents,keys:A.keys,overrides:[]});p.push([(0,R.overrideIdentifierFromKey)(D),[...L.added,...L.removed,...L.updated]])}}return{added:s,removed:u,updated:d,overrides:p}}e.compare=E;function n(v,r){const s=[];for(const u of Object.keys(v))if(R.OVERRIDE_PROPERTY_PATTERN.test(u)){const d={};for(const p in v[u])d[p]=v[u][p];s.push({identifiers:[(0,R.overrideIdentifierFromKey)(u).trim()],keys:Object.keys(d),contents:f(d,r)})}return s}e.toOverrides=n;function f(v,r){const s=Object.create(null);for(let u in v)a(s,u,v[u],r);return s}e.toValuesTree=f;function a(v,r,s,u){const d=r.split("."),p=d.pop();let k=v;for(let T=0;T<d.length;T++){let g=d[T],D=k[g];switch(typeof D){case"undefined":D=k[g]=Object.create(null);break;case"object":break;default:u(`Ignoring ${r} as ${d.slice(0,T+1).join(".")} is ${JSON.stringify(D)}`);return}k=D}if(typeof k=="object"&&k!==null)try{k[p]=s}catch(T){u(`Ignoring ${r} as ${d.join(".")} is ${JSON.stringify(k)}`)}else u(`Ignoring ${r} as ${d.join(".")} is ${JSON.stringify(k)}`)}e.addToValueTree=a;function l(v,r){const s=r.split(".");w(v,s)}e.removeFromValueTree=l;function w(v,r){const s=r.shift();if(r.length===0){delete v[s];return}if(Object.keys(v).indexOf(s)!==-1){const u=v[s];typeof u=="object"&&!Array.isArray(u)&&(w(u,r),Object.keys(u).length===0&&delete v[s])}}function I(v,r,s){function u(k,T){let g=k;for(const D of T){if(typeof g!="object"||g===null)return;g=g[D]}return g}const d=r.split("."),p=u(v,d);return typeof p=="undefined"?s:p}e.getConfigurationValue=I;function S(v,r,s){Object.keys(r).forEach(u=>{u!=="__proto__"&&(u in v?M.isObject(v[u])&&M.isObject(r[u])?S(v[u],r[u],s):s&&(v[u]=r[u]):v[u]=r[u])})}e.merge=S;function o(){const v=C.Registry.as(R.Extensions.Configuration).getConfigurationProperties();return Object.keys(v)}e.getConfigurationKeys=o;function h(){const v=Object.create(null),r=C.Registry.as(R.Extensions.Configuration).getConfigurationProperties();for(let s in r){let u=r[s].default;a(v,s,u,d=>console.error(`Conflict in default settings: ${d}`))}return v}e.getDefaultValues=h;function y(v){return`[${v}]`}e.keyFromOverrideIdentifier=y;function i(v,r,s){const u=v.inspect(r),d=v.inspect(s);return typeof u.userValue!="undefined"||typeof u.workspaceValue!="undefined"||typeof u.workspaceFolderValue!="undefined"?u.value:typeof d.userValue!="undefined"||typeof d.workspaceValue!="undefined"||typeof d.workspaceFolderValue!="undefined"?d.value:u.defaultValue}e.getMigratedSettingValue=i}),define(we[148],Ee([0,1,12,3,102,6,20,23,10,2,84,62,28]),function(re,e,c,M,b,R,F,C,_,P,t,E,n){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.AllKeysConfigurationChangeEvent=e.ConfigurationChangeEvent=e.mergeChanges=e.Configuration=e.UserSettings=e.ConfigurationModelParser=e.DefaultConfigurationModel=e.ConfigurationModel=void 0;class f{constructor(i={},v=[],r=[]){this._contents=i,this._keys=v,this._overrides=r,this.isFrozen=!1}get contents(){return this.checkAndFreeze(this._contents)}get overrides(){return this.checkAndFreeze(this._overrides)}get keys(){return this.checkAndFreeze(this._keys)}isEmpty(){return this._keys.length===0&&Object.keys(this._contents).length===0&&this._overrides.length===0}getValue(i){return i?(0,t.getConfigurationValue)(this.contents,i):this.contents}getOverrideValue(i,v){const r=this.getContentsForOverrideIdentifer(v);return r?i?(0,t.getConfigurationValue)(r,i):r:void 0}getKeysForOverrideIdentifier(i){for(const v of this.overrides)if(v.identifiers.indexOf(i)!==-1)return v.keys;return[]}override(i){const v=this.getContentsForOverrideIdentifer(i);if(!v||typeof v!="object"||!Object.keys(v).length)return this;let r={};for(const s of c.distinct([...Object.keys(this.contents),...Object.keys(v)])){let u=this.contents[s],d=v[s];d&&(typeof u=="object"&&typeof d=="object"?(u=C.deepClone(u),this.mergeContents(u,d)):u=d),r[s]=u}return new f(r,this.keys,this.overrides)}merge(...i){const v=C.deepClone(this.contents),r=C.deepClone(this.overrides),s=[...this.keys];for(const u of i){this.mergeContents(v,u.contents);for(const d of u.overrides){const[p]=r.filter(k=>c.equals(k.identifiers,d.identifiers));p?this.mergeContents(p.contents,d.contents):r.push(C.deepClone(d))}for(const d of u.keys)s.indexOf(d)===-1&&s.push(d)}return new f(v,s,r)}freeze(){return this.isFrozen=!0,this}mergeContents(i,v){for(const r of Object.keys(v)){if(r in i&&_.isObject(i[r])&&_.isObject(v[r])){this.mergeContents(i[r],v[r]);continue}i[r]=C.deepClone(v[r])}}checkAndFreeze(i){return this.isFrozen&&!Object.isFrozen(i)?C.deepFreeze(i):i}getContentsForOverrideIdentifer(i){for(const v of this.overrides)if(v.identifiers.indexOf(i)!==-1)return v.contents;return null}toJSON(){return{contents:this.contents,overrides:this.overrides,keys:this.keys}}setValue(i,v){this.addKey(i),(0,t.addToValueTree)(this.contents,i,v,r=>{throw new Error(r)})}removeValue(i){this.removeKey(i)&&(0,t.removeFromValueTree)(this.contents,i)}addKey(i){let v=this.keys.length;for(let r=0;r<v;r++)i.indexOf(this.keys[r])===0&&(v=r);this.keys.splice(v,1,i)}removeKey(i){let v=this.keys.indexOf(i);return v!==-1?(this.keys.splice(v,1),!0):!1}}e.ConfigurationModel=f;class a extends f{constructor(){const i=(0,t.getDefaultValues)(),v=(0,t.getConfigurationKeys)(),r=[];for(const s of Object.keys(i))E.OVERRIDE_PROPERTY_PATTERN.test(s)&&r.push({identifiers:[(0,E.overrideIdentifierFromKey)(s).trim()],keys:Object.keys(i[s]),contents:(0,t.toValuesTree)(i[s],u=>console.error(`Conflict in default settings file: ${u}`))});super(i,v,r)}}e.DefaultConfigurationModel=a;class l{constructor(i){this._name=i,this._raw=null,this._configurationModel=null,this._restrictedConfigurations=[],this._parseErrors=[]}get configurationModel(){return this._configurationModel||new f}get restrictedConfigurations(){return this._restrictedConfigurations}get errors(){return this._parseErrors}parse(i,v){if(!_.isUndefinedOrNull(i)){const r=this.doParseContent(i);this.parseRaw(r,v)}}reparse(i){this._raw&&this.parseRaw(this._raw,i)}parseRaw(i,v){this._raw=i;const{contents:r,keys:s,overrides:u,restricted:d}=this.doParseRaw(i,v);this._configurationModel=new f(r,s,u),this._restrictedConfigurations=d||[]}doParseContent(i){let v={},r=null,s=[],u=[],d=[];function p(T){Array.isArray(s)?s.push(T):r!==null&&(s[r]=T)}let k={onObjectBegin:()=>{let T={};p(T),u.push(s),s=T,r=null},onObjectProperty:T=>{r=T},onObjectEnd:()=>{s=u.pop()},onArrayBegin:()=>{let T=[];p(T),u.push(s),s=T,r=null},onArrayEnd:()=>{s=u.pop()},onLiteralValue:p,onError:(T,g,D)=>{d.push({error:T,offset:g,length:D})}};if(i)try{b.visit(i,k),v=s[0]||{}}catch(T){console.error(`Error while parsing settings file ${this._name}: ${T}`),this._parseErrors=[T]}return v}doParseRaw(i,v){const r=n.Registry.as(E.Extensions.Configuration).getConfigurationProperties(),s=this.filter(i,r,!0,v);i=s.raw;const u=(0,t.toValuesTree)(i,k=>console.error(`Conflict in settings file ${this._name}: ${k}`)),d=Object.keys(i),p=(0,t.toOverrides)(i,k=>console.error(`Conflict in settings file ${this._name}: ${k}`));return{contents:u,keys:d,overrides:p,restricted:s.restricted}}filter(i,v,r,s){if(!s?.scopes&&!s?.skipRestricted)return{raw:i,restricted:[]};const u={},d=[];for(let p in i)if(E.OVERRIDE_PROPERTY_PATTERN.test(p)&&r){const k=this.filter(i[p],v,!1,s);u[p]=k.raw,d.push(...k.restricted)}else{const k=v[p],T=k?typeof k.scope!="undefined"?k.scope:3:void 0;k?.restricted&&d.push(p),(T===void 0||s.scopes===void 0||s.scopes.includes(T))&&(s.skipRestricted&&k?.restricted||(u[p]=i[p]))}return{raw:u,restricted:d}}}e.ConfigurationModelParser=l;class w extends R.Disposable{constructor(i,v,r,s){super();this.userSettingsResource=i,this.scopes=v,this.fileService=s,this._onDidChange=this._register(new M.Emitter),this.onDidChange=this._onDidChange.event,this.parser=new l(this.userSettingsResource.toString()),this.parseOptions={scopes:this.scopes},this._register(this.fileService.watch(r.dirname(this.userSettingsResource))),this._register(this.fileService.watch(this.userSettingsResource)),this._register(M.Event.filter(this.fileService.onDidFilesChange,u=>u.contains(this.userSettingsResource))(()=>this._onDidChange.fire()))}async loadConfiguration(){try{const i=await this.fileService.readFile(this.userSettingsResource);return this.parser.parse(i.value.toString()||"{}",this.parseOptions),this.parser.configurationModel}catch(i){return new f}}reparse(){return this.parser.reparse(this.parseOptions),this.parser.configurationModel}getRestrictedSettings(){return this.parser.restrictedConfigurations}}e.UserSettings=w;class I{constructor(i,v,r=new f,s=new f,u=new F.ResourceMap,d=new f,p=new F.ResourceMap,k=!0){this._defaultConfiguration=i,this._localUserConfiguration=v,this._remoteUserConfiguration=r,this._workspaceConfiguration=s,this._folderConfigurations=u,this._memoryConfiguration=d,this._memoryConfigurationByResource=p,this._freeze=k,this._workspaceConsolidatedConfiguration=null,this._foldersConsolidatedConfigurations=new F.ResourceMap,this._userConfiguration=null}getValue(i,v,r){return this.getConsolidateConfigurationModel(v,r).getValue(i)}updateValue(i,v,r={}){let s;r.resource?(s=this._memoryConfigurationByResource.get(r.resource),s||(s=new f,this._memoryConfigurationByResource.set(r.resource,s))):s=this._memoryConfiguration,v===void 0?s.removeValue(i):s.setValue(i,v),r.resource||(this._workspaceConsolidatedConfiguration=null)}inspect(i,v,r){const s=this.getConsolidateConfigurationModel(v,r),u=this.getFolderConfigurationModelForResource(v.resource,r),d=v.resource?this._memoryConfigurationByResource.get(v.resource)||this._memoryConfiguration:this._memoryConfiguration,p=v.overrideIdentifier?this._defaultConfiguration.freeze().override(v.overrideIdentifier).getValue(i):this._defaultConfiguration.freeze().getValue(i),k=v.overrideIdentifier?this.userConfiguration.freeze().override(v.overrideIdentifier).getValue(i):this.userConfiguration.freeze().getValue(i),T=v.overrideIdentifier?this.localUserConfiguration.freeze().override(v.overrideIdentifier).getValue(i):this.localUserConfiguration.freeze().getValue(i),g=v.overrideIdentifier?this.remoteUserConfiguration.freeze().override(v.overrideIdentifier).getValue(i):this.remoteUserConfiguration.freeze().getValue(i),D=r?v.overrideIdentifier?this._workspaceConfiguration.freeze().override(v.overrideIdentifier).getValue(i):this._workspaceConfiguration.freeze().getValue(i):void 0,m=u?v.overrideIdentifier?u.freeze().override(v.overrideIdentifier).getValue(i):u.freeze().getValue(i):void 0,A=v.overrideIdentifier?d.override(v.overrideIdentifier).getValue(i):d.getValue(i),L=s.getValue(i),V=c.distinct(c.flatten(s.overrides.map(G=>G.identifiers))).filter(G=>s.getOverrideValue(i,G)!==void 0);return{defaultValue:p,userValue:k,userLocalValue:T,userRemoteValue:g,workspaceValue:D,workspaceFolderValue:m,memoryValue:A,value:L,default:p!==void 0?{value:this._defaultConfiguration.freeze().getValue(i),override:v.overrideIdentifier?this._defaultConfiguration.freeze().getOverrideValue(i,v.overrideIdentifier):void 0}:void 0,user:k!==void 0?{value:this.userConfiguration.freeze().getValue(i),override:v.overrideIdentifier?this.userConfiguration.freeze().getOverrideValue(i,v.overrideIdentifier):void 0}:void 0,userLocal:T!==void 0?{value:this.localUserConfiguration.freeze().getValue(i),override:v.overrideIdentifier?this.localUserConfiguration.freeze().getOverrideValue(i,v.overrideIdentifier):void 0}:void 0,userRemote:g!==void 0?{value:this.remoteUserConfiguration.freeze().getValue(i),override:v.overrideIdentifier?this.remoteUserConfiguration.freeze().getOverrideValue(i,v.overrideIdentifier):void 0}:void 0,workspace:D!==void 0?{value:this._workspaceConfiguration.freeze().getValue(i),override:v.overrideIdentifier?this._workspaceConfiguration.freeze().getOverrideValue(i,v.overrideIdentifier):void 0}:void 0,workspaceFolder:m!==void 0?{value:u?.freeze().getValue(i),override:v.overrideIdentifier?u?.freeze().getOverrideValue(i,v.overrideIdentifier):void 0}:void 0,memory:A!==void 0?{value:d.getValue(i),override:v.overrideIdentifier?d.getOverrideValue(i,v.overrideIdentifier):void 0}:void 0,overrideIdentifiers:V.length?V:void 0}}keys(i){const v=this.getFolderConfigurationModelForResource(void 0,i);return{default:this._defaultConfiguration.freeze().keys,user:this.userConfiguration.freeze().keys,workspace:this._workspaceConfiguration.freeze().keys,workspaceFolder:v?v.freeze().keys:[]}}updateDefaultConfiguration(i){this._defaultConfiguration=i,this._workspaceConsolidatedConfiguration=null,this._foldersConsolidatedConfigurations.clear()}updateLocalUserConfiguration(i){this._localUserConfiguration=i,this._userConfiguration=null,this._workspaceConsolidatedConfiguration=null,this._foldersConsolidatedConfigurations.clear()}updateRemoteUserConfiguration(i){this._remoteUserConfiguration=i,this._userConfiguration=null,this._workspaceConsolidatedConfiguration=null,this._foldersConsolidatedConfigurations.clear()}updateWorkspaceConfiguration(i){this._workspaceConfiguration=i,this._workspaceConsolidatedConfiguration=null,this._foldersConsolidatedConfigurations.clear()}updateFolderConfiguration(i,v){this._folderConfigurations.set(i,v),this._foldersConsolidatedConfigurations.delete(i)}deleteFolderConfiguration(i){this.folderConfigurations.delete(i),this._foldersConsolidatedConfigurations.delete(i)}compareAndUpdateDefaultConfiguration(i,v){const r=v.filter(s=>E.OVERRIDE_PROPERTY_PATTERN.test(s)).map(s=>{const u=(0,E.overrideIdentifierFromKey)(s),d=this._defaultConfiguration.getKeysForOverrideIdentifier(u),p=i.getKeysForOverrideIdentifier(u),k=[...p.filter(T=>d.indexOf(T)===-1),...d.filter(T=>p.indexOf(T)===-1),...d.filter(T=>!C.equals(this._defaultConfiguration.override(u).getValue(T),i.override(u).getValue(T)))];return[u,k]});return this.updateDefaultConfiguration(i),{keys:v,overrides:r}}compareAndUpdateLocalUserConfiguration(i){const{added:v,updated:r,removed:s,overrides:u}=(0,t.compare)(this.localUserConfiguration,i),d=[...v,...r,...s];return d.length&&this.updateLocalUserConfiguration(i),{keys:d,overrides:u}}compareAndUpdateRemoteUserConfiguration(i){const{added:v,updated:r,removed:s,overrides:u}=(0,t.compare)(this.remoteUserConfiguration,i);let d=[...v,...r,...s];return d.length&&this.updateRemoteUserConfiguration(i),{keys:d,overrides:u}}compareAndUpdateWorkspaceConfiguration(i){const{added:v,updated:r,removed:s,overrides:u}=(0,t.compare)(this.workspaceConfiguration,i);let d=[...v,...r,...s];return d.length&&this.updateWorkspaceConfiguration(i),{keys:d,overrides:u}}compareAndUpdateFolderConfiguration(i,v){const r=this.folderConfigurations.get(i),{added:s,updated:u,removed:d,overrides:p}=(0,t.compare)(r,v);let k=[...s,...u,...d];return(k.length||!r)&&this.updateFolderConfiguration(i,v),{keys:k,overrides:p}}compareAndDeleteFolderConfiguration(i){const v=this.folderConfigurations.get(i);if(!v)throw new Error("Unknown folder");this.deleteFolderConfiguration(i);const{added:r,updated:s,removed:u,overrides:d}=(0,t.compare)(v,void 0);return{keys:[...r,...s,...u],overrides:d}}get defaults(){return this._defaultConfiguration}get userConfiguration(){return this._userConfiguration||(this._userConfiguration=this._remoteUserConfiguration.isEmpty()?this._localUserConfiguration:this._localUserConfiguration.merge(this._remoteUserConfiguration),this._freeze&&this._userConfiguration.freeze()),this._userConfiguration}get localUserConfiguration(){return this._localUserConfiguration}get remoteUserConfiguration(){return this._remoteUserConfiguration}get workspaceConfiguration(){return this._workspaceConfiguration}get folderConfigurations(){return this._folderConfigurations}getConsolidateConfigurationModel(i,v){let r=this.getConsolidatedConfigurationModelForResource(i,v);return i.overrideIdentifier?r.override(i.overrideIdentifier):r}getConsolidatedConfigurationModelForResource({resource:i},v){let r=this.getWorkspaceConsolidatedConfiguration();if(v&&i){const s=v.getFolder(i);s&&(r=this.getFolderConsolidatedConfiguration(s.uri)||r);const u=this._memoryConfigurationByResource.get(i);u&&(r=r.merge(u))}return r}getWorkspaceConsolidatedConfiguration(){return this._workspaceConsolidatedConfiguration||(this._workspaceConsolidatedConfiguration=this._defaultConfiguration.merge(this.userConfiguration,this._workspaceConfiguration,this._memoryConfiguration),this._freeze&&(this._workspaceConfiguration=this._workspaceConfiguration.freeze())),this._workspaceConsolidatedConfiguration}getFolderConsolidatedConfiguration(i){let v=this._foldersConsolidatedConfigurations.get(i);if(!v){const r=this.getWorkspaceConsolidatedConfiguration(),s=this._folderConfigurations.get(i);s?(v=r.merge(s),this._freeze&&(v=v.freeze()),this._foldersConsolidatedConfigurations.set(i,v)):v=r}return v}getFolderConfigurationModelForResource(i,v){if(v&&i){const r=v.getFolder(i);if(r)return this._folderConfigurations.get(r.uri)}}toData(){return{defaults:{contents:this._defaultConfiguration.contents,overrides:this._defaultConfiguration.overrides,keys:this._defaultConfiguration.keys},user:{contents:this.userConfiguration.contents,overrides:this.userConfiguration.overrides,keys:this.userConfiguration.keys},workspace:{contents:this._workspaceConfiguration.contents,overrides:this._workspaceConfiguration.overrides,keys:this._workspaceConfiguration.keys},folders:[...this._folderConfigurations.keys()].reduce((i,v)=>{const{contents:r,overrides:s,keys:u}=this._folderConfigurations.get(v);return i.push([v,{contents:r,overrides:s,keys:u}]),i},[])}}allKeys(){const i=new Set;return this._defaultConfiguration.freeze().keys.forEach(v=>i.add(v)),this.userConfiguration.freeze().keys.forEach(v=>i.add(v)),this._workspaceConfiguration.freeze().keys.forEach(v=>i.add(v)),this._folderConfigurations.forEach(v=>v.freeze().keys.forEach(r=>i.add(r))),[...i.values()]}getAllKeysForOverrideIdentifier(i){const v=new Set;return this._defaultConfiguration.getKeysForOverrideIdentifier(i).forEach(r=>v.add(r)),this.userConfiguration.getKeysForOverrideIdentifier(i).forEach(r=>v.add(r)),this._workspaceConfiguration.getKeysForOverrideIdentifier(i).forEach(r=>v.add(r)),this._folderConfigurations.forEach(r=>r.getKeysForOverrideIdentifier(i).forEach(s=>v.add(s))),[...v.values()]}static parse(i){const v=this.parseConfigurationModel(i.defaults),r=this.parseConfigurationModel(i.user),s=this.parseConfigurationModel(i.workspace),u=i.folders.reduce((d,p)=>(d.set(P.URI.revive(p[0]),this.parseConfigurationModel(p[1])),d),new F.ResourceMap);return new I(v,r,new f,s,u,new f,new F.ResourceMap,!1)}static parseConfigurationModel(i){return new f(i.contents,i.keys,i.overrides).freeze()}}e.Configuration=I;function S(...y){if(y.length===0)return{keys:[],overrides:[]};if(y.length===1)return y[0];const i=new Set,v=new Map;for(const s of y)s.keys.forEach(u=>i.add(u)),s.overrides.forEach(([u,d])=>{const p=(0,F.getOrSet)(v,u,new Set);d.forEach(k=>p.add(k))});const r=[];return v.forEach((s,u)=>r.push([u,[...s.values()]])),{keys:[...i.values()],overrides:r}}e.mergeChanges=S;class o{constructor(i,v,r,s){this.change=i,this.previous=v,this.currentConfiguraiton=r,this.currentWorkspace=s,this._previousConfiguration=void 0;const u=new Set;i.keys.forEach(p=>u.add(p)),i.overrides.forEach(([,p])=>p.forEach(k=>u.add(k))),this.affectedKeys=[...u.values()];const d=new f;this.affectedKeys.forEach(p=>d.setValue(p,{})),this.affectedKeysTree=d.contents}get previousConfiguration(){return!this._previousConfiguration&&this.previous&&(this._previousConfiguration=I.parse(this.previous.data)),this._previousConfiguration}affectsConfiguration(i,v){if(this.doesAffectedKeysTreeContains(this.affectedKeysTree,i)){if(v){const r=this.previousConfiguration?this.previousConfiguration.getValue(i,v,this.previous?.workspace):void 0,s=this.currentConfiguraiton.getValue(i,v,this.currentWorkspace);return!C.equals(r,s)}return!0}return!1}doesAffectedKeysTreeContains(i,v){let r=(0,t.toValuesTree)({[v]:!0},()=>{}),s;for(;typeof r=="object"&&(s=Object.keys(r)[0]);){if(i=i[s],!i)return!1;r=r[s]}return!0}}e.ConfigurationChangeEvent=o;class h extends o{constructor(i,v,r,s){super({keys:i.allKeys(),overrides:[]},void 0,i,v);this.source=r,this.sourceConfig=s}}e.AllKeysConfigurationChangeEvent=h}),define(we[85],Ee([0,1,4]),function(re,e,c){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.RemoteAuthorityResolverError=e.RemoteAuthorityResolverErrorCode=e.IRemoteAuthorityResolverService=void 0,e.IRemoteAuthorityResolverService=(0,c.createDecorator)("remoteAuthorityResolverService");var M;(function(R){R.Unknown="Unknown",R.NotAvailable="NotAvailable",R.TemporarilyNotAvailable="TemporarilyNotAvailable",R.NoResolverFound="NoResolverFound"})(M=e.RemoteAuthorityResolverErrorCode||(e.RemoteAuthorityResolverErrorCode={}));class b extends Error{constructor(F,C=M.Unknown,_){super(F);this._message=F,this._code=C,this._detail=_,this.isHandled=C===M.NotAvailable&&_===!0,typeof Object.setPrototypeOf=="function"&&Object.setPrototypeOf(this,b.prototype)}static isTemporarilyNotAvailable(F){return F instanceof b&&F._code===M.TemporarilyNotAvailable}static isNoResolverFound(F){return F instanceof b&&F._code===M.NoResolverFound}static isHandled(F){return F instanceof b&&F.isHandled}}e.RemoteAuthorityResolverError=b}),define(we[86],Ee([0,1,11]),function(re,e,c){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.isVirtualWorkspace=e.getVirtualWorkspaceScheme=e.getVirtualWorkspaceLocation=e.isVirtualResource=e.getRemoteName=e.getRemoteAuthority=void 0;function M(P){return P.scheme===c.Schemas.vscodeRemote?P.authority:void 0}e.getRemoteAuthority=M;function b(P){if(!P)return;const t=P.indexOf("+");return t<0?P:P.substr(0,t)}e.getRemoteName=b;function R(P){return P.scheme!==c.Schemas.file&&P.scheme!==c.Schemas.vscodeRemote}e.isVirtualResource=R;function F(P){if(P.folders.length)return P.folders.every(t=>R(t.uri))?P.folders[0].uri:void 0;if(P.configuration&&R(P.configuration))return P.configuration}e.getVirtualWorkspaceLocation=F;function C(P){return F(P)?.scheme}e.getVirtualWorkspaceScheme=C;function _(P){return F(P)!==void 0}e.isVirtualWorkspace=_}),define(we[149],Ee([0,1]),function(re,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TerminalDataBufferer=void 0;class c{constructor(b){this._callback=b,this._terminalBufferMap=new Map}dispose(){for(const b of this._terminalBufferMap.values())b.dispose()}startBuffering(b,R,F=5){let C;return C=R(_=>{const P=typeof _=="string"?_:_.data;let t=this._terminalBufferMap.get(b);if(t){t.data.push(P);return}const E=setTimeout(()=>this.flushBuffer(b),F);t={data:[P],timeoutId:E,dispose:()=>{clearTimeout(E),this.flushBuffer(b),C.dispose()}},this._terminalBufferMap.set(b,t)}),C}stopBuffering(b){const R=this._terminalBufferMap.get(b);R&&R.dispose()}flushBuffer(b){const R=this._terminalBufferMap.get(b);R&&(this._terminalBufferMap.delete(b),this._callback(b,R.data.join("")))}}e.TerminalDataBufferer=c}),define(we[150],Ee([0,1]),function(re,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ColorScheme=void 0;var c;(function(M){M.DARK="dark",M.LIGHT="light",M.HIGH_CONTRAST="hc"})(c=e.ColorScheme||(e.ColorScheme={}))}),define(we[46],Ee([0,1,34,3,6,4,28,150]),function(re,e,c,M,b,R,F,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Themable=e.registerThemingParticipant=e.Extensions=e.getThemeTypeSelector=e.FolderThemeIcon=e.FileThemeIcon=e.ThemeIcon=e.themeColorFromId=e.ThemeColor=e.IThemeService=void 0,e.IThemeService=(0,R.createDecorator)("themeService");var _;(function(w){function I(S){return S&&typeof S=="object"&&typeof S.id=="string"}w.isThemeColor=I})(_=e.ThemeColor||(e.ThemeColor={}));function P(w){return{id:w}}e.themeColorFromId=P;var t;(function(w){function I(v){return v&&typeof v=="object"&&typeof v.id=="string"&&(typeof v.color=="undefined"||_.isThemeColor(v.color))}w.isThemeIcon=I;const S=new RegExp(`^\\$\\((${c.CSSIcon.iconNameExpression}(?:${c.CSSIcon.iconModifierExpression})?)\\)$`);function o(v){const r=S.exec(v);if(!r)return;let[,s]=r;return{id:s}}w.fromString=o;function h(v,r){let s=v.id;const u=s.lastIndexOf("~");return u!==-1&&(s=s.substring(0,u)),r&&(s=`${s}~${r}`),{id:s}}w.modify=h;function y(v,r){return v.id===r.id&&v.color?.id===r.color?.id}w.isEqual=y;function i(v,r){return{id:v.id,color:r?P(r):void 0}}w.asThemeIcon=i,w.asClassNameArray=c.CSSIcon.asClassNameArray,w.asClassName=c.CSSIcon.asClassName,w.asCSSSelector=c.CSSIcon.asCSSSelector})(t=e.ThemeIcon||(e.ThemeIcon={})),e.FileThemeIcon=c.Codicon.file,e.FolderThemeIcon=c.Codicon.folder;function E(w){switch(w){case C.ColorScheme.DARK:return"vs-dark";case C.ColorScheme.HIGH_CONTRAST:return"hc-black";default:return"vs"}}e.getThemeTypeSelector=E,e.Extensions={ThemingContribution:"base.contributions.theming"};class n{constructor(){this.themingParticipants=[],this.themingParticipants=[],this.onThemingParticipantAddedEmitter=new M.Emitter}onColorThemeChange(I){return this.themingParticipants.push(I),this.onThemingParticipantAddedEmitter.fire(I),(0,b.toDisposable)(()=>{const S=this.themingParticipants.indexOf(I);this.themingParticipants.splice(S,1)})}get onThemingParticipantAdded(){return this.onThemingParticipantAddedEmitter.event}getThemingParticipants(){return this.themingParticipants}}let f=new n;F.Registry.add(e.Extensions.ThemingContribution,f);function a(w){return f.onColorThemeChange(w)}e.registerThemingParticipant=a;class l extends b.Disposable{constructor(I){super();this.themeService=I,this.theme=I.getColorTheme(),this._register(this.themeService.onDidColorThemeChange(S=>this.onThemeChange(S)))}onThemeChange(I){this.theme=I,this.updateStyles()}updateStyles(){}getColor(I,S){let o=this.theme.getColor(I);return o&&S&&(o=S(o,this.theme)),o?o.toString():null}}e.Themable=l}),define(we[151],Ee([0,1,14,34,3,123,83,28,46]),function(re,e,c,M,b,R,F,C,_){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.syncing=e.gotoNextLocation=e.gotoPreviousLocation=e.widgetClose=e.iconsSchemaId=e.getIconRegistry=e.registerIcon=e.Extensions=void 0,e.Extensions={IconContribution:"base.contributions.icons"};class P{constructor(){this._onDidChange=new b.Emitter,this.onDidChange=this._onDidChange.event,this.iconSchema={definitions:{icons:{type:"object",properties:{fontId:{type:"string",description:(0,R.localize)(0,null)},fontCharacter:{type:"string",description:(0,R.localize)(1,null)}},additionalProperties:!1,defaultSnippets:[{body:{fontCharacter:"\\\\e030"}}]}},type:"object",properties:{}},this.iconReferenceSchema={type:"string",pattern:`^${M.CSSIcon.iconNameExpression}$`,enum:[],enumDescriptions:[]},this.iconsById={},this.iconFontsById={}}registerIcon(I,S,o,h){const y=this.iconsById[I];if(y){if(o&&!y.description){y.description=o,this.iconSchema.properties[I].markdownDescription=`${o} $(${I})`;const r=this.iconReferenceSchema.enum.indexOf(I);r!==-1&&(this.iconReferenceSchema.enumDescriptions[r]=o),this._onDidChange.fire()}return y}let i={id:I,description:o,defaults:S,deprecationMessage:h};this.iconsById[I]=i;let v={$ref:"#/definitions/icons"};return h&&(v.deprecationMessage=h),o&&(v.markdownDescription=`${o}: $(${I})`),this.iconSchema.properties[I]=v,this.iconReferenceSchema.enum.push(I),this.iconReferenceSchema.enumDescriptions.push(o||""),this._onDidChange.fire(),{id:I}}deregisterIcon(I){delete this.iconsById[I],delete this.iconSchema.properties[I];const S=this.iconReferenceSchema.enum.indexOf(I);S!==-1&&(this.iconReferenceSchema.enum.splice(S,1),this.iconReferenceSchema.enumDescriptions.splice(S,1)),this._onDidChange.fire()}getIcons(){return Object.keys(this.iconsById).map(I=>this.iconsById[I])}getIcon(I){return this.iconsById[I]}getIconSchema(){return this.iconSchema}getIconReferenceSchema(){return this.iconReferenceSchema}registerIconFont(I,S){const o=this.iconFontsById[I];if(o)return o;let h={id:I,definition:S};return this.iconFontsById[I]=h,this._onDidChange.fire(),h}deregisterIconFont(I){delete this.iconFontsById[I]}getIconFonts(){return Object.keys(this.iconFontsById).map(I=>this.iconFontsById[I])}getIconFont(I){return this.iconFontsById[I]}toString(){const I=(y,i)=>y.id.localeCompare(i.id),S=y=>{for(;_.ThemeIcon.isThemeIcon(y.defaults);)y=this.iconsById[y.defaults.id];return`codicon codicon-${y?y.id:""}`};let o=[];o.push("| preview     | identifier                        | default codicon ID                | description"),o.push("| ----------- | --------------------------------- | --------------------------------- | --------------------------------- |");const h=Object.keys(this.iconsById).map(y=>this.iconsById[y]);for(const y of h.filter(i=>!!i.description).sort(I))o.push(`|<i class="${S(y)}"></i>|${y.id}|${_.ThemeIcon.isThemeIcon(y.defaults)?y.defaults.id:y.id}|${y.description||""}|`);o.push("| preview     | identifier                        "),o.push("| ----------- | --------------------------------- |");for(const y of h.filter(i=>!_.ThemeIcon.isThemeIcon(i.defaults)).sort(I))o.push(`|<i class="${S(y)}"></i>|${y.id}|`);return o.join(`
`)}}const t=new P;C.Registry.add(e.Extensions.IconContribution,t);function E(w,I,S,o){return t.registerIcon(w,I,S,o)}e.registerIcon=E;function n(){return t}e.getIconRegistry=n;function f(){for(const w of M.iconRegistry.all)t.registerIcon(w.id,w.definition,w.description);M.iconRegistry.onDidRegister(w=>t.registerIcon(w.id,w.definition,w.description))}f(),e.iconsSchemaId="vscode://schemas/icons";let a=C.Registry.as(F.Extensions.JSONContribution);a.registerSchema(e.iconsSchemaId,t.getIconSchema());const l=new c.RunOnceScheduler(()=>a.notifySchemaChanged(e.iconsSchemaId),200);t.onDidChange(()=>{l.isScheduled()||l.schedule()}),e.widgetClose=E("widget-close",M.Codicon.close,(0,R.localize)(2,null)),e.gotoPreviousLocation=E("goto-previous-location",M.Codicon.arrowUp,(0,R.localize)(3,null)),e.gotoNextLocation=E("goto-next-location",M.Codicon.arrowDown,(0,R.localize)(4,null)),e.syncing=_.ThemeIcon.modify(M.Codicon.sync,"spin")}),define(we[47],Ee([0,1,20,24,2,4]),function(re,e,c,M,b,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.toWorkspaceFolder=e.WorkspaceFolder=e.Workspace=e.isWorkspaceFolder=e.isWorkspace=e.WorkbenchState=e.IWorkspaceContextService=void 0,e.IWorkspaceContextService=(0,R.createDecorator)("contextService");var F;(function(n){n[n.EMPTY=1]="EMPTY",n[n.FOLDER=2]="FOLDER",n[n.WORKSPACE=3]="WORKSPACE"})(F=e.WorkbenchState||(e.WorkbenchState={}));function C(n){const f=n;return!!(f&&typeof f=="object"&&typeof f.id=="string"&&Array.isArray(f.folders))}e.isWorkspace=C;function _(n){const f=n;return!!(f&&typeof f=="object"&&b.URI.isUri(f.uri)&&typeof f.name=="string"&&typeof f.toResource=="function")}e.isWorkspaceFolder=_;class P{constructor(f,a,l,w,I){this._id=f,this._transient=l,this._configuration=w,this._ignorePathCasing=I,this._foldersMap=c.TernarySearchTree.forUris(this._ignorePathCasing),this.folders=a}update(f){this._id=f.id,this._configuration=f.configuration,this._transient=f.transient,this._ignorePathCasing=f._ignorePathCasing,this.folders=f.folders}get folders(){return this._folders}set folders(f){this._folders=f,this.updateFoldersMap()}get id(){return this._id}get transient(){return this._transient}get configuration(){return this._configuration}set configuration(f){this._configuration=f}getFolder(f){return f&&this._foldersMap.findSubstr(f.with({scheme:f.scheme,authority:f.authority,path:f.path}))||null}updateFoldersMap(){this._foldersMap=c.TernarySearchTree.forUris(this._ignorePathCasing);for(const f of this.folders)this._foldersMap.set(f.uri,f)}toJSON(){return{id:this.id,folders:this.folders,transient:this.transient,configuration:this.configuration}}}e.Workspace=P;class t{constructor(f,a){this.raw=a,this.uri=f.uri,this.index=f.index,this.name=f.name}toResource(f){return(0,M.joinPath)(this.uri,f)}toJSON(){return{uri:this.uri,name:this.name,index:this.index}}}e.WorkspaceFolder=t;function E(n){return new t({uri:n,index:0,name:(0,M.basenameOrAuthority)(n)},{uri:n.toString()})}e.toWorkspaceFolder=E}),define(we[63],Ee([0,1]),function(re,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Cache=void 0;class c{constructor(b){this.id=b,this._data=new Map,this._idPool=1}add(b){const R=this._idPool++;return this._data.set(R,b),this.logDebugInfo(),R}get(b,R){return this._data.has(b)?this._data.get(b)[R]:void 0}delete(b){this._data.delete(b),this.logDebugInfo()}logDebugInfo(){!c.enableDebugLogging||console.log(`${this.id} cache size \u2014 ${this._data.size}`)}}e.Cache=c,c.enableDebugLogging=!1}),define(we[37],Ee([0,1,11,24,4]),function(re,e,c,M,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExtHostFileSystemInfo=e.ExtHostFileSystemInfo=void 0;class R{constructor(){this._systemSchemes=new Set(Object.keys(c.Schemas)),this._providerInfo=new Map,this.extUri=new M.ExtUri(C=>{const _=this._providerInfo.get(C.scheme);return!(_===void 0||_&1024)})}$acceptProviderInfos(C,_){_===null?this._providerInfo.delete(C):this._providerInfo.set(C,_)}isFreeScheme(C){return!this._providerInfo.has(C)&&!this._systemSchemes.has(C)}getCapabilities(C){return this._providerInfo.get(C)}}e.ExtHostFileSystemInfo=R,e.IExtHostFileSystemInfo=(0,b.createDecorator)("IExtHostFileSystemInfo")}),define(we[29],Ee([0,1,4]),function(re,e,c){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExtHostInitDataService=void 0,e.IExtHostInitDataService=(0,c.createDecorator)("IExtHostInitDataService")}),define(we[152],Ee([0,1,14]),function(re,e,c){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionGlobalMemento=e.ExtensionMemento=void 0;class M{constructor(F,C,_){this._deferredPromises=new Map,this._id=F,this._shared=C,this._storage=_,this._init=this._storage.getValue(this._shared,this._id,Object.create(null)).then(P=>(this._value=P,this)),this._storageListener=this._storage.onDidChangeStorage(P=>{P.shared===this._shared&&P.key===this._id&&(this._value=P.value)}),this._scheduler=new c.RunOnceScheduler(()=>{const P=this._deferredPromises;this._deferredPromises=new Map,(async()=>{try{await this._storage.setValue(this._shared,this._id,this._value);for(const t of P.values())t.complete()}catch(t){for(const E of P.values())E.error(t)}})()},0)}keys(){return Object.entries(this._value??{}).filter(([,F])=>F!==void 0).map(([F])=>F)}get whenReady(){return this._init}get(F,C){let _=this._value[F];return typeof _=="undefined"&&(_=C),_}update(F,C){this._value[F]=C;let _=this._deferredPromises.get(F);if(_!==void 0)return _.p;const P=new c.DeferredPromise;return this._deferredPromises.set(F,P),this._scheduler.isScheduled()||this._scheduler.schedule(),P.p}dispose(){this._storageListener.dispose()}}e.ExtensionMemento=M;class b extends M{constructor(F,C){super(F.identifier.value,!0,C);this._extension=F}setKeysForSync(F){this._storage.registerExtensionStorageKeysToSync({id:this._id,version:this._extension.version},F)}}e.ExtensionGlobalMemento=b}),define(we[153],Ee([0,1,3,2,15]),function(re,e,c,M,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostNotebookDocuments=void 0;let R=class{constructor(C,_){this._logService=C,this._notebooksAndEditors=_,this._onDidChangeNotebookDocumentMetadata=new c.Emitter,this.onDidChangeNotebookDocumentMetadata=this._onDidChangeNotebookDocumentMetadata.event,this._onDidSaveNotebookDocument=new c.Emitter,this.onDidSaveNotebookDocument=this._onDidSaveNotebookDocument.event}$acceptModelChanged(C,_,P){this._notebooksAndEditors.getNotebookDocument(M.URI.revive(C)).acceptModelChanged(_.value,P)}$acceptDirtyStateChanged(C,_){this._notebooksAndEditors.getNotebookDocument(M.URI.revive(C)).acceptDirty(_)}$acceptModelSaved(C){const _=this._notebooksAndEditors.getNotebookDocument(M.URI.revive(C));this._onDidSaveNotebookDocument.fire(_.apiNotebook)}$acceptDocumentPropertiesChanged(C,_){this._logService.debug("ExtHostNotebook#$acceptDocumentPropertiesChanged",C.path,_);const P=this._notebooksAndEditors.getNotebookDocument(M.URI.revive(C));P.acceptDocumentPropertiesChanged(_),_.metadata&&this._onDidChangeNotebookDocumentMetadata.fire({document:P.apiNotebook})}};R=We([ze(0,b.ILogService)],R),e.ExtHostNotebookDocuments=R}),define(we[13],Ee([0,1,4]),function(re,e,c){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostRpcService=e.IExtHostRpcService=void 0,e.IExtHostRpcService=(0,c.createDecorator)("IExtHostRpcService");class M{constructor(R){this.getProxy=R.getProxy.bind(R),this.set=R.set.bind(R),this.assertRegistered=R.assertRegistered.bind(R),this.drain=R.drain.bind(R)}}e.ExtHostRpcService=M});var Ze=this&&this.__classPrivateFieldSet||function(re,e,c,M,b){if(M==="m")throw new TypeError("Private method is not writable");if(M==="a"&&!b)throw new TypeError("Private accessor was defined without a setter");if(typeof e=="function"?re!==e||!b:!e.has(re))throw new TypeError("Cannot write private member to an object whose class did not declare it");return M==="a"?b.call(re,c):b?b.value=c:e.set(re,c),c},Ae=this&&this.__classPrivateFieldGet||function(re,e,c,M){if(c==="a"&&!M)throw new TypeError("Private accessor was defined without a getter");if(typeof e=="function"?re!==e||!M:!e.has(re))throw new TypeError("Cannot read private member from an object whose class did not declare it");return c==="m"?M:c==="a"?M.call(re):M?M.value:e.get(re)};define(we[154],Ee([0,1,25,3]),function(re,e,c,M){"use strict";var b;Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionSecrets=void 0;class R{constructor(C,_){b.set(this,void 0),this._onDidChange=new M.Emitter,this.onDidChange=this._onDidChange.event,this._id=c.ExtensionIdentifier.toKey(C.identifier),Ze(this,b,_,"f"),Ae(this,b,"f").onDidChangePassword(P=>{P.extensionId===this._id&&this._onDidChange.fire({key:P.key})})}get(C){return Ae(this,b,"f").get(this._id,C)}store(C,_){return Ae(this,b,"f").store(this._id,C,_)}delete(C){return Ae(this,b,"f").delete(this._id,C)}}e.ExtensionSecrets=R,b=new WeakMap}),define(we[87],Ee([0,1,4,3]),function(re,e,c,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExtHostTelemetry=e.ExtHostTelemetry=void 0;class b{constructor(){this._onDidChangeTelemetryEnabled=new M.Emitter,this.onDidChangeTelemetryEnabled=this._onDidChangeTelemetryEnabled.event,this._enabled=!1}getTelemetryEnabled(){return this._enabled}$initializeTelemetryEnabled(F){this._enabled=F}$onDidChangeTelemetryEnabled(F){this._enabled=F,this._onDidChangeTelemetryEnabled.fire(F)}}e.ExtHostTelemetry=b,e.IExtHostTelemetry=(0,c.createDecorator)("IExtHostTelemetry")}),define(we[48],Ee([0,1]),function(re,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TestItemRootImpl=e.TestItemImpl=e.MixedTestItemController=e.InvalidTestItemError=e.DuplicateTestItemError=e.diffTestItems=e.getPrivateApiFor=e.createPrivateApiFor=e.ExtHostTestItemEventOp=void 0;var c;(function(S){S[S.Upsert=0]="Upsert",S[S.RemoveChild=1]="RemoveChild",S[S.Invalidated=2]="Invalidated",S[S.SetProp=3]="SetProp",S[S.Bulk=4]="Bulk"})(c=e.ExtHostTestItemEventOp||(e.ExtHostTestItemEventOp={}));const M=new WeakMap,b=(S,o)=>{const h={controllerId:o};return M.set(S,h),h};e.createPrivateApiFor=b;const R=S=>M.get(S);e.getPrivateApiFor=R;const F=(S,o,h,y)=>{let i=h;return{enumerable:!0,configurable:!1,get(){return i},set(v){if(!y(i,v)){const r=i;i=v,S.listener?.({op:3,key:o,value:v,previous:r})}}}},C=(S,o)=>S===o,_={range:(S,o)=>S===o?!0:!S||!o?!1:S.isEqual(o),label:C,description:C,busy:C,error:C,canResolveChildren:C,tags:(S,o)=>!(S.length!==o.length||S.some(h=>!o.find(y=>h.id===y.id)))},P=Object.keys(_),t=(S,o)=>({range:F(S,"range",void 0,_.range),label:F(S,"label",o,_.label),description:F(S,"description",void 0,_.description),canResolveChildren:F(S,"canResolveChildren",!1,_.canResolveChildren),busy:F(S,"busy",!1,_.busy),error:F(S,"error",void 0,_.error),tags:F(S,"tags",[],_.tags)}),E=(S,o)=>{const h=new Map;for(const y of P)_[y](S[y],o[y])||h.set(y,o[y]);return h};e.diffTestItems=E;class n extends Error{constructor(o){super(`Attempted to insert a duplicate test item ID ${o}`)}}e.DuplicateTestItemError=n;class f extends Error{constructor(o){super(`TestItem with ID "${o}" is invalid. Make sure to create it from the createTestItem method.`)}}e.InvalidTestItemError=f;class a extends Error{constructor(o,h,y){super(`TestItem with ID "${o}" is from controller "${h}" and cannot be added as a child of an item from controller "${y}".`)}}e.MixedTestItemController=a;const l=S=>{const o=(0,e.getPrivateApiFor)(S);let h=new Map;return{get size(){return h.size},forEach(y,i){for(const v of h.values())y.call(i,v,this)},replace(y){const i=new Map,v=new Set(h.keys()),r={op:4,ops:[]};for(const s of y){if(!(s instanceof w))throw new f(s.id);const u=(0,e.getPrivateApiFor)(s).controllerId;if(u!==o.controllerId)throw new a(s.id,u,o.controllerId);if(i.has(s.id))throw new n(s.id);i.set(s.id,s),v.delete(s.id),r.ops.push({op:0,item:s})}for(const s of v.keys())r.ops.push({op:1,id:s});o.listener?.(r),h=i},add(y){if(!(y instanceof w))throw new f(y.id);h.set(y.id,y),o.listener?.({op:0,item:y})},delete(y){h.delete(y)&&o.listener?.({op:1,id:y})},get(y){return h.get(y)},toJSON(){return Array.from(h.values())},[Symbol.iterator](){return h.values()}}};class w{constructor(o,h,y,i){if(h.includes("\0"))throw new Error(`Test IDs may not include the ${JSON.stringify(h)} symbol`);const v=(0,e.createPrivateApiFor)(this,o);Object.defineProperties(this,{id:{value:h,enumerable:!0,writable:!1},uri:{value:i,enumerable:!0,writable:!1},parent:{enumerable:!1,get(){return v.parent instanceof I?void 0:v.parent}},children:{value:l(this),enumerable:!0,writable:!1},...t(v,y)})}invalidateResults(){(0,e.getPrivateApiFor)(this).listener?.({op:2})}}e.TestItemImpl=w;class I extends w{constructor(o,h){super(o,o,h,void 0)}}e.TestItemRootImpl=I}),define(we[64],Ee([0,1,4,3,13]),function(re,e,c,M,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostTunnelService=e.IExtHostTunnelService=e.TunnelDto=void 0;var R;(function(C){function _(t){return{remoteAddress:t.remoteAddress,localAddress:t.localAddress,public:!!t.public,protocol:t.protocol}}C.fromApiTunnel=_;function P(t){return{remoteAddress:{host:t.tunnelRemoteHost,port:t.tunnelRemotePort},localAddress:t.localAddress,public:t.public,protocol:t.protocol}}C.fromServiceTunnel=P})(R=e.TunnelDto||(e.TunnelDto={})),e.IExtHostTunnelService=(0,c.createDecorator)("IExtHostTunnelService");let F=class{constructor(_){this.onDidChangeTunnels=new M.Emitter().event}async $applyCandidateFilter(_){return _}async openTunnel(_,P){}async getTunnels(){return[]}async setTunnelExtensionFunctions(_){return{dispose:()=>{}}}registerPortsAttributesProvider(_,P){return{dispose:()=>{}}}async $providePortAttributes(_,P,t,E,n){return[]}async $forwardPort(_,P){}async $closeTunnel(_){}async $onDidTunnelsChange(){}async $registerCandidateFinder(){}};F=We([ze(0,b.IExtHostRpcService)],F),e.ExtHostTunnelService=F});var Ze=this&&this.__classPrivateFieldSet||function(re,e,c,M,b){if(M==="m")throw new TypeError("Private method is not writable");if(M==="a"&&!b)throw new TypeError("Private accessor was defined without a setter");if(typeof e=="function"?re!==e||!b:!e.has(re))throw new TypeError("Cannot write private member to an object whose class did not declare it");return M==="a"?b.call(re,c):b?b.value=c:e.set(re,c),c},Ae=this&&this.__classPrivateFieldGet||function(re,e,c,M){if(c==="a"&&!M)throw new TypeError("Private accessor was defined without a getter");if(typeof e=="function"?re!==e||!M:!e.has(re))throw new TypeError("Cannot read private member from an object whose class did not declare it");return c==="m"?M:c==="a"?M.call(re):M?M.value:e.get(re)};define(we[7],Ee([0,1,12,16,76,20,78,10,2,36,60,85]),function(re,e,c,M,b,R,F,C,_,P,t,E){"use strict";var n,f,a,l,w,I,S,o,h,y,i,v,r,s,u,d,p,k,T,g;Object.defineProperty(e,"__esModule",{value:!0}),e.TypeHierarchyItem=e.PortAutoForwardAction=e.WorkspaceTrustState=e.ExternalUriOpenerPriority=e.FunctionCoverage=e.BranchCoverage=e.StatementCoverage=e.FileCoverage=e.CoveredCount=e.TestTag=e.TestMessage=e.TestRunRequest=e.TestRunProfileKind=e.TestResultState=e.PortAttributes=e.LinkedEditingRanges=e.StandardTokenType=e.ExtensionRuntime=e.ExtensionMode=e.TimelineItem=e.NotebookRendererScript=e.NotebookControllerAffinity=e.NotebookCellStatusBarItem=e.NotebookEditorRevealType=e.NotebookCellStatusBarAlignment=e.NotebookCellExecutionState=e.NotebookCellKind=e.NotebookCellOutput=e.NotebookCellOutputItem=e.NotebookData=e.NotebookCellData=e.NotebookRange=e.ColorThemeKind=e.ColorTheme=e.FileDecoration=e.ExtensionKind=e.QuickInputButtons=e.DebugConfigurationProviderTriggerKind=e.DebugConsoleMode=e.SemanticTokensEdits=e.SemanticTokensEdit=e.SemanticTokens=e.SemanticTokensBuilder=e.SemanticTokensLegend=e.CommentMode=e.CommentThreadCollapsibleState=e.FoldingRangeKind=e.FoldingRange=e.FileSystemError=e.FileChangeType=e.InlineValueContext=e.InlineValueEvaluatableExpression=e.InlineValueVariableLookup=e.InlineValueText=e.InlineCompletionTriggerKind=e.EvaluatableExpression=e.DebugAdapterInlineImplementation=e.DebugAdapterNamedPipeServer=e.DebugAdapterServer=e.DebugAdapterExecutable=e.DataBreakpoint=e.FunctionBreakpoint=e.SourceBreakpoint=e.Breakpoint=e.RelativePattern=e.ConfigurationTarget=e.ThemeColor=e.ThemeIcon=e.TreeItemCollapsibleState=e.TreeItem=e.ProgressLocation=e.Task=e.CustomExecution=e.TaskScope=e.ShellQuoting=e.ShellExecution=e.ProcessExecution=e.TaskGroup=e.TaskPanelKind=e.TaskRevealKind=e.TerminalProfile=e.TerminalLocation=e.TerminalLink=e.SourceControlInputBoxValidationType=e.ColorFormat=e.ColorPresentation=e.ColorInformation=e.Color=e.DocumentLink=e.DecorationRangeBehavior=e.TextDocumentChangeReason=e.TextEditorSelectionChangeKind=e.TextEditorRevealType=e.TextDocumentSaveReason=e.TextEditorLineNumbersStyle=e.StatusBarAlignment=e.ViewColumn=e.InlineSuggestions=e.InlineSuggestion=e.CompletionList=e.CompletionItem=e.CompletionItemTag=e.CompletionItemKind=e.CompletionTriggerKind=e.InlayHint=e.InlayHintKind=e.SignatureHelpTriggerKind=e.SignatureHelp=e.SignatureInformation=e.ParameterInformation=e.MarkdownString=e.CodeLens=e.LanguageStatusSeverity=e.CallHierarchyOutgoingCall=e.CallHierarchyIncomingCall=e.CallHierarchyItem=e.SelectionRange=e.CodeActionKind=e.CodeAction=e.CodeActionTriggerKind=e.DocumentSymbol=e.SymbolInformation=e.SymbolTag=e.SymbolKind=e.DocumentHighlight=e.DocumentHighlightKind=e.Hover=e.Diagnostic=e.DiagnosticRelatedInformation=e.Location=e.DiagnosticSeverity=e.DiagnosticTag=e.SnippetString=e.WorkspaceEdit=e.FileEditType=e.TextEdit=e.EnvironmentVariableMutatorType=e.EndOfLine=e.RemoteAuthorityResolverError=e.ResolvedAuthority=e.Selection=e.Range=e.Position=e.Disposable=void 0;function D(N){function O(){return Reflect.construct(N,arguments,this.constructor)}return Object.defineProperty(O,"name",Object.getOwnPropertyDescriptor(N,"name")),Object.setPrototypeOf(O,N),Object.setPrototypeOf(O.prototype,N.prototype),O}let m=w=class{constructor(O){n.set(this,void 0),Ze(this,n,O,"f")}static from(...O){let ie=O;return new w(function(){if(ie){for(const _e of ie)_e&&typeof _e.dispose=="function"&&_e.dispose();ie=void 0}})}dispose(){typeof Ae(this,n,"f")=="function"&&(Ae(this,n,"f").call(this),Ze(this,n,void 0,"f"))}};n=new WeakMap,m=w=We([D],m),e.Disposable=m;let A=I=class{constructor(O,ie){if(O<0)throw(0,M.illegalArgument)("line must be non-negative");if(ie<0)throw(0,M.illegalArgument)("character must be non-negative");this._line=O,this._character=ie}static Min(...O){if(O.length===0)throw new TypeError;let ie=O[0];for(let _e=1;_e<O.length;_e++){const Ge=O[_e];Ge.isBefore(ie)&&(ie=Ge)}return ie}static Max(...O){if(O.length===0)throw new TypeError;let ie=O[0];for(let _e=1;_e<O.length;_e++){const Ge=O[_e];Ge.isAfter(ie)&&(ie=Ge)}return ie}static isPosition(O){if(!O)return!1;if(O instanceof I)return!0;let{line:ie,character:_e}=O;return typeof ie=="number"&&typeof _e=="number"}get line(){return this._line}get character(){return this._character}isBefore(O){return this._line<O._line?!0:O._line<this._line?!1:this._character<O._character}isBeforeOrEqual(O){return this._line<O._line?!0:O._line<this._line?!1:this._character<=O._character}isAfter(O){return!this.isBeforeOrEqual(O)}isAfterOrEqual(O){return!this.isBefore(O)}isEqual(O){return this._line===O._line&&this._character===O._character}compareTo(O){return this._line<O._line?-1:this._line>O.line?1:this._character<O._character?-1:this._character>O._character?1:0}translate(O,ie=0){if(O===null||ie===null)throw(0,M.illegalArgument)();let _e;return typeof O=="undefined"?_e=0:typeof O=="number"?_e=O:(_e=typeof O.lineDelta=="number"?O.lineDelta:0,ie=typeof O.characterDelta=="number"?O.characterDelta:0),_e===0&&ie===0?this:new I(this.line+_e,this.character+ie)}with(O,ie=this.character){if(O===null||ie===null)throw(0,M.illegalArgument)();let _e;return typeof O=="undefined"?_e=this.line:typeof O=="number"?_e=O:(_e=typeof O.line=="number"?O.line:this.line,ie=typeof O.character=="number"?O.character:this.character),_e===this.line&&ie===this.character?this:new I(_e,ie)}toJSON(){return{line:this.line,character:this.character}}};A=I=We([D],A),e.Position=A;let L=S=class{constructor(O,ie,_e,Ge){let tt,st;if(typeof O=="number"&&typeof ie=="number"&&typeof _e=="number"&&typeof Ge=="number"?(tt=new A(O,ie),st=new A(_e,Ge)):O instanceof A&&ie instanceof A&&(tt=O,st=ie),!tt||!st)throw new Error("Invalid arguments");tt.isBefore(st)?(this._start=tt,this._end=st):(this._start=st,this._end=tt)}static isRange(O){return O instanceof S?!0:O?A.isPosition(O.start)&&A.isPosition(O.end):!1}get start(){return this._start}get end(){return this._end}contains(O){return O instanceof S?this.contains(O._start)&&this.contains(O._end):O instanceof A?!(O.isBefore(this._start)||this._end.isBefore(O)):!1}isEqual(O){return this._start.isEqual(O._start)&&this._end.isEqual(O._end)}intersection(O){const ie=A.Max(O.start,this._start),_e=A.Min(O.end,this._end);if(!ie.isAfter(_e))return new S(ie,_e)}union(O){if(this.contains(O))return this;if(O.contains(this))return O;const ie=A.Min(O.start,this._start),_e=A.Max(O.end,this.end);return new S(ie,_e)}get isEmpty(){return this._start.isEqual(this._end)}get isSingleLine(){return this._start.line===this._end.line}with(O,ie=this.end){if(O===null||ie===null)throw(0,M.illegalArgument)();let _e;return O?A.isPosition(O)?_e=O:(_e=O.start||this.start,ie=O.end||this.end):_e=this.start,_e.isEqual(this._start)&&ie.isEqual(this.end)?this:new S(_e,ie)}toJSON(){return[this.start,this.end]}};L=S=We([D],L),e.Range=L;let V=o=class extends L{constructor(O,ie,_e,Ge){let tt,st;if(typeof O=="number"&&typeof ie=="number"&&typeof _e=="number"&&typeof Ge=="number"?(tt=new A(O,ie),st=new A(_e,Ge)):O instanceof A&&ie instanceof A&&(tt=O,st=ie),!tt||!st)throw new Error("Invalid arguments");super(tt,st);this._anchor=tt,this._active=st}static isSelection(O){return O instanceof o?!0:O?L.isRange(O)&&A.isPosition(O.anchor)&&A.isPosition(O.active)&&typeof O.isReversed=="boolean":!1}get anchor(){return this._anchor}get active(){return this._active}get isReversed(){return this._anchor===this._end}toJSON(){return{start:this.start,end:this.end,active:this.active,anchor:this.anchor}}};V=o=We([D],V),e.Selection=V;class G{constructor(O,ie,_e){if(typeof O!="string"||O.length===0)throw(0,M.illegalArgument)("host");if(typeof ie!="number"||ie===0||Math.round(ie)!==ie)throw(0,M.illegalArgument)("port");if(typeof _e!="undefined"&&(typeof _e!="string"||_e.length===0||!/^[0-9A-Za-z\-]+$/.test(_e)))throw(0,M.illegalArgument)("connectionToken");this.host=O,this.port=Math.round(ie),this.connectionToken=_e}}e.ResolvedAuthority=G;class U extends Error{constructor(O,ie=E.RemoteAuthorityResolverErrorCode.Unknown,_e){super(O);this._message=O,this._code=ie,this._detail=_e,typeof Object.setPrototypeOf=="function"&&Object.setPrototypeOf(this,U.prototype)}static NotAvailable(O,ie){return new U(O,E.RemoteAuthorityResolverErrorCode.NotAvailable,ie)}static TemporarilyNotAvailable(O){return new U(O,E.RemoteAuthorityResolverErrorCode.TemporarilyNotAvailable)}}e.RemoteAuthorityResolverError=U;var K;(function(N){N[N.LF=1]="LF",N[N.CRLF=2]="CRLF"})(K=e.EndOfLine||(e.EndOfLine={}));var $;(function(N){N[N.Replace=1]="Replace",N[N.Append=2]="Append",N[N.Prepend=3]="Prepend"})($=e.EnvironmentVariableMutatorType||(e.EnvironmentVariableMutatorType={}));let B=h=class{constructor(O,ie){this._range=O,this._newText=ie}static isTextEdit(O){return O instanceof h?!0:O?L.isRange(O)&&typeof O.newText=="string":!1}static replace(O,ie){return new h(O,ie)}static insert(O,ie){return h.replace(new L(O,O),ie)}static delete(O){return h.replace(O,"")}static setEndOfLine(O){const ie=new h(new L(new A(0,0),new A(0,0)),"");return ie.newEol=O,ie}get range(){return this._range}set range(O){if(O&&!L.isRange(O))throw(0,M.illegalArgument)("range");this._range=O}get newText(){return this._newText||""}set newText(O){if(O&&typeof O!="string")throw(0,M.illegalArgument)("newText");this._newText=O}get newEol(){return this._newEol}set newEol(O){if(O&&typeof O!="number")throw(0,M.illegalArgument)("newEol");this._newEol=O}toJSON(){return{range:this.range,newText:this.newText,newEol:this._newEol}}};B=h=We([D],B),e.TextEdit=B;var z;(function(N){N[N.File=1]="File",N[N.Text=2]="Text",N[N.Cell=3]="Cell",N[N.CellReplace=5]="CellReplace"})(z=e.FileEditType||(e.FileEditType={}));let Y=class{constructor(){this._edits=[]}_allEntries(){return this._edits}renameFile(O,ie,_e,Ge){this._edits.push({_type:1,from:O,to:ie,options:_e,metadata:Ge})}createFile(O,ie,_e){this._edits.push({_type:1,from:void 0,to:O,options:ie,metadata:_e})}deleteFile(O,ie,_e){this._edits.push({_type:1,from:O,to:void 0,options:ie,metadata:_e})}replaceNotebookMetadata(O,ie,_e){this._edits.push({_type:3,metadata:_e,uri:O,edit:{editType:5,metadata:ie},notebookMetadata:ie})}replaceNotebookCells(O,ie,_e,Ge,tt){let st,lt,Ct=[],At;if(zt.isNotebookRange(ie)&&Mt.isNotebookCellDataArray(_e)&&!Mt.isNotebookCellDataArray(Ge)?(st=ie.start,lt=ie.end,Ct=_e,At=Ge):typeof ie=="number"&&typeof _e=="number"&&Mt.isNotebookCellDataArray(Ge)&&(st=ie,lt=_e,Ct=Ge,At=tt),st===void 0||lt===void 0)throw new Error("Invalid arguments");(st!==lt||Ct.length>0)&&this._edits.push({_type:5,uri:O,index:st,count:lt-st,cells:Ct,metadata:At})}replaceNotebookCellMetadata(O,ie,_e,Ge){this._edits.push({_type:3,metadata:Ge,uri:O,edit:{editType:8,index:ie,metadata:_e}})}replace(O,ie,_e,Ge){this._edits.push({_type:2,uri:O,edit:new B(ie,_e),metadata:Ge})}insert(O,ie,_e,Ge){this.replace(O,new L(ie,ie),_e,Ge)}delete(O,ie,_e){this.replace(O,ie,"",_e)}has(O){return this._edits.some(ie=>ie._type===2&&ie.uri.toString()===O.toString())}set(O,ie){if(ie)for(const _e of ie)_e&&this._edits.push({_type:2,uri:O,edit:_e});else{for(let _e=0;_e<this._edits.length;_e++){const Ge=this._edits[_e];Ge._type===2&&Ge.uri.toString()===O.toString()&&(this._edits[_e]=void 0)}(0,c.coalesceInPlace)(this._edits)}}get(O){const ie=[];for(let _e of this._edits)_e._type===2&&_e.uri.toString()===O.toString()&&ie.push(_e.edit);return ie}entries(){const O=new R.ResourceMap;for(let ie of this._edits)if(ie._type===2){let _e=O.get(ie.uri);_e||(_e=[ie.uri,[]],O.set(ie.uri,_e)),_e[1].push(ie.edit)}return[...O.values()]}get size(){return this.entries().length}toJSON(){return this.entries()}};Y=We([D],Y),e.WorkspaceEdit=Y;let ne=y=class{constructor(O){this._tabstop=1,this.value=O||""}static isSnippetString(O){return O instanceof y?!0:O?typeof O.value=="string":!1}static _escape(O){return O.replace(/\$|}|\\/g,"\\$&")}appendText(O){return this.value+=y._escape(O),this}appendTabstop(O=this._tabstop++){return this.value+="$",this.value+=O,this}appendPlaceholder(O,ie=this._tabstop++){if(typeof O=="function"){const _e=new y;_e._tabstop=this._tabstop,O(_e),this._tabstop=_e._tabstop,O=_e.value}else O=y._escape(O);return this.value+="${",this.value+=ie,this.value+=":",this.value+=O,this.value+="}",this}appendChoice(O,ie=this._tabstop++){const _e=O.map(Ge=>Ge.replace(/\$|}|\\|,/g,"\\$&")).join(",");return this.value+="${",this.value+=ie,this.value+="|",this.value+=_e,this.value+="|}",this}appendVariable(O,ie){if(typeof ie=="function"){const _e=new y;_e._tabstop=this._tabstop,ie(_e),this._tabstop=_e._tabstop,ie=_e.value}else typeof ie=="string"&&(ie=ie.replace(/\$|}/g,"\\$&"));return this.value+="${",this.value+=O,ie&&(this.value+=":",this.value+=ie),this.value+="}",this}};ne=y=We([D],ne),e.SnippetString=ne;var j;(function(N){N[N.Unnecessary=1]="Unnecessary",N[N.Deprecated=2]="Deprecated"})(j=e.DiagnosticTag||(e.DiagnosticTag={}));var le;(function(N){N[N.Hint=3]="Hint",N[N.Information=2]="Information",N[N.Warning=1]="Warning",N[N.Error=0]="Error"})(le=e.DiagnosticSeverity||(e.DiagnosticSeverity={}));let oe=i=class{constructor(O,ie){if(this.uri=O,ie)if(ie instanceof L)this.range=ie;else if(ie instanceof A)this.range=new L(ie,ie);else throw new Error("Illegal argument")}static isLocation(O){return O instanceof i?!0:O?L.isRange(O.range)&&_.URI.isUri(O.uri):!1}toJSON(){return{uri:this.uri,range:this.range}}};oe=i=We([D],oe),e.Location=oe;let ve=class{constructor(O,ie){this.location=O,this.message=ie}static is(O){return O?typeof O.message=="string"&&O.location&&L.isRange(O.location.range)&&_.URI.isUri(O.location.uri):!1}static isEqual(O,ie){return O===ie?!0:!O||!ie?!1:O.message===ie.message&&O.location.range.isEqual(ie.location.range)&&O.location.uri.toString()===ie.location.uri.toString()}};ve=We([D],ve),e.DiagnosticRelatedInformation=ve;let Re=class{constructor(O,ie,_e=le.Error){if(!L.isRange(O))throw new TypeError("range must be set");if(!ie)throw new TypeError("message must be set");this.range=O,this.message=ie,this.severity=_e}toJSON(){return{severity:le[this.severity],message:this.message,range:this.range,source:this.source,code:this.code}}static isEqual(O,ie){return O===ie?!0:!O||!ie?!1:O.message===ie.message&&O.severity===ie.severity&&O.code===ie.code&&O.severity===ie.severity&&O.source===ie.source&&O.range.isEqual(ie.range)&&(0,c.equals)(O.tags,ie.tags)&&(0,c.equals)(O.relatedInformation,ie.relatedInformation,ve.isEqual)}};Re=We([D],Re),e.Diagnostic=Re;let Me=class{constructor(O,ie){if(!O)throw new Error("Illegal argument, contents must be defined");Array.isArray(O)?this.contents=O:this.contents=[O],this.range=ie}};Me=We([D],Me),e.Hover=Me;var Oe;(function(N){N[N.Text=0]="Text",N[N.Read=1]="Read",N[N.Write=2]="Write"})(Oe=e.DocumentHighlightKind||(e.DocumentHighlightKind={}));let Ye=class{constructor(O,ie=Oe.Text){this.range=O,this.kind=ie}toJSON(){return{range:this.range,kind:Oe[this.kind]}}};Ye=We([D],Ye),e.DocumentHighlight=Ye;var Ve;(function(N){N[N.File=0]="File",N[N.Module=1]="Module",N[N.Namespace=2]="Namespace",N[N.Package=3]="Package",N[N.Class=4]="Class",N[N.Method=5]="Method",N[N.Property=6]="Property",N[N.Field=7]="Field",N[N.Constructor=8]="Constructor",N[N.Enum=9]="Enum",N[N.Interface=10]="Interface",N[N.Function=11]="Function",N[N.Variable=12]="Variable",N[N.Constant=13]="Constant",N[N.String=14]="String",N[N.Number=15]="Number",N[N.Boolean=16]="Boolean",N[N.Array=17]="Array",N[N.Object=18]="Object",N[N.Key=19]="Key",N[N.Null=20]="Null",N[N.EnumMember=21]="EnumMember",N[N.Struct=22]="Struct",N[N.Event=23]="Event",N[N.Operator=24]="Operator",N[N.TypeParameter=25]="TypeParameter"})(Ve=e.SymbolKind||(e.SymbolKind={}));var qe;(function(N){N[N.Deprecated=1]="Deprecated"})(qe=e.SymbolTag||(e.SymbolTag={}));let x=v=class{constructor(O,ie,_e,Ge,tt){this.name=O,this.kind=ie,this.containerName=tt,typeof _e=="string"&&(this.containerName=_e),Ge instanceof oe?this.location=Ge:_e instanceof L&&(this.location=new oe(Ge,_e)),v.validate(this)}static validate(O){if(!O.name)throw new Error("name must not be falsy")}toJSON(){return{name:this.name,kind:Ve[this.kind],location:this.location,containerName:this.containerName}}};x=v=We([D],x),e.SymbolInformation=x;let Q=r=class{constructor(O,ie,_e,Ge,tt){this.name=O,this.detail=ie,this.kind=_e,this.range=Ge,this.selectionRange=tt,this.children=[],r.validate(this)}static validate(O){if(!O.name)throw new Error("name must not be falsy");if(!O.range.contains(O.selectionRange))throw new Error("selectionRange must be contained in fullRange");O.children&&O.children.forEach(r.validate)}};Q=r=We([D],Q),e.DocumentSymbol=Q;var te;(function(N){N[N.Invoke=1]="Invoke",N[N.Automatic=2]="Automatic"})(te=e.CodeActionTriggerKind||(e.CodeActionTriggerKind={}));let ae=class{constructor(O,ie){this.title=O,this.kind=ie}};ae=We([D],ae),e.CodeAction=ae;let q=s=class{constructor(O){this.value=O}append(O){return new s(this.value?this.value+s.sep+O:O)}intersects(O){return this.contains(O)||O.contains(this)}contains(O){return this.value===O.value||O.value.startsWith(this.value+s.sep)}};q.sep=".",q=s=We([D],q),e.CodeActionKind=q,q.Empty=new q(""),q.QuickFix=q.Empty.append("quickfix"),q.Refactor=q.Empty.append("refactor"),q.RefactorExtract=q.Refactor.append("extract"),q.RefactorInline=q.Refactor.append("inline"),q.RefactorRewrite=q.Refactor.append("rewrite"),q.Source=q.Empty.append("source"),q.SourceOrganizeImports=q.Source.append("organizeImports"),q.SourceFixAll=q.Source.append("fixAll");let se=class{constructor(O,ie){if(this.range=O,this.parent=ie,ie&&!ie.range.contains(this.range))throw new Error("Invalid argument: parent must contain this range")}};se=We([D],se),e.SelectionRange=se;class he{constructor(O,ie,_e,Ge,tt,st){this.kind=O,this.name=ie,this.detail=_e,this.uri=Ge,this.range=tt,this.selectionRange=st}}e.CallHierarchyItem=he;class Te{constructor(O,ie){this.fromRanges=ie,this.from=O}}e.CallHierarchyIncomingCall=Te;class Ue{constructor(O,ie){this.fromRanges=ie,this.to=O}}e.CallHierarchyOutgoingCall=Ue;var He;(function(N){N[N.Information=0]="Information",N[N.Warning=1]="Warning",N[N.Error=2]="Error"})(He=e.LanguageStatusSeverity||(e.LanguageStatusSeverity={}));let Ke=class{constructor(O,ie){this.range=O,this.command=ie}get isResolved(){return!!this.command}};Ke=We([D],Ke),e.CodeLens=Ke;let ye=u=class{constructor(O,ie=!1){f.set(this,void 0),Ze(this,f,new b.MarkdownString(O,{supportThemeIcons:ie}),"f")}static isMarkdownString(O){return O instanceof u?!0:O&&O.appendCodeblock&&O.appendMarkdown&&O.appendText&&O.value!==void 0}get value(){return Ae(this,f,"f").value}set value(O){Ae(this,f,"f").value=O}get isTrusted(){return Ae(this,f,"f").isTrusted}set isTrusted(O){Ae(this,f,"f").isTrusted=O}get supportThemeIcons(){return Ae(this,f,"f").supportThemeIcons}set supportThemeIcons(O){Ae(this,f,"f").supportThemeIcons=O}get supportHtml(){return Ae(this,f,"f").supportHtml}set supportHtml(O){Ae(this,f,"f").supportHtml=O}appendText(O){return Ae(this,f,"f").appendText(O),this}appendMarkdown(O){return Ae(this,f,"f").appendMarkdown(O),this}appendCodeblock(O,ie){return Ae(this,f,"f").appendCodeblock(ie??"",O),this}};f=new WeakMap,ye=u=We([D],ye),e.MarkdownString=ye;let nt=class{constructor(O,ie){this.label=O,this.documentation=ie}};nt=We([D],nt),e.ParameterInformation=nt;let H=class{constructor(O,ie){this.label=O,this.documentation=ie,this.parameters=[]}};H=We([D],H),e.SignatureInformation=H;let J=class{constructor(){this.activeSignature=0,this.activeParameter=0,this.signatures=[]}};J=We([D],J),e.SignatureHelp=J;var fe;(function(N){N[N.Invoke=1]="Invoke",N[N.TriggerCharacter=2]="TriggerCharacter",N[N.ContentChange=3]="ContentChange"})(fe=e.SignatureHelpTriggerKind||(e.SignatureHelpTriggerKind={}));var xe;(function(N){N[N.Other=0]="Other",N[N.Type=1]="Type",N[N.Parameter=2]="Parameter"})(xe=e.InlayHintKind||(e.InlayHintKind={}));let Qe=class{constructor(O,ie,_e){this.text=O,this.position=ie,this.kind=_e}};Qe=We([D],Qe),e.InlayHint=Qe;var rt;(function(N){N[N.Invoke=0]="Invoke",N[N.TriggerCharacter=1]="TriggerCharacter",N[N.TriggerForIncompleteCompletions=2]="TriggerForIncompleteCompletions"})(rt=e.CompletionTriggerKind||(e.CompletionTriggerKind={}));var ct;(function(N){N[N.Text=0]="Text",N[N.Method=1]="Method",N[N.Function=2]="Function",N[N.Constructor=3]="Constructor",N[N.Field=4]="Field",N[N.Variable=5]="Variable",N[N.Class=6]="Class",N[N.Interface=7]="Interface",N[N.Module=8]="Module",N[N.Property=9]="Property",N[N.Unit=10]="Unit",N[N.Value=11]="Value",N[N.Enum=12]="Enum",N[N.Keyword=13]="Keyword",N[N.Snippet=14]="Snippet",N[N.Color=15]="Color",N[N.File=16]="File",N[N.Reference=17]="Reference",N[N.Folder=18]="Folder",N[N.EnumMember=19]="EnumMember",N[N.Constant=20]="Constant",N[N.Struct=21]="Struct",N[N.Event=22]="Event",N[N.Operator=23]="Operator",N[N.TypeParameter=24]="TypeParameter",N[N.User=25]="User",N[N.Issue=26]="Issue"})(ct=e.CompletionItemKind||(e.CompletionItemKind={}));var ft;(function(N){N[N.Deprecated=1]="Deprecated"})(ft=e.CompletionItemTag||(e.CompletionItemTag={}));let Pt=class{constructor(O,ie){this.label=O,this.kind=ie}toJSON(){return{label:this.label,kind:this.kind&&ct[this.kind],detail:this.detail,documentation:this.documentation,sortText:this.sortText,filterText:this.filterText,preselect:this.preselect,insertText:this.insertText,textEdit:this.textEdit}}};Pt=We([D],Pt),e.CompletionItem=Pt;let mt=class{constructor(O=[],ie=!1){this.items=O,this.isIncomplete=ie}};mt=We([D],mt),e.CompletionList=mt;let Dt=class{constructor(O,ie,_e){this.text=O,this.range=ie,this.command=_e}};Dt=We([D],Dt),e.InlineSuggestion=Dt;let kt=class{constructor(O){this.items=O}};kt=We([D],kt),e.InlineSuggestions=kt;var vt;(function(N){N[N.Active=-1]="Active",N[N.Beside=-2]="Beside",N[N.One=1]="One",N[N.Two=2]="Two",N[N.Three=3]="Three",N[N.Four=4]="Four",N[N.Five=5]="Five",N[N.Six=6]="Six",N[N.Seven=7]="Seven",N[N.Eight=8]="Eight",N[N.Nine=9]="Nine"})(vt=e.ViewColumn||(e.ViewColumn={}));var Xe;(function(N){N[N.Left=1]="Left",N[N.Right=2]="Right"})(Xe=e.StatusBarAlignment||(e.StatusBarAlignment={}));var _t;(function(N){N[N.Off=0]="Off",N[N.On=1]="On",N[N.Relative=2]="Relative"})(_t=e.TextEditorLineNumbersStyle||(e.TextEditorLineNumbersStyle={}));var Pe;(function(N){N[N.Manual=1]="Manual",N[N.AfterDelay=2]="AfterDelay",N[N.FocusOut=3]="FocusOut"})(Pe=e.TextDocumentSaveReason||(e.TextDocumentSaveReason={}));var Se;(function(N){N[N.Default=0]="Default",N[N.InCenter=1]="InCenter",N[N.InCenterIfOutsideViewport=2]="InCenterIfOutsideViewport",N[N.AtTop=3]="AtTop"})(Se=e.TextEditorRevealType||(e.TextEditorRevealType={}));var De;(function(N){N[N.Keyboard=1]="Keyboard",N[N.Mouse=2]="Mouse",N[N.Command=3]="Command"})(De=e.TextEditorSelectionChangeKind||(e.TextEditorSelectionChangeKind={}));var ee;(function(N){N[N.Undo=1]="Undo",N[N.Redo=2]="Redo"})(ee=e.TextDocumentChangeReason||(e.TextDocumentChangeReason={}));var ue;(function(N){N[N.OpenOpen=0]="OpenOpen",N[N.ClosedClosed=1]="ClosedClosed",N[N.OpenClosed=2]="OpenClosed",N[N.ClosedOpen=3]="ClosedOpen"})(ue=e.DecorationRangeBehavior||(e.DecorationRangeBehavior={})),function(N){function O(ie){switch(ie){case"keyboard":return N.Keyboard;case"mouse":return N.Mouse;case"api":return N.Command}}N.fromValue=O}(De=e.TextEditorSelectionChangeKind||(e.TextEditorSelectionChangeKind={}));let pe=class{constructor(O,ie){if(ie&&!_.URI.isUri(ie))throw(0,M.illegalArgument)("target");if(!L.isRange(O)||O.isEmpty)throw(0,M.illegalArgument)("range");this.range=O,this.target=ie}};pe=We([D],pe),e.DocumentLink=pe;let me=class{constructor(O,ie,_e,Ge){this.red=O,this.green=ie,this.blue=_e,this.alpha=Ge}};me=We([D],me),e.Color=me;let Ie=class{constructor(O,ie){if(ie&&!(ie instanceof me))throw(0,M.illegalArgument)("color");if(!L.isRange(O)||O.isEmpty)throw(0,M.illegalArgument)("range");this.range=O,this.color=ie}};Ie=We([D],Ie),e.ColorInformation=Ie;let Be=class{constructor(O){if(!O||typeof O!="string")throw(0,M.illegalArgument)("label");this.label=O}};Be=We([D],Be),e.ColorPresentation=Be;var Ne;(function(N){N[N.RGB=0]="RGB",N[N.HEX=1]="HEX",N[N.HSL=2]="HSL"})(Ne=e.ColorFormat||(e.ColorFormat={}));var je;(function(N){N[N.Error=0]="Error",N[N.Warning=1]="Warning",N[N.Information=2]="Information"})(je=e.SourceControlInputBoxValidationType||(e.SourceControlInputBoxValidationType={}));class et{constructor(O,ie,_e){if(this.startIndex=O,this.length=ie,this.tooltip=_e,typeof O!="number"||O<0)throw(0,M.illegalArgument)("startIndex");if(typeof ie!="number"||ie<1)throw(0,M.illegalArgument)("length");if(_e!==void 0&&typeof _e!="string")throw(0,M.illegalArgument)("tooltip")}}e.TerminalLink=et;var Le;(function(N){N[N.Panel=1]="Panel",N[N.Editor=2]="Editor"})(Le=e.TerminalLocation||(e.TerminalLocation={}));class de{constructor(O){this.options=O,typeof O!="object"&&(0,M.illegalArgument)("options")}}e.TerminalProfile=de;var ge;(function(N){N[N.Always=1]="Always",N[N.Silent=2]="Silent",N[N.Never=3]="Never"})(ge=e.TaskRevealKind||(e.TaskRevealKind={}));var X;(function(N){N[N.Shared=1]="Shared",N[N.Dedicated=2]="Dedicated",N[N.New=3]="New"})(X=e.TaskPanelKind||(e.TaskPanelKind={}));let W=d=class{constructor(O,ie){if(this.label=ie,typeof O!="string"||typeof ie!="string")throw(0,M.illegalArgument)("name");this._id=O}static from(O){switch(O){case"clean":return d.Clean;case"build":return d.Build;case"rebuild":return d.Rebuild;case"test":return d.Test;default:return}}get id(){return this._id}};W.Clean=new d("clean","Clean"),W.Build=new d("build","Build"),W.Rebuild=new d("rebuild","Rebuild"),W.Test=new d("test","Test"),W=d=We([D],W),e.TaskGroup=W;function be(N){let O="";for(let ie=0;ie<N.length;ie++)O+=N[ie].replace(/,/g,",,")+",";return O}let ke=class{constructor(O,ie,_e){if(typeof O!="string")throw(0,M.illegalArgument)("process");this._args=[],this._process=O,ie!==void 0&&(Array.isArray(ie)?(this._args=ie,this._options=_e):this._options=ie)}get process(){return this._process}set process(O){if(typeof O!="string")throw(0,M.illegalArgument)("process");this._process=O}get args(){return this._args}set args(O){Array.isArray(O)||(O=[]),this._args=O}get options(){return this._options}set options(O){this._options=O}computeId(){const O=[];if(O.push("process"),this._process!==void 0&&O.push(this._process),this._args&&this._args.length>0)for(let ie of this._args)O.push(ie);return be(O)}};ke=We([D],ke),e.ProcessExecution=ke;let Je=class{constructor(O,ie,_e){if(this._args=[],Array.isArray(ie)){if(!O)throw(0,M.illegalArgument)("command can't be undefined or null");if(typeof O!="string"&&typeof O.value!="string")throw(0,M.illegalArgument)("command");this._command=O,this._args=ie,this._options=_e}else{if(typeof O!="string")throw(0,M.illegalArgument)("commandLine");this._commandLine=O,this._options=ie}}get commandLine(){return this._commandLine}set commandLine(O){if(typeof O!="string")throw(0,M.illegalArgument)("commandLine");this._commandLine=O}get command(){return this._command?this._command:""}set command(O){if(typeof O!="string"&&typeof O.value!="string")throw(0,M.illegalArgument)("command");this._command=O}get args(){return this._args}set args(O){this._args=O||[]}get options(){return this._options}set options(O){this._options=O}computeId(){const O=[];if(O.push("shell"),this._commandLine!==void 0&&O.push(this._commandLine),this._command!==void 0&&O.push(typeof this._command=="string"?this._command:this._command.value),this._args&&this._args.length>0)for(let ie of this._args)O.push(typeof ie=="string"?ie:ie.value);return be(O)}};Je=We([D],Je),e.ShellExecution=Je;var $e;(function(N){N[N.Escape=1]="Escape",N[N.Strong=2]="Strong",N[N.Weak=3]="Weak"})($e=e.ShellQuoting||(e.ShellQuoting={}));var ut;(function(N){N[N.Global=1]="Global",N[N.Workspace=2]="Workspace"})(ut=e.TaskScope||(e.TaskScope={}));class gt{constructor(O){this._callback=O}computeId(){return"customExecution"+(0,P.generateUuid)()}set callback(O){this._callback=O}get callback(){return this._callback}}e.CustomExecution=gt;let at=p=class{constructor(O,ie,_e,Ge,tt,st){this.__deprecated=!1,this._definition=this.definition=O;let lt;typeof ie=="string"?(this._name=this.name=ie,this._source=this.source=_e,this.execution=Ge,lt=tt,this.__deprecated=!0):ie===ut.Global||ie===ut.Workspace?(this.target=ie,this._name=this.name=_e,this._source=this.source=Ge,this.execution=tt,lt=st):(this.target=ie,this._name=this.name=_e,this._source=this.source=Ge,this.execution=tt,lt=st),typeof lt=="string"?(this._problemMatchers=[lt],this._hasDefinedMatchers=!0):Array.isArray(lt)?(this._problemMatchers=lt,this._hasDefinedMatchers=!0):(this._problemMatchers=[],this._hasDefinedMatchers=!1),this._isBackground=!1,this._presentationOptions=Object.create(null),this._runOptions=Object.create(null)}get _id(){return this.__id}set _id(O){this.__id=O}get _deprecated(){return this.__deprecated}clear(){this.__id!==void 0&&(this.__id=void 0,this._scope=void 0,this.computeDefinitionBasedOnExecution())}computeDefinitionBasedOnExecution(){this._execution instanceof ke?this._definition={type:p.ProcessType,id:this._execution.computeId()}:this._execution instanceof Je?this._definition={type:p.ShellType,id:this._execution.computeId()}:this._execution instanceof gt?this._definition={type:p.ExtensionCallbackType,id:this._execution.computeId()}:this._definition={type:p.EmptyType,id:(0,P.generateUuid)()}}get definition(){return this._definition}set definition(O){if(O==null)throw(0,M.illegalArgument)("Kind can't be undefined or null");this.clear(),this._definition=O}get scope(){return this._scope}set target(O){this.clear(),this._scope=O}get name(){return this._name}set name(O){if(typeof O!="string")throw(0,M.illegalArgument)("name");this.clear(),this._name=O}get execution(){return this._execution}set execution(O){O===null&&(O=void 0),this.clear(),this._execution=O;const ie=this._definition.type;(p.EmptyType===ie||p.ProcessType===ie||p.ShellType===ie||p.ExtensionCallbackType===ie)&&this.computeDefinitionBasedOnExecution()}get problemMatchers(){return this._problemMatchers}set problemMatchers(O){if(Array.isArray(O))this.clear(),this._problemMatchers=O,this._hasDefinedMatchers=!0;else{this.clear(),this._problemMatchers=[],this._hasDefinedMatchers=!1;return}}get hasDefinedMatchers(){return this._hasDefinedMatchers}get isBackground(){return this._isBackground}set isBackground(O){O!==!0&&O!==!1&&(O=!1),this.clear(),this._isBackground=O}get source(){return this._source}set source(O){if(typeof O!="string"||O.length===0)throw(0,M.illegalArgument)("source must be a string of length > 0");this.clear(),this._source=O}get group(){return this._group}set group(O){O===null&&(O=void 0),this.clear(),this._group=O}get detail(){return this._detail}set detail(O){O===null&&(O=void 0),this._detail=O}get presentationOptions(){return this._presentationOptions}set presentationOptions(O){O==null&&(O=Object.create(null)),this.clear(),this._presentationOptions=O}get runOptions(){return this._runOptions}set runOptions(O){O==null&&(O=Object.create(null)),this.clear(),this._runOptions=O}};at.ExtensionCallbackType="customExecution",at.ProcessType="process",at.ShellType="shell",at.EmptyType="$empty",at=p=We([D],at),e.Task=at;var dt;(function(N){N[N.SourceControl=1]="SourceControl",N[N.Window=10]="Window",N[N.Notification=15]="Notification"})(dt=e.ProgressLocation||(e.ProgressLocation={}));let ot=class{constructor(O,ie=pt.None){this.collapsibleState=ie,_.URI.isUri(O)?this.resourceUri=O:this.label=O}};ot=We([D],ot),e.TreeItem=ot;var pt;(function(N){N[N.None=0]="None",N[N.Collapsed=1]="Collapsed",N[N.Expanded=2]="Expanded"})(pt=e.TreeItemCollapsibleState||(e.TreeItemCollapsibleState={}));let St=class{constructor(O,ie){this.id=O,this.color=ie}};St=We([D],St),e.ThemeIcon=St,St.File=new St("file"),St.Folder=new St("folder");let Ut=class{constructor(O){this.id=O}};Ut=We([D],Ut),e.ThemeColor=Ut;var Vt;(function(N){N[N.Global=1]="Global",N[N.Workspace=2]="Workspace",N[N.WorkspaceFolder=3]="WorkspaceFolder"})(Vt=e.ConfigurationTarget||(e.ConfigurationTarget={}));let yt=class{constructor(O,ie){if(typeof O!="string"&&(!O||!_.URI.isUri(O)&&!_.URI.isUri(O.uri)))throw(0,M.illegalArgument)("base");if(typeof ie!="string")throw(0,M.illegalArgument)("pattern");typeof O=="string"?(this.baseFolder=_.URI.file(O),this.base=O):_.URI.isUri(O)?(this.baseFolder=O,this.base=O.fsPath):(this.baseFolder=O.uri,this.base=O.uri.fsPath),this.pattern=ie}};yt=We([D],yt),e.RelativePattern=yt;let $t=class{constructor(O,ie,_e,Ge){this.enabled=typeof O=="boolean"?O:!0,typeof ie=="string"&&(this.condition=ie),typeof _e=="string"&&(this.hitCondition=_e),typeof Ge=="string"&&(this.logMessage=Ge)}get id(){return this._id||(this._id=(0,P.generateUuid)()),this._id}};$t=We([D],$t),e.Breakpoint=$t;let ei=class extends $t{constructor(O,ie,_e,Ge,tt){super(ie,_e,Ge,tt);if(O===null)throw(0,M.illegalArgument)("location");this.location=O}};ei=We([D],ei),e.SourceBreakpoint=ei;let wt=class extends $t{constructor(O,ie,_e,Ge,tt){super(ie,_e,Ge,tt);this.functionName=O}};wt=We([D],wt),e.FunctionBreakpoint=wt;let Qt=class extends $t{constructor(O,ie,_e,Ge,tt,st,lt){super(Ge,tt,st,lt);if(!ie)throw(0,M.illegalArgument)("dataId");this.label=O,this.dataId=ie,this.canPersist=_e}};Qt=We([D],Qt),e.DataBreakpoint=Qt;let jt=class{constructor(O,ie,_e){this.command=O,this.args=ie||[],this.options=_e}};jt=We([D],jt),e.DebugAdapterExecutable=jt;let ti=class{constructor(O,ie){this.port=O,this.host=ie}};ti=We([D],ti),e.DebugAdapterServer=ti;let ii=class{constructor(O){this.path=O}};ii=We([D],ii),e.DebugAdapterNamedPipeServer=ii;let Tt=class{constructor(O){this.implementation=O}};Tt=We([D],Tt),e.DebugAdapterInlineImplementation=Tt;let Yt=class{constructor(O,ie){this.range=O,this.expression=ie}};Yt=We([D],Yt),e.EvaluatableExpression=Yt;var wi;(function(N){N[N.Automatic=0]="Automatic",N[N.Explicit=1]="Explicit"})(wi=e.InlineCompletionTriggerKind||(e.InlineCompletionTriggerKind={}));let Wt=class{constructor(O,ie){this.range=O,this.text=ie}};Wt=We([D],Wt),e.InlineValueText=Wt;let Ht=class{constructor(O,ie,_e=!0){this.range=O,this.variableName=ie,this.caseSensitiveLookup=_e}};Ht=We([D],Ht),e.InlineValueVariableLookup=Ht;let ht=class{constructor(O,ie){this.range=O,this.expression=ie}};ht=We([D],ht),e.InlineValueEvaluatableExpression=ht;let ni=class{constructor(O,ie){this.frameId=O,this.stoppedLocation=ie}};ni=We([D],ni),e.InlineValueContext=ni;var Ot;(function(N){N[N.Changed=1]="Changed",N[N.Created=2]="Created",N[N.Deleted=3]="Deleted"})(Ot=e.FileChangeType||(e.FileChangeType={}));let Nt=k=class extends Error{constructor(O,ie=t.FileSystemProviderErrorCode.Unknown,_e){super(_.URI.isUri(O)?O.toString(!0):O);this.code=_e?.name??"Unknown",(0,t.markAsFileSystemProviderError)(this,ie),typeof Object.setPrototypeOf=="function"&&Object.setPrototypeOf(this,k.prototype),typeof Error.captureStackTrace=="function"&&typeof _e=="function"&&Error.captureStackTrace(this,_e)}static FileExists(O){return new k(O,t.FileSystemProviderErrorCode.FileExists,k.FileExists)}static FileNotFound(O){return new k(O,t.FileSystemProviderErrorCode.FileNotFound,k.FileNotFound)}static FileNotADirectory(O){return new k(O,t.FileSystemProviderErrorCode.FileNotADirectory,k.FileNotADirectory)}static FileIsADirectory(O){return new k(O,t.FileSystemProviderErrorCode.FileIsADirectory,k.FileIsADirectory)}static NoPermissions(O){return new k(O,t.FileSystemProviderErrorCode.NoPermissions,k.NoPermissions)}static Unavailable(O){return new k(O,t.FileSystemProviderErrorCode.Unavailable,k.Unavailable)}};Nt=k=We([D],Nt),e.FileSystemError=Nt;let Jt=class{constructor(O,ie,_e){this.start=O,this.end=ie,this.kind=_e}};Jt=We([D],Jt),e.FoldingRange=Jt;var bi;(function(N){N[N.Comment=1]="Comment",N[N.Imports=2]="Imports",N[N.Region=3]="Region"})(bi=e.FoldingRangeKind||(e.FoldingRangeKind={}));var hi;(function(N){N[N.Collapsed=0]="Collapsed",N[N.Expanded=1]="Expanded"})(hi=e.CommentThreadCollapsibleState||(e.CommentThreadCollapsibleState={}));var Ei;(function(N){N[N.Editing=0]="Editing",N[N.Preview=1]="Preview"})(Ei=e.CommentMode||(e.CommentMode={}));class fi{constructor(O,ie=[]){this.tokenTypes=O,this.tokenModifiers=ie}}e.SemanticTokensLegend=fi;function ri(N){return typeof N=="undefined"||(0,C.isStringArray)(N)}class si{constructor(O){if(this._prevLine=0,this._prevChar=0,this._dataIsSortedAndDeltaEncoded=!0,this._data=[],this._dataLen=0,this._tokenTypeStrToInt=new Map,this._tokenModifierStrToInt=new Map,this._hasLegend=!1,O){this._hasLegend=!0;for(let ie=0,_e=O.tokenTypes.length;ie<_e;ie++)this._tokenTypeStrToInt.set(O.tokenTypes[ie],ie);for(let ie=0,_e=O.tokenModifiers.length;ie<_e;ie++)this._tokenModifierStrToInt.set(O.tokenModifiers[ie],ie)}}push(O,ie,_e,Ge,tt){if(typeof O=="number"&&typeof ie=="number"&&typeof _e=="number"&&typeof Ge=="number"&&(typeof tt=="number"||typeof tt=="undefined"))return typeof tt=="undefined"&&(tt=0),this._pushEncoded(O,ie,_e,Ge,tt);if(L.isRange(O)&&typeof ie=="string"&&ri(_e))return this._push(O,ie,_e);throw(0,M.illegalArgument)()}_push(O,ie,_e){if(!this._hasLegend)throw new Error("Legend must be provided in constructor");if(O.start.line!==O.end.line)throw new Error("`range` cannot span multiple lines");if(!this._tokenTypeStrToInt.has(ie))throw new Error("`tokenType` is not in the provided legend");const Ge=O.start.line,tt=O.start.character,st=O.end.character-O.start.character,lt=this._tokenTypeStrToInt.get(ie);let Ct=0;if(_e)for(const At of _e){if(!this._tokenModifierStrToInt.has(At))throw new Error("`tokenModifier` is not in the provided legend");const Ft=this._tokenModifierStrToInt.get(At);Ct|=1<<Ft>>>0}this._pushEncoded(Ge,tt,st,lt,Ct)}_pushEncoded(O,ie,_e,Ge,tt){if(this._dataIsSortedAndDeltaEncoded&&(O<this._prevLine||O===this._prevLine&&ie<this._prevChar)){this._dataIsSortedAndDeltaEncoded=!1;const Ct=this._data.length/5|0;let At=0,Ft=0;for(let Lt=0;Lt<Ct;Lt++){let xt=this._data[5*Lt],ci=this._data[5*Lt+1];xt===0?(xt=At,ci+=Ft):xt+=At,this._data[5*Lt]=xt,this._data[5*Lt+1]=ci,At=xt,Ft=ci}}let st=O,lt=ie;this._dataIsSortedAndDeltaEncoded&&this._dataLen>0&&(st-=this._prevLine,st===0&&(lt-=this._prevChar)),this._data[this._dataLen++]=st,this._data[this._dataLen++]=lt,this._data[this._dataLen++]=_e,this._data[this._dataLen++]=Ge,this._data[this._dataLen++]=tt,this._prevLine=O,this._prevChar=ie}static _sortAndDeltaEncode(O){let ie=[];const _e=O.length/5|0;for(let lt=0;lt<_e;lt++)ie[lt]=lt;ie.sort((lt,Ct)=>{const At=O[5*lt],Ft=O[5*Ct];if(At===Ft){const Lt=O[5*lt+1],xt=O[5*Ct+1];return Lt-xt}return At-Ft});const Ge=new Uint32Array(O.length);let tt=0,st=0;for(let lt=0;lt<_e;lt++){const Ct=5*ie[lt],At=O[Ct+0],Ft=O[Ct+1],Lt=O[Ct+2],xt=O[Ct+3],ci=O[Ct+4],xi=At-tt,qi=xi===0?Ft-st:Ft,di=5*lt;Ge[di+0]=xi,Ge[di+1]=qi,Ge[di+2]=Lt,Ge[di+3]=xt,Ge[di+4]=ci,tt=At,st=Ft}return Ge}build(O){return this._dataIsSortedAndDeltaEncoded?new qt(new Uint32Array(this._data),O):new qt(si._sortAndDeltaEncode(this._data),O)}}e.SemanticTokensBuilder=si;class qt{constructor(O,ie){this.resultId=ie,this.data=O}}e.SemanticTokens=qt;class oi{constructor(O,ie,_e){this.start=O,this.deleteCount=ie,this.data=_e}}e.SemanticTokensEdit=oi;class _i{constructor(O,ie){this.resultId=ie,this.edits=O}}e.SemanticTokensEdits=_i;var yi;(function(N){N[N.Separate=0]="Separate",N[N.MergeWithParent=1]="MergeWithParent"})(yi=e.DebugConsoleMode||(e.DebugConsoleMode={}));var Gt;(function(N){N[N.Initial=1]="Initial",N[N.Dynamic=2]="Dynamic"})(Gt=e.DebugConfigurationProviderTriggerKind||(e.DebugConfigurationProviderTriggerKind={}));let Xt=class{constructor(){}};Xt.Back={iconPath:new St("arrow-left")},Xt=We([D],Xt),e.QuickInputButtons=Xt;var Si;(function(N){N[N.UI=1]="UI",N[N.Workspace=2]="Workspace"})(Si=e.ExtensionKind||(e.ExtensionKind={}));class Di{constructor(O,ie,_e){this.badge=O,this.tooltip=ie,this.color=_e}static validate(O){if(O.badge&&O.badge.length!==1&&O.badge.length!==2)throw new Error("The 'badge'-property must be undefined or a short character");if(!O.color&&!O.badge&&!O.tooltip)throw new Error("The decoration is empty")}}e.FileDecoration=Di;let ai=class{constructor(O){this.kind=O}};ai=We([D],ai),e.ColorTheme=ai;var li;(function(N){N[N.Light=1]="Light",N[N.Dark=2]="Dark",N[N.HighContrast=3]="HighContrast"})(li=e.ColorThemeKind||(e.ColorThemeKind={}));class zt{constructor(O,ie){if(O<0)throw(0,M.illegalArgument)("start must be positive");if(ie<0)throw(0,M.illegalArgument)("end must be positive");O<=ie?(this._start=O,this._end=ie):(this._start=ie,this._end=O)}static isNotebookRange(O){return O instanceof zt?!0:O?typeof O.start=="number"&&typeof O.end=="number":!1}get start(){return this._start}get end(){return this._end}get isEmpty(){return this._start===this._end}with(O){let ie=this._start,_e=this._end;return O.start!==void 0&&(ie=O.start),O.end!==void 0&&(_e=O.end),ie===this._start&&_e===this._end?this:new zt(ie,_e)}}e.NotebookRange=zt;class Mt{constructor(O,ie,_e,Ge,tt,st,lt){this.kind=O,this.value=ie,this.languageId=_e,this.mime=Ge,this.outputs=tt??[],this.metadata=st,this.executionSummary=lt,Mt.validate(this)}static validate(O){if(typeof O.kind!="number")throw new Error("NotebookCellData MUST have 'kind' property");if(typeof O.value!="string")throw new Error("NotebookCellData MUST have 'value' property");if(typeof O.languageId!="string")throw new Error("NotebookCellData MUST have 'languageId' property")}static isNotebookCellDataArray(O){return Array.isArray(O)&&O.every(ie=>Mt.isNotebookCellData(ie))}static isNotebookCellData(O){return!0}}e.NotebookCellData=Mt;class Fe{constructor(O){this.cells=O}}e.NotebookData=Fe;class Rt{constructor(O,ie){this.data=O,this.mime=ie;const _e=(0,F.normalizeMimeType)(ie,!0);if(!_e)throw new Error(`INVALID mime type: ${ie}. Must be in the format "type/subtype[;optionalparameter]"`);this.mime=_e}static isNotebookCellOutputItem(O){return O instanceof Rt?!0:O?typeof O.mime=="string"&&O.data instanceof Uint8Array:!1}static error(O){const ie={name:O.name,message:O.message,stack:O.stack};return Rt.json(ie,"application/vnd.code.notebook.error")}static stdout(O){return Rt.text(O,"application/vnd.code.notebook.stdout")}static stderr(O){return Rt.text(O,"application/vnd.code.notebook.stderr")}static bytes(O,ie="application/octet-stream"){return new Rt(O,ie)}static text(O,ie=F.Mimes.text){const _e=Ae(Rt,a,"f",l).encode(String(O));return new Rt(_e,ie)}static json(O,ie="application/json"){const _e=JSON.stringify(O,void 0,"	");return Rt.text(_e,ie)}}e.NotebookCellOutputItem=Rt,a=Rt,l={value:new TextEncoder};class Kt{constructor(O,ie,_e){this.items=Kt.ensureUniqueMimeTypes(O,!0),typeof ie=="string"?(this.id=ie,this.metadata=_e):(this.id=(0,P.generateUuid)(),this.metadata=ie??_e)}static isNotebookCellOutput(O){return O instanceof Kt?!0:!O||typeof O!="object"?!1:typeof O.id=="string"&&(0,C.isArray)(O.items)}static ensureUniqueMimeTypes(O,ie=!1){const _e=new Set,Ge=new Set;for(let tt=0;tt<O.length;tt++){const st=O[tt],lt=(0,F.normalizeMimeType)(st.mime);if(!_e.has(lt)){_e.add(lt);continue}Ge.add(tt),ie&&console.warn(`DUPLICATED mime type '${st.mime}' will be dropped`)}return Ge.size===0?O:O.filter((tt,st)=>!Ge.has(st))}}e.NotebookCellOutput=Kt;var bt;(function(N){N[N.Markup=1]="Markup",N[N.Code=2]="Code"})(bt=e.NotebookCellKind||(e.NotebookCellKind={}));var Ci;(function(N){N[N.Idle=1]="Idle",N[N.Pending=2]="Pending",N[N.Executing=3]="Executing"})(Ci=e.NotebookCellExecutionState||(e.NotebookCellExecutionState={}));var ki;(function(N){N[N.Left=1]="Left",N[N.Right=2]="Right"})(ki=e.NotebookCellStatusBarAlignment||(e.NotebookCellStatusBarAlignment={}));var mi;(function(N){N[N.Default=0]="Default",N[N.InCenter=1]="InCenter",N[N.InCenterIfOutsideViewport=2]="InCenterIfOutsideViewport",N[N.AtTop=3]="AtTop"})(mi=e.NotebookEditorRevealType||(e.NotebookEditorRevealType={}));class gi{constructor(O,ie){this.text=O,this.alignment=ie}}e.NotebookCellStatusBarItem=gi;var Ii;(function(N){N[N.Default=1]="Default",N[N.Preferred=2]="Preferred"})(Ii=e.NotebookControllerAffinity||(e.NotebookControllerAffinity={}));class Pi{constructor(O,ie=[]){this.uri=O,this.provides=(0,c.asArray)(ie)}}e.NotebookRendererScript=Pi;let ui=class{constructor(O,ie){this.label=O,this.timestamp=ie}};ui=We([D],ui),e.TimelineItem=ui;var Ti;(function(N){N[N.Production=1]="Production",N[N.Development=2]="Development",N[N.Test=3]="Test"})(Ti=e.ExtensionMode||(e.ExtensionMode={}));var pi;(function(N){N[N.Node=1]="Node",N[N.Webworker=2]="Webworker"})(pi=e.ExtensionRuntime||(e.ExtensionRuntime={}));var Ai;(function(N){N[N.Other=0]="Other",N[N.Comment=1]="Comment",N[N.String=2]="String",N[N.RegEx=4]="RegEx"})(Ai=e.StandardTokenType||(e.StandardTokenType={}));class Ri{constructor(O,ie){this.ranges=O,this.wordPattern=ie}}e.LinkedEditingRanges=Ri;class Fi{constructor(O,ie){this._port=O,this._autoForwardAction=ie}get port(){return this._port}get autoForwardAction(){return this._autoForwardAction}}e.PortAttributes=Fi;var Mi;(function(N){N[N.Queued=1]="Queued",N[N.Running=2]="Running",N[N.Passed=3]="Passed",N[N.Failed=4]="Failed",N[N.Skipped=5]="Skipped",N[N.Errored=6]="Errored"})(Mi=e.TestResultState||(e.TestResultState={}));var Li;(function(N){N[N.Run=1]="Run",N[N.Debug=2]="Debug",N[N.Coverage=3]="Coverage"})(Li=e.TestRunProfileKind||(e.TestRunProfileKind={}));let Z=class{constructor(O,ie,_e){this.include=O,this.exclude=ie,this.profile=_e}};Z=We([D],Z),e.TestRunRequest=Z;let ce=T=class{constructor(O){this.message=O}static diff(O,ie,_e){const Ge=new T(O);return Ge.expectedOutput=ie,Ge.actualOutput=_e,Ge}};ce=T=We([D],ce),e.TestMessage=ce;let Ce=class{constructor(O){this.id=O}};Ce=We([D],Ce),e.TestTag=Ce;let it=class{constructor(O,ie){this.covered=O,this.total=ie}};it=We([D],it),e.CoveredCount=it;let Et=g=class{constructor(O,ie,_e,Ge){this.uri=O,this.statementCoverage=ie,this.branchCoverage=_e,this.functionCoverage=Ge}static fromDetails(O,ie){const _e=new it(0,0),Ge=new it(0,0),tt=new it(0,0);for(const lt of ie)if("branches"in lt){_e.total+=1,_e.covered+=lt.executionCount>0?1:0;for(const Ct of lt.branches)Ge.total+=1,Ge.covered+=Ct.executionCount>0?1:0}else tt.total+=1,tt.covered+=lt.executionCount>0?1:0;const st=new g(O,_e,Ge.total>0?Ge:void 0,tt.total>0?tt:void 0);return st.detailedCoverage=ie,st}};Et=g=We([D],Et),e.FileCoverage=Et;let It=class{constructor(O,ie,_e=[]){this.executionCount=O,this.location=ie,this.branches=_e}};It=We([D],It),e.StatementCoverage=It;let Oi=class{constructor(O,ie){this.executionCount=O,this.location=ie}};Oi=We([D],Oi),e.BranchCoverage=Oi;let Ni=class{constructor(O,ie){this.executionCount=O,this.location=ie}};Ni=We([D],Ni),e.FunctionCoverage=Ni;var Hi;(function(N){N[N.None=0]="None",N[N.Option=1]="Option",N[N.Default=2]="Default",N[N.Preferred=3]="Preferred"})(Hi=e.ExternalUriOpenerPriority||(e.ExternalUriOpenerPriority={}));var zi;(function(N){N[N.Untrusted=0]="Untrusted",N[N.Trusted=1]="Trusted",N[N.Unspecified=2]="Unspecified"})(zi=e.WorkspaceTrustState||(e.WorkspaceTrustState={}));var Vi;(function(N){N[N.Notify=1]="Notify",N[N.OpenBrowser=2]="OpenBrowser",N[N.OpenPreview=3]="OpenPreview",N[N.Silent=4]="Silent",N[N.Ignore=5]="Ignore",N[N.OpenBrowserOnce=6]="OpenBrowserOnce"})(Vi=e.PortAutoForwardAction||(e.PortAutoForwardAction={}));class ji{constructor(O,ie,_e,Ge,tt,st){this.kind=O,this.name=ie,this.detail=_e,this.uri=Ge,this.range=tt,this.selectionRange=st}}e.TypeHierarchyItem=ji}),define(we[88],Ee([0,1,42,11,9,227,118,7,12]),function(re,e,c,M,b,R,F,C,_){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostDocumentLine=e.ExtHostDocumentData=e.getWordDefinitionFor=e.setWordDefinitionFor=void 0;const P=new Map;function t(a,l){l?P.set(a,l):P.delete(a)}e.setWordDefinitionFor=t;function E(a){return P.get(a)}e.getWordDefinitionFor=E;class n extends R.MirrorTextModel{constructor(l,w,I,S,o,h,y,i){super(w,I,S,o);this._proxy=l,this._languageId=h,this._isDirty=y,this._notebook=i,this._isDisposed=!1}dispose(){(0,c.ok)(!this._isDisposed),this._isDisposed=!0,this._isDirty=!1}equalLines(l){return(0,_.equals)(this._lines,l)}get document(){if(!this._document){const l=this;this._document={get uri(){return l._uri},get fileName(){return l._uri.fsPath},get isUntitled(){return l._uri.scheme===M.Schemas.untitled},get languageId(){return l._languageId},get version(){return l._versionId},get isClosed(){return l._isDisposed},get isDirty(){return l._isDirty},get notebook(){return l._notebook},save(){return l._save()},getText(w){return w?l._getTextInRange(w):l.getText()},get eol(){return l._eol===`
`?C.EndOfLine.LF:C.EndOfLine.CRLF},get lineCount(){return l._lines.length},lineAt(w){return l._lineAt(w)},offsetAt(w){return l._offsetAt(w)},positionAt(w){return l._positionAt(w)},validateRange(w){return l._validateRange(w)},validatePosition(w){return l._validatePosition(w)},getWordRangeAtPosition(w,I){return l._getWordRangeAtPosition(w,I)}}}return Object.freeze(this._document)}_acceptLanguageId(l){(0,c.ok)(!this._isDisposed),this._languageId=l}_acceptIsDirty(l){(0,c.ok)(!this._isDisposed),this._isDirty=l}_save(){return this._isDisposed?Promise.reject(new Error("Document has been closed")):this._proxy.$trySaveDocument(this._uri)}_getTextInRange(l){const w=this._validateRange(l);if(w.isEmpty)return"";if(w.isSingleLine)return this._lines[w.start.line].substring(w.start.character,w.end.character);const I=this._eol,S=w.start.line,o=w.end.line,h=[];h.push(this._lines[S].substring(w.start.character));for(let y=S+1;y<o;y++)h.push(this._lines[y]);return h.push(this._lines[o].substring(0,w.end.character)),h.join(I)}_lineAt(l){let w;if(l instanceof C.Position?w=l.line:typeof l=="number"&&(w=l),typeof w!="number"||w<0||w>=this._lines.length||Math.floor(w)!==w)throw new Error("Illegal value for `line`");return new f(w,this._lines[w],w===this._lines.length-1)}_offsetAt(l){return l=this._validatePosition(l),this._ensureLineStarts(),this._lineStarts.getPrefixSum(l.line-1)+l.character}_positionAt(l){l=Math.floor(l),l=Math.max(0,l),this._ensureLineStarts();const w=this._lineStarts.getIndexOf(l),I=this._lines[w.index].length;return new C.Position(w.index,Math.min(w.remainder,I))}_validateRange(l){if(!(l instanceof C.Range))throw new Error("Invalid argument");const w=this._validatePosition(l.start),I=this._validatePosition(l.end);return w===l.start&&I===l.end?l:new C.Range(w.line,w.character,I.line,I.character)}_validatePosition(l){if(!(l instanceof C.Position))throw new Error("Invalid argument");if(this._lines.length===0)return l.with(0,0);let{line:w,character:I}=l,S=!1;if(w<0)w=0,I=0,S=!0;else if(w>=this._lines.length)w=this._lines.length-1,I=this._lines[w].length,S=!0;else{const o=this._lines[w].length;I<0?(I=0,S=!0):I>o&&(I=o,S=!0)}return S?new C.Position(w,I):l}_getWordRangeAtPosition(l,w){const I=this._validatePosition(l);if(!w)w=E(this._languageId);else if((0,b.regExpLeadsToEndlessLoop)(w))throw new Error(`[getWordRangeAtPosition]: ignoring custom regexp '${w.source}' because it matches the empty string.`);const S=(0,F.getWordAtText)(I.character+1,(0,F.ensureValidWordDefinition)(w),this._lines[I.line],0);if(S)return new C.Range(I.line,S.startColumn-1,I.line,S.endColumn-1)}}e.ExtHostDocumentData=n;class f{constructor(l,w,I){this._line=l,this._text=w,this._isLastLine=I}get lineNumber(){return this._line}get text(){return this._text}get range(){return new C.Range(this._line,0,this._line,this._text.length)}get rangeIncludingLineBreak(){return this._isLastLine?this.range:new C.Range(this._line,0,this._line+1,0)}get firstNonWhitespaceCharacterIndex(){return/^(\s*)/.exec(this._text)[1].length}get isEmptyOrWhitespace(){return this.firstNonWhitespaceCharacterIndex===this._text.length}}e.ExtHostDocumentLine=f}),define(we[155],Ee([0,1,7,3,228,6,55,20,2,36]),function(re,e,c,M,b,R,F,C,_,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostNotebookConcatDocument=void 0;class t{constructor(n,f,a,l){this._notebook=a,this._selector=l,this._disposables=new R.DisposableStore,this._isClosed=!1,this._versionId=0,this._onDidChange=new M.Emitter,this.onDidChange=this._onDidChange.event,this.uri=_.URI.from({scheme:"vscode-concat-doc",path:(0,P.generateUuid)()}),this._init(),this._disposables.add(f.onDidChangeDocument(I=>{const S=this._cellUris.get(I.document.uri);S!==void 0&&(this._cellLengths.changeValue(S,this._cells[S].document.getText().length+1),this._cellLines.changeValue(S,this._cells[S].document.lineCount),this._versionId+=1,this._onDidChange.fire(void 0))}));const w=I=>{I===this._notebook&&(this._init(),this._versionId+=1,this._onDidChange.fire(void 0))};this._disposables.add(n.onDidChangeNotebookCells(I=>w(I.document)))}dispose(){this._disposables.dispose(),this._isClosed=!0}get isClosed(){return this._isClosed}_init(){this._cells=[],this._cellUris=new C.ResourceMap;const n=[],f=[];for(const a of this._notebook.getCells())a.kind===c.NotebookCellKind.Code&&(!this._selector||(0,F.score)(this._selector,a.document.uri,a.document.languageId,!0))&&(this._cellUris.set(a.document.uri,this._cells.length),this._cells.push(a),n.push(a.document.getText().length+1),f.push(a.document.lineCount));this._cellLengths=new b.PrefixSumComputer(new Uint32Array(n)),this._cellLines=new b.PrefixSumComputer(new Uint32Array(f))}get version(){return this._versionId}getText(n){if(!n){let S="";for(const o of this._cells)S+=o.document.getText()+`
`;return S=S.slice(0,-1),S}if(n.isEmpty)return"";const f=this.locationAt(n.start),a=this.locationAt(n.end),l=this._cellUris.get(f.uri),w=this._cellUris.get(a.uri);if(l===void 0||w===void 0)return"";if(l===w)return this._cells[l].document.getText(new c.Range(f.range.start,a.range.end));const I=[this._cells[l].document.getText(new c.Range(f.range.start,new c.Position(this._cells[l].document.lineCount,0)))];for(let S=l+1;S<w;S++)I.push(this._cells[S].document.getText());return I.push(this._cells[w].document.getText(new c.Range(new c.Position(0,0),a.range.end))),I.join(`
`)}offsetAt(n){const f=this._cellLines.getIndexOf(n.line),a=this._cellLengths.getPrefixSum(f.index-1),l=this._cells[f.index].document.offsetAt(n.with(f.remainder));return a+l}positionAt(n){if(typeof n=="number"){const a=this._cellLengths.getIndexOf(n),l=this._cellLines.getPrefixSum(a.index-1);return this._cells[a.index].document.positionAt(a.remainder).translate(l)}const f=this._cellUris.get(n.uri);if(f!==void 0){const a=this._cellLines.getPrefixSum(f-1);return new c.Position(a+n.range.start.line,n.range.start.character)}return new c.Position(0,0)}locationAt(n){c.Range.isRange(n)||(n=new c.Range(n,n));const f=this._cellLines.getIndexOf(n.start.line);let a=f;n.isEmpty||(a=this._cellLines.getIndexOf(n.end.line));const l=new c.Position(f.remainder,n.start.character),w=new c.Position(a.remainder,n.end.character),I=new c.Range(l,w),S=this._cells[f.index];return new c.Location(S.document.uri,S.document.validateRange(I))}contains(n){return this._cellUris.has(n)}validateRange(n){const f=this.validatePosition(n.start),a=this.validatePosition(n.end);return n.with(f,a)}validatePosition(n){const f=this._cellLines.getIndexOf(n.line),a=new c.Position(f.remainder,n.character),l=this._cells[f.index].document.validatePosition(a),w=this._cellLines.getPrefixSum(f.index-1);return new c.Position(w+l.line,l.character)}}e.ExtHostNotebookConcatDocument=t}),define(we[156],Ee([0,1,7,13,3]),function(re,e,c,M,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostTheming=void 0;let R=class{constructor(C){this._actual=new c.ColorTheme(c.ColorThemeKind.Dark),this._onDidChangeActiveColorTheme=new b.Emitter}get activeColorTheme(){return this._actual}$onColorThemeChange(C){let _=C==="light"?c.ColorThemeKind.Light:C==="dark"?c.ColorThemeKind.Dark:c.ColorThemeKind.HighContrast;this._actual=new c.ColorTheme(_),this._onDidChangeActiveColorTheme.fire(this._actual)}get onDidChangeActiveColorTheme(){return this._onDidChangeActiveColorTheme.event}};R=We([ze(0,M.IExtHostRpcService)],R),e.ExtHostTheming=R}),define(we[65],Ee([0,1,4]),function(re,e,c){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.URITransformerService=e.IURITransformerService=void 0,e.IURITransformerService=(0,c.createDecorator)("IURITransformerService");class M{constructor(R){R?(this.transformIncoming=R.transformIncoming.bind(R),this.transformOutgoing=R.transformOutgoing.bind(R),this.transformOutgoingURI=R.transformOutgoingURI.bind(R),this.transformOutgoingScheme=R.transformOutgoingScheme.bind(R)):(this.transformIncoming=F=>F,this.transformOutgoing=F=>F,this.transformOutgoingURI=F=>F,this.transformOutgoingScheme=F=>F)}}e.URITransformerService=M}),define(we[157],Ee([0,1,22]),function(re,e,c){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.deserializeWebviewMessage=e.serializeWebviewMessage=void 0;class M{constructor(){this.buffers=[]}add(_){let P=this.buffers.indexOf(_);return P<0&&(P=this.buffers.length,this.buffers.push(_)),P}}function b(C,_){if(_.serializeBuffersForPostMessage){const P=new M,t=(f,a)=>{if(a instanceof ArrayBuffer){const l=P.add(a);return{$$vscode_array_buffer_reference$$:!0,index:l}}else if(ArrayBuffer.isView(a)){const l=R(a);if(l){const w=P.add(a.buffer);return{$$vscode_array_buffer_reference$$:!0,index:w,view:{type:l,byteLength:a.byteLength,byteOffset:a.byteOffset}}}}return a},E=JSON.stringify(C,t),n=P.buffers.map(f=>{const a=new Uint8Array(f);return c.VSBuffer.wrap(a)});return{message:E,buffers:n}}else return{message:JSON.stringify(C),buffers:[]}}e.serializeWebviewMessage=b;function R(C){switch(C.constructor.name){case"Int8Array":return 1;case"Uint8Array":return 2;case"Uint8ClampedArray":return 3;case"Int16Array":return 4;case"Uint16Array":return 5;case"Int32Array":return 6;case"Uint32Array":return 7;case"Float32Array":return 8;case"Float64Array":return 9;case"BigInt64Array":return 10;case"BigUint64Array":return 11}}function F(C,_){const P=_.map(n=>{const f=new ArrayBuffer(n.byteLength);return new Uint8Array(f).set(n.buffer),f}),t=_.length?(n,f)=>{if(typeof f=="object"&&f.$$vscode_array_buffer_reference$$){const a=f,{index:l}=a,w=P[l];if(a.view)switch(a.view.type){case 1:return new Int8Array(w,a.view.byteOffset,a.view.byteLength/Int8Array.BYTES_PER_ELEMENT);case 2:return new Uint8Array(w,a.view.byteOffset,a.view.byteLength/Uint8Array.BYTES_PER_ELEMENT);case 3:return new Uint8ClampedArray(w,a.view.byteOffset,a.view.byteLength/Uint8ClampedArray.BYTES_PER_ELEMENT);case 4:return new Int16Array(w,a.view.byteOffset,a.view.byteLength/Int16Array.BYTES_PER_ELEMENT);case 5:return new Uint16Array(w,a.view.byteOffset,a.view.byteLength/Uint16Array.BYTES_PER_ELEMENT);case 6:return new Int32Array(w,a.view.byteOffset,a.view.byteLength/Int32Array.BYTES_PER_ELEMENT);case 7:return new Uint32Array(w,a.view.byteOffset,a.view.byteLength/Uint32Array.BYTES_PER_ELEMENT);case 8:return new Float32Array(w,a.view.byteOffset,a.view.byteLength/Float32Array.BYTES_PER_ELEMENT);case 9:return new Float64Array(w,a.view.byteOffset,a.view.byteLength/Float64Array.BYTES_PER_ELEMENT);case 10:return new BigInt64Array(w,a.view.byteOffset,a.view.byteLength/BigInt64Array.BYTES_PER_ELEMENT);case 11:return new BigUint64Array(w,a.view.byteOffset,a.view.byteLength/BigUint64Array.BYTES_PER_ELEMENT);default:throw new Error("Unknown array buffer view type")}return w}return f}:void 0;return{message:JSON.parse(C,t),arrayBuffers:P}}e.deserializeWebviewMessage=F}),define(we[158],Ee([0,1]),function(re,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TreeDataTransferConverter=void 0;var c;(function(M){function b(F){const C={items:new Map};return F.types.forEach((_,P)=>{C.items.set(_,{asString:async()=>F.items[P].asString})}),C}M.toITreeDataTransfer=b;async function R(F){const C={types:[],items:[]},_=Array.from(F.items.entries());for(const P of _)C.types.push(P[0]),C.items.push({asString:await P[1].asString()});return C}M.toTreeDataTransferDTO=R})(c=e.TreeDataTransferConverter||(e.TreeDataTransferConverter={}))}),define(we[66],Ee([0,1,11,2]),function(re,e,c,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.decodeAuthority=e.asWebviewUri=e.webviewGenericCspSource=e.webviewRootResourceAuthority=e.webviewResourceBaseHost=void 0,e.webviewResourceBaseHost="vscode-webview.net",e.webviewRootResourceAuthority=`vscode-resource.${e.webviewResourceBaseHost}`,e.webviewGenericCspSource=`https://*.${e.webviewResourceBaseHost}`;function b(C,_){return C.scheme===c.Schemas.http||C.scheme===c.Schemas.https?C:(_&&_.authority&&_.isRemote&&C.scheme===c.Schemas.file&&(C=M.URI.from({scheme:c.Schemas.vscodeRemote,authority:_.authority,path:C.path})),M.URI.from({scheme:c.Schemas.https,authority:`${C.scheme}+${R(C.authority)}.${e.webviewRootResourceAuthority}`,path:C.path,fragment:C.fragment,query:C.query}))}e.asWebviewUri=b;function R(C){return C.replace(/./g,_=>{const P=_.charCodeAt(0);return P>=97&&P<=122||P>=65&&P<=90||P>=48&&P<=57?_:"-"+P.toString(16).padStart(4,"0")})}function F(C){return C.replace(/-([0-9a-f]{4})/g,(_,P)=>String.fromCharCode(parseInt(P,16)))}e.decodeAuthority=F}),define(we[159],Ee([0,1,3,6,66]),function(re,e,c,M,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostEditorInsets=void 0;class R{constructor(C,_,P){this._proxy=C,this._editors=_,this._initData=P,this._handlePool=0,this._disposables=new M.DisposableStore,this._insets=new Map,this._disposables.add(_.onDidChangeVisibleTextEditors(()=>{const t=_.getVisibleTextEditors();for(const E of this._insets.values())t.indexOf(E.editor)<0&&E.inset.dispose()}))}dispose(){this._insets.forEach(C=>C.inset.dispose()),this._disposables.dispose()}createWebviewEditorInset(C,_,P,t,E){let n;for(const o of this._editors.getVisibleTextEditors(!0))if(o.value===C){n=o;break}if(!n)throw new Error("not a visible editor");const f=this,a=this._handlePool++,l=new c.Emitter,w=new c.Emitter,I=new class{constructor(){this._html="",this._options=Object.create(null)}asWebviewUri(o){return(0,b.asWebviewUri)(o,f._initData.remote)}get cspSource(){return b.webviewGenericCspSource}set options(o){this._options=o,f._proxy.$setOptions(a,o)}get options(){return this._options}set html(o){this._html=o,f._proxy.$setHtml(a,o)}get html(){return this._html}get onDidReceiveMessage(){return l.event}postMessage(o){return f._proxy.$postMessage(a,o)}},S=new class{constructor(){this.editor=C,this.line=_,this.height=P,this.webview=I,this.onDidDispose=w.event}dispose(){f._insets.has(a)&&(f._insets.delete(a),f._proxy.$disposeEditorInset(a),w.fire(),w.dispose(),l.dispose())}};return this._proxy.$createEditorInset(a,n.id,n.value.document.uri,_+1,P,t||{},E.identifier,E.extensionLocation),this._insets.set(a,{editor:C,inset:S,onDidReceiveMessage:l}),S}$onDidDispose(C){const _=this._insets.get(C);_&&_.inset.dispose()}$onDidReceiveMessage(C,_){const P=this._insets.get(C);P&&P.onDidReceiveMessage.fire(_)}}e.ExtHostEditorInsets=R}),define(we[160],Ee([0,1,131,10,2,6,4,45,28,12,11]),function(re,e,c,M,b,R,F,C,_,P,t){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.EditorsOrder=e.pathsToEditors=e.CloseDirection=e.EditorResourceAccessor=e.SideBySideEditor=e.EditorCloseContext=e.isEditorIdentifier=e.isEditorInputWithOptionsAndGroup=e.isEditorInputWithOptions=e.isDiffEditorInput=e.isSideBySideEditorInput=e.isEditorInput=e.AbstractEditorInput=e.EditorInputCapabilities=e.SaveReason=e.Verbosity=e.isUntitledResourceEditorInput=e.isResourceSideBySideEditorInput=e.isResourceDiffEditorInput=e.isResourceEditorInput=e.findViewStateForEditor=e.BINARY_DIFF_EDITOR_ID=e.TEXT_DIFF_EDITOR_ID=e.SIDE_BY_SIDE_EDITOR_ID=e.EditorAreaVisibleContext=e.SplitEditorsVertically=e.IsCenteredLayoutContext=e.InEditorZenModeContext=e.EditorsVisibleContext=e.SingleEditorGroupsContext=e.MultipleEditorGroupsContext=e.ActiveEditorGroupLockedContext=e.ActiveEditorGroupLastContext=e.ActiveEditorGroupIndexContext=e.ActiveEditorGroupEmptyContext=e.EditorGroupEditorsCountContext=e.SideBySideEditorActiveContext=e.TextCompareEditorActiveContext=e.TextCompareEditorVisibleContext=e.ActiveEditorAvailableEditorIdsContext=e.ActiveEditorContext=e.ActiveEditorCanSplitInGroupContext=e.ActiveEditorCanRevertContext=e.ActiveEditorReadonlyContext=e.ActiveEditorStickyContext=e.ActiveEditorPinnedContext=e.ActiveEditorDirtyContext=e.DEFAULT_EDITOR_ASSOCIATION=e.EditorExtensions=void 0,e.EditorExtensions={EditorPane:"workbench.contributions.editors",EditorFactory:"workbench.contributions.editor.inputFactories"},e.DEFAULT_EDITOR_ASSOCIATION={id:"default",displayName:(0,c.localize)(0,null),providerDisplayName:(0,c.localize)(1,null)},e.ActiveEditorDirtyContext=new C.RawContextKey("activeEditorIsDirty",!1,(0,c.localize)(2,null)),e.ActiveEditorPinnedContext=new C.RawContextKey("activeEditorIsNotPreview",!1,(0,c.localize)(3,null)),e.ActiveEditorStickyContext=new C.RawContextKey("activeEditorIsPinned",!1,(0,c.localize)(4,null)),e.ActiveEditorReadonlyContext=new C.RawContextKey("activeEditorIsReadonly",!1,(0,c.localize)(5,null)),e.ActiveEditorCanRevertContext=new C.RawContextKey("activeEditorCanRevert",!1,(0,c.localize)(6,null)),e.ActiveEditorCanSplitInGroupContext=new C.RawContextKey("activeEditorCanSplitInGroup",!0),e.ActiveEditorContext=new C.RawContextKey("activeEditor",null,{type:"string",description:(0,c.localize)(7,null)}),e.ActiveEditorAvailableEditorIdsContext=new C.RawContextKey("activeEditorAvailableEditorIds","",(0,c.localize)(8,null)),e.TextCompareEditorVisibleContext=new C.RawContextKey("textCompareEditorVisible",!1,(0,c.localize)(9,null)),e.TextCompareEditorActiveContext=new C.RawContextKey("textCompareEditorActive",!1,(0,c.localize)(10,null)),e.SideBySideEditorActiveContext=new C.RawContextKey("sideBySideEditorActive",!1,(0,c.localize)(11,null)),e.EditorGroupEditorsCountContext=new C.RawContextKey("groupEditorsCount",0,(0,c.localize)(12,null)),e.ActiveEditorGroupEmptyContext=new C.RawContextKey("activeEditorGroupEmpty",!1,(0,c.localize)(13,null)),e.ActiveEditorGroupIndexContext=new C.RawContextKey("activeEditorGroupIndex",0,(0,c.localize)(14,null)),e.ActiveEditorGroupLastContext=new C.RawContextKey("activeEditorGroupLast",!1,(0,c.localize)(15,null)),e.ActiveEditorGroupLockedContext=new C.RawContextKey("activeEditorGroupLocked",!1,(0,c.localize)(16,null)),e.MultipleEditorGroupsContext=new C.RawContextKey("multipleEditorGroups",!1,(0,c.localize)(17,null)),e.SingleEditorGroupsContext=e.MultipleEditorGroupsContext.toNegated(),e.EditorsVisibleContext=new C.RawContextKey("editorIsOpen",!1,(0,c.localize)(18,null)),e.InEditorZenModeContext=new C.RawContextKey("inZenMode",!1,(0,c.localize)(19,null)),e.IsCenteredLayoutContext=new C.RawContextKey("isCenteredLayout",!1,(0,c.localize)(20,null)),e.SplitEditorsVertically=new C.RawContextKey("splitEditorsVertically",!1,(0,c.localize)(21,null)),e.EditorAreaVisibleContext=new C.RawContextKey("editorAreaVisible",!0,(0,c.localize)(22,null)),e.SIDE_BY_SIDE_EDITOR_ID="workbench.editor.sidebysideEditor",e.TEXT_DIFF_EDITOR_ID="workbench.editors.textDiffEditor",e.BINARY_DIFF_EDITOR_ID="workbench.editors.binaryResourceDiffEditor";function E(A,L,V){for(const G of V.visibleEditorPanes)if(G.group.id===L&&A.matches(G.input))return G.getViewState()}e.findViewStateForEditor=E;function n(A){if(h(A))return!1;const L=A;return b.URI.isUri(L?.resource)}e.isResourceEditorInput=n;function f(A){if(h(A))return!1;const L=A;return L?.original!==void 0&&L.modified!==void 0}e.isResourceDiffEditorInput=f;function a(A){if(h(A)||f(A))return!1;const L=A;return L?.primary!==void 0&&L.secondary!==void 0}e.isResourceSideBySideEditorInput=a;function l(A){if(h(A))return!1;const L=A;return L?L.resource===void 0||L.resource.scheme===t.Schemas.untitled||L.forceUntitled===!0:!1}e.isUntitledResourceEditorInput=l;var w;(function(A){A[A.SHORT=0]="SHORT",A[A.MEDIUM=1]="MEDIUM",A[A.LONG=2]="LONG"})(w=e.Verbosity||(e.Verbosity={}));var I;(function(A){A[A.EXPLICIT=1]="EXPLICIT",A[A.AUTO=2]="AUTO",A[A.FOCUS_CHANGE=3]="FOCUS_CHANGE",A[A.WINDOW_CHANGE=4]="WINDOW_CHANGE"})(I=e.SaveReason||(e.SaveReason={}));var S;(function(A){A[A.None=0]="None",A[A.Readonly=2]="Readonly",A[A.Untitled=4]="Untitled",A[A.Singleton=8]="Singleton",A[A.RequiresTrust=16]="RequiresTrust",A[A.CanSplitInGroup=32]="CanSplitInGroup",A[A.ForceDescription=64]="ForceDescription"})(S=e.EditorInputCapabilities||(e.EditorInputCapabilities={}));class o extends R.Disposable{}e.AbstractEditorInput=o;function h(A){return A instanceof o}e.isEditorInput=h;function y(A){const L=A;return b.URI.isUri(L?.preferredResource)}function i(A){const L=A;return h(L?.primary)&&h(L?.secondary)}e.isSideBySideEditorInput=i;function v(A){const L=A;return h(L?.modified)&&h(L?.original)}e.isDiffEditorInput=v;function r(A){return h(A?.editor)}e.isEditorInputWithOptions=r;function s(A){const L=A;return r(A)&&L?.group!==void 0}e.isEditorInputWithOptionsAndGroup=s;function u(A){const L=A;return typeof L?.groupId=="number"&&h(L.editor)}e.isEditorIdentifier=u;var d;(function(A){A[A.UNKNOWN=0]="UNKNOWN",A[A.REPLACE=1]="REPLACE",A[A.MOVE=2]="MOVE",A[A.UNPIN=3]="UNPIN"})(d=e.EditorCloseContext||(e.EditorCloseContext={}));var p;(function(A){A[A.PRIMARY=1]="PRIMARY",A[A.SECONDARY=2]="SECONDARY",A[A.BOTH=3]="BOTH",A[A.ANY=4]="ANY"})(p=e.SideBySideEditor||(e.SideBySideEditor={}));class k{getOriginalUri(L,V){if(!L)return;if(V?.supportSideBySide){const{primary:U,secondary:K}=this.getSideEditors(L);if(U&&K){if(V?.supportSideBySide===p.BOTH)return{primary:this.getOriginalUri(U,{filterByScheme:V.filterByScheme}),secondary:this.getOriginalUri(K,{filterByScheme:V.filterByScheme})};if(V?.supportSideBySide===p.ANY)return this.getOriginalUri(U,{filterByScheme:V.filterByScheme})??this.getOriginalUri(K,{filterByScheme:V.filterByScheme});L=V.supportSideBySide===p.PRIMARY?U:K}}if(f(L)||a(L))return;const G=y(L)?L.preferredResource:L.resource;return!G||!V||!V.filterByScheme?G:this.filterUri(G,V.filterByScheme)}getSideEditors(L){return i(L)||a(L)?{primary:L.primary,secondary:L.secondary}:v(L)||f(L)?{primary:L.modified,secondary:L.original}:{primary:void 0,secondary:void 0}}getCanonicalUri(L,V){if(!L)return;if(V?.supportSideBySide){const{primary:U,secondary:K}=this.getSideEditors(L);if(U&&K){if(V?.supportSideBySide===p.BOTH)return{primary:this.getCanonicalUri(U,{filterByScheme:V.filterByScheme}),secondary:this.getCanonicalUri(K,{filterByScheme:V.filterByScheme})};if(V?.supportSideBySide===p.ANY)return this.getCanonicalUri(U,{filterByScheme:V.filterByScheme})??this.getCanonicalUri(K,{filterByScheme:V.filterByScheme});L=V.supportSideBySide===p.PRIMARY?U:K}}if(f(L)||a(L))return;const G=L.resource;return!G||!V||!V.filterByScheme?G:this.filterUri(G,V.filterByScheme)}filterUri(L,V){if(Array.isArray(V)){if(V.some(G=>L.scheme===G))return L}else if(V===L.scheme)return L}}e.EditorResourceAccessor=new k;var T;(function(A){A[A.LEFT=0]="LEFT",A[A.RIGHT=1]="RIGHT"})(T=e.CloseDirection||(e.CloseDirection={}));class g{constructor(){this.editorSerializerConstructors=new Map,this.editorSerializerInstances=new Map}start(L){const V=this.instantiationService=L.get(F.IInstantiationService);for(const[G,U]of this.editorSerializerConstructors)this.createEditorSerializer(G,U,V);this.editorSerializerConstructors.clear()}createEditorSerializer(L,V,G){const U=G.createInstance(V);this.editorSerializerInstances.set(L,U)}registerFileEditorFactory(L){if(this.fileEditorFactory)throw new Error("Can only register one file editor factory.");this.fileEditorFactory=L}getFileEditorFactory(){return(0,M.assertIsDefined)(this.fileEditorFactory)}registerEditorSerializer(L,V){if(this.editorSerializerConstructors.has(L)||this.editorSerializerInstances.has(L))throw new Error(`A editor serializer with type ID '${L}' was already registered.`);return this.instantiationService?this.createEditorSerializer(L,V,this.instantiationService):this.editorSerializerConstructors.set(L,V),(0,R.toDisposable)(()=>{this.editorSerializerConstructors.delete(L),this.editorSerializerInstances.delete(L)})}getEditorSerializer(L){return this.editorSerializerInstances.get(typeof L=="string"?L:L.typeId)}}_.Registry.add(e.EditorExtensions.EditorFactory,new g);async function D(A,L){if(!A||!A.length)return[];const V=await Promise.all(A.map(async G=>{const U=b.URI.revive(G.fileUri);if(!U||(await L.activateProvider(U.scheme),!L.canHandleResource(U)))return;const K=typeof G.exists=="boolean"?G.exists:await L.exists(U);if(!K&&G.openOnlyIfExists)return;const $={selection:K?G.selection:void 0,pinned:!0,override:G.editorOverrideId};let B;return K?B={resource:U,options:$}:B={resource:U,options:$,forceUntitled:!0},B}));return(0,P.coalesce)(V)}e.pathsToEditors=D;var m;(function(A){A[A.MOST_RECENTLY_ACTIVE=0]="MOST_RECENTLY_ACTIVE",A[A.SEQUENTIAL=1]="SEQUENTIAL"})(m=e.EditorsOrder||(e.EditorsOrder={}))}),define(we[161],Ee([0,1,3,45,132,4,6,20,28,12,51,23,34,151]),function(re,e,c,M,b,R,F,C,_,P,t,E,n,f){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TREE_ITEM_DATA_TRANSFER_TYPE=e.ResolvableTreeItem=e.TreeItemCollapsibleState=e.ViewVisibilityState=e.IViewDescriptorService=e.getVisbileViewContextKey=e.FocusedViewContext=e.IViewsService=e.ViewContentGroups=e.getEnabledViewContainerContextKey=e.ViewContainerLocationToString=e.ViewContainerLocations=e.ViewContainerLocation=e.Extensions=e.defaultViewIcon=void 0,e.defaultViewIcon=(0,f.registerIcon)("default-view-icon",n.Codicon.window,(0,b.localize)(0,null));var a;(function(u){u.ViewContainersRegistry="workbench.registry.view.containers",u.ViewsRegistry="workbench.registry.view"})(a=e.Extensions||(e.Extensions={}));var l;(function(u){u[u.Sidebar=0]="Sidebar",u[u.Panel=1]="Panel",u[u.AuxiliaryBar=2]="AuxiliaryBar"})(l=e.ViewContainerLocation||(e.ViewContainerLocation={})),e.ViewContainerLocations=[0,1,2];function w(u){switch(u){case 0:return"sidebar";case 1:return"panel";case 2:return"auxiliarybar"}}e.ViewContainerLocationToString=w;function I(u){return`viewContainer.${u}.enabled`}e.getEnabledViewContainerContextKey=I;class S extends F.Disposable{constructor(){super(...arguments);this._onDidRegister=this._register(new c.Emitter),this.onDidRegister=this._onDidRegister.event,this._onDidDeregister=this._register(new c.Emitter),this.onDidDeregister=this._onDidDeregister.event,this.viewContainers=new Map,this.defaultViewContainers=[]}get all(){return(0,P.flatten)([...this.viewContainers.values()])}registerViewContainer(d,p,k){const T=this.get(d.id);if(T)return T;const g=d;return g.openCommandActionDescriptor=k?.donotRegisterOpenCommand?void 0:g.openCommandActionDescriptor??{id:g.id},(0,C.getOrSet)(this.viewContainers,p,[]).push(g),k?.isDefault&&this.defaultViewContainers.push(g),this._onDidRegister.fire({viewContainer:g,viewContainerLocation:p}),g}deregisterViewContainer(d){for(const p of this.viewContainers.keys()){const k=this.viewContainers.get(p),T=k?.indexOf(d);if(T!==-1){k?.splice(T,1),k.length===0&&this.viewContainers.delete(p),this._onDidDeregister.fire({viewContainer:d,viewContainerLocation:p});return}}}get(d){return this.all.filter(p=>p.id===d)[0]}getViewContainers(d){return[...this.viewContainers.get(d)||[]]}getViewContainerLocation(d){return[...this.viewContainers.keys()].filter(p=>this.getViewContainers(p).filter(k=>k?.id===d.id).length>0)[0]}getDefaultViewContainer(d){return this.defaultViewContainers.find(p=>this.getViewContainerLocation(p)===d)}}_.Registry.add(a.ViewContainersRegistry,new S);var o;(function(u){u.Open="2_open",u.Debug="4_debug",u.SCM="5_scm",u.More="9_more"})(o=e.ViewContentGroups||(e.ViewContentGroups={}));function h(u,d){const p=u.group??o.More,k=d.group??o.More;return p!==k?p.localeCompare(k):(u.order??5)-(d.order??5)}class y extends F.Disposable{constructor(){super(...arguments);this._onViewsRegistered=this._register(new c.Emitter),this.onViewsRegistered=this._onViewsRegistered.event,this._onViewsDeregistered=this._register(new c.Emitter),this.onViewsDeregistered=this._onViewsDeregistered.event,this._onDidChangeContainer=this._register(new c.Emitter),this.onDidChangeContainer=this._onDidChangeContainer.event,this._onDidChangeViewWelcomeContent=this._register(new c.Emitter),this.onDidChangeViewWelcomeContent=this._onDidChangeViewWelcomeContent.event,this._viewContainers=[],this._views=new Map,this._viewWelcomeContents=new t.SetMap}registerViews(d,p){this.registerViews2([{views:d,viewContainer:p}])}registerViews2(d){d.forEach(({views:p,viewContainer:k})=>this.addViews(p,k)),this._onViewsRegistered.fire(d)}deregisterViews(d,p){const k=this.removeViews(d,p);k.length&&this._onViewsDeregistered.fire({views:k,viewContainer:p})}moveViews(d,p){for(const k of this._views.keys())if(k!==p){const T=this.removeViews(d,k);T.length&&(this.addViews(T,p),this._onDidChangeContainer.fire({views:T,from:k,to:p}))}}getViews(d){return this._views.get(d)||[]}getView(d){for(const p of this._viewContainers){const k=(this._views.get(p)||[]).filter(T=>T.id===d)[0];if(k)return k}return null}getViewContainer(d){for(const p of this._viewContainers)if((this._views.get(p)||[]).filter(T=>T.id===d)[0])return p;return null}registerViewWelcomeContent(d,p){return this._viewWelcomeContents.add(d,p),this._onDidChangeViewWelcomeContent.fire(d),(0,F.toDisposable)(()=>{this._viewWelcomeContents.delete(d,p),this._onDidChangeViewWelcomeContent.fire(d)})}registerViewWelcomeContent2(d,p){const k=new Map;for(const[T,g]of p)this._viewWelcomeContents.add(d,g),k.set(T,(0,F.toDisposable)(()=>{this._viewWelcomeContents.delete(d,g),this._onDidChangeViewWelcomeContent.fire(d)}));return this._onDidChangeViewWelcomeContent.fire(d),k}getViewWelcomeContent(d){const p=[];return this._viewWelcomeContents.forEach(d,k=>p.push(k)),p.sort(h)}addViews(d,p){let k=this._views.get(p);k||(k=[],this._views.set(p,k),this._viewContainers.push(p));for(const T of d){if(this.getView(T.id)!==null)throw new Error((0,b.localize)(1,null,T.id));k.push(T)}}removeViews(d,p){const k=this._views.get(p);if(!k)return[];const T=[],g=[];for(const D of k)d.includes(D)?T.push(D):g.push(D);return T.length&&(g.length?this._views.set(p,g):(this._views.delete(p),this._viewContainers.splice(this._viewContainers.indexOf(p),1))),T}}_.Registry.add(a.ViewsRegistry,new y),e.IViewsService=(0,R.createDecorator)("viewsService"),e.FocusedViewContext=new M.RawContextKey("focusedView","",(0,b.localize)(2,null));function i(u){return`view.${u}.visible`}e.getVisbileViewContextKey=i,e.IViewDescriptorService=(0,R.createDecorator)("viewDescriptorService");var v;(function(u){u[u.Default=0]="Default",u[u.Expand=1]="Expand"})(v=e.ViewVisibilityState||(e.ViewVisibilityState={}));var r;(function(u){u[u.None=0]="None",u[u.Collapsed=1]="Collapsed",u[u.Expanded=2]="Expanded"})(r=e.TreeItemCollapsibleState||(e.TreeItemCollapsibleState={}));class s{constructor(d,p){this.resolved=!1,this._hasResolve=!1,(0,E.mixin)(this,d),this._hasResolve=!!p,this.resolve=async k=>{if(p&&!this.resolved){const T=await p(k);T&&(this.tooltip=this.tooltip??T.tooltip,this.command=this.command??T.command)}k.isCancellationRequested||(this.resolved=!0)}}get hasResolve(){return this._hasResolve}resetResolve(){this.resolved=!1}asTreeItem(){return{handle:this.handle,parentHandle:this.parentHandle,collapsibleState:this.collapsibleState,label:this.label,description:this.description,icon:this.icon,iconDark:this.iconDark,themeIcon:this.themeIcon,resourceUri:this.resourceUri,tooltip:this.tooltip,contextValue:this.contextValue,command:this.command,children:this.children,accessibilityInformation:this.accessibilityInformation}}}e.ResolvableTreeItem=s,e.TREE_ITEM_DATA_TRANSFER_TYPE="text/treeitems"}),define(we[162],Ee([0,1,3,14,133]),function(re,e,c,M,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.AbstractDebugAdapter=void 0;class R{constructor(){this.pendingRequests=new Map,this.queue=[],this._onError=new c.Emitter,this._onExit=new c.Emitter,this.sequence=1}get onError(){return this._onError.event}get onExit(){return this._onExit.event}onMessage(C){this.messageCallback&&this._onError.fire(new Error("attempt to set more than one 'Message' callback")),this.messageCallback=C}onEvent(C){this.eventCallback&&this._onError.fire(new Error("attempt to set more than one 'Event' callback")),this.eventCallback=C}onRequest(C){this.requestCallback&&this._onError.fire(new Error("attempt to set more than one 'Request' callback")),this.requestCallback=C}sendResponse(C){C.seq>0?this._onError.fire(new Error(`attempt to send more than one response for command ${C.command}`)):this.internalSend("response",C)}sendRequest(C,_,P,t){const E={command:C};if(_&&Object.keys(_).length>0&&(E.arguments=_),this.internalSend("request",E),typeof t=="number"){const n=setTimeout(()=>{clearTimeout(n);const f=this.pendingRequests.get(E.seq);if(f){this.pendingRequests.delete(E.seq);const a={type:"response",seq:0,request_seq:E.seq,success:!1,command:C,message:(0,b.localize)(0,null,t,C)};f(a)}},t)}return P&&this.pendingRequests.set(E.seq,P),E.seq}acceptMessage(C){this.messageCallback?this.messageCallback(C):(this.queue.push(C),this.queue.length===1&&this.processQueue())}needsTaskBoundaryBetween(C,_){return C.type!=="event"||_.type!=="event"}async processQueue(){let C;for(;this.queue.length;){if((!C||this.needsTaskBoundaryBetween(this.queue[0],C))&&await(0,M.timeout)(0),C=this.queue.shift(),!C)return;switch(C.type){case"event":this.eventCallback&&this.eventCallback(C);break;case"request":this.requestCallback&&this.requestCallback(C);break;case"response":const _=C,P=this.pendingRequests.get(_.request_seq);P&&(this.pendingRequests.delete(_.request_seq),P(_));break}}}internalSend(C,_){_.type=C,_.seq=this.sequence++,this.sendMessage(_)}async cancelPendingRequests(){if(this.pendingRequests.size===0)return Promise.resolve();const C=new Map;this.pendingRequests.forEach((_,P)=>C.set(P,_)),await(0,M.timeout)(500),C.forEach((_,P)=>{_({type:"response",seq:0,request_seq:P,success:!1,command:"canceled",message:"canceled"}),this.pendingRequests.delete(P)})}getPendingRequestIds(){return Array.from(this.pendingRequests.keys())}dispose(){this.queue=[]}}e.AbstractDebugAdapter=R}),define(we[163],Ee([0,1,9,2,17,23,11]),function(re,e,c,M,b,R,F){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.saveAllBeforeDebugStart=e.getVisibleAndSorted=e.convertToVSCPaths=e.convertToDAPaths=e.isUri=e.getExactExpressionStartAndEnd=e.isDebuggerMainContribution=e.getExtensionHostDebugSession=e.isSessionAttach=e.filterExceptionsFromTelemetry=e.formatPII=void 0;const C=/{([^}]+)}/g;function _(r,s,u){return r.replace(C,function(d,p){return s&&p.length>0&&p[0]!=="_"?d:u&&u.hasOwnProperty(p)?u[p]:d})}e.formatPII=_;function P(r){const s={};for(const u of Object.keys(r))u.startsWith("!")||(s[u]=r[u]);return s}e.filterExceptionsFromTelemetry=P;function t(r){return r.configuration.request==="attach"&&!E(r)&&(!r.parentSession||t(r.parentSession))}e.isSessionAttach=t;function E(r){let s=r.configuration.type;if(!!s)return s==="vslsShare"&&(s=r.configuration.adapterProxy.configuration.type),(0,c.equalsIgnoreCase)(s,"extensionhost")||(0,c.equalsIgnoreCase)(s,"pwa-extensionhost")?r:r.parentSession?E(r.parentSession):void 0}e.getExtensionHostDebugSession=E;function n(r){return r.type&&(r.label||r.program||r.runtime)}e.isDebuggerMainContribution=n;function f(r,s,u){let d,p=0,k=/([^()\[\]{}<>\s+\-/%~#^;=|,`!]|\->)+/g,T=null;for(;T=k.exec(r);){let g=T.index+1,D=g+T[0].length;if(g<=s&&D>=u){d=T[0],p=g;break}}if(d){let g=/\w+/g,D=null;for(;(D=g.exec(d))&&!(D.index+1+p+D[0].length>=u););D&&(d=d.substring(0,g.lastIndex))}return d?{start:p,end:p+d.length-1}:{start:0,end:0}}e.getExactExpressionStartAndEnd=f;const a=/^[a-zA-Z][a-zA-Z0-9\+\-\.]+:/;function l(r){return!!(r&&r.match(a))}e.isUri=l;function w(r){if(typeof r.path=="string"&&!(typeof r.sourceReference=="number"&&r.sourceReference>0)){if(l(r.path))return M.URI.parse(r.path);if((0,b.isAbsolute)(r.path))return M.URI.file(r.path)}return r.path}function I(r){if(typeof r.path=="object"){const s=M.URI.revive(r.path);if(s)return s.scheme===F.Schemas.file?s.fsPath:s.toString()}return r.path}function S(r,s){const u=s?w:I,d=(0,R.deepClone)(r);return h(d,(p,k)=>{p&&k&&(k.path=u(k))}),d}e.convertToDAPaths=S;function o(r,s){const u=s?w:I,d=(0,R.deepClone)(r);return h(d,(p,k)=>{!p&&k&&(k.path=u(k))}),d}e.convertToVSCPaths=o;function h(r,s){switch(r.type){case"event":const u=r;switch(u.event){case"output":s(!1,u.body.source);break;case"loadedSource":s(!1,u.body.source);break;case"breakpoint":s(!1,u.body.breakpoint.source);break;default:break}break;case"request":const d=r;switch(d.command){case"setBreakpoints":s(!0,d.arguments.source);break;case"breakpointLocations":s(!0,d.arguments.source);break;case"source":s(!0,d.arguments.source);break;case"gotoTargets":s(!0,d.arguments.source);break;case"launchVSCode":d.arguments.args.forEach(k=>s(!1,k));break;default:break}break;case"response":const p=r;if(p.success&&p.body)switch(p.command){case"stackTrace":p.body.stackFrames.forEach(k=>s(!1,k.source));break;case"loadedSources":p.body.sources.forEach(k=>s(!1,k));break;case"scopes":p.body.scopes.forEach(k=>s(!1,k.source));break;case"setFunctionBreakpoints":p.body.breakpoints.forEach(k=>s(!1,k.source));break;case"setBreakpoints":p.body.breakpoints.forEach(k=>s(!1,k.source));break;default:break}break}}function y(r){return r.filter(s=>!s.presentation?.hidden).sort((s,u)=>s.presentation?u.presentation?s.presentation.group?u.presentation.group?s.presentation.group!==u.presentation.group?s.presentation.group.localeCompare(u.presentation.group):i(s.presentation.order,u.presentation.order):-1:u.presentation.group?1:i(s.presentation.order,u.presentation.order):-1:u.presentation?1:0)}e.getVisibleAndSorted=y;function i(r,s){return typeof r!="number"?typeof s!="number"?0:1:typeof s!="number"?-1:r-s}async function v(r,s){const u=r.getValue("debug.saveBeforeStart",{overrideIdentifier:s.activeTextEditorMode});if(u!=="none"&&(await s.saveAll(),u==="allEditorsInActiveGroup")){const d=s.activeEditorPane;d&&await s.save({editor:d.input,groupId:d.group.id})}await r.reloadConfiguration()}e.saveAllBeforeDebugStart=v}),define(we[89],Ee([0,1,27,78,11,17,26,45]),function(re,e,c,M,b,R,F,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.NotebookWorkingCopyTypeIdentifier=e.CellStatusbarAlignment=e.GlobalToolbarShowLabel=e.TextOutputLineLimit=e.OpenGettingStarted=e.ConsolidatedRunButton=e.NotebookCellEditorOptionsCustomizations=e.DragAndDropEnabled=e.ShowFoldingControls=e.ConsolidatedOutputButton=e.UndoRedoPerCell=e.GlobalToolbar=e.InsertToolbarLocation=e.FocusIndicator=e.CompactView=e.ExperimentalInsertToolbarAlignment=e.NotebookTextDiffEditorPreview=e.ShowCellStatusBar=e.CellToolbarVisibility=e.CellToolbarLocation=e.DisplayOrderKey=e.CellSequence=e.notebookDocumentFilterMatch=e.isDocumentExcludePattern=e.NotebookEditorPriority=e.NOTEBOOK_EDITOR_CURSOR_BOUNDARY=e.diff=e.sortMimeTypes=e.mimeTypeIsMergeable=e.mimeTypeSupportedByCore=e.mimeTypeIsAlwaysSecure=e.CellUri=e.CellEditType=e.SelectionStateType=e.NotebookCellsChangeType=e.RendererMessagingSpec=e.NotebookRendererMatch=e.NotebookCellExecutionState=e.NotebookRunState=e.RENDERER_NOT_AVAILABLE=e.BUILTIN_RENDERER_ID=e.ACCESSIBLE_NOTEBOOK_DISPLAY_ORDER=e.NOTEBOOK_DISPLAY_ORDER=e.CellKind=void 0;var _;(function(g){g[g.Markup=1]="Markup",g[g.Code=2]="Code"})(_=e.CellKind||(e.CellKind={})),e.NOTEBOOK_DISPLAY_ORDER=["application/json","application/javascript","text/html","image/svg+xml",M.Mimes.markdown,"image/png","image/jpeg",M.Mimes.text],e.ACCESSIBLE_NOTEBOOK_DISPLAY_ORDER=[M.Mimes.markdown,"application/json",M.Mimes.text,"text/html","image/svg+xml","image/png","image/jpeg"],e.BUILTIN_RENDERER_ID="_builtin",e.RENDERER_NOT_AVAILABLE="_notAvailable";var P;(function(g){g[g.Running=1]="Running",g[g.Idle=2]="Idle"})(P=e.NotebookRunState||(e.NotebookRunState={}));var t;(function(g){g[g.Pending=2]="Pending",g[g.Executing=3]="Executing"})(t=e.NotebookCellExecutionState||(e.NotebookCellExecutionState={}));var E;(function(g){g[g.WithHardKernelDependency=0]="WithHardKernelDependency",g[g.WithOptionalKernelDependency=1]="WithOptionalKernelDependency",g[g.Pure=2]="Pure",g[g.Never=3]="Never"})(E=e.NotebookRendererMatch||(e.NotebookRendererMatch={}));var n;(function(g){g.Always="always",g.Never="never",g.Optional="optional"})(n=e.RendererMessagingSpec||(e.RendererMessagingSpec={}));var f;(function(g){g[g.ModelChange=1]="ModelChange",g[g.Move=2]="Move",g[g.ChangeLanguage=5]="ChangeLanguage",g[g.Initialize=6]="Initialize",g[g.ChangeCellMetadata=7]="ChangeCellMetadata",g[g.Output=8]="Output",g[g.OutputItem=9]="OutputItem",g[g.ChangeCellContent=10]="ChangeCellContent",g[g.ChangeDocumentMetadata=11]="ChangeDocumentMetadata",g[g.ChangeCellInternalMetadata=12]="ChangeCellInternalMetadata",g[g.ChangeCellMime=13]="ChangeCellMime",g[g.Unknown=100]="Unknown"})(f=e.NotebookCellsChangeType||(e.NotebookCellsChangeType={}));var a;(function(g){g[g.Handle=0]="Handle",g[g.Index=1]="Index"})(a=e.SelectionStateType||(e.SelectionStateType={}));var l;(function(g){g[g.Replace=1]="Replace",g[g.Output=2]="Output",g[g.Metadata=3]="Metadata",g[g.CellLanguage=4]="CellLanguage",g[g.DocumentMetadata=5]="DocumentMetadata",g[g.Move=6]="Move",g[g.OutputItems=7]="OutputItems",g[g.PartialMetadata=8]="PartialMetadata",g[g.PartialInternalMetadata=9]="PartialInternalMetadata"})(l=e.CellEditType||(e.CellEditType={}));var w;(function(g){g.scheme=b.Schemas.vscodeNotebookCell;const D=/^ch(\d{7,})/;function m(U,K){return U.with({scheme:g.scheme,fragment:`ch${K.toString().padStart(7,"0")}${U.scheme!==b.Schemas.file?U.scheme:""}`})}g.generate=m;function A(U){if(U.scheme!==g.scheme)return;const K=D.exec(U.fragment);return K?{handle:Number(K[1]),notebook:U.with({scheme:U.fragment.substr(K[0].length)||b.Schemas.file,fragment:null})}:void 0}g.parse=A;function L(U){if(U.scheme!==b.Schemas.vscodeNotebookCellMetadata)return;const K=D.exec(U.fragment);return K?{handle:Number(K[1]),notebook:U.with({scheme:U.fragment.substr(K[0].length)||b.Schemas.file,fragment:null})}:void 0}g.parseCellMetadataUri=L;function V(U,K,$){return U.with({scheme:$,fragment:`ch${K.toString().padStart(7,"0")}${U.scheme!==b.Schemas.file?U.scheme:""}`})}g.generateCellUri=V;function G(U,K){if(U.scheme!==K)return;const $=D.exec(U.fragment);return $?{handle:Number($[1]),notebook:U.with({scheme:U.fragment.substr($[0].length)||b.Schemas.file,fragment:null})}:void 0}g.parseCellUri=G})(w=e.CellUri||(e.CellUri={}));const I=new Map([["application/javascript",{supportedByCore:!0}],["image/png",{alwaysSecure:!0,supportedByCore:!0}],["image/jpeg",{alwaysSecure:!0,supportedByCore:!0}],["image/git",{alwaysSecure:!0,supportedByCore:!0}],["image/svg+xml",{supportedByCore:!0}],["application/json",{alwaysSecure:!0,supportedByCore:!0}],[M.Mimes.markdown,{alwaysSecure:!0,supportedByCore:!0}],[M.Mimes.text,{alwaysSecure:!0,supportedByCore:!0}],["text/html",{supportedByCore:!0}],["text/x-javascript",{alwaysSecure:!0,supportedByCore:!0}],["application/vnd.code.notebook.error",{alwaysSecure:!0,supportedByCore:!0}],["application/vnd.code.notebook.stdout",{alwaysSecure:!0,supportedByCore:!0,mergeable:!0}],["application/vnd.code.notebook.stderr",{alwaysSecure:!0,supportedByCore:!0,mergeable:!0}]]);function S(g){return I.get(g)?.alwaysSecure??!1}e.mimeTypeIsAlwaysSecure=S;function o(g){return I.get(g)?.supportedByCore??!1}e.mimeTypeSupportedByCore=o;function h(g){return I.get(g)?.mergeable??!1}e.mimeTypeIsMergeable=h;function y(g,D){return F.isWindows&&(g=g.replace(/\//g,"\\"),D=D.replace(/\//g,"\\")),c.match(g,D)}function i(g,D,m){let A=0;for(let L=0;L<D.length;L++){if(y(D[L],g))return A;A++}for(let L=0;L<m.length;L++){if(y(m[L],g))return A;A++}return A}function v(g,D,m){return g.sort((A,L)=>i(A,D,m)-i(L,D,m))}e.sortMimeTypes=v;function r(g,D,m,A=(L,V)=>L===V){const L=[];function V(K,$,B){if($===0&&B.length===0)return;const z=L[L.length-1];z&&z.start+z.deleteCount===K?(z.deleteCount+=$,z.toInsert.push(...B)):L.push({start:K,deleteCount:$,toInsert:B})}let G=0,U=0;for(;;){if(G===g.length){V(G,0,D.slice(U));break}if(U===D.length){V(G,g.length-G,[]);break}const K=g[G],$=D[U];if(A(K,$)){G+=1,U+=1;continue}m($)?(V(G,1,[]),G+=1):(V(G,0,[$]),U+=1)}return L}e.diff=r,e.NOTEBOOK_EDITOR_CURSOR_BOUNDARY=new C.RawContextKey("notebookEditorCursorAtBoundary","none");var s;(function(g){g.default="default",g.option="option"})(s=e.NotebookEditorPriority||(e.NotebookEditorPriority={}));function u(g){const D=g;return!!((typeof D.include=="string"||c.isRelativePattern(D.include))&&(typeof D.exclude=="string"||c.isRelativePattern(D.exclude)))}e.isDocumentExcludePattern=u;function d(g,D,m){if(Array.isArray(g.viewType)&&g.viewType.indexOf(D)>=0||g.viewType===D)return!0;if(g.filenamePattern){let A=u(g.filenamePattern)?g.filenamePattern.include:g.filenamePattern,L=u(g.filenamePattern)?g.filenamePattern.exclude:void 0;if(c.match(A,(0,R.basename)(m.fsPath).toLowerCase()))return!(L&&c.match(L,(0,R.basename)(m.fsPath).toLowerCase()))}return!1}e.notebookDocumentFilterMatch=d;class p{constructor(D){this.textModel=D}getElements(){const D=new Int32Array(this.textModel.cells.length);for(let m=0;m<this.textModel.cells.length;m++)D[m]=this.textModel.cells[m].getHashValue();return D}}e.CellSequence=p,e.DisplayOrderKey="notebook.displayOrder",e.CellToolbarLocation="notebook.cellToolbarLocation",e.CellToolbarVisibility="notebook.cellToolbarVisibility",e.ShowCellStatusBar="notebook.showCellStatusBar",e.NotebookTextDiffEditorPreview="notebook.diff.enablePreview",e.ExperimentalInsertToolbarAlignment="notebook.experimental.insertToolbarAlignment",e.CompactView="notebook.compactView",e.FocusIndicator="notebook.cellFocusIndicator",e.InsertToolbarLocation="notebook.insertToolbarLocation",e.GlobalToolbar="notebook.globalToolbar",e.UndoRedoPerCell="notebook.undoRedoPerCell",e.ConsolidatedOutputButton="notebook.consolidatedOutputButton",e.ShowFoldingControls="notebook.showFoldingControls",e.DragAndDropEnabled="notebook.dragAndDropEnabled",e.NotebookCellEditorOptionsCustomizations="notebook.editorOptionsCustomizations",e.ConsolidatedRunButton="notebook.consolidatedRunButton",e.OpenGettingStarted="notebook.experimental.openGettingStarted",e.TextOutputLineLimit="notebook.output.textLineLimit",e.GlobalToolbarShowLabel="notebook.globalToolbarShowLabel";var k;(function(g){g[g.Left=1]="Left",g[g.Right=2]="Right"})(k=e.CellStatusbarAlignment||(e.CellStatusbarAlignment={}));class T{static create(D){return`${T._prefix}${D}`}static parse(D){if(D.startsWith(T._prefix))return D.substr(T._prefix.length)}}e.NotebookWorkingCopyTypeIdentifier=T,T._prefix="notebook/"}),define(we[164],Ee([0,1,4]),function(re,e,c){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.INotebookExecutionService=e.CellExecutionUpdateType=void 0;var M;(function(b){b[b.Output=1]="Output",b[b.OutputItems=2]="OutputItems",b[b.ExecutionState=3]="ExecutionState",b[b.Complete=4]="Complete"})(M=e.CellExecutionUpdateType||(e.CellExecutionUpdateType={})),e.INotebookExecutionService=(0,c.createDecorator)("INotebookExecutionService")}),define(we[165],Ee([0,1,135,4,45]),function(re,e,c,M,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.USER_TASKS_GROUP_KEY=e.ITaskService=e.ProcessExecutionSupportedContext=e.ShellExecutionSupportedContext=e.CustomExecutionSupportedContext=void 0,e.CustomExecutionSupportedContext=new b.RawContextKey("customExecutionSupported",!0,c.localize(0,null)),e.ShellExecutionSupportedContext=new b.RawContextKey("shellExecutionSupported",!1,c.localize(1,null)),e.ProcessExecutionSupportedContext=new b.RawContextKey("processExecutionSupported",!1,c.localize(2,null)),e.ITaskService=(0,M.createDecorator)("taskService"),e.USER_TASKS_GROUP_KEY="settings"}),define(we[166],Ee([0,1]),function(re,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.deserializeEnvironmentVariableCollection=e.serializeEnvironmentVariableCollection=void 0;function c(b){return[...b.entries()]}e.serializeEnvironmentVariableCollection=c;function M(b){return new Map(b)}e.deserializeEnvironmentVariableCollection=M}),define(we[90],Ee([0,1]),function(re,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.AbstractIncrementalTestCollection=e.IncrementalChangeCollector=e.TestDiffOpType=e.DetailType=e.applyTestItemUpdate=e.TestItemExpandState=e.TestMessageType=e.testRunProfileBitsetList=e.TestRunProfileBitset=e.TestResultState=void 0;var c;(function(E){E[E.Unset=0]="Unset",E[E.Queued=1]="Queued",E[E.Running=2]="Running",E[E.Passed=3]="Passed",E[E.Failed=4]="Failed",E[E.Skipped=5]="Skipped",E[E.Errored=6]="Errored"})(c=e.TestResultState||(e.TestResultState={}));var M;(function(E){E[E.Run=2]="Run",E[E.Debug=4]="Debug",E[E.Coverage=8]="Coverage",E[E.HasNonDefaultProfile=16]="HasNonDefaultProfile",E[E.HasConfigurable=32]="HasConfigurable"})(M=e.TestRunProfileBitset||(e.TestRunProfileBitset={})),e.testRunProfileBitsetList=[2,4,8,16];var b;(function(E){E[E.Error=0]="Error",E[E.Info=1]="Info"})(b=e.TestMessageType||(e.TestMessageType={}));var R;(function(E){E[E.NotExpandable=0]="NotExpandable",E[E.Expandable=1]="Expandable",E[E.BusyExpanding=2]="BusyExpanding",E[E.Expanded=3]="Expanded"})(R=e.TestItemExpandState||(e.TestItemExpandState={}));const F=(E,n)=>{n.expand!==void 0&&(E.expand=n.expand),n.item!==void 0&&(E.item=E.item?Object.assign(E.item,n.item):n.item)};e.applyTestItemUpdate=F;var C;(function(E){E[E.Function=0]="Function",E[E.Statement=1]="Statement"})(C=e.DetailType||(e.DetailType={}));var _;(function(E){E[E.Add=0]="Add",E[E.Update=1]="Update",E[E.Remove=2]="Remove",E[E.IncrementPendingExtHosts=3]="IncrementPendingExtHosts",E[E.Retire=4]="Retire",E[E.AddTag=5]="AddTag",E[E.RemoveTag=6]="RemoveTag"})(_=e.TestDiffOpType||(e.TestDiffOpType={}));class P{add(n){}update(n){}remove(n,f){}complete(){}}e.IncrementalChangeCollector=P;class t{constructor(){this._tags=new Map,this.items=new Map,this.roots=new Set,this.busyControllerCount=0,this.pendingRootCount=0,this.tags=this._tags}apply(n){const f=this.createChangeCollector();for(const a of n)switch(a[0]){case 0:{const l=a[1];if(l.parent){if(this.items.has(l.parent)){const w=this.items.get(l.parent);w.children.add(l.item.extId);const I=this.createItem(l,w);this.items.set(l.item.extId,I),f.add(I)}}else{const w=this.createItem(l);this.roots.add(w),this.items.set(l.item.extId,w),f.add(w)}l.expand===2&&this.busyControllerCount++;break}case 1:{const l=a[1],w=this.items.get(l.extId);if(!w)break;l.expand!==void 0&&(w.expand===2&&this.busyControllerCount--,l.expand===2&&this.busyControllerCount++),(0,e.applyTestItemUpdate)(w,l),f.update(w);break}case 2:{const l=this.items.get(a[1]);if(!l)break;l.parent?this.items.get(l.parent).children.delete(l.item.extId):this.roots.delete(l);const w=[[a[1]]];for(;w.length;)for(const I of w.pop()){const S=this.items.get(I);S&&(w.push(S.children),this.items.delete(I),f.remove(S,S!==l),S.expand===2&&this.busyControllerCount--)}break}case 4:this.retireTest(a[1]);break;case 3:this.updatePendingRoots(a[1]);break;case 5:this._tags.set(a[1].id,a[1]);break;case 6:this._tags.delete(a[1]);break}f.complete()}retireTest(n){}updatePendingRoots(n){this.pendingRootCount+=n}createChangeCollector(){return new P}}e.AbstractIncrementalTestCollection=t}),define(we[67],Ee([0,1]),function(re,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TestId=e.TestPosition=e.TestIdPathParts=void 0;var c;(function(R){R.Delimiter="\0"})(c=e.TestIdPathParts||(e.TestIdPathParts={}));var M;(function(R){R[R.IsSame=0]="IsSame",R[R.Disconnected=1]="Disconnected",R[R.IsChild=2]="IsChild",R[R.IsParent=3]="IsParent"})(M=e.TestPosition||(e.TestPosition={}));class b{constructor(F,C=F.length){if(this.path=F,this.viewEnd=C,F.length===0||C<1)throw new Error("cannot create test with empty path")}static fromExtHostTestItem(F,C,_=F.parent){if(F.id===C)return new b([C]);let P=[F.id];for(let t=_;t&&t.id!==C;t=t.parent)P.push(t.id);return P.push(C),new b(P.reverse())}static isRoot(F){return!F.includes("\0")}static fromString(F){return new b(F.split("\0"))}static join(F,C){return new b([...F.path,C])}static joinToString(F,C){return F.toString()+"\0"+C}static compare(F,C){return F===C?0:C.startsWith(F+"\0")?2:F.startsWith(C+"\0")?3:1}get parentId(){return this.viewEnd>1?new b(this.path,this.viewEnd-1):this}get localId(){return this.path[this.viewEnd-1]}get controllerId(){return this.path[0]}get isRoot(){return this.viewEnd===1}*idsFromRoot(){for(let F=1;F<=this.viewEnd;F++)yield new b(this.path,F)}compare(F){if(typeof F=="string")return b.compare(this.toString(),F);for(let C=0;C<F.viewEnd&&C<this.viewEnd;C++)if(F.path[C]!==this.path[C])return 1;return F.viewEnd>this.viewEnd?2:F.viewEnd<this.viewEnd?3:0}toJSON(){return this.toString()}toString(){if(!this.stringifed){this.stringifed=this.path[0];for(let F=1;F<this.viewEnd;F++)this.stringifed+="\0",this.stringifed+=this.path[F]}return this.stringifed}}e.TestId=b}),define(we[167],Ee([0,1,17,91,10,23,26,77,136]),function(re,e,c,M,b,R,F,C,_){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.AbstractVariableResolverService=void 0;class P{constructor(E,n,f){this._contributedVariables=new Map,this._context=E,this._labelService=n,f&&(this._envVariablesPromise=f.then(a=>this.prepareEnv(a)))}prepareEnv(E){if(F.isWindows){const n=Object.create(null);return Object.keys(E).forEach(f=>{n[f.toLowerCase()]=E[f]}),n}return E}resolveWithEnvironment(E,n,f){return this.recursiveResolve(this.prepareEnv(E),n?n.uri:void 0,f)}async resolveAsync(E,n){return this.recursiveResolve(await this._envVariablesPromise,E?E.uri:void 0,n)}async resolveAnyBase(E,n,f,a){const l=R.deepClone(n);return F.isWindows&&l.windows?Object.keys(l.windows).forEach(w=>l[w]=l.windows[w]):F.isMacintosh&&l.osx?Object.keys(l.osx).forEach(w=>l[w]=l.osx[w]):F.isLinux&&l.linux&&Object.keys(l.linux).forEach(w=>l[w]=l.linux[w]),delete l.windows,delete l.osx,delete l.linux,this.recursiveResolve(await this._envVariablesPromise,E?E.uri:void 0,l,f,a)}async resolveAnyAsync(E,n,f){return this.resolveAnyBase(E,n,f)}async resolveAnyMap(E,n,f){const a=new Map;return{newConfig:await this.resolveAnyBase(E,n,f,a),resolvedVariables:a}}resolveWithInteractionReplace(E,n,f,a){throw new Error("resolveWithInteractionReplace not implemented.")}resolveWithInteraction(E,n,f,a){throw new Error("resolveWithInteraction not implemented.")}contributeVariable(E,n){if(this._contributedVariables.has(E))throw new Error("Variable "+E+" is contributed twice.");this._contributedVariables.set(E,n)}recursiveResolve(E,n,f,a,l){if(b.isString(f))return this.resolveString(E,n,f,a,l);if(b.isArray(f))return f.map(w=>this.recursiveResolve(E,n,w,a,l));if(b.isObject(f)){let w=Object.create(null);return Object.keys(f).forEach(I=>{const S=this.resolveString(E,n,I,a,l);w[S]=this.recursiveResolve(E,n,f[I],a,l)}),w}return f}resolveString(E,n,f,a,l){return f.replace(P.VARIABLE_REGEXP,(I,S)=>{if(S.includes(P.VARIABLE_LHS))return I;let o=this.evaluateSingleVariable(E,I,S,n,a);return l&&l.set(S,o),o!==I&&b.isString(o)&&o.match(P.VARIABLE_REGEXP)&&(o=this.resolveString(E,n,o,a,l)),o})}fsPath(E){return this._labelService?this._labelService.getUriLabel(E,{noPrefix:!0}):E.fsPath}evaluateSingleVariable(E,n,f,a,l){let w;const I=f.split(":");I.length>1&&(f=I[0],w=I[1]);const S=()=>{const y=this._context.getFilePath();if(y)return y;throw new Error((0,_.localize)(0,null,n))},o=()=>{const y=S();if(this._context.getWorkspaceFolderPathForFile){const i=this._context.getWorkspaceFolderPathForFile();if(i)return i}throw new Error((0,_.localize)(1,null,n,c.basename(y)))},h=()=>{if(w){const y=this._context.getFolderUri(w);if(y)return y;throw new Error((0,_.localize)(2,null,n,w))}if(a)return a;throw this._context.getWorkspaceFolderCount()>1?new Error((0,_.localize)(3,null,n)):new Error((0,_.localize)(4,null,n))};switch(f){case"env":if(w){if(E){const y=E[F.isWindows?w.toLowerCase():w];if(b.isString(y))return y}return""}throw new Error((0,_.localize)(5,null,n));case"config":if(w){const y=this._context.getConfigurationValue(a,w);if(b.isUndefinedOrNull(y))throw new Error((0,_.localize)(6,null,n,w));if(b.isObject(y))throw new Error((0,_.localize)(7,null,n,w));return y}throw new Error((0,_.localize)(8,null,n));case"command":return this.resolveFromMap(n,w,l,"command");case"input":return this.resolveFromMap(n,w,l,"input");default:switch(f){case"workspaceRoot":case"workspaceFolder":return(0,C.normalizeDriveLetter)(this.fsPath(h()));case"cwd":return a||w?(0,C.normalizeDriveLetter)(this.fsPath(h())):M.cwd();case"workspaceRootFolderName":case"workspaceFolderBasename":return c.basename(this.fsPath(h()));case"lineNumber":const y=this._context.getLineNumber();if(y)return y;throw new Error((0,_.localize)(9,null,n));case"selectedText":const i=this._context.getSelectedText();if(i)return i;throw new Error((0,_.localize)(10,null,n));case"file":return S();case"fileWorkspaceFolder":return o();case"relativeFile":return a||w?c.relative(this.fsPath(h()),S()):S();case"relativeFileDirname":const v=c.dirname(S());if(a||w){const d=c.relative(this.fsPath(h()),v);return d.length===0?".":d}return v;case"fileDirname":return c.dirname(S());case"fileExtname":return c.extname(S());case"fileBasename":return c.basename(S());case"fileBasenameNoExtension":const r=c.basename(S());return r.slice(0,r.length-c.extname(r).length);case"fileDirnameBasename":return c.basename(c.dirname(S()));case"execPath":const s=this._context.getExecPath();return s||n;case"execInstallFolder":const u=this._context.getAppRoot();return u||n;case"pathSeparator":return c.sep;default:try{const d=w?`${f}:${w}`:f;return this.resolveFromMap(n,d,l,void 0)}catch(d){return n}}}}resolveFromMap(E,n,f,a){if(n&&f){const l=a===void 0?f[n]:f[a+":"+n];if(typeof l=="string")return l;throw new Error((0,_.localize)(11,null,E))}return E}}e.AbstractVariableResolverService=P,P.VARIABLE_LHS="${",P.VARIABLE_REGEXP=/\$\{(.*?)\}/g}),define(we[92],Ee([0,1,4,160]),function(re,e,c,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.preferredSideBySideGroupDirection=e.isEditorGroup=e.OpenEditorContext=e.GroupChangeKind=e.GroupsOrder=e.isEditorReplacement=e.MergeGroupMode=e.GroupsArrangement=e.GroupLocation=e.GroupOrientation=e.GroupDirection=e.IEditorGroupsService=void 0,e.IEditorGroupsService=(0,c.createDecorator)("editorGroupsService");var b;(function(l){l[l.UP=0]="UP",l[l.DOWN=1]="DOWN",l[l.LEFT=2]="LEFT",l[l.RIGHT=3]="RIGHT"})(b=e.GroupDirection||(e.GroupDirection={}));var R;(function(l){l[l.HORIZONTAL=0]="HORIZONTAL",l[l.VERTICAL=1]="VERTICAL"})(R=e.GroupOrientation||(e.GroupOrientation={}));var F;(function(l){l[l.FIRST=0]="FIRST",l[l.LAST=1]="LAST",l[l.NEXT=2]="NEXT",l[l.PREVIOUS=3]="PREVIOUS"})(F=e.GroupLocation||(e.GroupLocation={}));var C;(function(l){l[l.MINIMIZE_OTHERS=0]="MINIMIZE_OTHERS",l[l.EVEN=1]="EVEN",l[l.TOGGLE=2]="TOGGLE"})(C=e.GroupsArrangement||(e.GroupsArrangement={}));var _;(function(l){l[l.COPY_EDITORS=0]="COPY_EDITORS",l[l.MOVE_EDITORS=1]="MOVE_EDITORS"})(_=e.MergeGroupMode||(e.MergeGroupMode={}));function P(l){const w=l;return(0,M.isEditorInput)(w?.editor)&&(0,M.isEditorInput)(w?.replacement)}e.isEditorReplacement=P;var t;(function(l){l[l.CREATION_TIME=0]="CREATION_TIME",l[l.MOST_RECENTLY_ACTIVE=1]="MOST_RECENTLY_ACTIVE",l[l.GRID_APPEARANCE=2]="GRID_APPEARANCE"})(t=e.GroupsOrder||(e.GroupsOrder={}));var E;(function(l){l[l.GROUP_ACTIVE=0]="GROUP_ACTIVE",l[l.GROUP_INDEX=1]="GROUP_INDEX",l[l.GROUP_LOCKED=2]="GROUP_LOCKED",l[l.EDITOR_OPEN=3]="EDITOR_OPEN",l[l.EDITOR_CLOSE=4]="EDITOR_CLOSE",l[l.EDITOR_MOVE=5]="EDITOR_MOVE",l[l.EDITOR_ACTIVE=6]="EDITOR_ACTIVE",l[l.EDITOR_LABEL=7]="EDITOR_LABEL",l[l.EDITOR_CAPABILITIES=8]="EDITOR_CAPABILITIES",l[l.EDITOR_PIN=9]="EDITOR_PIN",l[l.EDITOR_STICKY=10]="EDITOR_STICKY",l[l.EDITOR_DIRTY=11]="EDITOR_DIRTY"})(E=e.GroupChangeKind||(e.GroupChangeKind={}));var n;(function(l){l[l.NEW_EDITOR=1]="NEW_EDITOR",l[l.MOVE_EDITOR=2]="MOVE_EDITOR",l[l.COPY_EDITOR=3]="COPY_EDITOR"})(n=e.OpenEditorContext||(e.OpenEditorContext={}));function f(l){const w=l;return!!w&&typeof w.id=="number"&&Array.isArray(w.editors)}e.isEditorGroup=f;function a(l){return l.getValue("workbench.editor.openSideBySideDirection")==="down"?1:3}e.preferredSideBySideGroupDirection=a}),define(we[168],Ee([0,1,4,92]),function(re,e,c,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.isPreferredGroup=e.SIDE_GROUP=e.ACTIVE_GROUP=e.IEditorService=void 0,e.IEditorService=(0,c.createDecorator)("editorService"),e.ACTIVE_GROUP=-1,e.SIDE_GROUP=-2;function b(R){const F=R;return typeof R=="number"||(0,M.isEditorGroup)(F)}e.isPreferredGroup=b}),define(we[8],Ee([0,1,12,22,76,229,54,23,10,2,44,59,137,82,48,89,67,168,7]),function(re,e,c,M,b,R,F,C,_,P,t,E,n,f,a,l,w,I,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TypeHierarchyItem=e.CodeActionTriggerKind=e.TestCoverage=e.TestResults=e.TestItem=e.TestTag=e.TestMessage=e.NotebookRendererScript=e.NotebookDocumentContentOptions=e.NotebookStatusBarItem=e.NotebookDecorationRenderOptions=e.NotebookExclusiveDocumentPattern=e.NotebookCellOutput=e.NotebookCellOutputItem=e.NotebookCellData=e.NotebookData=e.NotebookCellKind=e.NotebookCellExecutionSummary=e.NotebookRange=e.LanguageSelector=e.GlobPattern=e.TextEditorOpenOptions=e.FoldingRangeKind=e.FoldingRange=e.ProgressLocation=e.EndOfLine=e.TextEditorLineNumbersStyle=e.TextDocumentSaveReason=e.SelectionRange=e.Color=e.ColorPresentation=e.DocumentLink=e.InlayHintKind=e.InlayHint=e.SignatureHelp=e.SignatureInformation=e.ParameterInformation=e.CompletionItem=e.CompletionItemKind=e.CompletionItemTag=e.CompletionContext=e.CompletionTriggerKind=e.DocumentHighlight=e.InlineValueContext=e.InlineValue=e.EvaluatableExpression=e.Hover=e.DefinitionLink=e.location=e.CallHierarchyOutgoingCall=e.CallHierarchyIncomingCall=e.CallHierarchyItem=e.DocumentSymbol=e.WorkspaceSymbol=e.SymbolTag=e.SymbolKind=e.WorkspaceEdit=e.TextEdit=e.DecorationRenderOptions=e.DecorationRangeBehavior=e.ThemableDecorationRenderOptions=e.ThemableDecorationAttachmentRenderOptions=e.pathOrURIToURI=e.fromRangeOrRangeWithMessage=e.MarkdownString=e.isDecorationOptionsArr=e.ViewColumn=e.DiagnosticSeverity=e.DiagnosticRelatedInformation=e.Diagnostic=e.DiagnosticTag=e.DocumentSelector=e.Position=e.TokenType=e.Range=e.Selection=void 0;var o;(function(de){function ge(W){const{selectionStartLineNumber:be,selectionStartColumn:ke,positionLineNumber:Je,positionColumn:$e}=W,ut=new S.Position(be-1,ke-1),gt=new S.Position(Je-1,$e-1);return new S.Selection(ut,gt)}de.to=ge;function X(W){const{anchor:be,active:ke}=W;return{selectionStartLineNumber:be.line+1,selectionStartColumn:be.character+1,positionLineNumber:ke.line+1,positionColumn:ke.character+1}}de.from=X})(o=e.Selection||(e.Selection={}));var h;(function(de){function ge(W){if(!W)return;const{start:be,end:ke}=W;return{startLineNumber:be.line+1,startColumn:be.character+1,endLineNumber:ke.line+1,endColumn:ke.character+1}}de.from=ge;function X(W){if(!W)return;const{startLineNumber:be,startColumn:ke,endLineNumber:Je,endColumn:$e}=W;return new S.Range(be-1,ke-1,Je-1,$e-1)}de.to=X})(h=e.Range||(e.Range={}));var y;(function(de){function ge(X){switch(X){case 1:return S.StandardTokenType.Comment;case 0:return S.StandardTokenType.Other;case 4:return S.StandardTokenType.RegEx;case 2:return S.StandardTokenType.String}}de.to=ge})(y=e.TokenType||(e.TokenType={}));var i;(function(de){function ge(W){return new S.Position(W.lineNumber-1,W.column-1)}de.to=ge;function X(W){return{lineNumber:W.line+1,column:W.character+1}}de.from=X})(i=e.Position||(e.Position={}));var v;(function(de){function ge(be,ke){return(0,c.coalesce)((0,c.asArray)(be).map(Je=>X(Je,ke)))}de.from=ge;function X(be,ke){if(typeof be=="string")return{$serialized:!0,language:be};if(be)return{$serialized:!0,language:be.language,scheme:W(be.scheme,ke),pattern:typeof be.pattern=="undefined"?void 0:ft.from(be.pattern),exclusive:be.exclusive}}function W(be,ke){return ke&&typeof be=="string"?ke.transformOutgoingScheme(be):be}})(v=e.DocumentSelector||(e.DocumentSelector={}));var r;(function(de){function ge(W){switch(W){case S.DiagnosticTag.Unnecessary:return 1;case S.DiagnosticTag.Deprecated:return 2}}de.from=ge;function X(W){switch(W){case 1:return S.DiagnosticTag.Unnecessary;case 2:return S.DiagnosticTag.Deprecated;default:return}}de.to=X})(r=e.DiagnosticTag||(e.DiagnosticTag={}));var s;(function(de){function ge(W){let be;return W.code&&((0,_.isString)(W.code)||(0,_.isNumber)(W.code)?be=String(W.code):be={value:String(W.code.value),target:W.code.target}),{...h.from(W.range),message:W.message,source:W.source,code:be,severity:d.from(W.severity),relatedInformation:W.relatedInformation&&W.relatedInformation.map(u.from),tags:Array.isArray(W.tags)?(0,c.coalesce)(W.tags.map(r.from)):void 0}}de.from=ge;function X(W){const be=new S.Diagnostic(h.to(W),W.message,d.to(W.severity));return be.source=W.source,be.code=(0,_.isString)(W.code)?W.code:W.code?.value,be.relatedInformation=W.relatedInformation&&W.relatedInformation.map(u.to),be.tags=W.tags&&(0,c.coalesce)(W.tags.map(r.to)),be}de.to=X})(s=e.Diagnostic||(e.Diagnostic={}));var u;(function(de){function ge(W){return{...h.from(W.location.range),message:W.message,resource:W.location.uri}}de.from=ge;function X(W){return new S.DiagnosticRelatedInformation(new S.Location(W.resource,h.to(W)),W.message)}de.to=X})(u=e.DiagnosticRelatedInformation||(e.DiagnosticRelatedInformation={}));var d;(function(de){function ge(W){switch(W){case S.DiagnosticSeverity.Error:return f.MarkerSeverity.Error;case S.DiagnosticSeverity.Warning:return f.MarkerSeverity.Warning;case S.DiagnosticSeverity.Information:return f.MarkerSeverity.Info;case S.DiagnosticSeverity.Hint:return f.MarkerSeverity.Hint}return f.MarkerSeverity.Error}de.from=ge;function X(W){switch(W){case f.MarkerSeverity.Info:return S.DiagnosticSeverity.Information;case f.MarkerSeverity.Warning:return S.DiagnosticSeverity.Warning;case f.MarkerSeverity.Error:return S.DiagnosticSeverity.Error;case f.MarkerSeverity.Hint:return S.DiagnosticSeverity.Hint;default:return S.DiagnosticSeverity.Error}}de.to=X})(d=e.DiagnosticSeverity||(e.DiagnosticSeverity={}));var p;(function(de){function ge(W){return typeof W=="number"&&W>=S.ViewColumn.One?W-1:W===S.ViewColumn.Beside?I.SIDE_GROUP:I.ACTIVE_GROUP}de.from=ge;function X(W){if(typeof W=="number"&&W>=0)return W+1;throw new Error("invalid 'EditorGroupColumn'")}de.to=X})(p=e.ViewColumn||(e.ViewColumn={}));function k(de){return typeof de.range!="undefined"}function T(de){return de.length===0?!0:!!k(de[0])}e.isDecorationOptionsArr=T;var g;(function(de){function ge($e){return $e.map(de.from)}de.fromMany=ge;function X($e){return $e&&typeof $e=="object"&&typeof $e.language=="string"&&typeof $e.value=="string"}function W($e){let ut;if(X($e)){const{language:ot,value:pt}=$e;ut={value:"```"+ot+`
`+pt+"\n```\n"}}else S.MarkdownString.isMarkdownString($e)?ut={value:$e.value,isTrusted:$e.isTrusted,supportThemeIcons:$e.supportThemeIcons,supportHtml:$e.supportHtml}:typeof $e=="string"?ut={value:$e}:ut={value:""};const gt=Object.create(null);ut.uris=gt;const at=ot=>{try{let pt=P.URI.parse(ot,!0);pt=pt.with({query:be(pt.query,gt)}),gt[ot]=pt}catch(pt){}return""},dt=new R.Renderer;return dt.link=at,dt.image=ot=>at(b.parseHrefAndDimensions(ot).href),R(ut.value,{renderer:dt}),ut}de.from=W;function be($e,ut){if(!$e)return $e;let gt;try{gt=(0,F.parse)($e)}catch(dt){}if(!gt)return $e;let at=!1;return gt=(0,C.cloneAndChange)(gt,dt=>{if(P.URI.isUri(dt)){const ot=`__uri_${Math.random().toString(16).slice(2,8)}`;return ut[ot]=dt,at=!0,ot}else return}),at?JSON.stringify(gt):$e}function ke($e){const ut=new S.MarkdownString($e.value,$e.supportThemeIcons);return ut.isTrusted=$e.isTrusted,ut.supportHtml=$e.supportHtml,ut}de.to=ke;function Je($e){if(!!$e)return typeof $e=="string"?$e:de.from($e)}de.fromStrict=Je})(g=e.MarkdownString||(e.MarkdownString={}));function D(de){return T(de)?de.map(ge=>({range:h.from(ge.range),hoverMessage:Array.isArray(ge.hoverMessage)?g.fromMany(ge.hoverMessage):ge.hoverMessage?g.from(ge.hoverMessage):void 0,renderOptions:ge.renderOptions})):de.map(ge=>({range:h.from(ge)}))}e.fromRangeOrRangeWithMessage=D;function m(de){return typeof de=="undefined"?de:typeof de=="string"?P.URI.file(de):de}e.pathOrURIToURI=m;var A;(function(de){function ge(X){return typeof X=="undefined"?X:{contentText:X.contentText,contentIconPath:X.contentIconPath?m(X.contentIconPath):void 0,border:X.border,borderColor:X.borderColor,fontStyle:X.fontStyle,fontWeight:X.fontWeight,textDecoration:X.textDecoration,color:X.color,backgroundColor:X.backgroundColor,margin:X.margin,width:X.width,height:X.height}}de.from=ge})(A=e.ThemableDecorationAttachmentRenderOptions||(e.ThemableDecorationAttachmentRenderOptions={}));var L;(function(de){function ge(X){return typeof X=="undefined"?X:{backgroundColor:X.backgroundColor,outline:X.outline,outlineColor:X.outlineColor,outlineStyle:X.outlineStyle,outlineWidth:X.outlineWidth,border:X.border,borderColor:X.borderColor,borderRadius:X.borderRadius,borderSpacing:X.borderSpacing,borderStyle:X.borderStyle,borderWidth:X.borderWidth,fontStyle:X.fontStyle,fontWeight:X.fontWeight,textDecoration:X.textDecoration,cursor:X.cursor,color:X.color,opacity:X.opacity,letterSpacing:X.letterSpacing,gutterIconPath:X.gutterIconPath?m(X.gutterIconPath):void 0,gutterIconSize:X.gutterIconSize,overviewRulerColor:X.overviewRulerColor,before:X.before?A.from(X.before):void 0,after:X.after?A.from(X.after):void 0}}de.from=ge})(L=e.ThemableDecorationRenderOptions||(e.ThemableDecorationRenderOptions={}));var V;(function(de){function ge(X){if(typeof X=="undefined")return X;switch(X){case S.DecorationRangeBehavior.OpenOpen:return 0;case S.DecorationRangeBehavior.ClosedClosed:return 1;case S.DecorationRangeBehavior.OpenClosed:return 2;case S.DecorationRangeBehavior.ClosedOpen:return 3}}de.from=ge})(V=e.DecorationRangeBehavior||(e.DecorationRangeBehavior={}));var G;(function(de){function ge(X){return{isWholeLine:X.isWholeLine,rangeBehavior:X.rangeBehavior?V.from(X.rangeBehavior):void 0,overviewRulerLane:X.overviewRulerLane,light:X.light?L.from(X.light):void 0,dark:X.dark?L.from(X.dark):void 0,backgroundColor:X.backgroundColor,outline:X.outline,outlineColor:X.outlineColor,outlineStyle:X.outlineStyle,outlineWidth:X.outlineWidth,border:X.border,borderColor:X.borderColor,borderRadius:X.borderRadius,borderSpacing:X.borderSpacing,borderStyle:X.borderStyle,borderWidth:X.borderWidth,fontStyle:X.fontStyle,fontWeight:X.fontWeight,textDecoration:X.textDecoration,cursor:X.cursor,color:X.color,opacity:X.opacity,letterSpacing:X.letterSpacing,gutterIconPath:X.gutterIconPath?m(X.gutterIconPath):void 0,gutterIconSize:X.gutterIconSize,overviewRulerColor:X.overviewRulerColor,before:X.before?A.from(X.before):void 0,after:X.after?A.from(X.after):void 0}}de.from=ge})(G=e.DecorationRenderOptions||(e.DecorationRenderOptions={}));var U;(function(de){function ge(W){return{text:W.newText,eol:W.newEol&&fe.from(W.newEol),range:h.from(W.range)}}de.from=ge;function X(W){const be=new S.TextEdit(h.to(W.range),W.text);return be.newEol=typeof W.eol=="undefined"?void 0:fe.to(W.eol),be}de.to=X})(U=e.TextEdit||(e.TextEdit={}));var K;(function(de){function ge(W,be,ke){const Je={edits:[]};if(W instanceof S.WorkspaceEdit)for(let $e of W._allEntries())if($e._type===1)Je.edits.push({_type:1,oldUri:$e.from,newUri:$e.to,options:$e.options,metadata:$e.metadata});else if($e._type===2){const ut=be?.getDocument($e.uri);Je.edits.push({_type:2,resource:$e.uri,edit:U.from($e.edit),modelVersionId:ut?.version,metadata:$e.metadata})}else $e._type===3?Je.edits.push({_type:3,metadata:$e.metadata,resource:$e.uri,edit:$e.edit,notebookMetadata:$e.notebookMetadata,notebookVersionId:ke?.getNotebookDocument($e.uri,!0)?.apiNotebook.version}):$e._type===5&&Je.edits.push({_type:3,metadata:$e.metadata,resource:$e.uri,notebookVersionId:ke?.getNotebookDocument($e.uri,!0)?.apiNotebook.version,edit:{editType:1,index:$e.index,count:$e.count,cells:$e.cells.map(Xe.from)}});return Je}de.from=ge;function X(W){const be=new S.WorkspaceEdit;for(const ke of W.edits)ke.edit?be.replace(P.URI.revive(ke.resource),h.to(ke.edit.range),ke.edit.text):be.renameFile(P.URI.revive(ke.oldUri),P.URI.revive(ke.newUri),ke.options);return be}de.to=X})(K=e.WorkspaceEdit||(e.WorkspaceEdit={}));var $;(function(de){const ge=Object.create(null);ge[S.SymbolKind.File]=0,ge[S.SymbolKind.Module]=1,ge[S.SymbolKind.Namespace]=2,ge[S.SymbolKind.Package]=3,ge[S.SymbolKind.Class]=4,ge[S.SymbolKind.Method]=5,ge[S.SymbolKind.Property]=6,ge[S.SymbolKind.Field]=7,ge[S.SymbolKind.Constructor]=8,ge[S.SymbolKind.Enum]=9,ge[S.SymbolKind.Interface]=10,ge[S.SymbolKind.Function]=11,ge[S.SymbolKind.Variable]=12,ge[S.SymbolKind.Constant]=13,ge[S.SymbolKind.String]=14,ge[S.SymbolKind.Number]=15,ge[S.SymbolKind.Boolean]=16,ge[S.SymbolKind.Array]=17,ge[S.SymbolKind.Object]=18,ge[S.SymbolKind.Key]=19,ge[S.SymbolKind.Null]=20,ge[S.SymbolKind.EnumMember]=21,ge[S.SymbolKind.Struct]=22,ge[S.SymbolKind.Event]=23,ge[S.SymbolKind.Operator]=24,ge[S.SymbolKind.TypeParameter]=25;function X(be){return typeof ge[be]=="number"?ge[be]:6}de.from=X;function W(be){for(const ke in ge)if(ge[ke]===be)return Number(ke);return S.SymbolKind.Property}de.to=W})($=e.SymbolKind||(e.SymbolKind={}));var B;(function(de){function ge(W){switch(W){case S.SymbolTag.Deprecated:return 1}}de.from=ge;function X(W){switch(W){case 1:return S.SymbolTag.Deprecated}}de.to=X})(B=e.SymbolTag||(e.SymbolTag={}));var z;(function(de){function ge(W){return{name:W.name,kind:$.from(W.kind),tags:W.tags&&W.tags.map(B.from),containerName:W.containerName,location:oe.from(W.location)}}de.from=ge;function X(W){const be=new S.SymbolInformation(W.name,$.to(W.kind),W.containerName,oe.to(W.location));return be.tags=W.tags&&W.tags.map(B.to),be}de.to=X})(z=e.WorkspaceSymbol||(e.WorkspaceSymbol={}));var Y;(function(de){function ge(W){const be={name:W.name||"!!MISSING: name!!",detail:W.detail,range:h.from(W.range),selectionRange:h.from(W.selectionRange),kind:$.from(W.kind),tags:W.tags?.map(B.from)??[]};return W.children&&(be.children=W.children.map(ge)),be}de.from=ge;function X(W){const be=new S.DocumentSymbol(W.name,W.detail,$.to(W.kind),h.to(W.range),h.to(W.selectionRange));return(0,c.isNonEmptyArray)(W.tags)&&(be.tags=W.tags.map(B.to)),W.children&&(be.children=W.children.map(X)),be}de.to=X})(Y=e.DocumentSymbol||(e.DocumentSymbol={}));var ne;(function(de){function ge(W){const be=new S.CallHierarchyItem($.to(W.kind),W.name,W.detail||"",P.URI.revive(W.uri),h.to(W.range),h.to(W.selectionRange));return be._sessionId=W._sessionId,be._itemId=W._itemId,be}de.to=ge;function X(W,be,ke){if(be=be??W._sessionId,ke=ke??W._itemId,be===void 0||ke===void 0)throw new Error("invalid item");return{_sessionId:be,_itemId:ke,name:W.name,detail:W.detail,kind:$.from(W.kind),uri:W.uri,range:h.from(W.range),selectionRange:h.from(W.selectionRange),tags:W.tags?.map(B.from)}}de.from=X})(ne=e.CallHierarchyItem||(e.CallHierarchyItem={}));var j;(function(de){function ge(X){return new S.CallHierarchyIncomingCall(ne.to(X.from),X.fromRanges.map(W=>h.to(W)))}de.to=ge})(j=e.CallHierarchyIncomingCall||(e.CallHierarchyIncomingCall={}));var le;(function(de){function ge(X){return new S.CallHierarchyOutgoingCall(ne.to(X.to),X.fromRanges.map(W=>h.to(W)))}de.to=ge})(le=e.CallHierarchyOutgoingCall||(e.CallHierarchyOutgoingCall={}));var oe;(function(de){function ge(W){return{range:W.range&&h.from(W.range),uri:W.uri}}de.from=ge;function X(W){return new S.Location(P.URI.revive(W.uri),h.to(W.range))}de.to=X})(oe=e.location||(e.location={}));var ve;(function(de){function ge(W){const be=W,ke=W;return{originSelectionRange:be.originSelectionRange?h.from(be.originSelectionRange):void 0,uri:be.targetUri?be.targetUri:ke.uri,range:h.from(be.targetRange?be.targetRange:ke.range),targetSelectionRange:be.targetSelectionRange?h.from(be.targetSelectionRange):void 0}}de.from=ge;function X(W){return{targetUri:P.URI.revive(W.uri),targetRange:h.to(W.range),targetSelectionRange:W.targetSelectionRange?h.to(W.targetSelectionRange):void 0,originSelectionRange:W.originSelectionRange?h.to(W.originSelectionRange):void 0}}de.to=X})(ve=e.DefinitionLink||(e.DefinitionLink={}));var Re;(function(de){function ge(W){return{range:h.from(W.range),contents:g.fromMany(W.contents)}}de.from=ge;function X(W){return new S.Hover(W.contents.map(g.to),h.to(W.range))}de.to=X})(Re=e.Hover||(e.Hover={}));var Me;(function(de){function ge(W){return{range:h.from(W.range),expression:W.expression}}de.from=ge;function X(W){return new S.EvaluatableExpression(h.to(W.range),W.expression)}de.to=X})(Me=e.EvaluatableExpression||(e.EvaluatableExpression={}));var Oe;(function(de){function ge(W){if(W instanceof S.InlineValueText)return{type:"text",range:h.from(W.range),text:W.text};if(W instanceof S.InlineValueVariableLookup)return{type:"variable",range:h.from(W.range),variableName:W.variableName,caseSensitiveLookup:W.caseSensitiveLookup};if(W instanceof S.InlineValueEvaluatableExpression)return{type:"expression",range:h.from(W.range),expression:W.expression};throw new Error("Unknown 'InlineValue' type")}de.from=ge;function X(W){switch(W.type){case"text":return{range:h.to(W.range),text:W.text};case"variable":return{range:h.to(W.range),variableName:W.variableName,caseSensitiveLookup:W.caseSensitiveLookup};case"expression":return{range:h.to(W.range),expression:W.expression}}}de.to=X})(Oe=e.InlineValue||(e.InlineValue={}));var Ye;(function(de){function ge(W){return{frameId:W.frameId,stoppedLocation:h.from(W.stoppedLocation)}}de.from=ge;function X(W){return new S.InlineValueContext(W.frameId,h.to(W.stoppedLocation))}de.to=X})(Ye=e.InlineValueContext||(e.InlineValueContext={}));var Ve;(function(de){function ge(W){return{range:h.from(W.range),kind:W.kind}}de.from=ge;function X(W){return new S.DocumentHighlight(h.to(W.range),W.kind)}de.to=X})(Ve=e.DocumentHighlight||(e.DocumentHighlight={}));var qe;(function(de){function ge(X){switch(X){case 1:return S.CompletionTriggerKind.TriggerCharacter;case 2:return S.CompletionTriggerKind.TriggerForIncompleteCompletions;case 0:default:return S.CompletionTriggerKind.Invoke}}de.to=ge})(qe=e.CompletionTriggerKind||(e.CompletionTriggerKind={}));var x;(function(de){function ge(X){return{triggerKind:qe.to(X.triggerKind),triggerCharacter:X.triggerCharacter}}de.to=ge})(x=e.CompletionContext||(e.CompletionContext={}));var Q;(function(de){function ge(W){switch(W){case S.CompletionItemTag.Deprecated:return 1}}de.from=ge;function X(W){switch(W){case 1:return S.CompletionItemTag.Deprecated}}de.to=X})(Q=e.CompletionItemTag||(e.CompletionItemTag={}));var te;(function(de){const ge=new Map([[S.CompletionItemKind.Method,0],[S.CompletionItemKind.Function,1],[S.CompletionItemKind.Constructor,2],[S.CompletionItemKind.Field,3],[S.CompletionItemKind.Variable,4],[S.CompletionItemKind.Class,5],[S.CompletionItemKind.Interface,7],[S.CompletionItemKind.Struct,6],[S.CompletionItemKind.Module,8],[S.CompletionItemKind.Property,9],[S.CompletionItemKind.Unit,12],[S.CompletionItemKind.Value,13],[S.CompletionItemKind.Constant,14],[S.CompletionItemKind.Enum,15],[S.CompletionItemKind.EnumMember,16],[S.CompletionItemKind.Keyword,17],[S.CompletionItemKind.Snippet,27],[S.CompletionItemKind.Text,18],[S.CompletionItemKind.Color,19],[S.CompletionItemKind.File,20],[S.CompletionItemKind.Reference,21],[S.CompletionItemKind.Folder,23],[S.CompletionItemKind.Event,10],[S.CompletionItemKind.Operator,11],[S.CompletionItemKind.TypeParameter,24],[S.CompletionItemKind.Issue,26],[S.CompletionItemKind.User,25]]);function X(ke){return ge.get(ke)??9}de.from=X;const W=new Map([[0,S.CompletionItemKind.Method],[1,S.CompletionItemKind.Function],[2,S.CompletionItemKind.Constructor],[3,S.CompletionItemKind.Field],[4,S.CompletionItemKind.Variable],[5,S.CompletionItemKind.Class],[7,S.CompletionItemKind.Interface],[6,S.CompletionItemKind.Struct],[8,S.CompletionItemKind.Module],[9,S.CompletionItemKind.Property],[12,S.CompletionItemKind.Unit],[13,S.CompletionItemKind.Value],[14,S.CompletionItemKind.Constant],[15,S.CompletionItemKind.Enum],[16,S.CompletionItemKind.EnumMember],[17,S.CompletionItemKind.Keyword],[27,S.CompletionItemKind.Snippet],[18,S.CompletionItemKind.Text],[19,S.CompletionItemKind.Color],[20,S.CompletionItemKind.File],[21,S.CompletionItemKind.Reference],[23,S.CompletionItemKind.Folder],[10,S.CompletionItemKind.Event],[11,S.CompletionItemKind.Operator],[24,S.CompletionItemKind.TypeParameter],[25,S.CompletionItemKind.User],[26,S.CompletionItemKind.Issue]]);function be(ke){return W.get(ke)??S.CompletionItemKind.Property}de.to=be})(te=e.CompletionItemKind||(e.CompletionItemKind={}));var ae;(function(de){function ge(X,W){const be=new S.CompletionItem(X.label);return be.insertText=X.insertText,be.kind=te.to(X.kind),be.tags=X.tags?.map(Q.to),be.detail=X.detail,be.documentation=b.isMarkdownString(X.documentation)?g.to(X.documentation):X.documentation,be.sortText=X.sortText,be.filterText=X.filterText,be.preselect=X.preselect,be.commitCharacters=X.commitCharacters,t.Range.isIRange(X.range)?be.range=h.to(X.range):typeof X.range=="object"&&(be.range={inserting:h.to(X.range.insert),replacing:h.to(X.range.replace)}),be.keepWhitespace=typeof X.insertTextRules=="undefined"?!1:Boolean(X.insertTextRules&1),typeof X.insertTextRules!="undefined"&&X.insertTextRules&4?be.insertText=new S.SnippetString(X.insertText):(be.insertText=X.insertText,be.textEdit=be.range instanceof S.Range?new S.TextEdit(be.range,be.insertText):void 0),X.additionalTextEdits&&X.additionalTextEdits.length>0&&(be.additionalTextEdits=X.additionalTextEdits.map(ke=>U.to(ke))),be.command=W&&X.command?W.fromInternal(X.command):void 0,be}de.to=ge})(ae=e.CompletionItem||(e.CompletionItem={}));var q;(function(de){function ge(W){return{label:W.label,documentation:W.documentation?g.fromStrict(W.documentation):void 0}}de.from=ge;function X(W){return{label:W.label,documentation:b.isMarkdownString(W.documentation)?g.to(W.documentation):W.documentation}}de.to=X})(q=e.ParameterInformation||(e.ParameterInformation={}));var se;(function(de){function ge(W){return{label:W.label,documentation:W.documentation?g.fromStrict(W.documentation):void 0,parameters:Array.isArray(W.parameters)?W.parameters.map(q.from):[],activeParameter:W.activeParameter}}de.from=ge;function X(W){return{label:W.label,documentation:b.isMarkdownString(W.documentation)?g.to(W.documentation):W.documentation,parameters:Array.isArray(W.parameters)?W.parameters.map(q.to):[],activeParameter:W.activeParameter}}de.to=X})(se=e.SignatureInformation||(e.SignatureInformation={}));var he;(function(de){function ge(W){return{activeSignature:W.activeSignature,activeParameter:W.activeParameter,signatures:Array.isArray(W.signatures)?W.signatures.map(se.from):[]}}de.from=ge;function X(W){return{activeSignature:W.activeSignature,activeParameter:W.activeParameter,signatures:Array.isArray(W.signatures)?W.signatures.map(se.to):[]}}de.to=X})(he=e.SignatureHelp||(e.SignatureHelp={}));var Te;(function(de){function ge(W){return{text:W.text,position:i.from(W.position),kind:Ue.from(W.kind??S.InlayHintKind.Other),whitespaceBefore:W.whitespaceBefore,whitespaceAfter:W.whitespaceAfter}}de.from=ge;function X(W){const be=new S.InlayHint(W.text,i.to(W.position),Ue.to(W.kind));return be.whitespaceAfter=W.whitespaceAfter,be.whitespaceBefore=W.whitespaceBefore,be}de.to=X})(Te=e.InlayHint||(e.InlayHint={}));var Ue;(function(de){function ge(W){return W}de.from=ge;function X(W){return W}de.to=X})(Ue=e.InlayHintKind||(e.InlayHintKind={}));var He;(function(de){function ge(W){return{range:h.from(W.range),url:W.target,tooltip:W.tooltip}}de.from=ge;function X(W){let be;if(W.url)try{be=typeof W.url=="string"?P.URI.parse(W.url,!0):P.URI.revive(W.url)}catch(ke){}return new S.DocumentLink(h.to(W.range),be)}de.to=X})(He=e.DocumentLink||(e.DocumentLink={}));var Ke;(function(de){function ge(W){const be=new S.ColorPresentation(W.label);return W.textEdit&&(be.textEdit=U.to(W.textEdit)),W.additionalTextEdits&&(be.additionalTextEdits=W.additionalTextEdits.map(ke=>U.to(ke))),be}de.to=ge;function X(W){return{label:W.label,textEdit:W.textEdit?U.from(W.textEdit):void 0,additionalTextEdits:W.additionalTextEdits?W.additionalTextEdits.map(be=>U.from(be)):void 0}}de.from=X})(Ke=e.ColorPresentation||(e.ColorPresentation={}));var ye;(function(de){function ge(W){return new S.Color(W[0],W[1],W[2],W[3])}de.to=ge;function X(W){return[W.red,W.green,W.blue,W.alpha]}de.from=X})(ye=e.Color||(e.Color={}));var nt;(function(de){function ge(W){return{range:h.from(W.range)}}de.from=ge;function X(W){return new S.SelectionRange(h.to(W.range))}de.to=X})(nt=e.SelectionRange||(e.SelectionRange={}));var H;(function(de){function ge(X){switch(X){case 2:return S.TextDocumentSaveReason.AfterDelay;case 1:return S.TextDocumentSaveReason.Manual;case 3:case 4:return S.TextDocumentSaveReason.FocusOut}}de.to=ge})(H=e.TextDocumentSaveReason||(e.TextDocumentSaveReason={}));var J;(function(de){function ge(W){switch(W){case S.TextEditorLineNumbersStyle.Off:return 0;case S.TextEditorLineNumbersStyle.Relative:return 2;case S.TextEditorLineNumbersStyle.On:default:return 1}}de.from=ge;function X(W){switch(W){case 0:return S.TextEditorLineNumbersStyle.Off;case 2:return S.TextEditorLineNumbersStyle.Relative;case 1:default:return S.TextEditorLineNumbersStyle.On}}de.to=X})(J=e.TextEditorLineNumbersStyle||(e.TextEditorLineNumbersStyle={}));var fe;(function(de){function ge(W){if(W===S.EndOfLine.CRLF)return 1;if(W===S.EndOfLine.LF)return 0}de.from=ge;function X(W){if(W===1)return S.EndOfLine.CRLF;if(W===0)return S.EndOfLine.LF}de.to=X})(fe=e.EndOfLine||(e.EndOfLine={}));var xe;(function(de){function ge(X){if(typeof X=="object")return X.viewId;switch(X){case S.ProgressLocation.SourceControl:return 3;case S.ProgressLocation.Window:return 10;case S.ProgressLocation.Notification:return 15}throw new Error("Unknown 'ProgressLocation'")}de.from=ge})(xe=e.ProgressLocation||(e.ProgressLocation={}));var Qe;(function(de){function ge(X){const W={start:X.start+1,end:X.end+1};return X.kind&&(W.kind=rt.from(X.kind)),W}de.from=ge})(Qe=e.FoldingRange||(e.FoldingRange={}));var rt;(function(de){function ge(X){if(X)switch(X){case S.FoldingRangeKind.Comment:return E.FoldingRangeKind.Comment;case S.FoldingRangeKind.Imports:return E.FoldingRangeKind.Imports;case S.FoldingRangeKind.Region:return E.FoldingRangeKind.Region}}de.from=ge})(rt=e.FoldingRangeKind||(e.FoldingRangeKind={}));var ct;(function(de){function ge(X){if(X)return{pinned:typeof X.preview=="boolean"?!X.preview:void 0,inactive:X.background,preserveFocus:X.preserveFocus,selection:typeof X.selection=="object"?h.from(X.selection):void 0,override:typeof X.override=="boolean"?n.EditorResolution.DISABLED:void 0}}de.from=ge})(ct=e.TextEditorOpenOptions||(e.TextEditorOpenOptions={}));var ft;(function(de){function ge(W){return W instanceof S.RelativePattern||typeof W=="string"?W:X(W)?new S.RelativePattern(W.base,W.pattern):W}de.from=ge;function X(W){const be=W;return be&&typeof be.base=="string"&&typeof be.pattern=="string"}})(ft=e.GlobPattern||(e.GlobPattern={}));var Pt;(function(de){function ge(X){if(X){if(Array.isArray(X))return X.map(ge);if(typeof X=="string")return X;{const W=X;return{language:W.language,scheme:W.scheme,pattern:typeof W.pattern=="undefined"?void 0:ft.from(W.pattern),exclusive:W.exclusive}}}else return}de.from=ge})(Pt=e.LanguageSelector||(e.LanguageSelector={}));var mt;(function(de){function ge(W){return{start:W.start,end:W.end}}de.from=ge;function X(W){return new S.NotebookRange(W.start,W.end)}de.to=X})(mt=e.NotebookRange||(e.NotebookRange={}));var Dt;(function(de){function ge(W){return{timing:typeof W.runStartTime=="number"&&typeof W.runEndTime=="number"?{startTime:W.runStartTime,endTime:W.runEndTime}:void 0,executionOrder:W.executionOrder,success:W.lastRunSuccess}}de.to=ge;function X(W){return{lastRunSuccess:W.success,runStartTime:W.timing?.startTime,runEndTime:W.timing?.endTime,executionOrder:W.executionOrder}}de.from=X})(Dt=e.NotebookCellExecutionSummary||(e.NotebookCellExecutionSummary={}));var kt;(function(de){function ge(W){switch(W){case S.NotebookCellKind.Markup:return l.CellKind.Markup;case S.NotebookCellKind.Code:default:return l.CellKind.Code}}de.from=ge;function X(W){switch(W){case l.CellKind.Markup:return S.NotebookCellKind.Markup;case l.CellKind.Code:default:return S.NotebookCellKind.Code}}de.to=X})(kt=e.NotebookCellKind||(e.NotebookCellKind={}));var vt;(function(de){function ge(W){const be={metadata:W.metadata??Object.create(null),cells:[]};for(let ke of W.cells)S.NotebookCellData.validate(ke),be.cells.push(Xe.from(ke));return be}de.from=ge;function X(W){const be=new S.NotebookData(W.cells.map(Xe.to));return(0,_.isEmptyObject)(W.metadata)||(be.metadata=W.metadata),be}de.to=X})(vt=e.NotebookData||(e.NotebookData={}));var Xe;(function(de){function ge(W){return{cellKind:kt.from(W.kind),language:W.languageId,mime:W.mime,source:W.value,metadata:W.metadata,internalMetadata:Dt.from(W.executionSummary??{}),outputs:W.outputs?W.outputs.map(Pe.from):[]}}de.from=ge;function X(W){return new S.NotebookCellData(kt.to(W.cellKind),W.source,W.language,W.mime,W.outputs?W.outputs.map(Pe.to):void 0,W.metadata,W.internalMetadata?Dt.to(W.internalMetadata):void 0)}de.to=X})(Xe=e.NotebookCellData||(e.NotebookCellData={}));var _t;(function(de){function ge(W){return{mime:W.mime,valueBytes:M.VSBuffer.wrap(W.data)}}de.from=ge;function X(W){return new S.NotebookCellOutputItem(W.valueBytes.buffer,W.mime)}de.to=X})(_t=e.NotebookCellOutputItem||(e.NotebookCellOutputItem={}));var Pe;(function(de){function ge(W){return{outputId:W.id,items:W.items.map(_t.from),metadata:W.metadata}}de.from=ge;function X(W){const be=W.items.map(_t.to);return new S.NotebookCellOutput(be,W.outputId,W.metadata)}de.to=X})(Pe=e.NotebookCellOutput||(e.NotebookCellOutput={}));var Se;(function(de){function ge(ke){if(ke!=null){if(ke instanceof S.RelativePattern||typeof ke=="string")return ke;if(be(ke))return new S.RelativePattern(ke.base,ke.pattern);if(W(ke))return{include:ft.from(ke.include)||void 0,exclude:ft.from(ke.exclude)||void 0}}}de.from=ge;function X(ke){return typeof ke=="string"?ke:be(ke)?{base:ke.base,pattern:ke.pattern}:{include:ke.include,exclude:ke.exclude}}de.to=X;function W(ke){const Je=ke,$e=ft.from(Je.include);if(!($e&&$e instanceof S.RelativePattern||typeof $e=="string"))return!1;const ut=ft.from(Je.exclude);return!!(ut&&ut instanceof S.RelativePattern||typeof ut=="string")}function be(ke){const Je=ke;return Je&&typeof Je.base=="string"&&typeof Je.pattern=="string"}})(Se=e.NotebookExclusiveDocumentPattern||(e.NotebookExclusiveDocumentPattern={}));var De;(function(de){function ge(X){return{backgroundColor:X.backgroundColor,borderColor:X.borderColor,top:X.top?A.from(X.top):void 0}}de.from=ge})(De=e.NotebookDecorationRenderOptions||(e.NotebookDecorationRenderOptions={}));var ee;(function(de){function ge(X,W,be){const ke=typeof X.command=="string"?{title:"",command:X.command}:X.command;return{alignment:X.alignment===S.NotebookCellStatusBarAlignment.Left?1:2,command:W.toInternal(ke,be),text:X.text,tooltip:X.tooltip,accessibilityInformation:X.accessibilityInformation,priority:X.priority}}de.from=ge})(ee=e.NotebookStatusBarItem||(e.NotebookStatusBarItem={}));var ue;(function(de){function ge(X){return{transientOutputs:X?.transientOutputs??!1,transientCellMetadata:X?.transientCellMetadata??{},transientDocumentMetadata:X?.transientDocumentMetadata??{}}}de.from=ge})(ue=e.NotebookDocumentContentOptions||(e.NotebookDocumentContentOptions={}));var pe;(function(de){function ge(W){return{uri:W.uri,provides:W.provides}}de.from=ge;function X(W){return new S.NotebookRendererScript(P.URI.revive(W.uri),W.provides)}de.to=X})(pe=e.NotebookRendererScript||(e.NotebookRendererScript={}));var me;(function(de){function ge(W){return{message:g.fromStrict(W.message)||"",type:0,expected:W.expectedOutput,actual:W.actualOutput,location:W.location?oe.from(W.location):void 0}}de.from=ge;function X(W){const be=new S.TestMessage(typeof W.message=="string"?W.message:g.to(W.message));return be.actualOutput=W.actual,be.expectedOutput=W.expected,be.location=W.location?oe.to(W.location):void 0,be}de.to=X})(me=e.TestMessage||(e.TestMessage={}));var Ie;(function(de){let ge;(function(X){X.Delimiter="\0"})(ge||(ge={})),de.namespace=(X,W)=>X+"\0"+W,de.denamespace=X=>{const W=X.indexOf("\0");return{ctrlId:X.slice(0,W),tagId:X.slice(W+1)}}})(Ie=e.TestTag||(e.TestTag={}));var Be;(function(de){function ge(ke){const Je=(0,a.getPrivateApiFor)(ke).controllerId;return{extId:w.TestId.fromExtHostTestItem(ke,Je).toString(),label:ke.label,uri:ke.uri,tags:ke.tags.map($e=>Ie.namespace(Je,$e.id)),range:h.from(ke.range)||null,description:ke.description||null,error:ke.error&&g.fromStrict(ke.error)||null}}de.from=ge;function X(ke){return{id:w.TestId.fromString(ke.extId).localId,label:ke.label,uri:P.URI.revive(ke.uri),tags:(ke.tags||[]).map(Je=>{const{tagId:$e}=Ie.denamespace(Je);return new S.TestTag($e)}),range:h.to(ke.range||void 0),invalidateResults:()=>{},canResolveChildren:!1,busy:!1,description:ke.description||void 0}}de.toPlain=X;function W(ke){const Je=w.TestId.fromString(ke.extId),$e=new a.TestItemImpl(Je.controllerId,Je.localId,ke.label,P.URI.revive(ke.uri));return $e.range=h.to(ke.range||void 0),$e.description=ke.description||void 0,$e}function be(ke){let Je;for(const $e of ke.tests){const ut=W($e.item);(0,a.getPrivateApiFor)(ut).parent=Je,Je=ut}return Je}de.toItemFromContext=be})(Be=e.TestItem||(e.TestItem={})),function(de){function ge(W){return{id:W.id}}de.from=ge;function X(W){return new S.TestTag(W.id)}de.to=X}(Ie=e.TestTag||(e.TestTag={}));var Ne;(function(de){const ge=(W,be)=>{const ke={...Be.toPlain(W.item),parent:void 0,taskStates:W.tasks.map(Je=>({state:Je.state,duration:Je.duration,messages:Je.messages.filter($e=>$e.type===0).map(me.to)})),children:W.children.map(Je=>be.get(Je)).filter(_.isDefined).map(Je=>ge(Je,be))};for(const Je of ke.children)Je.parent=ke;return ke};function X(W){const be=[],ke=new Map;for(const Je of W.items)ke.set(Je.item.extId,Je),W.request.targets.some($e=>$e.controllerId===Je.controllerId&&$e.testIds.includes(Je.item.extId))&&be.push(Je);return{completedAt:W.completedAt,results:be.map(Je=>ge(Je,ke))}}de.to=X})(Ne=e.TestResults||(e.TestResults={}));var je;(function(de){function ge(ke){return{covered:ke.covered,total:ke.covered}}function X(ke){return"line"in ke?i.from(ke):h.from(ke)}function W(ke){return"branches"in ke?{count:ke.executionCount,location:X(ke.location),type:1,branches:ke.branches.length?ke.branches.map(Je=>({count:Je.executionCount,location:Je.location&&X(Je.location)})):void 0}:{type:0,count:ke.executionCount,location:X(ke.location)}}de.fromDetailed=W;function be(ke){return{uri:ke.uri,statement:ge(ke.statementCoverage),branch:ke.branchCoverage&&ge(ke.branchCoverage),function:ke.functionCoverage&&ge(ke.functionCoverage),details:ke.detailedCoverage?.map(W)}}de.fromFile=be})(je=e.TestCoverage||(e.TestCoverage={}));var et;(function(de){function ge(X){switch(X){case 1:return S.CodeActionTriggerKind.Invoke;case 2:return S.CodeActionTriggerKind.Automatic}}de.to=ge})(et=e.CodeActionTriggerKind||(e.CodeActionTriggerKind={}));var Le;(function(de){function ge(W){const be=new S.TypeHierarchyItem($.to(W.kind),W.name,W.detail||"",P.URI.revive(W.uri),h.to(W.range),h.to(W.selectionRange));return be._sessionId=W._sessionId,be._itemId=W._itemId,be}de.to=ge;function X(W,be,ke){if(be=be??W._sessionId,ke=ke??W._itemId,be===void 0||ke===void 0)throw new Error("invalid item");return{_sessionId:be,_itemId:ke,kind:$.from(W.kind),name:W.name,detail:W.detail??"",uri:W.uri,range:h.from(W.range),selectionRange:h.from(W.selectionRange),tags:W.tags?.map(B.from)}}de.from=X})(Le=e.TypeHierarchyItem||(e.TypeHierarchyItem={}))}),define(we[169],Ee([0,1,2,16,7,8,230]),function(re,e,c,M,b,R,F){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostDocumentSaveParticipant=void 0;class C{constructor(P,t,E,n={timeout:1500,errors:3}){this._logService=P,this._documents=t,this._mainThreadBulkEdits=E,this._thresholds=n,this._callbacks=new F.LinkedList,this._badListeners=new WeakMap}dispose(){this._callbacks.clear()}getOnWillSaveTextDocumentEvent(P){return(t,E,n)=>{const a={dispose:this._callbacks.push([t,E,P])};return Array.isArray(n)&&n.push(a),a}}async $participateInSave(P,t){const E=c.URI.revive(P);let n=!1;const f=setTimeout(()=>n=!0,this._thresholds.timeout),a=[];try{for(let l of[...this._callbacks]){if(n)break;const w=this._documents.getDocument(E),I=await this._deliverEventAsyncAndBlameBadListeners(l,{document:w,reason:R.TextDocumentSaveReason.to(t)});a.push(I)}}finally{clearTimeout(f)}return a}_deliverEventAsyncAndBlameBadListeners([P,t,E],n){const f=this._badListeners.get(P);return typeof f=="number"&&f>this._thresholds.errors?Promise.resolve(!1):this._deliverEventAsync(E,P,t,n).then(()=>!0,a=>{if(this._logService.error(`onWillSaveTextDocument-listener from extension '${E.identifier.value}' threw ERROR`),this._logService.error(a),!(a instanceof Error)||a.message!=="concurrent_edits"){const l=this._badListeners.get(P);this._badListeners.set(P,l?l+1:1),typeof l=="number"&&l>this._thresholds.errors&&this._logService.info(`onWillSaveTextDocument-listener from extension '${E.identifier.value}' will now be IGNORED because of timeouts and/or errors`)}return!1})}_deliverEventAsync(P,t,E,n){const f=[],a=Date.now(),{document:l,reason:w}=n,{version:I}=l,S=Object.freeze({document:l,reason:w,waitUntil(o){if(Object.isFrozen(f))throw(0,M.illegalState)("waitUntil can not be called async");f.push(Promise.resolve(o))}});try{t.apply(E,[S])}catch(o){return Promise.reject(o)}return Object.freeze(f),new Promise((o,h)=>{const y=setTimeout(()=>h(new Error("timeout")),this._thresholds.timeout);return Promise.all(f).then(i=>{this._logService.debug(`onWillSaveTextDocument-listener from extension '${P.identifier.value}' finished after ${Date.now()-a}ms`),clearTimeout(y),o(i)}).catch(i=>{clearTimeout(y),h(i)})}).then(o=>{const h={edits:[]};for(const y of o)if(Array.isArray(y)&&y.every(i=>i instanceof b.TextEdit))for(const{newText:i,newEol:v,range:r}of y)h.edits.push({_type:2,resource:l.uri,edit:{range:r&&R.Range.from(r),text:i,eol:v&&R.EndOfLine.from(v)}});if(h.edits.length!==0)return I===l.version?this._mainThreadBulkEdits.$tryApplyWorkspaceEdit(h):Promise.reject(new Error("concurrent_edits"))})}}e.ExtHostDocumentSaveParticipant=C}),define(we[68],Ee([0,1,8,2,3,4]),function(re,e,c,M,b,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostEditorTabs=e.IExtHostEditorTabs=void 0,e.IExtHostEditorTabs=(0,R.createDecorator)("IExtHostEditorTabs");class F{constructor(){this._onDidChangeTabs=new b.Emitter,this.onDidChangeTabs=this._onDidChangeTabs.event,this._onDidChangeActiveTab=new b.Emitter,this.onDidChangeActiveTab=this._onDidChangeActiveTab.event,this._tabs=[]}get tabs(){return this._tabs}get activeTab(){return this._activeTab}$acceptEditorTabs(_){let P=-1;this._tabs=_.map((E,n)=>(E.isActive&&(P=n),Object.freeze({label:E.label,viewColumn:c.ViewColumn.to(E.viewColumn),index:n,resource:M.URI.revive(E.resource),additionalResourcesAndViewIds:E.additionalResourcesAndViewIds.map(({resource:f,viewId:a})=>({resource:M.URI.revive(f),viewId:a})),viewId:E.editorId,isActive:E.isActive}))),this._tabs=this._tabs.sort((E,n)=>E.viewColumn===n.viewColumn?E.index-n.index:E.viewColumn-n.viewColumn);const t=this._activeTab;this._activeTab=P===-1?void 0:this._tabs[P],this._activeTab!==t&&this._onDidChangeActiveTab.fire(this._activeTab),this._onDidChangeTabs.fire(this._tabs)}}e.ExtHostEditorTabs=F}),define(we[170],Ee([0,1,3,27,2,8,7]),function(re,e,c,M,b,R,F){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostFileSystemEventService=void 0;class C{constructor(t,E,n,f,a){this._onDidCreate=new c.Emitter,this._onDidChange=new c.Emitter,this._onDidDelete=new c.Emitter,this._config=0,n&&(this._config+=1),f&&(this._config+=2),a&&(this._config+=4);const l=(0,M.parse)(E),w=t(I=>{if(!n)for(let S of I.created){const o=b.URI.revive(S);l(o.fsPath)&&this._onDidCreate.fire(o)}if(!f)for(let S of I.changed){const o=b.URI.revive(S);l(o.fsPath)&&this._onDidChange.fire(o)}if(!a)for(let S of I.deleted){const o=b.URI.revive(S);l(o.fsPath)&&this._onDidDelete.fire(o)}});this._disposable=F.Disposable.from(this._onDidCreate,this._onDidChange,this._onDidDelete,w)}get ignoreCreateEvents(){return Boolean(this._config&1)}get ignoreChangeEvents(){return Boolean(this._config&2)}get ignoreDeleteEvents(){return Boolean(this._config&4)}dispose(){this._disposable.dispose()}get onDidCreate(){return this._onDidCreate.event}get onDidChange(){return this._onDidChange.event}get onDidDelete(){return this._onDidDelete.event}}class _{constructor(t,E,n){this._logService=E,this._extHostDocumentsAndEditors=n,this._onFileSystemEvent=new c.Emitter,this._onDidRenameFile=new c.Emitter,this._onDidCreateFile=new c.Emitter,this._onDidDeleteFile=new c.Emitter,this._onWillRenameFile=new c.AsyncEmitter,this._onWillCreateFile=new c.AsyncEmitter,this._onWillDeleteFile=new c.AsyncEmitter,this.onDidRenameFile=this._onDidRenameFile.event,this.onDidCreateFile=this._onDidCreateFile.event,this.onDidDeleteFile=this._onDidDeleteFile.event}createFileSystemWatcher(t,E,n,f){return new C(this._onFileSystemEvent.event,t,E,n,f)}$onFileEvent(t){this._onFileSystemEvent.fire(t)}$onDidRunFileOperation(t,E){switch(t){case 2:this._onDidRenameFile.fire(Object.freeze({files:E.map(n=>({oldUri:b.URI.revive(n.source),newUri:b.URI.revive(n.target)}))}));break;case 1:this._onDidDeleteFile.fire(Object.freeze({files:E.map(n=>b.URI.revive(n.target))}));break;case 0:this._onDidCreateFile.fire(Object.freeze({files:E.map(n=>b.URI.revive(n.target))}));break;default:}}getOnWillRenameFileEvent(t){return this._createWillExecuteEvent(t,this._onWillRenameFile)}getOnWillCreateFileEvent(t){return this._createWillExecuteEvent(t,this._onWillCreateFile)}getOnWillDeleteFileEvent(t){return this._createWillExecuteEvent(t,this._onWillDeleteFile)}_createWillExecuteEvent(t,E){return(n,f,a)=>{const l=function(I){n.call(f,I)};return l.extension=t,E.event(l,void 0,a)}}async $onWillRunFileOperation(t,E,n,f){switch(t){case 2:return await this._fireWillEvent(this._onWillRenameFile,{files:E.map(a=>({oldUri:b.URI.revive(a.source),newUri:b.URI.revive(a.target)}))},n,f);case 1:return await this._fireWillEvent(this._onWillDeleteFile,{files:E.map(a=>b.URI.revive(a.target))},n,f);case 0:return await this._fireWillEvent(this._onWillCreateFile,{files:E.map(a=>b.URI.revive(a.target))},n,f)}}async _fireWillEvent(t,E,n,f){const a=new Set,l=[];if(await t.fireAsync(E,f,async(I,S)=>{const o=Date.now(),h=await Promise.resolve(I);h instanceof F.WorkspaceEdit&&(l.push(h),a.add(S.extension.displayName??S.extension.identifier.value)),Date.now()-o>n&&this._logService.warn("SLOW file-participant",S.extension.identifier)}),f.isCancellationRequested||l.length===0)return;const w={edits:[]};for(let I of l){let{edits:S}=R.WorkspaceEdit.from(I,this._extHostDocumentsAndEditors);w.edits=w.edits.concat(S)}return{edit:w,extensionNames:Array.from(a)}}}e.ExtHostFileSystemEventService=_}),define(we[171],Ee([0,1,11,23,2,8,7,89]),function(re,e,c,M,b,R,F,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostNotebookDocument=e.ExtHostCell=void 0;class _{constructor(n,f,a,l){this.start=n,this.deletedCount=f,this.deletedItems=a,this.items=l}static asApiEvents(n){return n.map(f=>({start:f.start,deletedCount:f.deletedCount,deletedItems:f.deletedItems,items:f.items.map(a=>a.apiCell)}))}}class P{constructor(n,f,a){this.notebook=n,this._extHostDocument=f,this._cellData=a,this.handle=a.handle,this.uri=b.URI.revive(a.uri),this.cellKind=a.cellKind,this._outputs=a.outputs.map(R.NotebookCellOutput.to),this._internalMetadata=a.internalMetadata??{},this._metadata=Object.freeze(a.metadata??{}),this._previousResult=Object.freeze(R.NotebookCellExecutionSummary.to(a.internalMetadata??{}))}static asModelAddData(n,f){return{EOL:f.eol,lines:f.source,modeId:f.language,uri:f.uri,isDirty:!1,versionId:1,notebook:n}}get internalMetadata(){return this._internalMetadata}get apiCell(){if(!this._apiCell){const n=this,f=this._extHostDocument.getDocument(this.uri);if(!f)throw new Error(`MISSING extHostDocument for notebook cell: ${this.uri}`);this._apiCell=Object.freeze({get index(){return n.notebook.getCellIndex(n)},notebook:n.notebook.apiNotebook,kind:R.NotebookCellKind.to(this._cellData.cellKind),document:f.document,get mime(){return n._mime},set mime(a){n._mime=a},get outputs(){return n._outputs.slice(0)},get metadata(){return n._metadata},get executionSummary(){return n._previousResult}})}return this._apiCell}setOutputs(n){this._outputs=n.map(R.NotebookCellOutput.to)}setOutputItems(n,f,a){const l=a.map(R.NotebookCellOutputItem.to),w=this._outputs.find(I=>I.id===n);w&&(f||(w.items.length=0),w.items.push(...l))}setMetadata(n){this._metadata=Object.freeze(n)}setInternalMetadata(n){this._internalMetadata=n,this._previousResult=Object.freeze(R.NotebookCellExecutionSummary.to(n))}setMime(n){}}e.ExtHostCell=P;class t{constructor(n,f,a,l,w,I){this._proxy=n,this._textDocumentsAndEditors=f,this._textDocuments=a,this._emitter=l,this.uri=w,this.handle=t._handlePool++,this._cells=[],this._versionId=0,this._isDirty=!1,this._disposed=!1,this._notebookType=I.viewType,this._metadata=Object.freeze(I.metadata??Object.create(null)),this._spliceNotebookCells([[0,0,I.cells]],!0),this._versionId=I.versionId}dispose(){this._disposed=!0}get apiNotebook(){if(!this._notebook){const n=this;this._notebook={get uri(){return n.uri},get version(){return n._versionId},get notebookType(){return n._notebookType},get isDirty(){return n._isDirty},get isUntitled(){return n.uri.scheme===c.Schemas.untitled},get isClosed(){return n._disposed},get metadata(){return n._metadata},get cellCount(){return n._cells.length},cellAt(f){return f=n._validateIndex(f),n._cells[f].apiCell},getCells(f){return(f?n._getCells(f):n._cells).map(l=>l.apiCell)},save(){return n._save()}}}return this._notebook}updateBackup(n){this._backup?.delete(),this._backup=n}disposeBackup(){this._backup?.delete(),this._backup=void 0}acceptDocumentPropertiesChanged(n){n.metadata&&(this._metadata=Object.freeze({...this._metadata,...n.metadata}))}acceptDirty(n){this._isDirty=n}acceptModelChanged(n,f){this._versionId=n.versionId,this._isDirty=f;for(const a of n.rawEvents)a.kind===C.NotebookCellsChangeType.ModelChange?this._spliceNotebookCells(a.changes,!1):a.kind===C.NotebookCellsChangeType.Move?this._moveCell(a.index,a.newIdx):a.kind===C.NotebookCellsChangeType.Output?this._setCellOutputs(a.index,a.outputs):a.kind===C.NotebookCellsChangeType.OutputItem?this._setCellOutputItems(a.index,a.outputId,a.append,a.outputItems):a.kind===C.NotebookCellsChangeType.ChangeLanguage?this._changeCellLanguage(a.index,a.language):a.kind===C.NotebookCellsChangeType.ChangeCellMime?this._changeCellMime(a.index,a.mime):a.kind===C.NotebookCellsChangeType.ChangeCellMetadata?this._changeCellMetadata(a.index,a.metadata):a.kind===C.NotebookCellsChangeType.ChangeCellInternalMetadata&&this._changeCellInternalMetadata(a.index,a.internalMetadata)}_validateIndex(n){return n=n|0,n<0?0:n>=this._cells.length?this._cells.length-1:n}_validateRange(n){let f=n.start|0,a=n.end|0;return f<0&&(f=0),a>this._cells.length&&(a=this._cells.length),n.with({start:f,end:a})}_getCells(n){n=this._validateRange(n);const f=[];for(let a=n.start;a<n.end;a++)f.push(this._cells[a]);return f}async _save(){return this._disposed?Promise.reject(new Error("Notebook has been closed")):this._proxy.$trySaveNotebook(this.uri)}_spliceNotebookCells(n,f){if(this._disposed)return;const a=[],l=[],w=[];n.reverse().forEach(I=>{const o=I[2].map(i=>{const v=new P(this,this._textDocumentsAndEditors,i);return f||l.push(P.asModelAddData(this.apiNotebook,i)),v}),h=new _(I[0],I[1],[],o),y=this._cells.splice(I[0],I[1],...o);for(const i of y)w.push(i.uri),h.deletedItems.push(i.apiCell);a.push(h)}),this._textDocumentsAndEditors.acceptDocumentsAndEditorsDelta({addedDocuments:l,removedDocuments:w}),f||this._emitter.emitModelChange((0,M.deepFreeze)({document:this.apiNotebook,changes:_.asApiEvents(a)}))}_moveCell(n,f){const a=this._cells.splice(n,1);this._cells.splice(f,0,...a);const l=[new _(n,1,a.map(w=>w.apiCell),[]),new _(f,0,[],a)];this._emitter.emitModelChange((0,M.deepFreeze)({document:this.apiNotebook,changes:_.asApiEvents(l)}))}_setCellOutputs(n,f){const a=this._cells[n];a.setOutputs(f),this._emitter.emitCellOutputsChange((0,M.deepFreeze)({document:this.apiNotebook,cells:[a.apiCell]}))}_setCellOutputItems(n,f,a,l){const w=this._cells[n];w.setOutputItems(f,a,l),this._emitter.emitCellOutputsChange((0,M.deepFreeze)({document:this.apiNotebook,cells:[w.apiCell]}))}_changeCellLanguage(n,f){const a=this._cells[n];a.apiCell.document.languageId!==f&&this._textDocuments.$acceptModelModeChanged(a.uri,f)}_changeCellMime(n,f){const a=this._cells[n];a.apiCell.mime=f}_changeCellMetadata(n,f){const a=this._cells[n],l=a.apiCell.metadata;a.setMetadata(f);const w=a.apiCell.metadata;(0,M.equals)(l,w)||this._emitter.emitCellMetadataChange((0,M.deepFreeze)({document:this.apiNotebook,cell:a.apiCell}))}_changeCellInternalMetadata(n,f){const a=this._cells[n],l=a.internalMetadata;if(a.setInternalMetadata(f),l.runState!==f.runState){const w=f.runState??F.NotebookCellExecutionState.Idle;this._emitter.emitCellExecutionStateChange((0,M.deepFreeze)({document:this.apiNotebook,cell:a.apiCell,state:w}))}}getCellFromApiCell(n){return this._cells.find(f=>f.apiCell===n)}getCellFromIndex(n){return this._cells[n]}getCell(n){return this._cells.find(f=>f.handle===n)}getCellIndex(n){return this._cells.indexOf(n)}}e.ExtHostNotebookDocument=t,t._handlePool=0}),define(we[93],Ee([0,1,7,8,16]),function(re,e,c,M,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostNotebookEditor=void 0;class R{constructor(_){this._finalized=!1,this._collectedEdits=[],this._documentVersionId=_}finalize(){return this._finalized=!0,{documentVersionId:this._documentVersionId,cellEdits:this._collectedEdits}}_throwIfFinalized(){if(this._finalized)throw new Error("Edit is only valid while callback runs")}replaceMetadata(_){this._throwIfFinalized(),this._collectedEdits.push({editType:5,metadata:_})}replaceCellMetadata(_,P){this._throwIfFinalized(),this._collectedEdits.push({editType:8,index:_,metadata:P})}replaceCells(_,P,t){this._throwIfFinalized(),!(_===P&&t.length===0)&&this._collectedEdits.push({editType:1,index:_,count:P-_,cells:t.map(M.NotebookCellData.from)})}}class F{constructor(_,P,t,E,n,f){this.id=_,this._proxy=P,this.notebookData=t,this._selections=[],this._visibleRanges=[],this._visible=!1,this._hasDecorationsForKey=new Set,this._selections=n,this._visibleRanges=E,this._viewColumn=f}get apiEditor(){if(!this._editor){const _=this;this._editor={get document(){return _.notebookData.apiNotebook},get selections(){return _._selections},set selections(P){if(!Array.isArray(P)||!P.every(c.NotebookRange.isNotebookRange))throw(0,b.illegalArgument)("selections");_._selections=P,_._trySetSelections(P)},get visibleRanges(){return _._visibleRanges},revealRange(P,t){_._proxy.$tryRevealRange(_.id,M.NotebookRange.from(P),t??c.NotebookEditorRevealType.Default)},get viewColumn(){return _._viewColumn},edit(P){const t=new R(this.document.version);return P(t),_._applyEdit(t.finalize())},setDecorations(P,t){return _.setDecorations(P,t)}},F.apiEditorsToExtHost.set(this._editor,this)}return this._editor}get visible(){return this._visible}_acceptVisibility(_){this._visible=_}_acceptVisibleRanges(_){this._visibleRanges=_}_acceptSelections(_){this._selections=_}_trySetSelections(_){this._proxy.$trySetSelections(this.id,_.map(M.NotebookRange.from))}_acceptViewColumn(_){this._viewColumn=_}_applyEdit(_){if(_.cellEdits.length===0)return Promise.resolve(!0);const P=[];let t=-1;for(let E=0;E<_.cellEdits.length;E++){if(t<0){P.push(_.cellEdits[E]),t++;continue}const f=P[t],a=_.cellEdits[E];if(f.editType===1&&a.editType===1&&f.index===a.index){f.cells.push(..._.cellEdits[E].cells),f.count+=_.cellEdits[E].count;continue}P.push(_.cellEdits[E]),t++}return this._proxy.$tryApplyEdits(this.id,_.documentVersionId,P)}setDecorations(_,P){if(!(P.isEmpty&&!this._hasDecorationsForKey.has(_.key)))return P.isEmpty?this._hasDecorationsForKey.delete(_.key):this._hasDecorationsForKey.add(_.key),this._proxy.$trySetDecorations(this.id,M.NotebookRange.from(P),_.key)}}e.ExtHostNotebookEditor=F,F.apiEditorsToExtHost=new WeakMap}),define(we[172],Ee([0,1,8,147,126,21,52]),function(re,e,c,M,b,R,F){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostProgress=void 0;class C{constructor(E){this._handles=0,this._mapHandleToCancellationSource=new Map,this._proxy=E}withProgress(E,n,f){const a=this._handles++,{title:l,location:w,cancellable:I}=n,S={label:(0,b.localize)(0,null,E.displayName||E.name),id:E.identifier.value};return this._proxy.$startProgress(a,{location:c.ProgressLocation.from(w),title:l,source:S,cancellable:I},E),this._withProgress(a,f,!!I)}_withProgress(E,n,f){let a;f&&(a=new R.CancellationTokenSource,this._mapHandleToCancellationSource.set(E,a));const l=I=>{this._proxy.$progressEnd(I),this._mapHandleToCancellationSource.delete(I),a&&a.dispose()};let w;try{w=n(new P(this._proxy,E),f&&a?a.token:R.CancellationToken.None)}catch(I){throw l(E),I}return w.then(I=>l(E),I=>l(E)),w}$acceptProgressCanceled(E){const n=this._mapHandleToCancellationSource.get(E);n&&(n.cancel(),this._mapHandleToCancellationSource.delete(E))}}e.ExtHostProgress=C;function _(t,E){return t.message=E.message,typeof E.increment=="number"&&(typeof t.increment=="number"?t.increment+=E.increment:t.increment=E.increment),t}class P extends M.Progress{constructor(E,n){super(f=>this.throttledReport(f));this._proxy=E,this._handle=n}throttledReport(E){this._proxy.$progressReport(this._handle,E)}}We([(0,F.throttle)(100,(t,E)=>_(t,E),()=>Object.create(null))],P.prototype,"throttledReport",null)}),define(we[94],Ee([0,1,42,16,53,8,7]),function(re,e,c,M,b,R,F){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostTextEditor=e.ExtHostTextEditorOptions=e.TextEditorEdit=e.TextEditorDecorationType=void 0;class C{constructor(n,f,a){const l=C._Keys.nextId();n.$registerTextEditorDecorationType(f.identifier,l,R.DecorationRenderOptions.from(a)),this.value=Object.freeze({key:l,dispose(){n.$removeTextEditorDecorationType(l)}})}}e.TextEditorDecorationType=C,C._Keys=new b.IdGenerator("TextEditorDecorationType");class _{constructor(n,f){this._collectedEdits=[],this._setEndOfLine=void 0,this._finalized=!1,this._document=n,this._documentVersionId=n.version,this._undoStopBefore=f.undoStopBefore,this._undoStopAfter=f.undoStopAfter}finalize(){return this._finalized=!0,{documentVersionId:this._documentVersionId,edits:this._collectedEdits,setEndOfLine:this._setEndOfLine,undoStopBefore:this._undoStopBefore,undoStopAfter:this._undoStopAfter}}_throwIfFinalized(){if(this._finalized)throw new Error("Edit is only valid while callback runs")}replace(n,f){this._throwIfFinalized();let a=null;if(n instanceof F.Position)a=new F.Range(n,n);else if(n instanceof F.Range)a=n;else throw new Error("Unrecognized location");this._pushEdit(a,f,!1)}insert(n,f){this._throwIfFinalized(),this._pushEdit(new F.Range(n,n),f,!0)}delete(n){this._throwIfFinalized();let f=null;if(n instanceof F.Range)f=n;else throw new Error("Unrecognized location");this._pushEdit(f,null,!0)}_pushEdit(n,f,a){const l=this._document.validateRange(n);this._collectedEdits.push({range:l,text:f,forceMoveMarkers:a})}setEndOfLine(n){if(this._throwIfFinalized(),n!==F.EndOfLine.LF&&n!==F.EndOfLine.CRLF)throw(0,M.illegalArgument)("endOfLine");this._setEndOfLine=n}}e.TextEditorEdit=_;class P{constructor(n,f,a,l){this._proxy=n,this._id=f,this._accept(a),this._logService=l;const w=this;this.value={get tabSize(){return w._tabSize},set tabSize(I){w._setTabSize(I)},get insertSpaces(){return w._insertSpaces},set insertSpaces(I){w._setInsertSpaces(I)},get cursorStyle(){return w._cursorStyle},set cursorStyle(I){w._setCursorStyle(I)},get lineNumbers(){return w._lineNumbers},set lineNumbers(I){w._setLineNumbers(I)}}}_accept(n){this._tabSize=n.tabSize,this._insertSpaces=n.insertSpaces,this._cursorStyle=n.cursorStyle,this._lineNumbers=R.TextEditorLineNumbersStyle.to(n.lineNumbers)}_validateTabSize(n){if(n==="auto")return"auto";if(typeof n=="number"){const f=Math.floor(n);return f>0?f:null}if(typeof n=="string"){const f=parseInt(n,10);return isNaN(f)?null:f>0?f:null}return null}_setTabSize(n){const f=this._validateTabSize(n);if(f!==null){if(typeof f=="number"){if(this._tabSize===f)return;this._tabSize=f}this._warnOnError(this._proxy.$trySetOptions(this._id,{tabSize:f}))}}_validateInsertSpaces(n){return n==="auto"?"auto":n==="false"?!1:Boolean(n)}_setInsertSpaces(n){const f=this._validateInsertSpaces(n);if(typeof f=="boolean"){if(this._insertSpaces===f)return;this._insertSpaces=f}this._warnOnError(this._proxy.$trySetOptions(this._id,{insertSpaces:f}))}_setCursorStyle(n){this._cursorStyle!==n&&(this._cursorStyle=n,this._warnOnError(this._proxy.$trySetOptions(this._id,{cursorStyle:n})))}_setLineNumbers(n){this._lineNumbers!==n&&(this._lineNumbers=n,this._warnOnError(this._proxy.$trySetOptions(this._id,{lineNumbers:R.TextEditorLineNumbersStyle.from(n)})))}assign(n){const f={};let a=!1;if(typeof n.tabSize!="undefined"){const l=this._validateTabSize(n.tabSize);l==="auto"?(a=!0,f.tabSize=l):typeof l=="number"&&this._tabSize!==l&&(this._tabSize=l,a=!0,f.tabSize=l)}if(typeof n.insertSpaces!="undefined"){const l=this._validateInsertSpaces(n.insertSpaces);l==="auto"?(a=!0,f.insertSpaces=l):this._insertSpaces!==l&&(this._insertSpaces=l,a=!0,f.insertSpaces=l)}typeof n.cursorStyle!="undefined"&&this._cursorStyle!==n.cursorStyle&&(this._cursorStyle=n.cursorStyle,a=!0,f.cursorStyle=n.cursorStyle),typeof n.lineNumbers!="undefined"&&this._lineNumbers!==n.lineNumbers&&(this._lineNumbers=n.lineNumbers,a=!0,f.lineNumbers=R.TextEditorLineNumbersStyle.from(n.lineNumbers)),a&&this._warnOnError(this._proxy.$trySetOptions(this._id,f))}_warnOnError(n){n.catch(f=>this._logService.warn(f))}}e.ExtHostTextEditorOptions=P;class t{constructor(n,f,a,l,w,I,S,o){this.id=n,this._proxy=f,this._logService=a,this._disposed=!1,this._hasDecorationsForKey=new Set,this._selections=w,this._options=new P(this._proxy,this.id,I,a),this._visibleRanges=S,this._viewColumn=o;const h=this;this.value=Object.freeze({get document(){return l.getValue()},set document(y){throw(0,M.readonly)("document")},get selection(){return h._selections&&h._selections[0]},set selection(y){if(!(y instanceof F.Selection))throw(0,M.illegalArgument)("selection");h._selections=[y],h._trySetSelection()},get selections(){return h._selections},set selections(y){if(!Array.isArray(y)||y.some(i=>!(i instanceof F.Selection)))throw(0,M.illegalArgument)("selections");h._selections=y,h._trySetSelection()},get visibleRanges(){return h._visibleRanges},set visibleRanges(y){throw(0,M.readonly)("visibleRanges")},get options(){return h._options.value},set options(y){h._disposed||h._options.assign(y)},get viewColumn(){return h._viewColumn},set viewColumn(y){throw(0,M.readonly)("viewColumn")},edit(y,i={undoStopBefore:!0,undoStopAfter:!0}){if(h._disposed)return Promise.reject(new Error("TextEditor#edit not possible on closed editors"));const v=new _(l.getValue(),i);return y(v),h._applyEdit(v)},insertSnippet(y,i,v={undoStopBefore:!0,undoStopAfter:!0}){if(h._disposed)return Promise.reject(new Error("TextEditor#insertSnippet not possible on closed editors"));let r;if(!i||Array.isArray(i)&&i.length===0)r=h._selections.map(s=>R.Range.from(s));else if(i instanceof F.Position){const{lineNumber:s,column:u}=R.Position.from(i);r=[{startLineNumber:s,startColumn:u,endLineNumber:s,endColumn:u}]}else if(i instanceof F.Range)r=[R.Range.from(i)];else{r=[];for(const s of i)if(s instanceof F.Range)r.push(R.Range.from(s));else{const{lineNumber:u,column:d}=R.Position.from(s);r.push({startLineNumber:u,startColumn:d,endLineNumber:u,endColumn:d})}}return f.$tryInsertSnippet(n,y.value,r,v)},setDecorations(y,i){const v=i.length===0;v&&!h._hasDecorationsForKey.has(y.key)||(v?h._hasDecorationsForKey.delete(y.key):h._hasDecorationsForKey.add(y.key),h._runOnProxy(()=>{if(R.isDecorationOptionsArr(i))return f.$trySetDecorations(n,y.key,R.fromRangeOrRangeWithMessage(i));{const r=new Array(4*i.length);for(let s=0,u=i.length;s<u;s++){const d=i[s];r[4*s]=d.start.line+1,r[4*s+1]=d.start.character+1,r[4*s+2]=d.end.line+1,r[4*s+3]=d.end.character+1}return f.$trySetDecorationsFast(n,y.key,r)}}))},revealRange(y,i){h._runOnProxy(()=>f.$tryRevealRange(n,R.Range.from(y),i||F.TextEditorRevealType.Default))},show(y){f.$tryShowEditor(n,R.ViewColumn.from(y))},hide(){f.$tryHideEditor(n)}})}dispose(){(0,c.ok)(!this._disposed),this._disposed=!0}_acceptOptions(n){(0,c.ok)(!this._disposed),this._options._accept(n)}_acceptVisibleRanges(n){(0,c.ok)(!this._disposed),this._visibleRanges=n}_acceptViewColumn(n){(0,c.ok)(!this._disposed),this._viewColumn=n}_acceptSelections(n){(0,c.ok)(!this._disposed),this._selections=n}async _trySetSelection(){const n=this._selections.map(R.Selection.from);return await this._runOnProxy(()=>this._proxy.$trySetSelections(this.id,n)),this.value}_applyEdit(n){const f=n.finalize();if(f.edits.length===0&&!f.setEndOfLine)return Promise.resolve(!0);const a=f.edits.map(w=>w.range);a.sort((w,I)=>w.end.line===I.end.line?w.end.character===I.end.character?w.start.line===I.start.line?w.start.character-I.start.character:w.start.line-I.start.line:w.end.character-I.end.character:w.end.line-I.end.line);for(let w=0,I=a.length-1;w<I;w++){const S=a[w].end;if(a[w+1].start.isBefore(S))return Promise.reject(new Error("Overlapping ranges are not allowed!"))}const l=f.edits.map(w=>({range:R.Range.from(w.range),text:w.text,forceMoveMarkers:w.forceMoveMarkers}));return this._proxy.$tryApplyEdits(this.id,f.documentVersionId,l,{setEndOfLine:typeof f.setEndOfLine=="number"?R.EndOfLine.from(f.setEndOfLine):void 0,undoStopBefore:f.undoStopBefore,undoStopAfter:f.undoStopAfter})}_runOnProxy(n){return this._disposed?(this._logService.warn("TextEditor is closed/disposed"),Promise.resolve(void 0)):n().then(()=>this,f=>(f instanceof Error&&f.name==="DISPOSED"||this._logService.warn(f),null))}}e.ExtHostTextEditor=t}),define(we[173],Ee([0,1,129,24,2,3,6,161,14,7,10,12,8,21,158]),function(re,e,c,M,b,R,F,C,_,P,t,E,n,f,a){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostTreeViews=void 0;function l(S,o){if((0,t.isString)(S))return{label:S};if(S&&typeof S=="object"&&typeof S.label=="string"){let h;return Array.isArray(S.highlights)&&(h=S.highlights.filter(y=>y.length===2&&typeof y[0]=="number"&&typeof y[1]=="number"),h=h.length?h:void 0),{label:S.label,highlights:h}}}class w{constructor(o,h,y){this._proxy=o,this.commands=h,this.logService=y,this.treeViews=new Map;function i(v){return v&&v.$treeViewId&&v.$treeItemHandle}h.registerArgumentProcessor({processArgument:v=>i(v)?this.convertArgument(v):Array.isArray(v)&&v.length>0?v.map(r=>i(r)?this.convertArgument(r):r):v})}registerTreeDataProvider(o,h,y){const i=this.createTreeView(o,{treeDataProvider:h},y);return{dispose:()=>i.dispose()}}createTreeView(o,h,y){if(!h||!h.treeDataProvider)throw new Error("Options with treeDataProvider is mandatory");const i=h.dragAndDropController!==void 0,v=this._proxy.$registerTreeViewDataProvider(o,{showCollapseAll:!!h.showCollapseAll,canSelectMany:!!h.canSelectMany,canDragAndDrop:i}),r=this.createExtHostTreeView(o,h,y);return{get onDidCollapseElement(){return r.onDidCollapseElement},get onDidExpandElement(){return r.onDidExpandElement},get selection(){return r.selectedElements},get onDidChangeSelection(){return r.onDidChangeSelection},get visible(){return r.visible},get onDidChangeVisibility(){return r.onDidChangeVisibility},get message(){return r.message},set message(s){r.message=s},get title(){return r.title},set title(s){r.title=s},get description(){return r.description},set description(s){r.description=s},reveal:(s,u)=>r.reveal(s,u),dispose:async()=>{await v,this.treeViews.delete(o),r.dispose()}}}$getChildren(o,h){const y=this.treeViews.get(o);return y?y.getChildren(h):Promise.reject(new Error((0,c.localize)(0,null,o)))}async $onDrop(o,h,y){const i=this.treeViews.get(o);if(!i)return Promise.reject(new Error((0,c.localize)(1,null,o)));const v=a.TreeDataTransferConverter.toITreeDataTransfer(h);if(v.items.has(C.TREE_ITEM_DATA_TRANSFER_TYPE)){const s=JSON.parse(await v.items.get(C.TREE_ITEM_DATA_TRANSFER_TYPE).asString()).map(u=>i.getExtensionElement(u)).filter(u=>!!u);s.length>0?v.items.set(C.TREE_ITEM_DATA_TRANSFER_TYPE,{asString:async()=>JSON.stringify(s)}):v.items.delete(C.TREE_ITEM_DATA_TRANSFER_TYPE)}return i.onDrop(v,y)}async $hasResolve(o){const h=this.treeViews.get(o);if(!h)throw new Error((0,c.localize)(2,null,o));return h.hasResolve}$resolve(o,h,y){const i=this.treeViews.get(o);if(!i)throw new Error((0,c.localize)(3,null,o));return i.resolveTreeItem(h,y)}$setExpanded(o,h,y){const i=this.treeViews.get(o);if(!i)throw new Error((0,c.localize)(4,null,o));i.setExpanded(h,y)}$setSelection(o,h){const y=this.treeViews.get(o);if(!y)throw new Error((0,c.localize)(5,null,o));y.setSelection(h)}$setVisible(o,h){const y=this.treeViews.get(o);if(!y)throw new Error((0,c.localize)(6,null,o));y.setVisible(h)}createExtHostTreeView(o,h,y){const i=new I(o,h,this._proxy,this.commands.converter,this.logService,y);return this.treeViews.set(o,i),i}convertArgument(o){const h=this.treeViews.get(o.$treeViewId);return h?h.getExtensionElement(o.$treeItemHandle):null}}e.ExtHostTreeViews=w;class I extends F.Disposable{constructor(o,h,y,i,v,r){super();if(this.viewId=o,this.proxy=y,this.commands=i,this.logService=v,this.extension=r,this.roots=void 0,this.elements=new Map,this.nodes=new Map,this._visible=!1,this._selectedHandles=[],this._onDidExpandElement=this._register(new R.Emitter),this.onDidExpandElement=this._onDidExpandElement.event,this._onDidCollapseElement=this._register(new R.Emitter),this.onDidCollapseElement=this._onDidCollapseElement.event,this._onDidChangeSelection=this._register(new R.Emitter),this.onDidChangeSelection=this._onDidChangeSelection.event,this._onDidChangeVisibility=this._register(new R.Emitter),this.onDidChangeVisibility=this._onDidChangeVisibility.event,this._onDidChangeData=this._register(new R.Emitter),this.refreshPromise=Promise.resolve(),this.refreshQueue=Promise.resolve(),this._message="",this._title="",this._refreshCancellationSource=new f.CancellationTokenSource,r.contributes&&r.contributes.views)for(const d in r.contributes.views)for(const p of r.contributes.views[d])p.id===o&&(this._title=p.name);this.dataProvider=h.treeDataProvider,this.dndController=h.dragAndDropController,this.dataProvider.onDidChangeTreeData2?this._register(this.dataProvider.onDidChangeTreeData2(d=>this._onDidChangeData.fire({message:!1,element:d}))):this.dataProvider.onDidChangeTreeData&&this._register(this.dataProvider.onDidChangeTreeData(d=>this._onDidChangeData.fire({message:!1,element:d})));let s,u;this._register(R.Event.debounce(this._onDidChangeData.event,(d,p)=>(d||(d={message:!1,elements:[]}),p.element!==!1&&(s||(s=new Promise(k=>u=k),this.refreshPromise=this.refreshPromise.then(()=>s)),Array.isArray(p.element)?d.elements.push(...p.element):d.elements.push(p.element)),p.message&&(d.message=!0),d),200,!0)(({message:d,elements:p})=>{p.length&&(this.refreshQueue=this.refreshQueue.then(()=>{const k=u;return s=null,this.refresh(p).then(()=>k())})),d&&this.proxy.$setMessage(this.viewId,this._message)}))}get visible(){return this._visible}get selectedElements(){return this._selectedHandles.map(o=>this.getExtensionElement(o)).filter(o=>!(0,t.isUndefinedOrNull)(o))}async getChildren(o){const h=o?this.getExtensionElement(o):void 0;if(o&&!h)return this.logService.error(`No tree item with id '${o}' found.`),Promise.resolve([]);let y=this.getChildrenNodes(o);return y||(y=await this.fetchChildrenNodes(h)),y?y.map(i=>i.item):void 0}getExtensionElement(o){return this.elements.get(o)}reveal(o,h){h=h||{select:!0,focus:!1};const y=(0,t.isUndefinedOrNull)(h.select)?!0:h.select,i=(0,t.isUndefinedOrNull)(h.focus)?!1:h.focus,v=(0,t.isUndefinedOrNull)(h.expand)?!1:h.expand;return typeof this.dataProvider.getParent!="function"?Promise.reject(new Error("Required registered TreeDataProvider to implement 'getParent' method to access 'reveal' method")):o?this.refreshPromise.then(()=>this.resolveUnknownParentChain(o)).then(r=>this.resolveTreeNode(o,r[r.length-1]).then(s=>this.proxy.$reveal(this.viewId,{item:s.item,parentChain:r.map(u=>u.item)},{select:y,focus:i,expand:v})),r=>this.logService.error(r)):this.proxy.$reveal(this.viewId,void 0,{select:y,focus:i,expand:v})}get message(){return this._message}set message(o){this._message=o,this._onDidChangeData.fire({message:!0,element:!1})}get title(){return this._title}set title(o){this._title=o,this.proxy.$setTitle(this.viewId,o,this._description)}get description(){return this._description}set description(o){this._description=o,this.proxy.$setTitle(this.viewId,this._title,o)}setExpanded(o,h){const y=this.getExtensionElement(o);y&&(h?this._onDidExpandElement.fire(Object.freeze({element:y})):this._onDidCollapseElement.fire(Object.freeze({element:y})))}setSelection(o){(0,E.equals)(this._selectedHandles,o)||(this._selectedHandles=o,this._onDidChangeSelection.fire(Object.freeze({selection:this.selectedElements})))}setVisible(o){o!==this._visible&&(this._visible=o,this._onDidChangeVisibility.fire(Object.freeze({visible:this._visible})))}async onDrop(o,h){const y=this.getExtensionElement(h);if(!!y)return(0,_.asPromise)(()=>this.dndController?.onDrop(o,y))}get hasResolve(){return!!this.dataProvider.resolveTreeItem}async resolveTreeItem(o,h){if(!this.dataProvider.resolveTreeItem)return;const y=this.elements.get(o);if(y){const i=this.nodes.get(y);if(i){const v=await this.dataProvider.resolveTreeItem(i.extensionItem,y,h)??i.extensionItem;return i.item.tooltip=this.getTooltip(v.tooltip),i.item.command=this.getCommand(i.disposableStore,v.command),i.item}}}resolveUnknownParentChain(o){return this.resolveParent(o).then(h=>h?this.resolveUnknownParentChain(h).then(y=>this.resolveTreeNode(h,y[y.length-1]).then(i=>(y.push(i),y))):Promise.resolve([]))}resolveParent(o){const h=this.nodes.get(o);return h?Promise.resolve(h.parent?this.elements.get(h.parent.item.handle):void 0):(0,_.asPromise)(()=>this.dataProvider.getParent(o))}resolveTreeNode(o,h){const y=this.nodes.get(o);return y?Promise.resolve(y):(0,_.asPromise)(()=>this.dataProvider.getTreeItem(o)).then(i=>this.createHandle(o,i,h,!0)).then(i=>this.getChildren(h?h.item.handle:void 0).then(()=>{const v=this.getExtensionElement(i);if(v){const r=this.nodes.get(v);if(r)return Promise.resolve(r)}throw new Error(`Cannot resolve tree item for element ${i}`)}))}getChildrenNodes(o){if(o){let h;if(typeof o=="string"){const y=this.getExtensionElement(o);h=y?this.nodes.get(y):void 0}else h=o;return h&&h.children||void 0}return this.roots}async fetchChildrenNodes(o){this.clearChildren(o);const h=new f.CancellationTokenSource(this._refreshCancellationSource.token);try{const y=o?this.nodes.get(o):void 0,i=await this.dataProvider.getChildren(o);if(h.token.isCancellationRequested)return;const v=await Promise.all((0,E.coalesce)(i||[]).map(async r=>{const s=await this.dataProvider.getTreeItem(r);return s&&!h.token.isCancellationRequested?this.createAndRegisterTreeNode(r,s,y):null}));return h.token.isCancellationRequested?void 0:(0,E.coalesce)(v)}finally{h.dispose()}}refresh(o){if(o.some(y=>!y))return this._refreshCancellationSource.dispose(!0),this._refreshCancellationSource=new f.CancellationTokenSource,this.clearAll(),this.proxy.$refresh(this.viewId);{const y=this.getHandlesToRefresh(o);if(y.length)return this.refreshHandles(y)}return Promise.resolve(void 0)}getHandlesToRefresh(o){const h=new Set,y=o.map(v=>this.nodes.get(v));for(const v of y)if(v&&!h.has(v.item.handle)){let r=v;for(;r&&r.parent&&y.findIndex(s=>r&&r.parent&&s&&s.item.handle===r.parent.item.handle)===-1;){const s=this.elements.get(r.parent.item.handle);r=s?this.nodes.get(s):void 0}r&&!r.parent&&h.add(v.item.handle)}const i=[];return h.forEach(v=>{const r=this.elements.get(v);if(r){const s=this.nodes.get(r);s&&(!s.parent||!h.has(s.parent.item.handle))&&i.push(v)}}),i}refreshHandles(o){const h={};return Promise.all(o.map(y=>this.refreshNode(y).then(i=>{i&&(h[y]=i.item)}))).then(()=>Object.keys(h).length?this.proxy.$refresh(this.viewId,h):void 0)}refreshNode(o){const h=this.getExtensionElement(o);if(h){const y=this.nodes.get(h);if(y)return this.clearChildren(h),(0,_.asPromise)(()=>this.dataProvider.getTreeItem(h)).then(i=>{if(i){const v=this.createTreeNode(h,i,y.parent);return this.updateNodeCache(h,v,y,y.parent),y.dispose(),v}return null})}return Promise.resolve(null)}createAndRegisterTreeNode(o,h,y){const i=this.createTreeNode(o,h,y);if(h.id&&this.elements.has(i.item.handle))throw new Error((0,c.localize)(7,null,h.id));return this.addNodeToCache(o,i),this.addNodeToParentCache(i,y),i}getTooltip(o){return P.MarkdownString.isMarkdownString(o)?n.MarkdownString.from(o):o}getCommand(o,h){return h?this.commands.toInternal(h,o):void 0}createTreeNode(o,h,y){const i=new F.DisposableStore,v=this.createHandle(o,h,y),r=this.getLightIconPath(h);return{item:{handle:v,parentHandle:y?y.item.handle:void 0,label:l(h.label,this.extension),description:h.description,resourceUri:h.resourceUri,tooltip:this.getTooltip(h.tooltip),command:this.getCommand(i,h.command),contextValue:h.contextValue,icon:r,iconDark:this.getDarkIconPath(h)||r,themeIcon:this.getThemeIcon(h),collapsibleState:(0,t.isUndefinedOrNull)(h.collapsibleState)?P.TreeItemCollapsibleState.None:h.collapsibleState,accessibilityInformation:h.accessibilityInformation},extensionItem:h,parent:y,children:void 0,disposableStore:i,dispose(){i.dispose()}}}getThemeIcon(o){return o.iconPath instanceof P.ThemeIcon?o.iconPath:void 0}createHandle(o,{id:h,label:y,resourceUri:i},v,r){if(h)return`${I.ID_HANDLE_PREFIX}/${h}`;const s=l(y,this.extension),u=v?v.item.handle:I.LABEL_HANDLE_PREFIX;let d=s?s.label:i?(0,M.basename)(i):"";d=d.indexOf("/")!==-1?d.replace("/","//"):d;const p=this.nodes.has(o)?this.nodes.get(o).item.handle:void 0,k=this.getChildrenNodes(v)||[];let T,g=0;do{if(T=`${u}/${g}:${d}`,r||!this.elements.has(T)||p===T)break;g++}while(g<=k.length);return T}getLightIconPath(o){if(o.iconPath&&!(o.iconPath instanceof P.ThemeIcon))return typeof o.iconPath=="string"||b.URI.isUri(o.iconPath)?this.getIconPath(o.iconPath):this.getIconPath(o.iconPath.light)}getDarkIconPath(o){if(o.iconPath&&!(o.iconPath instanceof P.ThemeIcon)&&o.iconPath.dark)return this.getIconPath(o.iconPath.dark)}getIconPath(o){return b.URI.isUri(o)?o:b.URI.file(o)}addNodeToCache(o,h){this.elements.set(h.item.handle,o),this.nodes.set(o,h)}updateNodeCache(o,h,y,i){this.elements.delete(h.item.handle),this.nodes.delete(o),h.item.handle!==y.item.handle&&this.elements.delete(y.item.handle),this.addNodeToCache(o,h);const v=this.getChildrenNodes(i)||[],r=v.filter(s=>s.item.handle===y.item.handle)[0];r&&v.splice(v.indexOf(r),1,h)}addNodeToParentCache(o,h){h?(h.children||(h.children=[]),h.children.push(o)):(this.roots||(this.roots=[]),this.roots.push(o))}clearChildren(o){if(o){const h=this.nodes.get(o);if(h){if(h.children)for(const y of h.children){const i=this.elements.get(y.item.handle);i&&this.clear(i)}h.children=void 0}}else this.clearAll()}clear(o){const h=this.nodes.get(o);if(h){if(h.children)for(const y of h.children){const i=this.elements.get(y.item.handle);i&&this.clear(i)}this.nodes.delete(o),this.elements.delete(h.item.handle),h.dispose()}}clearAll(){this.roots=void 0,this.elements.clear(),this.nodes.forEach(o=>o.dispose()),this.nodes.clear()}dispose(){this._refreshCancellationSource.dispose(),this.clearAll()}}I.LABEL_HANDLE_PREFIX="0",I.ID_HANDLE_PREFIX="1"}),define(we[174],Ee([0,1,14,3,6,10,48,8,90,67]),function(re,e,c,M,b,R,F,C,_,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.SingleUseTestCollection=void 0;class t extends b.Disposable{constructor(n){super();this.controllerId=n,this.debounceSendDiff=this._register(new c.RunOnceScheduler(()=>this.flushDiff(),200)),this.diffOpEmitter=this._register(new M.Emitter),this.root=new F.TestItemRootImpl(this.controllerId,this.controllerId),this.tree=new Map,this.tags=new Map,this.diff=[],this.onDidGenerateDiff=this.diffOpEmitter.event,this.root.canResolveChildren=!0,this.upsertItem(this.root,void 0)}set resolveHandler(n){this._resolveHandler=n;for(const f of this.tree.values())this.updateExpandability(f)}collectDiff(){const n=this.diff;return this.diff=[],n}pushDiff(n){const f=this.diff[this.diff.length-1];if(f&&n[0]===1){if(f[0]===1&&f[1].extId===n[1].extId){(0,_.applyTestItemUpdate)(f[1],n[1]);return}if(f[0]===0&&f[1].item.extId===n[1].extId){(0,_.applyTestItemUpdate)(f[1],n[1]);return}}this.diff.push(n),this.debounceSendDiff.isScheduled()||this.debounceSendDiff.schedule()}expand(n,f){const a=this.tree.get(n);if(!!a){if((a.expandLevels===void 0||f>a.expandLevels)&&(a.expandLevels=f),a.expand===1){const l=this.resolveChildren(a);return l.isOpen()?this.expandChildren(a,f-1):l.wait().then(()=>this.expandChildren(a,f-1))}else if(a.expand===3)return a.resolveBarrier?.isOpen()===!1?a.resolveBarrier.wait().then(()=>this.expandChildren(a,f-1)):this.expandChildren(a,f-1)}}dispose(){for(const n of this.tree.values())(0,F.getPrivateApiFor)(n.actual).listener=void 0;this.tree.clear(),this.diff=[],super.dispose()}onTestItemEvent(n,f){switch(f.op){case 2:this.pushDiff([4,n.fullId.toString()]);break;case 1:this.removeItem(P.TestId.joinToString(n.fullId,f.id));break;case 0:this.upsertItem(f.item,n);break;case 4:for(const S of f.ops)this.onTestItemEvent(n,S);break;case 3:const{key:a,value:l,previous:w}=f,I=n.fullId.toString();switch(a){case"canResolveChildren":this.updateExpandability(n);break;case"tags":this.diffTagRefs(l,w,I);break;case"range":this.pushDiff([1,{extId:I,item:{range:C.Range.from(l)}}]);break;case"error":this.pushDiff([1,{extId:I,item:{error:C.MarkdownString.fromStrict(l)||null}}]);break;default:this.pushDiff([1,{extId:I,item:{[a]:l??null}}]);break}break;default:(0,R.assertNever)(f)}}upsertItem(n,f){if(!(n instanceof F.TestItemImpl))throw new Error(`TestItems provided to the VS Code API must extend \`vscode.TestItem\`, but ${n.id} did not`);const a=P.TestId.fromExtHostTestItem(n,this.root.id,f?.actual),l=(0,F.getPrivateApiFor)(n);l.parent&&l.parent!==f?.actual&&l.parent.children.delete(n.id);let w=this.tree.get(a.toString());if(!w){w={fullId:a,actual:n,parent:f?a.parentId:null,expandLevels:f?.expandLevels?f.expandLevels-1:void 0,expand:0},n.tags.forEach(this.incrementTagRefs,this),this.tree.set(w.fullId.toString(),w),this.setItemParent(n,f),this.pushDiff([0,{parent:w.parent&&w.parent.toString(),controllerId:this.controllerId,expand:w.expand,item:C.TestItem.from(n)}]),this.connectItemAndChildren(n,w,f);return}if(w.actual===n){this.connectItem(n,w,f);return}const I=w.actual.children,S=w.actual,o=(0,F.diffTestItems)(S,n);(0,F.getPrivateApiFor)(S).listener=void 0,w.actual=n,w.expand=0;for(const[h,y]of o)this.onTestItemEvent(w,{op:3,key:h,value:y,previous:S[h]});this.connectItemAndChildren(n,w,f);for(const h of I)n.children.get(h.id)||this.removeItem(P.TestId.joinToString(a,h.id))}diffTagRefs(n,f,a){const l=new Set(f.map(w=>w.id));for(const w of n)l.delete(w.id)||this.incrementTagRefs(w);this.pushDiff([1,{extId:a,item:{tags:n.map(w=>C.TestTag.namespace(this.controllerId,w.id))}}]),l.forEach(this.decrementTagRefs,this)}incrementTagRefs(n){const f=this.tags.get(n.id);f?f.refCount++:(this.tags.set(n.id,{refCount:1}),this.pushDiff([5,{id:C.TestTag.namespace(this.controllerId,n.id),ctrlLabel:this.root.label}]))}decrementTagRefs(n){const f=this.tags.get(n);f&&!--f.refCount&&(this.tags.delete(n),this.pushDiff([6,C.TestTag.namespace(this.controllerId,n)]))}setItemParent(n,f){(0,F.getPrivateApiFor)(n).parent=f&&f.actual!==this.root?f.actual:void 0}connectItem(n,f,a){this.setItemParent(n,a);const l=(0,F.getPrivateApiFor)(n);l.parent=a?.actual,l.listener=w=>this.onTestItemEvent(f,w),this.updateExpandability(f)}connectItemAndChildren(n,f,a){this.connectItem(n,f,a);for(const l of n.children)this.upsertItem(l,f)}updateExpandability(n){let f;this._resolveHandler?n.resolveBarrier?f=n.resolveBarrier.isOpen()?3:2:f=n.actual.canResolveChildren?1:0:f=0,f!==n.expand&&(n.expand=f,this.pushDiff([1,{extId:n.fullId.toString(),expand:f}]),f===1&&n.expandLevels!==void 0&&this.resolveChildren(n))}expandChildren(n,f){if(f<0)return;const a=[];for(const l of n.actual.children){const w=this.expand(P.TestId.joinToString(n.fullId,l.id),f);(0,c.isThenable)(w)&&a.push(w)}if(a.length)return Promise.all(a).then(()=>{})}resolveChildren(n){if(n.resolveBarrier)return n.resolveBarrier;if(!this._resolveHandler){const w=new c.Barrier;return w.open(),w}n.expand=2,this.pushExpandStateUpdate(n);const f=n.resolveBarrier=new c.Barrier,a=w=>{console.error(`Unhandled error in resolveHandler of test controller "${this.controllerId}"`),n.actual!==this.root&&(n.actual.error=w.stack||w.message||String(w))};let l;try{l=this._resolveHandler(n.actual===this.root?void 0:n.actual)}catch(w){a(w)}return(0,c.isThenable)(l)?l.catch(a).then(()=>{f.open(),this.updateExpandability(n)}):(f.open(),this.updateExpandability(n)),n.resolveBarrier}pushExpandStateUpdate(n){this.pushDiff([1,{extId:n.fullId.toString(),expand:n.expand}])}removeItem(n){const f=this.tree.get(n);if(!f)throw new Error("attempting to remove non-existent child");this.pushDiff([2,n]);const a=[f];for(;a.length;){const l=a.pop();if(!!l){(0,F.getPrivateApiFor)(l.actual).listener=void 0;for(const w of l.actual.tags)this.decrementTagRefs(w.id);this.tree.delete(l.fullId.toString());for(const w of l.actual.children)a.push(this.tree.get(P.TestId.joinToString(l.fullId,w.id)))}}}flushDiff(){const n=this.collectDiff();n.length&&this.diffOpEmitter.fire(n)}}e.SingleUseTestCollection=t}),define(we[175],Ee([0,1,4,142]),function(re,e,c,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IWorkbenchEnvironmentService=void 0,e.IWorkbenchEnvironmentService=(0,c.refineServiceDecorator)(M.IEnvironmentService)}),define(we[176],Ee([0,1,25,3,17]),function(re,e,c,M,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionDescriptionRegistry=e.DeltaExtensionsResult=void 0;class R{constructor(t){this.removedDueToLooping=t}}e.DeltaExtensionsResult=R;class F{constructor(t){this._onDidChange=new M.Emitter,this.onDidChange=this._onDidChange.event,this._extensionDescriptions=t,this._initialize()}_initialize(){this._extensionDescriptions.sort(_),this._extensionsMap=new Map,this._extensionsArr=[],this._activationMap=new Map;for(const t of this._extensionDescriptions){if(this._extensionsMap.has(c.ExtensionIdentifier.toKey(t.identifier))){console.error("Extension `"+t.identifier.value+"` is already registered");continue}if(this._extensionsMap.set(c.ExtensionIdentifier.toKey(t.identifier),t),this._extensionsArr.push(t),Array.isArray(t.activationEvents))for(let E of t.activationEvents)E==="onUri"&&(E=`onUri:${c.ExtensionIdentifier.toKey(t.identifier)}`),this._activationMap.has(E)||this._activationMap.set(E,[]),this._activationMap.get(E).push(t)}}keepOnly(t){const E=new Set;t.forEach(n=>E.add(c.ExtensionIdentifier.toKey(n))),this._extensionDescriptions=this._extensionDescriptions.filter(n=>E.has(c.ExtensionIdentifier.toKey(n.identifier))),this._initialize(),this._onDidChange.fire(void 0)}deltaExtensions(t,E){t.length>0&&(this._extensionDescriptions=this._extensionDescriptions.concat(t));const n=F._findLoopingExtensions(this._extensionDescriptions);if(E=E.concat(n.map(f=>f.identifier)),E.length>0){const f=new Set;E.forEach(a=>f.add(c.ExtensionIdentifier.toKey(a))),this._extensionDescriptions=this._extensionDescriptions.filter(a=>!f.has(c.ExtensionIdentifier.toKey(a.identifier)))}return this._initialize(),this._onDidChange.fire(void 0),new R(n)}static _findLoopingExtensions(t){const E=new class{constructor(){this._arcs=new Map,this._nodesSet=new Set,this._nodesArr=[]}addNode(w){this._nodesSet.has(w)||(this._nodesSet.add(w),this._nodesArr.push(w))}addArc(w,I){this.addNode(w),this.addNode(I),this._arcs.has(w)?this._arcs.get(w).push(I):this._arcs.set(w,[I])}getArcs(w){return this._arcs.has(w)?this._arcs.get(w):[]}hasOnlyGoodArcs(w,I){const S=E.getArcs(w);for(let o=0;o<S.length;o++)if(!I.has(S[o]))return!1;return!0}getNodes(){return this._nodesArr}};let n=new Map;for(let w of t){const I=c.ExtensionIdentifier.toKey(w.identifier);if(n.set(I,w),w.extensionDependencies)for(let S of w.extensionDependencies){const o=c.ExtensionIdentifier.toKey(S);E.addArc(I,o)}}let f=new Set;E.getNodes().filter(w=>E.getArcs(w).length===0).forEach(w=>f.add(w));let a=E.getNodes().filter(w=>!f.has(w)),l;do{l=!1;for(let w=0;w<a.length;w++){const I=a[w];E.hasOnlyGoodArcs(I,f)&&(a.splice(w,1),w--,f.add(I),l=!0)}}while(l);return a.map(w=>n.get(w))}containsActivationEvent(t){return this._activationMap.has(t)}containsExtension(t){return this._extensionsMap.has(c.ExtensionIdentifier.toKey(t))}getExtensionDescriptionsForActivationEvent(t){const E=this._activationMap.get(t);return E?E.slice(0):[]}getAllExtensionDescriptions(){return this._extensionsArr.slice(0)}getExtensionDescription(t){const E=this._extensionsMap.get(c.ExtensionIdentifier.toKey(t));return E||void 0}}e.ExtensionDescriptionRegistry=F;var C;(function(P){P[P.Builtin=0]="Builtin",P[P.User=1]="User",P[P.Dev=2]="Dev"})(C||(C={}));function _(P,t){const E=P.isBuiltin?0:P.isUnderDevelopment?2:1,n=t.isBuiltin?0:t.isUnderDevelopment?2:1;if(E!==n)return E-n;const f=b.posix.basename(P.extensionLocation.path),a=b.posix.basename(t.extensionLocation.path);return f<a?-1:f>a?1:0}}),define(we[177],Ee([0,1,22]),function(re,e,c){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.isMessageOfType=e.createMessageOfType=e.MessageType=e.ExtensionHostExitCode=void 0;var M;(function(C){C[C.VersionMismatch=55]="VersionMismatch",C[C.UnexpectedError=81]="UnexpectedError"})(M=e.ExtensionHostExitCode||(e.ExtensionHostExitCode={}));var b;(function(C){C[C.Initialized=0]="Initialized",C[C.Ready=1]="Ready",C[C.Terminate=2]="Terminate"})(b=e.MessageType||(e.MessageType={}));function R(C){const _=c.VSBuffer.alloc(1);switch(C){case 0:_.writeUInt8(1,0);break;case 1:_.writeUInt8(2,0);break;case 2:_.writeUInt8(3,0);break}return _}e.createMessageOfType=R;function F(C,_){if(C.byteLength!==1)return!1;switch(C.readUInt8(0)){case 1:return _===0;case 2:return _===1;case 3:return _===2;default:return!1}}e.isMessageOfType=F}),define(we[30],Ee([0,1,3,2,4,25,143]),function(re,e,c,M,b,R,F){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.NullExtensionService=e.toExtensionDescription=e.toExtension=e.throwProposedApiError=e.checkProposedApiEnabled=e.ActivationKind=e.ExtensionHostLogFileName=e.ExtensionPointContribution=e.ActivationTimes=e.extensionHostKindToString=e.ExtensionHostKind=e.MissingExtensionDependency=e.extensionRunningLocationToString=e.ExtensionRunningLocation=e.IExtensionService=e.webWorkerExtHostConfig=e.nullExtensionDescription=void 0,e.nullExtensionDescription=Object.freeze({identifier:new R.ExtensionIdentifier("nullExtensionDescription"),name:"Null Extension Description",version:"0.0.0",publisher:"vscode",enableProposedApi:!1,engines:{vscode:""},extensionLocation:M.URI.parse("void:location"),isBuiltin:!1}),e.webWorkerExtHostConfig="extensions.webWorker",e.IExtensionService=(0,b.createDecorator)("extensionService");var C;(function(h){h[h.None=0]="None",h[h.LocalProcess=1]="LocalProcess",h[h.LocalWebWorker=2]="LocalWebWorker",h[h.Remote=3]="Remote"})(C=e.ExtensionRunningLocation||(e.ExtensionRunningLocation={}));function _(h){switch(h){case 0:return"None";case 1:return"LocalProcess";case 2:return"LocalWebWorker";case 3:return"Remote"}}e.extensionRunningLocationToString=_;class P{constructor(y){this.dependency=y}}e.MissingExtensionDependency=P;var t;(function(h){h[h.LocalProcess=0]="LocalProcess",h[h.LocalWebWorker=1]="LocalWebWorker",h[h.Remote=2]="Remote"})(t=e.ExtensionHostKind||(e.ExtensionHostKind={}));function E(h){switch(h){case 0:return"LocalProcess";case 1:return"LocalWebWorker";case 2:return"Remote"}}e.extensionHostKindToString=E;class n{constructor(y,i,v,r){this.codeLoadingTime=y,this.activateCallTime=i,this.activateResolvedTime=v,this.activationReason=r}}e.ActivationTimes=n;class f{constructor(y,i){this.description=y,this.value=i}}e.ExtensionPointContribution=f,e.ExtensionHostLogFileName="exthost";var a;(function(h){h[h.Normal=0]="Normal",h[h.Immediate=1]="Immediate"})(a=e.ActivationKind||(e.ActivationKind={}));function l(h){h.enableProposedApi||w(h)}e.checkProposedApiEnabled=l;function w(h){throw new Error(`[${h.identifier.value}]: Proposed API is only available when running out of dev or with the following command line switch: --enable-proposed-api ${h.identifier.value}`)}e.throwProposedApiError=w;function I(h){return{type:h.isBuiltin?0:1,isBuiltin:h.isBuiltin||h.isUserBuiltin,identifier:{id:(0,F.getGalleryExtensionId)(h.publisher,h.name),uuid:h.uuid},manifest:h,location:h.extensionLocation}}e.toExtension=I;function S(h,y){return{identifier:new R.ExtensionIdentifier(h.identifier.id),isBuiltin:h.type===0,isUserBuiltin:h.type===1&&h.isBuiltin,isUnderDevelopment:!!y,extensionLocation:h.location,...h.manifest,uuid:h.identifier.uuid}}e.toExtensionDescription=S;class o{constructor(){this.onDidRegisterExtensions=c.Event.None,this.onDidChangeExtensionsStatus=c.Event.None,this.onDidChangeExtensions=c.Event.None,this.onWillActivateByEvent=c.Event.None,this.onDidChangeResponsiveChange=c.Event.None}activateByEvent(y){return Promise.resolve(void 0)}whenInstalledExtensionsRegistered(){return Promise.resolve(!0)}getExtensions(){return Promise.resolve([])}getExtension(){return Promise.resolve(void 0)}readExtensionPointContributions(y){return Promise.resolve(Object.create(null))}getExtensionsStatus(){return Object.create(null)}getInspectPort(y){return Promise.resolve(0)}stopExtensionHosts(){}async restartExtensionHost(){}async startExtensionHosts(){}async setRemoteEnvironment(y){}canAddExtension(){return!1}canRemoveExtension(){return!1}_activateById(y,i){return Promise.resolve()}_onWillActivateExtension(y){}_onDidActivateExtension(y,i,v,r,s){}_onDidActivateExtensionError(y,i){}_onExtensionRuntimeError(y,i){}_onExtensionHostExit(y){}}e.NullExtensionService=o}),define(we[178],Ee([0,1,25,30,15]),function(re,e,c,M,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionsActivator=e.FailedExtension=e.HostExtension=e.EmptyExtension=e.ActivatedExtension=e.ExtensionActivationTimesBuilder=e.ExtensionActivationTimes=void 0;const R=Promise.resolve(void 0);class F{constructor(a,l,w,I){this.startup=a,this.codeLoadingTime=l,this.activateCallTime=w,this.activateResolvedTime=I}}e.ExtensionActivationTimes=F,F.NONE=new F(!1,-1,-1,-1);class C{constructor(a){this._startup=a,this._codeLoadingStart=-1,this._codeLoadingStop=-1,this._activateCallStart=-1,this._activateCallStop=-1,this._activateResolveStart=-1,this._activateResolveStop=-1}_delta(a,l){return a===-1||l===-1?-1:l-a}build(){return new F(this._startup,this._delta(this._codeLoadingStart,this._codeLoadingStop),this._delta(this._activateCallStart,this._activateCallStop),this._delta(this._activateResolveStart,this._activateResolveStop))}codeLoadingStart(){this._codeLoadingStart=Date.now()}codeLoadingStop(){this._codeLoadingStop=Date.now()}activateCallStart(){this._activateCallStart=Date.now()}activateCallStop(){this._activateCallStop=Date.now()}activateResolveStart(){this._activateResolveStart=Date.now()}activateResolveStop(){this._activateResolveStop=Date.now()}}e.ExtensionActivationTimesBuilder=C;class _{constructor(a,l,w,I,S,o){this.activationFailed=a,this.activationFailedError=l,this.activationTimes=w,this.module=I,this.exports=S,this.subscriptions=o}}e.ActivatedExtension=_;class P extends _{constructor(a){super(!1,null,a,{activate:void 0,deactivate:void 0},void 0,[])}}e.EmptyExtension=P;class t extends _{constructor(){super(!1,null,F.NONE,{activate:void 0,deactivate:void 0},void 0,[])}}e.HostExtension=t;class E extends _{constructor(a){super(!0,a,F.NONE,{activate:void 0,deactivate:void 0},void 0,[])}}e.FailedExtension=E;let n=class{constructor(a,l,w,I,S){this._logService=S,this._registry=a,this._resolvedExtensionsSet=new Set,l.forEach(o=>this._resolvedExtensionsSet.add(c.ExtensionIdentifier.toKey(o))),this._hostExtensionsMap=new Map,w.forEach(o=>this._hostExtensionsMap.set(c.ExtensionIdentifier.toKey(o),o)),this._host=I,this._activatingExtensions=new Map,this._activatedExtensions=new Map,this._alreadyActivatedEvents=Object.create(null)}isActivated(a){const l=c.ExtensionIdentifier.toKey(a);return this._activatedExtensions.has(l)}getActivatedExtension(a){const l=c.ExtensionIdentifier.toKey(a),w=this._activatedExtensions.get(l);if(!w)throw new Error("Extension `"+a.value+"` is not known or not activated");return w}activateByEvent(a,l){if(this._alreadyActivatedEvents[a])return R;const w=this._registry.getExtensionDescriptionsForActivationEvent(a);return this._activateExtensions(w.map(I=>({id:I.identifier,reason:{startup:l,extensionId:I.identifier,activationEvent:a}}))).then(()=>{this._alreadyActivatedEvents[a]=!0})}activateById(a,l){const w=this._registry.getExtensionDescription(a);if(!w)throw new Error("Extension `"+a+"` is not known");return this._activateExtensions([{id:w.identifier,reason:l}])}_handleActivateRequest(a,l,w){if(this._hostExtensionsMap.has(c.ExtensionIdentifier.toKey(a.id))){l[c.ExtensionIdentifier.toKey(a.id)]=a;return}const I=this._registry.getExtensionDescription(a.id);if(!I){const h=new Error(`Cannot activate unknown extension '${a.id.value}'`);this._host.onExtensionActivationError(a.id,h,new M.MissingExtensionDependency(a.id.value)),this._activatedExtensions.set(c.ExtensionIdentifier.toKey(a.id),new E(h));return}const S=typeof I.extensionDependencies=="undefined"?[]:I.extensionDependencies;let o=!0;for(let h=0,y=S.length;h<y;h++){const i=S[h];if(this._resolvedExtensionsSet.has(c.ExtensionIdentifier.toKey(i)))continue;const v=this._activatedExtensions.get(c.ExtensionIdentifier.toKey(i));if(v&&!v.activationFailed)continue;if(v&&v.activationFailed){const d=I.displayName||I.identifier.value,p=this._registry.getExtensionDescription(i),k=p&&p.displayName||i,T=new Error(`Cannot activate the '${d}' extension because its dependency '${k}' failed to activate`);T.detail=v.activationFailedError,this._host.onExtensionActivationError(I.identifier,T,null),this._activatedExtensions.set(c.ExtensionIdentifier.toKey(I.identifier),new E(T));return}if(this._hostExtensionsMap.has(c.ExtensionIdentifier.toKey(i))){o=!1,l[c.ExtensionIdentifier.toKey(i)]={id:this._hostExtensionsMap.get(c.ExtensionIdentifier.toKey(i)),reason:a.reason};continue}const r=this._registry.getExtensionDescription(i);if(r){o=!1,l[c.ExtensionIdentifier.toKey(i)]={id:r.identifier,reason:a.reason};continue}const s=I.displayName||I.identifier.value,u=new Error(`Cannot activate the '${s}' extension because it depends on unknown extension '${i}'`);this._host.onExtensionActivationError(I.identifier,u,new M.MissingExtensionDependency(i)),this._activatedExtensions.set(c.ExtensionIdentifier.toKey(I.identifier),new E(u));return}o?l[c.ExtensionIdentifier.toKey(I.identifier)]=a:w.push(a)}_activateExtensions(a){if(a.length===0||(a=a.filter(S=>!this._activatedExtensions.has(c.ExtensionIdentifier.toKey(S.id))),a.length===0))return Promise.resolve(void 0);const l=Object.create(null),w=[];for(let S=0,o=a.length;S<o;S++)this._handleActivateRequest(a[S],l,w);for(let S=0,o=w.length;S<o;S++){const h=c.ExtensionIdentifier.toKey(w[S].id);l[h]&&delete l[h]}const I=Object.keys(l).map(S=>l[S]);return w.length===0?Promise.all(I.map(S=>this._activateExtension(S.id,S.reason))).then(S=>{}):this._activateExtensions(I).then(S=>this._activateExtensions(w))}_activateExtension(a,l){const w=c.ExtensionIdentifier.toKey(a);if(this._activatedExtensions.has(w))return Promise.resolve(void 0);const I=this._activatingExtensions.get(w);if(I)return I;const S=this._host.actualActivateExtension(a,l).then(void 0,o=>{const h=new Error;return o&&o.name&&(h.name=o.name),o&&o.message?h.message=`Activating extension '${a.value}' failed: ${o.message}.`:h.message=`Activating extension '${a.value}' failed: ${o}.`,o&&o.stack&&(h.stack=o.stack),this._host.onExtensionActivationError(a,h,null),this._logService.error(`Activating extension ${a.value} failed due to an error:`),this._logService.error(o),new E(o)}).then(o=>{this._activatedExtensions.set(w,o),this._activatingExtensions.delete(w)});return this._activatingExtensions.set(w,S),S}};n=We([ze(4,b.ILogService)],n),e.ExtensionsActivator=n}),define(we[179],Ee([0,1,16]),function(re,e,c){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.LazyPromise=void 0;class M{constructor(){this._actual=null,this._actualOk=null,this._actualErr=null,this._hasValue=!1,this._value=null,this._hasErr=!1,this._err=null}get[Symbol.toStringTag](){return this.toString()}_ensureActual(){return this._actual||(this._actual=new Promise((R,F)=>{this._actualOk=R,this._actualErr=F,this._hasValue&&this._actualOk(this._value),this._hasErr&&this._actualErr(this._err)})),this._actual}resolveOk(R){this._hasValue||this._hasErr||(this._hasValue=!0,this._value=R,this._actual&&this._actualOk(R))}resolveErr(R){this._hasValue||this._hasErr||(this._hasErr=!0,this._err=R,this._actual?this._actualErr(R):(0,c.onUnexpectedError)(R))}then(R,F){return this._ensureActual().then(R,F)}catch(R){return this._ensureActual().then(void 0,R)}finally(R){return this._ensureActual().finally(R)}}e.LazyPromise=M}),define(we[38],Ee([0,1]),function(re,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.SerializableObjectWithBuffers=e.getStringIdentifierForProxy=e.createExtHostContextProxyIdentifier=e.createMainContextProxyIdentifier=e.ProxyIdentifier=void 0;class c{constructor(P,t){this._proxyIdentifierBrand=void 0,this.isMain=P,this.sid=t,this.nid=++c.count}}e.ProxyIdentifier=c,c.count=0;const M=[];function b(_){const P=new c(!0,_);return M[P.nid]=P,P}e.createMainContextProxyIdentifier=b;function R(_){const P=new c(!1,_);return M[P.nid]=P,P}e.createExtHostContextProxyIdentifier=R;function F(_){return M[_].sid}e.getStringIdentifierForProxy=F;class C{constructor(P){this.value=P}}e.SerializableObjectWithBuffers=C}),define(we[5],Ee([0,1,54,2,38]),function(re,e,c,M,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostContext=e.MainContext=e.ExtHostTestingResource=e.reviveWorkspaceEditDto=e.WorkspaceEditType=e.ISuggestResultDtoField=e.ISuggestDataDtoField=e.IdObject=e.ObjectIdentifier=e.CandidatePortSource=e.NotebookEditorRevealType=e.CellOutputKind=e.WebviewMessageArrayBufferViewType=e.WebviewEditorCapabilities=e.TextEditorRevealType=e.UIKind=void 0;var R;(function(o){o[o.Desktop=1]="Desktop",o[o.Web=2]="Web"})(R=e.UIKind||(e.UIKind={}));var F;(function(o){o[o.Default=0]="Default",o[o.InCenter=1]="InCenter",o[o.InCenterIfOutsideViewport=2]="InCenterIfOutsideViewport",o[o.AtTop=3]="AtTop"})(F=e.TextEditorRevealType||(e.TextEditorRevealType={}));var C;(function(o){o[o.Editable=0]="Editable",o[o.SupportsHotExit=1]="SupportsHotExit"})(C=e.WebviewEditorCapabilities||(e.WebviewEditorCapabilities={}));var _;(function(o){o[o.Int8Array=1]="Int8Array",o[o.Uint8Array=2]="Uint8Array",o[o.Uint8ClampedArray=3]="Uint8ClampedArray",o[o.Int16Array=4]="Int16Array",o[o.Uint16Array=5]="Uint16Array",o[o.Int32Array=6]="Int32Array",o[o.Uint32Array=7]="Uint32Array",o[o.Float32Array=8]="Float32Array",o[o.Float64Array=9]="Float64Array",o[o.BigInt64Array=10]="BigInt64Array",o[o.BigUint64Array=11]="BigUint64Array"})(_=e.WebviewMessageArrayBufferViewType||(e.WebviewMessageArrayBufferViewType={}));var P;(function(o){o[o.Text=1]="Text",o[o.Error=2]="Error",o[o.Rich=3]="Rich"})(P=e.CellOutputKind||(e.CellOutputKind={}));var t;(function(o){o[o.Default=0]="Default",o[o.InCenter=1]="InCenter",o[o.InCenterIfOutsideViewport=2]="InCenterIfOutsideViewport",o[o.AtTop=3]="AtTop"})(t=e.NotebookEditorRevealType||(e.NotebookEditorRevealType={}));var E;(function(o){o[o.None=0]="None",o[o.Process=1]="Process",o[o.Output=2]="Output"})(E=e.CandidatePortSource||(e.CandidatePortSource={}));var n;(function(o){o.name="$ident";function h(i,v){return Object.defineProperty(i,o.name,{value:v,enumerable:!0}),i}o.mixin=h;function y(i){return i[o.name]}o.of=y})(n=e.ObjectIdentifier||(e.ObjectIdentifier={}));class f{static mixin(h){return h._id=f._n++,h}}e.IdObject=f,f._n=0;var a;(function(o){o.label="a",o.kind="b",o.detail="c",o.documentation="d",o.sortText="e",o.filterText="f",o.preselect="g",o.insertText="h",o.insertTextRules="i",o.range="j",o.commitCharacters="k",o.additionalTextEdits="l",o.command="m",o.kindModifier="n"})(a=e.ISuggestDataDtoField||(e.ISuggestDataDtoField={}));var l;(function(o){o.defaultRanges="a",o.completions="b",o.isIncomplete="c",o.duration="d"})(l=e.ISuggestResultDtoField||(e.ISuggestResultDtoField={}));var w;(function(o){o[o.File=1]="File",o[o.Text=2]="Text",o[o.Cell=3]="Cell"})(w=e.WorkspaceEditType||(e.WorkspaceEditType={}));function I(o){if(o&&o.edits)for(const h of o.edits)typeof h.resource=="object"?h.resource=M.URI.revive(h.resource):(h.newUri=M.URI.revive(h.newUri),h.oldUri=M.URI.revive(h.oldUri)),h.metadata&&h.metadata.iconPath&&(h.metadata=(0,c.revive)(h.metadata));return o}e.reviveWorkspaceEditDto=I;var S;(function(o){o[o.Workspace=0]="Workspace",o[o.TextDocument=1]="TextDocument"})(S=e.ExtHostTestingResource||(e.ExtHostTestingResource={})),e.MainContext={MainThreadAuthentication:(0,b.createMainContextProxyIdentifier)("MainThreadAuthentication"),MainThreadBulkEdits:(0,b.createMainContextProxyIdentifier)("MainThreadBulkEdits"),MainThreadClipboard:(0,b.createMainContextProxyIdentifier)("MainThreadClipboard"),MainThreadCommands:(0,b.createMainContextProxyIdentifier)("MainThreadCommands"),MainThreadComments:(0,b.createMainContextProxyIdentifier)("MainThreadComments"),MainThreadConfiguration:(0,b.createMainContextProxyIdentifier)("MainThreadConfiguration"),MainThreadConsole:(0,b.createMainContextProxyIdentifier)("MainThreadConsole"),MainThreadDebugService:(0,b.createMainContextProxyIdentifier)("MainThreadDebugService"),MainThreadDecorations:(0,b.createMainContextProxyIdentifier)("MainThreadDecorations"),MainThreadDiagnostics:(0,b.createMainContextProxyIdentifier)("MainThreadDiagnostics"),MainThreadDialogs:(0,b.createMainContextProxyIdentifier)("MainThreadDiaglogs"),MainThreadDocuments:(0,b.createMainContextProxyIdentifier)("MainThreadDocuments"),MainThreadDocumentContentProviders:(0,b.createMainContextProxyIdentifier)("MainThreadDocumentContentProviders"),MainThreadTextEditors:(0,b.createMainContextProxyIdentifier)("MainThreadTextEditors"),MainThreadEditorInsets:(0,b.createMainContextProxyIdentifier)("MainThreadEditorInsets"),MainThreadEditorTabs:(0,b.createMainContextProxyIdentifier)("MainThreadEditorTabs"),MainThreadErrors:(0,b.createMainContextProxyIdentifier)("MainThreadErrors"),MainThreadTreeViews:(0,b.createMainContextProxyIdentifier)("MainThreadTreeViews"),MainThreadDownloadService:(0,b.createMainContextProxyIdentifier)("MainThreadDownloadService"),MainThreadKeytar:(0,b.createMainContextProxyIdentifier)("MainThreadKeytar"),MainThreadLanguageFeatures:(0,b.createMainContextProxyIdentifier)("MainThreadLanguageFeatures"),MainThreadLanguages:(0,b.createMainContextProxyIdentifier)("MainThreadLanguages"),MainThreadLog:(0,b.createMainContextProxyIdentifier)("MainThread"),MainThreadMessageService:(0,b.createMainContextProxyIdentifier)("MainThreadMessageService"),MainThreadOutputService:(0,b.createMainContextProxyIdentifier)("MainThreadOutputService"),MainThreadProgress:(0,b.createMainContextProxyIdentifier)("MainThreadProgress"),MainThreadQuickOpen:(0,b.createMainContextProxyIdentifier)("MainThreadQuickOpen"),MainThreadStatusBar:(0,b.createMainContextProxyIdentifier)("MainThreadStatusBar"),MainThreadSecretState:(0,b.createMainContextProxyIdentifier)("MainThreadSecretState"),MainThreadStorage:(0,b.createMainContextProxyIdentifier)("MainThreadStorage"),MainThreadTelemetry:(0,b.createMainContextProxyIdentifier)("MainThreadTelemetry"),MainThreadTerminalService:(0,b.createMainContextProxyIdentifier)("MainThreadTerminalService"),MainThreadWebviews:(0,b.createMainContextProxyIdentifier)("MainThreadWebviews"),MainThreadWebviewPanels:(0,b.createMainContextProxyIdentifier)("MainThreadWebviewPanels"),MainThreadWebviewViews:(0,b.createMainContextProxyIdentifier)("MainThreadWebviewViews"),MainThreadCustomEditors:(0,b.createMainContextProxyIdentifier)("MainThreadCustomEditors"),MainThreadUrls:(0,b.createMainContextProxyIdentifier)("MainThreadUrls"),MainThreadUriOpeners:(0,b.createMainContextProxyIdentifier)("MainThreadUriOpeners"),MainThreadWorkspace:(0,b.createMainContextProxyIdentifier)("MainThreadWorkspace"),MainThreadFileSystem:(0,b.createMainContextProxyIdentifier)("MainThreadFileSystem"),MainThreadExtensionService:(0,b.createMainContextProxyIdentifier)("MainThreadExtensionService"),MainThreadSCM:(0,b.createMainContextProxyIdentifier)("MainThreadSCM"),MainThreadSearch:(0,b.createMainContextProxyIdentifier)("MainThreadSearch"),MainThreadTask:(0,b.createMainContextProxyIdentifier)("MainThreadTask"),MainThreadWindow:(0,b.createMainContextProxyIdentifier)("MainThreadWindow"),MainThreadLabelService:(0,b.createMainContextProxyIdentifier)("MainThreadLabelService"),MainThreadNotebook:(0,b.createMainContextProxyIdentifier)("MainThreadNotebook"),MainThreadNotebookDocuments:(0,b.createMainContextProxyIdentifier)("MainThreadNotebookDocumentsShape"),MainThreadNotebookEditors:(0,b.createMainContextProxyIdentifier)("MainThreadNotebookEditorsShape"),MainThreadNotebookKernels:(0,b.createMainContextProxyIdentifier)("MainThreadNotebookKernels"),MainThreadNotebookRenderers:(0,b.createMainContextProxyIdentifier)("MainThreadNotebookRenderers"),MainThreadInteractive:(0,b.createMainContextProxyIdentifier)("MainThreadInteractive"),MainThreadTheming:(0,b.createMainContextProxyIdentifier)("MainThreadTheming"),MainThreadTunnelService:(0,b.createMainContextProxyIdentifier)("MainThreadTunnelService"),MainThreadTimeline:(0,b.createMainContextProxyIdentifier)("MainThreadTimeline"),MainThreadTesting:(0,b.createMainContextProxyIdentifier)("MainThreadTesting")},e.ExtHostContext={ExtHostCommands:(0,b.createExtHostContextProxyIdentifier)("ExtHostCommands"),ExtHostConfiguration:(0,b.createExtHostContextProxyIdentifier)("ExtHostConfiguration"),ExtHostDiagnostics:(0,b.createExtHostContextProxyIdentifier)("ExtHostDiagnostics"),ExtHostDebugService:(0,b.createExtHostContextProxyIdentifier)("ExtHostDebugService"),ExtHostDecorations:(0,b.createExtHostContextProxyIdentifier)("ExtHostDecorations"),ExtHostDocumentsAndEditors:(0,b.createExtHostContextProxyIdentifier)("ExtHostDocumentsAndEditors"),ExtHostDocuments:(0,b.createExtHostContextProxyIdentifier)("ExtHostDocuments"),ExtHostDocumentContentProviders:(0,b.createExtHostContextProxyIdentifier)("ExtHostDocumentContentProviders"),ExtHostDocumentSaveParticipant:(0,b.createExtHostContextProxyIdentifier)("ExtHostDocumentSaveParticipant"),ExtHostEditors:(0,b.createExtHostContextProxyIdentifier)("ExtHostEditors"),ExtHostTreeViews:(0,b.createExtHostContextProxyIdentifier)("ExtHostTreeViews"),ExtHostFileSystem:(0,b.createExtHostContextProxyIdentifier)("ExtHostFileSystem"),ExtHostFileSystemInfo:(0,b.createExtHostContextProxyIdentifier)("ExtHostFileSystemInfo"),ExtHostFileSystemEventService:(0,b.createExtHostContextProxyIdentifier)("ExtHostFileSystemEventService"),ExtHostLanguages:(0,b.createExtHostContextProxyIdentifier)("ExtHostLanguages"),ExtHostLanguageFeatures:(0,b.createExtHostContextProxyIdentifier)("ExtHostLanguageFeatures"),ExtHostQuickOpen:(0,b.createExtHostContextProxyIdentifier)("ExtHostQuickOpen"),ExtHostExtensionService:(0,b.createExtHostContextProxyIdentifier)("ExtHostExtensionService"),ExtHostLogService:(0,b.createExtHostContextProxyIdentifier)("ExtHostLogService"),ExtHostTerminalService:(0,b.createExtHostContextProxyIdentifier)("ExtHostTerminalService"),ExtHostSCM:(0,b.createExtHostContextProxyIdentifier)("ExtHostSCM"),ExtHostSearch:(0,b.createExtHostContextProxyIdentifier)("ExtHostSearch"),ExtHostTask:(0,b.createExtHostContextProxyIdentifier)("ExtHostTask"),ExtHostWorkspace:(0,b.createExtHostContextProxyIdentifier)("ExtHostWorkspace"),ExtHostWindow:(0,b.createExtHostContextProxyIdentifier)("ExtHostWindow"),ExtHostWebviews:(0,b.createExtHostContextProxyIdentifier)("ExtHostWebviews"),ExtHostWebviewPanels:(0,b.createExtHostContextProxyIdentifier)("ExtHostWebviewPanels"),ExtHostCustomEditors:(0,b.createExtHostContextProxyIdentifier)("ExtHostCustomEditors"),ExtHostWebviewViews:(0,b.createExtHostContextProxyIdentifier)("ExtHostWebviewViews"),ExtHostEditorInsets:(0,b.createExtHostContextProxyIdentifier)("ExtHostEditorInsets"),ExtHostEditorTabs:(0,b.createExtHostContextProxyIdentifier)("ExtHostEditorTabs"),ExtHostProgress:(0,b.createMainContextProxyIdentifier)("ExtHostProgress"),ExtHostComments:(0,b.createMainContextProxyIdentifier)("ExtHostComments"),ExtHostSecretState:(0,b.createMainContextProxyIdentifier)("ExtHostSecretState"),ExtHostStorage:(0,b.createMainContextProxyIdentifier)("ExtHostStorage"),ExtHostUrls:(0,b.createExtHostContextProxyIdentifier)("ExtHostUrls"),ExtHostUriOpeners:(0,b.createExtHostContextProxyIdentifier)("ExtHostUriOpeners"),ExtHostOutputService:(0,b.createMainContextProxyIdentifier)("ExtHostOutputService"),ExtHosLabelService:(0,b.createMainContextProxyIdentifier)("ExtHostLabelService"),ExtHostNotebook:(0,b.createMainContextProxyIdentifier)("ExtHostNotebook"),ExtHostNotebookDocuments:(0,b.createMainContextProxyIdentifier)("ExtHostNotebookDocuments"),ExtHostNotebookEditors:(0,b.createMainContextProxyIdentifier)("ExtHostNotebookEditors"),ExtHostNotebookKernels:(0,b.createMainContextProxyIdentifier)("ExtHostNotebookKernels"),ExtHostNotebookRenderers:(0,b.createMainContextProxyIdentifier)("ExtHostNotebookRenderers"),ExtHostInteractive:(0,b.createMainContextProxyIdentifier)("ExtHostInteractive"),ExtHostTheming:(0,b.createMainContextProxyIdentifier)("ExtHostTheming"),ExtHostTunnelService:(0,b.createMainContextProxyIdentifier)("ExtHostTunnelService"),ExtHostAuthentication:(0,b.createMainContextProxyIdentifier)("ExtHostAuthentication"),ExtHostTimeline:(0,b.createMainContextProxyIdentifier)("ExtHostTimeline"),ExtHostTesting:(0,b.createMainContextProxyIdentifier)("ExtHostTesting"),ExtHostTelemetry:(0,b.createMainContextProxyIdentifier)("ExtHostTelemetry")}}),define(we[69],Ee([0,1,5,3,4]),function(re,e,c,M,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExtHostSecretState=e.ExtHostSecretState=void 0;class R{constructor(C){this._onDidChangePassword=new M.Emitter,this.onDidChangePassword=this._onDidChangePassword.event,this._proxy=C.getProxy(c.MainContext.MainThreadSecretState)}async $onDidChangePassword(C){this._onDidChangePassword.fire(C)}get(C,_){return this._proxy.$getPassword(C,_)}store(C,_,P){return this._proxy.$setPassword(C,_,P)}delete(C,_){return this._proxy.$deletePassword(C,_)}}e.ExtHostSecretState=R,e.IExtHostSecretState=(0,b.createDecorator)("IExtHostSecretState")}),define(we[70],Ee([0,1,4,15,5,13]),function(re,e,c,M,b,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.NullApiDeprecationService=e.ExtHostApiDeprecationService=e.IExtHostApiDeprecationService=void 0,e.IExtHostApiDeprecationService=(0,c.createDecorator)("IExtHostApiDeprecationService");let F=class{constructor(_,P){this._extHostLogService=P,this._reportedUsages=new Set,this._telemetryShape=_.getProxy(b.MainContext.MainThreadTelemetry)}report(_,P,t){const E=this.getUsageKey(_,P);this._reportedUsages.has(E)||(this._reportedUsages.add(E),P.isUnderDevelopment&&this._extHostLogService.warn(`[Deprecation Warning] '${_}' is deprecated. ${t}`),this._telemetryShape.$publicLog2("extHostDeprecatedApiUsage",{extensionId:P.identifier.value,apiId:_}))}getUsageKey(_,P){return`${_}-${P.identifier.value}`}};F=We([ze(0,R.IExtHostRpcService),ze(1,M.ILogService)],F),e.ExtHostApiDeprecationService=F,e.NullApiDeprecationService=Object.freeze(new class{report(C,_,P){}})}),define(we[180],Ee([0,1,3,5,7,25]),function(re,e,c,M,b,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostAuthentication=void 0;class F{constructor(_){this._authenticationProviders=new Map,this._providers=[],this._onDidChangeSessions=new c.Emitter,this.onDidChangeSessions=this._onDidChangeSessions.event,this._inFlightRequests=new Map,this._proxy=_.getProxy(M.MainContext.MainThreadAuthentication)}$setProviders(_){return this._providers=_,Promise.resolve()}async getSession(_,P,t,E={}){const n=R.ExtensionIdentifier.toKey(_.identifier),f=this._inFlightRequests.get(n)||[],a=[...t].sort().join(" ");let l=f.find(w=>w.scopes===a);if(l)return l.result;{const w=this._getSession(_,n,P,t,E);l={scopes:a,result:w},f.push(l),this._inFlightRequests.set(n,f);try{await w}finally{const I=f.findIndex(S=>S.scopes===a);I>-1&&(f.splice(I),this._inFlightRequests.set(n,f))}return w}}async _getSession(_,P,t,E,n={}){await this._proxy.$ensureProvider(t);const f=_.displayName||_.name;return this._proxy.$getSession(t,E,P,f,n)}async removeSession(_,P){const t=this._authenticationProviders.get(_);return t?t.provider.removeSession(P):this._proxy.$removeSession(_,P)}registerAuthenticationProvider(_,P,t,E){if(this._authenticationProviders.get(_))throw new Error(`An authentication provider with id '${_}' is already registered.`);this._authenticationProviders.set(_,{label:P,provider:t,options:E??{supportsMultipleAccounts:!1}}),this._providers.find(f=>f.id===_)||this._providers.push({id:_,label:P});const n=t.onDidChangeSessions(f=>{this._proxy.$sendDidChangeSessions(_,{added:f.added??[],changed:f.changed??[],removed:f.removed??[]})});return this._proxy.$registerAuthenticationProvider(_,P,E?.supportsMultipleAccounts??!1),new b.Disposable(()=>{n.dispose(),this._authenticationProviders.delete(_);const f=this._providers.findIndex(a=>a.id===_);f>-1&&this._providers.splice(f),this._proxy.$unregisterAuthenticationProvider(_)})}$createSession(_,P){const t=this._authenticationProviders.get(_);if(t)return Promise.resolve(t.provider.createSession(P));throw new Error(`Unable to find authentication provider with handle: ${_}`)}$removeSession(_,P){const t=this._authenticationProviders.get(_);if(t)return Promise.resolve(t.provider.removeSession(P));throw new Error(`Unable to find authentication provider with handle: ${_}`)}$getSessions(_,P){const t=this._authenticationProviders.get(_);if(t)return Promise.resolve(t.provider.getSessions(P));throw new Error(`Unable to find authentication provider with handle: ${_}`)}$onDidChangeAuthenticationSessions(_,P){return this._onDidChangeSessions.fire({provider:{id:_,label:P}}),Promise.resolve()}}e.ExtHostAuthentication=F}),define(we[181],Ee([0,1,5,13,8]),function(re,e,c,M,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostBulkEdits=void 0;let R=class{constructor(C,_){this._extHostDocumentsAndEditors=_,this._proxy=C.getProxy(c.MainContext.MainThreadBulkEdits)}applyWorkspaceEdit(C){const _=b.WorkspaceEdit.from(C,this._extHostDocumentsAndEditors);return this._proxy.$tryApplyWorkspaceEdit(_)}};R=We([ze(0,M.IExtHostRpcService)],R),e.ExtHostBulkEdits=R}),define(we[182],Ee([0,1,5]),function(re,e,c){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostClipboard=void 0;class M{constructor(R){const F=R.getProxy(c.MainContext.MainThreadClipboard);this.value=Object.freeze({readText(){return F.$readText()},writeText(C){return F.$writeText(C)}})}}e.ExtHostClipboard=M}),define(we[39],Ee([0,1,10,7,8,23,5,12,15,54,44,112,2,6,4,13,48,22,38]),function(re,e,c,M,b,R,F,C,_,P,t,E,n,f,a,l,w,I,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ApiCommand=e.ApiCommandResult=e.ApiCommandArgument=e.CommandsConverter=e.IExtHostCommands=e.ExtHostCommands=void 0;let o=class{constructor(s,u){this._commands=new Map,this._apiCommands=new Map,this._proxy=s.getProxy(F.MainContext.MainThreadCommands),this._logService=u,this.converter=new h(this,d=>{const p=this._apiCommands.get(d);return p?.result===i.Void?p:void 0},u),this._argumentProcessors=[{processArgument(d){return(0,P.revive)(d)}},{processArgument(d){return(0,R.cloneAndChange)(d,function(p){if(t.Range.isIRange(p))return b.Range.to(p);if(E.Position.isIPosition(p))return b.Position.to(p);if(t.Range.isIRange(p.range)&&n.URI.isUri(p.uri))return b.location.to(p);if(p instanceof I.VSBuffer)return p.buffer.buffer;if(!Array.isArray(p))return p})}}]}registerArgumentProcessor(s){this._argumentProcessors.push(s)}registerApiCommand(s){const u=this.registerCommand(!1,s.id,async(...d)=>{const p=s.args.map((T,g)=>{if(!T.validate(d[g]))throw new Error(`Invalid argument '${T.name}' when running '${s.id}', received: ${d[g]}`);return T.convert(d[g])}),k=await this.executeCommand(s.internalId,...p);return s.result.convert(k,d,this.converter)},void 0,{description:s.description,args:s.args,returns:s.result.description});return this._apiCommands.set(s.id,s),new M.Disposable(()=>{u.dispose(),this._apiCommands.delete(s.id)})}registerCommand(s,u,d,p,k){if(this._logService.trace("ExtHostCommands#registerCommand",u),!u.trim().length)throw new Error("invalid id");if(this._commands.has(u))throw new Error(`command '${u}' already exists`);return this._commands.set(u,{callback:d,thisArg:p,description:k}),s&&this._proxy.$registerCommand(u),new M.Disposable(()=>{this._commands.delete(u)&&s&&this._proxy.$unregisterCommand(u)})}executeCommand(s,...u){return this._logService.trace("ExtHostCommands#executeCommand",s),this._doExecuteCommand(s,u,!0)}async _doExecuteCommand(s,u,d){if(this._commands.has(s))return this._executeContributedCommand(s,u);{let p=!1;const k=(0,R.cloneAndChange)(u,function(T){if(T instanceof M.Position)return b.Position.from(T);if(T instanceof M.Range)return b.Range.from(T);if(T instanceof M.Location)return b.location.from(T);if(M.NotebookRange.isNotebookRange(T))return b.NotebookRange.from(T);if(T instanceof ArrayBuffer)return p=!0,I.VSBuffer.wrap(new Uint8Array(T));if(T instanceof Uint8Array)return p=!0,I.VSBuffer.wrap(T);if(!Array.isArray(T))return T});try{const T=await this._proxy.$executeCommand(s,p?new S.SerializableObjectWithBuffers(k):k,d);return(0,P.revive)(T)}catch(T){if(T instanceof Error&&T.message==="$executeCommand:retry")return this._doExecuteCommand(s,u,!1);throw T}}}async _executeContributedCommand(s,u){const d=this._commands.get(s);if(!d)throw new Error("Unknown command");let{callback:p,thisArg:k,description:T}=d;if(T)for(let g=0;g<T.args.length;g++)try{(0,c.validateConstraint)(u[g],T.args[g].constraint)}catch(D){throw new Error(`Running the contributed command: '${s}' failed. Illegal argument '${T.args[g].name}' - ${T.args[g].description}`)}try{return await p.apply(k,u)}catch(g){if(s===this.converter.delegatingCommandId){const D=this.converter.getActualCommand(...u);D&&(s=D.command)}throw this._logService.error(g,s),new Error(`Running the contributed command: '${s}' failed.`)}}$executeContributedCommand(s,...u){return this._logService.trace("ExtHostCommands#$executeContributedCommand",s),this._commands.has(s)?(u=u.map(d=>this._argumentProcessors.reduce((p,k)=>k.processArgument(p),d)),this._executeContributedCommand(s,u)):Promise.reject(new Error(`Contributed command '${s}' does not exist.`))}getCommands(s=!1){return this._logService.trace("ExtHostCommands#getCommands",s),this._proxy.$getCommands().then(u=>(s&&(u=u.filter(d=>d[0]!=="_")),u))}$getContributedCommandHandlerDescriptions(){const s=Object.create(null);for(let[u,d]of this._commands){let{description:p}=d;p&&(s[u]=p)}return Promise.resolve(s)}};o=We([ze(0,l.IExtHostRpcService),ze(1,_.ILogService)],o),e.ExtHostCommands=o,e.IExtHostCommands=(0,a.createDecorator)("IExtHostCommands");class h{constructor(s,u,d){this._commands=s,this._lookupApiCommand=u,this._logService=d,this.delegatingCommandId=`_vscode_delegate_cmd_${Date.now().toString(36)}`,this._cache=new Map,this._cachIdPool=0,this._commands.registerCommand(!0,this.delegatingCommandId,this._executeConvertedCommand,this)}toInternal(s,u){if(!s)return;const d={$ident:void 0,id:s.command,title:s.title,tooltip:s.tooltip};if(!s.command)return d;const p=this._lookupApiCommand(s.command);if(p)d.id=p.internalId,d.arguments=p.args.map((k,T)=>k.convert(s.arguments&&s.arguments[T]));else if((0,C.isNonEmptyArray)(s.arguments)){const k=++this._cachIdPool;this._cache.set(k,s),u.add((0,f.toDisposable)(()=>{this._cache.delete(k),this._logService.trace("CommandsConverter#DISPOSE",k)})),d.$ident=k,d.id=this.delegatingCommandId,d.arguments=[k],this._logService.trace("CommandsConverter#CREATE",s.command,k)}return d}fromInternal(s){const u=F.ObjectIdentifier.of(s);return typeof u=="number"?this._cache.get(u):{command:s.id,title:s.title,arguments:s.arguments}}getActualCommand(...s){return this._cache.get(s[0])}_executeConvertedCommand(...s){const u=this.getActualCommand(...s);return this._logService.trace("CommandsConverter#EXECUTE",s[0],u?u.command:"MISSING"),u?this._commands.executeCommand(u.command,...u.arguments||[]):Promise.reject("actual command NOT FOUND")}}e.CommandsConverter=h;class y{constructor(s,u,d,p){this.name=s,this.description=u,this.validate=d,this.convert=p}optional(){return new y(this.name,`(optional) ${this.description}`,s=>s==null||this.validate(s),s=>s===void 0?void 0:s===null?null:this.convert(s))}with(s,u){return new y(s??this.name,u??this.description,this.validate,this.convert)}}e.ApiCommandArgument=y,y.Uri=new y("uri","Uri of a text document",r=>n.URI.isUri(r),r=>r),y.Position=new y("position","A position in a text document",r=>M.Position.isPosition(r),b.Position.from),y.Range=new y("range","A range in a text document",r=>M.Range.isRange(r),b.Range.from),y.Selection=new y("selection","A selection in a text document",r=>M.Selection.isSelection(r),b.Selection.from),y.Number=new y("number","",r=>typeof r=="number",r=>r),y.String=new y("string","",r=>typeof r=="string",r=>r),y.CallHierarchyItem=new y("item","A call hierarchy item",r=>r instanceof M.CallHierarchyItem,b.CallHierarchyItem.from),y.TypeHierarchyItem=new y("item","A type hierarchy item",r=>r instanceof M.TypeHierarchyItem,b.TypeHierarchyItem.from),y.TestItem=new y("testItem","A VS Code TestItem",r=>r instanceof w.TestItemImpl,b.TestItem.from);class i{constructor(s,u){this.description=s,this.convert=u}}e.ApiCommandResult=i,i.Void=new i("no result",r=>r);class v{constructor(s,u,d,p,k){this.id=s,this.internalId=u,this.description=d,this.args=p,this.result=k}}e.ApiCommand=v}),define(we[183],Ee([0,1,8,7,59,39,12,80]),function(re,e,c,M,b,R,F,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostApiCommands=void 0;const _=[new R.ApiCommand("vscode.executeDocumentHighlights","_executeDocumentHighlights","Execute document highlight provider.",[R.ApiCommandArgument.Uri,R.ApiCommandArgument.Position],new R.ApiCommandResult("A promise that resolves to an array of DocumentHighlight-instances.",t(c.DocumentHighlight.to))),new R.ApiCommand("vscode.executeDocumentSymbolProvider","_executeDocumentSymbolProvider","Execute document symbol provider.",[R.ApiCommandArgument.Uri],new R.ApiCommandResult("A promise that resolves to an array of SymbolInformation and DocumentSymbol instances.",(n,f)=>{if((0,F.isFalsyOrEmpty)(n))return;class a extends M.SymbolInformation{static to(w){const I=new a(w.name,c.SymbolKind.to(w.kind),w.containerName||"",new M.Location(f[0],c.Range.to(w.range)));return I.detail=w.detail,I.range=I.location.range,I.selectionRange=c.Range.to(w.selectionRange),I.children=w.children?w.children.map(a.to):[],I}}return n.map(a.to)})),new R.ApiCommand("vscode.executeFormatDocumentProvider","_executeFormatDocumentProvider","Execute document format provider.",[R.ApiCommandArgument.Uri,new R.ApiCommandArgument("options","Formatting options",n=>!0,n=>n)],new R.ApiCommandResult("A promise that resolves to an array of TextEdits.",t(c.TextEdit.to))),new R.ApiCommand("vscode.executeFormatRangeProvider","_executeFormatRangeProvider","Execute range format provider.",[R.ApiCommandArgument.Uri,R.ApiCommandArgument.Range,new R.ApiCommandArgument("options","Formatting options",n=>!0,n=>n)],new R.ApiCommandResult("A promise that resolves to an array of TextEdits.",t(c.TextEdit.to))),new R.ApiCommand("vscode.executeFormatOnTypeProvider","_executeFormatOnTypeProvider","Execute format on type provider.",[R.ApiCommandArgument.Uri,R.ApiCommandArgument.Position,new R.ApiCommandArgument("ch","Trigger character",n=>typeof n=="string",n=>n),new R.ApiCommandArgument("options","Formatting options",n=>!0,n=>n)],new R.ApiCommandResult("A promise that resolves to an array of TextEdits.",t(c.TextEdit.to))),new R.ApiCommand("vscode.executeDefinitionProvider","_executeDefinitionProvider","Execute all definition providers.",[R.ApiCommandArgument.Uri,R.ApiCommandArgument.Position],new R.ApiCommandResult("A promise that resolves to an array of Location or LocationLink instances.",E)),new R.ApiCommand("vscode.executeTypeDefinitionProvider","_executeTypeDefinitionProvider","Execute all type definition providers.",[R.ApiCommandArgument.Uri,R.ApiCommandArgument.Position],new R.ApiCommandResult("A promise that resolves to an array of Location or LocationLink instances.",E)),new R.ApiCommand("vscode.executeDeclarationProvider","_executeDeclarationProvider","Execute all declaration providers.",[R.ApiCommandArgument.Uri,R.ApiCommandArgument.Position],new R.ApiCommandResult("A promise that resolves to an array of Location or LocationLink instances.",E)),new R.ApiCommand("vscode.executeImplementationProvider","_executeImplementationProvider","Execute all implementation providers.",[R.ApiCommandArgument.Uri,R.ApiCommandArgument.Position],new R.ApiCommandResult("A promise that resolves to an array of Location or LocationLink instances.",E)),new R.ApiCommand("vscode.executeReferenceProvider","_executeReferenceProvider","Execute all reference providers.",[R.ApiCommandArgument.Uri,R.ApiCommandArgument.Position],new R.ApiCommandResult("A promise that resolves to an array of Location-instances.",t(c.location.to))),new R.ApiCommand("vscode.executeHoverProvider","_executeHoverProvider","Execute all hover providers.",[R.ApiCommandArgument.Uri,R.ApiCommandArgument.Position],new R.ApiCommandResult("A promise that resolves to an array of Hover-instances.",t(c.Hover.to))),new R.ApiCommand("vscode.executeSelectionRangeProvider","_executeSelectionRangeProvider","Execute selection range provider.",[R.ApiCommandArgument.Uri,new R.ApiCommandArgument("position","A position in a text document",n=>Array.isArray(n)&&n.every(f=>M.Position.isPosition(f)),n=>n.map(c.Position.from))],new R.ApiCommandResult("A promise that resolves to an array of ranges.",n=>n.map(f=>{let a;for(const l of f.reverse())a=new M.SelectionRange(c.Range.to(l),a);return a}))),new R.ApiCommand("vscode.executeWorkspaceSymbolProvider","_executeWorkspaceSymbolProvider","Execute all workspace symbol providers.",[R.ApiCommandArgument.String.with("query","Search string")],new R.ApiCommandResult("A promise that resolves to an array of SymbolInformation-instances.",n=>{const f=[];if(Array.isArray(n))for(let a of n)f.push(...a[1].map(c.WorkspaceSymbol.to));return f})),new R.ApiCommand("vscode.prepareCallHierarchy","_executePrepareCallHierarchy","Prepare call hierarchy at a position inside a document",[R.ApiCommandArgument.Uri,R.ApiCommandArgument.Position],new R.ApiCommandResult("A CallHierarchyItem or undefined",n=>n.map(c.CallHierarchyItem.to))),new R.ApiCommand("vscode.provideIncomingCalls","_executeProvideIncomingCalls","Compute incoming calls for an item",[R.ApiCommandArgument.CallHierarchyItem],new R.ApiCommandResult("A CallHierarchyItem or undefined",n=>n.map(c.CallHierarchyIncomingCall.to))),new R.ApiCommand("vscode.provideOutgoingCalls","_executeProvideOutgoingCalls","Compute outgoing calls for an item",[R.ApiCommandArgument.CallHierarchyItem],new R.ApiCommandResult("A CallHierarchyItem or undefined",n=>n.map(c.CallHierarchyOutgoingCall.to))),new R.ApiCommand("vscode.executeDocumentRenameProvider","_executeDocumentRenameProvider","Execute rename provider.",[R.ApiCommandArgument.Uri,R.ApiCommandArgument.Position,R.ApiCommandArgument.String.with("newName","The new symbol name")],new R.ApiCommandResult("A promise that resolves to a WorkspaceEdit.",n=>{if(!!n){if(n.rejectReason)throw new Error(n.rejectReason);return c.WorkspaceEdit.to(n)}})),new R.ApiCommand("vscode.executeLinkProvider","_executeLinkProvider","Execute document link provider.",[R.ApiCommandArgument.Uri,R.ApiCommandArgument.Number.with("linkResolveCount","Number of links that should be resolved, only when links are unresolved.").optional()],new R.ApiCommandResult("A promise that resolves to an array of DocumentLink-instances.",n=>n.map(c.DocumentLink.to))),new R.ApiCommand("vscode.provideDocumentSemanticTokensLegend","_provideDocumentSemanticTokensLegend","Provide semantic tokens legend for a document",[R.ApiCommandArgument.Uri],new R.ApiCommandResult("A promise that resolves to SemanticTokensLegend.",n=>{if(!!n)return new M.SemanticTokensLegend(n.tokenTypes,n.tokenModifiers)})),new R.ApiCommand("vscode.provideDocumentSemanticTokens","_provideDocumentSemanticTokens","Provide semantic tokens for a document",[R.ApiCommandArgument.Uri],new R.ApiCommandResult("A promise that resolves to SemanticTokens.",n=>{if(!n)return;const f=(0,C.decodeSemanticTokensDto)(n);if(f.type==="full")return new M.SemanticTokens(f.data,void 0)})),new R.ApiCommand("vscode.provideDocumentRangeSemanticTokensLegend","_provideDocumentRangeSemanticTokensLegend","Provide semantic tokens legend for a document range",[R.ApiCommandArgument.Uri],new R.ApiCommandResult("A promise that resolves to SemanticTokensLegend.",n=>{if(!!n)return new M.SemanticTokensLegend(n.tokenTypes,n.tokenModifiers)})),new R.ApiCommand("vscode.provideDocumentRangeSemanticTokens","_provideDocumentRangeSemanticTokens","Provide semantic tokens for a document range",[R.ApiCommandArgument.Uri,R.ApiCommandArgument.Range],new R.ApiCommandResult("A promise that resolves to SemanticTokens.",n=>{if(!n)return;const f=(0,C.decodeSemanticTokensDto)(n);if(f.type==="full")return new M.SemanticTokens(f.data,void 0)})),new R.ApiCommand("vscode.executeCompletionItemProvider","_executeCompletionItemProvider","Execute completion item provider.",[R.ApiCommandArgument.Uri,R.ApiCommandArgument.Position,R.ApiCommandArgument.String.with("triggerCharacter","Trigger completion when the user types the character, like `,` or `(`").optional(),R.ApiCommandArgument.Number.with("itemResolveCount","Number of completions to resolve (too large numbers slow down completions)").optional()],new R.ApiCommandResult("A promise that resolves to a CompletionList-instance.",(n,f,a)=>{if(!n)return new M.CompletionList([]);const l=n.suggestions.map(w=>c.CompletionItem.to(w,a));return new M.CompletionList(l,n.incomplete)})),new R.ApiCommand("vscode.executeSignatureHelpProvider","_executeSignatureHelpProvider","Execute signature help provider.",[R.ApiCommandArgument.Uri,R.ApiCommandArgument.Position,R.ApiCommandArgument.String.with("triggerCharacter","Trigger signature help when the user types the character, like `,` or `(`").optional()],new R.ApiCommandResult("A promise that resolves to SignatureHelp.",n=>{if(n)return c.SignatureHelp.to(n)})),new R.ApiCommand("vscode.executeCodeLensProvider","_executeCodeLensProvider","Execute code lens provider.",[R.ApiCommandArgument.Uri,R.ApiCommandArgument.Number.with("itemResolveCount","Number of lenses that should be resolved and returned. Will only return resolved lenses, will impact performance)").optional()],new R.ApiCommandResult("A promise that resolves to an array of CodeLens-instances.",(n,f,a)=>t(l=>new M.CodeLens(c.Range.to(l.range),l.command&&a.fromInternal(l.command)))(n))),new R.ApiCommand("vscode.executeCodeActionProvider","_executeCodeActionProvider","Execute code action provider.",[R.ApiCommandArgument.Uri,new R.ApiCommandArgument("rangeOrSelection","Range in a text document. Some refactoring provider requires Selection object.",n=>M.Range.isRange(n),n=>M.Selection.isSelection(n)?c.Selection.from(n):c.Range.from(n)),R.ApiCommandArgument.String.with("kind","Code action kind to return code actions for").optional(),R.ApiCommandArgument.Number.with("itemResolveCount","Number of code actions to resolve (too large numbers slow down code actions)").optional()],new R.ApiCommandResult("A promise that resolves to an array of Command-instances.",(n,f,a)=>t(l=>{if(l._isSynthetic){if(!l.command)throw new Error("Synthetic code actions must have a command");return a.fromInternal(l.command)}else{const w=new M.CodeAction(l.title,l.kind?new M.CodeActionKind(l.kind):void 0);return l.edit&&(w.edit=c.WorkspaceEdit.to(l.edit)),l.command&&(w.command=a.fromInternal(l.command)),w.isPreferred=l.isPreferred,w}})(n))),new R.ApiCommand("vscode.executeDocumentColorProvider","_executeDocumentColorProvider","Execute document color provider.",[R.ApiCommandArgument.Uri],new R.ApiCommandResult("A promise that resolves to an array of ColorInformation objects.",n=>n?n.map(f=>new M.ColorInformation(c.Range.to(f.range),c.Color.to(f.color))):[])),new R.ApiCommand("vscode.executeColorPresentationProvider","_executeColorPresentationProvider","Execute color presentation provider.",[new R.ApiCommandArgument("color","The color to show and insert",n=>n instanceof M.Color,c.Color.from),new R.ApiCommandArgument("context","Context object with uri and range",n=>!0,n=>({uri:n.uri,range:c.Range.from(n.range)}))],new R.ApiCommandResult("A promise that resolves to an array of ColorPresentation objects.",n=>n?n.map(c.ColorPresentation.to):[])),new R.ApiCommand("vscode.executeInlayHintProvider","_executeInlayHintProvider","Execute inlay hints provider",[R.ApiCommandArgument.Uri,R.ApiCommandArgument.Range],new R.ApiCommandResult("A promise that resolves to an array of Inlay objects",n=>n.map(c.InlayHint.to))),new R.ApiCommand("vscode.resolveNotebookContentProviders","_resolveNotebookContentProvider","Resolve Notebook Content Providers",[],new R.ApiCommandResult("A promise that resolves to an array of NotebookContentProvider static info objects.",t(n=>({viewType:n.viewType,displayName:n.displayName,options:{transientOutputs:n.options.transientOutputs,transientCellMetadata:n.options.transientCellMetadata,transientDocumentMetadata:n.options.transientDocumentMetadata},filenamePattern:n.filenamePattern.map(f=>c.NotebookExclusiveDocumentPattern.to(f))})))),new R.ApiCommand("vscode.executeInlineValueProvider","_executeInlineValueProvider","Execute inline value provider",[R.ApiCommandArgument.Uri,R.ApiCommandArgument.Range],new R.ApiCommandResult("A promise that resolves to an array of InlineValue objects",n=>n.map(c.InlineValue.to))),new R.ApiCommand("vscode.open","_workbench.open","Opens the provided resource in the editor. Can be a text or binary file, or an http(s) URL. If you need more control over the options for opening a text file, use vscode.window.showTextDocument instead.",[R.ApiCommandArgument.Uri,new R.ApiCommandArgument("columnOrOptions","Either the column in which to open or editor options, see vscode.TextDocumentShowOptions",n=>n===void 0||typeof n=="number"||typeof n=="object",n=>n&&(typeof n=="number"?[n,void 0]:[c.ViewColumn.from(n.viewColumn),c.TextEditorOpenOptions.from(n)])).optional(),R.ApiCommandArgument.String.with("label","").optional()],R.ApiCommandResult.Void),new R.ApiCommand("vscode.openWith","_workbench.openWith","Opens the provided resource with a specific editor.",[R.ApiCommandArgument.Uri.with("resource","Resource to open"),R.ApiCommandArgument.String.with("viewId","Custom editor view id or 'default' to use VS Code's default editor"),new R.ApiCommandArgument("columnOrOptions","Either the column in which to open or editor options, see vscode.TextDocumentShowOptions",n=>n===void 0||typeof n=="number"||typeof n=="object",n=>n&&(typeof n=="number"?[n,void 0]:[c.ViewColumn.from(n.viewColumn),c.TextEditorOpenOptions.from(n)])).optional()],R.ApiCommandResult.Void),new R.ApiCommand("vscode.diff","_workbench.diff","Opens the provided resources in the diff editor to compare their contents.",[R.ApiCommandArgument.Uri.with("left","Left-hand side resource of the diff editor"),R.ApiCommandArgument.Uri.with("right","Right-hand side resource of the diff editor"),R.ApiCommandArgument.String.with("title","Human readable title for the diff editor").optional(),new R.ApiCommandArgument("columnOrOptions","Either the column in which to open or editor options, see vscode.TextDocumentShowOptions",n=>n===void 0||typeof n=="object",n=>n&&[c.ViewColumn.from(n.viewColumn),c.TextEditorOpenOptions.from(n)]).optional()],R.ApiCommandResult.Void),new R.ApiCommand("vscode.prepareTypeHierarchy","_executePrepareTypeHierarchy","Prepare type hierarchy at a position inside a document",[R.ApiCommandArgument.Uri,R.ApiCommandArgument.Position],new R.ApiCommandResult("A TypeHierarchyItem or undefined",n=>n.map(c.TypeHierarchyItem.to))),new R.ApiCommand("vscode.provideSupertypes","_executeProvideSupertypes","Compute supertypes for an item",[R.ApiCommandArgument.TypeHierarchyItem],new R.ApiCommandResult("A TypeHierarchyItem or undefined",n=>n.map(c.TypeHierarchyItem.to))),new R.ApiCommand("vscode.provideSubtypes","_executeProvideSubtypes","Compute subtypes for an item",[R.ApiCommandArgument.TypeHierarchyItem],new R.ApiCommandResult("A TypeHierarchyItem or undefined",n=>n.map(c.TypeHierarchyItem.to))),new R.ApiCommand("vscode.revealTestInExplorer","_revealTestInExplorer","Reveals a test instance in the explorer",[R.ApiCommandArgument.TestItem],R.ApiCommandResult.Void)];class P{static register(f){_.forEach(f.registerApiCommand,f)}}e.ExtHostApiCommands=P;function t(n){return f=>{if(Array.isArray(f))return f.map(n)}}function E(n){if(!Array.isArray(n))return;const f=[];for(const a of n)b.isLocationLink(a)?f.push(c.DefinitionLink.to(a)):f.push(c.location.to(a));return f}}),define(we[184],Ee([0,1,14,52,3,6,2,59,25,8,7,5]),function(re,e,c,M,b,R,F,C,_,P,t,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.createExtHostComments=void 0;function n(f,a,l){const w=f.getProxy(E.MainContext.MainThreadComments);class I{constructor(){this._commentControllers=new Map,this._commentControllersByExtension=new Map,a.registerArgumentProcessor({processArgument:s=>{if(s&&s.$mid===6){const u=this._commentControllers.get(s.handle);return u||s}else if(s&&s.$mid===7){const u=this._commentControllers.get(s.commentControlHandle);if(!u)return s;const d=u.getCommentThread(s.commentThreadHandle);return d||s}else if(s&&s.$mid===8){const u=this._commentControllers.get(s.thread.commentControlHandle);if(!u)return s;const d=u.getCommentThread(s.thread.commentThreadHandle);return d?{thread:d,text:s.text}:s}else if(s&&s.$mid===9){const u=this._commentControllers.get(s.thread.commentControlHandle);if(!u)return s;const d=u.getCommentThread(s.thread.commentThreadHandle);if(!d)return s;let p=s.commentUniqueId,k=d.getCommentByUniqueId(p);return k||s}else if(s&&s.$mid===10){const u=this._commentControllers.get(s.thread.commentControlHandle);if(!u)return s;const d=u.getCommentThread(s.thread.commentThreadHandle);if(!d)return s;let p=s.text,k=s.commentUniqueId,T=d.getCommentByUniqueId(k);return T?(T.body=p,T):s}return s}})}createCommentController(s,u,d){const p=I.handlePool++,k=new o(s,p,u,d);this._commentControllers.set(k.handle,k);const T=this._commentControllersByExtension.get(_.ExtensionIdentifier.toKey(s.identifier))||[];return T.push(k),this._commentControllersByExtension.set(_.ExtensionIdentifier.toKey(s.identifier),T),k.value}$createCommentThreadTemplate(s,u,d){const p=this._commentControllers.get(s);!p||p.$createCommentThreadTemplate(u,d)}async $updateCommentThreadTemplate(s,u,d){const p=this._commentControllers.get(s);!p||p.$updateCommentThreadTemplate(u,d)}$deleteCommentThread(s,u){const d=this._commentControllers.get(s);d&&d.$deleteCommentThread(u)}$provideCommentingRanges(s,u,d){const p=this._commentControllers.get(s);if(!p||!p.commentingRangeProvider)return Promise.resolve(void 0);const k=l.getDocument(F.URI.revive(u));return(0,c.asPromise)(()=>p.commentingRangeProvider.provideCommentingRanges(k,d)).then(T=>T?T.map(g=>P.Range.from(g)):void 0)}$toggleReaction(s,u,d,p,k){const T=this._commentControllers.get(s);return!T||!T.reactionHandler?Promise.resolve(void 0):(0,c.asPromise)(()=>{const g=T.getCommentThread(u);if(g){const D=g.getCommentByUniqueId(p.uniqueIdInThread);if(T!==void 0&&D&&T.reactionHandler)return T.reactionHandler(D,i(k))}return Promise.resolve(void 0)})}dispose(){}}I.handlePool=0;class S{constructor(s,u,d,p,k,T,g){this._commentControllerHandle=u,this._id=d,this._uri=p,this._range=k,this._comments=T,this.handle=S._handlePool++,this.commentHandle=0,this.modifications=Object.create(null),this._onDidUpdateCommentThread=new b.Emitter,this.onDidUpdateCommentThread=this._onDidUpdateCommentThread.event,this._canReply=!0,this._commentsMap=new Map,this._acceptInputDisposables=new R.MutableDisposable,this._acceptInputDisposables.value=new R.DisposableStore,this._id===void 0&&(this._id=`${s}.${this.handle}`),w.$createCommentThread(u,this.handle,this._id,this._uri,P.Range.from(this._range),g),this._localDisposables=[],this._isDiposed=!1,this._localDisposables.push(this.onDidUpdateCommentThread(()=>{this.eventuallyUpdateCommentThread()})),this.comments=T,this._localDisposables.push({dispose:()=>{w.$deleteCommentThread(u,this.handle)}});const D=this;this.value={get uri(){return D.uri},get range(){return D.range},set range(m){D.range=m},get comments(){return D.comments},set comments(m){D.comments=m},get collapsibleState(){return D.collapsibleState},set collapsibleState(m){D.collapsibleState=m},get canReply(){return D.canReply},set canReply(m){D.canReply=m},get contextValue(){return D.contextValue},set contextValue(m){D.contextValue=m},get label(){return D.label},set label(m){D.label=m},dispose:()=>{D.dispose()}}}set threadId(s){this._id=s}get threadId(){return this._id}get id(){return this._id}get resource(){return this._uri}get uri(){return this._uri}set range(s){s.isEqual(this._range)||(this._range=s,this.modifications.range=s,this._onDidUpdateCommentThread.fire())}get range(){return this._range}set canReply(s){this._canReply!==s&&(this._canReply=s,this.modifications.canReply=s,this._onDidUpdateCommentThread.fire())}get canReply(){return this._canReply}get label(){return this._label}set label(s){this._label=s,this.modifications.label=s,this._onDidUpdateCommentThread.fire()}get contextValue(){return this._contextValue}set contextValue(s){this._contextValue=s,this.modifications.contextValue=s,this._onDidUpdateCommentThread.fire()}get comments(){return this._comments}set comments(s){this._comments=s,this.modifications.comments=s,this._onDidUpdateCommentThread.fire()}get collapsibleState(){return this._collapseState}set collapsibleState(s){this._collapseState=s,this.modifications.collapsibleState=s,this._onDidUpdateCommentThread.fire()}get isDisposed(){return this._isDiposed}eventuallyUpdateCommentThread(){if(this._isDiposed)return;this._acceptInputDisposables.value||(this._acceptInputDisposables.value=new R.DisposableStore);const s=d=>Object.prototype.hasOwnProperty.call(this.modifications,d),u={};s("range")&&(u.range=P.Range.from(this._range)),s("label")&&(u.label=this.label),s("contextValue")&&(u.contextValue=this.contextValue),s("comments")&&(u.comments=this._comments.map(d=>h(this,d,this._commentsMap))),s("collapsibleState")&&(u.collapseState=v(this._collapseState)),s("canReply")&&(u.canReply=this.canReply),this.modifications={},w.$updateCommentThread(this._commentControllerHandle,this.handle,this._id,this._uri,u)}getCommentByUniqueId(s){for(let u of this._commentsMap){let d=u[0],p=u[1];if(s===p)return d}}dispose(){this._isDiposed=!0,this._acceptInputDisposables.dispose(),this._localDisposables.forEach(s=>s.dispose())}}S._handlePool=0,We([(0,M.debounce)(100)],S.prototype,"eventuallyUpdateCommentThread",null);class o{constructor(s,u,d,p){this._extension=s,this._handle=u,this._id=d,this._label=p,this._threads=new Map,w.$registerCommentController(this.handle,d,p);const k=this;this.value=Object.freeze({id:k.id,label:k.label,get options(){return k.options},set options(T){k.options=T},get commentingRangeProvider(){return k.commentingRangeProvider},set commentingRangeProvider(T){k.commentingRangeProvider=T},get reactionHandler(){return k.reactionHandler},set reactionHandler(T){k.reactionHandler=T},createCommentThread(T,g,D){return k.createCommentThread(T,g,D).value},dispose:()=>{k.dispose()}}),this._localDisposables=[],this._localDisposables.push({dispose:()=>{w.$unregisterCommentController(this.handle)}})}get id(){return this._id}get label(){return this._label}get handle(){return this._handle}get reactionHandler(){return this._reactionHandler}set reactionHandler(s){this._reactionHandler=s,w.$updateCommentControllerFeatures(this.handle,{reactionHandler:!!s})}get options(){return this._options}set options(s){this._options=s,w.$updateCommentControllerFeatures(this.handle,{options:this._options})}createCommentThread(s,u,d,p){if(typeof s=="string"){const k=new S(this.id,this.handle,s,u,d,p,this._extension.identifier);return this._threads.set(k.handle,k),k}else{const k=new S(this.id,this.handle,void 0,s,u,d,this._extension.identifier);return this._threads.set(k.handle,k),k}}$createCommentThreadTemplate(s,u){const d=new S(this.id,this.handle,void 0,F.URI.revive(s),P.Range.to(u),[],this._extension.identifier);return d.collapsibleState=C.CommentThreadCollapsibleState.Expanded,this._threads.set(d.handle,d),d}$updateCommentThreadTemplate(s,u){let d=this._threads.get(s);d&&(d.range=P.Range.to(u))}$deleteCommentThread(s){let u=this._threads.get(s);u&&u.dispose(),this._threads.delete(s)}getCommentThread(s){return this._threads.get(s)}dispose(){this._threads.forEach(s=>{s.dispose()}),this._localDisposables.forEach(s=>s.dispose())}}function h(r,s,u){let d=u.get(s);d||(d=++r.commentHandle,u.set(s,d));const p=s.author&&s.author.iconPath?s.author.iconPath.toString():void 0;return{mode:s.mode,contextValue:s.contextValue,uniqueIdInThread:d,body:P.MarkdownString.from(s.body),userName:s.author.name,userIconPath:p,label:s.label,commentReactions:s.reactions?s.reactions.map(k=>y(k)):void 0}}function y(r){return{label:r.label,iconPath:r.iconPath?P.pathOrURIToURI(r.iconPath):void 0,count:r.count,hasReacted:r.authorHasReacted}}function i(r){return{label:r.label||"",count:r.count||0,iconPath:r.iconPath?F.URI.revive(r.iconPath):"",authorHasReacted:r.hasReacted||!1}}function v(r){if(r!==void 0)switch(r){case t.CommentThreadCollapsibleState.Expanded:return C.CommentThreadCollapsibleState.Expanded;case t.CommentThreadCollapsibleState.Collapsed:return C.CommentThreadCollapsibleState.Collapsed}return C.CommentThreadCollapsibleState.Collapsed}return new I}e.createExtHostComments=n}),define(we[95],Ee([0,1,2,5,7,4,13,15,12,9,17]),function(re,e,c,M,b,R,F,C,_,P,t){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExtHostDecorations=e.ExtHostDecorations=void 0;let E=class vi{constructor(f,a){this._logService=a,this._provider=new Map,this._proxy=f.getProxy(M.MainContext.MainThreadDecorations)}registerFileDecorationProvider(f,a){const l=vi._handlePool++;this._provider.set(l,{provider:f,extensionId:a}),this._proxy.$registerDecorationProvider(l,a.value);const w=f.onDidChangeFileDecorations&&f.onDidChangeFileDecorations(I=>{if(!I){this._proxy.$onDidChange(l,null);return}let S=(0,_.asArray)(I);if(S.length<=vi._maxEventSize){this._proxy.$onDidChange(l,S);return}this._logService.warn("[Decorations] CAPPING events from decorations provider",a.value,S.length);const o=S.map(i=>({uri:i,rank:(0,P.count)(i.path,"/")})),h=(0,_.groupBy)(o,(i,v)=>i.rank-v.rank||(0,P.compare)(i.uri.path,v.uri.path));let y=[];e:for(let i of h){let v;for(let r of i){let s=(0,t.dirname)(r.uri.path);if(v!==s&&(v=s,y.push(r.uri)>=vi._maxEventSize))break e}}this._proxy.$onDidChange(l,y)});return new b.Disposable(()=>{w?.dispose(),this._proxy.$unregisterDecorationProvider(l),this._provider.delete(l)})}async $provideDecorations(f,a,l){if(!this._provider.has(f))return Object.create(null);const w=Object.create(null),{provider:I,extensionId:S}=this._provider.get(f);return await Promise.all(a.map(async o=>{try{const{uri:h,id:y}=o,i=await Promise.resolve(I.provideFileDecoration(c.URI.revive(h),l));if(!i)return;try{b.FileDecoration.validate(i),w[y]=[i.propagate,i.tooltip,i.badge,i.color]}catch(v){this._logService.warn(`INVALID decoration from extension '${S.value}': ${v}`)}}catch(h){this._logService.error(h)}})),w}};E._handlePool=0,E._maxEventSize=250,E=We([ze(0,F.IExtHostRpcService),ze(1,C.ILogService)],E),e.ExtHostDecorations=E,e.IExtHostDecorations=(0,R.createDecorator)("IExtHostDecorations")});var Ze=this&&this.__classPrivateFieldSet||function(re,e,c,M,b){if(M==="m")throw new TypeError("Private method is not writable");if(M==="a"&&!b)throw new TypeError("Private accessor was defined without a setter");if(typeof e=="function"?re!==e||!b:!e.has(re))throw new TypeError("Cannot write private member to an object whose class did not declare it");return M==="a"?b.call(re,c):b?b.value=c:e.set(re,c),c},Ae=this&&this.__classPrivateFieldGet||function(re,e,c,M){if(c==="a"&&!M)throw new TypeError("Private accessor was defined without a getter");if(typeof e=="function"?re!==e||!M:!e.has(re))throw new TypeError("Cannot read private member from an object whose class did not declare it");return c==="m"?M:c==="a"?M.call(re):M?M.value:e.get(re)};define(we[185],Ee([0,1,124,82,2,5,7,8,3,15,20,37,104]),function(re,e,c,M,b,R,F,C,_,P,t,E,n){"use strict";var f,a,l;Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostDiagnostics=e.DiagnosticCollection=void 0;class w{constructor(o,h,y,i,v,r){this._name=o,this._owner=h,this._maxDiagnosticsPerFile=y,f.set(this,void 0),a.set(this,void 0),l.set(this,void 0),this._isDisposed=!1,Ze(this,l,new n.SkipList((s,u)=>i.compare(s,u)),"f"),Ze(this,f,v,"f"),Ze(this,a,r,"f")}dispose(){this._isDisposed||(Ae(this,a,"f").fire([...Ae(this,l,"f").keys()]),Ae(this,f,"f")&&Ae(this,f,"f").$clear(this._owner),Ae(this,l,"f").clear(),this._isDisposed=!0)}get name(){return this._checkDisposed(),this._name}set(o,h){if(!o){this.clear();return}this._checkDisposed();let y=[];if(b.URI.isUri(o)){if(!h){this.delete(o);return}Ae(this,l,"f").set(o,h.slice()),y=[o]}else if(Array.isArray(o)){y=[];let v;o=[...o].sort(w._compareIndexedTuplesByUri);for(const r of o){const[s,u]=r;if((!v||s.toString()!==v.toString())&&(v&&Ae(this,l,"f").get(v).length===0&&Ae(this,l,"f").delete(v),v=s,y.push(s),Ae(this,l,"f").set(s,[])),u){const d=Ae(this,l,"f").get(s);d&&d.push(...u)}else{const d=Ae(this,l,"f").get(s);d&&(d.length=0)}}}if(Ae(this,a,"f").fire(y),!Ae(this,f,"f"))return;const i=[];for(let v of y){let r=[];const s=Ae(this,l,"f").get(v);if(s)if(s.length>this._maxDiagnosticsPerFile){r=[];const u=[F.DiagnosticSeverity.Error,F.DiagnosticSeverity.Warning,F.DiagnosticSeverity.Information,F.DiagnosticSeverity.Hint];e:for(let d=0;d<4;d++)for(let p of s)if(p.severity===u[d]&&r.push(C.Diagnostic.from(p))===this._maxDiagnosticsPerFile)break e;r.push({severity:M.MarkerSeverity.Info,message:(0,c.localize)(0,null,s.length-this._maxDiagnosticsPerFile),startLineNumber:r[r.length-1].startLineNumber,startColumn:r[r.length-1].startColumn,endLineNumber:r[r.length-1].endLineNumber,endColumn:r[r.length-1].endColumn})}else r=s.map(u=>C.Diagnostic.from(u));i.push([v,r])}Ae(this,f,"f").$changeMany(this._owner,i)}delete(o){this._checkDisposed(),Ae(this,a,"f").fire([o]),Ae(this,l,"f").delete(o),Ae(this,f,"f")&&Ae(this,f,"f").$changeMany(this._owner,[[o,void 0]])}clear(){this._checkDisposed(),Ae(this,a,"f").fire([...Ae(this,l,"f").keys()]),Ae(this,l,"f").clear(),Ae(this,f,"f")&&Ae(this,f,"f").$clear(this._owner)}forEach(o,h){this._checkDisposed();for(let y of Ae(this,l,"f").keys())o.apply(h,[y,this.get(y),this])}get(o){this._checkDisposed();const h=Ae(this,l,"f").get(o);return Array.isArray(h)?Object.freeze(h.slice(0)):[]}has(o){return this._checkDisposed(),Array.isArray(Ae(this,l,"f").get(o))}_checkDisposed(){if(this._isDisposed)throw new Error("illegal state - object is disposed")}static _compareIndexedTuplesByUri(o,h){return o[0].toString()<h[0].toString()?-1:o[0].toString()>h[0].toString()?1:0}}e.DiagnosticCollection=w,f=new WeakMap,a=new WeakMap,l=new WeakMap;let I=class Zt{constructor(o,h,y){this._logService=h,this._fileSystemInfoService=y,this._collections=new Map,this._onDidChangeDiagnostics=new _.DebounceEmitter({merge:i=>i.flat(),delay:50}),this.onDidChangeDiagnostics=_.Event.map(this._onDidChangeDiagnostics.event,Zt._mapper),this._proxy=o.getProxy(R.MainContext.MainThreadDiagnostics)}static _mapper(o){const h=new t.ResourceMap;for(const y of o)h.set(y,y);return{uris:Object.freeze(Array.from(h.values()))}}createDiagnosticCollection(o,h){const{_collections:y,_proxy:i,_onDidChangeDiagnostics:v,_logService:r,_fileSystemInfoService:s}=this,u=new class{$changeMany(k,T){i.$changeMany(k,T),r.trace("[DiagnosticCollection] change many (extension, owner, uris)",o.value,k,T.length===0?"CLEARING":T)}$clear(k){i.$clear(k),r.trace("[DiagnosticCollection] remove all (extension, owner)",o.value,k)}dispose(){i.dispose()}};let d;if(!h)h="_generated_diagnostic_collection_name_#"+Zt._idPool++,d=h;else if(!y.has(h))d=h;else{this._logService.warn(`DiagnosticCollection with name '${h}' does already exist.`);do d=h+Zt._idPool++;while(y.has(d))}return new class extends w{constructor(){super(h,d,Zt._maxDiagnosticsPerFile,s.extUri,u,v);y.set(d,this)}dispose(){super.dispose(),y.delete(d)}}}getDiagnostics(o){if(o)return this._getDiagnostics(o);{const h=new Map,y=[];for(const i of this._collections.values())i.forEach((v,r)=>{let s=h.get(v.toString());typeof s=="undefined"&&(s=y.length,h.set(v.toString(),s),y.push([v,[]])),y[s][1]=y[s][1].concat(...r)});return y}}_getDiagnostics(o){let h=[];for(let y of this._collections.values())y.has(o)&&(h=h.concat(y.get(o)));return h}$acceptMarkersChange(o){if(!this._mirrorCollection){const h="_generated_mirror",y=new w(h,h,Zt._maxDiagnosticsPerFile,this._fileSystemInfoService.extUri,void 0,this._onDidChangeDiagnostics);this._collections.set(h,y),this._mirrorCollection=y}for(const[h,y]of o)this._mirrorCollection.set(b.URI.revive(h),y.map(C.Diagnostic.to))}};I._idPool=0,I._maxDiagnosticsPerFile=1e3,I=We([ze(1,P.ILogService),ze(2,E.IExtHostFileSystemInfo)],I),e.ExtHostDiagnostics=I}),define(we[186],Ee([0,1,2,5]),function(re,e,c,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostDialogs=void 0;class b{constructor(F){this._proxy=F.getProxy(M.MainContext.MainThreadDialogs)}showOpenDialog(F){return this._proxy.$showOpenDialog(F).then(C=>C?C.map(_=>c.URI.revive(_)):void 0)}showSaveDialog(F){return this._proxy.$showSaveDialog(F).then(C=>C?c.URI.revive(C):void 0)}}e.ExtHostDialogs=b}),define(we[187],Ee([0,1,16,2,7,5,11,21,9]),function(re,e,c,M,b,R,F,C,_){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostDocumentContentProvider=void 0;class P{constructor(E,n,f){this._documentsAndEditors=n,this._logService=f,this._documentContentProviders=new Map,this._proxy=E.getProxy(R.MainContext.MainThreadDocumentContentProviders)}registerTextDocumentContentProvider(E,n){if(Object.keys(F.Schemas).indexOf(E)>=0)throw new Error(`scheme '${E}' already registered`);const f=P._handlePool++;this._documentContentProviders.set(f,n),this._proxy.$registerTextContentProvider(f,E);let a;return typeof n.onDidChange=="function"&&(a=n.onDidChange(l=>{if(l.scheme!==E){this._logService.warn(`Provider for scheme '${E}' is firing event for schema '${l.scheme}' which will be IGNORED`);return}this._documentsAndEditors.getDocument(l)&&this.$provideTextDocumentContent(f,l).then(w=>{if(!w&&typeof w!="string")return;const I=this._documentsAndEditors.getDocument(l);if(!I)return;const S=(0,_.splitLines)(w);if(!I.equalLines(S))return this._proxy.$onVirtualDocumentChange(l,w)},c.onUnexpectedError)})),new b.Disposable(()=>{this._documentContentProviders.delete(f)&&this._proxy.$unregisterTextContentProvider(f),a&&(a.dispose(),a=void 0)})}$provideTextDocumentContent(E,n){const f=this._documentContentProviders.get(E);return f?Promise.resolve(f.provideTextDocumentContent(M.URI.revive(n),C.CancellationToken.None)):Promise.reject(new Error(`unsupported uri-scheme: ${n.scheme}`))}}e.ExtHostDocumentContentProvider=P,P._handlePool=0}),define(we[188],Ee([0,1,3,6,2,5,88,8,10,23,7]),function(re,e,c,M,b,R,F,C,_,P,t){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostDocuments=void 0;class E{constructor(f,a){this._onDidAddDocument=new c.Emitter,this._onDidRemoveDocument=new c.Emitter,this._onDidChangeDocument=new c.Emitter,this._onDidSaveDocument=new c.Emitter,this.onDidAddDocument=this._onDidAddDocument.event,this.onDidRemoveDocument=this._onDidRemoveDocument.event,this.onDidChangeDocument=this._onDidChangeDocument.event,this.onDidSaveDocument=this._onDidSaveDocument.event,this._toDispose=new M.DisposableStore,this._documentLoader=new Map,this._proxy=f.getProxy(R.MainContext.MainThreadDocuments),this._documentsAndEditors=a,this._documentsAndEditors.onDidRemoveDocuments(l=>{for(const w of l)this._onDidRemoveDocument.fire(w.document)},void 0,this._toDispose),this._documentsAndEditors.onDidAddDocuments(l=>{for(const w of l)this._onDidAddDocument.fire(w.document)},void 0,this._toDispose)}dispose(){this._toDispose.dispose()}getAllDocumentData(){return[...this._documentsAndEditors.allDocuments()]}getDocumentData(f){if(!f)return;const a=this._documentsAndEditors.getDocument(f);if(a)return a}getDocument(f){const a=this.getDocumentData(f);if(!a?.document)throw new Error(`Unable to retrieve document from URI '${f}'`);return a.document}ensureDocumentData(f){const a=this._documentsAndEditors.getDocument(f);if(a)return Promise.resolve(a);let l=this._documentLoader.get(f.toString());return l||(l=this._proxy.$tryOpenDocument(f).then(w=>{this._documentLoader.delete(f.toString());const I=b.URI.revive(w);return(0,_.assertIsDefined)(this._documentsAndEditors.getDocument(I))},w=>(this._documentLoader.delete(f.toString()),Promise.reject(w))),this._documentLoader.set(f.toString(),l)),l}createDocumentData(f){return this._proxy.$tryCreateDocument(f).then(a=>b.URI.revive(a))}$acceptModelModeChanged(f,a){const l=b.URI.revive(f),w=this._documentsAndEditors.getDocument(l);if(!w)throw new Error("unknown document");this._onDidRemoveDocument.fire(w.document),w._acceptLanguageId(a),this._onDidAddDocument.fire(w.document)}$acceptModelSaved(f){const a=b.URI.revive(f),l=this._documentsAndEditors.getDocument(a);if(!l)throw new Error("unknown document");this.$acceptDirtyStateChanged(f,!1),this._onDidSaveDocument.fire(l.document)}$acceptDirtyStateChanged(f,a){const l=b.URI.revive(f),w=this._documentsAndEditors.getDocument(l);if(!w)throw new Error("unknown document");w._acceptIsDirty(a),this._onDidChangeDocument.fire({document:w.document,contentChanges:[],reason:void 0})}$acceptModelChanged(f,a,l){const w=b.URI.revive(f),I=this._documentsAndEditors.getDocument(w);if(!I)throw new Error("unknown document");I._acceptIsDirty(l),I.onEvents(a);let S;a.isUndoing?S=t.TextDocumentChangeReason.Undo:a.isRedoing&&(S=t.TextDocumentChangeReason.Redo),this._onDidChangeDocument.fire((0,P.deepFreeze)({document:I.document,contentChanges:a.changes.map(o=>({range:C.Range.to(o.range),rangeOffset:o.rangeOffset,rangeLength:o.rangeLength,text:o.text})),reason:S}))}setWordDefinitionFor(f,a){(0,F.setWordDefinitionFor)(f,a)}}e.ExtHostDocuments=E}),define(we[49],Ee([0,1,42,3,6,2,4,5,88,13,94,8,15,20,11,231,103]),function(re,e,c,M,b,R,F,C,_,P,t,E,n,f,a,l,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExtHostDocumentsAndEditors=e.ExtHostDocumentsAndEditors=void 0;class I{constructor(h){this.value=h,this._count=0}ref(){this._count++}unref(){return--this._count==0}}let S=class{constructor(h,y){this._extHostRpc=h,this._logService=y,this._activeEditorId=null,this._editors=new Map,this._documents=new f.ResourceMap,this._onDidAddDocuments=new M.Emitter,this._onDidRemoveDocuments=new M.Emitter,this._onDidChangeVisibleTextEditors=new M.Emitter,this._onDidChangeActiveTextEditor=new M.Emitter,this.onDidAddDocuments=this._onDidAddDocuments.event,this.onDidRemoveDocuments=this._onDidRemoveDocuments.event,this.onDidChangeVisibleTextEditors=this._onDidChangeVisibleTextEditors.event,this.onDidChangeActiveTextEditor=this._onDidChangeActiveTextEditor.event}$acceptDocumentsAndEditorsDelta(h){this.acceptDocumentsAndEditorsDelta(h)}acceptDocumentsAndEditorsDelta(h){const y=[],i=[],v=[];if(h.removedDocuments)for(const r of h.removedDocuments){const s=R.URI.revive(r),u=this._documents.get(s);u?.unref()&&(this._documents.delete(s),y.push(u.value))}if(h.addedDocuments)for(const r of h.addedDocuments){const s=R.URI.revive(r.uri);let u=this._documents.get(s);if(u&&s.scheme!==a.Schemas.vscodeNotebookCell&&s.scheme!==a.Schemas.vscodeInteractiveInput)throw new Error(`document '${s} already exists!'`);u||(u=new I(new _.ExtHostDocumentData(this._extHostRpc.getProxy(C.MainContext.MainThreadDocuments),s,r.lines,r.EOL,r.versionId,r.modeId,r.isDirty,r.notebook)),this._documents.set(s,u),i.push(u.value)),u.ref()}if(h.removedEditors)for(const r of h.removedEditors){const s=this._editors.get(r);this._editors.delete(r),s&&v.push(s)}if(h.addedEditors)for(const r of h.addedEditors){const s=R.URI.revive(r.documentUri);c.ok(this._documents.has(s),`document '${s}' does not exist`),c.ok(!this._editors.has(r.id),`editor '${r.id}' already exists!`);const u=this._documents.get(s).value,d=new t.ExtHostTextEditor(r.id,this._extHostRpc.getProxy(C.MainContext.MainThreadTextEditors),this._logService,new w.Lazy(()=>u.document),r.selections.map(E.Selection.to),r.options,r.visibleRanges.map(p=>E.Range.to(p)),typeof r.editorPosition=="number"?E.ViewColumn.to(r.editorPosition):void 0);this._editors.set(r.id,d)}h.newActiveEditor!==void 0&&(c.ok(h.newActiveEditor===null||this._editors.has(h.newActiveEditor),`active editor '${h.newActiveEditor}' does not exist`),this._activeEditorId=h.newActiveEditor),(0,b.dispose)(y),(0,b.dispose)(v),h.removedDocuments&&this._onDidRemoveDocuments.fire(y),h.addedDocuments&&this._onDidAddDocuments.fire(i),(h.removedEditors||h.addedEditors)&&this._onDidChangeVisibleTextEditors.fire(this.allEditors().map(r=>r.value)),h.newActiveEditor!==void 0&&this._onDidChangeActiveTextEditor.fire(this.activeEditor())}getDocument(h){return this._documents.get(h)?.value}allDocuments(){return l.Iterable.map(this._documents.values(),h=>h.value)}getEditor(h){return this._editors.get(h)}activeEditor(h){if(!this._activeEditorId)return;const y=this._editors.get(this._activeEditorId);return h?y:y?.value}allEditors(){return[...this._editors.values()]}};S=We([ze(0,P.IExtHostRpcService),ze(1,n.ILogService)],S),e.ExtHostDocumentsAndEditors=S,e.IExtHostDocumentsAndEditors=(0,F.createDecorator)("IExtHostDocumentsAndEditors")}),define(we[189],Ee([0,1,2,5,6,7,8,232,9,22]),function(re,e,c,M,b,R,F,C,_,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostFileSystem=void 0;class t{constructor(){this._schemes=[]}add(f){this._stateMachine=void 0,this._schemes.push(f)}delete(f){const a=this._schemes.indexOf(f);a>=0&&(this._schemes.splice(a,1),this._stateMachine=void 0)}_initStateMachine(){if(!this._stateMachine){const f=this._schemes.sort(),a=[];let l,w,I=14,S=14;for(const o of f){let h=l?(0,_.commonPrefixLength)(l,o):0;for(h===0?w=1:w=S;h<o.length;h++)h+1===o.length?(I=S,S=9):S+=1,a.push([w,o.toUpperCase().charCodeAt(h),S]),a.push([w,o.toLowerCase().charCodeAt(h),S]),w=S;l=o,S=I}a.push([9,58,10]),a.push([10,47,12]),this._stateMachine=new C.StateMachine(a)}}provideDocumentLinks(f){this._initStateMachine();const a=[],l=C.LinkComputer.computeLinks({getLineContent(w){return f.lineAt(w-1).text},getLineCount(){return f.lineCount}},this._stateMachine);for(const w of l){const I=F.DocumentLink.to(w);I.target&&a.push(I)}return a}}class E{constructor(f,a){this._extHostLanguageFeatures=a,this._linkProvider=new t,this._fsProvider=new Map,this._registeredSchemes=new Set,this._watches=new Map,this._handlePool=0,this._proxy=f.getProxy(M.MainContext.MainThreadFileSystem)}dispose(){this._linkProviderRegistration?.dispose()}_registerLinkProviderIfNotYetRegistered(){this._linkProviderRegistration||(this._linkProviderRegistration=this._extHostLanguageFeatures.registerDocumentLinkProvider(void 0,"*",this._linkProvider))}registerFileSystemProvider(f,a,l,w={}){if(this._registeredSchemes.has(a))throw new Error(`a provider for the scheme '${a}' is already registered`);this._registerLinkProviderIfNotYetRegistered();const I=this._handlePool++;this._linkProvider.add(a),this._registeredSchemes.add(a),this._fsProvider.set(I,l);let S=2;w.isCaseSensitive&&(S+=1024),w.isReadonly&&(S+=2048),typeof l.copy=="function"&&(S+=8),typeof l.open=="function"&&typeof l.close=="function"&&typeof l.read=="function"&&typeof l.write=="function"&&(S+=4),this._proxy.$registerFileSystemProvider(I,a,S).catch(h=>{console.error(`FAILED to register filesystem provider of ${f.value}-extension for the scheme ${a}`),console.error(h)});const o=l.onDidChangeFile(h=>{const y=[];for(const i of h){let{uri:v,type:r}=i;if(v.scheme!==a)continue;let s;switch(r){case R.FileChangeType.Changed:s=0;break;case R.FileChangeType.Created:s=1;break;case R.FileChangeType.Deleted:s=2;break;default:throw new Error("Unknown FileChangeType")}y.push({resource:v,type:s})}this._proxy.$onFileSystemChange(I,y)});return(0,b.toDisposable)(()=>{o.dispose(),this._linkProvider.delete(a),this._registeredSchemes.delete(a),this._fsProvider.delete(I),this._proxy.$unregisterProvider(I)})}static _asIStat(f){const{type:a,ctime:l,mtime:w,size:I,permissions:S}=f;return{type:a,ctime:l,mtime:w,size:I,permissions:S}}$stat(f,a){return Promise.resolve(this._getFsProvider(f).stat(c.URI.revive(a))).then(l=>E._asIStat(l))}$readdir(f,a){return Promise.resolve(this._getFsProvider(f).readDirectory(c.URI.revive(a)))}$readFile(f,a){return Promise.resolve(this._getFsProvider(f).readFile(c.URI.revive(a))).then(l=>P.VSBuffer.wrap(l))}$writeFile(f,a,l,w){return Promise.resolve(this._getFsProvider(f).writeFile(c.URI.revive(a),l.buffer,w))}$delete(f,a,l){return Promise.resolve(this._getFsProvider(f).delete(c.URI.revive(a),l))}$rename(f,a,l,w){return Promise.resolve(this._getFsProvider(f).rename(c.URI.revive(a),c.URI.revive(l),w))}$copy(f,a,l,w){const I=this._getFsProvider(f);if(!I.copy)throw new Error('FileSystemProvider does not implement "copy"');return Promise.resolve(I.copy(c.URI.revive(a),c.URI.revive(l),w))}$mkdir(f,a){return Promise.resolve(this._getFsProvider(f).createDirectory(c.URI.revive(a)))}$watch(f,a,l,w){const I=this._getFsProvider(f).watch(c.URI.revive(l),w);this._watches.set(a,I)}$unwatch(f,a){const l=this._watches.get(a);l&&(l.dispose(),this._watches.delete(a))}$open(f,a,l){const w=this._getFsProvider(f);if(!w.open)throw new Error('FileSystemProvider does not implement "open"');return Promise.resolve(w.open(c.URI.revive(a),l))}$close(f,a){const l=this._getFsProvider(f);if(!l.close)throw new Error('FileSystemProvider does not implement "close"');return Promise.resolve(l.close(a))}$read(f,a,l,w){const I=this._getFsProvider(f);if(!I.read)throw new Error('FileSystemProvider does not implement "read"');const S=P.VSBuffer.alloc(w);return Promise.resolve(I.read(a,l,S.buffer,0,w)).then(o=>S.slice(0,o))}$write(f,a,l,w){const I=this._getFsProvider(f);if(!I.write)throw new Error('FileSystemProvider does not implement "write"');return Promise.resolve(I.write(a,l,w.buffer,0,w.byteLength))}_getFsProvider(f){const a=this._fsProvider.get(f);if(!a){const l=new Error;throw l.name="ENOPRO",l.message="no provider",l}return a}}e.ExtHostFileSystem=E}),define(we[71],Ee([0,1,5,60,7,22,4,13,37]),function(re,e,c,M,b,R,F,C,_){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExtHostConsumerFileSystem=e.ExtHostConsumerFileSystem=void 0;let P=class Bt{constructor(E,n){const f=E.getProxy(c.MainContext.MainThreadFileSystem);this.value=Object.freeze({stat(a){return f.$stat(a).catch(Bt._handleError)},readDirectory(a){return f.$readdir(a).catch(Bt._handleError)},createDirectory(a){return f.$mkdir(a).catch(Bt._handleError)},async readFile(a){return f.$readFile(a).then(l=>l.buffer).catch(Bt._handleError)},writeFile(a,l){return f.$writeFile(a,R.VSBuffer.wrap(l)).catch(Bt._handleError)},delete(a,l){return f.$delete(a,{recursive:!1,useTrash:!1,...l}).catch(Bt._handleError)},rename(a,l,w){return f.$rename(a,l,{overwrite:!1,...w}).catch(Bt._handleError)},copy(a,l,w){return f.$copy(a,l,{overwrite:!1,...w}).catch(Bt._handleError)},isWritableFileSystem(a){const l=n.getCapabilities(a);if(typeof l=="number")return!(l&2048)}})}static _handleError(E){if(!(E instanceof Error))throw new b.FileSystemError(String(E));if(E.name==="ENOPRO")throw b.FileSystemError.Unavailable(E.message);switch(E.name){case M.FileSystemProviderErrorCode.FileExists:throw b.FileSystemError.FileExists(E.message);case M.FileSystemProviderErrorCode.FileNotFound:throw b.FileSystemError.FileNotFound(E.message);case M.FileSystemProviderErrorCode.FileNotADirectory:throw b.FileSystemError.FileNotADirectory(E.message);case M.FileSystemProviderErrorCode.FileIsADirectory:throw b.FileSystemError.FileIsADirectory(E.message);case M.FileSystemProviderErrorCode.NoPermissions:throw b.FileSystemError.NoPermissions(E.message);case M.FileSystemProviderErrorCode.Unavailable:throw b.FileSystemError.Unavailable(E.message);default:throw new b.FileSystemError(E.message,E.name)}}};P=We([ze(0,C.IExtHostRpcService),ze(1,_.IExtHostFileSystemInfo)],P),e.ExtHostConsumerFileSystem=P,e.IExtHostConsumerFileSystem=(0,F.createDecorator)("IExtHostConsumerFileSystem")}),define(we[190],Ee([0,1,2,39]),function(re,e,c,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostInteractive=void 0;class b{constructor(F,C,_,P){this._extHostNotebooks=C,this._textDocumentsAndEditors=_,this._commands=P;const t=new M.ApiCommand("interactive.open","_interactive.open","Open interactive window and return notebook editor and input URI",[new M.ApiCommandArgument("showOptions","Show Options",E=>!0,E=>E),new M.ApiCommandArgument("resource","Interactive resource Uri",E=>!0,E=>E),new M.ApiCommandArgument("controllerId","Notebook controller Id",E=>!0,E=>E),new M.ApiCommandArgument("title","Interactive editor title",E=>!0,E=>E)],new M.ApiCommandResult("Notebook and input URI",E=>{if(E.notebookEditorId!==void 0){const n=this._extHostNotebooks.getEditorById(E.notebookEditorId);return{notebookUri:c.URI.revive(E.notebookUri),inputUri:c.URI.revive(E.inputUri),notebookEditor:n.apiEditor}}return{notebookUri:c.URI.revive(E.notebookUri),inputUri:c.URI.revive(E.inputUri)}}));this._commands.registerApiCommand(t)}$willAddInteractiveDocument(F,C,_,P){this._textDocumentsAndEditors.acceptDocumentsAndEditorsDelta({addedDocuments:[{EOL:C,lines:[""],modeId:_,uri:F,isDirty:!1,versionId:1,notebook:this._extHostNotebooks.getNotebookDocument(c.URI.revive(P))?.apiNotebook}]})}$willRemoveInteractiveDocument(F,C){this._textDocumentsAndEditors.acceptDocumentsAndEditorsDelta({removedDocuments:[F]})}}e.ExtHostInteractive=b}),define(we[191],Ee([0,1,6,5]),function(re,e,c,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostLabelService=void 0;class b{constructor(F){this._handlePool=0,this._proxy=F.getProxy(M.MainContext.MainThreadLabelService)}$registerResourceLabelFormatter(F){const C=this._handlePool++;return this._proxy.$registerResourceLabelFormatter(C,F),(0,c.toDisposable)(()=>{this._proxy.$unregisterResourceLabelFormatter(C)})}}e.ExtHostLabelService=b}),define(we[192],Ee([0,1,2,23,8,7,5,9,44,12,10,233,6,80,53,63,193,16,3]),function(re,e,c,M,b,R,F,C,_,P,t,E,n,f,a,l,w,I,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostLanguageFeatures=e.InlineCompletionController=e.DocumentRangeSemanticTokensAdapter=e.DocumentSemanticTokensAdapter=void 0;class o{constructor(x,Q){this._documents=x,this._provider=Q}async provideDocumentSymbols(x,Q){const te=this._documents.getDocument(x),ae=await this._provider.provideDocumentSymbols(te,Q);if(!(0,P.isFalsyOrEmpty)(ae))return ae[0]instanceof R.DocumentSymbol?ae.map(b.DocumentSymbol.from):o._asDocumentSymbolTree(ae)}static _asDocumentSymbolTree(x){x=x.slice(0).sort((ae,q)=>{let se=ae.location.range.start.compareTo(q.location.range.start);return se===0&&(se=q.location.range.end.compareTo(ae.location.range.end)),se});const Q=[],te=[];for(const ae of x){const q={name:ae.name||"!!MISSING: name!!",kind:b.SymbolKind.from(ae.kind),tags:ae.tags?.map(b.SymbolTag.from)||[],detail:"",containerName:ae.containerName,range:b.Range.from(ae.location.range),selectionRange:b.Range.from(ae.location.range),children:[]};for(;;){if(te.length===0){te.push(q),Q.push(q);break}const se=te[te.length-1];if(_.Range.containsRange(se.range,q.range)&&!_.Range.equalsRange(se.range,q.range)){se.children&&se.children.push(q),te.push(q);break}te.pop()}}return Q}}class h{constructor(x,Q,te){this._documents=x,this._commands=Q,this._provider=te,this._cache=new l.Cache("CodeLens"),this._disposables=new Map}async provideCodeLenses(x,Q){const te=this._documents.getDocument(x),ae=await this._provider.provideCodeLenses(te,Q);if(!ae||Q.isCancellationRequested)return;const q=this._cache.add(ae),se=new n.DisposableStore;this._disposables.set(q,se);const he={cacheId:q,lenses:[]};for(let Te=0;Te<ae.length;Te++)he.lenses.push({cacheId:[q,Te],range:b.Range.from(ae[Te].range),command:this._commands.toInternal(ae[Te].command,se)});return he}async resolveCodeLens(x,Q){const te=x.cacheId&&this._cache.get(...x.cacheId);if(!te)return;let ae;if(typeof this._provider.resolveCodeLens!="function"||te.isResolved?ae=te:ae=await this._provider.resolveCodeLens(te,Q),ae||(ae=te),Q.isCancellationRequested)return;const q=x.cacheId&&this._disposables.get(x.cacheId[0]);if(!!q)return x.command=this._commands.toInternal(ae.command??h._badCmd,q),x}releaseCodeLenses(x){this._disposables.get(x)?.dispose(),this._disposables.delete(x),this._cache.delete(x)}}h._badCmd={command:"missing",title:"!!MISSING: command!!"};function y(qe){return Array.isArray(qe)?qe.map(b.DefinitionLink.from):qe?[b.DefinitionLink.from(qe)]:[]}class i{constructor(x,Q){this._documents=x,this._provider=Q}async provideDefinition(x,Q,te){const ae=this._documents.getDocument(x),q=b.Position.to(Q),se=await this._provider.provideDefinition(ae,q,te);return y(se)}}class v{constructor(x,Q){this._documents=x,this._provider=Q}async provideDeclaration(x,Q,te){const ae=this._documents.getDocument(x),q=b.Position.to(Q),se=await this._provider.provideDeclaration(ae,q,te);return y(se)}}class r{constructor(x,Q){this._documents=x,this._provider=Q}async provideImplementation(x,Q,te){const ae=this._documents.getDocument(x),q=b.Position.to(Q),se=await this._provider.provideImplementation(ae,q,te);return y(se)}}class s{constructor(x,Q){this._documents=x,this._provider=Q}async provideTypeDefinition(x,Q,te){const ae=this._documents.getDocument(x),q=b.Position.to(Q),se=await this._provider.provideTypeDefinition(ae,q,te);return y(se)}}class u{constructor(x,Q){this._documents=x,this._provider=Q}async provideHover(x,Q,te){const ae=this._documents.getDocument(x),q=b.Position.to(Q),se=await this._provider.provideHover(ae,q,te);if(!(!se||(0,P.isFalsyOrEmpty)(se.contents)))return se.range||(se.range=ae.getWordRangeAtPosition(q)),se.range||(se.range=new R.Range(q,q)),b.Hover.from(se)}}class d{constructor(x,Q){this._documents=x,this._provider=Q}async provideEvaluatableExpression(x,Q,te){const ae=this._documents.getDocument(x),q=b.Position.to(Q),se=await this._provider.provideEvaluatableExpression(ae,q,te);if(se)return b.EvaluatableExpression.from(se)}}class p{constructor(x,Q){this._documents=x,this._provider=Q}async provideInlineValues(x,Q,te,ae){const q=this._documents.getDocument(x),se=await this._provider.provideInlineValues(q,b.Range.to(Q),b.InlineValueContext.to(te),ae);if(Array.isArray(se))return se.map(he=>b.InlineValue.from(he))}}class k{constructor(x,Q){this._documents=x,this._provider=Q}async provideDocumentHighlights(x,Q,te){const ae=this._documents.getDocument(x),q=b.Position.to(Q),se=await this._provider.provideDocumentHighlights(ae,q,te);if(Array.isArray(se))return se.map(b.DocumentHighlight.from)}}class T{constructor(x,Q){this._documents=x,this._provider=Q}async provideLinkedEditingRanges(x,Q,te){const ae=this._documents.getDocument(x),q=b.Position.to(Q),se=await this._provider.provideLinkedEditingRanges(ae,q,te);if(se&&Array.isArray(se.ranges))return{ranges:(0,P.coalesce)(se.ranges.map(b.Range.from)),wordPattern:se.wordPattern}}}class g{constructor(x,Q){this._documents=x,this._provider=Q}async provideReferences(x,Q,te,ae){const q=this._documents.getDocument(x),se=b.Position.to(Q),he=await this._provider.provideReferences(q,se,te,ae);if(Array.isArray(he))return he.map(b.location.from)}}class D{constructor(x,Q,te,ae,q,se,he){this._documents=x,this._commands=Q,this._diagnostics=te,this._provider=ae,this._logService=q,this._extension=se,this._apiDeprecation=he,this._cache=new l.Cache("CodeAction"),this._disposables=new Map}async provideCodeActions(x,Q,te,ae){const q=this._documents.getDocument(x),se=E.Selection.isISelection(Q)?b.Selection.to(Q):b.Range.to(Q),he=[];for(const nt of this._diagnostics.getDiagnostics(x))if(se.intersection(nt.range)&&he.push(nt)>D._maxCodeActionsPerFile)break;const Te={diagnostics:he,only:te.only?new R.CodeActionKind(te.only):void 0,triggerKind:b.CodeActionTriggerKind.to(te.trigger)},Ue=await this._provider.provideCodeActions(q,se,Te,ae);if(!(0,P.isNonEmptyArray)(Ue)||ae.isCancellationRequested)return;const He=this._cache.add(Ue),Ke=new n.DisposableStore;this._disposables.set(He,Ke);const ye=[];for(let nt=0;nt<Ue.length;nt++){const H=Ue[nt];!H||(D._isCommand(H)?(this._apiDeprecation.report("CodeActionProvider.provideCodeActions - return commands",this._extension,"Return 'CodeAction' instances instead."),ye.push({_isSynthetic:!0,title:H.title,command:this._commands.toInternal(H,Ke)})):(Te.only&&(H.kind?Te.only.contains(H.kind)||this._logService.warn(`${this._extension.identifier.value} - Code actions of kind '${Te.only.value} 'requested but returned code action is of kind '${H.kind.value}'. Code action will be dropped. Please check 'CodeActionContext.only' to only return requested code actions.`):this._logService.warn(`${this._extension.identifier.value} - Code actions of kind '${Te.only.value} 'requested but returned code action does not have a 'kind'. Code action will be dropped. Please set 'CodeAction.kind'.`)),ye.push({cacheId:[He,nt],title:H.title,command:H.command&&this._commands.toInternal(H.command,Ke),diagnostics:H.diagnostics&&H.diagnostics.map(b.Diagnostic.from),edit:H.edit&&b.WorkspaceEdit.from(H.edit),kind:H.kind&&H.kind.value,isPreferred:H.isPreferred,disabled:H.disabled?.reason})))}return{cacheId:He,actions:ye}}async resolveCodeAction(x,Q){const[te,ae]=x,q=this._cache.get(te,ae);if(!q||D._isCommand(q)||!this._provider.resolveCodeAction)return;const se=await this._provider.resolveCodeAction(q,Q)??q;return se?.edit?b.WorkspaceEdit.from(se.edit):void 0}releaseCodeActions(x){this._disposables.get(x)?.dispose(),this._disposables.delete(x),this._cache.delete(x)}static _isCommand(x){return typeof x.command=="string"&&typeof x.title=="string"}}D._maxCodeActionsPerFile=1e3;class m{constructor(x,Q){this._documents=x,this._provider=Q}async provideDocumentFormattingEdits(x,Q,te){const ae=this._documents.getDocument(x),q=await this._provider.provideDocumentFormattingEdits(ae,Q,te);if(Array.isArray(q))return q.map(b.TextEdit.from)}}class A{constructor(x,Q){this._documents=x,this._provider=Q}async provideDocumentRangeFormattingEdits(x,Q,te,ae){const q=this._documents.getDocument(x),se=b.Range.to(Q),he=await this._provider.provideDocumentRangeFormattingEdits(q,se,te,ae);if(Array.isArray(he))return he.map(b.TextEdit.from)}}class L{constructor(x,Q){this._documents=x,this._provider=Q,this.autoFormatTriggerCharacters=[]}async provideOnTypeFormattingEdits(x,Q,te,ae,q){const se=this._documents.getDocument(x),he=b.Position.to(Q),Te=await this._provider.provideOnTypeFormattingEdits(se,he,te,ae,q);if(Array.isArray(Te))return Te.map(b.TextEdit.from)}}class V{constructor(x,Q){this._provider=x,this._logService=Q,this._symbolCache=new Map,this._resultCache=new Map}async provideWorkspaceSymbols(x,Q){const te=F.IdObject.mixin({symbols:[]}),ae=await this._provider.provideWorkspaceSymbols(x,Q);if((0,P.isNonEmptyArray)(ae))for(const q of ae){if(!q)continue;if(!q.name){this._logService.warn("INVALID SymbolInformation, lacks name",q);continue}const se=F.IdObject.mixin(b.WorkspaceSymbol.from(q));this._symbolCache.set(se._id,q),te.symbols.push(se)}return te.symbols.length>0&&this._resultCache.set(te._id,[te.symbols[0]._id,te.symbols[te.symbols.length-1]._id]),te}async resolveWorkspaceSymbol(x,Q){if(typeof this._provider.resolveWorkspaceSymbol!="function")return x;const te=this._symbolCache.get(x._id);if(te){const ae=await this._provider.resolveWorkspaceSymbol(te,Q);return ae&&(0,M.mixin)(x,b.WorkspaceSymbol.from(ae),!0)}}releaseWorkspaceSymbols(x){const Q=this._resultCache.get(x);if(Q){for(let[te,ae]=Q;te<=ae;te++)this._symbolCache.delete(te);this._resultCache.delete(x)}}}class G{constructor(x,Q,te){this._documents=x,this._provider=Q,this._logService=te}static supportsResolving(x){return typeof x.prepareRename=="function"}async provideRenameEdits(x,Q,te,ae){const q=this._documents.getDocument(x),se=b.Position.to(Q);try{const he=await this._provider.provideRenameEdits(q,se,te,ae);return he?b.WorkspaceEdit.from(he):void 0}catch(he){const Te=G._asMessage(he);return Te?{rejectReason:Te,edits:void 0}:Promise.reject(he)}}async resolveRenameLocation(x,Q,te){if(typeof this._provider.prepareRename!="function")return Promise.resolve(void 0);const ae=this._documents.getDocument(x),q=b.Position.to(Q);try{const se=await this._provider.prepareRename(ae,q,te);let he,Te;if(R.Range.isRange(se)?(he=se,Te=ae.getText(se)):(0,t.isObject)(se)&&(he=se.range,Te=se.placeholder),!he||!Te)return;if(he.start.line>q.line||he.end.line<q.line){this._logService.warn("INVALID rename location: position line must be within range start/end lines");return}return{range:b.Range.from(he),text:Te}}catch(se){const he=G._asMessage(se);return he?{rejectReason:he,range:void 0,text:void 0}:Promise.reject(se)}}static _asMessage(x){return typeof x=="string"?x:x instanceof Error&&typeof x.message=="string"?x.message:void 0}}class U{constructor(x,Q){this.resultId=x,this.tokens=Q}}class K{constructor(x,Q){this._documents=x,this._provider=Q,this._nextResultId=1,this._previousResults=new Map}async provideDocumentSemanticTokens(x,Q,te){const ae=this._documents.getDocument(x),q=Q!==0?this._previousResults.get(Q):null;let se=typeof q?.resultId=="string"&&typeof this._provider.provideDocumentSemanticTokensEdits=="function"?await this._provider.provideDocumentSemanticTokensEdits(ae,q.resultId,te):await this._provider.provideDocumentSemanticTokens(ae,te);return q&&this._previousResults.delete(Q),se?(se=K._fixProvidedSemanticTokens(se),this._send(K._convertToEdits(q,se),se)):null}async releaseDocumentSemanticColoring(x){this._previousResults.delete(x)}static _fixProvidedSemanticTokens(x){return K._isSemanticTokens(x)?K._isCorrectSemanticTokens(x)?x:new R.SemanticTokens(new Uint32Array(x.data),x.resultId):K._isSemanticTokensEdits(x)?K._isCorrectSemanticTokensEdits(x)?x:new R.SemanticTokensEdits(x.edits.map(Q=>new R.SemanticTokensEdit(Q.start,Q.deleteCount,Q.data?new Uint32Array(Q.data):Q.data)),x.resultId):x}static _isSemanticTokens(x){return x&&!!x.data}static _isCorrectSemanticTokens(x){return x.data instanceof Uint32Array}static _isSemanticTokensEdits(x){return x&&Array.isArray(x.edits)}static _isCorrectSemanticTokensEdits(x){for(const Q of x.edits)if(!(Q.data instanceof Uint32Array))return!1;return!0}static _convertToEdits(x,Q){if(!K._isSemanticTokens(Q)||!x||!x.tokens)return Q;const te=x.tokens,ae=te.length,q=Q.data,se=q.length;let he=0;const Te=Math.min(ae,se);for(;he<Te&&te[he]===q[he];)he++;if(he===ae&&he===se)return new R.SemanticTokensEdits([],Q.resultId);let Ue=0;const He=Te-he;for(;Ue<He&&te[ae-Ue-1]===q[se-Ue-1];)Ue++;return new R.SemanticTokensEdits([{start:he,deleteCount:ae-he-Ue,data:q.subarray(he,se-Ue)}],Q.resultId)}_send(x,Q){if(K._isSemanticTokens(x)){const te=this._nextResultId++;return this._previousResults.set(te,new U(x.resultId,x.data)),(0,f.encodeSemanticTokensDto)({id:te,type:"full",data:x.data})}if(K._isSemanticTokensEdits(x)){const te=this._nextResultId++;return K._isSemanticTokens(Q)?this._previousResults.set(te,new U(Q.resultId,Q.data)):this._previousResults.set(te,new U(x.resultId)),(0,f.encodeSemanticTokensDto)({id:te,type:"delta",deltas:(x.edits||[]).map(ae=>({start:ae.start,deleteCount:ae.deleteCount,data:ae.data}))})}return null}}e.DocumentSemanticTokensAdapter=K;class ${constructor(x,Q){this._documents=x,this._provider=Q}async provideDocumentRangeSemanticTokens(x,Q,te){const ae=this._documents.getDocument(x),q=await this._provider.provideDocumentRangeSemanticTokens(ae,b.Range.to(Q),te);return q?this._send(q):null}_send(x){return(0,f.encodeSemanticTokensDto)({id:0,type:"full",data:x.data})}}e.DocumentRangeSemanticTokensAdapter=$;class B{constructor(x,Q,te,ae,q){this._documents=x,this._commands=Q,this._provider=te,this._apiDeprecation=ae,this._extension=q,this._cache=new l.Cache("CompletionItem"),this._disposables=new Map}static supportsResolving(x){return typeof x.resolveCompletionItem=="function"}async provideCompletionItems(x,Q,te,ae){const q=this._documents.getDocument(x),se=b.Position.to(Q),he=q.getWordRangeAtPosition(se)||new R.Range(se,se),Te=he.with({end:se}),Ue=new w.StopWatch(!0),He=await this._provider.provideCompletionItems(q,se,ae,b.CompletionContext.to(te));if(!He||ae.isCancellationRequested)return;const Ke=Array.isArray(He)?new R.CompletionList(He):He,ye=B.supportsResolving(this._provider)?this._cache.add(Ke.items):this._cache.add([]),nt=new n.DisposableStore;this._disposables.set(ye,nt);const H=[],J={x:ye,b:H,a:{replace:b.Range.from(he),insert:b.Range.from(Te)},c:Ke.isIncomplete||void 0,d:Ue.elapsed()};for(let fe=0;fe<Ke.items.length;fe++){const xe=Ke.items[fe],Qe=this._convertCompletionItem(xe,[ye,fe],Te,he);H.push(Qe)}return J}async resolveCompletionItem(x,Q){if(typeof this._provider.resolveCompletionItem!="function")return;const te=this._cache.get(...x);if(!te)return;const ae=await this._provider.resolveCompletionItem(te,Q);if(!!ae)return this._convertCompletionItem(ae,x)}releaseCompletionItems(x){this._disposables.get(x)?.dispose(),this._disposables.delete(x),this._cache.delete(x)}_convertCompletionItem(x,Q,te,ae){const q=this._disposables.get(Q[0]);if(!q)throw Error("DisposableStore is missing...");const se={x:Q,a:x.label,b:x.kind!==void 0?b.CompletionItemKind.from(x.kind):void 0,n:x.tags&&x.tags.map(b.CompletionItemTag.from),c:x.detail,d:typeof x.documentation=="undefined"?void 0:b.MarkdownString.fromStrict(x.documentation),e:x.sortText!==x.label?x.sortText:void 0,f:x.filterText!==x.label?x.filterText:void 0,g:x.preselect||void 0,i:x.keepWhitespace?1:0,k:x.commitCharacters,l:x.additionalTextEdits&&x.additionalTextEdits.map(b.TextEdit.from),m:this._commands.toInternal(x.command,q)};x.textEdit?(this._apiDeprecation.report("CompletionItem.textEdit",this._extension,"Use 'CompletionItem.insertText' and 'CompletionItem.range' instead."),se.h=x.textEdit.newText):typeof x.insertText=="string"?se.h=x.insertText:x.insertText instanceof R.SnippetString&&(se.h=x.insertText.value,se.i|=4);let he;return x.textEdit?he=x.textEdit.range:x.range&&(he=x.range),R.Range.isRange(he)?se.j=b.Range.from(he):he&&(!te?.isEqual(he.inserting)||!ae?.isEqual(he.replacing))&&(se.j={insert:b.Range.from(he.inserting),replace:b.Range.from(he.replacing)}),se}}class z{constructor(x,Q,te){this._documents=x,this._provider=Q,this._commands=te,this._cache=new l.Cache("InlineCompletionItem"),this._disposables=new Map}async provideInlineCompletions(x,Q,te,ae){const q=this._documents.getDocument(x),se=b.Position.to(Q),he=await this._provider.provideInlineCompletionItems(q,se,{selectedCompletionInfo:te.selectedSuggestionInfo?{range:b.Range.to(te.selectedSuggestionInfo.range),text:te.selectedSuggestionInfo.text}:void 0,triggerKind:te.triggerKind},ae);if(!he||ae.isCancellationRequested)return;const Te=(0,t.isArray)(he)?{items:he}:he,Ue=this._cache.add(Te.items);let He;return{pid:Ue,items:Te.items.map((Ke,ye)=>{let nt;return Ke.command&&(He||(He=new n.DisposableStore,this._disposables.set(Ue,He)),nt=this._commands.toInternal(Ke.command,He)),{text:Ke.text,range:Ke.range?b.Range.from(Ke.range):void 0,command:nt,idx:ye}})}}disposeCompletions(x){this._cache.delete(x);const Q=this._disposables.get(x);Q&&Q.clear(),this._disposables.delete(x)}handleDidShowCompletionItem(x,Q){const te=this._cache.get(x,Q);te&&Y.get(this._provider).fireOnDidShowCompletionItem({completionItem:te})}}class Y{constructor(){this._onDidShowCompletionItemEmitter=new S.Emitter,this.onDidShowCompletionItem=this._onDidShowCompletionItemEmitter.event}static get(x){let Q=Y.map.get(x);return Q||(Q=new Y,Y.map.set(x,Q)),Q}fireOnDidShowCompletionItem(x){this._onDidShowCompletionItemEmitter.fire(x)}}e.InlineCompletionController=Y,Y.map=new WeakMap;class ne{constructor(x,Q){this._documents=x,this._provider=Q,this._cache=new l.Cache("SignatureHelp")}async provideSignatureHelp(x,Q,te,ae){const q=this._documents.getDocument(x),se=b.Position.to(Q),he=this.reviveContext(te),Te=await this._provider.provideSignatureHelp(q,se,ae,he);if(Te){const Ue=this._cache.add([Te]);return{...b.SignatureHelp.from(Te),id:Ue}}}reviveContext(x){let Q;if(x.activeSignatureHelp){const te=b.SignatureHelp.to(x.activeSignatureHelp),ae=this._cache.get(x.activeSignatureHelp.id,0);ae?(Q=ae,Q.activeSignature=te.activeSignature,Q.activeParameter=te.activeParameter):Q=te}return{...x,activeSignatureHelp:Q}}releaseSignatureHelp(x){this._cache.delete(x)}}class j{constructor(x,Q){this._documents=x,this._provider=Q}async provideInlayHints(x,Q,te){const ae=this._documents.getDocument(x),q=await this._provider.provideInlayHints(ae,b.Range.to(Q),te);return q?{hints:q.map(b.InlayHint.from)}:void 0}}class le{constructor(x,Q){this._documents=x,this._provider=Q,this._cache=new l.Cache("DocumentLink")}async provideLinks(x,Q){const te=this._documents.getDocument(x),ae=await this._provider.provideDocumentLinks(te,Q);if(!(!Array.isArray(ae)||ae.length===0)&&!Q.isCancellationRequested){if(typeof this._provider.resolveDocumentLink!="function")return{links:ae.filter(le._validateLink).map(b.DocumentLink.from)};{const q=this._cache.add(ae),se={links:[],id:q};for(let he=0;he<ae.length;he++){if(!le._validateLink(ae[he]))continue;const Te=b.DocumentLink.from(ae[he]);Te.cacheId=[q,he],se.links.push(Te)}return se}}}static _validateLink(x){return x.target&&x.target.path.length>5e4?(console.warn("DROPPING link because it is too long"),!1):!0}async resolveLink(x,Q){if(typeof this._provider.resolveDocumentLink!="function")return;const te=this._cache.get(...x);if(!te)return;const ae=await this._provider.resolveDocumentLink(te,Q);if(!(!ae||!le._validateLink(ae)))return b.DocumentLink.from(ae)}releaseLinks(x){this._cache.delete(x)}}class oe{constructor(x,Q){this._documents=x,this._provider=Q}async provideColors(x,Q){const te=this._documents.getDocument(x),ae=await this._provider.provideDocumentColors(te,Q);return Array.isArray(ae)?ae.map(se=>({color:b.Color.from(se.color),range:b.Range.from(se.range)})):[]}async provideColorPresentations(x,Q,te){const ae=this._documents.getDocument(x),q=b.Range.to(Q.range),se=b.Color.to(Q.color),he=await this._provider.provideColorPresentations(se,{document:ae,range:q},te);if(!!Array.isArray(he))return he.map(b.ColorPresentation.from)}}class ve{constructor(x,Q){this._documents=x,this._provider=Q}async provideFoldingRanges(x,Q,te){const ae=this._documents.getDocument(x),q=await this._provider.provideFoldingRanges(ae,Q,te);if(!!Array.isArray(q))return q.map(b.FoldingRange.from)}}class Re{constructor(x,Q,te){this._documents=x,this._provider=Q,this._logService=te}async provideSelectionRanges(x,Q,te){const ae=this._documents.getDocument(x),q=Q.map(b.Position.to),se=await this._provider.provideSelectionRanges(ae,q,te);if(!(0,P.isNonEmptyArray)(se))return[];if(se.length!==q.length)return this._logService.warn("BAD selection ranges, provider must return ranges for each position"),[];const he=[];for(let Te=0;Te<q.length;Te++){const Ue=[];he.push(Ue);let He=q[Te],Ke=se[Te];for(;;){if(!Ke.range.contains(He))throw new Error("INVALID selection range, must contain the previous range");if(Ue.push(b.SelectionRange.from(Ke)),!Ke.parent)break;He=Ke.range,Ke=Ke.parent}}return he}}class Me{constructor(x,Q){this._documents=x,this._provider=Q,this._idPool=new a.IdGenerator(""),this._cache=new Map}async prepareSession(x,Q,te){const ae=this._documents.getDocument(x),q=b.Position.to(Q),se=await this._provider.prepareCallHierarchy(ae,q,te);if(!se)return;const he=this._idPool.nextId();return this._cache.set(he,new Map),Array.isArray(se)?se.map(Te=>this._cacheAndConvertItem(he,Te)):[this._cacheAndConvertItem(he,se)]}async provideCallsTo(x,Q,te){const ae=this._itemFromCache(x,Q);if(!ae)throw new Error("missing call hierarchy item");const q=await this._provider.provideCallHierarchyIncomingCalls(ae,te);if(!!q)return q.map(se=>({from:this._cacheAndConvertItem(x,se.from),fromRanges:se.fromRanges.map(he=>b.Range.from(he))}))}async provideCallsFrom(x,Q,te){const ae=this._itemFromCache(x,Q);if(!ae)throw new Error("missing call hierarchy item");const q=await this._provider.provideCallHierarchyOutgoingCalls(ae,te);if(!!q)return q.map(se=>({to:this._cacheAndConvertItem(x,se.to),fromRanges:se.fromRanges.map(he=>b.Range.from(he))}))}releaseSession(x){this._cache.delete(x)}_cacheAndConvertItem(x,Q){const te=this._cache.get(x),ae=b.CallHierarchyItem.from(Q,x,te.size.toString(36));return te.set(ae._itemId,Q),ae}_itemFromCache(x,Q){return this._cache.get(x)?.get(Q)}}class Oe{constructor(x,Q){this._documents=x,this._provider=Q,this._idPool=new a.IdGenerator(""),this._cache=new Map}async prepareSession(x,Q,te){const ae=this._documents.getDocument(x),q=b.Position.to(Q),se=await this._provider.prepareTypeHierarchy(ae,q,te);if(!se)return;const he=this._idPool.nextId();return this._cache.set(he,new Map),Array.isArray(se)?se.map(Te=>this._cacheAndConvertItem(he,Te)):[this._cacheAndConvertItem(he,se)]}async provideSupertypes(x,Q,te){const ae=this._itemFromCache(x,Q);if(!ae)throw new Error("missing type hierarchy item");const q=await this._provider.provideTypeHierarchySupertypes(ae,te);if(!!q)return q.map(se=>this._cacheAndConvertItem(x,se))}async provideSubtypes(x,Q,te){const ae=this._itemFromCache(x,Q);if(!ae)throw new Error("missing type hierarchy item");const q=await this._provider.provideTypeHierarchySubtypes(ae,te);if(!!q)return q.map(se=>this._cacheAndConvertItem(x,se))}releaseSession(x){this._cache.delete(x)}_cacheAndConvertItem(x,Q){const te=this._cache.get(x),ae=b.TypeHierarchyItem.from(Q,x,te.size.toString(36));return te.set(ae._itemId,Q),ae}_itemFromCache(x,Q){return this._cache.get(x)?.get(Q)}}class Ye{constructor(x,Q){this.adapter=x,this.extension=Q}}class Ve{constructor(x,Q,te,ae,q,se,he){this._adapter=new Map,this._uriTransformer=Q,this._proxy=x.getProxy(F.MainContext.MainThreadLanguageFeatures),this._documents=te,this._commands=ae,this._diagnostics=q,this._logService=se,this._apiDeprecation=he}_transformDocumentSelector(x){return b.DocumentSelector.from(x,this._uriTransformer)}_createDisposable(x){return new R.Disposable(()=>{this._adapter.delete(x),this._proxy.$unregister(x)})}_nextHandle(){return Ve._handlePool++}_withAdapter(x,Q,te,ae,q=!1){const se=this._adapter.get(x);if(!se)return Promise.resolve(ae);if(se.adapter instanceof Q){let he;se.extension&&(he=Date.now(),this._logService.trace(`[${se.extension.identifier.value}] INVOKE provider '${Q.name}'`));const Te=te(se.adapter,se.extension),Ue=se.extension;return Ue&&Promise.resolve(Te).then(()=>this._logService.trace(`[${Ue.identifier.value}] provider DONE after ${Date.now()-he}ms`),He=>{q&&He instanceof I.CancellationError||(this._logService.error(`[${Ue.identifier.value}] provider FAILED`),this._logService.error(He))}),Te}return Promise.reject(new Error("no adapter found"))}_addNewAdapter(x,Q){const te=this._nextHandle();return this._adapter.set(te,new Ye(x,Q)),te}static _extLabel(x){return x.displayName||x.name}registerDocumentSymbolProvider(x,Q,te,ae){const q=this._addNewAdapter(new o(this._documents,te),x),se=ae&&ae.label||Ve._extLabel(x);return this._proxy.$registerDocumentSymbolProvider(q,this._transformDocumentSelector(Q),se),this._createDisposable(q)}$provideDocumentSymbols(x,Q,te){return this._withAdapter(x,o,ae=>ae.provideDocumentSymbols(c.URI.revive(Q),te),void 0)}registerCodeLensProvider(x,Q,te){const ae=this._nextHandle(),q=typeof te.onDidChangeCodeLenses=="function"?this._nextHandle():void 0;this._adapter.set(ae,new Ye(new h(this._documents,this._commands.converter,te),x)),this._proxy.$registerCodeLensSupport(ae,this._transformDocumentSelector(Q),q);let se=this._createDisposable(ae);if(q!==void 0){const he=te.onDidChangeCodeLenses(Te=>this._proxy.$emitCodeLensEvent(q));se=R.Disposable.from(se,he)}return se}$provideCodeLenses(x,Q,te){return this._withAdapter(x,h,ae=>ae.provideCodeLenses(c.URI.revive(Q),te),void 0)}$resolveCodeLens(x,Q,te){return this._withAdapter(x,h,ae=>ae.resolveCodeLens(Q,te),void 0)}$releaseCodeLenses(x,Q){this._withAdapter(x,h,te=>Promise.resolve(te.releaseCodeLenses(Q)),void 0)}registerDefinitionProvider(x,Q,te){const ae=this._addNewAdapter(new i(this._documents,te),x);return this._proxy.$registerDefinitionSupport(ae,this._transformDocumentSelector(Q)),this._createDisposable(ae)}$provideDefinition(x,Q,te,ae){return this._withAdapter(x,i,q=>q.provideDefinition(c.URI.revive(Q),te,ae),[])}registerDeclarationProvider(x,Q,te){const ae=this._addNewAdapter(new v(this._documents,te),x);return this._proxy.$registerDeclarationSupport(ae,this._transformDocumentSelector(Q)),this._createDisposable(ae)}$provideDeclaration(x,Q,te,ae){return this._withAdapter(x,v,q=>q.provideDeclaration(c.URI.revive(Q),te,ae),[])}registerImplementationProvider(x,Q,te){const ae=this._addNewAdapter(new r(this._documents,te),x);return this._proxy.$registerImplementationSupport(ae,this._transformDocumentSelector(Q)),this._createDisposable(ae)}$provideImplementation(x,Q,te,ae){return this._withAdapter(x,r,q=>q.provideImplementation(c.URI.revive(Q),te,ae),[])}registerTypeDefinitionProvider(x,Q,te){const ae=this._addNewAdapter(new s(this._documents,te),x);return this._proxy.$registerTypeDefinitionSupport(ae,this._transformDocumentSelector(Q)),this._createDisposable(ae)}$provideTypeDefinition(x,Q,te,ae){return this._withAdapter(x,s,q=>q.provideTypeDefinition(c.URI.revive(Q),te,ae),[])}registerHoverProvider(x,Q,te,ae){const q=this._addNewAdapter(new u(this._documents,te),x);return this._proxy.$registerHoverProvider(q,this._transformDocumentSelector(Q)),this._createDisposable(q)}$provideHover(x,Q,te,ae){return this._withAdapter(x,u,q=>q.provideHover(c.URI.revive(Q),te,ae),void 0)}registerEvaluatableExpressionProvider(x,Q,te,ae){const q=this._addNewAdapter(new d(this._documents,te),x);return this._proxy.$registerEvaluatableExpressionProvider(q,this._transformDocumentSelector(Q)),this._createDisposable(q)}$provideEvaluatableExpression(x,Q,te,ae){return this._withAdapter(x,d,q=>q.provideEvaluatableExpression(c.URI.revive(Q),te,ae),void 0)}registerInlineValuesProvider(x,Q,te,ae){const q=typeof te.onDidChangeInlineValues=="function"?this._nextHandle():void 0,se=this._addNewAdapter(new p(this._documents,te),x);this._proxy.$registerInlineValuesProvider(se,this._transformDocumentSelector(Q),q);let he=this._createDisposable(se);if(q!==void 0){const Te=te.onDidChangeInlineValues(Ue=>this._proxy.$emitInlineValuesEvent(q));he=R.Disposable.from(he,Te)}return he}$provideInlineValues(x,Q,te,ae,q){return this._withAdapter(x,p,se=>se.provideInlineValues(c.URI.revive(Q),te,ae,q),void 0)}registerDocumentHighlightProvider(x,Q,te){const ae=this._addNewAdapter(new k(this._documents,te),x);return this._proxy.$registerDocumentHighlightProvider(ae,this._transformDocumentSelector(Q)),this._createDisposable(ae)}$provideDocumentHighlights(x,Q,te,ae){return this._withAdapter(x,k,q=>q.provideDocumentHighlights(c.URI.revive(Q),te,ae),void 0)}registerLinkedEditingRangeProvider(x,Q,te){const ae=this._addNewAdapter(new T(this._documents,te),x);return this._proxy.$registerLinkedEditingRangeProvider(ae,this._transformDocumentSelector(Q)),this._createDisposable(ae)}$provideLinkedEditingRanges(x,Q,te,ae){return this._withAdapter(x,T,async q=>{const se=await q.provideLinkedEditingRanges(c.URI.revive(Q),te,ae);if(se)return{ranges:se.ranges,wordPattern:se.wordPattern?Ve._serializeRegExp(se.wordPattern):void 0}},void 0)}registerReferenceProvider(x,Q,te){const ae=this._addNewAdapter(new g(this._documents,te),x);return this._proxy.$registerReferenceSupport(ae,this._transformDocumentSelector(Q)),this._createDisposable(ae)}$provideReferences(x,Q,te,ae,q){return this._withAdapter(x,g,se=>se.provideReferences(c.URI.revive(Q),te,ae,q),void 0)}registerCodeActionProvider(x,Q,te,ae){const q=new n.DisposableStore,se=this._addNewAdapter(new D(this._documents,this._commands.converter,this._diagnostics,te,this._logService,x,this._apiDeprecation),x);return this._proxy.$registerQuickFixSupport(se,this._transformDocumentSelector(Q),{providedKinds:ae?.providedCodeActionKinds?.map(he=>he.value),documentation:ae?.documentation?.map(he=>({kind:he.kind.value,command:this._commands.converter.toInternal(he.command,q)}))},Ve._extLabel(x),Boolean(te.resolveCodeAction)),q.add(this._createDisposable(se)),q}$provideCodeActions(x,Q,te,ae,q){return this._withAdapter(x,D,se=>se.provideCodeActions(c.URI.revive(Q),te,ae,q),void 0)}$resolveCodeAction(x,Q,te){return this._withAdapter(x,D,ae=>ae.resolveCodeAction(Q,te),void 0)}$releaseCodeActions(x,Q){this._withAdapter(x,D,te=>Promise.resolve(te.releaseCodeActions(Q)),void 0)}registerDocumentFormattingEditProvider(x,Q,te){const ae=this._addNewAdapter(new m(this._documents,te),x);return this._proxy.$registerDocumentFormattingSupport(ae,this._transformDocumentSelector(Q),x.identifier,x.displayName||x.name),this._createDisposable(ae)}$provideDocumentFormattingEdits(x,Q,te,ae){return this._withAdapter(x,m,q=>q.provideDocumentFormattingEdits(c.URI.revive(Q),te,ae),void 0)}registerDocumentRangeFormattingEditProvider(x,Q,te){const ae=this._addNewAdapter(new A(this._documents,te),x);return this._proxy.$registerRangeFormattingSupport(ae,this._transformDocumentSelector(Q),x.identifier,x.displayName||x.name),this._createDisposable(ae)}$provideDocumentRangeFormattingEdits(x,Q,te,ae,q){return this._withAdapter(x,A,se=>se.provideDocumentRangeFormattingEdits(c.URI.revive(Q),te,ae,q),void 0)}registerOnTypeFormattingEditProvider(x,Q,te,ae){const q=this._addNewAdapter(new L(this._documents,te),x);return this._proxy.$registerOnTypeFormattingSupport(q,this._transformDocumentSelector(Q),ae,x.identifier),this._createDisposable(q)}$provideOnTypeFormattingEdits(x,Q,te,ae,q,se){return this._withAdapter(x,L,he=>he.provideOnTypeFormattingEdits(c.URI.revive(Q),te,ae,q,se),void 0)}registerWorkspaceSymbolProvider(x,Q){const te=this._addNewAdapter(new V(Q,this._logService),x);return this._proxy.$registerNavigateTypeSupport(te),this._createDisposable(te)}$provideWorkspaceSymbols(x,Q,te){return this._withAdapter(x,V,ae=>ae.provideWorkspaceSymbols(Q,te),{symbols:[]})}$resolveWorkspaceSymbol(x,Q,te){return this._withAdapter(x,V,ae=>ae.resolveWorkspaceSymbol(Q,te),void 0)}$releaseWorkspaceSymbols(x,Q){this._withAdapter(x,V,te=>te.releaseWorkspaceSymbols(Q),void 0)}registerRenameProvider(x,Q,te){const ae=this._addNewAdapter(new G(this._documents,te,this._logService),x);return this._proxy.$registerRenameSupport(ae,this._transformDocumentSelector(Q),G.supportsResolving(te)),this._createDisposable(ae)}$provideRenameEdits(x,Q,te,ae,q){return this._withAdapter(x,G,se=>se.provideRenameEdits(c.URI.revive(Q),te,ae,q),void 0)}$resolveRenameLocation(x,Q,te,ae){return this._withAdapter(x,G,q=>q.resolveRenameLocation(c.URI.revive(Q),te,ae),void 0)}registerDocumentSemanticTokensProvider(x,Q,te,ae){const q=this._nextHandle(),se=typeof te.onDidChangeSemanticTokens=="function"?this._nextHandle():void 0;this._adapter.set(q,new Ye(new K(this._documents,te),x)),this._proxy.$registerDocumentSemanticTokensProvider(q,this._transformDocumentSelector(Q),ae,se);let he=this._createDisposable(q);if(se){const Te=te.onDidChangeSemanticTokens(Ue=>this._proxy.$emitDocumentSemanticTokensEvent(se));he=R.Disposable.from(he,Te)}return he}$provideDocumentSemanticTokens(x,Q,te,ae){return this._withAdapter(x,K,q=>q.provideDocumentSemanticTokens(c.URI.revive(Q),te,ae),null,!0)}$releaseDocumentSemanticTokens(x,Q){this._withAdapter(x,K,te=>te.releaseDocumentSemanticColoring(Q),void 0)}registerDocumentRangeSemanticTokensProvider(x,Q,te,ae){const q=this._addNewAdapter(new $(this._documents,te),x);return this._proxy.$registerDocumentRangeSemanticTokensProvider(q,this._transformDocumentSelector(Q),ae),this._createDisposable(q)}$provideDocumentRangeSemanticTokens(x,Q,te,ae){return this._withAdapter(x,$,q=>q.provideDocumentRangeSemanticTokens(c.URI.revive(Q),te,ae),null,!0)}registerCompletionItemProvider(x,Q,te,ae){const q=this._addNewAdapter(new B(this._documents,this._commands.converter,te,this._apiDeprecation,x),x);return this._proxy.$registerSuggestSupport(q,this._transformDocumentSelector(Q),ae,B.supportsResolving(te),`${x.identifier.value}(${ae.join("")})`),this._createDisposable(q)}$provideCompletionItems(x,Q,te,ae,q){return this._withAdapter(x,B,se=>se.provideCompletionItems(c.URI.revive(Q),te,ae,q),void 0)}$resolveCompletionItem(x,Q,te){return this._withAdapter(x,B,ae=>ae.resolveCompletionItem(Q,te),void 0)}$releaseCompletionItems(x,Q){this._withAdapter(x,B,te=>te.releaseCompletionItems(Q),void 0)}registerInlineCompletionsProvider(x,Q,te){const ae=this._addNewAdapter(new z(this._documents,te,this._commands.converter),x);return this._proxy.$registerInlineCompletionsSupport(ae,this._transformDocumentSelector(Q)),this._createDisposable(ae)}$provideInlineCompletions(x,Q,te,ae,q){return this._withAdapter(x,z,se=>se.provideInlineCompletions(c.URI.revive(Q),te,ae,q),void 0)}$handleInlineCompletionDidShow(x,Q,te){this._withAdapter(x,z,async ae=>{ae.handleDidShowCompletionItem(Q,te)},void 0)}$freeInlineCompletionsList(x,Q){this._withAdapter(x,z,async te=>{te.disposeCompletions(Q)},void 0)}registerSignatureHelpProvider(x,Q,te,ae){const q=Array.isArray(ae)?{triggerCharacters:ae,retriggerCharacters:[]}:ae,se=this._addNewAdapter(new ne(this._documents,te),x);return this._proxy.$registerSignatureHelpProvider(se,this._transformDocumentSelector(Q),q),this._createDisposable(se)}$provideSignatureHelp(x,Q,te,ae,q){return this._withAdapter(x,ne,se=>se.provideSignatureHelp(c.URI.revive(Q),te,ae,q),void 0)}$releaseSignatureHelp(x,Q){this._withAdapter(x,ne,te=>te.releaseSignatureHelp(Q),void 0)}registerInlayHintsProvider(x,Q,te){const ae=typeof te.onDidChangeInlayHints=="function"?this._nextHandle():void 0,q=this._addNewAdapter(new j(this._documents,te),x);this._proxy.$registerInlayHintsProvider(q,this._transformDocumentSelector(Q),ae);let se=this._createDisposable(q);if(ae!==void 0){const he=te.onDidChangeInlayHints(Te=>this._proxy.$emitInlayHintsEvent(ae));se=R.Disposable.from(se,he)}return se}$provideInlayHints(x,Q,te,ae){return this._withAdapter(x,j,q=>q.provideInlayHints(c.URI.revive(Q),te,ae),void 0)}registerDocumentLinkProvider(x,Q,te){const ae=this._addNewAdapter(new le(this._documents,te),x);return this._proxy.$registerDocumentLinkProvider(ae,this._transformDocumentSelector(Q),typeof te.resolveDocumentLink=="function"),this._createDisposable(ae)}$provideDocumentLinks(x,Q,te){return this._withAdapter(x,le,ae=>ae.provideLinks(c.URI.revive(Q),te),void 0)}$resolveDocumentLink(x,Q,te){return this._withAdapter(x,le,ae=>ae.resolveLink(Q,te),void 0)}$releaseDocumentLinks(x,Q){this._withAdapter(x,le,te=>te.releaseLinks(Q),void 0)}registerColorProvider(x,Q,te){const ae=this._addNewAdapter(new oe(this._documents,te),x);return this._proxy.$registerDocumentColorProvider(ae,this._transformDocumentSelector(Q)),this._createDisposable(ae)}$provideDocumentColors(x,Q,te){return this._withAdapter(x,oe,ae=>ae.provideColors(c.URI.revive(Q),te),[])}$provideColorPresentations(x,Q,te,ae){return this._withAdapter(x,oe,q=>q.provideColorPresentations(c.URI.revive(Q),te,ae),void 0)}registerFoldingRangeProvider(x,Q,te){const ae=this._nextHandle(),q=typeof te.onDidChangeFoldingRanges=="function"?this._nextHandle():void 0;this._adapter.set(ae,new Ye(new ve(this._documents,te),x)),this._proxy.$registerFoldingRangeProvider(ae,this._transformDocumentSelector(Q),q);let se=this._createDisposable(ae);if(q!==void 0){const he=te.onDidChangeFoldingRanges(()=>this._proxy.$emitFoldingRangeEvent(q));se=R.Disposable.from(se,he)}return se}$provideFoldingRanges(x,Q,te,ae){return this._withAdapter(x,ve,q=>q.provideFoldingRanges(c.URI.revive(Q),te,ae),void 0)}registerSelectionRangeProvider(x,Q,te){const ae=this._addNewAdapter(new Re(this._documents,te,this._logService),x);return this._proxy.$registerSelectionRangeProvider(ae,this._transformDocumentSelector(Q)),this._createDisposable(ae)}$provideSelectionRanges(x,Q,te,ae){return this._withAdapter(x,Re,q=>q.provideSelectionRanges(c.URI.revive(Q),te,ae),[])}registerCallHierarchyProvider(x,Q,te){const ae=this._addNewAdapter(new Me(this._documents,te),x);return this._proxy.$registerCallHierarchyProvider(ae,this._transformDocumentSelector(Q)),this._createDisposable(ae)}$prepareCallHierarchy(x,Q,te,ae){return this._withAdapter(x,Me,q=>Promise.resolve(q.prepareSession(c.URI.revive(Q),te,ae)),void 0)}$provideCallHierarchyIncomingCalls(x,Q,te,ae){return this._withAdapter(x,Me,q=>q.provideCallsTo(Q,te,ae),void 0)}$provideCallHierarchyOutgoingCalls(x,Q,te,ae){return this._withAdapter(x,Me,q=>q.provideCallsFrom(Q,te,ae),void 0)}$releaseCallHierarchy(x,Q){this._withAdapter(x,Me,te=>Promise.resolve(te.releaseSession(Q)),void 0)}registerTypeHierarchyProvider(x,Q,te){const ae=this._addNewAdapter(new Oe(this._documents,te),x);return this._proxy.$registerTypeHierarchyProvider(ae,this._transformDocumentSelector(Q)),this._createDisposable(ae)}$prepareTypeHierarchy(x,Q,te,ae){return this._withAdapter(x,Oe,q=>Promise.resolve(q.prepareSession(c.URI.revive(Q),te,ae)),void 0)}$provideTypeHierarchySupertypes(x,Q,te,ae){return this._withAdapter(x,Oe,q=>q.provideSupertypes(Q,te,ae),void 0)}$provideTypeHierarchySubtypes(x,Q,te,ae){return this._withAdapter(x,Oe,q=>q.provideSubtypes(Q,te,ae),void 0)}$releaseTypeHierarchy(x,Q){this._withAdapter(x,Oe,te=>Promise.resolve(te.releaseSession(Q)),void 0)}static _serializeRegExp(x){return{pattern:x.source,flags:(0,C.regExpFlags)(x)}}static _serializeIndentationRule(x){return{decreaseIndentPattern:Ve._serializeRegExp(x.decreaseIndentPattern),increaseIndentPattern:Ve._serializeRegExp(x.increaseIndentPattern),indentNextLinePattern:x.indentNextLinePattern?Ve._serializeRegExp(x.indentNextLinePattern):void 0,unIndentedLinePattern:x.unIndentedLinePattern?Ve._serializeRegExp(x.unIndentedLinePattern):void 0}}static _serializeOnEnterRule(x){return{beforeText:Ve._serializeRegExp(x.beforeText),afterText:x.afterText?Ve._serializeRegExp(x.afterText):void 0,previousLineText:x.previousLineText?Ve._serializeRegExp(x.previousLineText):void 0,action:x.action}}static _serializeOnEnterRules(x){return x.map(Ve._serializeOnEnterRule)}setLanguageConfiguration(x,Q,te){let{wordPattern:ae}=te;if(ae&&(0,C.regExpLeadsToEndlessLoop)(ae))throw new Error(`Invalid language configuration: wordPattern '${ae}' is not allowed to match the empty string.`);ae?this._documents.setWordDefinitionFor(Q,ae):this._documents.setWordDefinitionFor(Q,void 0),te.__electricCharacterSupport&&this._apiDeprecation.report("LanguageConfiguration.__electricCharacterSupport",x,"Do not use."),te.__characterPairSupport&&this._apiDeprecation.report("LanguageConfiguration.__characterPairSupport",x,"Do not use.");const q=this._nextHandle(),se={comments:te.comments,brackets:te.brackets,wordPattern:te.wordPattern?Ve._serializeRegExp(te.wordPattern):void 0,indentationRules:te.indentationRules?Ve._serializeIndentationRule(te.indentationRules):void 0,onEnterRules:te.onEnterRules?Ve._serializeOnEnterRules(te.onEnterRules):void 0,__electricCharacterSupport:te.__electricCharacterSupport,__characterPairSupport:te.__characterPairSupport};return this._proxy.$setLanguageConfiguration(q,Q,se),this._createDisposable(q)}$setWordDefinitions(x){for(const Q of x)this._documents.setWordDefinitionFor(Q.languageId,new RegExp(Q.regexSource,Q.regexFlags))}}e.ExtHostLanguageFeatures=Ve,Ve._handlePool=0}),define(we[194],Ee([0,1,5,8,7,35,14,6]),function(re,e,c,M,b,R,F,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostLanguages=void 0;class _{constructor(t,E,n,f){this._documents=E,this._commands=n,this._uriTransformer=f,this._languageIds=[],this._handlePool=0,this._ids=new Set,this._proxy=t.getProxy(c.MainContext.MainThreadLanguages)}$acceptLanguageIds(t){this._languageIds=t}async getLanguages(){return this._languageIds.slice(0)}async changeLanguage(t,E){await this._proxy.$changeLanguage(t,E);const n=this._documents.getDocumentData(t);if(!n)throw new Error(`document '${t.toString}' NOT found`);return n.document}async tokenAtPosition(t,E){const n=t.version,f=M.Position.from(E),a=await this._proxy.$tokensAtPosition(t.uri,f),l={type:b.StandardTokenType.Other,range:t.getWordRangeAtPosition(E)??new b.Range(E.line,E.character,E.line,E.character)};if(!a)return l;const w={range:M.Range.to(a.range),type:M.TokenType.to(a.type)};return!w.range.contains(E)||n!==t.version?l:w}createLanguageStatusItem(t,E,n){const f=this._handlePool++,a=this._proxy,l=this._ids,w=`${t.identifier.value}/${E}`;if(l.has(w))throw new Error(`LanguageStatusItem with id '${E}' ALREADY exists`);l.add(w);const I={selector:n,id:E,name:t.displayName??t.name,severity:b.LanguageStatusSeverity.Information,command:void 0,text:"",detail:""};let S,o=new C.DisposableStore;const h=()=>{S?.dispose(),S=(0,F.disposableTimeout)(()=>{o.clear(),this._proxy.$setLanguageStatus(f,{id:w,name:I.name??t.displayName??t.name,source:t.displayName??t.name,selector:M.DocumentSelector.from(I.selector,this._uriTransformer),label:I.text,detail:I.detail??"",severity:I.severity===b.LanguageStatusSeverity.Error?R.default.Error:I.severity===b.LanguageStatusSeverity.Warning?R.default.Warning:R.default.Info,command:I.command&&this._commands.toInternal(I.command,o),accessibilityInfo:I.accessibilityInformation})},0)},y={dispose(){o.dispose(),S?.dispose(),a.$removeLanguageStatus(f),l.delete(w)},get id(){return I.id},get name(){return I.name},set name(i){I.name=i,h()},get selector(){return I.selector},set selector(i){I.selector=i,h()},get text(){return I.text},set text(i){I.text=i,h()},get detail(){return I.detail},set detail(i){I.detail=i,h()},get severity(){return I.severity},set severity(i){I.severity=i,h()},get accessibilityInformation(){return I.accessibilityInformation},set accessibilityInformation(i){I.accessibilityInformation=i,h()},get command(){return I.command},set command(i){I.command=i,h()}};return h(),y}}e.ExtHostLanguages=_}),define(we[195],Ee([0,1,5,15,30]),function(re,e,c,M,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostMessageService=void 0;function R(C){return C&&C.title}let F=class{constructor(_,P){this._logService=P,this._proxy=_.getProxy(c.MainContext.MainThreadMessageService)}showMessage(_,P,t,E,n){const f={extension:_};let a;typeof E=="string"||R(E)?a=[E,...n]:(f.modal=E?.modal,f.useCustom=E?.useCustom,f.detail=E?.detail,a=n),f.useCustom&&(0,b.checkProposedApiEnabled)(_);const l=[];for(let w=0;w<a.length;w++){const I=a[w];if(typeof I=="string")l.push({title:I,handle:w,isCloseAffordance:!1});else if(typeof I=="object"){let{title:S,isCloseAffordance:o}=I;l.push({title:S,isCloseAffordance:!!o,handle:w})}else this._logService.warn("Invalid message item:",I)}return this._proxy.$showMessage(P,t,f,l).then(w=>{if(typeof w=="number")return a[w]})}};F=We([ze(1,M.ILogService)],F),e.ExtHostMessageService=F}),define(we[196],Ee([0,1,22,3,58,6,20,9,10,2,63,5,8,7,38,171,93]),function(re,e,c,M,b,R,F,C,_,P,t,E,n,f,a,l,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostNotebookController=void 0;class I{constructor(o,h,y,i,v){this._textDocumentsAndEditors=y,this._textDocuments=i,this._extensionStoragePaths=v,this._notebookContentProviders=new Map,this._notebookStatusBarItemProviders=new Map,this._documents=new F.ResourceMap,this._editors=new Map,this._onDidChangeNotebookCells=new M.Emitter,this.onDidChangeNotebookCells=this._onDidChangeNotebookCells.event,this._onDidChangeCellOutputs=new M.Emitter,this.onDidChangeCellOutputs=this._onDidChangeCellOutputs.event,this._onDidChangeCellMetadata=new M.Emitter,this.onDidChangeCellMetadata=this._onDidChangeCellMetadata.event,this._onDidChangeActiveNotebookEditor=new M.Emitter,this.onDidChangeActiveNotebookEditor=this._onDidChangeActiveNotebookEditor.event,this._onDidChangeCellExecutionState=new M.Emitter,this.onDidChangeNotebookCellExecutionState=this._onDidChangeCellExecutionState.event,this._visibleNotebookEditors=[],this._onDidOpenNotebookDocument=new M.Emitter,this.onDidOpenNotebookDocument=this._onDidOpenNotebookDocument.event,this._onDidCloseNotebookDocument=new M.Emitter,this.onDidCloseNotebookDocument=this._onDidCloseNotebookDocument.event,this._onDidChangeVisibleNotebookEditors=new M.Emitter,this.onDidChangeVisibleNotebookEditors=this._onDidChangeVisibleNotebookEditors.event,this._statusBarCache=new t.Cache("NotebookCellStatusBarCache"),this._handlePool=0,this._notebookSerializer=new Map,this._backupIdPool=0,this._notebookProxy=o.getProxy(E.MainContext.MainThreadNotebook),this._notebookDocumentsProxy=o.getProxy(E.MainContext.MainThreadNotebookDocuments),this._notebookEditorsProxy=o.getProxy(E.MainContext.MainThreadNotebookEditors),this._commandsConverter=h.converter,h.registerArgumentProcessor({processArgument:r=>{if(r&&r.$mid===12){const s=r.notebookEditor?.notebookUri,u=r.cell.handle,p=this._documents.get(s)?.getCell(u);if(p)return p.apiCell}return r}})}get activeNotebookEditor(){return this._activeNotebookEditor?.apiEditor}get visibleNotebookEditors(){return this._visibleNotebookEditors.map(o=>o.apiEditor)}getEditorById(o){const h=this._editors.get(o);if(!h)throw new Error(`unknown text editor: ${o}. known editors: ${[...this._editors.keys()]} `);return h}getIdByEditor(o){for(const[h,y]of this._editors)if(y.apiEditor===o)return h}get notebookDocuments(){return[...this._documents.values()]}getNotebookDocument(o,h){const y=this._documents.get(o);if(!y&&!h)throw new Error(`NO notebook document for '${o}'`);return y}_getProviderData(o){const h=this._notebookContentProviders.get(o);if(!h)throw new Error(`NO provider for '${o}'`);return h}registerNotebookContentProvider(o,h,y,i,v){if((0,C.isFalsyOrWhitespace)(h))throw new Error("viewType cannot be empty or just whitespace");if(this._notebookContentProviders.has(h))throw new Error(`Notebook provider for '${h}' already registered`);this._notebookContentProviders.set(h,{extension:o,provider:y});let r;return y.onDidChangeNotebookContentOptions&&(r=y.onDidChangeNotebookContentOptions(()=>{const s=n.NotebookDocumentContentOptions.from(y.options);this._notebookProxy.$updateNotebookProviderOptions(h,s)})),this._notebookProxy.$registerNotebookProvider({id:o.identifier,location:o.extensionLocation},h,n.NotebookDocumentContentOptions.from(i),I._convertNotebookRegistrationData(o,v)),new f.Disposable(()=>{r?.dispose(),this._notebookContentProviders.delete(h),this._notebookProxy.$unregisterNotebookProvider(h)})}static _convertNotebookRegistrationData(o,h){if(!h)return;const y=h.filenamePattern.map(i=>n.NotebookExclusiveDocumentPattern.from(i)).filter(i=>i!==void 0);if(h.filenamePattern&&!y){console.warn(`Notebook content provider view options file name pattern is invalid ${h.filenamePattern}`);return}return{extension:o.identifier,providerDisplayName:o.displayName||o.name,displayName:h.displayName,filenamePattern:y,exclusive:h.exclusive||!1}}registerNotebookCellStatusBarItemProvider(o,h,y){const i=I._notebookStatusBarItemProviderHandlePool++,v=typeof y.onDidChangeCellStatusBarItems=="function"?I._notebookStatusBarItemProviderHandlePool++:void 0;this._notebookStatusBarItemProviders.set(i,y),this._notebookProxy.$registerNotebookCellStatusBarItemProvider(i,v,h);let r;return v!==void 0&&(r=y.onDidChangeCellStatusBarItems(s=>this._notebookProxy.$emitCellStatusBarEvent(v))),new f.Disposable(()=>{this._notebookStatusBarItemProviders.delete(i),this._notebookProxy.$unregisterNotebookCellStatusBarItemProvider(i,v),r&&r.dispose()})}async createNotebookDocument(o){const h=await this._notebookDocumentsProxy.$tryCreateNotebook({viewType:o.viewType,content:o.content&&n.NotebookData.from(o.content)});return P.URI.revive(h)}async openNotebookDocument(o){const h=this._documents.get(o);if(h)return h.apiNotebook;const y=await this._notebookDocumentsProxy.$tryOpenNotebook(o),i=this._documents.get(P.URI.revive(y));return(0,_.assertIsDefined)(i?.apiNotebook)}async showNotebookDocument(o,h){P.URI.isUri(o)&&(o=await this.openNotebookDocument(o));let y;typeof h=="object"?y={position:n.ViewColumn.from(h.viewColumn),preserveFocus:h.preserveFocus,selections:h.selections&&h.selections.map(n.NotebookRange.from),pinned:typeof h.preview=="boolean"?!h.preview:void 0}:y={preserveFocus:!1};const i=await this._notebookEditorsProxy.$tryShowNotebookDocument(o.uri,o.notebookType,y),v=i&&this._editors.get(i)?.apiEditor;if(v)return v;throw i?new Error(`Could NOT open editor for "${o.uri.toString()}" because another editor opened in the meantime.`):new Error(`Could NOT open editor for "${o.uri.toString()}".`)}async $provideNotebookCellStatusBarItems(o,h,y,i){const v=this._notebookStatusBarItemProviders.get(o),r=P.URI.revive(h),s=this._documents.get(r);if(!s||!v)return;const u=s.getCellFromIndex(y);if(!u)return;const d=await v.provideCellStatusBarItems(u.apiCell,i);if(!d)return;const p=new R.DisposableStore,k=this._statusBarCache.add([p]),g=(Array.isArray(d)?d:[d]).map(D=>n.NotebookStatusBarItem.from(D,this._commandsConverter,p));return{cacheId:k,items:g}}$releaseNotebookCellStatusBarItems(o){this._statusBarCache.delete(o)}registerNotebookSerializer(o,h,y,i,v){if((0,C.isFalsyOrWhitespace)(h))throw new Error("viewType cannot be empty or just whitespace");const r=this._handlePool++;return this._notebookSerializer.set(r,y),this._notebookProxy.$registerNotebookSerializer(r,{id:o.identifier,location:o.extensionLocation},h,n.NotebookDocumentContentOptions.from(i),I._convertNotebookRegistrationData(o,v)),(0,R.toDisposable)(()=>{this._notebookProxy.$unregisterNotebookSerializer(r)})}async $dataToNotebook(o,h,y){const i=this._notebookSerializer.get(o);if(!i)throw new Error("NO serializer found");const v=await i.deserializeNotebook(h.buffer,y);return new a.SerializableObjectWithBuffers(n.NotebookData.from(v))}async $notebookToData(o,h,y){const i=this._notebookSerializer.get(o);if(!i)throw new Error("NO serializer found");const v=await i.serializeNotebook(n.NotebookData.to(h.value),y);return c.VSBuffer.wrap(v)}async $openNotebook(o,h,y,i,v){const{provider:r}=this._getProviderData(o),s=await r.openNotebook(P.URI.revive(h),{backupId:y,untitledDocumentData:i?.buffer},v);return new a.SerializableObjectWithBuffers({metadata:s.metadata??Object.create(null),cells:s.cells.map(n.NotebookCellData.from)})}async $saveNotebook(o,h,y){const i=this.getNotebookDocument(P.URI.revive(h)),{provider:v}=this._getProviderData(o);return await v.saveNotebook(i.apiNotebook,y),!0}async $saveNotebookAs(o,h,y,i){const v=this.getNotebookDocument(P.URI.revive(h)),{provider:r}=this._getProviderData(o);return await r.saveNotebookAs(P.URI.revive(y),v.apiNotebook,i),!0}async $backupNotebook(o,h,y){const i=this.getNotebookDocument(P.URI.revive(h)),v=this._getProviderData(o),r=this._extensionStoragePaths.workspaceValue(v.extension)??this._extensionStoragePaths.globalValue(v.extension),s=String((0,b.hash)([i.uri.toString(),this._backupIdPool++])),u=P.URI.joinPath(r,s),d=await v.provider.backupNotebook(i.apiNotebook,{destination:u},y);return i.updateBackup(d),d.id}_createExtHostEditor(o,h,y){if(this._editors.has(h))throw new Error(`editor with id ALREADY EXSIST: ${h}`);const i=new w.ExtHostNotebookEditor(h,this._notebookEditorsProxy,o,y.visibleRanges.map(n.NotebookRange.to),y.selections.map(n.NotebookRange.to),typeof y.viewColumn=="number"?n.ViewColumn.to(y.viewColumn):void 0);this._editors.set(h,i)}$acceptDocumentAndEditorsDelta(o){if(o.value.removedDocuments)for(const y of o.value.removedDocuments){const i=P.URI.revive(y),v=this._documents.get(i);v&&(v.dispose(),this._documents.delete(i),this._textDocumentsAndEditors.$acceptDocumentsAndEditorsDelta({removedDocuments:v.apiNotebook.getCells().map(r=>r.document.uri)}),this._onDidCloseNotebookDocument.fire(v.apiNotebook));for(const r of this._editors.values())r.notebookData.uri.toString()===i.toString()&&this._editors.delete(r.id)}if(o.value.addedDocuments){const y=[];for(const i of o.value.addedDocuments){const v=P.URI.revive(i.uri);if(this._documents.has(v))throw new Error(`adding EXISTING notebook ${v} `);const r=this,s=new l.ExtHostNotebookDocument(this._notebookDocumentsProxy,this._textDocumentsAndEditors,this._textDocuments,{emitModelChange(u){r._onDidChangeNotebookCells.fire(u)},emitCellOutputsChange(u){r._onDidChangeCellOutputs.fire(u)},emitCellMetadataChange(u){r._onDidChangeCellMetadata.fire(u)},emitCellExecutionStateChange(u){r._onDidChangeCellExecutionState.fire(u)}},v,i);y.push(...i.cells.map(u=>l.ExtHostCell.asModelAddData(s.apiNotebook,u))),this._documents.get(v)?.dispose(),this._documents.set(v,s),this._textDocumentsAndEditors.$acceptDocumentsAndEditorsDelta({addedDocuments:y}),this._onDidOpenNotebookDocument.fire(s.apiNotebook)}}if(o.value.addedEditors)for(const y of o.value.addedEditors){if(this._editors.has(y.id))return;const i=P.URI.revive(y.documentUri),v=this._documents.get(i);v&&this._createExtHostEditor(v,y.id,y)}const h=[];if(o.value.removedEditors)for(const y of o.value.removedEditors){const i=this._editors.get(y);i&&(this._editors.delete(y),this._activeNotebookEditor?.id===i.id&&(this._activeNotebookEditor=void 0),h.push(i))}if(o.value.visibleEditors){this._visibleNotebookEditors=o.value.visibleEditors.map(i=>this._editors.get(i)).filter(i=>!!i);const y=new Set;this._visibleNotebookEditors.forEach(i=>y.add(i.id));for(const i of this._editors.values()){const v=y.has(i.id);i._acceptVisibility(v)}this._visibleNotebookEditors=[...this._editors.values()].map(i=>i).filter(i=>i.visible),this._onDidChangeVisibleNotebookEditors.fire(this.visibleNotebookEditors)}o.value.newActiveEditor===null?this._activeNotebookEditor=void 0:o.value.newActiveEditor&&(this._activeNotebookEditor=this._editors.get(o.value.newActiveEditor)),o.value.newActiveEditor!==void 0&&this._onDidChangeActiveNotebookEditor.fire(this._activeNotebookEditor?.apiEditor)}}e.ExtHostNotebookController=I,I._notebookStatusBarItemProviderHandlePool=0}),define(we[197],Ee([0,1,3,53,15,5,13,8]),function(re,e,c,M,b,R,F,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostNotebookEditors=void 0;class _{constructor(E,n){const f=_._Keys.nextId();E.$registerNotebookEditorDecorationType(f,C.NotebookDecorationRenderOptions.from(n)),this.value={key:f,dispose(){E.$removeNotebookEditorDecorationType(f)}}}}_._Keys=new M.IdGenerator("NotebookEditorDecorationType");let P=class{constructor(E,n,f){this._logService=E,this._extHostRpc=n,this._notebooksAndEditors=f,this._onDidChangeNotebookEditorSelection=new c.Emitter,this._onDidChangeNotebookEditorVisibleRanges=new c.Emitter,this.onDidChangeNotebookEditorSelection=this._onDidChangeNotebookEditorSelection.event,this.onDidChangeNotebookEditorVisibleRanges=this._onDidChangeNotebookEditorVisibleRanges.event}createNotebookEditorDecorationType(E){return new _(this._extHostRpc.getProxy(R.MainContext.MainThreadNotebookEditors),E).value}$acceptEditorPropertiesChanged(E,n){this._logService.debug("ExtHostNotebook#$acceptEditorPropertiesChanged",E,n);const f=this._notebooksAndEditors.getEditorById(E);n.visibleRanges&&f._acceptVisibleRanges(n.visibleRanges.ranges.map(C.NotebookRange.to)),n.selections&&f._acceptSelections(n.selections.selections.map(C.NotebookRange.to)),n.visibleRanges&&this._onDidChangeNotebookEditorVisibleRanges.fire({notebookEditor:f.apiEditor,visibleRanges:f.apiEditor.visibleRanges}),n.selections&&this._onDidChangeNotebookEditorSelection.fire(Object.freeze({notebookEditor:f.apiEditor,selections:f.apiEditor.selections}))}$acceptEditorViewColumns(E){for(const n in E)this._notebooksAndEditors.getEditorById(n)._acceptViewColumn(C.ViewColumn.to(E[n]))}};P=We([ze(0,b.ILogService),ze(1,F.IExtHostRpcService)],P),e.ExtHostNotebookEditors=P}),define(we[198],Ee([0,1,12,14,21,3,6,20,2,25,15,5,39,8,7,66,164,30,38]),function(re,e,c,M,b,R,F,C,_,P,t,E,n,f,a,l,w,I,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostNotebookKernels=void 0;let o=class{constructor(r,s,u,d,p){this._initData=s,this._extHostNotebook=u,this._commands=d,this._logService=p,this._activeExecutions=new C.ResourceMap,this._kernelData=new Map,this._handlePool=0,this._proxy=r.getProxy(E.MainContext.MainThreadNotebookKernels);const k=new n.ApiCommand("notebook.selectKernel","_notebook.selectKernel","Trigger kernel picker for specified notebook editor widget",[new n.ApiCommandArgument("options","Select kernel options",T=>!0,T=>{if(T&&"notebookEditor"in T&&"id"in T){const g=this._extHostNotebook.getIdByEditor(T.notebookEditor);return{id:T.id,extension:T.extension,notebookEditorId:g}}else if(T&&"notebookEditor"in T){const g=this._extHostNotebook.getIdByEditor(T.notebookEditor);if(g===void 0)throw new Error(`Cannot invoke 'notebook.selectKernel' for unrecognized notebook editor ${T.notebookEditor.document.uri.toString()}`);return{notebookEditorId:g}}return T})],n.ApiCommandResult.Void);this._commands.registerApiCommand(k)}createNotebookController(r,s,u,d,p,k){for(let ne of this._kernelData.values())if(ne.controller.id===s&&P.ExtensionIdentifier.equals(r.identifier,ne.extensionId))throw new Error(`notebook controller with id '${s}' ALREADY exist`);const T=this._handlePool++,g=this;this._logService.trace(`NotebookController[${T}], CREATED by ${r.identifier.value}, ${s}`);const D=()=>console.warn(`NO execute handler from notebook controller '${G.id}' of extension: '${r.identifier}'`);let m=!1;const A=new F.DisposableStore,L=new R.Emitter,V=new R.Emitter,G={id:`${r.identifier.value}/${s}`,notebookType:u,extensionId:r.identifier,extensionLocation:r.extensionLocation,label:d||r.identifier.value,preloads:k?k.map(f.NotebookRendererScript.from):[]};let U=p??D,K;this._proxy.$addKernel(T,G).catch(ne=>{console.log(ne),m=!0});let $=0;const B=()=>{if(m)return;const ne=++$;Promise.resolve().then(()=>{ne===$&&this._proxy.$updateKernel(T,G)})},z=new C.ResourceMap,Y={get id(){return s},get notebookType(){return G.notebookType},onDidChangeSelectedNotebooks:L.event,get label(){return G.label},set label(ne){G.label=ne??r.displayName??r.name,B()},get detail(){return G.detail??""},set detail(ne){G.detail=ne,B()},get description(){return G.description??""},set description(ne){G.description=ne,B()},get supportedLanguages(){return G.supportedLanguages},set supportedLanguages(ne){G.supportedLanguages=ne,B()},get supportsExecutionOrder(){return G.supportsExecutionOrder??!1},set supportsExecutionOrder(ne){G.supportsExecutionOrder=ne,B()},get rendererScripts(){return G.preloads?G.preloads.map(f.NotebookRendererScript.to):[]},get executeHandler(){return U},set executeHandler(ne){U=ne??D},get interruptHandler(){return K},set interruptHandler(ne){K=ne,G.supportsInterrupt=Boolean(ne),B()},createNotebookCellExecution(ne){if(m)throw new Error("notebook controller is DISPOSED");if(!z.has(ne.notebook.uri))throw g._logService.trace(`NotebookController[${T}] NOT associated to notebook, associated to THESE notebooks:`,Array.from(z.keys()).map(j=>j.toString())),new Error(`notebook controller is NOT associated to notebook: ${ne.notebook.uri.toString()}`);return g._createNotebookCellExecution(ne)},dispose:()=>{m||(this._logService.trace(`NotebookController[${T}], DISPOSED`),m=!0,this._kernelData.delete(T),A.dispose(),L.dispose(),V.dispose(),this._proxy.$removeKernel(T))},updateNotebookAffinity(ne,j){g._proxy.$updateNotebookPriority(T,ne.uri,j)},onDidReceiveMessage:V.event,postMessage(ne,j){return(0,I.checkProposedApiEnabled)(r),g._proxy.$postMessage(T,j&&g._extHostNotebook.getIdByEditor(j),ne)},asWebviewUri(ne){return(0,I.checkProposedApiEnabled)(r),(0,l.asWebviewUri)(ne,g._initData.remote)}};return this._kernelData.set(T,{extensionId:r.identifier,controller:Y,onDidReceiveMessage:V,onDidChangeSelection:L,associatedNotebooks:z}),Y}$acceptNotebookAssociation(r,s,u){const d=this._kernelData.get(r);if(d){const p=this._extHostNotebook.getNotebookDocument(_.URI.revive(s));u?d.associatedNotebooks.set(p.uri,!0):d.associatedNotebooks.delete(p.uri),this._logService.trace(`NotebookController[${r}] ASSOCIATE notebook`,p.uri.toString(),u),d.onDidChangeSelection.fire({selected:u,notebook:p.apiNotebook})}}async $executeCells(r,s,u){const d=this._kernelData.get(r);if(!d)return;const p=this._extHostNotebook.getNotebookDocument(_.URI.revive(s)),k=[];for(let T of u){const g=p.getCell(T);g&&k.push(g.apiCell)}try{this._logService.trace(`NotebookController[${r}] EXECUTE cells`,p.uri.toString(),k.length),await d.controller.executeHandler.call(d.controller,k,p.apiNotebook,d.controller)}catch(T){this._logService.error(`NotebookController[${r}] execute cells FAILED`,T),console.error(T)}}async $cancelCells(r,s,u){const d=this._kernelData.get(r);if(!d)return;const p=this._extHostNotebook.getNotebookDocument(_.URI.revive(s));if(d.controller.interruptHandler)await d.controller.interruptHandler.call(d.controller,p.apiNotebook);else for(let k of u){const T=p.getCell(k);T&&this._activeExecutions.get(T.uri)?.cancel()}}$acceptKernelMessageFromRenderer(r,s,u){const d=this._kernelData.get(r);if(!d)return;const p=this._extHostNotebook.getEditorById(s);d.onDidReceiveMessage.fire(Object.freeze({editor:p.apiEditor,message:u}))}_createNotebookCellExecution(r){if(r.index<0)throw new Error("CANNOT execute cell that has been REMOVED from notebook");const u=this._extHostNotebook.getNotebookDocument(r.notebook.uri).getCellFromApiCell(r);if(!u)throw new Error("invalid cell");if(this._activeExecutions.has(u.uri))throw new Error(`duplicate execution for ${u.uri}`);const d=new y(u.notebook,u,this._proxy);this._activeExecutions.set(u.uri,d);const p=d.onDidChangeState(()=>{d.state===h.Resolved&&(d.dispose(),p.dispose(),this._activeExecutions.delete(u.uri))});return d.asApiObject()}};o=We([ze(4,t.ILogService)],o),e.ExtHostNotebookKernels=o;var h;(function(v){v[v.Init=0]="Init",v[v.Started=1]="Started",v[v.Resolved=2]="Resolved"})(h||(h={}));class y extends F.Disposable{constructor(r,s,u){super();this._document=r,this._cell=s,this._proxy=u,this._handle=y.HANDLE++,this._onDidChangeState=new R.Emitter,this.onDidChangeState=this._onDidChangeState.event,this._state=h.Init,this._tokenSource=this._register(new b.CancellationTokenSource),this._collector=new i(10,d=>this.update(d)),this._executionOrder=s.internalMetadata.executionOrder,this._proxy.$addExecution(this._handle,this._cell.notebook.uri,this._cell.handle)}get state(){return this._state}cancel(){this._tokenSource.cancel()}async updateSoon(r){await this._collector.addItem(r)}async update(r){const s=Array.isArray(r)?r:[r];return this._proxy.$updateExecutions(new S.SerializableObjectWithBuffers(s))}verifyStateForOutput(){if(this._state===h.Init)throw new Error("Must call start before modifying cell output");if(this._state===h.Resolved)throw new Error("Cannot modify cell output after calling resolve")}cellIndexToHandle(r){let s=this._cell;if(r&&(s=this._document.getCellFromApiCell(r)),!s)throw new Error("INVALID cell");return s.handle}validateAndConvertOutputs(r){return r.map(s=>{const u=a.NotebookCellOutput.ensureUniqueMimeTypes(s.items,!0);return u===s.items?f.NotebookCellOutput.from(s):f.NotebookCellOutput.from({items:u,id:s.id,metadata:s.metadata})})}async updateOutputs(r,s,u){const d=this.cellIndexToHandle(s),p=this.validateAndConvertOutputs((0,c.asArray)(r));return this.updateSoon({editType:w.CellExecutionUpdateType.Output,executionHandle:this._handle,cellHandle:d,append:u,outputs:p})}async updateOutputItems(r,s,u){return r=a.NotebookCellOutput.ensureUniqueMimeTypes((0,c.asArray)(r),!0),this.updateSoon({editType:w.CellExecutionUpdateType.OutputItems,executionHandle:this._handle,items:r.map(f.NotebookCellOutputItem.from),outputId:s.id,append:u})}asApiObject(){const r=this;return Object.freeze({get token(){return r._tokenSource.token},get cell(){return r._cell.apiCell},get executionOrder(){return r._executionOrder},set executionOrder(u){r._executionOrder=u,r.update([{editType:w.CellExecutionUpdateType.ExecutionState,executionHandle:r._handle,executionOrder:r._executionOrder}])},start(u){if(r._state===h.Resolved||r._state===h.Started)throw new Error("Cannot call start again");r._state=h.Started,r._onDidChangeState.fire(),r.update({editType:w.CellExecutionUpdateType.ExecutionState,executionHandle:r._handle,runStartTime:u})},end(u,d){if(r._state===h.Resolved)throw new Error("Cannot call resolve twice");r._state=h.Resolved,r._onDidChangeState.fire(),r.updateSoon({editType:w.CellExecutionUpdateType.Complete,executionHandle:r._handle,runEndTime:d,lastRunSuccess:u}),r._collector.flush(),r._proxy.$removeExecution(r._handle)},clearOutput(u){return r.verifyStateForOutput(),r.updateOutputs([],u,!1)},appendOutput(u,d){return r.verifyStateForOutput(),r.updateOutputs(u,d,!0)},replaceOutput(u,d){return r.verifyStateForOutput(),r.updateOutputs(u,d,!1)},appendOutputItems(u,d){return r.verifyStateForOutput(),r.updateOutputItems(u,d,!0)},replaceOutputItems(u,d){return r.verifyStateForOutput(),r.updateOutputItems(u,d,!1)}})}}y.HANDLE=0;class i{constructor(r,s){this.delay=r,this.callback=s,this.batch=[],this.startedTimer=Date.now()}addItem(r){return this.batch.push(r),this.currentDeferred||(this.currentDeferred=new M.DeferredPromise,this.startedTimer=Date.now(),(0,M.timeout)(this.delay).then(()=>this.flush())),Date.now()-this.startedTimer>this.delay?this.flush():this.currentDeferred.p}flush(){if(this.batch.length===0||!this.currentDeferred)return Promise.resolve();const r=this.currentDeferred;this.currentDeferred=void 0;const s=this.batch;return this.batch=[],this.callback(s).finally(()=>r.complete())}}}),define(we[199],Ee([0,1,3,5,93]),function(re,e,c,M,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostNotebookRenderers=void 0;class R{constructor(C,_){this._extHostNotebook=_,this._rendererMessageEmitters=new Map,this.proxy=C.getProxy(M.MainContext.MainThreadNotebookRenderers)}$postRendererMessage(C,_,P){const t=this._extHostNotebook.getEditorById(C);this._rendererMessageEmitters.get(_)?.fire({editor:t.apiEditor,message:P})}createRendererMessaging(C,_){if(!C.contributes?.notebookRenderer?.some(n=>n.id===_))throw new Error(`Extensions may only call createRendererMessaging() for renderers they contribute (got ${_})`);const P=!!C.enableProposedApi,t=new WeakMap;return{onDidReceiveMessage:(n,f,a)=>{const l=P?n:w=>{const I={};t.set(I,w.editor),n({editor:I,message:w.message})};return this.getOrCreateEmitterFor(_).event(l,f,a)},postMessage:(n,f)=>{b.ExtHostNotebookEditor.apiEditorsToExtHost.has(n)&&([n,f]=[f,n]);const a=P?f:t.get(f),l=a&&b.ExtHostNotebookEditor.apiEditorsToExtHost.get(a);return this.proxy.$postMessage(l?.id,_,n)}}}getOrCreateEmitterFor(C){let _=this._rendererMessageEmitters.get(C);return _||(_=new c.Emitter({onLastListenerRemove:()=>{_?.dispose(),this._rendererMessageEmitters.delete(C)}}),this._rendererMessageEmitters.set(C,_),_)}}e.ExtHostNotebookRenderers=R}),define(we[96],Ee([0,1,5,3,6,22,4,13]),function(re,e,c,M,b,R,F,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExtHostOutputService=e.ExtHostOutputService=e.LazyOutputChannel=e.ExtHostPushOutputChannel=e.AbstractExtHostOutputChannel=void 0;class _ extends b.Disposable{constructor(a,l,w,I,S){super();this._onDidAppend=this._register(new M.Emitter),this.onDidAppend=this._onDidAppend.event,this._name=a,this._proxy=S,this._id=S.$register(this.name,l,w,I),this._disposed=!1,this._offset=0}get name(){return this._name}append(a){this.validate(),this._offset+=a?R.VSBuffer.fromString(a).byteLength:0}update(){this._id.then(a=>this._proxy.$update(a))}appendLine(a){this.validate(),this.append(a+`
`)}clear(){this.validate();const a=this._offset;this._id.then(l=>this._proxy.$clear(l,a))}show(a,l){this.validate(),this._id.then(w=>this._proxy.$reveal(w,!!(typeof a=="boolean"?a:l)))}hide(){this.validate(),this._id.then(a=>this._proxy.$close(a))}validate(){if(this._disposed)throw new Error("Channel has been closed")}dispose(){super.dispose(),this._disposed||this._id.then(a=>this._proxy.$dispose(a)).then(()=>this._disposed=!0)}}e.AbstractExtHostOutputChannel=_;class P extends _{constructor(a,l,w){super(a,!1,void 0,l,w)}append(a){super.append(a),this._id.then(l=>this._proxy.$append(l,a)),this._onDidAppend.fire()}}e.ExtHostPushOutputChannel=P;class t extends _{constructor(a,l,w){super(a,!0,l,void 0,w)}append(a){throw new Error("Not supported")}}class E{constructor(a,l){this.name=a,this._channel=l}append(a){this._channel.then(l=>l.append(a))}appendLine(a){this._channel.then(l=>l.appendLine(a))}clear(){this._channel.then(a=>a.clear())}show(a,l){this._channel.then(w=>w.show(a,l))}hide(){this._channel.then(a=>a.hide())}dispose(){this._channel.then(a=>a.dispose())}}e.LazyOutputChannel=E;let n=class{constructor(a){this._proxy=a.getProxy(c.MainContext.MainThreadOutputService)}$setVisibleChannel(a){}createOutputChannel(a,l){if(a=a.trim(),!a)throw new Error("illegal argument `name`. must not be falsy");return new P(a,l.identifier.value,this._proxy)}createOutputChannelFromLogFile(a,l){if(a=a.trim(),!a)throw new Error("illegal argument `name`. must not be falsy");if(!l)throw new Error("illegal argument `file`. must not be falsy");return new t(a,l,this._proxy)}};n=We([ze(0,C.IExtHostRpcService)],n),e.ExtHostOutputService=n,e.IExtHostOutputService=(0,F.createDecorator)("IExtHostOutputService")}),define(we[200],Ee([0,1,14,21,3,6,5,2,7,16,12,35,46]),function(re,e,c,M,b,R,F,C,_,P,t,E,n){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.createExtHostQuickOpen=void 0;function f(a,l,w){const I=a.getProxy(F.MainContext.MainThreadQuickOpen);class S{constructor(d,p){this._sessions=new Map,this._instances=0,this._workspace=d,this._commands=p}showQuickPick(d,p,k,T=M.CancellationToken.None){this._onDidSelectItem=void 0;const g=Promise.resolve(d),D=++this._instances,m=I.$show(D,{title:k?.title,placeHolder:k?.placeHolder,matchOnDescription:k?.matchOnDescription,matchOnDetail:k?.matchOnDetail,ignoreFocusLost:k?.ignoreFocusOut,canPickMany:k?.canPickMany},T),A={},L=m.then(()=>A);return Promise.race([L,g]).then(V=>{if(V!==A)return g.then(G=>{const U=[];for(let K=0;K<G.length;K++){const $=G[K];let B,z,Y,ne,j;typeof $=="string"?B=$:(B=$.label,z=$.description,Y=$.detail,ne=$.picked,j=$.alwaysShow),U.push({label:B,description:z,handle:K,detail:Y,picked:ne,alwaysShow:j})}return k&&typeof k.onDidSelectItem=="function"&&(this._onDidSelectItem=K=>{k.onDidSelectItem(G[K])}),I.$setItems(D,U),m.then(K=>{if(typeof K=="number")return G[K];if(Array.isArray(K))return K.map($=>G[$])})})}).then(void 0,V=>{if(!(0,P.isPromiseCanceledError)(V))return I.$setError(D,V),Promise.reject(V)})}$onItemSelected(d){this._onDidSelectItem&&this._onDidSelectItem(d)}showInput(d,p=M.CancellationToken.None){return this._validateInput=d?d.validateInput:void 0,I.$input(d,typeof this._validateInput=="function",p).then(void 0,k=>{if(!(0,P.isPromiseCanceledError)(k))return Promise.reject(k)})}$validateInput(d){return this._validateInput?(0,c.asPromise)(()=>this._validateInput(d)):Promise.resolve(void 0)}async showWorkspaceFolderPick(d,p=M.CancellationToken.None){const k=await this._commands.executeCommand("_workbench.pickWorkspaceFolder",[d]);if(!k)return;const T=await this._workspace.getWorkspaceFolders2();if(!!T)return T.find(g=>g.uri.toString()===k.uri.toString())}createQuickPick(d,p){const k=new r(d,p,()=>this._sessions.delete(k._id));return this._sessions.set(k._id,k),k}createInputBox(d){const p=new s(d,()=>this._sessions.delete(p._id));return this._sessions.set(p._id,p),p}$onDidChangeValue(d,p){const k=this._sessions.get(d);k&&k._fireDidChangeValue(p)}$onDidAccept(d){const p=this._sessions.get(d);p&&p._fireDidAccept()}$onDidChangeActive(d,p){const k=this._sessions.get(d);k instanceof r&&k._fireDidChangeActive(p)}$onDidChangeSelection(d,p){const k=this._sessions.get(d);k instanceof r&&k._fireDidChangeSelection(p)}$onDidTriggerButton(d,p){const k=this._sessions.get(d);k&&k._fireDidTriggerButton(p)}$onDidTriggerItemButton(d,p,k){const T=this._sessions.get(d);T instanceof r&&T._fireDidTriggerItemButton(p,k)}$onDidHide(d){const p=this._sessions.get(d);p&&p._fireDidHide()}}class o{constructor(d,p){this._extensionId=d,this._onDidDispose=p,this._id=r._nextId++,this._visible=!1,this._expectingHide=!1,this._enabled=!0,this._busy=!1,this._ignoreFocusOut=!0,this._value="",this._buttons=[],this._handlesToButtons=new Map,this._onDidAcceptEmitter=new b.Emitter,this._onDidChangeValueEmitter=new b.Emitter,this._onDidTriggerButtonEmitter=new b.Emitter,this._onDidHideEmitter=new b.Emitter,this._pendingUpdate={id:this._id},this._disposed=!1,this._disposables=[this._onDidTriggerButtonEmitter,this._onDidHideEmitter,this._onDidAcceptEmitter,this._onDidChangeValueEmitter],this.onDidChangeValue=this._onDidChangeValueEmitter.event,this.onDidAccept=this._onDidAcceptEmitter.event,this.onDidTriggerButton=this._onDidTriggerButtonEmitter.event,this.onDidHide=this._onDidHideEmitter.event}get title(){return this._title}set title(d){this._title=d,this.update({title:d})}get step(){return this._steps}set step(d){this._steps=d,this.update({step:d})}get totalSteps(){return this._totalSteps}set totalSteps(d){this._totalSteps=d,this.update({totalSteps:d})}get enabled(){return this._enabled}set enabled(d){this._enabled=d,this.update({enabled:d})}get busy(){return this._busy}set busy(d){this._busy=d,this.update({busy:d})}get ignoreFocusOut(){return this._ignoreFocusOut}set ignoreFocusOut(d){this._ignoreFocusOut=d,this.update({ignoreFocusOut:d})}get value(){return this._value}set value(d){this._value=d,this.update({value:d})}get placeholder(){return this._placeholder}set placeholder(d){this._placeholder=d,this.update({placeholder:d})}get buttons(){return this._buttons}set buttons(d){this._buttons=d.slice(),this._handlesToButtons.clear(),d.forEach((p,k)=>{const T=p===_.QuickInputButtons.Back?-1:k;this._handlesToButtons.set(T,p)}),this.update({buttons:d.map((p,k)=>({...v(p),tooltip:p.tooltip,handle:p===_.QuickInputButtons.Back?-1:k}))})}show(){this._visible=!0,this._expectingHide=!0,this.update({visible:!0})}hide(){this._visible=!1,this.update({visible:!1})}_fireDidAccept(){this._onDidAcceptEmitter.fire()}_fireDidChangeValue(d){this._value=d,this._onDidChangeValueEmitter.fire(d)}_fireDidTriggerButton(d){const p=this._handlesToButtons.get(d);p&&this._onDidTriggerButtonEmitter.fire(p)}_fireDidHide(){this._expectingHide&&(this._expectingHide=!1,this._onDidHideEmitter.fire())}dispose(){this._disposed||(this._disposed=!0,this._fireDidHide(),this._disposables=(0,R.dispose)(this._disposables),this._updateTimeout&&(clearTimeout(this._updateTimeout),this._updateTimeout=void 0),this._onDidDispose(),I.$dispose(this._id))}update(d){if(!this._disposed){for(const p of Object.keys(d)){const k=d[p];this._pendingUpdate[p]=k===void 0?null:k}"visible"in this._pendingUpdate?(this._updateTimeout&&(clearTimeout(this._updateTimeout),this._updateTimeout=void 0),this.dispatchUpdate()):this._visible&&!this._updateTimeout&&(this._updateTimeout=setTimeout(()=>{this._updateTimeout=void 0,this.dispatchUpdate()},0))}}dispatchUpdate(){I.$createOrUpdate(this._pendingUpdate),this._pendingUpdate={id:this._id}}}o._nextId=1;function h(u){if(u instanceof _.ThemeIcon)return{id:u.id};const d=i(u),p=y(u);return{dark:typeof d=="string"?C.URI.file(d):d,light:typeof p=="string"?C.URI.file(p):p}}function y(u){return typeof u=="object"&&"light"in u?u.light:u}function i(u){return typeof u=="object"&&"dark"in u?u.dark:u}function v(u){const d=h(u.iconPath);let p,k;return"id"in d?k=n.ThemeIcon.asClassName(d):p=d,{iconPath:p,iconClass:k}}class r extends o{constructor(d,p,k){super(d,k);this.enableProposedApi=p,this._items=[],this._handlesToItems=new Map,this._itemsToHandles=new Map,this._canSelectMany=!1,this._matchOnDescription=!0,this._matchOnDetail=!0,this._sortByLabel=!0,this._keepScrollPosition=!1,this._activeItems=[],this._onDidChangeActiveEmitter=new b.Emitter,this._selectedItems=[],this._onDidChangeSelectionEmitter=new b.Emitter,this._onDidTriggerItemButtonEmitter=new b.Emitter,this.onDidChangeActive=this._onDidChangeActiveEmitter.event,this.onDidChangeSelection=this._onDidChangeSelectionEmitter.event,this.onDidTriggerItemButton=this._onDidTriggerItemButtonEmitter.event,this._disposables.push(this._onDidChangeActiveEmitter,this._onDidChangeSelectionEmitter,this._onDidTriggerItemButtonEmitter),this.update({type:"quickPick"})}get items(){return this._items}set items(d){this._items=d.slice(),this._handlesToItems.clear(),this._itemsToHandles.clear(),d.forEach((p,k)=>{this._handlesToItems.set(k,p),this._itemsToHandles.set(p,k)}),this.update({items:d.map((p,k)=>({label:p.label,description:p.description,handle:k,detail:p.detail,picked:p.picked,alwaysShow:p.alwaysShow,buttons:p.buttons&&this.enableProposedApi?p.buttons.map((T,g)=>({...v(T),tooltip:T.tooltip,handle:g})):void 0}))})}get canSelectMany(){return this._canSelectMany}set canSelectMany(d){this._canSelectMany=d,this.update({canSelectMany:d})}get matchOnDescription(){return this._matchOnDescription}set matchOnDescription(d){this._matchOnDescription=d,this.update({matchOnDescription:d})}get matchOnDetail(){return this._matchOnDetail}set matchOnDetail(d){this._matchOnDetail=d,this.update({matchOnDetail:d})}get sortByLabel(){return this._sortByLabel}set sortByLabel(d){this._sortByLabel=d,this.update({sortByLabel:d})}get keepScrollPosition(){return this._keepScrollPosition}set keepScrollPosition(d){this._keepScrollPosition=d,this.update({keepScrollPosition:d})}get activeItems(){return this._activeItems}set activeItems(d){this._activeItems=d.filter(p=>this._itemsToHandles.has(p)),this.update({activeItems:this._activeItems.map(p=>this._itemsToHandles.get(p))})}get selectedItems(){return this._selectedItems}set selectedItems(d){this._selectedItems=d.filter(p=>this._itemsToHandles.has(p)),this.update({selectedItems:this._selectedItems.map(p=>this._itemsToHandles.get(p))})}_fireDidChangeActive(d){const p=(0,t.coalesce)(d.map(k=>this._handlesToItems.get(k)));this._activeItems=p,this._onDidChangeActiveEmitter.fire(p)}_fireDidChangeSelection(d){const p=(0,t.coalesce)(d.map(k=>this._handlesToItems.get(k)));this._selectedItems=p,this._onDidChangeSelectionEmitter.fire(p)}_fireDidTriggerItemButton(d,p){const k=this._handlesToItems.get(d);if(!k||!k.buttons||!k.buttons.length)return;const T=k.buttons[p];T&&this._onDidTriggerItemButtonEmitter.fire({button:T,item:k})}}class s extends o{constructor(d,p){super(d,p);this._password=!1,this.update({type:"inputBox"})}get password(){return this._password}set password(d){this._password=d,this.update({password:d})}get prompt(){return this._prompt}set prompt(d){this._prompt=d,this.update({prompt:d})}get validationMessage(){return this._validationMessage}set validationMessage(d){this._validationMessage=d,this.update({validationMessage:d,severity:d?E.default.Error:E.default.Ignore})}}return new S(l,w)}e.createExtHostQuickOpen=f}),define(we[201],Ee([0,1,2,3,52,6,14,5,12,108,15,25,30,46,8]),function(re,e,c,M,b,R,F,C,_,P,t,E,n,f,a){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostSCM=e.ExtHostSCMInputBox=void 0;function l(d){if(d)return typeof d.iconPath=="string"?c.URI.file(d.iconPath):c.URI.isUri(d.iconPath)||f.ThemeIcon.isThemeIcon(d.iconPath)?d.iconPath:void 0}function w(d,p){if(!d.iconPath&&!p.iconPath)return 0;if(d.iconPath){if(!p.iconPath)return 1}else return-1;const k=typeof d.iconPath=="string"?d.iconPath:c.URI.isUri(d.iconPath)?d.iconPath.fsPath:d.iconPath.id,T=typeof p.iconPath=="string"?p.iconPath:c.URI.isUri(p.iconPath)?p.iconPath.fsPath:p.iconPath.id;return(0,P.comparePaths)(k,T)}function I(d,p){let k=0;if(d.strikeThrough!==p.strikeThrough)return d.strikeThrough?1:-1;if(d.faded!==p.faded)return d.faded?1:-1;if(d.tooltip!==p.tooltip)return(d.tooltip||"").localeCompare(p.tooltip||"");if(k=w(d,p),k!==0)return k;if(d.light&&p.light)k=w(d.light,p.light);else{if(d.light)return 1;if(p.light)return-1}if(k!==0)return k;if(d.dark&&p.dark)k=w(d.dark,p.dark);else{if(d.dark)return 1;if(p.dark)return-1}return k}function S(d,p){if(d.command!==p.command)return d.command<p.command?-1:1;if(d.title!==p.title)return d.title<p.title?-1:1;if(d.tooltip!==p.tooltip){if(d.tooltip!==void 0&&p.tooltip!==void 0)return d.tooltip<p.tooltip?-1:1;if(d.tooltip!==void 0)return 1;if(p.tooltip!==void 0)return-1}if(d.arguments===p.arguments)return 0;if(d.arguments)if(p.arguments){if(d.arguments.length!==p.arguments.length)return d.arguments.length-p.arguments.length}else return 1;else return-1;for(let k=0;k<d.arguments.length;k++){const T=d.arguments[k],g=p.arguments[k];if(T!==g)return T<g?-1:1}return 0}function o(d,p){let k=(0,P.comparePaths)(d.resourceUri.fsPath,p.resourceUri.fsPath,!0);if(k!==0)return k;if(d.command&&p.command)k=S(d.command,p.command);else{if(d.command)return 1;if(p.command)return-1}if(k!==0)return k;if(d.decorations&&p.decorations)k=I(d.decorations,p.decorations);else{if(d.decorations)return 1;if(p.decorations)return-1}return k}function h(d,p){for(let k=0;k<d.length;k++)if(d[k]!==p[k])return!1;return!0}function y(d,p){return d.command===p.command&&d.title===p.title&&d.tooltip===p.tooltip&&(d.arguments&&p.arguments?h(d.arguments,p.arguments):d.arguments===p.arguments)}function i(d,p){return(0,_.equals)(d,p,y)}class v{constructor(p,k,T){this._extension=p,this._proxy=k,this._sourceControlHandle=T,this._value="",this._onDidChange=new M.Emitter,this._placeholder="",this._visible=!0}get value(){return this._value}set value(p){this._proxy.$setInputBoxValue(this._sourceControlHandle,p),this.updateValue(p)}get onDidChange(){return this._onDidChange.event}get placeholder(){return this._placeholder}set placeholder(p){this._proxy.$setInputBoxPlaceholder(this._sourceControlHandle,p),this._placeholder=p}get validateInput(){return(0,n.checkProposedApiEnabled)(this._extension),this._validateInput}set validateInput(p){if((0,n.checkProposedApiEnabled)(this._extension),p&&typeof p!="function")throw new Error(`[${this._extension.identifier.value}]: Invalid SCM input box validation function`);this._validateInput=p,this._proxy.$setValidationProviderIsEnabled(this._sourceControlHandle,!!p)}get visible(){return this._visible}set visible(p){p=!!p,this._visible!==p&&(this._visible=p,this._proxy.$setInputBoxVisibility(this._sourceControlHandle,p))}focus(){(0,n.checkProposedApiEnabled)(this._extension),this._visible||(this.visible=!0),this._proxy.$setInputBoxFocus(this._sourceControlHandle)}showValidationMessage(p,k){(0,n.checkProposedApiEnabled)(this._extension),this._proxy.$showValidationMessage(this._sourceControlHandle,p,k)}$onInputBoxValueChange(p){this.updateValue(p)}updateValue(p){this._value=p,this._onDidChange.fire(p)}}e.ExtHostSCMInputBox=v;class r{constructor(p,k,T,g,D){this._proxy=p,this._commands=k,this._sourceControlHandle=T,this._id=g,this._label=D,this._resourceHandlePool=0,this._resourceStates=[],this._resourceStatesMap=new Map,this._resourceStatesCommandsMap=new Map,this._resourceStatesDisposablesMap=new Map,this._onDidUpdateResourceStates=new M.Emitter,this.onDidUpdateResourceStates=this._onDidUpdateResourceStates.event,this._disposed=!1,this._onDidDispose=new M.Emitter,this.onDidDispose=this._onDidDispose.event,this._handlesSnapshot=[],this._resourceSnapshot=[],this._hideWhenEmpty=void 0,this.handle=r._handlePool++}get disposed(){return this._disposed}get id(){return this._id}get label(){return this._label}set label(p){this._label=p,this._proxy.$updateGroupLabel(this._sourceControlHandle,this.handle,p)}get hideWhenEmpty(){return this._hideWhenEmpty}set hideWhenEmpty(p){this._hideWhenEmpty=p,this._proxy.$updateGroup(this._sourceControlHandle,this.handle,this.features)}get features(){return{hideWhenEmpty:this.hideWhenEmpty}}get resourceStates(){return[...this._resourceStates]}set resourceStates(p){this._resourceStates=[...p],this._onDidUpdateResourceStates.fire()}getResourceState(p){return this._resourceStatesMap.get(p)}$executeResourceCommand(p,k){const T=this._resourceStatesCommandsMap.get(p);return T?(0,F.asPromise)(()=>this._commands.executeCommand(T.command,...T.arguments||[],k)):Promise.resolve(void 0)}_takeResourceStateSnapshot(){const p=[...this._resourceStates].sort(o),T=(0,_.sortedDiff)(this._resourceSnapshot,p,o).map(m=>{const A=m.toInsert.map(L=>{const V=this._resourceHandlePool++;this._resourceStatesMap.set(V,L);const G=L.resourceUri;let U;if(L.command)if(L.command.command==="vscode.open"||L.command.command==="vscode.diff"){const ve=new R.DisposableStore;U=this._commands.converter.toInternal(L.command,ve),this._resourceStatesDisposablesMap.set(V,ve)}else this._resourceStatesCommandsMap.set(V,L.command);const K=l(L.decorations),$=L.decorations&&l(L.decorations.light)||K,B=L.decorations&&l(L.decorations.dark)||K,z=[$,B],Y=L.decorations&&L.decorations.tooltip||"",ne=L.decorations&&!!L.decorations.strikeThrough,j=L.decorations&&!!L.decorations.faded,le=L.contextValue||"";return{rawResource:[V,G,z,Y,ne,j,le,U],handle:V}});return{start:m.start,deleteCount:m.deleteCount,toInsert:A}}),g=T.map(({start:m,deleteCount:A,toInsert:L})=>[m,A,L.map(V=>V.rawResource)]),D=T.reverse();for(const{start:m,deleteCount:A,toInsert:L}of D){const V=L.map(U=>U.handle),G=this._handlesSnapshot.splice(m,A,...V);for(const U of G)this._resourceStatesMap.delete(U),this._resourceStatesCommandsMap.delete(U),this._resourceStatesDisposablesMap.get(U)?.dispose(),this._resourceStatesDisposablesMap.delete(U)}return this._resourceSnapshot=p,g}dispose(){this._disposed=!0,this._onDidDispose.fire()}}r._handlePool=0;class s{constructor(p,k,T,g,D,m){this._proxy=k,this._commands=T,this._id=g,this._label=D,this._rootUri=m,this._groups=new Map,this._count=void 0,this._quickDiffProvider=void 0,this._commitTemplate=void 0,this._acceptInputDisposables=new R.MutableDisposable,this._acceptInputCommand=void 0,this._statusBarDisposables=new R.MutableDisposable,this._statusBarCommands=void 0,this._selected=!1,this._onDidChangeSelection=new M.Emitter,this.onDidChangeSelection=this._onDidChangeSelection.event,this.handle=s._handlePool++,this.createdResourceGroups=new Map,this.updatedResourceGroups=new Set,this._inputBox=new v(p,this._proxy,this.handle),this._proxy.$registerSourceControl(this.handle,g,D,m)}get id(){return this._id}get label(){return this._label}get rootUri(){return this._rootUri}get inputBox(){return this._inputBox}get count(){return this._count}set count(p){this._count!==p&&(this._count=p,this._proxy.$updateSourceControl(this.handle,{count:p}))}get quickDiffProvider(){return this._quickDiffProvider}set quickDiffProvider(p){this._quickDiffProvider=p,this._proxy.$updateSourceControl(this.handle,{hasQuickDiffProvider:!!p})}get commitTemplate(){return this._commitTemplate}set commitTemplate(p){p!==this._commitTemplate&&(this._commitTemplate=p,this._proxy.$updateSourceControl(this.handle,{commitTemplate:p}))}get acceptInputCommand(){return this._acceptInputCommand}set acceptInputCommand(p){this._acceptInputDisposables.value=new R.DisposableStore,this._acceptInputCommand=p;const k=this._commands.converter.toInternal(p,this._acceptInputDisposables.value);this._proxy.$updateSourceControl(this.handle,{acceptInputCommand:k})}get statusBarCommands(){return this._statusBarCommands}set statusBarCommands(p){if(this._statusBarCommands&&p&&i(this._statusBarCommands,p))return;this._statusBarDisposables.value=new R.DisposableStore,this._statusBarCommands=p;const k=(p||[]).map(T=>this._commands.converter.toInternal(T,this._statusBarDisposables.value));this._proxy.$updateSourceControl(this.handle,{statusBarCommands:k})}get selected(){return this._selected}createResourceGroup(p,k){const T=new r(this._proxy,this._commands,this.handle,p,k),g=M.Event.once(T.onDidDispose)(()=>this.createdResourceGroups.delete(T));return this.createdResourceGroups.set(T,g),this.eventuallyAddResourceGroups(),T}eventuallyAddResourceGroups(){const p=[],k=[];for(const[T,g]of this.createdResourceGroups){g.dispose();const D=T.onDidUpdateResourceStates(()=>{this.updatedResourceGroups.add(T),this.eventuallyUpdateResourceStates()});M.Event.once(T.onDidDispose)(()=>{this.updatedResourceGroups.delete(T),D.dispose(),this._groups.delete(T.handle),this._proxy.$unregisterGroup(this.handle,T.handle)}),p.push([T.handle,T.id,T.label,T.features]);const m=T._takeResourceStateSnapshot();m.length>0&&k.push([T.handle,m]),this._groups.set(T.handle,T)}this._proxy.$registerGroups(this.handle,p,k),this.createdResourceGroups.clear()}eventuallyUpdateResourceStates(){const p=[];this.updatedResourceGroups.forEach(k=>{const T=k._takeResourceStateSnapshot();T.length!==0&&p.push([k.handle,T])}),p.length>0&&this._proxy.$spliceResourceStates(this.handle,p),this.updatedResourceGroups.clear()}getResourceGroup(p){return this._groups.get(p)}setSelectionState(p){this._selected=p,this._onDidChangeSelection.fire(p)}dispose(){this._acceptInputDisposables.dispose(),this._statusBarDisposables.dispose(),this._groups.forEach(p=>p.dispose()),this._proxy.$unregisterSourceControl(this.handle)}}s._handlePool=0,We([(0,b.debounce)(100)],s.prototype,"eventuallyAddResourceGroups",null),We([(0,b.debounce)(100)],s.prototype,"eventuallyUpdateResourceStates",null);let u=class Bi{constructor(p,k,T){this._commands=k,this.logService=T,this._sourceControls=new Map,this._sourceControlsByExtension=new Map,this._onDidChangeActiveProvider=new M.Emitter,this._proxy=p.getProxy(C.MainContext.MainThreadSCM),this._telemetry=p.getProxy(C.MainContext.MainThreadTelemetry),k.registerArgumentProcessor({processArgument:g=>{if(g&&g.$mid===3){const D=this._sourceControls.get(g.sourceControlHandle);if(!D)return g;const m=D.getResourceGroup(g.groupHandle);return m?m.getResourceState(g.handle):g}else if(g&&g.$mid===4){const D=this._sourceControls.get(g.sourceControlHandle);return D?D.getResourceGroup(g.groupHandle):g}else if(g&&g.$mid===5){const D=this._sourceControls.get(g.handle);return D||g}return g}})}get onDidChangeActiveProvider(){return this._onDidChangeActiveProvider.event}createSourceControl(p,k,T,g){this.logService.trace("ExtHostSCM#createSourceControl",p.identifier.value,k,T,g),this._telemetry.$publicLog2("api/scm/createSourceControl",{extensionId:p.identifier.value});const D=Bi._handlePool++,m=new s(p,this._proxy,this._commands,k,T,g);this._sourceControls.set(D,m);const A=this._sourceControlsByExtension.get(E.ExtensionIdentifier.toKey(p.identifier))||[];return A.push(m),this._sourceControlsByExtension.set(E.ExtensionIdentifier.toKey(p.identifier),A),m}getLastInputBox(p){this.logService.trace("ExtHostSCM#getLastInputBox",p.identifier.value);const k=this._sourceControlsByExtension.get(E.ExtensionIdentifier.toKey(p.identifier)),T=k&&k[k.length-1];return T&&T.inputBox}$provideOriginalResource(p,k,T){const g=c.URI.revive(k);this.logService.trace("ExtHostSCM#$provideOriginalResource",p,g.toString());const D=this._sourceControls.get(p);return!D||!D.quickDiffProvider||!D.quickDiffProvider.provideOriginalResource?Promise.resolve(null):(0,F.asPromise)(()=>D.quickDiffProvider.provideOriginalResource(g,T)).then(m=>m||null)}$onInputBoxValueChange(p,k){this.logService.trace("ExtHostSCM#$onInputBoxValueChange",p);const T=this._sourceControls.get(p);return T&&T.inputBox.$onInputBoxValueChange(k),Promise.resolve(void 0)}$executeResourceCommand(p,k,T,g){this.logService.trace("ExtHostSCM#$executeResourceCommand",p,k,T);const D=this._sourceControls.get(p);if(!D)return Promise.resolve(void 0);const m=D.getResourceGroup(k);return m?m.$executeResourceCommand(T,g):Promise.resolve(void 0)}$validateInput(p,k,T){this.logService.trace("ExtHostSCM#$validateInput",p);const g=this._sourceControls.get(p);return!g||!g.inputBox.validateInput?Promise.resolve(void 0):(0,F.asPromise)(()=>g.inputBox.validateInput(k,T)).then(D=>{if(!D)return Promise.resolve(void 0);const m=a.MarkdownString.fromStrict(D.message);return m?Promise.resolve([m,D.type]):Promise.resolve(void 0)})}$setSelectedSourceControl(p){return this.logService.trace("ExtHostSCM#$setSelectedSourceControl",p),p!==void 0&&this._sourceControls.get(p)?.setSelectionState(!0),this._selectedSourceControlHandle!==void 0&&this._sourceControls.get(this._selectedSourceControlHandle)?.setSelectionState(!1),this._selectedSourceControlHandle=p,Promise.resolve(void 0)}};u._handlePool=0,u=We([ze(2,t.ILogService)],u),e.ExtHostSCM=u});var Ze=this&&this.__classPrivateFieldSet||function(re,e,c,M,b){if(M==="m")throw new TypeError("Private method is not writable");if(M==="a"&&!b)throw new TypeError("Private accessor was defined without a setter");if(typeof e=="function"?re!==e||!b:!e.has(re))throw new TypeError("Cannot write private member to an object whose class did not declare it");return M==="a"?b.call(re,c):b?b.value=c:e.set(re,c),c},Ae=this&&this.__classPrivateFieldGet||function(re,e,c,M){if(c==="a"&&!M)throw new TypeError("Private accessor was defined without a getter");if(typeof e=="function"?re!==e||!M:!e.has(re))throw new TypeError("Cannot read private member from an object whose class did not declare it");return c==="m"?M:c==="a"?M.call(re):M?M.value:e.get(re)};define(we[202],Ee([0,1,7,5,127,6,8,10]),function(re,e,c,M,b,R,F,C){"use strict";var _,P;Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostStatusBar=e.ExtHostStatusBarEntry=void 0;class t{constructor(a,l,w,I,S=c.StatusBarAlignment.Left,o){_.set(this,void 0),P.set(this,void 0),this._disposed=!1,this._visible=!1,this._text="",this._internalCommandRegistration=new R.DisposableStore,Ze(this,_,a,"f"),Ze(this,P,l,"f"),this._entryId=t.ID_GEN++,this._extension=w,this._id=I,this._alignment=S,this._priority=this.validatePriority(o)}validatePriority(a){if(!!(0,C.isNumber)(a))return a===Number.POSITIVE_INFINITY?Number.MAX_VALUE:a===Number.NEGATIVE_INFINITY?-Number.MAX_VALUE:a}get id(){return this._id??this._extension.identifier.value}get alignment(){return this._alignment}get priority(){return this._priority}get text(){return this._text}get name(){return this._name}get tooltip(){return this._tooltip}get color(){return this._color}get backgroundColor(){return this._backgroundColor}get command(){return this._command?.fromApi}get accessibilityInformation(){return this._accessibilityInformation}set text(a){this._text=a,this.update()}set name(a){this._name=a,this.update()}set tooltip(a){this._tooltip=a,this.update()}set color(a){this._color=a,this.update()}set backgroundColor(a){a&&!t.ALLOWED_BACKGROUND_COLORS.has(a.id)&&(a=void 0),this._backgroundColor=a,this.update()}set command(a){this._command?.fromApi!==a&&(this._internalCommandRegistration.clear(),typeof a=="string"?this._command={fromApi:a,internal:Ae(this,P,"f").toInternal({title:"",command:a},this._internalCommandRegistration)}:a?this._command={fromApi:a,internal:Ae(this,P,"f").toInternal(a,this._internalCommandRegistration)}:this._command=void 0,this.update())}set accessibilityInformation(a){this._accessibilityInformation=a,this.update()}show(){this._visible=!0,this.update()}hide(){clearTimeout(this._timeoutHandle),this._visible=!1,Ae(this,_,"f").$dispose(this._entryId)}update(){this._disposed||!this._visible||(clearTimeout(this._timeoutHandle),this._timeoutHandle=setTimeout(()=>{this._timeoutHandle=void 0;let a;this._extension?this._id?a=`${this._extension.identifier.value}.${this._id}`:a=this._extension.identifier.value:a=this._id;let l;this._name?l=this._name:l=(0,b.localize)(0,null,this._extension.displayName||this._extension.name);let w=this._color;this._backgroundColor&&(w=t.ALLOWED_BACKGROUND_COLORS.get(this._backgroundColor.id));const I=this._tooltip?F.MarkdownString.fromStrict(this._tooltip):void 0;Ae(this,_,"f").$setEntry(this._entryId,a,l,this._text,I,this._command?.internal,w,this._backgroundColor,this._alignment===c.StatusBarAlignment.Left,this._priority,this._accessibilityInformation)},0))}dispose(){this.hide(),this._disposed=!0}}e.ExtHostStatusBarEntry=t,_=new WeakMap,P=new WeakMap,t.ID_GEN=0,t.ALLOWED_BACKGROUND_COLORS=new Map([["statusBarItem.errorBackground",new c.ThemeColor("statusBarItem.errorForeground")],["statusBarItem.warningBackground",new c.ThemeColor("statusBarItem.warningForeground")]]);class E{constructor(a){this._messages=[],this._item=a.createStatusBarEntry(void 0,"status.extensionMessage",c.StatusBarAlignment.Left,Number.MIN_VALUE),this._item.name=(0,b.localize)(1,null)}dispose(){this._messages.length=0,this._item.dispose()}setMessage(a){const l={message:a};return this._messages.unshift(l),this._update(),new c.Disposable(()=>{const w=this._messages.indexOf(l);w>=0&&(this._messages.splice(w,1),this._update())})}_update(){this._messages.length>0?(this._item.text=this._messages[0].message,this._item.show()):this._item.hide()}}class n{constructor(a,l){this._proxy=a.getProxy(M.MainContext.MainThreadStatusBar),this._commands=l,this._statusMessage=new E(this)}createStatusBarEntry(a,l,w,I){return new t(this._proxy,this._commands,a,l,w,I)}setStatusBarMessage(a,l){const w=this._statusMessage.setMessage(a);let I;return typeof l=="number"?I=setTimeout(()=>w.dispose(),l):typeof l!="undefined"&&l.then(()=>w.dispose(),()=>w.dispose()),new c.Disposable(()=>{w.dispose(),clearTimeout(I)})}}e.ExtHostStatusBar=n}),define(we[72],Ee([0,1,5,3,4]),function(re,e,c,M,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExtHostStorage=e.ExtHostStorage=void 0;class R{constructor(C){this._onDidChangeStorage=new M.Emitter,this.onDidChangeStorage=this._onDidChangeStorage.event,this._proxy=C.getProxy(c.MainContext.MainThreadStorage)}registerExtensionStorageKeysToSync(C,_){this._proxy.$registerExtensionStorageKeysToSync(C,_)}getValue(C,_,P){return this._proxy.$getValue(C,_).then(t=>t||P)}setValue(C,_,P){return this._proxy.$setValue(C,_,P)}$acceptValue(C,_,P){this._onDidChangeStorage.fire({shared:C,key:_,value:P})}}e.ExtHostStorage=R,e.IExtHostStorage=(0,b.createDecorator)("IExtHostStorage")}),define(we[73],Ee([0,1,4,29,15,71,2]),function(re,e,c,M,b,R,F){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionStoragePaths=e.IExtensionStoragePaths=void 0,e.IExtensionStoragePaths=(0,c.createDecorator)("IExtensionStoragePaths");let C=class{constructor(P,t,E){this._logService=t,this._extHostFileSystem=E,this._workspace=P.workspace??void 0,this._environment=P.environment,this.whenReady=this._getOrCreateWorkspaceStoragePath().then(n=>this._value=n)}async _getWorkspaceStorageURI(P){return F.URI.joinPath(this._environment.workspaceStorageHome,P)}async _getOrCreateWorkspaceStoragePath(){if(!this._workspace)return Promise.resolve(void 0);const P=this._workspace.id,t=await this._getWorkspaceStorageURI(P);try{return await this._extHostFileSystem.value.stat(t),this._logService.trace("[ExtHostStorage] storage dir already exists",t),t}catch{}try{return this._logService.trace("[ExtHostStorage] creating dir and metadata-file",t),await this._extHostFileSystem.value.createDirectory(t),await this._extHostFileSystem.value.writeFile(F.URI.joinPath(t,"meta.json"),new TextEncoder().encode(JSON.stringify({id:this._workspace.id,configuration:F.URI.revive(this._workspace.configuration)?.toString(),name:this._workspace.name},void 0,2))),t}catch(E){this._logService.error("[ExtHostStorage]",E);return}}workspaceValue(P){if(this._value)return F.URI.joinPath(this._value,P.identifier.value)}globalValue(P){return F.URI.joinPath(this._environment.globalStorageHome,P.identifier.value.toLowerCase())}onWillDeactivateAll(){}};C=We([ze(0,M.IExtHostInitDataService),ze(1,b.ILogService),ze(2,R.IExtHostConsumerFileSystem)],C),e.ExtensionStoragePaths=C}),define(we[40],Ee([0,1,3,5,4,2,13,6,7,128,16,166,21,36,149,46,10]),function(re,e,c,M,b,R,F,C,_,P,t,E,n,f,a,l,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.WorkerExtHostTerminalService=e.EnvironmentVariableCollection=e.BaseExtHostTerminalService=e.ExtHostPseudoterminal=e.ExtHostTerminal=e.IExtHostTerminalService=void 0,e.IExtHostTerminalService=(0,b.createDecorator)("IExtHostTerminalService");class I{constructor(u,d,p,k){this._proxy=u,this._id=d,this._creationOptions=p,this._name=k,this._disposed=!1,this._state={isInteractedWith:!1},this.isOpen=!1,this._creationOptions=Object.freeze(this._creationOptions),this._pidPromise=new Promise(g=>this._pidPromiseComplete=g);const T=this;this.value={get name(){return T._name||""},get processId(){return T._pidPromise},get creationOptions(){return T._creationOptions},get exitStatus(){return T._exitStatus},get state(){return T._state},sendText(g,D=!0){T._checkDisposed(),T._proxy.$sendText(T._id,g,D)},show(g){T._checkDisposed(),T._proxy.$show(T._id,g)},hide(){T._checkDisposed(),T._proxy.$hide(T._id)},dispose(){T._disposed||(T._disposed=!0,T._proxy.$dispose(T._id))},get dimensions(){if(!(T._cols===void 0||T._rows===void 0))return{columns:T._cols,rows:T._rows}}}}async create(u,d){if(typeof this._id!="string")throw new Error("Terminal has already been created");await this._proxy.$createTerminal(this._id,{name:u.name,shellPath:(0,w.withNullAsUndefined)(u.shellPath),shellArgs:(0,w.withNullAsUndefined)(u.shellArgs),cwd:(0,w.withNullAsUndefined)(u.cwd),env:(0,w.withNullAsUndefined)(u.env),icon:(0,w.withNullAsUndefined)(v(u.iconPath)),color:l.ThemeColor.isThemeColor(u.color)?u.color.id:void 0,initialText:(0,w.withNullAsUndefined)(u.message),strictEnv:(0,w.withNullAsUndefined)(u.strictEnv),hideFromUser:(0,w.withNullAsUndefined)(u.hideFromUser),isFeatureTerminal:(0,w.withNullAsUndefined)(d?.isFeatureTerminal),isExtensionOwnedTerminal:!0,useShellEnvironment:(0,w.withNullAsUndefined)(d?.useShellEnvironment),location:d?.location||this._serializeParentTerminal(u.location,d?.resolvedExtHostIdentifier)})}async createExtensionTerminal(u,d,p,k){if(typeof this._id!="string")throw new Error("Terminal has already been created");if(await this._proxy.$createTerminal(this._id,{name:this._name,isExtensionCustomPtyTerminal:!0,icon:p,color:l.ThemeColor.isThemeColor(k)?k.id:void 0,location:this._serializeParentTerminal(u,d)}),typeof this._id=="string")throw new Error("Terminal creation failed");return this._id}_serializeParentTerminal(u,d){return typeof u=="object"?"parentTerminal"in u&&u.parentTerminal&&d?{parentTerminal:d}:"viewColumn"in u?{viewColumn:u.viewColumn,preserveFocus:u.preserveFocus}:void 0:u}_checkDisposed(){if(this._disposed)throw new Error("Terminal has already been disposed")}set name(u){this._name=u}setExitCode(u){this._exitStatus=Object.freeze({code:u})}setDimensions(u,d){return u===this._cols&&d===this._rows||u===0||d===0?!1:(this._cols=u,this._rows=d,!0)}setInteractedWith(){return this._state.isInteractedWith?!1:(this._state={isInteractedWith:!0},!0)}_setProcessId(u){this._pidPromiseComplete?(this._pidPromiseComplete(u),this._pidPromiseComplete=void 0):this._pidPromise.then(d=>{d!==u&&(this._pidPromise=Promise.resolve(u))})}}e.ExtHostTerminal=I;class S{constructor(u){this._pty=u,this.id=0,this.shouldPersist=!1,this._capabilities=[],this._onProcessData=new c.Emitter,this.onProcessData=this._onProcessData.event,this._onProcessExit=new c.Emitter,this.onProcessExit=this._onProcessExit.event,this._onProcessReady=new c.Emitter,this._onProcessTitleChanged=new c.Emitter,this.onProcessTitleChanged=this._onProcessTitleChanged.event,this._onProcessOverrideDimensions=new c.Emitter,this._onProcessShellTypeChanged=new c.Emitter,this.onProcessShellTypeChanged=this._onProcessShellTypeChanged.event,this._onDidChangeProperty=new c.Emitter,this.onDidChangeProperty=this._onDidChangeProperty.event}get capabilities(){return this._capabilities}get onProcessReady(){return this._onProcessReady.event}get onProcessOverrideDimensions(){return this._onProcessOverrideDimensions.event}refreshProperty(u){return Promise.resolve("")}async start(){}shutdown(){this._pty.close()}input(u){this._pty.handleInput&&this._pty.handleInput(u)}resize(u,d){this._pty.setDimensions&&this._pty.setDimensions({columns:u,rows:d})}async processBinary(u){}acknowledgeDataEvent(u){}async setUnicodeVersion(u){}getInitialCwd(){return Promise.resolve("")}getCwd(){return Promise.resolve("")}getLatency(){return Promise.resolve(0)}startSendingEvents(u){this._pty.onDidWrite(d=>this._onProcessData.fire(d)),this._pty.onDidClose&&this._pty.onDidClose((d=void 0)=>{this._onProcessExit.fire(d===void 0?void 0:d)}),this._pty.onDidOverrideDimensions&&this._pty.onDidOverrideDimensions(d=>this._onProcessOverrideDimensions.fire(d&&{cols:d.columns,rows:d.rows})),this._pty.onDidChangeName&&this._pty.onDidChangeName(d=>this._onProcessTitleChanged.fire(d)),this._pty.open(u||void 0),this._pty.setDimensions&&u&&this._pty.setDimensions(u),this._onProcessReady.fire({pid:-1,cwd:"",capabilities:this._capabilities})}}e.ExtHostPseudoterminal=S;let o=1,h=class extends C.Disposable{constructor(u,d){super();this._terminals=[],this._terminalProcesses=new Map,this._terminalProcessDisposables={},this._extensionTerminalAwaitingStart={},this._getTerminalPromises={},this._environmentVariableCollections=new Map,this._linkProviders=new Set,this._profileProviders=new Map,this._terminalLinkCache=new Map,this._terminalLinkCancellationSource=new Map,this._onDidCloseTerminal=new c.Emitter,this.onDidCloseTerminal=this._onDidCloseTerminal.event,this._onDidOpenTerminal=new c.Emitter,this.onDidOpenTerminal=this._onDidOpenTerminal.event,this._onDidChangeActiveTerminal=new c.Emitter,this.onDidChangeActiveTerminal=this._onDidChangeActiveTerminal.event,this._onDidChangeTerminalDimensions=new c.Emitter,this.onDidChangeTerminalDimensions=this._onDidChangeTerminalDimensions.event,this._onDidChangeTerminalState=new c.Emitter,this.onDidChangeTerminalState=this._onDidChangeTerminalState.event,this._proxy=d.getProxy(M.MainContext.MainThreadTerminalService),this._bufferer=new a.TerminalDataBufferer(this._proxy.$sendProcessData),this._onDidWriteTerminalData=new c.Emitter({onFirstListenerAdd:()=>this._proxy.$startSendingDataEvents(),onLastListenerRemove:()=>this._proxy.$stopSendingDataEvents()}),this._proxy.$registerProcessSupport(u),this._register({dispose:()=>{for(const[p,k]of this._terminalProcesses)k.shutdown(!0)}})}get activeTerminal(){return this._activeTerminal?.value}get terminals(){return this._terminals.map(u=>u.value)}get onDidWriteTerminalData(){return this._onDidWriteTerminalData.event}getDefaultShell(u){return(u?this._defaultAutomationProfile:this._defaultProfile)?.path||""}getDefaultShellArgs(u){return(u?this._defaultAutomationProfile:this._defaultProfile)?.args||[]}createExtensionTerminal(u,d){const p=new I(this._proxy,(0,f.generateUuid)(),u,u.name),k=new S(u.pty);return p.createExtensionTerminal(u.location,this._serializeParentTerminal(u,d).resolvedExtHostIdentifier,v(u.iconPath),r(u.color)).then(T=>{const g=this._setupExtHostProcessListeners(T,k);this._terminalProcessDisposables[T]=g}),this._terminals.push(p),p.value}_serializeParentTerminal(u,d){if(d=d||{},u.location&&typeof u.location=="object"&&"parentTerminal"in u.location){const p=u.location.parentTerminal;if(p){const k=this._terminals.find(T=>T.value===p);k&&(d.resolvedExtHostIdentifier=k._id)}}else u.location&&typeof u.location!="object"?d.location=u.location:d.location&&typeof d.location=="object"&&"splitActiveTerminal"in d.location&&(d.location={splitActiveTerminal:!0});return d}attachPtyToTerminal(u,d){if(!this._getTerminalById(u))throw new Error(`Cannot resolve terminal with id ${u} for virtual process`);const k=new S(d),T=this._setupExtHostProcessListeners(u,k);this._terminalProcessDisposables[u]=T}async $acceptActiveTerminalChanged(u){const d=this._activeTerminal;if(u===null){this._activeTerminal=void 0,d!==this._activeTerminal&&this._onDidChangeActiveTerminal.fire(this._activeTerminal);return}const p=this._getTerminalById(u);p&&(this._activeTerminal=p,d!==this._activeTerminal&&this._onDidChangeActiveTerminal.fire(this._activeTerminal.value))}async $acceptTerminalProcessData(u,d){const p=this._getTerminalById(u);p&&this._onDidWriteTerminalData.fire({terminal:p.value,data:d})}async $acceptTerminalDimensions(u,d,p){const k=this._getTerminalById(u);k&&k.setDimensions(d,p)&&this._onDidChangeTerminalDimensions.fire({terminal:k.value,dimensions:k.value.dimensions})}async $acceptTerminalMaximumDimensions(u,d,p){this._terminalProcesses.get(u)?.resize(d,p)}async $acceptTerminalTitleChange(u,d){const p=this._getTerminalById(u);p&&(p.name=d)}async $acceptTerminalClosed(u,d){const p=this._getTerminalObjectIndexById(this._terminals,u);if(p!==null){const k=this._terminals.splice(p,1)[0];k.setExitCode(d),this._onDidCloseTerminal.fire(k.value)}}$acceptTerminalOpened(u,d,p,k){if(d){const D=this._getTerminalObjectIndexById(this._terminals,d);if(D!==null){this._terminals[D]._id=u,this._onDidOpenTerminal.fire(this.terminals[D]),this._terminals[D].isOpen=!0;return}}const T={name:k.name,shellPath:k.executable,shellArgs:k.args,cwd:typeof k.cwd=="string"?k.cwd:R.URI.revive(k.cwd),env:k.env,hideFromUser:k.hideFromUser},g=new I(this._proxy,u,T,p);this._terminals.push(g),this._onDidOpenTerminal.fire(g.value),g.isOpen=!0}async $acceptTerminalProcessId(u,d){const p=this._getTerminalById(u);p&&p._setProcessId(d)}async $startExtensionTerminal(u,d){const p=this._getTerminalById(u);if(!p)return{message:(0,P.localize)(0,null,u)};p.isOpen||await new Promise(T=>{const g=this.onDidOpenTerminal(async D=>{D===p.value&&(g.dispose(),T())})});const k=this._terminalProcesses.get(u);k?k.startSendingEvents(d):this._extensionTerminalAwaitingStart[u]={initialDimensions:d}}_setupExtHostProcessListeners(u,d){const p=new C.DisposableStore;p.add(d.onProcessReady(T=>this._proxy.$sendProcessReady(u,T.pid,T.cwd))),p.add(d.onProcessTitleChanged(T=>this._proxy.$sendProcessTitle(u,T))),this._bufferer.startBuffering(u,d.onProcessData),p.add(d.onProcessExit(T=>this._onProcessExit(u,T))),d.onProcessOverrideDimensions&&p.add(d.onProcessOverrideDimensions(T=>this._proxy.$sendOverrideDimensions(u,T))),this._terminalProcesses.set(u,d);const k=this._extensionTerminalAwaitingStart[u];return k&&d instanceof S&&(d.startSendingEvents(k.initialDimensions),delete this._extensionTerminalAwaitingStart[u]),p}$acceptProcessAckDataEvent(u,d){this._terminalProcesses.get(u)?.acknowledgeDataEvent(d)}$acceptProcessInput(u,d){this._terminalProcesses.get(u)?.input(d)}$acceptTerminalInteraction(u){const d=this._getTerminalById(u);d?.setInteractedWith()&&this._onDidChangeTerminalState.fire(d.value)}$acceptProcessResize(u,d,p){try{this._terminalProcesses.get(u)?.resize(d,p)}catch(k){if(k.code!=="EPIPE"&&k.code!=="ERR_IPC_CHANNEL_CLOSED")throw k}}$acceptProcessShutdown(u,d){this._terminalProcesses.get(u)?.shutdown(d)}$acceptProcessRequestInitialCwd(u){this._terminalProcesses.get(u)?.getInitialCwd().then(d=>this._proxy.$sendProcessInitialCwd(u,d))}$acceptProcessRequestCwd(u){this._terminalProcesses.get(u)?.getCwd().then(d=>this._proxy.$sendProcessCwd(u,d))}$acceptProcessRequestLatency(u){return u}registerLinkProvider(u){return this._linkProviders.add(u),this._linkProviders.size===1&&this._proxy.$startLinkProvider(),new _.Disposable(()=>{this._linkProviders.delete(u),this._linkProviders.size===0&&this._proxy.$stopLinkProvider()})}registerProfileProvider(u,d,p){if(this._profileProviders.has(d))throw new Error(`Terminal profile provider "${d}" already registered`);return this._profileProviders.set(d,p),this._proxy.$registerProfileProvider(d,u.identifier.value),new _.Disposable(()=>{this._profileProviders.delete(d),this._proxy.$unregisterProfileProvider(d)})}async $createContributedProfileTerminal(u,d){const p=new n.CancellationTokenSource().token,k=await this._profileProviders.get(u)?.provideTerminalProfile(p);if(!p.isCancellationRequested){if(!k||!("options"in k))throw new Error(`No terminal profile options provided for id "${u}"`);if("pty"in k.options){this.createExtensionTerminal(k.options,d);return}this.createTerminalFromOptions(k.options,d)}}async $provideLinks(u,d){const p=this._getTerminalById(u);if(!p)return[];this._terminalLinkCache.delete(u);const k=this._terminalLinkCancellationSource.get(u);k&&k.dispose(!0);const T=new n.CancellationTokenSource;this._terminalLinkCancellationSource.set(u,T);const g=[],D={terminal:p.value,line:d},m=[];for(const V of this._linkProviders)m.push(new Promise(async G=>{T.token.onCancellationRequested(()=>G({provider:V,links:[]}));const U=await V.provideTerminalLinks(D,T.token)||[];T.token.isCancellationRequested||G({provider:V,links:U})}));const A=await Promise.all(m);if(T.token.isCancellationRequested)return[];const L=new Map;for(const V of A)V&&V.links.length>0&&g.push(...V.links.map(G=>{const U={id:o++,startIndex:G.startIndex,length:G.length,label:G.tooltip};return L.set(U.id,{provider:V.provider,link:G}),U}));return this._terminalLinkCache.set(u,L),g}$activateLink(u,d){const p=this._terminalLinkCache.get(u)?.get(d);!p||p.provider.handleTerminalLink(p.link)}_onProcessExit(u,d){this._bufferer.stopBuffering(u),this._terminalProcesses.delete(u),delete this._extensionTerminalAwaitingStart[u];const p=this._terminalProcessDisposables[u];p&&(p.dispose(),delete this._terminalProcessDisposables[u]),this._proxy.$sendProcessExit(u,d)}_getTerminalById(u){return this._getTerminalObjectById(this._terminals,u)}_getTerminalObjectById(u,d){const p=this._getTerminalObjectIndexById(u,d);return p!==null?u[p]:null}_getTerminalObjectIndexById(u,d){let p=null;return u.some((k,T)=>k._id===d?(p=T,!0):!1),p}getEnvironmentVariableCollection(u){let d=this._environmentVariableCollections.get(u.identifier.value);return d||(d=new y,this._setEnvironmentVariableCollection(u.identifier.value,d)),d}_syncEnvironmentVariableCollection(u,d){const p=(0,E.serializeEnvironmentVariableCollection)(d.map);this._proxy.$setEnvironmentVariableCollection(u,d.persistent,p.length===0?void 0:p)}$initEnvironmentVariableCollections(u){u.forEach(d=>{const p=d[0],k=new y(d[1]);this._setEnvironmentVariableCollection(p,k)})}$acceptDefaultProfile(u,d){this._defaultProfile=u,this._defaultAutomationProfile=d}_setEnvironmentVariableCollection(u,d){this._environmentVariableCollections.set(u,d),d.onDidChangeCollection(()=>{this._syncEnvironmentVariableCollection(u,d)})}};h=We([ze(1,F.IExtHostRpcService)],h),e.BaseExtHostTerminalService=h;class y{constructor(u){this.map=new Map,this._persistent=!0,this._onDidChangeCollection=new c.Emitter,this.map=new Map(u)}get persistent(){return this._persistent}set persistent(u){this._persistent=u,this._onDidChangeCollection.fire()}get onDidChangeCollection(){return this._onDidChangeCollection&&this._onDidChangeCollection.event}get size(){return this.map.size}replace(u,d){this._setIfDiffers(u,{value:d,type:_.EnvironmentVariableMutatorType.Replace})}append(u,d){this._setIfDiffers(u,{value:d,type:_.EnvironmentVariableMutatorType.Append})}prepend(u,d){this._setIfDiffers(u,{value:d,type:_.EnvironmentVariableMutatorType.Prepend})}_setIfDiffers(u,d){const p=this.map.get(u);(!p||p.value!==d.value||p.type!==d.type)&&(this.map.set(u,d),this._onDidChangeCollection.fire())}get(u){return this.map.get(u)}forEach(u,d){this.map.forEach((p,k)=>u.call(d,k,p,this))}delete(u){this.map.delete(u),this._onDidChangeCollection.fire()}clear(){this.map.clear(),this._onDidChangeCollection.fire()}}e.EnvironmentVariableCollection=y;let i=class extends h{constructor(u){super(!1,u)}createTerminal(u,d,p){throw new t.NotSupportedError}createTerminalFromOptions(u,d){throw new t.NotSupportedError}};i=We([ze(0,F.IExtHostRpcService)],i),e.WorkerExtHostTerminalService=i;function v(s){if(!(!s||typeof s=="string"))return"id"in s?{id:s.id,color:s.color}:s}function r(s){return l.ThemeColor.isThemeColor(s)?s:void 0}});var Ze=this&&this.__classPrivateFieldSet||function(re,e,c,M,b){if(M==="m")throw new TypeError("Private method is not writable");if(M==="a"&&!b)throw new TypeError("Private accessor was defined without a setter");if(typeof e=="function"?re!==e||!b:!e.has(re))throw new TypeError("Cannot write private member to an object whose class did not declare it");return M==="a"?b.call(re,c):b?b.value=c:e.set(re,c),c},Ae=this&&this.__classPrivateFieldGet||function(re,e,c,M){if(c==="a"&&!M)throw new TypeError("Private accessor was defined without a getter");if(typeof e=="function"?re!==e||!M:!e.has(re))throw new TypeError("Cannot read private member from an object whose class did not declare it");return c==="m"?M:c==="a"?M.call(re):M?M.value:e.get(re)};define(we[203],Ee([0,1,12,22,21,3,234,58,6,23,10,36,5,13,48,8,7,174,90,67]),function(re,e,c,M,b,R,F,C,_,P,t,E,n,f,a,l,w,I,S,o){"use strict";var h;Object.defineProperty(e,"__esModule",{value:!0}),e.TestRunProfileImpl=e.MirroredTestCollection=e.TestRunDto=e.TestRunCoordinator=e.ExtHostTesting=void 0;let y=class{constructor(m,A){this.resultsChangedEmitter=new R.Emitter,this.controllers=new Map,this.onResultsChanged=this.resultsChangedEmitter.event,this.results=[],this.proxy=m.getProxy(n.MainContext.MainThreadTesting),this.observer=new k(this.proxy),this.runTracker=new v(this.proxy),A.registerArgumentProcessor({processArgument:L=>L?.$mid===13?l.TestItem.toItemFromContext(L):L})}createTestController(m,A){if(this.controllers.has(m))throw new Error(`Attempt to insert a duplicate controller with ID "${m}"`);const L=new _.DisposableStore,V=L.add(new I.SingleUseTestCollection(m));V.root.label=A;const G=new Map,U=this.proxy,K={items:V.root.children,get label(){return A},set label(B){A=B,V.root.label=B,U.$updateControllerLabel(m,A)},get id(){return m},createRunProfile:(B,z,Y,ne,j)=>{let le=(0,C.hash)(B);for(;G.has(le);)le++;const oe=new T(this.proxy,m,le,B,z,Y,ne,j);return G.set(le,oe),oe},createTestItem(B,z,Y){return new a.TestItemImpl(m,B,z,Y)},createTestRun:(B,z,Y=!0)=>this.runTracker.createTestRun(m,V,B,z,Y),set resolveHandler(B){V.resolveHandler=B},get resolveHandler(){return V.resolveHandler},dispose:()=>{L.dispose()}};K.createRunConfiguration=K.createRunProfile,U.$registerTestController(m,A),L.add((0,_.toDisposable)(()=>U.$unregisterTestController(m)));const $={controller:K,collection:V,profiles:G};return this.controllers.set(m,$),L.add((0,_.toDisposable)(()=>this.controllers.delete(m))),L.add(V.onDidGenerateDiff(B=>U.$publishDiff(m,B))),K}createTestObserver(){return this.observer.checkout()}async runTests(m,A=b.CancellationToken.None){const L=r(m);if(!L)throw new Error("The request passed to `vscode.test.runTests` must include a profile");const V=this.controllers.get(L.controllerId);if(!V)throw new Error("Controller not found");await this.proxy.$runTests({targets:[{testIds:m.include?.map(G=>G.id)??[V.collection.root.id],profileGroup:g[L.kind],profileId:L.profileId,controllerId:L.controllerId}],exclude:m.exclude?.map(G=>G.id)},A)}$provideFileCoverage(m,A,L){return(0,c.mapFind)(this.runTracker.trackers,G=>G.id===m?G.getCoverage(A):void 0)?.provideFileCoverage(L)??Promise.resolve([])}$resolveFileCoverage(m,A,L,V){return(0,c.mapFind)(this.runTracker.trackers,U=>U.id===m?U.getCoverage(A):void 0)?.resolveFileCoverage(L,V)??Promise.resolve([])}$configureRunProfile(m,A){this.controllers.get(m)?.profiles.get(A)?.configureHandler?.()}$publishTestResults(m){this.results=Object.freeze(m.map(A=>(0,P.deepFreeze)(l.TestResults.to(A))).concat(this.results).sort((A,L)=>L.completedAt-A.completedAt).slice(0,32)),this.resultsChangedEmitter.fire()}async $expandTest(m,A){const L=this.controllers.get(o.TestId.fromString(m).controllerId)?.collection;L&&(await L.expand(m,A<0?Infinity:A),L.flushDiff())}$acceptDiff(m){this.observer.applyDiff(m)}async $runControllerTests(m,A){const L=this.controllers.get(m.controllerId);if(!L)return;const{collection:V,profiles:G}=L,U=G.get(m.profileId);if(!U)return;const K=m.testIds.map(Y=>V.tree.get(Y)).filter(t.isDefined),$=m.excludeExtIds.map(Y=>L.collection.tree.get(Y)).filter(t.isDefined).filter(Y=>K.some(ne=>ne.fullId.compare(Y.fullId)===2));if(!K.length)return;const B=new w.TestRunRequest(K.some(Y=>Y.actual instanceof a.TestItemRootImpl)?void 0:K.map(Y=>Y.actual),$.map(Y=>Y.actual),U),z=this.runTracker.prepareForMainThreadTestRun(B,s.fromInternal(m,L.collection),A);try{await U.runHandler(B,A)}finally{z.isRunning&&!A.isCancellationRequested&&await R.Event.toPromise(z.onEnd),z.dispose()}}$cancelExtensionTestRun(m){m===void 0?this.runTracker.cancelAllRuns():this.runTracker.cancelRunById(m)}};y=We([ze(0,f.IExtHostRpcService)],y),e.ExtHostTesting=y;class i extends _.Disposable{constructor(m,A,L){super();this.dto=m,this.proxy=A,this.tasks=new Map,this.sharedTestIds=new Set,this.endEmitter=this._register(new R.Emitter),this.disposed=!1,this.onEnd=this.endEmitter.event,this.cts=this._register(new b.CancellationTokenSource(L)),this._register(this.cts.token.onCancellationRequested(()=>{for(const{run:V}of this.tasks.values())V.end()}))}get isRunning(){return this.tasks.size>0}get id(){return this.dto.id}getCoverage(m){return this.tasks.get(m)?.coverage}createRun(m){const A=this.dto.id,L=this.dto.controllerId,V=(0,E.generateUuid)(),G=new u(this.proxy,A,V),U=z=>(Y,...ne)=>{if($){console.warn(`Setting the state of test "${Y.id}" is a no-op after the run ends.`);return}!this.dto.isIncluded(Y)||(this.ensureTestIsKnown(Y),z(Y,...ne))},K=(z,Y)=>{const ne=Y instanceof Array?Y.map(l.TestMessage.from):[l.TestMessage.from(Y)];if(z.uri&&z.range){const j={range:l.Range.from(z.range),uri:z.uri};for(const le of ne)le.location=le.location||j}this.proxy.$appendTestMessagesInRun(A,V,o.TestId.fromExtHostTestItem(z,L).toString(),ne)};let $=!1;const B={isPersisted:this.dto.isPersisted,token:this.cts.token,name:m,get coverageProvider(){return G.coverageProvider},set coverageProvider(z){G.coverageProvider=z},enqueued:U(z=>{this.proxy.$updateTestStateInRun(A,V,o.TestId.fromExtHostTestItem(z,L).toString(),1)}),skipped:U(z=>{this.proxy.$updateTestStateInRun(A,V,o.TestId.fromExtHostTestItem(z,L).toString(),5)}),started:U(z=>{this.proxy.$updateTestStateInRun(A,V,o.TestId.fromExtHostTestItem(z,L).toString(),2)}),errored:U((z,Y,ne)=>{K(z,Y),this.proxy.$updateTestStateInRun(A,V,o.TestId.fromExtHostTestItem(z,L).toString(),6,ne)}),failed:U((z,Y,ne)=>{K(z,Y),this.proxy.$updateTestStateInRun(A,V,o.TestId.fromExtHostTestItem(z,L).toString(),4,ne)}),passed:U((z,Y)=>{this.proxy.$updateTestStateInRun(A,V,o.TestId.fromExtHostTestItem(z,this.dto.controllerId).toString(),3,Y)}),appendOutput:(z,Y,ne)=>{$||(ne&&(this.dto.isIncluded(ne)?this.ensureTestIsKnown(ne):ne=void 0),this.proxy.$appendOutputToRun(A,V,M.VSBuffer.fromString(z),Y&&l.location.from(Y),ne&&o.TestId.fromExtHostTestItem(ne,L).toString()))},end:()=>{$||($=!0,this.proxy.$finishedTestRunTask(A,V),this.tasks.delete(V),this.isRunning||this.dispose())}};return this.tasks.set(V,{run:B,coverage:G}),this.proxy.$startedTestRunTask(A,{id:V,name:m,running:!0}),B}dispose(){this.disposed||(this.disposed=!0,this.endEmitter.fire(),this.cts.cancel(),super.dispose())}ensureTestIsKnown(m){if(!(m instanceof a.TestItemImpl))throw new a.InvalidTestItemError(m.id);if(this.sharedTestIds.has(o.TestId.fromExtHostTestItem(m,this.dto.controllerId).toString()))return;const A=[],L=this.dto.colllection.root;for(;;){const V=l.TestItem.from(m);if(A.unshift(V),this.sharedTestIds.has(V.extId)||(this.sharedTestIds.add(V.extId),m===L))break;m=m.parent||L}this.proxy.$addTestsToRun(this.dto.controllerId,this.dto.id,A)}}class v{constructor(m){this.proxy=m,this.tracked=new Map}get trackers(){return this.tracked.values()}prepareForMainThreadTestRun(m,A,L){return this.getTracker(m,A,L)}cancelRunById(m){for(const A of this.tracked.values())if(A.id===m){A.dispose();return}}cancelAllRuns(){for(const m of this.tracked.values())m.dispose()}createTestRun(m,A,L,V,G){const U=this.tracked.get(L);if(U)return U.createRun(V);const K=s.fromPublic(m,A,L,G),$=r(L);this.proxy.$startedExtensionTestRun({controllerId:m,profile:$&&{group:g[$.kind],id:$.profileId},exclude:L.exclude?.map(z=>z.id)??[],id:K.id,include:L.include?.map(z=>z.id)??[A.root.id],persist:G});const B=this.getTracker(L,K);return B.onEnd(()=>this.proxy.$finishedExtensionTestRun(K.id)),B.createRun(V)}getTracker(m,A,L){const V=new i(A,this.proxy,L);return this.tracked.set(m,V),V.onEnd(()=>this.tracked.delete(m)),V}}e.TestRunCoordinator=v;const r=D=>{if(!!D.profile){if(!(D.profile instanceof T))throw new Error("TestRunRequest.profile is not an instance created from TestController.createRunProfile");return D.profile}};class s{constructor(m,A,L,V,G,U){this.controllerId=m,this.id=A,this.isPersisted=G,this.colllection=U,this.includePrefix=L.map(K=>K+"\0"),this.excludePrefix=V.map(K=>K+"\0")}static fromPublic(m,A,L,V){return new s(m,(0,E.generateUuid)(),L.include?.map(G=>o.TestId.fromExtHostTestItem(G,m).toString())??[m],L.exclude?.map(G=>o.TestId.fromExtHostTestItem(G,m).toString())??[],V,A)}static fromInternal(m,A){return new s(m.controllerId,m.runId,m.testIds,m.excludeExtIds,!0,A)}isIncluded(m){const A=o.TestId.fromExtHostTestItem(m,this.controllerId).toString()+"\0";for(const L of this.excludePrefix)if(A===L||A.startsWith(L))return!1;for(const L of this.includePrefix)if(A===L||A.startsWith(L))return!0;return!1}}e.TestRunDto=s;class u{constructor(m,A,L){this.proxy=m,this.runId=A,this.taskId=L}set coverageProvider(m){if(this._coverageProvider)throw new Error("The TestCoverageProvider cannot be replaced after being provided");!m||(this._coverageProvider=m,this.proxy.$signalCoverageAvailable(this.runId,this.taskId))}get coverageProvider(){return this._coverageProvider}async provideFileCoverage(m){if(!this._coverageProvider)return[];this.fileCoverage||(this.fileCoverage=(async()=>this._coverageProvider.provideFileCoverage(m))());try{return(await this.fileCoverage)?.map(l.TestCoverage.fromFile)??[]}catch(A){throw this.fileCoverage=void 0,A}}async resolveFileCoverage(m,A){const L=await this.fileCoverage;let V=L?.[m];return!this._coverageProvider||!L||!V?[]:(V.detailedCoverage||(V=L[m]=await this._coverageProvider.resolveFileCoverage?.(V,A)??V),V.detailedCoverage?.map(l.TestCoverage.fromDetailed)??[])}}class d extends S.IncrementalChangeCollector{constructor(m){super();this.emitter=m,this.added=new Set,this.updated=new Set,this.removed=new Set,this.alreadyRemoved=new Set}get isEmpty(){return this.added.size===0&&this.removed.size===0&&this.updated.size===0}add(m){this.added.add(m)}update(m){Object.assign(m.revived,l.TestItem.toPlain(m.item)),this.added.has(m)||this.updated.add(m)}remove(m){if(this.added.has(m)){this.added.delete(m);return}if(this.updated.delete(m),m.parent&&this.alreadyRemoved.has(m.parent)){this.alreadyRemoved.add(m.item.extId);return}this.removed.add(m)}getChangeEvent(){const{added:m,updated:A,removed:L}=this;return{get added(){return[...m].map(V=>V.revived)},get updated(){return[...A].map(V=>V.revived)},get removed(){return[...L].map(V=>V.revived)}}}complete(){this.isEmpty||this.emitter.fire(this.getChangeEvent())}}class p extends S.AbstractIncrementalTestCollection{constructor(){super(...arguments);this.changeEmitter=new R.Emitter,this.onDidChangeTests=this.changeEmitter.event}get rootTests(){return super.roots}getMirroredTestDataById(m){return this.items.get(m)}getMirroredTestDataByReference(m){return this.items.get(m.id)}createItem(m,A){return{...m,revived:l.TestItem.toPlain(m.item),depth:A?A.depth+1:0,children:new Set}}createChangeCollector(){return new d(this.changeEmitter)}}e.MirroredTestCollection=p;class k{constructor(m){this.proxy=m}checkout(){this.current||(this.current=this.createObserverData());const m=this.current;return m.observers++,{onDidChangeTest:m.tests.onDidChangeTests,get tests(){return[...m.tests.rootTests].map(A=>A.revived)},dispose:(0,F.once)(()=>{--m.observers==0&&(this.proxy.$unsubscribeFromDiffs(),this.current=void 0)})}}getMirroredTestDataByReference(m){return this.current?.tests.getMirroredTestDataByReference(m)}applyDiff(m){this.current?.tests.apply(m)}createObserverData(){const m=new p;return this.proxy.$subscribeToDiffs(),{observers:0,tests:m}}}class T{constructor(m,A,L,V,G,U,K=!1,$=void 0){this.controllerId=A,this.profileId=L,this._label=V,this.kind=G,this.runHandler=U,this._isDefault=K,this._tag=$,h.set(this,void 0),Ze(this,h,m,"f");const B=g[G];if(typeof B!="number")throw new Error(`Unknown TestRunProfile.group ${G}`);Ae(this,h,"f").$publishTestRunProfile({profileId:L,controllerId:A,tag:$?l.TestTag.namespace(this.controllerId,$.id):null,label:V,group:B,isDefault:K,hasConfigurationHandler:!1})}get label(){return this._label}set label(m){m!==this._label&&(this._label=m,Ae(this,h,"f").$updateTestRunConfig(this.controllerId,this.profileId,{label:m}))}get isDefault(){return this._isDefault}set isDefault(m){m!==this._isDefault&&(this._isDefault=m,Ae(this,h,"f").$updateTestRunConfig(this.controllerId,this.profileId,{isDefault:m}))}get tag(){return this._tag}set tag(m){m?.id!==this._tag?.id&&(this._tag=m,Ae(this,h,"f").$updateTestRunConfig(this.controllerId,this.profileId,{tag:m?l.TestTag.namespace(this.controllerId,m.id):null}))}get configureHandler(){return this._configureHandler}set configureHandler(m){m!==this._configureHandler&&(this._configureHandler=m,Ae(this,h,"f").$updateTestRunConfig(this.controllerId,this.profileId,{hasConfigurationHandler:!!m}))}dispose(){Ae(this,h,"f").$removeTestProfile(this.controllerId,this.profileId)}}e.TestRunProfileImpl=T,h=new WeakMap;const g={[w.TestRunProfileKind.Coverage]:8,[w.TestRunProfileKind.Debug]:4,[w.TestRunProfileKind.Run]:2}}),define(we[204],Ee([0,1,3,12,5,94,8,7]),function(re,e,c,M,b,R,F,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostEditors=void 0;class _{constructor(t,E){this._extHostDocumentsAndEditors=E,this._onDidChangeTextEditorSelection=new c.Emitter,this._onDidChangeTextEditorOptions=new c.Emitter,this._onDidChangeTextEditorVisibleRanges=new c.Emitter,this._onDidChangeTextEditorViewColumn=new c.Emitter,this._onDidChangeActiveTextEditor=new c.Emitter,this._onDidChangeVisibleTextEditors=new c.Emitter,this.onDidChangeTextEditorSelection=this._onDidChangeTextEditorSelection.event,this.onDidChangeTextEditorOptions=this._onDidChangeTextEditorOptions.event,this.onDidChangeTextEditorVisibleRanges=this._onDidChangeTextEditorVisibleRanges.event,this.onDidChangeTextEditorViewColumn=this._onDidChangeTextEditorViewColumn.event,this.onDidChangeActiveTextEditor=this._onDidChangeActiveTextEditor.event,this.onDidChangeVisibleTextEditors=this._onDidChangeVisibleTextEditors.event,this._proxy=t.getProxy(b.MainContext.MainThreadTextEditors),this._extHostDocumentsAndEditors.onDidChangeVisibleTextEditors(n=>this._onDidChangeVisibleTextEditors.fire(n)),this._extHostDocumentsAndEditors.onDidChangeActiveTextEditor(n=>this._onDidChangeActiveTextEditor.fire(n))}getActiveTextEditor(){return this._extHostDocumentsAndEditors.activeEditor()}getVisibleTextEditors(t){const E=this._extHostDocumentsAndEditors.allEditors();return t?E:E.map(n=>n.value)}async showTextDocument(t,E,n){let f;typeof E=="number"?f={position:F.ViewColumn.from(E),preserveFocus:n}:typeof E=="object"?f={position:F.ViewColumn.from(E.viewColumn),preserveFocus:E.preserveFocus,selection:typeof E.selection=="object"?F.Range.from(E.selection):void 0,pinned:typeof E.preview=="boolean"?!E.preview:void 0}:f={preserveFocus:!1};const a=await this._proxy.$tryShowTextDocument(t.uri,f),l=a&&this._extHostDocumentsAndEditors.getEditor(a);if(l)return l.value;throw a?new Error(`Could NOT open editor for "${t.uri.toString()}" because another editor opened in the meantime.`):new Error(`Could NOT open editor for "${t.uri.toString()}".`)}createTextEditorDecorationType(t,E){return new R.TextEditorDecorationType(this._proxy,t,E).value}$acceptEditorPropertiesChanged(t,E){const n=this._extHostDocumentsAndEditors.getEditor(t);if(!n)throw new Error("unknown text editor");if(E.options&&n._acceptOptions(E.options),E.selections){const f=E.selections.selections.map(F.Selection.to);n._acceptSelections(f)}if(E.visibleRanges){const f=M.coalesce(E.visibleRanges.map(F.Range.to));n._acceptVisibleRanges(f)}if(E.options&&this._onDidChangeTextEditorOptions.fire({textEditor:n.value,options:{...E.options,lineNumbers:F.TextEditorLineNumbersStyle.to(E.options.lineNumbers)}}),E.selections){const f=C.TextEditorSelectionChangeKind.fromValue(E.selections.source),a=E.selections.selections.map(F.Selection.to);this._onDidChangeTextEditorSelection.fire({textEditor:n.value,selections:a,kind:f})}if(E.visibleRanges){const f=M.coalesce(E.visibleRanges.map(F.Range.to));this._onDidChangeTextEditorVisibleRanges.fire({textEditor:n.value,visibleRanges:f})}}$acceptEditorPositionData(t){for(const E in t){const n=this._extHostDocumentsAndEditors.getEditor(E);if(!n)throw new Error("Unknown text editor");const f=F.ViewColumn.to(t[E]);n.value.viewColumn!==f&&(n._acceptViewColumn(f),this._onDidChangeTextEditorViewColumn.fire({textEditor:n.value,viewColumn:f}))}}getDiffInformation(t){return Promise.resolve(this._proxy.$getDiffInformation(t))}}e.ExtHostEditors=_}),define(we[205],Ee([0,1,2,4,5,6,7]),function(re,e,c,M,b,R,F){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostTimeline=e.IExtHostTimeline=void 0,e.IExtHostTimeline=(0,M.createDecorator)("IExtHostTimeline");class C{constructor(t,E){this._providers=new Map,this._itemsBySourceAndUriMap=new Map,this._proxy=t.getProxy(b.MainContext.MainThreadTimeline),E.registerArgumentProcessor({processArgument:n=>{if(n&&n.$mid===11){const f=n.uri===void 0?void 0:c.URI.revive(n.uri);return this._itemsBySourceAndUriMap.get(n.source)?.get(_(f))?.get(n.handle)}return n}})}async $getTimeline(t,E,n,f,a){return this._providers.get(t)?.provideTimeline(c.URI.revive(E),n,f,a)}registerTimelineProvider(t,E,n,f){const a=new R.DisposableStore,l=this.convertTimelineItem(E.id,f,a).bind(this);let w;E.onDidChange&&(w=E.onDidChange(S=>this._proxy.$emitTimelineChangeEvent({uri:void 0,reset:!0,...S,id:E.id}),this));const I=this._itemsBySourceAndUriMap;return this.registerTimelineProviderCore({...E,scheme:t,onDidChange:void 0,async provideTimeline(S,o,h,y){y?.resetCache&&(a.clear(),I.get(E.id)?.clear());const i=await E.provideTimeline(S,o,h);if(i==null)return;const v=l(S,y);return{...i,source:E.id,items:i.items.map(v)}},dispose(){for(const S of I.values())S.get(E.id)?.clear();w?.dispose(),a.dispose()}})}convertTimelineItem(t,E,n){return(f,a)=>{let l;if(a?.cacheResults){let w=this._itemsBySourceAndUriMap.get(t);w===void 0&&(w=new Map,this._itemsBySourceAndUriMap.set(t,w));const I=_(f);l=w.get(I),l===void 0&&(l=new Map,w.set(I,l))}return w=>{const{iconPath:I,...S}=w,o=`${t}|${w.id??w.timestamp}`;l?.set(o,w);let h,y,i;return w.iconPath&&(I instanceof F.ThemeIcon?i={id:I.id,color:I.color}:c.URI.isUri(I)?(h=I,y=I):{light:h,dark:y}=I),{...S,id:S.id??void 0,handle:o,source:t,command:w.command?E.toInternal(w.command,n):void 0,icon:h,iconDark:y,themeIcon:i,accessibilityInformation:w.accessibilityInformation}}}}registerTimelineProviderCore(t){if(this._providers.get(t.id))throw new Error(`Timeline Provider ${t.id} already exists.`);return this._proxy.$registerTimelineProvider({id:t.id,label:t.label,scheme:t.scheme}),this._providers.set(t.id,t),(0,R.toDisposable)(()=>{for(const n of this._itemsBySourceAndUriMap.values())n.get(t.id)?.clear();this._providers.delete(t.id),this._proxy.$unregisterTimelineProvider(t.id),t.dispose()})}}e.ExtHostTimeline=C;function _(P){return P?.toString()}}),define(we[206],Ee([0,1,6,11,2,5]),function(re,e,c,M,b,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostUriOpeners=void 0;class F{constructor(_){this._openers=new Map,this._proxy=_.getProxy(R.MainContext.MainThreadUriOpeners)}registerExternalUriOpener(_,P,t,E){if(this._openers.has(P))throw new Error(`Opener with id '${P}' already registered`);const n=E.schemes.find(f=>!F.supportedSchemes.has(f));if(n)throw new Error(`Scheme '${n}' is not supported. Only http and https are currently supported.`);return this._openers.set(P,t),this._proxy.$registerUriOpener(P,E.schemes,_,E.label),(0,c.toDisposable)(()=>{this._openers.delete(P),this._proxy.$unregisterUriOpener(P)})}async $canOpenUri(_,P,t){const E=this._openers.get(_);if(!E)throw new Error(`Unknown opener with id: ${_}`);const n=b.URI.revive(P);return E.canOpenExternalUri(n,t)}async $openUri(_,P,t){const E=this._openers.get(_);if(!E)throw new Error(`Unknown opener id: '${_}'`);return E.openExternalUri(b.URI.revive(P.resolvedUri),{sourceUri:b.URI.revive(P.sourceUri)},t)}}e.ExtHostUriOpeners=F,F.supportedSchemes=new Set([M.Schemas.http,M.Schemas.https])}),define(we[207],Ee([0,1,5,2,6,16,25]),function(re,e,c,M,b,R,F){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostUrls=void 0;class C{constructor(P){this.handles=new Set,this.handlers=new Map,this._proxy=P.getProxy(c.MainContext.MainThreadUrls)}registerUriHandler(P,t){if(this.handles.has(F.ExtensionIdentifier.toKey(P)))throw new Error(`Protocol handler already registered for extension ${P}`);const E=C.HandlePool++;return this.handles.add(F.ExtensionIdentifier.toKey(P)),this.handlers.set(E,t),this._proxy.$registerUriHandler(E,P),(0,b.toDisposable)(()=>{this.handles.delete(F.ExtensionIdentifier.toKey(P)),this.handlers.delete(E),this._proxy.$unregisterUriHandler(E)})}$handleExternalUri(P,t){const E=this.handlers.get(P);if(!E)return Promise.resolve(void 0);try{E.handleUri(M.URI.revive(t))}catch(n){(0,R.onUnexpectedError)(n)}return Promise.resolve(void 0)}async createAppUri(P){return M.URI.revive(await this._proxy.$createAppUri(P))}}e.ExtHostUrls=C,C.HandlePool=0});var Ze=this&&this.__classPrivateFieldSet||function(re,e,c,M,b){if(M==="m")throw new TypeError("Private method is not writable");if(M==="a"&&!b)throw new TypeError("Private accessor was defined without a setter");if(typeof e=="function"?re!==e||!b:!e.has(re))throw new TypeError("Cannot write private member to an object whose class did not declare it");return M==="a"?b.call(re,c):b?b.value=c:e.set(re,c),c},Ae=this&&this.__classPrivateFieldGet||function(re,e,c,M){if(c==="a"&&!M)throw new TypeError("Private accessor was defined without a getter");if(typeof e=="function"?re!==e||!M:!e.has(re))throw new TypeError("Cannot read private member from an object whose class did not declare it");return c==="m"?M:c==="a"?M.call(re):M?M.value:e.get(re)};define(we[50],Ee([0,1,3,2,138,157,66,5]),function(re,e,c,M,b,R,F,C){"use strict";var _,P,t,E,n,f,a,l,w,I,S,o;Object.defineProperty(e,"__esModule",{value:!0}),e.reviveOptions=e.serializeWebviewOptions=e.toExtensionData=e.ExtHostWebviews=e.shouldSerializeBuffersForPostMessage=e.ExtHostWebview=void 0;class h{constructor(p,k,T,g,D,m,A){_.set(this,void 0),P.set(this,void 0),t.set(this,void 0),E.set(this,void 0),n.set(this,void 0),f.set(this,void 0),a.set(this,""),l.set(this,void 0),w.set(this,!1),I.set(this,!1),S.set(this,!1),this._onMessageEmitter=new c.Emitter,this.onDidReceiveMessage=this._onMessageEmitter.event,o.set(this,new c.Emitter),this._onDidDispose=Ae(this,o,"f").event,Ze(this,_,p,"f"),Ze(this,P,k,"f"),Ze(this,l,T,"f"),Ze(this,E,g,"f"),Ze(this,n,D,"f"),Ze(this,f,m,"f"),Ze(this,S,y(m),"f"),Ze(this,t,A,"f")}dispose(){Ze(this,w,!0,"f"),Ae(this,o,"f").fire(),Ae(this,o,"f").dispose(),this._onMessageEmitter.dispose()}asWebviewUri(p){return Ze(this,I,!0,"f"),(0,F.asWebviewUri)(p,Ae(this,E,"f").remote)}get cspSource(){return F.webviewGenericCspSource}get html(){return this.assertNotDisposed(),Ae(this,a,"f")}set html(p){this.assertNotDisposed(),Ae(this,a,"f")!==p&&(Ze(this,a,p,"f"),!Ae(this,I,"f")&&/(["'])vscode-resource:([^\s'"]+?)(["'])/i.test(p)&&(Ze(this,I,!0,"f"),Ae(this,t,"f").report("Webview vscode-resource: uris",Ae(this,f,"f"),"Please migrate to use the 'webview.asWebviewUri' api instead: https://aka.ms/vscode-webview-use-aswebviewuri")),Ae(this,P,"f").$setHtml(Ae(this,_,"f"),p))}get options(){return this.assertNotDisposed(),Ae(this,l,"f")}set options(p){this.assertNotDisposed(),Ae(this,P,"f").$setOptions(Ae(this,_,"f"),r(Ae(this,f,"f"),Ae(this,n,"f"),p)),Ze(this,l,p,"f")}async postMessage(p){if(Ae(this,w,"f"))return!1;const k=(0,R.serializeWebviewMessage)(p,{serializeBuffersForPostMessage:Ae(this,S,"f")});return Ae(this,P,"f").$postMessage(Ae(this,_,"f"),k.message,...k.buffers)}assertNotDisposed(){if(Ae(this,w,"f"))throw new Error("Webview is disposed")}}e.ExtHostWebview=h,_=new WeakMap,P=new WeakMap,t=new WeakMap,E=new WeakMap,n=new WeakMap,f=new WeakMap,a=new WeakMap,l=new WeakMap,w=new WeakMap,I=new WeakMap,S=new WeakMap,o=new WeakMap;function y(d){try{const p=(0,b.normalizeVersion)((0,b.parseVersion)(d.engines.vscode));return!!p&&p.majorBase>=1&&p.minorBase>=57}catch{return!1}}e.shouldSerializeBuffersForPostMessage=y;class i{constructor(p,k,T,g,D){this.initData=k,this.workspace=T,this._logService=g,this._deprecationService=D,this._webviews=new Map,this._webviewProxy=p.getProxy(C.MainContext.MainThreadWebviews)}$onMessage(p,k,...T){const g=this.getWebview(p);if(g){const{message:D}=(0,R.deserializeWebviewMessage)(k,T);g._onMessageEmitter.fire(D)}}$onMissingCsp(p,k){this._logService.warn(`${k} created a webview without a content security policy: https://aka.ms/vscode-webview-missing-csp`)}createNewWebview(p,k,T){const g=new h(p,this._webviewProxy,s(k),this.initData,this.workspace,T,this._deprecationService);return this._webviews.set(p,g),g._onDidDispose(()=>{this._webviews.delete(p)}),g}deleteWebview(p){this._webviews.delete(p)}getWebview(p){return this._webviews.get(p)}}e.ExtHostWebviews=i;function v(d){return{id:d.identifier,location:d.extensionLocation}}e.toExtensionData=v;function r(d,p,k){return{enableCommandUris:k.enableCommandUris,enableScripts:k.enableScripts,enableForms:k.enableForms,portMapping:k.portMapping,localResourceRoots:k.localResourceRoots||u(d,p)}}e.serializeWebviewOptions=r;function s(d){return{enableCommandUris:d.enableCommandUris,enableScripts:d.enableScripts,enableForms:d.enableForms,portMapping:d.portMapping,localResourceRoots:d.localResourceRoots?.map(p=>M.URI.from(p))}}e.reviveOptions=s;function u(d,p){return[...(p?.getWorkspaceFolders()||[]).map(k=>k.uri),d.extensionLocation]}}),define(we[208],Ee([0,1,21,58,6,11,24,2,8,50,63,5,7]),function(re,e,c,M,b,R,F,C,_,P,t,E,n){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostCustomEditors=void 0;class f{constructor(i,v){this.document=i,this._storagePath=v,this._backupCounter=1,this._edits=new t.Cache("custom documents")}addEdit(i){return this._edits.add([i])}async undo(i,v){await this.getEdit(i).undo(),v||this.disposeBackup()}async redo(i,v){await this.getEdit(i).redo(),v||this.disposeBackup()}disposeEdits(i){for(const v of i)this._edits.delete(v)}getNewBackupUri(){if(!this._storagePath)throw new Error("Backup requires a valid storage path");const i=h(this.document.uri)+this._backupCounter++;return(0,F.joinPath)(this._storagePath,i)}updateBackup(i){this._backup?.delete(),this._backup=i}disposeBackup(){this._backup?.delete(),this._backup=void 0}getEdit(i){const v=this._edits.get(i,0);if(!v)throw new Error("No edit found");return v}}class a{constructor(){this._documents=new Map}get(i,v){return this._documents.get(this.key(i,v))}add(i,v,r){const s=this.key(i,v.uri);if(this._documents.has(s))throw new Error(`Document already exists for viewType:${i} resource:${v.uri}`);const u=new f(v,r);return this._documents.set(s,u),u}delete(i,v){const r=this.key(i,v.uri);this._documents.delete(r)}key(i,v){return`${i}@@@${v}`}}var l;(function(y){y[y.Text=0]="Text",y[y.Custom=1]="Custom"})(l||(l={}));class w{constructor(){this._providers=new Map}addTextProvider(i,v,r){return this.add(0,i,v,r)}addCustomProvider(i,v,r){return this.add(1,i,v,r)}get(i){return this._providers.get(i)}add(i,v,r,s){if(this._providers.has(v))throw new Error(`Provider for viewType:${v} already registered`);return this._providers.set(v,{type:i,extension:r,provider:s}),new n.Disposable(()=>this._providers.delete(v))}}class I{constructor(i,v,r,s,u){this._extHostDocuments=v,this._extensionStoragePaths=r,this._extHostWebview=s,this._extHostWebviewPanels=u,this._editorProviders=new w,this._documents=new a,this._proxy=i.getProxy(E.MainContext.MainThreadCustomEditors)}registerCustomEditorProvider(i,v,r,s){const u=new b.DisposableStore;return S(r)?(u.add(this._editorProviders.addTextProvider(v,i,r)),this._proxy.$registerTextEditorProvider((0,P.toExtensionData)(i),v,s.webviewOptions||{},{supportsMove:!!r.moveCustomTextEditor},(0,P.shouldSerializeBuffersForPostMessage)(i))):(u.add(this._editorProviders.addCustomProvider(v,i,r)),this.supportEditing(r)&&u.add(r.onDidChangeCustomDocument(d=>{const p=this.getCustomDocumentEntry(v,d.document.uri);if(o(d)){const k=p.addEdit(d);this._proxy.$onDidEdit(d.document.uri,v,k,d.label)}else this._proxy.$onContentChange(d.document.uri,v)})),this._proxy.$registerCustomEditorProvider((0,P.toExtensionData)(i),v,s.webviewOptions||{},!!s.supportsMultipleEditorsPerDocument,(0,P.shouldSerializeBuffersForPostMessage)(i))),n.Disposable.from(u,new n.Disposable(()=>{this._proxy.$unregisterEditorProvider(v)}))}async $createCustomDocument(i,v,r,s,u){const d=this._editorProviders.get(v);if(!d)throw new Error(`No provider found for '${v}'`);if(d.type!==1)throw new Error(`Invalid provide type for '${v}'`);const p=C.URI.revive(i),k=await d.provider.openCustomDocument(p,{backupId:r,untitledDocumentData:s?.buffer},u);let T;return this.supportEditing(d.provider)&&this._extensionStoragePaths&&(T=this._extensionStoragePaths.workspaceValue(d.extension)??this._extensionStoragePaths.globalValue(d.extension)),this._documents.add(v,k,T),{editable:this.supportEditing(d.provider)}}async $disposeCustomDocument(i,v){const r=this._editorProviders.get(v);if(!r)throw new Error(`No provider found for '${v}'`);if(r.type!==1)throw new Error(`Invalid provider type for '${v}'`);const s=C.URI.revive(i),{document:u}=this.getCustomDocumentEntry(v,s);this._documents.delete(v,u),u.dispose()}async $resolveWebviewEditor(i,v,r,s,u,d){const p=this._editorProviders.get(r);if(!p)throw new Error(`No provider found for '${r}'`);const k=_.ViewColumn.to(u),T=this._extHostWebview.createNewWebview(v,s.webviewOptions,p.extension),g=this._extHostWebviewPanels.createNewWebviewPanel(v,r,s.title,k,s.panelOptions,T),D=C.URI.revive(i);switch(p.type){case 1:{const{document:m}=this.getCustomDocumentEntry(r,D);return p.provider.resolveCustomEditor(m,g,d)}case 0:{const m=this._extHostDocuments.getDocument(D);return p.provider.resolveCustomTextEditor(m,g,d)}default:throw new Error("Unknown webview provider type")}}$disposeEdits(i,v,r){this.getCustomDocumentEntry(v,i).disposeEdits(r)}async $onMoveCustomEditor(i,v,r){const s=this._editorProviders.get(r);if(!s)throw new Error(`No provider found for '${r}'`);if(!s.provider.moveCustomTextEditor)throw new Error(`Provider does not implement move '${r}'`);const u=this._extHostWebviewPanels.getWebviewPanel(i);if(!u)throw new Error("No webview found");const d=C.URI.revive(v),p=this._extHostDocuments.getDocument(d);await s.provider.moveCustomTextEditor(p,u,c.CancellationToken.None)}async $undo(i,v,r,s){return this.getCustomDocumentEntry(v,i).undo(r,s)}async $redo(i,v,r,s){return this.getCustomDocumentEntry(v,i).redo(r,s)}async $revert(i,v,r){const s=this.getCustomDocumentEntry(v,i);await this.getCustomEditorProvider(v).revertCustomDocument(s.document,r),s.disposeBackup()}async $onSave(i,v,r){const s=this.getCustomDocumentEntry(v,i);await this.getCustomEditorProvider(v).saveCustomDocument(s.document,r),s.disposeBackup()}async $onSaveAs(i,v,r,s){const u=this.getCustomDocumentEntry(v,i);return this.getCustomEditorProvider(v).saveCustomDocumentAs(u.document,C.URI.revive(r),s)}async $backup(i,v,r){const s=this.getCustomDocumentEntry(v,i),d=await this.getCustomEditorProvider(v).backupCustomDocument(s.document,{destination:s.getNewBackupUri()},r);return s.updateBackup(d),d.id}getCustomDocumentEntry(i,v){const r=this._documents.get(i,C.URI.revive(v));if(!r)throw new Error("No custom document found");return r}getCustomEditorProvider(i){const r=this._editorProviders.get(i)?.provider;if(!r||!this.supportEditing(r))throw new Error("Custom document is not editable");return r}supportEditing(i){return!!i.onDidChangeCustomDocument}}e.ExtHostCustomEditors=I;function S(y){return typeof y.resolveCustomTextEditor=="function"}function o(y){return typeof y.undo=="function"&&typeof y.redo=="function"}function h(y){const i=y.scheme===R.Schemas.file||y.scheme===R.Schemas.untitled?y.fsPath:y.toString();return(0,M.hash)(i)+""}});var Ze=this&&this.__classPrivateFieldSet||function(re,e,c,M,b){if(M==="m")throw new TypeError("Private method is not writable");if(M==="a"&&!b)throw new TypeError("Private accessor was defined without a setter");if(typeof e=="function"?re!==e||!b:!e.has(re))throw new TypeError("Cannot write private member to an object whose class did not declare it");return M==="a"?b.call(re,c):b?b.value=c:e.set(re,c),c},Ae=this&&this.__classPrivateFieldGet||function(re,e,c,M){if(c==="a"&&!M)throw new TypeError("Private accessor was defined without a getter");if(typeof e=="function"?re!==e||!M:!e.has(re))throw new TypeError("Cannot read private member from an object whose class did not declare it");return c==="m"?M:c==="a"?M.call(re):M?M.value:e.get(re)};define(we[209],Ee([0,1,3,6,2,36,8,50,5,7]),function(re,e,c,M,b,R,F,C,_,P){"use strict";var t,E,n,f,a,l,w,I,S,o,h,y,i;Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostWebviewPanels=void 0;class v extends M.Disposable{constructor(d,p,k,T,g,D,m){super();t.set(this,void 0),E.set(this,void 0),n.set(this,void 0),f.set(this,void 0),a.set(this,void 0),l.set(this,void 0),w.set(this,void 0),I.set(this,void 0),S.set(this,!0),o.set(this,!0),h.set(this,!1),y.set(this,this._register(new c.Emitter)),this.onDidDispose=Ae(this,y,"f").event,i.set(this,this._register(new c.Emitter)),this.onDidChangeViewState=Ae(this,i,"f").event,Ze(this,t,d,"f"),Ze(this,E,p,"f"),Ze(this,n,k,"f"),Ze(this,a,D,"f"),Ze(this,I,g,"f"),Ze(this,l,T,"f"),Ze(this,f,m,"f")}dispose(){Ae(this,h,"f")||(Ze(this,h,!0,"f"),Ae(this,y,"f").fire(),Ae(this,E,"f").$disposeWebview(Ae(this,t,"f")),Ae(this,f,"f").dispose(),super.dispose())}get webview(){return this.assertNotDisposed(),Ae(this,f,"f")}get viewType(){return this.assertNotDisposed(),Ae(this,n,"f")}get title(){return this.assertNotDisposed(),Ae(this,l,"f")}set title(d){this.assertNotDisposed(),Ae(this,l,"f")!==d&&(Ze(this,l,d,"f"),Ae(this,E,"f").$setTitle(Ae(this,t,"f"),d))}get iconPath(){return this.assertNotDisposed(),Ae(this,w,"f")}set iconPath(d){this.assertNotDisposed(),Ae(this,w,"f")!==d&&(Ze(this,w,d,"f"),Ae(this,E,"f").$setIconPath(Ae(this,t,"f"),b.URI.isUri(d)?{light:d,dark:d}:d))}get options(){return Ae(this,a,"f")}get viewColumn(){if(this.assertNotDisposed(),!(typeof Ae(this,I,"f")=="number"&&Ae(this,I,"f")<0))return Ae(this,I,"f")}get active(){return this.assertNotDisposed(),Ae(this,o,"f")}get visible(){return this.assertNotDisposed(),Ae(this,S,"f")}_updateViewState(d){Ae(this,h,"f")||(this.active!==d.active||this.visible!==d.visible||this.viewColumn!==d.viewColumn)&&(Ze(this,o,d.active,"f"),Ze(this,S,d.visible,"f"),Ze(this,I,d.viewColumn,"f"),Ae(this,i,"f").fire({webviewPanel:this}))}reveal(d,p){this.assertNotDisposed(),Ae(this,E,"f").$reveal(Ae(this,t,"f"),{viewColumn:d?F.ViewColumn.from(d):void 0,preserveFocus:!!p})}assertNotDisposed(){if(Ae(this,h,"f"))throw new Error("Webview is disposed")}}t=new WeakMap,E=new WeakMap,n=new WeakMap,f=new WeakMap,a=new WeakMap,l=new WeakMap,w=new WeakMap,I=new WeakMap,S=new WeakMap,o=new WeakMap,h=new WeakMap,y=new WeakMap,i=new WeakMap;class r{constructor(d,p,k){this.webviews=p,this.workspace=k,this._webviewPanels=new Map,this._serializers=new Map,this._proxy=d.getProxy(_.MainContext.MainThreadWebviewPanels)}static newHandle(){return(0,R.generateUuid)()}createWebviewPanel(d,p,k,T,g={}){const D=typeof T=="object"?T.viewColumn:T,m={viewColumn:F.ViewColumn.from(D),preserveFocus:typeof T=="object"&&!!T.preserveFocus},A=(0,C.shouldSerializeBuffersForPostMessage)(d),L=r.newHandle();this._proxy.$createWebviewPanel((0,C.toExtensionData)(d),L,p,{title:k,panelOptions:s(g),webviewOptions:(0,C.serializeWebviewOptions)(d,this.workspace,g),serializeBuffersForPostMessage:A},m);const V=this.webviews.createNewWebview(L,g,d);return this.createNewWebviewPanel(L,p,k,D,g,V)}$onDidChangeWebviewPanelViewStates(d){const p=Object.keys(d);p.sort((k,T)=>{const g=d[k],D=d[T];return g.active?1:D.active?-1:+g.visible-+D.visible});for(const k of p){const T=this.getWebviewPanel(k);if(!T)continue;const g=d[k];T._updateViewState({active:g.active,visible:g.visible,viewColumn:F.ViewColumn.to(g.position)})}}async $onDidDisposeWebviewPanel(d){this.getWebviewPanel(d)?.dispose(),this._webviewPanels.delete(d),this.webviews.deleteWebview(d)}registerWebviewPanelSerializer(d,p,k){if(this._serializers.has(p))throw new Error(`Serializer for '${p}' already registered`);return this._serializers.set(p,{serializer:k,extension:d}),this._proxy.$registerSerializer(p,{serializeBuffersForPostMessage:(0,C.shouldSerializeBuffersForPostMessage)(d)}),new P.Disposable(()=>{this._serializers.delete(p),this._proxy.$unregisterSerializer(p)})}async $deserializeWebviewPanel(d,p,k,T){const g=this._serializers.get(p);if(!g)throw new Error(`No serializer found for '${p}'`);const{serializer:D,extension:m}=g,A=this.webviews.createNewWebview(d,k.webviewOptions,m),L=this.createNewWebviewPanel(d,p,k.title,T,k.panelOptions,A);await D.deserializeWebviewPanel(L,k.state)}createNewWebviewPanel(d,p,k,T,g,D){const m=new v(d,this._proxy,p,k,T,g,D);return this._webviewPanels.set(d,m),m}getWebviewPanel(d){return this._webviewPanels.get(d)}}e.ExtHostWebviewPanels=r;function s(u){return{enableFindWidget:u.enableFindWidget,retainContextWhenHidden:u.retainContextWhenHidden}}});var Ze=this&&this.__classPrivateFieldSet||function(re,e,c,M,b){if(M==="m")throw new TypeError("Private method is not writable");if(M==="a"&&!b)throw new TypeError("Private accessor was defined without a setter");if(typeof e=="function"?re!==e||!b:!e.has(re))throw new TypeError("Cannot write private member to an object whose class did not declare it");return M==="a"?b.call(re,c):b?b.value=c:e.set(re,c),c},Ae=this&&this.__classPrivateFieldGet||function(re,e,c,M){if(c==="a"&&!M)throw new TypeError("Private accessor was defined without a getter");if(typeof e=="function"?re!==e||!M:!e.has(re))throw new TypeError("Cannot read private member from an object whose class did not declare it");return c==="m"?M:c==="a"?M.call(re):M?M.value:e.get(re)};define(we[210],Ee([0,1,3,6,50,5,7]),function(re,e,c,M,b,R,F){"use strict";var C,_,P,t,E,n,f,a,l,w;Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostWebviewViews=void 0;class I extends M.Disposable{constructor(h,y,i,v,r,s){super();C.set(this,void 0),_.set(this,void 0),P.set(this,void 0),t.set(this,void 0),E.set(this,!1),n.set(this,void 0),f.set(this,void 0),a.set(this,void 0),l.set(this,this._register(new c.Emitter)),this.onDidChangeVisibility=Ae(this,l,"f").event,w.set(this,this._register(new c.Emitter)),this.onDidDispose=Ae(this,w,"f").event,Ze(this,P,i,"f"),Ze(this,f,v,"f"),Ze(this,C,h,"f"),Ze(this,_,y,"f"),Ze(this,t,r,"f"),Ze(this,n,s,"f")}dispose(){Ae(this,E,"f")||(Ze(this,E,!0,"f"),Ae(this,w,"f").fire(),Ae(this,t,"f").dispose(),super.dispose())}get title(){return this.assertNotDisposed(),Ae(this,f,"f")}set title(h){this.assertNotDisposed(),Ae(this,f,"f")!==h&&(Ze(this,f,h,"f"),Ae(this,_,"f").$setWebviewViewTitle(Ae(this,C,"f"),h))}get description(){return this.assertNotDisposed(),Ae(this,a,"f")}set description(h){this.assertNotDisposed(),Ae(this,a,"f")!==h&&(Ze(this,a,h,"f"),Ae(this,_,"f").$setWebviewViewDescription(Ae(this,C,"f"),h))}get visible(){return Ae(this,n,"f")}get webview(){return Ae(this,t,"f")}get viewType(){return Ae(this,P,"f")}_setVisible(h){h===Ae(this,n,"f")||Ae(this,E,"f")||(Ze(this,n,h,"f"),Ae(this,l,"f").fire())}show(h){this.assertNotDisposed(),Ae(this,_,"f").$show(Ae(this,C,"f"),!!h)}assertNotDisposed(){if(Ae(this,E,"f"))throw new Error("Webview is disposed")}}C=new WeakMap,_=new WeakMap,P=new WeakMap,t=new WeakMap,E=new WeakMap,n=new WeakMap,f=new WeakMap,a=new WeakMap,l=new WeakMap,w=new WeakMap;class S{constructor(h,y){this._extHostWebview=y,this._viewProviders=new Map,this._webviewViews=new Map,this._proxy=h.getProxy(R.MainContext.MainThreadWebviewViews)}registerWebviewViewProvider(h,y,i,v){if(this._viewProviders.has(y))throw new Error(`View provider for '${y}' already registered`);return this._viewProviders.set(y,{provider:i,extension:h}),this._proxy.$registerWebviewViewProvider((0,b.toExtensionData)(h),y,{retainContextWhenHidden:v?.retainContextWhenHidden,serializeBuffersForPostMessage:!1}),new F.Disposable(()=>{this._viewProviders.delete(y),this._proxy.$unregisterWebviewViewProvider(y)})}async $resolveWebviewView(h,y,i,v,r){const s=this._viewProviders.get(y);if(!s)throw new Error(`No view provider found for '${y}'`);const{provider:u,extension:d}=s,p=this._extHostWebview.createNewWebview(h,{},d),k=new I(h,this._proxy,y,i,p,!0);this._webviewViews.set(h,k),await u.resolveWebviewView(k,{state:v},r)}async $onDidChangeWebviewViewVisibility(h,y){this.getWebviewView(h)._setVisible(y)}async $disposeWebviewView(h){const y=this.getWebviewView(h);this._webviewViews.delete(h),y.dispose(),this._extHostWebview.deleteWebview(h)}getWebviewView(h){const y=this._webviewViews.get(h);if(!y)throw new Error("No webview found");return y}}e.ExtHostWebviewViews=S}),define(we[97],Ee([0,1,3,5,2,11,9,4,13]),function(re,e,c,M,b,R,F,C,_){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExtHostWindow=e.ExtHostWindow=void 0;let P=class Ui{constructor(E){this._onDidChangeWindowState=new c.Emitter,this.onDidChangeWindowState=this._onDidChangeWindowState.event,this._state=Ui.InitialState,this._proxy=E.getProxy(M.MainContext.MainThreadWindow),this._proxy.$getWindowVisibility().then(n=>this.$onDidChangeWindowFocus(n))}get state(){return this._state}$onDidChangeWindowFocus(E){E!==this._state.focused&&(this._state={...this._state,focused:E},this._onDidChangeWindowState.fire(this._state))}openUri(E,n){let f;if(typeof E=="string"){f=E;try{E=b.URI.parse(E)}catch(a){return Promise.reject(`Invalid uri - '${E}'`)}}return(0,F.isFalsyOrWhitespace)(E.scheme)?Promise.reject("Invalid scheme - cannot be empty"):E.scheme===R.Schemas.command?Promise.reject(`Invalid scheme '${E.scheme}'`):this._proxy.$openUri(E,f,n)}async asExternalUri(E,n){if((0,F.isFalsyOrWhitespace)(E.scheme))return Promise.reject("Invalid scheme - cannot be empty");const f=await this._proxy.$asExternalUri(E,n);return b.URI.from(f)}};P.InitialState={focused:!0},P=We([ze(0,_.IExtHostRpcService)],P),e.ExtHostWindow=P,e.IExtHostWindow=(0,C.createDecorator)("IExtHostWindow")}),define(we[211],Ee([0,1,15,5,29,13]),function(re,e,c,M,b,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostLogService=void 0;let F=class extends c.AbstractLogger{constructor(_,P){super();this._proxy=_.getProxy(M.MainContext.MainThreadLog),this._logFile=P.logFile.toJSON(),this.setLevel(P.logLevel)}$setLevel(_){this.setLevel(_)}trace(_,...P){this.getLevel()<=c.LogLevel.Trace&&this._proxy.$log(this._logFile,c.LogLevel.Trace,Array.from(arguments))}debug(_,...P){this.getLevel()<=c.LogLevel.Debug&&this._proxy.$log(this._logFile,c.LogLevel.Debug,Array.from(arguments))}info(_,...P){this.getLevel()<=c.LogLevel.Info&&this._proxy.$log(this._logFile,c.LogLevel.Info,Array.from(arguments))}warn(_,...P){this.getLevel()<=c.LogLevel.Warning&&this._proxy.$log(this._logFile,c.LogLevel.Warning,Array.from(arguments))}error(_,...P){this.getLevel()<=c.LogLevel.Error&&this._proxy.$log(this._logFile,c.LogLevel.Error,Array.from(arguments))}critical(_,...P){this.getLevel()<=c.LogLevel.Critical&&this._proxy.$log(this._logFile,c.LogLevel.Critical,Array.from(arguments))}flush(){}};F=We([ze(0,R.IExtHostRpcService),ze(1,b.IExtHostInitDataService)],F),e.ExtHostLogService=F}),define(we[212],Ee([0,1,14,22,21,16,3,6,109,179,38]),function(re,e,c,M,b,R,F,C,_,P,t){"use strict";var E;Object.defineProperty(e,"__esModule",{value:!0}),e.RPCProtocol=e.ResponsiveState=e.RequestInitiator=e.parseJsonAndRestoreBufferRefs=e.stringifyJsonWithBufferRefs=void 0;function n(g,D){try{return JSON.stringify(g,D)}catch(m){return"null"}}const f="$$ref$$",a={[f]:-1};class l{constructor(D,m){this.jsonString=D,this.referencedBuffers=m}}function w(g,D=null,m=!1){const A=[];return{jsonString:(m?n:JSON.stringify)(g,(V,G)=>{if(typeof G=="undefined")return a;if(typeof G=="object"){if(G instanceof M.VSBuffer){const U=A.push(G)-1;return{[f]:U}}if(D)return D(V,G)}return G}),referencedBuffers:A}}e.stringifyJsonWithBufferRefs=w;function I(g,D,m){return JSON.parse(g,(A,L)=>{if(L){const V=L[f];if(typeof V=="number")return D[V];if(m&&L.$mid===1)return m.transformIncoming(L)}return L})}e.parseJsonAndRestoreBufferRefs=I;function S(g,D){return JSON.stringify(g,D)}function o(g){return g?(D,m)=>m&&m.$mid===1?g.transformOutgoing(m):m:null}var h;(function(g){g[g.LocalSide=0]="LocalSide",g[g.OtherSide=1]="OtherSide"})(h=e.RequestInitiator||(e.RequestInitiator={}));var y;(function(g){g[g.Responsive=0]="Responsive",g[g.Unresponsive=1]="Unresponsive"})(y=e.ResponsiveState||(e.ResponsiveState={}));const i=()=>{},v=Symbol.for("rpcProtocol"),r=Symbol.for("rpcProxy");class s extends C.Disposable{constructor(D,m=null,A=null){super();this[E]=!0,this._onDidChangeResponsiveState=this._register(new F.Emitter),this.onDidChangeResponsiveState=this._onDidChangeResponsiveState.event,this._protocol=D,this._logger=m,this._uriTransformer=A,this._uriReplacer=o(this._uriTransformer),this._isDisposed=!1,this._locals=[],this._proxies=[];for(let L=0,V=t.ProxyIdentifier.count;L<V;L++)this._locals[L]=null,this._proxies[L]=null;this._lastMessageId=0,this._cancelInvokedHandlers=Object.create(null),this._pendingRPCReplies={},this._responsiveState=0,this._unacknowledgedCount=0,this._unresponsiveTime=0,this._asyncCheckUresponsive=this._register(new c.RunOnceScheduler(()=>this._checkUnresponsive(),1e3)),this._protocol.onMessage(L=>this._receiveOneMessage(L))}dispose(){this._isDisposed=!0,Object.keys(this._pendingRPCReplies).forEach(D=>{this._pendingRPCReplies[D].resolveErr(R.canceled())})}drain(){return typeof this._protocol.drain=="function"?this._protocol.drain():Promise.resolve()}_onWillSendRequest(D){this._unacknowledgedCount===0&&(this._unresponsiveTime=Date.now()+s.UNRESPONSIVE_TIME),this._unacknowledgedCount++,this._asyncCheckUresponsive.isScheduled()||this._asyncCheckUresponsive.schedule()}_onDidReceiveAcknowledge(D){this._unresponsiveTime=Date.now()+s.UNRESPONSIVE_TIME,this._unacknowledgedCount--,this._unacknowledgedCount===0&&this._asyncCheckUresponsive.cancel(),this._setResponsiveState(0)}_checkUnresponsive(){this._unacknowledgedCount!==0&&(Date.now()>this._unresponsiveTime?this._setResponsiveState(1):this._asyncCheckUresponsive.schedule())}_setResponsiveState(D){this._responsiveState!==D&&(this._responsiveState=D,this._onDidChangeResponsiveState.fire(this._responsiveState))}get responsiveState(){return this._responsiveState}transformIncomingURIs(D){return this._uriTransformer?(0,_.transformIncomingURIs)(D,this._uriTransformer):D}getProxy(D){const{nid:m,sid:A}=D;return this._proxies[m]||(this._proxies[m]=this._createProxy(m,A)),this._proxies[m]}_createProxy(D,m){let A={get:(L,V)=>(typeof V=="string"&&!L[V]&&V.charCodeAt(0)===36&&(L[V]=(...G)=>this._remoteCall(D,V,G)),V===r?m:L[V])};return new Proxy(Object.create(null),A)}set(D,m){return this._locals[D.nid]=m,m}assertRegistered(D){for(let m=0,A=D.length;m<A;m++){const L=D[m];if(!this._locals[L.nid])throw new Error(`Missing actor ${L.sid} (isMain: ${L.isMain})`)}}_receiveOneMessage(D){if(this._isDisposed)return;const m=D.byteLength,A=u.read(D,0),L=A.readUInt8(),V=A.readUInt32();switch(L){case 1:case 2:{let{rpcId:G,method:U,args:K}=p.deserializeRequestJSONArgs(A);this._uriTransformer&&(K=(0,_.transformIncomingURIs)(K,this._uriTransformer)),this._receiveRequest(m,V,G,U,K,L===2);break}case 3:case 4:{let{rpcId:G,method:U,args:K}=p.deserializeRequestMixedArgs(A);this._uriTransformer&&(K=(0,_.transformIncomingURIs)(K,this._uriTransformer)),this._receiveRequest(m,V,G,U,K,L===4);break}case 5:{this._logger&&this._logger.logIncoming(m,V,0,"ack"),this._onDidReceiveAcknowledge(V);break}case 6:{this._receiveCancel(m,V);break}case 7:{this._receiveReply(m,V,void 0);break}case 9:{let G=p.deserializeReplyOKJSON(A);this._uriTransformer&&(G=(0,_.transformIncomingURIs)(G,this._uriTransformer)),this._receiveReply(m,V,G);break}case 10:{const G=p.deserializeReplyOKJSONWithBuffers(A,this._uriTransformer);this._receiveReply(m,V,G);break}case 8:{let G=p.deserializeReplyOKVSBuffer(A);this._receiveReply(m,V,G);break}case 11:{let G=p.deserializeReplyErrError(A);this._uriTransformer&&(G=(0,_.transformIncomingURIs)(G,this._uriTransformer)),this._receiveReplyErr(m,V,G);break}case 12:{this._receiveReplyErr(m,V,void 0);break}default:console.error("received unexpected message"),console.error(D)}}_receiveRequest(D,m,A,L,V,G){this._logger&&this._logger.logIncoming(D,m,1,`receiveRequest ${(0,t.getStringIdentifierForProxy)(A)}.${L}(`,V);const U=String(m);let K,$;if(G){const z=new b.CancellationTokenSource;V.push(z.token),K=this._invokeHandler(A,L,V),$=()=>z.cancel()}else K=this._invokeHandler(A,L,V),$=i;this._cancelInvokedHandlers[U]=$;const B=p.serializeAcknowledged(m);this._logger&&this._logger.logOutgoing(B.byteLength,m,1,"ack"),this._protocol.send(B),K.then(z=>{delete this._cancelInvokedHandlers[U];const Y=p.serializeReplyOK(m,z,this._uriReplacer);this._logger&&this._logger.logOutgoing(Y.byteLength,m,1,"reply:",z),this._protocol.send(Y)},z=>{delete this._cancelInvokedHandlers[U];const Y=p.serializeReplyErr(m,z);this._logger&&this._logger.logOutgoing(Y.byteLength,m,1,"replyErr:",z),this._protocol.send(Y)})}_receiveCancel(D,m){this._logger&&this._logger.logIncoming(D,m,1,"receiveCancel");const A=String(m);this._cancelInvokedHandlers[A]&&this._cancelInvokedHandlers[A]()}_receiveReply(D,m,A){this._logger&&this._logger.logIncoming(D,m,0,"receiveReply:",A);const L=String(m);if(!this._pendingRPCReplies.hasOwnProperty(L))return;const V=this._pendingRPCReplies[L];delete this._pendingRPCReplies[L],V.resolveOk(A)}_receiveReplyErr(D,m,A){this._logger&&this._logger.logIncoming(D,m,0,"receiveReplyErr:",A);const L=String(m);if(!this._pendingRPCReplies.hasOwnProperty(L))return;const V=this._pendingRPCReplies[L];delete this._pendingRPCReplies[L];let G;A&&(A.$isError?(G=new Error,G.name=A.name,G.message=A.message,G.stack=A.stack):G=A),V.resolveErr(G)}_invokeHandler(D,m,A){try{return Promise.resolve(this._doInvokeHandler(D,m,A))}catch(L){return Promise.reject(L)}}_doInvokeHandler(D,m,A){const L=this._locals[D];if(!L)throw new Error("Unknown actor "+(0,t.getStringIdentifierForProxy)(D));let V=L[m];if(typeof V!="function")throw new Error("Unknown method "+m+" on actor "+(0,t.getStringIdentifierForProxy)(D));return V.apply(L,A)}_remoteCall(D,m,A){if(this._isDisposed)return Promise.reject(R.canceled());let L=null;if(A.length>0&&b.CancellationToken.isCancellationToken(A[A.length-1])&&(L=A.pop()),L&&L.isCancellationRequested)return Promise.reject(R.canceled());const V=p.serializeRequestArguments(A,this._uriReplacer),G=++this._lastMessageId,U=String(G),K=new P.LazyPromise;L&&L.onCancellationRequested(()=>{const B=p.serializeCancel(G);this._logger&&this._logger.logOutgoing(B.byteLength,G,0,"cancel"),this._protocol.send(p.serializeCancel(G))}),this._pendingRPCReplies[U]=K,this._onWillSendRequest(G);const $=p.serializeRequest(G,D,m,V,!!L);return this._logger&&this._logger.logOutgoing($.byteLength,G,0,`request: ${(0,t.getStringIdentifierForProxy)(D)}.${m}(`,A),this._protocol.send($),K}}e.RPCProtocol=s,E=v,s.UNRESPONSIVE_TIME=3*1e3;class u{constructor(D,m){this._buff=D,this._offset=m}static alloc(D,m,A){let L=new u(M.VSBuffer.alloc(A+1+4),0);return L.writeUInt8(D),L.writeUInt32(m),L}static read(D,m){return new u(D,m)}get buffer(){return this._buff}static sizeUInt8(){return 1}writeUInt8(D){this._buff.writeUInt8(D,this._offset),this._offset+=1}readUInt8(){const D=this._buff.readUInt8(this._offset);return this._offset+=1,D}writeUInt32(D){this._buff.writeUInt32BE(D,this._offset),this._offset+=4}readUInt32(){const D=this._buff.readUInt32BE(this._offset);return this._offset+=4,D}static sizeShortString(D){return 1+D.byteLength}writeShortString(D){this._buff.writeUInt8(D.byteLength,this._offset),this._offset+=1,this._buff.set(D,this._offset),this._offset+=D.byteLength}readShortString(){const D=this._buff.readUInt8(this._offset);this._offset+=1;const A=this._buff.slice(this._offset,this._offset+D).toString();return this._offset+=D,A}static sizeLongString(D){return 4+D.byteLength}writeLongString(D){this._buff.writeUInt32BE(D.byteLength,this._offset),this._offset+=4,this._buff.set(D,this._offset),this._offset+=D.byteLength}readLongString(){const D=this._buff.readUInt32BE(this._offset);this._offset+=4;const A=this._buff.slice(this._offset,this._offset+D).toString();return this._offset+=D,A}writeBuffer(D){this._buff.writeUInt32BE(D.byteLength,this._offset),this._offset+=4,this._buff.set(D,this._offset),this._offset+=D.byteLength}static sizeVSBuffer(D){return 4+D.byteLength}writeVSBuffer(D){this._buff.writeUInt32BE(D.byteLength,this._offset),this._offset+=4,this._buff.set(D,this._offset),this._offset+=D.byteLength}readVSBuffer(){const D=this._buff.readUInt32BE(this._offset);this._offset+=4;const m=this._buff.slice(this._offset,this._offset+D);return this._offset+=D,m}static sizeMixedArray(D){let m=0;m+=1;for(let A=0,L=D.length;A<L;A++){const V=D[A];switch(m+=1,V.type){case 1:m+=this.sizeLongString(V.value);break;case 2:m+=this.sizeVSBuffer(V.value);break;case 3:m+=this.sizeUInt32,m+=this.sizeLongString(V.value);for(let G=0;G<V.buffers.length;++G)m+=this.sizeVSBuffer(V.buffers[G]);break;case 4:break}}return m}writeMixedArray(D){this._buff.writeUInt8(D.length,this._offset),this._offset+=1;for(let m=0,A=D.length;m<A;m++){const L=D[m];switch(L.type){case 1:this.writeUInt8(1),this.writeLongString(L.value);break;case 2:this.writeUInt8(2),this.writeVSBuffer(L.value);break;case 3:this.writeUInt8(3),this.writeUInt32(L.buffers.length),this.writeLongString(L.value);for(let V=0;V<L.buffers.length;++V)this.writeBuffer(L.buffers[V]);break;case 4:this.writeUInt8(4);break}}}readMixedArray(){const D=this._buff.readUInt8(this._offset);this._offset+=1;let m=new Array(D);for(let A=0;A<D;A++)switch(this.readUInt8()){case 1:m[A]=this.readLongString();break;case 2:m[A]=this.readVSBuffer();break;case 3:const V=this.readUInt32(),G=this.readLongString(),U=[];for(let K=0;K<V;++K)U.push(this.readVSBuffer());m[A]=new t.SerializableObjectWithBuffers(I(G,U,null));break;case 4:m[A]=void 0;break}return m}}u.sizeUInt32=4;var d;(function(g){g[g.Simple=0]="Simple",g[g.Mixed=1]="Mixed"})(d||(d={}));class p{static _useMixedArgSerialization(D){for(let m=0,A=D.length;m<A;m++)if(D[m]instanceof M.VSBuffer||D[m]instanceof t.SerializableObjectWithBuffers||typeof D[m]=="undefined")return!0;return!1}static serializeRequestArguments(D,m){if(this._useMixedArgSerialization(D)){const A=[];for(let L=0,V=D.length;L<V;L++){const G=D[L];if(G instanceof M.VSBuffer)A[L]={type:2,value:G};else if(typeof G=="undefined")A[L]={type:4};else if(G instanceof t.SerializableObjectWithBuffers){const{jsonString:U,referencedBuffers:K}=w(G.value,m);A[L]={type:3,value:M.VSBuffer.fromString(U),buffers:K}}else A[L]={type:1,value:M.VSBuffer.fromString(S(G,m))}}return{type:1,args:A}}return{type:0,args:S(D,m)}}static serializeRequest(D,m,A,L,V){switch(L.type){case 0:return this._requestJSONArgs(D,m,A,L.args,V);case 1:return this._requestMixedArgs(D,m,A,L.args,V)}}static _requestJSONArgs(D,m,A,L,V){const G=M.VSBuffer.fromString(A),U=M.VSBuffer.fromString(L);let K=0;K+=u.sizeUInt8(),K+=u.sizeShortString(G),K+=u.sizeLongString(U);let $=u.alloc(V?2:1,D,K);return $.writeUInt8(m),$.writeShortString(G),$.writeLongString(U),$.buffer}static deserializeRequestJSONArgs(D){const m=D.readUInt8(),A=D.readShortString(),L=D.readLongString();return{rpcId:m,method:A,args:JSON.parse(L)}}static _requestMixedArgs(D,m,A,L,V){const G=M.VSBuffer.fromString(A);let U=0;U+=u.sizeUInt8(),U+=u.sizeShortString(G),U+=u.sizeMixedArray(L);let K=u.alloc(V?4:3,D,U);return K.writeUInt8(m),K.writeShortString(G),K.writeMixedArray(L),K.buffer}static deserializeRequestMixedArgs(D){const m=D.readUInt8(),A=D.readShortString(),L=D.readMixedArray(),V=new Array(L.length);for(let G=0,U=L.length;G<U;G++){const K=L[G];typeof K=="string"?V[G]=JSON.parse(K):V[G]=K}return{rpcId:m,method:A,args:V}}static serializeAcknowledged(D){return u.alloc(5,D,0).buffer}static serializeCancel(D){return u.alloc(6,D,0).buffer}static serializeReplyOK(D,m,A){if(typeof m=="undefined")return this._serializeReplyOKEmpty(D);if(m instanceof M.VSBuffer)return this._serializeReplyOKVSBuffer(D,m);if(m instanceof t.SerializableObjectWithBuffers){const{jsonString:L,referencedBuffers:V}=w(m.value,A,!0);return this._serializeReplyOKJSONWithBuffers(D,L,V)}else return this._serializeReplyOKJSON(D,n(m,A))}static _serializeReplyOKEmpty(D){return u.alloc(7,D,0).buffer}static _serializeReplyOKVSBuffer(D,m){let A=0;A+=u.sizeVSBuffer(m);let L=u.alloc(8,D,A);return L.writeVSBuffer(m),L.buffer}static deserializeReplyOKVSBuffer(D){return D.readVSBuffer()}static _serializeReplyOKJSON(D,m){const A=M.VSBuffer.fromString(m);let L=0;L+=u.sizeLongString(A);let V=u.alloc(9,D,L);return V.writeLongString(A),V.buffer}static _serializeReplyOKJSONWithBuffers(D,m,A){const L=M.VSBuffer.fromString(m);let V=0;V+=u.sizeUInt32,V+=u.sizeLongString(L);for(const U of A)V+=u.sizeVSBuffer(U);let G=u.alloc(10,D,V);G.writeUInt32(A.length),G.writeLongString(L);for(const U of A)G.writeBuffer(U);return G.buffer}static deserializeReplyOKJSON(D){const m=D.readLongString();return JSON.parse(m)}static deserializeReplyOKJSONWithBuffers(D,m){const A=D.readUInt32(),L=D.readLongString(),V=[];for(let G=0;G<A;++G)V.push(D.readVSBuffer());return new t.SerializableObjectWithBuffers(I(L,V,m))}static serializeReplyErr(D,m){return m?this._serializeReplyErrEror(D,m):this._serializeReplyErrEmpty(D)}static _serializeReplyErrEror(D,m){const A=M.VSBuffer.fromString(n(R.transformErrorForSerialization(m),null));let L=0;L+=u.sizeLongString(A);let V=u.alloc(11,D,L);return V.writeLongString(A),V.buffer}static deserializeReplyErrError(D){const m=D.readLongString();return JSON.parse(m)}static _serializeReplyErrEmpty(D){return u.alloc(12,D,0).buffer}}var k;(function(g){g[g.RequestJSONArgs=1]="RequestJSONArgs",g[g.RequestJSONArgsWithCancellation=2]="RequestJSONArgsWithCancellation",g[g.RequestMixedArgs=3]="RequestMixedArgs",g[g.RequestMixedArgsWithCancellation=4]="RequestMixedArgsWithCancellation",g[g.Acknowledged=5]="Acknowledged",g[g.Cancel=6]="Cancel",g[g.ReplyOKEmpty=7]="ReplyOKEmpty",g[g.ReplyOKVSBuffer=8]="ReplyOKVSBuffer",g[g.ReplyOKJSON=9]="ReplyOKJSON",g[g.ReplyOKJSONWithBuffers=10]="ReplyOKJSONWithBuffers",g[g.ReplyErrError=11]="ReplyErrError",g[g.ReplyErrEmpty=12]="ReplyErrEmpty"})(k||(k={}));var T;(function(g){g[g.String=1]="String",g[g.VSBuffer=2]="VSBuffer",g[g.SerializedObjectWithBuffers=3]="SerializedObjectWithBuffers",g[g.Undefined=4]="Undefined"})(T||(T={}))}),define(we[213],Ee([0,1]),function(re,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.NestedWorker=void 0;const c=function(R){const F=C=>{self.removeEventListener("message",F);const _=C.data;Object.defineProperties(self,{postMessage:{value(P,t){_.postMessage(P,t)}},onmessage:{get(){return _.onmessage},set(P){_.onmessage=P}}}),_.addEventListener("message",P=>{self.dispatchEvent(new MessageEvent("message",{data:P.data}))}),_.start(),self.Worker=class{constructor(){throw new TypeError("Nested workers from within nested worker are NOT supported.")}},importScripts(R)};self.addEventListener("message",F)}.toString();class M extends EventTarget{constructor(R,F,C){super();this.onmessage=null,this.onmessageerror=null,this.onerror=null;const _=`((${c})('${F}'))`,P=new Blob([_],{type:"application/javascript"}),t=URL.createObjectURL(P),E=new MessageChannel,n=t,f={type:"_newWorker",id:n,port:E.port2,url:t,options:C};R(f,[E.port2]),this.postMessage=E.port1.postMessage.bind(E.port1),this.terminate=()=>{const a={type:"_terminateWorker",id:n};E.port1.postMessage(a),URL.revokeObjectURL(t),E.port1.close(),E.port2.close()},Object.defineProperties(this,{onmessage:{get(){return E.port1.onmessage},set(a){E.port1.onmessage=a}},onmessageerror:{get(){return E.port1.onmessageerror},set(a){E.port1.onmessageerror=a}}}),E.port1.addEventListener("messageerror",a=>{const l=new MessageEvent("messageerror",{data:a.data});this.dispatchEvent(l)}),E.port1.addEventListener("message",a=>{const l=new MessageEvent("message",{data:a.data});this.dispatchEvent(l)}),E.port1.start()}}e.NestedWorker=M}),define(we[214],Ee([0,1,4]),function(re,e,c){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IRemoteAgentService=e.RemoteExtensionLogFileName=void 0,e.RemoteExtensionLogFileName="remoteagent",e.IRemoteAgentService=(0,c.createDecorator)("remoteAgentService")}),define(we[215],Ee([0,1,11,17,26,2,4,86,47,175,214]),function(re,e,c,M,b,R,F,C,_,P,t){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.AbstractPathService=e.IPathService=void 0,e.IPathService=(0,F.createDecorator)("pathService");let E=class $i{constructor(f,a,l,w){this.localUserHome=f,this.remoteAgentService=a,this.environmentService=l,this.contextService=w,this.resolveOS=(async()=>(await this.remoteAgentService.getEnvironment())?.os||b.OS)(),this.resolveUserHome=(async()=>{const I=await this.remoteAgentService.getEnvironment();return this.maybeUnresolvedUserHome=I?.userHome||f})()}get defaultUriScheme(){return $i.findDefaultUriScheme(this.environmentService,this.contextService)}static findDefaultUriScheme(f,a){if(f.remoteAuthority)return c.Schemas.vscodeRemote;const l=(0,C.getVirtualWorkspaceScheme)(a.getWorkspace());if(l)return l;const w=a.getWorkspace().folders[0];if(w)return w.uri.scheme;const I=a.getWorkspace().configuration;return I?I.scheme:c.Schemas.file}async userHome(f){return f?.preferLocal?this.localUserHome:this.resolveUserHome}get resolvedUserHome(){return this.maybeUnresolvedUserHome}get path(){return this.resolveOS.then(f=>f===1?M.win32:M.posix)}async fileURI(f){let a="";if(await this.resolveOS===1&&(f=f.replace(/\\/g,"/")),f[0]==="/"&&f[1]==="/"){const w=f.indexOf("/",2);w===-1?(a=f.substring(2),f="/"):(a=f.substring(2,w),f=f.substring(w)||"/")}return R.URI.from({scheme:c.Schemas.file,authority:a,path:f,query:"",fragment:""})}};E=We([ze(1,t.IRemoteAgentService),ze(2,P.IWorkbenchEnvironmentService),ze(3,_.IWorkspaceContextService)],E),e.AbstractPathService=E}),define(we[98],Ee([0,1]),function(re,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TextSearchCompleteMessageType=e.Range=e.Position=void 0;class c{constructor(F,C){this.line=F,this.character=C}isBefore(F){return!1}isBeforeOrEqual(F){return!1}isAfter(F){return!1}isAfterOrEqual(F){return!1}isEqual(F){return!1}compareTo(F){return 0}translate(F,C){return new c(0,0)}with(F){return new c(0,0)}}e.Position=c;class M{constructor(F,C,_,P){this.isEmpty=!1,this.isSingleLine=!1,this.start=new c(F,C),this.end=new c(_,P)}contains(F){return!1}isEqual(F){return!1}intersection(F){}union(F){return new M(0,0,0,0)}with(F){return new M(0,0,0,0)}}e.Range=M;var b;(function(R){R[R.Information=1]="Information",R[R.Warning=2]="Warning"})(b=e.TextSearchCompleteMessageType||(e.TextSearchCompleteMessageType={}))}),define(we[41],Ee([0,1,12,27,23,43,9,4,17,16,98,10]),function(re,e,c,M,b,R,F,C,_,P,t,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.QueryGlobTester=e.resolvePatternsForProvider=e.SerializableFileMatch=e.isFilePatternMatch=e.isSerializedFileMatch=e.isSerializedSearchSuccess=e.isSerializedSearchComplete=e.serializeSearchError=e.deserializeSearchError=e.SearchError=e.SearchErrorCode=e.pathIncludedInQuery=e.getExcludes=e.SearchSortOrder=e.OneLineRange=e.SearchRange=e.TextSearchMatch=e.FileMatch=e.SearchCompletionExitCode=e.isProgressMessage=e.isFileMatch=e.resultIsMatch=e.QueryType=e.SearchProviderType=e.ISearchService=e.SEARCH_EXCLUDE_CONFIG=e.VIEW_ID=e.PANEL_ID=e.VIEWLET_ID=e.TextSearchCompleteMessageType=void 0,Object.defineProperty(e,"TextSearchCompleteMessageType",{enumerable:!0,get:function(){return t.TextSearchCompleteMessageType}}),e.VIEWLET_ID="workbench.view.search",e.PANEL_ID="workbench.panel.search",e.VIEW_ID="workbench.view.search",e.SEARCH_EXCLUDE_CONFIG="search.exclude";const n="\u27EA ",f=" characters skipped \u27EB",a=(n.length+f.length+5)*2;e.ISearchService=(0,C.createDecorator)("searchService");var l;(function(B){B[B.file=0]="file",B[B.text=1]="text"})(l=e.SearchProviderType||(e.SearchProviderType={}));var w;(function(B){B[B.File=1]="File",B[B.Text=2]="Text"})(w=e.QueryType||(e.QueryType={}));function I(B){return!!B.preview}e.resultIsMatch=I;function S(B){return!!B.resource}e.isFileMatch=S;function o(B){return!!B.message}e.isProgressMessage=o;var h;(function(B){B[B.Normal=0]="Normal",B[B.NewSearchStarted=1]="NewSearchStarted"})(h=e.SearchCompletionExitCode||(e.SearchCompletionExitCode={}));class y{constructor(z){this.resource=z,this.results=[]}}e.FileMatch=y;class i{constructor(z,Y,ne){this.ranges=Y;const j=Array.isArray(Y)?Y:[Y];if(ne&&ne.matchLines===1&&v(j)){z=(0,F.getNLines)(z,ne.matchLines);let le="",oe=0,ve=0;const Re=Math.floor(ne.charsPerLine/5),Me=[];for(const Oe of j){const Ye=Math.max(Oe.startColumn-Re,0),Ve=Oe.startColumn+ne.charsPerLine;if(Ye>ve+Re+a){const qe=n+(Ye-ve)+f;le+=qe+z.slice(Ye,Ve),oe+=Ye-(ve+qe.length)}else le+=z.slice(ve,Ve);Me.push(new s(0,Oe.startColumn-oe,Oe.endColumn-oe)),ve=Ve}this.preview={text:le,matches:Array.isArray(this.ranges)?Me:Me[0]}}else{const le=Array.isArray(Y)?Y[0].startLineNumber:Y.startLineNumber;this.preview={text:z,matches:(0,c.mapArrayOrNot)(Y,oe=>new r(oe.startLineNumber-le,oe.startColumn,oe.endLineNumber-le,oe.endColumn))}}}}e.TextSearchMatch=i;function v(B){const z=B[0].startLineNumber;for(const Y of B)if(Y.startLineNumber!==z||Y.endLineNumber!==z)return!1;return!0}class r{constructor(z,Y,ne,j){this.startLineNumber=z,this.startColumn=Y,this.endLineNumber=ne,this.endColumn=j}}e.SearchRange=r;class s extends r{constructor(z,Y,ne){super(z,Y,z,ne)}}e.OneLineRange=s;var u;(function(B){B.Default="default",B.FileNames="fileNames",B.Type="type",B.Modified="modified",B.CountDescending="countDescending",B.CountAscending="countAscending"})(u=e.SearchSortOrder||(e.SearchSortOrder={}));function d(B,z=!0){const Y=B&&B.files&&B.files.exclude,ne=z&&B&&B.search&&B.search.exclude;if(!Y&&!ne)return;if(!Y||!ne)return Y||ne;let j=Object.create(null);return j=b.mixin(j,b.deepClone(Y)),j=b.mixin(j,b.deepClone(ne),!0),j}e.getExcludes=d;function p(B,z){return B.excludePattern&&M.match(B.excludePattern,z)?!1:B.includePattern||B.usingSearchPaths?B.includePattern&&M.match(B.includePattern,z)?!0:B.usingSearchPaths?!!B.folderQueries&&B.folderQueries.some(Y=>{const ne=Y.folder.fsPath;if(R.isEqualOrParent(z,ne)){const j=_.relative(ne,z);return!Y.includePattern||!!M.match(Y.includePattern,j)}else return!1}):!1:!0}e.pathIncludedInQuery=p;var k;(function(B){B[B.unknownEncoding=1]="unknownEncoding",B[B.regexParseError=2]="regexParseError",B[B.globParseError=3]="globParseError",B[B.invalidLiteral=4]="invalidLiteral",B[B.rgProcessError=5]="rgProcessError",B[B.other=6]="other",B[B.canceled=7]="canceled"})(k=e.SearchErrorCode||(e.SearchErrorCode={}));class T extends Error{constructor(z,Y){super(z);this.code=Y}}e.SearchError=T;function g(B){const z=B.message;if((0,P.isPromiseCanceledError)(B))return new T(z,k.canceled);try{const Y=JSON.parse(z);return new T(Y.message,Y.code)}catch(Y){return new T(z,k.other)}}e.deserializeSearchError=g;function D(B){const z={message:B.message,code:B.code};return new Error(JSON.stringify(z))}e.serializeSearchError=D;function m(B){return B.type==="error"?!0:B.type==="success"}e.isSerializedSearchComplete=m;function A(B){return B.type==="success"}e.isSerializedSearchSuccess=A;function L(B){return!!B.path}e.isSerializedFileMatch=L;function V(B,z){const Y=B.searchPath?B.searchPath:B.relativePath;return(0,F.fuzzyContains)(Y,z)}e.isFilePatternMatch=V;class G{constructor(z){this.path=z,this.results=[]}addMatch(z){this.results.push(z)}serialize(){return{path:this.path,results:this.results,numMatches:this.results.length}}}e.SerializableFileMatch=G;function U(B,z){const Y={...B||{},...z||{}};return Object.keys(Y).filter(ne=>{const j=Y[ne];return typeof j=="boolean"&&j})}e.resolvePatternsForProvider=U;class K{constructor(z,Y){this._parsedIncludeExpression=null,this._excludeExpression={...z.excludePattern||{},...Y.excludePattern||{}},this._parsedExcludeExpression=M.parse(this._excludeExpression);let ne=z.includePattern;Y.includePattern&&(ne?ne={...ne,...Y.includePattern}:ne=Y.includePattern),ne&&(this._parsedIncludeExpression=M.parse(ne))}includedInQuerySync(z,Y,ne){return!(this._parsedExcludeExpression&&this._parsedExcludeExpression(z,Y,ne)||this._parsedIncludeExpression&&!this._parsedIncludeExpression(z,Y,ne))}includedInQuery(z,Y,ne){const j=this._parsedExcludeExpression(z,Y,ne),le=()=>this._parsedIncludeExpression?!!this._parsedIncludeExpression(z,Y,ne):!0;return(0,E.isPromise)(j)?j.then(oe=>oe?!1:le()):le()}hasSiblingExcludeClauses(){return $(this._excludeExpression)}}e.QueryGlobTester=K;function $(B){for(const z in B)if(typeof B[z]!="boolean")return!0;return!1}}),define(we[31],Ee([0,1,12,14,21,3,20,11,75,24,9,10,2,130,4,15,145,47,37,29,13,7,41,5]),function(re,e,c,M,b,R,F,C,_,P,t,E,n,f,a,l,w,I,S,o,h,y,i,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExtHostWorkspace=e.ExtHostWorkspace=void 0;function r(D,m,A){return new P.ExtUri(L=>p(L,A)).isEqual(D,m)}function s(D,m,A){return r(D.uri,m.uri,A)?0:(0,t.compare)(D.uri.toString(),m.uri.toString())}function u(D,m,A){return D.index!==m.index?D.index<m.index?-1:1:r(D.uri,m.uri,A)?(0,t.compare)(D.name,m.name):(0,t.compare)(D.uri.toString(),m.uri.toString())}function d(D,m,A,L){const V=D.slice(0).sort((U,K)=>A(U,K,L)),G=m.slice(0).sort((U,K)=>A(U,K,L));return(0,c.delta)(V,G,(U,K)=>A(U,K,L))}function p(D,m){const A=m.getCapabilities(D.scheme);return!(A&&A&1024)}class k extends I.Workspace{constructor(m,A,L,V,G,U,K){super(m,L.map($=>new I.WorkspaceFolder($)),V,G,K);this._name=A,this._isUntitled=U,this._workspaceFolders=[],this._structure=F.TernarySearchTree.forUris(K),L.forEach($=>{this._workspaceFolders.push($),this._structure.set($.uri,$)})}static toExtHostWorkspace(m,A,L,V){if(!m)return{workspace:null,added:[],removed:[]};const{id:G,name:U,folders:K,configuration:$,transient:B,isUntitled:z}=m,Y=[],ne=A;A?K.forEach((ve,Re)=>{const Me=n.URI.revive(ve.uri),Oe=k._findFolder(L||A,Me,V);Oe?(Oe.name=ve.name,Oe.index=ve.index,Y.push(Oe)):Y.push({uri:Me,name:ve.name,index:Re})}):Y.push(...K.map(({uri:ve,name:Re,index:Me})=>({uri:n.URI.revive(ve),name:Re,index:Me}))),Y.sort((ve,Re)=>ve.index<Re.index?-1:1);const j=new k(G,U,Y,!!B,$?n.URI.revive($):null,!!z,ve=>p(ve,V)),{added:le,removed:oe}=d(ne?ne.workspaceFolders:[],j.workspaceFolders,s,V);return{workspace:j,added:le,removed:oe}}static _findFolder(m,A,L){for(let V=0;V<m.folders.length;V++){const G=m.workspaceFolders[V];if(r(G.uri,A,L))return G}}get name(){return this._name}get isUntitled(){return this._isUntitled}get workspaceFolders(){return this._workspaceFolders.slice(0)}getWorkspaceFolder(m,A){return A&&this._structure.get(m)&&(m=(0,P.dirname)(m)),this._structure.findSubstr(m)}resolveWorkspaceFolder(m){return this._structure.get(m)}}let T=class{constructor(m,A,L,V){this._onDidChangeWorkspace=new R.Emitter,this.onDidChangeWorkspace=this._onDidChangeWorkspace.event,this._onDidGrantWorkspaceTrust=new R.Emitter,this.onDidGrantWorkspaceTrust=this._onDidGrantWorkspaceTrust.event,this._activeSearchCallbacks=[],this._trusted=!1,this._logService=V,this._extHostFileSystemInfo=L,this._requestIdProvider=new _.Counter,this._barrier=new M.Barrier,this._proxy=m.getProxy(v.MainContext.MainThreadWorkspace),this._messageService=m.getProxy(v.MainContext.MainThreadMessageService);const G=A.workspace;this._confirmedWorkspace=G?new k(G.id,G.name,[],!!G.transient,G.configuration?n.URI.revive(G.configuration):null,!!G.isUntitled,U=>p(U,L)):void 0}$initializeWorkspace(m,A){this._trusted=A,this.$acceptWorkspaceData(m),this._barrier.open()}waitForInitializeCall(){return this._barrier.wait()}get workspace(){return this._actualWorkspace}get name(){return this._actualWorkspace?this._actualWorkspace.name:void 0}get workspaceFile(){if(this._actualWorkspace&&this._actualWorkspace.configuration)return this._actualWorkspace.isUntitled?n.URI.from({scheme:C.Schemas.untitled,path:(0,P.basename)((0,P.dirname)(this._actualWorkspace.configuration))}):this._actualWorkspace.configuration}get _actualWorkspace(){return this._unconfirmedWorkspace||this._confirmedWorkspace}getWorkspaceFolders(){if(!!this._actualWorkspace)return this._actualWorkspace.workspaceFolders.slice(0)}async getWorkspaceFolders2(){if(await this._barrier.wait(),!!this._actualWorkspace)return this._actualWorkspace.workspaceFolders.slice(0)}updateWorkspaceFolders(m,A,L,...V){const G=[];if(Array.isArray(V)&&V.forEach(z=>{n.URI.isUri(z.uri)&&!G.some(Y=>r(Y.uri,z.uri,this._extHostFileSystemInfo))&&G.push({uri:z.uri,name:z.name||(0,P.basenameOrAuthority)(z.uri)})}),this._unconfirmedWorkspace||[A,L].some(z=>typeof z!="number"||z<0)||L===0&&G.length===0)return!1;const U=this._actualWorkspace?this._actualWorkspace.workspaceFolders:[];if(A+L>U.length)return!1;const K=U.slice(0);K.splice(A,L,...G.map(z=>({uri:z.uri,name:z.name||(0,P.basenameOrAuthority)(z.uri),index:void 0})));for(let z=0;z<K.length;z++){const Y=K[z];if(K.some((ne,j)=>j!==z&&r(Y.uri,ne.uri,this._extHostFileSystemInfo)))return!1}K.forEach((z,Y)=>z.index=Y);const{added:$,removed:B}=d(U,K,u,this._extHostFileSystemInfo);if($.length===0&&B.length===0)return!1;if(this._proxy){const z=m.displayName||m.name;this._proxy.$updateWorkspaceFolders(z,A,L,G).then(void 0,Y=>{this._unconfirmedWorkspace=void 0,this._messageService.$showMessage(w.Severity.Error,(0,f.localize)(0,null,z,Y.toString()),{extension:m},[])})}return this.trySetWorkspaceFolders(K),!0}getWorkspaceFolder(m,A){if(!!this._actualWorkspace)return this._actualWorkspace.getWorkspaceFolder(m,A)}async getWorkspaceFolder2(m,A){if(await this._barrier.wait(),!!this._actualWorkspace)return this._actualWorkspace.getWorkspaceFolder(m,A)}async resolveWorkspaceFolder(m){if(await this._barrier.wait(),!!this._actualWorkspace)return this._actualWorkspace.resolveWorkspaceFolder(m)}getPath(){if(!this._actualWorkspace)return;const{folders:m}=this._actualWorkspace;if(m.length!==0)return m[0].uri.fsPath}getRelativePath(m,A){let L,V="";if(typeof m=="string"?(L=n.URI.file(m),V=m):typeof m!="undefined"&&(L=m,V=m.fsPath),!L)return V;const G=this.getWorkspaceFolder(L,!0);if(!G)return V;typeof A=="undefined"&&this._actualWorkspace&&(A=this._actualWorkspace.folders.length>1);let U=(0,P.relativePath)(G.uri,L);return A&&G.name&&(U=`${G.name}/${U}`),U}trySetWorkspaceFolders(m){this._actualWorkspace&&(this._unconfirmedWorkspace=k.toExtHostWorkspace({id:this._actualWorkspace.id,name:this._actualWorkspace.name,configuration:this._actualWorkspace.configuration,folders:m,isUntitled:this._actualWorkspace.isUntitled},this._actualWorkspace,void 0,this._extHostFileSystemInfo).workspace||void 0)}$acceptWorkspaceData(m){const{workspace:A,added:L,removed:V}=k.toExtHostWorkspace(m,this._confirmedWorkspace,this._unconfirmedWorkspace,this._extHostFileSystemInfo);this._confirmedWorkspace=A||void 0,this._unconfirmedWorkspace=void 0,this._onDidChangeWorkspace.fire(Object.freeze({added:L,removed:V}))}findFiles(m,A,L,V,G=b.CancellationToken.None){this._logService.trace(`extHostWorkspace#findFiles: fileSearch, extension: ${V.value}, entryPoint: findFiles`);let U;if(A===null?U=!1:A&&(typeof A=="string"?U=A:U=A.pattern),G&&G.isCancellationRequested)return Promise.resolve([]);const{includePattern:K,folder:$}=g(m);return this._proxy.$startFileSearch((0,E.withUndefinedAsNull)(K),(0,E.withUndefinedAsNull)($),(0,E.withUndefinedAsNull)(U),(0,E.withUndefinedAsNull)(L),G).then(B=>Array.isArray(B)?B.map(z=>n.URI.revive(z)):[])}async findTextInFiles(m,A,L,V,G=b.CancellationToken.None){this._logService.trace(`extHostWorkspace#findTextInFiles: textSearch, extension: ${V.value}, entryPoint: findTextInFiles`);const U=this._requestIdProvider.getNext(),K=typeof A.previewOptions=="undefined"?{matchLines:100,charsPerLine:1e4}:A.previewOptions,{includePattern:$,folder:B}=g(A.include),z=typeof A.exclude=="string"?A.exclude:A.exclude?A.exclude.pattern:void 0,Y={ignoreSymlinks:typeof A.followSymlinks=="boolean"?!A.followSymlinks:void 0,disregardIgnoreFiles:typeof A.useIgnoreFiles=="boolean"?!A.useIgnoreFiles:void 0,disregardGlobalIgnoreFiles:typeof A.useGlobalIgnoreFiles=="boolean"?!A.useGlobalIgnoreFiles:void 0,disregardExcludeSettings:typeof A.useDefaultExcludes=="boolean"?!A.useDefaultExcludes:!0,fileEncoding:A.encoding,maxResults:A.maxResults,previewOptions:K,afterContext:A.afterContext,beforeContext:A.beforeContext,includePattern:$,excludePattern:z},ne=!1;if(this._activeSearchCallbacks[U]=j=>{if(ne)return;const le=n.URI.revive(j.resource);j.results.forEach(oe=>{(0,i.resultIsMatch)(oe)?L({uri:le,preview:{text:oe.preview.text,matches:(0,c.mapArrayOrNot)(oe.preview.matches,ve=>new y.Range(ve.startLineNumber,ve.startColumn,ve.endLineNumber,ve.endColumn))},ranges:(0,c.mapArrayOrNot)(oe.ranges,ve=>new y.Range(ve.startLineNumber,ve.startColumn,ve.endLineNumber,ve.endColumn))}):L({uri:le,text:oe.text,lineNumber:oe.lineNumber})})},G.isCancellationRequested)return{};try{const j=await this._proxy.$startTextSearch(m,(0,E.withUndefinedAsNull)(B),Y,U,G);return delete this._activeSearchCallbacks[U],j||{}}catch(j){throw delete this._activeSearchCallbacks[U],j}}$handleTextSearchResult(m,A){this._activeSearchCallbacks[A]&&this._activeSearchCallbacks[A](m)}saveAll(m){return this._proxy.$saveAll(m)}resolveProxy(m){return this._proxy.$resolveProxy(m)}get trusted(){return this._trusted}requestWorkspaceTrust(m){return this._proxy.$requestWorkspaceTrust(m)}$onDidGrantWorkspaceTrust(){this._trusted||(this._trusted=!0,this._onDidGrantWorkspaceTrust.fire())}};T=We([ze(0,h.IExtHostRpcService),ze(1,o.IExtHostInitDataService),ze(2,S.IExtHostFileSystemInfo),ze(3,l.ILogService)],T),e.ExtHostWorkspace=T,e.IExtHostWorkspace=(0,a.createDecorator)("IExtHostWorkspace");function g(D){let m,A;return D&&(typeof D=="string"?m=D:(m=D.pattern,A=D.baseFolder||n.URI.file(D.base))),{includePattern:m,folder:A}}}),define(we[32],Ee([0,1,23,3,31,5,7,148,62,10,14,4,13,15,2]),function(re,e,c,M,b,R,F,C,_,P,t,E,n,f,a){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExtHostConfiguration=e.ExtHostConfigProvider=e.ExtHostConfiguration=void 0;function l(v,r){if(r){const s=r.split(".");let u=v;for(let d=0;u&&d<s.length;d++)u=u[s[d]];return u}}function w(v){return v instanceof a.URI}function I(v){return v&&v.uri instanceof a.URI&&v.languageId&&typeof v.languageId=="string"}function S(v){return v&&!v.uri&&v.languageId&&typeof v.languageId=="string"}function o(v){return v&&v.uri instanceof a.URI&&(!v.name||typeof v.name=="string")&&(!v.index||typeof v.index=="number")}function h(v){if(w(v))return{resource:v};if(I(v))return{resource:v.uri,overrideIdentifier:v.languageId};if(S(v))return{overrideIdentifier:v.languageId};if(o(v))return{resource:v.uri};if(v===null)return{resource:null}}let y=class{constructor(r,s,u){this._proxy=r.getProxy(R.MainContext.MainThreadConfiguration),this._extHostWorkspace=s,this._logService=u,this._barrier=new t.Barrier,this._actual=null}getConfigProvider(){return this._barrier.wait().then(r=>this._actual)}$initializeConfiguration(r){this._actual=new i(this._proxy,this._extHostWorkspace,r,this._logService),this._barrier.open()}$acceptConfigurationChanged(r,s){this.getConfigProvider().then(u=>u.$acceptConfigurationChanged(r,s))}};y=We([ze(0,n.IExtHostRpcService),ze(1,b.IExtHostWorkspace),ze(2,f.ILogService)],y),e.ExtHostConfiguration=y;class i{constructor(r,s,u,d){this._onDidChangeConfiguration=new M.Emitter,this._proxy=r,this._logService=d,this._extHostWorkspace=s,this._configuration=C.Configuration.parse(u),this._configurationScopes=this._toMap(u.configurationScopes)}get onDidChangeConfiguration(){return this._onDidChangeConfiguration&&this._onDidChangeConfiguration.event}$acceptConfigurationChanged(r,s){const u={data:this._configuration.toData(),workspace:this._extHostWorkspace.workspace};this._configuration=C.Configuration.parse(r),this._configurationScopes=this._toMap(r.configurationScopes),this._onDidChangeConfiguration.fire(this._toConfigurationChangeEvent(s,u))}getConfiguration(r,s,u){const d=h(s)||{},p=this._toReadonlyValue(r?l(this._configuration.getValue(void 0,d,this._extHostWorkspace.workspace),r):this._configuration.getValue(void 0,d,this._extHostWorkspace.workspace));r&&this._validateConfigurationAccess(r,d,u?.identifier);function k(g){if(g==null)return null;if(typeof g=="boolean")return g?1:4;switch(g){case F.ConfigurationTarget.Global:return 1;case F.ConfigurationTarget.Workspace:return 4;case F.ConfigurationTarget.WorkspaceFolder:return 5}}const T={has(g){return typeof l(p,g)!="undefined"},get:(g,D)=>{this._validateConfigurationAccess(r?`${r}.${g}`:g,d,u?.identifier);let m=l(p,g);if(typeof m=="undefined")m=D;else{let A;const L=(V,G)=>{let U;const K=()=>{A=A||(0,c.deepClone)(p),U=U||l(A,G)};return(0,P.isObject)(V)?new Proxy(V,{get:($,B)=>{if(typeof B=="string"&&B.toLowerCase()==="tojson")return K(),()=>U;if(A)return U=U||l(A,G),U[B];const z=$[B];return typeof B=="string"?L(z,`${G}.${B}`):z},set:($,B,z)=>(K(),U&&(U[B]=z),!0),deleteProperty:($,B)=>(K(),U&&delete U[B],!0),defineProperty:($,B,z)=>(K(),U&&Object.defineProperty(U,B,z),!0)}):V};m=L(m,g)}return m},update:(g,D,m,A)=>{g=r?`${r}.${g}`:g;const L=k(m);return D!==void 0?this._proxy.$updateConfigurationOption(L,g,D,d,A):this._proxy.$removeConfigurationOption(L,g,d,A)},inspect:g=>{g=r?`${r}.${g}`:g;const D=(0,c.deepClone)(this._configuration.inspect(g,d,this._extHostWorkspace.workspace));if(D)return{key:g,defaultValue:D.default?.value,globalValue:D.user?.value,workspaceValue:D.workspace?.value,workspaceFolderValue:D.workspaceFolder?.value,defaultLanguageValue:D.default?.override,globalLanguageValue:D.user?.override,workspaceLanguageValue:D.workspace?.override,workspaceFolderLanguageValue:D.workspaceFolder?.override,languageIds:D.overrideIdentifiers}}};return typeof p=="object"&&(0,c.mixin)(T,p,!1),Object.freeze(T)}_toReadonlyValue(r){const s=u=>(0,P.isObject)(u)?new Proxy(u,{get:(d,p)=>s(d[p]),set:(d,p,k)=>{throw new Error(`TypeError: Cannot assign to read only property '${String(p)}' of object`)},deleteProperty:(d,p)=>{throw new Error(`TypeError: Cannot delete read only property '${String(p)}' of object`)},defineProperty:(d,p)=>{throw new Error(`TypeError: Cannot define property '${String(p)}' for a readonly object`)},setPrototypeOf:d=>{throw new Error("TypeError: Cannot set prototype for a readonly object")},isExtensible:()=>!1,preventExtensions:()=>!0}):u;return s(r)}_validateConfigurationAccess(r,s,u){const d=_.OVERRIDE_PROPERTY_PATTERN.test(r)?4:this._configurationScopes.get(r),p=u?`[${u.value}] `:"";if(d===4){typeof s?.resource=="undefined"&&this._logService.warn(`${p}Accessing a resource scoped configuration without providing a resource is not expected. To get the effective value for '${r}', provide the URI of a resource or 'null' for any resource.`);return}if(d===3){s?.resource&&this._logService.warn(`${p}Accessing a window scoped configuration for a resource is not expected. To associate '${r}' to a resource, define its scope to 'resource' in configuration contributions in 'package.json'.`);return}}_toConfigurationChangeEvent(r,s){const u=new C.ConfigurationChangeEvent(r,s,this._configuration,this._extHostWorkspace.workspace);return Object.freeze({affectsConfiguration:(d,p)=>u.affectsConfiguration(d,h(p))})}_toMap(r){return r.reduce((s,u)=>(s.set(u[0],u[1]),s),new Map)}}e.ExtHostConfigProvider=i,e.IExtHostConfiguration=(0,E.createDecorator)("IExtHostConfiguration")});var Ze=this&&this.__classPrivateFieldSet||function(re,e,c,M,b){if(M==="m")throw new TypeError("Private method is not writable");if(M==="a"&&!b)throw new TypeError("Private accessor was defined without a setter");if(typeof e=="function"?re!==e||!b:!e.has(re))throw new TypeError("Cannot write private member to an object whose class did not declare it");return M==="a"?b.call(re,c):b?b.value=c:e.set(re,c),c},Ae=this&&this.__classPrivateFieldGet||function(re,e,c,M){if(c==="a"&&!M)throw new TypeError("Private accessor was defined without a getter");if(typeof e=="function"?re!==e||!M:!e.has(re))throw new TypeError("Cannot read private member from an object whose class did not declare it");return c==="m"?M:c==="a"?M.call(re):M?M.value:e.get(re)};define(we[99],Ee([0,1,2,14,3,5,7,31,49,32,21,40,13,29,4,11,26,15,70,165,16]),function(re,e,c,M,b,R,F,C,_,P,t,E,n,f,a,l,w,I,S,o,h){"use strict";var y;Object.defineProperty(e,"__esModule",{value:!0}),e.IExtHostTask=e.WorkerExtHostTask=e.ExtHostTaskBase=e.TaskExecutionDTO=e.TaskFilterDTO=e.TaskDTO=e.TaskGroupDTO=e.TaskHandleDTO=e.CustomExecutionDTO=e.ShellExecutionDTO=e.ShellExecutionOptionsDTO=e.ProcessExecutionDTO=e.ProcessExecutionOptionsDTO=e.TaskPresentationOptionsDTO=e.TaskDefinitionDTO=void 0;var i;(function(G){function U($){if($!=null)return $}G.from=U;function K($){if($!=null)return $}G.to=K})(i=e.TaskDefinitionDTO||(e.TaskDefinitionDTO={}));var v;(function(G){function U($){if($!=null)return $}G.from=U;function K($){if($!=null)return $}G.to=K})(v=e.TaskPresentationOptionsDTO||(e.TaskPresentationOptionsDTO={}));var r;(function(G){function U($){if($!=null)return $}G.from=U;function K($){if($!=null)return $}G.to=K})(r=e.ProcessExecutionOptionsDTO||(e.ProcessExecutionOptionsDTO={}));var s;(function(G){function U(B){if(B){const z=B;return z&&!!z.process}else return!1}G.is=U;function K(B){if(B==null)return;const z={process:B.process,args:B.args};return B.options&&(z.options=r.from(B.options)),z}G.from=K;function $(B){if(B!=null)return new F.ProcessExecution(B.process,B.args,B.options)}G.to=$})(s=e.ProcessExecutionDTO||(e.ProcessExecutionDTO={}));var u;(function(G){function U($){if($!=null)return $}G.from=U;function K($){if($!=null)return $}G.to=K})(u=e.ShellExecutionOptionsDTO||(e.ShellExecutionOptionsDTO={}));var d;(function(G){function U(B){if(B){const z=B;return z&&(!!z.commandLine||!!z.command)}else return!1}G.is=U;function K(B){if(B==null)return;const z={};return B.commandLine!==void 0?z.commandLine=B.commandLine:(z.command=B.command,z.args=B.args),B.options&&(z.options=u.from(B.options)),z}G.from=K;function $(B){if(!(B==null||B.command===void 0&&B.commandLine===void 0))return B.commandLine?new F.ShellExecution(B.commandLine,B.options):new F.ShellExecution(B.command,B.args?B.args:[],B.options)}G.to=$})(d=e.ShellExecutionDTO||(e.ShellExecutionDTO={}));var p;(function(G){function U(B){if(B){let z=B;return z&&z.customExecution==="customExecution"}else return!1}G.is=U;function K(B){return{customExecution:"customExecution"}}G.from=K;function $(B,z){return z.get(B)}G.to=$})(p=e.CustomExecutionDTO||(e.CustomExecutionDTO={}));var k;(function(G){function U(K,$){let B;return K.scope!==void 0&&typeof K.scope!="number"?B=K.scope.uri:K.scope!==void 0&&typeof K.scope=="number"&&(K.scope===F.TaskScope.Workspace&&$&&$.workspaceFile?B=$.workspaceFile:B=o.USER_TASKS_GROUP_KEY),{id:K._id,workspaceFolder:B}}G.from=U})(k=e.TaskHandleDTO||(e.TaskHandleDTO={}));var T;(function(G){function U(K){if(K!=null)return{_id:K.id,isDefault:K.isDefault}}G.from=U})(T=e.TaskGroupDTO||(e.TaskGroupDTO={}));var g;(function(G){function U(B,z){if(B==null)return[];const Y=[];for(let ne of B){const j=K(ne,z);j&&Y.push(j)}return Y}G.fromMany=U;function K(B,z){if(B==null)return;let Y;B.execution instanceof F.ProcessExecution?Y=s.from(B.execution):B.execution instanceof F.ShellExecution?Y=d.from(B.execution):B.execution&&B.execution instanceof F.CustomExecution&&(Y=p.from(B.execution));const ne=i.from(B.definition);let j;return B.scope?typeof B.scope=="number"?j=B.scope:j=B.scope.uri:j=F.TaskScope.Workspace,!ne||!j?void 0:{_id:B._id,definition:ne,name:B.name,source:{extensionId:z.identifier.value,label:B.source,scope:j},execution:Y,isBackground:B.isBackground,group:T.from(B.group),presentationOptions:v.from(B.presentationOptions),problemMatchers:B.problemMatchers,hasDefinedMatchers:B.hasDefinedMatchers,runOptions:B.runOptions?B.runOptions:{reevaluateOnRerun:!0},detail:B.detail}}G.from=K;async function $(B,z,Y){if(B==null)return;let ne;s.is(B.execution)?ne=s.to(B.execution):d.is(B.execution)?ne=d.to(B.execution):p.is(B.execution)&&(ne=p.to(B._id,Y));const j=i.to(B.definition);let le;if(B.source&&(B.source.scope!==void 0?typeof B.source.scope=="number"?le=B.source.scope:le=await z.resolveWorkspaceFolder(c.URI.revive(B.source.scope)):le=F.TaskScope.Workspace),!j||!le)return;const oe=new F.Task(j,le,B.name,B.source.label,ne,B.problemMatchers);return B.isBackground!==void 0&&(oe.isBackground=B.isBackground),B.group!==void 0&&(oe.group=F.TaskGroup.from(B.group._id),oe.group&&B.group.isDefault&&(oe.group=new F.TaskGroup(oe.group.id,oe.group.label),B.group.isDefault&&(oe.group.isDefault=B.group.isDefault))),B.presentationOptions&&(oe.presentationOptions=v.to(B.presentationOptions)),B._id&&(oe._id=B._id),B.detail&&(oe.detail=B.detail),oe}G.to=$})(g=e.TaskDTO||(e.TaskDTO={}));var D;(function(G){function U($){return $}G.from=U;function K($){if(!!$)return Object.assign(Object.create(null),$)}G.to=K})(D=e.TaskFilterDTO||(e.TaskFilterDTO={}));class m{constructor(U,K,$){this._id=K,this._task=$,y.set(this,void 0),Ze(this,y,U,"f")}get task(){return this._task}terminate(){Ae(this,y,"f").terminateTask(this)}fireDidStartProcess(U){}fireDidEndProcess(U){}}y=new WeakMap;var A;(function(G){function U(K){return{id:K._id,task:void 0}}G.from=U})(A=e.TaskExecutionDTO||(e.TaskExecutionDTO={}));let L=class{constructor(U,K,$,B,z,Y,ne,j){this._onDidExecuteTask=new b.Emitter,this._onDidTerminateTask=new b.Emitter,this._onDidTaskProcessStarted=new b.Emitter,this._onDidTaskProcessEnded=new b.Emitter,this._proxy=U.getProxy(R.MainContext.MainThreadTask),this._workspaceProvider=$,this._editorService=B,this._configurationService=z,this._terminalService=Y,this._handleCounter=0,this._handlers=new Map,this._taskExecutions=new Map,this._taskExecutionPromises=new Map,this._providedCustomExecutions2=new Map,this._notProvidedCustomExecutions=new Set,this._activeCustomExecutions2=new Map,this._logService=ne,this._deprecationService=j,this._proxy.$registerSupportedExecutions(!0)}registerTaskProvider(U,K,$){if(!$)return new F.Disposable(()=>{});const B=this.nextHandle();return this._handlers.set(B,{type:K,provider:$,extension:U}),this._proxy.$registerTaskProvider(B,K),new F.Disposable(()=>{this._handlers.delete(B),this._proxy.$unregisterTaskProvider(B)})}registerTaskSystem(U,K){this._proxy.$registerTaskSystem(U,K)}fetchTasks(U){return this._proxy.$fetchTasks(D.from(U)).then(async K=>{const $=[];for(let B of K){const z=await g.to(B,this._workspaceProvider,this._providedCustomExecutions2);z&&$.push(z)}return $})}get taskExecutions(){const U=[];return this._taskExecutions.forEach(K=>U.push(K)),U}terminateTask(U){if(!(U instanceof m))throw new Error("No valid task execution provided");return this._proxy.$terminateTask(U._id)}get onDidStartTask(){return this._onDidExecuteTask.event}async $onDidStartTask(U,K,$){const B=this._providedCustomExecutions2.get(U.id);if(B){if(this._activeCustomExecutions2.get(U.id)!==void 0)throw new Error("We should not be trying to start the same custom task executions twice.");this._activeCustomExecutions2.set(U.id,B),this._terminalService.attachPtyToTerminal(K,await B.callback($))}this._lastStartedTask=U.id,this._onDidExecuteTask.fire({execution:await this.getTaskExecution(U)})}get onDidEndTask(){return this._onDidTerminateTask.event}async $OnDidEndTask(U){const K=await this.getTaskExecution(U);this._taskExecutionPromises.delete(U.id),this._taskExecutions.delete(U.id),this.customExecutionComplete(U),this._onDidTerminateTask.fire({execution:K})}get onDidStartTaskProcess(){return this._onDidTaskProcessStarted.event}async $onDidStartTaskProcess(U){const K=await this.getTaskExecution(U.id);this._onDidTaskProcessStarted.fire({execution:K,processId:U.processId})}get onDidEndTaskProcess(){return this._onDidTaskProcessEnded.event}async $onDidEndTaskProcess(U){const K=await this.getTaskExecution(U.id);this._onDidTaskProcessEnded.fire({execution:K,exitCode:U.exitCode})}$provideTasks(U,K){const $=this._handlers.get(U);if(!$)return Promise.reject(new Error("no handler found"));const B=[],z=(0,M.asPromise)(()=>$.provider.provideTasks(t.CancellationToken.None)).then(Y=>this.provideTasksInternal(K,B,$,Y));return new Promise(Y=>{z.then(ne=>{Promise.all(B).then(()=>{Y(ne)})})})}async $resolveTask(U,K){const $=this._handlers.get(U);if(!$)return Promise.reject(new Error("no handler found"));if(K.definition.type!==$.type)throw new Error(`Unexpected: Task of type [${K.definition.type}] cannot be resolved by provider of type [${$.type}].`);const B=await g.to(K,this._workspaceProvider,this._providedCustomExecutions2);if(!B)throw new Error("Unexpected: Task cannot be resolved.");const z=await $.provider.resolveTask(B,t.CancellationToken.None);if(!z)return;this.checkDeprecation(z,$);const Y=g.from(z,$.extension);if(!Y)throw new Error("Unexpected: Task cannot be resolved.");if(z.definition!==B.definition)throw new Error("Unexpected: The resolved task definition must be the same object as the original task definition. The task definition cannot be changed.");return p.is(Y.execution)&&await this.addCustomExecution(Y,z,!0),await this.resolveTaskInternal(Y)}nextHandle(){return this._handleCounter++}async addCustomExecution(U,K,$){const B=await this._proxy.$createTaskId(U);!$&&!this._providedCustomExecutions2.has(B)&&this._notProvidedCustomExecutions.add(B),this._providedCustomExecutions2.set(B,K.execution)}async getTaskExecution(U,K){if(typeof U=="string"){const z=this._taskExecutionPromises.get(U);if(!z)throw new Error("Unexpected: The specified task is missing an execution");return z}let $=this._taskExecutionPromises.get(U.id);if($)return $;const B=new Promise(async(z,Y)=>{const ne=K||await g.to(U.task,this._workspaceProvider,this._providedCustomExecutions2);ne?z(new m(this,U.id,ne)):Y("Unexpected: Task does not exist.")});return this._taskExecutionPromises.set(U.id,B),B.then(z=>(this._taskExecutions.set(U.id,z),z),z=>Promise.reject(z))}checkDeprecation(U,K){U._deprecated&&this._deprecationService.report("Task.constructor",K.extension,"Use the Task constructor that takes a `scope` instead.")}customExecutionComplete(U){this._activeCustomExecutions2.get(U.id)&&this._activeCustomExecutions2.delete(U.id),this._notProvidedCustomExecutions.has(U.id)&&this._lastStartedTask!==U.id&&(this._providedCustomExecutions2.delete(U.id),this._notProvidedCustomExecutions.delete(U.id));let $=this._notProvidedCustomExecutions.values(),B=$.next();for(;!B.done;)!this._activeCustomExecutions2.has(B.value)&&this._lastStartedTask!==B.value&&(this._providedCustomExecutions2.delete(B.value),this._notProvidedCustomExecutions.delete(B.value)),B=$.next()}};L=We([ze(0,n.IExtHostRpcService),ze(1,f.IExtHostInitDataService),ze(2,C.IExtHostWorkspace),ze(3,_.IExtHostDocumentsAndEditors),ze(4,P.IExtHostConfiguration),ze(5,E.IExtHostTerminalService),ze(6,I.ILogService),ze(7,S.IExtHostApiDeprecationService)],L),e.ExtHostTaskBase=L;let V=class extends L{constructor(U,K,$,B,z,Y,ne,j){super(U,K,$,B,z,Y,ne,j);this.registerTaskSystem(l.Schemas.vscodeRemote,{scheme:l.Schemas.vscodeRemote,authority:"",platform:w.PlatformToString(0)})}async executeTask(U,K){if(!K.execution)throw new Error("Tasks to execute must include an execution");const $=g.from(K,U);if($===void 0)throw new Error("Task is not valid");if(p.is($.execution))await this.addCustomExecution($,K,!1);else throw new h.NotSupportedError;const B=await this.getTaskExecution(await this._proxy.$getTaskExecution($),K);return this._proxy.$executeTask($).catch(z=>{throw new Error(z)}),B}provideTasksInternal(U,K,$,B){const z=[];if(B)for(let Y of B){this.checkDeprecation(Y,$),(!Y.definition||!U[Y.definition.type])&&this._logService.warn(`The task [${Y.source}, ${Y.name}] uses an undefined task type. The task will be ignored in the future.`);const ne=g.from(Y,$.extension);ne&&p.is(ne.execution)?(z.push(ne),K.push(this.addCustomExecution(ne,Y,!0))):this._logService.warn("Only custom execution tasks supported.")}return{tasks:z,extension:$.extension}}async resolveTaskInternal(U){if(p.is(U.execution))return U;this._logService.warn("Only custom execution tasks supported.")}async $resolveVariables(U,K){return{process:void 0,variables:Object.create(null)}}async $jsonTasksSupported(){return!1}async $findExecutable(U,K,$){}};V=We([ze(0,n.IExtHostRpcService),ze(1,f.IExtHostInitDataService),ze(2,C.IExtHostWorkspace),ze(3,_.IExtHostDocumentsAndEditors),ze(4,P.IExtHostConfiguration),ze(5,E.IExtHostTerminalService),ze(6,I.ILogService),ze(7,S.IExtHostApiDeprecationService)],V),e.WorkerExtHostTask=V,e.IExtHostTask=(0,a.createDecorator)("IExtHostTask")}),define(we[216],Ee([0,1,12,51,27,77,20,11,17,24,9,10,2,111,134,84,47,92,215,41]),function(re,e,c,M,b,R,F,C,_,P,t,E,n,f,a,l,w,I,S,o){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.resolveResourcesForSearchIncludes=e.QueryBuilder=void 0;let h=class{constructor(k,T,g,D){this.configurationService=k,this.workspaceContextService=T,this.editorGroupsService=g,this.pathService=D}text(k,T,g={}){k=this.getContentPattern(k,g);const D=this.configurationService.getValue(),m=T&&T.some(L=>!this.configurationService.getValue({resource:L}).search.useRipgrep);return{...this.commonQuery(T?.map(w.toWorkspaceFolder),g),type:2,contentPattern:k,previewOptions:g.previewOptions,maxFileSize:g.maxFileSize,usePCRE2:D.search.usePCRE2||m||!1,beforeContext:g.beforeContext,afterContext:g.afterContext,userDisabledExcludesAndIgnoreFiles:g.disregardExcludeSettings&&g.disregardIgnoreFiles}}getContentPattern(k,T){const g=this.configurationService.getValue();k.isRegExp&&(k.pattern=k.pattern.replace(/\r?\n/g,"\\n"));const D={...k,wordSeparators:g.editor.wordSeparators};return this.isCaseSensitive(k,T)&&(D.isCaseSensitive=!0),this.isMultiline(k)&&(D.isMultiline=!0),D}file(k,T={}){return{...this.commonQuery(k,T),type:1,filePattern:T.filePattern?T.filePattern.trim():T.filePattern,exists:T.exists,sortByScore:T.sortByScore,cacheKey:T.cacheKey}}handleIncludeExclude(k,T){return k?(k=Array.isArray(k)?k.map(s):s(k),T?this.parseSearchPaths(k):{pattern:i(...Array.isArray(k)?k:[k])}):{}}commonQuery(k=[],T={}){const g=this.handleIncludeExclude(T.includePattern,T.expandPatterns),D=this.handleIncludeExclude(T.excludePattern,T.expandPatterns),m=k.length>1,A=(g.searchPaths&&g.searchPaths.length?g.searchPaths.map(G=>this.getFolderQueryForSearchPath(G,T,D)):k.map(G=>this.getFolderQueryForRoot(G,T,D,m))).filter(G=>!!G),L={_reason:T._reason,folderQueries:A,usingSearchPaths:!!(g.searchPaths&&g.searchPaths.length),extraFileResources:T.extraFileResources,excludePattern:D.pattern,includePattern:g.pattern,onlyOpenEditors:T.onlyOpenEditors,maxResults:T.maxResults};if(T.onlyOpenEditors){const U=c.coalesce(c.flatten(this.editorGroupsService.groups.map($=>$.editors.map(B=>B.resource)))).filter($=>(0,o.pathIncludedInQuery)(L,$.fsPath)),K=this.commonQueryFromFileList(U);return{...L,...K}}const V=T.extraFileResources&&T.extraFileResources.filter(G=>(0,o.pathIncludedInQuery)(L,G.fsPath));return L.extraFileResources=V&&V.length?V:void 0,L}commonQueryFromFileList(k){const T=[],g=new F.ResourceMap,D={};let m=!1;return k.forEach(A=>{if(A.scheme===C.Schemas.walkThrough)return;if((0,P.isAbsolutePath)(A)){const V=this.workspaceContextService.getWorkspaceFolder(A)?.uri??A.with({path:_.dirname(A.fsPath)});let G=g.get(V);G||(m=!0,G={folder:V,includePattern:{}},T.push(G),g.set(V,G));const U=_.relative(V.fsPath,A.fsPath);(0,E.assertIsDefined)(G.includePattern)[U.replace(/\\/g,"/")]=!0}else A.fsPath&&(m=!0,D[A.fsPath]=!0)}),{folderQueries:T,includePattern:D,usingSearchPaths:!0,excludePattern:m?void 0:{"**/*":!0}}}isCaseSensitive(k,T){if(T.isSmartCase){if(k.isRegExp){if(t.containsUppercaseCharacter(k.pattern,!0))return!0}else if(t.containsUppercaseCharacter(k.pattern))return!0}return!!k.isCaseSensitive}isMultiline(k){return k.isMultiline||k.isRegExp&&(0,f.isMultilineRegexSource)(k.pattern)||k.pattern.indexOf(`
`)>=0?!0:!!k.isMultiline}parseSearchPaths(k){const T=K=>_.isAbsolute(K)||/^\.\.?([\/\\]|$)/.test(K),D=(Array.isArray(k)?k:v(k)).map(K=>{const $=this.pathService.resolvedUserHome;return $?(0,R.untildify)(K,$.scheme===C.Schemas.file?$.fsPath:$.path):K}),m=M.groupBy(D,K=>T(K)?"searchPaths":"exprSegments"),A=(m.exprSegments||[]).map(K=>t.rtrim(K,"/")).map(K=>t.rtrim(K,"\\")).map(K=>(K[0]==="."&&(K="*"+K),r(K))),L={},V=this.expandSearchPathPatterns(m.searchPaths||[]);V&&V.length&&(L.searchPaths=V);const G=c.flatten(A),U=i(...G);return U&&(L.pattern=U),L}getExcludesForFolder(k,T){return T.disregardExcludeSettings?void 0:(0,o.getExcludes)(k,!T.disregardSearchExcludeSettings)}expandSearchPathPatterns(k){if(!k||!k.length)return[];const T=c.flatten(k.map(D=>{let{pathPortion:m,globPortion:A}=y(D);A&&(A=u(A));const L=this.expandOneSearchPath(m);return c.flatten(L.map(V=>this.resolveOneSearchPathPattern(V,A)))})),g=new Map;return T.forEach(D=>{const m=D.searchPath.toString(),A=g.get(m);A?D.pattern&&(A.pattern=A.pattern||{},A.pattern[D.pattern]=!0):g.set(m,{searchPath:D.searchPath,pattern:D.pattern?i(D.pattern):void 0})}),Array.from(g.values())}expandOneSearchPath(k){if(_.isAbsolute(k)){const T=this.workspaceContextService.getWorkspace().folders;return T[0]&&T[0].uri.scheme!==C.Schemas.file?[{searchPath:T[0].uri.with({path:k})}]:[{searchPath:n.URI.file(_.normalize(k))}]}if(this.workspaceContextService.getWorkbenchState()===2){const T=this.workspaceContextService.getWorkspace().folders[0].uri;if(k=s(k),k.startsWith("../")||k===".."){const D=_.posix.resolve(T.path,k);return[{searchPath:T.with({path:D})}]}const g=u(k);return[{searchPath:T,pattern:g}]}else{if(k==="./"||k===".\\")return[];{const T=k.replace(/^\.[\/\\]/,""),D=this.workspaceContextService.getWorkspace().folders.map(m=>{const A=T.match(new RegExp(`^${t.escapeRegExpCharacters(m.name)}(?:/(.*)|$)`));return A?{match:A,folder:m}:null}).filter(E.isDefined);if(D.length)return D.map(m=>{const A=m.match[1];return{searchPath:m.folder.uri,pattern:A&&u(A)}});{const m=k.match(/\.[\/\\](.+)[\/\\]?/),A=m?m[1]:k,L=a.localize(0,null,A);throw new Error(L)}}}}resolveOneSearchPathPattern(k,T){const g=k.pattern&&T?`${k.pattern}/${T}`:k.pattern||T,D=[{searchPath:k.searchPath,pattern:g}];return g&&!g.endsWith("**")&&D.push({searchPath:k.searchPath,pattern:g+"/**"}),D}getFolderQueryForSearchPath(k,T,g){const D=this.getFolderQueryForRoot((0,w.toWorkspaceFolder)(k.searchPath),T,g,!1);return D?{...D,includePattern:k.pattern}:null}getFolderQueryForRoot(k,T,g,D){let m;const A=n.URI.isUri(k)?k:k.uri;if(g.searchPaths){const K=g.searchPaths.filter($=>(0,P.isEqual)($.searchPath,A))[0];if(K&&!K.pattern)return null;K&&(m=K.pattern)}const L=this.configurationService.getValue({resource:A}),G={...this.getExcludesForFolder(L,T)||{},...m||{}},U=n.URI.isUri(k)?(0,P.basename)(k):k.name;return{folder:A,folderName:D?U:void 0,excludePattern:Object.keys(G).length>0?G:void 0,fileEncoding:L.files&&L.files.encoding,disregardIgnoreFiles:typeof T.disregardIgnoreFiles=="boolean"?T.disregardIgnoreFiles:!L.search.useIgnoreFiles,disregardGlobalIgnoreFiles:typeof T.disregardGlobalIgnoreFiles=="boolean"?T.disregardGlobalIgnoreFiles:!L.search.useGlobalIgnoreFiles,ignoreSymlinks:typeof T.ignoreSymlinks=="boolean"?T.ignoreSymlinks:!L.search.followSymlinks}}};h=We([ze(0,l.IConfigurationService),ze(1,w.IWorkspaceContextService),ze(2,I.IEditorGroupsService),ze(3,S.IPathService)],h),e.QueryBuilder=h;function y(p){const k=p.match(/[\*\{\}\(\)\[\]\?]/);if(k){const T=k.index,g=p.substr(0,T).match(/[/|\\][^/\\]*$/);if(g){let D=p.substr(0,g.index);return D.match(/[/\\]/)||(D+="/"),{pathPortion:D,globPortion:p.substr((g.index||0)+1)}}}return{pathPortion:p}}function i(...p){return p.length?p.reduce((k,T)=>(k[T]=!0,k),Object.create(null)):void 0}function v(p){return b.splitGlobAware(p,",").map(k=>k.trim()).filter(k=>!!k.length)}function r(p){return[`**/${p}/**`,`**/${p}`].map(T=>T.replace(/\*\*\/\*\*/g,"**"))}function s(p){return p.replace(/\\/g,"/")}function u(p){return s(p).replace(/^\.\//,"").replace(/\/+$/g,"")}function d(p,k){p=c.distinct(p,D=>D.toString());const T=[],g=k.getWorkspace();return p&&p.forEach(D=>{let m;if(k.getWorkbenchState()===2)m=(0,P.relativePath)(g.folders[0].uri,D),m&&m!=="."&&(m="./"+m);else{const A=k.getWorkspaceFolder(D);if(A){const L=A.name;if(g.folders.filter(G=>G.name===L).length===1){const G=(0,P.relativePath)(A.uri,D);G===""?m=`./${A.name}`:m=`./${A.name}/${G}`}else m=D.fsPath}}m&&T.push(m)}),T}e.resolveResourcesForSearchIncludes=d}),define(we[217],Ee([0,1,24,2,21,16,4,216,41,47]),function(re,e,c,M,b,R,F,C,_,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.checkGlobFileExists=e.checkActivateWorkspaceContainsExtension=void 0;const t=7e3;function E(l,w){const I=w.activationEvents;if(!I)return Promise.resolve(void 0);const S=[],o=[];for(const s of I)if(/^workspaceContains:/.test(s)){const u=s.substr("workspaceContains:".length);u.indexOf("*")>=0||u.indexOf("?")>=0||l.forceUsingSearch?o.push(u):S.push(u)}if(S.length===0&&o.length===0)return Promise.resolve(void 0);let h;const y=new Promise((s,u)=>{h=s}),i=s=>h({activationEvent:s}),v=Promise.all(S.map(s=>n(l,s,i))).then(()=>{}),r=f(l,w.identifier,o,i);return Promise.all([v,r]).then(()=>{h(void 0)}),y}e.checkActivateWorkspaceContainsExtension=E;async function n(l,w,I){for(const S of l.folders)if(await l.exists(c.joinPath(M.URI.revive(S),w))){I(`workspaceContains:${w}`);return}}async function f(l,w,I,S){if(I.length===0)return Promise.resolve(void 0);const o=new b.CancellationTokenSource,h=l.checkExists(l.folders,I,o.token),y=setTimeout(async()=>{o.cancel(),S(`workspaceContainsTimeout:${I.join(",")}`)},t);let i=!1;try{i=await h}catch(v){R.isPromiseCanceledError(v)||R.onUnexpectedError(v)}o.dispose(),clearTimeout(y),i&&S(`workspaceContains:${I.join(",")}`)}function a(l,w,I,S){const o=l.get(F.IInstantiationService),h=l.get(_.ISearchService),i=o.createInstance(C.QueryBuilder).file(w.map(v=>(0,P.toWorkspaceFolder)(M.URI.revive(v))),{_reason:"checkExists",includePattern:I,exists:!0});return h.fileSearch(i,S).then(v=>!!v.limitHit,v=>R.isPromiseCanceledError(v)?!1:Promise.reject(v))}e.checkGlobFileExists=a});var Ze=this&&this.__classPrivateFieldSet||function(re,e,c,M,b){if(M==="m")throw new TypeError("Private method is not writable");if(M==="a"&&!b)throw new TypeError("Private accessor was defined without a setter");if(typeof e=="function"?re!==e||!b:!e.has(re))throw new TypeError("Cannot write private member to an object whose class did not declare it");return M==="a"?b.call(re,c):b?b.value=c:e.set(re,c),c},Ae=this&&this.__classPrivateFieldGet||function(re,e,c,M){if(c==="a"&&!M)throw new TypeError("Private accessor was defined without a getter");if(typeof e=="function"?re!==e||!M:!e.has(re))throw new TypeError("Cannot read private member from an object whose class did not declare it");return c==="m"?M:c==="a"?M.call(re):M?M.value:e.get(re)};define(we[33],Ee([0,1,125,17,74,24,14,6,20,2,15,5,32,178,72,31,30,176,16,25,22,152,7,85,4,29,73,13,61,64,40,3,217,69,154]),function(re,e,c,M,b,R,F,C,_,P,t,E,n,f,a,l,w,I,S,o,h,y,i,v,r,s,u,d,p,k,T,g,D,m,A){"use strict";var L,V,G;Object.defineProperty(e,"__esModule",{value:!0}),e.Extension=e.IExtHostExtensionService=e.AbstractExtHostExtensionService=e.IHostUtils=void 0,e.IHostUtils=(0,r.createDecorator)("IHostUtils");let U=class Wi extends C.Disposable{constructor(z,Y,ne,j,le,oe,ve,Re,Me,Oe){super();this._onDidChangeRemoteConnectionData=this._register(new g.Emitter),this.onDidChangeRemoteConnectionData=this._onDidChangeRemoteConnectionData.event,this._hostUtils=Y,this._extHostContext=ne,this._initData=ve,this._extHostWorkspace=j,this._extHostConfiguration=le,this._logService=oe,this._extHostTunnelService=Me,this._extHostTerminalService=Oe,this._disposables=new C.DisposableStore,this._mainThreadWorkspaceProxy=this._extHostContext.getProxy(E.MainContext.MainThreadWorkspace),this._mainThreadTelemetryProxy=this._extHostContext.getProxy(E.MainContext.MainThreadTelemetry),this._mainThreadExtensionsProxy=this._extHostContext.getProxy(E.MainContext.MainThreadExtensionService),this._almostReadyToRunExtensions=new F.Barrier,this._readyToStartExtensionHost=new F.Barrier,this._readyToRunExtensions=new F.Barrier,this._eagerExtensionsActivated=new F.Barrier,this._registry=new I.ExtensionDescriptionRegistry(this._initData.extensions),this._storage=new a.ExtHostStorage(this._extHostContext),this._secretState=new m.ExtHostSecretState(this._extHostContext),this._storagePath=Re,this._instaService=z.createChild(new p.ServiceCollection([a.IExtHostStorage,this._storage],[m.IExtHostSecretState,this._secretState]));const Ye=new Set;this._initData.hostExtensions.forEach(Ve=>Ye.add(o.ExtensionIdentifier.toKey(Ve))),this._activator=new f.ExtensionsActivator(this._registry,this._initData.resolvedExtensions,this._initData.hostExtensions,{onExtensionActivationError:(Ve,qe,x)=>{this._mainThreadExtensionsProxy.$onExtensionActivationError(Ve,S.transformErrorForSerialization(qe),x)},actualActivateExtension:async(Ve,qe)=>{if(Ye.has(o.ExtensionIdentifier.toKey(Ve)))return await this._mainThreadExtensionsProxy.$activateExtension(Ve,qe),new f.HostExtension;const x=this._registry.getExtensionDescription(Ve);return this._activateExtension(x,qe)}},this._logService),this._extensionPathIndex=null,this._resolvers=Object.create(null),this._started=!1,this._remoteConnectionData=this._initData.remote.connectionData}getRemoteConnectionData(){return this._remoteConnectionData}async initialize(){try{await this._beforeAlmostReadyToRunExtensions(),this._almostReadyToRunExtensions.open(),await this._extHostWorkspace.waitForInitializeCall(),b.mark("code/extHost/ready"),this._readyToStartExtensionHost.open(),this._initData.autoStart&&this._startExtensionHost()}catch(z){S.onUnexpectedError(z)}}async deactivateAll(){this._storagePath.onWillDeactivateAll();let z=[];try{z=this._registry.getAllExtensionDescriptions().map(le=>le.identifier).filter(le=>this.isActivated(le)).map(le=>this._deactivate(le))}catch(Y){}await Promise.all(z)}isActivated(z){return this._readyToRunExtensions.isOpen()?this._activator.isActivated(z):!1}_activateByEvent(z,Y){return this._activator.activateByEvent(z,Y)}_activateById(z,Y){return this._activator.activateById(z,Y)}activateByIdWithErrors(z,Y){return this._activateById(z,Y).then(()=>{const ne=this._activator.getActivatedExtension(z);if(ne.activationFailed)return Promise.reject(ne.activationFailedError)})}getExtensionRegistry(){return this._readyToRunExtensions.wait().then(z=>this._registry)}getExtensionExports(z){return this._readyToRunExtensions.isOpen()?this._activator.getActivatedExtension(z).exports:null}getExtensionPathIndex(){if(!this._extensionPathIndex){const z=_.TernarySearchTree.forPaths(),Y=this._registry.getAllExtensionDescriptions().map(ne=>{if(!!this._getEntryPoint(ne))return this._hostUtils.realpath(ne.extensionLocation.fsPath).then(j=>z.set(P.URI.file(j).fsPath,ne))});this._extensionPathIndex=Promise.all(Y).then(()=>z)}return this._extensionPathIndex}_deactivate(z){let Y=Promise.resolve(void 0);if(!this._readyToRunExtensions.isOpen()||!this._activator.isActivated(z))return Y;const ne=this._activator.getActivatedExtension(z);if(!ne)return Y;try{typeof ne.module.deactivate=="function"&&(Y=Promise.resolve(ne.module.deactivate()).then(void 0,j=>(this._logService.error(j),Promise.resolve(void 0))))}catch(j){this._logService.error(j)}try{(0,C.dispose)(ne.subscriptions)}catch(j){this._logService.error(j)}return Y}async _activateExtension(z,Y){return this._initData.remote.isRemote?this._mainThreadExtensionsProxy.$onWillActivateExtension(z.identifier):await this._mainThreadExtensionsProxy.$onWillActivateExtension(z.identifier),this._doActivateExtension(z,Y).then(ne=>{const j=ne.activationTimes;return this._mainThreadExtensionsProxy.$onDidActivateExtension(z.identifier,j.codeLoadingTime,j.activateCallTime,j.activateResolvedTime,Y),this._logExtensionActivationTimes(z,Y,"success",j),ne},ne=>{throw this._logExtensionActivationTimes(z,Y,"failure"),ne})}_logExtensionActivationTimes(z,Y,ne,j){const le=K(z,Y);this._mainThreadTelemetryProxy.$publicLog2("extensionActivationTimes",{...le,...j||{},outcome:ne})}_doActivateExtension(z,Y){const ne=K(z,Y);this._mainThreadTelemetryProxy.$publicLog2("activatePlugin",ne);const j=this._getEntryPoint(z);if(!j)return Promise.resolve(new f.EmptyExtension(f.ExtensionActivationTimes.NONE));this._logService.info(`ExtensionService#_doActivateExtension ${z.identifier.value} ${JSON.stringify(Y)}`),this._logService.flush();const le=new f.ExtensionActivationTimesBuilder(Y.startup);return Promise.all([this._loadCommonJSModule(z.identifier,(0,R.joinPath)(z.extensionLocation,j),le),this._loadExtensionContext(z)]).then(oe=>(b.mark(`code/extHost/willActivateExtension/${z.identifier.value}`),Wi._callActivate(this._logService,z.identifier,oe[0],oe[1],le))).then(oe=>(b.mark(`code/extHost/didActivateExtension/${z.identifier.value}`),oe))}_loadExtensionContext(z){const Y=new y.ExtensionGlobalMemento(z,this._storage),ne=new y.ExtensionMemento(z.identifier.value,!1,this._storage),j=new A.ExtensionSecrets(z,this._secretState),le=z.isUnderDevelopment?this._initData.environment.extensionTestsLocationURI?i.ExtensionMode.Test:i.ExtensionMode.Development:i.ExtensionMode.Production,oe=this._initData.remote.isRemote?i.ExtensionKind.Workspace:i.ExtensionKind.UI;return this._logService.trace(`ExtensionService#loadExtensionContext ${z.identifier.value}`),Promise.all([Y.whenReady,ne.whenReady,this._storagePath.whenReady]).then(()=>{const ve=this;let Re;return Object.freeze({globalState:Y,workspaceState:ne,secrets:j,subscriptions:[],get extensionUri(){return z.extensionLocation},get extensionPath(){return z.extensionLocation.fsPath},asAbsolutePath(Me){return M.join(z.extensionLocation.fsPath,Me)},get storagePath(){return ve._storagePath.workspaceValue(z)?.fsPath},get globalStoragePath(){return ve._storagePath.globalValue(z).fsPath},get logPath(){return M.join(ve._initData.logsLocation.fsPath,z.identifier.value)},get logUri(){return P.URI.joinPath(ve._initData.logsLocation,z.identifier.value)},get storageUri(){return ve._storagePath.workspaceValue(z)},get globalStorageUri(){return ve._storagePath.globalValue(z)},get extensionMode(){return le},get extension(){return Re===void 0&&(Re=new $(ve,z.identifier,z,oe)),Re},get extensionRuntime(){return(0,w.checkProposedApiEnabled)(z),ve.extensionRuntime},get environmentVariableCollection(){return ve._extHostTerminalService.getEnvironmentVariableCollection(z)}})})}static _callActivate(z,Y,ne,j,le){return ne=ne||{activate:void 0,deactivate:void 0},this._callActivateOptional(z,Y,ne,j,le).then(oe=>new f.ActivatedExtension(!1,null,le.build(),ne,oe,j.subscriptions))}static _callActivateOptional(z,Y,ne,j,le){if(typeof ne.activate=="function")try{le.activateCallStart(),z.trace(`ExtensionService#_callActivateOptional ${Y.value}`);const oe=typeof global=="object"?global:self,ve=ne.activate.apply(oe,[j]);return le.activateCallStop(),le.activateResolveStart(),Promise.resolve(ve).then(Re=>(le.activateResolveStop(),Re))}catch(oe){return Promise.reject(oe)}else return Promise.resolve(ne)}_activateOneStartupFinished(z,Y){this._activateById(z.identifier,{startup:!1,extensionId:z.identifier,activationEvent:Y}).then(void 0,ne=>{this._logService.error(ne)})}_activateAllStartupFinished(){this._mainThreadExtensionsProxy.$setPerformanceMarks(b.getMarks());for(const z of this._registry.getAllExtensionDescriptions())if(z.activationEvents)for(const Y of z.activationEvents)Y==="onStartupFinished"&&this._activateOneStartupFinished(z,Y)}_handleEagerExtensions(){const z=this._activateByEvent("*",!0).then(void 0,le=>{this._logService.error(le)});this._disposables.add(this._extHostWorkspace.onDidChangeWorkspace(le=>this._handleWorkspaceContainsEagerExtensions(le.added)));const Y=this._extHostWorkspace.workspace?this._extHostWorkspace.workspace.folders:[],ne=this._handleWorkspaceContainsEagerExtensions(Y),j=Promise.all([z,ne]).then(()=>{});return Promise.race([j,(0,F.timeout)(1e4)]).then(()=>{this._activateAllStartupFinished()}),j}_handleWorkspaceContainsEagerExtensions(z){return z.length===0?Promise.resolve(void 0):Promise.all(this._registry.getAllExtensionDescriptions().map(Y=>this._handleWorkspaceContainsEagerExtension(z,Y))).then(()=>{})}async _handleWorkspaceContainsEagerExtension(z,Y){if(this.isActivated(Y.identifier))return;const ne=!this._initData.remote.isRemote&&!!this._initData.remote.authority,j={folders:z.map(oe=>oe.uri),forceUsingSearch:ne,exists:oe=>this._hostUtils.exists(oe.fsPath),checkExists:(oe,ve,Re)=>this._mainThreadWorkspaceProxy.$checkExists(oe,ve,Re)},le=await(0,D.checkActivateWorkspaceContainsExtension)(j,Y);if(!!le)return this._activateById(Y.identifier,{startup:!0,extensionId:Y.identifier,activationEvent:le.activationEvent}).then(void 0,oe=>this._logService.error(oe))}async $extensionTestsExecute(){await this._eagerExtensionsActivated.wait();try{return await this._doHandleExtensionTests()}catch(z){throw console.error(z),z}}async _doHandleExtensionTests(){const{extensionDevelopmentLocationURI:z,extensionTestsLocationURI:Y}=this._initData.environment;if(!z||!Y)throw new Error(c.localize(0,null));const ne=await this._loadCommonJSModule(null,Y,new f.ExtensionActivationTimesBuilder(!1));if(!ne||typeof ne.run!="function")throw new Error(c.localize(1,null,Y.toString()));return new Promise((j,le)=>{const oe=(Me,Oe)=>{Me?le(Me):j(typeof Oe=="number"&&Oe>0?1:0)},ve=(0,R.originalFSPath)(Y),Re=ne.run(ve,oe);Re&&Re.then&&Re.then(()=>{j(0)}).catch(Me=>{le(Me.toString())})})}async $extensionTestsExit(z){this._logService.info(`extension host terminating: test runner requested exit with code ${z}`),this._logService.info(`exiting with code ${z}`),this._logService.flush(),this._hostUtils.exit(z)}_startExtensionHost(){if(this._started)throw new Error("Extension host is already started!");return this._started=!0,this._readyToStartExtensionHost.wait().then(()=>this._readyToRunExtensions.open()).then(()=>this._handleEagerExtensions()).then(()=>{this._eagerExtensionsActivated.open(),this._logService.info("eager extensions activated")})}registerRemoteAuthorityResolver(z,Y){return this._resolvers[z]=Y,(0,C.toDisposable)(()=>{delete this._resolvers[z]})}async _activateAndGetResolver(z){const Y=z.indexOf("+");if(Y===-1)throw new Error("Not an authority that can be resolved!");const ne=z.substr(0,Y);return await this._almostReadyToRunExtensions.wait(),await this._activateByEvent(`onResolveRemoteAuthority:${ne}`,!1),{authorityPrefix:ne,resolver:this._resolvers[ne]}}async $resolveAuthority(z,Y){const{authorityPrefix:ne,resolver:j}=await this._activateAndGetResolver(z);if(!j)return{type:"error",error:{code:v.RemoteAuthorityResolverErrorCode.NoResolverFound,message:`No remote extension installed to resolve ${ne}.`,detail:void 0}};try{this._disposables.add(await this._extHostTunnelService.setTunnelExtensionFunctions(j)),b.mark(`code/extHost/willResolveAuthority/${ne}`);const le=await j.resolve(z,{resolveAttempt:Y});b.mark(`code/extHost/didResolveAuthorityOK/${ne}`);const oe={authority:z,host:le.host,port:le.port,connectionToken:le.connectionToken},ve={extensionHostEnv:le.extensionHostEnv,isTrusted:le.isTrusted};return{type:"ok",value:{authority:oe,options:ve,tunnelInformation:{environmentTunnels:le.environmentTunnels}}}}catch(le){if(b.mark(`code/extHost/didResolveAuthorityError/${ne}`),le instanceof i.RemoteAuthorityResolverError)return{type:"error",error:{code:le._code,message:le._message,detail:le._detail}};throw le}}async $getCanonicalURI(z,Y){const{authorityPrefix:ne,resolver:j}=await this._activateAndGetResolver(z);if(!j)throw new Error(`Cannot get canonical URI because no remote extension is installed to resolve ${ne}`);const le=P.URI.revive(Y);if(typeof j.getCanonicalURI=="undefined")return le;const oe=await(0,F.asPromise)(()=>j.getCanonicalURI(le));return oe||le}$startExtensionHost(z){return this._registry.keepOnly(z),this._startExtensionHost()}$activateByEvent(z,Y){return Y===1?this._activateByEvent(z,!1):this._readyToRunExtensions.wait().then(ne=>this._activateByEvent(z,!1))}async $activate(z,Y){return await this._readyToRunExtensions.wait(),this._registry.getExtensionDescription(z)?(await this._activateById(z,Y),!0):!1}async $deltaExtensions(z,Y){z.forEach(j=>j.extensionLocation=P.URI.revive(j.extensionLocation));const ne=await this.getExtensionPathIndex();return await Promise.all(Y.map(async j=>{const le=this._registry.getExtensionDescription(j);if(!le)return;const oe=await this._hostUtils.realpath(le.extensionLocation.fsPath);ne.delete(P.URI.file(oe).fsPath)})),await Promise.all(z.map(async j=>{const le=await this._hostUtils.realpath(j.extensionLocation.fsPath);ne.set(P.URI.file(le).fsPath,j)})),this._registry.deltaExtensions(z,Y),Promise.resolve(void 0)}async $test_latency(z){return z}async $test_up(z){return z.byteLength}async $test_down(z){let Y=h.VSBuffer.alloc(z),ne=Math.random()%256;for(let j=0;j<z;j++)Y.writeUInt8(ne,j);return Y}async $updateRemoteConnectionData(z){this._remoteConnectionData=z,this._onDidChangeRemoteConnectionData.fire()}};U=We([ze(0,r.IInstantiationService),ze(1,e.IHostUtils),ze(2,d.IExtHostRpcService),ze(3,l.IExtHostWorkspace),ze(4,n.IExtHostConfiguration),ze(5,t.ILogService),ze(6,s.IExtHostInitDataService),ze(7,u.IExtensionStoragePaths),ze(8,k.IExtHostTunnelService),ze(9,T.IExtHostTerminalService)],U),e.AbstractExtHostExtensionService=U;function K(B,z){return{id:B.identifier.value,name:B.name,extensionVersion:B.version,publisherDisplayName:B.publisher,activationEvents:B.activationEvents?B.activationEvents.join(","):null,isBuiltin:B.isBuiltin,reason:z.activationEvent,reasonId:z.extensionId.value}}e.IExtHostExtensionService=(0,r.createDecorator)("IExtHostExtensionService");class ${constructor(z,Y,ne,j){L.set(this,void 0),V.set(this,void 0),G.set(this,void 0),Ze(this,L,z,"f"),Ze(this,V,Y,"f"),Ze(this,G,ne.identifier,"f"),this.id=ne.identifier.value,this.extensionUri=ne.extensionLocation,this.extensionPath=M.normalize((0,R.originalFSPath)(ne.extensionLocation)),this.packageJSON=ne,this.extensionKind=j}get isActive(){return Ae(this,L,"f").isActivated(Ae(this,G,"f"))}get exports(){if(this.packageJSON.api!=="none")return Ae(this,L,"f").getExtensionExports(Ae(this,G,"f"))}activate(){return Ae(this,L,"f").activateByIdWithErrors(Ae(this,G,"f"),{startup:!1,extensionId:Ae(this,V,"f"),activationEvent:"api"}).then(()=>this.exports)}}e.Extension=$,L=new WeakMap,V=new WeakMap,G=new WeakMap}),define(we[100],Ee([0,1,17,2,3,14,5,7,162,31,33,49,167,32,163,13,4,10,91,68]),function(re,e,c,M,b,R,F,C,_,P,t,E,n,f,a,l,w,I,S,o){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.WorkerExtHostDebugService=e.ExtHostVariableResolverService=e.ExtHostDebugConsole=e.ExtHostDebugSession=e.ExtHostDebugServiceBase=e.IExtHostDebugService=void 0,e.IExtHostDebugService=(0,w.createDecorator)("IExtHostDebugService");let h=class{constructor(p,k,T,g,D,m){this._workspaceService=k,this._extensionService=T,this._editorsService=g,this._configurationService=D,this._editorTabs=m,this._debugSessions=new Map,this._configProviderHandleCounter=0,this._configProviders=[],this._adapterFactoryHandleCounter=0,this._adapterFactories=[],this._trackerFactoryHandleCounter=0,this._trackerFactories=[],this._debugAdapters=new Map,this._debugAdaptersTrackers=new Map,this._onDidStartDebugSession=new b.Emitter,this._onDidTerminateDebugSession=new b.Emitter,this._onDidChangeActiveDebugSession=new b.Emitter,this._onDidReceiveDebugSessionCustomEvent=new b.Emitter,this._debugServiceProxy=p.getProxy(F.MainContext.MainThreadDebugService),this._onDidChangeBreakpoints=new b.Emitter({onFirstListenerAdd:()=>{this.startBreakpoints()}}),this._activeDebugConsole=new i(this._debugServiceProxy),this._breakpoints=new Map,this._breakpointEventsActive=!1,this._extensionService.getExtensionRegistry().then(A=>{A.onDidChange(L=>{this.registerAllDebugTypes(A)}),this.registerAllDebugTypes(A)})}get onDidStartDebugSession(){return this._onDidStartDebugSession.event}get onDidTerminateDebugSession(){return this._onDidTerminateDebugSession.event}get onDidChangeActiveDebugSession(){return this._onDidChangeActiveDebugSession.event}get activeDebugSession(){return this._activeDebugSession}get onDidReceiveDebugSessionCustomEvent(){return this._onDidReceiveDebugSessionCustomEvent.event}get activeDebugConsole(){return this._activeDebugConsole.value}asDebugSourceUri(p,k){const T=p;if(typeof T.sourceReference=="number"&&T.sourceReference>0){let g=`debug:${encodeURIComponent(T.path||"")}`,D="?";return k&&(g+=`${D}session=${encodeURIComponent(k.id)}`,D="&"),g+=`${D}ref=${T.sourceReference}`,M.URI.parse(g)}else{if(T.path)return M.URI.file(T.path);throw new Error("cannot create uri from DAP 'source' object; properties 'path' and 'sourceReference' are both missing.")}}registerAllDebugTypes(p){const k=[];for(const T of p.getAllExtensionDescriptions())if(T.contributes){const g=T.contributes.debuggers;if(g&&g.length>0)for(const D of g)(0,a.isDebuggerMainContribution)(D)&&k.push(D.type)}this._debugServiceProxy.$registerDebugTypes(k)}get onDidChangeBreakpoints(){return this._onDidChangeBreakpoints.event}get breakpoints(){this.startBreakpoints();const p=[];return this._breakpoints.forEach(k=>p.push(k)),p}addBreakpoints(p){this.startBreakpoints();const k=p.filter(D=>{const m=D.id;return this._breakpoints.has(m)?!1:(this._breakpoints.set(m,D),!0)});this.fireBreakpointChanges(k,[],[]);const T=[],g=new Map;for(const D of k)if(D instanceof C.SourceBreakpoint){let m=g.get(D.location.uri.toString());m||(m={type:"sourceMulti",uri:D.location.uri,lines:[]},g.set(D.location.uri.toString(),m),T.push(m)),m.lines.push({id:D.id,enabled:D.enabled,condition:D.condition,hitCondition:D.hitCondition,logMessage:D.logMessage,line:D.location.range.start.line,character:D.location.range.start.character})}else D instanceof C.FunctionBreakpoint&&T.push({type:"function",id:D.id,enabled:D.enabled,hitCondition:D.hitCondition,logMessage:D.logMessage,condition:D.condition,functionName:D.functionName});return this._debugServiceProxy.$registerBreakpoints(T)}removeBreakpoints(p){this.startBreakpoints();const k=p.filter(m=>this._breakpoints.delete(m.id));this.fireBreakpointChanges([],k,[]);const T=k.filter(m=>m instanceof C.SourceBreakpoint).map(m=>m.id),g=k.filter(m=>m instanceof C.FunctionBreakpoint).map(m=>m.id),D=k.filter(m=>m instanceof C.DataBreakpoint).map(m=>m.id);return this._debugServiceProxy.$unregisterBreakpoints(T,g,D)}startDebugging(p,k,T){return this._debugServiceProxy.$startDebugging(p?p.uri:void 0,k,{parentSessionID:T.parentSession?T.parentSession.id:void 0,lifecycleManagedByParent:T.lifecycleManagedByParent,repl:T.consoleMode===C.DebugConsoleMode.MergeWithParent?"mergeWithParent":"separate",noDebug:T.noDebug,compact:T.compact,debugUI:T.debugUI,suppressSaveBeforeStart:T.suppressSaveBeforeStart})}stopDebugging(p){return this._debugServiceProxy.$stopDebugging(p?p.id:void 0)}registerDebugConfigurationProvider(p,k,T){if(!k)return new C.Disposable(()=>{});const g=this._configProviderHandleCounter++;return this._configProviders.push({type:p,handle:g,provider:k}),this._debugServiceProxy.$registerDebugConfigurationProvider(p,T,!!k.provideDebugConfigurations,!!k.resolveDebugConfiguration,!!k.resolveDebugConfigurationWithSubstitutedVariables,g),new C.Disposable(()=>{this._configProviders=this._configProviders.filter(D=>D.provider!==k),this._debugServiceProxy.$unregisterDebugConfigurationProvider(g)})}registerDebugAdapterDescriptorFactory(p,k,T){if(!T)return new C.Disposable(()=>{});if(!this.definesDebugType(p,k))throw new Error(`a DebugAdapterDescriptorFactory can only be registered from the extension that defines the '${k}' debugger.`);if(this.getAdapterDescriptorFactoryByType(k))throw new Error("a DebugAdapterDescriptorFactory can only be registered once per a type.");const g=this._adapterFactoryHandleCounter++;return this._adapterFactories.push({type:k,handle:g,factory:T}),this._debugServiceProxy.$registerDebugAdapterDescriptorFactory(k,g),new C.Disposable(()=>{this._adapterFactories=this._adapterFactories.filter(D=>D.factory!==T),this._debugServiceProxy.$unregisterDebugAdapterDescriptorFactory(g)})}registerDebugAdapterTrackerFactory(p,k){if(!k)return new C.Disposable(()=>{});const T=this._trackerFactoryHandleCounter++;return this._trackerFactories.push({type:p,handle:T,factory:k}),new C.Disposable(()=>{this._trackerFactories=this._trackerFactories.filter(g=>g.factory!==k)})}async $runInTerminal(p,k){return Promise.resolve(void 0)}async $substituteVariables(p,k){if(!this._variableResolver){const[D,m]=await Promise.all([this._workspaceService.getWorkspaceFolders2(),this._configurationService.getConfigProvider()]);this._variableResolver=this.createVariableResolver(D||[],this._editorsService,m)}let T;const g=await this.getFolder(p);return g&&(T={uri:g.uri,name:g.name,index:g.index,toResource:()=>{throw new Error("Not implemented")}}),this._variableResolver.resolveAnyAsync(T,k)}createDebugAdapter(p,k){if(p.type==="implementation")return new s(p.implementation)}createSignService(){}async $startDASession(p,k){const T=this,g=await this.getSession(k);return this.getAdapterDescriptor(this.getAdapterDescriptorFactoryByType(g.type),g).then(D=>{if(!D)throw new Error(`Couldn't find a debug adapter descriptor for debug type '${g.type}' (extension might have failed to activate)`);const m=this.convertToDto(D),A=this.createDebugAdapter(m,g);if(!A)throw new Error(`Couldn't create a debug adapter for type '${g.type}'.`);const L=A;return this._debugAdapters.set(p,L),this.getDebugAdapterTrackers(g).then(V=>(V&&this._debugAdaptersTrackers.set(p,V),L.onMessage(async G=>{if(G.type==="request"&&G.command==="handshake"){const U=G,K={type:"response",seq:0,command:U.command,request_seq:U.seq,success:!0};this._signService||(this._signService=this.createSignService());try{if(this._signService){const $=await this._signService.sign(U.arguments.value);K.body={signature:$},L.sendResponse(K)}else throw new Error("no signer")}catch($){K.success=!1,K.message=$.message,L.sendResponse(K)}}else V&&V.onDidSendMessage&&V.onDidSendMessage(G),G=(0,a.convertToVSCPaths)(G,!0),T._debugServiceProxy.$acceptDAMessage(p,G)}),L.onError(G=>{V&&V.onError&&V.onError(G),this._debugServiceProxy.$acceptDAError(p,G.name,G.message,G.stack)}),L.onExit(G=>{V&&V.onExit&&V.onExit((0,I.withNullAsUndefined)(G),void 0),this._debugServiceProxy.$acceptDAExit(p,(0,I.withNullAsUndefined)(G),void 0)}),V&&V.onWillStartSession&&V.onWillStartSession(),L.startSession()))})}$sendDAMessage(p,k){k=(0,a.convertToDAPaths)(k,!1);const T=this._debugAdaptersTrackers.get(p);T&&T.onWillReceiveMessage&&T.onWillReceiveMessage(k);const g=this._debugAdapters.get(p);g&&g.sendMessage(k)}$stopDASession(p){const k=this._debugAdaptersTrackers.get(p);this._debugAdaptersTrackers.delete(p),k&&k.onWillStopSession&&k.onWillStopSession();const T=this._debugAdapters.get(p);return this._debugAdapters.delete(p),T?T.stopSession():Promise.resolve(void 0)}$acceptBreakpointsDelta(p){const k=[],T=[],g=[];if(p.added)for(const D of p.added){const m=D.id;if(m&&!this._breakpoints.has(m)){let A;if(D.type==="function")A=new C.FunctionBreakpoint(D.functionName,D.enabled,D.condition,D.hitCondition,D.logMessage);else if(D.type==="data")A=new C.DataBreakpoint(D.label,D.dataId,D.canPersist,D.enabled,D.hitCondition,D.condition,D.logMessage);else{const L=M.URI.revive(D.uri);A=new C.SourceBreakpoint(new C.Location(L,new C.Position(D.line,D.character)),D.enabled,D.condition,D.hitCondition,D.logMessage)}A._id=m,this._breakpoints.set(m,A),k.push(A)}}if(p.removed)for(const D of p.removed){const m=this._breakpoints.get(D);m&&(this._breakpoints.delete(D),T.push(m))}if(p.changed){for(const D of p.changed)if(D.id){const m=this._breakpoints.get(D.id);if(m){if(m instanceof C.FunctionBreakpoint&&D.type==="function"){const A=m;A.enabled=D.enabled,A.condition=D.condition,A.hitCondition=D.hitCondition,A.logMessage=D.logMessage,A.functionName=D.functionName}else if(m instanceof C.SourceBreakpoint&&D.type==="source"){const A=m;A.enabled=D.enabled,A.condition=D.condition,A.hitCondition=D.hitCondition,A.logMessage=D.logMessage,A.location=new C.Location(M.URI.revive(D.uri),new C.Position(D.line,D.character))}g.push(m)}}}this.fireBreakpointChanges(k,T,g)}$provideDebugConfigurations(p,k,T){return(0,R.asPromise)(async()=>{const g=this.getConfigProviderByHandle(p);if(!g)throw new Error("no DebugConfigurationProvider found");if(!g.provideDebugConfigurations)throw new Error("DebugConfigurationProvider has no method provideDebugConfigurations");const D=await this.getFolder(k);return g.provideDebugConfigurations(D,T)}).then(g=>{if(!g)throw new Error("nothing returned from DebugConfigurationProvider.provideDebugConfigurations");return g})}$resolveDebugConfiguration(p,k,T,g){return(0,R.asPromise)(async()=>{const D=this.getConfigProviderByHandle(p);if(!D)throw new Error("no DebugConfigurationProvider found");if(!D.resolveDebugConfiguration)throw new Error("DebugConfigurationProvider has no method resolveDebugConfiguration");const m=await this.getFolder(k);return D.resolveDebugConfiguration(m,T,g)})}$resolveDebugConfigurationWithSubstitutedVariables(p,k,T,g){return(0,R.asPromise)(async()=>{const D=this.getConfigProviderByHandle(p);if(!D)throw new Error("no DebugConfigurationProvider found");if(!D.resolveDebugConfigurationWithSubstitutedVariables)throw new Error("DebugConfigurationProvider has no method resolveDebugConfigurationWithSubstitutedVariables");const m=await this.getFolder(k);return D.resolveDebugConfigurationWithSubstitutedVariables(m,T,g)})}async $provideDebugAdapter(p,k){const T=this.getAdapterDescriptorFactoryByHandle(p);if(!T)return Promise.reject(new Error("no adapter descriptor factory found for handle"));const g=await this.getSession(k);return this.getAdapterDescriptor(T,g).then(D=>{if(!D)throw new Error(`Couldn't find a debug adapter descriptor for debug type '${g.type}'`);return this.convertToDto(D)})}async $acceptDebugSessionStarted(p){const k=await this.getSession(p);this._onDidStartDebugSession.fire(k)}async $acceptDebugSessionTerminated(p){const k=await this.getSession(p);k&&(this._onDidTerminateDebugSession.fire(k),this._debugSessions.delete(k.id))}async $acceptDebugSessionActiveChanged(p){this._activeDebugSession=p?await this.getSession(p):void 0,this._onDidChangeActiveDebugSession.fire(this._activeDebugSession)}async $acceptDebugSessionNameChanged(p,k){const T=await this.getSession(p);T&&T._acceptNameChanged(k)}async $acceptDebugSessionCustomEvent(p,k){const g={session:await this.getSession(p),event:k.event,body:k.body};this._onDidReceiveDebugSessionCustomEvent.fire(g)}convertToDto(p){if(p instanceof C.DebugAdapterExecutable)return{type:"executable",command:p.command,args:p.args,options:p.options};if(p instanceof C.DebugAdapterServer)return{type:"server",port:p.port,host:p.host};if(p instanceof C.DebugAdapterNamedPipeServer)return{type:"pipeServer",path:p.path};if(p instanceof C.DebugAdapterInlineImplementation)return{type:"implementation",implementation:p.implementation};throw new Error("convertToDto unexpected type")}getAdapterDescriptorFactoryByType(p){const k=this._adapterFactories.filter(T=>T.type===p);if(k.length>0)return k[0].factory}getAdapterDescriptorFactoryByHandle(p){const k=this._adapterFactories.filter(T=>T.handle===p);if(k.length>0)return k[0].factory}getConfigProviderByHandle(p){const k=this._configProviders.filter(T=>T.handle===p);if(k.length>0)return k[0].provider}definesDebugType(p,k){if(p.contributes){const T=p.contributes.debuggers;if(T&&T.length>0){for(const g of T)if(g.label&&g.type&&g.type===k)return!0}}return!1}getDebugAdapterTrackers(p){const T=p.configuration.type,g=this._trackerFactories.filter(D=>D.type===T||D.type==="*").map(D=>(0,R.asPromise)(()=>D.factory.createDebugAdapterTracker(p)).then(m=>m,m=>null));return Promise.race([Promise.all(g).then(D=>{const m=D.filter(A=>!!A);if(m.length>0)return new r(m)}),new Promise((D,m)=>{const A=setTimeout(()=>{clearTimeout(A),m(new Error("timeout"))},1e3)})]).catch(D=>{})}async getAdapterDescriptor(p,k){const T=k.configuration.debugServer;if(typeof T=="number")return Promise.resolve(new C.DebugAdapterServer(T));if(p){const D=await this._extensionService.getExtensionRegistry();return(0,R.asPromise)(()=>p.createDebugAdapterDescriptor(k,this.daExecutableFromPackage(k,D))).then(m=>{if(m)return m})}const g=await this._extensionService.getExtensionRegistry();return Promise.resolve(this.daExecutableFromPackage(k,g))}daExecutableFromPackage(p,k){}startBreakpoints(){this._breakpointEventsActive||(this._breakpointEventsActive=!0,this._debugServiceProxy.$startBreakpointEvents())}fireBreakpointChanges(p,k,T){(p.length>0||k.length>0||T.length>0)&&this._onDidChangeBreakpoints.fire(Object.freeze({added:p,removed:k,changed:T}))}async getSession(p){if(p)if(typeof p=="string"){const k=this._debugSessions.get(p);if(k)return k}else{let k=this._debugSessions.get(p.id);if(!k){const T=await this.getFolder(p.folderUri),g=p.parent?this._debugSessions.get(p.parent):void 0;k=new y(this._debugServiceProxy,p.id,p.type,p.name,T,p.configuration,g),this._debugSessions.set(k.id,k),this._debugServiceProxy.$sessionCached(k.id)}return k}throw new Error("cannot find session")}getFolder(p){if(p){const k=M.URI.revive(p);return this._workspaceService.resolveWorkspaceFolder(k)}return Promise.resolve(void 0)}};h=We([ze(0,l.IExtHostRpcService),ze(1,P.IExtHostWorkspace),ze(2,t.IExtHostExtensionService),ze(3,E.IExtHostDocumentsAndEditors),ze(4,f.IExtHostConfiguration),ze(5,o.IExtHostEditorTabs)],h),e.ExtHostDebugServiceBase=h;class y{constructor(p,k,T,g,D,m,A){this._debugServiceProxy=p,this._id=k,this._type=T,this._name=g,this._workspaceFolder=D,this._configuration=m,this._parentSession=A}get id(){return this._id}get type(){return this._type}get name(){return this._name}set name(p){this._name=p,this._debugServiceProxy.$setDebugSessionName(this._id,p)}get parentSession(){return this._parentSession}_acceptNameChanged(p){this._name=p}get workspaceFolder(){return this._workspaceFolder}get configuration(){return this._configuration}customRequest(p,k){return this._debugServiceProxy.$customDebugAdapterRequest(this._id,p,k)}getDebugProtocolBreakpoint(p){return this._debugServiceProxy.$getDebugProtocolBreakpoint(this._id,p.id)}}e.ExtHostDebugSession=y;class i{constructor(p){this.value=Object.freeze({append(k){p.$appendDebugConsole(k)},appendLine(k){this.append(k+`
`)}})}}e.ExtHostDebugConsole=i;class v extends n.AbstractVariableResolverService{constructor(p,k,T,g,D){function m(){if(k){const A=k.activeEditor();if(A)return A.document.uri;const L=g.tabs.filter(V=>V.isActive);if(L.length>0){const V=L[0].resource;return V&&(V.primary||V.secondary)?V.primary??V.secondary:L[0].resource}}}super({getFolderUri:A=>{const L=p.filter(V=>V.name===A);if(L&&L.length>0)return L[0].uri},getWorkspaceFolderCount:()=>p.length,getConfigurationValue:(A,L)=>T.getConfiguration(void 0,A).get(L),getAppRoot:()=>S.cwd(),getExecPath:()=>S.env.VSCODE_EXEC_PATH,getFilePath:()=>{const A=m();if(A)return c.normalize(A.fsPath)},getWorkspaceFolderPathForFile:()=>{if(D){const A=m();if(A){const L=D.getWorkspaceFolder(A);if(L)return c.normalize(L.uri.fsPath)}}},getSelectedText:()=>{if(k){const A=k.activeEditor();if(A&&!A.selection.isEmpty)return A.document.getText(A.selection)}},getLineNumber:()=>{if(k){const A=k.activeEditor();if(A)return String(A.selection.end.line+1)}}},void 0,Promise.resolve(S.env))}}e.ExtHostVariableResolverService=v;class r{constructor(p){this.trackers=p}onWillStartSession(){this.trackers.forEach(p=>p.onWillStartSession?p.onWillStartSession():void 0)}onWillReceiveMessage(p){this.trackers.forEach(k=>k.onWillReceiveMessage?k.onWillReceiveMessage(p):void 0)}onDidSendMessage(p){this.trackers.forEach(k=>k.onDidSendMessage?k.onDidSendMessage(p):void 0)}onWillStopSession(){this.trackers.forEach(p=>p.onWillStopSession?p.onWillStopSession():void 0)}onError(p){this.trackers.forEach(k=>k.onError?k.onError(p):void 0)}onExit(p,k){this.trackers.forEach(T=>T.onExit?T.onExit(p,k):void 0)}}class s extends _.AbstractDebugAdapter{constructor(p){super();this.implementation=p,p.onDidSendMessage(k=>{this.acceptMessage(k)})}startSession(){return Promise.resolve(void 0)}sendMessage(p){this.implementation.handleMessage(p)}stopSession(){return this.implementation.dispose(),Promise.resolve(void 0)}}let u=class extends h{constructor(p,k,T,g,D,m){super(p,k,T,g,D,m)}createVariableResolver(p,k,T){return new v(p,k,T,this._editorTabs)}};u=We([ze(0,l.IExtHostRpcService),ze(1,P.IExtHostWorkspace),ze(2,t.IExtHostExtensionService),ze(3,E.IExtHostDocumentsAndEditors),ze(4,f.IExtHostConfiguration),ze(5,o.IExtHostEditorTabs)],u),e.WorkerExtHostDebugService=u}),define(we[218],Ee([0,1,74,2,5,32,30,25,13,29,4,33,91,15]),function(re,e,c,M,b,R,F,C,_,P,t,E,n,f){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.RequireInterceptor=void 0;let a=class{constructor(o,h,y,i,v,r,s){this._apiFactory=o,this._extensionRegistry=h,this._instaService=y,this._extHostConfiguration=i,this._extHostExtensionService=v,this._initData=r,this._logService=s,this._factories=new Map,this._alternatives=[]}async install(){this._installInterceptor(),c.mark("code/extHost/willWaitForConfig");const o=await this._extHostConfiguration.getConfigProvider();c.mark("code/extHost/didWaitForConfig");const h=await this._extHostExtensionService.getExtensionPathIndex();this.register(new l(this._apiFactory,h,this._extensionRegistry,o,this._logService)),this.register(this._instaService.createInstance(w)),this._initData.remote.isRemote&&this.register(this._instaService.createInstance(I,h,this._initData.environment.appUriScheme))}register(o){if(Array.isArray(o.nodeModuleName))for(let h of o.nodeModuleName)this._factories.set(h,o);else this._factories.set(o.nodeModuleName,o);typeof o.alternativeModuleName=="function"&&this._alternatives.push(h=>o.alternativeModuleName(h))}};a=We([ze(2,t.IInstantiationService),ze(3,R.IExtHostConfiguration),ze(4,E.IExtHostExtensionService),ze(5,P.IExtHostInitDataService),ze(6,f.ILogService)],a),e.RequireInterceptor=a;class l{constructor(o,h,y,i,v){this._apiFactory=o,this._extensionPaths=h,this._extensionRegistry=y,this._configProvider=i,this._logService=v,this.nodeModuleName="vscode",this._extApiImpl=new Map}load(o,h){const y=this._extensionPaths.findSubstr(h.fsPath);if(y){let i=this._extApiImpl.get(C.ExtensionIdentifier.toKey(y.identifier));return i||(i=this._apiFactory(y,this._extensionRegistry,this._configProvider),this._extApiImpl.set(C.ExtensionIdentifier.toKey(y.identifier),i)),i}if(!this._defaultApiImpl){let i="";this._extensionPaths.forEach((v,r)=>i+=`	${r} -> ${v.identifier.value}
`),this._logService.warn(`Could not identify extension for 'vscode' require call from ${h.fsPath}. These are the extension path mappings: 
${i}`),this._defaultApiImpl=this._apiFactory(F.nullExtensionDescription,this._extensionRegistry,this._configProvider)}return this._defaultApiImpl}}let w=class{constructor(o,h){this.nodeModuleName="keytar";const{environment:y}=h,i=o.getProxy(b.MainContext.MainThreadKeytar);if(y.appRoot){let v=y.appRoot.fsPath;n.platform==="win32"&&(v=v.replace(/\\/g,"/")),v[v.length-1]==="/"&&(v=v.substr(0,v.length-1)),this.alternativeNames=new Set,this.alternativeNames.add(`${v}/node_modules.asar/keytar`),this.alternativeNames.add(`${v}/node_modules/keytar`)}this._impl={getPassword:(v,r)=>i.$getPassword(v,r),setPassword:(v,r,s)=>i.$setPassword(v,r,s),deletePassword:(v,r)=>i.$deletePassword(v,r),findPassword:v=>i.$findPassword(v),findCredentials(v){return i.$findCredentials(v)}}}load(o,h){return this._impl}alternativeModuleName(o){const h=o.length;if(h<=7||!this.alternativeNames)return;const y=h-7;if((o.charAt(y)==="/"||o.charAt(y)==="\\")&&o.endsWith("keytar")&&(o=o.replace(/\\/g,"/"),this.alternativeNames.has(o)))return"keytar"}};w=We([ze(0,_.IExtHostRpcService),ze(1,P.IExtHostInitDataService)],w);let I=class{constructor(o,h,y){this._extensionPaths=o,this._appUriScheme=h,this.nodeModuleName=["open","opn"],this._mainThreadTelemetry=y.getProxy(b.MainContext.MainThreadTelemetry);const i=y.getProxy(b.MainContext.MainThreadWindow);this._impl=(v,r)=>{const s=M.URI.parse(v);return r?this.callOriginal(v,r):s.scheme==="http"||s.scheme==="https"?i.$openUri(s,v,{allowTunneling:!0}):s.scheme==="mailto"||s.scheme===this._appUriScheme?i.$openUri(s,v,{}):this.callOriginal(v,r)}}load(o,h,y){const i=this._extensionPaths.findSubstr(h.fsPath);return i&&(this._extensionId=i.identifier.value,this.sendShimmingTelemetry()),this._original=y(o),this._impl}callOriginal(o,h){return this.sendNoForwardTelemetry(),this._original(o,h)}sendShimmingTelemetry(){!this._extensionId||this._mainThreadTelemetry.$publicLog2("shimming.open",{extension:this._extensionId})}sendNoForwardTelemetry(){!this._extensionId||this._mainThreadTelemetry.$publicLog2("shimming.open.call.noForward",{extension:this._extensionId})}};I=We([ze(2,_.IExtHostRpcService)],I)}),define(we[219],Ee([0,1,14,16,74,6,2,5,212,15,57,61,29,144,13,65,33,40]),function(re,e,c,M,b,R,F,C,_,P,t,E,n,f,a,l,w,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionHostMain=void 0;class S{constructor(h,y,i,v){this._disposables=new R.DisposableStore,this._isTerminating=!1,this._hostUtils=i,this._rpcProtocol=new _.RPCProtocol(h,null,v),y=S._transform(y,this._rpcProtocol);const r=new E.ServiceCollection(...(0,t.getSingletonServiceDescriptors)());r.set(n.IExtHostInitDataService,{_serviceBrand:void 0,...y}),r.set(a.IExtHostRpcService,new a.ExtHostRpcService(this._rpcProtocol)),r.set(l.IURITransformerService,new l.URITransformerService(v)),r.set(w.IHostUtils,i);const s=new f.InstantiationService(r,!0),u=s.invokeFunction(T=>T.get(I.IExtHostTerminalService));this._disposables.add(u),this._logService=s.invokeFunction(T=>T.get(P.ILogService)),b.mark("code/extHost/didCreateServices"),this._logService.info("extension host started"),this._logService.trace("initData",y),this._extensionService=s.invokeFunction(T=>T.get(w.IExtHostExtensionService)),this._extensionService.initialize(),Error.stackTraceLimit=100;const d=new WeakMap;this._extensionService.getExtensionPathIndex().then(T=>{Error.prepareStackTrace=(g,D)=>{let m="",A,L;for(const V of D)m+=`
	at ${V.toString()}`,L=V.getFileName(),!A&&L&&(A=T.findSubstr(L));return d.set(g,A),`${g.name||"Error"}: ${g.message||""}${m}`}});const p=this._rpcProtocol.getProxy(C.MainContext.MainThreadExtensionService),k=this._rpcProtocol.getProxy(C.MainContext.MainThreadErrors);M.setUnexpectedErrorHandler(T=>{const g=M.transformErrorForSerialization(T),D=d.get(T);D?p.$onExtensionRuntimeError(D.identifier,g):k.$onUnexpectedError(g)})}terminate(h){if(this._isTerminating)return;this._isTerminating=!0,this._logService.info(`extension host terminating: ${h}`),this._logService.flush(),this._disposables.dispose(),M.setUnexpectedErrorHandler(i=>{this._logService.error(i)}),this._rpcProtocol.dispose();const y=this._extensionService.deactivateAll();setTimeout(()=>{Promise.race([(0,c.timeout)(4e3),y]).finally(()=>{this._logService.info("exiting with code 0"),this._logService.flush(),this._logService.dispose(),this._hostUtils.exit(0)})},1e3)}static _transform(h,y){h.extensions.forEach(v=>v.extensionLocation=F.URI.revive(y.transformIncomingURIs(v.extensionLocation))),h.environment.appRoot=F.URI.revive(y.transformIncomingURIs(h.environment.appRoot));const i=h.environment.extensionDevelopmentLocationURI;return i&&(h.environment.extensionDevelopmentLocationURI=i.map(v=>F.URI.revive(y.transformIncomingURIs(v)))),h.environment.extensionTestsLocationURI=F.URI.revive(y.transformIncomingURIs(h.environment.extensionTestsLocationURI)),h.environment.globalStorageHome=F.URI.revive(y.transformIncomingURIs(h.environment.globalStorageHome)),h.environment.workspaceStorageHome=F.URI.revive(y.transformIncomingURIs(h.environment.workspaceStorageHome)),h.logsLocation=F.URI.revive(y.transformIncomingURIs(h.logsLocation)),h.logFile=F.URI.revive(y.transformIncomingURIs(h.logFile)),h.workspace=y.transformIncomingURIs(h.workspace),h}}e.ExtensionHostMain=S}),define(we[220],Ee([0,1,17,21,56,27,24,193,41]),function(re,e,c,M,b,R,F,C,_){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.FileSearchManager=void 0;class P{constructor(n,f,a){this.config=n,this.provider=f,this.sessionToken=a,this.isLimitHit=!1,this.resultCount=0,this.isCanceled=!1,this.filePattern=n.filePattern,this.includePattern=n.includePattern&&R.parse(n.includePattern),this.maxResults=n.maxResults||void 0,this.exists=n.exists,this.activeCancellationTokens=new Set,this.globalExcludePattern=n.excludePattern&&R.parse(n.excludePattern)}cancel(){this.isCanceled=!0,this.activeCancellationTokens.forEach(n=>n.cancel()),this.activeCancellationTokens=new Set}search(n){const f=this.config.folderQueries||[];return new Promise((a,l)=>{const w=I=>{this.resultCount++,n(I)};if(this.isCanceled)return a({limitHit:this.isLimitHit});this.config.extraFileResources&&this.config.extraFileResources.forEach(I=>{const S=I.toString(),o=c.basename(S);this.globalExcludePattern&&this.globalExcludePattern(S,o)||this.matchFile(w,{base:I,basename:o})}),Promise.all(f.map(I=>this.searchInFolder(I,w))).then(I=>{a({limitHit:this.isLimitHit,stats:I[0]||void 0})},I=>{l(new Error((0,b.toErrorMessage)(I)))})})}async searchInFolder(n,f){const a=new M.CancellationTokenSource,l=this.getSearchOptionsForFolder(n),w=this.initDirectoryTree(),I=new _.QueryGlobTester(this.config,n),S=!I.hasSiblingExcludeClauses();let o;try{this.activeCancellationTokens.add(a),o=C.StopWatch.create();const h=await this.provider.provideFileSearchResults({pattern:this.config.filePattern||""},l,a.token),y=o.elapsed(),i=C.StopWatch.create();return this.isCanceled&&!this.isLimitHit||(h&&h.forEach(v=>{const r=c.posix.relative(n.folder.path,v.path);if(S){const s=c.basename(v.path);this.matchFile(f,{base:n.folder,relativePath:r,basename:s});return}this.addDirectoryEntries(w,n.folder,r,f)}),this.isCanceled&&!this.isLimitHit)?null:(this.matchDirectoryTree(w,I,f),{providerTime:y,postProcessTime:i.elapsed()})}finally{a.dispose(),this.activeCancellationTokens.delete(a)}}getSearchOptionsForFolder(n){const f=(0,_.resolvePatternsForProvider)(this.config.includePattern,n.includePattern),a=(0,_.resolvePatternsForProvider)(this.config.excludePattern,n.excludePattern);return{folder:n.folder,excludes:a,includes:f,useIgnoreFiles:!n.disregardIgnoreFiles,useGlobalIgnoreFiles:!n.disregardGlobalIgnoreFiles,followSymlinks:!n.ignoreSymlinks,maxResults:this.config.maxResults,session:this.sessionToken}}initDirectoryTree(){const n={rootEntries:[],pathToEntries:Object.create(null)};return n.pathToEntries["."]=n.rootEntries,n}addDirectoryEntries({pathToEntries:n},f,a,l){if(a===this.filePattern){const I=c.basename(this.filePattern);this.matchFile(l,{base:f,relativePath:this.filePattern,basename:I})}function w(I){const S=c.basename(I),o=c.dirname(I);let h=n[o];h||(h=n[o]=[],w(o)),h.push({base:f,relativePath:I,basename:S})}w(a)}matchDirectoryTree({rootEntries:n,pathToEntries:f},a,l){const w=this,I=this.filePattern;function S(o){const h=R.hasSiblingFn(()=>o.map(y=>y.basename));for(let y=0,i=o.length;y<i;y++){const v=o[y],{relativePath:r,basename:s}=v;if(!a.includedInQuerySync(r,s,I!==s?h:void 0))continue;const u=f[r];if(u)S(u);else{if(r===I)continue;w.matchFile(l,v)}if(w.isLimitHit)break}}S(n)}matchFile(n,f){(!this.includePattern||f.relativePath&&this.includePattern(f.relativePath,f.basename))&&((this.exists||this.maxResults&&this.resultCount>=this.maxResults)&&(this.isLimitHit=!0,this.cancel()),this.isLimitHit||n(f))}}class t{constructor(){this.sessions=new Map}fileSearch(n,f,a,l){const w=this.getSessionTokenSource(n.cacheKey),I=new P(n,f,w&&w.token);let S=0;const o=h=>{S+=h.length,a(h.map(y=>this.rawMatchToSearchItem(y)))};return this.doSearch(I,t.BATCH_SIZE,o,l).then(h=>({limitHit:h.limitHit,stats:{fromCache:!1,type:"fileSearchProvider",resultCount:S,detailStats:h.stats}}))}clearCache(n){const f=this.getSessionTokenSource(n);f&&f.cancel()}getSessionTokenSource(n){if(!!n)return this.sessions.has(n)||this.sessions.set(n,new M.CancellationTokenSource),this.sessions.get(n)}rawMatchToSearchItem(n){return n.relativePath?{resource:F.joinPath(n.base,n.relativePath)}:{resource:n.base}}doSearch(n,f,a,l){l.onCancellationRequested(()=>{n.cancel()});const w=S=>{S&&(I.push(S),f>0&&I.length>=f&&(a(I),I=[]))};let I=[];return n.search(w).then(S=>(I.length&&a(I),S),S=>(I.length&&a(I),Promise.reject(S)))}}e.FileSearchManager=t,t.BATCH_SIZE=512}),define(we[221],Ee([0,1,12,21,56,27,11,17,24,10,2,41]),function(re,e,c,M,b,R,F,C,_,P,t,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.BatchedCollector=e.extensionResultIsMatch=e.TextSearchResultsCollector=e.TextSearchManager=void 0;class n{constructor(o,h,y,i){this.query=o,this.provider=h,this.fileUtils=y,this.processType=i,this.collector=null,this.isLimitHit=!1,this.resultCount=0}search(o,h){const y=this.query.folderQueries||[],i=new M.CancellationTokenSource;return h.onCancellationRequested(()=>i.cancel()),new Promise((v,r)=>{this.collector=new a(o);let s=!1;const u=(d,p)=>{if(!s&&!this.isLimitHit){const k=this.resultSize(d);w(d)&&typeof this.query.maxResults=="number"&&this.resultCount+k>this.query.maxResults&&(this.isLimitHit=!0,s=!0,i.cancel(),d=this.trimResultToSize(d,this.query.maxResults-this.resultCount));const T=this.resultSize(d);this.resultCount+=T,(T>0||!w(d))&&this.collector.add(d,p)}};Promise.all(y.map((d,p)=>this.searchInFolder(d,k=>u(k,p),i.token))).then(d=>{i.dispose(),this.collector.flush();const p=d.some(k=>!!k&&!!k.limitHit);v({limitHit:this.isLimitHit||p,messages:(0,c.flatten)(d.map(k=>k?.message?(0,P.isArray)(k.message)?k.message:[k.message]:[])),stats:{type:this.processType}})},d=>{i.dispose();const p=(0,b.toErrorMessage)(d);r(new Error(p))})})}resultSize(o){return w(o)?Array.isArray(o.ranges)?o.ranges.length:1:0}trimResultToSize(o,h){const y=Array.isArray(o.ranges)?o.ranges:[o.ranges],i=Array.isArray(o.preview.matches)?o.preview.matches:[o.preview.matches];return{ranges:y.slice(0,h),preview:{matches:i.slice(0,h),text:o.preview.text},uri:o.uri}}async searchInFolder(o,h,y){const i=new E.QueryGlobTester(this.query,o),v=[],r={report:d=>{if(!this.validateProviderResult(d))return;const p=o.folder.scheme===F.Schemas.file?R.hasSiblingPromiseFn(()=>this.fileUtils.readdir(_.dirname(d.uri))):void 0,k=_.relativePath(o.folder,d.uri);if(k){const T=i.includedInQuery(k,C.basename(k),p);(0,P.isPromise)(T)?v.push(T.then(g=>{g&&h(d)})):T&&h(d)}}},s=this.getSearchOptionsForFolder(o),u=await this.provider.provideTextSearchResults(f(this.query.contentPattern),s,r,y);return v.length&&await Promise.all(v),u}validateProviderResult(o){if(w(o)){if(Array.isArray(o.ranges)){if(!Array.isArray(o.preview.matches))return console.warn("INVALID - A text search provider match's`ranges` and`matches` properties must have the same type."),!1;if(o.preview.matches.length!==o.ranges.length)return console.warn("INVALID - A text search provider match's`ranges` and`matches` properties must have the same length."),!1}else if(Array.isArray(o.preview.matches))return console.warn("INVALID - A text search provider match's`ranges` and`matches` properties must have the same length."),!1}return!0}getSearchOptionsForFolder(o){const h=(0,E.resolvePatternsForProvider)(this.query.includePattern,o.includePattern),y=(0,E.resolvePatternsForProvider)(this.query.excludePattern,o.excludePattern),i={folder:t.URI.from(o.folder),excludes:y,includes:h,useIgnoreFiles:!o.disregardIgnoreFiles,useGlobalIgnoreFiles:!o.disregardGlobalIgnoreFiles,followSymlinks:!o.ignoreSymlinks,encoding:o.fileEncoding&&this.fileUtils.toCanonicalName(o.fileEncoding),maxFileSize:this.query.maxFileSize,maxResults:this.query.maxResults,previewOptions:this.query.previewOptions,afterContext:this.query.afterContext,beforeContext:this.query.beforeContext};return i.usePCRE2=this.query.usePCRE2,i}}e.TextSearchManager=n;function f(S){return{isCaseSensitive:S.isCaseSensitive||!1,isRegExp:S.isRegExp||!1,isWordMatch:S.isWordMatch||!1,isMultiline:S.isMultiline||!1,pattern:S.pattern}}class a{constructor(o){this._onResult=o,this._currentFolderIdx=-1,this._currentFileMatch=null,this._batchedCollector=new I(512,h=>this.sendItems(h))}add(o,h){this._currentFileMatch&&(this._currentFolderIdx!==h||!_.isEqual(this._currentUri,o.uri))&&(this.pushToCollector(),this._currentFileMatch=null),this._currentFileMatch||(this._currentFolderIdx=h,this._currentFileMatch={resource:o.uri,results:[]}),this._currentFileMatch.results.push(l(o))}pushToCollector(){const o=this._currentFileMatch&&this._currentFileMatch.results?this._currentFileMatch.results.length:0;this._batchedCollector.addItem(this._currentFileMatch,o)}flush(){this.pushToCollector(),this._batchedCollector.flush()}sendItems(o){this._onResult(o)}}e.TextSearchResultsCollector=a;function l(S){return w(S)?{preview:{matches:(0,c.mapArrayOrNot)(S.preview.matches,o=>({startLineNumber:o.start.line,startColumn:o.start.character,endLineNumber:o.end.line,endColumn:o.end.character})),text:S.preview.text},ranges:(0,c.mapArrayOrNot)(S.ranges,o=>({startLineNumber:o.start.line,startColumn:o.start.character,endLineNumber:o.end.line,endColumn:o.end.character}))}:{text:S.text,lineNumber:S.lineNumber}}function w(S){return!!S.preview}e.extensionResultIsMatch=w;class I{constructor(o,h){this.maxBatchSize=o,this.cb=h,this.totalNumberCompleted=0,this.batch=[],this.batchSize=0}addItem(o,h){!o||this.addItemToBatch(o,h)}addItems(o,h){!o||this.addItemsToBatch(o,h)}addItemToBatch(o,h){this.batch.push(o),this.batchSize+=h,this.onUpdate()}addItemsToBatch(o,h){this.batch=this.batch.concat(o),this.batchSize+=h,this.onUpdate()}onUpdate(){this.totalNumberCompleted<I.START_BATCH_AFTER_COUNT?this.flush():this.batchSize>=this.maxBatchSize?this.flush():this.timeoutHandle||(this.timeoutHandle=setTimeout(()=>{this.flush()},I.TIMEOUT))}flush(){this.batchSize&&(this.totalNumberCompleted+=this.batchSize,this.cb(this.batch),this.batch=[],this.batchSize=0,this.timeoutHandle&&(clearTimeout(this.timeoutHandle),this.timeoutHandle=0))}}e.BatchedCollector=I,I.TIMEOUT=4e3,I.START_BATCH_AFTER_COUNT=50}),define(we[101],Ee([0,1,6,5,4,220,13,65,15,2,221]),function(re,e,c,M,b,R,F,C,_,P,t){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.reviveQuery=e.ExtHostSearch=e.IExtHostSearch=void 0,e.IExtHostSearch=(0,b.createDecorator)("IExtHostSearch");let E=class{constructor(l,w,I){this.extHostRpc=l,this._uriTransformer=w,this._logService=I,this._proxy=this.extHostRpc.getProxy(M.MainContext.MainThreadSearch),this._handlePool=0,this._textSearchProvider=new Map,this._textSearchUsedSchemes=new Set,this._fileSearchProvider=new Map,this._fileSearchUsedSchemes=new Set,this._fileSearchManager=new R.FileSearchManager}_transformScheme(l){return this._uriTransformer.transformOutgoingScheme(l)}registerTextSearchProvider(l,w){if(this._textSearchUsedSchemes.has(l))throw new Error(`a text search provider for the scheme '${l}' is already registered`);this._textSearchUsedSchemes.add(l);const I=this._handlePool++;return this._textSearchProvider.set(I,w),this._proxy.$registerTextSearchProvider(I,this._transformScheme(l)),(0,c.toDisposable)(()=>{this._textSearchUsedSchemes.delete(l),this._textSearchProvider.delete(I),this._proxy.$unregisterProvider(I)})}registerFileSearchProvider(l,w){if(this._fileSearchUsedSchemes.has(l))throw new Error(`a file search provider for the scheme '${l}' is already registered`);this._fileSearchUsedSchemes.add(l);const I=this._handlePool++;return this._fileSearchProvider.set(I,w),this._proxy.$registerFileSearchProvider(I,this._transformScheme(l)),(0,c.toDisposable)(()=>{this._fileSearchUsedSchemes.delete(l),this._fileSearchProvider.delete(I),this._proxy.$unregisterProvider(I)})}$provideFileSearchResults(l,w,I,S){const o=n(I),h=this._fileSearchProvider.get(l);if(h)return this._fileSearchManager.fileSearch(o,h,y=>{this._proxy.$handleFileMatch(l,w,y.map(i=>i.resource))},S);throw new Error("unknown provider: "+l)}$clearCache(l){return this._fileSearchManager.clearCache(l),Promise.resolve(void 0)}$provideTextSearchResults(l,w,I,S){const o=this._textSearchProvider.get(l);if(!o||!o.provideTextSearchResults)throw new Error(`Unknown provider ${l}`);const h=n(I);return this.createTextSearchManager(h,o).search(i=>this._proxy.$handleTextMatch(l,w,i),S)}$enableExtensionHostSearch(){}createTextSearchManager(l,w){return new t.TextSearchManager(l,w,{readdir:I=>Promise.resolve([]),toCanonicalName:I=>I},"textSearchProvider")}};E=We([ze(0,F.IExtHostRpcService),ze(1,C.IURITransformerService),ze(2,_.ILogService)],E),e.ExtHostSearch=E;function n(a){return{...a,folderQueries:a.folderQueries&&a.folderQueries.map(f),extraFileResources:a.extraFileResources&&a.extraFileResources.map(l=>P.URI.revive(l))}}e.reviveQuery=n;function f(a){return{...a,folder:P.URI.revive(a.folder)}}}),define(we[222],Ee([0,1,21,16,3,35,2,117,79,113,55,60,5,183,182,39,184,32,185,186,187,169,188,49,33,189,170,192,194,195,96,172,200,201,202,72,40,204,173,8,7,207,50,97,31,30,51,159,191,86,95,99,100,101,15,65,13,29,196,156,64,70,180,205,155,73,71,210,208,209,181,37,203,206,69,68,87,198,98,199,11,146,197,153,190]),function(re,e,c,M,b,R,F,C,_,P,t,E,n,f,a,l,w,I,S,o,h,y,i,v,r,s,u,d,p,k,T,g,D,m,A,L,V,G,U,K,$,B,z,Y,ne,j,le,oe,ve,Re,Me,Oe,Ye,Ve,qe,x,Q,te,ae,q,se,he,Te,Ue,He,Ke,ye,nt,H,J,fe,xe,Qe,rt,ct,ft,Pt,mt,Dt,kt,vt,Xe,_t,Pe,Se){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.createApiFactoryAndRegisterActors=void 0;function De(ee){const ue=ee.get(te.IExtHostInitDataService),pe=ee.get(xe.IExtHostFileSystemInfo),me=ee.get(ye.IExtHostConsumerFileSystem),Ie=ee.get(r.IExtHostExtensionService),Be=ee.get(ne.IExtHostWorkspace),Ne=ee.get(Pt.IExtHostTelemetry),je=ee.get(I.IExtHostConfiguration),et=ee.get(x.IURITransformerService),Le=ee.get(Q.IExtHostRpcService),de=ee.get(L.IExtHostStorage),ge=ee.get(Ke.IExtensionStoragePaths),X=ee.get(qe.ILogService),W=ee.get(se.IExtHostTunnelService),be=ee.get(he.IExtHostApiDeprecationService),ke=ee.get(Y.IExtHostWindow),Je=ee.get(ct.IExtHostSecretState),$e=ee.get(ft.IExtHostEditorTabs);Le.set(n.ExtHostContext.ExtHostFileSystemInfo,pe),Le.set(n.ExtHostContext.ExtHostLogService,X),Le.set(n.ExtHostContext.ExtHostWorkspace,Be),Le.set(n.ExtHostContext.ExtHostConfiguration,je),Le.set(n.ExtHostContext.ExtHostExtensionService,Ie),Le.set(n.ExtHostContext.ExtHostStorage,de),Le.set(n.ExtHostContext.ExtHostTunnelService,W),Le.set(n.ExtHostContext.ExtHostWindow,ke),Le.set(n.ExtHostContext.ExtHostSecretState,Je),Le.set(n.ExtHostContext.ExtHostTelemetry,Ne),Le.set(n.ExtHostContext.ExtHostEditorTabs,$e);const ut=Le.set(n.ExtHostContext.ExtHostDecorations,ee.get(Me.IExtHostDecorations)),gt=Le.set(n.ExtHostContext.ExtHostDocumentsAndEditors,ee.get(v.IExtHostDocumentsAndEditors)),at=Le.set(n.ExtHostContext.ExtHostCommands,ee.get(l.IExtHostCommands)),dt=Le.set(n.ExtHostContext.ExtHostTerminalService,ee.get(V.IExtHostTerminalService)),ot=Le.set(n.ExtHostContext.ExtHostDebugService,ee.get(Ye.IExtHostDebugService)),pt=Le.set(n.ExtHostContext.ExtHostSearch,ee.get(Ve.IExtHostSearch)),St=Le.set(n.ExtHostContext.ExtHostTask,ee.get(Oe.IExtHostTask)),Ut=Le.set(n.ExtHostContext.ExtHostOutputService,ee.get(T.IExtHostOutputService)),Vt=Le.set(n.ExtHostContext.ExtHostUrls,new B.ExtHostUrls(Le)),yt=Le.set(n.ExtHostContext.ExtHostDocuments,new i.ExtHostDocuments(Le,gt)),$t=Le.set(n.ExtHostContext.ExtHostDocumentContentProviders,new h.ExtHostDocumentContentProvider(Le,gt,X)),ei=Le.set(n.ExtHostContext.ExtHostDocumentSaveParticipant,new y.ExtHostDocumentSaveParticipant(X,yt,Le.getProxy(n.MainContext.MainThreadBulkEdits))),wt=Le.set(n.ExtHostContext.ExtHostNotebook,new ae.ExtHostNotebookController(Le,at,gt,yt,ge)),Qt=Le.set(n.ExtHostContext.ExtHostNotebookDocuments,new Pe.ExtHostNotebookDocuments(X,wt)),jt=Le.set(n.ExtHostContext.ExtHostNotebookEditors,new _t.ExtHostNotebookEditors(X,Le,wt)),ti=Le.set(n.ExtHostContext.ExtHostNotebookKernels,new mt.ExtHostNotebookKernels(Le,ue,wt,at,X)),ii=Le.set(n.ExtHostContext.ExtHostNotebookRenderers,new kt.ExtHostNotebookRenderers(Le,wt)),Tt=Le.set(n.ExtHostContext.ExtHostEditors,new G.ExtHostEditors(Le,gt)),Yt=Le.set(n.ExtHostContext.ExtHostTreeViews,new U.ExtHostTreeViews(Le.getProxy(n.MainContext.MainThreadTreeViews),at,X)),wi=Le.set(n.ExtHostContext.ExtHostEditorInsets,new oe.ExtHostEditorInsets(Le.getProxy(n.MainContext.MainThreadEditorInsets),Tt,ue)),Wt=Le.set(n.ExtHostContext.ExtHostDiagnostics,new S.ExtHostDiagnostics(Le,X,pe)),Ht=Le.set(n.ExtHostContext.ExtHostLanguages,new p.ExtHostLanguages(Le,yt,at.converter,et)),ht=Le.set(n.ExtHostContext.ExtHostLanguageFeatures,new d.ExtHostLanguageFeatures(Le,et,yt,at,Wt,X,be)),ni=Le.set(n.ExtHostContext.ExtHostFileSystem,new s.ExtHostFileSystem(Le,ht)),Ot=Le.set(n.ExtHostContext.ExtHostFileSystemEventService,new u.ExtHostFileSystemEventService(Le,X,gt)),Nt=Le.set(n.ExtHostContext.ExtHostQuickOpen,(0,D.createExtHostQuickOpen)(Le,Be,at)),Jt=Le.set(n.ExtHostContext.ExtHostSCM,new m.ExtHostSCM(Le,at,X)),bi=Le.set(n.ExtHostContext.ExtHostComments,(0,w.createExtHostComments)(Le,at,yt)),hi=Le.set(n.ExtHostContext.ExtHostProgress,new g.ExtHostProgress(Le.getProxy(n.MainContext.MainThreadProgress))),Ei=Le.set(n.ExtHostContext.ExtHosLabelService,new ve.ExtHostLabelService(Le)),fi=Le.set(n.ExtHostContext.ExtHostTheming,new q.ExtHostTheming(Le)),ri=Le.set(n.ExtHostContext.ExtHostAuthentication,new Te.ExtHostAuthentication(Le)),si=Le.set(n.ExtHostContext.ExtHostTimeline,new Ue.ExtHostTimeline(Le,at)),qt=Le.set(n.ExtHostContext.ExtHostWebviews,new z.ExtHostWebviews(Le,{remote:ue.remote},Be,X,be)),oi=Le.set(n.ExtHostContext.ExtHostWebviewPanels,new J.ExtHostWebviewPanels(Le,qt,Be)),_i=Le.set(n.ExtHostContext.ExtHostCustomEditors,new H.ExtHostCustomEditors(Le,yt,ge,qt,oi)),yi=Le.set(n.ExtHostContext.ExtHostWebviewViews,new nt.ExtHostWebviewViews(Le,qt)),Gt=Le.set(n.ExtHostContext.ExtHostTesting,new Qe.ExtHostTesting(Le,at)),Xt=Le.set(n.ExtHostContext.ExtHostUriOpeners,new rt.ExtHostUriOpeners(Le));Le.set(n.ExtHostContext.ExtHostInteractive,new Se.ExtHostInteractive(Le,wt,gt,at));const Si=(0,le.values)(n.ExtHostContext);Le.assertRegistered(Si);const Di=new fe.ExtHostBulkEdits(Le,gt),ai=new a.ExtHostClipboard(Le),li=new k.ExtHostMessageService(Le,X),zt=new o.ExtHostDialogs(Le),Mt=new A.ExtHostStatusBar(Le,at.converter);return f.ExtHostApiCommands.register(at),function(Fe,Rt,Kt){const bt=function(){let Z=!Fe.isUnderDevelopment;function ce(Ce){Z||(X.info(`Extension '${Fe.identifier.value}' uses a document selector without scheme. Learn more about this: https://go.microsoft.com/fwlink/?linkid=872305`),Z=!0)}return function Ce(it){if(Array.isArray(it))it.forEach(Ce);else if(typeof it=="string")ce(it);else{const Et=it;typeof Et.scheme=="undefined"&&ce(it),!Fe.enableProposedApi&&typeof Et.exclusive=="boolean"&&(0,j.throwProposedApiError)(Fe)}return it}}(),Ci={getSession(Z,ce,Ce){return Ce?.forceNewSession&&(0,j.checkProposedApiEnabled)(Fe),ri.getSession(Fe,Z,ce,Ce)},get onDidChangeSessions(){return ri.onDidChangeSessions},registerAuthenticationProvider(Z,ce,Ce,it){return ri.registerAuthenticationProvider(Z,ce,Ce,it)}},ki={registerCommand(Z,ce,Ce){return at.registerCommand(!0,Z,ce,Ce)},registerTextEditorCommand(Z,ce,Ce){return at.registerCommand(!0,Z,(...it)=>{const Et=Tt.getActiveTextEditor();if(!Et){X.warn("Cannot execute "+Z+" because there is no active text editor.");return}return Et.edit(It=>{ce.apply(Ce,[Et,It,...it])}).then(It=>{It||X.warn("Edits from command "+Z+" were not applied.")},It=>{X.warn("An error occurred while running command "+Z,It)})})},registerDiffInformationCommand:(Z,ce,Ce)=>((0,j.checkProposedApiEnabled)(Fe),at.registerCommand(!0,Z,async(...it)=>{const Et=gt.activeEditor(!0);if(!Et){X.warn("Cannot execute "+Z+" because there is no active text editor.");return}const It=await Tt.getDiffInformation(Et.id);ce.apply(Ce,[It,...it])})),executeCommand(Z,...ce){return at.executeCommand(Z,...ce)},getCommands(Z=!1){return at.getCommands(Z)}},mi={get machineId(){return ue.telemetryInfo.machineId},get sessionId(){return ue.telemetryInfo.sessionId},get language(){return ue.environment.appLanguage},get appName(){return ue.environment.appName},get appRoot(){return ue.environment.appRoot?.fsPath??""},get appHost(){return ue.environment.appHost},get uriScheme(){return ue.environment.appUriScheme},get clipboard(){return ai.value},get shell(){return dt.getDefaultShell(!1)},get isTelemetryEnabled(){return Ne.getTelemetryEnabled()},get onDidChangeTelemetryEnabled(){return Ne.onDidChangeTelemetryEnabled},get isNewAppInstall(){const Z=Date.now()-new Date(ue.telemetryInfo.firstSessionDate).getTime();return isNaN(Z)?!1:Z<1e3*60*60*24},openExternal(Z,ce){return ke.openUri(Z,{allowTunneling:!!ue.remote.authority,allowContributedOpeners:ce?.allowContributedOpeners})},async asExternalUri(Z){if(Z.scheme===ue.environment.appUriScheme)return Vt.createAppUri(Z);try{return await ke.asExternalUri(Z,{allowTunneling:!!ue.remote.authority})}catch(ce){if((0,Xe.matchesScheme)(Z,vt.Schemas.http)||(0,Xe.matchesScheme)(Z,vt.Schemas.https))return Z;throw ce}},get remoteName(){return(0,Re.getRemoteName)(ue.remote.authority)},get remoteAuthority(){return(0,j.checkProposedApiEnabled)(Fe),ue.remote.authority},get uiKind(){return ue.uiKind}};ue.environment.extensionTestsLocationURI||Object.freeze(mi);const gi=ue.remote.isRemote?$.ExtensionKind.Workspace:$.ExtensionKind.UI,Ii={createTestController(Z,ce){return Gt.createTestController(Z,ce)},createTestObserver(){return(0,j.checkProposedApiEnabled)(Fe),Gt.createTestObserver()},runTests(Z){return(0,j.checkProposedApiEnabled)(Fe),Gt.runTests(Z)},get onDidChangeTestResults(){return(0,j.checkProposedApiEnabled)(Fe),Gt.onResultsChanged},get testResults(){return(0,j.checkProposedApiEnabled)(Fe),Gt.results}},Pi={getExtension(Z){const ce=Rt.getExtensionDescription(Z);if(ce)return new r.Extension(Ie,Fe.identifier,ce,gi)},get all(){return Rt.getAllExtensionDescriptions().map(Z=>new r.Extension(Ie,Fe.identifier,Z,gi))},get onDidChange(){return Rt.onDidChange}},ui={createDiagnosticCollection(Z){return Wt.createDiagnosticCollection(Fe.identifier,Z)},get onDidChangeDiagnostics(){return Wt.onDidChangeDiagnostics},getDiagnostics:Z=>Wt.getDiagnostics(Z),getLanguages(){return Ht.getLanguages()},setTextDocumentLanguage(Z,ce){return Ht.changeLanguage(Z.uri,ce)},match(Z,ce){return(0,t.score)(K.LanguageSelector.from(Z),ce.uri,ce.languageId,!0)},registerCodeActionsProvider(Z,ce,Ce){return ht.registerCodeActionProvider(Fe,bt(Z),ce,Ce)},registerCodeLensProvider(Z,ce){return ht.registerCodeLensProvider(Fe,bt(Z),ce)},registerDefinitionProvider(Z,ce){return ht.registerDefinitionProvider(Fe,bt(Z),ce)},registerDeclarationProvider(Z,ce){return ht.registerDeclarationProvider(Fe,bt(Z),ce)},registerImplementationProvider(Z,ce){return ht.registerImplementationProvider(Fe,bt(Z),ce)},registerTypeDefinitionProvider(Z,ce){return ht.registerTypeDefinitionProvider(Fe,bt(Z),ce)},registerHoverProvider(Z,ce){return ht.registerHoverProvider(Fe,bt(Z),ce,Fe.identifier)},registerEvaluatableExpressionProvider(Z,ce){return ht.registerEvaluatableExpressionProvider(Fe,bt(Z),ce,Fe.identifier)},registerInlineValuesProvider(Z,ce){return ht.registerInlineValuesProvider(Fe,bt(Z),ce,Fe.identifier)},registerDocumentHighlightProvider(Z,ce){return ht.registerDocumentHighlightProvider(Fe,bt(Z),ce)},registerLinkedEditingRangeProvider(Z,ce){return ht.registerLinkedEditingRangeProvider(Fe,bt(Z),ce)},registerReferenceProvider(Z,ce){return ht.registerReferenceProvider(Fe,bt(Z),ce)},registerRenameProvider(Z,ce){return ht.registerRenameProvider(Fe,bt(Z),ce)},registerDocumentSymbolProvider(Z,ce,Ce){return ht.registerDocumentSymbolProvider(Fe,bt(Z),ce,Ce)},registerWorkspaceSymbolProvider(Z){return ht.registerWorkspaceSymbolProvider(Fe,Z)},registerDocumentFormattingEditProvider(Z,ce){return ht.registerDocumentFormattingEditProvider(Fe,bt(Z),ce)},registerDocumentRangeFormattingEditProvider(Z,ce){return ht.registerDocumentRangeFormattingEditProvider(Fe,bt(Z),ce)},registerOnTypeFormattingEditProvider(Z,ce,Ce,...it){return ht.registerOnTypeFormattingEditProvider(Fe,bt(Z),ce,[Ce].concat(it))},registerDocumentSemanticTokensProvider(Z,ce,Ce){return ht.registerDocumentSemanticTokensProvider(Fe,bt(Z),ce,Ce)},registerDocumentRangeSemanticTokensProvider(Z,ce,Ce){return ht.registerDocumentRangeSemanticTokensProvider(Fe,bt(Z),ce,Ce)},registerSignatureHelpProvider(Z,ce,Ce,...it){return typeof Ce=="object"?ht.registerSignatureHelpProvider(Fe,bt(Z),ce,Ce):ht.registerSignatureHelpProvider(Fe,bt(Z),ce,typeof Ce=="undefined"?[]:[Ce,...it])},registerCompletionItemProvider(Z,ce,...Ce){return ht.registerCompletionItemProvider(Fe,bt(Z),ce,Ce)},registerInlineCompletionItemProvider(Z,ce){return(0,j.checkProposedApiEnabled)(Fe),ht.registerInlineCompletionsProvider(Fe,bt(Z),ce)},registerDocumentLinkProvider(Z,ce){return ht.registerDocumentLinkProvider(Fe,bt(Z),ce)},registerColorProvider(Z,ce){return ht.registerColorProvider(Fe,bt(Z),ce)},registerFoldingRangeProvider(Z,ce){return ht.registerFoldingRangeProvider(Fe,bt(Z),ce)},registerSelectionRangeProvider(Z,ce){return ht.registerSelectionRangeProvider(Fe,Z,ce)},registerCallHierarchyProvider(Z,ce){return ht.registerCallHierarchyProvider(Fe,Z,ce)},registerTypeHierarchyProvider(Z,ce){return ht.registerTypeHierarchyProvider(Fe,Z,ce)},setLanguageConfiguration:(Z,ce)=>ht.setLanguageConfiguration(Fe,Z,ce),getTokenInformationAtPosition(Z,ce){return(0,j.checkProposedApiEnabled)(Fe),Ht.tokenAtPosition(Z,ce)},registerInlayHintsProvider(Z,ce){return(0,j.checkProposedApiEnabled)(Fe),ht.registerInlayHintsProvider(Fe,Z,ce)},createLanguageStatusItem(Z,ce){return(0,j.checkProposedApiEnabled)(Fe),Ht.createLanguageStatusItem(Fe,Z,ce)}},Ti={get activeTextEditor(){return Tt.getActiveTextEditor()},get visibleTextEditors(){return Tt.getVisibleTextEditors()},get activeTerminal(){return dt.activeTerminal},get terminals(){return dt.terminals},async showTextDocument(Z,ce,Ce){const it=await(F.URI.isUri(Z)?Promise.resolve(pi.openTextDocument(Z)):Promise.resolve(Z));return Tt.showTextDocument(it,ce,Ce)},createTextEditorDecorationType(Z){return Tt.createTextEditorDecorationType(Fe,Z)},onDidChangeActiveTextEditor(Z,ce,Ce){return Tt.onDidChangeActiveTextEditor(Z,ce,Ce)},onDidChangeVisibleTextEditors(Z,ce,Ce){return Tt.onDidChangeVisibleTextEditors(Z,ce,Ce)},onDidChangeTextEditorSelection(Z,ce,Ce){return Tt.onDidChangeTextEditorSelection(Z,ce,Ce)},onDidChangeTextEditorOptions(Z,ce,Ce){return Tt.onDidChangeTextEditorOptions(Z,ce,Ce)},onDidChangeTextEditorVisibleRanges(Z,ce,Ce){return Tt.onDidChangeTextEditorVisibleRanges(Z,ce,Ce)},onDidChangeTextEditorViewColumn(Z,ce,Ce){return Tt.onDidChangeTextEditorViewColumn(Z,ce,Ce)},onDidCloseTerminal(Z,ce,Ce){return dt.onDidCloseTerminal(Z,ce,Ce)},onDidOpenTerminal(Z,ce,Ce){return dt.onDidOpenTerminal(Z,ce,Ce)},onDidChangeActiveTerminal(Z,ce,Ce){return dt.onDidChangeActiveTerminal(Z,ce,Ce)},onDidChangeTerminalDimensions(Z,ce,Ce){return(0,j.checkProposedApiEnabled)(Fe),dt.onDidChangeTerminalDimensions(Z,ce,Ce)},onDidChangeTerminalState(Z,ce,Ce){return(0,j.checkProposedApiEnabled)(Fe),dt.onDidChangeTerminalState(Z,ce,Ce)},onDidWriteTerminalData(Z,ce,Ce){return(0,j.checkProposedApiEnabled)(Fe),dt.onDidWriteTerminalData(Z,ce,Ce)},get state(){return ke.state},onDidChangeWindowState(Z,ce,Ce){return ke.onDidChangeWindowState(Z,ce,Ce)},showInformationMessage(Z,...ce){return li.showMessage(Fe,R.default.Info,Z,ce[0],ce.slice(1))},showWarningMessage(Z,...ce){return li.showMessage(Fe,R.default.Warning,Z,ce[0],ce.slice(1))},showErrorMessage(Z,...ce){return li.showMessage(Fe,R.default.Error,Z,ce[0],ce.slice(1))},showQuickPick(Z,ce,Ce){return Nt.showQuickPick(Z,!!Fe.enableProposedApi,ce,Ce)},showWorkspaceFolderPick(Z){return Nt.showWorkspaceFolderPick(Z)},showInputBox(Z,ce){return Nt.showInput(Z,ce)},showOpenDialog(Z){return zt.showOpenDialog(Z)},showSaveDialog(Z){return zt.showSaveDialog(Z)},createStatusBarItem(Z,ce,Ce){let it,Et,It;return typeof Z=="string"?(it=Z,Et=ce,It=Ce):(Et=Z,It=ce),Mt.createStatusBarEntry(Fe,it,Et,It)},setStatusBarMessage(Z,ce){return Mt.setStatusBarMessage(Z,ce)},withScmProgress(Z){return be.report("window.withScmProgress",Fe,"Use 'withProgress' instead."),hi.withProgress(Fe,{location:$.ProgressLocation.SourceControl},(ce,Ce)=>Z({report(it){}}))},withProgress(Z,ce){return hi.withProgress(Fe,Z,ce)},createOutputChannel(Z){return Ut.createOutputChannel(Z,Fe)},createWebviewPanel(Z,ce,Ce,it){return oi.createWebviewPanel(Fe,Z,ce,Ce,it)},createWebviewTextEditorInset(Z,ce,Ce,it){return(0,j.checkProposedApiEnabled)(Fe),wi.createWebviewEditorInset(Z,ce,Ce,it,Fe)},createTerminal(Z,ce,Ce){return typeof Z=="object"?("location"in Z&&(0,j.checkProposedApiEnabled)(Fe),"pty"in Z?dt.createExtensionTerminal(Z):dt.createTerminalFromOptions(Z)):dt.createTerminal(Z,ce,Ce)},registerTerminalLinkProvider(Z){return dt.registerLinkProvider(Z)},registerTerminalProfileProvider(Z,ce){return dt.registerProfileProvider(Fe,Z,ce)},registerTreeDataProvider(Z,ce){return Yt.registerTreeDataProvider(Z,ce,Fe)},createTreeView(Z,ce){return Yt.createTreeView(Z,ce,Fe)},registerWebviewPanelSerializer:(Z,ce)=>oi.registerWebviewPanelSerializer(Fe,Z,ce),registerCustomEditorProvider:(Z,ce,Ce={})=>_i.registerCustomEditorProvider(Fe,Z,ce,Ce),registerFileDecorationProvider(Z){return ut.registerFileDecorationProvider(Z,Fe.identifier)},registerUriHandler(Z){return Vt.registerUriHandler(Fe.identifier,Z)},createQuickPick(){return Nt.createQuickPick(Fe.identifier,!!Fe.enableProposedApi)},createInputBox(){return Nt.createInputBox(Fe.identifier)},get activeColorTheme(){return fi.activeColorTheme},onDidChangeActiveColorTheme(Z,ce,Ce){return fi.onDidChangeActiveColorTheme(Z,ce,Ce)},registerWebviewViewProvider(Z,ce,Ce){return yi.registerWebviewViewProvider(Fe,Z,ce,Ce?.webviewOptions)},get activeNotebookEditor(){return(0,j.checkProposedApiEnabled)(Fe),wt.activeNotebookEditor},onDidChangeActiveNotebookEditor(Z,ce,Ce){return(0,j.checkProposedApiEnabled)(Fe),wt.onDidChangeActiveNotebookEditor(Z,ce,Ce)},get visibleNotebookEditors(){return(0,j.checkProposedApiEnabled)(Fe),wt.visibleNotebookEditors},get onDidChangeVisibleNotebookEditors(){return(0,j.checkProposedApiEnabled)(Fe),wt.onDidChangeVisibleNotebookEditors},onDidChangeNotebookEditorSelection(Z,ce,Ce){return(0,j.checkProposedApiEnabled)(Fe),jt.onDidChangeNotebookEditorSelection(Z,ce,Ce)},onDidChangeNotebookEditorVisibleRanges(Z,ce,Ce){return(0,j.checkProposedApiEnabled)(Fe),jt.onDidChangeNotebookEditorVisibleRanges(Z,ce,Ce)},showNotebookDocument(Z,ce){return(0,j.checkProposedApiEnabled)(Fe),wt.showNotebookDocument(Z,ce)},registerExternalUriOpener(Z,ce,Ce){return(0,j.checkProposedApiEnabled)(Fe),Xt.registerExternalUriOpener(Fe.identifier,Z,ce,Ce)},get tabs(){return(0,j.checkProposedApiEnabled)(Fe),$e.tabs},get activeTab(){return(0,j.checkProposedApiEnabled)(Fe),$e.activeTab},get onDidChangeTabs(){return(0,j.checkProposedApiEnabled)(Fe),$e.onDidChangeTabs},get onDidChangeActiveTab(){return(0,j.checkProposedApiEnabled)(Fe),$e.onDidChangeActiveTab},getInlineCompletionItemController(Z){return(0,j.checkProposedApiEnabled)(Fe),d.InlineCompletionController.get(Z)}},pi={get rootPath(){return be.report("workspace.rootPath",Fe,"Please use 'workspace.workspaceFolders' instead. More details: https://aka.ms/vscode-eliminating-rootpath"),Be.getPath()},set rootPath(Z){throw M.readonly()},getWorkspaceFolder(Z){return Be.getWorkspaceFolder(Z)},get workspaceFolders(){return Be.getWorkspaceFolders()},get name(){return Be.name},set name(Z){throw M.readonly()},get workspaceFile(){return Be.workspaceFile},set workspaceFile(Z){throw M.readonly()},updateWorkspaceFolders:(Z,ce,...Ce)=>Be.updateWorkspaceFolders(Fe,Z,ce||0,...Ce),onDidChangeWorkspaceFolders:function(Z,ce,Ce){return Be.onDidChangeWorkspace(Z,ce,Ce)},asRelativePath:(Z,ce)=>Be.getRelativePath(Z,ce),findFiles:(Z,ce,Ce,it)=>Be.findFiles(K.GlobPattern.from(Z),K.GlobPattern.from(ce),Ce,Fe.identifier,it),findTextInFiles:(Z,ce,Ce,it)=>{let Et,It;return typeof ce=="object"?(Et=ce,It=Ce):(Et={},It=ce,it=Ce),Be.findTextInFiles(Z,Et||{},It,Fe.identifier,it)},saveAll:Z=>Be.saveAll(Z),applyEdit(Z){return Di.applyWorkspaceEdit(Z)},createFileSystemWatcher:(Z,ce,Ce,it)=>Ot.createFileSystemWatcher(K.GlobPattern.from(Z),ce,Ce,it),get textDocuments(){return yt.getAllDocumentData().map(Z=>Z.document)},set textDocuments(Z){throw M.readonly()},openTextDocument(Z){let ce;const Ce=Z;if(typeof Z=="string")ce=Promise.resolve(F.URI.file(Z));else if(F.URI.isUri(Z))ce=Promise.resolve(Z);else if(!Ce||typeof Ce=="object")ce=yt.createDocumentData(Ce);else throw new Error("illegal argument - uriOrFileNameOrOptions");return ce.then(it=>yt.ensureDocumentData(it).then(Et=>Et.document))},onDidOpenTextDocument:(Z,ce,Ce)=>yt.onDidAddDocument(Z,ce,Ce),onDidCloseTextDocument:(Z,ce,Ce)=>yt.onDidRemoveDocument(Z,ce,Ce),onDidChangeTextDocument:(Z,ce,Ce)=>yt.onDidChangeDocument(Z,ce,Ce),onDidSaveTextDocument:(Z,ce,Ce)=>yt.onDidSaveDocument(Z,ce,Ce),onWillSaveTextDocument:(Z,ce,Ce)=>ei.getOnWillSaveTextDocumentEvent(Fe)(Z,ce,Ce),get notebookDocuments(){return wt.notebookDocuments.map(Z=>Z.apiNotebook)},async openNotebookDocument(Z,ce){let Ce;if(F.URI.isUri(Z))Ce=Z,await wt.openNotebookDocument(Z);else if(typeof Z=="string")Ce=F.URI.revive(await wt.createNotebookDocument({viewType:Z,content:ce}));else throw new Error("Invalid arguments");return wt.getNotebookDocument(Ce).apiNotebook},get onDidOpenNotebookDocument(){return wt.onDidOpenNotebookDocument},get onDidCloseNotebookDocument(){return wt.onDidCloseNotebookDocument},registerNotebookSerializer(Z,ce,Ce,it){return wt.registerNotebookSerializer(Fe,Z,ce,Ce,Fe.enableProposedApi?it:void 0)},registerNotebookContentProvider:(Z,ce,Ce,it)=>((0,j.checkProposedApiEnabled)(Fe),wt.registerNotebookContentProvider(Fe,Z,ce,Ce,Fe.enableProposedApi?it:void 0)),onDidChangeConfiguration:(Z,ce,Ce)=>Kt.onDidChangeConfiguration(Z,ce,Ce),getConfiguration(Z,ce){return ce=arguments.length===1?void 0:ce,Kt.getConfiguration(Z,ce,Fe)},registerTextDocumentContentProvider(Z,ce){return $t.registerTextDocumentContentProvider(Z,ce)},registerTaskProvider:(Z,ce)=>(be.report("window.registerTaskProvider",Fe,"Use the corresponding function on the 'tasks' namespace instead"),St.registerTaskProvider(Fe,Z,ce)),registerFileSystemProvider(Z,ce,Ce){return ni.registerFileSystemProvider(Fe.identifier,Z,ce,Ce)},get fs(){return me.value},registerFileSearchProvider:(Z,ce)=>((0,j.checkProposedApiEnabled)(Fe),pt.registerFileSearchProvider(Z,ce)),registerTextSearchProvider:(Z,ce)=>((0,j.checkProposedApiEnabled)(Fe),pt.registerTextSearchProvider(Z,ce)),registerRemoteAuthorityResolver:(Z,ce)=>((0,j.checkProposedApiEnabled)(Fe),Ie.registerRemoteAuthorityResolver(Z,ce)),registerResourceLabelFormatter:Z=>((0,j.checkProposedApiEnabled)(Fe),Ei.$registerResourceLabelFormatter(Z)),onDidCreateFiles:(Z,ce,Ce)=>Ot.onDidCreateFile(Z,ce,Ce),onDidDeleteFiles:(Z,ce,Ce)=>Ot.onDidDeleteFile(Z,ce,Ce),onDidRenameFiles:(Z,ce,Ce)=>Ot.onDidRenameFile(Z,ce,Ce),onWillCreateFiles:(Z,ce,Ce)=>Ot.getOnWillCreateFileEvent(Fe)(Z,ce,Ce),onWillDeleteFiles:(Z,ce,Ce)=>Ot.getOnWillDeleteFileEvent(Fe)(Z,ce,Ce),onWillRenameFiles:(Z,ce,Ce)=>Ot.getOnWillRenameFileEvent(Fe)(Z,ce,Ce),openTunnel:Z=>((0,j.checkProposedApiEnabled)(Fe),W.openTunnel(Fe,Z).then(ce=>{if(!ce)throw new Error("cannot open tunnel");return ce})),get tunnels(){return(0,j.checkProposedApiEnabled)(Fe),W.getTunnels()},onDidChangeTunnels:(Z,ce,Ce)=>((0,j.checkProposedApiEnabled)(Fe),W.onDidChangeTunnels(Z,ce,Ce)),registerPortAttributesProvider:(Z,ce)=>((0,j.checkProposedApiEnabled)(Fe),W.registerPortsAttributesProvider(Z,ce)),registerTimelineProvider:(Z,ce)=>((0,j.checkProposedApiEnabled)(Fe),si.registerTimelineProvider(Z,ce,Fe.identifier,at.converter)),get isTrusted(){return Be.trusted},requestWorkspaceTrust:Z=>((0,j.checkProposedApiEnabled)(Fe),Be.requestWorkspaceTrust(Z)),onDidGrantWorkspaceTrust:(Z,ce,Ce)=>Be.onDidGrantWorkspaceTrust(Z,ce,Ce)},Ai={get inputBox(){return be.report("scm.inputBox",Fe,"Use 'SourceControl.inputBox' instead"),Jt.getLastInputBox(Fe)},createSourceControl(Z,ce,Ce){return Jt.createSourceControl(Fe,Z,ce,Ce)}},Ri={createCommentController(Z,ce){return bi.createCommentController(Fe,Z,ce)}},Fi={get activeDebugSession(){return ot.activeDebugSession},get activeDebugConsole(){return ot.activeDebugConsole},get breakpoints(){return ot.breakpoints},onDidStartDebugSession(Z,ce,Ce){return ot.onDidStartDebugSession(Z,ce,Ce)},onDidTerminateDebugSession(Z,ce,Ce){return ot.onDidTerminateDebugSession(Z,ce,Ce)},onDidChangeActiveDebugSession(Z,ce,Ce){return ot.onDidChangeActiveDebugSession(Z,ce,Ce)},onDidReceiveDebugSessionCustomEvent(Z,ce,Ce){return ot.onDidReceiveDebugSessionCustomEvent(Z,ce,Ce)},onDidChangeBreakpoints(Z,ce,Ce){return ot.onDidChangeBreakpoints(Z,ce,Ce)},registerDebugConfigurationProvider(Z,ce,Ce){return ot.registerDebugConfigurationProvider(Z,ce,Ce||$.DebugConfigurationProviderTriggerKind.Initial)},registerDebugAdapterDescriptorFactory(Z,ce){return ot.registerDebugAdapterDescriptorFactory(Fe,Z,ce)},registerDebugAdapterTrackerFactory(Z,ce){return ot.registerDebugAdapterTrackerFactory(Z,ce)},startDebugging(Z,ce,Ce){return!Ce||typeof Ce=="object"&&"configuration"in Ce?ot.startDebugging(Z,ce,{parentSession:Ce}):ot.startDebugging(Z,ce,Ce||{})},stopDebugging(Z){return ot.stopDebugging(Z)},addBreakpoints(Z){return ot.addBreakpoints(Z)},removeBreakpoints(Z){return ot.removeBreakpoints(Z)},asDebugSourceUri(Z,ce){return ot.asDebugSourceUri(Z,ce)}},Mi={registerTaskProvider:(Z,ce)=>St.registerTaskProvider(Fe,Z,ce),fetchTasks:Z=>St.fetchTasks(Z),executeTask:Z=>St.executeTask(Fe,Z),get taskExecutions(){return St.taskExecutions},onDidStartTask:(Z,ce,Ce)=>St.onDidStartTask(Z,ce,Ce),onDidEndTask:(Z,ce,Ce)=>St.onDidEndTask(Z,ce,Ce),onDidStartTaskProcess:(Z,ce,Ce)=>St.onDidStartTaskProcess(Z,ce,Ce),onDidEndTaskProcess:(Z,ce,Ce)=>St.onDidEndTaskProcess(Z,ce,Ce)},Li={createNotebookController(Z,ce,Ce,it,Et){return ti.createNotebookController(Fe,Z,ce,Ce,it,Fe.enableProposedApi?Et:void 0)},registerNotebookCellStatusBarItemProvider:(Z,ce)=>wt.registerNotebookCellStatusBarItemProvider(Fe,Z,ce),get onDidSaveNotebookDocument(){return(0,j.checkProposedApiEnabled)(Fe),Qt.onDidSaveNotebookDocument},createNotebookEditorDecorationType(Z){return(0,j.checkProposedApiEnabled)(Fe),jt.createNotebookEditorDecorationType(Z)},createRendererMessaging(Z){return ii.createRendererMessaging(Fe,Z)},onDidChangeNotebookDocumentMetadata(Z,ce,Ce){return(0,j.checkProposedApiEnabled)(Fe),Qt.onDidChangeNotebookDocumentMetadata(Z,ce,Ce)},onDidChangeNotebookCells(Z,ce,Ce){return(0,j.checkProposedApiEnabled)(Fe),wt.onDidChangeNotebookCells(Z,ce,Ce)},onDidChangeNotebookCellExecutionState(Z,ce,Ce){return(0,j.checkProposedApiEnabled)(Fe),wt.onDidChangeNotebookCellExecutionState(Z,ce,Ce)},onDidChangeCellOutputs(Z,ce,Ce){return(0,j.checkProposedApiEnabled)(Fe),wt.onDidChangeCellOutputs(Z,ce,Ce)},onDidChangeCellMetadata(Z,ce,Ce){return(0,j.checkProposedApiEnabled)(Fe),wt.onDidChangeCellMetadata(Z,ce,Ce)},createConcatTextDocument(Z,ce){return(0,j.checkProposedApiEnabled)(Fe),new He.ExtHostNotebookConcatDocument(wt,yt,Z,ce)}};return{version:ue.version,authentication:Ci,commands:ki,comments:Ri,debug:Fi,env:mi,extensions:Pi,languages:ui,notebooks:Li,scm:Ai,tasks:Mi,tests:Ii,window:Ti,workspace:pi,Breakpoint:$.Breakpoint,CallHierarchyIncomingCall:$.CallHierarchyIncomingCall,CallHierarchyItem:$.CallHierarchyItem,CallHierarchyOutgoingCall:$.CallHierarchyOutgoingCall,CancellationError:M.CancellationError,CancellationTokenSource:c.CancellationTokenSource,CandidatePortSource:n.CandidatePortSource,CodeAction:$.CodeAction,CodeActionKind:$.CodeActionKind,CodeActionTriggerKind:$.CodeActionTriggerKind,CodeLens:$.CodeLens,Color:$.Color,ColorInformation:$.ColorInformation,ColorPresentation:$.ColorPresentation,ColorThemeKind:$.ColorThemeKind,CommentMode:$.CommentMode,CommentThreadCollapsibleState:$.CommentThreadCollapsibleState,CompletionItem:$.CompletionItem,CompletionItemKind:$.CompletionItemKind,CompletionItemTag:$.CompletionItemTag,CompletionList:$.CompletionList,CompletionTriggerKind:$.CompletionTriggerKind,ConfigurationTarget:$.ConfigurationTarget,CustomExecution:$.CustomExecution,DebugAdapterExecutable:$.DebugAdapterExecutable,DebugAdapterInlineImplementation:$.DebugAdapterInlineImplementation,DebugAdapterNamedPipeServer:$.DebugAdapterNamedPipeServer,DebugAdapterServer:$.DebugAdapterServer,DebugConfigurationProviderTriggerKind:$.DebugConfigurationProviderTriggerKind,DebugConsoleMode:$.DebugConsoleMode,DecorationRangeBehavior:$.DecorationRangeBehavior,Diagnostic:$.Diagnostic,DiagnosticRelatedInformation:$.DiagnosticRelatedInformation,DiagnosticSeverity:$.DiagnosticSeverity,DiagnosticTag:$.DiagnosticTag,Disposable:$.Disposable,DocumentHighlight:$.DocumentHighlight,DocumentHighlightKind:$.DocumentHighlightKind,DocumentLink:$.DocumentLink,DocumentSymbol:$.DocumentSymbol,EndOfLine:$.EndOfLine,EnvironmentVariableMutatorType:$.EnvironmentVariableMutatorType,EvaluatableExpression:$.EvaluatableExpression,InlineValueText:$.InlineValueText,InlineValueVariableLookup:$.InlineValueVariableLookup,InlineValueEvaluatableExpression:$.InlineValueEvaluatableExpression,InlineCompletionTriggerKind:$.InlineCompletionTriggerKind,EventEmitter:b.Emitter,ExtensionKind:$.ExtensionKind,ExtensionMode:$.ExtensionMode,ExternalUriOpenerPriority:$.ExternalUriOpenerPriority,FileChangeType:$.FileChangeType,FileDecoration:$.FileDecoration,FileSystemError:$.FileSystemError,FileType:E.FileType,FilePermission:E.FilePermission,FoldingRange:$.FoldingRange,FoldingRangeKind:$.FoldingRangeKind,FunctionBreakpoint:$.FunctionBreakpoint,InlineCompletionItem:$.InlineSuggestion,InlineCompletionList:$.InlineSuggestions,Hover:$.Hover,IndentAction:P.IndentAction,Location:$.Location,MarkdownString:$.MarkdownString,OverviewRulerLane:_.OverviewRulerLane,ParameterInformation:$.ParameterInformation,PortAutoForwardAction:$.PortAutoForwardAction,Position:$.Position,ProcessExecution:$.ProcessExecution,ProgressLocation:$.ProgressLocation,QuickInputButtons:$.QuickInputButtons,Range:$.Range,RelativePattern:$.RelativePattern,Selection:$.Selection,SelectionRange:$.SelectionRange,SemanticTokens:$.SemanticTokens,SemanticTokensBuilder:$.SemanticTokensBuilder,SemanticTokensEdit:$.SemanticTokensEdit,SemanticTokensEdits:$.SemanticTokensEdits,SemanticTokensLegend:$.SemanticTokensLegend,ShellExecution:$.ShellExecution,ShellQuoting:$.ShellQuoting,SignatureHelp:$.SignatureHelp,SignatureHelpTriggerKind:$.SignatureHelpTriggerKind,SignatureInformation:$.SignatureInformation,SnippetString:$.SnippetString,SourceBreakpoint:$.SourceBreakpoint,StandardTokenType:$.StandardTokenType,StatusBarAlignment:$.StatusBarAlignment,SymbolInformation:$.SymbolInformation,SymbolKind:$.SymbolKind,SymbolTag:$.SymbolTag,Task:$.Task,TaskGroup:$.TaskGroup,TaskPanelKind:$.TaskPanelKind,TaskRevealKind:$.TaskRevealKind,TaskScope:$.TaskScope,TerminalLink:$.TerminalLink,TerminalLocation:$.TerminalLocation,TerminalProfile:$.TerminalProfile,TextDocumentSaveReason:$.TextDocumentSaveReason,TextEdit:$.TextEdit,TextEditorCursorStyle:C.TextEditorCursorStyle,TextEditorLineNumbersStyle:$.TextEditorLineNumbersStyle,TextEditorRevealType:$.TextEditorRevealType,TextEditorSelectionChangeKind:$.TextEditorSelectionChangeKind,TextDocumentChangeReason:$.TextDocumentChangeReason,ThemeColor:$.ThemeColor,ThemeIcon:$.ThemeIcon,TreeItem:$.TreeItem,TreeItemCollapsibleState:$.TreeItemCollapsibleState,TypeHierarchyItem:$.TypeHierarchyItem,UIKind:n.UIKind,Uri:F.URI,ViewColumn:$.ViewColumn,WorkspaceEdit:$.WorkspaceEdit,InlayHint:$.InlayHint,InlayHintKind:$.InlayHintKind,RemoteAuthorityResolverError:$.RemoteAuthorityResolverError,ResolvedAuthority:$.ResolvedAuthority,SourceControlInputBoxValidationType:$.SourceControlInputBoxValidationType,ExtensionRuntime:$.ExtensionRuntime,TimelineItem:$.TimelineItem,NotebookRange:$.NotebookRange,NotebookCellKind:$.NotebookCellKind,NotebookCellExecutionState:$.NotebookCellExecutionState,NotebookCellData:$.NotebookCellData,NotebookData:$.NotebookData,NotebookRendererScript:$.NotebookRendererScript,NotebookCellStatusBarAlignment:$.NotebookCellStatusBarAlignment,NotebookEditorRevealType:$.NotebookEditorRevealType,NotebookCellOutput:$.NotebookCellOutput,NotebookCellOutputItem:$.NotebookCellOutputItem,NotebookCellStatusBarItem:$.NotebookCellStatusBarItem,NotebookControllerAffinity:$.NotebookControllerAffinity,PortAttributes:$.PortAttributes,LinkedEditingRanges:$.LinkedEditingRanges,TestResultState:$.TestResultState,TestRunRequest:$.TestRunRequest,TestMessage:$.TestMessage,TestTag:$.TestTag,TestRunProfileKind:$.TestRunProfileKind,TextSearchCompleteMessageType:Dt.TextSearchCompleteMessageType,CoveredCount:$.CoveredCount,FileCoverage:$.FileCoverage,StatementCoverage:$.StatementCoverage,BranchCoverage:$.BranchCoverage,FunctionCoverage:$.FunctionCoverage,WorkspaceTrustState:$.WorkspaceTrustState,LanguageStatusSeverity:$.LanguageStatusSeverity}}}e.createApiFactoryAndRegisterActors=De}),define(we[223],Ee([0,1,57,96,31,95,32,39,49,40,99,100,101,72,64,70,97,71,37,69,87,68]),function(re,e,c,M,b,R,F,C,_,P,t,E,n,f,a,l,w,I,S,o,h,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),(0,c.registerSingleton)(l.IExtHostApiDeprecationService,l.ExtHostApiDeprecationService),(0,c.registerSingleton)(C.IExtHostCommands,C.ExtHostCommands),(0,c.registerSingleton)(F.IExtHostConfiguration,F.ExtHostConfiguration),(0,c.registerSingleton)(I.IExtHostConsumerFileSystem,I.ExtHostConsumerFileSystem),(0,c.registerSingleton)(E.IExtHostDebugService,E.WorkerExtHostDebugService),(0,c.registerSingleton)(R.IExtHostDecorations,R.ExtHostDecorations),(0,c.registerSingleton)(_.IExtHostDocumentsAndEditors,_.ExtHostDocumentsAndEditors),(0,c.registerSingleton)(S.IExtHostFileSystemInfo,S.ExtHostFileSystemInfo),(0,c.registerSingleton)(M.IExtHostOutputService,M.ExtHostOutputService),(0,c.registerSingleton)(n.IExtHostSearch,n.ExtHostSearch),(0,c.registerSingleton)(f.IExtHostStorage,f.ExtHostStorage),(0,c.registerSingleton)(t.IExtHostTask,t.WorkerExtHostTask),(0,c.registerSingleton)(P.IExtHostTerminalService,P.WorkerExtHostTerminalService),(0,c.registerSingleton)(a.IExtHostTunnelService,a.ExtHostTunnelService),(0,c.registerSingleton)(w.IExtHostWindow,w.ExtHostWindow),(0,c.registerSingleton)(b.IExtHostWorkspace,b.ExtHostWorkspace),(0,c.registerSingleton)(o.IExtHostSecretState,o.ExtHostSecretState),(0,c.registerSingleton)(h.IExtHostTelemetry,h.ExtHostTelemetry),(0,c.registerSingleton)(y.IExtHostEditorTabs,y.ExtHostEditorTabs)}),define(we[224],Ee([0,1,222,33,218,7,14,5,11]),function(re,e,c,M,b,R,F,C,_){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostExtensionService=void 0;var P;(function(a){const l=self.trustedTypes?.createPolicy("TrustedFunctionWorkaround",{createScript:(I,...S)=>{S.forEach(i=>{if(!self.trustedTypes?.isScript(i))throw new Error("TrustedScripts only, please")});const o=S.slice(0,-1).join(","),h=S.pop().toString();return`(function anonymous(${o}) {${h}
})`}});function w(...I){return l?self.eval(l.createScript("",...I)):new Function(...I)}a.create=w})(P||(P={}));class t extends b.RequireInterceptor{_installInterceptor(){}getModule(l,w){for(let I of this._alternatives){let S=I(l);if(S){l=S;break}}if(this._factories.has(l))return this._factories.get(l).load(l,w,()=>{throw new Error("CANNOT LOAD MODULE from here.")})}}class E extends M.AbstractExtHostExtensionService{constructor(){super(...arguments);this.extensionRuntime=R.ExtensionRuntime.Webworker}async _beforeAlmostReadyToRunExtensions(){const l=this._extHostContext.getProxy(C.MainContext.MainThreadConsole);f(l,this._initData.environment.isExtensionDevelopmentDebug);const w=this._instaService.invokeFunction(c.createApiFactoryAndRegisterActors);this._fakeModules=this._instaService.createInstance(t,w,this._registry),await this._fakeModules.install(),performance.mark("code/extHost/didInitAPI"),await this._waitForDebuggerAttachment()}_getEntryPoint(l){return l.browser}async _loadCommonJSModule(l,w,I){w=w.with({path:n(w.path,".js")}),l&&performance.mark(`code/extHost/willFetchExtensionCode/${l.value}`);const S=await fetch(_.FileAccess.asBrowserUri(w).toString(!0));if(l&&performance.mark(`code/extHost/didFetchExtensionCode/${l.value}`),S.status!==200)throw new Error(S.statusText);const o=await S.text(),h=`${w.toString(!0)}#vscode-extension`,y=`${o}
//# sourceURL=${h}`;let i;try{i=P.create(E._ttpExtensionScripts?.createScript("module")??"module",E._ttpExtensionScripts?.createScript("exports")??"exports",E._ttpExtensionScripts?.createScript("require")??"require",E._ttpExtensionScripts?.createScript(y)??y)}catch(u){throw console.error(l?`Loading code for extension ${l.value} failed: ${u.message}`:`Loading code failed: ${u.message}`),console.error(`${w.toString(!0)}${typeof u.line=="number"?` line ${u.line}`:""}${typeof u.column=="number"?` column ${u.column}`:""}`),console.error(u),u}const v={},r={exports:v},s=u=>{const d=this._fakeModules.getModule(u,w);if(d===void 0)throw new Error(`Cannot load module '${u}'`);return d};try{return I.codeLoadingStart(),l&&performance.mark(`code/extHost/willLoadExtensionCode/${l.value}`),i(r,v,s),r.exports!==v?r.exports:v}finally{l&&performance.mark(`code/extHost/didLoadExtensionCode/${l.value}`),I.codeLoadingStop()}}async $setRemoteEnvironment(l){}async _waitForDebuggerAttachment(l=5e3){if(!this._initData.environment.isExtensionDevelopmentDebug)return;const w=Date.now()+l;for(;Date.now()<w&&!("__jsDebugIsReady"in globalThis);)await(0,F.timeout)(10)}}e.ExtHostExtensionService=E,E._ttpExtensionScripts=self.trustedTypes?.createPolicy("ExtensionScripts",{createScript:a=>a});function n(a,l){return a.endsWith(l)?a:a+l}function f(a,l){w("info","log"),w("log","log"),w("warn","warn"),w("error","error");function w(o,h){const y=console[o];console[o]=function(){a.$logExtensionHostMessage({type:"__$console",severity:h,arguments:S(arguments)}),l&&y.apply(console,arguments)}}const I=1e5;function S(o){const h=[],y=[];if(o.length)for(let i=0;i<o.length;i++){if(typeof o[i]=="undefined")o[i]="undefined";else if(o[i]instanceof Error){const v=o[i];v.stack?o[i]=v.stack:o[i]=v.toString()}y.push(o[i])}try{const i=JSON.stringify(y,function(v,r){if(r&&typeof r=="object"){if(h.indexOf(r)!==-1)return"[Circular]";h.push(r)}return r});return i.length>I?"Output omitted for a large object that exceeds the limits":i}catch(i){return`Output omitted for an object that cannot be inspected ('${i.toString()}')`}}}}),define(we[225],Ee([0,1,57,15,33,73,224,211]),function(re,e,c,M,b,R,F,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),(0,c.registerSingleton)(b.IExtHostExtensionService,F.ExtHostExtensionService),(0,c.registerSingleton)(M.ILogService,C.ExtHostLogService),(0,c.registerSingleton)(R.IExtensionStoragePaths,R.ExtensionStoragePaths)}),define(we[235],Ee([0,1,22,3,177,219,213,17,74,11,2,223,225]),function(re,e,c,M,b,R,F,C,_,P,t){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.create=void 0;const E=self.close.bind(self);self.close=()=>console.trace("'close' has been blocked");const n=postMessage.bind(self);self.postMessage=()=>console.trace("'postMessage' has been blocked");const f=fetch.bind(self);if(self.fetch=function(o,h){return o instanceof Request||/^file:/i.test(String(o))&&(o=P.FileAccess.asBrowserUri(t.URI.parse(String(o))).toString(!0)),f(o,h)},self.XMLHttpRequest=class extends XMLHttpRequest{open(o,h,y,i,v){return/^file:/i.test(h.toString())&&(h=P.FileAccess.asBrowserUri(t.URI.parse(h.toString())).toString(!0)),super.open(o,h,y??!0,i,v)}},self.importScripts=()=>{throw new Error("'importScripts' has been blocked")},self.addEventListener=()=>console.trace("'addEventListener' has been blocked"),self.AMDLoader=void 0,self.NLSLoaderPlugin=void 0,self.define=void 0,self.require=void 0,self.webkitRequestFileSystem=void 0,self.webkitRequestFileSystemSync=void 0,self.webkitResolveLocalFileSystemSyncURL=void 0,self.webkitResolveLocalFileSystemURL=void 0,self.Worker){const o=self.trustedTypes?.createPolicy("extensionHostWorker",{createScriptURL:y=>y}),h=self.Worker;Worker=function(y,i){/^file:/i.test(y.toString())&&(y=P.FileAccess.asBrowserUri(t.URI.parse(y.toString())).toString(!0));const r=`(${function(p){function k(m){return typeof m=="string"||m instanceof URL?String(m).replace(/^file:\/\//i,"vscode-file://vscode-app"):m}const T=fetch.bind(self);self.fetch=function(m,A){return m instanceof Request?T(m,A):T(k(m),A)},self.XMLHttpRequest=class extends XMLHttpRequest{open(m,A,L,V,G){return super.open(m,k(A),L??!0,V,G)}};const g=importScripts.bind(self);self.importScripts=(...m)=>{g(...m.map(k))};const D=self.trustedTypes?self.trustedTypes.createPolicy("extensionHostWorker",{createScriptURL:m=>m}):void 0;g(D?D.createScriptURL(p):p)}.toString()}('${y}'))`;i=i||{},i.name=i.name||C.basename(y.toString());const s=new Blob([r],{type:"application/javascript"}),u=URL.createObjectURL(s);return new h(o?o.createScriptURL(u):u,i)}}else self.Worker=class extends F.NestedWorker{constructor(o,h){super(n,o,{name:C.basename(o.toString()),...h})}};const a=new class{exit(o){E()}async exists(o){return!0}async realpath(o){return o}};class l{constructor(){const h=new MessageChannel,y=new M.Emitter;let i=!1;n(h.port2,[h.port2]),h.port1.onmessage=v=>{const{data:r}=v;if(!(r instanceof ArrayBuffer)){console.warn("UNKNOWN data received",r);return}const s=c.VSBuffer.wrap(new Uint8Array(r,0,r.byteLength));if((0,b.isMessageOfType)(s,2)){i=!0,I("received terminate message from renderer");return}y.fire(s)},this.protocol={onMessage:y.event,send:v=>{if(!i){const r=v.buffer.buffer.slice(v.buffer.byteOffset,v.buffer.byteOffset+v.buffer.byteLength);h.port1.postMessage(r,[r])}}}}}function w(o){return new Promise(h=>{const y=o.onMessage(i=>{y.dispose();const v=JSON.parse(i.toString());o.send((0,b.createMessageOfType)(0)),h({protocol:o,initData:v})});o.send((0,b.createMessageOfType)(1))})}let I=o=>E();function S(){const o=new l;_.mark("code/extHost/willConnectToRenderer"),w(o.protocol).then(h=>{_.mark("code/extHost/didWaitForInitData");const y=new R.ExtensionHostMain(h.protocol,h.initData,a,null);I=i=>y.terminate(i)})}e.create=S})}).call(this);

//# sourceMappingURL=https://ticino.blob.core.windows.net/sourcemaps/53aff5e347865fe22f9487ebd54dec9db23773b2/core/vs/workbench/services/extensions/worker/extensionHostWorker.js.map
